/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ee=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/path","vs/base/common/network","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/base/common/extpath","vs/base/common/glob","vs/workbench/api/common/extHostCommands","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/base/common/iterator","vs/base/common/hash","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/decorators","vs/base/common/assert","vs/base/common/themables","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function($e){for(var e=[],D=0,N=$e.length;D<N;D++)e[D]=Ee[$e[D]];return e};define(Ee[157],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T=e.$S=void 0,e.$S=!1;class D{static get(){const g=new Map,I=new Map,L=new Map,b=new Map;function $(v,S){v.has(S.detail)||v.set(S.detail,-S.timestamp)}function y(v,S){const f=v.get(S.detail);f&&(f>=0||v.set(S.detail,f+S.timestamp))}let A=[];typeof $e=="function"&&typeof $e.getStats=="function"&&(A=$e.getStats().slice(0).sort((v,S)=>v.timestamp-S.timestamp));for(const v of A)switch(v.type){case 10:$(g,v);break;case 11:case 12:y(g,v);break;case 21:$(I,v);break;case 22:y(I,v);break;case 33:$(L,v);break;case 34:y(L,v);break;case 31:$(b,v);break;case 32:y(b,v);break}let C=0;L.forEach(v=>C+=v);function m(v){const S=[];return v.forEach((f,d)=>S.push([d,f])),S}return{amdLoad:m(g),amdInvoke:m(I),nodeRequire:m(L),nodeEval:m(b),nodeRequireTotal:C}}static toMarkdownTable(g,I){let L="";const b=[];return g.forEach(($,y)=>{b[y]=$.length}),I.forEach($=>{$.forEach((y,A)=>{typeof y>"u"&&(y=$[A]="-");const C=y.toString().length;b[A]=Math.max(C,b[A])})}),g.forEach(($,y)=>{L+=`| ${$+" ".repeat(b[y]-$.toString().length)} `}),L+=`|
`,g.forEach(($,y)=>{L+=`| ${"-".repeat(b[y])} `}),L+=`|
`,I.forEach($=>{$.forEach((y,A)=>{typeof y<"u"&&(L+=`| ${y+" ".repeat(b[A]-y.toString().length)} `)}),L+=`|
`}),L}}e.$T=D}),define(Ee[158],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=e.$eb=void 0;function D(f,d,s){const i=N(f,d);if(i!==-1)return f[i]}e.$eb=D;function N(f,d,s=f.length-1){for(let i=s;i>=0;i--){const n=f[i];if(d(n))return i}return-1}e.$fb=N;function g(f,d){const s=I(f,d);return s===-1?void 0:f[s]}e.$gb=g;function I(f,d,s=0,i=f.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);d(f[a])?n=a+1:o=a}return n-1}e.$hb=I;function L(f,d){const s=b(f,d);return s===f.length?void 0:f[s]}e.$ib=L;function b(f,d,s=0,i=f.length){let n=s,o=i;for(;n<o;){const a=Math.floor((n+o)/2);d(f[a])?o=a:n=a+1}return n}e.$jb=b;function $(f,d,s=0,i=f.length){const n=b(f,d,s,i);return n===f.length?-1:n}e.$kb=$;class y{static{this.assertInvariants=!1}constructor(d){this.e=d,this.c=0}findLastMonotonous(d){if(y.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!d(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=d}const s=I(this.e,d,this.c);return this.c=s+1,s===-1?void 0:this.e[s]}}e.$lb=y;function A(f,d){if(f.length===0)return;let s=f[0];for(let i=1;i<f.length;i++){const n=f[i];d(n,s)>0&&(s=n)}return s}e.$mb=A;function C(f,d){if(f.length===0)return;let s=f[0];for(let i=1;i<f.length;i++){const n=f[i];d(n,s)>=0&&(s=n)}return s}e.$nb=C;function m(f,d){return A(f,(s,i)=>-d(s,i))}e.$ob=m;function v(f,d){if(f.length===0)return-1;let s=0;for(let i=1;i<f.length;i++){const n=f[i];d(n,f[s])>0&&(s=i)}return s}e.$pb=v;function S(f,d){for(const s of f){const i=d(s);if(i!==void 0)return i}}e.$qb=S}),define(Ee[73],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M=e.$L=e.$K=e.$J=void 0;function D(L,b){const $=Object.create(null);for(const y of L){const A=b(y);let C=$[A];C||(C=$[A]=[]),C.push(y)}return $}e.$J=D;function N(L,b){const $=[],y=[];for(const A of L)b.has(A)||$.push(A);for(const A of b)L.has(A)||y.push(A);return{removed:$,added:y}}e.$K=N;function g(L,b){const $=[],y=[];for(const[A,C]of L)b.has(A)||$.push(C);for(const[A,C]of b)L.has(A)||y.push(C);return{removed:$,added:y}}e.$L=g;function I(L,b){const $=new Set;for(const y of b)L.has(y)&&$.add(y);return $}e.$M=I}),define(Ee[59],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=void 0;function D(L){return(b,$,y)=>{let A=null,C=null;if(typeof y.value=="function"?(A="value",C=y.value):typeof y.get=="function"&&(A="get",C=y.get),!C)throw new Error("not supported");y[A]=L(C,$)}}function N(L,b,$){let y=null,A=null;if(typeof $.value=="function"?(y="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(y="get",A=$.get),!A)throw new Error("not supported");const C=`$memoize$${b}`;$[y]=function(...m){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,m)}),this[C]}}e.$rh=N;function g(L,b,$){return D((y,A)=>{const C=`$debounce$${A}`,m=`$debounce$result$${A}`;return function(...v){this[m]||(this[m]=$?$():void 0),clearTimeout(this[C]),b&&(this[m]=b(this[m],...v),v=[this[m]]),this[C]=setTimeout(()=>{y.apply(this,v),this[m]=$?$():void 0},L)}})}e.$sh=g;function I(L,b,$){return D((y,A)=>{const C=`$throttle$timer$${A}`,m=`$throttle$result$${A}`,v=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...f){if(this[m]||(this[m]=$?$():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),b&&(this[m]=b(this[m],...f)),this[S])return;const d=this[v]+L;d<=Date.now()?(this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0):(this[S]=!0,this[C]=setTimeout(()=>{this[S]=!1,this[v]=Date.now(),y.apply(this,[this[m]]),this[m]=$?$():void 0},d-Date.now()))}})}e.$th=I}),define(Ee[8],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.$Y=e.setUnexpectedErrorHandler=e.$W=e.$V=void 0;class D{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?n.isErrorNoTelemetry(t)?new n(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$V=D,e.$W=new D;function N(a){e.$W.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=N;function g(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Y=g;function I(a){y(a)||e.$W.onUnexpectedError(a)}e.$Z=I;function L(a){y(a)||e.$W.onUnexpectedExternalError(a)}e.$1=L;function b(a){if(a instanceof Error){const{name:t,message:r}=a,h=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:h,noTelemetry:n.isErrorNoTelemetry(a)}}return a}e.$2=b;const $="Canceled";function y(a){return a instanceof A?!0:a instanceof Error&&a.name===$&&a.message===$}e.$3=y;class A extends Error{constructor(){super($),this.name=this.message}}e.$4=A;function C(){const a=new Error($);return a.name=a.message,a}e.$5=C;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$6=m;function v(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$7=v;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$8=S;function f(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$9=f;class d extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$0=d;class s extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$$=s;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$_=i;class n extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof n)return t;const r=new n;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$ab=n;class o extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,o.prototype)}}e.$bb=o}),define(Ee[19],Se([1,0,8,158]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.$6b=e.CompareResult=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.$Fb=e.top=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=e.$rb=void 0;function g(fe,me=0){return fe[fe.length-(1+me)]}e.$rb=g;function I(fe){if(fe.length===0)throw new Error("Invalid tail call");return[fe.slice(0,fe.length-1),fe[fe.length-1]]}e.$sb=I;function L(fe,me,ee=(ie,G)=>ie===G){if(fe===me)return!0;if(!fe||!me||fe.length!==me.length)return!1;for(let ie=0,G=fe.length;ie<G;ie++)if(!ee(fe[ie],me[ie]))return!1;return!0}e.$tb=L;function b(fe,me){const ee=fe.length-1;me<ee&&(fe[me]=fe[ee]),fe.pop()}e.$ub=b;function $(fe,me,ee){return y(fe.length,ie=>ee(fe[ie],me))}e.$vb=$;function y(fe,me){let ee=0,ie=fe-1;for(;ee<=ie;){const G=(ee+ie)/2|0,te=me(G);if(te<0)ee=G+1;else if(te>0)ie=G-1;else return G}return-(ee+1)}e.$wb=y;function A(fe,me,ee){if(fe=fe|0,fe>=me.length)throw new TypeError("invalid index");const ie=me[Math.floor(me.length*Math.random())],G=[],te=[],J=[];for(const ce of me){const be=ee(ce,ie);be<0?G.push(ce):be>0?te.push(ce):J.push(ce)}return fe<G.length?A(fe,G,ee):fe<G.length+J.length?J[0]:A(fe-(G.length+J.length),te,ee)}e.$xb=A;function C(fe,me){const ee=[];let ie;for(const G of fe.slice(0).sort(me))!ie||me(ie[0],G)!==0?(ie=[G],ee.push(ie)):ie.push(G);return ee}e.$yb=C;function*m(fe,me){let ee,ie;for(const G of fe)ie!==void 0&&me(ie,G)?ee.push(G):(ee&&(yield ee),ee=[G]),ie=G;ee&&(yield ee)}e.$zb=m;function v(fe,me){for(let ee=0;ee<=fe.length;ee++)me(ee===0?void 0:fe[ee-1],ee===fe.length?void 0:fe[ee])}e.$Ab=v;function S(fe,me){for(let ee=0;ee<fe.length;ee++)me(ee===0?void 0:fe[ee-1],fe[ee],ee+1===fe.length?void 0:fe[ee+1])}e.$Bb=S;function f(fe,me,ee){const ie=[];function G(ce,be,Ie){if(be===0&&Ie.length===0)return;const Me=ie[ie.length-1];Me&&Me.start+Me.deleteCount===ce?(Me.deleteCount+=be,Me.toInsert.push(...Ie)):ie.push({start:ce,deleteCount:be,toInsert:Ie})}let te=0,J=0;for(;;){if(te===fe.length){G(te,0,me.slice(J));break}if(J===me.length){G(te,fe.length-te,[]);break}const ce=fe[te],be=me[J],Ie=ee(ce,be);Ie===0?(te+=1,J+=1):Ie<0?(G(te,1,[]),te+=1):Ie>0&&(G(te,0,[be]),J+=1)}return ie}e.$Cb=f;function d(fe,me,ee){const ie=f(fe,me,ee),G=[],te=[];for(const J of ie)G.push(...fe.slice(J.start,J.start+J.deleteCount)),te.push(...J.toInsert);return{removed:G,added:te}}e.$Db=d;function s(fe,me,ee){if(ee===0)return[];const ie=fe.slice(0,ee).sort(me);return n(fe,me,ie,ee,fe.length),ie}e.top=s;function i(fe,me,ee,ie,G){return ee===0?Promise.resolve([]):new Promise((te,J)=>{(async()=>{const ce=fe.length,be=fe.slice(0,ee).sort(me);for(let Ie=ee,Me=Math.min(ee+ie,ce);Ie<ce;Ie=Me,Me=Math.min(Me+ie,ce)){if(Ie>ee&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new D.$4;n(fe,me,be,Ie,Me)}return be})().then(te,J)})}e.$Fb=i;function n(fe,me,ee,ie,G){for(const te=ee.length;ie<G;ie++){const J=fe[ie];if(me(J,ee[te-1])<0){ee.pop();const ce=(0,N.$jb)(ee,be=>me(J,be)<0);ee.splice(ce,0,J)}}}function o(fe){return fe.filter(me=>!!me)}e.$Gb=o;function a(fe){let me=0;for(let ee=0;ee<fe.length;ee++)fe[ee]&&(fe[me]=fe[ee],me+=1);fe.length=me}e.$Hb=a;function t(fe,me,ee){fe.splice(ee,0,fe.splice(me,1)[0])}e.$Ib=t;function r(fe){return!Array.isArray(fe)||fe.length===0}e.$Jb=r;function h(fe){return Array.isArray(fe)&&fe.length>0}e.$Kb=h;function u(fe,me=ee=>ee){const ee=new Set;return fe.filter(ie=>{const G=me(ie);return ee.has(G)?!1:(ee.add(G),!0)})}e.$Lb=u;function c(fe){const me=new Set;return ee=>{const ie=fe(ee);return me.has(ie)?!1:(me.add(ie),!0)}}e.$Mb=c;function l(fe,me){return fe.length>0?fe[0]:me}e.$Nb=l;function k(fe,me){return fe.length>0?fe[fe.length-1]:me}e.$Ob=k;function R(fe,me,ee=(ie,G)=>ie===G){let ie=0;for(let G=0,te=Math.min(fe.length,me.length);G<te&&ee(fe[G],me[G]);G++)ie++;return ie}e.$Pb=R;function w(fe){return[].concat(...fe)}e.$Qb=w;function p(fe,me){let ee=typeof me=="number"?fe:0;typeof me=="number"?ee=fe:(ee=0,me=fe);const ie=[];if(ee<=me)for(let G=ee;G<me;G++)ie.push(G);else for(let G=ee;G>me;G--)ie.push(G);return ie}e.$Rb=p;function E(fe,me,ee){return fe.reduce((ie,G)=>(ie[me(G)]=ee?ee(G):G,ie),Object.create(null))}e.$Sb=E;function P(fe,me){return fe.push(me),()=>z(fe,me)}e.$Tb=P;function z(fe,me){const ee=fe.indexOf(me);if(ee>-1)return fe.splice(ee,1),me}e.$Ub=z;function j(fe,me,ee){const ie=fe.slice(0,me),G=fe.slice(me);return ie.concat(ee,G)}e.$Vb=j;function F(fe,me){let ee;if(typeof me=="number"){let ie=me;ee=()=>{const G=Math.sin(ie++)*179426549;return G-Math.floor(G)}}else ee=Math.random;for(let ie=fe.length-1;ie>0;ie-=1){const G=Math.floor(ee()*(ie+1)),te=fe[ie];fe[ie]=fe[G],fe[G]=te}}e.$Wb=F;function O(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.unshift(me))}e.$Xb=O;function T(fe,me){const ee=fe.indexOf(me);ee>-1&&(fe.splice(ee,1),fe.push(me))}e.$Yb=T;function M(fe,me){for(const ee of me)fe.push(ee)}e.$Zb=M;function W(fe,me){return Array.isArray(fe)?fe.map(me):me(fe)}e.$1b=W;function Y(fe){return Array.isArray(fe)?fe:[fe]}e.$2b=Y;function ue(fe){return fe[Math.floor(Math.random()*fe.length)]}e.$3b=ue;function Z(fe,me,ee){const ie=x(fe,me),G=fe.length,te=ee.length;fe.length=G+te;for(let J=G-1;J>=ie;J--)fe[J+te]=fe[J];for(let J=0;J<te;J++)fe[J+ie]=ee[J]}e.$4b=Z;function Q(fe,me,ee,ie){const G=x(fe,me);let te=fe.splice(G,ee);return te===void 0&&(te=[]),Z(fe,G,ie),te}e.$5b=Q;function x(fe,me){return me<0?Math.max(me+fe.length,0):Math.min(me,fe.length)}var oe;(function(fe){function me(te){return te<0}fe.isLessThan=me;function ee(te){return te<=0}fe.isLessThanOrEqual=ee;function ie(te){return te>0}fe.isGreaterThan=ie;function G(te){return te===0}fe.isNeitherLessOrGreaterThan=G,fe.greaterThan=1,fe.lessThan=-1,fe.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function X(fe,me){return(ee,ie)=>me(fe(ee),fe(ie))}e.$6b=X;function ve(...fe){return(me,ee)=>{for(const ie of fe){const G=ie(me,ee);if(!oe.isNeitherLessOrGreaterThan(G))return G}return oe.neitherLessOrGreaterThan}}e.$7b=ve;const ge=(fe,me)=>fe-me;e.$8b=ge;const V=(fe,me)=>(0,e.$8b)(fe?1:0,me?1:0);e.$9b=V;function U(fe){return(me,ee)=>-fe(me,ee)}e.$0b=U;class ne{constructor(me){this.g=me,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(me){let ee=this.c;for(;ee<this.g.length&&me(this.g[ee]);)ee++;const ie=ee===this.c?null:this.g.slice(this.c,ee);return this.c=ee,ie}takeFromEndWhile(me){let ee=this.d;for(;ee>=0&&me(this.g[ee]);)ee--;const ie=ee===this.d?null:this.g.slice(ee+1,this.d+1);return this.d=ee,ie}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const me=this.g[this.c];return this.c++,me}removeLast(){const me=this.g[this.d];return this.d--,me}takeCount(me){const ee=this.g.slice(this.c,this.c+me);return this.c+=me,ee}}e.$$b=ne;class ye{static{this.empty=new ye(me=>{})}constructor(me){this.iterate=me}forEach(me){this.iterate(ee=>(me(ee),!0))}toArray(){const me=[];return this.iterate(ee=>(me.push(ee),!0)),me}filter(me){return new ye(ee=>this.iterate(ie=>me(ie)?ee(ie):!0))}map(me){return new ye(ee=>this.iterate(ie=>ee(me(ie))))}some(me){let ee=!1;return this.iterate(ie=>(ee=me(ie),!ee)),ee}findFirst(me){let ee;return this.iterate(ie=>me(ie)?(ee=ie,!1):!0),ee}findLast(me){let ee;return this.iterate(ie=>(me(ie)&&(ee=ie),!0)),ee}findLastMaxBy(me){let ee,ie=!0;return this.iterate(G=>((ie||oe.isGreaterThan(me(G,ee)))&&(ie=!1,ee=G),!0)),ee}}e.$_b=ye}),define(Ee[60],Se([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7c=e.$6c=e.$5c=e.$4c=e.ok=void 0;function N($,y){if(!$)throw new Error(y?`Assertion failed (${y})`:"Assertion Failed")}e.ok=N;function g($,y="Unreachable"){throw new Error(y)}e.$4c=g;function I($){if(!$)throw new D.$bb("Assertion Failed")}e.$5c=I;function L($){if(!$()){debugger;$(),(0,D.$Z)(new D.$bb("Assertion Failed"))}}e.$6c=L;function b($,y){let A=0;for(;A<$.length-1;){const C=$[A],m=$[A+1];if(!y(C,m))return!1;A++}return!0}e.$7c=b}),define(Ee[74],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=void 0;function D(N,g){const I=this;let L=!1,b;return function(){if(L)return b;if(L=!0,g)try{b=N.apply(I,arguments)}finally{g()}else b=N.apply(I,arguments);return b}}e.$cb=D}),define(Ee[121],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;class D{constructor(g){this.a=g,this.b=0}nextId(){return this.a+ ++this.b}}e.$MM=D,e.$NM=new D("id#")}),define(Ee[52],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(N){function g(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}N.is=g;const I=Object.freeze([]);function L(){return I}N.empty=L;function*b(a){yield a}N.single=b;function $(a){return g(a)?a:b(a)}N.wrap=$;function y(a){return a||I}N.from=y;function*A(a){for(let t=a.length-1;t>=0;t--)yield a[t]}N.reverse=A;function C(a){return!a||a[Symbol.iterator]().next().done===!0}N.isEmpty=C;function m(a){return a[Symbol.iterator]().next().value}N.first=m;function v(a,t){for(const r of a)if(t(r))return!0;return!1}N.some=v;function S(a,t){for(const r of a)if(t(r))return r}N.find=S;function*f(a,t){for(const r of a)t(r)&&(yield r)}N.filter=f;function*d(a,t){let r=0;for(const h of a)yield t(h,r++)}N.map=d;function*s(...a){for(const t of a)yield*t}N.concat=s;function i(a,t,r){let h=r;for(const u of a)h=t(h,u);return h}N.reduce=i;function*n(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}N.slice=n;function o(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const h=a[Symbol.iterator]();for(let u=0;u<t;u++){const c=h.next();if(c.done)return[r,N.empty()];r.push(c.value)}return[r,{[Symbol.iterator](){return h}}]}N.consume=o})(D||(e.Iterable=D={}))}),define(Ee[159],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(D||(e.ScanError=D={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var g;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(g||(e.ParseErrorCode=g={}));var I;(function(t){t.DEFAULT={allowTrailingComma:!0}})(I||(e.ParseOptions=I={}));function L(t,r=!1){let h=0;const u=t.length;let c="",l=0,k=16,R=0;function w(O){let T=0,M=0;for(;T<O;){const W=t.charCodeAt(h);if(W>=48&&W<=57)M=M*16+W-48;else if(W>=65&&W<=70)M=M*16+W-65+10;else if(W>=97&&W<=102)M=M*16+W-97+10;else break;h++,T++}return T<O&&(M=-1),M}function p(O){h=O,c="",l=0,k=16,R=0}function E(){const O=h;if(t.charCodeAt(h)===48)h++;else for(h++;h<t.length&&y(t.charCodeAt(h));)h++;if(h<t.length&&t.charCodeAt(h)===46)if(h++,h<t.length&&y(t.charCodeAt(h)))for(h++;h<t.length&&y(t.charCodeAt(h));)h++;else return R=3,t.substring(O,h);let T=h;if(h<t.length&&(t.charCodeAt(h)===69||t.charCodeAt(h)===101))if(h++,(h<t.length&&t.charCodeAt(h)===43||t.charCodeAt(h)===45)&&h++,h<t.length&&y(t.charCodeAt(h))){for(h++;h<t.length&&y(t.charCodeAt(h));)h++;T=h}else R=3;return t.substring(O,T)}function P(){let O="",T=h;for(;;){if(h>=u){O+=t.substring(T,h),R=2;break}const M=t.charCodeAt(h);if(M===34){O+=t.substring(T,h),h++;break}if(M===92){if(O+=t.substring(T,h),h++,h>=u){R=2;break}switch(t.charCodeAt(h++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const Y=w(4);Y>=0?O+=String.fromCharCode(Y):R=4;break}default:R=5}T=h;continue}if(M>=0&&M<=31)if($(M)){O+=t.substring(T,h),R=2;break}else R=6;h++}return O}function z(){if(c="",R=0,l=h,h>=u)return l=u,k=17;let O=t.charCodeAt(h);if(b(O)){do h++,c+=String.fromCharCode(O),O=t.charCodeAt(h);while(b(O));return k=15}if($(O))return h++,c+=String.fromCharCode(O),O===13&&t.charCodeAt(h)===10&&(h++,c+=`
`),k=14;switch(O){case 123:return h++,k=1;case 125:return h++,k=2;case 91:return h++,k=3;case 93:return h++,k=4;case 58:return h++,k=6;case 44:return h++,k=5;case 34:return h++,c=P(),k=10;case 47:{const T=h-1;if(t.charCodeAt(h+1)===47){for(h+=2;h<u&&!$(t.charCodeAt(h));)h++;return c=t.substring(T,h),k=12}if(t.charCodeAt(h+1)===42){h+=2;const M=u-1;let W=!1;for(;h<M;){if(t.charCodeAt(h)===42&&t.charCodeAt(h+1)===47){h+=2,W=!0;break}h++}return W||(h++,R=1),c=t.substring(T,h),k=13}return c+=String.fromCharCode(O),h++,k=16}case 45:if(c+=String.fromCharCode(O),h++,h===u||!y(t.charCodeAt(h)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=E(),k=11;default:for(;h<u&&j(O);)h++,O=t.charCodeAt(h);if(l!==h){switch(c=t.substring(l,h),c){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return c+=String.fromCharCode(O),h++,k=16}}function j(O){if(b(O)||$(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function F(){let O;do O=z();while(O>=12&&O<=15);return O}return{setPosition:p,getPosition:()=>h,scan:r?F:z,getToken:()=>k,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>h-l,getTokenError:()=>R}}e.$5m=L;function b(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function C(t,r){const h=[],u=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function R(w,p,E,P){l.value=w,l.offset=p,l.length=E,l.type=P,l.colonOffset=void 0,c=l}try{n(t,{onObjectBegin:(w,p)=>{if(r<=w)throw u;c=void 0,k=r>w,h.push("")},onObjectProperty:(w,p,E)=>{if(r<p||(R(w,p,E,"property"),h[h.length-1]=w,r<=p+E))throw u},onObjectEnd:(w,p)=>{if(r<=w)throw u;c=void 0,h.pop()},onArrayBegin:(w,p)=>{if(r<=w)throw u;c=void 0,h.push(0)},onArrayEnd:(w,p)=>{if(r<=w)throw u;c=void 0,h.pop()},onLiteralValue:(w,p,E)=>{if(r<p||(R(w,p,E,a(w)),r<=p+E))throw u},onSeparator:(w,p,E)=>{if(r<=p)throw u;if(w===":"&&c&&c.type==="property")c.colonOffset=p,k=!1,c=void 0;else if(w===","){const P=h[h.length-1];typeof P=="number"?h[h.length-1]=P+1:(k=!0,h[h.length-1]=""),c=void 0}}})}catch(w){if(w!==u)throw w}return{path:h,previousNode:c,isAtPropertyKey:k,matches:w=>{let p=0;for(let E=0;p<w.length&&E<h.length;E++)if(w[p]===h[E]||w[p]==="*")p++;else if(w[p]!=="**")return!1;return p===w.length}}}e.$6m=C;function m(t,r=[],h=I.DEFAULT){let u=null,c=[];const l=[];function k(w){Array.isArray(c)?c.push(w):u!==null&&(c[u]=w)}return n(t,{onObjectBegin:()=>{const w={};k(w),l.push(c),c=w,u=null},onObjectProperty:w=>{u=w},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const w=[];k(w),l.push(c),c=w,u=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:k,onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},h),c[0]}e.$7m=m;function v(t,r=[],h=I.DEFAULT){let u={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(w){u.type==="property"&&(u.length=w-u.offset,u=u.parent)}function l(w){return u.children.push(w),w}n(t,{onObjectBegin:w=>{u=l({type:"object",offset:w,length:-1,parent:u,children:[]})},onObjectProperty:(w,p,E)=>{u=l({type:"property",offset:p,length:-1,parent:u,children:[]}),u.children.push({type:"string",value:w,offset:p,length:E,parent:u})},onObjectEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,c(w+p)},onArrayBegin:(w,p)=>{u=l({type:"array",offset:w,length:-1,parent:u,children:[]})},onArrayEnd:(w,p)=>{u.length=w+p-u.offset,u=u.parent,c(w+p)},onLiteralValue:(w,p,E)=>{l({type:a(w),offset:p,length:E,parent:u,value:w}),c(p+E)},onSeparator:(w,p,E)=>{u.type==="property"&&(w===":"?u.colonOffset=p:w===","&&c(p))},onError:(w,p,E)=>{r.push({error:w,offset:p,length:E})}},h);const R=u.children[0];return R&&delete R.parent,R}e.$8m=v;function S(t,r){if(!t)return;let h=t;for(const u of r)if(typeof u=="string"){if(h.type!=="object"||!Array.isArray(h.children))return;let c=!1;for(const l of h.children)if(Array.isArray(l.children)&&l.children[0].value===u){h=l.children[1],c=!0;break}if(!c)return}else{const c=u;if(h.type!=="array"||c<0||!Array.isArray(h.children)||c>=h.children.length)return;h=h.children[c]}return h}e.$9m=S;function f(t){if(!t.parent||!t.parent.children)return[];const r=f(t.parent);if(t.parent.type==="property"){const h=t.parent.children[0].value;r.push(h)}else if(t.parent.type==="array"){const h=t.parent.children.indexOf(t);h!==-1&&r.push(h)}return r}e.$0m=f;function d(t){switch(t.type){case"array":return t.children.map(d);case"object":{const r=Object.create(null);for(const h of t.children){const u=h.children[1];u&&(r[h.children[0].value]=d(u))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$$m=d;function s(t,r,h=!1){return r>=t.offset&&r<t.offset+t.length||h&&r===t.offset+t.length}e.$_m=s;function i(t,r,h=!1){if(s(t,r,h)){const u=t.children;if(Array.isArray(u))for(let c=0;c<u.length&&u[c].offset<=r;c++){const l=i(u[c],r,h);if(l)return l}return t}}e.$an=i;function n(t,r,h=I.DEFAULT){const u=L(t,!1);function c(X){return X?()=>X(u.getTokenOffset(),u.getTokenLength()):()=>!0}function l(X){return X?ve=>X(ve,u.getTokenOffset(),u.getTokenLength()):()=>!0}const k=c(r.onObjectBegin),R=l(r.onObjectProperty),w=c(r.onObjectEnd),p=c(r.onArrayBegin),E=c(r.onArrayEnd),P=l(r.onLiteralValue),z=l(r.onSeparator),j=c(r.onComment),F=l(r.onError),O=h&&h.disallowComments,T=h&&h.allowTrailingComma;function M(){for(;;){const X=u.scan();switch(u.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:O||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(X){case 12:case 13:O?W(10):j();break;case 16:W(1);break;case 15:case 14:break;default:return X}}}function W(X,ve=[],ge=[]){if(F(X),ve.length+ge.length>0){let V=u.getToken();for(;V!==17;){if(ve.indexOf(V)!==-1){M();break}else if(ge.indexOf(V)!==-1)break;V=M()}}}function Y(X){const ve=u.getTokenValue();return X?P(ve):R(ve),M(),!0}function ue(){switch(u.getToken()){case 11:{let X=0;try{X=JSON.parse(u.getTokenValue()),typeof X!="number"&&(W(2),X=0)}catch{W(2)}P(X);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return M(),!0}function Z(){return u.getToken()!==10?(W(3,[],[2,5]),!1):(Y(!1),u.getToken()===6?(z(":"),M(),oe()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function Q(){k(),M();let X=!1;for(;u.getToken()!==2&&u.getToken()!==17;){if(u.getToken()===5){if(X||W(4,[],[]),z(","),M(),u.getToken()===2&&T)break}else X&&W(6,[],[]);Z()||W(4,[],[2,5]),X=!0}return w(),u.getToken()!==2?W(7,[2],[]):M(),!0}function x(){p(),M();let X=!1;for(;u.getToken()!==4&&u.getToken()!==17;){if(u.getToken()===5){if(X||W(4,[],[]),z(","),M(),u.getToken()===4&&T)break}else X&&W(6,[],[]);oe()||W(4,[],[4,5]),X=!0}return E(),u.getToken()!==4?W(8,[4],[]):M(),!0}function oe(){switch(u.getToken()){case 3:return x();case 1:return Q();case 10:return Y(!0);default:return ue()}}return M(),u.getToken()===17?h.allowEmptyContent?!0:(W(4,[],[]),!1):oe()?(u.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$bn=n;function o(t,r){const h=L(t),u=[];let c,l=0,k;do switch(k=h.getPosition(),c=h.scan(),c){case 12:case 13:case 17:l!==k&&u.push(t.substring(l,k)),r!==void 0&&u.push(h.getTokenValue().replace(/[^\r\n]/g,r)),l=h.getPosition();break}while(c!==17);return u.join("")}e.$cn=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$dn=a}),define(Ee[43],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=void 0;class D{constructor(g){this.d=g,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(g){this.c=g}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$U=D}),define(Ee[75],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2c=void 0;class D{static{this.Undefined=new D(void 0)}constructor(I){this.element=I,this.next=D.Undefined,this.prev=D.Undefined}}class N{constructor(){this.a=D.Undefined,this.b=D.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===D.Undefined}clear(){let I=this.a;for(;I!==D.Undefined;){const L=I.next;I.prev=D.Undefined,I.next=D.Undefined,I=L}this.a=D.Undefined,this.b=D.Undefined,this.c=0}unshift(I){return this.d(I,!1)}push(I){return this.d(I,!0)}d(I,L){const b=new D(I);if(this.a===D.Undefined)this.a=b,this.b=b;else if(L){const y=this.b;this.b=b,b.prev=y,y.next=b}else{const y=this.a;this.a=b,b.next=y,y.prev=b}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(b))}}shift(){if(this.a!==D.Undefined){const I=this.a.element;return this.e(this.a),I}}pop(){if(this.b!==D.Undefined){const I=this.b.element;return this.e(this.b),I}}e(I){if(I.prev!==D.Undefined&&I.next!==D.Undefined){const L=I.prev;L.next=I.next,I.next.prev=L}else I.prev===D.Undefined&&I.next===D.Undefined?(this.a=D.Undefined,this.b=D.Undefined):I.next===D.Undefined?(this.b=this.b.prev,this.b.next=D.Undefined):I.prev===D.Undefined&&(this.a=this.a.next,this.a.prev=D.Undefined);this.c-=1}*[Symbol.iterator](){let I=this.a;for(;I!==D.Undefined;)yield I.element,I=I.next}}e.$2c=N}),define(Ee[28],Se([1,0]),function($e,e){"use strict";var D,N,g;Object.defineProperty(e,"__esModule",{value:!0}),e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.$Bc=e.Touch=e.$Ac=e.$zc=e.$yc=e.$xc=e.$wc=void 0;function I(i,n,o){let a=i.get(n);return a===void 0&&(a=o,i.set(n,a)),a}e.$wc=I;function L(i){const n=[];return i.forEach((o,a)=>{n.push(`${a} => ${o}`)}),`Map(${i.size}) {${n.join(", ")}}`}e.$xc=L;function b(i){const n=[];return i.forEach(o=>{n.push(o)}),`Set(${i.size}) {${n.join(", ")}}`}e.$yc=b;class ${constructor(n,o){this.uri=n,this.value=o}}function y(i){return Array.isArray(i)}class A{static{this.a=n=>n.toString()}constructor(n,o){if(this[D]="ResourceMap",n instanceof A)this.b=new Map(n.b),this.c=o??A.a;else if(y(n)){this.b=new Map,this.c=o??A.a;for(const[a,t]of n)this.set(a,t)}else this.b=new Map,this.c=n??A.a}set(n,o){return this.b.set(this.c(n),new $(n,o)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,o){typeof o<"u"&&(n=n.bind(o));for(const[a,t]of this.b)n(t.value,t.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}e.$zc=A;class C{constructor(n,o){this[N]="ResourceSet",!n||typeof n=="function"?this.a=new A(n):(this.a=new A(o),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,o){this.a.forEach((a,t)=>n.call(o,t,t,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Ac=C;var m;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[g]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,o=0){const a=this.a.get(n);if(a)return o!==0&&this.j(a,o),a.value}set(n,o,a=0){let t=this.a.get(n);if(t)t.value=o,a!==0&&this.j(t,a);else{switch(t={key:n,value:o,next:void 0,previous:void 0},a){case 0:this.h(t);break;case 1:this.g(t);break;case 2:this.h(t);break;default:this.h(t);break}this.a.set(n,t),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const o=this.a.get(n);if(o)return this.a.delete(n),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,o){const a=this.e;let t=this.b;for(;t;){if(o?n.bind(o)(t.value,t.key,this):n(t.value,t.key,this),this.e!==a)throw new Error("LinkedMap got modified during iteration.");t=t.next}}keys(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.key,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}values(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:a.value,done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}entries(){const n=this,o=this.e;let a=this.b;const t={[Symbol.iterator](){return t},next(){if(n.e!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const r={value:[a.key,a.value],done:!1};return a=a.next,r}else return{value:void 0,done:!0}}};return t}[(g=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let o=this.b,a=this.size;for(;o&&a>n;)this.a.delete(o.key),o=o.next,a--;this.b=o,this.d=a,o&&(o.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const o=n.next,a=n.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}n.next=void 0,n.previous=void 0,this.e++}j(n,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(n===this.b)return;const a=n.next,t=n.previous;n===this.c?(t.next=void 0,this.c=t):(a.previous=t,t.next=a),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(o===2){if(n===this.c)return;const a=n.next,t=n.previous;n===this.b?(a.previous=void 0,this.b=a):(a.previous=t,t.next=a),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((o,a)=>{n.push([a,o])}),n}fromJSON(n){this.clear();for(const[o,a]of n)this.set(o,a)}}e.$Bc=v;class S extends v{constructor(n,o=1){super(),this.k=n,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,o=2){return super.get(n,o)}peek(n){return super.get(n,0)}set(n,o){return super.set(n,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.$Cc=S;class f{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let o=this.a.get(n)||0;return o===0?!1:(o--,o===0?this.a.delete(n):this.a.set(n,o),!0)}has(n){return this.a.has(n)}}e.$Dc=f;class d{constructor(n){if(this.a=new Map,this.b=new Map,n)for(const[o,a]of n)this.set(o,a)}clear(){this.a.clear(),this.b.clear()}set(n,o){this.a.set(n,o),this.b.set(o,n)}get(n){return this.a.get(n)}getKey(n){return this.b.get(n)}delete(n){const o=this.a.get(n);return o===void 0?!1:(this.a.delete(n),this.b.delete(o),!0)}forEach(n,o){this.a.forEach((a,t)=>{n.call(o,a,t,this)})}keys(){return this.a.keys()}values(){return this.a.values()}}e.$Ec=d;class s{constructor(){this.a=new Map}add(n,o){let a=this.a.get(n);a||(a=new Set,this.a.set(n,a)),a.add(o)}delete(n,o){const a=this.a.get(n);a&&(a.delete(o),a.size===0&&this.a.delete(n))}forEach(n,o){const a=this.a.get(n);a&&a.forEach(o)}get(n){const o=this.a.get(n);return o||new Set}}e.$Fc=s}),define(Ee[3],Se([1,0,19,73,28,74,52]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=e.$Hc=e.$Gc=void 0;const b=!1;let $=null;class y{constructor(){this.b=new Map}static{this.a=0}c(P){let z=this.b.get(P);return z||(z={parent:null,source:null,isSingleton:!1,value:P,idx:y.a++},this.b.set(P,z)),z}trackDisposable(P){const z=this.c(P);z.source||(z.source=new Error().stack)}setParent(P,z){const j=this.c(P);j.parent=z}markAsDisposed(P){this.b.delete(P)}markAsSingleton(P){this.c(P).isSingleton=!0}f(P,z){const j=z.get(P);if(j)return j;const F=P.parent?this.f(this.c(P.parent),z):P;return z.set(P,F),F}getTrackedDisposables(){const P=new Map;return[...this.b.entries()].filter(([,j])=>j.source!==null&&!this.f(j,P).isSingleton).flatMap(([j])=>j)}computeLeakingDisposables(P=10,z){let j;if(z)j=z;else{const W=new Map,Y=[...this.b.values()].filter(Z=>Z.source!==null&&!this.f(Z,W).isSingleton);if(Y.length===0)return;const ue=new Set(Y.map(Z=>Z.value));if(j=Y.filter(Z=>!(Z.parent&&ue.has(Z.parent))),j.length===0)throw new Error("There are cyclic diposable chains!")}if(!j)return;function F(W){function Y(Z,Q){for(;Z.length>0&&Q.some(x=>typeof x=="string"?x===Z[0]:Z[0].match(x));)Z.shift()}const ue=W.source.split(`
`).map(Z=>Z.trim().replace("at ","")).filter(Z=>Z!=="");return Y(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const O=new g.$Fc;for(const W of j){const Y=F(W);for(let ue=0;ue<=Y.length;ue++)O.add(Y.slice(0,ue).join(`
`),W)}j.sort((0,D.$6b)(W=>W.idx,D.$8b));let T="",M=0;for(const W of j.slice(0,P)){M++;const Y=F(W),ue=[];for(let Z=0;Z<Y.length;Z++){let Q=Y[Z];Q=`(shared with ${O.get(Y.slice(0,Z+1).join(`
`)).size}/${j.length} leaks) at ${Q}`;const oe=O.get(Y.slice(0,Z).join(`
`)),X=(0,N.$J)([...oe].map(ve=>F(ve)[Z]),ve=>ve);delete X[Y[Z]];for(const[ve,ge]of Object.entries(X))ue.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${ve}`);ue.unshift(Q)}T+=`


==================== Leaking disposable ${M}/${j.length}: ${W.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return j.length>P&&(T+=`


... and ${j.length-P} more leaking disposables

`),{leaks:j,details:T}}}e.$Gc=y;function A(E){$=E}if(e.$Hc=A,b){const E="__is_disposable_tracked__";A(new class{trackDisposable(P){const z=new Error("Potentially leaked disposable").stack;setTimeout(()=>{P[E]||console.log(z)},3e3)}setParent(P,z){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsDisposed(P){if(P&&P!==t.None)try{P[E]=!0}catch{}}markAsSingleton(P){}})}function C(E){return $?.trackDisposable(E),E}e.$Ic=C;function m(E){$?.markAsDisposed(E)}e.$Jc=m;function v(E,P){$?.setParent(E,P)}function S(E,P){if($)for(const z of E)$.setParent(z,P)}function f(E){return $?.markAsSingleton(E),E}e.$Kc=f;function d(E){return typeof E.dispose=="function"&&E.dispose.length===0}e.$Lc=d;function s(E){if(L.Iterable.is(E)){const P=[];for(const z of E)if(z)try{z.dispose()}catch(j){P.push(j)}if(P.length===1)throw P[0];if(P.length>1)throw new AggregateError(P,"Encountered errors while disposing of store");return Array.isArray(E)?[]:E}else if(E)return E.dispose(),E}e.$Mc=s;function i(E){for(const P of E)d(P)&&P.dispose();return[]}e.$Nc=i;function n(...E){const P=o(()=>s(E));return S(E,P),P}e.$Oc=n;function o(E){const P=C({dispose:(0,I.$cb)(()=>{m(P),E()})});return P}e.$Pc=o;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,C(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{s(this.f)}finally{this.f.clear()}}add(P){if(!P)return P;if(P===this)throw new Error("Cannot register a disposable on itself!");return v(P,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(P),P}delete(P){if(P){if(P===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(P),P.dispose()}}deleteAndLeak(P){P&&this.f.has(P)&&(this.f.delete(P),v(P,null))}}e.$Qc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,C(this),v(this.q,this)}dispose(){m(this),this.q.dispose()}B(P){if(P===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(P)}}e.$Rc=t;class r{constructor(){this.b=!1,C(this)}get value(){return this.b?void 0:this.a}set value(P){this.b||P===this.a||(this.a?.dispose(),P&&v(P,this),this.a=P)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const P=this.a;return this.a=void 0,P&&v(P,null),P}}e.$Sc=r;class h{constructor(P){this.a=new r,this.b=!1,this.a.value=P}get value(){return this.a.value}set value(P){this.b||P===this.a.value||(this.a.value=P)}dispose(){this.b=!0,this.a.dispose()}}e.$Tc=h;class u{constructor(P){this.b=P,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Uc=u;class c{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(P){let z=P;return this.unset=()=>z=void 0,this.isset=()=>z!==void 0,this.dispose=()=>{z&&(z(),z=void 0,m(this))},this}}e.$Vc=c;class l{constructor(){this.a=new Map}acquire(P,...z){let j=this.a.get(P);j||(j={counter:0,object:this.b(P,...z)},this.a.set(P,j));const{object:F}=j,O=(0,I.$cb)(()=>{--j.counter===0&&(this.c(P,j.object),this.a.delete(P))});return j.counter++,{object:F,dispose:O}}}e.$Wc=l;class k{constructor(P){this.a=P}async acquire(P,...z){const j=this.a.acquire(P,...z);try{return{object:await j.object,dispose:()=>j.dispose()}}catch(F){throw j.dispose(),F}}}e.$Xc=k;class R{constructor(P){this.object=P}dispose(){}}e.$Yc=R;function w(E){const P=new a;try{E(P)}finally{P.dispose()}}e.$Zc=w;class p{constructor(){this.a=new Map,this.b=!1,C(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{s(this.a.values())}finally{this.a.clear()}}has(P){return this.a.has(P)}get size(){return this.a.size}get(P){return this.a.get(P)}set(P,z,j=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),j||this.a.get(P)?.dispose(),this.a.set(P,z)}deleteAndDispose(P){this.a.get(P)?.dispose(),this.a.delete(P)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$1c=p}),function($e,e){typeof define=="function"&&define.amd?define(Ee[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):($e=typeof globalThis<"u"?globalThis:$e||self,e($e.marked={}))}(this,function($e){"use strict";function e(me,ee){for(var ie=0;ie<ee.length;ie++){var G=ee[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(me,G.key,G)}}function D(me,ee,ie){return ee&&e(me.prototype,ee),ie&&e(me,ie),Object.defineProperty(me,"prototype",{writable:!1}),me}function N(me,ee){if(me){if(typeof me=="string")return g(me,ee);var ie=Object.prototype.toString.call(me).slice(8,-1);if(ie==="Object"&&me.constructor&&(ie=me.constructor.name),ie==="Map"||ie==="Set")return Array.from(me);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return g(me,ee)}}function g(me,ee){(ee==null||ee>me.length)&&(ee=me.length);for(var ie=0,G=new Array(ee);ie<ee;ie++)G[ie]=me[ie];return G}function I(me,ee){var ie=typeof Symbol<"u"&&me[Symbol.iterator]||me["@@iterator"];if(ie)return(ie=ie.call(me)).next.bind(ie);if(Array.isArray(me)||(ie=N(me))||ee&&me&&typeof me.length=="number"){ie&&(me=ie);var G=0;return function(){return G>=me.length?{done:!0}:{done:!1,value:me[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}$e.defaults=L();function b(me){$e.defaults=me}var $=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,C=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},v=function(ee){return m[ee]};function S(me,ee){if(ee){if($.test(me))return me.replace(y,v)}else if(A.test(me))return me.replace(C,v);return me}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(me){return me.replace(f,function(ee,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(me,ee){me=typeof me=="string"?me:me.source,ee=ee||"";var ie={replace:function(te,J){return J=J.source||J,J=J.replace(s,"$1"),me=me.replace(te,J),ie},getRegex:function(){return new RegExp(me,ee)}};return ie}var n=/[^\w:]/g,o=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(me,ee,ie){if(me){var G;try{G=decodeURIComponent(d(ie)).replace(n,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}ee&&!o.test(ie)&&(ie=c(ee,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var t={},r=/^[^:]+:\/*[^/]*$/,h=/^([^:]+:)[\s\S]*$/,u=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(me,ee){t[" "+me]||(r.test(me)?t[" "+me]=me+"/":t[" "+me]=w(me,"/",!0)),me=t[" "+me];var ie=me.indexOf(":")===-1;return ee.substring(0,2)==="//"?ie?ee:me.replace(h,"$1")+ee:ee.charAt(0)==="/"?ie?ee:me.replace(u,"$1")+ee:me+ee}var l={exec:function(){}};function k(me){for(var ee=1,ie,G;ee<arguments.length;ee++){ie=arguments[ee];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(me[G]=ie[G])}return me}function R(me,ee){var ie=me.replace(/\|/g,function(J,ce,be){for(var Ie=!1,Me=ce;--Me>=0&&be[Me]==="\\";)Ie=!Ie;return Ie?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>ee)G.splice(ee);else for(;G.length<ee;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function w(me,ee,ie){var G=me.length;if(G===0)return"";for(var te=0;te<G;){var J=me.charAt(G-te-1);if(J===ee&&!ie)te++;else if(J!==ee&&ie)te++;else break}return me.slice(0,G-te)}function p(me,ee){if(me.indexOf(ee[1])===-1)return-1;for(var ie=me.length,G=0,te=0;te<ie;te++)if(me[te]==="\\")te++;else if(me[te]===ee[0])G++;else if(me[te]===ee[1]&&(G--,G<0))return te;return-1}function E(me){me&&me.sanitize&&!me.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(me,ee){if(ee<1)return"";for(var ie="";ee>1;)ee&1&&(ie+=me),ee>>=1,me+=me;return ie+me}function z(me,ee,ie,G){var te=ee.href,J=ee.title?S(ee.title):null,ce=me[1].replace(/\\([\[\]])/g,"$1");if(me[0].charAt(0)!=="!"){G.state.inLink=!0;var be={type:"link",raw:ie,href:te,title:J,text:ce,tokens:G.inlineTokens(ce)};return G.state.inLink=!1,be}return{type:"image",raw:ie,href:te,title:J,text:S(ce)}}function j(me,ee){var ie=me.match(/^(\s+)(?:```)/);if(ie===null)return ee;var G=ie[1];return ee.split(`
`).map(function(te){var J=te.match(/^\s+/);if(J===null)return te;var ce=J[0];return ce.length>=G.length?te.slice(G.length):te}).join(`
`)}var F=function(){function me(ie){this.options=ie||$e.defaults}var ee=me.prototype;return ee.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},ee.code=function(G){var te=this.rules.block.code.exec(G);if(te){var J=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?J:w(J,`
`)}}},ee.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var J=te[0],ce=j(J,te[3]||"");return{type:"code",raw:J,lang:te[2]?te[2].trim():te[2],text:ce}}},ee.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var J=te[2].trim();if(/#$/.test(J)){var ce=w(J,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(J=ce.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:J,tokens:this.lexer.inline(J)}}},ee.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},ee.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var J=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(J,[]),text:J}}},ee.list=function(G){var te=this.rules.block.list.exec(G);if(te){var J,ce,be,Ie,Me,B,_,se,K,ae,de,Re,Be=te[1].trim(),Xe=Be.length>1,Ye={type:"list",raw:"",ordered:Xe,start:Xe?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Xe?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Xe?Be:"[*+-]");for(var it=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Re=!1,!(!(te=it.exec(G))||this.rules.block.hr.test(G)));){if(J=te[0],G=G.substring(J.length),se=te[2].split(`
`,1)[0],K=G.split(`
`,1)[0],this.options.pedantic?(Ie=2,de=se.trimLeft()):(Ie=te[2].search(/[^ ]/),Ie=Ie>4?1:Ie,de=se.slice(Ie),Ie+=te[1].length),B=!1,!se&&/^ *$/.test(K)&&(J+=K+`
`,G=G.substring(K.length+1),Re=!0),!Re)for(var st=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Pe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Te=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}(?:```|~~~)"),qe=new RegExp("^ {0,"+Math.min(3,Ie-1)+"}#");G&&(ae=G.split(`
`,1)[0],se=ae,this.options.pedantic&&(se=se.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Te.test(se)||qe.test(se)||st.test(se)||Pe.test(G)));){if(se.search(/[^ ]/)>=Ie||!se.trim())de+=`
`+se.slice(Ie);else if(!B)de+=`
`+se;else break;!B&&!se.trim()&&(B=!0),J+=ae+`
`,G=G.substring(ae.length+1)}Ye.loose||(_?Ye.loose=!0:/\n *\n *$/.test(J)&&(_=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(de),ce&&(be=ce[0]!=="[ ] ",de=de.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:J,task:!!ce,checked:be,loose:!1,text:de}),Ye.raw+=J}Ye.items[Ye.items.length-1].raw=J.trimRight(),Ye.items[Ye.items.length-1].text=de.trimRight(),Ye.raw=Ye.raw.trimRight();var Le=Ye.items.length;for(Me=0;Me<Le;Me++){this.lexer.state.top=!1,Ye.items[Me].tokens=this.lexer.blockTokens(Ye.items[Me].text,[]);var xe=Ye.items[Me].tokens.filter(function(le){return le.type==="space"}),he=xe.every(function(le){for(var Ce=le.raw.split(""),Ve=0,Ge=I(Ce),_e;!(_e=Ge()).done;){var ot=_e.value;if(ot===`
`&&(Ve+=1),Ve>1)return!0}return!1});!Ye.loose&&xe.length&&he&&(Ye.loose=!0,Ye.items[Me].loose=!0)}return Ye}},ee.html=function(G){var te=this.rules.block.html.exec(G);if(te){var J={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]);J.type="paragraph",J.text=ce,J.tokens=this.lexer.inline(ce)}return J}},ee.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var J=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:J,raw:te[0],href:te[2],title:te[3]}}},ee.table=function(G){var te=this.rules.block.table.exec(G);if(te){var J={type:"table",header:R(te[1]).map(function(_){return{text:_}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(J.header.length===J.align.length){J.raw=te[0];var ce=J.align.length,be,Ie,Me,B;for(be=0;be<ce;be++)/^ *-+: *$/.test(J.align[be])?J.align[be]="right":/^ *:-+: *$/.test(J.align[be])?J.align[be]="center":/^ *:-+ *$/.test(J.align[be])?J.align[be]="left":J.align[be]=null;for(ce=J.rows.length,be=0;be<ce;be++)J.rows[be]=R(J.rows[be],J.header.length).map(function(_){return{text:_}});for(ce=J.header.length,Ie=0;Ie<ce;Ie++)J.header[Ie].tokens=this.lexer.inline(J.header[Ie].text);for(ce=J.rows.length,Ie=0;Ie<ce;Ie++)for(B=J.rows[Ie],Me=0;Me<B.length;Me++)B[Me].tokens=this.lexer.inline(B[Me].text);return J}}},ee.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},ee.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var J=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:J,tokens:this.lexer.inline(J)}}},ee.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},ee.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:S(te[1])}},ee.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):S(te[0]):te[0]}},ee.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var J=te[2].trim();if(!this.options.pedantic&&/^</.test(J)){if(!/>$/.test(J))return;var ce=w(J.slice(0,-1),"\\");if((J.length-ce.length)%2===0)return}else{var be=p(te[2],"()");if(be>-1){var Ie=te[0].indexOf("!")===0?5:4,Me=Ie+te[1].length+be;te[2]=te[2].substring(0,be),te[0]=te[0].substring(0,Me).trim(),te[3]=""}}var B=te[2],_="";if(this.options.pedantic){var se=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);se&&(B=se[1],_=se[3])}else _=te[3]?te[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(J)?B=B.slice(1):B=B.slice(1,-1)),z(te,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:_&&_.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},ee.reflink=function(G,te){var J;if((J=this.rules.inline.reflink.exec(G))||(J=this.rules.inline.nolink.exec(G))){var ce=(J[2]||J[1]).replace(/\s+/g," ");if(ce=te[ce.toLowerCase()],!ce||!ce.href){var be=J[0].charAt(0);return{type:"text",raw:be,text:be}}return z(J,ce,J[0],this.lexer)}},ee.emStrong=function(G,te,J){J===void 0&&(J="");var ce=this.rules.inline.emStrong.lDelim.exec(G);if(ce&&!(ce[3]&&J.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var be=ce[1]||ce[2]||"";if(!be||be&&(J===""||this.rules.inline.punctuation.exec(J))){var Ie=ce[0].length-1,Me,B,_=Ie,se=0,K=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(K.lastIndex=0,te=te.slice(-1*G.length+Ie);(ce=K.exec(te))!=null;)if(Me=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Me){if(B=Me.length,ce[3]||ce[4]){_+=B;continue}else if((ce[5]||ce[6])&&Ie%3&&!((Ie+B)%3)){se+=B;continue}if(_-=B,!(_>0)){if(B=Math.min(B,B+_+se),Math.min(Ie,B)%2){var ae=G.slice(1,Ie+ce.index+B);return{type:"em",raw:G.slice(0,Ie+ce.index+B+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var de=G.slice(2,Ie+ce.index+B-1);return{type:"strong",raw:G.slice(0,Ie+ce.index+B+1),text:de,tokens:this.lexer.inlineTokens(de)}}}}}},ee.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var J=te[2].replace(/\n/g," "),ce=/[^ ]/.test(J),be=/^ /.test(J)&&/ $/.test(J);return ce&&be&&(J=J.substring(1,J.length-1)),J=S(J,!0),{type:"codespan",raw:te[0],text:J}}},ee.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},ee.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},ee.autolink=function(G,te){var J=this.rules.inline.autolink.exec(G);if(J){var ce,be;return J[2]==="@"?(ce=S(this.options.mangle?te(J[1]):J[1]),be="mailto:"+ce):(ce=S(J[1]),be=ce),{type:"link",raw:J[0],text:ce,href:be,tokens:[{type:"text",raw:ce,text:ce}]}}},ee.url=function(G,te){var J;if(J=this.rules.inline.url.exec(G)){var ce,be;if(J[2]==="@")ce=S(this.options.mangle?te(J[0]):J[0]),be="mailto:"+ce;else{var Ie;do Ie=J[0],J[0]=this.rules.inline._backpedal.exec(J[0])[0];while(Ie!==J[0]);ce=S(J[0]),J[1]==="www."?be="http://"+ce:be=ce}return{type:"link",raw:J[0],text:ce,href:be,tokens:[{type:"text",raw:ce,text:ce}]}}},ee.inlineText=function(G,te){var J=this.rules.inline.text.exec(G);if(J){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):S(J[0]):J[0]:ce=S(this.options.smartypants?te(J[0]):J[0]),{type:"text",raw:J[0],text:ce}}},me}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=k({},O),O.gfm=k({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=k({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var T={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};T._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",T.punctuation=i(T.punctuation).replace(/punctuation/g,T._punctuation).getRegex(),T.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,T.escapedEmSt=/\\\*|\\_/g,T._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),T.emStrong.lDelim=i(T.emStrong.lDelim).replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimAst=i(T.emStrong.rDelimAst,"g").replace(/punct/g,T._punctuation).getRegex(),T.emStrong.rDelimUnd=i(T.emStrong.rDelimUnd,"g").replace(/punct/g,T._punctuation).getRegex(),T._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,T._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,T._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,T.autolink=i(T.autolink).replace("scheme",T._scheme).replace("email",T._email).getRegex(),T._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,T.tag=i(T.tag).replace("comment",T._comment).replace("attribute",T._attribute).getRegex(),T._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,T._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,T._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,T.link=i(T.link).replace("label",T._label).replace("href",T._href).replace("title",T._title).getRegex(),T.reflink=i(T.reflink).replace("label",T._label).replace("ref",O._label).getRegex(),T.nolink=i(T.nolink).replace("ref",O._label).getRegex(),T.reflinkSearch=i(T.reflinkSearch,"g").replace("reflink",T.reflink).replace("nolink",T.nolink).getRegex(),T.normal=k({},T),T.pedantic=k({},T.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",T._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",T._label).getRegex()}),T.gfm=k({},T.normal,{escape:i(T.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),T.gfm.url=i(T.gfm.url,"i").replace("email",T.gfm._extended_email).getRegex(),T.breaks=k({},T.gfm,{br:i(T.br).replace("{2,}","*").getRegex(),text:i(T.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function M(me){return me.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(me){var ee="",ie,G,te=me.length;for(ie=0;ie<te;ie++)G=me.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),ee+="&#"+G+";";return ee}var Y=function(){function me(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||$e.defaults,this.options.tokenizer=this.options.tokenizer||new F,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:O.normal,inline:T.normal};this.options.pedantic?(G.block=O.pedantic,G.inline=T.pedantic):this.options.gfm&&(G.block=O.gfm,this.options.breaks?G.inline=T.breaks:G.inline=T.gfm),this.tokenizer.rules=G}me.lex=function(G,te){var J=new me(te);return J.lex(G)},me.lexInline=function(G,te){var J=new me(te);return J.inlineTokens(G)};var ee=me.prototype;return ee.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},ee.blockTokens=function(G,te){var J=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(_,se,K){return se+"    ".repeat(K.length)});for(var ce,be,Ie,Me;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(_){return(ce=_.call({lexer:J},G,te))?(G=G.substring(ce.raw.length),te.push(ce),!0):!1}))){if(ce=this.tokenizer.space(G)){G=G.substring(ce.raw.length),ce.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(ce);continue}if(ce=this.tokenizer.code(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce);continue}if(ce=this.tokenizer.fences(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.heading(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.hr(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.blockquote(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.list(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.html(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.def(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&(be.type==="paragraph"||be.type==="text")?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=be.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.lheading(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(Ie=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var _=1/0,se=G.slice(1),K=void 0;J.options.extensions.startBlock.forEach(function(ae){K=ae.call({lexer:this},se),typeof K=="number"&&K>=0&&(_=Math.min(_,K))}),_<1/0&&_>=0&&(Ie=G.substring(0,_+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(Ie))){be=te[te.length-1],Me&&be.type==="paragraph"?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce),Me=Ie.length!==G.length,G=G.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&be.type==="text"?(be.raw+=`
`+ce.raw,be.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=be.text):te.push(ce);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,te},ee.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},ee.inlineTokens=function(G,te){var J=this;te===void 0&&(te=[]);var ce,be,Ie,Me=G,B,_,se;if(this.tokens.links){var K=Object.keys(this.tokens.links);if(K.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)K.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,B.index)+"["+P("a",B[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,B.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(_||(se=""),_=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(de){return(ce=de.call({lexer:J},G,te))?(G=G.substring(ce.raw.length),te.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.tag(G)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&ce.type==="text"&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(ce=this.tokenizer.link(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(ce.raw.length),be=te[te.length-1],be&&ce.type==="text"&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(ce=this.tokenizer.emStrong(G,Me,se)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.codespan(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.br(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.del(G)){G=G.substring(ce.raw.length),te.push(ce);continue}if(ce=this.tokenizer.autolink(G,W)){G=G.substring(ce.raw.length),te.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(G,W))){G=G.substring(ce.raw.length),te.push(ce);continue}if(Ie=G,this.options.extensions&&this.options.extensions.startInline&&function(){var de=1/0,Re=G.slice(1),Be=void 0;J.options.extensions.startInline.forEach(function(Xe){Be=Xe.call({lexer:this},Re),typeof Be=="number"&&Be>=0&&(de=Math.min(de,Be))}),de<1/0&&de>=0&&(Ie=G.substring(0,de+1))}(),ce=this.tokenizer.inlineText(Ie,M)){G=G.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(se=ce.raw.slice(-1)),_=!0,be=te[te.length-1],be&&be.type==="text"?(be.raw+=ce.raw,be.text+=ce.text):te.push(ce);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return te},D(me,null,[{key:"rules",get:function(){return{block:O,inline:T}}}]),me}(),ue=function(){function me(ie){this.options=ie||$e.defaults}var ee=me.prototype;return ee.code=function(G,te,J){var ce=(te||"").match(/\S*/)[0];if(this.options.highlight){var be=this.options.highlight(G,ce);be!=null&&be!==G&&(J=!0,G=be)}return G=G.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+S(ce,!0)+'">'+(J?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(J?G:S(G,!0))+`</code></pre>
`},ee.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},ee.html=function(G){return G},ee.heading=function(G,te,J,ce){if(this.options.headerIds){var be=this.options.headerPrefix+ce.slug(J);return"<h"+te+' id="'+be+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},ee.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ee.list=function(G,te,J){var ce=te?"ol":"ul",be=te&&J!==1?' start="'+J+'"':"";return"<"+ce+be+`>
`+G+"</"+ce+`>
`},ee.listitem=function(G){return"<li>"+G+`</li>
`},ee.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ee.paragraph=function(G){return"<p>"+G+`</p>
`},ee.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},ee.tablerow=function(G){return`<tr>
`+G+`</tr>
`},ee.tablecell=function(G,te){var J=te.header?"th":"td",ce=te.align?"<"+J+' align="'+te.align+'">':"<"+J+">";return ce+G+("</"+J+`>
`)},ee.strong=function(G){return"<strong>"+G+"</strong>"},ee.em=function(G){return"<em>"+G+"</em>"},ee.codespan=function(G){return"<code>"+G+"</code>"},ee.br=function(){return this.options.xhtml?"<br/>":"<br>"},ee.del=function(G){return"<del>"+G+"</del>"},ee.link=function(G,te,J){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return J;var ce='<a href="'+S(G)+'"';return te&&(ce+=' title="'+te+'"'),ce+=">"+J+"</a>",ce},ee.image=function(G,te,J){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return J;var ce='<img src="'+G+'" alt="'+J+'"';return te&&(ce+=' title="'+te+'"'),ce+=this.options.xhtml?"/>":">",ce},ee.text=function(G){return G},me}(),Z=function(){function me(){}var ee=me.prototype;return ee.strong=function(G){return G},ee.em=function(G){return G},ee.codespan=function(G){return G},ee.del=function(G){return G},ee.html=function(G){return G},ee.text=function(G){return G},ee.link=function(G,te,J){return""+J},ee.image=function(G,te,J){return""+J},ee.br=function(){return""},me}(),Q=function(){function me(){this.seen={}}var ee=me.prototype;return ee.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ee.getNextSafeSlug=function(G,te){var J=G,ce=0;if(this.seen.hasOwnProperty(J)){ce=this.seen[G];do ce++,J=G+"-"+ce;while(this.seen.hasOwnProperty(J))}return te||(this.seen[G]=ce,this.seen[J]=0),J},ee.slug=function(G,te){te===void 0&&(te={});var J=this.serialize(G);return this.getNextSafeSlug(J,te.dryrun)},me}(),x=function(){function me(ie){this.options=ie||$e.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new Q}me.parse=function(G,te){var J=new me(te);return J.parse(G)},me.parseInline=function(G,te){var J=new me(te);return J.parseInline(G)};var ee=me.prototype;return ee.parse=function(G,te){te===void 0&&(te=!0);var J="",ce,be,Ie,Me,B,_,se,K,ae,de,Re,Be,Xe,Ye,it,st,Pe,Te,qe,Le=G.length;for(ce=0;ce<Le;ce++){if(de=G[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[de.type]&&(qe=this.options.extensions.renderers[de.type].call({parser:this},de),qe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(de.type))){J+=qe||"";continue}switch(de.type){case"space":continue;case"hr":{J+=this.renderer.hr();continue}case"heading":{J+=this.renderer.heading(this.parseInline(de.tokens),de.depth,d(this.parseInline(de.tokens,this.textRenderer)),this.slugger);continue}case"code":{J+=this.renderer.code(de.text,de.lang,de.escaped);continue}case"table":{for(K="",se="",Me=de.header.length,be=0;be<Me;be++)se+=this.renderer.tablecell(this.parseInline(de.header[be].tokens),{header:!0,align:de.align[be]});for(K+=this.renderer.tablerow(se),ae="",Me=de.rows.length,be=0;be<Me;be++){for(_=de.rows[be],se="",B=_.length,Ie=0;Ie<B;Ie++)se+=this.renderer.tablecell(this.parseInline(_[Ie].tokens),{header:!1,align:de.align[Ie]});ae+=this.renderer.tablerow(se)}J+=this.renderer.table(K,ae);continue}case"blockquote":{ae=this.parse(de.tokens),J+=this.renderer.blockquote(ae);continue}case"list":{for(Re=de.ordered,Be=de.start,Xe=de.loose,Me=de.items.length,ae="",be=0;be<Me;be++)it=de.items[be],st=it.checked,Pe=it.task,Ye="",it.task&&(Te=this.renderer.checkbox(st),Xe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=Te+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=Te+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:Te}):Ye+=Te),Ye+=this.parse(it.tokens,Xe),ae+=this.renderer.listitem(Ye,Pe,st);J+=this.renderer.list(ae,Re,Be);continue}case"html":{J+=this.renderer.html(de.text);continue}case"paragraph":{J+=this.renderer.paragraph(this.parseInline(de.tokens));continue}case"text":{for(ae=de.tokens?this.parseInline(de.tokens):de.text;ce+1<Le&&G[ce+1].type==="text";)de=G[++ce],ae+=`
`+(de.tokens?this.parseInline(de.tokens):de.text);J+=te?this.renderer.paragraph(ae):ae;continue}default:{var xe='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(xe);return}else throw new Error(xe)}}}return J},ee.parseInline=function(G,te){te=te||this.renderer;var J="",ce,be,Ie,Me=G.length;for(ce=0;ce<Me;ce++){if(be=G[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[be.type]&&(Ie=this.options.extensions.renderers[be.type].call({parser:this},be),Ie!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(be.type))){J+=Ie||"";continue}switch(be.type){case"escape":{J+=te.text(be.text);break}case"html":{J+=te.html(be.text);break}case"link":{J+=te.link(be.href,be.title,this.parseInline(be.tokens,te));break}case"image":{J+=te.image(be.href,be.title,be.text);break}case"strong":{J+=te.strong(this.parseInline(be.tokens,te));break}case"em":{J+=te.em(this.parseInline(be.tokens,te));break}case"codespan":{J+=te.codespan(be.text);break}case"br":{J+=te.br();break}case"del":{J+=te.del(this.parseInline(be.tokens,te));break}case"text":{J+=te.text(be.text);break}default:{var B='Token with "'+be.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return J},me}();function oe(me,ee,ie){if(typeof me>"u"||me===null)throw new Error("marked(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");if(typeof ee=="function"&&(ie=ee,ee=null),ee=k({},oe.defaults,ee||{}),E(ee),ie){var G=ee.highlight,te;try{te=Y.lex(me,ee)}catch(Me){return ie(Me)}var J=function(B){var _;if(!B)try{ee.walkTokens&&oe.walkTokens(te,ee.walkTokens),_=x.parse(te,ee)}catch(se){B=se}return ee.highlight=G,B?ie(B):ie(null,_)};if(!G||G.length<3||(delete ee.highlight,!te.length))return J();var ce=0;oe.walkTokens(te,function(Me){Me.type==="code"&&(ce++,setTimeout(function(){G(Me.text,Me.lang,function(B,_){if(B)return J(B);_!=null&&_!==Me.text&&(Me.text=_,Me.escaped=!0),ce--,ce===0&&J()})},0))}),ce===0&&J();return}function be(Me){if(Me.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+S(Me.message+"",!0)+"</pre>";throw Me}try{var Ie=Y.lex(me,ee);if(ee.walkTokens){if(ee.async)return Promise.all(oe.walkTokens(Ie,ee.walkTokens)).then(function(){return x.parse(Ie,ee)}).catch(be);oe.walkTokens(Ie,ee.walkTokens)}return x.parse(Ie,ee)}catch(Me){be(Me)}}oe.options=oe.setOptions=function(me){return k(oe.defaults,me),b(oe.defaults),oe},oe.getDefaults=L,oe.defaults=$e.defaults,oe.use=function(){for(var me=arguments.length,ee=new Array(me),ie=0;ie<me;ie++)ee[ie]=arguments[ie];var G=k.apply(void 0,[{}].concat(ee)),te=oe.defaults.extensions||{renderers:{},childTokens:{}},J;ee.forEach(function(ce){if(ce.extensions&&(J=!0,ce.extensions.forEach(function(Ie){if(!Ie.name)throw new Error("extension name required");if(Ie.renderer){var Me=te.renderers?te.renderers[Ie.name]:null;Me?te.renderers[Ie.name]=function(){for(var B=arguments.length,_=new Array(B),se=0;se<B;se++)_[se]=arguments[se];var K=Ie.renderer.apply(this,_);return K===!1&&(K=Me.apply(this,_)),K}:te.renderers[Ie.name]=Ie.renderer}if(Ie.tokenizer){if(!Ie.level||Ie.level!=="block"&&Ie.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[Ie.level]?te[Ie.level].unshift(Ie.tokenizer):te[Ie.level]=[Ie.tokenizer],Ie.start&&(Ie.level==="block"?te.startBlock?te.startBlock.push(Ie.start):te.startBlock=[Ie.start]:Ie.level==="inline"&&(te.startInline?te.startInline.push(Ie.start):te.startInline=[Ie.start]))}Ie.childTokens&&(te.childTokens[Ie.name]=Ie.childTokens)})),ce.renderer&&function(){var Ie=oe.defaults.renderer||new ue,Me=function(se){var K=Ie[se];Ie[se]=function(){for(var ae=arguments.length,de=new Array(ae),Re=0;Re<ae;Re++)de[Re]=arguments[Re];var Be=ce.renderer[se].apply(Ie,de);return Be===!1&&(Be=K.apply(Ie,de)),Be}};for(var B in ce.renderer)Me(B);G.renderer=Ie}(),ce.tokenizer&&function(){var Ie=oe.defaults.tokenizer||new F,Me=function(se){var K=Ie[se];Ie[se]=function(){for(var ae=arguments.length,de=new Array(ae),Re=0;Re<ae;Re++)de[Re]=arguments[Re];var Be=ce.tokenizer[se].apply(Ie,de);return Be===!1&&(Be=K.apply(Ie,de)),Be}};for(var B in ce.tokenizer)Me(B);G.tokenizer=Ie}(),ce.walkTokens){var be=oe.defaults.walkTokens;G.walkTokens=function(Ie){var Me=[];return Me.push(ce.walkTokens.call(this,Ie)),be&&(Me=Me.concat(be.call(this,Ie))),Me}}J&&(G.extensions=te),oe.setOptions(G)})},oe.walkTokens=function(me,ee){for(var ie=[],G=function(){var be=J.value;switch(ie=ie.concat(ee.call(oe,be)),be.type){case"table":{for(var Ie=I(be.header),Me;!(Me=Ie()).done;){var B=Me.value;ie=ie.concat(oe.walkTokens(B.tokens,ee))}for(var _=I(be.rows),se;!(se=_()).done;)for(var K=se.value,ae=I(K),de;!(de=ae()).done;){var Re=de.value;ie=ie.concat(oe.walkTokens(Re.tokens,ee))}break}case"list":{ie=ie.concat(oe.walkTokens(be.items,ee));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[be.type]?oe.defaults.extensions.childTokens[be.type].forEach(function(Be){ie=ie.concat(oe.walkTokens(be[Be],ee))}):be.tokens&&(ie=ie.concat(oe.walkTokens(be.tokens,ee)))}},te=I(me),J;!(J=te()).done;)G();return ie},oe.parseInline=function(me,ee){if(typeof me>"u"||me===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof me!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(me)+", string expected");ee=k({},oe.defaults,ee||{}),E(ee);try{var ie=Y.lexInline(me,ee);return ee.walkTokens&&oe.walkTokens(ie,ee.walkTokens),x.parseInline(ie,ee)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,ee.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},oe.Parser=x,oe.parser=x.parse,oe.Renderer=ue,oe.TextRenderer=Z,oe.Lexer=Y,oe.lexer=Y.lex,oe.Tokenizer=F,oe.Slugger=Q,oe.parse=oe;var X=oe.options,ve=oe.setOptions,ge=oe.use,V=oe.walkTokens,U=oe.parseInline,ne=oe,ye=x.parse,fe=Y.lex;$e.Lexer=Y,$e.Parser=x,$e.Renderer=ue,$e.Slugger=Q,$e.TextRenderer=Z,$e.Tokenizer=F,$e.getDefaults=L,$e.lexer=fe,$e.marked=oe,$e.options=X,$e.parse=ne,$e.parseInline=U,$e.parser=ye,$e.setOptions=ve,$e.use=ge,$e.walkTokens=V,Object.defineProperty($e,"__esModule",{value:!0})}),define(Ee[76],Se([1,0,28]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$zl=e.$yl=void 0;const N=new D.$Cc(1e4);function g(y){return $(y,"NFC",N)}e.$yl=g;const I=new D.$Cc(1e4);function L(y){return $(y,"NFD",I)}e.$zl=L;const b=/[^\u0000-\u0080]/;function $(y,A,C){if(!y)return y;const m=C.get(y);if(m)return m;let v;return b.test(y)?v=y.normalize(A):v=y,C.set(y,v),v}e.$Al=function(){const y=/[\u0300-\u036f]/g;return function(A){return L(A).replace(y,"")}}()}),define(Ee[122],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.rot=e.$Yl=void 0;function D(b,$,y){return Math.min(Math.max(b,$),y)}e.$Yl=D;function N(b,$){return($+b%$)%$}e.rot=N;class g{constructor(){this.a=0}getNext(){return this.a++}}e.$1l=g;class I{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$2l=I;class L{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const y=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$3l=L}),function(){function $e(g){const I=[];typeof g=="number"&&I.push("code/timeOrigin",g);function L($){I.push($,Date.now())}function b(){const $=[];for(let y=0;y<I.length;y+=2)$.push({name:I[y],startTime:I[y+1]});return $}return{mark:L,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$e():{mark(g){performance.mark(g)},getMarks(){let g=performance.timeOrigin;typeof g!="number"&&(g=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const I=[{name:"code/timeOrigin",startTime:Math.round(g)}];for(const L of performance.getEntriesByType("mark"))I.push({name:L.name,startTime:Math.round(g+L.startTime)});return I}};if(typeof process=="object"){const g=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return $e(g)}else return console.trace("perf-util loaded in UNKNOWN environment"),$e()}function D(g){return g.MonacoPerformanceMarks||(g.MonacoPerformanceMarks=e()),g.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=D(N))}(),function($e,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var N in D)(typeof exports=="object"?exports:$e)[N]=D[N]}}(typeof self<"u"?self:this,function(){return function($e){var e={};function D(N){if(e[N])return e[N].exports;var g=e[N]={i:N,l:!1,exports:{}};return $e[N].call(g.exports,g,g.exports,D),g.l=!0,g.exports}return D.m=$e,D.c=e,D.d=function(N,g,I){D.o(N,g)||Object.defineProperty(N,g,{enumerable:!0,get:I})},D.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},D.t=function(N,g){if(1&g&&(N=D(N)),8&g||4&g&&typeof N=="object"&&N&&N.__esModule)return N;var I=Object.create(null);if(D.r(I),Object.defineProperty(I,"default",{enumerable:!0,value:N}),2&g&&typeof N!="string")for(var L in N)D.d(I,L,function(b){return N[b]}.bind(null,L));return I},D.n=function(N){var g=N&&N.__esModule?function(){return N.default}:function(){return N};return D.d(g,"a",g),g},D.o=function(N,g){return Object.prototype.hasOwnProperty.call(N,g)},D.p="",D(D.s=0)}([function($e,e,D){(function(N){var g;e=$e.exports=ge,g=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var K=Array.prototype.slice.call(arguments,0);K.unshift("SEMVER"),console.log.apply(console,K)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var I=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],$=e.src=[],y=0,A=y++;$[A]="0|[1-9]\\d*";var C=y++;$[C]="[0-9]+";var m=y++;$[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=y++;$[v]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var S=y++;$[S]="("+$[C]+")\\.("+$[C]+")\\.("+$[C]+")";var f=y++;$[f]="(?:"+$[A]+"|"+$[m]+")";var d=y++;$[d]="(?:"+$[C]+"|"+$[m]+")";var s=y++;$[s]="(?:-("+$[f]+"(?:\\."+$[f]+")*))";var i=y++;$[i]="(?:-?("+$[d]+"(?:\\."+$[d]+")*))";var n=y++;$[n]="[0-9A-Za-z-]+";var o=y++;$[o]="(?:\\+("+$[n]+"(?:\\."+$[n]+")*))";var a=y++,t="v?"+$[v]+$[s]+"?"+$[o]+"?";$[a]="^"+t+"$";var r="[v=\\s]*"+$[S]+$[i]+"?"+$[o]+"?",h=y++;$[h]="^"+r+"$";var u=y++;$[u]="((?:<|>)?=?)";var c=y++;$[c]=$[C]+"|x|X|\\*";var l=y++;$[l]=$[A]+"|x|X|\\*";var k=y++;$[k]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[s]+")?"+$[o]+"?)?)?";var R=y++;$[R]="[v=\\s]*("+$[c]+")(?:\\.("+$[c]+")(?:\\.("+$[c]+")(?:"+$[i]+")?"+$[o]+"?)?)?";var w=y++;$[w]="^"+$[u]+"\\s*"+$[k]+"$";var p=y++;$[p]="^"+$[u]+"\\s*"+$[R]+"$";var E=y++;$[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=y++;$[P]="(?:~>?)";var z=y++;$[z]="(\\s*)"+$[P]+"\\s+",b[z]=new RegExp($[z],"g");var j=y++;$[j]="^"+$[P]+$[k]+"$";var F=y++;$[F]="^"+$[P]+$[R]+"$";var O=y++;$[O]="(?:\\^)";var T=y++;$[T]="(\\s*)"+$[O]+"\\s+",b[T]=new RegExp($[T],"g");var M=y++;$[M]="^"+$[O]+$[k]+"$";var W=y++;$[W]="^"+$[O]+$[R]+"$";var Y=y++;$[Y]="^"+$[u]+"\\s*("+r+")$|^$";var ue=y++;$[ue]="^"+$[u]+"\\s*("+t+")$|^$";var Z=y++;$[Z]="(\\s*)"+$[u]+"\\s*("+r+"|"+$[k]+")",b[Z]=new RegExp($[Z],"g");var Q=y++;$[Q]="^\\s*("+$[k]+")\\s+-\\s+("+$[k]+")\\s*$";var x=y++;$[x]="^\\s*("+$[R]+")\\s+-\\s+("+$[R]+")\\s*$";var oe=y++;$[oe]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)g(X,$[X]),b[X]||(b[X]=new RegExp($[X]));function ve(K,ae){if(K instanceof ge)return K;if(typeof K!="string"||K.length>I||!(ae?b[h]:b[a]).test(K))return null;try{return new ge(K,ae)}catch{return null}}function ge(K,ae){if(K instanceof ge){if(K.loose===ae)return K;K=K.version}else if(typeof K!="string")throw new TypeError("Invalid Version: "+K);if(K.length>I)throw new TypeError("version is longer than "+I+" characters");if(!(this instanceof ge))return new ge(K,ae);g("SemVer",K,ae),this.loose=ae;var de=K.trim().match(ae?b[h]:b[a]);if(!de)throw new TypeError("Invalid Version: "+K);if(this.raw=K,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Re){if(/^[0-9]+$/.test(Re)){var Be=+Re;if(Be>=0&&Be<L)return Be}return Re}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ve,e.valid=function(K,ae){var de=ve(K,ae);return de?de.version:null},e.clean=function(K,ae){var de=ve(K.trim().replace(/^[=v]+/,""),ae);return de?de.version:null},e.SemVer=ge,ge.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ge.prototype.toString=function(){return this.version},ge.prototype.compare=function(K){return g("SemVer.compare",this.version,this.loose,K),K instanceof ge||(K=new ge(K,this.loose)),this.compareMain(K)||this.comparePre(K)},ge.prototype.compareMain=function(K){return K instanceof ge||(K=new ge(K,this.loose)),U(this.major,K.major)||U(this.minor,K.minor)||U(this.patch,K.patch)},ge.prototype.comparePre=function(K){if(K instanceof ge||(K=new ge(K,this.loose)),this.prerelease.length&&!K.prerelease.length)return-1;if(!this.prerelease.length&&K.prerelease.length)return 1;if(!this.prerelease.length&&!K.prerelease.length)return 0;var ae=0;do{var de=this.prerelease[ae],Re=K.prerelease[ae];if(g("prerelease compare",ae,de,Re),de===void 0&&Re===void 0)return 0;if(Re===void 0)return 1;if(de===void 0)return-1;if(de!==Re)return U(de,Re)}while(++ae)},ge.prototype.inc=function(K,ae){switch(K){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+K)}return this.format(),this.raw=this.version,this},e.inc=function(K,ae,de,Re){typeof de=="string"&&(Re=de,de=void 0);try{return new ge(K,de).inc(ae,Re).version}catch{return null}},e.diff=function(K,ae){if(me(K,ae))return null;var de=ve(K),Re=ve(ae);if(de.prerelease.length||Re.prerelease.length){for(var Be in de)if((Be==="major"||Be==="minor"||Be==="patch")&&de[Be]!==Re[Be])return"pre"+Be;return"prerelease"}for(var Be in de)if((Be==="major"||Be==="minor"||Be==="patch")&&de[Be]!==Re[Be])return Be},e.compareIdentifiers=U;var V=/^[0-9]+$/;function U(K,ae){var de=V.test(K),Re=V.test(ae);return de&&Re&&(K=+K,ae=+ae),de&&!Re?-1:Re&&!de?1:K<ae?-1:K>ae?1:0}function ne(K,ae,de){return new ge(K,de).compare(new ge(ae,de))}function ye(K,ae,de){return ne(K,ae,de)>0}function fe(K,ae,de){return ne(K,ae,de)<0}function me(K,ae,de){return ne(K,ae,de)===0}function ee(K,ae,de){return ne(K,ae,de)!==0}function ie(K,ae,de){return ne(K,ae,de)>=0}function G(K,ae,de){return ne(K,ae,de)<=0}function te(K,ae,de,Re){var Be;switch(ae){case"===":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),Be=K===de;break;case"!==":typeof K=="object"&&(K=K.version),typeof de=="object"&&(de=de.version),Be=K!==de;break;case"":case"=":case"==":Be=me(K,de,Re);break;case"!=":Be=ee(K,de,Re);break;case">":Be=ye(K,de,Re);break;case">=":Be=ie(K,de,Re);break;case"<":Be=fe(K,de,Re);break;case"<=":Be=G(K,de,Re);break;default:throw new TypeError("Invalid operator: "+ae)}return Be}function J(K,ae){if(K instanceof J){if(K.loose===ae)return K;K=K.value}if(!(this instanceof J))return new J(K,ae);g("comparator",K,ae),this.loose=ae,this.parse(K),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,g("comp",this)}e.rcompareIdentifiers=function(K,ae){return U(ae,K)},e.major=function(K,ae){return new ge(K,ae).major},e.minor=function(K,ae){return new ge(K,ae).minor},e.patch=function(K,ae){return new ge(K,ae).patch},e.compare=ne,e.compareLoose=function(K,ae){return ne(K,ae,!0)},e.rcompare=function(K,ae,de){return ne(ae,K,de)},e.sort=function(K,ae){return K.sort(function(de,Re){return e.compare(de,Re,ae)})},e.rsort=function(K,ae){return K.sort(function(de,Re){return e.rcompare(de,Re,ae)})},e.gt=ye,e.lt=fe,e.eq=me,e.neq=ee,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=J;var ce={};function be(K,ae){if(K instanceof be)return K.loose===ae?K:new be(K.raw,ae);if(K instanceof J)return new be(K.value,ae);if(!(this instanceof be))return new be(K,ae);if(this.loose=ae,this.raw=K,this.set=K.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+K);this.format()}function Ie(K){return!K||K.toLowerCase()==="x"||K==="*"}function Me(K,ae,de,Re,Be,Xe,Ye,it,st,Pe,Te,qe,Le){return((ae=Ie(de)?"":Ie(Re)?">="+de+".0.0":Ie(Be)?">="+de+"."+Re+".0":">="+ae)+" "+(it=Ie(st)?"":Ie(Pe)?"<"+(+st+1)+".0.0":Ie(Te)?"<"+st+"."+(+Pe+1)+".0":qe?"<="+st+"."+Pe+"."+Te+"-"+qe:"<="+it)).trim()}function B(K,ae){for(var de=0;de<K.length;de++)if(!K[de].test(ae))return!1;if(ae.prerelease.length){for(de=0;de<K.length;de++)if(g(K[de].semver),K[de].semver!==ce&&K[de].semver.prerelease.length>0){var Re=K[de].semver;if(Re.major===ae.major&&Re.minor===ae.minor&&Re.patch===ae.patch)return!0}return!1}return!0}function _(K,ae,de){try{ae=new be(ae,de)}catch{return!1}return ae.test(K)}function se(K,ae,de,Re){var Be,Xe,Ye,it,st;switch(K=new ge(K,Re),ae=new be(ae,Re),de){case">":Be=ye,Xe=G,Ye=fe,it=">",st=">=";break;case"<":Be=fe,Xe=ie,Ye=ye,it="<",st="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(_(K,ae,Re))return!1;for(var Pe=0;Pe<ae.set.length;++Pe){var Te=ae.set[Pe],qe=null,Le=null;if(Te.forEach(function(xe){xe.semver===ce&&(xe=new J(">=0.0.0")),qe=qe||xe,Le=Le||xe,Be(xe.semver,qe.semver,Re)?qe=xe:Ye(xe.semver,Le.semver,Re)&&(Le=xe)}),qe.operator===it||qe.operator===st||(!Le.operator||Le.operator===it)&&Xe(K,Le.semver)||Le.operator===st&&Ye(K,Le.semver))return!1}return!0}J.prototype.parse=function(K){var ae=this.loose?b[Y]:b[ue],de=K.match(ae);if(!de)throw new TypeError("Invalid comparator: "+K);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new ge(de[2],this.loose):this.semver=ce},J.prototype.toString=function(){return this.value},J.prototype.test=function(K){return g("Comparator.test",K,this.loose),this.semver===ce||(typeof K=="string"&&(K=new ge(K,this.loose)),te(K,this.operator,this.semver,this.loose))},J.prototype.intersects=function(K,ae){if(!(K instanceof J))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new be(K.value,ae),_(this.value,de,ae);if(K.operator==="")return de=new be(this.value,ae),_(K.semver,de,ae);var Re=!(this.operator!==">="&&this.operator!==">"||K.operator!==">="&&K.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||K.operator!=="<="&&K.operator!=="<"),Xe=this.semver.version===K.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||K.operator!==">="&&K.operator!=="<="),it=te(this.semver,"<",K.semver,ae)&&(this.operator===">="||this.operator===">")&&(K.operator==="<="||K.operator==="<"),st=te(this.semver,">",K.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(K.operator===">="||K.operator===">");return Re||Be||Xe&&Ye||it||st},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(K){return K.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(K){var ae=this.loose;K=K.trim(),g("range",K,ae);var de=ae?b[x]:b[Q];K=K.replace(de,Me),g("hyphen replace",K),K=K.replace(b[Z],"$1$2$3"),g("comparator trim",K,b[Z]),K=(K=(K=K.replace(b[z],"$1~")).replace(b[T],"$1^")).split(/\s+/).join(" ");var Re=ae?b[Y]:b[ue],Be=K.split(" ").map(function(Xe){return function(Ye,it){return g("comp",Ye),Ye=function(st,Pe){return st.trim().split(/\s+/).map(function(Te){return function(qe,Le){g("caret",qe,Le);var xe=Le?b[W]:b[M];return qe.replace(xe,function(he,le,Ce,Ve,Ge){var _e;return g("caret",qe,he,le,Ce,Ve,Ge),Ie(le)?_e="":Ie(Ce)?_e=">="+le+".0.0 <"+(+le+1)+".0.0":Ie(Ve)?_e=le==="0"?">="+le+"."+Ce+".0 <"+le+"."+(+Ce+1)+".0":">="+le+"."+Ce+".0 <"+(+le+1)+".0.0":Ge?(g("replaceCaret pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=le==="0"?Ce==="0"?">="+le+"."+Ce+"."+Ve+Ge+" <"+le+"."+Ce+"."+(+Ve+1):">="+le+"."+Ce+"."+Ve+Ge+" <"+le+"."+(+Ce+1)+".0":">="+le+"."+Ce+"."+Ve+Ge+" <"+(+le+1)+".0.0"):(g("no pr"),_e=le==="0"?Ce==="0"?">="+le+"."+Ce+"."+Ve+" <"+le+"."+Ce+"."+(+Ve+1):">="+le+"."+Ce+"."+Ve+" <"+le+"."+(+Ce+1)+".0":">="+le+"."+Ce+"."+Ve+" <"+(+le+1)+".0.0"),g("caret return",_e),_e})}(Te,Pe)}).join(" ")}(Ye,it),g("caret",Ye),Ye=function(st,Pe){return st.trim().split(/\s+/).map(function(Te){return function(qe,Le){var xe=Le?b[F]:b[j];return qe.replace(xe,function(he,le,Ce,Ve,Ge){var _e;return g("tilde",qe,he,le,Ce,Ve,Ge),Ie(le)?_e="":Ie(Ce)?_e=">="+le+".0.0 <"+(+le+1)+".0.0":Ie(Ve)?_e=">="+le+"."+Ce+".0 <"+le+"."+(+Ce+1)+".0":Ge?(g("replaceTilde pr",Ge),Ge.charAt(0)!=="-"&&(Ge="-"+Ge),_e=">="+le+"."+Ce+"."+Ve+Ge+" <"+le+"."+(+Ce+1)+".0"):_e=">="+le+"."+Ce+"."+Ve+" <"+le+"."+(+Ce+1)+".0",g("tilde return",_e),_e})}(Te,Pe)}).join(" ")}(Ye,it),g("tildes",Ye),Ye=function(st,Pe){return g("replaceXRanges",st,Pe),st.split(/\s+/).map(function(Te){return function(qe,Le){qe=qe.trim();var xe=Le?b[p]:b[w];return qe.replace(xe,function(he,le,Ce,Ve,Ge,_e){g("xRange",qe,he,le,Ce,Ve,Ge,_e);var ot=Ie(Ce),ut=ot||Ie(Ve),je=ut||Ie(Ge);return le==="="&&je&&(le=""),ot?he=le===">"||le==="<"?"<0.0.0":"*":le&&je?(ut&&(Ve=0),je&&(Ge=0),le===">"?(le=">=",ut?(Ce=+Ce+1,Ve=0,Ge=0):je&&(Ve=+Ve+1,Ge=0)):le==="<="&&(le="<",ut?Ce=+Ce+1:Ve=+Ve+1),he=le+Ce+"."+Ve+"."+Ge):ut?he=">="+Ce+".0.0 <"+(+Ce+1)+".0.0":je&&(he=">="+Ce+"."+Ve+".0 <"+Ce+"."+(+Ve+1)+".0"),g("xRange return",he),he})}(Te,Pe)}).join(" ")}(Ye,it),g("xrange",Ye),Ye=function(st,Pe){return g("replaceStars",st,Pe),st.trim().replace(b[oe],"")}(Ye,it),g("stars",Ye),Ye}(Xe,ae)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Xe){return!!Xe.match(Re)})),Be=Be.map(function(Xe){return new J(Xe,ae)})},be.prototype.intersects=function(K,ae){if(!(K instanceof be))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Re){return K.set.some(function(Be){return Be.every(function(Xe){return Re.intersects(Xe,ae)})})})})},e.toComparators=function(K,ae){return new be(K,ae).set.map(function(de){return de.map(function(Re){return Re.value}).join(" ").trim().split(" ")})},be.prototype.test=function(K){if(!K)return!1;typeof K=="string"&&(K=new ge(K,this.loose));for(var ae=0;ae<this.set.length;ae++)if(B(this.set[ae],K))return!0;return!1},e.satisfies=_,e.maxSatisfying=function(K,ae,de){var Re=null,Be=null;try{var Xe=new be(ae,de)}catch{return null}return K.forEach(function(Ye){Xe.test(Ye)&&(Re&&Be.compare(Ye)!==-1||(Be=new ge(Re=Ye,de)))}),Re},e.minSatisfying=function(K,ae,de){var Re=null,Be=null;try{var Xe=new be(ae,de)}catch{return null}return K.forEach(function(Ye){Xe.test(Ye)&&(Re&&Be.compare(Ye)!==1||(Be=new ge(Re=Ye,de)))}),Re},e.validRange=function(K,ae){try{return new be(K,ae).range||"*"}catch{return null}},e.ltr=function(K,ae,de){return se(K,ae,"<",de)},e.gtr=function(K,ae,de){return se(K,ae,">",de)},e.outside=se,e.prerelease=function(K,ae){var de=ve(K,ae);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(K,ae,de){return K=new be(K,de),ae=new be(ae,de),K.intersects(ae)},e.coerce=function(K){if(K instanceof ge)return K;if(typeof K!="string")return null;var ae=K.match(b[E]);return ae==null?null:ve((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,D(1))},function($e,e){var D,N,g=$e.exports={};function I(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function b(d){if(D===setTimeout)return setTimeout(d,0);if((D===I||!D)&&setTimeout)return D=setTimeout,setTimeout(d,0);try{return D(d,0)}catch{try{return D.call(null,d,0)}catch{return D.call(this,d,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:I}catch{D=I}try{N=typeof clearTimeout=="function"?clearTimeout:L}catch{N=L}})();var $,y=[],A=!1,C=-1;function m(){A&&$&&(A=!1,$.length?y=$.concat(y):C=-1,y.length&&v())}function v(){if(!A){var d=b(m);A=!0;for(var s=y.length;s;){for($=y,y=[];++C<s;)$&&$[C].run();C=-1,s=y.length}$=null,A=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===L||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(d)}}function S(d,s){this.fun=d,this.array=s}function f(){}g.nextTick=function(d){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new S(d,s)),y.length!==1||A||b(v)},S.prototype.run=function(){this.fun.apply(null,this.array)},g.title="browser",g.browser=!0,g.env={},g.argv=[],g.version="",g.versions={},g.on=f,g.addListener=f,g.once=f,g.off=f,g.removeListener=f,g.removeAllListeners=f,g.emit=f,g.prependListener=f,g.prependOnceListener=f,g.listeners=function(d){return[]},g.binding=function(d){throw new Error("process.binding is not supported")},g.cwd=function(){return"/"},g.chdir=function(d){throw new Error("process.chdir is not supported")},g.umask=function(){return 0}}])}),define(Ee[38],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nd=void 0;const D=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(I){return new N(I)}constructor(I){this.c=D&&I===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Nd=N}),define(Ee[4],Se([1,0,8,74,3,75,38]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.$Sd=e.$Rd=e.$Qd=e.$Pd=e.Event=void 0;const b=!1,$=!1;var y;(function(w){w.None=()=>g.$Rc.None;function p(te){if($){const{onDidAddListener:J}=te,ce=S.create();let be=0;te.onDidAddListener=()=>{++be===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),J?.()}}}function E(te,J){return ue(te,()=>{},0,void 0,!0,void 0,J)}w.defer=E;function P(te){return(J,ce=null,be)=>{let Ie=!1,Me;return Me=te(B=>{if(!Ie)return Me?Me.dispose():Ie=!0,J.call(ce,B)},null,be),Ie&&Me.dispose(),Me}}w.once=P;function z(te,J,ce){return W((be,Ie=null,Me)=>te(B=>be.call(Ie,J(B)),null,Me),ce)}w.map=z;function j(te,J,ce){return W((be,Ie=null,Me)=>te(B=>{J(B),be.call(Ie,B)},null,Me),ce)}w.forEach=j;function F(te,J,ce){return W((be,Ie=null,Me)=>te(B=>J(B)&&be.call(Ie,B),null,Me),ce)}w.filter=F;function O(te){return te}w.signal=O;function T(...te){return(J,ce=null,be)=>{const Ie=(0,g.$Oc)(...te.map(Me=>Me(B=>J.call(ce,B))));return Y(Ie,be)}}w.any=T;function M(te,J,ce,be){let Ie=ce;return z(te,Me=>(Ie=J(Ie,Me),Ie),be)}w.reduce=M;function W(te,J){let ce;const be={onWillAddFirstListener(){ce=te(Ie.fire,Ie)},onDidRemoveLastListener(){ce?.dispose()}};J||p(be);const Ie=new n(be);return J?.add(Ie),Ie.event}function Y(te,J){return J instanceof Array?J.push(te):J&&J.add(te),te}function ue(te,J,ce=100,be=!1,Ie=!1,Me,B){let _,se,K,ae=0,de;const Re={leakWarningThreshold:Me,onWillAddFirstListener(){_=te(Xe=>{ae++,se=J(se,Xe),be&&!K&&(Be.fire(se),se=void 0),de=()=>{const Ye=se;se=void 0,K=void 0,(!be||ae>1)&&Be.fire(Ye),ae=0},typeof ce=="number"?(clearTimeout(K),K=setTimeout(de,ce)):K===void 0&&(K=0,queueMicrotask(de))})},onWillRemoveListener(){Ie&&ae>0&&de?.()},onDidRemoveLastListener(){de=void 0,_.dispose()}};B||p(Re);const Be=new n(Re);return B?.add(Be),Be.event}w.debounce=ue;function Z(te,J=0,ce){return w.debounce(te,(be,Ie)=>be?(be.push(Ie),be):[Ie],J,void 0,!0,void 0,ce)}w.accumulate=Z;function Q(te,J=(be,Ie)=>be===Ie,ce){let be=!0,Ie;return F(te,Me=>{const B=be||!J(Me,Ie);return be=!1,Ie=Me,B},ce)}w.latch=Q;function x(te,J,ce){return[w.filter(te,J,ce),w.filter(te,be=>!J(be),ce)]}w.split=x;function oe(te,J=!1,ce=[],be){let Ie=ce.slice(),Me=te(se=>{Ie?Ie.push(se):_.fire(se)});be&&be.add(Me);const B=()=>{Ie?.forEach(se=>_.fire(se)),Ie=null},_=new n({onWillAddFirstListener(){Me||(Me=te(se=>_.fire(se)),be&&be.add(Me))},onDidAddFirstListener(){Ie&&(J?setTimeout(B):B())},onDidRemoveLastListener(){Me&&Me.dispose(),Me=null}});return be&&be.add(_),_.event}w.buffer=oe;function X(te,J){return(be,Ie,Me)=>{const B=J(new ge);return te(function(_){const se=B.evaluate(_);se!==ve&&be.call(Ie,se)},void 0,Me)}}w.chain=X;const ve=Symbol("HaltChainable");class ge{constructor(){this.f=[]}map(J){return this.f.push(J),this}forEach(J){return this.f.push(ce=>(J(ce),ce)),this}filter(J){return this.f.push(ce=>J(ce)?ce:ve),this}reduce(J,ce){let be=ce;return this.f.push(Ie=>(be=J(be,Ie),be)),this}latch(J=(ce,be)=>ce===be){let ce=!0,be;return this.f.push(Ie=>{const Me=ce||!J(Ie,be);return ce=!1,be=Ie,Me?Ie:ve}),this}evaluate(J){for(const ce of this.f)if(J=ce(J),J===ve)break;return J}}function V(te,J,ce=be=>be){const be=(..._)=>B.fire(ce(..._)),Ie=()=>te.on(J,be),Me=()=>te.removeListener(J,be),B=new n({onWillAddFirstListener:Ie,onDidRemoveLastListener:Me});return B.event}w.fromNodeEventEmitter=V;function U(te,J,ce=be=>be){const be=(..._)=>B.fire(ce(..._)),Ie=()=>te.addEventListener(J,be),Me=()=>te.removeEventListener(J,be),B=new n({onWillAddFirstListener:Ie,onDidRemoveLastListener:Me});return B.event}w.fromDOMEventEmitter=U;function ne(te){return new Promise(J=>P(te)(J))}w.toPromise=ne;function ye(te){const J=new n;return te.then(ce=>{J.fire(ce)},()=>{J.fire(void 0)}).finally(()=>{J.dispose()}),J.event}w.fromPromise=ye;function fe(te,J,ce){return J(ce),te(be=>J(be))}w.runAndSubscribe=fe;function me(te,J){let ce=null;function be(Me){ce?.dispose(),ce=new g.$Qc,J(Me,ce)}be(void 0);const Ie=te(Me=>be(Me));return(0,g.$Pc)(()=>{Ie.dispose(),ce?.dispose()})}w.runAndSubscribeWithStore=me;class ee{constructor(J,ce){this._observable=J,this.f=0,this.g=!1;const be={onWillAddFirstListener:()=>{J.addObserver(this)},onDidRemoveLastListener:()=>{J.removeObserver(this)}};ce||p(be),this.emitter=new n(be),ce&&ce.add(this.emitter)}beginUpdate(J){this.f++}handlePossibleChange(J){}handleChange(J,ce){this.g=!0}endUpdate(J){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function ie(te,J){return new ee(te,J).emitter.event}w.fromObservable=ie;function G(te){return J=>{let ce=0,be=!1;const Ie={beginUpdate(){ce++},endUpdate(){ce--,ce===0&&(te.reportChanges(),be&&(be=!1,J()))},handlePossibleChange(){},handleChange(){be=!0}};return te.addObserver(Ie),te.reportChanges(),{dispose(){te.removeObserver(Ie)}}}}w.fromObservableLight=G})(y||(e.Event=y={}));class A{static{this.all=new Set}static{this.f=0}constructor(p){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${p}_${A.f++}`,A.all.add(this)}start(p){this.g=new L.$Nd,this.listenerCount=p}stop(){if(this.g){const p=this.g.elapsed();this.durations.push(p),this.elapsedOverall+=p,this.invocationCount+=1,this.g=void 0}}}e.$Pd=A;let C=-1;function m(w){const p=C;return C=w,{dispose(){C=p}}}e.$Qd=m;class v{constructor(p,E=Math.random().toString(18).slice(2,5)){this.threshold=p,this.name=E,this.g=0}dispose(){this.f?.clear()}check(p,E){const P=this.threshold;if(P<=0||E<P)return;this.f||(this.f=new Map);const z=this.f.get(p.value)||0;if(this.f.set(p.value,z+1),this.g-=1,this.g<=0){this.g=P*.5;let j,F=0;for(const[O,T]of this.f)(!j||F<T)&&(j=O,F=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${E} listeners already. MOST frequent listener (${F}):`),console.warn(j)}return()=>{const j=this.f.get(p.value)||0;this.f.set(p.value,j-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(p){this.value=p}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let f=0;class d{constructor(p){this.value=p,this.id=f++}}const s=2,i=(w,p)=>{if(w instanceof d)p(w);else for(let E=0;E<w.length;E++){const P=w[E];P&&p(P)}};class n{constructor(p){this.w=0,this.f=p,this.g=C>0||this.f?.leakWarningThreshold?new v(this.f?.leakWarningThreshold??C):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(b){const p=this.t;queueMicrotask(()=>{i(p,E=>E.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(p,E,P)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),g.$Rc.None;if(this.m)return g.$Rc.None;E&&(p=p.bind(E));const z=new d(p);let j,F;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(z.stack=S.create(),j=this.g.check(z.stack,this.w+1)),b&&(z.stack=F??S.create()),this.t?this.t instanceof d?(this.u??=new a,this.t=[this.t,z]):this.t.push(z):(this.f?.onWillAddFirstListener?.(this),this.t=z,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,g.$Pc)(()=>{j?.(),this.x(z)});return P instanceof g.$Qc?P.add(O):Array.isArray(P)&&P.push(O),O},this.q}x(p){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const E=this.t,P=E.indexOf(p);if(P===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,E[P]=void 0;const z=this.u.current===this;if(this.w*s<=E.length){let j=0;for(let F=0;F<E.length;F++)E[F]?E[j++]=E[F]:z&&(this.u.end--,j<this.u.i&&this.u.i--);E.length=j}}y(p,E){if(!p)return;const P=this.f?.onListenerError||D.$Z;if(!P){p.value(E);return}try{p.value(E)}catch(z){P(z)}}z(p){const E=p.current.t;for(;p.i<p.end;)this.y(E[p.i++],p.value);p.reset()}fire(p){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof d)this.y(this.t,p);else{const E=this.u;E.enqueue(this,p,this.t.length),this.z(E)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Rd=n;const o=()=>new a;e.$Sd=o;class a{constructor(){this.i=-1,this.end=0}enqueue(p,E,P){this.i=0,this.end=P,this.current=p,this.value=E}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends n{async fireAsync(p,E,P){if(this.t)for(this.h||(this.h=new I.$2c),i(this.t,z=>this.h.push([z.value,p]));this.h.size>0&&!E.isCancellationRequested;){const[z,j]=this.h.shift(),F=[],O={...j,token:E,waitUntil:T=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");P&&(T=P(T,z)),F.push(T)}};try{z(O)}catch(T){(0,D.$Z)(T);continue}Object.freeze(F),await Promise.allSettled(F).then(T=>{for(const M of T)M.status==="rejected"&&(0,D.$Z)(M.reason)})}}}e.$Td=t;class r extends n{get isPaused(){return this.h!==0}constructor(p){super(p),this.h=0,this.s=new I.$2c,this.A=p?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const p=Array.from(this.s);this.s.clear(),super.fire(this.A(p))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(p){this.w&&(this.h!==0?this.s.push(p):super.fire(p))}}e.$Ud=r;class h extends r{constructor(p){super(p),this.k=p.delay??100}fire(p){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(p)}}e.$Vd=h;class u extends n{constructor(p){super(p),this.h=[],this.k=p?.merge}fire(p){this.hasListeners()&&(this.h.push(p),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(E=>super.fire(E)),this.h=[]}))}}e.$Wd=u;class c{constructor(){this.g=!1,this.h=[],this.f=new n({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(p){const E={event:p,listener:null};this.h.push(E),this.g&&this.m(E);const P=()=>{this.g&&this.o(E);const z=this.h.indexOf(E);this.h.splice(z,1)};return(0,g.$Pc)((0,N.$cb)(P))}j(){this.g=!0,this.h.forEach(p=>this.m(p))}k(){this.g=!1,this.h.forEach(p=>this.o(p))}m(p){p.listener=p.event(E=>this.f.fire(E))}o(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.f.dispose()}}e.$Xd=c;class l{constructor(p,E,P,z){this.f=new g.$Qc;const j=this.f.add(new c),F=this.f.add(new g.$1c);function O(T){F.set(T,j.add(z(T)))}for(const T of p)O(T);this.f.add(E(T=>{O(T)})),this.f.add(P(T=>{F.deleteAndDispose(T)})),this.event=j.event}dispose(){this.f.dispose()}}e.$Yd=l;class k{constructor(){this.f=[]}wrapEvent(p){return(E,P,z)=>p(j=>{const F=this.f[this.f.length-1];F?F.push(()=>E.call(P,j)):E.call(P,j)},void 0,z)}bufferEvents(p){const E=[];this.f.push(E);const P=p();return this.f.pop(),E.forEach(z=>z()),P}}e.$Zd=k;class R{constructor(){this.f=!1,this.g=y.None,this.h=g.$Rc.None,this.j=new n({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(p){this.g=p,this.f&&(this.h.dispose(),this.h=p(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$1d=R}),define(Ee[21],Se([1,0,4]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2d=e.CancellationToken=void 0;const N=Object.freeze(function(b,$){const y=setTimeout(b.bind($),0);return{dispose(){clearTimeout(y)}}});var g;(function(b){function $(y){return y===b.None||y===b.Cancelled||y instanceof I?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}b.isCancellationToken=$,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(g||(e.CancellationToken=g={}));class I{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new D.$Rd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class L{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new I),this.f}cancel(){this.f?this.f instanceof I&&this.f.cancel():this.f=g.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof I&&this.f.dispose():this.f=g.None}}e.$2d=L}),define(Ee[161],Se([1,0,21]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ce=e.$Be=e.$Ae=void 0;class N{constructor(b){this.b=b,this.a=null}get(){if(this.a)return this.a;const b=new D.$2d,$=this.b(b.token);return this.a={promise:$,dispose:()=>{this.a=null,b.cancel(),b.dispose()}},this.a}}e.$Ae=N;class g{constructor(b){this.c=b,this.a=void 0,this.b=void 0}get(b){const $=JSON.stringify(b);return this.b!==$&&(this.b=$,this.a=this.c(b)),this.a}}e.$Be=g;class I{get cachedValues(){return this.a}constructor(b){this.b=b,this.a=new Map}get(b){if(this.a.has(b))return this.a.get(b);const $=this.b(b);return this.a.set(b,$),$}}e.$Ce=I}),define(Ee[98],Se([1,0,8,3]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function g(o){const a=o;return a?typeof a.read=="function":!1}e.$3d=g;function I(o){const a=o;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$4d=I;function L(o){const a=o;return a?I(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$5d=L;function b(o,a){return new $(o,a)}e.$6d=b;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,D.$Z)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const h=r.indexOf(t);h>=0&&r.splice(h,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(o,a){const t=[];let r;for(;(r=o.read())!==null;)t.push(r);return a(t)}e.$7d=y;function A(o,a,t){const r=[];let h;for(;(h=o.read())!==null&&r.length<t;)r.push(h);return h===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof h<"u"){const u=h;return h=void 0,u}return o.read()}}}e.$8d=A;function C(o,a){return new Promise((t,r)=>{const h=[];m(o,{onData:u=>{a&&h.push(u)},onError:u=>{a?r(u):t(void 0)},onEnd:()=>{t(a?a(h):void 0)}})})}e.$9d=C;function m(o,a,t){o.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),o.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),o.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}e.$0d=m;function v(o,a){return new Promise((t,r)=>{const h=new N.$Qc,u=[],c=R=>{if(u.push(R),u.length>a)return h.dispose(),o.pause(),t({stream:o,buffer:u,ended:!1})},l=R=>(h.dispose(),r(R)),k=()=>(h.dispose(),t({stream:o,buffer:u,ended:!0}));h.add((0,N.$Pc)(()=>o.removeListener("error",l))),o.on("error",l),h.add((0,N.$Pc)(()=>o.removeListener("end",k))),o.on("end",k),h.add((0,N.$Pc)(()=>o.removeListener("data",c))),o.on("data",c)})}e.$$d=v;function S(o,a){const t=b(a);return t.end(o),t}e.$_d=S;function f(){const o=b(()=>{throw new Error("not supported")});return o.end(),o}e.$ae=f;function d(o){let a=!1;return{read:()=>a?null:(a=!0,o)}}e.$be=d;function s(o,a,t){const r=b(t);return m(o,{onData:h=>r.write(a.data(h)),onError:h=>r.error(a.error?a.error(h):h),onEnd:()=>r.end()}),r}e.$ce=s;function i(o,a,t){let r=!1;return{read:()=>{const h=a.read();return r?h:(r=!0,h!==null?t([o,h]):o)}}}e.$de=i;function n(o,a,t){let r=!1;const h=b(t);return m(a,{onData:u=>r?h.write(u):(r=!0,h.write(t([o,u]))),onError:u=>h.error(u),onEnd:()=>{r||(r=!0,h.write(o)),h.end()}}),h}e.$ee=n}),define(Ee[22],Se([1,0,43,98]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const g=typeof Buffer<"u",I=new D.$U(()=>new Uint8Array(256));let L,b;class ${static alloc(E){return g?new $(Buffer.allocUnsafe(E)):new $(new Uint8Array(E))}static wrap(E){return g&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new $(E)}static fromString(E,P){return!(P?.dontUseNodeBuffer||!1)&&g?new $(Buffer.from(E)):(L||(L=new TextEncoder),new $(L.encode(E)))}static fromByteArray(E){const P=$.alloc(E.length);for(let z=0,j=E.length;z<j;z++)P.buffer[z]=E[z];return P}static concat(E,P){if(typeof P>"u"){P=0;for(let F=0,O=E.length;F<O;F++)P+=E[F].byteLength}const z=$.alloc(P);let j=0;for(let F=0,O=E.length;F<O;F++){const T=E[F];z.set(T,j),j+=T.byteLength}return z}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=$.alloc(this.byteLength);return E.set(this),E}toString(){return g?this.buffer.toString():(b||(b=new TextDecoder),b.decode(this.buffer))}slice(E,P){return new $(this.buffer.subarray(E,P))}set(E,P){if(E instanceof $)this.buffer.set(E.buffer,P);else if(E instanceof Uint8Array)this.buffer.set(E,P);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),P);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return m(this.buffer,E)}writeUInt32BE(E,P){v(this.buffer,E,P)}readUInt32LE(E){return S(this.buffer,E)}writeUInt32LE(E,P){f(this.buffer,E,P)}readUInt8(E){return d(this.buffer,E)}writeUInt8(E,P){s(this.buffer,E,P)}indexOf(E,P=0){return y(this.buffer,E instanceof $?E.buffer:E,P)}}e.$fe=$;function y(p,E,P=0){const z=E.byteLength,j=p.byteLength;if(z===0)return 0;if(z===1)return p.indexOf(E[0]);if(z>j-P)return-1;const F=I.value;F.fill(E.length);for(let W=0;W<E.length;W++)F[E[W]]=E.length-W-1;let O=P+E.length-1,T=O,M=-1;for(;O<j;)if(p[O]===E[T]){if(T===0){M=O;break}O--,T--}else O+=Math.max(E.length-T,F[p[O]]),T=E.length-1;return M}e.$ge=y;function A(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0}e.$he=A;function C(p,E,P){p[P+0]=E&255,E=E>>>8,p[P+1]=E&255}e.$ie=C;function m(p,E){return p[E]*2**24+p[E+1]*2**16+p[E+2]*2**8+p[E+3]}e.$je=m;function v(p,E,P){p[P+3]=E,E=E>>>8,p[P+2]=E,E=E>>>8,p[P+1]=E,E=E>>>8,p[P]=E}e.$ke=v;function S(p,E){return p[E+0]<<0>>>0|p[E+1]<<8>>>0|p[E+2]<<16>>>0|p[E+3]<<24>>>0}e.$le=S;function f(p,E,P){p[P+0]=E&255,E=E>>>8,p[P+1]=E&255,E=E>>>8,p[P+2]=E&255,E=E>>>8,p[P+3]=E&255}e.$me=f;function d(p,E){return p[E]}e.$ne=d;function s(p,E,P){p[P]=E}e.$oe=s;function i(p){return N.$7d(p,E=>$.concat(E))}e.$pe=i;function n(p){return N.$be(p)}e.$qe=n;function o(p){return N.$9d(p,E=>$.concat(E))}e.$re=o;async function a(p){return p.ended?$.concat(p.buffer):$.concat([...p.buffer,await o(p.stream)])}e.$se=a;function t(p){return N.$_d(p,E=>$.concat(E))}e.$te=t;function r(p){return N.$ce(p,{data:E=>typeof E=="string"?$.fromString(E):$.wrap(E)},E=>$.concat(E))}e.$ue=r;function h(p){return N.$6d(E=>$.concat(E),p)}e.$ve=h;function u(p,E){return N.$de(p,E,P=>$.concat(P))}e.$we=u;function c(p,E){return N.$ee(p,E,P=>$.concat(P))}e.$xe=c;function l(p){let E=0,P=0,z=0;const j=new Uint8Array(Math.floor(p.length/4*3)),F=T=>{switch(P){case 3:j[z++]=E|T,P=0;break;case 2:j[z++]=E|T>>>2,E=T<<6,P=3;break;case 1:j[z++]=E|T>>>4,E=T<<4,P=2;break;default:E=T<<2,P=1}};for(let T=0;T<p.length;T++){const M=p.charCodeAt(T);if(M>=65&&M<=90)F(M-65);else if(M>=97&&M<=122)F(M-97+26);else if(M>=48&&M<=57)F(M-48+52);else if(M===43||M===45)F(62);else if(M===47||M===95)F(63);else{if(M===61)break;throw new SyntaxError(`Unexpected base64 character ${p[T]}`)}}const O=z;for(;P>0;)F(0);return $.wrap(j).slice(0,O)}e.$ye=l;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",R="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function w({buffer:p},E=!0,P=!1){const z=P?R:k;let j="";const F=p.byteLength%3;let O=0;for(;O<p.byteLength-F;O+=3){const T=p[O+0],M=p[O+1],W=p[O+2];j+=z[T>>>2],j+=z[(T<<4|M>>>4)&63],j+=z[(M<<2|W>>>6)&63],j+=z[W&63]}if(F===1){const T=p[O+0];j+=z[T>>>2],j+=z[T<<4&63],E&&(j+="==")}else if(F===2){const T=p[O+0],M=p[O+1];j+=z[T>>>2],j+=z[(T<<4|M>>>4)&63],j+=z[M<<2&63],E&&(j+="=")}return j}e.$ze=w}),define(Ee[13],Se([1,0,161,43]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bf=e.$Af=e.$zf=e.$yf=e.GraphemeBreakType=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=e.$Ie=e.$He=e.$Ge=e.$Fe=void 0;function g(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Fe=g;const I=/{(\d+)}/g;function L(Pe,...Te){return Te.length===0?Pe:Pe.replace(I,function(qe,Le){const xe=parseInt(Le,10);return isNaN(xe)||xe<0||xe>=Te.length?qe:Te[xe]})}e.$Ge=L;const b=/{([^}]+)}/g;function $(Pe,Te){return Object.keys(Te).length===0?Pe:Pe.replace(b,(qe,Le)=>Te[Le]??qe)}e.$He=$;function y(Pe){return Pe.replace(/[<>&]/g,function(Te){switch(Te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Te}})}e.$Ie=y;function A(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Je=A;function C(Pe,Te){let qe=0;const Le=Te.charCodeAt(0);for(let xe=Pe.length-1;xe>=0;xe--)Pe.charCodeAt(xe)===Le&&qe++;return qe}e.$Ke=C;function m(Pe,Te,qe="\u2026"){return Pe.length<=Te?Pe:`${Pe.substr(0,Te)}${qe}`}e.$Le=m;function v(Pe,Te=" "){const qe=S(Pe,Te);return f(qe,Te)}e.$Me=v;function S(Pe,Te){if(!Pe||!Te)return Pe;const qe=Te.length;if(qe===0||Pe.length===0)return Pe;let Le=0;for(;Pe.indexOf(Te,Le)===Le;)Le=Le+qe;return Pe.substring(Le)}e.$Ne=S;function f(Pe,Te){if(!Pe||!Te)return Pe;const qe=Te.length,Le=Pe.length;if(qe===0||Le===0)return Pe;let xe=Le,he=-1;for(;he=Pe.lastIndexOf(Te,xe-1),!(he===-1||he+qe!==xe);){if(he===0)return"";xe=he}return Pe.substring(0,xe)}e.$Oe=f;function d(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Pe=d;function s(Pe){return Pe.replace(/\*/g,"")}e.$Qe=s;function i(Pe,Te,qe={}){if(!Pe)throw new Error("Cannot create regex from empty string");Te||(Pe=A(Pe)),qe.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Le="";return qe.global&&(Le+="g"),qe.matchCase||(Le+="i"),qe.multiline&&(Le+="m"),qe.unicode&&(Le+="u"),new RegExp(Pe,Le)}e.$Re=i;function n(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Se=n;function o(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Te=o;function a(Pe){for(let Te=0,qe=Pe.length;Te<qe;Te++){const Le=Pe.charCodeAt(Te);if(Le!==32&&Le!==9)return Te}return-1}e.$Ue=a;function t(Pe,Te=0,qe=Pe.length){for(let Le=Te;Le<qe;Le++){const xe=Pe.charCodeAt(Le);if(xe!==32&&xe!==9)return Pe.substring(Te,Le)}return Pe.substring(Te,qe)}e.$Ve=t;function r(Pe,Te=Pe.length-1){for(let qe=Te;qe>=0;qe--){const Le=Pe.charCodeAt(qe);if(Le!==32&&Le!==9)return qe}return-1}e.$We=r;function h(Pe,Te,qe){const Le=[];let xe=0;for(const he of Pe.matchAll(Te)){if(Le.push(Pe.slice(xe,he.index)),he.index===void 0)throw new Error("match.index should be defined");xe=he.index+he[0].length,Le.push(qe(he[0],...he.slice(1),he.index,Pe,he.groups))}return Le.push(Pe.slice(xe)),Promise.all(Le).then(he=>he.join(""))}e.$Xe=h;function u(Pe,Te){return Pe<Te?-1:Pe>Te?1:0}e.$Ye=u;function c(Pe,Te,qe=0,Le=Pe.length,xe=0,he=Te.length){for(;qe<Le&&xe<he;qe++,xe++){const Ve=Pe.charCodeAt(qe),Ge=Te.charCodeAt(xe);if(Ve<Ge)return-1;if(Ve>Ge)return 1}const le=Le-qe,Ce=he-xe;return le<Ce?-1:le>Ce?1:0}e.$Ze=c;function l(Pe,Te){return k(Pe,Te,0,Pe.length,0,Te.length)}e.$1e=l;function k(Pe,Te,qe=0,Le=Pe.length,xe=0,he=Te.length){for(;qe<Le&&xe<he;qe++,xe++){let Ve=Pe.charCodeAt(qe),Ge=Te.charCodeAt(xe);if(Ve===Ge)continue;if(Ve>=128||Ge>=128)return c(Pe.toLowerCase(),Te.toLowerCase(),qe,Le,xe,he);w(Ve)&&(Ve-=32),w(Ge)&&(Ge-=32);const _e=Ve-Ge;if(_e!==0)return _e}const le=Le-qe,Ce=he-xe;return le<Ce?-1:le>Ce?1:0}e.$2e=k;function R(Pe){return Pe>=48&&Pe<=57}e.$3e=R;function w(Pe){return Pe>=97&&Pe<=122}e.$4e=w;function p(Pe){return Pe>=65&&Pe<=90}e.$5e=p;function E(Pe,Te){return Pe.length===Te.length&&k(Pe,Te)===0}e.$6e=E;function P(Pe,Te){const qe=Te.length;return Te.length>Pe.length?!1:k(Pe,Te,0,qe)===0}e.$7e=P;function z(Pe,Te){const qe=Math.min(Pe.length,Te.length);let Le;for(Le=0;Le<qe;Le++)if(Pe.charCodeAt(Le)!==Te.charCodeAt(Le))return Le;return qe}e.$8e=z;function j(Pe,Te){const qe=Math.min(Pe.length,Te.length);let Le;const xe=Pe.length-1,he=Te.length-1;for(Le=0;Le<qe;Le++)if(Pe.charCodeAt(xe-Le)!==Te.charCodeAt(he-Le))return Le;return qe}e.$9e=j;function F(Pe){return 55296<=Pe&&Pe<=56319}e.$0e=F;function O(Pe){return 56320<=Pe&&Pe<=57343}e.$$e=O;function T(Pe,Te){return(Pe-55296<<10)+(Te-56320)+65536}e.$_e=T;function M(Pe,Te,qe){const Le=Pe.charCodeAt(qe);if(F(Le)&&qe+1<Te){const xe=Pe.charCodeAt(qe+1);if(O(xe))return T(Le,xe)}return Le}e.$af=M;function W(Pe,Te){const qe=Pe.charCodeAt(Te-1);if(O(qe)&&Te>1){const Le=Pe.charCodeAt(Te-2);if(F(Le))return T(Le,qe)}return qe}class Y{get offset(){return this.e}constructor(Te,qe=0){this.c=Te,this.d=Te.length,this.e=qe}setOffset(Te){this.e=Te}prevCodePoint(){const Te=W(this.c,this.e);return this.e-=Te>=65536?2:1,Te}nextCodePoint(){const Te=M(this.c,this.d,this.e);return this.e+=Te>=65536?2:1,Te}eol(){return this.e>=this.d}}e.$bf=Y;class ue{get offset(){return this.c.offset}constructor(Te,qe=0){this.c=new Y(Te,qe)}nextGraphemeLength(){const Te=ae.getInstance(),qe=this.c,Le=qe.offset;let xe=Te.getGraphemeBreakType(qe.nextCodePoint());for(;!qe.eol();){const he=qe.offset,le=Te.getGraphemeBreakType(qe.nextCodePoint());if(se(xe,le)){qe.setOffset(he);break}xe=le}return qe.offset-Le}prevGraphemeLength(){const Te=ae.getInstance(),qe=this.c,Le=qe.offset;let xe=Te.getGraphemeBreakType(qe.prevCodePoint());for(;qe.offset>0;){const he=qe.offset,le=Te.getGraphemeBreakType(qe.prevCodePoint());if(se(le,xe)){qe.setOffset(he);break}xe=le}return Le-qe.offset}eol(){return this.c.eol()}}e.$cf=ue;function Z(Pe,Te){return new ue(Pe,Te).nextGraphemeLength()}e.$df=Z;function Q(Pe,Te){return new ue(Pe,Te).prevGraphemeLength()}e.$ef=Q;function x(Pe,Te){Te>0&&O(Pe.charCodeAt(Te))&&Te--;const qe=Te+Z(Pe,Te);return[qe-Q(Pe,qe),qe]}e.$ff=x;function oe(Pe){const Te=new ue(Pe);let qe=0;for(;!Te.eol();)qe++,Te.nextGraphemeLength();return qe}e.$gf=oe;let X;function ve(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ge(Pe){return X||(X=ve()),X.test(Pe)}e.$hf=ge;const V=/^[\t\n\r\x20-\x7E]*$/;function U(Pe){return V.test(Pe)}e.$if=U,e.$jf=/[\u2028\u2029]/;function ne(Pe){return e.$jf.test(Pe)}e.$kf=ne;function ye(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$lf=ye;function fe(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$mf=fe;function me(Pe,Te){if(Pe.length<Te)return Pe;const qe=/\b/g;let Le=0;for(;qe.test(Pe)&&!(Pe.length-qe.lastIndex<Te);)Le=qe.lastIndex,qe.lastIndex+=1;return Pe.substring(Le).replace(/^\s/,"")}e.$nf=me;const ee=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ie=/\x1b\].*?\x07/g;function G(Pe){return Pe&&(Pe=Pe.replace(ee,"").replace(ie,"")),Pe}e.$of=G,e.$pf=String.fromCharCode(65279);function te(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$qf=te;function J(Pe){return te(Pe)?Pe.substr(1):Pe}e.$rf=J;function ce(Pe,Te){if(!Pe||!Te||Pe.length<Te.length)return!1;const qe=Te.length,Le=Pe.toLowerCase();let xe=0,he=-1;for(;xe<qe;){const le=Le.indexOf(Te[xe],he+1);if(le<0)return!1;he=le,xe++}return!0}e.$sf=ce;function be(Pe,Te=!1){return Pe?(Te&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$tf=be;function Ie(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$uf=Ie;function Me(Pe,Te=1){if(Te===0)return"";let qe=-1;do qe=Pe.indexOf(`
`,qe+1),Te--;while(Te>0&&qe>=0);return qe===-1?Pe:(Pe[qe-1]==="\r"&&qe--,Pe.substr(0,qe))}e.$vf=Me;function B(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$wf=B;function _(Pe){return ae.getInstance().getGraphemeBreakType(Pe)}e.$xf=_;function se(Pe,Te){return Pe===0?Te!==5&&Te!==7:Pe===2&&Te===3?!1:Pe===4||Pe===2||Pe===3||Te===4||Te===2||Te===3?!0:!(Pe===8&&(Te===8||Te===9||Te===11||Te===12)||(Pe===11||Pe===9)&&(Te===9||Te===10)||(Pe===12||Pe===10)&&Te===10||Te===5||Te===13||Te===7||Pe===1||Pe===13&&Te===14||Pe===6&&Te===6)}var K;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(K||(e.GraphemeBreakType=K={}));class ae{static{this.c=null}static getInstance(){return ae.c||(ae.c=new ae),ae.c}constructor(){this.d=de()}getGraphemeBreakType(Te){if(Te<32)return Te===10?3:Te===13?2:4;if(Te<127)return 0;const qe=this.d,Le=qe.length/3;let xe=1;for(;xe<=Le;)if(Te<qe[3*xe])xe=2*xe;else if(Te>qe[3*xe+1])xe=2*xe+1;else return qe[3*xe+2];return 0}}function de(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Re(Pe,Te){if(Pe===0)return 0;const qe=Be(Pe,Te);if(qe!==void 0)return qe;const Le=new Y(Te,Pe);return Le.prevCodePoint(),Le.offset}e.$yf=Re;function Be(Pe,Te){const qe=new Y(Te,Pe);let Le=qe.prevCodePoint();for(;Xe(Le)||Le===65039||Le===8419;){if(qe.offset===0)return;Le=qe.prevCodePoint()}if(!fe(Le))return;let xe=qe.offset;return xe>0&&qe.prevCodePoint()===8205&&(xe=qe.offset),xe}function Xe(Pe){return 127995<=Pe&&Pe<=127999}var Ye;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(Ye||(Ye={})),e.$zf="\xA0";class it{static{this.c=new N.$U(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new D.$Be(Te=>{function qe(_e){const ot=new Map;for(let ut=0;ut<_e.length;ut+=2)ot.set(_e[ut],_e[ut+1]);return ot}function Le(_e,ot){const ut=new Map(_e);for(const[je,kt]of ot)ut.set(je,kt);return ut}function xe(_e,ot){if(!_e)return ot;const ut=new Map;for(const[je,kt]of _e)ot.has(je)&&ut.set(je,kt);return ut}const he=this.c.value;let le=Te.filter(_e=>!_e.startsWith("_")&&_e in he);le.length===0&&(le=["_default"]);let Ce;for(const _e of le){const ot=qe(he[_e]);Ce=xe(Ce,ot)}const Ve=qe(he._common),Ge=Le(Ve,Ce);return new it(Ge)})}static getInstance(Te){return it.d.get(Array.from(Te))}static{this.e=new N.$U(()=>Object.keys(it.c.value).filter(Te=>!Te.startsWith("_")))}static getLocales(){return it.e.value}constructor(Te){this.f=Te}isAmbiguous(Te){return this.f.has(Te)}getPrimaryConfusable(Te){return this.f.get(Te)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Af=it;class st{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(st.c())),this.d}static isInvisibleCharacter(Te){return st.e().has(Te)}static get codePoints(){return st.e()}}e.$Bf=st}),define(Ee[123],Se([1,0,28,13]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.FuzzyScore=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.or=void 0;function g(...J){return function(ce,be){for(let Ie=0,Me=J.length;Ie<Me;Ie++){const B=J[Ie](ce,be);if(B)return B}return null}}e.or=g,e.$Mj=I.bind(void 0,!1),e.$Nj=I.bind(void 0,!0);function I(J,ce,be){if(!be||be.length<ce.length)return null;let Ie;return J?Ie=N.$7e(be,ce):Ie=be.indexOf(ce)===0,Ie?ce.length>0?[{start:0,end:ce.length}]:[]:null}function L(J,ce){const be=ce.toLowerCase().indexOf(J.toLowerCase());return be===-1?null:[{start:be,end:be+J.length}]}e.$Oj=L;function b(J,ce){return $(J.toLowerCase(),ce.toLowerCase(),0,0)}e.$Pj=b;function $(J,ce,be,Ie){if(be===J.length)return[];if(Ie===ce.length)return null;if(J[be]===ce[Ie]){let Me=null;return(Me=$(J,ce,be+1,Ie+1))?s({start:Ie,end:Ie+1},Me):null}return $(J,ce,be,Ie+1)}function y(J){return 97<=J&&J<=122}function A(J){return 65<=J&&J<=90}e.$Qj=A;function C(J){return 48<=J&&J<=57}function m(J){return J===32||J===9||J===10||J===13}const v=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(J=>v.add(J.charCodeAt(0)));function S(J){return m(J)||v.has(J)}function f(J,ce){return J===ce||S(J)&&S(ce)}function d(J){return y(J)||A(J)||C(J)}function s(J,ce){return ce.length===0?ce=[J]:J.end===ce[0].start?ce[0].start=J.start:ce.unshift(J),ce}function i(J,ce){for(let be=ce;be<J.length;be++){const Ie=J.charCodeAt(be);if(A(Ie)||C(Ie)||be>0&&!d(J.charCodeAt(be-1)))return be}return J.length}function n(J,ce,be,Ie){if(be===J.length)return[];if(Ie===ce.length)return null;if(J[be]!==ce[Ie].toLowerCase())return null;{let Me=null,B=Ie+1;for(Me=n(J,ce,be+1,Ie+1);!Me&&(B=i(ce,B))<ce.length;)Me=n(J,ce,be+1,B),B++;return Me===null?null:s({start:Ie,end:Ie+1},Me)}}function o(J){let ce=0,be=0,Ie=0,Me=0,B=0;for(let de=0;de<J.length;de++)B=J.charCodeAt(de),A(B)&&ce++,y(B)&&be++,d(B)&&Ie++,C(B)&&Me++;const _=ce/J.length,se=be/J.length,K=Ie/J.length,ae=Me/J.length;return{upperPercent:_,lowerPercent:se,alphaPercent:K,numericPercent:ae}}function a(J){const{upperPercent:ce,lowerPercent:be}=J;return be===0&&ce>.6}function t(J){const{upperPercent:ce,lowerPercent:be,alphaPercent:Ie,numericPercent:Me}=J;return be>.2&&ce<.8&&Ie>.6&&Me<.2}function r(J){let ce=0,be=0,Ie=0,Me=0;for(let B=0;B<J.length;B++)Ie=J.charCodeAt(B),A(Ie)&&ce++,y(Ie)&&be++,m(Ie)&&Me++;return(ce===0||be===0)&&Me===0?J.length<=30:ce<=5}function h(J,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!r(J)||ce.length>60)return null;const be=o(ce);if(!t(be)){if(!a(be))return null;ce=ce.toLowerCase()}let Ie=null,Me=0;for(J=J.toLowerCase();Me<ce.length&&(Ie=n(J,ce,0,Me))===null;)Me=i(ce,Me+1);return Ie}e.$Rj=h;function u(J,ce,be=!1){if(!ce||ce.length===0)return null;let Ie=null,Me=0;for(J=J.toLowerCase(),ce=ce.toLowerCase();Me<ce.length&&(Ie=c(J,ce,0,Me,be))===null;)Me=l(ce,Me+1);return Ie}e.$Sj=u;function c(J,ce,be,Ie,Me){if(be===J.length)return[];if(Ie===ce.length)return null;if(f(J.charCodeAt(be),ce.charCodeAt(Ie))){let B=null,_=Ie+1;if(B=c(J,ce,be+1,Ie+1,Me),!Me)for(;!B&&(_=l(ce,_))<ce.length;)B=c(J,ce,be+1,_,Me),_++;return B?J.charCodeAt(be)!==ce.charCodeAt(Ie)?B:s({start:Ie,end:Ie+1},B):null}else return null}function l(J,ce){for(let be=ce;be<J.length;be++)if(S(J.charCodeAt(be))||be>0&&S(J.charCodeAt(be-1)))return be;return J.length}const k=g(e.$Nj,h,L),R=g(e.$Nj,h,b),w=new D.$Cc(1e4);function p(J,ce,be=!1){if(typeof J!="string"||typeof ce!="string")return null;let Ie=w.get(J);Ie||(Ie=new RegExp(N.$Pe(J),"i"),w.set(J,Ie));const Me=Ie.exec(ce);return Me?[{start:Me.index,end:Me.index+Me[0].length}]:be?R(J,ce):k(J,ce)}e.$Tj=p;function E(J,ce){const be=ye(J,J.toLowerCase(),0,ce,ce.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return be?z(be):null}e.$Uj=E;function P(J,ce,be,Ie,Me,B){const _=Math.min(13,J.length);for(;be<_;be++){const se=ye(J,ce,be,Ie,Me,B,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(se)return se}return[0,B]}e.$Vj=P;function z(J){if(typeof J>"u")return[];const ce=[],be=J[1];for(let Ie=J.length-1;Ie>1;Ie--){const Me=J[Ie]+be,B=ce[ce.length-1];B&&B.end===Me?B.end=Me+1:ce.push({start:Me,end:Me+1})}return ce}e.$Wj=z;const j=128;function F(){const J=[],ce=[];for(let be=0;be<=j;be++)ce[be]=0;for(let be=0;be<=j;be++)J.push(ce.slice(0));return J}function O(J){const ce=[];for(let be=0;be<=J;be++)ce[be]=0;return ce}const T=O(2*j),M=O(2*j),W=F(),Y=F(),ue=F(),Z=!1;function Q(J,ce,be,Ie,Me){function B(se,K,ae=" "){for(;se.length<K;)se=ae+se;return se}let _=` |   |${Ie.split("").map(se=>B(se,3)).join("|")}
`;for(let se=0;se<=be;se++)se===0?_+=" |":_+=`${ce[se-1]}|`,_+=J[se].slice(0,Me+1).map(K=>B(K.toString(),3)).join("|")+`
`;return _}function x(J,ce,be,Ie){J=J.substr(ce),be=be.substr(Ie),console.log(Q(Y,J,J.length,be,be.length)),console.log(Q(ue,J,J.length,be,be.length)),console.log(Q(W,J,J.length,be,be.length))}function oe(J,ce){if(ce<0||ce>=J.length)return!1;const be=J.codePointAt(ce);switch(be){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!N.$mf(be)}}function X(J,ce){if(ce<0||ce>=J.length)return!1;switch(J.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function ve(J,ce,be){return ce[J]!==be[J]}function ge(J,ce,be,Ie,Me,B,_=!1){for(;ce<be&&Me<B;)J[ce]===Ie[Me]&&(_&&(T[ce]=Me),ce+=1),Me+=1;return ce===be}e.$Xj=ge;var V;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(V||(V={}));var U;(function(J){J.Default=[-100,0];function ce(be){return!be||be.length===2&&be[0]===-100&&be[1]===0}J.isDefault=ce})(U||(e.FuzzyScore=U={}));class ne{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ce,be){this.firstMatchCanBeWeak=ce,this.boostFullMatch=be}}e.$Yj=ne;function ye(J,ce,be,Ie,Me,B,_=ne.default){const se=J.length>j?j:J.length,K=Ie.length>j?j:Ie.length;if(be>=se||B>=K||se-be>K-B||!ge(ce,be,se,Me,B,K,!0))return;fe(se,K,be,B,ce,Me);let ae=1,de=1,Re=be,Be=B;const Xe=[!1];for(ae=1,Re=be;Re<se;ae++,Re++){const Te=T[Re],qe=M[Re],Le=Re+1<se?M[Re+1]:K;for(de=Te-B+1,Be=Te;Be<Le;de++,Be++){let xe=Number.MIN_SAFE_INTEGER,he=!1;Be<=qe&&(xe=me(J,ce,Re,be,Ie,Me,Be,K,B,W[ae-1][de-1]===0,Xe));let le=0;xe!==Number.MAX_SAFE_INTEGER&&(he=!0,le=xe+Y[ae-1][de-1]);const Ce=Be>Te,Ve=Ce?Y[ae][de-1]+(W[ae][de-1]>0?-5:0):0,Ge=Be>Te+1&&W[ae][de-1]>0,_e=Ge?Y[ae][de-2]+(W[ae][de-2]>0?-5:0):0;if(Ge&&(!Ce||_e>=Ve)&&(!he||_e>=le))Y[ae][de]=_e,ue[ae][de]=3,W[ae][de]=0;else if(Ce&&(!he||Ve>=le))Y[ae][de]=Ve,ue[ae][de]=2,W[ae][de]=0;else if(he)Y[ae][de]=le,ue[ae][de]=1,W[ae][de]=W[ae-1][de-1]+1;else throw new Error("not possible")}}if(Z&&x(J,be,Ie,B),!Xe[0]&&!_.firstMatchCanBeWeak)return;ae--,de--;const Ye=[Y[ae][de],B];let it=0,st=0;for(;ae>=1;){let Te=de;do{const qe=ue[ae][Te];if(qe===3)Te=Te-2;else if(qe===2)Te=Te-1;else break}while(Te>=1);it>1&&ce[be+ae-1]===Me[B+de-1]&&!ve(Te+B-1,Ie,Me)&&it+1>W[ae][Te]&&(Te=de),Te===de?it++:it=1,st||(st=Te),ae--,de=Te-1,Ye.push(de)}K===se&&_.boostFullMatch&&(Ye[0]+=2);const Pe=st-se;return Ye[0]-=Pe,Ye}e.$Zj=ye;function fe(J,ce,be,Ie,Me,B){let _=J-1,se=ce-1;for(;_>=be&&se>=Ie;)Me[_]===B[se]&&(M[_]=se,_--),se--}function me(J,ce,be,Ie,Me,B,_,se,K,ae,de){if(ce[be]!==B[_])return Number.MIN_SAFE_INTEGER;let Re=1,Be=!1;return _===be-Ie?Re=J[be]===Me[_]?7:5:ve(_,Me,B)&&(_===0||!ve(_-1,Me,B))?(Re=J[be]===Me[_]?7:5,Be=!0):oe(B,_)&&(_===0||!oe(B,_-1))?Re=5:(oe(B,_-1)||X(B,_-1))&&(Re=5,Be=!0),Re>1&&be===Ie&&(de[0]=!0),Be||(Be=ve(_,Me,B)||oe(B,_-1)||X(B,_-1)),be===Ie?_>K&&(Re-=Be?3:5):ae?Re+=Be?2:0:Re+=Be?0:1,_+1===se&&(Re-=Be?3:5),Re}function ee(J,ce,be,Ie,Me,B,_){return G(J,ce,be,Ie,Me,B,!0,_)}e.$1j=ee;function ie(J,ce,be,Ie,Me,B,_){return G(J,ce,be,Ie,Me,B,!1,_)}e.$2j=ie;function G(J,ce,be,Ie,Me,B,_,se){let K=ye(J,ce,be,Ie,Me,B,se);if(K&&!_)return K;if(J.length>=3){const ae=Math.min(7,J.length-1);for(let de=be+1;de<ae;de++){const Re=te(J,de);if(Re){const Be=ye(Re,Re.toLowerCase(),be,Ie,Me,B,se);Be&&(Be[0]-=3,(!K||Be[0]>K[0])&&(K=Be))}}}return K}function te(J,ce){if(ce+1>=J.length)return;const be=J[ce],Ie=J[ce+1];if(be!==Ie)return J.slice(0,ce)+Ie+be+J.slice(ce+2)}}),define(Ee[53],Se([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ti=e.$Si=e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=void 0;function N(s){return g(s,0)}e.$Ni=N;function g(s,i){switch(typeof s){case"object":return s===null?I(349,i):Array.isArray(s)?$(s,i):y(s,i);case"string":return b(s,i);case"boolean":return L(s,i);case"number":return I(s,i);case"undefined":return I(937,i);default:return I(617,i)}}e.$Oi=g;function I(s,i){return(i<<5)-i+s|0}e.$Pi=I;function L(s,i){return I(s?433:863,i)}function b(s,i){i=I(149417,i);for(let n=0,o=s.length;n<o;n++)i=I(s.charCodeAt(n),i);return i}e.$Qi=b;function $(s,i){return i=I(104579,i),s.reduce((n,o)=>g(o,n),i)}function y(s,i){return i=I(181387,i),Object.keys(s).sort().reduce((n,o)=>(n=b(o,n),g(s[o],n)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=g(i,this.g),this.g}}e.$Ri=A;var C;(function(s){s[s.BLOCK_SIZE=64]="BLOCK_SIZE",s[s.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(C||(C={}));function m(s,i,n=32){const o=n-i,a=~((1<<o)-1);return(s<<i|(a&s)>>>o)>>>0}function v(s,i=0,n=s.byteLength,o=0){for(let a=0;a<n;a++)s[i+a]=o}function S(s,i,n="0"){for(;s.length<i;)s=n+s;return s}function f(s,i=32){return s instanceof ArrayBuffer?Array.from(new Uint8Array(s)).map(n=>n.toString(16).padStart(2,"0")).join(""):S((s>>>0).toString(16),i/4)}e.$Si=f;class d{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const n=i.length;if(n===0)return;const o=this.p;let a=this.r,t=this.u,r,h;for(t!==0?(r=t,h=-1,t=0):(r=i.charCodeAt(0),h=0);;){let u=r;if(D.$0e(r))if(h+1<n){const c=i.charCodeAt(h+1);D.$$e(c)?(h++,u=D.$_e(r,c)):u=65533}else{t=r;break}else D.$$e(r)&&(u=65533);if(a=this.w(o,a,u),h++,h<n)r=i.charCodeAt(h);else break}this.r=a,this.u=t}w(i,n,o){return o<128?i[n++]=o:o<2048?(i[n++]=192|(o&1984)>>>6,i[n++]=128|(o&63)>>>0):o<65536?(i[n++]=224|(o&61440)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0):(i[n++]=240|(o&1835008)>>>18,i[n++]=128|(o&258048)>>>12,i[n++]=128|(o&4032)>>>6,i[n++]=128|(o&63)>>>0),n>=64&&(this.y(),n-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),n}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,v(this.p,this.r),this.r>56&&(this.y(),v(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=d.g,n=this.q;for(let k=0;k<64;k+=4)i.setUint32(k,n.getUint32(k,!1),!1);for(let k=64;k<320;k+=4)i.setUint32(k,m(i.getUint32(k-12,!1)^i.getUint32(k-32,!1)^i.getUint32(k-56,!1)^i.getUint32(k-64,!1),1),!1);let o=this.h,a=this.l,t=this.m,r=this.n,h=this.o,u,c,l;for(let k=0;k<80;k++)k<20?(u=a&t|~a&r,c=1518500249):k<40?(u=a^t^r,c=1859775393):k<60?(u=a&t|a&r|t&r,c=2400959708):(u=a^t^r,c=3395469782),l=m(o,5)+u+h+c+i.getUint32(k*4,!1)&4294967295,h=r,r=t,t=m(a,30),a=o,o=l;this.h=this.h+o&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+h&4294967295}}e.$Ti=d}),define(Ee[39],Se([1,0,13]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(g){g[g.Ignore=0]="Ignore",g[g.Info=1]="Info",g[g.Warning=2]="Warning",g[g.Error=3]="Error"})(N||(N={})),function(g){const I="error",L="warning",b="warn",$="info",y="ignore";function A(m){return m?D.$6e(I,m)?g.Error:D.$6e(L,m)||D.$6e(b,m)?g.Warning:D.$6e($,m)?g.Info:g.Ignore:g.Ignore}g.fromValue=A;function C(m){switch(m){case g.Error:return I;case g.Warning:return L;case g.Info:return $;default:return y}}g.toString=C}(N||(N={})),e.default=N}),define(Ee[162],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Ee[77],Se([1,0,19,13]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0;class g{constructor(){this.b="",this.c=0}reset(v){return this.b=v,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(v){const S=v.charCodeAt(0),f=this.b.charCodeAt(this.c);return S-f}value(){return this.b[this.c]}}e.$2h=g;class I{constructor(v=!0){this.e=v}reset(v){return this.b=v,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let v=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(v)this.c++;else break;else v=!1;return this}cmp(v){return this.e?(0,N.$Ze)(v,this.b,0,v.length,this.c,this.d):(0,N.$2e)(v,this.b,0,v.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$3h=I;class L{constructor(v=!0,S=!0){this.f=v,this.g=S}reset(v){this.d=0,this.e=0,this.b=v,this.c=v.length;for(let S=v.length-1;S>=0;S--,this.c--){const f=this.b.charCodeAt(S);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let v=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(v)this.d++;else break;else v=!1}return this}cmp(v){return this.g?(0,N.$Ze)(v,this.b,0,v.length,this.d,this.e):(0,N.$2e)(v,this.b,0,v.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$4h=L;var b;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(b||(b={}));class ${constructor(v,S){this.f=v,this.g=S,this.d=[],this.e=0}reset(v){return this.c=v,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f(v)),this.b.reset(v.path),this.b.value()&&this.d.push(3)),this.g(v)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(v){if(this.d[this.e]===1)return(0,N.$1e)(v,this.c.scheme);if(this.d[this.e]===2)return(0,N.$1e)(v,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(v);if(this.d[this.e]===4)return(0,N.$Ye)(v,this.c.query);if(this.d[this.e]===5)return(0,N.$Ye)(v,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$5h=$;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const v=this.right;return this.right=v.left,v.left=this,this.updateHeight(),v.updateHeight(),v}rotateRight(){const v=this.left;return this.left=v.right,v.right=this,this.updateHeight(),v.updateHeight(),v}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(A||(A={}));class C{static forUris(v=()=>!1,S=()=>!1){return new C(new $(v,S))}static forPaths(v=!1){return new C(new L(void 0,!v))}static forStrings(){return new C(new g)}static forConfigKeys(){return new C(new I)}constructor(v){this.b=v}clear(){this.c=void 0}fill(v,S){if(S){const f=S.slice(0);(0,D.$Wb)(f);for(const d of f)this.set(d,v)}else{const f=v.slice(0);(0,D.$Wb)(f);for(const d of f)this.set(d[0],d[1])}}set(v,S){const f=this.b.reset(v);let d;this.c||(this.c=new y,this.c.segment=f.value());const s=[];for(d=this.c;;){const n=f.cmp(d.segment);if(n>0)d.left||(d.left=new y,d.left.segment=f.value()),s.push([-1,d]),d=d.left;else if(n<0)d.right||(d.right=new y,d.right.segment=f.value()),s.push([1,d]),d=d.right;else if(f.hasNext())f.next(),d.mid||(d.mid=new y,d.mid.segment=f.value()),s.push([0,d]),d=d.mid;else break}const i=d.value;d.value=S,d.key=v;for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const a=o.balanceFactor();if(a<-1||a>1){const t=s[n][0],r=s[n+1][0];if(t===1&&r===1)s[n][1]=o.rotateLeft();else if(t===-1&&r===-1)s[n][1]=o.rotateRight();else if(t===1&&r===-1)o.right=s[n+1][1]=s[n+1][1].rotateRight(),s[n][1]=o.rotateLeft();else if(t===-1&&r===1)o.left=s[n+1][1]=s[n+1][1].rotateLeft(),s[n][1]=o.rotateRight();else throw new Error;if(n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}return i}get(v){return this.d(v)?.value}d(v){const S=this.b.reset(v);let f=this.c;for(;f;){const d=S.cmp(f.segment);if(d>0)f=f.left;else if(d<0)f=f.right;else if(S.hasNext())S.next(),f=f.mid;else break}return f}has(v){const S=this.d(v);return!(S?.value===void 0&&S?.mid===void 0)}delete(v){return this.e(v,!1)}deleteSuperstr(v){return this.e(v,!0)}e(v,S){const f=this.b.reset(v),d=[];let s=this.c;for(;s;){const i=f.cmp(s.segment);if(i>0)d.push([-1,s]),s=s.left;else if(i<0)d.push([1,s]),s=s.right;else if(f.hasNext())f.next(),d.push([0,s]),s=s.mid;else break}if(s){if(S?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:n,value:o,segment:a}=i;this.e(i.key,!1),s.key=n,s.value=o,s.segment=a}}else{const i=s.left??s.right;if(d.length>0){const[n,o]=d[d.length-1];switch(n){case-1:o.left=i;break;case 0:o.mid=i;break;case 1:o.right=i;break}}else this.c=i}for(let i=d.length-1;i>=0;i--){const n=d[i][1];n.updateHeight();const o=n.balanceFactor();if(o>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),d[i][1]=n.rotateLeft()):o<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),d[i][1]=n.rotateRight()),i>0)switch(d[i-1][0]){case-1:d[i-1][1].left=d[i][1];break;case 1:d[i-1][1].right=d[i][1];break;case 0:d[i-1][1].mid=d[i][1];break}else this.c=d[0][1]}}}f(v){for(;v.left;)v=v.left;return v}findSubstr(v){const S=this.b.reset(v);let f=this.c,d;for(;f;){const s=S.cmp(f.segment);if(s>0)f=f.left;else if(s<0)f=f.right;else if(S.hasNext())S.next(),d=f.value||d,f=f.mid;else break}return f&&f.value||d}findSuperstr(v){return this.g(v,!1)}g(v,S){const f=this.b.reset(v);let d=this.c;for(;d;){const s=f.cmp(d.segment);if(s>0)d=d.left;else if(s<0)d=d.right;else if(f.hasNext())f.next(),d=d.mid;else return d.mid?this.h(d.mid):S?d.value:void 0}}hasElementOrSubtree(v){return this.g(v,!0)!==void 0}forEach(v){for(const[S,f]of this)v(f,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(v){const S=[];return this.j(v,S),S[Symbol.iterator]()}j(v,S){v&&(v.left&&this.j(v.left,S),v.value&&S.push([v.key,v.value]),v.mid&&this.j(v.mid,S),v.right&&this.j(v.right,S))}_isBalanced(){const v=S=>{if(!S)return!0;const f=S.balanceFactor();return f<-1||f>1?!1:v(S.left)&&v(S.right)};return v(this.c)}}e.$6h=C}),define(Ee[18],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.$Df=e.$Cf=void 0;function D(a){return typeof a=="string"}e.$Cf=D;function N(a){return Array.isArray(a)&&a.every(t=>D(t))}e.$Df=N;function g(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Ef=g;function I(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Ff=I;function L(a){return typeof a=="number"&&!isNaN(a)}e.$Gf=L;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Hf=b;function $(a){return a===!0||a===!1}e.$If=$;function y(a){return typeof a>"u"}e.$Jf=y;function A(a){return!C(a)}e.$Kf=A;function C(a){return y(a)||a===null}e.$Lf=C;function m(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Mf=m;function v(a){if(C(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Nf=v;function S(...a){const t=[];for(let r=0;r<a.length;r++){const h=a[r];if(C(h))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(h)}return t}e.$Of=S;const f=Object.prototype.hasOwnProperty;function d(a){if(!g(a))return!1;for(const t in a)if(f.call(a,t))return!1;return!0}e.$Pf=d;function s(a){return typeof a=="function"}e.$Qf=s;function i(...a){return a.length>0&&a.every(s)}e.$Rf=i;function n(a,t){const r=Math.min(a.length,t.length);for(let h=0;h<r;h++)o(a[h],t[h])}e.$Sf=n;function o(a,t){if(D(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(s(t)){try{if(a instanceof t)return}catch{}if(!C(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Tf=o}),define(Ee[78],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5j=e.$4j=e.$3j=void 0;const N=Object.create(null);function g(b,$){if((0,D.$Cf)($)){const y=N[$];if(y===void 0)throw new Error(`${b} references an unknown codicon: ${$}`);$=y}return N[b]=$,{id:b}}function I(){return N}e.$3j=I;function L(){return Object.values(e.$5j)}e.$4j=L,e.$5j={add:g("add",6e4),plus:g("plus",6e4),gistNew:g("gist-new",6e4),repoCreate:g("repo-create",6e4),lightbulb:g("lightbulb",60001),lightBulb:g("light-bulb",60001),repo:g("repo",60002),repoDelete:g("repo-delete",60002),gistFork:g("gist-fork",60003),repoForked:g("repo-forked",60003),gitPullRequest:g("git-pull-request",60004),gitPullRequestAbandoned:g("git-pull-request-abandoned",60004),recordKeys:g("record-keys",60005),keyboard:g("keyboard",60005),tag:g("tag",60006),tagAdd:g("tag-add",60006),tagRemove:g("tag-remove",60006),gitPullRequestLabel:g("git-pull-request-label",60006),person:g("person",60007),personFollow:g("person-follow",60007),personOutline:g("person-outline",60007),personFilled:g("person-filled",60007),gitBranch:g("git-branch",60008),gitBranchCreate:g("git-branch-create",60008),gitBranchDelete:g("git-branch-delete",60008),sourceControl:g("source-control",60008),mirror:g("mirror",60009),mirrorPublic:g("mirror-public",60009),star:g("star",60010),starAdd:g("star-add",60010),starDelete:g("star-delete",60010),starEmpty:g("star-empty",60010),comment:g("comment",60011),commentAdd:g("comment-add",60011),alert:g("alert",60012),warning:g("warning",60012),search:g("search",60013),searchSave:g("search-save",60013),logOut:g("log-out",60014),signOut:g("sign-out",60014),logIn:g("log-in",60015),signIn:g("sign-in",60015),eye:g("eye",60016),eyeUnwatch:g("eye-unwatch",60016),eyeWatch:g("eye-watch",60016),circleFilled:g("circle-filled",60017),primitiveDot:g("primitive-dot",60017),closeDirty:g("close-dirty",60017),debugBreakpoint:g("debug-breakpoint",60017),debugBreakpointDisabled:g("debug-breakpoint-disabled",60017),debugHint:g("debug-hint",60017),primitiveSquare:g("primitive-square",60018),edit:g("edit",60019),pencil:g("pencil",60019),info:g("info",60020),issueOpened:g("issue-opened",60020),gistPrivate:g("gist-private",60021),gitForkPrivate:g("git-fork-private",60021),lock:g("lock",60021),mirrorPrivate:g("mirror-private",60021),close:g("close",60022),removeClose:g("remove-close",60022),x:g("x",60022),repoSync:g("repo-sync",60023),sync:g("sync",60023),clone:g("clone",60024),desktopDownload:g("desktop-download",60024),beaker:g("beaker",60025),microscope:g("microscope",60025),vm:g("vm",60026),deviceDesktop:g("device-desktop",60026),file:g("file",60027),fileText:g("file-text",60027),more:g("more",60028),ellipsis:g("ellipsis",60028),kebabHorizontal:g("kebab-horizontal",60028),mailReply:g("mail-reply",60029),reply:g("reply",60029),organization:g("organization",60030),organizationFilled:g("organization-filled",60030),organizationOutline:g("organization-outline",60030),newFile:g("new-file",60031),fileAdd:g("file-add",60031),newFolder:g("new-folder",60032),fileDirectoryCreate:g("file-directory-create",60032),trash:g("trash",60033),trashcan:g("trashcan",60033),history:g("history",60034),clock:g("clock",60034),folder:g("folder",60035),fileDirectory:g("file-directory",60035),symbolFolder:g("symbol-folder",60035),logoGithub:g("logo-github",60036),markGithub:g("mark-github",60036),github:g("github",60036),terminal:g("terminal",60037),console:g("console",60037),repl:g("repl",60037),zap:g("zap",60038),symbolEvent:g("symbol-event",60038),error:g("error",60039),stop:g("stop",60039),variable:g("variable",60040),symbolVariable:g("symbol-variable",60040),array:g("array",60042),symbolArray:g("symbol-array",60042),symbolModule:g("symbol-module",60043),symbolPackage:g("symbol-package",60043),symbolNamespace:g("symbol-namespace",60043),symbolObject:g("symbol-object",60043),symbolMethod:g("symbol-method",60044),symbolFunction:g("symbol-function",60044),symbolConstructor:g("symbol-constructor",60044),symbolBoolean:g("symbol-boolean",60047),symbolNull:g("symbol-null",60047),symbolNumeric:g("symbol-numeric",60048),symbolNumber:g("symbol-number",60048),symbolStructure:g("symbol-structure",60049),symbolStruct:g("symbol-struct",60049),symbolParameter:g("symbol-parameter",60050),symbolTypeParameter:g("symbol-type-parameter",60050),symbolKey:g("symbol-key",60051),symbolText:g("symbol-text",60051),symbolReference:g("symbol-reference",60052),goToFile:g("go-to-file",60052),symbolEnum:g("symbol-enum",60053),symbolValue:g("symbol-value",60053),symbolRuler:g("symbol-ruler",60054),symbolUnit:g("symbol-unit",60054),activateBreakpoints:g("activate-breakpoints",60055),archive:g("archive",60056),arrowBoth:g("arrow-both",60057),arrowDown:g("arrow-down",60058),arrowLeft:g("arrow-left",60059),arrowRight:g("arrow-right",60060),arrowSmallDown:g("arrow-small-down",60061),arrowSmallLeft:g("arrow-small-left",60062),arrowSmallRight:g("arrow-small-right",60063),arrowSmallUp:g("arrow-small-up",60064),arrowUp:g("arrow-up",60065),bell:g("bell",60066),bold:g("bold",60067),book:g("book",60068),bookmark:g("bookmark",60069),debugBreakpointConditionalUnverified:g("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:g("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:g("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:g("debug-breakpoint-data-unverified",60072),debugBreakpointData:g("debug-breakpoint-data",60073),debugBreakpointDataDisabled:g("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:g("debug-breakpoint-log-unverified",60074),debugBreakpointLog:g("debug-breakpoint-log",60075),debugBreakpointLogDisabled:g("debug-breakpoint-log-disabled",60075),briefcase:g("briefcase",60076),broadcast:g("broadcast",60077),browser:g("browser",60078),bug:g("bug",60079),calendar:g("calendar",60080),caseSensitive:g("case-sensitive",60081),check:g("check",60082),checklist:g("checklist",60083),chevronDown:g("chevron-down",60084),dropDownButton:g("drop-down-button",60084),chevronLeft:g("chevron-left",60085),chevronRight:g("chevron-right",60086),chevronUp:g("chevron-up",60087),chromeClose:g("chrome-close",60088),chromeMaximize:g("chrome-maximize",60089),chromeMinimize:g("chrome-minimize",60090),chromeRestore:g("chrome-restore",60091),circle:g("circle",60092),circleOutline:g("circle-outline",60092),debugBreakpointUnverified:g("debug-breakpoint-unverified",60092),circleSlash:g("circle-slash",60093),circuitBoard:g("circuit-board",60094),clearAll:g("clear-all",60095),clippy:g("clippy",60096),closeAll:g("close-all",60097),cloudDownload:g("cloud-download",60098),cloudUpload:g("cloud-upload",60099),code:g("code",60100),collapseAll:g("collapse-all",60101),colorMode:g("color-mode",60102),commentDiscussion:g("comment-discussion",60103),compareChanges:g("compare-changes",60157),creditCard:g("credit-card",60105),dash:g("dash",60108),dashboard:g("dashboard",60109),database:g("database",60110),debugContinue:g("debug-continue",60111),debugDisconnect:g("debug-disconnect",60112),debugPause:g("debug-pause",60113),debugRestart:g("debug-restart",60114),debugStart:g("debug-start",60115),debugStepInto:g("debug-step-into",60116),debugStepOut:g("debug-step-out",60117),debugStepOver:g("debug-step-over",60118),debugStop:g("debug-stop",60119),debug:g("debug",60120),deviceCameraVideo:g("device-camera-video",60121),deviceCamera:g("device-camera",60122),deviceMobile:g("device-mobile",60123),diffAdded:g("diff-added",60124),diffIgnored:g("diff-ignored",60125),diffModified:g("diff-modified",60126),diffRemoved:g("diff-removed",60127),diffRenamed:g("diff-renamed",60128),diff:g("diff",60129),discard:g("discard",60130),editorLayout:g("editor-layout",60131),emptyWindow:g("empty-window",60132),exclude:g("exclude",60133),extensions:g("extensions",60134),eyeClosed:g("eye-closed",60135),fileBinary:g("file-binary",60136),fileCode:g("file-code",60137),fileMedia:g("file-media",60138),filePdf:g("file-pdf",60139),fileSubmodule:g("file-submodule",60140),fileSymlinkDirectory:g("file-symlink-directory",60141),fileSymlinkFile:g("file-symlink-file",60142),fileZip:g("file-zip",60143),files:g("files",60144),filter:g("filter",60145),flame:g("flame",60146),foldDown:g("fold-down",60147),foldUp:g("fold-up",60148),fold:g("fold",60149),folderActive:g("folder-active",60150),folderOpened:g("folder-opened",60151),gear:g("gear",60152),gift:g("gift",60153),gistSecret:g("gist-secret",60154),gist:g("gist",60155),gitCommit:g("git-commit",60156),gitCompare:g("git-compare",60157),gitMerge:g("git-merge",60158),githubAction:g("github-action",60159),githubAlt:g("github-alt",60160),globe:g("globe",60161),grabber:g("grabber",60162),graph:g("graph",60163),gripper:g("gripper",60164),heart:g("heart",60165),home:g("home",60166),horizontalRule:g("horizontal-rule",60167),hubot:g("hubot",60168),inbox:g("inbox",60169),issueClosed:g("issue-closed",60324),issueReopened:g("issue-reopened",60171),issues:g("issues",60172),italic:g("italic",60173),jersey:g("jersey",60174),json:g("json",60175),bracket:g("bracket",60175),kebabVertical:g("kebab-vertical",60176),key:g("key",60177),law:g("law",60178),lightbulbAutofix:g("lightbulb-autofix",60179),linkExternal:g("link-external",60180),link:g("link",60181),listOrdered:g("list-ordered",60182),listUnordered:g("list-unordered",60183),liveShare:g("live-share",60184),loading:g("loading",60185),location:g("location",60186),mailRead:g("mail-read",60187),mail:g("mail",60188),markdown:g("markdown",60189),megaphone:g("megaphone",60190),mention:g("mention",60191),milestone:g("milestone",60192),gitPullRequestMilestone:g("git-pull-request-milestone",60192),mortarBoard:g("mortar-board",60193),move:g("move",60194),multipleWindows:g("multiple-windows",60195),mute:g("mute",60196),noNewline:g("no-newline",60197),note:g("note",60198),octoface:g("octoface",60199),openPreview:g("open-preview",60200),package:g("package",60201),paintcan:g("paintcan",60202),pin:g("pin",60203),play:g("play",60204),run:g("run",60204),plug:g("plug",60205),preserveCase:g("preserve-case",60206),preview:g("preview",60207),project:g("project",60208),pulse:g("pulse",60209),question:g("question",60210),quote:g("quote",60211),radioTower:g("radio-tower",60212),reactions:g("reactions",60213),references:g("references",60214),refresh:g("refresh",60215),regex:g("regex",60216),remoteExplorer:g("remote-explorer",60217),remote:g("remote",60218),remove:g("remove",60219),replaceAll:g("replace-all",60220),replace:g("replace",60221),repoClone:g("repo-clone",60222),repoForcePush:g("repo-force-push",60223),repoPull:g("repo-pull",60224),repoPush:g("repo-push",60225),report:g("report",60226),requestChanges:g("request-changes",60227),rocket:g("rocket",60228),rootFolderOpened:g("root-folder-opened",60229),rootFolder:g("root-folder",60230),rss:g("rss",60231),ruby:g("ruby",60232),saveAll:g("save-all",60233),saveAs:g("save-as",60234),save:g("save",60235),screenFull:g("screen-full",60236),screenNormal:g("screen-normal",60237),searchStop:g("search-stop",60238),server:g("server",60240),settingsGear:g("settings-gear",60241),settings:g("settings",60242),shield:g("shield",60243),smiley:g("smiley",60244),sortPrecedence:g("sort-precedence",60245),splitHorizontal:g("split-horizontal",60246),splitVertical:g("split-vertical",60247),squirrel:g("squirrel",60248),starFull:g("star-full",60249),starHalf:g("star-half",60250),symbolClass:g("symbol-class",60251),symbolColor:g("symbol-color",60252),symbolCustomColor:g("symbol-customcolor",60252),symbolConstant:g("symbol-constant",60253),symbolEnumMember:g("symbol-enum-member",60254),symbolField:g("symbol-field",60255),symbolFile:g("symbol-file",60256),symbolInterface:g("symbol-interface",60257),symbolKeyword:g("symbol-keyword",60258),symbolMisc:g("symbol-misc",60259),symbolOperator:g("symbol-operator",60260),symbolProperty:g("symbol-property",60261),wrench:g("wrench",60261),wrenchSubaction:g("wrench-subaction",60261),symbolSnippet:g("symbol-snippet",60262),tasklist:g("tasklist",60263),telescope:g("telescope",60264),textSize:g("text-size",60265),threeBars:g("three-bars",60266),thumbsdown:g("thumbsdown",60267),thumbsup:g("thumbsup",60268),tools:g("tools",60269),triangleDown:g("triangle-down",60270),triangleLeft:g("triangle-left",60271),triangleRight:g("triangle-right",60272),triangleUp:g("triangle-up",60273),twitter:g("twitter",60274),unfold:g("unfold",60275),unlock:g("unlock",60276),unmute:g("unmute",60277),unverified:g("unverified",60278),verified:g("verified",60279),versions:g("versions",60280),vmActive:g("vm-active",60281),vmOutline:g("vm-outline",60282),vmRunning:g("vm-running",60283),watch:g("watch",60284),whitespace:g("whitespace",60285),wholeWord:g("whole-word",60286),window:g("window",60287),wordWrap:g("word-wrap",60288),zoomIn:g("zoom-in",60289),zoomOut:g("zoom-out",60290),listFilter:g("list-filter",60291),listFlat:g("list-flat",60292),listSelection:g("list-selection",60293),selection:g("selection",60293),listTree:g("list-tree",60294),debugBreakpointFunctionUnverified:g("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:g("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:g("debug-breakpoint-function-disabled",60296),debugStackframeActive:g("debug-stackframe-active",60297),circleSmallFilled:g("circle-small-filled",60298),debugStackframeDot:g("debug-stackframe-dot",60298),debugStackframe:g("debug-stackframe",60299),debugStackframeFocused:g("debug-stackframe-focused",60299),debugBreakpointUnsupported:g("debug-breakpoint-unsupported",60300),symbolString:g("symbol-string",60301),debugReverseContinue:g("debug-reverse-continue",60302),debugStepBack:g("debug-step-back",60303),debugRestartFrame:g("debug-restart-frame",60304),callIncoming:g("call-incoming",60306),callOutgoing:g("call-outgoing",60307),menu:g("menu",60308),expandAll:g("expand-all",60309),feedback:g("feedback",60310),gitPullRequestReviewer:g("git-pull-request-reviewer",60310),groupByRefType:g("group-by-ref-type",60311),ungroupByRefType:g("ungroup-by-ref-type",60312),account:g("account",60313),gitPullRequestAssignee:g("git-pull-request-assignee",60313),bellDot:g("bell-dot",60314),debugConsole:g("debug-console",60315),library:g("library",60316),output:g("output",60317),runAll:g("run-all",60318),syncIgnored:g("sync-ignored",60319),pinned:g("pinned",60320),githubInverted:g("github-inverted",60321),debugAlt:g("debug-alt",60305),serverProcess:g("server-process",60322),serverEnvironment:g("server-environment",60323),pass:g("pass",60324),stopCircle:g("stop-circle",60325),playCircle:g("play-circle",60326),record:g("record",60327),debugAltSmall:g("debug-alt-small",60328),vmConnect:g("vm-connect",60329),cloud:g("cloud",60330),merge:g("merge",60331),exportIcon:g("export",60332),graphLeft:g("graph-left",60333),magnet:g("magnet",60334),notebook:g("notebook",60335),redo:g("redo",60336),checkAll:g("check-all",60337),pinnedDirty:g("pinned-dirty",60338),passFilled:g("pass-filled",60339),circleLargeFilled:g("circle-large-filled",60340),circleLarge:g("circle-large",60341),circleLargeOutline:g("circle-large-outline",60341),combine:g("combine",60342),gather:g("gather",60342),table:g("table",60343),variableGroup:g("variable-group",60344),typeHierarchy:g("type-hierarchy",60345),typeHierarchySub:g("type-hierarchy-sub",60346),typeHierarchySuper:g("type-hierarchy-super",60347),gitPullRequestCreate:g("git-pull-request-create",60348),runAbove:g("run-above",60349),runBelow:g("run-below",60350),notebookTemplate:g("notebook-template",60351),debugRerun:g("debug-rerun",60352),workspaceTrusted:g("workspace-trusted",60353),workspaceUntrusted:g("workspace-untrusted",60354),workspaceUnspecified:g("workspace-unspecified",60355),terminalCmd:g("terminal-cmd",60356),terminalDebian:g("terminal-debian",60357),terminalLinux:g("terminal-linux",60358),terminalPowershell:g("terminal-powershell",60359),terminalTmux:g("terminal-tmux",60360),terminalUbuntu:g("terminal-ubuntu",60361),terminalBash:g("terminal-bash",60362),arrowSwap:g("arrow-swap",60363),copy:g("copy",60364),personAdd:g("person-add",60365),filterFilled:g("filter-filled",60366),wand:g("wand",60367),debugLineByLine:g("debug-line-by-line",60368),inspect:g("inspect",60369),layers:g("layers",60370),layersDot:g("layers-dot",60371),layersActive:g("layers-active",60372),compass:g("compass",60373),compassDot:g("compass-dot",60374),compassActive:g("compass-active",60375),azure:g("azure",60376),issueDraft:g("issue-draft",60377),gitPullRequestClosed:g("git-pull-request-closed",60378),gitPullRequestDraft:g("git-pull-request-draft",60379),debugAll:g("debug-all",60380),debugCoverage:g("debug-coverage",60381),runErrors:g("run-errors",60382),folderLibrary:g("folder-library",60383),debugContinueSmall:g("debug-continue-small",60384),beakerStop:g("beaker-stop",60385),graphLine:g("graph-line",60386),graphScatter:g("graph-scatter",60387),pieChart:g("pie-chart",60388),bracketDot:g("bracket-dot",60389),bracketError:g("bracket-error",60390),lockSmall:g("lock-small",60391),azureDevops:g("azure-devops",60392),verifiedFilled:g("verified-filled",60393),newLine:g("newline",60394),layout:g("layout",60395),layoutActivitybarLeft:g("layout-activitybar-left",60396),layoutActivitybarRight:g("layout-activitybar-right",60397),layoutPanelLeft:g("layout-panel-left",60398),layoutPanelCenter:g("layout-panel-center",60399),layoutPanelJustify:g("layout-panel-justify",60400),layoutPanelRight:g("layout-panel-right",60401),layoutPanel:g("layout-panel",60402),layoutSidebarLeft:g("layout-sidebar-left",60403),layoutSidebarRight:g("layout-sidebar-right",60404),layoutStatusbar:g("layout-statusbar",60405),layoutMenubar:g("layout-menubar",60406),layoutCentered:g("layout-centered",60407),layoutSidebarRightOff:g("layout-sidebar-right-off",60416),layoutPanelOff:g("layout-panel-off",60417),layoutSidebarLeftOff:g("layout-sidebar-left-off",60418),target:g("target",60408),indent:g("indent",60409),recordSmall:g("record-small",60410),errorSmall:g("error-small",60411),arrowCircleDown:g("arrow-circle-down",60412),arrowCircleLeft:g("arrow-circle-left",60413),arrowCircleRight:g("arrow-circle-right",60414),arrowCircleUp:g("arrow-circle-up",60415),heartFilled:g("heart-filled",60420),map:g("map",60421),mapFilled:g("map-filled",60422),circleSmall:g("circle-small",60423),bellSlash:g("bell-slash",60424),bellSlashDot:g("bell-slash-dot",60425),commentUnresolved:g("comment-unresolved",60426),gitPullRequestGoToChanges:g("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:g("git-pull-request-new-changes",60428),searchFuzzy:g("search-fuzzy",60429),commentDraft:g("comment-draft",60430),send:g("send",60431),sparkle:g("sparkle",60432),insert:g("insert",60433),mic:g("mic",60434),thumbsDownFilled:g("thumbsdown-filled",60435),thumbsUpFilled:g("thumbsup-filled",60436),coffee:g("coffee",60437),snake:g("snake",60438),game:g("game",60439),vr:g("vr",60440),chip:g("chip",60441),piano:g("piano",60442),music:g("music",60443),micFilled:g("mic-filled",60444),gitFetch:g("git-fetch",60445),copilot:g("copilot",60446),lightbulbSparkle:g("lightbulb-sparkle",60447),dialogError:g("dialog-error","error"),dialogWarning:g("dialog-warning","warning"),dialogInfo:g("dialog-info","info"),dialogClose:g("dialog-close","close"),treeItemExpanded:g("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:g("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:g("tree-filter-on-type-off","list-selection"),treeFilterClear:g("tree-filter-clear","close"),treeItemLoading:g("tree-item-loading","loading"),menuSelection:g("menu-selection","check"),menuSubmenu:g("menu-submenu","chevron-right"),menuBarMore:g("menubar-more","more"),scrollbarButtonLeft:g("scrollbar-button-left","triangle-left"),scrollbarButtonRight:g("scrollbar-button-right","triangle-right"),scrollbarButtonUp:g("scrollbar-button-up","triangle-up"),scrollbarButtonDown:g("scrollbar-button-down","triangle-down"),toolBarMore:g("toolbar-more","more"),quickInputBack:g("quick-input-back","arrow-left")}}),define(Ee[24],Se([1,0,18]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=void 0;function N(s){if(!s||typeof s!="object"||s instanceof RegExp)return s;const i=Array.isArray(s)?[]:{};return Object.entries(s).forEach(([n,o])=>{i[n]=o&&typeof o=="object"?N(o):o}),i}e.$en=N;function g(s){if(!s||typeof s!="object")return s;const i=[s];for(;i.length>0;){const n=i.shift();Object.freeze(n);for(const o in n)if(I.call(n,o)){const a=n[o];typeof a=="object"&&!Object.isFrozen(a)&&!(0,D.$Ff)(a)&&i.push(a)}}return s}e.$fn=g;const I=Object.prototype.hasOwnProperty;function L(s,i){return b(s,i,new Set)}e.$gn=L;function b(s,i,n){if((0,D.$Lf)(s))return s;const o=i(s);if(typeof o<"u")return o;if(Array.isArray(s)){const a=[];for(const t of s)a.push(b(t,i,n));return a}if((0,D.$Ef)(s)){if(n.has(s))throw new Error("Cannot clone recursive data-structure");n.add(s);const a={};for(const t in s)I.call(s,t)&&(a[t]=b(s[t],i,n));return n.delete(s),a}return s}function $(s,i,n=!0){return(0,D.$Ef)(s)?((0,D.$Ef)(i)&&Object.keys(i).forEach(o=>{o in s?n&&((0,D.$Ef)(s[o])&&(0,D.$Ef)(i[o])?$(s[o],i[o],n):s[o]=i[o]):s[o]=i[o]}),s):i}e.$hn=$;function y(s,i){if(s===i)return!0;if(s==null||i===null||i===void 0||typeof s!=typeof i||typeof s!="object"||Array.isArray(s)!==Array.isArray(i))return!1;let n,o;if(Array.isArray(s)){if(s.length!==i.length)return!1;for(n=0;n<s.length;n++)if(!y(s[n],i[n]))return!1}else{const a=[];for(o in s)a.push(o);a.sort();const t=[];for(o in i)t.push(o);if(t.sort(),!y(a,t))return!1;for(n=0;n<a.length;n++)if(!y(s[a[n]],i[a[n]]))return!1}return!0}e.$in=y;function A(s){const i=new Set;return JSON.stringify(s,(n,o)=>{if((0,D.$Ef)(o)||Array.isArray(o)){if(i.has(o))return"[Circular]";i.add(o)}return o})}e.$jn=A;function C(s,i){const n=Object.create(null);return!s||!i||Object.keys(i).forEach(a=>{const t=s[a],r=i[a];y(t,r)||(n[a]=r)}),n}e.$kn=C;function m(s,i){const n=i.toLowerCase(),o=Object.keys(s).find(a=>a.toLowerCase()===n);return o?s[o]:s[i]}e.$ln=m;function v(s,i){const n=Object.create(null);for(const[o,a]of Object.entries(s))i(o,a)&&(n[o]=a);return n}e.$mn=v;function S(s){let i=[];for(;Object.prototype!==s;)i=i.concat(Object.getOwnPropertyNames(s)),s=Object.getPrototypeOf(s);return i}e.$nn=S;function f(s){const i=[];for(const n of S(s))typeof s[n]=="function"&&i.push(n);return i}e.$on=f;function d(s,i){const n=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},o={};for(const a of s)o[a]=n(a);return o}e.$pn=d}),define(Ee[61],Se([1,0,78]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$6j=e.ThemeColor=void 0;var N;(function(L){function b($){return $&&typeof $=="object"&&typeof $.id=="string"}L.isThemeColor=b})(N||(e.ThemeColor=N={}));function g(L){return{id:L}}e.$6j=g;var I;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function $(i){const n=b.exec(i.id);if(!n)return $(D.$5j.error);const[,o,a]=n,t=["codicon","codicon-"+o];return a&&t.push("codicon-modifier-"+a.substring(1)),t}L.asClassNameArray=$;function y(i){return $(i).join(" ")}L.asClassName=y;function A(i){return"."+$(i).join(".")}L.asCSSSelector=A;function C(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}L.isThemeIcon=C;const m=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function v(i){const n=m.exec(i);if(!n)return;const[,o]=n;return{id:o}}L.fromString=v;function S(i){return{id:i}}L.fromId=S;function f(i,n){let o=i.id;const a=o.lastIndexOf("~");return a!==-1&&(o=o.substring(0,a)),n&&(o=`${o}~${n}`),{id:o}}L.modify=f;function d(i){const n=i.id.lastIndexOf("~");if(n!==-1)return i.id.substring(n+1)}L.getModifier=d;function s(i,n){return i.id===n.id&&i.color?.id===n.color?.id}L.isEqual=s})(I||(e.ThemeIcon=I={}))}),define(Ee[163],Se([1,0,123,13,61]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=void 0;const I="$(",L=new RegExp(`\\$\\(${g.ThemeIcon.iconNameExpression}(?:${g.ThemeIcon.iconModifierExpression})?\\)`,"g"),b=new RegExp(`(\\\\)?${L.source}`,"g");function $(s){return s.replace(b,(i,n)=>n?i:`\\${i}`)}e.$7j=$;const y=new RegExp(`\\\\${L.source}`,"g");function A(s){return s.replace(y,i=>`\\${i}`)}e.$8j=A;const C=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(s){return s.indexOf(I)===-1?s:s.replace(C,(i,n,o,a)=>o?i:n||a||"")}e.$9j=m;function v(s){return s?s.replace(/\$\((.*?)\)/g,(i,n)=>` ${n} `).trim():""}e.$0j=v;const S=new RegExp(`\\$\\(${g.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(s){S.lastIndex=0;let i="";const n=[];let o=0;for(;;){const a=S.lastIndex,t=S.exec(s),r=s.substring(a,t?.index);if(r.length>0){i+=r;for(let h=0;h<r.length;h++)n.push(o)}if(!t)break;o+=t[0].length}return{text:i,iconOffsets:n}}e.$$j=f;function d(s,i,n=!1){const{text:o,iconOffsets:a}=i;if(!a||a.length===0)return(0,D.$Tj)(s,o,n);const t=(0,N.$Ne)(o," "),r=o.length-t.length,h=(0,D.$Tj)(s,t,n);if(h)for(const u of h){const c=a[u.start+r]+r;u.start+=c,u.end+=c}return h}e.$_j=d}),define(Ee[124],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.Constants=void 0;var D;(function(I){I[I.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",I[I.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",I[I.MAX_UINT_8=255]="MAX_UINT_8",I[I.MAX_UINT_16=65535]="MAX_UINT_16",I[I.MAX_UINT_32=4294967295]="MAX_UINT_32",I[I.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(D||(e.Constants=D={}));function N(I){return I<0?0:I>255?255:I|0}e.$De=N;function g(I){return I<0?0:I>4294967295?4294967295:I|0}e.$Ee=g}),define(Ee[30],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(g){return D.test(g)}e.$jg=N,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let g;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?g=crypto.getRandomValues.bind(crypto):g=function(b){for(let $=0;$<b.length;$++)b[$]=Math.floor(Math.random()*256);return b};const I=new Uint8Array(16),L=[];for(let b=0;b<256;b++)L.push(b.toString(16).padStart(2,"0"));return function(){g(I),I[6]=I[6]&15|64,I[8]=I[8]&63|128;let $=0,y="";return y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+="-",y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y+=L[I[$++]],y}}()}),define(Ee[164],Se([1,0,19,52,30]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.$9s=void 0;function I(C){return{asString:async()=>C,asFile:()=>{},value:typeof C=="string"?C:void 0}}e.$9s=I;function L(C,m,v){const S={id:(0,g.$kg)(),name:C,uri:m,data:v};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$0s=L;class b{constructor(){this.a=new Map}get size(){let m=0;for(const v of this.a)m++;return m}has(m){return this.a.has(this.b(m))}matches(m){const v=[...this.a.keys()];return N.Iterable.some(this,([S,f])=>f.asFile())&&v.push("files"),A($(m),v)}get(m){return this.a.get(this.b(m))?.[0]}append(m,v){const S=this.a.get(m);S?S.push(v):this.a.set(this.b(m),[v])}replace(m,v){this.a.set(this.b(m),[v])}delete(m){this.a.delete(this.b(m))}*[Symbol.iterator](){for(const[m,v]of this.a)for(const S of v)yield[m,S]}b(m){return $(m)}}e.$$s=b;function $(C){return C.toLowerCase()}function y(C,m){return A($(C),m.map($))}e.$_s=y;function A(C,m){if(C==="*/*")return m.length>0;if(m.includes(C))return!0;const v=C.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!v)return!1;const[S,f,d]=v;return d==="*"?m.some(s=>s.startsWith(f+"/")):!1}e.$at=Object.freeze({create:C=>(0,D.$Lb)(C.map(m=>m.toString())).join(`\r
`),split:C=>C.split(`\r
`),parse:C=>e.$at.split(C).filter(m=>!m.startsWith("#"))})}),define(Ee[165],Se([1,0,62]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$og=e.$ng=e.$mg=void 0;function N(b,$,y,A=1){let C=!1;return new Promise(m=>{const v=setTimeout(()=>{if(!C)return C=!0,m(0)},y);g(b,$,A,S=>{if(!C)return C=!0,clearTimeout(v),m(S)})})}e.$mg=N;function g(b,$,y,A){if($===0)return A(0);const C=new D.Socket;C.once("connect",()=>(L(C),g(b+y,$-1,y,A))),C.once("data",()=>{}),C.once("error",m=>(L(C),m.code!=="ECONNREFUSED"?g(b+y,$-1,y,A):A(b))),C.connect(b,"127.0.0.1")}e.$ng={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function I(b,$,y,A="127.0.0.1"){let C=!1,m,v=1;const S=D.createServer({pauseOnConnect:!0});function f(d,s){C||(C=!0,S.removeAllListeners(),S.close(),m&&clearTimeout(m),s(d))}return new Promise(d=>{m=setTimeout(()=>{f(0,d)},y),S.on("listening",()=>{f(b,d)}),S.on("error",s=>{s&&(s.code==="EADDRINUSE"||s.code==="EACCES")&&v<$?(b++,v++,S.listen(b,A)):f(0,d)}),S.on("close",()=>{f(0,d)}),S.listen(b,A)})}e.$og=I;function L(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch($){console.error($)}}}),define(Ee[125],Se([1,0,124]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2s=e.$1s=void 0;class N{constructor(b){const $=(0,D.$De)(b);this.c=$,this.a=N.d($),this.b=new Map}static d(b){const $=new Uint8Array(256);return $.fill(b),$}set(b,$){const y=(0,D.$De)($);b>=0&&b<256?this.a[b]=y:this.b.set(b,y)}get(b){return b>=0&&b<256?this.a[b]:this.b.get(b)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$1s=N;var g;(function(L){L[L.False=0]="False",L[L.True=1]="True"})(g||(g={}));class I{constructor(){this.a=new N(0)}add(b){this.a.set(b,1)}has(b){return this.a.get(b)===1}clear(){return this.a.clear()}}e.$2s=I}),define(Ee[166],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.StringEOL=void 0;var D;(function(g){g[g.Unknown=0]="Unknown",g[g.Invalid=3]="Invalid",g[g.LF=1]="LF",g[g.CRLF=2]="CRLF"})(D||(e.StringEOL=D={}));function N(g){let I=0,L=0,b=0,$=0;for(let y=0,A=g.length;y<A;y++){const C=g.charCodeAt(y);C===13?(I===0&&(L=y),I++,y+1<A&&g.charCodeAt(y+1)===10?($|=2,y++):$|=3,b=y+1):C===10&&($|=1,I===0&&(L=y),I++,b=y+1)}return I===0&&(L=g.length),[I,L,g.length-b,$]}e.$dt=N}),define(Ee[49],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=void 0;class D{constructor(g,I){this.lineNumber=g,this.column=I}with(g=this.lineNumber,I=this.column){return g===this.lineNumber&&I===this.column?this:new D(g,I)}delta(g=0,I=0){return this.with(this.lineNumber+g,this.column+I)}equals(g){return D.equals(this,g)}static equals(g,I){return!g&&!I?!0:!!g&&!!I&&g.lineNumber===I.lineNumber&&g.column===I.column}isBefore(g){return D.isBefore(this,g)}static isBefore(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<I.column}isBeforeOrEqual(g){return D.isBeforeOrEqual(this,g)}static isBeforeOrEqual(g,I){return g.lineNumber<I.lineNumber?!0:I.lineNumber<g.lineNumber?!1:g.column<=I.column}static compare(g,I){const L=g.lineNumber|0,b=I.lineNumber|0;if(L===b){const $=g.column|0,y=I.column|0;return $-y}return L-b}clone(){return new D(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(g){return new D(g.lineNumber,g.column)}static isIPosition(g){return g&&typeof g.lineNumber=="number"&&typeof g.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Cs=D}),define(Ee[29],Se([1,0,49]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ds=void 0;class N{constructor(I,L,b,$){I>b||I===b&&L>$?(this.startLineNumber=b,this.startColumn=$,this.endLineNumber=I,this.endColumn=L):(this.startLineNumber=I,this.startColumn=L,this.endLineNumber=b,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(I){return I.startLineNumber===I.endLineNumber&&I.startColumn===I.endColumn}containsPosition(I){return N.containsPosition(this,I)}static containsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<I.startColumn||L.lineNumber===I.endLineNumber&&L.column>I.endColumn)}static strictContainsPosition(I,L){return!(L.lineNumber<I.startLineNumber||L.lineNumber>I.endLineNumber||L.lineNumber===I.startLineNumber&&L.column<=I.startColumn||L.lineNumber===I.endLineNumber&&L.column>=I.endColumn)}containsRange(I){return N.containsRange(this,I)}static containsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>I.endColumn)}strictContainsRange(I){return N.strictContainsRange(this,I)}static strictContainsRange(I,L){return!(L.startLineNumber<I.startLineNumber||L.endLineNumber<I.startLineNumber||L.startLineNumber>I.endLineNumber||L.endLineNumber>I.endLineNumber||L.startLineNumber===I.startLineNumber&&L.startColumn<=I.startColumn||L.endLineNumber===I.endLineNumber&&L.endColumn>=I.endColumn)}plusRange(I){return N.plusRange(this,I)}static plusRange(I,L){let b,$,y,A;return L.startLineNumber<I.startLineNumber?(b=L.startLineNumber,$=L.startColumn):L.startLineNumber===I.startLineNumber?(b=L.startLineNumber,$=Math.min(L.startColumn,I.startColumn)):(b=I.startLineNumber,$=I.startColumn),L.endLineNumber>I.endLineNumber?(y=L.endLineNumber,A=L.endColumn):L.endLineNumber===I.endLineNumber?(y=L.endLineNumber,A=Math.max(L.endColumn,I.endColumn)):(y=I.endLineNumber,A=I.endColumn),new N(b,$,y,A)}intersectRanges(I){return N.intersectRanges(this,I)}static intersectRanges(I,L){let b=I.startLineNumber,$=I.startColumn,y=I.endLineNumber,A=I.endColumn;const C=L.startLineNumber,m=L.startColumn,v=L.endLineNumber,S=L.endColumn;return b<C?(b=C,$=m):b===C&&($=Math.max($,m)),y>v?(y=v,A=S):y===v&&(A=Math.min(A,S)),b>y||b===y&&$>A?null:new N(b,$,y,A)}equalsRange(I){return N.equalsRange(this,I)}static equalsRange(I,L){return!I&&!L?!0:!!I&&!!L&&I.startLineNumber===L.startLineNumber&&I.startColumn===L.startColumn&&I.endLineNumber===L.endLineNumber&&I.endColumn===L.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(I){return new D.$Cs(I.endLineNumber,I.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(I){return new D.$Cs(I.startLineNumber,I.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(I,L){return new N(this.startLineNumber,this.startColumn,I,L)}setStartPosition(I,L){return new N(I,L,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(I){return new N(I.startLineNumber,I.startColumn,I.startLineNumber,I.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(I){return new N(I.endLineNumber,I.endColumn,I.endLineNumber,I.endColumn)}delta(I){return new N(this.startLineNumber+I,this.startColumn,this.endLineNumber+I,this.endColumn)}static fromPositions(I,L=I){return new N(I.lineNumber,I.column,L.lineNumber,L.column)}static lift(I){return I?new N(I.startLineNumber,I.startColumn,I.endLineNumber,I.endColumn):null}static isIRange(I){return I&&typeof I.startLineNumber=="number"&&typeof I.startColumn=="number"&&typeof I.endLineNumber=="number"&&typeof I.endColumn=="number"}static areIntersectingOrTouching(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<I.startColumn)}static areIntersecting(I,L){return!(I.endLineNumber<L.startLineNumber||I.endLineNumber===L.startLineNumber&&I.endColumn<=L.startColumn||L.endLineNumber<I.startLineNumber||L.endLineNumber===I.startLineNumber&&L.endColumn<=I.startColumn)}static compareRangesUsingStarts(I,L){if(I&&L){const y=I.startLineNumber|0,A=L.startLineNumber|0;if(y===A){const C=I.startColumn|0,m=L.startColumn|0;if(C===m){const v=I.endLineNumber|0,S=L.endLineNumber|0;if(v===S){const f=I.endColumn|0,d=L.endColumn|0;return f-d}return v-S}return C-m}return y-A}return(I?1:0)-(L?1:0)}static compareRangesUsingEnds(I,L){return I.endLineNumber===L.endLineNumber?I.endColumn===L.endColumn?I.startLineNumber===L.startLineNumber?I.startColumn-L.startColumn:I.startLineNumber-L.startLineNumber:I.endColumn-L.endColumn:I.endLineNumber-L.endLineNumber}static spansMultipleLines(I){return I.endLineNumber>I.startLineNumber}toJSON(){return this}}e.$Ds=N}),define(Ee[167],Se([1,0,29]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class N{static insert(I,L){return{range:new D.$Ds(I.lineNumber,I.column,I.lineNumber,I.column),text:L,forceMoveMarkers:!0}}static delete(I){return{range:I,text:null}}static replace(I,L){return{range:I,text:L}}static replaceMove(I,L){return{range:I,text:L,forceMoveMarkers:!0}}}e.$Es=N}),define(Ee[168],Se([1,0,49,29]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=e.SelectionDirection=void 0;var g;(function(L){L[L.LTR=0]="LTR",L[L.RTL=1]="RTL"})(g||(e.SelectionDirection=g={}));class I extends N.$Ds{constructor(b,$,y,A){super(b,$,y,A),this.selectionStartLineNumber=b,this.selectionStartColumn=$,this.positionLineNumber=y,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(b){return I.selectionsEqual(this,b)}static selectionsEqual(b,$){return b.selectionStartLineNumber===$.selectionStartLineNumber&&b.selectionStartColumn===$.selectionStartColumn&&b.positionLineNumber===$.positionLineNumber&&b.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(b,$){return this.getDirection()===0?new I(this.startLineNumber,this.startColumn,b,$):new I(b,$,this.startLineNumber,this.startColumn)}getPosition(){return new D.$Cs(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new D.$Cs(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(b,$){return this.getDirection()===0?new I(b,$,this.endLineNumber,this.endColumn):new I(this.endLineNumber,this.endColumn,b,$)}static fromPositions(b,$=b){return new I(b.lineNumber,b.column,$.lineNumber,$.column)}static fromRange(b,$){return $===0?new I(b.startLineNumber,b.startColumn,b.endLineNumber,b.endColumn):new I(b.endLineNumber,b.endColumn,b.startLineNumber,b.startColumn)}static liftSelection(b){return new I(b.selectionStartLineNumber,b.selectionStartColumn,b.positionLineNumber,b.positionColumn)}static selectionsArrEqual(b,$){if(b&&!$||!b&&$)return!1;if(!b&&!$)return!0;if(b.length!==$.length)return!1;for(let y=0,A=b.length;y<A;y++)if(!this.selectionsEqual(b[y],$[y]))return!1;return!0}static isISelection(b){return b&&typeof b.selectionStartLineNumber=="number"&&typeof b.selectionStartColumn=="number"&&typeof b.positionLineNumber=="number"&&typeof b.positionColumn=="number"}static createWithDirection(b,$,y,A,C){return C===0?new I(b,$,y,A):new I(y,A,b,$)}}e.$Fs=I}),define(Ee[169],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,e.$as={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ee[170],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4s=e.$3s=e.WordCharacterClass=void 0;var N;(function(L){L[L.Regular=0]="Regular",L[L.Whitespace=1]="Whitespace",L[L.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class g extends D.$1s{constructor(b){super(0);for(let $=0,y=b.length;$<y;$++)this.set(b.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$3s=g;function I(L){const b={};return $=>(b.hasOwnProperty($)||(b[$]=L($)),b[$])}e.$4s=I(L=>new g(L))}),define(Ee[126],Se([1,0,52,3,75]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fs=e.$es=e.$ds=e.$cs=e.$bs=void 0,e.$bs="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function I(C=""){let m="(-?\\d*\\.\\d\\w*)|([^";for(const v of e.$bs)C.indexOf(v)>=0||(m+="\\"+v);return m+="\\s]+)",new RegExp(m,"g")}e.$cs=I();function L(C){let m=e.$cs;if(C&&C instanceof RegExp)if(C.global)m=C;else{let v="g";C.ignoreCase&&(v+="i"),C.multiline&&(v+="m"),C.unicode&&(v+="u"),m=new RegExp(C.source,v)}return m.lastIndex=0,m}e.$ds=L;const b=new g.$2c;b.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(C){const m=b.unshift(C);return(0,N.$Pc)(m)}e.$es=$;function y(C,m,v,S,f){if(f||(f=D.Iterable.first(b)),v.length>f.maxLen){let o=C-f.maxLen/2;return o<0?o=0:S+=o,v=v.substring(o,C+f.maxLen/2),y(C,m,v,S,f)}const d=Date.now(),s=C-1-S;let i=-1,n=null;for(let o=1;!(Date.now()-d>=f.timeBudget);o++){const a=s-f.windowSize*o;m.lastIndex=Math.max(0,a);const t=A(m,v,s,i);if(!t&&n||(n=t,a<=0))break;i=a}if(n){const o={word:n[0],startColumn:S+1+n.index,endColumn:S+1+n.index+n[0].length};return m.lastIndex=0,o}return null}e.$fs=y;function A(C,m,v,S){let f;for(;f=C.exec(m);){const d=f.index||0;if(d<=v&&C.lastIndex>=v)return f;if(S>0&&d>S)return null}return null}}),define(Ee[171],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.IndentAction=void 0;var D;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(D||(e.IndentAction=D={}));class N{constructor(b){if(this.e=null,this.f=!1,this.open=b.open,this.close=b.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(b.notIn))for(let $=0,y=b.notIn.length;$<y;$++)switch(b.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(b){switch(b){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(b,$){if(b.getTokenCount()===0)return!0;const y=b.findTokenIndexAtOffset($-2),A=b.getStandardTokenType(y);return this.isOK(A)}g(b,$){for(let y=b;y<=$;y++){const A=String.fromCharCode(y);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$At=N;class g{constructor(b){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of b)I(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),I(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),I(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),I(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&I(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$Bt=g;function I(L,b,$){L.has(b)?L.get(b).push($):L.set(b,[$])}}),define(Ee[172],Se([1,0,125]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dZ=e.$cZ=e.$bZ=e.State=void 0;var N;(function(v){v[v.Invalid=0]="Invalid",v[v.Start=1]="Start",v[v.H=2]="H",v[v.HT=3]="HT",v[v.HTT=4]="HTT",v[v.HTTP=5]="HTTP",v[v.F=6]="F",v[v.FI=7]="FI",v[v.FIL=8]="FIL",v[v.BeforeColon=9]="BeforeColon",v[v.AfterColon=10]="AfterColon",v[v.AlmostThere=11]="AlmostThere",v[v.End=12]="End",v[v.Accept=13]="Accept",v[v.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class g{constructor(S,f,d){const s=new Uint8Array(S*f);for(let i=0,n=S*f;i<n;i++)s[i]=d;this.a=s,this.rows=S,this.cols=f}get(S,f){return this.a[S*this.cols+f]}set(S,f,d){this.a[S*this.cols+f]=d}}class I{constructor(S){let f=0,d=0;for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];a>f&&(f=a),o>d&&(d=o),t>d&&(d=t)}f++,d++;const s=new g(d,f,0);for(let i=0,n=S.length;i<n;i++){const[o,a,t]=S[i];s.set(o,a,t)}this.a=s,this.b=f}nextState(S,f){return f<0||f>=this.b?0:this.a.get(S,f)}}e.$bZ=I;let L=null;function b(){return L===null&&(L=new I([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),L}var $;(function(v){v[v.None=0]="None",v[v.ForceTermination=1]="ForceTermination",v[v.CannotEndIn=2]="CannotEndIn"})($||($={}));let y=null;function A(){if(y===null){y=new D.$1s(0);const v=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<v.length;f++)y.set(v.charCodeAt(f),1);const S=".,;:";for(let f=0;f<S.length;f++)y.set(S.charCodeAt(f),2)}return y}class C{static a(S,f,d,s,i){let n=i-1;do{const o=f.charCodeAt(n);if(S.get(o)!==2)break;n--}while(n>s);if(s>0){const o=f.charCodeAt(s-1),a=f.charCodeAt(n);(o===40&&a===41||o===91&&a===93||o===123&&a===125)&&n--}return{range:{startLineNumber:d,startColumn:s+1,endLineNumber:d,endColumn:n+2},url:f.substring(s,n+1)}}static computeLinks(S,f=b()){const d=A(),s=[];for(let i=1,n=S.getLineCount();i<=n;i++){const o=S.getLineContent(i),a=o.length;let t=0,r=0,h=0,u=1,c=!1,l=!1,k=!1,R=!1;for(;t<a;){let w=!1;const p=o.charCodeAt(t);if(u===13){let E;switch(p){case 40:c=!0,E=0;break;case 41:E=c?0:1;break;case 91:k=!0,l=!0,E=0;break;case 93:k=!1,E=l?0:1;break;case 123:R=!0,E=0;break;case 125:E=R?0:1;break;case 39:case 34:case 96:h===p?E=1:h===39||h===34||h===96?E=0:E=1;break;case 42:E=h===42?1:0;break;case 124:E=h===124?1:0;break;case 32:E=k?0:1;break;default:E=d.get(p)}E===1&&(s.push(C.a(d,o,i,r,t)),w=!0)}else if(u===12){let E;p===91?(l=!0,E=0):E=d.get(p),E===1?w=!0:u=13}else u=f.nextState(u,p),u===0&&(w=!0);w&&(u=1,c=!1,l=!1,R=!1,r=t+1,h=p),t++}u===13&&s.push(C.a(d,o,i,r,a))}return s}}e.$cZ=C;function m(v){return!v||typeof v.getLineCount!="function"||typeof v.getLineContent!="function"?[]:C.computeLinks(v)}e.$dZ=m}),define(Ee[79],Se([1,0,24]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1u=e.$Zu=e.$Yu=e.$Xu=e.ModelConstants=e.PositionAffinity=e.$Wu=e.TrackedRangeStickiness=e.$Vu=e.$Uu=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var g;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(g||(e.GlyphMarginLane=g={}));var I;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(I||(e.MinimapPosition=I={}));var L;(function(o){o[o.Both=0]="Both",o[o.Right=1]="Right",o[o.Left=2]="Left",o[o.None=3]="None"})(L||(e.InjectedTextCursorStops=L={}));var b;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(b||(e.EndOfLinePreference=b={}));var $;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var y;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(y||(e.EndOfLineSequence=y={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,D.$in)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$Uu=A;class C{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$Vu=C;var m;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(m||(e.TrackedRangeStickiness=m={}));function v(o){return o&&typeof o.read=="function"}e.$Wu=v;var S;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right",o[o.None=2]="None",o[o.LeftOfInjectedText=3]="LeftOfInjectedText",o[o.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var f;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(f||(e.ModelConstants=f={}));class d{constructor(a,t,r,h,u,c){this.identifier=a,this.range=t,this.text=r,this.forceMoveMarkers=h,this.isAutoWhitespaceEdit=u,this._isTracked=c}}e.$Xu=d;class s{constructor(a,t,r){this.regex=a,this.wordSeparators=t,this.simpleSearch=r}}e.$Yu=s;class i{constructor(a,t,r){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=r}}e.$Zu=i;function n(o){return!o.isTooLargeForSyncing()&&!o.isForSimpleWidget}e.$1u=n}),define(Ee[173],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=e.NodeColor=e.$wB=void 0;class D{constructor(d,s){this.piece=d,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$xB)return g(this.right);let d=this;for(;d.parent!==e.$xB&&d.parent.left!==d;)d=d.parent;return d.parent===e.$xB?e.$xB:d.parent}prev(){if(this.left!==e.$xB)return I(this.left);let d=this;for(;d.parent!==e.$xB&&d.parent.right!==d;)d=d.parent;return d.parent===e.$xB?e.$xB:d.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$wB=D;var N;(function(f){f[f.Black=0]="Black",f[f.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$xB=new D(null,0),e.$xB.parent=e.$xB,e.$xB.left=e.$xB,e.$xB.right=e.$xB,e.$xB.color=0;function g(f){for(;f.left!==e.$xB;)f=f.left;return f}e.$yB=g;function I(f){for(;f.right!==e.$xB;)f=f.right;return f}e.$zB=I;function L(f){return f===e.$xB?0:f.size_left+f.piece.length+L(f.right)}function b(f){return f===e.$xB?0:f.lf_left+f.piece.lineFeedCnt+b(f.right)}function $(){e.$xB.parent=e.$xB}function y(f,d){const s=d.right;s.size_left+=d.size_left+(d.piece?d.piece.length:0),s.lf_left+=d.lf_left+(d.piece?d.piece.lineFeedCnt:0),d.right=s.left,s.left!==e.$xB&&(s.left.parent=d),s.parent=d.parent,d.parent===e.$xB?f.root=s:d.parent.left===d?d.parent.left=s:d.parent.right=s,s.left=d,d.parent=s}e.$AB=y;function A(f,d){const s=d.left;d.left=s.right,s.right!==e.$xB&&(s.right.parent=d),s.parent=d.parent,d.size_left-=s.size_left+(s.piece?s.piece.length:0),d.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),d.parent===e.$xB?f.root=s:d===d.parent.right?d.parent.right=s:d.parent.left=s,s.right=d,d.parent=s}e.$BB=A;function C(f,d){let s,i;if(d.left===e.$xB?(i=d,s=i.right):d.right===e.$xB?(i=d,s=i.left):(i=g(d.right),s=i.right),i===f.root){f.root=s,s.color=0,d.detach(),$(),f.root.parent=e.$xB;return}const n=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===d?(s.parent=i.parent,S(f,s)):(i.parent===d?s.parent=i:s.parent=i.parent,S(f,s),i.left=d.left,i.right=d.right,i.parent=d.parent,i.color=d.color,d===f.root?f.root=i:d===d.parent.left?d.parent.left=i:d.parent.right=i,i.left!==e.$xB&&(i.left.parent=i),i.right!==e.$xB&&(i.right.parent=i),i.size_left=d.size_left,i.lf_left=d.lf_left,S(f,i)),d.detach(),s.parent.left===s){const a=L(s),t=b(s);if(a!==s.parent.size_left||t!==s.parent.lf_left){const r=a-s.parent.size_left,h=t-s.parent.lf_left;s.parent.size_left=a,s.parent.lf_left=t,v(f,s.parent,r,h)}}if(S(f,s.parent),n){$();return}let o;for(;s!==f.root&&s.color===0;)s===s.parent.left?(o=s.parent.right,o.color===1&&(o.color=0,s.parent.color=1,y(f,s.parent),o=s.parent.right),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.right.color===0&&(o.left.color=0,o.color=1,A(f,o),o=s.parent.right),o.color=s.parent.color,s.parent.color=0,o.right.color=0,y(f,s.parent),s=f.root)):(o=s.parent.left,o.color===1&&(o.color=0,s.parent.color=1,A(f,s.parent),o=s.parent.left),o.left.color===0&&o.right.color===0?(o.color=1,s=s.parent):(o.left.color===0&&(o.right.color=0,o.color=1,y(f,o),o=s.parent.left),o.color=s.parent.color,s.parent.color=0,o.left.color=0,A(f,s.parent),s=f.root));s.color=0,$()}e.$CB=C;function m(f,d){for(S(f,d);d!==f.root&&d.parent.color===1;)if(d.parent===d.parent.parent.left){const s=d.parent.parent.right;s.color===1?(d.parent.color=0,s.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.right&&(d=d.parent,y(f,d)),d.parent.color=0,d.parent.parent.color=1,A(f,d.parent.parent))}else{const s=d.parent.parent.left;s.color===1?(d.parent.color=0,s.color=0,d.parent.parent.color=1,d=d.parent.parent):(d===d.parent.left&&(d=d.parent,A(f,d)),d.parent.color=0,d.parent.parent.color=1,y(f,d.parent.parent))}f.root.color=0}e.$DB=m;function v(f,d,s,i){for(;d!==f.root&&d!==e.$xB;)d.parent.left===d&&(d.parent.size_left+=s,d.parent.lf_left+=i),d=d.parent}e.$EB=v;function S(f,d){let s=0,i=0;if(d!==f.root){for(;d!==f.root&&d===d.parent.right;)d=d.parent;if(d!==f.root)for(d=d.parent,s=L(d.left)-d.size_left,i=b(d.left)-d.lf_left,d.size_left+=s,d.lf_left+=i;d!==f.root&&(s!==0||i!==0);)d.parent.left===d&&(d.parent.size_left+=s,d.parent.lf_left+=i),d=d.parent}}e.$FB=S}),define(Ee[174],Se([1,0,19,124]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6u=e.$5u=e.$4u=void 0;class g{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,y){$=(0,N.$Ee)($);const A=this.a,C=this.b,m=y.length;return m===0?!1:(this.a=new Uint32Array(A.length+m),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+m),this.a.set(y,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}setValue($,y){return $=(0,N.$Ee)($),y=(0,N.$Ee)(y),this.a[$]===y?!1:(this.a[$]=y,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,y){$=(0,N.$Ee)($),y=(0,N.$Ee)(y);const A=this.a,C=this.b;if($>=A.length)return!1;const m=A.length-$;return y>=m&&(y=m),y===0?!1:(this.a=new Uint32Array(A.length-y),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+y),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(C.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Ee)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let y=this.c[0]+1;y===0&&(this.b[0]=this.a[0],y++),$>=this.a.length&&($=this.a.length-1);for(let A=y;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let y=0,A=this.a.length-1,C=0,m=0,v=0;for(;y<=A;)if(C=y+(A-y)/2|0,m=this.b[C],v=m-this.a[C],$<v)A=C-1;else if($>=m)y=C+1;else break;return new L(C,$-v)}}e.$4u=g;class I{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const y=this.e[$],A=y>0?this.d[y-1]:0;return new L(y,$-A)}removeValues($,y){this.a.splice($,y),this.f($)}insertValues($,y){this.a=(0,D.$Vb)(this.a,$,y),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,y=this.a.length;$<y;$++){const A=this.a[$],C=$>0?this.d[$-1]:0;this.d[$]=C+A;for(let m=0;m<A;m++)this.e[C+m]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,y){this.a[$]!==y&&(this.a[$]=y,this.f($))}}e.$5u=I;class L{constructor($,y){this.index=$,this.remainder=y,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=y}}e.$6u=L}),define(Ee[175],Se([1,0,13,49,174]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7u=void 0;class I{constructor(b,$,y,A){this.d=b,this.f=$,this.g=y,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(b){b.eol&&b.eol!==this.g&&(this.g=b.eol,this.j=null);const $=b.changes;for(const y of $)this.o(y.range),this.p(new N.$Cs(y.range.startLineNumber,y.range.startColumn),y.text);this.h=b.versionId,this.k=null}l(){if(!this.j){const b=this.g.length,$=this.f.length,y=new Uint32Array($);for(let A=0;A<$;A++)y[A]=this.f[A].length+b;this.j=new g.$4u(y)}}n(b,$){this.f[b]=$,this.j&&this.j.setValue(b,this.f[b].length+this.g.length)}o(b){if(b.startLineNumber===b.endLineNumber){if(b.startColumn===b.endColumn)return;this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.startLineNumber-1].substring(b.endColumn-1));return}this.n(b.startLineNumber-1,this.f[b.startLineNumber-1].substring(0,b.startColumn-1)+this.f[b.endLineNumber-1].substring(b.endColumn-1)),this.f.splice(b.startLineNumber,b.endLineNumber-b.startLineNumber),this.j&&this.j.removeValues(b.startLineNumber,b.endLineNumber-b.startLineNumber)}p(b,$){if($.length===0)return;const y=(0,D.$Te)($);if(y.length===1){this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]+this.f[b.lineNumber-1].substring(b.column-1));return}y[y.length-1]+=this.f[b.lineNumber-1].substring(b.column-1),this.n(b.lineNumber-1,this.f[b.lineNumber-1].substring(0,b.column-1)+y[0]);const A=new Uint32Array(y.length-1);for(let C=1;C<y.length;C++)this.f.splice(b.lineNumber+C-1,0,y[C]),A[C-1]=y[C].length+this.g.length;this.j&&this.j.insertValues(b.lineNumber,A)}}e.$7u=I}),define(Ee[99],Se([1,0,13,170,49,29,79]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LB=e.$KB=e.$JB=e.$IB=e.$HB=e.$GB=void 0;const b=999;class ${constructor(i,n,o,a){this.searchString=i,this.isRegex=n,this.matchCase=o,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=y(this.searchString):i=this.searchString.indexOf(`
`)>=0;let n=null;try{n=D.$Re(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!n)return null;let o=!this.isRegex&&!i;return o&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(o=this.matchCase),new L.$Yu(n,this.wordSeparators?(0,N.$4s)(this.wordSeparators):null,o?this.searchString:null)}}e.$GB=$;function y(s){if(!s||s.length===0)return!1;for(let i=0,n=s.length;i<n;i++){const o=s.charCodeAt(i);if(o===10)return!0;if(o===92){if(i++,i>=n)break;const a=s.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$HB=y;function A(s,i,n){if(!n)return new L.$Vu(s,null);const o=[];for(let a=0,t=i.length;a<t;a++)o[a]=i[a];return new L.$Vu(s,o)}e.$IB=A;class C{constructor(i){const n=[];let o=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(n[o++]=a);this.a=n}findLineFeedCountBeforeOffset(i){const n=this.a;let o=0,a=n.length-1;if(a===-1||i<=n[0])return 0;for(;o<a;){const t=o+((a-o)/2>>0);n[t]>=i?a=t-1:n[t+1]>=i?(o=t,a=t):o=t+1}return o+1}}class m{static findMatches(i,n,o,a,t){const r=n.parseSearchRequest();return r?r.regex.multiline?this.b(i,o,new d(r.wordSeparators,r.regex),a,t):this.c(i,o,r,a,t):[]}static a(i,n,o,a,t,r){let h,u=0;a?(u=a.findLineFeedCountBeforeOffset(t),h=n+t+u):h=n+t;let c;if(a){const w=a.findLineFeedCountBeforeOffset(t+r.length)-u;c=h+r.length+w}else c=h+r.length;const l=i.getPositionAt(h),k=i.getPositionAt(c);return new I.$Ds(l.lineNumber,l.column,k.lineNumber,k.column)}static b(i,n,o,a,t){const r=i.getOffsetAt(n.getStartPosition()),h=i.getValueInRange(n,1),u=i.getEOL()===`\r
`?new C(h):null,c=[];let l=0,k;for(o.reset(0);k=o.next(h);)if(c[l++]=A(this.a(i,r,h,u,k.index,k[0]),k,a),l>=t)return c;return c}static c(i,n,o,a,t){const r=[];let h=0;if(n.startLineNumber===n.endLineNumber){const c=i.getLineContent(n.startLineNumber).substring(n.startColumn-1,n.endColumn-1);return h=this.d(o,c,n.startLineNumber,n.startColumn-1,h,r,a,t),r}const u=i.getLineContent(n.startLineNumber).substring(n.startColumn-1);h=this.d(o,u,n.startLineNumber,n.startColumn-1,h,r,a,t);for(let c=n.startLineNumber+1;c<n.endLineNumber&&h<t;c++)h=this.d(o,i.getLineContent(c),c,0,h,r,a,t);if(h<t){const c=i.getLineContent(n.endLineNumber).substring(0,n.endColumn-1);h=this.d(o,c,n.endLineNumber,0,h,r,a,t)}return r}static d(i,n,o,a,t,r,h,u){const c=i.wordSeparators;if(!h&&i.simpleSearch){const R=i.simpleSearch,w=R.length,p=n.length;let E=-w;for(;(E=n.indexOf(R,E+w))!==-1;)if((!c||f(c,n,p,E,w))&&(r[t++]=new L.$Vu(new I.$Ds(o,E+1+a,o,E+1+w+a),null),t>=u))return t;return t}const l=new d(i.wordSeparators,i.regex);let k;l.reset(0);do if(k=l.next(n),k&&(r[t++]=A(new I.$Ds(o,k.index+1+a,o,k.index+1+k[0].length+a),k,h),t>=u))return t;while(k);return t}static findNextMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,o,r,a):this.f(i,o,r,a)}static e(i,n,o,a){const t=new g.$Cs(n.lineNumber,1),r=i.getOffsetAt(t),h=i.getLineCount(),u=i.getValueInRange(new I.$Ds(t.lineNumber,t.column,h,i.getLineMaxColumn(h)),1),c=i.getEOL()===`\r
`?new C(u):null;o.reset(n.column-1);const l=o.next(u);return l?A(this.a(i,r,u,c,l.index,l[0]),l,a):n.lineNumber!==1||n.column!==1?this.e(i,new g.$Cs(1,1),o,a):null}static f(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r),u=this.g(o,h,r,n.column,a);if(u)return u;for(let c=1;c<=t;c++){const l=(r+c-1)%t,k=i.getLineContent(l+1),R=this.g(o,k,l+1,1,a);if(R)return R}return null}static g(i,n,o,a,t){i.reset(a-1);const r=i.next(n);return r?A(new I.$Ds(o,r.index+1,o,r.index+1+r[0].length),r,t):null}static findPreviousMatch(i,n,o,a){const t=n.parseSearchRequest();if(!t)return null;const r=new d(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,o,r,a):this.j(i,o,r,a)}static h(i,n,o,a){const t=this.b(i,new I.$Ds(1,1,n.lineNumber,n.column),o,a,10*b);if(t.length>0)return t[t.length-1];const r=i.getLineCount();return n.lineNumber!==r||n.column!==i.getLineMaxColumn(r)?this.h(i,new g.$Cs(r,i.getLineMaxColumn(r)),o,a):null}static j(i,n,o,a){const t=i.getLineCount(),r=n.lineNumber,h=i.getLineContent(r).substring(0,n.column-1),u=this.k(o,h,r,a);if(u)return u;for(let c=1;c<=t;c++){const l=(t+r-c-1)%t,k=i.getLineContent(l+1),R=this.k(o,k,l+1,a);if(R)return R}return null}static k(i,n,o,a){let t=null,r;for(i.reset(0);r=i.next(n);)t=A(new I.$Ds(o,r.index+1,o,r.index+1+r[0].length),r,a);return t}}e.$JB=m;function v(s,i,n,o,a){if(o===0)return!0;const t=i.charCodeAt(o-1);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o);if(s.get(r)!==0)return!0}return!1}function S(s,i,n,o,a){if(o+a===n)return!0;const t=i.charCodeAt(o+a);if(s.get(t)!==0||t===13||t===10)return!0;if(a>0){const r=i.charCodeAt(o+a-1);if(s.get(r)!==0)return!0}return!1}function f(s,i,n,o,a){return v(s,i,n,o,a)&&S(s,i,n,o,a)}e.$KB=f;class d{constructor(i,n){this._wordSeparators=i,this.a=n,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const n=i.length;let o;do{if(this.b+this.c===n||(o=this.a.exec(i),!o))return null;const a=o.index,t=o[0].length;if(a===this.b&&t===this.c){if(t===0){D.$af(i,n,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||f(this._wordSeparators,i,n,a,t))return o}while(o);return null}}e.$LB=d}),define(Ee[127],Se([1,0,49,29,79,173,99]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=e.$PB=e.$OB=e.$NB=e.$MB=void 0;const b=65535;function $(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,n,o,a,t){this.lineStarts=i,this.cr=n,this.lf=o,this.crlf=a,this.isBasicASCII=t}}function A(s,i=!0){const n=[0];let o=1;for(let a=0,t=s.length;a<t;a++){const r=s.charCodeAt(a);r===13?a+1<t&&s.charCodeAt(a+1)===10?(n[o++]=a+2,a++):n[o++]=a+1:r===10&&(n[o++]=a+1)}return i?$(n):n}e.$MB=A;function C(s,i){s.length=0,s[0]=0;let n=1,o=0,a=0,t=0,r=!0;for(let u=0,c=i.length;u<c;u++){const l=i.charCodeAt(u);l===13?u+1<c&&i.charCodeAt(u+1)===10?(t++,s[n++]=u+2,u++):(o++,s[n++]=u+1):l===10?(a++,s[n++]=u+1):r&&l!==9&&(l<32||l>126)&&(r=!1)}const h=new y($(s),o,a,t,r);return s.length=0,h}e.$NB=C;class m{constructor(i,n,o,a,t){this.bufferIndex=i,this.start=n,this.end=o,this.lineFeedCnt=a,this.length=t}}e.$OB=m;class v{constructor(i,n){this.buffer=i,this.lineStarts=n}}e.$PB=v;class S{constructor(i,n){this.a=[],this.c=i,this.d=n,this.b=0,i.root!==I.$xB&&i.iterate(i.root,o=>(o!==I.$xB&&this.a.push(o.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class f{constructor(i){this.a=i,this.b=[]}get(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartOffset<=i&&o.nodeStartOffset+o.node.piece.length>=i)return o}return null}get2(i){for(let n=this.b.length-1;n>=0;n--){const o=this.b[n];if(o.nodeStartLineNumber&&o.nodeStartLineNumber<i&&o.nodeStartLineNumber+o.node.piece.lineFeedCnt>=i)return o}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let n=!1;const o=this.b;for(let a=0;a<o.length;a++){const t=o[a];if(t.node.parent===null||t.nodeStartOffset>=i){o[a]=null,n=!0;continue}}if(n){const a=[];for(const t of o)t!==null&&a.push(t);this.b=a}}}class d{constructor(i,n,o){this.create(i,n,o)}create(i,n,o){this.a=[new v("",[0])],this.g={line:0,column:0},this.root=I.$xB,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=o;let a=null;for(let t=0,r=i.length;t<r;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const h=new m(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,h)}this.h=new f(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const n=b,o=n-Math.floor(n/3),a=o*2;let t="",r=0;const h=[];if(this.iterate(this.root,u=>{const c=this.R(u),l=c.length;if(r<=o||r+l<a)return t+=c,r+=l,!0;const k=t.replace(/\r\n|\r|\n/g,i);return h.push(new v(k,A(k))),t=c,r=l,!0}),r>0){const u=t.replace(/\r\n|\r|\n/g,i);h.push(new v(u,A(u)))}this.create(h,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let n=0;return this.iterate(this.root,a=>{if(a===I.$xB)return!0;const t=this.R(a),r=t.length,h=i.G(n),u=i.G(n+r),c=i.getValueInRange2(h,u);return n+=r,t===c})}getOffsetAt(i,n){let o=0,a=this.root;for(;a!==I.$xB;)if(a.left!==I.$xB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){o+=a.size_left;const t=this.B(a,i-a.lf_left-2);return o+=t+n-1}else i-=a.lf_left+a.piece.lineFeedCnt,o+=a.size_left+a.piece.length,a=a.right;return o}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let n=this.root,o=0;const a=i;for(;n!==I.$xB;)if(n.size_left!==0&&n.size_left>=i)n=n.left;else if(n.size_left+n.piece.length>=i){const t=this.A(n,i-n.size_left);if(o+=n.lf_left+t.index,t.index===0){const r=this.getOffsetAt(o+1,1),h=a-r;return new D.$Cs(o+1,h+1)}return new D.$Cs(o+1,t.remainder+1)}else if(i-=n.size_left+n.piece.length,o+=n.lf_left+n.piece.lineFeedCnt,n.right===I.$xB){const t=this.getOffsetAt(o+1,1),r=a-i-t;return new D.$Cs(o+1,r+1)}else n=n.right;return new D.$Cs(1,1)}getValueInRange(i,n){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const o=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(o,a);return n?n!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,n):t}getValueInRange2(i,n){if(i.node===n.node){const h=i.node,u=this.a[h.piece.bufferIndex].buffer,c=this.u(h.piece.bufferIndex,h.piece.start);return u.substring(c+i.remainder,c+n.remainder)}let o=i.node;const a=this.a[o.piece.bufferIndex].buffer,t=this.u(o.piece.bufferIndex,o.piece.start);let r=a.substring(t+i.remainder,t+o.piece.length);for(o=o.next();o!==I.$xB;){const h=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(o===n.node){r+=h.substring(u,u+n.remainder);break}else r+=h.substr(u,o.piece.length);o=o.next()}return r}getLinesContent(){const i=[];let n=0,o="",a=!1;return this.iterate(this.root,t=>{if(t===I.$xB)return!0;const r=t.piece;let h=r.length;if(h===0)return!0;const u=this.a[r.bufferIndex].buffer,c=this.a[r.bufferIndex].lineStarts,l=r.start.line,k=r.end.line;let R=c[l]+r.start.column;if(a&&(u.charCodeAt(R)===10&&(R++,h--),i[n++]=o,o="",a=!1,h===0))return!0;if(l===k)return!this.f&&u.charCodeAt(R+h-1)===13?(a=!0,o+=u.substr(R,h-1)):o+=u.substr(R,h),!0;o+=this.f?u.substring(R,Math.max(R,c[l+1]-this.e)):u.substring(R,c[l+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;for(let w=l+1;w<k;w++)o=this.f?u.substring(c[w],c[w+1]-this.e):u.substring(c[w],c[w+1]).replace(/(\r\n|\r|\n)$/,""),i[n++]=o;return!this.f&&u.charCodeAt(c[k]+r.end.column-1)===13?(a=!0,r.end.column===0?n--:o=u.substr(c[k],r.end.column-1)):o=u.substr(c[k],r.end.column),!0}),a&&(i[n++]=o,o=""),i[n++]=o,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const n=i.node.next();if(!n)return 0;const o=this.a[n.piece.bufferIndex],a=this.u(n.piece.bufferIndex,n.piece.start);return o.buffer.charCodeAt(a)}else{const n=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return n.buffer.charCodeAt(a)}}getLineCharCode(i,n){const o=this.H(i,n+1);return this.l(o)}getLineLength(i){if(i===this.getLineCount()){const n=this.getOffsetAt(i,1);return this.getLength()-n}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const n=this.G(i);return this.l(n)}findMatchesInNode(i,n,o,a,t,r,h,u,c,l,k){const R=this.a[i.piece.bufferIndex],w=this.u(i.piece.bufferIndex,i.piece.start),p=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,r);let P;const z={line:0,column:0};let j,F;n._wordSeparators?(j=R.buffer.substring(p,E),F=O=>O+p,n.reset(0)):(j=R.buffer,F=O=>O,n.reset(p));do if(P=n.next(j),P){if(F(P.index)>=E)return l;this.s(i,F(P.index)-w,z);const O=this.t(i.piece.bufferIndex,t,z),T=z.line===t.line?z.column-t.column+a:z.column+1,M=T+P[0].length;if(k[l++]=(0,L.$IB)(new N.$Ds(o+O,T,o+O,M),P,u),F(P.index)+P[0].length>=E||l>=c)return l}while(P);return l}findMatchesLineByLine(i,n,o,a){const t=[];let r=0;const h=new L.$LB(n.wordSeparators,n.regex);let u=this.H(i.startLineNumber,i.startColumn);if(u===null)return[];const c=this.H(i.endLineNumber,i.endColumn);if(c===null)return[];let l=this.s(u.node,u.remainder);const k=this.s(c.node,c.remainder);if(u.node===c.node)return this.findMatchesInNode(u.node,h,i.startLineNumber,i.startColumn,l,k,n,o,a,r,t),t;let R=i.startLineNumber,w=u.node;for(;w!==c.node;){const E=this.t(w.piece.bufferIndex,l,w.piece.end);if(E>=1){const z=this.a[w.piece.bufferIndex].lineStarts,j=this.u(w.piece.bufferIndex,w.piece.start),F=z[l.line+E],O=R===i.startLineNumber?i.startColumn:1;if(r=this.findMatchesInNode(w,h,R,O,l,this.s(w,F-j),n,o,a,r,t),r>=a)return t;R+=E}const P=R===i.startLineNumber?i.startColumn-1:0;if(R===i.endLineNumber){const z=this.getLineContent(R).substring(P,i.endColumn-1);return r=this.n(n,h,z,i.endLineNumber,P,r,t,o,a),t}if(r=this.n(n,h,this.getLineContent(R).substr(P),R,P,r,t,o,a),r>=a)return t;R++,u=this.H(R,1),w=u.node,l=this.s(u.node,u.remainder)}if(R===i.endLineNumber){const E=R===i.startLineNumber?i.startColumn-1:0,P=this.getLineContent(R).substring(E,i.endColumn-1);return r=this.n(n,h,P,i.endLineNumber,E,r,t,o,a),t}const p=R===i.startLineNumber?i.startColumn:1;return r=this.findMatchesInNode(c.node,h,R,p,l,k,n,o,a,r,t),t}n(i,n,o,a,t,r,h,u,c){const l=i.wordSeparators;if(!u&&i.simpleSearch){const R=i.simpleSearch,w=R.length,p=o.length;let E=-w;for(;(E=o.indexOf(R,E+w))!==-1;)if((!l||(0,L.$KB)(l,o,p,E,w))&&(h[r++]=new g.$Vu(new N.$Ds(a,E+1+t,a,E+1+w+t),null),r>=c))return r;return r}let k;n.reset(0);do if(k=n.next(o),k&&(h[r++]=(0,L.$IB)(new N.$Ds(a,k.index+1+t,a,k.index+1+k[0].length+t),k,u),r>=c))return r;while(k);return r}insert(i,n,o=!1){if(this.f=this.f&&o,this.j.lineNumber=0,this.j.value="",this.root!==I.$xB){const{node:a,remainder:t,nodeStartOffset:r}=this.G(i),h=a.piece,u=h.bufferIndex,c=this.s(a,t);if(a.piece.bufferIndex===0&&h.end.line===this.g.line&&h.end.column===this.g.column&&r+h.length===i&&n.length<b){this.F(a,n),this.y();return}if(r===i)this.o(n,a),this.h.validate(i);else if(r+a.piece.length>i){const l=[];let k=new m(h.bufferIndex,c,h.end,this.t(h.bufferIndex,c,h.end),this.u(u,h.end)-this.u(u,c));if(this.K()&&this.M(n)&&this.I(a,t)===10){const E={line:k.start.line+1,column:0};k=new m(k.bufferIndex,E,k.end,this.t(k.bufferIndex,E,k.end),k.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(a,t-1)===13){const E=this.s(a,t-1);this.C(a,E),n="\r"+n,a.piece.length===0&&l.push(a)}else this.C(a,c);else this.C(a,c);const R=this.w(n);k.length>0&&this.S(a,k);let w=a;for(let p=0;p<R.length;p++)w=this.S(w,R[p]);this.v(l)}else this.q(n,a)}else{const a=this.w(n);let t=this.T(null,a[0]);for(let r=1;r<a.length;r++)t=this.S(t,a[r])}this.y()}delete(i,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===I.$xB)return;const o=this.G(i),a=this.G(i+n),t=o.node,r=a.node;if(t===r){const R=this.s(t,o.remainder),w=this.s(t,a.remainder);if(o.nodeStartOffset===i){if(n===t.piece.length){const p=t.next();(0,I.$CB)(this,t),this.N(p),this.y();return}this.D(t,w),this.h.validate(i),this.N(t),this.y();return}if(o.nodeStartOffset+t.piece.length===i+n){this.C(t,R),this.O(t),this.y();return}this.E(t,R,w),this.y();return}const h=[],u=this.s(t,o.remainder);this.C(t,u),this.h.validate(i),t.piece.length===0&&h.push(t);const c=this.s(r,a.remainder);this.D(r,c),r.piece.length===0&&h.push(r);const l=t.next();for(let R=l;R!==I.$xB&&R!==r;R=R.next())h.push(R);const k=t.piece.length===0?t.prev():t;this.v(h),this.O(k),this.y()}o(i,n){const o=[];if(this.K()&&this.M(i)&&this.L(n)){const r=n.piece,h={line:r.start.line+1,column:0},u=new m(r.bufferIndex,h,r.end,this.t(r.bufferIndex,h,r.end),r.length-1);n.piece=u,i+=`
`,(0,I.$EB)(this,n,-1,-1),n.piece.length===0&&o.push(n)}const a=this.w(i);let t=this.T(n,a[a.length-1]);for(let r=a.length-2;r>=0;r--)t=this.T(t,a[r]);this.N(t),this.v(o)}q(i,n){this.Q(i,n)&&(i+=`
`);const o=this.w(i),a=this.S(n,o[0]);let t=a;for(let r=1;r<o.length;r++)t=this.S(t,o[r]);this.N(a)}s(i,n,o){const a=i.piece,t=i.piece.bufferIndex,r=this.a[t].lineStarts,u=r[a.start.line]+a.start.column+n;let c=a.start.line,l=a.end.line,k=0,R=0,w=0;for(;c<=l&&(k=c+(l-c)/2|0,w=r[k],k!==l);)if(R=r[k+1],u<w)l=k-1;else if(u>=R)c=k+1;else break;return o?(o.line=k,o.column=u-w,null):{line:k,column:u-w}}t(i,n,o){if(o.column===0)return o.line-n.line;const a=this.a[i].lineStarts;if(o.line===a.length-1)return o.line-n.line;const t=a[o.line+1],r=a[o.line]+o.column;if(t>r+1)return o.line-n.line;const h=r-1;return this.a[i].buffer.charCodeAt(h)===13?o.line-n.line+1:o.line-n.line}u(i,n){return this.a[i].lineStarts[n.line]+n.column}v(i){for(let n=0;n<i.length;n++)(0,I.$CB)(this,i[n])}w(i){if(i.length>b){const l=[];for(;i.length>b;){const R=i.charCodeAt(b-1);let w;R===13||R>=55296&&R<=56319?(w=i.substring(0,b-1),i=i.substring(b-1)):(w=i.substring(0,b),i=i.substring(b));const p=A(w);l.push(new m(this.a.length,{line:0,column:0},{line:p.length-1,column:w.length-p[p.length-1]},p.length-1,w.length)),this.a.push(new v(w,p))}const k=A(i);return l.push(new m(this.a.length,{line:0,column:0},{line:k.length-1,column:i.length-k[k.length-1]},k.length-1,i.length)),this.a.push(new v(i,k)),l}let n=this.a[0].buffer.length;const o=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let l=0;l<o.length;l++)o[l]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+="_"+i,n+=1}else{if(n!==0)for(let l=0;l<o.length;l++)o[l]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(o.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,h=t-this.a[0].lineStarts[r],u={line:r,column:h},c=new m(0,a,u,this.t(0,a,u),t-n);return this.g=u,[c]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,n=0){let o=this.root,a="";const t=this.h.get2(i);if(t){o=t.node;const r=this.B(o,i-t.nodeStartLineNumber-1),h=this.a[o.piece.bufferIndex].buffer,u=this.u(o.piece.bufferIndex,o.piece.start);if(t.nodeStartLineNumber+o.piece.lineFeedCnt===i)a=h.substring(u+r,u+o.piece.length);else{const c=this.B(o,i-t.nodeStartLineNumber);return h.substring(u+r,u+c-n)}}else{let r=0;const h=i;for(;o!==I.$xB;)if(o.left!==I.$xB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const u=this.B(o,i-o.lf_left-2),c=this.B(o,i-o.lf_left-1),l=this.a[o.piece.bufferIndex].buffer,k=this.u(o.piece.bufferIndex,o.piece.start);return r+=o.size_left,this.h.set({node:o,nodeStartOffset:r,nodeStartLineNumber:h-(i-1-o.lf_left)}),l.substring(k+u,k+c-n)}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const u=this.B(o,i-o.lf_left-2),c=this.a[o.piece.bufferIndex].buffer,l=this.u(o.piece.bufferIndex,o.piece.start);a=c.substring(l+u,l+o.piece.length);break}else i-=o.lf_left+o.piece.lineFeedCnt,r+=o.size_left+o.piece.length,o=o.right}for(o=o.next();o!==I.$xB;){const r=this.a[o.piece.bufferIndex].buffer;if(o.piece.lineFeedCnt>0){const h=this.B(o,0),u=this.u(o.piece.bufferIndex,o.piece.start);return a+=r.substring(u,u+h-n),a}else{const h=this.u(o.piece.bufferIndex,o.piece.start);a+=r.substr(h,o.piece.length)}o=o.next()}return a}y(){let i=this.root,n=1,o=0;for(;i!==I.$xB;)n+=i.lf_left+i.piece.lineFeedCnt,o+=i.size_left+i.piece.length,i=i.right;this.b=n,this.c=o,this.h.validate(this.c)}A(i,n){const o=i.piece,a=this.s(i,n),t=a.line-o.start.line;if(this.u(o.bufferIndex,o.end)-this.u(o.bufferIndex,o.start)===n){const r=this.t(i.piece.bufferIndex,o.start,a);if(r!==t)return{index:r,remainder:0}}return{index:t,remainder:a.column}}B(i,n){if(n<0)return 0;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,t=o.start.line+n+1;return t>o.end.line?a[o.end.line]+o.end.column-a[o.start.line]-o.start.column:a[t]-a[o.start.line]-o.start.column}C(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.end),r=n,h=this.u(o.bufferIndex,r),u=this.t(o.bufferIndex,o.start,r),c=u-a,l=h-t,k=o.length+l;i.piece=new m(o.bufferIndex,o.start,r,u,k),(0,I.$EB)(this,i,l,c)}D(i,n){const o=i.piece,a=o.lineFeedCnt,t=this.u(o.bufferIndex,o.start),r=n,h=this.t(o.bufferIndex,r,o.end),u=this.u(o.bufferIndex,r),c=h-a,l=t-u,k=o.length+l;i.piece=new m(o.bufferIndex,r,o.end,h,k),(0,I.$EB)(this,i,l,c)}E(i,n,o){const a=i.piece,t=a.start,r=a.end,h=a.length,u=a.lineFeedCnt,c=n,l=this.t(a.bufferIndex,a.start,c),k=this.u(a.bufferIndex,n)-this.u(a.bufferIndex,t);i.piece=new m(a.bufferIndex,a.start,c,l,k),(0,I.$EB)(this,i,k-h,l-u);const R=new m(a.bufferIndex,o,r,this.t(a.bufferIndex,o,r),this.u(a.bufferIndex,r)-this.u(a.bufferIndex,o)),w=this.S(i,R);this.N(w)}F(i,n){this.Q(n,i)&&(n+=`
`);const o=this.K()&&this.L(n)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=n;const t=A(n,!1);for(let w=0;w<t.length;w++)t[w]+=a;if(o){const w=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-w}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const r=this.a[0].lineStarts.length-1,h=this.a[0].buffer.length-this.a[0].lineStarts[r],u={line:r,column:h},c=i.piece.length+n.length,l=i.piece.lineFeedCnt,k=this.t(0,i.piece.start,u),R=k-l;i.piece=new m(i.piece.bufferIndex,i.piece.start,u,k,c),this.g=u,(0,I.$EB)(this,i,n.length,R)}G(i){let n=this.root;const o=this.h.get(i);if(o)return{node:o.node,nodeStartOffset:o.nodeStartOffset,remainder:i-o.nodeStartOffset};let a=0;for(;n!==I.$xB;)if(n.size_left>i)n=n.left;else if(n.size_left+n.piece.length>=i){a+=n.size_left;const t={node:n,remainder:i-n.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=n.size_left+n.piece.length,a+=n.size_left+n.piece.length,n=n.right;return null}H(i,n){let o=this.root,a=0;for(;o!==I.$xB;)if(o.left!==I.$xB&&o.lf_left>=i-1)o=o.left;else if(o.lf_left+o.piece.lineFeedCnt>i-1){const t=this.B(o,i-o.lf_left-2),r=this.B(o,i-o.lf_left-1);return a+=o.size_left,{node:o,remainder:Math.min(t+n-1,r),nodeStartOffset:a}}else if(o.lf_left+o.piece.lineFeedCnt===i-1){const t=this.B(o,i-o.lf_left-2);if(t+n-1<=o.piece.length)return{node:o,remainder:t+n-1,nodeStartOffset:a};n-=o.piece.length-t;break}else i-=o.lf_left+o.piece.lineFeedCnt,a+=o.size_left+o.piece.length,o=o.right;for(o=o.next();o!==I.$xB;){if(o.piece.lineFeedCnt>0){const t=this.B(o,0),r=this.J(o);return{node:o,remainder:Math.min(n-1,t),nodeStartOffset:r}}else if(o.piece.length>=n-1){const t=this.J(o);return{node:o,remainder:n-1,nodeStartOffset:t}}else n-=o.piece.length;o=o.next()}return null}I(i,n){if(i.piece.lineFeedCnt<1)return-1;const o=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+n;return o.buffer.charCodeAt(a)}J(i){if(!i)return 0;let n=i.size_left;for(;i!==this.root;)i.parent.right===i&&(n+=i.parent.size_left+i.parent.piece.length),i=i.parent;return n}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===I.$xB||i.piece.lineFeedCnt===0)return!1;const n=i.piece,o=this.a[n.bufferIndex].lineStarts,a=n.start.line,t=o[a]+n.start.column;return a===o.length-1||o[a+1]>t+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===I.$xB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const n=i.prev();this.M(n)&&this.P(n,i)}}O(i){if(this.K()&&this.M(i)){const n=i.next();this.L(n)&&this.P(i,n)}}P(i,n){const o=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const r=i.piece.length-1,h=i.piece.lineFeedCnt-1;i.piece=new m(i.piece.bufferIndex,i.piece.start,t,h,r),(0,I.$EB)(this,i,-1,-1),i.piece.length===0&&o.push(i);const u={line:n.piece.start.line+1,column:0},c=n.piece.length-1,l=this.t(n.piece.bufferIndex,u,n.piece.end);n.piece=new m(n.piece.bufferIndex,u,n.piece.end,l,c),(0,I.$EB)(this,n,-1,-1),n.piece.length===0&&o.push(n);const k=this.w(`\r
`);this.S(i,k[0]);for(let R=0;R<o.length;R++)(0,I.$CB)(this,o[R])}Q(i,n){if(this.K()&&this.M(i)){const o=n.next();if(this.L(o)){if(i+=`
`,o.piece.length===1)(0,I.$CB)(this,o);else{const a=o.piece,t={line:a.start.line+1,column:0},r=a.length-1,h=this.t(a.bufferIndex,t,a.end);o.piece=new m(a.bufferIndex,t,a.end,h,r),(0,I.$EB)(this,o,-1,-1)}return!0}}return!1}iterate(i,n){if(i===I.$xB)return n(I.$xB);const o=this.iterate(i.left,n);return o&&n(i)&&this.iterate(i.right,n)}R(i){if(i===I.$xB)return"";const n=this.a[i.piece.bufferIndex],o=i.piece,a=this.u(o.bufferIndex,o.start),t=this.u(o.bufferIndex,o.end);return n.buffer.substring(a,t)}getPieceContent(i){const n=this.a[i.bufferIndex],o=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return n.buffer.substring(o,a)}S(i,n){const o=new I.$wB(n,1);if(o.left=I.$xB,o.right=I.$xB,o.parent=I.$xB,o.size_left=0,o.lf_left=0,this.root===I.$xB)this.root=o,o.color=0;else if(i.right===I.$xB)i.right=o,o.parent=i;else{const t=(0,I.$yB)(i.right);t.left=o,o.parent=t}return(0,I.$DB)(this,o),o}T(i,n){const o=new I.$wB(n,1);if(o.left=I.$xB,o.right=I.$xB,o.parent=I.$xB,o.size_left=0,o.lf_left=0,this.root===I.$xB)this.root=o,o.color=0;else if(i.left===I.$xB)i.left=o,o.parent=i;else{const a=(0,I.$zB)(i.left);a.right=o,o.parent=a}return(0,I.$DB)(this,o),o}U(i){let n="";return this.iterate(i,o=>(n+=this.R(o),!0)),n}}e.$QB=d}),define(Ee[176],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37=e.$27=void 0;class D{constructor(){this.a=new Map}removeDragOperationTransfer(I){if(I&&this.a.has(I)){const L=this.a.get(I);return this.a.delete(I),L}}addDragOperationTransfer(I,L){this.a.set(I,L)}}e.$27=D;class N{constructor(I){this.identifier=I}}e.$37=N}),define(Ee[177],Se([1,0,4,3]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=void 0;class g{constructor(){this.a=new Map,this.b=new Map,this.c=new D.$Rd,this.onDidChange=this.c.event,this.d=null}handleChange(b){this.c.fire({changedLanguages:b,changedColorMap:!1})}register(b,$){return this.a.set(b,$),this.handleChange([b]),(0,N.$Pc)(()=>{this.a.get(b)===$&&(this.a.delete(b),this.handleChange([b]))})}get(b){return this.a.get(b)||null}registerFactory(b,$){this.b.get(b)?.dispose();const y=new I(this,b,$);return this.b.set(b,y),(0,N.$Pc)(()=>{const A=this.b.get(b);!A||A!==y||(this.b.delete(b),A.dispose())})}async getOrCreate(b){const $=this.get(b);if($)return $;const y=this.b.get(b);return!y||y.isResolved?null:(await y.resolve(),this.get(b))}isResolved(b){if(this.get(b))return!0;const y=this.b.get(b);return!!(!y||y.isResolved)}setColorMap(b){this.d=b,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$ct=g;class I extends N.$Rc{get isResolved(){return this.c}constructor(b,$,y){super(),this.f=b,this.g=$,this.h=y,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const b=await this.h.tokenizationSupport;this.c=!0,b&&!this.a&&this.B(this.f.register(this.g,b))}}}),define(Ee[178],Se([9,10]),function($e,e){return $e.create("vs/base/common/actions",e)}),define(Ee[179],Se([1,0,4,3,178]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class I extends N.$Rc{constructor(m,v="",S="",f=!0,d){super(),this.h=this.B(new D.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=m,this.m=v,this.u=S,this.w=f,this.C=d}get id(){return this.j}get label(){return this.m}set label(m){this.D(m)}D(m){this.m!==m&&(this.m=m,this.h.fire({label:m}))}get tooltip(){return this.n||""}set tooltip(m){this.F(m)}F(m){this.n!==m&&(this.n=m,this.h.fire({tooltip:m}))}get class(){return this.u}set class(m){this.G(m)}G(m){this.u!==m&&(this.u=m,this.h.fire({class:m}))}get enabled(){return this.w}set enabled(m){this.H(m)}H(m){this.w!==m&&(this.w=m,this.h.fire({enabled:m}))}get checked(){return this.z}set checked(m){this.I(m)}I(m){this.z!==m&&(this.z=m,this.h.fire({checked:m}))}async run(m,v){this.C&&await this.C(m)}}e.$Ei=I;class L extends N.$Rc{constructor(){super(...arguments),this.f=this.B(new D.$Rd),this.onWillRun=this.f.event,this.m=this.B(new D.$Rd),this.onDidRun=this.m.event}async run(m,v){if(!m.enabled)return;this.f.fire({action:m});let S;try{await this.u(m,v)}catch(f){S=f}this.m.fire({action:m,error:S})}async u(m,v){await m.run(v)}}e.$Fi=L;class b{constructor(){this.id=b.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...m){let v=[];for(const S of m)S.length&&(v.length?v=[...v,new b,...S]:v=S);return v}static{this.ID="vs.actions.separator"}async run(){}}e.$Gi=b;class ${get actions(){return this.a}constructor(m,v,S,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=m,this.label=v,this.class=f,this.a=S}async run(){}}e.$Hi=$;class y extends I{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,g.localize(0,null),void 0,!1)}}e.$Ii=y;function A(C){return{id:C.id,label:C.label,class:void 0,enabled:C.enabled??!0,checked:C.checked??!1,run:async(...m)=>C.run(...m),tooltip:C.label}}e.$Ji=A}),define(Ee[180],Se([9,10]),function($e,e){return $e.create("vs/base/common/date",e)}),define(Ee[181],Se([1,0,180]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0;const N=60,g=N*60,I=g*24,L=I*7,b=I*30,$=I*365;function y(C,m,v,S){typeof C!="number"&&(C=C.getTime());const f=Math.round((new Date().getTime()-C)/1e3);if(f<-30)return(0,D.localize)(0,null,y(new Date().getTime()+f*1e3,!1));if(!S&&f<30)return(0,D.localize)(1,null);let d;return f<N?(d=f,m?d===1?v?(0,D.localize)(2,null,d):(0,D.localize)(3,null,d):v?(0,D.localize)(4,null,d):(0,D.localize)(5,null,d):d===1?v?(0,D.localize)(6,null,d):(0,D.localize)(7,null,d):v?(0,D.localize)(8,null,d):(0,D.localize)(9,null,d)):f<g?(d=Math.floor(f/N),m?d===1?v?(0,D.localize)(10,null,d):(0,D.localize)(11,null,d):v?(0,D.localize)(12,null,d):(0,D.localize)(13,null,d):d===1?v?(0,D.localize)(14,null,d):(0,D.localize)(15,null,d):v?(0,D.localize)(16,null,d):(0,D.localize)(17,null,d)):f<I?(d=Math.floor(f/g),m?d===1?v?(0,D.localize)(18,null,d):(0,D.localize)(19,null,d):v?(0,D.localize)(20,null,d):(0,D.localize)(21,null,d):d===1?v?(0,D.localize)(22,null,d):(0,D.localize)(23,null,d):v?(0,D.localize)(24,null,d):(0,D.localize)(25,null,d)):f<L?(d=Math.floor(f/I),m?d===1?(0,D.localize)(26,null,d):(0,D.localize)(27,null,d):d===1?(0,D.localize)(28,null,d):(0,D.localize)(29,null,d)):f<b?(d=Math.floor(f/L),m?d===1?v?(0,D.localize)(30,null,d):(0,D.localize)(31,null,d):v?(0,D.localize)(32,null,d):(0,D.localize)(33,null,d):d===1?v?(0,D.localize)(34,null,d):(0,D.localize)(35,null,d):v?(0,D.localize)(36,null,d):(0,D.localize)(37,null,d)):f<$?(d=Math.floor(f/b),m?d===1?v?(0,D.localize)(38,null,d):(0,D.localize)(39,null,d):v?(0,D.localize)(40,null,d):(0,D.localize)(41,null,d):d===1?v?(0,D.localize)(42,null,d):(0,D.localize)(43,null,d):v?(0,D.localize)(44,null,d):(0,D.localize)(45,null,d)):(d=Math.floor(f/$),m?d===1?v?(0,D.localize)(46,null,d):(0,D.localize)(47,null,d):v?(0,D.localize)(48,null,d):(0,D.localize)(49,null,d):d===1?v?(0,D.localize)(50,null,d):(0,D.localize)(51,null,d):v?(0,D.localize)(52,null,d):(0,D.localize)(53,null,d))}e.$nm=y;function A(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$om=A}),define(Ee[182],Se([9,10]),function($e,e){return $e.create("vs/base/common/errorMessage",e)}),define(Ee[44],Se([1,0,19,18,182]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=void 0;function I(C,m){return m&&(C.stack||C.stacktrace)?g.localize(0,null,b(C),L(C.stack)||L(C.stacktrace)):b(C)}function L(C){return Array.isArray(C)?C.join(`
`):C}function b(C){return C.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${C.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function $(C=null,m=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const v=D.$Gb(C),S=$(v[0],m);return v.length>1?g.localize(4,null,S,v.length):S}if(N.$Cf(C))return C;if(C.detail){const v=C.detail;if(v.error)return I(v.error,m);if(v.exception)return I(v.exception,m)}return C.stack?I(C,m):C.message?C.message:g.localize(5,null)}e.$Ki=$;function y(C){const m=C;return m instanceof Error&&Array.isArray(m.actions)}e.$Li=y;function A(C,m){let v;return typeof C=="string"?v=new Error(C):v=C,v.actions=m,v}e.$Mi=A}),define(Ee[183],Se([9,10]),function($e,e){return $e.create("vs/base/common/platform",e)}),define(Ee[11],Se([1,0,183]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,g=!1,I=!1,L=!1,b=!1,$=!1,y=!1,A=!1,C=!1,m=!1,v,S=e.$g,f=e.$g,d,s;const i=globalThis;let n;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?n=i.vscode.process:typeof process<"u"&&(n=process);const o=typeof n?.versions?.electron=="string",a=o&&n?.type==="renderer";if(typeof navigator=="object"&&!a)s=navigator.userAgent,N=s.indexOf("Windows")>=0,g=s.indexOf("Macintosh")>=0,A=(s.indexOf("Macintosh")>=0||s.indexOf("iPad")>=0||s.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=s.indexOf("Linux")>=0,m=s?.indexOf("Mobi")>=0,$=!0,v=D.getConfiguredDefaultLocale(D.localize(0,null))||e.$g,S=v,f=navigator.language;else if(typeof n=="object"){N=n.platform==="win32",g=n.platform==="darwin",I=n.platform==="linux",L=I&&!!n.env.SNAP&&!!n.env.SNAP_REVISION,y=o,C=!!n.env.CI||!!n.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.$g,S=e.$g;const w=n.env.VSCODE_NLS_CONFIG;if(w)try{const p=JSON.parse(w),E=p.availableLanguages["*"];v=p.locale,f=p.osLocale,S=E||e.$g,d=p._translationsConfigFile}catch{}b=!0}else console.error("Unable to resolve platform.");var t;(function(w){w[w.Web=0]="Web",w[w.Mac=1]="Mac",w[w.Linux=2]="Linux",w[w.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(w){switch(w){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=r;let h=0;g?h=1:N?h=3:I&&(h=2),e.$i=N,e.$j=g,e.$k=I,e.$l=L,e.$m=b,e.$n=y,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=m,e.$t=C,e.$u=h,e.$v=s,e.$w=S;var u;(function(w){function p(){return e.$w}w.value=p;function E(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}w.isDefaultVariant=E;function P(){return e.$w==="en"}w.isDefault=P})(u||(e.Language=u={})),e.$x=v,e.$y=f,e.$z=d,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const w=[];i.addEventListener("message",E=>{if(E.data&&E.data.vscodeScheduleAsyncWork)for(let P=0,z=w.length;P<z;P++){const j=w[P];if(j.id===E.data.vscodeScheduleAsyncWork){w.splice(P,1),j.callback();return}}});let p=0;return E=>{const P=++p;w.push({id:P,callback:E}),i.postMessage({vscodeScheduleAsyncWork:P},"*")}}return w=>setTimeout(w)})();var c;(function(w){w[w.Windows=1]="Windows",w[w.Macintosh=2]="Macintosh",w[w.Linux=3]="Linux"})(c||(e.OperatingSystem=c={})),e.OS=g||A?2:N?1:3;let l=!0,k=!1;function R(){if(!k){k=!0;const w=new Uint8Array(2);w[0]=1,w[1]=2,l=new Uint16Array(w.buffer)[0]===(2<<8)+1}return l}e.$D=R,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0)}),define(Ee[50],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dc=e.$cc=e.env=e.cwd=void 0;let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.process<"u"){const I=g.process;N={get platform(){return I.platform},get arch(){return I.arch},get env(){return I.env},cwd(){return I.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return D.$i?"win32":D.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$cc=N.platform,e.$dc=N.arch}),define(Ee[16],Se([1,0,50]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sc=e.sep=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=e.$ec=void 0;const N=65,g=97,I=90,L=122,b=46,$=47,y=92,A=58,C=63;class m extends Error{constructor(r,h,u){let c;typeof h=="string"&&h.indexOf("not ")===0?(c="must not be",h=h.replace(/^not /,"")):c="must be";const l=r.indexOf(".")!==-1?"property":"argument";let k=`The "${r}" ${l} ${c} of type ${h}`;k+=`. Received type ${typeof u}`,super(k),this.code="ERR_INVALID_ARG_TYPE"}}function v(t,r){if(t===null||typeof t!="object")throw new m(r,"Object",t)}function S(t,r){if(typeof t!="string")throw new m(r,"string",t)}const f=D.$cc==="win32";function d(t){return t===$||t===y}function s(t){return t===$}function i(t){return t>=N&&t<=I||t>=g&&t<=L}function n(t,r,h,u){let c="",l=0,k=-1,R=0,w=0;for(let p=0;p<=t.length;++p){if(p<t.length)w=t.charCodeAt(p);else{if(u(w))break;w=$}if(u(w)){if(!(k===p-1||R===1))if(R===2){if(c.length<2||l!==2||c.charCodeAt(c.length-1)!==b||c.charCodeAt(c.length-2)!==b){if(c.length>2){const E=c.lastIndexOf(h);E===-1?(c="",l=0):(c=c.slice(0,E),l=c.length-1-c.lastIndexOf(h)),k=p,R=0;continue}else if(c.length!==0){c="",l=0,k=p,R=0;continue}}r&&(c+=c.length>0?`${h}..`:"..",l=2)}else c.length>0?c+=`${h}${t.slice(k+1,p)}`:c=t.slice(k+1,p),l=p-k-1;k=p,R=0}else w===b&&R!==-1?++R:R=-1}return c}function o(t,r){v(r,"pathObject");const h=r.dir||r.root,u=r.base||`${r.name||""}${r.ext||""}`;return h?h===r.root?`${h}${u}`:`${h}${t}${u}`:u}e.$ec={resolve(...t){let r="",h="",u=!1;for(let c=t.length-1;c>=-1;c--){let l;if(c>=0){if(l=t[c],S(l,"path"),l.length===0)continue}else r.length===0?l=D.cwd():(l=D.env[`=${r}`]||D.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==r.toLowerCase()&&l.charCodeAt(2)===y)&&(l=`${r}\\`));const k=l.length;let R=0,w="",p=!1;const E=l.charCodeAt(0);if(k===1)d(E)&&(R=1,p=!0);else if(d(E))if(p=!0,d(l.charCodeAt(1))){let P=2,z=P;for(;P<k&&!d(l.charCodeAt(P));)P++;if(P<k&&P!==z){const j=l.slice(z,P);for(z=P;P<k&&d(l.charCodeAt(P));)P++;if(P<k&&P!==z){for(z=P;P<k&&!d(l.charCodeAt(P));)P++;(P===k||P!==z)&&(w=`\\\\${j}\\${l.slice(z,P)}`,R=P)}}}else R=1;else i(E)&&l.charCodeAt(1)===A&&(w=l.slice(0,2),R=2,k>2&&d(l.charCodeAt(2))&&(p=!0,R=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(u){if(r.length>0)break}else if(h=`${l.slice(R)}\\${h}`,u=p,p&&r.length>0)break}return h=n(h,!u,"\\",d),u?`${r}\\${h}`:`${r}${h}`||"."},normalize(t){S(t,"path");const r=t.length;if(r===0)return".";let h=0,u,c=!1;const l=t.charCodeAt(0);if(r===1)return s(l)?"\\":t;if(d(l))if(c=!0,d(t.charCodeAt(1))){let R=2,w=R;for(;R<r&&!d(t.charCodeAt(R));)R++;if(R<r&&R!==w){const p=t.slice(w,R);for(w=R;R<r&&d(t.charCodeAt(R));)R++;if(R<r&&R!==w){for(w=R;R<r&&!d(t.charCodeAt(R));)R++;if(R===r)return`\\\\${p}\\${t.slice(w)}\\`;R!==w&&(u=`\\\\${p}\\${t.slice(w,R)}`,h=R)}}}else h=1;else i(l)&&t.charCodeAt(1)===A&&(u=t.slice(0,2),h=2,r>2&&d(t.charCodeAt(2))&&(c=!0,h=3));let k=h<r?n(t.slice(h),!c,"\\",d):"";return k.length===0&&!c&&(k="."),k.length>0&&d(t.charCodeAt(r-1))&&(k+="\\"),u===void 0?c?`\\${k}`:k:c?`${u}\\${k}`:`${u}${k}`},isAbsolute(t){S(t,"path");const r=t.length;if(r===0)return!1;const h=t.charCodeAt(0);return d(h)||r>2&&i(h)&&t.charCodeAt(1)===A&&d(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,h;for(let l=0;l<t.length;++l){const k=t[l];S(k,"path"),k.length>0&&(r===void 0?r=h=k:r+=`\\${k}`)}if(r===void 0)return".";let u=!0,c=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++c;const l=h.length;l>1&&d(h.charCodeAt(1))&&(++c,l>2&&(d(h.charCodeAt(2))?++c:u=!1))}if(u){for(;c<r.length&&d(r.charCodeAt(c));)c++;c>=2&&(r=`\\${r.slice(c)}`)}return e.$ec.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r)return"";const h=e.$ec.resolve(t),u=e.$ec.resolve(r);if(h===u||(t=h.toLowerCase(),r=u.toLowerCase(),t===r))return"";let c=0;for(;c<t.length&&t.charCodeAt(c)===y;)c++;let l=t.length;for(;l-1>c&&t.charCodeAt(l-1)===y;)l--;const k=l-c;let R=0;for(;R<r.length&&r.charCodeAt(R)===y;)R++;let w=r.length;for(;w-1>R&&r.charCodeAt(w-1)===y;)w--;const p=w-R,E=k<p?k:p;let P=-1,z=0;for(;z<E;z++){const F=t.charCodeAt(c+z);if(F!==r.charCodeAt(R+z))break;F===y&&(P=z)}if(z!==E){if(P===-1)return u}else{if(p>E){if(r.charCodeAt(R+z)===y)return u.slice(R+z+1);if(z===2)return u.slice(R+z)}k>E&&(t.charCodeAt(c+z)===y?P=z:z===2&&(P=3)),P===-1&&(P=0)}let j="";for(z=c+P+1;z<=l;++z)(z===l||t.charCodeAt(z)===y)&&(j+=j.length===0?"..":"\\..");return R+=P,j.length>0?`${j}${u.slice(R,w)}`:(u.charCodeAt(R)===y&&++R,u.slice(R,w))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$ec.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===y){if(r.charCodeAt(1)===y){const h=r.charCodeAt(2);if(h!==C&&h!==b)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(i(r.charCodeAt(0))&&r.charCodeAt(1)===A&&r.charCodeAt(2)===y)return`\\\\?\\${r}`;return t},dirname(t){S(t,"path");const r=t.length;if(r===0)return".";let h=-1,u=0;const c=t.charCodeAt(0);if(r===1)return d(c)?t:".";if(d(c)){if(h=u=1,d(t.charCodeAt(1))){let R=2,w=R;for(;R<r&&!d(t.charCodeAt(R));)R++;if(R<r&&R!==w){for(w=R;R<r&&d(t.charCodeAt(R));)R++;if(R<r&&R!==w){for(w=R;R<r&&!d(t.charCodeAt(R));)R++;if(R===r)return t;R!==w&&(h=u=R+1)}}}}else i(c)&&t.charCodeAt(1)===A&&(h=r>2&&d(t.charCodeAt(2))?3:2,u=h);let l=-1,k=!0;for(let R=r-1;R>=u;--R)if(d(t.charCodeAt(R))){if(!k){l=R;break}}else k=!1;if(l===-1){if(h===-1)return".";l=h}return t.slice(0,l)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let h=0,u=-1,c=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(h=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,R=-1;for(l=t.length-1;l>=h;--l){const w=t.charCodeAt(l);if(d(w)){if(!c){h=l+1;break}}else R===-1&&(c=!1,R=l+1),k>=0&&(w===r.charCodeAt(k)?--k===-1&&(u=l):(k=-1,u=R))}return h===u?u=R:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=h;--l)if(d(t.charCodeAt(l))){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){S(t,"path");let r=0,h=-1,u=0,c=-1,l=!0,k=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(r=u=2);for(let R=t.length-1;R>=r;--R){const w=t.charCodeAt(R);if(d(w)){if(!l){u=R+1;break}continue}c===-1&&(l=!1,c=R+1),w===b?h===-1?h=R:k!==1&&(k=1):h!==-1&&(k=-1)}return h===-1||c===-1||k===0||k===1&&h===c-1&&h===u+1?"":t.slice(h,c)},format:o.bind(null,"\\"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.length;let u=0,c=t.charCodeAt(0);if(h===1)return d(c)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(d(c)){if(u=1,d(t.charCodeAt(1))){let P=2,z=P;for(;P<h&&!d(t.charCodeAt(P));)P++;if(P<h&&P!==z){for(z=P;P<h&&d(t.charCodeAt(P));)P++;if(P<h&&P!==z){for(z=P;P<h&&!d(t.charCodeAt(P));)P++;P===h?u=P:P!==z&&(u=P+1)}}}}else if(i(c)&&t.charCodeAt(1)===A){if(h<=2)return r.root=r.dir=t,r;if(u=2,d(t.charCodeAt(2))){if(h===3)return r.root=r.dir=t,r;u=3}}u>0&&(r.root=t.slice(0,u));let l=-1,k=u,R=-1,w=!0,p=t.length-1,E=0;for(;p>=u;--p){if(c=t.charCodeAt(p),d(c)){if(!w){k=p+1;break}continue}R===-1&&(w=!1,R=p+1),c===b?l===-1?l=p:E!==1&&(E=1):l!==-1&&(E=-1)}return R!==-1&&(l===-1||E===0||E===1&&l===R-1&&l===k+1?r.base=r.name=t.slice(k,R):(r.name=t.slice(k,l),r.base=t.slice(k,R),r.ext=t.slice(l,R))),k>0&&k!==u?r.dir=t.slice(0,k-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(f){const t=/\\/g;return()=>{const r=D.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>D.cwd()})();e.$fc={resolve(...t){let r="",h=!1;for(let u=t.length-1;u>=-1&&!h;u--){const c=u>=0?t[u]:a();S(c,"path"),c.length!==0&&(r=`${c}/${r}`,h=c.charCodeAt(0)===$)}return r=n(r,!h,"/",s),h?`/${r}`:r.length>0?r:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$,h=t.charCodeAt(t.length-1)===$;return t=n(t,!r,"/",s),t.length===0?r?"/":h?"./":".":(h&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let r;for(let h=0;h<t.length;++h){const u=t[h];S(u,"path"),u.length>0&&(r===void 0?r=u:r+=`/${u}`)}return r===void 0?".":e.$fc.normalize(r)},relative(t,r){if(S(t,"from"),S(r,"to"),t===r||(t=e.$fc.resolve(t),r=e.$fc.resolve(r),t===r))return"";const h=1,u=t.length,c=u-h,l=1,k=r.length-l,R=c<k?c:k;let w=-1,p=0;for(;p<R;p++){const P=t.charCodeAt(h+p);if(P!==r.charCodeAt(l+p))break;P===$&&(w=p)}if(p===R)if(k>R){if(r.charCodeAt(l+p)===$)return r.slice(l+p+1);if(p===0)return r.slice(l+p)}else c>R&&(t.charCodeAt(h+p)===$?w=p:p===0&&(w=0));let E="";for(p=h+w+1;p<=u;++p)(p===u||t.charCodeAt(p)===$)&&(E+=E.length===0?"..":"/..");return`${E}${r.slice(l+w)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===$;let h=-1,u=!0;for(let c=t.length-1;c>=1;--c)if(t.charCodeAt(c)===$){if(!u){h=c;break}}else u=!1;return h===-1?r?"/":".":r&&h===1?"//":t.slice(0,h)},basename(t,r){r!==void 0&&S(r,"ext"),S(t,"path");let h=0,u=-1,c=!0,l;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let k=r.length-1,R=-1;for(l=t.length-1;l>=0;--l){const w=t.charCodeAt(l);if(w===$){if(!c){h=l+1;break}}else R===-1&&(c=!1,R=l+1),k>=0&&(w===r.charCodeAt(k)?--k===-1&&(u=l):(k=-1,u=R))}return h===u?u=R:u===-1&&(u=t.length),t.slice(h,u)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===$){if(!c){h=l+1;break}}else u===-1&&(c=!1,u=l+1);return u===-1?"":t.slice(h,u)},extname(t){S(t,"path");let r=-1,h=0,u=-1,c=!0,l=0;for(let k=t.length-1;k>=0;--k){const R=t.charCodeAt(k);if(R===$){if(!c){h=k+1;break}continue}u===-1&&(c=!1,u=k+1),R===b?r===-1?r=k:l!==1&&(l=1):r!==-1&&(l=-1)}return r===-1||u===-1||l===0||l===1&&r===u-1&&r===h+1?"":t.slice(r,u)},format:o.bind(null,"/"),parse(t){S(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const h=t.charCodeAt(0)===$;let u;h?(r.root="/",u=1):u=0;let c=-1,l=0,k=-1,R=!0,w=t.length-1,p=0;for(;w>=u;--w){const E=t.charCodeAt(w);if(E===$){if(!R){l=w+1;break}continue}k===-1&&(R=!1,k=w+1),E===b?c===-1?c=w:p!==1&&(p=1):c!==-1&&(p=-1)}if(k!==-1){const E=l===0&&h?1:l;c===-1||p===0||p===1&&c===k-1&&c===l+1?r.base=r.name=t.slice(E,k):(r.name=t.slice(E,c),r.base=t.slice(E,k),r.ext=t.slice(c,k))}return l>0?r.dir=t.slice(0,l-1):h&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$fc.win32=e.$ec.win32=e.$ec,e.$fc.posix=e.$ec.posix=e.$fc,e.$gc=f?e.$ec.normalize:e.$fc.normalize,e.$hc=f?e.$ec.isAbsolute:e.$fc.isAbsolute,e.$ic=f?e.$ec.join:e.$fc.join,e.$jc=f?e.$ec.resolve:e.$fc.resolve,e.$kc=f?e.$ec.relative:e.$fc.relative,e.$lc=f?e.$ec.dirname:e.$fc.dirname,e.$mc=f?e.$ec.basename:e.$fc.basename,e.$nc=f?e.$ec.extname:e.$fc.extname,e.$oc=f?e.$ec.format:e.$fc.format,e.$pc=f?e.$ec.parse:e.$fc.parse,e.$qc=f?e.$ec.toNamespacedPath:e.$fc.toNamespacedPath,e.sep=f?e.$ec.sep:e.$fc.sep,e.$sc=f?e.$ec.delimiter:e.$fc.delimiter}),define(Ee[128],Se([1,0,43,16]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;const g=new D.$U(()=>{const R=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:R,collatorIsNumeric:R.resolvedOptions().numeric}}),I=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new D.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function b(R,w,p=!1){const E=R||"",P=w||"",z=g.value.collator.compare(E,P);return g.value.collatorIsNumeric&&z===0&&E!==P?E<P?-1:1:z}e.$rq=b;function $(R,w){const p=I.value.collator;return R=R||"",w=w||"",o(p,R,w)}e.$sq=$;function y(R,w){const p=I.value.collator;return R=R||"",w=w||"",h(R,w)||o(p,R,w)}e.$tq=y;function A(R,w){const p=I.value.collator;return R=R||"",w=w||"",r(R,w)||o(p,R,w)}e.$uq=A;function C(R,w){return R=R||"",w=w||"",R===w?0:R<w?-1:1}e.$vq=C;function m(R,w){const[p,E]=i(R),[P,z]=i(w);let j=g.value.collator.compare(E,z);if(j===0){if(g.value.collatorIsNumeric&&E!==z)return E<z?-1:1;if(j=g.value.collator.compare(p,P),g.value.collatorIsNumeric&&j===0&&p!==P)return p<P?-1:1}return j}e.$wq=m;function v(R,w){R=R||"",w=w||"";const p=n(R),E=n(w),P=I.value.collator,z=L.value.collator;return o(z,p,E)||o(P,R,w)}e.$xq=v;function S(R,w){R=R||"",w=w||"";const p=n(R),E=n(w),P=I.value.collator,z=L.value.collator;return o(z,p,E)||h(R,w)||o(P,R,w)}e.$yq=S;function f(R,w){R=R||"",w=w||"";const p=n(R),E=n(w),P=I.value.collator,z=L.value.collator;return o(z,p,E)||r(R,w)||o(P,R,w)}e.$zq=f;function d(R,w){R=R||"",w=w||"";const p=n(R).toLowerCase(),E=n(w).toLowerCase();return p!==E?p<E?-1:1:R!==w?R<w?-1:1:0}e.$Aq=d;const s=/^(.*?)(\.([^.]*))?$/;function i(R,w=!1){const p=R?s.exec(R):[];let E=[p&&p[1]||"",p&&p[3]||""];return w&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function n(R){const w=R?s.exec(R):[];return w&&w[1]&&w[1].charAt(0)!=="."&&w[3]||""}function o(R,w,p){const E=R.compare(w,p);return E!==0?E:w.length!==p.length?w.length<p.length?-1:1:0}function a(R){const w=R.charAt(0);return w.toLocaleUpperCase()!==w}function t(R){const w=R.charAt(0);return w.toLocaleLowerCase()!==w}function r(R,w){return a(R)&&t(w)?-1:t(R)&&a(w)?1:0}function h(R,w){return t(R)&&a(w)?-1:a(R)&&t(w)?1:0}function u(R,w,p=!1){return p||(R=R&&R.toLowerCase(),w=w&&w.toLowerCase()),R===w?0:R<w?-1:1}function c(R,w,p=!1){const E=R.split(N.sep),P=w.split(N.sep),z=E.length-1,j=P.length-1;let F,O;for(let T=0;;T++){if(F=z===T,O=j===T,F&&O)return b(E[T],P[T],p);if(F)return-1;if(O)return 1;const M=u(E[T],P[T],p);if(M!==0)return M}}e.$Bq=c;function l(R,w,p){const E=R.toLowerCase(),P=w.toLowerCase(),z=k(R,w,p);if(z)return z;const j=E.endsWith(p),F=P.endsWith(p);if(j!==F)return j?-1:1;const O=b(E,P);return O!==0?O:E.localeCompare(P)}e.$Cq=l;function k(R,w,p){const E=R.toLowerCase(),P=w.toLowerCase(),z=E.startsWith(p),j=P.startsWith(p);if(z!==j)return z?-1:1;if(z&&j){if(E.length<P.length)return-1;if(E.length>P.length)return 1}return 0}e.$Dq=k}),define(Ee[33],Se([1,0,16,11,13,18]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function L(l){return l===47||l===92}e.$Uf=L;function b(l){return l.replace(/[\\/]/g,D.$fc.sep)}e.$Vf=b;function $(l){return l.indexOf("/")===-1&&(l=b(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$Wf=$;function y(l,k=D.$fc.sep){if(!l)return"";const R=l.length,w=l.charCodeAt(0);if(L(w)){if(L(l.charCodeAt(1))&&!L(l.charCodeAt(2))){let E=3;const P=E;for(;E<R&&!L(l.charCodeAt(E));E++);if(P!==E&&!L(l.charCodeAt(E+1))){for(E+=1;E<R;E++)if(L(l.charCodeAt(E)))return l.slice(0,E+1).replace(/[\\/]/g,k)}}return k}else if(s(w)&&l.charCodeAt(1)===58)return L(l.charCodeAt(2))?l.slice(0,2)+k:l.slice(0,2);let p=l.indexOf("://");if(p!==-1){for(p+=3;p<R;p++)if(L(l.charCodeAt(p)))return l.slice(0,p+1)}return""}e.$Xf=y;function A(l){if(!N.$i||!l||l.length<5)return!1;let k=l.charCodeAt(0);if(k!==92||(k=l.charCodeAt(1),k!==92))return!1;let R=2;const w=R;for(;R<l.length&&(k=l.charCodeAt(R),k!==92);R++);return!(w===R||(k=l.charCodeAt(R+1),isNaN(k)||k===92))}e.$Yf=A;const C=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,v=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,k=N.$i){const R=k?C:m;return!(!l||l.length===0||/^\s+$/.test(l)||(R.lastIndex=0,R.test(l))||k&&v.test(l)||l==="."||l===".."||k&&l[l.length-1]==="."||k&&l.length!==l.trim().length||l.length>255)}e.$Zf=S;function f(l,k,R){const w=l===k;return!R||w?w:!l||!k?!1:(0,g.$6e)(l,k)}e.$1f=f;function d(l,k,R,w=D.sep){if(l===k)return!0;if(!l||!k||k.length>l.length)return!1;if(R){if(!(0,g.$7e)(l,k))return!1;if(k.length===l.length)return!0;let E=k.length;return k.charAt(k.length-1)===w&&E--,l.charAt(E)===w}return k.charAt(k.length-1)!==w&&(k+=w),l.indexOf(k)===0}e.$2f=d;function s(l){return l>=65&&l<=90||l>=97&&l<=122}e.$3f=s;function i(l,k){return N.$i&&l.endsWith(":")&&(l+=D.sep),(0,D.$hc)(l)||(l=(0,D.$ic)(k,l)),l=(0,D.$gc)(l),N.$i?(l=(0,g.$Oe)(l,D.sep),l.endsWith(":")&&(l+=D.sep)):(l=(0,g.$Oe)(l,D.sep),l||(l=D.sep)),l}e.$4f=i;function n(l){const k=(0,D.$gc)(l);return N.$i?l.length>3?!1:o(k)&&(l.length===2||k.charCodeAt(2)===92):k===D.$fc.sep}e.$5f=n;function o(l,k=N.$i){return k?s(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$6f=o;function a(l,k=N.$i){return o(l,k)?l[0]:void 0}e.$7f=a;function t(l,k,R){return k.length>l.length?-1:l===k?0:(R&&(l=l.toLowerCase(),k=k.toLowerCase()),l.indexOf(k))}e.$8f=t;function r(l){const k=l.split(":");let R,w,p;for(const E of k){const P=Number(E);(0,I.$Gf)(P)?w===void 0?w=P:p===void 0&&(p=P):R=R?[R,E].join(":"):E}if(!R)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:R,line:w!==void 0?w:void 0,column:p!==void 0?p:w!==void 0?1:void 0}}e.$9f=r;const h="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",u="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function c(l,k,R=8){let w="";for(let E=0;E<R;E++){let P;E===0&&N.$i&&!k&&(R===3||R===4)?P=u:P=h,w+=P.charAt(Math.floor(Math.random()*P.length))}let p;return k?p=`${k}-${w}`:p=w,l?(0,D.$ic)(l,p):p}e.$0f=c}),define(Ee[129],Se([1,0,128,123,53,16,11,13]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jq=e.$Iq=e.$Hq=e.$Gq=e.$Fq=e.$Eq=void 0;const $=0,y=[$,[]];function A(W,Y,ue,Z){if(!W||!Y)return y;const Q=W.length,x=Y.length;if(Q<x)return y;const oe=W.toLowerCase();return C(Y,ue,x,W,oe,Q,Z)}e.$Eq=A;function C(W,Y,ue,Z,Q,x,oe){const X=[],ve=[];for(let ne=0;ne<ue;ne++){const ye=ne*x,fe=ye-x,me=ne>0,ee=W[ne],ie=Y[ne];for(let G=0;G<x;G++){const te=G>0,J=ye+G,ce=J-1,be=fe+G-1,Ie=te?X[ce]:0,Me=me&&te?X[be]:0,B=me&&te?ve[be]:0;let _;!Me&&me?_=0:_=m(ee,ie,Z,Q,G,B),_&&Me+_>=Ie&&(oe||me||Q.startsWith(Y,G))?(ve[J]=B+1,X[J]=Me+_):(ve[J]=$,X[J]=Ie)}}const ge=[];let V=ue-1,U=x-1;for(;V>=0&&U>=0;){const ne=V*x+U;ve[ne]===$||(ge.push(U),V--),U--}return[X[ue*x-1],ge.reverse()]}function m(W,Y,ue,Z,Q,x){let oe=0;if(!v(Y,Z[Q]))return oe;if(oe+=1,x>0&&(oe+=x*5),W===ue[Q]&&(oe+=1),Q===0)oe+=8;else{const X=S(ue.charCodeAt(Q-1));X?oe+=X:(0,N.$Qj)(ue.charCodeAt(Q))&&x===0&&(oe+=2)}return oe}function v(W,Y){return W===Y?!0:W==="/"||W==="\\"?Y==="/"||Y==="\\":!1}function S(W){switch(W){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function d(W,Y,ue=0,Z=0){const Q=Y;return Q.values&&Q.values.length>1?s(W,Q.values,ue,Z):i(W,Y,ue,Z)}e.$Fq=d;function s(W,Y,ue,Z){let Q=0;const x=[];for(const oe of Y){const[X,ve]=i(W,oe,ue,Z);if(typeof X!="number")return f;Q+=X,x.push(...ve)}return[Q,R(x)]}function i(W,Y,ue,Z){const Q=(0,N.$Zj)(Y.original,Y.originalLowercase,ue,W,W.toLowerCase(),Z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,N.$Wj)(Q)]:f}const n=Object.freeze({score:0}),o=1<<18,a=1<<17,t=1<<16;function r(W,Y,ue,Z){const Q=Z.values?Z.values:[Z];return(0,g.$Ni)({[Z.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:W,description:Y,allowNonContiguousMatches:ue}})}function h(W,Y,ue,Z,Q){if(!W||!Y.normalized)return n;const x=Z.getItemLabel(W);if(!x)return n;const oe=Z.getItemDescription(W),X=r(x,oe,ue,Y),ve=Q[X];if(ve)return ve;const ge=u(x,oe,Z.getItemPath(W),Y,ue);return Q[X]=ge,ge}e.$Gq=h;function u(W,Y,ue,Z,Q){const x=!ue||!Z.containsPathSeparator;return ue&&(L.$k?Z.pathNormalized===ue:(0,b.$6e)(Z.pathNormalized,ue))?{score:o,labelMatch:[{start:0,end:W.length}],descriptionMatch:Y?[{start:0,end:Y.length}]:void 0}:Z.values&&Z.values.length>1?c(W,Y,ue,Z.values,x,Q):l(W,Y,ue,Z,x,Q)}function c(W,Y,ue,Z,Q,x){let oe=0;const X=[],ve=[];for(const ge of Z){const{score:V,labelMatch:U,descriptionMatch:ne}=l(W,Y,ue,ge,Q,x);if(V===$)return n;oe+=V,U&&X.push(...U),ne&&ve.push(...ne)}return{score:oe,labelMatch:R(X),descriptionMatch:R(ve)}}function l(W,Y,ue,Z,Q,x){if(Q||!Y){const[oe,X]=A(W,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(oe){const ve=(0,N.$Nj)(Z.normalized,W);let ge;if(ve){ge=a;const V=Math.round(Z.normalized.length/W.length*100);ge+=V}else ge=t;return{score:ge+oe,labelMatch:ve||k(X)}}}if(Y){let oe=Y;ue&&(oe=`${Y}${I.sep}`);const X=oe.length,ve=`${oe}${W}`,[ge,V]=A(ve,Z.normalized,Z.normalizedLowercase,x&&!Z.expectContiguousMatch);if(ge){const U=k(V),ne=[],ye=[];return U.forEach(fe=>{fe.start<X&&fe.end>X?(ne.push({start:0,end:fe.end-X}),ye.push({start:fe.start,end:X})):fe.start>=X?ne.push({start:fe.start-X,end:fe.end-X}):ye.push(fe)}),{score:ge,labelMatch:ne,descriptionMatch:ye}}}return n}function k(W){const Y=[];if(!W)return Y;let ue;for(const Z of W)ue&&ue.end===Z?ue.end+=1:(ue={start:Z,end:Z+1},Y.push(ue));return Y}function R(W){const Y=W.sort((Q,x)=>Q.start-x.start),ue=[];let Z;for(const Q of Y)!Z||!w(Z,Q)?(Z=Q,ue.push(Q)):(Z.start=Math.min(Z.start,Q.start),Z.end=Math.max(Z.end,Q.end));return ue}function w(W,Y){return!(W.end<Y.start||Y.end<W.start)}function p(W,Y,ue,Z,Q,x){const oe=h(W,ue,Z,Q,x),X=h(Y,ue,Z,Q,x),ve=oe.score,ge=X.score;if((ve===o||ge===o)&&ve!==ge)return ve===o?-1:1;if(ve>t||ge>t){if(ve!==ge)return ve>ge?-1:1;if(ve<a&&ge<a){const ee=P(oe.labelMatch,X.labelMatch);if(ee!==0)return ee}const fe=Q.getItemLabel(W)||"",me=Q.getItemLabel(Y)||"";if(fe.length!==me.length)return fe.length-me.length}if(ve!==ge)return ve>ge?-1:1;const V=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,U=Array.isArray(X.labelMatch)&&X.labelMatch.length>0;if(V&&!U)return-1;if(U&&!V)return 1;const ne=E(W,oe,Q),ye=E(Y,X,Q);return ne&&ye&&ne!==ye?ye>ne?-1:1:z(W,Y,ue,Q)}e.$Hq=p;function E(W,Y,ue){let Z=-1,Q=-1;if(Y.descriptionMatch&&Y.descriptionMatch.length?Z=Y.descriptionMatch[0].start:Y.labelMatch&&Y.labelMatch.length&&(Z=Y.labelMatch[0].start),Y.labelMatch&&Y.labelMatch.length){if(Q=Y.labelMatch[Y.labelMatch.length-1].end,Y.descriptionMatch&&Y.descriptionMatch.length){const x=ue.getItemDescription(W);x&&(Q+=x.length)}}else Y.descriptionMatch&&Y.descriptionMatch.length&&(Q=Y.descriptionMatch[Y.descriptionMatch.length-1].end);return Q-Z}function P(W,Y){if(!W&&!Y||(!W||!W.length)&&(!Y||!Y.length))return 0;if(!Y||!Y.length)return-1;if(!W||!W.length)return 1;const ue=W[0].start,Q=W[W.length-1].end-ue,x=Y[0].start,X=Y[Y.length-1].end-x;return Q===X?0:X<Q?1:-1}function z(W,Y,ue,Z){const Q=Z.getItemLabel(W)||"",x=Z.getItemLabel(Y)||"",oe=Z.getItemDescription(W),X=Z.getItemDescription(Y),ve=Q.length+(oe?oe.length:0),ge=x.length+(X?X.length:0);if(ve!==ge)return ve-ge;const V=Z.getItemPath(W),U=Z.getItemPath(Y);return V&&U&&V.length!==U.length?V.length-U.length:Q!==x?(0,D.$Cq)(Q,x,ue.normalized):oe&&X&&oe!==X?(0,D.$Cq)(oe,X,ue.normalized):V&&U&&V!==U?(0,D.$Cq)(V,U,ue.normalized):0}function j(W){return W.startsWith('"')&&W.endsWith('"')}const F=" ";function O(W){typeof W!="string"&&(W="");const Y=W.toLowerCase(),{pathNormalized:ue,normalized:Z,normalizedLowercase:Q}=T(W),x=ue.indexOf(I.sep)>=0,oe=j(W);let X;const ve=W.split(F);if(ve.length>1)for(const ge of ve){const V=j(ge),{pathNormalized:U,normalized:ne,normalizedLowercase:ye}=T(ge);ne&&(X||(X=[]),X.push({original:ge,originalLowercase:ge.toLowerCase(),pathNormalized:U,normalized:ne,normalizedLowercase:ye,expectContiguousMatch:V}))}return{original:W,originalLowercase:Y,pathNormalized:ue,normalized:Z,normalizedLowercase:Q,values:X,containsPathSeparator:x,expectContiguousMatch:oe}}e.$Iq=O;function T(W){let Y;L.$i?Y=W.replace(/\//g,I.sep):Y=W.replace(/\\/g,I.sep);const ue=(0,b.$Qe)(Y).replace(/\s|"/g,"");return{pathNormalized:Y,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function M(W){return Array.isArray(W)?O(W.map(Y=>Y.original).join(F)):O(W.original)}e.$Jq=M}),define(Ee[100],Se([1,0,16]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},g={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function I(A){const C=(0,D.$nc)(A),m=N[C.toLowerCase()];return m!==void 0?m:L(A)}e.$1r=I;function L(A){const C=(0,D.$nc)(A);return g[C.toLowerCase()]}e.$2r=L;function b(A){for(const C in g)if(g[C]===A)return C}e.$3r=b;const $=/^(.+)\/(.+?)(;.+)?$/;function y(A,C){const m=$.exec(A);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:C?void 0:A}e.$4r=y}),define(Ee[101],Se([1,0,11]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kl=e.$Jl=e.TerminateResponseCode=e.Source=void 0;var N;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(N||(e.Source=N={}));var g;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(g||(e.TerminateResponseCode=g={}));function I(b,...$){const y=$.reduce((m,v)=>(m[v]=!0,m),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(m=>!y[m]).forEach(m=>{for(let v=0;v<A.length;v++)if(m.search(A[v])!==-1){delete b[m];break}})}e.$Jl=I;function L(b){b&&(delete b.DEBUG,D.$j&&delete b.DYLD_LIBRARY_PATH,D.$k&&delete b.LD_PRELOAD)}e.$Kl=L}),define(Ee[2],Se([1,0,16,11]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vc=e.$uc=e.URI=void 0;const g=/^\w[\w\d+.-]*$/,I=/^\//,L=/^\/\//;function b(u,c){if(!u.scheme&&c)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${u.authority}", path: "${u.path}", query: "${u.query}", fragment: "${u.fragment}"}`);if(u.scheme&&!g.test(u.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(u.path){if(u.authority){if(!I.test(u.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(L.test(u.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(u,c){return!u&&!c?"file":u}function y(u,c){switch(u){case"https":case"http":case"file":c?c[0]!==C&&(c=C+c):c=C;break}return c}const A="",C="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class v{static isUri(c){return c instanceof v?!0:c?typeof c.authority=="string"&&typeof c.fragment=="string"&&typeof c.path=="string"&&typeof c.query=="string"&&typeof c.scheme=="string"&&typeof c.fsPath=="string"&&typeof c.with=="function"&&typeof c.toString=="function":!1}constructor(c,l,k,R,w,p=!1){typeof c=="object"?(this.scheme=c.scheme||A,this.authority=c.authority||A,this.path=c.path||A,this.query=c.query||A,this.fragment=c.fragment||A):(this.scheme=$(c,p),this.authority=l||A,this.path=y(this.scheme,k||A),this.query=R||A,this.fragment=w||A,b(this,p))}get fsPath(){return o(this,!1)}with(c){if(!c)return this;let{scheme:l,authority:k,path:R,query:w,fragment:p}=c;return l===void 0?l=this.scheme:l===null&&(l=A),k===void 0?k=this.authority:k===null&&(k=A),R===void 0?R=this.path:R===null&&(R=A),w===void 0?w=this.query:w===null&&(w=A),p===void 0?p=this.fragment:p===null&&(p=A),l===this.scheme&&k===this.authority&&R===this.path&&w===this.query&&p===this.fragment?this:new d(l,k,R,w,p)}static parse(c,l=!1){const k=m.exec(c);return k?new d(k[2]||A,h(k[4]||A),h(k[5]||A),h(k[7]||A),h(k[9]||A),l):new d(A,A,A,A,A)}static file(c){let l=A;if(N.$i&&(c=c.replace(/\\/g,C)),c[0]===C&&c[1]===C){const k=c.indexOf(C,2);k===-1?(l=c.substring(2),c=C):(l=c.substring(2,k),c=c.substring(k)||C)}return new d("file",l,c,A,A)}static from(c,l){return new d(c.scheme,c.authority,c.path,c.query,c.fragment,l)}static joinPath(c,...l){if(!c.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let k;return N.$i&&c.scheme==="file"?k=v.file(D.$ec.join(o(c,!0),...l)).path:k=D.$fc.join(c.path,...l),c.with({path:k})}toString(c=!1){return a(this,c)}toJSON(){return this}static revive(c){if(c){if(c instanceof v)return c;{const l=new d(c);return l._formatted=c.external??null,l._fsPath=c._sep===f?c.fsPath??null:null,l}}else return c}}e.URI=v;function S(u){return!u||typeof u!="object"?!1:typeof u.scheme=="string"&&(typeof u.authority=="string"||typeof u.authority>"u")&&(typeof u.path=="string"||typeof u.path>"u")&&(typeof u.query=="string"||typeof u.query>"u")&&(typeof u.fragment=="string"||typeof u.fragment>"u")}e.$uc=S;const f=N.$i?1:void 0;class d extends v{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(c=!1){return c?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const c={$mid:1};return this._fsPath&&(c.fsPath=this._fsPath,c._sep=f),this._formatted&&(c.external=this._formatted),this.path&&(c.path=this.path),this.scheme&&(c.scheme=this.scheme),this.authority&&(c.authority=this.authority),this.query&&(c.query=this.query),this.fragment&&(c.fragment=this.fragment),c}}const s={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(u,c,l){let k,R=-1;for(let w=0;w<u.length;w++){const p=u.charCodeAt(w);if(p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57||p===45||p===46||p===95||p===126||c&&p===47||l&&p===91||l&&p===93||l&&p===58)R!==-1&&(k+=encodeURIComponent(u.substring(R,w)),R=-1),k!==void 0&&(k+=u.charAt(w));else{k===void 0&&(k=u.substr(0,w));const E=s[p];E!==void 0?(R!==-1&&(k+=encodeURIComponent(u.substring(R,w)),R=-1),k+=E):R===-1&&(R=w)}}return R!==-1&&(k+=encodeURIComponent(u.substring(R))),k!==void 0?k:u}function n(u){let c;for(let l=0;l<u.length;l++){const k=u.charCodeAt(l);k===35||k===63?(c===void 0&&(c=u.substr(0,l)),c+=s[k]):c!==void 0&&(c+=u[l])}return c!==void 0?c:u}function o(u,c){let l;return u.authority&&u.path.length>1&&u.scheme==="file"?l=`//${u.authority}${u.path}`:u.path.charCodeAt(0)===47&&(u.path.charCodeAt(1)>=65&&u.path.charCodeAt(1)<=90||u.path.charCodeAt(1)>=97&&u.path.charCodeAt(1)<=122)&&u.path.charCodeAt(2)===58?c?l=u.path.substr(1):l=u.path[1].toLowerCase()+u.path.substr(2):l=u.path,N.$i&&(l=l.replace(/\//g,"\\")),l}e.$vc=o;function a(u,c){const l=c?n:i;let k="",{scheme:R,authority:w,path:p,query:E,fragment:P}=u;if(R&&(k+=R,k+=":"),(w||R==="file")&&(k+=C,k+=C),w){let z=w.indexOf("@");if(z!==-1){const j=w.substr(0,z);w=w.substr(z+1),z=j.lastIndexOf(":"),z===-1?k+=l(j,!1,!1):(k+=l(j.substr(0,z),!1,!1),k+=":",k+=l(j.substr(z+1),!1,!0)),k+="@"}w=w.toLowerCase(),z=w.lastIndexOf(":"),z===-1?k+=l(w,!1,!0):(k+=l(w.substr(0,z),!1,!0),k+=w.substr(z))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const z=p.charCodeAt(1);z>=65&&z<=90&&(p=`/${String.fromCharCode(z+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const z=p.charCodeAt(0);z>=65&&z<=90&&(p=`${String.fromCharCode(z+32)}:${p.substr(2)}`)}k+=l(p,!0,!1)}return E&&(k+="?",k+=l(E,!1,!1)),P&&(k+="#",k+=c?P:i(P,!1,!1)),k}function t(u){try{return decodeURIComponent(u)}catch{return u.length>3?u.substr(0,3)+t(u.substr(3)):u}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function h(u){return u.match(r)?u.replace(r,c=>t(c)):u}}),define(Ee[184],Se([1,0,2]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$0p=e.$9p=e.$8p=void 0;function N(y){const A=y;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$8p=N;function g(y){const A=[];let C;try{const m=JSON.parse(y.arguments),v=m[m.length-1];v&&v.__$stack&&(m.pop(),C=v.__$stack),A.push(...m)}catch{A.push("Unable to log remote console arguments",y.arguments)}return{args:A,stack:C}}e.$9p=g;function I(y){if(typeof y!="string")return I(g(y).stack);const A=y;if(A){const C=L(A),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(m&&m.length===4)return{uri:D.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$0p=I;function L(y){if(!y)return y;const A=y.indexOf(`
`);return A===-1?y:y.substring(0,A)}function b(y,A){const{args:C,stack:m}=g(y),v=typeof C[0]=="string"&&C.length===1;let S=L(m);S&&(S=`(${S.trim()})`);let f=[];if(typeof C[0]=="string"?S&&v?f=[`%c[${A}] %c${C[0]} %c${S}`,$("blue"),$(""),$("grey")]:f=[`%c[${A}] %c${C[0]}`,$("blue"),$(""),...C.slice(1)]:f=[`%c[${A}]%`,$("blue"),...C],S&&!v&&f.push(S),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,f)}e.log=b;function $(y){return`color: ${y}`}}),define(Ee[54],Se([1,0,22,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function g($){return JSON.stringify($,L)}e.$uh=g;function I($){let y=JSON.parse($);return y=b(y),y}e.$vh=I;function L($,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function b($,y=0){if(!$||y>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof D.$fe||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=b($[A],y+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=b($[A],y+1))}return $}e.$wh=b}),define(Ee[17],Se([1,0,8,11,13,2]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var L;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function b(m,v){return I.URI.isUri(m)?(0,g.$6e)(m.scheme,v):(0,g.$7e)(m,v+":")}e.$$f=b;function $(m,...v){return v.some(S=>b(m,S))}e.$_f=$,e.$ag="vscode-tkn",e.$bg="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(v){this.d=v}setDelegate(v){this.e=v}setServerRootPath(v){this.f=`${v}/${L.vscodeRemoteResource}`}set(v,S,f){this.a[v]=S,this.b[v]=f}setConnectionToken(v,S){this.c[v]=S}getPreferredWebSchema(){return this.d}rewrite(v){if(this.e)try{return this.e(v)}catch(n){return D.$Z(n),v}const S=v.authority;let f=this.a[S];f&&f.indexOf(":")!==-1&&f.indexOf("[")===-1&&(f=`[${f}]`);const d=this.b[S],s=this.c[S];let i=`path=${encodeURIComponent(v.path)}`;return typeof s=="string"&&(i+=`&${e.$bg}=${encodeURIComponent(s)}`),I.URI.from({scheme:N.$o?this.d:L.vscodeRemoteResource,authority:`${f}:${d}`,path:this.f,query:i})}}e.$cg=new y,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class A{static{this.a=e.$hg}asBrowserUri(v){const S=this.b(v,$e);return this.uriToBrowserUri(S)}uriToBrowserUri(v){return v.scheme===L.vscodeRemote?e.$cg.rewrite(v):v.scheme===L.file&&(N.$m||N.$q===`${L.vscodeFileResource}://${A.a}`)?v.with({scheme:L.vscodeFileResource,authority:v.authority||A.a,query:null,fragment:null}):v}asFileUri(v){const S=this.b(v,$e);return this.uriToFileUri(S)}uriToFileUri(v){return v.scheme===L.vscodeFileResource?v.with({scheme:L.file,authority:v.authority!==A.a?v.authority:null,query:null,fragment:null}):v}b(v,S){return I.URI.isUri(v)?v:I.URI.parse(S.toUrl(v))}}e.$ig=new A;var C;(function(m){const v=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(v.get("3"));const S="vscode-coi";function f(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:I.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const n=i?.get(S);if(n)return v.get(n)}m.getHeadersFromQuery=f;function d(s,i,n){if(!globalThis.crossOriginIsolated)return;const o=i&&n?"3":n?"2":"1";s instanceof URLSearchParams?s.set(S,o):s[S]=o}m.addSearchParam=d})(C||(e.COI=C={}))}),define(Ee[185],Se([1,0,157,17,11,2]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class L{constructor(m,v,S){this.id=m,this.dependencies=v,this.callback=S}}class b{static{this.INSTANCE=new b}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,v,S)=>{typeof m!="string"&&(S=v,v=m,m=null),(typeof v!="object"||!Array.isArray(v))&&(S=v,v=null),this.c.push(new L(m,v,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const v=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!v)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(v.dependencies)&&v.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${v.dependencies.join(", ")}`);return typeof v.callback=="function"?v.callback([]):v.callback}h(m){return new Promise((v,S)=>{const f=document.createElement("script");f.setAttribute("async","async"),f.setAttribute("type","text/javascript");const d=()=>{f.removeEventListener("load",s),f.removeEventListener("error",i)},s=n=>{d(),v(this.c.pop())},i=n=>{d(),S(n)};f.addEventListener("load",s),f.addEventListener("error",i),this.f&&(m=this.f.createScriptURL(m)),f.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(f)})}i(m){return new Promise((v,S)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),v(this.c.pop())}catch(f){S(f)}})}async j(m){try{const v=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,f=globalThis._VSCODE_NODE_MODULES.module,d=I.URI.parse(m).fsPath,s=v.readFileSync(d).toString(),i=f.wrap(s.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(v){throw v}}}const $=new Map;let y={};typeof globalThis.require=="object"&&(y=globalThis.require.paths??{});async function A(C,m,v){if(D.$S){v===void 0&&(v=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),y[C]&&(C=y[C]);const S=`${C}/${m}`;if($.has(S))return $.get(S);let f;if(/^\w[\w\d+.-]*:\/\//.test(S))f=S;else{const n=`${v&&!g.$o?N.$fg:N.$eg}/${S}`;f=N.$ig.asBrowserUri(n).toString(!0)}const d=b.INSTANCE.load(f);return $.set(S,d),d}else return await new Promise((S,f)=>{$e([C],S,f)})}e.$UC=A}),define(Ee[23],Se([1,0,33,17,16,11,13,2]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function $(v){return(0,b.$vc)(v,!0)}e.$pg=$;class y{constructor(S){this.a=S}compare(S,f,d=!1){return S===f?0:(0,L.$Ye)(this.getComparisonKey(S,d),this.getComparisonKey(f,d))}isEqual(S,f,d=!1){return S===f?!0:!S||!f?!1:this.getComparisonKey(S,d)===this.getComparisonKey(f,d)}getComparisonKey(S,f=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,f,d=!1){if(S.scheme===f.scheme){if(S.scheme===N.Schemas.file)return D.$2f($(S),$(f),this.a(S))&&S.query===f.query&&(d||S.fragment===f.fragment);if((0,e.$Gg)(S.authority,f.authority))return D.$2f(S.path,f.path,this.a(S),"/")&&S.query===f.query&&(d||S.fragment===f.fragment)}return!1}joinPath(S,...f){return b.URI.joinPath(S,...f)}basenameOrAuthority(S){return(0,e.$yg)(S)||S.authority}basename(S){return g.$fc.basename(S.path)}extname(S){return g.$fc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let f;return S.scheme===N.Schemas.file?f=b.URI.file(g.$lc($(S))).path:(f=g.$fc.dirname(S.path),S.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),f="/")),S.with({path:f})}normalizePath(S){if(!S.path.length)return S;let f;return S.scheme===N.Schemas.file?f=b.URI.file(g.$gc($(S))).path:f=g.$fc.normalize(S.path),S.with({path:f})}relativePath(S,f){if(S.scheme!==f.scheme||!(0,e.$Gg)(S.authority,f.authority))return;if(S.scheme===N.Schemas.file){const i=g.$kc($(S),$(f));return I.$i?D.$Vf(i):i}let d=S.path||"/";const s=f.path||"/";if(this.a(S)){let i=0;for(const n=Math.min(d.length,s.length);i<n&&!(d.charCodeAt(i)!==s.charCodeAt(i)&&d.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);d=s.substr(0,i)+d.substr(i)}return g.$fc.relative(d,s)}resolvePath(S,f){if(S.scheme===N.Schemas.file){const d=b.URI.file(g.$jc($(S),f));return S.with({authority:d.authority,path:d.path})}return f=D.$Wf(f),S.with({path:g.$fc.resolve(S.path,f)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,f){return S===f||S!==void 0&&f!==void 0&&(0,L.$6e)(S,f)}hasTrailingPathSeparator(S,f=g.sep){if(S.scheme===N.Schemas.file){const d=$(S);return d.length>D.$Xf(d).length&&d[d.length-1]===f}else{const d=S.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,f=g.sep){return(0,e.$Hg)(S,f)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,f=g.sep){let d=!1;if(S.scheme===N.Schemas.file){const s=$(S);d=s!==void 0&&s.length===D.$Xf(s).length&&s[s.length-1]===f}else{f="/";const s=S.path;d=s.length===1&&s.charCodeAt(s.length-1)===47}return!d&&!(0,e.$Hg)(S,f)?S.with({path:S.path+"/"}):S}}e.$qg=y,e.$rg=new y(()=>!1),e.$sg=new y(v=>v.scheme===N.Schemas.file?!I.$k:!0),e.$tg=new y(v=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function A(v,S){const f=[];for(let d=0;d<v.length;d++){const s=S(v[d]);v.some((i,n)=>n===d?!1:(0,e.$vg)(s,S(i)))||f.push(v[d])}return f}e.$Kg=A;var C;(function(v){v.META_DATA_LABEL="label",v.META_DATA_DESCRIPTION="description",v.META_DATA_SIZE="size",v.META_DATA_MIME="mime";function S(f){const d=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(n=>{const[o,a]=n.split(":");o&&a&&d.set(o,a)});const i=f.path.substring(0,f.path.indexOf(";"));return i&&d.set(v.META_DATA_MIME,i),d}v.parseMetaData=S})(C||(e.DataUri=C={}));function m(v,S,f){if(S){let d=v.path;return d&&d[0]!==g.$fc.sep&&(d=g.$fc.sep+d),v.with({scheme:f,authority:S,path:d})}return v.with({scheme:f})}e.$Lg=m}),define(Ee[12],Se([1,0,21,8,4,3,23,11,162,43]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function A(ee){return!!ee&&typeof ee.then=="function"}e.$Mg=A;function C(ee){const ie=new D.$2d,G=ee(ie.token),te=new Promise((J,ce)=>{const be=ie.token.onCancellationRequested(()=>{be.dispose(),ie.dispose(),ce(new N.$4)});Promise.resolve(G).then(Ie=>{be.dispose(),ie.dispose(),J(Ie)},Ie=>{be.dispose(),ie.dispose(),ce(Ie)})});return new class{cancel(){ie.cancel()}then(J,ce){return te.then(J,ce)}catch(J){return this.then(void 0,J)}finally(J){return te.finally(J)}}}e.$Ng=C;function m(ee,ie,G){return new Promise((te,J)=>{const ce=ie.onCancellationRequested(()=>{ce.dispose(),te(G)});ee.then(te,J).finally(()=>ce.dispose())})}e.$Og=m;function v(ee,ie){return new Promise((G,te)=>{const J=ie.onCancellationRequested(()=>{J.dispose(),te(new N.$4)});ee.then(G,te).finally(()=>J.dispose())})}e.$Pg=v;async function S(ee){let ie=-1;const G=ee.map((te,J)=>te.then(ce=>(ie=J,ce)));try{return await Promise.race(G)}finally{ee.forEach((te,J)=>{J!==ie&&te.cancel()})}}e.$Qg=S;function f(ee,ie,G){let te;const J=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([ee.finally(()=>clearTimeout(J)),new Promise(ce=>te=ce)])}e.$Rg=f;function d(ee){return new Promise((ie,G)=>{const te=ee();A(te)?te.then(ie,G):ie(te)})}e.$Sg=d;class s{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(J=>{this.a=null,G(J)},J=>{this.a=null,te(J)})})}dispose(){this.f=!0}}e.$Tg=s;class i{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Ug=i;class n{constructor(){this.a=new Map}queue(ie,G){const J=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===J&&this.a.delete(ie)});return this.a.set(ie,J),J}}e.$Vg=n;const o=(ee,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},ee);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},a=ee=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,ee())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class t{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((J,ce)=>{this.d=J,this.f=ce}).then(()=>{if(this.b=null,this.d=null,this.g){const J=this.g;return this.g=null,J()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Od?a(te):o(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=t;class r{constructor(ie){this.a=new t(ie),this.b=new s}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=r;class h{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=h;class u extends h{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$Zg=u;function c(ee,ie){return ie?new Promise((G,te)=>{const J=setTimeout(()=>{ce.dispose(),G()},ee),ce=ie.onCancellationRequested(()=>{clearTimeout(J),ce.dispose(),te(new N.$4)})}):C(G=>c(ee,G))}e.$1g=c;function l(ee,ie=0,G){const te=setTimeout(()=>{ee(),G&&J.dispose()},ie),J=(0,I.$Pc)(()=>{clearTimeout(te),G?.deleteAndLeak(J)});return G?.add(J),J}e.$2g=l;function k(ee){const ie=[];let G=0;const te=ee.length;function J(){return G<te?ee[G++]():null}function ce(be){be!=null&&ie.push(be);const Ie=J();return Ie?Ie.then(ce):Promise.resolve(ie)}return Promise.resolve(null).then(ce)}e.$3g=k;function R(ee,ie=te=>!!te,G=null){let te=0;const J=ee.length,ce=()=>{if(te>=J)return Promise.resolve(G);const be=ee[te++];return Promise.resolve(be()).then(Me=>ie(Me)?Promise.resolve(Me):ce())};return ce()}e.$4g=R;function w(ee,ie=te=>!!te,G=null){if(ee.length===0)return Promise.resolve(G);let te=ee.length;const J=()=>{te=-1;for(const ce of ee)ce.cancel?.()};return new Promise((ce,be)=>{for(const Ie of ee)Ie.then(Me=>{--te>=0&&ie(Me)?(J(),ce(Me)):te===0&&ce(G)}).catch(Me=>{--te>=0&&(J(),be(Me))})})}e.$5g=w;class p{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new g.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=p;class E extends p{constructor(){super(1)}}e.$7g=E;class P{constructor(){this.a=new Q,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$8g=P;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new X;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=L.$rg){const te=G.getComparisonKey(ie);let J=this.a.get(te);if(!J){J=new E;const ce=this.f++,be=g.Event.once(J.onDrained)(()=>{J?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(ce),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new I.$1c),this.d.set(ce,be),this.a.set(te,J)}return J}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=z;class j{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$0g=j;class F{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const J=te.setInterval(()=>{ie()},G);this.d=(0,I.$Pc)(()=>{te.clearInterval(J),this.d=void 0})}dispose(){this.cancel()}}e.$$g=F;class O{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=O;class T{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=T;class M extends O{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$bh=M;class W extends I.$Rc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new I.$Sc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=W,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(ee,ie)=>{(0,b.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$eh=(ee,ie,G)=>{const te=ee.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let J=!1;return{dispose(){J||(J=!0,ee.cancelIdleCallback(te))}}},e.$dh=ee=>(0,e.$eh)(globalThis,ee)}();class Y{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$eh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=Y;class ue extends Y{constructor(ie){super(globalThis,ie)}}e.$gh=ue;async function Z(ee,ie,G){let te;for(let J=0;J<G;J++)try{return await ee()}catch(ce){te=ce,await c(ie)}throw te}e.$hh=Z;class Q{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const J=new Promise((ce,be)=>{G=ce,te=be});this.b={run:ie,promise:J,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=Q;class x{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$jh=x;var oe;(function(ee){ee[ee.Resolved=0]="Resolved",ee[ee.Rejected=1]="Rejected"})(oe||(oe={}));class X{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new N.$4)}}e.$kh=X;var ve;(function(ee){async function ie(te){let J;const ce=await Promise.all(te.map(be=>be.then(Ie=>Ie,Ie=>{J||(J=Ie)})));if(typeof J<"u")throw J;return ce}ee.settled=ie;function G(te){return new Promise(async(J,ce)=>{try{await te(J,ce)}catch(be){ce(be)}})}ee.withAsyncBody=G})(ve||(e.Promises=ve={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new N.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$lh=ge;class V{constructor(ie){this.b=ie,this.a=new y.$U(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$mh=V;var U;(function(ee){ee[ee.Initial=0]="Initial",ee[ee.DoneOK=1]="DoneOK",ee[ee.DoneError=2]="DoneError"})(U||(U={}));class ne{static fromArray(ie){return new ne(G=>{G.emitMany(ie)})}static fromPromise(ie){return new ne(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new ne(async G=>{await Promise.all(ie.map(async te=>{for await(const J of te)G.emitOne(J)}))})}static{this.EMPTY=ne.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new g.$Rd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await g.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new ne(async te=>{for await(const J of ie)te.emitOne(G(J))})}map(ie){return ne.map(this,ie)}static filter(ie,G){return new ne(async te=>{for await(const J of ie)G(J)&&te.emitOne(J)})}filter(ie){return ne.filter(this,ie)}static coalesce(ie){return ne.filter(ie,G=>!!G)}coalesce(){return ne.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return ne.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$nh=ne;class ye extends ne{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$oh=ye;function fe(ee){const ie=new D.$2d,G=ee(ie.token);return new ye(ie,async te=>{const J=ie.token.onCancellationRequested(()=>{J.dispose(),ie.dispose(),te.reject(new N.$4)});try{for await(const ce of G){if(ie.token.isCancellationRequested)return;te.emitOne(ce)}J.dispose(),ie.dispose()}catch(ce){J.dispose(),ie.dispose(),te.reject(ce)}})}e.$ph=fe;class me{constructor(){this.a=new X,this.b=new ne(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=J=>te.reject(J),this.f=J=>te.emitOne(J),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$qh=me}),define(Ee[34],Se([1,0,19,12,33,28,16,11,13]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=void 0;function y(){return Object.create(null)}e.$Bj=y,e.$Cj="**",e.$Dj="/";const A="[/\\\\]",C="[^/\\\\]",m=/\//g;function v(ue,Z){switch(ue){case 0:return"";case 1:return`${C}*?`;default:return`(?:${A}|${C}+${A}${Z?`|${A}${C}+`:""})*?`}}function S(ue,Z){if(!ue)return[];const Q=[];let x=!1,oe=!1,X="";for(const ve of ue){switch(ve){case Z:if(!x&&!oe){Q.push(X),X="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}X+=ve}return X&&Q.push(X),Q}e.$Ej=S;function f(ue){if(!ue)return"";let Z="";const Q=S(ue,e.$Dj);if(Q.every(x=>x===e.$Cj))Z=".*";else{let x=!1;Q.forEach((oe,X)=>{if(oe===e.$Cj){if(x)return;Z+=v(2,X===Q.length-1)}else{let ve=!1,ge="",V=!1,U="";for(const ne of oe){if(ne!=="}"&&ve){ge+=ne;continue}if(V&&(ne!=="]"||!U)){let ye;ne==="-"?ye=ne:(ne==="^"||ne==="!")&&!U?ye="^":ne===e.$Dj?ye="":ye=(0,$.$Je)(ne),U+=ye;continue}switch(ne){case"{":ve=!0;continue;case"[":V=!0;continue;case"}":{const fe=`(?:${S(ge,",").map(me=>f(me)).join("|")})`;Z+=fe,ve=!1,ge="";break}case"]":{Z+="["+U+"]",V=!1,U="";break}case"?":Z+=C;continue;case"*":Z+=v(1);continue;default:Z+=(0,$.$Je)(ne)}}X<Q.length-1&&(Q[X+1]!==e.$Cj||X+2<Q.length)&&(Z+=A)}x=oe===e.$Cj})}return Z}const d=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,o=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new I.$Cc(1e4),r=function(){return!1},h=function(){return null};function u(ue,Z){if(!ue)return h;let Q;typeof ue!="string"?Q=ue.pattern:Q=ue,Q=Q.trim();const x=`${Q}_${!!Z.trimForExclusions}`;let oe=t.get(x);if(oe)return c(oe,ue);let X;return d.test(Q)?oe=k(Q.substr(4),Q):(X=s.exec(l(Q,Z)))?oe=R(X[1],Q):(Z.trimForExclusions?n:i).test(Q)?oe=w(Q,Z):(X=o.exec(l(Q,Z)))?oe=p(X[1].substr(1),Q,!0):(X=a.exec(l(Q,Z)))?oe=p(X[1],Q,!1):oe=E(Q),t.set(x,oe),c(oe,ue)}function c(ue,Z){if(typeof Z=="string")return ue;const Q=function(x,oe){return(0,g.$2f)(x,Z.base,!b.$k)?ue((0,$.$Ne)(x.substr(Z.base.length),L.sep),oe):null};return Q.allBasenames=ue.allBasenames,Q.allPaths=ue.allPaths,Q.basenames=ue.basenames,Q.patterns=ue.patterns,Q}function l(ue,Z){return Z.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function k(ue,Z){return function(Q,x){return typeof Q=="string"&&Q.endsWith(ue)?Z:null}}function R(ue,Z){const Q=`/${ue}`,x=`\\${ue}`,oe=function(ve,ge){return typeof ve!="string"?null:ge?ge===ue?Z:null:ve===ue||ve.endsWith(Q)||ve.endsWith(x)?Z:null},X=[ue];return oe.basenames=X,oe.patterns=[Z],oe.allBasenames=X,oe}function w(ue,Z){const Q=W(ue.slice(1,-1).split(",").map(ge=>u(ge,Z)).filter(ge=>ge!==h),ue),x=Q.length;if(!x)return h;if(x===1)return Q[0];const oe=function(ge,V){for(let U=0,ne=Q.length;U<ne;U++)if(Q[U](ge,V))return ue;return null},X=Q.find(ge=>!!ge.allBasenames);X&&(oe.allBasenames=X.allBasenames);const ve=Q.reduce((ge,V)=>V.allPaths?ge.concat(V.allPaths):ge,[]);return ve.length&&(oe.allPaths=ve),oe}function p(ue,Z,Q){const x=L.sep===L.$fc.sep,oe=x?ue:ue.replace(m,L.sep),X=L.sep+oe,ve=L.$fc.sep+ue;let ge;return Q?ge=function(V,U){return typeof V=="string"&&(V===oe||V.endsWith(X)||!x&&(V===ue||V.endsWith(ve)))?Z:null}:ge=function(V,U){return typeof V=="string"&&(V===oe||!x&&V===ue)?Z:null},ge.allPaths=[(Q?"*/":"./")+ue],ge}function E(ue){try{const Z=new RegExp(`^${f(ue)}$`);return function(Q){return Z.lastIndex=0,typeof Q=="string"&&Z.test(Q)?ue:null}}catch{return h}}function P(ue,Z,Q){return!ue||typeof Z!="string"?!1:z(ue)(Z,void 0,Q)}e.$Fj=P;function z(ue,Z={}){if(!ue)return r;if(typeof ue=="string"||j(ue)){const Q=u(ue,Z);if(Q===h)return r;const x=function(oe,X){return!!Q(oe,X)};return Q.allBasenames&&(x.allBasenames=Q.allBasenames),Q.allPaths&&(x.allPaths=Q.allPaths),x}return T(ue,Z)}e.$Gj=z;function j(ue){const Z=ue;return Z?typeof Z.base=="string"&&typeof Z.pattern=="string":!1}e.$Hj=j;function F(ue){return ue.allBasenames||[]}e.$Ij=F;function O(ue){return ue.allPaths||[]}e.$Jj=O;function T(ue,Z){const Q=W(Object.getOwnPropertyNames(ue).map(ge=>M(ge,ue[ge],Z)).filter(ge=>ge!==h)),x=Q.length;if(!x)return h;if(!Q.some(ge=>!!ge.requiresSiblings)){if(x===1)return Q[0];const ge=function(ne,ye){let fe;for(let me=0,ee=Q.length;me<ee;me++){const ie=Q[me](ne,ye);if(typeof ie=="string")return ie;(0,N.$Mg)(ie)&&(fe||(fe=[]),fe.push(ie))}return fe?(async()=>{for(const me of fe){const ee=await me;if(typeof ee=="string")return ee}return null})():null},V=Q.find(ne=>!!ne.allBasenames);V&&(ge.allBasenames=V.allBasenames);const U=Q.reduce((ne,ye)=>ye.allPaths?ne.concat(ye.allPaths):ne,[]);return U.length&&(ge.allPaths=U),ge}const oe=function(ge,V,U){let ne,ye;for(let fe=0,me=Q.length;fe<me;fe++){const ee=Q[fe];ee.requiresSiblings&&U&&(V||(V=(0,L.$mc)(ge)),ne||(ne=V.substr(0,V.length-(0,L.$nc)(ge).length)));const ie=ee(ge,V,ne,U);if(typeof ie=="string")return ie;(0,N.$Mg)(ie)&&(ye||(ye=[]),ye.push(ie))}return ye?(async()=>{for(const fe of ye){const me=await fe;if(typeof me=="string")return me}return null})():null},X=Q.find(ge=>!!ge.allBasenames);X&&(oe.allBasenames=X.allBasenames);const ve=Q.reduce((ge,V)=>V.allPaths?ge.concat(V.allPaths):ge,[]);return ve.length&&(oe.allPaths=ve),oe}function M(ue,Z,Q){if(Z===!1)return h;const x=u(ue,Q);if(x===h)return h;if(typeof Z=="boolean")return x;if(Z){const oe=Z.when;if(typeof oe=="string"){const X=(ve,ge,V,U)=>{if(!U||!x(ve,ge))return null;const ne=oe.replace("$(basename)",()=>V),ye=U(ne);return(0,N.$Mg)(ye)?ye.then(fe=>fe?ue:null):ye?ue:null};return X.requiresSiblings=!0,X}}return x}function W(ue,Z){const Q=ue.filter(ge=>!!ge.basenames);if(Q.length<2)return ue;const x=Q.reduce((ge,V)=>{const U=V.basenames;return U?ge.concat(U):ge},[]);let oe;if(Z){oe=[];for(let ge=0,V=x.length;ge<V;ge++)oe.push(Z)}else oe=Q.reduce((ge,V)=>{const U=V.patterns;return U?ge.concat(U):ge},[]);const X=function(ge,V){if(typeof ge!="string")return null;if(!V){let ne;for(ne=ge.length;ne>0;ne--){const ye=ge.charCodeAt(ne-1);if(ye===47||ye===92)break}V=ge.substr(ne)}const U=x.indexOf(V);return U!==-1?oe[U]:null};X.basenames=x,X.patterns=oe,X.allBasenames=x;const ve=ue.filter(ge=>!ge.basenames);return ve.push(X),ve}function Y(ue,Z){return(0,D.$tb)(ue,Z,(Q,x)=>typeof Q=="string"&&typeof x=="string"?Q===x:typeof Q!="string"&&typeof x!="string"?Q.base===x.base&&Q.pattern===x.pattern:!1)}e.$Kj=Y}),define(Ee[80],Se([1,0,8,163,23,13,2]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.MarkdownStringTextNewlineStyle=void 0;var b;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(b||(e.MarkdownStringTextNewlineStyle=b={}));class ${constructor(s="",i=!1){if(this.value=s,typeof this.value!="string")throw(0,D.$6)("value");typeof i=="boolean"?(this.isTrusted=i,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=i.isTrusted??void 0,this.supportThemeIcons=i.supportThemeIcons??!1,this.supportHtml=i.supportHtml??!1)}appendText(s,i=0){return this.value+=m(this.supportThemeIcons?(0,N.$7j)(s):s).replace(/([ \t]+)/g,(n,o)=>"&nbsp;".repeat(o.length)).replace(/\>/gm,"\\>").replace(/\n/g,i===1?`\\
`:`

`),this}appendMarkdown(s){return this.value+=s,this}appendCodeblock(s,i){return this.value+="\n```",this.value+=s,this.value+=`
`,this.value+=i,this.value+="\n```\n",this}appendLink(s,i,n){return this.value+="[",this.value+=this.c(i,"]"),this.value+="](",this.value+=this.c(String(s),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(s,i){const n=new RegExp((0,I.$Je)(i),"g");return s.replace(n,(o,a)=>s.charAt(a-1)!=="\\"?`\\${o}`:o)}}e.$ak=$;function y(d){return A(d)?!d.value:Array.isArray(d)?d.every(y):!0}e.$bk=y;function A(d){return d instanceof $?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||typeof d.isTrusted=="object"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.$ck=A;function C(d,s){return d===s?!0:!d||!s?!1:d.value===s.value&&d.isTrusted===s.isTrusted&&d.supportThemeIcons===s.supportThemeIcons&&d.supportHtml===s.supportHtml&&(d.baseUri===s.baseUri||!!d.baseUri&&!!s.baseUri&&(0,g.$ug)(L.URI.from(d.baseUri),L.URI.from(s.baseUri)))}e.$dk=C;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ek=m;function v(d){return d.replace(/"/g,"&quot;")}e.$fk=v;function S(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$gk=S;function f(d){const s=[],i=d.split("|").map(o=>o.trim());d=i[0];const n=i[1];if(n){const o=/height=(\d+)/.exec(n),a=/width=(\d+)/.exec(n),t=o?o[1]:"",r=a?a[1]:"",h=isFinite(parseInt(r)),u=isFinite(parseInt(t));h&&s.push(`width="${r}"`),u&&s.push(`height="${t}"`)}return{href:d,dimensions:s}}e.$hk=f}),define(Ee[102],Se([1,0,19,33,16,11,23,13]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=void 0;function $(u,c){const{os:l,tildify:k,relative:R}=c;if(R){const E=y(u,R,l);if(typeof E=="string")return E}let w=u.fsPath;if(l===1&&!I.$i?w=w.replace(/\//g,"\\"):l!==1&&I.$i&&(w=w.replace(/\\/g,"/")),l!==1&&k?.userHome){const E=k.userHome.fsPath;let P;u.scheme!==k.userHome.scheme&&u.path[0]===g.$fc.sep&&u.path[1]!==g.$fc.sep?P=k.userHome.with({path:u.path}).fsPath:P=w,w=m(P,E,l)}return(l===1?g.$ec:g.$fc).normalize(A(w,l===1))}e.$Dv=$;function y(u,c,l){const k=l===1?g.$ec:g.$fc,R=l===3?L.$rg:L.$tg,w=c.getWorkspace(),p=(0,D.$Nb)(w.folders);if(!p)return;u.scheme!==p.uri.scheme&&u.path[0]===g.$fc.sep&&u.path[1]!==g.$fc.sep&&(u=p.uri.with({path:u.path}));const E=c.getWorkspaceFolder(u);if(!E)return;let P;if(R.isEqual(E.uri,u)?P="":P=R.relativePath(E.uri,u)??"",P&&(P=k.normalize(P)),w.folders.length>1&&!c.noPrefix){const z=E.name?E.name:R.basenameOrAuthority(E.uri);P=P?`${z} \u2022 ${P}`:z}return P}function A(u,c=I.$i){return(0,N.$6f)(u,c)?u.charAt(0).toUpperCase()+u.slice(1):u}e.$Ev=A;let C=Object.create(null);function m(u,c,l=I.OS){if(l===1||!u||!c)return u;let k=C.original===c?C.normalized:void 0;k||(k=c,I.$i&&(k=(0,N.$Vf)(k)),k=`${(0,b.$Oe)(k,g.$fc.sep)}${g.$fc.sep}`,C={original:c,normalized:k});let R=u;return I.$i&&(R=(0,N.$Vf)(R)),(l===3?R.startsWith(k):(0,b.$7e)(R,k))?`~/${R.substr(k.length)}`:u}e.$Fv=m;function v(u,c){return u.replace(/^~($|\/|\\)/,`${c}$1`)}e.$Gv=v;const S="\u2026",f="\\\\",d="~";function s(u,c=g.sep){const l=new Array(u.length);let k=!1;for(let R=0;R<u.length;R++){const w=u[R];if(w===""){l[R]=`.${c}`;continue}if(!w){l[R]=w;continue}k=!0;let p="",E=w;E.indexOf(f)===0?(p=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(c)===0?(p=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length)):E.indexOf(d)===0&&(p=E.substr(0,E.indexOf(d)+d.length),E=E.substr(E.indexOf(d)+d.length));const P=E.split(c);for(let z=1;k&&z<=P.length;z++)for(let j=P.length-z;k&&j>=0;j--){k=!1;let F=P.slice(j,j+z).join(c);for(let O=0;!k&&O<u.length;O++)if(O!==R&&u[O]&&u[O].indexOf(F)>-1){const T=j+z===P.length,M=j>0&&u[O].indexOf(c)>-1?c+F:F,W=u[O].endsWith(M);k=!T||W}if(!k){let O="";(P[0].endsWith(":")||p!=="")&&(j===1&&(j=0,z++,F=P[0]+c+F),j>0&&(O=P[0]+c),O=p+O),j>0&&(O=O+S+c),O=O+F,j+z<P.length&&(O=O+c+S),l[R]=O}}k&&(l[R]=w)}return l}e.$Hv=s;var i;(function(u){u[u.TEXT=0]="TEXT",u[u.VARIABLE=1]="VARIABLE",u[u.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function n(u,c=Object.create(null)){const l=[];let k=!1,R="";for(const w of u)if(w==="$"||k&&w==="{")R&&l.push({value:R,type:i.TEXT}),R="",k=!0;else if(w==="}"&&k){const p=c[R];if(typeof p=="string")p.length&&l.push({value:p,type:i.VARIABLE});else if(p){const E=l[l.length-1];(!E||E.type!==i.SEPARATOR)&&l.push({value:p.label,type:i.SEPARATOR})}R="",k=!1}else R+=w;return R&&!k&&l.push({value:R,type:i.TEXT}),l.filter((w,p)=>{if(w.type===i.SEPARATOR){const E=l[p-1],P=l[p+1];return[E,P].every(z=>z&&(z.type===i.VARIABLE||z.type===i.TEXT)&&z.value.length>0)}return!0}).map(w=>w.value).join("")}e.$Iv=n;function o(u,c){return I.$j||c?u.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.$j?"&":"&&"):u.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$Jv=o;function a(u,c){return I.$j||c?u.replace(/\(&&\w\)|&&/g,""):I.$i?u.replace(/&&|&/g,l=>l==="&"?"&&":"&"):u.replace(/&&/g,"_")}e.$Kv=a;function t(u){return u.replace(/&/g,"&&")}e.$Lv=t;function r(u){if(u.endsWith("]")){const c=u.lastIndexOf(" [",u.length-2);if(c!==-1){const l=h(u.substring(0,c));return{name:l.name,parentPath:l.parentPath+u.substring(c)}}}return h(u)}e.$Mv=r;function h(u){const c=u.indexOf("/")!==-1?g.$fc:g.$ec,l=c.basename(u),k=c.dirname(u);return l.length?{name:l,parentPath:k}:{name:k,parentPath:""}}}),define(Ee[130],Se([1,0,22,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function g(C){return C.toJSON()}class I{constructor(m){this.a=m}transformIncoming(m){const v=this.a.transformIncoming(m);return v===m?m:g(N.URI.from(v))}transformOutgoing(m){const v=this.a.transformOutgoing(m);return v===m?m:g(N.URI.from(v))}transformOutgoingURI(m){const v=this.a.transformOutgoing(m);return v===m?m:N.URI.from(v)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$Vm=I,e.$Wm=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function L(C,m,v){if(!C||v>200)return null;if(typeof C=="object"){if(C instanceof N.URI)return m.transformOutgoing(C);for(const S in C)if(Object.hasOwnProperty.call(C,S)){const f=L(C[S],m,v+1);f!==null&&(C[S]=f)}}return null}function b(C,m){const v=L(C,m,0);return v===null?C:v}e.$Xm=b;function $(C,m,v,S){if(!C||S>200)return null;if(typeof C=="object"){if(C.$mid===1)return v?N.URI.revive(m.transformIncoming(C)):m.transformIncoming(C);if(C instanceof D.$fe)return null;for(const f in C)if(Object.hasOwnProperty.call(C,f)){const d=$(C[f],m,v,S+1);d!==null&&(C[f]=d)}}return null}function y(C,m){const v=$(C,m,!1,0);return v===null?C:v}e.$Ym=y;function A(C,m){const v=$(C,m,!0,0);return v===null?C:v}e.$Zm=A}),define(Ee[31],Se([1,0,55,63,384,12,33,76,16,11,23,2]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(M){M[M.UNLINK=0]="UNLINK",M[M.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function v(M,W=m.UNLINK,Y){if((0,L.$5f)(M))throw new Error("rimraf - will refuse to recursively delete root");return W===m.UNLINK?f(M):S(M,Y)}async function S(M,W=(0,L.$0f)((0,N.tmpdir)())){try{try{await D.promises.rename(M,W)}catch(Y){return Y.code==="ENOENT"?void 0:f(M)}f(W).catch(Y=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function f(M){return(0,g.promisify)(D.rm)(M,{recursive:!0,force:!0,maxRetries:3})}function d(M){if((0,L.$5f)(M))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(M,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=d;async function s(M,W){return o(await(W?i(M):(0,g.promisify)(D.readdir)(M)))}async function i(M){try{return await(0,g.promisify)(D.readdir)(M,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const W=[],Y=await s(M);for(const ue of Y){let Z=!1,Q=!1,x=!1;try{const oe=await e.Promises.lstat((0,$.$ic)(M,ue));Z=oe.isFile(),Q=oe.isDirectory(),x=oe.isSymbolicLink()}catch(oe){console.warn("[node.js fs] unexpected error from lstat after readdir: ",oe)}W.push({name:ue,isFile:()=>Z,isDirectory:()=>Q,isSymbolicLink:()=>x})}return W}function n(M){return o(D.readdirSync(M))}e.readdirSync=n;function o(M){return M.map(W=>typeof W=="string"?y.$j?(0,b.$yl)(W):W:(W.name=y.$j?(0,b.$yl)(W.name):W.name,W))}async function a(M){const W=await s(M),Y=[];for(const ue of W)await r.existsDirectory((0,$.$ic)(M,ue))&&Y.push(ue);return Y}function t(M,W=1e3){return new Promise(Y=>{let ue=!1;const Z=setInterval(()=>{ue||(ue=!0,D.access(M,Q=>{ue=!1,Q&&(clearInterval(Z),Y(void 0))}))},W)})}e.whenDeleted=t;var r;(function(M){async function W(Z){let Q;try{if(Q=await e.Promises.lstat(Z),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(y.$i&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(oe){if(oe.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw oe}throw x}}M.stat=W;async function Y(Z){try{const{stat:Q,symbolicLink:x}=await M.stat(Z);return Q.isFile()&&x?.dangling!==!0}catch{}return!1}M.existsFile=Y;async function ue(Z){try{const{stat:Q,symbolicLink:x}=await M.stat(Z);return Q.isDirectory()&&x?.dangling!==!0}catch{}return!1}M.existsDirectory=ue})(r||(e.SymlinkSupport=r={}));const h=new I.$9g;function u(M,W,Y){return h.queueFor(C.URI.file(M),A.$sg).queue(()=>{const ue=w(Y);return new Promise((Z,Q)=>k(M,W,ue,x=>x?Q(x):Z()))})}let c=!0;function l(M){c=M}e.configureFlushOnWrite=l;function k(M,W,Y,ue){if(!c)return D.writeFile(M,W,{mode:Y.mode,flag:Y.flag},ue);D.open(M,Y.flag,Y.mode,(Z,Q)=>{if(Z)return ue(Z);D.writeFile(Q,W,x=>{if(x)return D.close(Q,()=>ue(x));D.fdatasync(Q,oe=>(oe&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",oe),l(!1)),D.close(Q,X=>ue(X))))})})}function R(M,W,Y){const ue=w(Y);if(!c)return D.writeFileSync(M,W,{mode:ue.mode,flag:ue.flag});const Z=D.openSync(M,ue.flag,ue.mode);try{D.writeFileSync(Z,W);try{D.fdatasyncSync(Z)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{D.closeSync(Z)}}e.writeFileSync=R;function w(M){return M?{mode:typeof M.mode=="number"?M.mode:438,flag:typeof M.flag=="string"?M.flag:"w"}:{mode:438,flag:"w"}}async function p(M,W,Y=6e4){if(M!==W)try{y.$i&&typeof Y=="number"?await E(M,W,Date.now(),Y):await(0,g.promisify)(D.rename)(M,W)}catch(ue){if(M.toLowerCase()!==W.toLowerCase()&&ue.code==="EXDEV"||M.endsWith("."))await P(M,W,{preserveSymlinks:!1}),await v(M,m.MOVE);else throw ue}}async function E(M,W,Y,ue,Z=0){try{return await(0,g.promisify)(D.rename)(M,W)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-Y>=ue)throw console.error(`[node.js fs] rename failed after ${Z} retries with error: ${Q}`),Q;if(Z===0){let x=!1;try{const{stat:oe}=await r.stat(W);oe.isFile()||(x=!0)}catch{}if(x)throw Q}return await(0,I.$1g)(Math.min(100,Z*10)),E(M,W,Y,ue,Z+1)}}async function P(M,W,Y){return j(M,W,{root:{source:M,target:W},options:Y,handledSourcePaths:new Set})}const z=511;async function j(M,W,Y){if(Y.handledSourcePaths.has(M))return;Y.handledSourcePaths.add(M);const{stat:ue,symbolicLink:Z}=await r.stat(M);if(Z){if(Y.options.preserveSymlinks)try{return await T(M,W,Y)}catch{}if(Z.dangling)return}return ue.isDirectory()?F(M,W,ue.mode&z,Y):O(M,W,ue.mode&z)}async function F(M,W,Y,ue){await e.Promises.mkdir(W,{recursive:!0,mode:Y});const Z=await s(M);for(const Q of Z)await j((0,$.$ic)(M,Q),(0,$.$ic)(W,Q),ue)}async function O(M,W,Y){await e.Promises.copyFile(M,W),await e.Promises.chmod(W,Y)}async function T(M,W,Y){let ue=await e.Promises.readlink(M);(0,L.$2f)(ue,Y.root.source,!y.$k)&&(ue=(0,$.$ic)(Y.root.target,ue.substr(Y.root.source.length+1))),await e.Promises.symlink(ue,W)}e.Promises=new class{get access(){return(0,g.promisify)(D.access)}get stat(){return(0,g.promisify)(D.stat)}get lstat(){return(0,g.promisify)(D.lstat)}get utimes(){return(0,g.promisify)(D.utimes)}get read(){return(M,W,Y,ue,Z)=>new Promise((Q,x)=>{D.read(M,W,Y,ue,Z,(oe,X,ve)=>oe?x(oe):Q({bytesRead:X,buffer:ve}))})}get readFile(){return(0,g.promisify)(D.readFile)}get write(){return(M,W,Y,ue,Z)=>new Promise((Q,x)=>{D.write(M,W,Y,ue,Z,(oe,X,ve)=>oe?x(oe):Q({bytesWritten:X,buffer:ve}))})}get appendFile(){return(0,g.promisify)(D.appendFile)}get fdatasync(){return(0,g.promisify)(D.fdatasync)}get truncate(){return(0,g.promisify)(D.truncate)}get copyFile(){return(0,g.promisify)(D.copyFile)}get open(){return(0,g.promisify)(D.open)}get close(){return(0,g.promisify)(D.close)}get symlink(){return(0,g.promisify)(D.symlink)}get readlink(){return(0,g.promisify)(D.readlink)}get chmod(){return(0,g.promisify)(D.chmod)}get mkdir(){return(0,g.promisify)(D.mkdir)}get unlink(){return(0,g.promisify)(D.unlink)}get rmdir(){return(0,g.promisify)(D.rmdir)}get realpath(){return(0,g.promisify)(D.realpath)}async exists(M){try{return await e.Promises.access(M),!0}catch{return!1}}get readdir(){return s}get readDirsInDir(){return a}get writeFile(){return u}get rm(){return v}get rename(){return p}get copy(){return P}}}),define(Ee[103],Se([1,0,55,16,11,13,31]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.$dq=e.$cq=void 0;function b(m){if(g.$k)return m;const v=(0,N.$lc)(m);if(m===v)return m;const S=((0,N.$mc)(m)||m).toLowerCase();try{const d=(0,L.readdirSync)(v).filter(s=>s.toLowerCase()===S);if(d.length===1){const s=b(v);if(s)return(0,N.$ic)(s,d[0])}else if(d.length>1){const s=d.indexOf(S);if(s>=0){const i=b(v);if(i)return(0,N.$ic)(i,d[s])}}}catch{}return null}e.$cq=b;async function $(m){if(g.$k)return m;const v=(0,N.$lc)(m);if(m===v)return m;const S=((0,N.$mc)(m)||m).toLowerCase();try{const d=(await L.Promises.readdir(v)).filter(s=>s.toLowerCase()===S);if(d.length===1){const s=await $(v);if(s)return(0,N.$ic)(s,d[0])}else if(d.length>1){const s=d.indexOf(S);if(s>=0){const i=await $(v);if(i)return(0,N.$ic)(i,d[s])}}}catch{}return null}e.$dq=$;async function y(m){try{return await L.Promises.realpath(m)}catch{const S=C(m);return await L.Promises.access(S,D.constants.R_OK),S}}e.$eq=y;function A(m){try{return D.realpathSync(m)}catch{const S=C(m);return D.accessSync(S,D.constants.R_OK),S}}e.$fq=A;function C(m){return(0,I.$Oe)((0,N.$gc)(m),N.sep)}}),define(Ee[104],Se([1,0,16,11,50,101,18,31]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ml=e.$Ll=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function $(C=g.env){return C.comspec||"cmd.exe"}e.$Ll=$;function y(C){let m=[],v=!1;const S=function(f){if(v){m.push(f);return}(!C.send(f,s=>{if(s&&console.error(s),v=!1,m.length>0){const i=m.slice(0);m=[],i.forEach(n=>S(n))}})||N.$i)&&(v=!0)};return{send:S}}e.$Ml=y;var A;(function(C){async function m(v,S,f){if(D.$hc(v))return v;if(S===void 0&&(S=g.cwd()),D.$lc(v)!=="."||(f===void 0&&L.$Cf(g.env.PATH)&&(f=g.env.PATH.split(D.$sc)),f===void 0||f.length===0))return D.$ic(S,v);async function s(i){if(await b.Promises.exists(i)){let n;try{n=await b.Promises.stat(i)}catch(o){o.message.startsWith("EACCES")&&(n=await b.Promises.lstat(i))}return n?!n.isDirectory():!1}return!1}for(const i of f){let n;if(D.$hc(i)?n=D.$ic(i,v):n=D.$ic(S,i,v),await s(n))return n;let o=n+".com";if(await s(o)||(o=n+".exe",await s(o)))return o}return D.$ic(S,v)}C.findExecutable=m})(A||(e.win32=A={}))});var Ke=this&&this.__decorate||function($e,e,D,N){var g=arguments.length,I=g<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,D):N,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")I=Reflect.decorate($e,e,D,N);else for(var b=$e.length-1;b>=0;b--)(L=$e[b])&&(I=(g<3?L(I):g>3?L(e,D,I):L(e,D))||I);return g>3&&I&&Object.defineProperty(e,D,I),I};define(Ee[81],Se([1,0,19,12,22,21,59,8,4,3,54,13,18]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ih=e.ProxyChannel=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.RequestInitiator=e.$Bh=e.$Ah=e.$zh=e.$yh=e.$xh=void 0;var v;(function(Z){Z[Z.Promise=100]="Promise",Z[Z.PromiseCancel=101]="PromiseCancel",Z[Z.EventListen=102]="EventListen",Z[Z.EventDispose=103]="EventDispose"})(v||(v={}));function S(Z){switch(Z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(Z){Z[Z.Initialize=200]="Initialize",Z[Z.PromiseSuccess=201]="PromiseSuccess",Z[Z.PromiseError=202]="PromiseError",Z[Z.PromiseErrorObj=203]="PromiseErrorObj",Z[Z.EventFire=204]="EventFire"})(f||(f={}));function d(Z){switch(Z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var s;(function(Z){Z[Z.Uninitialized=0]="Uninitialized",Z[Z.Idle=1]="Idle"})(s||(s={}));function i(Z){let Q=0;for(let x=0;;x+=7){const oe=Z.read(1);if(Q|=(oe.buffer[0]&127)<<x,!(oe.buffer[0]&128))return Q}}const n=h(0);function o(Z,Q){if(Q===0){Z.write(n);return}let x=0;for(let X=Q;X!==0;X=X>>>7)x++;const oe=g.$fe.alloc(x);for(let X=0;Q!==0;X++)oe.buffer[X]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[X]|=128);Z.write(oe)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const x=this.b.slice(this.a,this.a+Q);return this.a+=x.byteLength,x}}e.$xh=a;class t{constructor(){this.a=[]}get buffer(){return g.$fe.concat(this.a)}write(Q){this.a.push(Q)}}e.$yh=t;var r;(function(Z){Z[Z.Undefined=0]="Undefined",Z[Z.String=1]="String",Z[Z.Buffer=2]="Buffer",Z[Z.VSBuffer=3]="VSBuffer",Z[Z.Array=4]="Array",Z[Z.Object=5]="Object",Z[Z.Int=6]="Int"})(r||(r={}));function h(Z){const Q=g.$fe.alloc(1);return Q.writeUInt8(Z,0),Q}const u={Undefined:h(r.Undefined),String:h(r.String),Buffer:h(r.Buffer),VSBuffer:h(r.VSBuffer),Array:h(r.Array),Object:h(r.Object),Uint:h(r.Int)},c=typeof Buffer<"u";function l(Z,Q){if(typeof Q>"u")Z.write(u.Undefined);else if(typeof Q=="string"){const x=g.$fe.fromString(Q);Z.write(u.String),o(Z,x.byteLength),Z.write(x)}else if(c&&Buffer.isBuffer(Q)){const x=g.$fe.wrap(Q);Z.write(u.Buffer),o(Z,x.byteLength),Z.write(x)}else if(Q instanceof g.$fe)Z.write(u.VSBuffer),o(Z,Q.byteLength),Z.write(Q);else if(Array.isArray(Q)){Z.write(u.Array),o(Z,Q.length);for(const x of Q)l(Z,x)}else if(typeof Q=="number"&&(Q|0)===Q)Z.write(u.Uint),o(Z,Q);else{const x=g.$fe.fromString(JSON.stringify(Q));Z.write(u.Object),o(Z,x.byteLength),Z.write(x)}}e.$zh=l;function k(Z){switch(Z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return Z.read(i(Z)).toString();case r.Buffer:return Z.read(i(Z)).buffer;case r.VSBuffer:return Z.read(i(Z));case r.Array:{const x=i(Z),oe=[];for(let X=0;X<x;X++)oe.push(k(Z));return oe}case r.Object:return JSON.parse(Z.read(i(Z)).toString());case r.Int:return i(Z)}}e.$Ah=k;class R{constructor(Q,x,oe=null,X=1e3){this.h=Q,this.j=x,this.k=oe,this.l=X,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ve=>this.q(ve)),this.m({type:200})}registerChannel(Q,x){this.b.set(Q,x),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const x=this.o([Q.type]);this.k?.logOutgoing(x,0,1,d(Q.type));return}case 201:case 202:case 204:case 203:{const x=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(x,Q.id,1,d(Q.type),Q.data);return}}}o(Q,x=void 0){const oe=new t;return l(oe,Q),l(oe,x),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const x=new a(Q),oe=k(x),X=k(x),ve=oe[0];switch(ve){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(ve)}: ${oe[2]}.${oe[3]}`,X),this.s({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:X});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(ve)}: ${oe[2]}.${oe[3]}`,X),this.t({type:ve,id:oe[1],channelName:oe[2],name:oe[3],arg:X});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(ve)}`),this.u({type:ve,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${S(ve)}`),this.u({type:ve,id:oe[1]})}}s(Q){const x=this.b.get(Q.channelName);if(!x){this.v(Q);return}const oe=new I.$2d;let X;try{X=x.call(this.j,Q.name,Q.arg,oe.token)}catch(V){X=Promise.reject(V)}const ve=Q.id;X.then(V=>{this.m({id:ve,data:V,type:201})},V=>{V instanceof Error?this.m({id:ve,data:{message:V.message,name:V.name,stack:V.stack?V.stack.split?V.stack.split(`
`):V.stack:void 0},type:202}):this.m({id:ve,data:V,type:203})}).finally(()=>{ge.dispose(),this.d.delete(Q.id)});const ge=(0,y.$Pc)(()=>oe.cancel());this.d.set(Q.id,ge)}t(Q){const x=this.b.get(Q.channelName);if(!x){this.v(Q);return}const oe=Q.id,ve=x.listen(this.j,Q.name,Q.arg)(ge=>this.m({id:oe,data:ge,type:204}));this.d.set(Q.id,ve)}u(Q){const x=this.d.get(Q.id);x&&(x.dispose(),this.d.delete(Q.id))}v(Q){let x=this.g.get(Q.channelName);x||(x=[],this.g.set(Q.channelName,x));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);x.push({request:Q,timeoutTimer:oe})}w(Q){const x=this.g.get(Q);if(x){for(const oe of x)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,y.$Mc)(this.d.values()),this.d.clear()}}e.$Bh=R;var w;(function(Z){Z[Z.LocalSide=0]="LocalSide",Z[Z.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class p{constructor(Q,x=null){this.l=Q,this.a=!1,this.b=s.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Rd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=x}getChannel(Q){const x=this;return{call(oe,X,ve){return x.a?Promise.reject(new b.$4):x.m(Q,oe,X,ve)},listen(oe,X){return x.a?$.Event.None:x.o(Q,oe,X)}}}m(Q,x,oe,X=I.CancellationToken.None){const ve=this.g++,V={id:ve,type:100,channelName:Q,name:x,arg:oe};if(X.isCancellationRequested)return Promise.reject(new b.$4);let U;return new Promise((ye,fe)=>{if(X.isCancellationRequested)return fe(new b.$4);const me=()=>{const te=J=>{switch(J.type){case 201:this.f.delete(ve),ye(J.data);break;case 202:{this.f.delete(ve);const ce=new Error(J.data.message);ce.stack=Array.isArray(J.data.stack)?J.data.stack.join(`
`):J.data.stack,ce.name=J.data.name,fe(ce);break}case 203:this.f.delete(ve),fe(J.data);break}};this.f.set(ve,te),this.p(V)};let ee=null;this.b===s.Idle?me():(ee=(0,N.$Ng)(te=>this.u()),ee.then(()=>{ee=null,me()}));const ie=()=>{ee?(ee.cancel(),ee=null):this.p({id:ve,type:101}),fe(new b.$4)},G=X.onCancellationRequested(ie);U=(0,y.$Oc)((0,y.$Pc)(ie),G),this.d.add(U)}).finally(()=>{U.dispose(),this.d.delete(U)})}o(Q,x,oe){const X=this.g++,ge={id:X,type:102,channelName:Q,name:x,arg:oe};let V=null;const U=new $.$Rd({onWillAddFirstListener:()=>{V=(0,N.$Ng)(ye=>this.u()),V.then(()=>{V=null,this.d.add(U),this.p(ge)})},onDidRemoveLastListener:()=>{V?(V.cancel(),V=null):(this.d.delete(U),this.p({id:X,type:103}))}}),ne=ye=>U.fire(ye.data);return this.f.set(X,ne),U.event}p(Q){switch(Q.type){case 100:case 102:{const x=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(x,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const x=this.q([Q.type,Q.id]);this.j?.logOutgoing(x,Q.id,0,S(Q.type));return}}}q(Q,x=void 0){const oe=new t;return l(oe,Q),l(oe,x),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const x=new a(Q),oe=k(x),X=k(x),ve=oe[0];switch(ve){case 200:return this.j?.logIncoming(Q.byteLength,0,0,d(ve)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,d(ve),X),this.t({type:oe[0],id:oe[1],data:X})}}t(Q){if(Q.type===200){this.b=s.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===s.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,y.$Mc)(this.d.values()),this.d.clear()}}e.$Ch=p,Ke([L.$rh],p.prototype,"onDidInitializePromise",null);class E{get connections(){const Q=[];return this.f.forEach(x=>Q.push(x)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$Rd,this.onDidAddConnection=this.g.event,this.h=new $.$Rd,this.onDidRemoveConnection=this.h.event,this.j=new y.$Qc,this.j.add(Q(({protocol:x,onDidClientDisconnect:oe})=>{const X=$.Event.once(x.onMessage);this.j.add(X(ve=>{const ge=new a(ve),V=k(ge),U=new R(x,V),ne=new p(x);this.a.forEach((fe,me)=>U.registerChannel(me,fe));const ye={channelServer:U,channelClient:ne,ctx:V};this.f.add(ye),this.g.fire(ye),this.j.add(oe(()=>{U.dispose(),ne.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Q,x){const oe=this;return{call(X,ve,ge){let V;if((0,m.$Qf)(x)){const ne=(0,D.$3b)(oe.connections.filter(x));V=ne?Promise.resolve(ne):$.Event.toPromise($.Event.filter(oe.onDidAddConnection,x))}else V=x.routeCall(oe,X,ve);const U=V.then(ne=>ne.channelClient.getChannel(Q));return z(U).call(X,ve,ge)},listen(X,ve){if((0,m.$Qf)(x))return oe.k(Q,x,X,ve);const ge=x.routeEvent(oe,X,ve).then(V=>V.channelClient.getChannel(Q));return z(ge).listen(X,ve)}}}k(Q,x,oe,X){const ve=this;let ge;const V=new $.$Rd({onWillAddFirstListener:()=>{ge=new y.$Qc;const U=new $.$Xd,ne=new Map,ye=me=>{const ie=me.channelClient.getChannel(Q).listen(oe,X),G=U.add(ie);ne.set(me,G)},fe=me=>{const ee=ne.get(me);ee&&(ee.dispose(),ne.delete(me))};ve.connections.filter(x).forEach(ye),$.Event.filter(ve.onDidAddConnection,x)(ye,void 0,ge),ve.onDidRemoveConnection(fe,void 0,ge),U.event(V.fire,V,ge),ge.add(U)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return V.event}registerChannel(Q,x){this.a.set(Q,x);for(const oe of this.f)oe.channelServer.registerChannel(Q,x)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Dh=E;class P{constructor(Q,x,oe=null){const X=new t;l(X,x),Q.send(X.buffer),this.a=new p(Q,oe),this.d=new R(Q,x,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,x){this.d.registerChannel(Q,x)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Eh=P;function z(Z){return{call(Q,x,oe){return Z.then(X=>X.call(Q,x,oe))},listen(Q,x){const oe=new $.$1d;return Z.then(X=>oe.input=X.listen(Q,x)),oe.event}}}e.$Fh=z;function j(Z){let Q=!1;return{call(x,oe,X){return Q?Z.call(x,oe,X):(0,N.$1g)(0).then(()=>Q=!0).then(()=>Z.call(x,oe,X))},listen(x,oe){if(Q)return Z.listen(x,oe);const X=new $.$1d;return(0,N.$1g)(0).then(()=>Q=!0).then(()=>X.input=Z.listen(x,oe)),X.event}}}e.$Gh=j;class F{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const x of Q.connections)if(await Promise.resolve(this.a(x.ctx)))return Promise.resolve(x);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Hh=F;var O;(function(Z){function Q(ve,ge,V){const U=ve,ne=V&&V.disableMarshalling,ye=new Map;for(const fe in U)oe(fe)&&ye.set(fe,$.Event.buffer(U[fe],!0,void 0,ge));return new class{listen(fe,me,ee){const ie=ye.get(me);if(ie)return ie;if(X(me)){const G=U[me];if(typeof G=="function")return G.call(U,ee)}throw new b.$ab(`Event not found: ${me}`)}call(fe,me,ee){const ie=U[me];if(typeof ie=="function"){if(!ne&&Array.isArray(ee))for(let te=0;te<ee.length;te++)ee[te]=(0,A.$wh)(ee[te]);let G=ie.apply(U,ee);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new b.$ab(`Method not found: ${me}`)}}}Z.fromService=Q;function x(ve,ge){const V=ge&&ge.disableMarshalling;return new Proxy({},{get(U,ne){if(typeof ne=="string")return ge?.properties?.has(ne)?ge.properties.get(ne):X(ne)?function(ye){return ve.listen(ne,ye)}:oe(ne)?ve.listen(ne):async function(...ye){let fe;ge&&!(0,m.$Lf)(ge.context)?fe=[ge.context,...ye]:fe=ye;const me=await ve.call(ne,fe);return V?me:(0,A.$wh)(me)};throw new b.$ab(`Property not found: ${String(ne)}`)}})}Z.toService=x;function oe(ve){return ve[0]==="o"&&ve[1]==="n"&&C.$5e(ve.charCodeAt(2))}function X(ve){return/^onDynamic/.test(ve)&&C.$5e(ve.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const T=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function M(Z){if(Array.isArray(Z))return Z;if(Z&&typeof Z=="object"&&typeof Z.toString=="function"){const Q=Z.toString();if(Q!=="[object Object]")return Q}return Z}function W(Z){return Array.isArray(Z)?Z.map(M):M(Z)}function Y(Z,Q,x,oe,X,ve,ge){ge=W(ge);const V=T[X],U=V[oe%V.length];let ne=[`%c[${Z}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(x).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${ve}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ve)?(ne=ne.concat(ge),ne.push(")")):ne.push(ge),console.log.apply(console,ne)}class ue{constructor(Q,x){this.d=Q,this.f=x,this.a=0,this.b=0}logOutgoing(Q,x,oe,X,ve){this.b+=Q,Y(this.d,this.b,Q,x,oe,X,ve)}logIncoming(Q,x,oe,X,ve){this.a+=Q,Y(this.f,this.a,Q,x,oe,X,ve)}}e.$Ih=ue}),define(Ee[82],Se([1,0,22,4,3,81]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.ProtocolConstants=e.$Jh=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var L;(function(u){u.Created="created",u.Read="read",u.Write="write",u.Open="open",u.Error="error",u.Close="close",u.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",u.NodeEndReceived="nodeEndReceived",u.NodeEndSent="nodeEndSent",u.NodeDrainBegin="nodeDrainBegin",u.NodeDrainEnd="nodeDrainEnd",u.zlibInflateError="zlibInflateError",u.zlibInflateData="zlibInflateData",u.zlibInflateInitialWrite="zlibInflateInitialWrite",u.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",u.zlibInflateWrite="zlibInflateWrite",u.zlibInflateFlushFired="zlibInflateFlushFired",u.zlibDeflateError="zlibDeflateError",u.zlibDeflateData="zlibDeflateData",u.zlibDeflateWrite="zlibDeflateWrite",u.zlibDeflateFlushFired="zlibDeflateFlushFired",u.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",u.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",u.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",u.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",u.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",u.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",u.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",u.ProtocolHeaderRead="protocolHeaderRead",u.ProtocolMessageRead="protocolMessageRead",u.ProtocolHeaderWrite="protocolHeaderWrite",u.ProtocolMessageWrite="protocolMessageWrite",u.ProtocolWrite="protocolWrite"})(L||(e.SocketDiagnosticsEventType=L={}));var b;(function(u){u.enableDiagnostics=!1,u.records=[];const c=new WeakMap;let l=0;function k(w,p){if(!c.has(w)){const E=String(++l);c.set(w,E)}return c.get(w)}function R(w,p,E,P){if(!u.enableDiagnostics)return;const z=k(w,p);if(P instanceof D.$fe||P instanceof Uint8Array||P instanceof ArrayBuffer||ArrayBuffer.isView(P)){const j=D.$fe.alloc(P.byteLength);j.set(P),u.records.push({timestamp:Date.now(),id:z,label:p,type:E,buff:j})}else u.records.push({timestamp:Date.now(),id:z,label:p,type:E,data:P})}u.traceSocketEvent=R})(b||(e.SocketDiagnostics=b={}));var $;(function(u){u[u.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",u[u.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let y=null;function A(){return y||(y=D.$fe.alloc(0)),y}class C{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(c){this.a.push(c),this.b+=c.byteLength}read(c){return this.c(c,!0)}peek(c){return this.c(c,!1)}c(c,l){if(c===0)return A();if(c>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===c){const p=this.a[0];return l&&(this.a.shift(),this.b-=c),p}if(this.a[0].byteLength>c){const p=this.a[0].slice(0,c);return l&&(this.a[0]=this.a[0].slice(c),this.b-=c),p}const k=D.$fe.alloc(c);let R=0,w=0;for(;c>0;){const p=this.a[w];if(p.byteLength>c){const E=p.slice(0,c);k.set(E,R),R+=c,l&&(this.a[w]=p.slice(c),this.b-=c),c-=c}else k.set(p,R),R+=p.byteLength,l?(this.a.shift(),this.b-=p.byteLength):w++,c-=p.byteLength}return k}}e.$Jh=C;var m;(function(u){u[u.None=0]="None",u[u.Regular=1]="Regular",u[u.Control=2]="Control",u[u.Ack=3]="Ack",u[u.Disconnect=5]="Disconnect",u[u.ReplayRequest=6]="ReplayRequest",u[u.Pause=7]="Pause",u[u.Resume=8]="Resume",u[u.KeepAlive=9]="KeepAlive"})(m||(m={}));function v(u){switch(u){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(u){u[u.HeaderLength=13]="HeaderLength",u[u.AcknowledgeTime=2e3]="AcknowledgeTime",u[u.TimeoutTime=2e4]="TimeoutTime",u[u.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",u[u.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",u[u.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class f{constructor(c,l,k,R){this.type=c,this.id=l,this.ack=k,this.data=R,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends g.$Rc{constructor(c){super(),this.f=this.B(new N.$Rd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=c,this.b=!1,this.c=new C,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(c){if(!(!c||c.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(c);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:v(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const k=this.g.messageType,R=this.g.id,w=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new f(k,R,w,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class s{constructor(c){this.k=null,this.a=!1,this.b=!1,this.c=c,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(c){if(this.a)return;c.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.$fe.alloc(13);l.writeUInt8(c.type,0),l.writeUInt32BE(c.id,1),l.writeUInt32BE(c.ack,5),l.writeUInt32BE(c.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:v(c.type),id:c.id,ack:c.ack,messageSize:c.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",c.data),this.j(l,c.data)}g(c,l){const k=this.f===0;return this.d.push(c,l),this.f+=c.byteLength+l.byteLength,k}h(){const c=D.$fe.concat(this.d,this.f);return this.d.length=0,this.f=0,c}j(c,l){this.g(c,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const c=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:c.byteLength}),this.c.write(c)}}class i extends g.$Rc{constructor(c){super(),this.f=new N.$Rd,this.onMessage=this.f.event,this.g=new N.$Rd,this.onDidDispose=this.g.event,this.a=c,this.b=this.B(new s(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(c){this.b.write(new f(1,0,0,c))}}e.$Kh=i;class n extends I.$Eh{static fromSocket(c,l){return new n(new i(c),l)}get onDidDispose(){return this.b.onDidDispose}constructor(c,l,k=null){super(c,l,k),this.b=c}dispose(){super.dispose();const c=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),c.end()}}e.$Lh=n;class o{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Rd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(c){this.b?this.d.length>0?this.d.push(c):this.a.fire(c):this.d.push(c)}flushBuffer(){this.d=[]}}e.$Mh=o;class a{constructor(c){this.data=c,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let c=0,l=this.a;for(;l;)l=l.next,c++;return c}peek(){return this.a?this.a.data:null}toArray(){const c=[];let l=0,k=this.a;for(;k;)c[l++]=k.data,k=k.next;return c}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(c){const l=new a(c);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const c=Date.now();for(let l=0;l<r.a;l++)this.c[l]=c-1e3*l;setInterval(()=>{for(let l=r.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const c=Date.now(),l=(1+r.a)*1e3;let k=0;for(let R=0;R<r.a;R++)c-this.c[R]<=l&&k++;return 1-k/r.a}hasHighLoad(){return this.d()>=.5}}class h{get unacknowledgedCount(){return this.c-this.d}constructor(c){this.u=new o,this.onControlMessage=this.u.event,this.v=new o,this.onMessage=this.v.event,this.w=new o,this.onDidDispose=this.w.event,this.x=new o,this.onSocketClose=this.x.event,this.y=new o,this.onSocketTimeout=this.y.event,this.s=c.loadEstimator??r.getInstance(),this.t=c.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new g.$Qc,this.o=c.socket,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),c.initialChunk&&this.q.acceptChunk(c.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const c=new f(5,0,0,A());this.p.write(c),this.p.flush()}sendPause(){const c=new f(7,0,0,A());this.p.write(c)}sendResume(){const c=new f(8,0,0,A());this.p.write(c)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(c,l){this.a=!0,this.r.dispose(),this.r=new g.$Qc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=c,this.p=this.r.add(new s(this.o)),this.q=this.r.add(new d(this.o)),this.r.add(this.q.onMessage(k=>this.z(k))),this.r.add(this.o.onClose(k=>this.x.fire(k))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const c=new f(3,0,this.h,A());this.p.write(c);const l=this.b.toArray();for(let k=0,R=l.length;k<R;k++)this.p.write(l[k]);this.B()}acceptDisconnect(){this.w.fire()}z(c){if(c.ack>this.d){this.d=c.ack;do{const l=this.b.peek();if(l&&l.id<=c.ack)this.b.pop();else break}while(!0)}switch(c.type){case 0:break;case 1:{if(c.id>this.g)if(c.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new f(6,0,0,A())))}else this.g=c.id,this.j=Date.now(),this.A(),this.v.fire(c.data);break}case 2:{this.u.fire(c.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let k=0,R=l.length;k<R;k++)this.p.write(l[k]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(c){const l=++this.c;this.h=this.g;const k=new f(1,l,this.h,c);this.b.push(k),this.a||(this.p.write(k),this.B())}sendControl(c){const l=new f(2,0,0,c);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const c=Date.now()-this.j;if(c>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-c+5)}B(){if(this.c<=this.d||this.f||this.a)return;const c=this.b.peek(),l=Date.now()-c.writtenTime,k=Date.now()-this.q.lastReadTime,R=Date.now()-this.n;if(l>=2e4&&k>=2e4&&R>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:k});return}const w=Math.max(2e4-l,2e4-k,2e4-R,500);this.f=setTimeout(()=>{this.f=null,this.B()},w)}C(){if(this.g<=this.h)return;this.h=this.g;const c=new f(3,0,this.h,A());this.p.write(c)}D(){this.h=this.g;const c=new f(9,0,this.h,A());this.p.write(c)}}e.$Nh=h}),define(Ee[186],Se([1,0,51,12,22,21,184,8,4,3,24,104,101,81]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=void 0;class S extends v.$Bh{constructor(s){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>g.$fe.wrap(Buffer.from(i,"base64")))},s),process.once("disconnect",()=>this.dispose())}}e.$_p=S;class f{constructor(s,i){this.i=s,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Rd,this.onDidProcessExit=this.h.event;const n=i&&i.timeout?i.timeout:6e4;this.b=new N.$Wg(n),this.d=null,this.f=null}getChannel(s){const i=this;return{call(n,o,a){return i.k(s,n,o,a)},listen(n,o){return i.l(s,n,o)}}}k(s,i,n,o=I.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(o.isCancellationRequested)return Promise.reject(b.$5());this.b.cancel();const a=this.n(s),t=(0,N.$Ng)(u=>a.call(i,n,u)),r=o.onCancellationRequested(()=>t.cancel()),h=(0,y.$Pc)(()=>t.cancel());return this.c.add(h),t.finally(()=>{r.dispose(),this.c.delete(h),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(s,i,n){if(!this.b)return $.Event.None;this.b.cancel();let o;const a=new $.$Rd({onWillAddFirstListener:()=>{o=this.n(s).listen(i,n)(a.fire,a),this.c.add(o)},onDidRemoveLastListener:()=>{this.c.delete(o),o.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const s=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$en)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c)).filter(c=>!c.startsWith("--vscode-"))),(0,m.$Kl)(i.env),this.d=(0,D.fork)(this.i,s,i);const n=new $.$Rd;$.Event.fromNodeEventEmitter(this.d,"message",c=>c)(c=>{if((0,L.$8p)(c)){(0,L.log)(c,`IPC Library: ${this.j.serverName}`);return}n.fire(g.$fe.wrap(Buffer.from(c,"base64")))});const a=this.j.useQueue?(0,C.$Ml)(this.d):this.d,t=c=>this.d&&this.d.connected&&a.send(c.buffer.toString("base64")),r=n.event,h={send:t,onMessage:r};this.f=new v.$Ch(h);const u=()=>this.o();process.once("exit",u),this.d.on("error",c=>console.warn('IPC "'+this.j.serverName+'" errored with '+c)),this.d.on("exit",(c,l)=>{process.removeListener("exit",u),this.c.forEach(k=>(0,y.$Mc)(k)),this.c.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+c+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:c,signal:l})})}return this.f}n(s){let i=this.g.get(s);return i||(i=this.m.getChannel(s),this.g.set(s,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$aq=f}),define(Ee[187],Se([1,0,12,4,3,54,18]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ap=e.$_o=e.StorageState=e.$$o=e.StorageHint=void 0;var b;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(b||(e.StorageHint=b={}));function $(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.$$o=$;var y;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(y||(e.StorageState=y={}));class A extends g.$Rc{static{this.a=100}constructor(v,S=Object.create(null)){super(),this.r=v,this.s=S,this.b=this.B(new N.$Ud),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=this.B(new D.$Xg(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(v=>this.u(v)))}u(v){this.b.pause();try{v.changed?.forEach((S,f)=>this.w(f,S)),v.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(v,S){if(this.c===y.Closed)return;let f=!1;(0,L.$Lf)(S)?f=this.f.delete(v):this.f.get(v)!==S&&(this.f.set(v,S),f=!0),f&&this.b.fire({key:v,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.s.hint!==b.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(v,S){const f=this.f.get(v);return(0,L.$Lf)(f)?S:f}getBoolean(v,S){const f=this.get(v);return(0,L.$Lf)(f)?S:f==="true"}getNumber(v,S){const f=this.get(v);return(0,L.$Lf)(f)?S:parseInt(f,10)}getObject(v,S){const f=this.get(v);return(0,L.$Lf)(f)?S:(0,I.$vh)(f)}async set(v,S,f=!1){if(this.c===y.Closed)return;if((0,L.$Lf)(S))return this.delete(v,f);const d=(0,L.$Ef)(S)||Array.isArray(S)?(0,I.$uh)(S):String(S);if(this.f.get(v)!==d)return this.f.set(v,d),this.j.set(v,d),this.h.delete(v),this.b.fire({key:v,external:f}),this.D()}async delete(v,S=!1){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire({key:v,external:S}),this.D()}async optimize(){if(this.c!==y.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=y.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(v).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(v){if(this.z)return this.D(v)}async D(v){return this.s.hint===b.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),v)}async whenFlushed(){if(this.z)return new Promise(v=>this.n.push(v))}isInMemory(){return this.s.hint===b.STORAGE_IN_MEMORY}}e.$_o=A;class C{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((S,f)=>this.a.set(f,S)),v.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$ap=C}),define(Ee[188],Se([1,0,13,11,22]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0;let I;function L(){return I||(I=new TextDecoder("UTF-16LE")),I}let b;function $(){return b||(b=new TextDecoder("UTF-16BE")),b}let y;function A(){return y||(y=N.$D()?L():$()),y}e.$Vs=A;function C(S,f,d){const s=new Uint16Array(S.buffer,f,d);return d>0&&(s[0]===65279||s[0]===65534)?m(S,f,d):L().decode(s)}e.$Ws=C;function m(S,f,d){const s=[];let i=0;for(let n=0;n<d;n++){const o=g.$he(S,f);f+=2,s[i++]=String.fromCharCode(o)}return s.join("")}class v{constructor(f){this.a=f|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const f=new Uint16Array(this.b.buffer,0,this.d);return A().decode(f)}f(){const f=this.e();this.d=0,this.c===null?this.c=[f]:this.c[this.c.length]=f}appendCharCode(f){const d=this.a-this.d;d<=1&&(d===0||D.$0e(f))&&this.f(),this.b[this.d++]=f}appendASCIICharCode(f){this.d===this.a&&this.f(),this.b[this.d++]=f}appendString(f){const d=f.length;if(this.d+d>=this.a){this.f(),this.c[this.c.length]=f;return}for(let s=0;s<d;s++)this.b[this.d++]=f.charCodeAt(s)}}e.$Xs=v}),define(Ee[189],Se([1,0,22,188]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=void 0;function g($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class I{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,A,C,m){this.oldPosition=y,this.oldText=A,this.newPosition=C,this.newText=m}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${g(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${g(this.oldText)}")`:`(replace@${this.oldPosition} "${g(this.oldText)}" with "${g(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,A,C){const m=A.length;D.$ke(y,m,C),C+=4;for(let v=0;v<m;v++)D.$ie(y,A.charCodeAt(v),C),C+=2;return C}static d(y,A){const C=D.$je(y,A);return A+=4,(0,N.$Ws)(y,A,C)}writeSize(){return 4+4+I.a(this.oldText)+I.a(this.newText)}write(y,A){return D.$ke(y,this.oldPosition,A),A+=4,D.$ke(y,this.newPosition,A),A+=4,A=I.c(y,this.oldText,A),A=I.c(y,this.newText,A),A}static read(y,A,C){const m=D.$je(y,A);A+=4;const v=D.$je(y,A);A+=4;const S=I.d(y,A);A+=I.a(S);const f=I.d(y,A);return A+=I.a(f),C.push(new I(m,S,v,f)),A}}e.$Ys=I;function L($,y){return $===null||$.length===0?y:new b($,y).compress()}e.$Zs=L;class b{constructor(y,A){this.a=y,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,A=0,C=this.n(y),m=this.l(A);for(;y<this.f||A<this.h;){if(C===null){this.k(m),m=this.l(++A);continue}if(m===null){this.m(C),C=this.n(++y);continue}if(m.oldEnd<=C.newPosition){this.k(m),m=this.l(++A);continue}if(C.newEnd<=m.oldPosition){this.m(C),C=this.n(++y);continue}if(m.oldPosition<C.newPosition){const[s,i]=b.r(m,C.newPosition-m.oldPosition);this.k(s),m=i;continue}if(C.newPosition<m.oldPosition){const[s,i]=b.q(C,m.oldPosition-C.newPosition);this.m(s),C=i;continue}let f,d;if(m.oldEnd===C.newEnd)f=C,d=m,C=this.n(++y),m=this.l(++A);else if(m.oldEnd<C.newEnd){const[s,i]=b.q(C,m.oldLength);f=s,d=m,C=i,m=this.l(++A)}else{const[s,i]=b.r(m,C.newLength);f=C,d=s,C=this.n(++y),m=i}this.d[this.e++]=new I(f.oldPosition,f.oldText,d.newPosition,d.newText),this.g+=f.newLength-f.oldLength,this.j+=d.newLength-d.oldLength}const v=b.s(this.d);return b.t(v)}k(y){this.d[this.e++]=b.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=b.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,A){return new I(A.oldPosition-y,A.oldText,A.newPosition,A.newText)}static p(y,A){return new I(A.oldPosition,A.oldText,A.newPosition+y,A.newText)}static q(y,A){const C=y.newText.substr(0,A),m=y.newText.substr(A);return[new I(y.oldPosition,y.oldText,y.newPosition,C),new I(y.oldEnd,"",y.newPosition+A,m)]}static r(y,A){const C=y.oldText.substr(0,A),m=y.oldText.substr(A);return[new I(y.oldPosition,C,y.newPosition,y.newText),new I(y.oldPosition+A,m,y.newEnd,"")]}static s(y){if(y.length===0)return y;const A=[];let C=0,m=y[0];for(let v=1;v<y.length;v++){const S=y[v];m.oldEnd===S.oldPosition?m=new I(m.oldPosition,m.oldText+S.oldText,m.newPosition,m.newText+S.newText):(A[C++]=m,m=S)}return A[C++]=m,A}static t(y){if(y.length===0)return y;const A=[];let C=0;for(let m=0;m<y.length;m++){const v=y[m];v.oldText!==v.newText&&(A[C++]=v)}return A}}}),define(Ee[190],Se([1,0,34,16]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;function g(I,L,b,$,y,A){if(Array.isArray(I)){let C=0;for(const m of I){const v=g(m,L,b,$,y,A);if(v===10)return v;v>C&&(C=v)}return C}else{if(typeof I=="string")return $?I==="*"?5:I===b?10:0:0;if(I){const{language:C,pattern:m,scheme:v,hasAccessToAllModels:S,notebookType:f}=I;if(!$&&!S)return 0;f&&y&&(L=y);let d=0;if(v)if(v===L.scheme)d=10;else if(v==="*")d=5;else return 0;if(C)if(C===b)d=10;else if(C==="*")d=Math.max(d,5);else return 0;if(f)if(f===A)d=10;else if(f==="*"&&A!==void 0)d=Math.max(d,5);else return 0;if(m){let s;if(typeof m=="string"?s=m:s={...m,base:(0,N.$gc)(m.base)},s===L.fsPath||(0,D.$Fj)(s,L.fsPath))d=10;else return 0}return d}else return 0}}e.$kt=g}),define(Ee[191],Se([1,0,4,13,29,79,127,166,189,3]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class A extends y.$Rc{constructor(m,v,S,f,d,s,i){super(),this.m=this.B(new D.$Rd),this.onDidChangeContent=this.m.event,this.f=v,this.j=!s,this.g=f,this.h=d,this.c=new L.$QB(m,S,i)}equals(m){return!(m instanceof A)||this.f!==m.f||this.getEOL()!==m.getEOL()?!1:this.c.equal(m.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(m){return this.c.createSnapshot(m?this.f:"")}getOffsetAt(m,v){return this.c.getOffsetAt(m,v)}getPositionAt(m){return this.c.getPositionAt(m)}getRangeAt(m,v){const S=m+v,f=this.getPositionAt(m),d=this.getPositionAt(S);return new g.$Ds(f.lineNumber,f.column,d.lineNumber,d.column)}getValueInRange(m,v=0){if(m.isEmpty())return"";const S=this.n(v);return this.c.getValueInRange(m,S)}getValueLengthInRange(m,v=0){if(m.isEmpty())return 0;if(m.startLineNumber===m.endLineNumber)return m.endColumn-m.startColumn;const S=this.getOffsetAt(m.startLineNumber,m.startColumn),f=this.getOffsetAt(m.endLineNumber,m.endColumn);let d=0;const s=this.n(v),i=this.getEOL();if(s.length!==i.length){const n=s.length-i.length,o=m.endLineNumber-m.startLineNumber;d=n*o}return f-S+d}getCharacterCountInRange(m,v=0){if(this.j){let S=0;const f=m.startLineNumber,d=m.endLineNumber;for(let s=f;s<=d;s++){const i=this.getLineContent(s),n=s===f?m.startColumn-1:0,o=s===d?m.endColumn-1:i.length;for(let a=n;a<o;a++)N.$0e(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(v).length*(d-f),S}return this.getValueLengthInRange(m,v)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(m){return this.c.getLineContent(m)}getLineCharCode(m,v){return this.c.getLineCharCode(m,v)}getCharCode(m){return this.c.getCharCode(m)}getLineLength(m){return this.c.getLineLength(m)}getLineMinColumn(m){return 1}getLineMaxColumn(m){return this.getLineLength(m)+1}getLineFirstNonWhitespaceColumn(m){const v=N.$Ue(this.getLineContent(m));return v===-1?0:v+1}getLineLastNonWhitespaceColumn(m){const v=N.$We(this.getLineContent(m));return v===-1?0:v+2}n(m){switch(m){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(m){this.c.setEOL(m)}applyEdits(m,v,S){let f=this.g,d=this.h,s=this.j,i=!0,n=[];for(let c=0;c<m.length;c++){const l=m[c];i&&l._isTracked&&(i=!1);const k=l.range;if(l.text){let P=!0;s||(P=!N.$if(l.text),s=P),!f&&P&&(f=N.$hf(l.text)),!d&&P&&(d=N.$kf(l.text))}let R="",w=0,p=0,E=0;if(l.text){let P;[w,p,E,P]=(0,b.$dt)(l.text);const z=this.getEOL();P===0||P===(z===`\r
`?2:1)?R=l.text:R=l.text.replace(/\r\n|\r|\n/g,z)}n[c]={sortIndex:c,identifier:l.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:R,eolCount:w,firstLineLength:p,lastLineLength:E,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}n.sort(A.u);let o=!1;for(let c=0,l=n.length-1;c<l;c++){const k=n[c].range.getEndPosition(),R=n[c+1].range.getStartPosition();if(R.isBeforeOrEqual(k)){if(R.isBefore(k))throw new Error("Overlapping ranges are not allowed!");o=!0}}i&&(n=this.s(n));const a=S||v?A._getInverseEditRanges(n):[],t=[];if(v)for(let c=0;c<n.length;c++){const l=n[c],k=a[c];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let R=k.startLineNumber;R<=k.endLineNumber;R++){let w="";R===k.startLineNumber&&(w=this.getLineContent(l.range.startLineNumber),N.$Ue(w)!==-1)||t.push({lineNumber:R,oldContent:w})}}let r=null;if(S){let c=0;r=[];for(let l=0;l<n.length;l++){const k=n[l],R=a[l],w=this.getValueInRange(k.range),p=k.rangeOffset+c;c+=k.text.length-w.length,r[l]={sortIndex:k.sortIndex,identifier:k.identifier,range:R,text:w,textChange:new $.$Ys(k.rangeOffset,w,p,k.text)}}o||r.sort((l,k)=>l.sortIndex-k.sortIndex)}this.g=f,this.h=d,this.j=s;const h=this.t(n);let u=null;if(v&&t.length>0){t.sort((c,l)=>l.lineNumber-c.lineNumber),u=[];for(let c=0,l=t.length;c<l;c++){const k=t[c].lineNumber;if(c>0&&t[c-1].lineNumber===k)continue;const R=t[c].oldContent,w=this.getLineContent(k);w.length===0||w===R||N.$Ue(w)!==-1||u.push(k)}}return this.m.fire(),new I.$Zu(r,h,u)}s(m){return m.length<1e3?m:[this._toSingleEditOperation(m)]}_toSingleEditOperation(m){let v=!1;const S=m[0].range,f=m[m.length-1].range,d=new g.$Ds(S.startLineNumber,S.startColumn,f.endLineNumber,f.endColumn);let s=S.startLineNumber,i=S.startColumn;const n=[];for(let h=0,u=m.length;h<u;h++){const c=m[h],l=c.range;v=v||c.forceMoveMarkers,n.push(this.getValueInRange(new g.$Ds(s,i,l.startLineNumber,l.startColumn))),c.text.length>0&&n.push(c.text),s=l.endLineNumber,i=l.endColumn}const o=n.join(""),[a,t,r]=(0,b.$dt)(o);return{sortIndex:0,identifier:m[0].identifier,range:d,rangeOffset:this.getOffsetAt(d.startLineNumber,d.startColumn),rangeLength:this.getValueLengthInRange(d,0),text:o,eolCount:a,firstLineLength:t,lastLineLength:r,forceMoveMarkers:v,isAutoWhitespaceEdit:!1}}t(m){m.sort(A.w);const v=[];for(let S=0;S<m.length;S++){const f=m[S],d=f.range.startLineNumber,s=f.range.startColumn,i=f.range.endLineNumber,n=f.range.endColumn;if(d===i&&s===n&&f.text.length===0)continue;f.text?(this.c.delete(f.rangeOffset,f.rangeLength),this.c.insert(f.rangeOffset,f.text,!0)):this.c.delete(f.rangeOffset,f.rangeLength);const o=new g.$Ds(d,s,i,n);v.push({range:o,rangeLength:f.rangeLength,text:f.text,rangeOffset:f.rangeOffset,forceMoveMarkers:f.forceMoveMarkers})}return v}findMatchesLineByLine(m,v,S,f){return this.c.findMatchesLineByLine(m,v,S,f)}getPieceTree(){return this.c}static _getInverseEditRange(m,v){const S=m.startLineNumber,f=m.startColumn,[d,s,i]=(0,b.$dt)(v);let n;if(v.length>0){const o=d+1;o===1?n=new g.$Ds(S,f,S,f+s):n=new g.$Ds(S,f,S+o-1,i+1)}else n=new g.$Ds(S,f,S,f);return n}static _getInverseEditRanges(m){const v=[];let S=0,f=0,d=null;for(let s=0,i=m.length;s<i;s++){const n=m[s];let o,a;d?d.range.endLineNumber===n.range.startLineNumber?(o=S,a=f+(n.range.startColumn-d.range.endColumn)):(o=S+(n.range.startLineNumber-d.range.endLineNumber),a=n.range.startColumn):(o=n.range.startLineNumber,a=n.range.startColumn);let t;if(n.text.length>0){const r=n.eolCount+1;r===1?t=new g.$Ds(o,a,o,a+n.firstLineLength):t=new g.$Ds(o,a,o+r-1,n.lastLineLength+1)}else t=new g.$Ds(o,a,o,a);S=t.endLineNumber,f=t.endColumn,v.push(t),d=n}return v}static u(m,v){const S=g.$Ds.compareRangesUsingEnds(m.range,v.range);return S===0?m.sortIndex-v.sortIndex:S}static w(m,v){const S=g.$Ds.compareRangesUsingEnds(m.range,v.range);return S===0?v.sortIndex-m.sortIndex:-S}}e.$RB=A}),define(Ee[192],Se([1,0,13,127,191]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=void 0;class I{constructor($,y,A,C,m,v,S,f,d){this.a=$,this.b=y,this.c=A,this.d=C,this.e=m,this.f=v,this.g=S,this.h=f,this.j=d}k($){const y=this.c+this.d+this.e,A=this.c+this.e;return y===0?$===1?`
`:`\r
`:A>y/2?`\r
`:`
`}create($){const y=this.k($),A=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let m=0,v=A.length;m<v;m++){const S=A[m].buffer.replace(/\r\n|\r|\n/g,y),f=(0,N.$MB)(S);A[m]=new N.$PB(S,f)}const C=new g.$RB(A,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:C,disposable:C}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&D.$qf($)&&(this.b=D.$pf,$=$.substr(1));const y=$.charCodeAt($.length-1);y===13||y>=55296&&y<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=y):(this.m($,!1),this.c=!1,this.d=y)}m($,y){!y&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const y=(0,N.$NB)(this.e,$);this.a.push(new N.$PB($,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=D.$hf($)),this.k||(this.k=D.$kf($)))}finish($=!0){return this.o(),new I(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const y=(0,N.$MB)($.buffer);$.lineStarts=y,this.d===13&&this.f++}}}e.$SB=L}),define(Ee[131],Se([1,0,22,11]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0=e.$$0=void 0;var g;(function(C){C[C.Full=1]="Full",C[C.Delta=2]="Delta"})(g||(g={}));function I(C){for(let m=0,v=C.length;m<v;m+=4){const S=C[m+0],f=C[m+1],d=C[m+2],s=C[m+3];C[m+0]=s,C[m+1]=d,C[m+2]=f,C[m+3]=S}}function L(C){const m=new Uint8Array(C.buffer,C.byteOffset,C.length*4);return N.$D()||I(m),D.$fe.wrap(m)}function b(C){const m=C.buffer;if(N.$D()||I(m),m.byteOffset%4===0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const v=new Uint8Array(m.byteLength);return v.set(m),new Uint32Array(v.buffer,v.byteOffset,v.length/4)}}function $(C){const m=new Uint32Array(y(C));let v=0;if(m[v++]=C.id,C.type==="full")m[v++]=1,m[v++]=C.data.length,m.set(C.data,v),v+=C.data.length;else{m[v++]=2,m[v++]=C.deltas.length;for(const S of C.deltas)m[v++]=S.start,m[v++]=S.deleteCount,S.data?(m[v++]=S.data.length,m.set(S.data,v),v+=S.data.length):m[v++]=0}return L(m)}e.$$0=$;function y(C){let m=0;if(m+=1+1,C.type==="full")m+=1+C.data.length;else{m+=1,m+=(1+1+1)*C.deltas.length;for(const v of C.deltas)v.data&&(m+=v.data.length)}return m}function A(C){const m=b(C);let v=0;const S=m[v++];if(m[v++]===1){const i=m[v++],n=m.subarray(v,v+i);return v+=i,{id:S,type:"full",data:n}}const d=m[v++],s=[];for(let i=0;i<d;i++){const n=m[v++],o=m[v++],a=m[v++];let t;a>0&&(t=m.subarray(v,v+a),v+=a),s[i]={start:n,deleteCount:o,data:t}}return{id:S,type:"delta",deltas:s}}e.$_0=A}),define(Ee[193],Se([9,10]),function($e,e){return $e.create("vs/editor/common/config/editorOptions",e)}),define(Ee[132],Se([1,0,19,24,11,169,126,193]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(he){he[he.None=0]="None",he[he.Keep=1]="Keep",he[he.Brackets=2]="Brackets",he[he.Advanced=3]="Advanced",he[he.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(le){this.c=le}hasChanged(le){return this.c[le]}}e.ConfigurationChangedEvent=y;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class C{constructor(le,Ce,Ve,Ge){this.id=le,this.name=Ce,this.defaultValue=Ve,this.schema=Ge}applyUpdate(le,Ce){return v(le,Ce)}compute(le,Ce,Ve){return Ve}}class m{constructor(le,Ce){this.newValue=le,this.didChange=Ce}}e.ApplyUpdateResult=m;function v(he,le){if(typeof he!="object"||typeof le!="object"||!he||!le)return new m(le,he!==le);if(Array.isArray(he)||Array.isArray(le)){const Ve=Array.isArray(he)&&Array.isArray(le)&&D.$tb(he,le);return new m(le,!Ve)}let Ce=!1;for(const Ve in le)if(le.hasOwnProperty(Ve)){const Ge=v(he[Ve],le[Ve]);Ge.didChange&&(he[Ve]=Ge.newValue,Ce=!0)}return new m(he,Ce)}class S{constructor(le){this.schema=void 0,this.id=le,this.name="_never_",this.defaultValue=void 0}applyUpdate(le,Ce){return v(le,Ce)}validate(le){return this.defaultValue}}class f{constructor(le,Ce,Ve,Ge){this.id=le,this.name=Ce,this.defaultValue=Ve,this.schema=Ge}applyUpdate(le,Ce){return v(le,Ce)}validate(le){return typeof le>"u"?this.defaultValue:le}compute(le,Ce,Ve){return Ve}}function d(he,le){return typeof he>"u"?le:he==="false"?!1:!!he}e.boolean=d;class s extends f{constructor(le,Ce,Ve,Ge=void 0){typeof Ge<"u"&&(Ge.type="boolean",Ge.default=Ve),super(le,Ce,Ve,Ge)}validate(le){return d(le,this.defaultValue)}}function i(he,le,Ce,Ve){if(typeof he>"u")return le;let Ge=parseInt(he,10);return isNaN(Ge)?le:(Ge=Math.max(Ce,Ge),Ge=Math.min(Ve,Ge),Ge|0)}e.clampedInt=i;class n extends f{static clampedInt(le,Ce,Ve,Ge){return i(le,Ce,Ve,Ge)}constructor(le,Ce,Ve,Ge,_e,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Ve,ot.minimum=Ge,ot.maximum=_e),super(le,Ce,Ve,ot),this.minimum=Ge,this.maximum=_e}validate(le){return n.clampedInt(le,this.defaultValue,this.minimum,this.maximum)}}function o(he,le,Ce,Ve){if(typeof he>"u")return le;const Ge=a.float(he,le);return a.clamp(Ge,Ce,Ve)}e.clampedFloat=o;class a extends f{static clamp(le,Ce,Ve){return le<Ce?Ce:le>Ve?Ve:le}static float(le,Ce){if(typeof le=="number")return le;if(typeof le>"u")return Ce;const Ve=parseFloat(le);return isNaN(Ve)?Ce:Ve}constructor(le,Ce,Ve,Ge,_e){typeof _e<"u"&&(_e.type="number",_e.default=Ve),super(le,Ce,Ve,_e),this.validationFn=Ge}validate(le){return this.validationFn(a.float(le,this.defaultValue))}}class t extends f{static string(le,Ce){return typeof le!="string"?Ce:le}constructor(le,Ce,Ve,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.default=Ve),super(le,Ce,Ve,Ge)}validate(le){return t.string(le,this.defaultValue)}}function r(he,le,Ce,Ve){return typeof he!="string"?le:Ve&&he in Ve?Ve[he]:Ce.indexOf(he)===-1?le:he}e.stringSet=r;class h extends f{constructor(le,Ce,Ve,Ge,_e=void 0){typeof _e<"u"&&(_e.type="string",_e.enum=Ge,_e.default=Ve),super(le,Ce,Ve,_e),this.c=Ge}validate(le){return r(le,this.defaultValue,this.c)}}class u extends C{constructor(le,Ce,Ve,Ge,_e,ot,ut=void 0){typeof ut<"u"&&(ut.type="string",ut.enum=_e,ut.default=Ge),super(le,Ce,Ve,ut),this.c=_e,this.d=ot}validate(le){return typeof le!="string"?this.defaultValue:this.c.indexOf(le)===-1?this.defaultValue:this.d(le)}}function c(he){switch(he){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[b.localize(0,null),b.localize(1,null),b.localize(2,null)],default:"auto",tags:["accessibility"],description:b.localize(3,null)})}validate(le){switch(le){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(le,Ce,Ve){return Ve===0?le.accessibilitySupport:Ve}}class k extends C{constructor(){const le={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",le,{"editor.comments.insertSpace":{type:"boolean",default:le.insertSpace,description:b.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:le.ignoreEmptyLines,description:b.localize(5,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{insertSpace:d(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var R;(function(he){he[he.Hidden=0]="Hidden",he[he.Blink=1]="Blink",he[he.Smooth=2]="Smooth",he[he.Phase=3]="Phase",he[he.Expand=4]="Expand",he[he.Solid=5]="Solid"})(R||(e.TextEditorCursorBlinkingStyle=R={}));function w(he){switch(he){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var p;(function(he){he[he.Line=1]="Line",he[he.Block=2]="Block",he[he.Underline=3]="Underline",he[he.LineThin=4]="LineThin",he[he.BlockOutline=5]="BlockOutline",he[he.UnderlineThin=6]="UnderlineThin"})(p||(e.TextEditorCursorStyle=p={}));function E(he){switch(he){case p.Line:return"line";case p.Block:return"block";case p.Underline:return"underline";case p.LineThin:return"line-thin";case p.BlockOutline:return"block-outline";case p.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function P(he){switch(he){case"line":return p.Line;case"block":return p.Block;case"underline":return p.Underline;case"line-thin":return p.LineThin;case"block-outline":return p.BlockOutline;case"underline-thin":return p.UnderlineThin}}class z extends S{constructor(){super(140)}compute(le,Ce,Ve){const Ge=["monaco-editor"];return Ce.get(39)&&Ge.push(Ce.get(39)),le.extraEditorClassName&&Ge.push(le.extraEditorClassName),Ce.get(73)==="default"?Ge.push("mouse-default"):Ce.get(73)==="copy"&&Ge.push("mouse-copy"),Ce.get(110)&&Ge.push("showUnused"),Ce.get(138)&&Ge.push("showDeprecated"),Ge.join(" ")}}class j extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:b.localize(6,null)})}compute(le,Ce,Ve){return Ve&&le.emptySelectionClipboard}}class F extends C{constructor(){const le={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",le,{"editor.find.cursorMoveOnType":{type:"boolean",default:le.cursorMoveOnType,description:b.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:le.seedSearchStringFromSelection,enumDescriptions:[b.localize(8,null),b.localize(9,null),b.localize(10,null)],description:b.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:le.autoFindInSelection,enumDescriptions:[b.localize(12,null),b.localize(13,null),b.localize(14,null)],description:b.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:le.globalFindClipboard,description:b.localize(16,null),included:g.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:le.addExtraSpaceOnTop,description:b.localize(17,null)},"editor.find.loop":{type:"boolean",default:le.loop,description:b.localize(18,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{cursorMoveOnType:d(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof le.seedSearchStringFromSelection=="boolean"?le.seedSearchStringFromSelection?"always":"never":r(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof le.autoFindInSelection=="boolean"?le.autoFindInSelection?"always":"never":r(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(Ce.loop,this.defaultValue.loop)}}}class O extends C{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:b.localize(19,null)},{type:"string",description:b.localize(20,null)}],description:b.localize(21,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?O.OFF:le==="true"?O.ON:le:le?O.ON:O.OFF}}e.EditorFontLigatures=O;class T extends C{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",T.OFF,{anyOf:[{type:"boolean",description:b.localize(22,null)},{type:"string",description:b.localize(23,null)}],description:b.localize(24,null),default:!1})}validate(le){return typeof le>"u"?this.defaultValue:typeof le=="string"?le==="false"?T.OFF:le==="true"?T.TRANSLATE:le:le?T.TRANSLATE:T.OFF}compute(le,Ce,Ve){return le.fontInfo.fontVariationSettings}}e.EditorFontVariations=T;class M extends S{constructor(){super(50)}compute(le,Ce,Ve){return le.fontInfo}}class W extends f{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:b.localize(25,null)})}validate(le){const Ce=a.float(le,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(le,Ce,Ve){return le.fontInfo.fontSize}}class Y extends C{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:Y.d,maximum:Y.e,errorMessage:b.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:Y.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:b.localize(27,null)})}validate(le){return le==="normal"||le==="bold"?le:String(n.clampedInt(le,e.EDITOR_FONT_DEFAULTS.fontWeight,Y.d,Y.e))}}class ue extends C{constructor(){const le={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:le.multiple,enumDescriptions:[b.localize(28,null),b.localize(29,null),b.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",le,{"editor.gotoLocation.multiple":{deprecationMessage:b.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:b.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:b.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:b.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:b.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:b.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:le.alternativeDefinitionCommand,enum:Ve,description:b.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:le.alternativeTypeDefinitionCommand,enum:Ve,description:b.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:le.alternativeDeclarationCommand,enum:Ve,description:b.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:le.alternativeImplementationCommand,enum:Ve,description:b.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:le.alternativeReferenceCommand,enum:Ve,description:b.localize(41,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{multiple:r(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??r(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??r(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??r(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??r(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??r(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends C{constructor(){const le={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",le,{"editor.hover.enabled":{type:"boolean",default:le.enabled,description:b.localize(42,null)},"editor.hover.delay":{type:"number",default:le.delay,minimum:0,maximum:1e4,description:b.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:le.sticky,description:b.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:le.hidingDelay,description:b.localize(45,null)},"editor.hover.above":{type:"boolean",default:le.above,description:b.localize(46,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),delay:n.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:d(Ce.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:d(Ce.above,this.defaultValue.above)}}}var Q;(function(he){he[he.None=0]="None",he[he.Text=1]="Text",he[he.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class x extends S{constructor(){super(143)}compute(le,Ce,Ve){return x.computeLayout(Ce,{memory:le.memory,outerWidth:le.outerWidth,outerHeight:le.outerHeight,isDominatedByLongLines:le.isDominatedByLongLines,lineHeight:le.fontInfo.lineHeight,viewLineCount:le.viewLineCount,lineNumbersDigitCount:le.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:le.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:le.fontInfo.maxDigitWidth,pixelRatio:le.pixelRatio,glyphMarginDecorationLaneCount:le.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(le){const Ce=le.height/le.lineHeight,Ve=Math.floor(le.paddingTop/le.lineHeight);let Ge=Math.floor(le.paddingBottom/le.lineHeight);le.scrollBeyondLastLine&&(Ge=Math.max(Ge,Ce-1));const _e=(Ve+le.viewLineCount+Ge)/(le.pixelRatio*le.height),ot=Math.floor(le.viewLineCount/_e);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Ge,desiredRatio:_e,minimapLineCount:ot}}static c(le,Ce){const Ve=le.outerWidth,Ge=le.outerHeight,_e=le.pixelRatio;if(!le.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(_e*Ge),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ge};const ot=Ce.stableMinimapLayoutInput,ut=ot&&le.outerHeight===ot.outerHeight&&le.lineHeight===ot.lineHeight&&le.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&le.pixelRatio===ot.pixelRatio&&le.scrollBeyondLastLine===ot.scrollBeyondLastLine&&le.paddingTop===ot.paddingTop&&le.paddingBottom===ot.paddingBottom&&le.minimap.enabled===ot.minimap.enabled&&le.minimap.side===ot.minimap.side&&le.minimap.size===ot.minimap.size&&le.minimap.showSlider===ot.minimap.showSlider&&le.minimap.renderCharacters===ot.minimap.renderCharacters&&le.minimap.maxColumn===ot.minimap.maxColumn&&le.minimap.scale===ot.minimap.scale&&le.verticalScrollbarWidth===ot.verticalScrollbarWidth&&le.isViewportWrapping===ot.isViewportWrapping,je=le.lineHeight,kt=le.typicalHalfwidthCharacterWidth,Ht=le.scrollBeyondLastLine,jt=le.minimap.renderCharacters;let yt=_e>=2?Math.round(le.minimap.scale*2):le.minimap.scale;const Wt=le.minimap.maxColumn,zt=le.minimap.size,Kt=le.minimap.side,Gt=le.verticalScrollbarWidth,Rt=le.viewLineCount,Ct=le.remainingWidth,tt=le.isViewportWrapping,Jt=jt?2:3;let qt=Math.floor(_e*Ge);const lt=qt/_e;let mt=!1,Zt=!1,It=Jt*yt,St=yt/_e,ft=1;if(zt==="fill"||zt==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:gt,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:De}=x.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Ht,paddingTop:le.paddingTop,paddingBottom:le.paddingBottom,height:Ge,lineHeight:je,pixelRatio:_e});if(Rt/De>1)mt=!0,Zt=!0,yt=1,It=1,St=yt/_e;else{let Oe=!1,He=yt+1;if(zt==="fit"){const et=Math.ceil((gt+Rt+Fe)*It);tt&&ut&&Ct<=Ce.stableFitRemainingWidth?(Oe=!0,He=Ce.stableFitMaxMinimapScale):Oe=et>qt}if(zt==="fill"||Oe){mt=!0;const et=yt;It=Math.min(je*_e,Math.max(1,Math.floor(1/Ne))),tt&&ut&&Ct<=Ce.stableFitRemainingWidth&&(He=Ce.stableFitMaxMinimapScale),yt=Math.min(He,Math.max(1,Math.floor(It/Jt))),yt>et&&(ft=Math.min(2,yt/et)),St=yt/_e/ft,qt=Math.ceil(Math.max(Qt,gt+Rt+Fe)*It),tt?(Ce.stableMinimapLayoutInput=le,Ce.stableFitRemainingWidth=Ct,Ce.stableFitMaxMinimapScale=yt):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const At=Math.floor(Wt*St),Ot=Math.min(At,Math.max(0,Math.floor((Ct-Gt-2)*St/(kt+St)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(_e*Ot);const Qe=Et/_e;Et=Math.floor(Et*ft);const Lt=jt?1:2,Ut=Kt==="left"?0:Ve-Ot-Gt;return{renderMinimap:Lt,minimapLeft:Ut,minimapWidth:Ot,minimapHeightIsEditorHeight:mt,minimapIsSampling:Zt,minimapScale:yt,minimapLineHeight:It,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:qt,minimapCanvasOuterWidth:Qe,minimapCanvasOuterHeight:lt}}static computeLayout(le,Ce){const Ve=Ce.outerWidth|0,Ge=Ce.outerHeight|0,_e=Ce.lineHeight|0,ot=Ce.lineNumbersDigitCount|0,ut=Ce.typicalHalfwidthCharacterWidth,je=Ce.maxDigitWidth,kt=Ce.pixelRatio,Ht=Ce.viewLineCount,jt=le.get(135),yt=jt==="inherit"?le.get(134):jt,Wt=yt==="inherit"?le.get(130):yt,zt=le.get(133),Kt=Ce.isDominatedByLongLines,Gt=le.get(57),Rt=le.get(67).renderType!==0,Ct=le.get(68),tt=le.get(104),Jt=le.get(83),qt=le.get(72),lt=le.get(102),mt=lt.verticalScrollbarSize,Zt=lt.verticalHasArrows,It=lt.arrowSize,St=lt.horizontalScrollbarSize,ft=le.get(43),At=le.get(109)!=="never";let Ot=le.get(65);ft&&At&&(Ot+=16);let Et=0;if(Rt){const rt=Math.max(ot,Ct);Et=Math.round(rt*je)}let Qe=0;Gt&&(Qe=_e*Ce.glyphMarginDecorationLaneCount);let Lt=0,Ut=Lt+Qe,Qt=Ut+Et,gt=Qt+Ot;const Fe=Ve-Qe-Et-Ot;let Ne=!1,De=!1,re=-1;yt==="inherit"&&Kt?(Ne=!0,De=!0):Wt==="on"||Wt==="bounded"?De=!0:Wt==="wordWrapColumn"&&(re=zt);const Oe=x.c({outerWidth:Ve,outerHeight:Ge,lineHeight:_e,typicalHalfwidthCharacterWidth:ut,pixelRatio:kt,scrollBeyondLastLine:tt,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:qt,verticalScrollbarWidth:mt,viewLineCount:Ht,remainingWidth:Fe,isViewportWrapping:De},Ce.memory||new A);Oe.renderMinimap!==0&&Oe.minimapLeft===0&&(Lt+=Oe.minimapWidth,Ut+=Oe.minimapWidth,Qt+=Oe.minimapWidth,gt+=Oe.minimapWidth);const He=Fe-Oe.minimapWidth,et=Math.max(1,Math.floor((He-mt-2)/ut)),Je=Zt?It:0;return De&&(re=Math.max(1,et),Wt==="bounded"&&(re=Math.min(re,zt))),{width:Ve,height:Ge,glyphMarginLeft:Lt,glyphMarginWidth:Qe,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Ut,lineNumbersWidth:Et,decorationsLeft:Qt,decorationsWidth:Ot,contentLeft:gt,contentWidth:He,minimap:Oe,viewportColumn:et,isWordWrapMinified:Ne,isViewportWrapping:De,wrappingColumn:re,verticalScrollbarWidth:mt,horizontalScrollbarHeight:St,overviewRuler:{top:Je,width:mt,height:Ge-2*Je,right:0}}}}e.EditorLayoutInfoComputer=x;class oe extends C{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[b.localize(47,null),b.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:b.localize(49,null)}})}validate(le){return r(le,"simple",["simple","advanced"])}compute(le,Ce,Ve){return Ce.get(2)===2?"advanced":Ve}}class X extends C{constructor(){const le={enabled:!0};super(64,"lightbulb",le,{"editor.lightbulb.enabled":{type:"boolean",default:le.enabled,description:b.localize(50,null)}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{enabled:d(le.enabled,this.defaultValue.enabled)}}}class ve extends C{constructor(){const le={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",le,{"editor.stickyScroll.enabled":{type:"boolean",default:le.enabled,description:b.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:le.maxLineCount,minimum:1,maximum:10,description:b.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:le.defaultModel,description:b.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:le.scrollWithEditor,description:b.localize(54,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:d(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ge extends C{constructor(){const le={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",le,{"editor.inlayHints.enabled":{type:"string",default:le.enabled,description:b.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[b.localize(56,null),b.localize(57,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(58,null,g.$j?"Ctrl+Option":"Ctrl+Alt"),b.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:le.fontSize,markdownDescription:b.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:le.fontFamily,markdownDescription:b.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:le.padding,description:b.localize(62,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:r(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:d(Ce.padding,this.defaultValue.padding)}}}class V extends C{constructor(){super(65,"lineDecorationsWidth",10)}validate(le){return typeof le=="string"&&/^\d+(\.\d+)?ch$/.test(le)?-parseFloat(le.substring(0,le.length-2)):n.clampedInt(le,this.defaultValue,0,1e3)}compute(le,Ce,Ve){return Ve<0?n.clampedInt(-Ve*le.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class U extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,le=>a.clamp(le,0,150),{markdownDescription:b.localize(63,null)})}compute(le,Ce,Ve){return le.fontInfo.lineHeight}}class ne extends C{constructor(){const le={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",le,{"editor.minimap.enabled":{type:"boolean",default:le.enabled,description:b.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:le.autohide,description:b.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[b.localize(66,null),b.localize(67,null),b.localize(68,null)],default:le.size,description:b.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:le.side,description:b.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:le.showSlider,description:b.localize(71,null)},"editor.minimap.scale":{type:"number",default:le.scale,minimum:1,maximum:3,enum:[1,2,3],description:b.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:le.renderCharacters,description:b.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:le.maxColumn,description:b.localize(74,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),autohide:d(Ce.autohide,this.defaultValue.autohide),size:r(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(Ce.side,this.defaultValue.side,["right","left"]),showSlider:r(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt(Ce.scale,1,1,3),maxColumn:n.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ye(he){return he==="ctrlCmd"?g.$j?"metaKey":"ctrlKey":"altKey"}class fe extends C{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:b.localize(76,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{top:n.clampedInt(Ce.top,0,0,1e3),bottom:n.clampedInt(Ce.bottom,0,0,1e3)}}}class me extends C{constructor(){const le={enabled:!0,cycle:!0};super(85,"parameterHints",le,{"editor.parameterHints.enabled":{type:"boolean",default:le.enabled,description:b.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:le.cycle,description:b.localize(78,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),cycle:d(Ce.cycle,this.defaultValue.cycle)}}}class ee extends S{constructor(){super(141)}compute(le,Ce,Ve){return le.pixelRatio}}class ie extends C{constructor(){const le={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[b.localize(79,null),b.localize(80,null),b.localize(81,null)]}];super(88,"quickSuggestions",le,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:le.strings,description:b.localize(82,null)},comments:{anyOf:Ce,default:le.comments,description:b.localize(83,null)},other:{anyOf:Ce,default:le.other,description:b.localize(84,null)}},default:le,markdownDescription:b.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=le}validate(le){if(typeof le=="boolean"){const kt=le?"on":"off";return{comments:kt,strings:kt,other:kt}}if(!le||typeof le!="object")return this.defaultValue;const{other:Ce,comments:Ve,strings:Ge}=le,_e=["on","inline","off"];let ot,ut,je;return typeof Ce=="boolean"?ot=Ce?"on":"off":ot=r(Ce,this.defaultValue.other,_e),typeof Ve=="boolean"?ut=Ve?"on":"off":ut=r(Ve,this.defaultValue.comments,_e),typeof Ge=="boolean"?je=Ge?"on":"off":je=r(Ge,this.defaultValue.strings,_e),{other:ot,comments:ut,strings:je}}}var G;(function(he){he[he.Off=0]="Off",he[he.On=1]="On",he[he.Relative=2]="Relative",he[he.Interval=3]="Interval",he[he.Custom=4]="Custom"})(G||(e.RenderLineNumbersType=G={}));class te extends C{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[b.localize(86,null),b.localize(87,null),b.localize(88,null),b.localize(89,null)],default:"on",description:b.localize(90,null)})}validate(le){let Ce=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof le<"u"&&(typeof le=="function"?(Ce=4,Ve=le):le==="interval"?Ce=3:le==="relative"?Ce=2:le==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:Ve}}}function J(he){const le=he.get(97);return le==="editable"?he.get(90):le!=="on"}e.filterValidationDecorations=J;class ce extends C{constructor(){const le=[],Ce={type:"number",description:b.localize(91,null)};super(101,"rulers",le,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:b.localize(92,null),format:"color-hex"}}}]},default:le,description:b.localize(93,null)})}validate(le){if(Array.isArray(le)){const Ce=[];for(const Ve of le)if(typeof Ve=="number")Ce.push({column:n.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Ge=Ve;Ce.push({column:n.clampedInt(Ge.column,0,0,1e4),color:Ge.color})}return Ce.sort((Ve,Ge)=>Ve.column-Ge.column),Ce}return this.defaultValue}}class be extends C{constructor(){super(91,"readOnlyMessage",void 0)}validate(le){return!le||typeof le!="object"?this.defaultValue:le}}function Ie(he,le){if(typeof he!="string")return le;switch(he){case"hidden":return 2;case"visible":return 3;default:return 1}}class Me extends C{constructor(){const le={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",le,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(94,null),b.localize(95,null),b.localize(96,null)],default:"auto",description:b.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[b.localize(98,null),b.localize(99,null),b.localize(100,null)],default:"auto",description:b.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:le.verticalScrollbarSize,description:b.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:le.horizontalScrollbarSize,description:b.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:le.scrollByPage,description:b.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:le.ignoreHorizontalScrollbarInContentHeight,description:b.localize(105,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le,Ve=n.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ge=n.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:d(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:n.clampedInt(Ce.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Ge,verticalSliderSize:n.clampedInt(Ce.verticalSliderSize,Ge,0,1e3),scrollByPage:d(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:d(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class B extends C{constructor(){const le={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",le,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.nonBasicASCII,description:b.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:le.invisibleCharacters,description:b.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:le.ambiguousCharacters,description:b.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeComments,description:b.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:le.includeStrings,description:b.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:le.allowedCharacters,description:b.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:le.allowedLocales,description:b.localize(112,null)}})}applyUpdate(le,Ce){let Ve=!1;Ce.allowedCharacters&&le&&(N.$in(le.allowedCharacters,Ce.allowedCharacters)||(le={...le,allowedCharacters:Ce.allowedCharacters},Ve=!0)),Ce.allowedLocales&&le&&(N.$in(le.allowedLocales,Ce.allowedLocales)||(le={...le,allowedLocales:Ce.allowedLocales},Ve=!0));const Ge=super.applyUpdate(le,Ce);return Ve?new m(Ge.newValue,!0):Ge}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{nonBasicASCII:ae(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ae(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ae(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(le.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(le.allowedLocales,this.defaultValue.allowedLocales)}}c(le,Ce){if(typeof le!="object"||!le)return Ce;const Ve={};for(const[Ge,_e]of Object.entries(le))_e===!0&&(Ve[Ge]=!0);return Ve}}class _ extends C{constructor(){const le={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",le,{"editor.inlineSuggest.enabled":{type:"boolean",default:le.enabled,description:b.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:le.showToolbar,enum:["always","onHover","never"],enumDescriptions:[b.localize(114,null),b.localize(115,null),b.localize(116,null)],description:b.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:le.suppressSuggestions,description:b.localize(118,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),mode:r(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:d(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:d(Ce.keepOnBlur,this.defaultValue.keepOnBlur)}}}class se extends C{constructor(){const le={enabled:I.$as.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:I.$as.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",le,{"editor.bracketPairColorization.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:le.independentColorPoolPerBracketType,description:b.localize(120,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class K extends C{constructor(){const le={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",le,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(121,null),b.localize(122,null),b.localize(123,null)],default:le.bracketPairs,description:b.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[b.localize(125,null),b.localize(126,null),b.localize(127,null)],default:le.bracketPairsHorizontal,description:b.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:le.highlightActiveBracketPair,description:b.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:le.indentation,description:b.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[b.localize(131,null),b.localize(132,null),b.localize(133,null)],default:le.highlightActiveIndentation,description:b.localize(134,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{bracketPairs:ae(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ae(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:ae(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ae(he,le,Ce){const Ve=Ce.indexOf(he);return Ve===-1?le:Ce[Ve]}class de extends C{constructor(){const le={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",le,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[b.localize(135,null),b.localize(136,null)],default:le.insertMode,description:b.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:le.filterGraceful,description:b.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:le.localityBonus,description:b.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:le.shareSuggestSelections,markdownDescription:b.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[b.localize(141,null),b.localize(142,null),b.localize(143,null),b.localize(144,null)],default:le.selectionMode,markdownDescription:b.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:le.snippetsPreventQuickSuggestions,description:b.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:le.showIcons,description:b.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:le.showStatusBar,description:b.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:le.preview,description:b.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:le.showInlineDetails,description:b.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:b.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:b.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:b.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:b.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:b.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:b.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:b.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:b.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:b.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:b.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:b.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:b.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:b.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:b.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:b.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:b.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:b.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:b.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:b.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:b.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:b.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:b.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:b.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:b.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:b.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:b.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:b.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:b.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:b.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:b.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:b.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:b.localize(182,null)}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{insertMode:r(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:d(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:d(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:d(Ce.preview,this.defaultValue.preview),previewMode:r(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(Ce.showMethods,this.defaultValue.showMethods),showFunctions:d(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:d(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:d(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:d(Ce.showFields,this.defaultValue.showFields),showVariables:d(Ce.showVariables,this.defaultValue.showVariables),showClasses:d(Ce.showClasses,this.defaultValue.showClasses),showStructs:d(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:d(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:d(Ce.showModules,this.defaultValue.showModules),showProperties:d(Ce.showProperties,this.defaultValue.showProperties),showEvents:d(Ce.showEvents,this.defaultValue.showEvents),showOperators:d(Ce.showOperators,this.defaultValue.showOperators),showUnits:d(Ce.showUnits,this.defaultValue.showUnits),showValues:d(Ce.showValues,this.defaultValue.showValues),showConstants:d(Ce.showConstants,this.defaultValue.showConstants),showEnums:d(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:d(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(Ce.showKeywords,this.defaultValue.showKeywords),showWords:d(Ce.showWords,this.defaultValue.showWords),showColors:d(Ce.showColors,this.defaultValue.showColors),showFiles:d(Ce.showFiles,this.defaultValue.showFiles),showReferences:d(Ce.showReferences,this.defaultValue.showReferences),showFolders:d(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:d(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:d(Ce.showUsers,this.defaultValue.showUsers),showIssues:d(Ce.showIssues,this.defaultValue.showIssues)}}}class Re extends C{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:b.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:b.localize(184,null),default:!0,type:"boolean"}})}validate(le){return!le||typeof le!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(le.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:d(le.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(he){he[he.None=0]="None",he[he.Same=1]="Same",he[he.Indent=2]="Indent",he[he.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class Xe extends C{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[b.localize(185,null),b.localize(186,null),b.localize(187,null),b.localize(188,null)],description:b.localize(189,null),default:"same"}})}validate(le){switch(le){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(le,Ce,Ve){return Ce.get(2)===2?0:Ve}}class Ye extends S{constructor(){super(144)}compute(le,Ce,Ve){const Ge=Ce.get(143);return{isDominatedByLongLines:le.isDominatedByLongLines,isWordWrapMinified:Ge.isWordWrapMinified,isViewportWrapping:Ge.isViewportWrapping,wrappingColumn:Ge.wrappingColumn}}}class it extends C{constructor(){const le={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",le,{"editor.dropIntoEditor.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:b.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[b.localize(192,null),b.localize(193,null)],default:"afterDrop"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showDropSelector:r(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends C{constructor(){const le={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",le,{"editor.pasteAs.enabled":{type:"boolean",default:le.enabled,markdownDescription:b.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:b.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[b.localize(196,null),b.localize(197,null)],default:"afterPaste"}})}validate(le){if(!le||typeof le!="object")return this.defaultValue;const Ce=le;return{enabled:d(Ce.enabled,this.defaultValue.enabled),showPasteSelector:r(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const Pe="Consolas, 'Courier New', monospace",Te="Menlo, Monaco, 'Courier New', monospace",qe="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:g.$j?Te:g.$k?qe:Pe,fontWeight:"normal",fontSize:g.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(he){return e.editorOptionsRegistry[he.id]=he,he}var xe;(function(he){he[he.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",he[he.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",he[he.accessibilitySupport=2]="accessibilitySupport",he[he.accessibilityPageSize=3]="accessibilityPageSize",he[he.ariaLabel=4]="ariaLabel",he[he.ariaRequired=5]="ariaRequired",he[he.autoClosingBrackets=6]="autoClosingBrackets",he[he.autoClosingComments=7]="autoClosingComments",he[he.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",he[he.autoClosingDelete=9]="autoClosingDelete",he[he.autoClosingOvertype=10]="autoClosingOvertype",he[he.autoClosingQuotes=11]="autoClosingQuotes",he[he.autoIndent=12]="autoIndent",he[he.automaticLayout=13]="automaticLayout",he[he.autoSurround=14]="autoSurround",he[he.bracketPairColorization=15]="bracketPairColorization",he[he.guides=16]="guides",he[he.codeLens=17]="codeLens",he[he.codeLensFontFamily=18]="codeLensFontFamily",he[he.codeLensFontSize=19]="codeLensFontSize",he[he.colorDecorators=20]="colorDecorators",he[he.colorDecoratorsLimit=21]="colorDecoratorsLimit",he[he.columnSelection=22]="columnSelection",he[he.comments=23]="comments",he[he.contextmenu=24]="contextmenu",he[he.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",he[he.cursorBlinking=26]="cursorBlinking",he[he.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",he[he.cursorStyle=28]="cursorStyle",he[he.cursorSurroundingLines=29]="cursorSurroundingLines",he[he.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",he[he.cursorWidth=31]="cursorWidth",he[he.disableLayerHinting=32]="disableLayerHinting",he[he.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",he[he.domReadOnly=34]="domReadOnly",he[he.dragAndDrop=35]="dragAndDrop",he[he.dropIntoEditor=36]="dropIntoEditor",he[he.emptySelectionClipboard=37]="emptySelectionClipboard",he[he.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",he[he.extraEditorClassName=39]="extraEditorClassName",he[he.fastScrollSensitivity=40]="fastScrollSensitivity",he[he.find=41]="find",he[he.fixedOverflowWidgets=42]="fixedOverflowWidgets",he[he.folding=43]="folding",he[he.foldingStrategy=44]="foldingStrategy",he[he.foldingHighlight=45]="foldingHighlight",he[he.foldingImportsByDefault=46]="foldingImportsByDefault",he[he.foldingMaximumRegions=47]="foldingMaximumRegions",he[he.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",he[he.fontFamily=49]="fontFamily",he[he.fontInfo=50]="fontInfo",he[he.fontLigatures=51]="fontLigatures",he[he.fontSize=52]="fontSize",he[he.fontWeight=53]="fontWeight",he[he.fontVariations=54]="fontVariations",he[he.formatOnPaste=55]="formatOnPaste",he[he.formatOnType=56]="formatOnType",he[he.glyphMargin=57]="glyphMargin",he[he.gotoLocation=58]="gotoLocation",he[he.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",he[he.hover=60]="hover",he[he.inDiffEditor=61]="inDiffEditor",he[he.inlineSuggest=62]="inlineSuggest",he[he.letterSpacing=63]="letterSpacing",he[he.lightbulb=64]="lightbulb",he[he.lineDecorationsWidth=65]="lineDecorationsWidth",he[he.lineHeight=66]="lineHeight",he[he.lineNumbers=67]="lineNumbers",he[he.lineNumbersMinChars=68]="lineNumbersMinChars",he[he.linkedEditing=69]="linkedEditing",he[he.links=70]="links",he[he.matchBrackets=71]="matchBrackets",he[he.minimap=72]="minimap",he[he.mouseStyle=73]="mouseStyle",he[he.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",he[he.mouseWheelZoom=75]="mouseWheelZoom",he[he.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",he[he.multiCursorModifier=77]="multiCursorModifier",he[he.multiCursorPaste=78]="multiCursorPaste",he[he.multiCursorLimit=79]="multiCursorLimit",he[he.occurrencesHighlight=80]="occurrencesHighlight",he[he.overviewRulerBorder=81]="overviewRulerBorder",he[he.overviewRulerLanes=82]="overviewRulerLanes",he[he.padding=83]="padding",he[he.pasteAs=84]="pasteAs",he[he.parameterHints=85]="parameterHints",he[he.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",he[he.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",he[he.quickSuggestions=88]="quickSuggestions",he[he.quickSuggestionsDelay=89]="quickSuggestionsDelay",he[he.readOnly=90]="readOnly",he[he.readOnlyMessage=91]="readOnlyMessage",he[he.renameOnType=92]="renameOnType",he[he.renderControlCharacters=93]="renderControlCharacters",he[he.renderFinalNewline=94]="renderFinalNewline",he[he.renderLineHighlight=95]="renderLineHighlight",he[he.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",he[he.renderValidationDecorations=97]="renderValidationDecorations",he[he.renderWhitespace=98]="renderWhitespace",he[he.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",he[he.roundedSelection=100]="roundedSelection",he[he.rulers=101]="rulers",he[he.scrollbar=102]="scrollbar",he[he.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",he[he.scrollBeyondLastLine=104]="scrollBeyondLastLine",he[he.scrollPredominantAxis=105]="scrollPredominantAxis",he[he.selectionClipboard=106]="selectionClipboard",he[he.selectionHighlight=107]="selectionHighlight",he[he.selectOnLineNumbers=108]="selectOnLineNumbers",he[he.showFoldingControls=109]="showFoldingControls",he[he.showUnused=110]="showUnused",he[he.snippetSuggestions=111]="snippetSuggestions",he[he.smartSelect=112]="smartSelect",he[he.smoothScrolling=113]="smoothScrolling",he[he.stickyScroll=114]="stickyScroll",he[he.stickyTabStops=115]="stickyTabStops",he[he.stopRenderingLineAfter=116]="stopRenderingLineAfter",he[he.suggest=117]="suggest",he[he.suggestFontSize=118]="suggestFontSize",he[he.suggestLineHeight=119]="suggestLineHeight",he[he.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",he[he.suggestSelection=121]="suggestSelection",he[he.tabCompletion=122]="tabCompletion",he[he.tabIndex=123]="tabIndex",he[he.unicodeHighlighting=124]="unicodeHighlighting",he[he.unusualLineTerminators=125]="unusualLineTerminators",he[he.useShadowDOM=126]="useShadowDOM",he[he.useTabStops=127]="useTabStops",he[he.wordBreak=128]="wordBreak",he[he.wordSeparators=129]="wordSeparators",he[he.wordWrap=130]="wordWrap",he[he.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",he[he.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",he[he.wordWrapColumn=133]="wordWrapColumn",he[he.wordWrapOverride1=134]="wordWrapOverride1",he[he.wordWrapOverride2=135]="wordWrapOverride2",he[he.wrappingIndent=136]="wrappingIndent",he[he.wrappingStrategy=137]="wrappingStrategy",he[he.showDeprecated=138]="showDeprecated",he[he.inlayHints=139]="inlayHints",he[he.editorClassName=140]="editorClassName",he[he.pixelRatio=141]="pixelRatio",he[he.tabFocusMode=142]="tabFocusMode",he[he.layoutInfo=143]="layoutInfo",he[he.wrappingInfo=144]="wrappingInfo",he[he.defaultColorDecorators=145]="defaultColorDecorators",he[he.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",he[he.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(xe||(e.EditorOption=xe={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:b.localize(198,null)})),acceptSuggestionOnEnter:Le(new h(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",b.localize(199,null),""],markdownDescription:b.localize(200,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new n(3,"accessibilityPageSize",10,1,1073741824,{description:b.localize(201,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",b.localize(202,null))),ariaRequired:Le(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:b.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:Le(new h(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(204,null),b.localize(205,null),""],description:b.localize(206,null)})),autoClosingComments:Le(new h(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(207,null),b.localize(208,null),""],description:b.localize(209,null)})),autoClosingDelete:Le(new h(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",b.localize(210,null),""],description:b.localize(211,null)})),autoClosingOvertype:Le(new h(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",b.localize(212,null),""],description:b.localize(213,null)})),autoClosingQuotes:Le(new h(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",b.localize(214,null),b.localize(215,null),""],description:b.localize(216,null)})),autoIndent:Le(new u(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],c,{enumDescriptions:[b.localize(217,null),b.localize(218,null),b.localize(219,null),b.localize(220,null),b.localize(221,null)],description:b.localize(222,null)})),automaticLayout:Le(new s(13,"automaticLayout",!1)),autoSurround:Le(new h(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[b.localize(223,null),b.localize(224,null),b.localize(225,null),""],description:b.localize(226,null)})),bracketPairColorization:Le(new se),bracketPairGuides:Le(new K),stickyTabStops:Le(new s(115,"stickyTabStops",!1,{description:b.localize(227,null)})),codeLens:Le(new s(17,"codeLens",!0,{description:b.localize(228,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:b.localize(229,null)})),codeLensFontSize:Le(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:b.localize(230,null)})),colorDecorators:Le(new s(20,"colorDecorators",!0,{description:b.localize(231,null)})),colorDecoratorActivatedOn:Le(new h(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[b.localize(232,null),b.localize(233,null),b.localize(234,null)],description:b.localize(235,null)})),colorDecoratorsLimit:Le(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:b.localize(236,null)})),columnSelection:Le(new s(22,"columnSelection",!1,{description:b.localize(237,null)})),comments:Le(new k),contextmenu:Le(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new s(25,"copyWithSyntaxHighlighting",!0,{description:b.localize(238,null)})),cursorBlinking:Le(new u(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:b.localize(239,null)})),cursorSmoothCaretAnimation:Le(new h(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[b.localize(240,null),b.localize(241,null),b.localize(242,null)],description:b.localize(243,null)})),cursorStyle:Le(new u(28,"cursorStyle",p.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:b.localize(244,null)})),cursorSurroundingLines:Le(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:b.localize(245,null)})),cursorSurroundingLinesStyle:Le(new h(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[b.localize(246,null),b.localize(247,null)],markdownDescription:b.localize(248,null)})),cursorWidth:Le(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:b.localize(249,null)})),disableLayerHinting:Le(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new s(34,"domReadOnly",!1)),dragAndDrop:Le(new s(35,"dragAndDrop",!0,{description:b.localize(250,null)})),emptySelectionClipboard:Le(new j),dropIntoEditor:Le(new it),stickyScroll:Le(new ve),experimentalWhitespaceRendering:Le(new h(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[b.localize(251,null),b.localize(252,null),b.localize(253,null)],description:b.localize(254,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,he=>he<=0?5:he,{markdownDescription:b.localize(255,null)})),find:Le(new F),fixedOverflowWidgets:Le(new s(42,"fixedOverflowWidgets",!1)),folding:Le(new s(43,"folding",!0,{description:b.localize(256,null)})),foldingStrategy:Le(new h(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[b.localize(257,null),b.localize(258,null)],description:b.localize(259,null)})),foldingHighlight:Le(new s(45,"foldingHighlight",!0,{description:b.localize(260,null)})),foldingImportsByDefault:Le(new s(46,"foldingImportsByDefault",!1,{description:b.localize(261,null)})),foldingMaximumRegions:Le(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:b.localize(262,null)})),unfoldOnClickAfterEndOfLine:Le(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:b.localize(263,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:b.localize(264,null)})),fontInfo:Le(new M),fontLigatures2:Le(new O),fontSize:Le(new W),fontWeight:Le(new Y),fontVariations:Le(new T),formatOnPaste:Le(new s(55,"formatOnPaste",!1,{description:b.localize(265,null)})),formatOnType:Le(new s(56,"formatOnType",!1,{description:b.localize(266,null)})),glyphMargin:Le(new s(57,"glyphMargin",!0,{description:b.localize(267,null)})),gotoLocation:Le(new ue),hideCursorInOverviewRuler:Le(new s(59,"hideCursorInOverviewRuler",!1,{description:b.localize(268,null)})),hover:Le(new Z),inDiffEditor:Le(new s(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,he=>a.clamp(he,-5,20),{description:b.localize(269,null)})),lightbulb:Le(new X),lineDecorationsWidth:Le(new V),lineHeight:Le(new U),lineNumbers:Le(new te),lineNumbersMinChars:Le(new n(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new s(69,"linkedEditing",!1,{description:b.localize(270,null)})),links:Le(new s(70,"links",!0,{description:b.localize(271,null)})),matchBrackets:Le(new h(71,"matchBrackets","always",["always","near","never"],{description:b.localize(272,null)})),minimap:Le(new ne),mouseStyle:Le(new h(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,he=>he===0?1:he,{markdownDescription:b.localize(273,null)})),mouseWheelZoom:Le(new s(75,"mouseWheelZoom",!1,{markdownDescription:b.localize(274,null)})),multiCursorMergeOverlapping:Le(new s(76,"multiCursorMergeOverlapping",!0,{description:b.localize(275,null)})),multiCursorModifier:Le(new u(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ye,{markdownEnumDescriptions:[b.localize(276,null),b.localize(277,null)],markdownDescription:b.localize(278,null)})),multiCursorPaste:Le(new h(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[b.localize(279,null),b.localize(280,null)],markdownDescription:b.localize(281,null)})),multiCursorLimit:Le(new n(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:b.localize(282,null)})),occurrencesHighlight:Le(new h(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[b.localize(283,null),b.localize(284,null),b.localize(285,null)],markdownDescription:b.localize(286,null)})),overviewRulerBorder:Le(new s(81,"overviewRulerBorder",!0,{description:b.localize(287,null)})),overviewRulerLanes:Le(new n(82,"overviewRulerLanes",3,0,3)),padding:Le(new fe),pasteAs:Le(new st),parameterHints:Le(new me),peekWidgetDefaultFocus:Le(new h(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[b.localize(288,null),b.localize(289,null)],description:b.localize(290,null)})),definitionLinkOpensInPeek:Le(new s(87,"definitionLinkOpensInPeek",!1,{description:b.localize(291,null)})),quickSuggestions:Le(new ie),quickSuggestionsDelay:Le(new n(89,"quickSuggestionsDelay",10,0,1073741824,{description:b.localize(292,null)})),readOnly:Le(new s(90,"readOnly",!1)),readOnlyMessage:Le(new be),renameOnType:Le(new s(92,"renameOnType",!1,{description:b.localize(293,null),markdownDeprecationMessage:b.localize(294,null)})),renderControlCharacters:Le(new s(93,"renderControlCharacters",!0,{description:b.localize(295,null),restricted:!0})),renderFinalNewline:Le(new h(94,"renderFinalNewline",g.$k?"dimmed":"on",["off","on","dimmed"],{description:b.localize(296,null)})),renderLineHighlight:Le(new h(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",b.localize(297,null)],description:b.localize(298,null)})),renderLineHighlightOnlyWhenFocus:Le(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:b.localize(299,null)})),renderValidationDecorations:Le(new h(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new h(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",b.localize(300,null),b.localize(301,null),b.localize(302,null),""],description:b.localize(303,null)})),revealHorizontalRightPadding:Le(new n(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new s(100,"roundedSelection",!0,{description:b.localize(304,null)})),rulers:Le(new ce),scrollbar:Le(new Me),scrollBeyondLastColumn:Le(new n(103,"scrollBeyondLastColumn",4,0,1073741824,{description:b.localize(305,null)})),scrollBeyondLastLine:Le(new s(104,"scrollBeyondLastLine",!0,{description:b.localize(306,null)})),scrollPredominantAxis:Le(new s(105,"scrollPredominantAxis",!0,{description:b.localize(307,null)})),selectionClipboard:Le(new s(106,"selectionClipboard",!0,{description:b.localize(308,null),included:g.$k})),selectionHighlight:Le(new s(107,"selectionHighlight",!0,{description:b.localize(309,null)})),selectOnLineNumbers:Le(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new h(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[b.localize(310,null),b.localize(311,null),b.localize(312,null)],description:b.localize(313,null)})),showUnused:Le(new s(110,"showUnused",!0,{description:b.localize(314,null)})),showDeprecated:Le(new s(138,"showDeprecated",!0,{description:b.localize(315,null)})),inlayHints:Le(new ge),snippetSuggestions:Le(new h(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[b.localize(316,null),b.localize(317,null),b.localize(318,null),b.localize(319,null)],description:b.localize(320,null)})),smartSelect:Le(new Re),smoothScrolling:Le(new s(113,"smoothScrolling",!1,{description:b.localize(321,null)})),stopRenderingLineAfter:Le(new n(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new de),inlineSuggest:Le(new _),inlineCompletionsAccessibilityVerbose:Le(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:b.localize(322,null)})),suggestFontSize:Le(new n(118,"suggestFontSize",0,0,1e3,{markdownDescription:b.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new n(119,"suggestLineHeight",0,0,1e3,{markdownDescription:b.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new s(120,"suggestOnTriggerCharacters",!0,{description:b.localize(325,null)})),suggestSelection:Le(new h(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[b.localize(326,null),b.localize(327,null),b.localize(328,null)],description:b.localize(329,null)})),tabCompletion:Le(new h(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[b.localize(330,null),b.localize(331,null),b.localize(332,null)],description:b.localize(333,null)})),tabIndex:Le(new n(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new B),unusualLineTerminators:Le(new h(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[b.localize(334,null),b.localize(335,null),b.localize(336,null)],description:b.localize(337,null)})),useShadowDOM:Le(new s(126,"useShadowDOM",!0)),useTabStops:Le(new s(127,"useTabStops",!0,{description:b.localize(338,null)})),wordBreak:Le(new h(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[b.localize(339,null),b.localize(340,null)],description:b.localize(341,null)})),wordSeparators:Le(new t(129,"wordSeparators",L.$bs,{description:b.localize(342,null)})),wordWrap:Le(new h(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[b.localize(343,null),b.localize(344,null),b.localize(345,null),b.localize(346,null)],description:b.localize(347,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new n(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:b.localize(348,null)})),wordWrapOverride1:Le(new h(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new h(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new z),defaultColorDecorators:Le(new s(145,"defaultColorDecorators",!1,{markdownDescription:b.localize(349,null)})),pixelRatio:Le(new ee),tabFocusMode:Le(new s(142,"tabFocusMode",!1,{markdownDescription:b.localize(350,null)})),layoutInfo:Le(new x),wrappingInfo:Le(new Ye),wrappingIndent:Le(new Xe),wrappingStrategy:Le(new oe)}}),define(Ee[194],Se([9,10]),function($e,e){return $e.create("vs/editor/common/languages",e)}),define(Ee[83],Se([1,0,78,2,167,29,177,194]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$vt=e.$ut=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$tt=e.$st=e.SymbolKinds=e.SymbolTag=e.$rt=e.$qt=e.SymbolKind=e.$pt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$ot=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$nt=e.$mt=e.$lt=void 0;class ${constructor(O,T,M){this.offset=O,this.type=T,this.language=M,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$lt=$;class y{constructor(O,T){this.tokens=O,this.endState=T,this._tokenizationResultBrand=void 0}}e.$mt=y;class A{constructor(O,T){this.tokens=O,this.endState=T,this._encodedTokenizationResultBrand=void 0}}e.$nt=A;var C;(function(F){F[F.Method=0]="Method",F[F.Function=1]="Function",F[F.Constructor=2]="Constructor",F[F.Field=3]="Field",F[F.Variable=4]="Variable",F[F.Class=5]="Class",F[F.Struct=6]="Struct",F[F.Interface=7]="Interface",F[F.Module=8]="Module",F[F.Property=9]="Property",F[F.Event=10]="Event",F[F.Operator=11]="Operator",F[F.Unit=12]="Unit",F[F.Value=13]="Value",F[F.Constant=14]="Constant",F[F.Enum=15]="Enum",F[F.EnumMember=16]="EnumMember",F[F.Keyword=17]="Keyword",F[F.Text=18]="Text",F[F.Color=19]="Color",F[F.File=20]="File",F[F.Reference=21]="Reference",F[F.Customcolor=22]="Customcolor",F[F.Folder=23]="Folder",F[F.TypeParameter=24]="TypeParameter",F[F.User=25]="User",F[F.Issue=26]="Issue",F[F.Snippet=27]="Snippet"})(C||(e.CompletionItemKind=C={}));var m;(function(F){const O=new Map;O.set(0,D.$5j.symbolMethod),O.set(1,D.$5j.symbolFunction),O.set(2,D.$5j.symbolConstructor),O.set(3,D.$5j.symbolField),O.set(4,D.$5j.symbolVariable),O.set(5,D.$5j.symbolClass),O.set(6,D.$5j.symbolStruct),O.set(7,D.$5j.symbolInterface),O.set(8,D.$5j.symbolModule),O.set(9,D.$5j.symbolProperty),O.set(10,D.$5j.symbolEvent),O.set(11,D.$5j.symbolOperator),O.set(12,D.$5j.symbolUnit),O.set(13,D.$5j.symbolValue),O.set(15,D.$5j.symbolEnum),O.set(14,D.$5j.symbolConstant),O.set(15,D.$5j.symbolEnum),O.set(16,D.$5j.symbolEnumMember),O.set(17,D.$5j.symbolKeyword),O.set(27,D.$5j.symbolSnippet),O.set(18,D.$5j.symbolText),O.set(19,D.$5j.symbolColor),O.set(20,D.$5j.symbolFile),O.set(21,D.$5j.symbolReference),O.set(22,D.$5j.symbolCustomColor),O.set(23,D.$5j.symbolFolder),O.set(24,D.$5j.symbolTypeParameter),O.set(25,D.$5j.account),O.set(26,D.$5j.issues);function T(Y){let ue=O.get(Y);return ue||(console.info("No codicon found for CompletionItemKind "+Y),ue=D.$5j.symbolProperty),ue}F.toIcon=T;const M=new Map;M.set("method",0),M.set("function",1),M.set("constructor",2),M.set("field",3),M.set("variable",4),M.set("class",5),M.set("struct",6),M.set("interface",7),M.set("module",8),M.set("property",9),M.set("event",10),M.set("operator",11),M.set("unit",12),M.set("value",13),M.set("constant",14),M.set("enum",15),M.set("enum-member",16),M.set("enumMember",16),M.set("keyword",17),M.set("snippet",27),M.set("text",18),M.set("color",19),M.set("file",20),M.set("reference",21),M.set("customcolor",22),M.set("folder",23),M.set("type-parameter",24),M.set("typeParameter",24),M.set("account",25),M.set("issue",26);function W(Y,ue){let Z=M.get(Y);return typeof Z>"u"&&!ue&&(Z=9),Z}F.fromString=W})(m||(e.CompletionItemKinds=m={}));var v;(function(F){F[F.Deprecated=1]="Deprecated"})(v||(e.CompletionItemTag=v={}));var S;(function(F){F[F.None=0]="None",F[F.KeepWhitespace=1]="KeepWhitespace",F[F.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var f;(function(F){F[F.Invoke=0]="Invoke",F[F.TriggerCharacter=1]="TriggerCharacter",F[F.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f||(e.CompletionTriggerKind=f={}));var d;(function(F){F[F.Automatic=0]="Automatic",F[F.Explicit=1]="Explicit"})(d||(e.InlineCompletionTriggerKind=d={}));class s{constructor(O,T,M,W){this.range=O,this.text=T,this.completionKind=M,this.isSnippetText=W}equals(O){return I.$Ds.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$ot=s;var i;(function(F){F[F.Invoke=1]="Invoke",F[F.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var n;(function(F){F[F.Invoke=1]="Invoke",F[F.TriggerCharacter=2]="TriggerCharacter",F[F.ContentChange=3]="ContentChange"})(n||(e.SignatureHelpTriggerKind=n={}));var o;(function(F){F[F.Text=0]="Text",F[F.Read=1]="Read",F[F.Write=2]="Write"})(o||(e.DocumentHighlightKind=o={}));function a(F){return F&&N.URI.isUri(F.uri)&&I.$Ds.isIRange(F.range)&&(I.$Ds.isIRange(F.originSelectionRange)||I.$Ds.isIRange(F.targetSelectionRange))}e.$pt=a;var t;(function(F){F[F.File=0]="File",F[F.Module=1]="Module",F[F.Namespace=2]="Namespace",F[F.Package=3]="Package",F[F.Class=4]="Class",F[F.Method=5]="Method",F[F.Property=6]="Property",F[F.Field=7]="Field",F[F.Constructor=8]="Constructor",F[F.Enum=9]="Enum",F[F.Interface=10]="Interface",F[F.Function=11]="Function",F[F.Variable=12]="Variable",F[F.Constant=13]="Constant",F[F.String=14]="String",F[F.Number=15]="Number",F[F.Boolean=16]="Boolean",F[F.Array=17]="Array",F[F.Object=18]="Object",F[F.Key=19]="Key",F[F.Null=20]="Null",F[F.EnumMember=21]="EnumMember",F[F.Struct=22]="Struct",F[F.Event=23]="Event",F[F.Operator=24]="Operator",F[F.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$qt={[17]:(0,b.localize)(0,null),[16]:(0,b.localize)(1,null),[4]:(0,b.localize)(2,null),[13]:(0,b.localize)(3,null),[8]:(0,b.localize)(4,null),[9]:(0,b.localize)(5,null),[21]:(0,b.localize)(6,null),[23]:(0,b.localize)(7,null),[7]:(0,b.localize)(8,null),[0]:(0,b.localize)(9,null),[11]:(0,b.localize)(10,null),[10]:(0,b.localize)(11,null),[19]:(0,b.localize)(12,null),[5]:(0,b.localize)(13,null),[1]:(0,b.localize)(14,null),[2]:(0,b.localize)(15,null),[20]:(0,b.localize)(16,null),[15]:(0,b.localize)(17,null),[18]:(0,b.localize)(18,null),[24]:(0,b.localize)(19,null),[3]:(0,b.localize)(20,null),[6]:(0,b.localize)(21,null),[14]:(0,b.localize)(22,null),[22]:(0,b.localize)(23,null),[25]:(0,b.localize)(24,null),[12]:(0,b.localize)(25,null)};function r(F,O){return(0,b.localize)(26,null,F,e.$qt[O])}e.$rt=r;var h;(function(F){F[F.Deprecated=1]="Deprecated"})(h||(e.SymbolTag=h={}));var u;(function(F){const O=new Map;O.set(0,D.$5j.symbolFile),O.set(1,D.$5j.symbolModule),O.set(2,D.$5j.symbolNamespace),O.set(3,D.$5j.symbolPackage),O.set(4,D.$5j.symbolClass),O.set(5,D.$5j.symbolMethod),O.set(6,D.$5j.symbolProperty),O.set(7,D.$5j.symbolField),O.set(8,D.$5j.symbolConstructor),O.set(9,D.$5j.symbolEnum),O.set(10,D.$5j.symbolInterface),O.set(11,D.$5j.symbolFunction),O.set(12,D.$5j.symbolVariable),O.set(13,D.$5j.symbolConstant),O.set(14,D.$5j.symbolString),O.set(15,D.$5j.symbolNumber),O.set(16,D.$5j.symbolBoolean),O.set(17,D.$5j.symbolArray),O.set(18,D.$5j.symbolObject),O.set(19,D.$5j.symbolKey),O.set(20,D.$5j.symbolNull),O.set(21,D.$5j.symbolEnumMember),O.set(22,D.$5j.symbolStruct),O.set(23,D.$5j.symbolEvent),O.set(24,D.$5j.symbolOperator),O.set(25,D.$5j.symbolTypeParameter);function T(M){let W=O.get(M);return W||(console.info("No codicon found for SymbolKind "+M),W=D.$5j.symbolProperty),W}F.toIcon=T})(u||(e.SymbolKinds=u={}));class c{static asEditOperation(O){return g.$Es.replace(I.$Ds.lift(O.range),O.text)}}e.$st=c;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(O){switch(O){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(O)}constructor(O){this.value=O}}e.$tt=l;var k;(function(F){function O(T){return!T||typeof T!="object"?!1:typeof T.id=="string"&&typeof T.title=="string"}F.is=O})(k||(e.Command=k={}));var R;(function(F){F[F.Collapsed=0]="Collapsed",F[F.Expanded=1]="Expanded"})(R||(e.CommentThreadCollapsibleState=R={}));var w;(function(F){F[F.Unresolved=0]="Unresolved",F[F.Resolved=1]="Resolved"})(w||(e.CommentThreadState=w={}));var p;(function(F){F[F.Editing=0]="Editing",F[F.Preview=1]="Preview"})(p||(e.CommentMode=p={}));var E;(function(F){F[F.Published=0]="Published",F[F.Draft=1]="Draft"})(E||(e.CommentState=E={}));var P;(function(F){F[F.Type=1]="Type",F[F.Parameter=2]="Parameter"})(P||(e.InlayHintKind=P={}));class z{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$ut=z,e.$vt=new L.$ct;var j;(function(F){F[F.None=0]="None",F[F.Option=1]="Option",F[F.Default=2]="Default",F[F.Preferred=3]="Preferred"})(j||(e.ExternalUriOpenerPriority=j={}))}),define(Ee[195],Se([9,10]),function($e,e){return $e.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ee[196],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/contextkey",e)}),define(Ee[197],Se([9,10]),function($e,e){return $e.create("vs/platform/contextkey/common/scanner",e)}),define(Ee[198],Se([9,10]),function($e,e){return $e.create("vs/platform/dialogs/common/dialogs",e)}),define(Ee[199],Se([9,10]),function($e,e){return $e.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ee[200],Se([9,10]),function($e,e){return $e.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ee[201],Se([9,10]),function($e,e){return $e.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ee[202],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/files",e)}),define(Ee[203],Se([9,10]),function($e,e){return $e.create("vs/platform/files/common/io",e)}),define(Ee[204],Se([9,10]),function($e,e){return $e.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Ee[205],Se([9,10]),function($e,e){return $e.create("vs/platform/markers/common/markers",e)}),define(Ee[206],Se([9,10]),function($e,e){return $e.create("vs/platform/theme/common/iconRegistry",e)}),define(Ee[207],Se([9,10]),function($e,e){return $e.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Ee[208],Se([9,10]),function($e,e){return $e.create("vs/platform/workspace/common/workspace",e)}),define(Ee[209],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Ee[210],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ee[211],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ee[212],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ee[213],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostLogService",e)}),define(Ee[214],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ee[215],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostProgress",e)}),define(Ee[216],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ee[217],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ee[218],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ee[219],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ee[220],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ee[221],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ee[222],Se([9,10]),function($e,e){return $e.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ee[223],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/configuration",e)}),define(Ee[224],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/editor",e)}),define(Ee[225],Se([9,10]),function($e,e){return $e.create("vs/workbench/common/views",e)}),define(Ee[226],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ee[227],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ee[228],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ee[229],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ee[230],Se([9,10]),function($e,e){return $e.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ee[231],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ee[232],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ee[233],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ee[234],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(Ee[235],Se([9,10]),function($e,e){return $e.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ee[236],Se([1,0,8,197]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.TokenType=void 0;var g;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(g||(e.TokenType=g={}));function I(...y){switch(y.length){case 1:return(0,N.localize)(0,null,y[0]);case 2:return(0,N.localize)(1,null,y[0],y[1]);case 3:return(0,N.localize)(2,null,y[0],y[1],y[2]);default:return}}const L=(0,N.localize)(3,null),b=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,D.$7)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const C=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:C})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const C=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:C})}else this.h(126)?this.k(9):this.l(I("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(I("&&"));break;case 124:this.h(124)?this.k(16):this.l(I("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const C=this.d,m=this.c.substring(this.d,this.e),v={type:19,offset:this.d,lexeme:m};this.g.push({offset:C,lexeme:m,additionalInfo:A}),this.f.push(v)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const C=this.c.substring(this.d,this.e),m=$.b.get(C);m?this.k(m):this.f.push({type:17,lexeme:C,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,C=!1,m=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(b);return}const S=this.c.charCodeAt(A);if(C)C=!1;else if(S===47&&!m){A++;break}else S===91?m=!0:S===92?C=!0:S===93&&(m=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const v=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:v,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ui=$}),define(Ee[237],Se([1,0,23,39,200,385]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function $(s){return s=s.trim(),s==="*"||L.test(s)}e.$Vo=$;function y(s){if(!$(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$Wo=y;function A(s){if(!s)return null;const i=s.majorBase,n=s.majorMustEqual,o=s.minorBase;let a=s.minorMustEqual;const t=s.patchBase;let r=s.patchMustEqual;s.hasCaret&&(i===0||(a=!1),r=!1);let h=0;if(s.preRelease){const u=b.exec(s.preRelease);if(u){const[,c,l,k]=u;h=Date.UTC(Number(c),Number(l)-1,Number(k))}}return{majorBase:i,majorMustEqual:n,minorBase:o,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:s.hasGreaterEquals,notBefore:h}}e.$Xo=A;function C(s,i,n){let o;typeof s=="string"?o=A(y(s)):o=s;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof n=="string"?t=A(y(n)):t=n,!o||!t)return!1;const r=o.majorBase,h=o.minorBase,u=o.patchBase;let c=t.majorBase,l=t.minorBase,k=t.patchBase;const R=t.notBefore;let w=t.majorMustEqual,p=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?r>c?!0:r<c?!1:h>l?!0:h<l||a&&a<R?!1:u>=k:(r===1&&c===0&&(!w||!p||!E)&&(c=1,l=0,k=0,w=!0,p=!1,E=!1),r<c?!1:r>c?!w:h<l?!1:h>l?!p:u<k?!1:u>k?!E:!(a&&a<R))}e.$Yo=C;function m(s,i,n,o,a){const t=[];if(typeof o.publisher<"u"&&typeof o.publisher!="string")return t.push([N.default.Error,g.localize(0,null)]),t;if(typeof o.name!="string")return t.push([N.default.Error,g.localize(1,null,"name")]),t;if(typeof o.version!="string")return t.push([N.default.Error,g.localize(2,null,"version")]),t;if(!o.engines)return t.push([N.default.Error,g.localize(3,null,"engines")]),t;if(typeof o.engines.vscode!="string")return t.push([N.default.Error,g.localize(4,null,"engines.vscode")]),t;if(typeof o.extensionDependencies<"u"&&!d(o.extensionDependencies))return t.push([N.default.Error,g.localize(5,null,"extensionDependencies")]),t;if(typeof o.activationEvents<"u"){if(!d(o.activationEvents))return t.push([N.default.Error,g.localize(6,null,"activationEvents")]),t;if(typeof o.main>"u"&&typeof o.browser>"u")return t.push([N.default.Error,g.localize(7,null,"activationEvents","main","browser")]),t}if(typeof o.extensionKind<"u"&&typeof o.main>"u"&&t.push([N.default.Warning,g.localize(8,null,"extensionKind")]),typeof o.main<"u"){if(typeof o.main!="string")return t.push([N.default.Error,g.localize(9,null,"main")]),t;{const u=(0,D.$Bg)(n,o.main);(0,D.$vg)(u,n)||t.push([N.default.Warning,g.localize(10,null,u.path,n.path)])}}if(typeof o.browser<"u"){if(typeof o.browser!="string")return t.push([N.default.Error,g.localize(11,null,"browser")]),t;{const u=(0,D.$Bg)(n,o.browser);(0,D.$vg)(u,n)||t.push([N.default.Warning,g.localize(12,null,u.path,n.path)])}}if(!I.valid(o.version))return t.push([N.default.Error,g.localize(13,null)]),t;const r=[];if(!v(s,i,o,a,r))for(const u of r)t.push([N.default.Error,u]);return t}e.$Zo=m;function v(s,i,n,o,a){return o||typeof n.main>"u"&&typeof n.browser>"u"?!0:f(s,i,n.engines.vscode,a)}e.$1o=v;function S(s,i,n){return s==="*"||f(i,n,s)}e.$2o=S;function f(s,i,n,o=[]){const a=A(y(n));if(!a)return o.push(g.localize(14,null,n)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return o.push(g.localize(15,null,n)),!1}else if(!a.majorMustEqual)return o.push(g.localize(16,null,n)),!1;return C(s,i,a)?!0:(o.push(g.localize(17,null,s,n)),!1)}function d(s){if(!Array.isArray(s))return!1;for(let i=0,n=s.length;i<n;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Ee[105],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=void 0;class D{constructor(g,I=[],L=!1){this.ctor=g,this.staticArguments=I,this.supportsDelayedInstantiation=L}}e.$Wh=D}),define(Ee[106],Se([1,0,105]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.InstantiationType=void 0;const N=[];var g;(function(b){b[b.Eager=0]="Eager",b[b.Delayed=1]="Delayed"})(g||(e.InstantiationType=g={}));function I(b,$,y){$ instanceof D.$Wh||($=new D.$Wh($,[],!!y)),N.push([b,$])}e.$Gr=I;function L(){return N}e.$Hr=L}),define(Ee[238],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class D{constructor(I,L){this.key=I,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$lq=D;class N{constructor(I){this.b=I,this.a=new Map}roots(){const I=[];for(const L of this.a.values())L.outgoing.size===0&&I.push(L);return I}insertEdge(I,L){const b=this.lookupOrInsertNode(I),$=this.lookupOrInsertNode(L);b.outgoing.set($.key,$),$.incoming.set(b.key,b)}removeNode(I){const L=this.b(I);this.a.delete(L);for(const b of this.a.values())b.outgoing.delete(L),b.incoming.delete(L)}lookupOrInsertNode(I){const L=this.b(I);let b=this.a.get(L);return b||(b=new D(L,I),this.a.set(L,b)),b}lookup(I){return this.a.get(this.b(I))}isEmpty(){return this.a.size===0}toString(){const I=[];for(const[L,b]of this.a)I.push(`${L}
	(-> incoming)[${[...b.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...b.outgoing.keys()].join(",")}]
`);return I.join(`
`)}findCycleSlow(){for(const[I,L]of this.a){const b=new Set([I]),$=this.c(L,b);if($)return $}}c(I,L){for(const[b,$]of I.outgoing){if(L.has(b))return[...L,b].join(" -> ");L.add(b);const y=this.c($,L);if(y)return y;L.delete(b)}}}e.$mq=N}),define(Ee[5],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e._util=void 0;var D;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function b($){return $[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=b})(D||(e._util=D={})),e.$Yh=g("instantiationService");function N(L,b,$){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:L,index:$}):(b[D.DI_DEPENDENCIES]=[{id:L,index:$}],b[D.DI_TARGET]=b)}function g(L){if(D.serviceIds.has(L))return D.serviceIds.get(L);const b=function($,y,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(b,$,A)};return b.toString=()=>L,D.serviceIds.set(L,b),b}e.$Zh=g;function I(L){return L}e.$1h=I}),define(Ee[45],Se([1,0,18,2,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.ConfigurationTarget=e.$vi=e.$ui=e.$ti=void 0,e.$ti=(0,g.$Zh)("configurationService");function I(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}e.$ui=I;function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}e.$vi=L;var b;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(b||(e.ConfigurationTarget=b={}));function $(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$wi=$;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$xi=y;function A(s,i){const n=Object.create(null);for(const o in s)C(n,o,s[o],i);return n}e.$yi=A;function C(s,i,n,o){const a=i.split("."),t=a.pop();let r=s;for(let h=0;h<a.length;h++){const u=a[h];let c=r[u];switch(typeof c){case"undefined":c=r[u]=Object.create(null);break;case"object":break;default:o(`Ignoring ${i} as ${a.slice(0,h+1).join(".")} is ${JSON.stringify(c)}`);return}r=c}if(typeof r=="object"&&r!==null)try{r[t]=n}catch{o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}else o(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(r)}`)}e.$zi=C;function m(s,i){const n=i.split(".");v(s,n)}e.$Ai=m;function v(s,i){const n=i.shift();if(i.length===0){delete s[n];return}if(Object.keys(s).indexOf(n)!==-1){const o=s[n];typeof o=="object"&&!Array.isArray(o)&&(v(o,i),Object.keys(o).length===0&&delete s[n])}}function S(s,i,n){function o(r,h){let u=r;for(const c of h){if(typeof u!="object"||u===null)return;u=u[c]}return u}const a=i.split("."),t=o(s,a);return typeof t>"u"?n:t}e.$Bi=S;function f(s,i,n){Object.keys(i).forEach(o=>{o!=="__proto__"&&(o in s?D.$Ef(s[o])&&D.$Ef(i[o])?f(s[o],i[o],n):n&&(s[o]=i[o]):s[o]=i[o])})}e.$Ci=f;function d(s){return s.replace(/[\[\]]/g,"")}e.$Di=d}),define(Ee[46],Se([1,0,11,13,236,5,196,8]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.ContextKeyExprType=e.$Vi=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",D.$j),$.set("isLinux",D.$k),$.set("isWindows",D.$i),$.set("isWeb",D.$o),$.set("isMacNative",D.$j&&!D.$o),$.set("isEdge",D.$H),$.set("isFirefox",D.$F),$.set("isChrome",D.$E),$.set("isSafari",D.$G);function y(V,U){if($.get(V)!==void 0)throw(0,b.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(V,U)}e.$Vi=y;const A=Object.prototype.hasOwnProperty;var C;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(C||(e.ContextKeyExprType=C={}));const m={regexParsingWithErrorRecovery:!0},v=(0,L.localize)(0,null),S=(0,L.localize)(1,null),f=(0,L.localize)(2,null),d=(0,L.localize)(3,null),s=(0,L.localize)(4,null),i=(0,L.localize)(5,null),n=(0,L.localize)(6,null),o=(0,L.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=m){this.k=U,this.d=new g.$Ui,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:v,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const ne=this.l();if(!this.E()){const ye=this.D(),fe=ye.type===17?i:void 0;throw this.h.push({message:s,offset:ye.offset,lexeme:g.$Ui.getLexeme(ye),additionalInfo:fe}),a.c}return ne}catch(ne){if(ne!==a.c)throw ne;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const ne=this.o();U.push(ne)}return U.length===1?U[0]:t.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const ne=this.s();U.push(ne)}return U.length===1?U[0]:t.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),c.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const ne=this.l();return this.A(1,d),ne?.negate()}case 17:return this.z(),P.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ne=this.l();return this.A(1,d),ne}case 17:{const ne=U.lexeme;if(this.z(),this.y(9)){const fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),fe.type!==10)throw this.B("REGEX",fe);const me=fe.lexeme,ee=me.lastIndexOf("/"),ie=ee===me.length-1?void 0:this.w(me.substring(ee+1));let G;try{G=new RegExp(me.substring(1,ee),ie)}catch{throw this.B("REGEX",fe)}return M.create(ne,G)}switch(fe.type){case 10:case 19:{const me=[fe.lexeme];this.z();let ee=this.D(),ie=0;for(let be=0;be<fe.lexeme.length;be++)fe.lexeme.charCodeAt(be)===40?ie++:fe.lexeme.charCodeAt(be)===41&&ie--;for(;!this.E()&&ee.type!==15&&ee.type!==16;){switch(ee.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let be=0;be<ee.lexeme.length;be++)ee.lexeme.charCodeAt(be)===40?ie++:fe.lexeme.charCodeAt(be)===41&&ie--}if(ie<0)break;me.push(g.$Ui.getLexeme(ee)),this.z(),ee=this.D()}const G=me.join(""),te=G.lastIndexOf("/"),J=te===G.length-1?void 0:this.w(G.substring(te+1));let ce;try{ce=new RegExp(G.substring(1,te),J)}catch{throw this.B("REGEX",fe)}return t.regex(ne,ce)}case 18:{const me=fe.lexeme;this.z();let ee=null;if(!(0,N.$Fe)(me)){const ie=me.indexOf("/"),G=me.lastIndexOf("/");if(ie!==G&&ie>=0){const te=me.slice(ie+1,G),J=me[G+1]==="i"?"i":"";try{ee=new RegExp(te,J)}catch{throw this.B("REGEX",fe)}}}if(ee===null)throw this.B("REGEX",fe);return M.create(ne,ee)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,f);const fe=this.u();return t.notIn(ne,fe)}switch(this.D().type){case 3:{this.z();const fe=this.u();if(this.x().type===18)return t.equals(ne,fe);switch(fe){case"true":return t.has(ne);case"false":return t.not(ne);default:return t.equals(ne,fe)}}case 4:{this.z();const fe=this.u();if(this.x().type===18)return t.notEquals(ne,fe);switch(fe){case"true":return t.not(ne);case"false":return t.has(ne);default:return t.notEquals(ne,fe)}}case 5:return this.z(),O.create(ne,this.u());case 6:return this.z(),T.create(ne,this.u());case 7:return this.z(),j.create(ne,this.u());case 8:return this.z(),F.create(ne,this.u());case 13:return this.z(),t.in(ne,this.u());default:return t.has(ne)}}case 20:throw this.h.push({message:n,offset:U.offset,lexeme:"",additionalInfo:o}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,ne){if(this.C(U))return this.z();throw this.B(ne,this.D())}B(U,ne,ye){const fe=(0,L.localize)(8,null,U,g.$Ui.getLexeme(ne)),me=ne.offset,ee=g.$Ui.getLexeme(ne);return this.h.push({message:fe,offset:me,lexeme:ee,additionalInfo:ye}),a.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Wi=a;class t{static false(){return c.INSTANCE}static true(){return l.INSTANCE}static has(U){return k.create(U)}static equals(U,ne){return R.create(U,ne)}static notEquals(U,ne){return E.create(U,ne)}static regex(U,ne){return M.create(U,ne)}static in(U,ne){return w.create(U,ne)}static notIn(U,ne){return p.create(U,ne)}static not(U){return P.create(U)}static and(...U){return ue.create(U,null,!0)}static or(...U){return Z.create(U,null,!0)}static greater(U,ne){return j.create(U,ne)}static greaterEquals(U,ne){return F.create(U,ne)}static smaller(U,ne){return O.create(U,ne)}static smallerEquals(U,ne){return T.create(U,ne)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$Xi=t;function r(V){const U=new a({regexParsingWithErrorRecovery:!1});return V.map(ne=>(U.parse(ne),U.lexingErrors.length>0?U.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,L.localize)(9,null,ye.additionalInfo):(0,L.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$Yi=r;function h(V,U){const ne=V?V.substituteConstants():void 0,ye=U?U.substituteConstants():void 0;return!ne&&!ye?!0:!ne||!ye?!1:ne.equals(ye)}e.$Zi=h;function u(V,U){return V.cmp(U)}class c{static{this.INSTANCE=new c}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return l.INSTANCE}}e.$1i=c;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return c.INSTANCE}}e.$2i=l;class k{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?l.INSTANCE:c.INSTANCE:new k(U,ne)}constructor(U,ne){this.key=U,this.c=ne,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:x(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=$.get(this.key);return typeof U=="boolean"?U?l.INSTANCE:c.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$3i=k;class R{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?k.create(U,ye):P.create(U,ye);const fe=$.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?l.INSTANCE:c.INSTANCE:new R(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?l.INSTANCE:c.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$4i=R;class w{static create(U,ne){return new w(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.f),ye=U.getValue(this.d);return Array.isArray(ne)?ne.includes(ye):typeof ye=="string"&&typeof ne=="object"&&ne!==null?A.call(ne,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=p.create(this.d,this.f)),this.c}}e.$5i=w;class p{static create(U,ne){return new p(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=11,this.c=w.create(U,ne)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$6i=p;class E{static create(U,ne,ye=null){if(typeof ne=="boolean")return ne?P.create(U,ye):k.create(U,ye);const fe=$.get(U);return typeof fe=="boolean"?ne===(fe?"true":"false")?c.INSTANCE:l.INSTANCE:new E(U,ne,ye)}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=$.get(this.c);if(typeof U=="boolean"){const ne=U?"true":"false";return this.d===ne?c.INSTANCE:l.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$7i=E;class P{static create(U,ne=null){const ye=$.get(U);return typeof ye=="boolean"?ye?c.INSTANCE:l.INSTANCE:new P(U,ne)}constructor(U,ne){this.c=U,this.d=ne,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:x(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=$.get(this.c);return typeof U=="boolean"?U?c.INSTANCE:l.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$8i=P;function z(V,U){if(typeof V=="string"){const ne=parseFloat(V);isNaN(ne)||(V=ne)}return typeof V=="string"||typeof V=="number"?U(V):c.INSTANCE}class j{static create(U,ne,ye=null){return z(ne,fe=>new j(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$9i=j;class F{static create(U,ne,ye=null){return z(ne,fe=>new F(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$0i=F;class O{static create(U,ne,ye=null){return z(ne,fe=>new O(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$$i=O;class T{static create(U,ne,ye=null){return z(ne,fe=>new T(U,fe,ye))}constructor(U,ne,ye){this.c=U,this.d=ne,this.f=ye,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:oe(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$_i=T;class M{static create(U,ne){return new M(U,ne)}constructor(U,ne){this.d=U,this.f=ne,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return ne<ye?-1:ne>ye?1:0}equals(U){if(U.type===this.type){const ne=this.f?this.f.source:"",ye=U.f?U.f.source:"";return this.d===U.d&&ne===ye}return!1}substituteConstants(){return this}evaluate(U){const ne=U.getValue(this.d);return this.f?this.f.test(ne):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$aj=M;class W{static create(U){return new W(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new W(this.c.map(U))}negate(){return this.c}}e.$bj=W;function Y(V){let U=null;for(let ne=0,ye=V.length;ne<ye;ne++){const fe=V[ne].substituteConstants();if(V[ne]!==fe&&U===null){U=[];for(let me=0;me<ne;me++)U[me]=V[me]}U!==null&&(U[ne]=fe)}return U===null?V:U}class ue{static create(U,ne,ye){return ue.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:ue.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].evaluate(U))return!1;return!0}static d(U,ne,ye){const fe=[];let me=!1;for(const ee of U)if(ee){if(ee.type===1){me=!0;continue}if(ee.type===0)return c.INSTANCE;if(ee.type===6){fe.push(...ee.expr);continue}fe.push(ee)}if(fe.length===0&&me)return l.INSTANCE;if(fe.length!==0){if(fe.length===1)return fe[0];fe.sort(u);for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];for(;fe.length>1;){const ee=fe[fe.length-1];if(ee.type!==9)break;fe.pop();const ie=fe.pop(),G=fe.length===0,te=Z.create(ee.expr.map(J=>ue.create([J,ie],null,ye)),null,G);te&&(fe.push(te),fe.sort(u))}if(fe.length===1)return fe[0];if(ye){for(let ee=0;ee<fe.length;ee++)for(let ie=ee+1;ie<fe.length;ie++)if(fe[ee].negate().equals(fe[ie]))return c.INSTANCE;if(fe.length===1)return fe[0]}return new ue(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new ue(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());this.c=Z.create(U,this,!0)}return this.c}}e.$cj=ue;class Z{static create(U,ne,ye){return Z.d(U,ne,ye)}constructor(U,ne){this.expr=U,this.c=ne,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let ne=0,ye=this.expr.length;ne<ye;ne++){const fe=u(this.expr[ne],U.expr[ne]);if(fe!==0)return fe}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(!this.expr[ne].equals(U.expr[ne]))return!1;return!0}return!1}substituteConstants(){const U=Y(this.expr);return U===this.expr?this:Z.create(U,this.c,!1)}evaluate(U){for(let ne=0,ye=this.expr.length;ne<ye;ne++)if(this.expr[ne].evaluate(U))return!0;return!1}static d(U,ne,ye){let fe=[],me=!1;if(U){for(let ee=0,ie=U.length;ee<ie;ee++){const G=U[ee];if(G){if(G.type===0){me=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){fe=fe.concat(G.expr);continue}fe.push(G)}}if(fe.length===0&&me)return c.INSTANCE;fe.sort(u)}if(fe.length!==0){if(fe.length===1)return fe[0];for(let ee=1;ee<fe.length;ee++)fe[ee-1].equals(fe[ee])&&(fe.splice(ee,1),ee--);if(fe.length===1)return fe[0];if(ye){for(let ee=0;ee<fe.length;ee++)for(let ie=ee+1;ie<fe.length;ie++)if(fe[ee].negate().equals(fe[ie]))return l.INSTANCE;if(fe.length===1)return fe[0]}return new Z(fe,ne)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const ne of this.expr)U.push(...ne.keys());return U}map(U){return new Z(this.expr.map(ne=>ne.map(U)),null)}negate(){if(!this.c){const U=[];for(const ne of this.expr)U.push(ne.negate());for(;U.length>1;){const ne=U.shift(),ye=U.shift(),fe=[];for(const me of ge(ne))for(const ee of ge(ye))fe.push(ue.create([me,ee],null,!1));U.unshift(Z.create(fe,null,!1))}this.c=Z.create(U,this,!0)}return this.c}}e.$dj=Z;class Q extends k{static{this.d=[]}static all(){return Q.d.values()}constructor(U,ne,ye){super(U,null),this.f=ne,typeof ye=="object"?Q.d.push({...ye,key:U}):ye!==!0&&Q.d.push({key:U,description:ye,type:ne!=null?typeof ne:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return R.create(this.key,U)}notEqualsTo(U){return E.create(this.key,U)}}e.$ej=Q,e.$fj=(0,I.$Zh)("contextKeyService");function x(V,U){return V<U?-1:V>U?1:0}function oe(V,U,ne,ye){return V<ne?-1:V>ne?1:U<ye?-1:U>ye?1:0}function X(V,U){if(V.type===0||U.type===1)return!0;if(V.type===9)return U.type===9?ve(V.expr,U.expr):!1;if(U.type===9){for(const ne of U.expr)if(X(V,ne))return!0;return!1}if(V.type===6){if(U.type===6)return ve(U.expr,V.expr);for(const ne of V.expr)if(X(ne,U))return!0;return!1}return V.equals(U)}e.$gj=X;function ve(V,U){let ne=0,ye=0;for(;ne<V.length&&ye<U.length;){const fe=V[ne].cmp(U[ye]);if(fe<0)return!1;fe===0&&ne++,ye++}return ne===V.length}function ge(V){return V.type===9?V.expr:[V]}}),define(Ee[239],Se([1,0,23,39,198,5,102,11,24]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rv=e.$Qv=e.ConfirmResult=e.$Pv=e.$Ov=e.$Nv=void 0,e.$Nv=(0,I.$Zh)("dialogService");var y;(function(f){f[f.Confirmation=1]="Confirmation",f[f.Prompt=2]="Prompt",f[f.Input=3]="Input"})(y||(y={}));class A{a(d){return this.d(d,y.Confirmation)}b(d){return this.d(d,y.Prompt)}c(d){return this.d(d,y.Input)}d(d,s){const i=[];switch(s){case y.Confirmation:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(0,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(1,null));break}case y.Prompt:{const n=d;Array.isArray(n.buttons)&&n.buttons.length>0&&i.push(...n.buttons.map(o=>o.label)),n.cancelButton&&(n.cancelButton===!0?i.push((0,g.localize)(2,null)):typeof n.cancelButton=="string"?i.push(n.cancelButton):n.cancelButton.label?i.push(n.cancelButton.label):i.push((0,g.localize)(3,null))),i.length===0&&i.push((0,g.localize)(4,null));break}case y.Input:{const n=d;n.primaryButton?i.push(n.primaryButton):i.push((0,g.localize)(5,null)),n.cancelButton?i.push(n.cancelButton):i.push((0,g.localize)(6,null));break}}return i}e(d){if(typeof d=="string")return d;if(typeof d=="number")return d===N.default.Info?"info":d===N.default.Error?"error":d===N.default.Warning?"warning":"none"}f(d,s,i){const n=[...d.buttons??[]];d.cancelButton&&typeof d.cancelButton!="string"&&typeof d.cancelButton!="boolean"&&n.push(d.cancelButton);let o=n[s]?.run({checkboxChecked:i});return o instanceof Promise||(o=Promise.resolve(o)),{result:o,checkboxChecked:i}}}e.$Ov=A,e.$Pv=(0,I.$Zh)("fileDialogService");var C;(function(f){f[f.SAVE=0]="SAVE",f[f.DONT_SAVE=1]="DONT_SAVE",f[f.CANCEL=2]="CANCEL"})(C||(e.ConfirmResult=C={}));const m=10;function v(f){const d=[];return d.push(...f.slice(0,m).map(s=>typeof s=="string"?s:(0,D.$yg)(s))),f.length>m&&(f.length-m===1?d.push((0,g.localize)(7,null)):d.push((0,g.localize)(8,null,f.length-m))),d.push(""),d.join(`
`)}e.$Qv=v;function S(f,d){const s=(0,$.$en)(f);let i=(s.buttons??[]).map(t=>(0,L.$Kv)(t)),n=(f.buttons||[]).map((t,r)=>r),o=0,a=s.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(b.$k||b.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const r=n[a];n.splice(a,1),n.splice(1,0,r),a=1}b.$k&&i.length>1&&(i=i.reverse(),n=n.reverse(),o=i.length-1,typeof t=="string"&&(a=o-1))}else if(b.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const r=n[a];n.splice(a,1),n.push(r),a=i.length-1}}return s.buttons=i,s.defaultId=o,s.cancelId=a,s.noLink=!0,s.title=s.title||d.nameLong,{options:s,buttonIndeces:n}}e.$Rv=S}),define(Ee[133],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=void 0,e.$7h=(0,D.$Zh)("environmentService"),e.$8h=(0,D.$1h)(e.$7h)}),define(Ee[134],Se([1,0,199,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ho=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=void 0,e.$8n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9n=new RegExp(e.$8n),e.$0n="__web_extension",e.$$n="skipWalkthrough",e.$_n="extensionsSync",e.$ao="dependecyOrPackExtensionInstall";function g(s){switch(s){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$bo=g;function I(s){switch(s){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$co=I;function L(s,i){switch(s){case 3:return i==="x64"?"win32-x64":i==="arm64"?"win32-arm64":"unknown";case 2:return i==="x64"?"linux-x64":i==="arm64"?"linux-arm64":i==="arm"?"linux-armhf":"unknown";case"alpine":return i==="x64"?"alpine-x64":i==="arm64"?"alpine-arm64":"unknown";case 1:return i==="x64"?"darwin-x64":i==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$do=L;function b(s,i){return i==="web"&&!s.includes("web")}e.$eo=b;function $(s,i,n){return b(i,n)?!1:s==="undefined"||s==="universal"?!0:s==="unknown"?!1:s===n}e.$fo=$;function y(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(!s.uuid||typeof s.uuid=="string")}e.$go=y;var A;(function(s){s[s.NoneOrRelevance=0]="NoneOrRelevance",s[s.LastUpdatedDate=1]="LastUpdatedDate",s[s.Title=2]="Title",s[s.PublisherName=3]="PublisherName",s[s.InstallCount=4]="InstallCount",s[s.PublishedDate=10]="PublishedDate",s[s.AverageRating=6]="AverageRating",s[s.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var C;(function(s){s[s.Default=0]="Default",s[s.Ascending=1]="Ascending",s[s.Descending=2]="Descending"})(C||(e.SortOrder=C={}));var m;(function(s){s.Install="install",s.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var v;(function(s){s[s.None=1]="None",s[s.Install=2]="Install",s[s.Update=3]="Update",s[s.Migrate=4]="Migrate"})(v||(e.InstallOperation=v={})),e.$ho=(0,N.$Zh)("extensionGalleryService");var S;(function(s){s.Unsupported="Unsupported",s.Deprecated="Deprecated",s.Malicious="Malicious",s.Incompatible="Incompatible",s.IncompatibleTargetPlatform="IncompatibleTargetPlatform",s.ReleaseVersionNotFound="ReleaseVersionNotFound",s.Invalid="Invalid",s.Download="Download",s.Extract="Extract",s.Delete="Delete",s.Rename="Rename",s.CorruptZip="CorruptZip",s.IncompleteZip="IncompleteZip",s.Signature="Signature",s.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var f;(function(s){s.UnknownError="UnknownError",s.PackageIsInvalidZip="PackageIsInvalidZip",s.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(f||(e.ExtensionSignaturetErrorCode=f={}));class d extends Error{constructor(i,n){super(i),this.code=n,this.name=n}}e.$io=d,e.$jo=(0,N.$Zh)("extensionManagementService"),e.$ko="extensionsIdentifiers/disabled",e.$lo="extensionsIdentifiers/enabled",e.$mo=(0,N.$Zh)("IGlobalExtensionEnablementService"),e.$no=(0,N.$Zh)("IExtensionTipsService"),e.$oo=(0,D.localize)(0,null),e.$po={value:e.$oo,original:"Extensions"},e.$qo={value:(0,D.localize)(1,null),original:"Preferences"}}),define(Ee[240],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u1b=e.$t1b=void 0,e.$t1b=(0,D.$Zh)("externalTerminal"),e.$u1b="Terminal.app"}),define(Ee[241],Se([1,0,51,17,16,11,101,31,104,201,240]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t9b=e.$s9b=e.$r9b=void 0;const C=y.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:v.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class v extends m{static{this.b="cmd.exe"}openTerminal(o,a){return this.spawnTerminal(D,o,$.$Ll(),a)}spawnTerminal(o,a,t,r){const h=a.windowsExec||v.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const u=g.$mc(h,".exe").toLowerCase();if(u==="cmder")return o.spawn(h,r?[r]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return h.indexOf(" ")>=0&&c.push('""'),c.push(h),u==="wt"&&c.push("-d ."),new Promise((l,k)=>{const R=d(process),w=o.spawn(t,c,{cwd:r,env:R});w.on("error",k),w.on("exit",()=>l())})}runInTerminal(o,a,t,r,h){const u="windowsExec"in h&&h.windowsExec?h.windowsExec:v.getDefaultTerminalWindows();return new Promise((c,l)=>{const k=`"${a} - ${C}"`,R=`""${t.join('" "')}" & pause"`,w=Object.assign({},d(process),r);Object.keys(w).filter(j=>w[j]===null).forEach(j=>delete w[j]);const p={cwd:a,env:w,windowsVerbatimArguments:!0};let E,P;g.$mc(u,".exe")==="wt"?(E=u,P=["-d",".",v.b,"/c",R]):(E=v.b,P=["/c","start",k,"/wait",u,"/c",R]),D.spawn(E,P,p).on("error",j=>{l(s(j))}),c(void 0)})}static getDefaultTerminalWindows(){if(!v.d){const o=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");v.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${o?"Sysnative":"System32"}\\cmd.exe`}return v.d}}e.$r9b=v;class S extends m{static{this.b="/usr/bin/osascript"}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.osxExec||A.$u1b;return new Promise((c,l)=>{if(u===A.$u1b||u==="iTerm.app"){const k=u===A.$u1b?"TerminalHelper":"iTermHelper",w=[N.$ig.asFileUri(`vs/workbench/contrib/externalTerminal/node/${k}.scpt`).fsPath,"-t",o||C,"-w",a];for(const P of t)w.push("-a"),w.push(P);if(r){const P=Object.assign({},d(process),r);for(const z in P){const j=P[z];j===null?(w.push("-u"),w.push(z)):(w.push("-e"),w.push(`${z}=${j}`))}}let p="";const E=D.spawn(S.b,w);E.on("error",P=>{l(s(P))}),E.stderr.on("data",P=>{p+=P.toString()}),E.on("exit",P=>{if(P===0)c(void 0);else if(p){const z=p.split(`
`,1);l(new Error(z[0]))}else l(new Error(y.localize(1,null,k,P)))})}else l(new Error(y.localize(2,null,u)))})}spawnTerminal(o,a,t){const r=a.osxExec||A.$u1b;return new Promise((h,u)=>{const c=["-a",r];t&&c.push(t);const l=d(process),k=o.spawn("/usr/bin/open",c,{cwd:t,env:l});k.on("error",u),k.on("exit",()=>h())})}}e.$s9b=S;class f extends m{static{this.b=y.localize(3,null)}openTerminal(o,a){return this.spawnTerminal(D,o,a)}runInTerminal(o,a,t,r,h){const u=h.linuxExec?Promise.resolve(h.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,l)=>{const k=[];u.then(R=>{R.indexOf("gnome-terminal")>=0?k.push("-x"):k.push("-e"),k.push("bash"),k.push("-c");const w=`${i(t)}; echo; read -p "${f.b}" -n1;`;k.push(`''${w}''`);const p=Object.assign({},d(process),r);Object.keys(p).filter(j=>p[j]===null).forEach(j=>delete p[j]);const E={cwd:a,env:p};let P="";const z=D.spawn(R,k,E);z.on("error",j=>{l(s(j))}),z.stderr.on("data",j=>{P+=j.toString()}),z.on("exit",j=>{if(j===0)c(void 0);else if(P){const F=P.split(`
`,1);l(new Error(F[0]))}else l(new Error(y.localize(4,null,R,j)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!I.$k)f.d=Promise.resolve("xterm");else{const o=await b.Promises.exists("/etc/debian_version");f.d=new Promise(a=>{o?a("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?a("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?a("konsole"):process.env.COLORTERM?a(process.env.COLORTERM):process.env.TERM?a(process.env.TERM):a("xterm")})}return f.d}spawnTerminal(o,a,t){const r=a.linuxExec?Promise.resolve(a.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((h,u)=>{r.then(c=>{const l=d(process),k=o.spawn(c,[],{cwd:t,env:l});k.on("error",u),k.on("exit",()=>h())})})}}e.$t9b=f;function d(n){const o={...n.env};return(0,L.$Jl)(o),o}function s(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(y.localize(5,null,n.path)):n}function i(n){let o="";for(const a of n)a.indexOf(" ")>=0?o+='"'+a+'"':o+=a,o+=" ";return o}}),define(Ee[32],Se([1,0,77,16,13,18,2,202,5,11,17,43]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileKind=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileOperationResult=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileChangeType=e.$Ak=e.FileOperation=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderErrorCode=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderCapabilities=e.$kk=e.FilePermission=e.FileType=e.$jk=e.$ik=void 0,e.$ik=(0,$.$Zh)("fileService");function m(X){return X.create===!0}e.$jk=m;var v;(function(X){X[X.Unknown=0]="Unknown",X[X.File=1]="File",X[X.Directory=2]="Directory",X[X.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var S;(function(X){X[X.Readonly=1]="Readonly",X[X.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function f(X){const ve=X;return!!ve&&typeof ve.onDidChange=="function"}e.$kk=f;var d;(function(X){X[X.None=0]="None",X[X.FileReadWrite=2]="FileReadWrite",X[X.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",X[X.FileReadStream=16]="FileReadStream",X[X.FileFolderCopy=8]="FileFolderCopy",X[X.PathCaseSensitive=1024]="PathCaseSensitive",X[X.Readonly=2048]="Readonly",X[X.Trash=4096]="Trash",X[X.FileWriteUnlock=8192]="FileWriteUnlock",X[X.FileAtomicRead=16384]="FileAtomicRead",X[X.FileAtomicWrite=32768]="FileAtomicWrite",X[X.FileAtomicDelete=65536]="FileAtomicDelete",X[X.FileClone=131072]="FileClone"})(d||(e.FileSystemProviderCapabilities=d={}));function s(X){return!!(X.capabilities&2)}e.$lk=s;function i(X){return!!(X.capabilities&8)}e.$mk=i;function n(X){return!!(X.capabilities&131072)}e.$nk=n;function o(X){return!!(X.capabilities&4)}e.$ok=o;function a(X){return!!(X.capabilities&16)}e.$pk=a;function t(X){return s(X)?!!(X.capabilities&16384):!1}e.$qk=t;function r(X){return s(X)?!!(X.capabilities&32768):!1}e.$rk=r;function h(X){return!!(X.capabilities&65536)}e.$sk=h;function u(X){return!!(X.capabilities&2048)}e.$tk=u;var c;(function(X){X.FileExists="EntryExists",X.FileNotFound="EntryNotFound",X.FileNotADirectory="EntryNotADirectory",X.FileIsADirectory="EntryIsADirectory",X.FileExceedsStorageQuota="EntryExceedsStorageQuota",X.FileTooLarge="EntryTooLarge",X.FileWriteLocked="EntryWriteLocked",X.NoPermissions="NoPermissions",X.Unavailable="Unavailable",X.Unknown="Unknown"})(c||(e.FileSystemProviderErrorCode=c={}));class l extends Error{static create(ve,ge){const V=new l(ve.toString(),ge);return w(V,ge),V}constructor(ve,ge){super(ve),this.code=ge}}e.$uk=l;function k(X,ve){return l.create(X,ve)}e.$vk=k;function R(X){return X||k((0,b.localize)(0,null),c.Unknown)}e.$wk=R;function w(X,ve){return X.name=ve?`${ve} (FileSystemError)`:"FileSystemError",X}e.$xk=w;function p(X){if(!X)return c.Unknown;if(X instanceof l)return X.code;const ve=/^(.+) \(FileSystemError\)$/.exec(X.name);if(!ve)return c.Unknown;switch(ve[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.$yk=p;function E(X){if(X instanceof T)return X.fileOperationResult;switch(p(X)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 9;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileTooLarge:return 7;default:return 10}}e.$zk=E;var P;(function(X){X[X.CREATE=0]="CREATE",X[X.DELETE=1]="DELETE",X[X.MOVE=2]="MOVE",X[X.COPY=3]="COPY",X[X.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class z{constructor(ve,ge,V){this.resource=ve,this.operation=ge,this.target=V}isOperation(ve){return this.operation===ve}}e.$Ak=z;var j;(function(X){X[X.UPDATED=0]="UPDATED",X[X.ADDED=1]="ADDED",X[X.DELETED=2]="DELETED"})(j||(e.FileChangeType=j={}));class F{static{this.a=null}constructor(ve,ge){this.c=ge,this.b=void 0,this.d=new C.$U(()=>{const V=D.$6h.forUris(()=>this.c);return V.fill(this.rawAdded.map(U=>[U,!0])),V}),this.f=new C.$U(()=>{const V=D.$6h.forUris(()=>this.c);return V.fill(this.rawUpdated.map(U=>[U,!0])),V}),this.g=new C.$U(()=>{const V=D.$6h.forUris(()=>this.c);return V.fill(this.rawDeleted.map(U=>[U,!0])),V}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const V of ve){switch(V.type){case 1:this.rawAdded.push(V.resource);break;case 0:this.rawUpdated.push(V.resource);break;case 2:this.rawDeleted.push(V.resource);break}this.b!==F.a&&(typeof V.cId=="number"?this.b===void 0?this.b=V.cId:this.b!==V.cId&&(this.b=F.a):this.b!==void 0&&(this.b=F.a))}}contains(ve,...ge){return this.h(ve,{includeChildren:!1},...ge)}affects(ve,...ge){return this.h(ve,{includeChildren:!0},...ge)}h(ve,ge,...V){if(!ve)return!1;const U=V.length>0;return!!((!U||V.includes(1))&&(this.d.value.get(ve)||ge.includeChildren&&this.d.value.findSuperstr(ve))||(!U||V.includes(0))&&(this.f.value.get(ve)||ge.includeChildren&&this.f.value.findSuperstr(ve))||(!U||V.includes(2))&&(this.g.value.findSubstr(ve)||ge.includeChildren&&this.g.value.findSuperstr(ve)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ve){return this.b===ve}hasCorrelation(){return typeof this.b=="number"}}e.$Bk=F;function O(X,ve,ge){return!X||!ve||X===ve||ve.length>X.length?!1:(ve.charAt(ve.length-1)!==N.sep&&(ve+=N.sep),ge?(0,g.$7e)(X,ve):X.indexOf(ve)===0)}e.$Ck=O;class T extends Error{constructor(ve,ge,V){super(ve),this.fileOperationResult=ge,this.options=V}}e.$Dk=T;class M extends T{constructor(ve,ge,V,U){super(ve,ge,U),this.fileOperationResult=ge,this.size=V}}e.$Ek=M;class W extends T{constructor(ve,ge,V){super(ve,2,V),this.stat=ge}}e.$Fk=W;var Y;(function(X){X[X.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",X[X.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",X[X.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",X[X.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",X[X.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",X[X.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",X[X.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",X[X.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",X[X.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",X[X.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",X[X.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Y||(e.FileOperationResult=Y={})),e.$Gk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Hk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ik="files.associations",e.$Jk="files.exclude",e.$Kk="files.readonlyInclude",e.$Lk="files.readonlyExclude",e.$Mk="files.readonlyFromPermissions";var ue;(function(X){X[X.FILE=0]="FILE",X[X.FOLDER=1]="FOLDER",X[X.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Nk="";function Z(X){if(!(typeof X.size!="number"||typeof X.mtime!="number"))return X.mtime.toString(29)+X.size.toString(31)}e.$Ok=Z;async function Q(X,ve){if(!ve.hasProvider(L.URI.from({scheme:X.scheme})))return new Promise(ge=>{const V=ve.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===X.scheme&&U.added&&(V.dispose(),ge())})})}e.$Pk=Q;class x{static{this.KB=1024}static{this.MB=x.KB*x.KB}static{this.GB=x.MB*x.KB}static{this.TB=x.GB*x.KB}static formatSize(ve){return(0,I.$Gf)(ve)||(ve=0),ve<x.KB?(0,b.localize)(1,null,ve.toFixed(0)):ve<x.MB?(0,b.localize)(2,null,(ve/x.KB).toFixed(2)):ve<x.GB?(0,b.localize)(3,null,(ve/x.MB).toFixed(2)):ve<x.TB?(0,b.localize)(4,null,(ve/x.GB).toFixed(2)):(0,b.localize)(5,null,(ve/x.TB).toFixed(2))}}e.$Qk=x;function oe(X){const ve=typeof X=="string"||X?.scheme===A.Schemas.vscodeRemote;return typeof X!="string"&&X?.scheme===A.Schemas.file?1024*x.MB:ve?10*x.MB:y.$o?50*x.MB:1024*x.MB}e.$Rk=oe}),define(Ee[242],Se([1,0,22,8,203,32]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=void 0;async function L(A,C,m,v,S,f){let d;try{await b(A,C,m,v,S,f)}catch(s){d=s}finally{d&&S.errorTransformer&&(d=S.errorTransformer(d)),typeof d<"u"&&m.error(d),m.end()}}e.$Wp=L;async function b(A,C,m,v,S,f){$(f);const d=await A.open(C,{create:!1});try{$(f);let s=0,i=0,n=S&&typeof S.length=="number"?S.length:void 0,o=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(d,a,o.buffer,t,o.byteLength-t),a+=i,t+=i,s+=i,typeof n=="number"&&(n-=i),t===o.byteLength&&(await m.write(v(o)),o=D.$fe.alloc(Math.min(S.bufferSize,typeof n=="number"?n:S.bufferSize)),t=0);while(i>0&&(typeof n!="number"||n>0)&&$(f)&&y(s,S));if(t>0){let r=t;typeof n=="number"&&(r=Math.min(t,n)),m.write(v(o.slice(0,r)))}}catch(s){throw(0,I.$wk)(s)}finally{await A.close(d)}}function $(A){if(A.isCancellationRequested)throw(0,N.$5)();return!0}function y(A,C){if(typeof C?.limits?.size=="number"&&A>C.limits.size)throw(0,I.$vk)((0,g.localize)(0,null),I.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(Ee[84],Se([1,0,34,3,16,11,2,32]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=e.$5p=e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.$Yp=void 0;function $(s){return s.recursive===!0}e.$Yp=$;class y extends N.$Rc{static{this.a=5}constructor(i,n,o,a){super(),this.h=i,this.j=n,this.m=o,this.n=a,this.c=this.B(new N.$Sc),this.f=void 0,this.g=0}s(){const i=new N.$Qc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(n=>this.h(n))),i.add(this.b.onDidLogMessage(n=>this.j(n))),i.add(this.b.onDidError(n=>this.t(n)))}t(i){this.n.restartOnError?this.g<y.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Zp=y;class A extends y{constructor(i,n,o){super(i,n,o,{type:"node.js",restartOnError:!1})}}e.$1p=A;class C extends y{constructor(i,n,o){super(i,n,o,{type:"universal",restartOnError:!0})}}e.$2p=C;function m(s){return s.map(i=>({type:i.type,resource:L.URI.revive(i.resource),cId:i.cId}))}e.$3p=m;function v(s){const i=new d;for(const n of s)i.processEvent(n);return i.coalesce()}e.$4p=v;function S(s,i){return typeof i=="string"&&!i.startsWith(D.$Cj)&&!(0,g.$hc)(i)?{base:s,pattern:i}:i}e.$5p=S;function f(s,i){const n=[];for(const o of i)n.push((0,D.$Gj)(S(s,o)));return n}e.$6p=f;class d{constructor(){this.a=new Set,this.b=new Map}c(i){return I.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const n=this.b.get(this.c(i));let o=!1;if(n){const a=n.type,t=i.type;n.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?o=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(n)):a===2&&t===1?n.type=0:a===1&&t===0||(n.type=t)}else o=!0;o&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],n=[];return Array.from(this.a).filter(o=>o.type!==2?(i.push(o),!1):!0).sort((o,a)=>o.resource.fsPath.length-a.resource.fsPath.length).filter(o=>n.some(a=>(0,b.$Ck)(o.resource.fsPath,a,!I.$k))?!1:(n.push(o.resource.fsPath),!0)).concat(i)}}}),define(Ee[243],Se([1,0,55,12,21,33,3,76,16,11,23,2,103,31,84]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hq=e.$gq=void 0;class f extends L.$Rc{static{this.a=100}static{this.b=75}constructor(i,n,o,a){super(),this.m=i,this.n=n,this.r=o,this.s=a,this.c=this.B(new N.$ch({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$bh(t=>this.z(t),f.b)),this.g=(0,S.$6p)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$6p)(this.m.path,this.m.includes):void 0,this.j=new g.$2d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const n=await v.Promises.stat(i);this.B(await this.w(i,n.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let n=i.path;try{n=await v.Promises.realpath(i.path),i.path===n&&(n=await(0,m.$dq)(i.path)??i.path),i.path!==n&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${n})`)}catch{}return n}async w(i,n){if(y.$j&&(0,I.$2f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),L.$Rc.None;const o=new g.$2d(this.j.token),a=new L.$Qc;try{const t=C.URI.file(this.m.path),r=(0,$.$mc)(i),h=(0,D.watch)(i);a.add((0,L.$Pc)(()=>{h.removeAllListeners(),h.close()})),this.G(`Started watching: '${i}'`);const u=new Set;if(n)try{for(const l of await v.Promises.readdir(i))u.add(l)}catch(l){this.D(l)}const c=new Map;a.add((0,L.$Pc)(()=>{for(const[,l]of c)l.dispose();c.clear()})),h.on("error",(l,k)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${k})`),this.dispose()}),h.on("change",(l,k)=>{if(o.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${k}`);let R="";if(k&&(R=k.toString(),y.$j&&(R=(0,b.$yl)(R))),!(!R||l!=="change"&&l!=="rename"))if(n)if(l==="rename"){c.get(R)?.dispose();const w=setTimeout(async()=>{if(c.delete(R),R===r&&!await v.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const p=await this.C((0,$.$ic)(i,R));if(o.token.isCancellationRequested)return;let E;p?u.has(R)?E=0:(E=1,u.add(R)):(u.delete(R),E=2),this.y({resource:(0,A.$Bg)(t,R),type:E,cId:this.m.correlationId})},f.a);c.set(R,(0,L.$Pc)(()=>clearTimeout(w)))}else{let w;u.has(R)?w=0:(w=1,u.add(R)),this.y({resource:(0,A.$Bg)(t,R),type:w,cId:this.m.correlationId})}else if(l==="rename"||R!==r){const w=setTimeout(async()=>{const p=await v.Promises.exists(i);o.token.isCancellationRequested||(p?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},f.a);a.clear(),a.add((0,L.$Pc)(()=>clearTimeout(w)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await v.Promises.exists(i)&&!o.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,L.$Pc)(()=>{o.dispose(!0),a.dispose()})}y(i,n=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!n&&this.g.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!n&&this.h&&this.h.length>0&&!this.h.some(o=>o(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const n=(0,S.$4p)(i);if(n.length>0){if(this.s)for(const a of n)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(n)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${n.length}, most recent change: ${n[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(y.$k)return v.Promises.exists(i);try{const n=(0,$.$mc)(i);return(await v.Promises.readdir((0,$.$lc)(i))).some(a=>a===n)}catch(n){return this.G(n),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$gq=f;async function d(s,i,n,o,a=512){const t=await v.Promises.open(s,"r"),r=Buffer.allocUnsafe(a),h=new g.$2d(o);let u,c=!1;const l={path:s,excludes:[],recursive:!1},k=new f(l,R=>{(async()=>{for(const{type:w}of R)if(w===0){if(c)return;c=!0;try{for(;!h.token.isCancellationRequested;){const{bytesRead:p}=await v.Promises.read(t,r,0,a,null);if(!p||h.token.isCancellationRequested)break;i(r.slice(0,p))}}catch(p){u=new Error(p),h.dispose(!0)}finally{c=!1}}})()});return await k.ready,n(),new Promise((R,w)=>{h.token.onCancellationRequested(async()=>{k.dispose();try{await v.Promises.close(t)}catch(p){u=new Error(p)}u?w(u):R()})})}e.$hq=d}),define(Ee[244],Se([1,0,4,34,3,11,243]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iq=void 0;class b extends g.$Rc{constructor(){super(...arguments),this.a=this.B(new D.$Rd),this.onDidChangeFile=this.a.event,this.b=this.B(new D.$Rd),this.onDidLogMessage=this.b.event,this.onDidError=D.Event.None,this.c=new Map,this.f=!1}async watch(y){const A=this.j(y),C=A.filter(v=>{const S=this.c.get(v.path);return S?!(0,N.$Kj)(S.request.excludes,v.excludes)||!(0,N.$Kj)(S.request.includes,v.includes):!0}),m=Array.from(this.c.values()).filter(({request:v})=>!A.find(S=>S.path===v.path&&(0,N.$Kj)(S.excludes,v.excludes)&&(0,N.$Kj)(S.includes,v.includes))).map(({request:v})=>v.path);C.length&&this.m(`Request to start watching: ${C.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"}, correlationId: ${typeof v.correlationId=="number"?v.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const v of m)this.h(v);for(const v of C)this.g(v)}g(y){const A=new L.$gq(y,m=>this.a.fire(m),m=>this.b.fire(m),this.f),C={request:y,instance:A};this.c.set(y.path,C)}async stop(){for(const[y]of this.c)this.h(y);this.c.clear()}h(y){const A=this.c.get(y);A&&(this.c.delete(y),A.instance.dispose())}j(y){const A=new Map;for(const C of y){const m=I.$k?C.path:C.path.toLowerCase();let v=A.get(C.correlationId);v||(v=new Map,A.set(C.correlationId,v)),v.set(m,C)}return Array.from(A.values()).map(C=>Array.from(C.values())).flat()}async setVerboseLogging(y){this.f=y;for(const[,A]of this.c)A.instance.setVerboseLogging(y)}m(y){this.f&&this.b.fire({type:"trace",message:this.n(y)})}n(y,A){return A?`[File Watcher (node.js)] ${y} (path: ${A.request.path})`:`[File Watcher (node.js)] ${y}`}}e.$iq=b}),define(Ee[245],Se([1,0,84,244]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jq=void 0;class g extends D.$1p{constructor(L,b,$){super(L,b,$),this.s()}r(L){return L.add(new N.$iq)}}e.$jq=g}),define(Ee[246],Se([1,0,17,81,186,84]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;class L extends I.$2p{constructor($,y,A){super($,y,A),this.s()}r($){const y=$.add(new g.$aq(D.$ig.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(y.onDidProcessExit(({code:A,signal:C})=>this.t(`terminated by itself with code ${A}, signal: ${C}`))),N.ProxyChannel.toService((0,N.$Gh)(y.getChannel("watcher")))}}e.$bq=L}),define(Ee[107],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class D{constructor(...g){this.a=new Map;for(const[I,L]of g)this.set(I,L)}set(g,I){const L=this.a.get(g);return this.a.set(g,I),L}has(g){return this.a.has(g)}get(g){return this.a.get(g)}}e.$Xh=D}),define(Ee[247],Se([1,0,12,8,3,105,238,5,107,75]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;const A=!1;class C extends Error{constructor(d){super("cyclic dependency between services"),this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class m{constructor(d=new $.$Xh,s=!1,i,n=A){this.f=d,this.g=s,this.h=i,this.i=n,this.o=new Set,this.f.set(b.$Yh,this),this._globalGraph=n?i?._globalGraph??new L.$mq(o=>o):void 0}createChild(d){return new m(d,this.g,this,this.i)}invokeFunction(d,...s){const i=S.traceInvocation(this.i,d);let n=!1;try{return d({get:a=>{if(n)throw(0,N.$7)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...s)}finally{n=!0,i.stop()}}createInstance(d,...s){let i,n;return d instanceof I.$Wh?(i=S.traceCreation(this.i,d.ctor),n=this.j(d.ctor,d.staticArguments.concat(s),i)):(i=S.traceCreation(this.i,d),n=this.j(d,s,i)),i.stop(),n}j(d,s=[],i){const n=b._util.getServiceDependencies(d).sort((t,r)=>t.index-r.index),o=[];for(const t of n){const r=this.m(t.id,i);r||this.u(`[createInstance] ${d.name} depends on UNKNOWN service ${t.id}.`,!1),o.push(r)}const a=n.length>0?n[0].index:s.length;if(s.length!==a){console.trace(`[createInstance] First service dependency of ${d.name} at position ${a+1} conflicts with ${s.length} static arguments`);const t=a-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,a)}return Reflect.construct(d,s.concat(o))}k(d,s){if(this.f.get(d)instanceof I.$Wh)this.f.set(d,s);else if(this.h)this.h.k(d,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(d){const s=this.f.get(d);return!s&&this.h?this.h.l(d):s}m(d,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(d));const i=this.l(d);return i instanceof I.$Wh?this.q(d,i,s.branch(d,!0)):(s.branch(d,!1),i)}q(d,s,i){if(this.o.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this.o.add(d);try{return this.r(d,s,i)}finally{this.o.delete(d)}}r(d,s,i){const n=new L.$mq(t=>t.id.toString());let o=0;const a=[{id:d,desc:s,_trace:i}];for(;a.length;){const t=a.pop();if(n.lookupOrInsertNode(t),o++>1e3)throw new C(n);for(const r of b._util.getServiceDependencies(t.desc.ctor)){const h=this.l(r.id);if(h||this.u(`[createInstance] ${d} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),h instanceof I.$Wh){const u={id:r.id,desc:h,_trace:t._trace.branch(r.id,!0)};n.insertEdge(t,u),a.push(u)}}}for(;;){const t=n.roots();if(t.length===0){if(!n.isEmpty())throw new C(n);break}for(const{data:r}of t){if(this.l(r.id)instanceof I.$Wh){const u=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,u)}n.removeNode(r)}}return this.l(d)}s(d,s,i=[],n,o){if(this.f.get(d)instanceof I.$Wh)return this.t(d,s,i,n,o);if(this.h)return this.h.s(d,s,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(d,s,i=[],n,o){if(n){const a=new m(void 0,this.g,this,this.i);a.c=String(d);const t=new Map,r=new D.$gh(()=>{const h=a.j(s,i,o);for(const[u,c]of t){const l=h[u];if(typeof l=="function")for(const k of c)l.apply(h,k)}return t.clear(),h});return new Proxy(Object.create(null),{get(h,u){if(!r.isInitialized&&typeof u=="string"&&(u.startsWith("onDid")||u.startsWith("onWill"))){let k=t.get(u);return k||(k=new y.$2c,t.set(u,k)),(w,p,E)=>{const P=k.push([w,p,E]);return(0,g.$Pc)(P)}}if(u in h)return h[u];const c=r.value;let l=c[u];return typeof l!="function"||(l=l.bind(c),h[u]=l),l},set(h,u,c){return r.value[u]=c,!0},getPrototypeOf(h){return s.prototype}})}else return this.j(s,i,o)}u(d,s){if(s&&console.warn(d),this.g)throw new Error(d)}}e.$nq=m;var v;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(v||(v={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(d,s){return d?new S(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(d,s){return d?new S(1,s.name):S.c}static{this.f=0}constructor(d,s){this.type=d,this.name=s,this.g=Date.now(),this.h=[]}branch(d,s){const i=new S(3,d.toString());return this.h.push([d,s,i]),i}stop(){const d=Date.now()-this.g;S.f+=d;let s=!1;function i(o,a){const t=[],r=new Array(o+1).join("	");for(const[h,u,c]of a.h)if(u&&c){s=!0,t.push(`${r}CREATES -> ${h}`);const l=i(o+1,c);l&&t.push(l)}else t.push(`${r}uses -> ${h}`);return t.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(d>2||s)&&S.all.add(n.join(`
`))}}e.$oq=S}),define(Ee[14],Se([1,0,44,4,53,3,28,11,23,18,2,46,5]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.log=e.$kj=e.LogLevel=e.$jj=e.$ij=e.$hj=void 0,e.$hj=(0,m.$Zh)("logService"),e.$ij=(0,m.$Zh)("loggerService");function v(){return new Date().toISOString()}function S(w){return(0,y.$Gf)(w)}e.$jj=S;var f;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(f||(e.LogLevel=f={})),e.$kj=f.Info;function d(w,p,E){switch(p){case f.Trace:w.trace(E);break;case f.Debug:w.debug(E);break;case f.Info:w.info(E);break;case f.Warning:w.warn(E);break;case f.Error:w.error(E);break;case f.Off:break;default:throw new Error(`Invalid log level ${p}`)}}e.log=d;function s(w,p=!1){let E="";for(let P=0;P<w.length;P++){let z=w[P];if(z instanceof Error&&(z=(0,D.$Ki)(z,p)),typeof z=="object")try{z=JSON.stringify(z)}catch{}E+=(P>0?" ":"")+z}return E}class i extends I.$Rc{constructor(){super(...arguments),this.b=e.$kj,this.c=this.B(new N.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(p){this.b!==p&&(this.b=p,this.c.fire(this.b))}getLevel(){return this.b}f(p){return this.b!==f.Off&&this.b<=p}}e.$mj=i;class n extends i{constructor(p){super(),this.h=p}f(p){return this.h||super.f(p)}trace(p,...E){this.f(f.Trace)&&this.g(f.Trace,s([p,...E],!0))}debug(p,...E){this.f(f.Debug)&&this.g(f.Debug,s([p,...E]))}info(p,...E){this.f(f.Info)&&this.g(f.Info,s([p,...E]))}warn(p,...E){this.f(f.Warning)&&this.g(f.Warning,s([p,...E]))}error(p,...E){if(this.f(f.Error))if(p instanceof Error){const P=Array.prototype.slice.call(arguments);P[0]=p.stack,this.g(f.Error,s(P))}else this.g(f.Error,s([p,...E]))}flush(){}}e.$nj=n;class o extends i{constructor(p=e.$kj){super(),this.setLevel(p),this.g=!b.$i}trace(p,...E){this.f(f.Trace)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}debug(p,...E){this.f(f.Debug)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}info(p,...E){this.f(f.Info)&&(this.g?console.log(`\x1B[90m[main ${v()}]\x1B[0m`,p,...E):console.log(`[main ${v()}]`,p,...E))}warn(p,...E){this.f(f.Warning)&&(this.g?console.warn(`\x1B[93m[main ${v()}]\x1B[0m`,p,...E):console.warn(`[main ${v()}]`,p,...E))}error(p,...E){this.f(f.Error)&&(this.g?console.error(`\x1B[91m[main ${v()}]\x1B[0m`,p,...E):console.error(`[main ${v()}]`,p,...E))}dispose(){}flush(){}}e.$oj=o;class a extends i{constructor(p=e.$kj,E=!0){super(),this.g=E,this.setLevel(p)}trace(p,...E){this.f(f.Trace)&&(this.g?console.log("%cTRACE","color: #888",p,...E):console.log(p,...E))}debug(p,...E){this.f(f.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",p,...E):console.log(p,...E))}info(p,...E){this.f(f.Info)&&(this.g?console.log("%c INFO","color: #33f",p,...E):console.log(p,...E))}warn(p,...E){this.f(f.Warning)&&(this.g?console.log("%c WARN","color: #993",p,...E):console.log(p,...E))}error(p,...E){this.f(f.Error)&&(this.g?console.log("%c  ERR","color: #f33",p,...E):console.error(p,...E))}dispose(){}flush(){}}e.$pj=a;class t extends i{constructor(p,E=e.$kj){super(),this.g=p,this.setLevel(E)}trace(p,...E){this.f(f.Trace)&&this.g.log(f.Trace,[this.h(p),...E])}debug(p,...E){this.f(f.Debug)&&this.g.log(f.Debug,[this.h(p),...E])}info(p,...E){this.f(f.Info)&&this.g.log(f.Info,[this.h(p),...E])}warn(p,...E){this.f(f.Warning)&&this.g.log(f.Warning,[this.h(p),...E])}error(p,...E){this.f(f.Error)&&this.g.log(f.Error,[this.h(p),...E])}h(p){return typeof p=="string"?p:(0,D.$Ki)(p,this.f(f.Trace))}dispose(){}flush(){}}e.$qj=t;class r extends i{constructor(p){super(),this.g=p,p.length&&this.setLevel(p[0].getLevel())}setLevel(p){for(const E of this.g)E.setLevel(p);super.setLevel(p)}trace(p,...E){for(const P of this.g)P.trace(p,...E)}debug(p,...E){for(const P of this.g)P.debug(p,...E)}info(p,...E){for(const P of this.g)P.info(p,...E)}warn(p,...E){for(const P of this.g)P.warn(p,...E)}error(p,...E){for(const P of this.g)P.error(p,...E)}flush(){for(const p of this.g)p.flush()}dispose(){for(const p of this.g)p.dispose()}}e.$rj=r;class h extends I.$Rc{constructor(p,E,P){if(super(),this.h=p,this.j=E,this.b=new L.$zc,this.c=this.B(new N.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Rd),this.onDidChangeVisibility=this.g.event,P)for(const z of P)this.b.set(z.resource,{logger:void 0,info:z})}m(p){return(0,y.$Cf)(p)?[...this.b.values()].find(E=>E.info.id===p):this.b.get(p)}getLogger(p){return this.m(p)?.logger}createLogger(p,E){const P=this.n(p),z=(0,y.$Cf)(p)?p:E?.id??(0,g.$Ni)(P.toString()).toString(16);let j=this.b.get(P)?.logger;const F=E?.logLevel==="always"?f.Trace:E?.logLevel;j||(j=this.s(P,F??this.getLogLevel(P)??this.h,{...E,id:z}));const O={logger:j,info:{resource:P,id:z,logLevel:F,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(O.info),this.b.set(P,O),j}n(p){return(0,y.$Cf)(p)?(0,$.$Bg)(this.j,`${p}.log`):p}setLogLevel(p,E){if(A.URI.isUri(p)){const P=p,z=E,j=this.b.get(P);j&&z!==j.info.logLevel&&(j.info.logLevel=z===this.h?void 0:z,j.logger?.setLevel(z),this.b.set(j.info.resource,j),this.f.fire([P,z]))}else{this.h=p;for(const[P,z]of this.b.entries())this.b.get(P)?.info.logLevel===void 0&&z.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(p,E){const P=this.m(p);P&&E!==!P.info.hidden&&(P.info.hidden=!E,this.b.set(P.info.resource,P),this.g.fire([P.info.resource,E]))}getLogLevel(p){let E;return p&&(E=this.b.get(p)?.info.logLevel),E??this.h}registerLogger(p){const E=this.b.get(p.resource);E?E.info.hidden!==p.hidden&&this.setVisibility(p.resource,!p.hidden):(this.b.set(p.resource,{info:p,logger:void 0}),this.c.fire({added:[p],removed:[]}))}deregisterLogger(p){const E=this.b.get(p);E&&(E.logger&&E.logger.dispose(),this.b.delete(p),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const p of this.b.values())yield p.info}getRegisteredLogger(p){return this.b.get(p)?.info}dispose(){this.b.forEach(p=>p.logger?.dispose()),this.b.clear(),super.dispose()}}e.$sj=h;class u{constructor(){this.onDidChangeLogLevel=new N.$Rd().event}setLevel(p){}getLevel(){return f.Info}trace(p,...E){}debug(p,...E){}info(p,...E){}warn(p,...E){}error(p,...E){}critical(p,...E){}dispose(){}flush(){}}e.$tj=u;class c extends u{}e.$uj=c;function l(w){if(w.verbose)return f.Trace;if(typeof w.logLevel=="string"){const p=R(w.logLevel.toLowerCase());if(p!==void 0)return p}return e.$kj}e.$vj=l;function k(w){switch(w){case f.Trace:return"trace";case f.Debug:return"debug";case f.Info:return"info";case f.Warning:return"warn";case f.Error:return"error";case f.Off:return"off"}}e.$wj=k;function R(w){switch(w){case"trace":return f.Trace;case"debug":return f.Debug;case"info":return f.Info;case"warn":return f.Warning;case"error":return f.Error;case"critical":return f.Error;case"off":return f.Off}}e.$xj=R,e.$yj=new C.$ej("logLevel",k(f.Info))}),define(Ee[248],Se([1,0,19,12,8,4,3,16,84,14]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;class A extends L.$Rc{constructor(m,v){super(),this.a=m,this.b=v,this.c=this.B(new I.$Rd),this.onDidChangeFile=this.c.event,this.g=this.B(new I.$Rd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$Xg(0)),this.w=[],this.y=this.B(new N.$Xg(0))}watch(m,v){return v.recursive||this.b?.watcher?.forceUniversal?this.n(m,v):this.z(m,v)}n(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:v.recursive,correlationId:v.correlationId},f=(0,D.$Tb)(this.j,S);return this.r(),(0,L.$Pc)(()=>{f(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,g.$Z)(m))}s(){this.h||(this.h=this.B(this.t(v=>this.c.fire((0,$.$3p)(v)),v=>this.G(v),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const v of this.j)(0,$.$Yp)(v)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const v of this.j)(0,$.$Yp)(v)&&m.includes(v.path)&&(v.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,v){const S={path:this.H(m),excludes:v.excludes,includes:v.includes,recursive:!1,correlationId:v.correlationId},f=(0,D.$Tb)(this.w,S);return this.C(),(0,L.$Pc)(()=>{f(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,g.$Z)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,$.$3p)(m)),m=>this.G(m),this.a.getLevel()===y.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===y.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,b.$gc)(m.fsPath)}}e.$7p=A}),define(Ee[249],Se([1,0,55,386,12,28,22,4,33,3,16,11,23,98,31,204,32,242,248,44,246,245]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=void 0,(()=>{try{(0,N.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,n.$Ki)(r)}`)}})();class t extends i.$7p{static{this.I=!1}constructor(h,u){super(h,u),this.onDidChangeCapabilities=b.Event.None,this.N=new I.$zc(c=>m.$sg.getComparisonKey(c)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,C.$k&&(this.J|=1024)),this.J}async stat(h){try{const{stat:u,symbolicLink:c}=await S.SymlinkSupport.stat(this.H(h));return{type:this.M(u,c),ctime:u.birthtime.getTime(),mtime:u.mtime.getTime(),size:u.size,permissions:u.mode&128?void 0:d.FilePermission.Locked}}catch(u){throw this.fb(u)}}async L(h){try{return await this.stat(h)}catch{return}}async readdir(h){try{const u=await S.Promises.readdir(this.H(h),{withFileTypes:!0}),c=[];return await Promise.all(u.map(async l=>{try{let k;l.isSymbolicLink()?k=(await this.stat((0,m.$Bg)(h,l.name))).type:k=this.M(l),c.push([l.name,k])}catch(k){this.a.trace(k)}})),c}catch(u){throw this.fb(u)}}M(h,u){let c;return u?.dangling?c=d.FileType.Unknown:h.isFile()?c=d.FileType.File:h.isDirectory()?c=d.FileType.Directory:c=d.FileType.Unknown,u&&(c|=d.FileType.SymbolicLink),c}async O(h){const u=this.H(h);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${u})`);let c;for(;c=this.N.get(h);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${u})`),await c.wait();const l=new g.$Yg;return this.N.set(h,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${u})`),(0,y.$Pc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${u})`),this.N.get(h)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${u})`),this.N.delete(h)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${u})`),l.open()})}async readFile(h,u){let c;try{u?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(h)})`),c=await this.O(h));const l=this.H(h);return await S.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{c?.dispose()}}P(h){t.I&&this.a.trace(h)}readFileStream(h,u,c){const l=(0,v.$6d)(k=>L.$fe.concat(k.map(R=>L.$fe.wrap(R))).buffer);return(0,s.$Wp)(this,h,l,k=>k.buffer,{...u,bufferSize:256*1024},c),l}async writeFile(h,u,c){return c?.atomic!==!1&&c?.atomic?.postfix&&await this.Q(h)?this.R(h,(0,m.$Bg)((0,m.$Ag)(h),`${(0,m.$yg)(h)}${c.atomic.postfix}`),u,c):this.S(h,u,c)}async Q(h){try{const u=this.H(h),{symbolicLink:c}=await S.SymlinkSupport.stat(u);if(c)return!1}catch{}return!0}async R(h,u,c,l){const k=new y.$Qc;try{k.add(await this.O(h)),k.add(await this.O(u)),await this.S(u,c,l,!0);try{await this.rename(u,h,{overwrite:!0})}catch(R){try{await this.delete(u,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw R}}finally{k.dispose()}}async S(h,u,c,l){let k;try{const R=this.H(h);if(!c.create||!c.overwrite){if(await S.Promises.exists(R)){if(!c.overwrite)throw(0,d.$vk)((0,f.localize)(0,null),d.FileSystemProviderErrorCode.FileExists)}else if(!c.create)throw(0,d.$vk)((0,f.localize)(1,null),d.FileSystemProviderErrorCode.FileNotFound)}k=await this.open(h,{create:!0,unlock:c.unlock},l),await this.write(k,0,u,0,u.byteLength)}catch(R){throw await this.gb(h,R)}finally{typeof k=="number"&&await this.close(k)}}static{this.Y=!0}static configureFlushOnWrite(h){t.Y=h}async open(h,u,c){const l=this.H(h);let k;(0,d.$jk)(u)&&!c&&(k=await this.O(h));let R;try{if((0,d.$jk)(u)&&u.unlock)try{const{stat:p}=await S.SymlinkSupport.stat(l);p.mode&128||await S.Promises.chmod(l,p.mode|128)}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}let w;if((0,d.$jk)(u)){if(C.$i)try{await S.Promises.truncate(l,0),w="r+"}catch(p){p.code!=="ENOENT"&&this.a.trace(p)}w||(w="w")}else w="r";R=await S.Promises.open(l,w)}catch(w){throw k?.dispose(),(0,d.$jk)(u)?await this.gb(h,w):this.fb(w)}if(this.U.set(R,0),(0,d.$jk)(u)&&this.X.set(R,h),k){const w=this.W.get(R);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${R} (${l})`),this.W.set(R,k),w&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${R} (${l})`),w.dispose())}return R}async close(h){const u=this.W.get(h);try{if(this.U.delete(h),this.X.delete(h)&&t.Y)try{await S.Promises.fdatasync(h)}catch(c){t.configureFlushOnWrite(!1),this.a.error(c)}return await S.Promises.close(h)}catch(c){throw this.fb(c)}finally{u&&(this.W.get(h)===u&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${h}`),this.W.delete(h)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${h}`),u.dispose())}}async read(h,u,c,l,k){const R=this.Z(h,u);let w=null;try{w=(await S.Promises.read(h,c,l,k,R)).bytesRead}catch(p){throw this.fb(p)}finally{this.$(h,R,w)}return w}Z(h,u){return u===this.U.get(h)?null:u}$(h,u,c){const l=this.U.get(h);typeof l=="number"&&(typeof u=="number"||(typeof c=="number"?this.U.set(h,l+c):this.U.delete(h)))}async write(h,u,c,l,k){return(0,g.$hh)(()=>this.ab(h,u,c,l,k),100,3)}async ab(h,u,c,l,k){const R=this.Z(h,u);let w=null;try{w=(await S.Promises.write(h,c,l,k,R)).bytesWritten}catch(p){throw await this.gb(this.X.get(h),p)}finally{this.$(h,R,w)}return w}async mkdir(h){try{await S.Promises.mkdir(this.H(h))}catch(u){throw this.fb(u)}}async delete(h,u){try{const c=this.H(h);if(u.recursive){let l;u?.atomic!==!1&&u.atomic.postfix&&(l=(0,A.$ic)((0,A.$lc)(c),`${(0,A.$mc)(c)}${u.atomic.postfix}`)),await S.Promises.rm(c,S.RimRafMode.MOVE,l)}else try{await S.Promises.unlink(c)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let k=!1;try{const{stat:R,symbolicLink:w}=await S.SymlinkSupport.stat(c);k=R.isDirectory()&&!w}catch{}if(k)await S.Promises.rmdir(c);else throw l}else throw l}}catch(c){throw this.fb(c)}}async rename(h,u,c){const l=this.H(h),k=this.H(u);if(l!==k)try{await this.bb(h,u,"move",c.overwrite),await S.Promises.rename(l,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,f.localize)(2,null,(0,A.$mc)(l),(0,A.$mc)((0,A.$lc)(k)),R.toString()))),this.fb(R)}}async copy(h,u,c){const l=this.H(h),k=this.H(u);if(l!==k)try{await this.bb(h,u,"copy",c.overwrite),await S.Promises.copy(l,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,f.localize)(3,null,(0,A.$mc)(l),(0,A.$mc)((0,A.$lc)(k)),R.toString()))),this.fb(R)}}async bb(h,u,c,l){const k=this.H(h),R=this.H(u);let w=!1;if(!!(this.capabilities&1024)||(w=(0,$.$1f)(k,R,!0)),w){if(c==="copy")throw(0,d.$vk)((0,f.localize)(4,null),d.FileSystemProviderErrorCode.FileExists);if(c==="move")return}const E=await this.L(h);if(!E)throw(0,d.$vk)((0,f.localize)(5,null),d.FileSystemProviderErrorCode.FileNotFound);const P=await this.L(u);if(P){if(!l)throw(0,d.$vk)((0,f.localize)(6,null),d.FileSystemProviderErrorCode.FileExists);E.type&d.FileType.File&&P.type&d.FileType.File||await this.delete(u,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(h,u){return this.cb(h,u,!1)}async cb(h,u,c){const l=this.H(h),k=this.H(u),R=!!(this.capabilities&1024);if((0,$.$1f)(l,k,!R))return;const w=new y.$Qc;try{w.add(await this.O(h)),w.add(await this.O(u)),c&&await S.Promises.mkdir((0,A.$lc)(k),{recursive:!0}),await S.Promises.copyFile(l,k)}catch(p){if(p.code==="ENOENT"&&!c)return this.cb(h,u,!0);throw this.fb(p)}finally{w.dispose()}}t(h,u,c){return new o.$bq(l=>h(l),l=>u(l),c)}F(h,u,c){return new a.$jq(l=>h(l),l=>u(l),c)}fb(h){if(h instanceof d.$uk)return h;let u=h,c;switch(h.code){case"ENOENT":c=d.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":c=d.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":c=d.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":c=d.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":c=d.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":u=`${h.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,c=d.FileSystemProviderErrorCode.Unknown;break;default:c=d.FileSystemProviderErrorCode.Unknown}return(0,d.$vk)(u,c)}async gb(h,u){let c=this.fb(u);if(h&&c.code===d.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await S.SymlinkSupport.stat(this.H(h));l.mode&128||(c=(0,d.$vk)(u,d.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return c}}e.$kq=t}),define(Ee[250],Se([1,0,3,14]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;class g extends D.$Rc{constructor(L,b=[]){super(),this.a=new N.$rj([L,...b]),this.B(L.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...b){this.a.trace(L,...b)}debug(L,...b){this.a.debug(L,...b)}info(L,...b){this.a.info(L,...b)}warn(L,...b){this.a.warn(L,...b)}error(L,...b){this.a.error(L,...b)}flush(){this.a.flush()}}e.$5N=g}),define(Ee[251],Se([1,0,32,14]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TN=void 0;var g;(function(y){y[y.Trace=0]="Trace",y[y.Debug=1]="Debug",y[y.Info=2]="Info",y[y.Warning=3]="Warning",y[y.Error=4]="Error",y[y.Critical=5]="Critical",y[y.Off=6]="Off"})(g||(g={}));async function I(y,A,C,m,v){try{const S=await new Promise((d,s)=>{$e(["@vscode/spdlog"],d,s)});S.setFlushOn(g.Trace);const f=await S.createAsyncRotatingLogger(y,A,C,m);return v?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(S){console.error(S)}return null}function L(y,A,C){switch(A){case N.LogLevel.Trace:y.trace(C);break;case N.LogLevel.Debug:y.debug(C);break;case N.LogLevel.Info:y.info(C);break;case N.LogLevel.Warning:y.warn(C);break;case N.LogLevel.Error:y.error(C);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function b(y,A){switch(A){case N.LogLevel.Trace:y.setLevel(g.Trace);break;case N.LogLevel.Debug:y.setLevel(g.Debug);break;case N.LogLevel.Info:y.setLevel(g.Info);break;case N.LogLevel.Warning:y.setLevel(g.Warning);break;case N.LogLevel.Error:y.setLevel(g.Error);break;case N.LogLevel.Off:y.setLevel(g.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$nj{constructor(A,C,m,v,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,C,m,v),this.B(this.onDidChangeLogLevel(f=>{this.r&&b(this.r,f)}))}async s(A,C,m,v){const S=m?6:1,f=30/S*D.$Qk.MB,d=await I(A,C,f,S,v);if(d){this.r=d,b(this.r,this.getLevel());for(const{level:s,message:i}of this.m)L(this.r,s,i);this.m=[]}}g(A,C){this.r?L(this.r,A,C):this.getLevel()<=A&&this.m.push({level:A,message:C})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u())}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$TN=$}),define(Ee[135],Se([1,0,39,205,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var I;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(I||(e.MarkerTag=I={}));var L;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function($){function y(S,f){return f-S}$.compare=y;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function C(S){return A[S]||""}$.toString=C;function m(S){switch(S){case D.default.Error:return $.Error;case D.default.Warning:return $.Warning;case D.default.Info:return $.Info;case D.default.Ignore:return $.Hint}}$.fromSeverity=m;function v(S){switch(S){case $.Error:return D.default.Error;case $.Warning:return D.default.Warning;case $.Info:return D.default.Info;case $.Hint:return D.default.Ignore}}$.toSeverity=v}(L||(e.MarkerSeverity=L={}));var b;(function($){const y="";function A(m){return C(m,!0)}$.makeKey=A;function C(m,v){const S=[y];return m.source?S.push(m.source.replace("\xA6","\\\xA6")):S.push(y),m.code?typeof m.code=="string"?S.push(m.code.replace("\xA6","\\\xA6")):S.push(m.code.value.replace("\xA6","\\\xA6")):S.push(y),m.severity!==void 0&&m.severity!==null?S.push(L.toString(m.severity)):S.push(y),m.message&&v?S.push(m.message.replace("\xA6","\\\xA6")):S.push(y),m.startLineNumber!==void 0&&m.startLineNumber!==null?S.push(m.startLineNumber.toString()):S.push(y),m.startColumn!==void 0&&m.startColumn!==null?S.push(m.startColumn.toString()):S.push(y),m.endLineNumber!==void 0&&m.endLineNumber!==null?S.push(m.endLineNumber.toString()):S.push(y),m.endColumn!==void 0&&m.endColumn!==null?S.push(m.endColumn.toString()):S.push(y),S.push(y),S.join("\xA6")}$.makeKeyOptionalMessage=C})(b||(e.IMarkerData=b={})),e.$jt=(0,g.$Zh)("markerService")}),define(Ee[252],Se([1,0,4,39,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$$u=e.Severity=void 0,e.Severity=N.default,e.$$u=(0,g.$Zh)("notificationService");var I;(function(A){A[A.DEFAULT=0]="DEFAULT",A[A.SILENT=1]="SILENT",A[A.URGENT=2]="URGENT"})(I||(e.NotificationPriority=I={}));var L;(function(A){A[A.WORKSPACE=0]="WORKSPACE",A[A.PROFILE=1]="PROFILE",A[A.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));var b;(function(A){A[A.OFF=0]="OFF",A[A.SILENT=1]="SILENT",A[A.ERROR=2]="ERROR"})(b||(e.NotificationsFilter=b={}));class ${constructor(){this.progress=new y,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(C){}updateMessage(C){}updateActions(C){}close(){}}e.$_u=$;class y{infinite(){}done(){}total(C){}worked(C){}}e.$av=y}),define(Ee[253],Se([1,0,50]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const g=globalThis.vscode;if(typeof g<"u"&&typeof g.context<"u"){const I=g.context.configuration();if(I)N=I.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,D.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const I=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:I.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(Ee[136],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=void 0,e.$zj=(0,D.$Zh)("productService"),e.$Aj="vscode://schemas/vscode-product"});var We=this&&this.__param||function($e,e){return function(D,N){e(D,N,$e)}};define(Ee[85],Se([1,0,12,21,3,5]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.ProgressLocation=e.$bv=void 0,e.$bv=(0,I.$Zh)("progressService");var L;(function(C){C[C.Explorer=1]="Explorer",C[C.Scm=3]="Scm",C[C.Extensions=5]="Extensions",C[C.Window=10]="Window",C[C.Notification=15]="Notification",C[C.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$cv=Object.freeze({total(){},worked(){},done(){}});class b{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(m){this.b=m}report(m){this.a=m,this.b(this.a)}}e.$dv=b;class ${get value(){return this.a}constructor(m){this.e=m}report(m){this.b?this.b.push(m):this.b=[m],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const m=this.b.shift();this.a=m,await this.e(this.a)}}finally{this.c=!1;const m=this.d;this.d=void 0,m?.()}}drain(){return this.c?new Promise(m=>{const v=this.d;this.d=()=>{v?.(),m()}}):Promise.resolve()}}e.$ev=$;let y=class extends g.$Rc{constructor(m,v){super(),this.a=new D.$kh,v.withProgress(m,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,g.$Pc)(()=>this.a.complete()))}report(m){this.b?this.b.report(m):this.c=m}};e.$fv=y,e.$fv=y=Ke([We(1,e.$bv)],y);class A extends g.$Rc{constructor(m){super(),this.g=m,this.a=0,this.b=this.B(new g.$Qc)}start(m){this.stop();const v=++this.a,S=new N.$2d;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},m),this.b.add((0,g.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,g.$Pc)(()=>S.cancel())),this.b.add((0,g.$Pc)(()=>this.c?this.c.done():void 0)),{id:v,token:S.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(m){this.a===m&&this.b.clear()}}e.$gv=A,e.$hv=(0,I.$Zh)("editorProgressService")}),define(Ee[37],Se([1,0,60,18]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;class g{constructor(){this.a=new Map}add(L,b){D.ok(N.$Cf(L)),D.ok(N.$Ef(b)),D.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,b)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$qn=new g}),define(Ee[108],Se([1,0,4,37]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn={JSONContribution:"base.contributions.json"};function g(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class I{constructor(){this.b=new D.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,y){this.a[g($)]=y,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const L=new I;N.$qn.add(e.$rn.JSONContribution,L)}),define(Ee[86],Se([1,0,19,4,18,195,45,108,37]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.ConfigurationScope=e.$vn=e.EditPresentationTypes=void 0;var y;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$vn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn="vscode://schemas/settings/resourceLanguage",e.$Dn="vscode://schemas/settings/configurationDefaults";const C=$.$qn.as(b.$rn.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.$Rd,this.onDidSchemaChange=this.i.event,this.j=new N.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:I.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},C.registerSchema(e.$Cn,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const h=new Set;this.n(t,r,h),C.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:h})}deregisterConfigurations(t){const r=new Set;this.o(t,r),C.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const h=new Set;this.o(r,h),this.n(t,!1,h),C.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:h})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const h=[];for(const{overrides:u,source:c}of t)for(const l in u)if(r.add(l),e.$Fn.test(l)){const k=this.a.get(l),R=k?.valuesSources??new Map;if(c)for(const P of Object.keys(u[l]))R.set(P,c);const w={...k?.value||{},...u[l]};this.a.set(l,{source:c,value:w,valuesSources:R});const p=(0,L.$Di)(l),E={type:"object",default:w,description:I.localize(1,null,p),$ref:e.$Cn,defaultDefaultValue:w,source:g.$Cf(c)?void 0:c,defaultValueSource:c};h.push(...f(l)),this.d[l]=E,this.b.properties[l]=E}else{this.a.set(l,{value:u[l],source:c});const k=this.d[l];k&&(this.w(l,k),this.r(l,k))}this.m(h)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:h,source:u}of t)for(const c in h){const l=this.a.get(c),k=g.$Cf(u)?u:u?.id,R=g.$Cf(l?.source)?l?.source:l?.source?.id;if(k===R)if(r.add(c),this.a.delete(c),e.$Fn.test(c))delete this.d[c],delete this.b.properties[c];else{const w=this.d[c];w&&(this.w(c,w),this.r(c,w))}}this.u()}deltaConfiguration(t){let r=!1;const h=new Set;t.removedDefaults&&(this.l(t.removedDefaults,h),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,h),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,h),t.addedConfigurations&&this.n(t.addedConfigurations,!1,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,h){t.forEach(u=>{this.p(u,r,u.extensionInfo,u.restrictedProperties,void 0,h),this.c.push(u),this.q(u)})}o(t,r){const h=u=>{if(u.properties)for(const c in u.properties){r.add(c);const l=this.d[c];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[c],this.s(c,u.properties[c])}u.allOf?.forEach(c=>h(c))};for(const u of t){h(u);const c=this.c.indexOf(u);c!==-1&&this.c.splice(c,1)}}p(t,r=!0,h,u,c=3,l){c=g.$Lf(t.scope)?c:t.scope;const k=t.properties;if(k)for(const w in k){const p=k[w];if(r&&n(w,p)){delete k[w];continue}if(p.source=h,p.defaultDefaultValue=k[w].default,this.w(w,p),e.$Fn.test(w)?p.scope=void 0:(p.scope=g.$Lf(p.scope)?c:p.scope,p.restricted=g.$Lf(p.restricted)?!!u?.includes(w):p.restricted),k[w].hasOwnProperty("included")&&!k[w].included){this.f[w]=k[w],delete k[w];continue}else this.d[w]=k[w],k[w].policy?.name&&this.e.set(k[w].policy.name,w);!k[w].deprecationMessage&&k[w].markdownDeprecationMessage&&(k[w].deprecationMessage=k[w].markdownDeprecationMessage),l.add(w)}const R=t.allOf;if(R)for(const w of R)this.p(w,r,h,u,c,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=h=>{const u=h.properties;if(u)for(const l in u)this.r(l,u[l]);h.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$wn.properties[t]=r,r.scope){case 1:e.$xn.properties[t]=r;break;case 2:e.$yn.properties[t]=r;break;case 6:e.$zn.properties[t]=r;break;case 3:e.$An.properties[t]=r;break;case 4:e.$Bn.properties[t]=r;break;case 5:e.$Bn.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$wn.properties[t],r.scope){case 1:delete e.$xn.properties[t];break;case 2:delete e.$yn.properties[t];break;case 6:delete e.$zn.properties[t];break;case 3:delete e.$An.properties[t];break;case 4:case 5:delete e.$Bn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,h={type:"object",description:I.localize(2,null),errorMessage:I.localize(3,null),$ref:e.$Cn};this.w(r,h),e.$wn.properties[r]=h,e.$xn.properties[r]=h,e.$yn.properties[r]=h,e.$zn.properties[r]=h,e.$An.properties[r]=h,e.$Bn.properties[r]=h}}v(){const t={type:"object",description:I.localize(4,null),errorMessage:I.localize(5,null),$ref:e.$Cn};e.$wn.patternProperties[e.$En]=t,e.$xn.patternProperties[e.$En]=t,e.$yn.patternProperties[e.$En]=t,e.$zn.patternProperties[e.$En]=t,e.$An.patternProperties[e.$En]=t,e.$Bn.patternProperties[e.$En]=t,this.i.fire()}w(t,r){const h=this.a.get(t);let u=h?.value,c=h?.source;g.$Jf(u)&&(u=r.defaultDefaultValue,c=void 0),g.$Jf(u)&&(u=s(r.type)),r.default=u,r.defaultValueSource=c}}const v="\\[([^\\]]+)\\]",S=new RegExp(v,"g");e.$En=`^(${v})+$`,e.$Fn=new RegExp(e.$En);function f(a){const t=[];if(e.$Fn.test(a)){let r=S.exec(a);for(;r?.length;){const h=r[1].trim();h&&t.push(h),r=S.exec(a)}}return(0,D.$Lb)(t)}e.$Gn=f;function d(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}e.$Hn=d;function s(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$In=s;const i=new m;$.$qn.add(e.$vn.Configuration,i);function n(a,t){return a.trim()?e.$Fn.test(a)?I.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?I.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?I.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:I.localize(6,null)}e.$Jn=n;function o(){const a=[],t=i.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$Kn=o}),define(Ee[254],Se([1,0,19,4,159,3,28,24,18,2,45,86,37]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function v(r){return Object.isFrozen(r)?r:b.$fn(r)}class S{constructor(h={},u=[],c=[],l){this.b=h,this.c=u,this.d=c,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const h=this.raw.map(u=>{if(u instanceof S)return u;const c=new f("");return c.parseRaw(u),c.configurationModel});this.f=h.reduce((u,c)=>c===u?c:u.merge(c),h[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(h){return h?(0,A.$Bi)(this.contents,h):this.contents}inspect(h,u){const c=this.rawConfiguration.getValue(h),l=u?this.rawConfiguration.getOverrideValue(h,u):void 0,k=u?this.rawConfiguration.override(u).getValue(h):c;return{value:c,override:l,merged:k}}getOverrideValue(h,u){const c=this.i(u);return c?h?(0,A.$Bi)(c,h):c:void 0}getKeysForOverrideIdentifier(h){const u=[];for(const c of this.overrides)c.identifiers.includes(h)&&u.push(...c.keys);return D.$Lb(u)}getAllOverrideIdentifiers(){const h=[];for(const u of this.overrides)h.push(...u.identifiers);return D.$Lb(h)}override(h){let u=this.a.get(h);return u||(u=this.g(h),this.a.set(h,u)),u}merge(...h){const u=b.$en(this.contents),c=b.$en(this.overrides),l=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const R of h)if(k.push(...R.raw?.length?R.raw:[R]),!R.isEmpty()){this.h(u,R.contents);for(const w of R.overrides){const[p]=c.filter(E=>D.$tb(E.identifiers,w.identifiers));p?(this.h(p.contents,w.contents),p.keys.push(...w.keys),p.keys=D.$Lb(p.keys)):c.push(b.$en(w))}for(const w of R.keys)l.indexOf(w)===-1&&l.push(w)}return new S(u,l,c,k.every(R=>R instanceof S)?void 0:k)}g(h){const u=this.i(h);if(!u||typeof u!="object"||!Object.keys(u).length)return this;const c={};for(const l of D.$Lb([...Object.keys(this.contents),...Object.keys(u)])){let k=this.contents[l];const R=u[l];R&&(typeof k=="object"&&typeof R=="object"?(k=b.$en(k),this.h(k,R)):k=R),c[l]=k}return new S(c,this.keys,this.overrides)}h(h,u){for(const c of Object.keys(u)){if(c in h&&$.$Ef(h[c])&&$.$Ef(u[c])){this.h(h[c],u[c]);continue}h[c]=b.$en(u[c])}}i(h){let u=null,c=null;const l=k=>{k&&(c?this.h(c,k):c=b.$en(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===h?u=k.contents:k.identifiers.includes(h)&&l(k.contents);return l(u),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(h,u){this.j(h,u,!0)}setValue(h,u){this.j(h,u,!1)}removeValue(h){const u=this.keys.indexOf(h);u!==-1&&(this.keys.splice(u,1),(0,A.$Ai)(this.contents,h),C.$Fn.test(h)&&this.overrides.splice(this.overrides.findIndex(c=>D.$tb(c.identifiers,(0,C.$Gn)(h))),1))}j(h,u,c){(0,A.$zi)(this.contents,h,u,l=>console.error(l)),c=c||this.keys.indexOf(h)===-1,c&&this.keys.push(h),C.$Fn.test(h)&&this.overrides.push({identifiers:(0,C.$Gn)(h),keys:Object.keys(this.contents[h]),contents:(0,A.$yi)(this.contents[h],l=>console.error(l))})}}e.$Ln=S;class f{constructor(h){this.f=h,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(h,u){if(!$.$Lf(h)){const c=this.g(h);this.parseRaw(c,u)}}reparse(h){this.a&&this.parseRaw(this.a,h)}parseRaw(h,u){this.a=h;const{contents:c,keys:l,overrides:k,restricted:R,hasExcludedProperties:w}=this.h(h,u);this.b=new S(c,l,k,w?[h]:void 0),this.c=R||[]}g(h){let u={},c=null,l=[];const k=[],R=[];function w(E){Array.isArray(l)?l.push(E):c!==null&&(l[c]=E)}const p={onObjectBegin:()=>{const E={};w(E),k.push(l),l=E,c=null},onObjectProperty:E=>{c=E},onObjectEnd:()=>{l=k.pop()},onArrayBegin:()=>{const E=[];w(E),k.push(l),l=E,c=null},onArrayEnd:()=>{l=k.pop()},onLiteralValue:w,onError:(E,P,z)=>{R.push({error:E,offset:P,length:z})}};if(h)try{g.$bn(h,p),u=l[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return u}h(h,u){const c=m.$qn.as(C.$vn.Configuration).getConfigurationProperties(),l=this.i(h,c,!0,u);h=l.raw;const k=(0,A.$yi)(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`)),R=Object.keys(h),w=this.j(h,p=>console.error(`Conflict in settings file ${this.f}: ${p}`));return{contents:k,keys:R,overrides:w,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(h,u,c,l){let k=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:h,restricted:[],hasExcludedProperties:k};const R={},w=[];for(const p in h)if(C.$Fn.test(p)&&c){const E=this.i(h[p],u,!1,l);R[p]=E.raw,k=k||E.hasExcludedProperties,w.push(...E.restricted)}else{const E=u[p],P=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&w.push(p),!l.exclude?.includes(p)&&(l.include?.includes(p)||(P===void 0||l.scopes===void 0||l.scopes.includes(P))&&!(l.skipRestricted&&E?.restricted))?R[p]=h[p]:k=!0}return{raw:R,restricted:w,hasExcludedProperties:k}}j(h,u){const c=[];for(const l of Object.keys(h))if(C.$Fn.test(l)){const k={};for(const R in h[l])k[R]=h[l][R];c.push({identifiers:(0,C.$Gn)(l),keys:Object.keys(k),contents:(0,A.$yi)(k,u)})}return c}}e.$Mn=f;class d extends I.$Rc{constructor(h,u,c,l){super(),this.c=h,this.f=u,this.g=l,this.b=this.B(new N.$Rd),this.onDidChange=this.b.event,this.a=new f(this.c.toString()),this.B(this.g.watch(c.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&c.isEqual(k.resource,h)))(()=>this.b.fire()))}async loadConfiguration(){try{const h=await this.g.readFile(this.c);return this.a.parse(h.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(h){return h&&(this.f=h),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Nn=d;class s{constructor(h,u,c,l,k,R,w,p,E,P,z,j,F){this.a=h,this.b=u,this.c=c,this.overrideIdentifiers=l,this.d=k,this.f=R,this.g=w,this.h=p,this.i=E,this.j=P,this.k=z,this.l=j,this.m=F}get value(){return v(this.c)}n(h,u,c){const l=h.inspect(u,c);return{get value(){return v(l.value)},get override(){return v(l.override)},get merged(){return v(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(h,u,c,l,k=new S,R=new S,w=new L.$zc,p=new S,E=new L.$zc){this.c=h,this.d=u,this.f=c,this.g=l,this.h=k,this.i=R,this.j=w,this.l=p,this.m=E,this.a=null,this.b=new L.$zc,this.n=null}getValue(h,u,c){return this.p(h,u,c).getValue(h)}updateValue(h,u,c={}){let l;c.resource?(l=this.m.get(c.resource),l||(l=new S,this.m.set(c.resource,l))):l=this.l,u===void 0?l.removeValue(h):l.setValue(h,u),c.resource||(this.a=null)}inspect(h,u,c){const l=this.p(h,u,c),k=this.t(u.resource,c),R=u.resource?this.m.get(u.resource)||this.l:this.l,w=new Set;for(const p of l.overrides)for(const E of p.identifiers)l.getOverrideValue(h,E)!==void 0&&w.add(E);return new s(h,u,l.getValue(h),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,k||void 0,R)}keys(h){const u=this.t(void 0,h);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:u?u.keys.slice(0):[]}}updateDefaultConfiguration(h){this.c=h,this.a=null,this.b.clear()}updatePolicyConfiguration(h){this.d=h}updateApplicationConfiguration(h){this.f=h,this.a=null,this.b.clear()}updateLocalUserConfiguration(h){this.g=h,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(h){this.h=h,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(h){this.i=h,this.a=null,this.b.clear()}updateFolderConfiguration(h,u){this.j.set(h,u),this.b.delete(h)}deleteFolderConfiguration(h){this.folderConfigurations.delete(h),this.b.delete(h)}compareAndUpdateDefaultConfiguration(h,u){const c=[];if(!u){const{added:l,updated:k,removed:R}=a(this.c,h);u=[...l,...k,...R]}for(const l of u)for(const k of(0,C.$Gn)(l)){const R=this.c.getKeysForOverrideIdentifier(k),w=h.getKeysForOverrideIdentifier(k),p=[...w.filter(E=>R.indexOf(E)===-1),...R.filter(E=>w.indexOf(E)===-1),...R.filter(E=>!b.$in(this.c.override(k).getValue(E),h.override(k).getValue(E)))];c.push([k,p])}return this.updateDefaultConfiguration(h),{keys:u,overrides:c}}compareAndUpdatePolicyConfiguration(h){const{added:u,updated:c,removed:l}=a(this.d,h),k=[...u,...c,...l];return k.length&&this.updatePolicyConfiguration(h),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(h){const{added:u,updated:c,removed:l,overrides:k}=a(this.applicationConfiguration,h),R=[...u,...c,...l];return R.length&&this.updateApplicationConfiguration(h),{keys:R,overrides:k}}compareAndUpdateLocalUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:k}=a(this.localUserConfiguration,h),R=[...u,...c,...l];return R.length&&this.updateLocalUserConfiguration(h),{keys:R,overrides:k}}compareAndUpdateRemoteUserConfiguration(h){const{added:u,updated:c,removed:l,overrides:k}=a(this.remoteUserConfiguration,h),R=[...u,...c,...l];return R.length&&this.updateRemoteUserConfiguration(h),{keys:R,overrides:k}}compareAndUpdateWorkspaceConfiguration(h){const{added:u,updated:c,removed:l,overrides:k}=a(this.workspaceConfiguration,h),R=[...u,...c,...l];return R.length&&this.updateWorkspaceConfiguration(h),{keys:R,overrides:k}}compareAndUpdateFolderConfiguration(h,u){const c=this.folderConfigurations.get(h),{added:l,updated:k,removed:R,overrides:w}=a(c,u),p=[...l,...k,...R];return(p.length||!c)&&this.updateFolderConfiguration(h,u),{keys:p,overrides:w}}compareAndDeleteFolderConfiguration(h){const u=this.folderConfigurations.get(h);if(!u)throw new Error("Unknown folder");this.deleteFolderConfiguration(h);const{added:c,updated:l,removed:k,overrides:R}=a(u,void 0);return{keys:[...c,...l,...k],overrides:R}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(h,u,c){let l=this.q(u,c);return u.overrideIdentifier&&(l=l.override(u.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(h)!==void 0&&(l=l.merge(this.d)),l}q({resource:h},u){let c=this.r();if(u&&h){const l=u.getFolder(h);l&&(c=this.s(l.uri)||c);const k=this.m.get(h);k&&(c=c.merge(k))}return c}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(h){let u=this.b.get(h);if(!u){const c=this.r(),l=this.j.get(h);l?(u=c.merge(l),this.b.set(h,u)):u=c}return u}t(h,u){if(u&&h){const c=u.getFolder(h);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((h,u)=>{const{contents:c,overrides:l,keys:k}=this.j.get(u);return h.push([u,{contents:c,overrides:l,keys:k}]),h},[])}}allKeys(){const h=new Set;return this.c.keys.forEach(u=>h.add(u)),this.userConfiguration.keys.forEach(u=>h.add(u)),this.i.keys.forEach(u=>h.add(u)),this.j.forEach(u=>u.keys.forEach(c=>h.add(c))),[...h.values()]}u(){const h=new Set;return this.c.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.userConfiguration.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.i.getAllOverrideIdentifiers().forEach(u=>h.add(u)),this.j.forEach(u=>u.getAllOverrideIdentifiers().forEach(c=>h.add(c))),[...h.values()]}v(h){const u=new Set;return this.c.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.i.getKeysForOverrideIdentifier(h).forEach(c=>u.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(h).forEach(l=>u.add(l))),[...u.values()]}static parse(h){const u=this.w(h.defaults),c=this.w(h.policy),l=this.w(h.application),k=this.w(h.user),R=this.w(h.workspace),w=h.folders.reduce((p,E)=>(p.set(y.URI.revive(E[0]),this.w(E[1])),p),new L.$zc);return new i(u,c,l,k,new S,R,w,new S,new L.$zc)}static w(h){return new S(h.contents,h.keys,h.overrides)}}e.$On=i;function n(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const h=new Set,u=new Map;for(const l of r)l.keys.forEach(k=>h.add(k)),l.overrides.forEach(([k,R])=>{const w=(0,L.$wc)(u,k,new Set);R.forEach(p=>w.add(p))});const c=[];return u.forEach((l,k)=>c.push([k,[...l.values()]])),{keys:[...h.values()],overrides:c}}e.$Pn=n;class o{constructor(h,u,c,l){this.change=h,this.f=u,this.g=c,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of h.keys)this.affectedKeys.add(k);for(const[,k]of h.overrides)for(const R of k)this.affectedKeys.add(R);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(h,u){const c=this.a+h,l=this.d.indexOf(c);if(l<0)return!1;const k=l+c.length;if(k>=this.d.length)return!1;const R=this.d.charCodeAt(k);if(R!==this.b&&R!==this.c)return!1;if(u){const w=this.previousConfiguration?this.previousConfiguration.getValue(h,u,this.f?.workspace):void 0,p=this.g.getValue(h,u,this.h);return!b.$in(w,p)}return!0}}e.$Qn=o;function a(r,h){const{added:u,removed:c,updated:l}=t(h?.rawConfiguration,r?.rawConfiguration),k=[],R=r?.getAllOverrideIdentifiers()||[],w=h?.getAllOverrideIdentifiers()||[];if(h){const p=w.filter(E=>!R.includes(E));for(const E of p)k.push([E,h.getKeysForOverrideIdentifier(E)])}if(r){const p=R.filter(E=>!w.includes(E));for(const E of p)k.push([E,r.getKeysForOverrideIdentifier(E)])}if(h&&r){for(const p of R)if(w.includes(p)){const E=t({contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)},{contents:h.getOverrideValue(void 0,p)||{},keys:h.getKeysForOverrideIdentifier(p)});k.push([p,[...E.added,...E.removed,...E.updated]])}}return{added:u,removed:c,updated:l,overrides:k}}function t(r,h){const u=r?h?r.keys.filter(k=>h.keys.indexOf(k)===-1):[...r.keys]:[],c=h?r?h.keys.filter(k=>r.keys.indexOf(k)===-1):[...h.keys]:[],l=[];if(r&&h){for(const k of h.keys)if(r.keys.indexOf(k)!==-1){const R=(0,A.$Bi)(h.contents,k),w=(0,A.$Bi)(r.contents,k);b.$in(R,w)||l.push(k)}}return{added:u,removed:c,updated:l}}}),define(Ee[255],Se([1,0,22,4,3,82]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nqb=e.$Mqb=e.$Lqb=e.$Kqb=void 0;const L=(y,A,C)=>{const m=new Uint8Array(16);for(let f=0;f<16;f++)m[f]=Math.round(Math.random()*256);const v=(0,D.$ze)(D.$fe.wrap(m));return[`GET ws://localhost${y}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${v}`].join(`\r
`)+`\r
\r
`};e.$Kqb=L,e.$Lqb=D.$fe.fromString(`\r
\r
`);async function b(y,A,C,m,v){y.write(D.$fe.fromString((0,e.$Kqb)(A,C,m)));const S=new g.$Qc;try{return await new Promise((f,d)=>{let s;S.add(y.onData(i=>{s?s=D.$fe.concat([s,i],s.byteLength+i.byteLength):s=i;const n=s.indexOf(e.$Lqb);if(n===-1)return;f(y),y.pauseData();const o=s.slice(n+e.$Lqb.byteLength);o.byteLength&&v.onData.fire(o)})),S.add(y.onClose(i=>d(i??new Error("socket closed")))),S.add(y.onEnd(()=>d(new Error("socket ended"))))})}catch(f){throw y.dispose(),f}finally{S.dispose()}}e.$Mqb=b;class $ extends g.$Rc{constructor(A,C){super(),this.g=A,this.a=this.B(new N.$Ud),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new N.$Rd),this.onDidDispose=this.b.event,this.f=!1,this.B(C.onData),this.B(C.onData.event(m=>this.a.fire(m))),this.onClose=this.B(C.onClose).event,this.onEnd=this.B(C.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,C){I.SocketDiagnostics.traceSocketEvent(this,this.g,A,C)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$Nqb=$}),define(Ee[64],Se([1,0,8,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.RemoteAuthorityResolverErrorCode=e.$2k=e.$1k=e.RemoteConnectionType=e.$Zk=void 0,e.$Zk=(0,N.$Zh)("remoteAuthorityResolverService");var g;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(g||(e.RemoteConnectionType=g={}));class I{constructor(C){this.id=C,this.type=1}toString(){return`Managed(${this.id})`}}e.$1k=I;class L{constructor(C,m){this.host=C,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$2k=L;var b;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(b||(e.RemoteAuthorityResolverErrorCode=b={}));class $ extends D.$ab{static isNotAvailable(C){return C instanceof $&&C._code===b.NotAvailable}static isTemporarilyNotAvailable(C){return C instanceof $&&C._code===b.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof $&&C._code===b.NoResolverFound}static isInvalidAuthority(C){return C instanceof $&&C._code===b.InvalidAuthority}static isHandled(C){return C instanceof $&&C.isHandled}constructor(C,m=b.Unknown,v){super(C),this._message=C,this._code=m,this._detail=v,this.isHandled=m===b.NotAvailable&&v===!0,Object.setPrototypeOf(this,$.prototype)}}e.$3k=$;function y(A){const C=A.indexOf("+");return C===-1?A:A.substring(0,C)}e.$4k=y}),define(Ee[65],Se([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=void 0;function N(y){return y.scheme===D.Schemas.vscodeRemote?y.authority:void 0}e.$5k=N;function g(y){if(!y)return;const A=y.indexOf("+");return A<0?y:y.substr(0,A)}e.$6k=g;function I(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$7k=I;function L(y){const{host:A,port:C}=$(y);if(typeof C>"u")throw new Error("Remote authority doesn't contain a port!");return{host:A,port:C}}e.$8k=L;function b(y,A){let{host:C,port:m}=$(y);return typeof m>"u"&&(m=A),{host:C,port:m}}e.$9k=b;function $(y){const A=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const C=y.match(/^(\[[0-9a-z:]+\])$/);if(C)return{host:C[1],port:void 0};const m=y.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:y,port:void 0}}}),define(Ee[26],Se([1,0,13,5,65]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.TargetPlatform=e.ExtensionType=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l="extensions.user.cache",e.$$l="extensions.builtin.cache",e.$_l="undefined_publisher",e.$am=["ui","workspace","web"];function I(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.$bm=I,e.$cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(L||(e.ExtensionType=L={}));var b;(function(f){f.WIN32_X64="win32-x64",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(b||(e.TargetPlatform=b={}));class ${constructor(d){this.value=d,this._lower=d.toLowerCase()}static equals(d,s){if(typeof d>"u"||d===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof d=="string"||typeof s=="string"){const i=typeof d=="string"?d:d.value,n=typeof s=="string"?s:s.value;return D.$6e(i,n)}return d._lower===s._lower}static toKey(d){return typeof d=="string"?d.toLowerCase():d._lower}}e.$dm=$;class y{get size(){return this.c.size}constructor(d){if(this.c=new Set,d)for(const s of d)this.add(s)}add(d){this.c.add($.toKey(d))}delete(d){return this.c.delete($.toKey(d))}has(d){return this.c.has($.toKey(d))}}e.$em=y;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(d){this.c.delete($.toKey(d))}get(d){return this.c.get($.toKey(d))}has(d){return this.c.has($.toKey(d))}set(d,s){this.c.set($.toKey(d),s)}values(){return this.c.values()}forEach(d){this.c.forEach(d)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$fm=A;function C(f){return m(f)}e.$gm=C;function m(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.$hm=m;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.$im=v;function S(f,d){if(d){const s=`onResolveRemoteAuthority:${(0,g.$6k)(d)}`;return!!f.activationEvents?.includes(s)}return!1}e.$jm=S,e.$km=(0,N.$Zh)("IBuiltinExtensionsScannerService")}),define(Ee[137],Se([1,0,8,26]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CF=e.$BF=void 0;class g{constructor(){this.a=new Map,this.b=new WeakMap}register(L,b){this.a.set(L,b)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const b=Object.create(null);for(const $ of L){const y=this.readActivationEvents($);y.length>0&&(b[N.$dm.toKey($.identifier)]=y)}return b}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const b=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let $=0;$<b.length;$++)b[$]==="onUri"&&(b[$]=`onUri:${N.$dm.toKey(L.identifier)}`);if(!L.contributes)return b;for(const $ in L.contributes){const y=this.a.get($);if(!y)continue;const A=L.contributes[$],C=Array.isArray(A)?A:[A];try{y(C,b)}catch(m){(0,D.$Z)(m)}}return b}}e.$BF=g,e.$CF=new g}),define(Ee[256],Se([1,0,12,22,21,8,4,3,56,38,30,82,64,65]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ll=e.$kl=e.$jl=e.$il=e.$hl=e.$gl=e.$fl=e.$el=e.PersistentConnectionEventType=e.$dl=e.$cl=e.$bl=e.ConnectionType=void 0;const S=30*1e3;var f;(function(V){V[V.Management=1]="Management",V[V.ExtensionHost=2]="ExtensionHost",V[V.Tunnel=3]="Tunnel"})(f||(e.ConnectionType=f={}));function d(V){switch(V){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function s(V){const U=new g.$2d;return setTimeout(()=>U.cancel(),V),U.token}function i(V,U){if(V.isCancellationRequested||U.isCancellationRequested)return g.CancellationToken.Cancelled;const ne=new g.$2d;return V.onCancellationRequested(()=>ne.cancel()),U.onCancellationRequested(()=>ne.cancel()),ne.token}class n{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new b.$Qc,this.promise=new Promise((ne,ye)=>{this.f=ne,this.g=ye}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function o(V,U){const ne=new n(U);return ne.registerDisposable(V.onControlMessage(ye=>{const fe=JSON.parse(ye.toString()),me=Q(fe);me?ne.reject(me):ne.resolve(fe)})),ne.promise}function a(V,U,ne,ye,fe,me,ee,ie){const G=new n(ie),te=y.$Nd.create(!1);return V.info(`Creating a socket (${ee})...`),$.mark(`code/willCreateSocket/${me}`),U.connect(ne,ye,fe,ee).then(J=>{G.didTimeout?($.mark(`code/didCreateSocketError/${me}`),V.info(`Creating a socket (${ee}) finished after ${te.elapsed()} ms, but this is too late and has timed out already.`),J?.dispose()):($.mark(`code/didCreateSocketOK/${me}`),V.info(`Creating a socket (${ee}) was successful after ${te.elapsed()} ms.`),G.resolve(J))},J=>{$.mark(`code/didCreateSocketError/${me}`),V.info(`Creating a socket (${ee}) returned an error after ${te.elapsed()} ms.`),V.error(J),G.reject(J)}),G.promise}function t(V,U){const ne=new n(U);return V.then(ye=>{ne.didTimeout||ne.resolve(ye)},ye=>{ne.didTimeout||ne.reject(ye)}),ne.promise}async function r(V,U,ne,ye){const fe=ve(V,U);V.logService.trace(`${fe} 1/6. invoking socketFactory.connect().`);let me;try{me=await a(V.logService,V.remoteSocketFactoryService,V.connectTo,(0,v.$7k)(V),`reconnectionToken=${V.reconnectionToken}&reconnection=${V.reconnectionProtocol?"true":"false"}`,d(U),`renderer-${d(U)}-${V.reconnectionToken}`,ye)}catch(J){throw V.logService.error(`${fe} socketFactory.connect() failed or timed out. Error:`),V.logService.error(J),J}V.logService.trace(`${fe} 2/6. socketFactory.connect() was successful.`);let ee,ie;V.reconnectionProtocol?(V.reconnectionProtocol.beginAcceptReconnection(me,null),ee=V.reconnectionProtocol,ie=!1):(ee=new C.$Nh({socket:me}),ie=!0),V.logService.trace(`${fe} 3/6. sending AuthRequest control message.`);const G=await t(V.signService.createNewMessage((0,A.$kg)()),ye),te={type:"auth",auth:V.connectionToken||"00000000000000000000",data:G.data};ee.sendControl(N.$fe.fromString(JSON.stringify(te)));try{const J=await o(ee,i(ye,s(1e4)));if(J.type!=="sign"||typeof J.data!="string"){const Me=new Error("Unexpected handshake message");throw Me.code="VSCODE_CONNECTION_ERROR",Me}if(V.logService.trace(`${fe} 4/6. received SignRequest control message.`),!await t(V.signService.validate(G,J.signedData),ye)){const Me=new Error("Refused to connect to unsupported server");throw Me.code="VSCODE_CONNECTION_ERROR",Me}const be=await t(V.signService.sign(J.data),ye),Ie={type:"connectionType",commit:V.commit,signedData:be,desiredConnectionType:U};return ne&&(Ie.args=ne),V.logService.trace(`${fe} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.$fe.fromString(JSON.stringify(Ie))),{protocol:ee,ownsProtocol:ie}}catch(J){throw J&&J.code==="ETIMEDOUT"&&(V.logService.error(`${fe} the handshake timed out. Error:`),V.logService.error(J)),J&&J.code==="VSCODE_CONNECTION_ERROR"&&(V.logService.error(`${fe} received error control message when negotiating connection. Error:`),V.logService.error(J)),ie&&Z(ee),J}}async function h(V,U,ne,ye){const fe=Date.now(),me=ve(V,U),{protocol:ee,ownsProtocol:ie}=await r(V,U,ne,ye),G=new n(ye);return G.registerDisposable(ee.onControlMessage(te=>{const J=JSON.parse(te.toString()),ce=Q(J);ce?(V.logService.error(`${me} received error control message when negotiating connection. Error:`),V.logService.error(ce),ie&&Z(ee),G.reject(ce)):(V.reconnectionProtocol?.endAcceptReconnection(),V.logService.trace(`${me} 6/6. handshake finished, connection is up and running after ${ge(fe)}!`),G.resolve({protocol:ee,firstMessage:J}))})),G.promise}async function u(V,U){const{protocol:ne}=await h(V,1,void 0,U);return{protocol:ne}}async function c(V,U,ne){const{protocol:ye,firstMessage:fe}=await h(V,2,U,ne),me=fe&&fe.debugPort;return{protocol:ye,debugPort:me}}async function l(V,U,ne){const ye=Date.now(),fe=ve(V,3),{protocol:me}=await r(V,3,U,ne);return V.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${ge(ye)}!`),me}async function k(V,U,ne){const{connectTo:ye,connectionToken:fe}=await V.addressProvider.getAddress();return{commit:V.commit,quality:V.quality,connectTo:ye,connectionToken:fe,reconnectionToken:U,reconnectionProtocol:ne,remoteSocketFactoryService:V.remoteSocketFactoryService,signService:V.signService,logService:V.logService}}async function R(V,U,ne){return p(V,async ye=>{const{protocol:fe}=await u(ye,g.CancellationToken.None);return new Y(V,U,ne,ye.reconnectionToken,fe)})}e.$bl=R;async function w(V,U){return p(V,async ne=>{const{protocol:ye,debugPort:fe}=await c(ne,U,g.CancellationToken.None);return new ue(V,U,ne.reconnectionToken,ye,fe)})}e.$cl=w;async function p(V,U){for(let ye=1;;ye++)try{const fe=(0,A.$kg)(),me=await k(V,fe,null);return await U(me)}catch(fe){if(ye<5)V.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),V.logService.error(fe);else throw V.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),V.logService.error(fe),W.triggerPermanentFailure(0,0,m.$3k.isHandled(fe)),fe}}async function E(V,U,ne){const ye=await k(V,(0,A.$kg)(),null);return await l(ye,{host:U,port:ne},g.CancellationToken.None)}e.$dl=E;function P(V){return(0,D.$Ng)(U=>new Promise((ne,ye)=>{const fe=setTimeout(ne,V*1e3);U.onCancellationRequested(()=>{clearTimeout(fe),ne()})}))}var z;(function(V){V[V.ConnectionLost=0]="ConnectionLost",V[V.ReconnectionWait=1]="ReconnectionWait",V[V.ReconnectionRunning=2]="ReconnectionRunning",V[V.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",V[V.ConnectionGain=4]="ConnectionGain"})(z||(e.PersistentConnectionEventType=z={}));class j{constructor(U,ne){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.type=0}}e.$el=j;class F{constructor(U,ne,ye,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.durationSeconds=ye,this.c=fe,this.type=1}skipWait(){this.c.cancel()}}e.$fl=F;class O{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=2}}e.$gl=O;class T{constructor(U,ne,ye){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.type=4}}e.$hl=T;class M{constructor(U,ne,ye,fe){this.reconnectionToken=U,this.millisSinceLastIncomingData=ne,this.attempt=ye,this.handled=fe,this.type=3}}e.$il=M;class W extends b.$Rc{static triggerPermanentFailure(U,ne,ye){this._permanentFailure=!0,this.f=U,this.g=ne,this.h=ye,this.j.forEach(fe=>fe.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(U=>U.y())}static debugPauseSocketWriting(){this.j.forEach(U=>U.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||W._permanentFailure}constructor(U,ne,ye,fe,me){super(),this.t=U,this.u=ne,this.reconnectionToken=ye,this.protocol=fe,this.w=me,this.m=this.B(new L.$Rd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new T(this.reconnectionToken,0,0)),this.B(fe.onSocketClose(ee=>{const ie=X(this.t,this.reconnectionToken,!0);ee?ee.type===0?(this.u.logService.info(`${ie} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.u.logService.error(ee.error)):(this.u.logService.info(`${ie} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.u.logService.error(ee.event)):this.u.logService.info(`${ie} received socket close event.`),this.y()})),this.B(fe.onSocketTimeout(ee=>{const ie=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ie} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.y()})),W.j.push(this),this.B((0,b.$Pc)(()=>{const ee=W.j.indexOf(this);ee>=0&&W.j.splice(ee,1)})),this.n&&this.D(W.f,W.g,W.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const U=X(this.t,this.reconnectionToken,!0);this.u.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ne=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const fe=ye<ne.length?ne[ye]:ne[ne.length-1];try{if(fe>0){const ee=P(fe);this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),fe,ee)),this.u.logService.info(`${U} waiting for ${fe} seconds before reconnecting...`);try{await ee}catch{}}if(this.n){this.u.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${U} resolving connection...`);const me=await k(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${U} connecting to ${me.connectTo}...`),await this.G(me,s(S)),this.u.logService.info(`${U} reconnected!`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(me){if(me.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(m.$3k.isTemporarilyNotAvailable(me)){this.u.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((me.code==="ETIMEDOUT"||me.code==="ENETUNREACH"||me.code==="ECONNREFUSED"||me.code==="ECONNRESET")&&me.syscall==="connect"){this.u.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if((0,I.$3)(me)){this.u.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(me);continue}if(me instanceof m.$3k){this.u.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,m.$3k.isHandled(me));break}this.u.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(me),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(U,ne,ye){this.w?W.triggerPermanentFailure(U,ne,ye):this.D(U,ne,ye)}D(U,ne,ye){this.m.fire(new M(this.reconnectionToken,U,ne,ye)),Z(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$jl=W;class Y extends W{constructor(U,ne,ye,fe,me){super(1,U,fe,me,!0),this.client=this.B(new C.$Lh(me,{remoteAuthority:ne,clientId:ye},U.ipcLogger))}async G(U,ne){await u(U,ne)}}e.$kl=Y;class ue extends W{constructor(U,ne,ye,fe,me){super(2,U,ye,fe,!1),this.H=ne,this.debugPort=me}async G(U,ne){await c(U,this.H,ne)}}e.$ll=ue;function Z(V){try{V.acceptDisconnect();const U=V.getSocket();V.dispose(),U.dispose()}catch(U){(0,I.$Z)(U)}}function Q(V){if(V&&V.type==="error"){const U=new Error(`Connection error: ${V.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function x(V,U){for(;V.length<U;)V+=" ";return V}function oe(V,U){return`[remote-connection][${x(d(V),13)}][${U.substr(0,5)}\u2026]`}function X(V,U,ne){return`${oe(V,U)}[${ne?"reconnect":"initial"}]`}function ve(V,U){return`${X(U,V.reconnectionToken,!!V.reconnectionProtocol)}[${V.connectTo}]`}function ge(V){return`${Date.now()-V} ms`}}),define(Ee[257],Se([1,0,3,5]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$k=e.$0k=void 0,e.$0k=(0,N.$Zh)("remoteSocketFactoryService");class g{constructor(){this.a={}}register(L,b){return this.a[L]??=[],this.a[L].push(b),(0,D.$Pc)(()=>{const $=this.a[L]?.indexOf(b);typeof $=="number"&&$>=0&&this.a[L]?.splice($,1)})}b(L){return(this.a[L.type]||[]).find($=>$.supports(L))}connect(L,b,$,y){const A=this.b(L);if(!A)throw new Error(`No socket factory found for ${L}`);return A.connect(L,b,$,y)}}e.$$k=g}),define(Ee[258],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I5b=void 0;class D{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(g){try{const I=await this.c();if(I){const L=String(D.a++);return this.b.set(L,I),{id:L,data:I.createNewMessage(g)}}}catch{}return{id:"",data:g}}async validate(g,I){if(!g.id)return!0;const L=this.b.get(g.id);if(!L)return!1;this.b.delete(g.id);try{return L.validate(I)==="ok"}catch{return!1}finally{L.dispose?.()}}async sign(g){try{return await this.d(g)}catch{}return g}}e.$I5b=D}),define(Ee[109],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$al=e.$_k=void 0,e.$_k="signService",e.$al=(0,D.$Zh)(e.$_k)}),define(Ee[138],Se([1,0,258]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0;class N extends D.$I5b{c(){return this.h().then(I=>new I.validator)}d(I){return this.h().then(L=>new L.signer().sign(I))}h(){return new Promise((I,L)=>$e(["vsda"],I,L))}}e.$F0b=N}),define(Ee[259],Se([1,0,11,50,30]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;function I($){if(D.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function L($,y,A,C,m,v,S,f,d){const s=Object.create(null);s["common.machineId"]=v,s["common.sqmId"]=S,s.sessionID=(0,g.$kg)()+Date.now(),s.commitHash=C,s.version=m,s["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,D.$h)(D.$u),s["common.nodePlatform"]=N.$cc,s["common.nodeArch"]=A,s["common.product"]=d||"desktop",f&&(s["common.msftInternal"]=f);let i=0;const n=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),D.$l&&(s["common.snap"]="true");const o=I(y);return o&&(s["common.platformDetail"]=o),s}e.$ro=L;function b($){const y=N.env.USERDNSDOMAIN;if(!y)return!1;const A=y.toLowerCase();return $.some(C=>A===C)}e.$so=b}),define(Ee[260],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=void 0,e.$ml=(0,D.$Zh)("telemetryService"),e.$nl=(0,D.$Zh)("customEndpointTelemetryService"),e.$ol="telemetry.currentSessionDate",e.$pl="telemetry.firstSessionDate",e.$ql="telemetry.lastSessionDate",e.$rl="telemetry.machineId",e.$sl="telemetry.sqmId",e.$tl="telemetry",e.$ul="telemetry.telemetryLevel",e.$vl="telemetry.enableCrashReporter",e.$wl="telemetry.enableTelemetry";var N;(function(I){I[I.NONE=0]="NONE",I[I.CRASH=1]="CRASH",I[I.ERROR=2]="ERROR",I[I.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var g;(function(I){I.OFF="off",I.CRASH="crash",I.ERROR="error",I.ON="all"})(g||(e.TelemetryConfiguration=g={}))}),define(Ee[87],Se([1,0,24,18,4,45,65,259,260]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;class y{constructor(c){this.value=c,this.isTrustedTelemetryValue=!0}}e.$to=y;class A{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$uo=A,e.$vo=new A;class C{async publicLog(c,l,k){}async publicLogError(c,l,k){}}e.$wo=C,e.$xo="telemetry",e.$yo="extensionTelemetryLog",e.$zo={log:()=>null,flush:()=>Promise.resolve(null)};function m(u,c){return g.Event.debounce(c.onDidChangeConfiguration,(k,R)=>{const w=k?new Set([...k.affectedKeys,...R.affectedKeys]):R.affectedKeys;return{...R,affectedKeys:w}},1e3,!0)(k=>{k.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,I.$wi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Ao=m;function v(u,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!u.enableTelemetry)}e.$Bo=v;function S(u,c){return c.extensionTestsLocationURI?!0:!(c.isBuilt||c.disableTelemetry||u.enableTelemetry&&u.aiConfig?.ariaKey)}e.$Co=S;function f(u){const c=u.getValue($.$ul),l=u.getValue($.$vl);if(u.getValue($.$wl)===!1||l===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Do=f;function d(u){const c={},l={},k={};n(u,k);for(let R in k){R=R.length>150?R.substr(R.length-149):R;const w=k[R];typeof w=="number"?l[R]=w:typeof w=="boolean"?l[R]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${R} has been trimmed to 8192, the original length is ${w.length}`),c[R]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(c[R]=w)}return{properties:c,measurements:l}}e.$Eo=d;const s=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function i(u){if(!u)return"none";const c=(0,L.$6k)(u);return s.has(c)?c:"other"}e.$Fo=i;function n(u,c,l=0,k){if(u)for(const R of Object.getOwnPropertyNames(u)){const w=u[R],p=k?k+R:R;Array.isArray(w)?c[p]=(0,D.$jn)(w):w instanceof Date?c[p]=w.toISOString():(0,N.$Ef)(w)?l<2?n(w,c,l+1,p+"."):c[p]=(0,D.$jn)(w):c[p]=w}}function o(u,c){const l=u.msftInternalDomains||[],k=c.getValue("telemetry.internalTesting");return(0,b.$so)(l)||k}e.$Go=o;function a(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.$Ho=a;function t(u,c){if(!u||!u.includes("/")&&!u.includes("\\"))return u;let l=u;const k=[];for(const E of c)for(;;){const P=E.exec(u);if(!P)break;k.push([P.index,E.lastIndex])}const R=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(l="";;){const E=w.exec(u);if(!E)break;const P=k.some(([z,j])=>E.index<j&&z<w.lastIndex);!R.test(E[0])&&!P&&(l+=u.substring(p,E.index)+"<REDACTED: user-file-path>",p=w.lastIndex)}return p<u.length&&(l+=u.substr(p)),l}function r(u){if(!u)return u;const c=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const l of c)if(l.regex.test(u))return`<REDACTED: ${l.label}>`;return u}function h(u,c){return(0,D.$gn)(u,l=>{if(l instanceof y||Object.hasOwnProperty.call(l,"isTrustedTelemetryValue"))return l.value;if(typeof l=="string"){let k=l.replaceAll("%20"," ");k=t(k,c);for(const R of c)k=k.replace(R,"");return k=r(k),k}})}e.$Io=h}),define(Ee[261],Se([1,0,13,134,26,11,2,8,50,87]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;function A(h,u){return h.uuid&&u.uuid?h.uuid===u.uuid:h.id===u.id?!0:(0,D.$1e)(h.id,u.id)===0}e.$Jo=A;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(u){const c=u.manifest?u.manifest.version:u.version,l=u.manifest?u.targetPlatform:u.properties.targetPlatform;return new m(u.identifier,c,l)}static parse(u){const c=C.exec(u);return c&&c[1]&&c[2]?new m({id:c[1]},c[2],c[4]||void 0):null}constructor(u,c,l="undefined"){this.version=c,this.targetPlatform=l,this.id=u.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(u){return u instanceof m?A(this,u)&&this.version===u.version&&this.targetPlatform===u.targetPlatform:!1}}e.$Ko=m;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(h){const u=v.exec(h);return u&&u[1]?[d(u[1]),u[2]]:[d(h),void 0]}e.$Lo=S;function f(h,u){return`${h}.${u}`}e.$Mo=f;function d(h){return h.toLowerCase()}e.$No=d;function s(h,u){return d(f(h??g.$_l,u))}e.$Oo=s;function i(h,u){const c=[],l=k=>{for(const R of c)if(R.some(w=>A(u(w),u(k))))return R;return null};for(const k of h){const R=l(k);R?R.push(k):c.push([k])}return c}e.$Po=i;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.$Qo=n;function o(h){return{id:new y.$to(h.identifier.id),name:new y.$to(h.name),galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,isPreReleaseVersion:h.properties.isPreReleaseVersion,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),isSigned:h.isSigned,...h.telemetryData}}e.$Ro=o,e.$So=new g.$dm("pprice.better-merge");function a(h,u){const c=[],l=u.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const k=l.shift();if(k&&c.every(R=>!A(R.identifier,{id:k}))){const R=h.filter(w=>A(w.identifier,{id:k}));R.length===1&&(c.push(R[0]),l.push(...R[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.$To=a;async function t(h,u){if(!I.$k)return!1;let c;try{c=(await h.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await h.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){u.debug("Error while getting the os-release file.",(0,b.$9)(k))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(h,u){const c=await t(h,u),l=(0,N.$do)(c?"alpine":I.$u,$.$dc);return u.debug("ComputeTargetPlatform:",l),l}e.$Uo=r}),define(Ee[262],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0;function D($){return[...$.entries()]}e.$ur=D;function N($){return $?[...$.entries()]:[]}e.$vr=N;function g($){return new Map($)}e.$wr=g;function I($){return new Map($??[])}e.$xr=I;function L($){return Array.from($.entries()).map(y=>[y[0],D(y[1].map),N(y[1].descriptionMap)])}e.$yr=L;function b($){return new Map($.map(y=>[y[0],{map:g(y[1]),descriptionMap:I(y[2])}]))}e.$zr=b}),define(Ee[263],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qb=void 0;class D{constructor(g){this.b=g,this.a=new Map}dispose(){for(const g of this.a.values())g.dispose()}startBuffering(g,I,L=5){const b=I($=>{const y=typeof $=="string"?$:$.data;let A=this.a.get(g);if(A){A.data.push(y);return}const C=setTimeout(()=>this.flushBuffer(g),L);A={data:[y],timeoutId:C,dispose:()=>{clearTimeout(C),this.flushBuffer(g),b.dispose()}},this.a.set(g,A)});return b}stopBuffering(g){this.a.get(g)?.dispose()}flushBuffer(g){const I=this.a.get(g);I&&(this.a.delete(g),this.b(g,I.data.join("")))}}e.$5qb=D}),define(Ee[264],Se([1,0,12,78,61,4,18,2,206,108,37]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.IconFontDefinition=e.IconContribution=e.$ew=void 0,e.$ew={IconContribution:"base.contributions.icons"};var C;(function(o){function a(t,r){let h=t.defaults;for(;g.ThemeIcon.isThemeIcon(h);){const u=S.getIcon(h.id);if(!u)return;h=u.defaults}return h}o.getDefinition=a})(C||(e.IconContribution=C={}));var m;(function(o){function a(r){return{weight:r.weight,style:r.style,src:r.src.map(h=>({format:h.format,location:h.location.toString()}))}}o.toJSONObject=a;function t(r){const h=u=>(0,L.$Cf)(u)?u:void 0;if(r&&Array.isArray(r.src)&&r.src.every(u=>(0,L.$Cf)(u.format)&&(0,L.$Cf)(u.location)))return{weight:h(r.weight),style:h(r.style),src:r.src.map(u=>({format:u.format,location:b.URI.parse(u.location)}))}}o.fromJSONObject=t})(m||(e.IconFontDefinition=m={}));class v{constructor(){this.a=new I.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${g.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,r,h){const u=this.b[a];if(u){if(r&&!u.description){u.description=r,this.d.properties[a].markdownDescription=`${r} $(${a})`;const k=this.e.enum.indexOf(a);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return u}const c={id:a,description:r,defaults:t,deprecationMessage:h};this.b[a]=c;const l={$ref:"#/definitions/icons"};return h&&(l.deprecationMessage=h),r&&(l.markdownDescription=`${r}: $(${a})`),this.d.properties[a]=l,this.e.enum.push(a),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const r=this.f[a];return r||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(u,c)=>u.id.localeCompare(c.id),t=u=>{for(;g.ThemeIcon.isThemeIcon(u.defaults);)u=this.b[u.defaults.id];return`codicon codicon-${u?u.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const h=Object.keys(this.b).map(u=>this.b[u]);for(const u of h.filter(c=>!!c.description).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|${g.ThemeIcon.isThemeIcon(u.defaults)?u.defaults.id:u.id}|${u.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const u of h.filter(c=>!g.ThemeIcon.isThemeIcon(c.defaults)).sort(a))r.push(`|<i class="${t(u)}"></i>|${u.id}|`);return r.join(`
`)}}const S=new v;A.$qn.add(e.$ew.IconContribution,S);function f(o,a,t,r){return S.registerIcon(o,a,t,r)}e.$fw=f;function d(){return S}e.$gw=d;function s(){const o=(0,N.$3j)();for(const a in o){const t="\\"+o[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}s(),e.$hw="vscode://schemas/icons";const i=A.$qn.as(y.$rn.JSONContribution);i.registerSchema(e.$hw,S.getIconSchema());const n=new D.$_g(()=>i.notifySchemaChanged(e.$hw),200);S.onDidChange(()=>{n.isScheduled()||n.schedule()}),e.$iw=f("widget-close",N.$5j.close,(0,$.localize)(2,null)),e.$jw=f("goto-previous-location",N.$5j.arrowUp,(0,$.localize)(3,null)),e.$kw=f("goto-next-location",N.$5j.arrowDown,(0,$.localize)(4,null)),e.$lw=g.ThemeIcon.modify(N.$5j.sync,"spin"),e.$mw=g.ThemeIcon.modify(N.$5j.loading,"spin")}),define(Ee[88],Se([1,0,4,45,5,14]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.ProvidedOnAutoForward=e.$kv=e.TunnelPrivacyId=e.TunnelProtocol=e.$jv=e.$iv=void 0,e.$iv=(0,g.$Zh)("tunnelService"),e.$jv=(0,g.$Zh)("sharedTunnelsService");var L;(function(d){d.Http="http",d.Https="https"})(L||(e.TunnelProtocol=L={}));var b;(function(d){d.ConstantPrivate="constantPrivate",d.Private="private",d.Public="public"})(b||(e.TunnelPrivacyId=b={}));function $(d){return!!d.forwardPort}e.$kv=$;var y;(function(d){d[d.Notify=1]="Notify",d[d.OpenBrowser=2]="OpenBrowser",d[d.OpenPreview=3]="OpenPreview",d[d.Silent=4]="Silent",d[d.Ignore=5]="Ignore",d[d.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function A(d){if(d.scheme!=="http"&&d.scheme!=="https")return;const s=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(d.authority);if(s)return{address:s[1],port:+s[2]}}e.$lv=A,e.$mv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(d){return e.$mv.indexOf(d)>=0}e.$nv=C,e.$ov=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(d){return e.$ov.indexOf(d)>=0}e.$pv=m;function v(d,s,i,n){if(i===1)return!1;if(i===2&&m(s)){const o=/(\d+)\.(\d+)\.(\d+)/g.exec(n);if(o?.length===4&&parseInt(o[1])>=18)return!1}return d<1024}e.$qv=v;class S{constructor(s,i,n){this.remoteAddress=s,this.localAddress=i,this.b=n,this.a=new D.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$rv=S;let f=class{constructor(s,i){this.j=s,this.k=i,this.a=new D.$Rd,this.onTunnelOpened=this.a.event,this.b=new D.$Rd,this.onTunnelClosed=this.b.event,this.c=new D.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const s=this.k.getValue("remote.localPortHost");return!s||s==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(s){return this.f=s,s?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(s){this.g=s.elevation,this.h=s.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const s=[],i=Array.from(this.e.values());for(const n of i){const o=Array.from(n.values());for(const a of o){const t=await a.value;t&&typeof t!="string"&&s.push(t)}}return s}async dispose(){for(const s of this.e.values()){for(const{value:i}of s.values())await i.then(n=>typeof n!="string"?n?.dispose():void 0);s.clear()}this.e.clear()}setEnvironmentTunnel(s,i,n,o,a){this.p(s,i,Promise.resolve({tunnelRemoteHost:s,tunnelRemotePort:i,localAddress:n,privacy:o,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(s,i){(m(s)||C(s))&&(s=e.$mv[0]);const n=this.r(s,i);if(n)return++n.refcount,n.value}openTunnel(s,i,n,o,a,t=!1,r,h){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${n} on local port ${a}.`);const u=this.f??s;if(!u)return;if(i||(i="localhost"),o||(o=this.l),this.f&&this.i.has(n)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const c=this.s(u,i,n,o,a,t,r,h);return c?c.then(l=>{if(l){if(typeof l=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(i,n),l}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(i,n);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==n)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&l.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),c)}n(s){return{tunnelRemotePort:s.tunnelRemotePort,tunnelRemoteHost:s.tunnelRemoteHost,tunnelLocalPort:s.tunnelLocalPort,localAddress:s.localAddress,privacy:s.privacy,protocol:s.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${s.tunnelRemoteHost}:${s.tunnelRemotePort} `);const i=this.e.get(s.tunnelRemoteHost);if(i){const n=i.get(s.tunnelRemotePort);n&&(n.refcount--,await this.o(s.tunnelRemoteHost,s.tunnelRemotePort,n))}}}}async o(s,i,n){if(n.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${s}:${i}.`);const o=n.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(s)&&this.e.get(s).delete(i),o}}async closeTunnel(s,i){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${s}:${i} `);const n=this.e.get(s);if(n&&n.has(i)){const o=n.get(i);o.refcount=0,await this.o(s,i,o)}}p(s,i,n){this.e.has(s)||this.e.set(s,new Map),this.e.get(s).set(i,{refcount:1,value:n})}async q(s,i){const n=this.e.get(s);if(n){const o=n.get(i),a=o?await o.value:void 0;(!a||typeof a=="string")&&n.delete(i),n.size===0&&this.e.delete(s)}}r(s,i){const n=[s];C(s)?(n.push(...e.$mv),n.push(...e.$ov)):m(s)&&n.push(...e.$ov);const o=n.map(a=>this.e.get(a));for(const a of o){const t=a?.get(i);if(t)return t}}canTunnel(s){return!!A(s)}t(s,i,n,o,a,t,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${n} on local port ${o}.`);const h=n;this.i.add(h);const u=o===void 0?n:o,c={elevationRequired:a?this.isPortPrivileged(u):!1},l={remoteAddress:{host:i,port:n},localAddressPort:o,privacy:t,public:t?t!==b.Private:void 0,protocol:r},k=s.forwardPort(l,c);return k?(this.p(i,n,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(h)})):this.i.delete(h),k}};e.$sv=f,e.$sv=f=Ke([We(0,I.$hj),We(1,N.$ti)],f)}),define(Ee[265],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=void 0,e.$Sk=(0,D.$Zh)("IUriIdentityService")}),define(Ee[266],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$tv=void 0,e.$tv=(0,D.$Zh)("editSessionIdentityService");var N;(function(g){g[g.Complete=100]="Complete",g[g.Partial=50]="Partial",g[g.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ee[267],Se([1,0,17]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=void 0;function N($){return $.scheme!==D.Schemas.file&&$.scheme!==D.Schemas.vscodeRemote}e.$bK=N;function g($){if($.folders.length)return $.folders.every(y=>N(y.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}e.$cK=g;function I($){return g($)?.scheme}e.$dK=I;function L($){return g($)?.authority}e.$eK=L;function b($){return g($)!==void 0}e.$fK=b}),define(Ee[40],Se([1,0,208,16,77,23,2,5,17]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.WorkbenchState=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0,e.$9h=(0,b.$Zh)("contextService");function y(u){const c=u;return typeof c?.id=="string"&&L.URI.isUri(c.uri)}e.$0h=y;function A(u){return typeof u?.id=="string"&&!y(u)&&!m(u)}e.$$h=A,e.$_h={id:"ext-dev"},e.$ai={id:"empty-window"};function C(u,c){if(typeof u=="string"||typeof u>"u")return typeof u=="string"?{id:(0,N.$mc)(u)}:c?e.$_h:e.$ai;const l=u;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$bi=C;function m(u){const c=u;return typeof c?.id=="string"&&L.URI.isUri(c.configPath)}e.$ci=m;function v(u){const c=u;if(c?.uri)return{id:c.id,uri:L.URI.revive(c.uri)};const l=u;if(l?.configPath)return{id:l.id,configPath:L.URI.revive(l.configPath)};if(u?.id)return{id:u.id}}e.$di=v;var S;(function(u){u[u.EMPTY=1]="EMPTY",u[u.FOLDER=2]="FOLDER",u[u.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function f(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&Array.isArray(c.folders))}e.$ei=f;function d(u){const c=u;return!!(c&&typeof c=="object"&&L.URI.isUri(c.uri)&&typeof c.name=="string"&&typeof c.toResource=="function")}e.$fi=d;class s{constructor(c,l,k,R,w){this.h=c,this.j=k,this.k=R,this.l=w,this.c=g.$6h.forUris(this.l,()=>!0),this.folders=l}update(c){this.h=c.id,this.k=c.configuration,this.j=c.transient,this.l=c.l,this.folders=c.folders}get folders(){return this.g}set folders(c){this.g=c,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(c){this.k=c}getFolder(c){return c&&this.c.findSubstr(c)||null}n(){this.c=g.$6h.forUris(this.l,()=>!0);for(const c of this.folders)this.c.set(c.uri,c)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$gi=s;class i{constructor(c,l){this.raw=l,this.uri=c.uri,this.index=c.index,this.name=c.name}toResource(c){return(0,I.$Bg)(this.uri,c)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$hi=i;function n(u){return new i({uri:u,index:0,name:(0,I.$xg)(u)},{uri:u.toString()})}e.$ii=n,e.$ji="code-workspace",e.$ki=`.${e.$ji}`,e.$li=[{name:(0,D.localize)(0,null),extensions:[e.$ji]}],e.$mi="workspace.json";function o(u,c){return I.$sg.isEqualOrParent(u,c.untitledWorkspacesHome)}e.$ni=o;function a(u){let c;return L.URI.isUri(u)?c=u:c=u.configuration,c?.scheme===$.Schemas.tmp}e.$oi=a,e.$pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(u){return u.id===e.$pi}e.$qi=t;function r(u,c){return!o(u,c)&&!a(u)}e.$ri=r;function h(u){return(typeof u=="string"?(0,N.$nc)(u):(0,I.$zg)(u))===e.$ki}e.$si=h}),define(Ee[268],Se([1,0,53,4,3,23,2,207,133,32,5,14,40,28,265,12,30,13,18]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.ProfileResourceType=void 0;var n;(function(u){u.Settings="settings",u.Keybindings="keybindings",u.Snippets="snippets",u.Tasks="tasks",u.Extensions="extensions",u.GlobalState="globalState"})(n||(e.ProfileResourceType=n={}));function o(u){const c=u;return!!(c&&typeof c=="object"&&typeof c.id=="string"&&typeof c.isDefault=="boolean"&&typeof c.name=="string"&&L.URI.isUri(c.location)&&L.URI.isUri(c.globalStorageHome)&&L.URI.isUri(c.settingsResource)&&L.URI.isUri(c.keybindingsResource)&&L.URI.isUri(c.tasksResource)&&L.URI.isUri(c.snippetsHome)&&L.URI.isUri(c.extensionsResource))}e.$Tk=o,e.$Uk=(0,A.$Zh)("IUserDataProfilesService");function a(u,c){return{id:u.id,isDefault:u.isDefault,name:u.name,shortName:u.shortName,icon:u.icon,location:L.URI.revive(u.location).with({scheme:c}),globalStorageHome:L.URI.revive(u.globalStorageHome).with({scheme:c}),settingsResource:L.URI.revive(u.settingsResource).with({scheme:c}),keybindingsResource:L.URI.revive(u.keybindingsResource).with({scheme:c}),tasksResource:L.URI.revive(u.tasksResource).with({scheme:c}),snippetsHome:L.URI.revive(u.snippetsHome).with({scheme:c}),extensionsResource:L.URI.revive(u.extensionsResource).with({scheme:c}),cacheHome:L.URI.revive(u.cacheHome).with({scheme:c}),useDefaultFlags:u.useDefaultFlags,isTransient:u.isTransient}}e.$Vk=a;function t(u,c,l,k,R,w){return{id:u,name:c,location:l,isDefault:!1,shortName:R?.shortName,icon:R?.icon,globalStorageHome:w&&R?.useDefaultFlags?.globalState?w.globalStorageHome:(0,I.$Bg)(l,"globalStorage"),settingsResource:w&&R?.useDefaultFlags?.settings?w.settingsResource:(0,I.$Bg)(l,"settings.json"),keybindingsResource:w&&R?.useDefaultFlags?.keybindings?w.keybindingsResource:(0,I.$Bg)(l,"keybindings.json"),tasksResource:w&&R?.useDefaultFlags?.tasks?w.tasksResource:(0,I.$Bg)(l,"tasks.json"),snippetsHome:w&&R?.useDefaultFlags?.snippets?w.snippetsHome:(0,I.$Bg)(l,"snippets"),extensionsResource:w&&R?.useDefaultFlags?.extensions?w.extensionsResource:(0,I.$Bg)(l,"extensions.json"),cacheHome:(0,I.$Bg)(k,u),useDefaultFlags:R?.useDefaultFlags,isTransient:R?.transient}}e.$Wk=t;let r=class extends g.$Rc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(c,l,k,R){super(),this.t=c,this.u=l,this.w=k,this.y=R,this.f=!0,this.h=this.B(new N.$Rd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Rd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Rd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Rd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new v.$zc,emptyWindows:new Map},this.profilesHome=(0,I.$Bg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,I.$Bg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(c){this.f!==c&&(this.z=void 0,this.f=c)}isEnabled(){return this.f}get C(){if(!this.z){const c=this.D(),l=[c];if(this.f)try{for(const w of this.O()){if(!w.name||!(0,i.$Cf)(w.name)||!w.location){this.y.warn("Skipping the invalid stored profile",w.location||w.name);continue}l.push(t((0,I.$yg)(w.location),w.name,w.location,this.g,{shortName:w.shortName,icon:w.icon,useDefaultFlags:w.useDefaultFlags},c))}}catch(w){this.y.error(w)}const k=new v.$zc,R=new Map;if(l.length)try{const w=this.Q();if(w.workspaces)for(const[p,E]of Object.entries(w.workspaces)){const P=L.URI.parse(p),z=l.find(j=>j.id===E);z&&k.set(P,z)}if(w.emptyWindows)for(const[p,E]of Object.entries(w.emptyWindows)){const P=l.find(z=>z.id===E);P&&R.set(p,P)}}catch(w){this.y.error(w)}this.z={profiles:l,workspaces:k,emptyWindows:R}}return this.z}D(){const c=t("__default__profile__",(0,b.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...c,extensionsResource:this.S()??c.extensionsResource,isDefault:!0}}async createTransientProfile(c){const l="Temp",k=new RegExp(`${(0,s.$Je)(l)}\\s(\\d+)`);let R=0;for(const p of this.profiles){const E=k.exec(p.name),P=E?parseInt(E[1]):0;R=P>R?P:R}const w=`${l} ${R+1}`;return this.createProfile((0,D.$Ni)((0,d.$kg)()).toString(16),w,{transient:!0},c)}async createNamedProfile(c,l,k){return this.createProfile((0,D.$Ni)((0,d.$kg)()).toString(16),c,l,k)}async createProfile(c,l,k,R){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const w=await this.F(c,l,k);return R&&await this.setProfileForWorkspace(R,w),w}async F(c,l,k){if(!(0,i.$Cf)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let R=this.r.get(l);return R||(R=(async()=>{try{const w=this.profiles.find(P=>P.name===l||P.id===c);if(w)return w;const p=t(c,l,(0,I.$Bg)(this.profilesHome,c),this.g,k,this.defaultProfile);await this.u.createFolder(p.location);const E=[];return this.j.fire({profile:p,join(P){E.push(P)}}),await f.Promises.settled(E),this.I([p],[],[]),p}finally{this.r.delete(l)}})(),this.r.set(l,R)),R}async updateProfile(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let k=this.profiles.find(R=>R.id===c.id);if(!k)throw new Error(`Profile '${c.name}' does not exist`);return k=t(k.id,l.name??k.name,k.location,this.g,{shortName:l.shortName??k.shortName,icon:l.icon===null?void 0:l.icon??k.icon,transient:l.transient??k.isTransient,useDefaultFlags:l.useDefaultFlags??k.useDefaultFlags},this.defaultProfile),this.I([],[],[k]),k}async removeProfile(c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(c.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(R=>R.id===c.id);if(!l)throw new Error(`Profile '${c.name}' does not exist`);const k=[];this.m.fire({profile:l,join(R){k.push(R)}});try{await Promise.allSettled(k)}catch(R){this.y.error(R)}for(const R of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(R)?.id&&this.C.emptyWindows.delete(R);for(const R of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(R)?.id&&this.C.workspaces.delete(R);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(R){(0,y.$zk)(R)!==1&&this.y.error(R)}}async setProfileForWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const k=this.profiles.find(R=>R.id===l.id);if(!k)throw new Error(`Profile '${l.name}' does not exist`);this.L(c,k)}unsetWorkspace(c,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(c,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const c=await this.u.resolve(this.profilesHome);await Promise.all((c.children||[]).filter(l=>l.isDirectory&&this.profiles.every(k=>!this.w.extUri.isEqual(k.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const c=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(c.map(l=>this.removeProfile(l)))}getProfileForWorkspace(c){const l=this.G(c);return L.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(c){return(0,m.$0h)(c)?c.uri:(0,m.$ci)(c)?c.configPath:c.id}H(c){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,c.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,c.location)))}I(c,l,k){const R=[...this.profiles,...c],w=[];this.s.profiles=[];for(let p of R)p.isDefault||l.some(E=>p.id===E.id)||(p=k.find(E=>p.id===E.id)??p,p.isTransient?this.s.profiles.push(p):w.push({location:p.location,name:p.name,shortName:p.shortName,icon:p.icon,useDefaultFlags:p.useDefaultFlags}));this.P(w),this.z=void 0,this.J(c,l,k)}J(c,l,k){this.h.fire({added:c,removed:l,updated:k,all:this.profiles})}L(c,l,k){k=l?.isTransient?!0:k,k||this.L(c,void 0,!0);const R=this.G(c),w=k?this.s:this.C;L.URI.isUri(R)?(w.workspaces.delete(R),l&&w.workspaces.set(R,l)):(w.emptyWindows.delete(R),l&&w.emptyWindows.set(R,l)),k||this.M()}M(){const c={};for(const[k,R]of this.C.workspaces.entries())c[k.toString()]=R.id;const l={};for(const[k,R]of this.C.emptyWindows.entries())l[k.toString()]=R.id;this.R({workspaces:c,emptyWindows:l}),this.z=void 0}N(c){const l={},k=this.D();if(c.workspaces)for(const[w,p]of Object.entries(c.workspaces)){const E=L.URI.parse(p);l[w]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}const R={};if(c.emptyWindows)for(const[w,p]of Object.entries(c.emptyWindows)){const E=L.URI.parse(p);R[w]=this.w.extUri.isEqual(E,k.location)?k.id:this.w.extUri.basename(E)}return{workspaces:l,emptyWindows:R}}O(){return[]}P(c){throw new Error("not implemented")}Q(){return{}}R(c){throw new Error("not implemented")}S(){}};e.$Xk=r,e.$Xk=r=Ke([We(0,$.$7h),We(1,y.$ik),We(2,S.$Sk),We(3,C.$hj)],r);class h extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(c){this.a=c}Q(){return this.X}R(c){this.X=c}}e.$Yk=h}),define(Ee[269],Se([1,0,12,4,3,56,18,187,5,268]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$dp=e.$cp=e.$bp=void 0,e.$bp="__$__isNewStorageMarker",e.$cp="__$__targetStorageMarker",e.$dp=(0,$.$Zh)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var C;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(C||(e.StorageScope=C={}));var m;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function v(i){const n=i.get(e.$cp);if(n)try{return JSON.parse(n)}catch{}return Object.create(null)}e.$ep=v;class S extends g.$Rc{static{this.a=60*1e3}constructor(n={flushInterval:S.a}){super(),this.m=n,this.b=this.B(new N.$Ud),this.c=this.B(new N.$Ud),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Rd),this.onWillSaveState=this.f.event,this.h=this.B(new D.$_g(()=>this.n(),this.m.flushInterval)),this.j=this.B(new g.$Sc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(n,o,a){return N.Event.filter(this.b.event,t=>t.scope===n&&(o===void 0||t.key===o),a)}n(){this.j.value=(0,D.$dh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,g.$Mc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,I.mark)("code/willInitStorage");try{await this.O()}finally{(0,I.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(n,o){const{key:a,external:t}=o;if(a===e.$cp){switch(n){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:n})}else this.b.fire({scope:n,key:a,target:this.J(n)[a],external:t})}w(n){this.f.fire({reason:n})}get(n,o,a){return this.P(o)?.get(n,a)}getBoolean(n,o,a){return this.P(o)?.getBoolean(n,a)}getNumber(n,o,a){return this.P(o)?.getNumber(n,a)}getObject(n,o,a){return this.P(o)?.getObject(n,a)}storeAll(n,o){this.y(()=>{for(const a of n)this.store(a.key,a.value,a.scope,a.target,o)})}store(n,o,a,t,r=!1){if((0,L.$Lf)(o)){this.remove(n,a,r);return}this.y(()=>{this.z(n,a,t),this.P(a)?.set(n,o,r)})}remove(n,o,a=!1){this.y(()=>{this.z(n,o,void 0),this.P(o)?.delete(n,a)})}y(n){this.b.pause(),this.c.pause();try{n()}finally{this.b.resume(),this.c.resume()}}keys(n,o){const a=[],t=this.J(n);for(const r of Object.keys(t))t[r]===o&&a.push(r);return a}z(n,o,a,t=!1){const r=this.J(o);typeof a=="number"?r[n]!==a&&(r[n]=a,this.P(o)?.set(e.$cp,JSON.stringify(r),t)):typeof r[n]=="number"&&(delete r[n],this.P(o)?.set(e.$cp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(n){switch(n){case-1:return this.I;case 0:return this.G;default:return this.D}}L(n){const o=this.P(n);return o?v(o):Object.create(null)}isNew(n){return this.getBoolean(e.$bp,n)===!0}async flush(n=A.NONE){this.f.fire({reason:n});const o=this.P(-1),a=this.P(0),t=this.P(1);switch(n){case A.NONE:await D.Promises.settled([o?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await D.Promises.settled([o?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const n=this.P(-1)?.items??new Map,o=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return s(n,o,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(n){return await this.flush(),this.P(n)?.optimize()}async switch(n,o){return this.w(A.NONE),(0,y.$Tk)(n)?this.R(n,o):this.S(n,o)}M(n,o){return!(n.id===o.id||f(o)&&f(n))}N(n,o,a){this.y(()=>{const t=new Set;for(const[r,h]of n)t.add(r),o.get(r)!==h&&this.u(a,{key:r,external:!0});for(const[r]of o.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$fp=S;function f(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$gp=f;class d extends S{constructor(){super(),this.U=this.B(new b.$_o(new b.$ap,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new b.$_o(new b.$ap,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new b.$_o(new b.$ap,{hint:b.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(n=>this.u(1,n))),this.B(this.W.onDidChangeStorage(n=>this.u(0,n))),this.B(this.U.onDidChangeStorage(n=>this.u(-1,n)))}P(n){switch(n){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(n){switch(n){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(n){return!1}}e.$hp=d;async function s(i,n,o,a,t,r){const h=P=>{try{return JSON.parse(P)}catch{return P}},u=new Map,c=new Map;i.forEach((P,z)=>{u.set(z,P),c.set(z,h(P))});const l=new Map,k=new Map;n.forEach((P,z)=>{l.set(z,P),k.set(z,h(P))});const R=new Map,w=new Map;o.forEach((P,z)=>{R.set(z,P),w.set(z,h(P))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const p=[];if(u.forEach((P,z)=>{p.push({key:z,value:P})}),console.table(p),console.groupEnd(),console.log(c),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const P=[];l.forEach((z,j)=>{P.push({key:j,value:z})}),console.table(P),console.groupEnd(),console.log(k)}console.group(`Storage: Workspace (path: ${r})`);const E=[];R.forEach((P,z)=>{E.push({key:z,value:P})}),console.table(E),console.groupEnd(),console.log(w)}e.$ip=s}),define(Ee[110],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class D{static{this.a=!1}constructor(g){this.d=g,this.b=new Map,this.c=1}add(g){const I=this.c++;return this.b.set(I,g),this.e(),I}get(g,I){return this.b.has(g)?this.b.get(g)[I]:void 0}delete(g){this.b.delete(g),this.e()}e(){D.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$vec=D}),define(Ee[57],Se([1,0,17,23,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0;class I{constructor(){this.a=new Set(Object.keys(D.Schemas)),this.b=new Map,this.extUri=new N.$qg(b=>{const $=this.b.get(b.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(b,$){$===null?this.b.delete(b.scheme):this.b.set(b.scheme,$)}isFreeScheme(b){return!this.b.has(b)&&!this.a.has(b)}getCapabilities(b){return this.b.get(b)}}e.$yec=I,e.$zec=(0,g.$Zh)("IExtHostFileSystemInfo")}),define(Ee[27],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0,e.$XM=(0,D.$Zh)("IExtHostInitDataService")}),define(Ee[270],Se([1,0,213,14,250,27]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;let L=class extends g.$5N{constructor($,y,A){const C=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",m=A.remote.isRemote?(0,D.localize)(0,null):$?(0,D.localize)(1,null):(0,D.localize)(2,null);super(y.createLogger(C,{name:m}))}};e.$Fgc=L,e.$Fgc=L=Ke([We(1,N.$ij),We(2,I.$XM)],L)}),define(Ee[271],Se([1,0,12]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=void 0;class N{constructor(L,b,$){this.h=new Map,this.a=L,this.b=b,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new D.$_g(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of y.values())A.complete()}catch(A){for(const C of y.values())C.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,b){let $=this.f[L];return typeof $>"u"&&($=b),$}update(L,b){this.f[L]=b;const $=this.h.get(L);if($!==void 0)return $.p;const y=new D.$kh;return this.h.set(L,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$hfc=N;class g extends N{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,b){super(L.identifier.value,!0,b),this.j=L}}e.$ifc=g}),define(Ee[272],Se([1,0,4,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class g{constructor(L){this.c=L,this.a=new D.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new D.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,b,$,y){const C=this.c.getNotebookDocument(N.URI.revive(L)).acceptModelChanged(b.value,$,y);this.b.fire(C)}$acceptDirtyStateChanged(L,b){this.c.getNotebookDocument(N.URI.revive(L)).acceptDirty(b)}$acceptModelSaved(L){const b=this.c.getNotebookDocument(N.URI.revive(L));this.a.fire(b.apiNotebook)}}e.$8fc=g}),define(Ee[20],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=void 0,e.$HM=(0,D.$Zh)("IExtHostRpcService");class N{constructor(I){this.getProxy=I.getProxy.bind(I),this.set=I.set.bind(I),this.dispose=I.dispose.bind(I),this.assertRegistered=I.assertRegistered.bind(I),this.drain=I.drain.bind(I)}}e.$IM=N}),define(Ee[273],Se([1,0,26,4]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class g{#e;constructor(L,b){this.b=new N.$Rd,this.onDidChange=this.b.event,this.a=D.$dm.toKey(L.identifier),this.#e=b,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(L){return this.#e.get(this.a,L)}store(L,b){return this.#e.store(this.a,L,b)}delete(L){return this.#e.delete(this.a,L)}}e.$pfc=g}),define(Ee[66],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=e.$Rec=void 0,e.$Rec=(0,D.$Zh)("IURITransformerService");class N{constructor(I){I?(this.transformIncoming=I.transformIncoming.bind(I),this.transformOutgoing=I.transformOutgoing.bind(I),this.transformOutgoingURI=I.transformOutgoingURI.bind(I),this.transformOutgoingScheme=I.transformOutgoingScheme.bind(I)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Sec=N}),define(Ee[274],Se([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfb=e.$jfb=void 0;class N{constructor(){this.buffers=[]}add($){let y=this.buffers.indexOf($);return y<0&&(y=this.buffers.length,this.buffers.push($)),y}}function g(b,$){if($.serializeBuffersForPostMessage){const y=new N,C=JSON.stringify(b,(v,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S)};if(ArrayBuffer.isView(S)){const f=I(S);if(f)return{$$vscode_array_buffer_reference$$:!0,index:y.add(S.buffer),view:{type:f,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),m=y.buffers.map(v=>{const S=new Uint8Array(v);return D.$fe.wrap(S)});return{message:C,buffers:m}}else return{message:JSON.stringify(b),buffers:[]}}e.$jfb=g;function I(b){switch(b.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(b,$){const y=$.map(m=>{const v=new ArrayBuffer(m.byteLength);return new Uint8Array(v).set(m.buffer),v}),A=$.length?(m,v)=>{if(v&&typeof v=="object"&&v.$$vscode_array_buffer_reference$$){const S=v,{index:f}=S,d=y[f];if(S.view)switch(S.view.type){case 1:return new Int8Array(d,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return v}:void 0;return{message:JSON.parse(b,A),arrayBuffers:y}}e.$kfb=L}),define(Ee[275],Se([1,0,276,387,388,62,2,14,389]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bhc=void 0;const y=!1;function A(n,o,a,t,r,h){const u=h.environment.useHostProxy,c=typeof u=="boolean"?u:!h.remote.isRemote,l={resolveProxy:w=>n.resolveProxy(w),lookupProxyAuthorization:d.bind(void 0,t,r,o,{},h.remote.isRemote),getProxyURL:()=>o.getConfiguration("http").get("proxy"),getProxySupport:()=>o.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>m(o),addCertificatesV2:()=>v(o),log:t,getLogLevel:()=>{const w=t.getLevel();switch(w){case b.LogLevel.Trace:return $.LogLevel.Trace;case b.LogLevel.Debug:return $.LogLevel.Debug;case b.LogLevel.Info:return $.LogLevel.Info;case b.LogLevel.Warning:return $.LogLevel.Warning;case b.LogLevel.Error:return $.LogLevel.Error;case b.LogLevel.Off:return $.LogLevel.Off;default:return p(w)}function p(E){return t.error("Unknown log level",E),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:c,loadAdditionalCertificates:async()=>{const w=[];if(h.remote.isRemote&&w.push((0,$.loadSystemCertificates)({log:t})),c){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const p=n.loadCertificates();p.then(E=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",E.length)),w.push(p)}return(await Promise.all(w)).flat()},env:process.env},k=(0,$.createProxyResolver)(l),R=C(l,k);return f(a,R)}e.$bhc=A;function C(n,o){return{http:Object.assign(D,(0,$.createHttpPatch)(n,D,o)),https:Object.assign(N,(0,$.createHttpPatch)(n,N,o)),net:Object.assign(I,(0,$.createNetPatch)(n,I)),tls:Object.assign(g,(0,$.createTlsPatch)(n,g))}}function m(n){const o=n.getConfiguration("http");return!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}function v(n){const o=n.getConfiguration("http");return!!o.get("experimental.systemCertificatesV2",y)&&!!o.get("systemCertificates")}const S=new Map;function f(n,o){return n.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,r=t._load;t._load=function(u,c,l){if(u==="net")return o.net;if(u==="tls")return o.tls;if(u!=="http"&&u!=="https")return r.apply(this,arguments);const k=a.findSubstr(L.URI.file(c.filename));let R=S.get(k);if(R||S.set(k,R={}),!R[u]){const w=o[u];R[u]={...w}}return R[u]}})}async function d(n,o,a,t,r,h,u,c){const l=t[h];u&&(t[h]=u),n.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${h}`,`proxyAuthenticate:${u}`,`proxyAuthenticateCache:${l}`);const k=u||l,R=Array.isArray(k)?k:typeof k=="string"?[k]:[];if(i(o,R,r),R.some(w=>/^(Negotiate|Kerberos)( |$)/i.test(w))&&!c.kerberosRequested)try{c.kerberosRequested=!0;const w=await new Promise((j,F)=>{$e(["kerberos"],j,F)}),p=new URL(h),E=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${p.hostname}`:`HTTP@${p.hostname}`);return n.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${h}`,`spn:${E}`),"Negotiate "+await(await w.initializeClient(E)).step("")}catch(w){n.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",w)}}let s=!1;function i(n,o,a){s||!o.length||(s=!0,n.$publicLog2("proxyAuthenticationRequest",{authenticationType:o.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(Ee[277],Se([1,0,130]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kr=void 0;function N(I){return{transformIncoming:L=>L.scheme==="vscode-remote"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="file"?{scheme:"vscode-local",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoing:L=>L.scheme==="file"?{scheme:"vscode-remote",authority:I,path:L.path,query:L.query,fragment:L.fragment}:L.scheme==="vscode-local"?{scheme:"file",path:L.path,query:L.query,fragment:L.fragment}:L,transformOutgoingScheme:L=>L==="file"?"vscode-remote":L==="vscode-local"?"file":L}}function g(I){return new D.$Vm(N(I))}e.$Kr=g}),define(Ee[139],Se([1,0,224,18,2,3,5,37,32,17,44,179,39]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HE=e.$GE=e.$FE=e.EditorsOrder=e.$EE=e.CloseDirection=e.$DE=e.$CE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.EditorInputCapabilities=e.$tE=e.SaveReason=e.Verbosity=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=void 0,e.$gE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$hE={id:"default",displayName:(0,D.localize)(0,null),providerDisplayName:(0,D.localize)(1,null)},e.$iE="workbench.editor.sidebysideEditor",e.$jE="workbench.editors.textDiffEditor",e.$kE="workbench.editors.binaryResourceDiffEditor";var v;(function(ge){ge[ge.PROGRAMMATIC=1]="PROGRAMMATIC",ge[ge.USER=2]="USER",ge[ge.EDIT=3]="EDIT",ge[ge.NAVIGATION=4]="NAVIGATION",ge[ge.JUMP=5]="JUMP"})(v||(e.EditorPaneSelectionChangeReason=v={}));var S;(function(ge){ge[ge.IDENTICAL=1]="IDENTICAL",ge[ge.SIMILAR=2]="SIMILAR",ge[ge.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function f(ge){const V=ge;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.$lE=f;function d(ge,V,U){for(const ne of U.visibleEditorPanes)if(ne.group.id===V&&ge.matches(ne.input))return ne.getViewState()}e.$mE=d;function s(ge){if(k(ge))return!1;const V=ge;return g.URI.isUri(V?.resource)}e.$nE=s;function i(ge){if(k(ge))return!1;const V=ge;return V?.original!==void 0&&V.modified!==void 0}e.$oE=i;function n(ge){if(k(ge))return!1;const V=ge;return Array.isArray(V?.resources)}e.$pE=n;function o(ge){if(k(ge)||i(ge))return!1;const V=ge;return V?.primary!==void 0&&V.secondary!==void 0}e.$qE=o;function a(ge){if(k(ge))return!1;const V=ge;return V?V.resource===void 0||V.resource.scheme===y.Schemas.untitled||V.forceUntitled===!0:!1}e.$rE=a;function t(ge){if(k(ge))return!1;const V=ge;return g.URI.isUri(V?.base?.resource)&&g.URI.isUri(V?.input1?.resource)&&g.URI.isUri(V?.input2?.resource)&&g.URI.isUri(V?.result?.resource)}e.$sE=t;var r;(function(ge){ge[ge.SHORT=0]="SHORT",ge[ge.MEDIUM=1]="MEDIUM",ge[ge.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var h;(function(ge){ge[ge.EXPLICIT=1]="EXPLICIT",ge[ge.AUTO=2]="AUTO",ge[ge.FOCUS_CHANGE=3]="FOCUS_CHANGE",ge[ge.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(h||(e.SaveReason=h={}));class u{constructor(){this.a=new Map}registerSource(V,U){let ne=this.a.get(V);return ne||(ne={source:V,label:U},this.a.set(V,ne)),ne.source}getSourceLabel(V){return this.a.get(V)?.label??V}}e.$tE=new u;var c;(function(ge){ge[ge.None=0]="None",ge[ge.Readonly=2]="Readonly",ge[ge.Untitled=4]="Untitled",ge[ge.Singleton=8]="Singleton",ge[ge.RequiresTrust=16]="RequiresTrust",ge[ge.CanSplitInGroup=32]="CanSplitInGroup",ge[ge.ForceDescription=64]="ForceDescription",ge[ge.CanDropIntoEditor=128]="CanDropIntoEditor",ge[ge.MultipleEditors=256]="MultipleEditors",ge[ge.Scratchpad=512]="Scratchpad",ge[ge.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(c||(e.EditorInputCapabilities=c={}));class l extends I.$Rc{}e.$uE=l;function k(ge){return ge instanceof l}e.$vE=k;function R(ge){const V=ge;return g.URI.isUri(V?.preferredResource)}function w(ge){const V=ge;return k(V?.primary)&&k(V?.secondary)}e.$wE=w;function p(ge){const V=ge;return k(V?.modified)&&k(V?.original)}e.$xE=p;function E(ge,V,U,ne,ye){return ve(ne,[(0,C.$Ji)({id:"workbench.action.openLargeFile",label:(0,D.localize)(2,null),run:()=>{const fe={...U,limits:{size:Number.MAX_VALUE}};ge.openEditor(V,fe)}}),(0,C.$Ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,D.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:m.default.Warning})}e.$yE=E;function P(ge){return k(ge?.editor)}e.$zE=P;function z(ge){const V=ge;return P(ge)&&V?.group!==void 0}e.$AE=z;function j(ge){const V=ge;return typeof V?.groupId=="number"&&k(V.editor)}e.$BE=j;var F;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.REPLACE=1]="REPLACE",ge[ge.MOVE=2]="MOVE",ge[ge.UNPIN=3]="UNPIN"})(F||(e.EditorCloseContext=F={}));var O;(function(ge){ge[ge.GROUP_ACTIVE=0]="GROUP_ACTIVE",ge[ge.GROUP_INDEX=1]="GROUP_INDEX",ge[ge.GROUP_LABEL=2]="GROUP_LABEL",ge[ge.GROUP_LOCKED=3]="GROUP_LOCKED",ge[ge.EDITOR_OPEN=4]="EDITOR_OPEN",ge[ge.EDITOR_CLOSE=5]="EDITOR_CLOSE",ge[ge.EDITOR_MOVE=6]="EDITOR_MOVE",ge[ge.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ge[ge.EDITOR_LABEL=8]="EDITOR_LABEL",ge[ge.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ge[ge.EDITOR_PIN=10]="EDITOR_PIN",ge[ge.EDITOR_STICKY=11]="EDITOR_STICKY",ge[ge.EDITOR_DIRTY=12]="EDITOR_DIRTY",ge[ge.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var T;(function(ge){ge[ge.PRIMARY=1]="PRIMARY",ge[ge.SECONDARY=2]="SECONDARY",ge[ge.BOTH=3]="BOTH",ge[ge.ANY=4]="ANY"})(T||(e.SideBySideEditor=T={}));class M{getOriginalUri(V,U){if(!V)return;if(t(V))return e.$DE.getOriginalUri(V.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:fe}=this.a(V);if(ye&&fe){if(U?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getOriginalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getOriginalUri(ye,{filterByScheme:U.filterByScheme})??this.getOriginalUri(fe,{filterByScheme:U.filterByScheme});V=U.supportSideBySide===T.PRIMARY?ye:fe}}if(i(V)||n(V)||o(V)||t(V))return;const ne=R(V)?V.preferredResource:V.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}a(V){return w(V)||o(V)?{primary:V.primary,secondary:V.secondary}:p(V)||i(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,U){if(!V)return;if(t(V))return e.$DE.getCanonicalUri(V.result,U);if(U?.supportSideBySide){const{primary:ye,secondary:fe}=this.a(V);if(ye&&fe){if(U?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme}),secondary:this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme})};if(U?.supportSideBySide===T.ANY)return this.getCanonicalUri(ye,{filterByScheme:U.filterByScheme})??this.getCanonicalUri(fe,{filterByScheme:U.filterByScheme});V=U.supportSideBySide===T.PRIMARY?ye:fe}}if(i(V)||n(V)||o(V)||t(V))return;const ne=V.resource;return!ne||!U||!U.filterByScheme?ne:this.b(ne,U.filterByScheme)}b(V,U){if(Array.isArray(U)){if(U.some(ne=>V.scheme===ne))return V}else if(U===V.scheme)return V}}var W;(function(ge){ge[ge.UNKNOWN=0]="UNKNOWN",ge[ge.KEYBOARD=1]="KEYBOARD",ge[ge.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function Y(ge,V,U,ne){if(!ge.isSticky(V))return!1;switch(ne.preventPinnedEditorClose){case"keyboardAndMouse":return U===W.MOUSE||U===W.KEYBOARD;case"mouse":return U===W.MOUSE;case"keyboard":return U===W.KEYBOARD}return!1}e.$CE=Y,e.$DE=new M;var ue;(function(ge){ge[ge.LEFT=0]="LEFT",ge[ge.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(V){const U=this.a=V.get(L.$Yh);for(const[ne,ye]of this.c)this.e(ne,ye,U);this.c.clear()}e(V,U,ne){const ye=ne.createInstance(U);this.d.set(V,ye)}registerFileEditorFactory(V){if(this.b)throw new Error("Can only register one file editor factory.");this.b=V}getFileEditorFactory(){return(0,N.$Nf)(this.b)}registerEditorSerializer(V,U){if(this.c.has(V)||this.d.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.a?this.e(V,U,this.a):this.c.set(V,U),(0,I.$Pc)(()=>{this.c.delete(V),this.d.delete(V)})}getEditorSerializer(V){return this.d.get(typeof V=="string"?V:V.typeId)}}b.$qn.add(e.$gE.EditorFactory,new Z);async function Q(ge,V,U){return!ge||!ge.length?[]:await Promise.all(ge.map(async ne=>{const ye=g.URI.revive(ne.fileUri);if(!ye){U.info("Cannot resolve the path because it is not valid.",ne);return}if(!await V.canHandleResource(ye)){U.info("Cannot resolve the path because it cannot be handled",ne);return}let me=ne.exists,ee=ne.type;if(typeof me!="boolean"||typeof ee!="number")try{ee=(await V.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,me=!0}catch(G){U.error(G),me=!1}if(!me&&ne.openOnlyIfExists){U.info("Cannot resolve the path because it does not exist",ne);return}if(ee===$.FileType.Directory){U.info("Cannot resolve the path because it is a directory",ne);return}const ie={...ne.options,pinned:!0};return me?{resource:ye,options:ie}:{resource:ye,options:ie,forceUntitled:!0}}))}e.$EE=Q;var x;(function(ge){ge[ge.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ge[ge.SEQUENTIAL=1]="SEQUENTIAL"})(x||(e.EditorsOrder=x={}));function oe(ge){const V=ge;if(!V)return!1;const U=V;if(U.modified)return oe(U.modified);const ne=V;return!!(ne.contributionsState&&ne.viewState&&Array.isArray(ne.cursorState))}e.$FE=oe;function X(ge){return(0,A.$Li)(ge)}e.$GE=X;function ve(ge,V,U){const ne=(0,A.$Mi)(ge,V);return ne.forceMessage=U?.forceMessage,ne.forceSeverity=U?.forceSeverity,ne.allowDialog=U?.allowDialog,ne}e.$HE=ve}),define(Ee[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$OE=e.$NE=e.ViewContentGroups=e.$ME=e.$LE=e.ViewContainerLocation=e.Extensions=e.$KE=e.$JE=e.$IE=void 0,e.$IE="views",e.$JE=(0,N.localize)(0,null),e.$KE=(0,C.$fw)("default-view-icon",A.$5j.window,(0,N.localize)(1,null));var m;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(m||(e.Extensions=m={}));var v;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(v||(e.ViewContainerLocation=v={})),e.$LE=[0,1,2];function S(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$ME=S;class f extends I.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new D.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Qb)([...this.g.values()])}registerViewContainer(h,u,c){const l=this.get(h.id);if(l)return l;const k=h;return k.openCommandActionDescriptor=c?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,L.$wc)(this.g,u,[]).push(k),c?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:u}),k}deregisterViewContainer(h){for(const u of this.g.keys()){const c=this.g.get(u),l=c?.indexOf(h);if(l!==-1){c?.splice(l,1),c.length===0&&this.g.delete(u),this.f.fire({viewContainer:h,viewContainerLocation:u});return}}}get(h){return this.all.filter(u=>u.id===h)[0]}getViewContainers(h){return[...this.g.get(h)||[]]}getViewContainerLocation(h){return[...this.g.keys()].filter(u=>this.getViewContainers(u).filter(c=>c?.id===h.id).length>0)[0]}getDefaultViewContainer(h){return this.h.find(u=>this.getViewContainerLocation(u)===h)}}b.$qn.add(m.ViewContainersRegistry,new f);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d||(e.ViewContentGroups=d={}));function s(r,h){const u=r.group??d.More,c=h.group??d.More;return u!==c?u.localeCompare(c):(r.order??5)-(h.order??5)}class i extends I.$Rc{constructor(){super(...arguments),this.c=this.B(new D.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new D.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new D.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new D.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Fc}registerViews(h,u){this.registerViews2([{views:h,viewContainer:u}])}registerViews2(h){h.forEach(({views:u,viewContainer:c})=>this.r(u,c)),this.c.fire(h)}deregisterViews(h,u){const c=this.s(h,u);c.length&&this.f.fire({views:c,viewContainer:u})}moveViews(h,u){for(const c of this.m.keys())if(c!==u){const l=this.s(h,c);l.length&&(this.r(l,u),this.g.fire({views:l,from:c,to:u}))}}getViews(h){return this.m.get(h)||[]}getView(h){for(const u of this.j){const c=(this.m.get(u)||[]).filter(l=>l.id===h)[0];if(c)return c}return null}getViewContainer(h){for(const u of this.j)if((this.m.get(u)||[]).filter(l=>l.id===h)[0])return u;return null}registerViewWelcomeContent(h,u){return this.n.add(h,u),this.h.fire(h),(0,I.$Pc)(()=>{this.n.delete(h,u),this.h.fire(h)})}registerViewWelcomeContent2(h,u){const c=new Map;for(const[l,k]of u)this.n.add(h,k),c.set(l,(0,I.$Pc)(()=>{this.n.delete(h,k),this.h.fire(h)}));return this.h.fire(h),c}getViewWelcomeContent(h){const u=[];return this.n.forEach(h,c=>u.push(c)),u.sort(s)}r(h,u){let c=this.m.get(u);c||(c=[],this.m.set(u,c),this.j.push(u));for(const l of h){if(this.getView(l.id)!==null)throw new Error((0,N.localize)(2,null,l.id));c.push(l)}}s(h,u){const c=this.m.get(u);if(!c)return[];const l=[],k=[];for(const R of c)h.includes(R)?l.push(R):k.push(R);return l.length&&(k.length?this.m.set(u,k):(this.m.delete(u),this.j.splice(this.j.indexOf(u),1))),l}}b.$qn.add(m.ViewsRegistry,new i),e.$NE=(0,g.$Zh)("viewsService"),e.$OE=(0,g.$Zh)("viewDescriptorService");var n;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var o;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(o||(e.TreeItemCollapsibleState=o={}));class a{constructor(h,u){this.c=!1,this.d=!1,(0,y.$hn)(this,h),this.d=!!u,this.resolve=async c=>{if(u&&!this.c){const l=await u(c);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}c.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$PE=a;class t extends Error{constructor(h){super((0,N.localize)(3,null,h)),this.name="NoTreeViewError"}static is(h){return h.name==="NoTreeViewError"}}e.$QE=t}),define(Ee[279],Se([1,0,2,29,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$dF=e.$cF=void 0;function I(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof D.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(N.$Ds.isIRange)}e.$cF=I;function L(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(I)}e.$dF=L;var b;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(b||(e.InteractiveSessionVoteDirection=b={}));var $;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})($||(e.InteractiveSessionCopyKind=$={})),e.$eF=(0,g.$Zh)("IChatService")}),define(Ee[140],Se([1,0,4,12,226]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfb=void 0;class I{constructor(){this.f=new Map,this.k=[],this.m=new D.$Rd,this.n=new D.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(b){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=b}onEvent(b){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=b}onRequest(b){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=b}sendResponse(b){b.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${b.command}`)):this.s("response",b)}sendRequest(b,$,y,A){const C={command:b};if($&&Object.keys($).length>0&&(C.arguments=$),this.s("request",C),typeof A=="number"){const m=setTimeout(()=>{clearTimeout(m);const v=this.f.get(C.seq);if(v){this.f.delete(C.seq);const S={type:"response",seq:0,request_seq:C.seq,success:!1,command:b,message:(0,g.localize)(0,null,A,b)};v(S)}},A)}return y&&this.f.set(C.seq,y),C.seq}acceptMessage(b){this.j?this.j(b):(this.k.push(b),this.k.length===1&&this.q())}o(b,$){return b.type!=="event"||$.type!=="event"}async q(){let b;for(;this.k.length;){if((!b||this.o(this.k[0],b))&&await(0,N.$1g)(0),b=this.k.shift(),!b)return;switch(b.type){case"event":this.i?.(b);break;case"request":this.g?.(b);break;case"response":{const $=b,y=this.f.get($.request_seq);y&&(this.f.delete($.request_seq),y($));break}}}}s(b,$){$.type=b,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const b=new Map;this.f.forEach(($,y)=>b.set(y,$)),await(0,N.$1g)(500),b.forEach(($,y)=>{$({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Pfb=I}),define(Ee[280],Se([1,0,227,46,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$pH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$oH=e.MemoryRangeType=e.$nH=e.State=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0,e.$kG="workbench.view.debug",e.$lG="workbench.debug.variablesView",e.$mG="workbench.debug.watchExpressionsView",e.$nG="workbench.debug.callStackView",e.$oG="workbench.debug.loadedScriptsView",e.$pG="workbench.debug.breakPointsView",e.$qG="workbench.debug.disassemblyView",e.$rG="workbench.panel.repl",e.$sG="workbench.panel.repl.view",e.$tG=new N.$ej("debugType",void 0,{type:"string",description:D.localize(0,null)}),e.$uG=new N.$ej("debugConfigurationType",void 0,{type:"string",description:D.localize(1,null)}),e.$vG=new N.$ej("debugState","inactive",{type:"string",description:D.localize(2,null)}),e.$wG="debugUx",e.$xG=new N.$ej(e.$wG,"default",{type:"string",description:D.localize(3,null)}),e.$yG=new N.$ej("hasDebugged",!1,{type:"boolean",description:D.localize(4,null)}),e.$zG=new N.$ej("inDebugMode",!1,{type:"boolean",description:D.localize(5,null)}),e.$AG=new N.$ej("inDebugRepl",!1,{type:"boolean",description:D.localize(6,null)}),e.$BG=new N.$ej("breakpointWidgetVisible",!1,{type:"boolean",description:D.localize(7,null)}),e.$CG=new N.$ej("inBreakpointWidget",!1,{type:"boolean",description:D.localize(8,null)}),e.$DG=new N.$ej("breakpointsFocused",!0,{type:"boolean",description:D.localize(9,null)}),e.$EG=new N.$ej("watchExpressionsFocused",!0,{type:"boolean",description:D.localize(10,null)}),e.$FG=new N.$ej("watchExpressionsExist",!1,{type:"boolean",description:D.localize(11,null)}),e.$GG=new N.$ej("variablesFocused",!0,{type:"boolean",description:D.localize(12,null)}),e.$HG=new N.$ej("expressionSelected",!1,{type:"boolean",description:D.localize(13,null)}),e.$IG=new N.$ej("breakpointInputFocused",!1,{type:"boolean",description:D.localize(14,null)}),e.$JG=new N.$ej("callStackItemType",void 0,{type:"string",description:D.localize(15,null)}),e.$KG=new N.$ej("callStackSessionIsAttach",!1,{type:"boolean",description:D.localize(16,null)}),e.$LG=new N.$ej("callStackItemStopped",!1,{type:"boolean",description:D.localize(17,null)}),e.$MG=new N.$ej("callStackSessionHasOneThread",!1,{type:"boolean",description:D.localize(18,null)}),e.$NG=new N.$ej("watchItemType",void 0,{type:"string",description:D.localize(19,null)}),e.$OG=new N.$ej("canViewMemory",void 0,{type:"boolean",description:D.localize(20,null)}),e.$PG=new N.$ej("breakpointItemType",void 0,{type:"string",description:D.localize(21,null)}),e.$QG=new N.$ej("breakpointSupportsCondition",!1,{type:"boolean",description:D.localize(22,null)}),e.$RG=new N.$ej("loadedScriptsSupported",!1,{type:"boolean",description:D.localize(23,null)}),e.$SG=new N.$ej("loadedScriptsItemType",void 0,{type:"string",description:D.localize(24,null)}),e.$TG=new N.$ej("focusedSessionIsAttach",!1,{type:"boolean",description:D.localize(25,null)}),e.$UG=new N.$ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:D.localize(26,null)}),e.$VG=new N.$ej("stepBackSupported",!1,{type:"boolean",description:D.localize(27,null)}),e.$WG=new N.$ej("restartFrameSupported",!1,{type:"boolean",description:D.localize(28,null)}),e.$XG=new N.$ej("stackFrameSupportsRestart",!1,{type:"boolean",description:D.localize(29,null)}),e.$YG=new N.$ej("jumpToCursorSupported",!1,{type:"boolean",description:D.localize(30,null)}),e.$ZG=new N.$ej("stepIntoTargetsSupported",!1,{type:"boolean",description:D.localize(31,null)}),e.$1G=new N.$ej("breakpointsExist",!1,{type:"boolean",description:D.localize(32,null)}),e.$2G=new N.$ej("debuggersAvailable",!1,{type:"boolean",description:D.localize(33,null)}),e.$3G=new N.$ej("debugExtensionAvailable",!0,{type:"boolean",description:D.localize(34,null)}),e.$4G=new N.$ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:D.localize(35,null)}),e.$5G=new N.$ej("debugSetVariableSupported",!1,{type:"boolean",description:D.localize(36,null)}),e.$6G=new N.$ej("debugSetExpressionSupported",!1,{type:"boolean",description:D.localize(37,null)}),e.$7G=new N.$ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:D.localize(38,null)}),e.$8G=new N.$ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:D.localize(39,null)}),e.$9G=new N.$ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:D.localize(40,null)}),e.$0G=new N.$ej("terminateDebuggeeSupported",!1,{type:"boolean",description:D.localize(41,null)}),e.$$G=new N.$ej("suspendDebuggeeSupported",!1,{type:"boolean",description:D.localize(42,null)}),e.$_G=new N.$ej("variableEvaluateNamePresent",!1,{type:"boolean",description:D.localize(43,null)}),e.$aH=new N.$ej("variableIsReadonly",!1,{type:"boolean",description:D.localize(44,null)}),e.$bH=new N.$ej("exceptionWidgetVisible",!1,{type:"boolean",description:D.localize(45,null)}),e.$cH=new N.$ej("multiSessionRepl",!1,{type:"boolean",description:D.localize(46,null)}),e.$dH=new N.$ej("multiSessionDebug",!1,{type:"boolean",description:D.localize(47,null)}),e.$eH=new N.$ej("disassembleRequestSupported",!1,{type:"boolean",description:D.localize(48,null)}),e.$fH=new N.$ej("disassemblyViewFocus",!1,{type:"boolean",description:D.localize(49,null)}),e.$gH=new N.$ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:D.localize(50,null)}),e.$hH=new N.$ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:D.localize(51,null)});const I=m=>D.localize(52,null,m);e.$iH=I,e.$jH="editor.contrib.debug",e.$kH="editor.contrib.breakpoint",e.$lH="debug",e.$mH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:D.localize(53,null)};var L;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(L||(e.State=L={}));function b(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$nH=b;var $;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})($||(e.MemoryRangeType=$={})),e.$oH="vscode-debug-memory";var y;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(y||(e.DebugConfigurationProviderTriggerKind=y={}));var A;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(A||(e.DebuggerString=A={})),e.$pH=(0,g.$Zh)("debugService");var C;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(C||(e.BreakpointWidgetContext=C={}))}),define(Ee[281],Se([1,0,13,2,16,24,17,29,21,19]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const A=/{([^}]+)}/g;function C(R,w,p){return R.replace(A,function(E,P){return w&&P.length>0&&P[0]!=="_"?E:p&&p.hasOwnProperty(P)?p[P]:E})}e.$jF=C;function m(R){const w={};for(const p of Object.keys(R))p.startsWith("!")||(w[p]=R[p]);return w}e.$kF=m;function v(R){return R.configuration.request==="attach"&&!S(R)&&(!R.parentSession||v(R.parentSession))}e.$lF=v;function S(R){let w=R.configuration.type;if(w)return w==="vslsShare"&&(w=R.configuration.adapterProxy.configuration.type),(0,D.$6e)(w,"extensionhost")||(0,D.$6e)(w,"pwa-extensionhost")?R:R.parentSession?S(R.parentSession):void 0}e.$mF=S;function f(R){return R.type&&(R.label||R.program||R.runtime)}e.$nF=f;function d(R,w,p){let E,P=0;const z=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=z.exec(R);){const F=j.index+1,O=F+j[0].length;if(F<=w&&O>=p){E=j[0],P=F;break}}if(E){const F=/\w+/g;let O=null;for(;(O=F.exec(E))&&!(O.index+1+P+O[0].length>=p););O&&(E=E.substring(0,F.lastIndex))}return E?{start:P,end:P+E.length-1}:{start:0,end:0}}e.$oF=d;async function s(R,w,p,E){if(R.evaluatableExpressionProvider.has(w)){const P=R.evaluatableExpressionProvider.ordered(w),z=(0,y.$Gb)(await Promise.all(P.map(async j=>{try{return await j.provideEvaluatableExpression(w,p,E??$.CancellationToken.None)}catch{return}})));if(z.length>0){let j=z[0].expression;const F=z[0].range;return j||(j=w.getLineContent(p.lineNumber).substring(F.startColumn-1,F.endColumn-1)),{range:F,matchingExpression:j}}}else{const P=w.getLineContent(p.lineNumber),{start:z,end:j}=d(P,p.column,p.column),F=P.substring(z-1,j);return{matchingExpression:F,range:new b.$Ds(p.lineNumber,z,p.lineNumber,z+F.length)}}return null}e.$pF=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(R){return!!(R&&R.match(i))}e.$qF=n;function o(R){if(typeof R.path=="string"&&!(typeof R.sourceReference=="number"&&R.sourceReference>0)){if(n(R.path))return N.URI.parse(R.path);if((0,g.$hc)(R.path))return N.URI.file(R.path)}return R.path}function a(R){if(typeof R.path=="object"){const w=N.URI.revive(R.path);if(w)return w.scheme===L.Schemas.file?w.fsPath:w.toString()}return R.path}function t(R,w){const p=w?o:a,E=(0,I.$en)(R);return h(E,(P,z)=>{P&&z&&(z.path=p(z))}),E}e.$rF=t;function r(R,w){const p=w?o:a,E=(0,I.$en)(R);return h(E,(P,z)=>{!P&&z&&(z.path=p(z))}),E}e.$sF=r;function h(R,w){switch(R.type){case"event":{const p=R;switch(p.event){case"output":w(!1,p.body.source);break;case"loadedSource":w(!1,p.body.source);break;case"breakpoint":w(!1,p.body.breakpoint.source);break;default:break}break}case"request":{const p=R;switch(p.command){case"setBreakpoints":w(!0,p.arguments.source);break;case"breakpointLocations":w(!0,p.arguments.source);break;case"source":w(!0,p.arguments.source);break;case"gotoTargets":w(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(E=>w(!1,E));break;default:break}break}case"response":{const p=R;if(p.success&&p.body)switch(p.command){case"stackTrace":p.body.stackFrames.forEach(E=>w(!1,E.source));break;case"loadedSources":p.body.sources.forEach(E=>w(!1,E));break;case"scopes":p.body.scopes.forEach(E=>w(!1,E.source));break;case"setFunctionBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"setBreakpoints":p.body.breakpoints.forEach(E=>w(!1,E.source));break;case"disassemble":p.body?.instructions.forEach(P=>w(!1,P.location));break;default:break}break}}}function u(R){return R.filter(w=>!w.presentation?.hidden).sort((w,p)=>w.presentation?p.presentation?w.presentation.group?p.presentation.group?w.presentation.group!==p.presentation.group?w.presentation.group.localeCompare(p.presentation.group):c(w.presentation.order,p.presentation.order):-1:p.presentation.group?1:c(w.presentation.order,p.presentation.order):-1:p.presentation?1:0)}e.$tF=u;function c(R,w){return typeof R!="number"?typeof w!="number"?0:1:typeof w!="number"?-1:R-w}async function l(R,w){const p=R.getValue("debug.saveBeforeStart",{overrideIdentifier:w.activeTextEditorLanguageId});if(p!=="none"&&(await w.saveAll(),p==="allEditorsInActiveGroup")){const E=w.activeEditorPane;E&&E.input.resource?.scheme===L.Schemas.untitled&&await w.save({editor:E.input,groupId:E.group.id})}await R.reloadConfiguration()}e.$uF=l;const k=(R,w)=>!R||!w?R===w:R.name===w.name&&R.path===w.path&&R.sourceReference===w.sourceReference;e.$vF=k}),define(Ee[282],Se([1,0,51,62,24,16,11,13,31,228,140]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=e.$Ogc=e.$Ngc=e.$Mgc=e.$Lgc=void 0;class C extends A.$Pfb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(s,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,s.on("data",n=>this.w(n))}sendMessage(s){if(this.p){const i=JSON.stringify(s);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${C.a}${i}`,"utf8")}}w(s){for(this.r=Buffer.concat([this.r,s]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(n){this.m.fire(new Error((n.message||n)+`
`+i))}continue}}else{const i=this.r.indexOf(C.a);if(i!==-1){const o=this.r.toString("utf8",0,i).split(C.b);for(const a of o){const t=a.split(C.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+C.a.length);continue}}break}}}e.$Lgc=C;class m extends C{startSession(){return new Promise((s,i)=>{let n=!1;this.x=this.y(()=>{this.v(this.x,this.x),s(),n=!0}),this.x.on("close",()=>{n?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",o=>{n?this.m.fire(o):i(o)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Mgc=m;class v extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",s)}}e.$Ngc=v;class S extends m{constructor(s){super(),this.z=s}y(s){return N.createConnection(this.z.path,s)}}e.$Ogc=S;class f extends C{constructor(s,i){super(),this.y=s,this.z=i}async startSession(){const s=this.y.command,i=this.y.args,n=this.y.options||{};try{if(s)if(I.$hc(s)){if(!await $.Promises.exists(s))throw new Error(y.localize(0,null,s))}else s.indexOf("/")<0&&s.indexOf("\\")<0;else throw new Error(y.localize(1,null,this.z));let o=process.env;if(n.env&&Object.keys(n.env).length>0&&(o=g.$hn(g.$en(process.env),n.env)),s==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:o,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};n.cwd&&(t.cwd=n.cwd);const r=D.fork(i[0],i.slice(1),t);if(!r.pid)throw new Error(y.localize(2,null,i[0]));this.x=r}else throw new Error(y.localize(3,null));else{const a={env:o};n.cwd&&(a.cwd=n.cwd),this.x=D.spawn(s,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(o){this.m.fire(o)}}async stopSession(){return this.x?(await this.u(),L.$i?new Promise((s,i)=>{const n=D.exec(`taskkill /F /T /PID ${this.x.pid}`,function(o,a,t){if(o)return i(o)});n.on("exit",s),n.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(s,i){if(!s)return;const n=Object.create(null);s.runtime&&(s.runtime.indexOf("./")===0?n.runtime=I.$ic(i,s.runtime):n.runtime=s.runtime),s.runtimeArgs&&(n.runtimeArgs=s.runtimeArgs),s.program&&(I.$hc(s.program)?n.program=s.program:n.program=I.$ic(i,s.program)),s.args&&(n.args=s.args);const o=s;return o.win&&(n.win=f.A(o.win,i)),o.winx86&&(n.winx86=f.A(o.winx86,i)),o.windows&&(n.windows=f.A(o.windows,i)),o.osx&&(n.osx=f.A(o.osx,i)),o.linux&&(n.linux=f.A(o.linux,i)),n}static platformAdapterExecutable(s,i){let n=Object.create(null);i=i.toLowerCase();for(const u of s)if(u.contributes){const c=u.contributes.debuggers;c&&c.length>0&&c.filter(l=>typeof l.type=="string"&&b.$6e(l.type,i)).forEach(l=>{const k=f.A(l,u.extensionLocation.fsPath);n=g.$hn(n,k,u.isBuiltin)})}let o;L.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?o=n.winx86||n.win||n.windows:L.$i?o=n.win||n.windows:L.$j?o=n.osx:L.$k&&(o=n.linux),o=o||n;const a=o.program||n.program,t=o.args||n.args,r=o.runtime||n.runtime,h=o.runtimeArgs||n.runtimeArgs;if(r)return{type:"executable",command:r,args:(h||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Pgc=f}),define(Ee[283],Se([1,0,51,33,11]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=e.$Qgc=void 0;function I(y,A){return new Promise((C,m)=>{let v="";const S=D.spawn(y,A);S.pid&&S.stdout.on("data",f=>{v+=f.toString()}),S.on("error",f=>{m(f)}),S.on("close",f=>{C(v)})})}async function L(y){if(y)if(g.$i){const A=await new Promise((C,m)=>{$e(["@vscode/windows-process-tree"],C,m)});return new Promise(C=>{A.getProcessTree(y,m=>{C(!!m&&m.children.length>0)})})}else return I("/usr/bin/pgrep",["-lP",String(y)]).then(A=>{const C=A.trim();return!(C.length===0||C.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Qgc=L;var b;(function(y){y[y.cmd=0]="cmd",y[y.powershell=1]="powershell",y[y.bash=2]="bash"})(b||(b={}));function $(y,A,C,m,v){y=y.trim().toLowerCase();let S;y.indexOf("powershell")>=0||y.indexOf("pwsh")>=0?S=1:y.indexOf("cmd.exe")>=0?S=0:y.indexOf("bash")>=0?S=2:g.$i?S=0:S=2;let f,d=" ";switch(S){case 1:if(f=s=>(s=s.replace(/\'/g,"''"),s.length>0&&s.charAt(s.length-1)==="\\"?`'${s}\\'`:`'${s}'`),m){const s=(0,N.$7f)(m);s&&(d+=`${s}:; `),d+=`cd ${f(m)}; `}if(v)for(const s in v){const i=v[s];i===null?d+=`Remove-Item env:${s}; `:d+=`\${env:${s}}='${i}'; `}if(A.length>0){const s=A.shift(),i=C?s:f(s);d+=i[0]==="'"?`& ${i} `:`${i} `;for(const n of A)d+=n==="<"||n===">"||C?n:f(n),d+=" "}break;case 0:if(f=s=>(s=s.replace(/\"/g,'""'),s=s.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>s.includes(i))||s.length===0?`"${s}"`:s),m){const s=(0,N.$7f)(m);s&&(d+=`${s}: && `),d+=`cd ${f(m)} && `}if(v){d+='cmd /C "';for(const s in v){let i=v[s];i===null?d+=`set "${s}=" && `:(i=i.replace(/[&^|<>]/g,n=>`^${n}`),d+=`set "${s}=${i}" && `)}}for(const s of A)d+=s==="<"||s===">"||C?s:f(s),d+=" ";v&&(d+='"');break;case 2:{f=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const s=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(m&&(d+=`cd ${f(m)} ; `),v){d+="/usr/bin/env";for(const i in v){const n=v[i];n===null?d+=` -u ${s(i)}`:d+=` ${s(`${i}=${n}`)}`}d+=" "}for(const i of A)d+=i==="<"||i===">"||C?i:f(i),d+=" ";break}}return d}e.$Rgc=$}),define(Ee[111],Se([1,0,22,34,52,100,17,16,11,46]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KI=e.$JI=e.$II=e.$HI=e.CellStatusbarAlignment=e.$GI=e.$FI=e.$EI=e.NotebookEditorPriority=e.$DI=e.$CI=e.$BI=e.$AI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$zI=e.$yI=e.$xI=e.$wI=e.CellKind=e.$vI=e.$uI=e.$tI=void 0,e.$tI="workbench.editor.notebook",e.$uI="workbench.editor.notebookTextDiffEditor",e.$vI="workbench.editor.interactive";var A;(function(M){M[M.Markup=1]="Markup",M[M.Code=2]="Code"})(A||(e.CellKind=A={})),e.$wI=["application/json","application/javascript","text/html","image/svg+xml",I.$Zr.latex,I.$Zr.markdown,"image/png","image/jpeg",I.$Zr.text],e.$xI=[I.$Zr.latex,I.$Zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",I.$Zr.text],e.$yI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$zI="_notAvailable";var C;(function(M){M[M.Running=1]="Running",M[M.Idle=2]="Idle"})(C||(e.NotebookRunState=C={}));var m;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(m||(e.NotebookCellExecutionState=m={}));var v;(function(M){M[M.Unconfirmed=1]="Unconfirmed",M[M.Pending=2]="Pending",M[M.Executing=3]="Executing"})(v||(e.NotebookExecutionState=v={}));var S;(function(M){M[M.WithHardKernelDependency=0]="WithHardKernelDependency",M[M.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",M[M.Pure=2]="Pure",M[M.Never=3]="Never"})(S||(e.NotebookRendererMatch=S={}));var f;(function(M){M.Always="always",M.Never="never",M.Optional="optional"})(f||(e.RendererMessagingSpec=f={}));var d;(function(M){M[M.ModelChange=1]="ModelChange",M[M.Move=2]="Move",M[M.ChangeCellLanguage=5]="ChangeCellLanguage",M[M.Initialize=6]="Initialize",M[M.ChangeCellMetadata=7]="ChangeCellMetadata",M[M.Output=8]="Output",M[M.OutputItem=9]="OutputItem",M[M.ChangeCellContent=10]="ChangeCellContent",M[M.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",M[M.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",M[M.ChangeCellMime=13]="ChangeCellMime",M[M.Unknown=100]="Unknown"})(d||(e.NotebookCellsChangeType=d={}));var s;(function(M){M[M.Handle=0]="Handle",M[M.Index=1]="Index"})(s||(e.SelectionStateType=s={}));var i;(function(M){M[M.Replace=1]="Replace",M[M.Output=2]="Output",M[M.Metadata=3]="Metadata",M[M.CellLanguage=4]="CellLanguage",M[M.DocumentMetadata=5]="DocumentMetadata",M[M.Move=6]="Move",M[M.OutputItems=7]="OutputItems",M[M.PartialMetadata=8]="PartialMetadata",M[M.PartialInternalMetadata=9]="PartialInternalMetadata"})(i||(e.CellEditType=i={}));var n;(function(M){M.scheme=L.Schemas.vscodeNotebookCell;const W=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${W.join("")}]+`),ue=7;function Z(ge,V){const U=V.toString(ue),ye=`${U.length<W.length?W[U.length-1]:"z"}${U}s${(0,D.$ze)(D.$fe.fromString(ge.scheme),!0,!0)}`;return ge.with({scheme:M.scheme,fragment:ye})}M.generate=Z;function Q(ge){if(ge.scheme!==M.scheme)return;const V=ge.fragment.indexOf("s");if(V<0)return;const U=parseInt(ge.fragment.substring(0,V).replace(Y,""),ue),ne=(0,D.$ye)(ge.fragment.substring(V+1)).toString();if(!isNaN(U))return{handle:U,notebook:ge.with({scheme:ne,fragment:null})}}M.parse=Q;function x(ge,V){return ge.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${V??""},${ge.scheme!==L.Schemas.file?ge.scheme:""}`})}M.generateCellOutputUri=x;function oe(ge){if(ge.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const V=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ge.fragment);if(!V)return;const U=V[1]&&V[1]!==""?V[1]:void 0,ne=V[2];return{outputId:U,notebook:ge.with({scheme:ne||L.Schemas.file,fragment:null})}}M.parseCellOutputUri=oe;function X(ge,V,U){return M.generate(ge,V).with({scheme:U})}M.generateCellPropertyUri=X;function ve(ge,V){if(ge.scheme===V)return M.parse(ge.with({scheme:M.scheme}))}M.parseCellPropertyUri=ve})(n||(e.CellUri=n={}));const o=M=>$.$i?M.replace(/\//g,"\\"):M;class a{constructor(W=[],Y=e.$wI){this.e=Y,this.d=[...new Set(W)].map(ue=>({pattern:ue,matches:N.$Gj(o(ue))}))}sort(W){const Y=new Map(g.Iterable.map(W,Z=>[Z,o(Z)]));let ue=[];for(const{matches:Z}of this.d)for(const[Q,x]of Y)if(Z(x)){ue.push(Q),Y.delete(Q);break}return Y.size&&(ue=ue.concat([...Y.keys()].sort((Z,Q)=>this.e.indexOf(Z)-this.e.indexOf(Q)))),ue}prioritize(W,Y){const ue=this.f(W);if(ue===-1){this.d.unshift({pattern:W,matches:N.$Gj(o(W))});return}const Z=new Set(Y.map(x=>this.f(x,ue)));Z.delete(-1);const Q=Array.from(Z).sort();this.d.splice(ue+1,0,...Q.map(x=>this.d[x]));for(let x=Q.length-1;x>=0;x--)this.d.splice(Q[x],1)}toArray(){return this.d.map(W=>W.pattern)}f(W,Y=this.d.length){const ue=o(W);for(let Z=0;Z<Y;Z++)if(this.d[Z].matches(ue))return Z;return-1}}e.$AI=a;function t(M,W,Y,ue=(Z,Q)=>Z===Q){const Z=[];function Q(X,ve,ge){if(ve===0&&ge.length===0)return;const V=Z[Z.length-1];V&&V.start+V.deleteCount===X?(V.deleteCount+=ve,V.toInsert.push(...ge)):Z.push({start:X,deleteCount:ve,toInsert:ge})}let x=0,oe=0;for(;;){if(x===M.length){Q(x,0,W.slice(oe));break}if(oe===W.length){Q(x,M.length-x,[]);break}const X=M[x],ve=W[oe];if(ue(X,ve)){x+=1,oe+=1;continue}Y(ve)?(Q(x,1,[]),x+=1):(Q(x,0,[ve]),oe+=1)}return Z}e.$BI=t,e.$CI=new y.$ej("notebookEditorCursorAtBoundary","none"),e.$DI=new y.$ej("notebookEditorCursorAtLineBoundary","none");var r;(function(M){M.default="default",M.option="option"})(r||(e.NotebookEditorPriority=r={}));function h(M){const W=M;return!!((typeof W.include=="string"||N.$Hj(W.include))&&(typeof W.exclude=="string"||N.$Hj(W.exclude)))}e.$EI=h;function u(M,W,Y){if(Array.isArray(M.viewType)&&M.viewType.indexOf(W)>=0||M.viewType===W)return!0;if(M.filenamePattern){const ue=h(M.filenamePattern)?M.filenamePattern.include:M.filenamePattern,Z=h(M.filenamePattern)?M.filenamePattern.exclude:void 0;if(N.$Fj(ue,(0,b.$mc)(Y.fsPath).toLowerCase()))return!(Z&&N.$Fj(Z,(0,b.$mc)(Y.fsPath).toLowerCase()))}return!1}e.$FI=u,e.$GI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var c;(function(M){M[M.Left=1]="Left",M[M.Right=2]="Right"})(c||(e.CellStatusbarAlignment=c={}));class l{static{this.d="notebook/"}static create(W){return`${l.d}${W}`}static parse(W){if(W.startsWith(l.d))return W.substring(l.d.length)}}e.$HI=l;function k(M){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(M)}e.$II=k;const R=new TextDecoder;function w(M){const W=[];let Y=!1;for(const x of M)(W.length===0||Y)&&(W.push(x),Y=!0);let ue=P(W);const Z=D.$fe.concat(W.map(x=>D.$fe.wrap(x))),Q=T(Z);return ue=ue||Q.byteLength!==Z.byteLength,{data:Q,didCompression:ue}}e.$JI=w,e.$KI=`${String.fromCharCode(27)}[A`;const p=e.$KI.split("").map(M=>M.charCodeAt(0)),E=10;function P(M){let W=!1;return M.forEach((Y,ue)=>{if(ue===0||Y.length<e.$KI.length)return;const Z=M[ue-1],Q=Y.subarray(0,e.$KI.length);if(Q[0]===p[0]&&Q[1]===p[1]&&Q[2]===p[2]){const x=Z.lastIndexOf(E);if(x===-1)return;W=!0,M[ue-1]=Z.subarray(0,x),M[ue]=Y.subarray(e.$KI.length)}}),W}function z(M){let W=M;do M=W,W=M.replace(/[^\n]\x08/gm,"");while(W.length<M.length);return M}function j(M){for(M=M.replace(/\r+\n/gm,`
`);M.search(/\r[^$]/g)>-1;){const W=M.match(/^(.*)\r+/m)[1];let Y=M.match(/\r+(.*)$/m)[1];Y=Y+W.slice(Y.length,W.length),M=M.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return M}const F="\b".charCodeAt(0),O="\r".charCodeAt(0);function T(M){return!M.buffer.includes(F)&&!M.buffer.includes(O)?M:D.$fe.fromString(j(z(R.decode(M.buffer))))}}),define(Ee[7],Se([1,0,19,8,80,28,100,13,18,2,30,26,32,64,111]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S){"use strict";var f,d,s,i,n,o,a,t,r,h,u,c,l,k,R,w,p;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$wM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.TestRunProfileKind=e.TestResultState=e.$cM=e.$bM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$aM=e.NotebookVariablesRequestKind=e.$_L=e.$$L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$0L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.ColorThemeKind=e.$4L=e.$3L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$2L=e.DebugConsoleMode=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$VL=e.$UL=e.FileChangeType=e.$TL=e.$SL=e.$RL=e.$QL=e.InlineCompletionTriggerKind=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.ConfigurationTarget=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$tL=e.ViewBadge=e.ProgressLocation=e.$sL=e.$rL=e.TaskScope=e.ShellQuoting=e.$qL=e.$pL=e.$oL=e.TaskPanelKind=e.TaskRevealKind=e.$nL=e.TerminalLocation=e.$mL=e.$lL=e.$kL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$jL=e.$iL=e.$hL=e.$gL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$fL=e.StatusBarAlignment=e.ViewColumn=e.$eL=e.$dL=e.$cL=e.$bL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$aL=e.$_K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.LanguageStatusSeverity=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.CodeActionTriggerKind=e.$ZK=e.$YK=e.SymbolTag=e.SymbolKind=e.$XK=e.$WK=e.DocumentHighlightKind=e.$VK=e.$UK=e.$TK=e.$SK=e.DiagnosticSeverity=e.DiagnosticTag=e.$RK=e.$QK=e.FileEditType=e.$PK=e.$OK=e.$NK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(H){return Object.assign(H,{apply:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const Ae=we.length===1?[]:we[1];return Reflect.construct(H,Ae,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const[Ae,...Ze]=we;return Reflect.construct(H,Ze,Ae.constructor)}}})}var P;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var z;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(z||(e.TerminalQuickFixType=z={}));let j=f=class{static from(...q){let we=q;return new f(function(){if(we){for(const Ae of we)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();we=void 0}})}#e;constructor(q){this.#e=q}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$GK=j,e.$GK=j=f=Ke([E],j);let F=d=class{static Min(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Ae=1;Ae<q.length;Ae++){const Ze=q[Ae];Ze.isBefore(we)&&(we=Ze)}return we}static Max(...q){if(q.length===0)throw new TypeError;let we=q[0];for(let Ae=1;Ae<q.length;Ae++){const Ze=q[Ae];Ze.isAfter(we)&&(we=Ze)}return we}static isPosition(q){if(!q)return!1;if(q instanceof d)return!0;const{line:we,character:Ae}=q;return typeof we=="number"&&typeof Ae=="number"}static of(q){if(q instanceof d)return q;if(this.isPosition(q))return new d(q.line,q.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(q,we){if(q<0)throw(0,N.$6)("line must be non-negative");if(we<0)throw(0,N.$6)("character must be non-negative");this.c=q,this.e=we}isBefore(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<q.e}isBeforeOrEqual(q){return this.c<q.c?!0:q.c<this.c?!1:this.e<=q.e}isAfter(q){return!this.isBeforeOrEqual(q)}isAfterOrEqual(q){return!this.isBefore(q)}isEqual(q){return this.c===q.c&&this.e===q.e}compareTo(q){return this.c<q.c?-1:this.c>q.line?1:this.e<q.e?-1:this.e>q.e?1:0}translate(q,we=0){if(q===null||we===null)throw(0,N.$6)();let Ae;return typeof q>"u"?Ae=0:typeof q=="number"?Ae=q:(Ae=typeof q.lineDelta=="number"?q.lineDelta:0,we=typeof q.characterDelta=="number"?q.characterDelta:0),Ae===0&&we===0?this:new d(this.line+Ae,this.character+we)}with(q,we=this.character){if(q===null||we===null)throw(0,N.$6)();let Ae;return typeof q>"u"?Ae=this.line:typeof q=="number"?Ae=q:(Ae=typeof q.line=="number"?q.line:this.line,we=typeof q.character=="number"?q.character:this.character),Ae===this.line&&we===this.character?this:new d(Ae,we)}toJSON(){return{line:this.line,character:this.character}}};e.$HK=F,e.$HK=F=d=Ke([E],F);let O=s=class{static isRange(q){return q instanceof s?!0:q?F.isPosition(q.start)&&F.isPosition(q.end):!1}static of(q){if(q instanceof s)return q;if(this.isRange(q))return new s(q.start,q.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(q,we,Ae,Ze){let nt,ct;if(typeof q=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ze=="number"?(nt=new F(q,we),ct=new F(Ae,Ze)):F.isPosition(q)&&F.isPosition(we)&&(nt=F.of(q),ct=F.of(we)),!nt||!ct)throw new Error("Invalid arguments");nt.isBefore(ct)?(this.c=nt,this.e=ct):(this.c=ct,this.e=nt)}contains(q){return s.isRange(q)?this.contains(q.start)&&this.contains(q.end):F.isPosition(q)?!(F.of(q).isBefore(this.c)||this.e.isBefore(q)):!1}isEqual(q){return this.c.isEqual(q.c)&&this.e.isEqual(q.e)}intersection(q){const we=F.Max(q.start,this.c),Ae=F.Min(q.end,this.e);if(!we.isAfter(Ae))return new s(we,Ae)}union(q){if(this.contains(q))return this;if(q.contains(this))return q;const we=F.Min(q.start,this.c),Ae=F.Max(q.end,this.end);return new s(we,Ae)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(q,we=this.end){if(q===null||we===null)throw(0,N.$6)();let Ae;return q?F.isPosition(q)?Ae=q:(Ae=q.start||this.start,we=q.end||this.end):Ae=this.start,Ae.isEqual(this.c)&&we.isEqual(this.end)?this:new s(Ae,we)}toJSON(){return[this.start,this.end]}};e.$IK=O,e.$IK=O=s=Ke([E],O);let T=i=class extends O{static isSelection(q){return q instanceof i?!0:q?O.isRange(q)&&F.isPosition(q.anchor)&&F.isPosition(q.active)&&typeof q.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(q,we,Ae,Ze){let nt,ct;if(typeof q=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ze=="number"?(nt=new F(q,we),ct=new F(Ae,Ze)):F.isPosition(q)&&F.isPosition(we)&&(nt=F.of(q),ct=F.of(we)),!nt||!ct)throw new Error("Invalid arguments");super(nt,ct),this.f=nt,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$JK=T,e.$JK=T=i=Ke([E],T);const M=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$6)("connectionToken")};class W{static isResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.host=="string"&&typeof q.port=="number"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we,Ae){if(typeof q!="string"||q.length===0)throw(0,N.$6)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,N.$6)("port");typeof Ae<"u"&&M(Ae),this.host=q,this.port=Math.round(we),this.connectionToken=Ae}}e.$KK=W;class Y{static isManagedResolvedAuthority(q){return q&&typeof q=="object"&&typeof q.makeConnection=="function"&&(q.connectionToken===void 0||typeof q.connectionToken=="string")}constructor(q,we){this.makeConnection=q,this.connectionToken=we,typeof we<"u"&&M(we)}}e.$LK=Y;class ue extends Error{static NotAvailable(q,we){return new ue(q,v.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(q){return new ue(q,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(q,we=v.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(q),this._message=q,this._code=we,this._detail=Ae,Object.setPrototypeOf(this,ue.prototype)}}e.$MK=ue;var Z;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(Z||(e.EndOfLine=Z={}));var Q;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let x=n=class{static isTextEdit(q){return q instanceof n?!0:q?O.isRange(q)&&typeof q.newText=="string":!1}static replace(q,we){return new n(q,we)}static insert(q,we){return n.replace(new O(q,q),we)}static delete(q){return n.replace(q,"")}static setEndOfLine(q){const we=new n(new O(new F(0,0),new F(0,0)),"");return we.newEol=q,we}get range(){return this.c}set range(q){if(q&&!O.isRange(q))throw(0,N.$6)("range");this.c=q}get newText(){return this.e||""}set newText(q){if(q&&typeof q!="string")throw(0,N.$6)("newText");this.e=q}get newEol(){return this.f}set newEol(q){if(q&&typeof q!="number")throw(0,N.$6)("newEol");this.f=q}constructor(q,we){this.c=q,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$NK=x,e.$NK=x=n=Ke([E],x);let oe=o=class{static isNotebookCellEdit(q){return q instanceof o?!0:q?_t.isNotebookRange(q)&&Array.isArray(q.newCells):!1}static replaceCells(q,we){return new o(q,we)}static insertCells(q,we){return new o(new _t(q,q),we)}static deleteCells(q){return new o(q,[])}static updateCellMetadata(q,we){const Ae=new o(new _t(q,q),[]);return Ae.newCellMetadata=we,Ae}static updateNotebookMetadata(q){const we=new o(new _t(0,0),[]);return we.newNotebookMetadata=q,we}constructor(q,we){this.range=q,this.newCells=we}};e.$OK=oe,e.$OK=oe=o=Ke([E],oe);class X{static isSnippetTextEdit(q){return q instanceof X?!0:q?O.isRange(q.range)&&V.isSnippetString(q.snippet):!1}static replace(q,we){return new X(q,we)}static insert(q,we){return X.replace(new O(q,q),we)}constructor(q,we){this.range=q,this.snippet=we}}e.$PK=X;var ve;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})(ve||(e.FileEditType=ve={}));let ge=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(q,we,Ae,Ze){this.c.push({_type:1,from:q,to:we,options:Ae,metadata:Ze})}createFile(q,we,Ae){this.c.push({_type:1,from:void 0,to:q,options:we,metadata:Ae})}deleteFile(q,we,Ae){this.c.push({_type:1,from:q,to:void 0,options:we,metadata:Ae})}e(q,we,Ae){this.c.push({_type:3,metadata:Ae,uri:q,edit:{editType:5,metadata:we},notebookMetadata:we})}f(q,we,Ae,Ze){const nt=we.start,ct=we.end;(nt!==ct||Ae.length>0)&&this.c.push({_type:5,uri:q,index:nt,count:ct-nt,cells:Ae,metadata:Ze})}g(q,we,Ae,Ze){this.c.push({_type:3,metadata:Ze,uri:q,edit:{editType:3,index:we,metadata:Ae}})}replace(q,we,Ae,Ze){this.c.push({_type:2,uri:q,edit:new x(we,Ae),metadata:Ze})}insert(q,we,Ae,Ze){this.replace(q,new O(we,we),Ae,Ze)}delete(q,we,Ae){this.replace(q,we,"",Ae)}has(q){return this.c.some(we=>we._type===2&&we.uri.toString()===q.toString())}set(q,we){if(we)for(const Ae of we){if(!Ae)continue;let Ze,nt;Array.isArray(Ae)?(Ze=Ae[0],nt=Ae[1]):Ze=Ae,oe.isNotebookCellEdit(Ze)?Ze.newCellMetadata?this.g(q,Ze.range.start,Ze.newCellMetadata,nt):Ze.newNotebookMetadata?this.e(q,Ze.newNotebookMetadata,nt):this.f(q,Ze.range,Ze.newCells,nt):X.isSnippetTextEdit(Ze)?this.c.push({_type:6,uri:q,range:Ze.range,edit:Ze.snippet,metadata:nt}):this.c.push({_type:2,uri:q,edit:Ze,metadata:nt})}else{for(let Ae=0;Ae<this.c.length;Ae++){const Ze=this.c[Ae];switch(Ze._type){case 2:case 6:case 3:case 5:Ze.uri.toString()===q.toString()&&(this.c[Ae]=void 0);break}}(0,D.$Hb)(this.c)}}get(q){const we=[];for(const Ae of this.c)Ae._type===2&&Ae.uri.toString()===q.toString()&&we.push(Ae.edit);return we}entries(){const q=new I.$zc;for(const we of this.c)if(we._type===2){let Ae=q.get(we.uri);Ae||(Ae=[we.uri,[]],q.set(we.uri,Ae)),Ae[1].push(we.edit)}return[...q.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$QK=ge,e.$QK=ge=Ke([E],ge);let V=a=class{static isSnippetString(q){return q instanceof a?!0:q?typeof q.value=="string":!1}static c(q){return q.replace(/\$|}|\\/g,"\\$&")}constructor(q){this.e=1,this.value=q||""}appendText(q){return this.value+=a.c(q),this}appendTabstop(q=this.e++){return this.value+="$",this.value+=q,this}appendPlaceholder(q,we=this.e++){if(typeof q=="function"){const Ae=new a;Ae.e=this.e,q(Ae),this.e=Ae.e,q=Ae.value}else q=a.c(q);return this.value+="${",this.value+=we,this.value+=":",this.value+=q,this.value+="}",this}appendChoice(q,we=this.e++){const Ae=q.map(Ze=>Ze.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(q,we){if(typeof we=="function"){const Ae=new a;Ae.e=this.e,we(Ae),this.e=Ae.e,we=Ae.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=q,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$RK=V,e.$RK=V=a=Ke([E],V);var U;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var ne;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ne||(e.DiagnosticSeverity=ne={}));let ye=t=class{static isLocation(q){return q instanceof t?!0:q?O.isRange(q.range)&&y.URI.isUri(q.uri):!1}constructor(q,we){if(this.uri=q,we)if(O.isRange(we))this.range=O.of(we);else if(F.isPosition(we))this.range=new O(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$SK=ye,e.$SK=ye=t=Ke([E],ye);let fe=class{static is(q){return q?typeof q.message=="string"&&q.location&&O.isRange(q.location.range)&&y.URI.isUri(q.location.uri):!1}constructor(q,we){this.location=q,this.message=we}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.location.range.isEqual(we.location.range)&&q.location.uri.toString()===we.location.uri.toString()}};e.$TK=fe,e.$TK=fe=Ke([E],fe);let me=class{constructor(q,we,Ae=ne.Error){if(!O.isRange(q))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=q,this.message=we,this.severity=Ae}toJSON(){return{severity:ne[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(q,we){return q===we?!0:!q||!we?!1:q.message===we.message&&q.severity===we.severity&&q.code===we.code&&q.severity===we.severity&&q.source===we.source&&q.range.isEqual(we.range)&&(0,D.$tb)(q.tags,we.tags)&&(0,D.$tb)(q.relatedInformation,we.relatedInformation,fe.isEqual)}};e.$UK=me,e.$UK=me=Ke([E],me);let ee=class{constructor(q,we){if(!q)throw new Error("Illegal argument, contents must be defined");Array.isArray(q)?this.contents=q:this.contents=[q],this.range=we}};e.$VK=ee,e.$VK=ee=Ke([E],ee);var ie;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(q,we=ie.Text){this.range=q,this.kind=we}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$WK=G,e.$WK=G=Ke([E],G);let te=class{constructor(q,we){this.uri=q,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(q=>q.toJSON())}}};e.$XK=te,e.$XK=te=Ke([E],te);var J;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(J||(e.SymbolKind=J={}));var ce;(function(H){H[H.Deprecated=1]="Deprecated"})(ce||(e.SymbolTag=ce={}));let be=r=class{static validate(q){if(!q.name)throw new Error("name must not be falsy")}constructor(q,we,Ae,Ze,nt){this.name=q,this.kind=we,this.containerName=nt,typeof Ae=="string"&&(this.containerName=Ae),Ze instanceof ye?this.location=Ze:Ae instanceof O&&(this.location=new ye(Ze,Ae)),r.validate(this)}toJSON(){return{name:this.name,kind:J[this.kind],location:this.location,containerName:this.containerName}}};e.$YK=be,e.$YK=be=r=Ke([E],be);let Ie=h=class{static validate(q){if(!q.name)throw new Error("name must not be falsy");if(!q.range.contains(q.selectionRange))throw new Error("selectionRange must be contained in fullRange");q.children?.forEach(h.validate)}constructor(q,we,Ae,Ze,nt){this.name=q,this.detail=we,this.kind=Ae,this.range=Ze,this.selectionRange=nt,this.children=[],h.validate(this)}};e.$ZK=Ie,e.$ZK=Ie=h=Ke([E],Ie);var Me;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Me||(e.CodeActionTriggerKind=Me={}));let B=class{constructor(q,we){this.title=q,this.kind=we}};e.$1K=B,e.$1K=B=Ke([E],B);let _=class{static{u=this}static{this.c="."}constructor(q){this.value=q}append(q){return new u(this.value?this.value+u.c+q:q)}intersects(q){return this.contains(q)||q.contains(this)}contains(q){return this.value===q.value||q.value.startsWith(this.value+u.c)}};e.$2K=_,e.$2K=_=u=Ke([E],_),_.Empty=new _(""),_.QuickFix=_.Empty.append("quickfix"),_.Refactor=_.Empty.append("refactor"),_.RefactorExtract=_.Refactor.append("extract"),_.RefactorInline=_.Refactor.append("inline"),_.RefactorMove=_.Refactor.append("move"),_.RefactorRewrite=_.Refactor.append("rewrite"),_.Source=_.Empty.append("source"),_.SourceOrganizeImports=_.Source.append("organizeImports"),_.SourceFixAll=_.Source.append("fixAll"),_.Notebook=_.Empty.append("notebook");let se=class{constructor(q,we){if(this.range=q,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$3K=se,e.$3K=se=Ke([E],se);class K{constructor(q,we,Ae,Ze,nt,ct){this.kind=q,this.name=we,this.detail=Ae,this.uri=Ze,this.range=nt,this.selectionRange=ct}}e.$4K=K;class ae{constructor(q,we){this.fromRanges=we,this.from=q}}e.$5K=ae;class de{constructor(q,we){this.fromRanges=we,this.to=q}}e.$6K=de;var Re;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Re||(e.LanguageStatusSeverity=Re={}));let Be=class{constructor(q,we){this.range=q,this.command=we}get isResolved(){return!!this.command}};e.$7K=Be,e.$7K=Be=Ke([E],Be);let Xe=c=class{#e;static isMarkdownString(q){return q instanceof c?!0:q&&q.appendCodeblock&&q.appendMarkdown&&q.appendText&&q.value!==void 0}constructor(q,we=!1){this.#e=new g.$ak(q,{supportThemeIcons:we})}get value(){return this.#e.value}set value(q){this.#e.value=q}get isTrusted(){return this.#e.isTrusted}set isTrusted(q){this.#e.isTrusted=q}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(q){this.#e.supportThemeIcons=q}get supportHtml(){return this.#e.supportHtml}set supportHtml(q){this.#e.supportHtml=q}get baseUri(){return this.#e.baseUri}set baseUri(q){this.#e.baseUri=q}appendText(q){return this.#e.appendText(q),this}appendMarkdown(q){return this.#e.appendMarkdown(q),this}appendCodeblock(q,we){return this.#e.appendCodeblock(we??"",q),this}};e.$8K=Xe,e.$8K=Xe=c=Ke([E],Xe);let Ye=class{constructor(q,we){this.label=q,this.documentation=we}};e.$9K=Ye,e.$9K=Ye=Ke([E],Ye);let it=class{constructor(q,we){this.label=q,this.documentation=we,this.parameters=[]}};e.$0K=it,e.$0K=it=Ke([E],it);let st=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$$K=st,e.$$K=st=Ke([E],st);var Pe;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(Pe||(e.SignatureHelpTriggerKind=Pe={}));var Te;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(Te||(e.InlayHintKind=Te={}));let qe=class{constructor(q){this.value=q}};e.$_K=qe,e.$_K=qe=Ke([E],qe);let Le=class{constructor(q,we,Ae){this.position=q,this.label=we,this.kind=Ae}};e.$aL=Le,e.$aL=Le=Ke([E],Le);var xe;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe||(e.CompletionTriggerKind=xe={}));var he;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(he||(e.CompletionItemKind=he={}));var le;(function(H){H[H.Deprecated=1]="Deprecated"})(le||(e.CompletionItemTag=le={}));let Ce=class{constructor(q,we){this.label=q,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$bL=Ce,e.$bL=Ce=Ke([E],Ce);let Ve=class{constructor(q=[],we=!1){this.items=q,this.isIncomplete=we}};e.$cL=Ve,e.$cL=Ve=Ke([E],Ve);let Ge=class{constructor(q,we,Ae){this.insertText=q,this.range=we,this.command=Ae}};e.$dL=Ge,e.$dL=Ge=Ke([E],Ge);let _e=class{constructor(q){this.commands=void 0,this.suppressSuggestions=void 0,this.items=q}};e.$eL=_e,e.$eL=_e=Ke([E],_e);var ot;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var ut;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ut||(e.StatusBarAlignment=ut={}));function je(H,q){return`${C.$dm.toKey(H)}.${q}`}e.$fL=je;var kt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(kt||(e.TextEditorLineNumbersStyle=kt={}));var Ht;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Ht||(e.TextDocumentSaveReason=Ht={}));var jt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(jt||(e.TextEditorRevealType=jt={}));var yt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var Wt;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Wt||(e.TextDocumentChangeReason=Wt={}));var zt;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(zt||(e.DecorationRangeBehavior=zt={})),function(H){function q(we){switch(we){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=q}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Kt;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Kt||(e.SyntaxTokenType=Kt={})),function(H){function q(we){switch(we){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=q}(Kt||(e.SyntaxTokenType=Kt={}));let Gt=class{constructor(q,we){if(we&&!y.URI.isUri(we))throw(0,N.$6)("target");if(!O.isRange(q)||q.isEmpty)throw(0,N.$6)("range");this.range=q,this.target=we}};e.$gL=Gt,e.$gL=Gt=Ke([E],Gt);let Rt=class{constructor(q,we,Ae,Ze){this.red=q,this.green=we,this.blue=Ae,this.alpha=Ze}};e.$hL=Rt,e.$hL=Rt=Ke([E],Rt);let Ct=class{constructor(q,we){if(we&&!(we instanceof Rt))throw(0,N.$6)("color");if(!O.isRange(q)||q.isEmpty)throw(0,N.$6)("range");this.range=q,this.color=we}};e.$iL=Ct,e.$iL=Ct=Ke([E],Ct);let tt=class{constructor(q){if(!q||typeof q!="string")throw(0,N.$6)("label");this.label=q}};e.$jL=tt,e.$jL=tt=Ke([E],tt);var Jt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var qt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(qt||(e.SourceControlInputBoxValidationType=qt={}));var lt;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(lt||(e.TerminalExitReason=lt={}));class mt{constructor(q,we,Ae){if(this.startIndex=q,this.length=we,this.tooltip=Ae,typeof q!="number"||q<0)throw(0,N.$6)("startIndex");if(typeof we!="number"||we<1)throw(0,N.$6)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,N.$6)("tooltip")}}e.$kL=mt;class Zt{constructor(q){this.uri=q}}e.$lL=Zt;class It{constructor(q){this.terminalCommand=q}}e.$mL=It;var St;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(St||(e.TerminalLocation=St={}));class ft{constructor(q){if(this.options=q,typeof q!="object")throw(0,N.$6)("options")}}e.$nL=ft;var At;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var Ot;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let Et=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(q){switch(q){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(q,we){if(this.label=we,typeof q!="string"||typeof we!="string")throw(0,N.$6)("name");this.c=q}get id(){return this.c}};e.$oL=Et,e.$oL=Et=l=Ke([E],Et);function Qe(H){let q="";for(let we=0;we<H.length;we++)q+=H[we].replace(/,/g,",,")+",";return q}let Lt=class{constructor(q,we,Ae){if(typeof q!="string")throw(0,N.$6)("process");this.e=[],this.c=q,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Ae):this.f=we)}get process(){return this.c}set process(q){if(typeof q!="string")throw(0,N.$6)("process");this.c=q}get args(){return this.e}set args(q){Array.isArray(q)||(q=[]),this.e=q}get options(){return this.f}set options(q){this.f=q}computeId(){const q=[];if(q.push("process"),this.c!==void 0&&q.push(this.c),this.e&&this.e.length>0)for(const we of this.e)q.push(we);return Qe(q)}};e.$pL=Lt,e.$pL=Lt=Ke([E],Lt);let Ut=class{constructor(q,we,Ae){if(this.f=[],Array.isArray(we)){if(!q)throw(0,N.$6)("command can't be undefined or null");if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$6)("command");this.e=q,this.f=we,this.g=Ae}else{if(typeof q!="string")throw(0,N.$6)("commandLine");this.c=q,this.g=we}}get commandLine(){return this.c}set commandLine(q){if(typeof q!="string")throw(0,N.$6)("commandLine");this.c=q}get command(){return this.e?this.e:""}set command(q){if(typeof q!="string"&&typeof q.value!="string")throw(0,N.$6)("command");this.e=q}get args(){return this.f}set args(q){this.f=q||[]}get options(){return this.g}set options(q){this.g=q}computeId(){const q=[];if(q.push("shell"),this.c!==void 0&&q.push(this.c),this.e!==void 0&&q.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)q.push(typeof we=="string"?we:we.value);return Qe(q)}};e.$qL=Ut,e.$qL=Ut=Ke([E],Ut);var Qt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Fe{constructor(q){this.c=q}computeId(){return"customExecution"+(0,A.$kg)()}set callback(q){this.c=q}get callback(){return this.c}}e.$rL=Fe;let Ne=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(q,we,Ae,Ze,nt,ct){this.k=!1,this.l=this.definition=q;let dt;typeof we=="string"?(this.n=this.name=we,this.u=this.source=Ae,this.execution=Ze,dt=nt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.n=this.name=Ae,this.u=this.source=Ze,this.execution=nt,dt=ct):(this.target=we,this.n=this.name=Ae,this.u=this.source=Ze,this.execution=nt,dt=ct),typeof dt=="string"?(this.q=[dt],this.r=!0):Array.isArray(dt)?(this.q=dt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(q){this.j=q}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Lt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof Ut?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof Fe?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,A.$kg)()}}get definition(){return this.l}set definition(q){if(q==null)throw(0,N.$6)("Kind can't be undefined or null");this.A(),this.l=q}get scope(){return this.m}set target(q){this.A(),this.m=q}get name(){return this.n}set name(q){if(typeof q!="string")throw(0,N.$6)("name");this.A(),this.n=q}get execution(){return this.o}set execution(q){q===null&&(q=void 0),this.A(),this.o=q;const we=this.l.type;(k.g===we||k.e===we||k.f===we||k.c===we)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(q){if(Array.isArray(q))this.A(),this.q=q,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(q){q!==!0&&q!==!1&&(q=!1),this.A(),this.t=q}get source(){return this.u}set source(q){if(typeof q!="string"||q.length===0)throw(0,N.$6)("source must be a string of length > 0");this.A(),this.u=q}get group(){return this.w}set group(q){q===null&&(q=void 0),this.A(),this.w=q}get detail(){return this.z}set detail(q){q===null&&(q=void 0),this.z=q}get presentationOptions(){return this.x}set presentationOptions(q){q==null&&(q=Object.create(null)),this.A(),this.x=q}get runOptions(){return this.y}set runOptions(q){q==null&&(q=Object.create(null)),this.A(),this.y=q}};e.$sL=Ne,e.$sL=Ne=k=Ke([E],Ne);var De;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(De||(e.ProgressLocation=De={}));var re;(function(H){function q(we){const Ae=we;return(0,$.$Gf)(Ae.value)?Ae.tooltip&&!(0,$.$Cf)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}H.isViewBadge=q})(re||(e.ViewBadge=re={}));let Oe=R=class{static isTreeItem(q,we){const Ae=q;if(Ae.checkboxState!==void 0){const Ze=(0,$.$Gf)(Ae.checkboxState)?Ae.checkboxState:(0,$.$Ef)(Ae.checkboxState)&&(0,$.$Gf)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,nt=!(0,$.$Gf)(Ae.checkboxState)&&(0,$.$Ef)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ze===void 0||Ze!==et.Checked&&Ze!==et.Unchecked||nt!==void 0&&!(0,$.$Cf)(nt))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(q instanceof R)return!0;if(Ae.label!==void 0&&!(0,$.$Cf)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,$.$Cf)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,$.$Cf)(Ae.iconPath)&&!y.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,$.$Cf)(Ae.iconPath.id))){const Ze=Ae.iconPath;if(!Ze||!(0,$.$Cf)(Ze.light)&&!y.URI.isUri(Ze.light)&&!(0,$.$Cf)(Ze.dark)&&!y.URI.isUri(Ze.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,$.$Cf)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!y.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,$.$Cf)(Ae.tooltip)&&!(Ae.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<He.None&&Ae.collapsibleState>He.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,$.$Cf)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(q,we=He.None){this.collapsibleState=we,y.URI.isUri(q)?this.resourceUri=q:this.label=q}};e.$tL=Oe,e.$tL=Oe=R=Ke([E],Oe);var He;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(He||(e.TreeItemCollapsibleState=He={}));var et;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(et||(e.TreeItemCheckboxState=et={}));let Je=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(q){this.value=q}};e.$uL=Je,e.$uL=Je=Ke([E],Je);class rt extends Je{}e.$vL=rt;class $t extends rt{#e;constructor(q){super(""),this.#e=q}asFile(){return this.#e}}e.$wL=$t;class pt{constructor(q,we,Ae,Ze){this.name=q,this.uri=we,this._itemId=Ae,this.c=Ze}data(){return this.c()}}e.$xL=pt;let Mt=class{#e=new Map;constructor(q){for(const[we,Ae]of q??[]){const Ze=this.#e.get(this.#t(we));Ze?Ze.push(Ae):this.#e.set(this.#t(we),[Ae])}}get(q){return this.#e.get(this.#t(q))?.[0]}set(q,we){this.#e.set(this.#t(q),[we])}forEach(q,we){for(const[Ae,Ze]of this.#e)for(const nt of Ze)q.call(we,nt,Ae,this)}*[Symbol.iterator](){for(const[q,we]of this.#e)for(const Ae of we)yield[q,Ae]}#t(q){return q.toLowerCase()}};e.$yL=Mt,e.$yL=Mt=Ke([E],Mt);let wt=class{constructor(q){this.insertText=q}};e.$zL=wt,e.$zL=wt=Ke([E],wt);let Nt=class{constructor(q,we){this.label=we,this.insertText=q}};e.$AL=Nt,e.$AL=Nt=Ke([E],Nt);let Vt=class{constructor(q,we){this.id=q,this.color=we}static isThemeIcon(q){return typeof q.id!="string"?(console.log("INVALID ThemeIcon, invalid id",q.id),!1):!0}};e.$BL=Vt,e.$BL=Vt=Ke([E],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let mi=class{constructor(q){this.id=q}};e.$CL=mi,e.$CL=mi=Ke([E],mi);var Pt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(Pt||(e.ConfigurationTarget=Pt={}));let Si=class{get base(){return this.c}set base(q){this.c=q,this.e=y.URI.file(q)}get baseUri(){return this.e}set baseUri(q){this.e=q,this.c=q.fsPath}constructor(q,we){if(typeof q!="string"&&(!q||!y.URI.isUri(q)&&!y.URI.isUri(q.uri)))throw(0,N.$6)("base");if(typeof we!="string")throw(0,N.$6)("pattern");typeof q=="string"?this.baseUri=y.URI.file(q):y.URI.isUri(q)?this.baseUri=q:this.baseUri=q.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$DL=Si,e.$DL=Si=Ke([E],Si);const qi=new WeakMap;function Dt(H,q){qi.set(H,q)}e.$EL=Dt;let ni=class{constructor(q,we,Ae,Ze){this.enabled=typeof q=="boolean"?q:!0,typeof we=="string"&&(this.condition=we),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ze=="string"&&(this.logMessage=Ze)}get id(){return this.c||(this.c=qi.get(this)??(0,A.$kg)()),this.c}};e.$FL=ni,e.$FL=ni=Ke([E],ni);let $i=class extends ni{constructor(q,we,Ae,Ze,nt){if(super(we,Ae,Ze,nt),q===null)throw(0,N.$6)("location");this.location=q}};e.$GL=$i,e.$GL=$i=Ke([E],$i);let ai=class extends ni{constructor(q,we,Ae,Ze,nt){super(we,Ae,Ze,nt),this.functionName=q}};e.$HL=ai,e.$HL=ai=Ke([E],ai);let Di=class extends ni{constructor(q,we,Ae,Ze,nt,ct,dt){if(super(Ze,nt,ct,dt),!we)throw(0,N.$6)("dataId");this.label=q,this.dataId=we,this.canPersist=Ae}};e.$IL=Di,e.$IL=Di=Ke([E],Di);let Ci=class{constructor(q,we,Ae){this.command=q,this.args=we||[],this.options=Ae}};e.$JL=Ci,e.$JL=Ci=Ke([E],Ci);let Ft=class{constructor(q,we){this.port=q,this.host=we}};e.$KL=Ft,e.$KL=Ft=Ke([E],Ft);let bi=class{constructor(q){this.path=q}};e.$LL=bi,e.$LL=bi=Ke([E],bi);let Ii=class{constructor(q){this.implementation=q}};e.$ML=Ii,e.$ML=Ii=Ke([E],Ii);let ci=class{constructor(q,we,Ae){this.session=q,this.threadId=we,this.frameId=Ae}};e.$NL=ci,e.$NL=ci=Ke([E],ci);let ui=class{constructor(q,we){this.session=q,this.threadId=we}};e.$OL=ui,e.$OL=ui=Ke([E],ui);let ht=class{constructor(q,we){this.range=q,this.expression=we}};e.$PL=ht,e.$PL=ht=Ke([E],ht);var Vi;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Vi||(e.InlineCompletionTriggerKind=Vi={}));let xt=class{constructor(q,we){this.range=q,this.text=we}};e.$QL=xt,e.$QL=xt=Ke([E],xt);let ri=class{constructor(q,we,Ae=!0){this.range=q,this.variableName=we,this.caseSensitiveLookup=Ae}};e.$RL=ri,e.$RL=ri=Ke([E],ri);let di=class{constructor(q,we){this.range=q,this.expression=we}};e.$SL=di,e.$SL=di=Ke([E],di);let Pi=class{constructor(q,we){this.frameId=q,this.stoppedLocation=we}};e.$TL=Pi,e.$TL=Pi=Ke([E],Pi);var Hi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Hi||(e.FileChangeType=Hi={}));let Ri=w=class extends Error{static FileExists(q){return new w(q,m.FileSystemProviderErrorCode.FileExists,w.FileExists)}static FileNotFound(q){return new w(q,m.FileSystemProviderErrorCode.FileNotFound,w.FileNotFound)}static FileNotADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileNotADirectory,w.FileNotADirectory)}static FileIsADirectory(q){return new w(q,m.FileSystemProviderErrorCode.FileIsADirectory,w.FileIsADirectory)}static NoPermissions(q){return new w(q,m.FileSystemProviderErrorCode.NoPermissions,w.NoPermissions)}static Unavailable(q){return new w(q,m.FileSystemProviderErrorCode.Unavailable,w.Unavailable)}constructor(q,we=m.FileSystemProviderErrorCode.Unknown,Ae){super(y.URI.isUri(q)?q.toString(!0):q),this.code=Ae?.name??"Unknown",(0,m.$xk)(this,we),Object.setPrototypeOf(this,w.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.$UL=Ri,e.$UL=Ri=w=Ke([E],Ri);let pi=class{constructor(q,we,Ae){this.start=q,this.end=we,this.kind=Ae}};e.$VL=pi,e.$VL=pi=Ke([E],pi);var Ki;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Ki||(e.FoldingRangeKind=Ki={}));var Ai;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var li;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var wi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(wi||(e.CommentThreadState=wi={}));class Li{constructor(q,we=[]){this.tokenTypes=q,this.tokenModifiers=we}}e.$WL=Li;function cn(H){return typeof H>"u"||(0,$.$Df)(H)}class Mi{constructor(q){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,q){this.m=!0;for(let we=0,Ae=q.tokenTypes.length;we<Ae;we++)this.k.set(q.tokenTypes[we],we);for(let we=0,Ae=q.tokenModifiers.length;we<Ae;we++)this.l.set(q.tokenModifiers[we],we)}}push(q,we,Ae,Ze,nt){if(typeof q=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ze=="number"&&(typeof nt=="number"||typeof nt>"u"))return typeof nt>"u"&&(nt=0),this.o(q,we,Ae,Ze,nt);if(O.isRange(q)&&typeof we=="string"&&cn(Ae))return this.n(q,we,Ae);throw(0,N.$6)()}n(q,we,Ae){if(!this.m)throw new Error("Legend must be provided in constructor");if(q.start.line!==q.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Ze=q.start.line,nt=q.start.character,ct=q.end.character-q.start.character,dt=this.k.get(we);let Bt=0;if(Ae)for(const Xt of Ae){if(!this.l.has(Xt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Xt);Bt|=1<<ti>>>0}this.o(Ze,nt,ct,dt,Bt)}o(q,we,Ae,Ze,nt){if(this.f&&(q<this.c||q===this.c&&we<this.e)){this.f=!1;const Bt=this.g.length/5|0;let Xt=0,ti=0;for(let ii=0;ii<Bt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Xt,Bi+=ti):oi+=Xt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Xt=oi,ti=Bi}}let ct=q,dt=we;this.f&&this.j>0&&(ct-=this.c,ct===0&&(dt-=this.e)),this.g[this.j++]=ct,this.g[this.j++]=dt,this.g[this.j++]=Ae,this.g[this.j++]=Ze,this.g[this.j++]=nt,this.c=q,this.e=we}static q(q){const we=[],Ae=q.length/5|0;for(let dt=0;dt<Ae;dt++)we[dt]=dt;we.sort((dt,Bt)=>{const Xt=q[5*dt],ti=q[5*Bt];if(Xt===ti){const ii=q[5*dt+1],oi=q[5*Bt+1];return ii-oi}return Xt-ti});const Ze=new Uint32Array(q.length);let nt=0,ct=0;for(let dt=0;dt<Ae;dt++){const Bt=5*we[dt],Xt=q[Bt+0],ti=q[Bt+1],ii=q[Bt+2],oi=q[Bt+3],Bi=q[Bt+4],Sn=Xt-nt,On=Sn===0?ti-ct:ti,Wi=5*dt;Ze[Wi+0]=Sn,Ze[Wi+1]=On,Ze[Wi+2]=ii,Ze[Wi+3]=oi,Ze[Wi+4]=Bi,nt=Xt,ct=ti}return Ze}build(q){return this.f?new si(new Uint32Array(this.g),q):new si(Mi.q(this.g),q)}}e.$XL=Mi;class si{constructor(q,we){this.resultId=we,this.data=q}}e.$YL=si;class un{constructor(q,we,Ae){this.start=q,this.deleteCount=we,this.data=Ae}}e.$ZL=un;class ln{constructor(q,we){this.resultId=we,this.edits=q}}e.$1L=ln;var Ji;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new Vt("arrow-left")}}constructor(){}};e.$2L=fi,e.$2L=fi=Ke([E],fi);var Qi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Yi{static validate(q){if(typeof q.badge=="string"){let we=(0,b.$df)(q.badge,0);if(we<q.badge.length&&(we+=(0,b.$df)(q.badge,we)),q.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(q.badge&&!Vt.isThemeIcon(q.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!q.color&&!q.badge&&!q.tooltip)throw new Error("The decoration is empty");return!0}constructor(q,we,Ae){this.badge=q,this.tooltip=we,this.color=Ae}}e.$3L=Yi;let Fi=class{constructor(q){this.kind=q}};e.$4L=Fi,e.$4L=Fi=Ke([E],Fi);var Ti;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(q){return q instanceof _t?!0:q?typeof q.start=="number"&&typeof q.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(q,we){if(q<0)throw(0,N.$6)("start must be positive");if(we<0)throw(0,N.$6)("end must be positive");q<=we?(this.c=q,this.e=we):(this.c=we,this.e=q)}with(q){let we=this.c,Ae=this.e;return q.start!==void 0&&(we=q.start),q.end!==void 0&&(Ae=q.end),we===this.c&&Ae===this.e?this:new _t(we,Ae)}}e.$5L=_t;class vi{static validate(q){if(typeof q.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof q.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof q.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(q){return Array.isArray(q)&&q.every(we=>vi.isNotebookCellData(we))}static isNotebookCellData(q){return!0}constructor(q,we,Ae,Ze,nt,ct,dt){this.kind=q,this.value=we,this.languageId=Ae,this.mime=Ze,this.outputs=nt??[],this.metadata=ct,this.executionSummary=dt,vi.validate(this)}}e.$6L=vi;class hn{constructor(q){this.cells=q}}e.$7L=hn;class Yt{static isNotebookCellOutputItem(q){return q instanceof Yt?!0:q?typeof q.mime=="string"&&q.data instanceof Uint8Array:!1}static error(q){const we={name:q.name,message:q.message,stack:q.stack};return Yt.json(we,"application/vnd.code.notebook.error")}static stdout(q){return Yt.text(q,"application/vnd.code.notebook.stdout")}static stderr(q){return Yt.text(q,"application/vnd.code.notebook.stderr")}static bytes(q,we="application/octet-stream"){return new Yt(q,we)}static#e=new TextEncoder;static text(q,we=L.$Zr.text){const Ae=Yt.#e.encode(String(q));return new Yt(Ae,we)}static json(q,we="text/x-json"){const Ae=JSON.stringify(q,void 0,"	");return Yt.text(Ae,we)}constructor(q,we){this.data=q,this.mime=we;const Ae=(0,L.$4r)(we,!0);if(!Ae)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.$8L=Yt;class yi{static isNotebookCellOutput(q){return q instanceof yi?!0:!q||typeof q!="object"?!1:typeof q.id=="string"&&Array.isArray(q.items)}static ensureUniqueMimeTypes(q,we=!1){const Ae=new Set,Ze=new Set;for(let nt=0;nt<q.length;nt++){const ct=q[nt],dt=(0,L.$4r)(ct.mime);if(!Ae.has(dt)||(0,S.$II)(dt)){Ae.add(dt);continue}Ze.add(nt),we&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ze.size===0?q:q.filter((nt,ct)=>!Ze.has(ct))}constructor(q,we,Ae){this.items=yi.ensureUniqueMimeTypes(q,!0),typeof we=="string"?(this.id=we,this.metadata=Ae):(this.id=(0,A.$kg)(),this.metadata=we??Ae)}}e.$9L=yi;var Ei;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Ue;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(Ue||(e.NotebookCellStatusBarAlignment=Ue={}));var ei;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Xi{constructor(q,we){this.text=q,this.alignment=we}}e.$0L=Xi;var bt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var xi;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(q,we=[]){this.uri=q,this.provides=(0,D.$2b)(we)}}e.$$L=dn;class _i{constructor(q){this.label=q}}e.$_L=_i;var en;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(q,we){this.label=q,this.timestamp=we}};e.$aM=hi,e.$aM=hi=Ke([E],hi);var tn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(q,we){this.ranges=q,this.wordPattern=we}}e.$bM=sn;class fn{constructor(q){this.c=q}get autoForwardAction(){return this.c}}e.$cM=fn;var on;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(q=void 0,we=void 0,Ae=void 0,Ze=!1){this.include=q,this.exclude=we,this.profile=Ae,this.continuous=Ze}};e.$dM=Ni,e.$dM=Ni=Ke([E],Ni);let ji=p=class{static diff(q,we,Ae){const Ze=new p(q);return Ze.expectedOutput=we,Ze.actualOutput=Ae,Ze}constructor(q){this.message=q}};e.$eM=ji,e.$eM=ji=p=Ke([E],ji);let zi=class{constructor(q){this.id=q}};e.$fM=zi,e.$fM=zi=Ke([E],zi);class ki{constructor(q,we){this.covered=q,this.total=we}}e.$gM=ki;class Ui{static fromDetails(q,we){const Ae=new ki(0,0),Ze=new ki(0,0),nt=new ki(0,0);for(const dt of we)if("branches"in dt){Ae.total+=1,Ae.covered+=dt.executionCount>0?1:0;for(const Bt of dt.branches)Ze.total+=1,Ze.covered+=Bt.executionCount>0?1:0}else nt.total+=1,nt.covered+=dt.executionCount>0?1:0;const ct=new Ui(q,Ae,Ze.total>0?Ze:void 0,nt.total>0?nt:void 0);return ct.detailedCoverage=we,ct}constructor(q,we,Ae,Ze){this.uri=q,this.statementCoverage=we,this.branchCoverage=Ae,this.functionCoverage=Ze}}e.$hM=Ui;class gn{constructor(q,we,Ae=[]){this.executionCount=q,this.location=we,this.branches=Ae}}e.$iM=gn;class mn{constructor(q,we){this.executionCount=q,this.location=we}}e.$jM=mn;class pe{constructor(q,we,Ae){this.name=q,this.executionCount=we,this.location=Ae}}e.$kM=pe;var ke;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(ke||(e.ExternalUriOpenerPriority=ke={}));var ze;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(ze||(e.WorkspaceTrustState=ze={}));var at;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(at||(e.PortAutoForwardAction=at={}));class vt{constructor(q,we,Ae,Ze,nt,ct){this.kind=q,this.name=we,this.detail=Ae,this.uri=Ze,this.range=nt,this.selectionRange=ct}}e.$lM=vt;class Tt{constructor(q){this.uri=q}}e.$mM=Tt;class Dn{constructor(q,we){this.original=q,this.modified=we}}e.$nM=Dn;class Cn{constructor(q,we,Ae,Ze){this.base=q,this.input1=we,this.input2=Ae,this.result=Ze}}e.$oM=Cn;class In{constructor(q,we){this.uri=q,this.viewType=we}}e.$pM=In;class Pn{constructor(q){this.viewType=q}}e.$qM=Pn;class Rn{constructor(q,we){this.uri=q,this.notebookType=we}}e.$rM=Rn;class An{constructor(q,we,Ae){this.original=q,this.modified=we,this.notebookType=Ae}}e.$sM=An;class Ln{constructor(){}}e.$tM=Ln;class Mn{constructor(q,we){this.uri=q,this.inputBoxUri=we}}e.$uM=Mn;class Fn{constructor(q){this.providerId=q}}e.$vM=Fn;var $n;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var bn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(bn||(e.InteractiveSessionCopyKind=bn={}));var pn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(pn||(e.InteractiveEditorResponseFeedbackKind=pn={}));var wn;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(wn||(e.ChatMessageRole=wn={}));var vn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(vn||(e.ChatVariableLevel=vn={}));class Tn{constructor(q,we){this.role=q,this.content=we}}e.$wM=Tn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var kn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(kn||(e.SpeechToTextStatus=kn={}))}),define(Ee[141],Se([1,0,60,17,13,175,126,7,19]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=void 0;const y=new Map;function A(S,f){f?y.set(S,f):y.delete(S)}e.$JM=A;function C(S){return y.get(S)}class m extends I.$7u{constructor(f,d,s,i,n,o,a,t){super(d,s,i,n),this.c=f,this.m=o,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,D.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,$.$tb)(this.f,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.d},get fileName(){return f.d.fsPath},get isUntitled(){return f.d.scheme===N.Schemas.untitled},get languageId(){return f.m},get version(){return f.h},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(d){return d?f.s(d):f.getText()},get eol(){return f.g===`
`?b.EndOfLine.LF:b.EndOfLine.CRLF},get lineCount(){return f.f.length},lineAt(d){return f.t(d)},offsetAt(d){return f.u(d)},positionAt(d){return f.v(d)},validateRange(d){return f.w(d)},validatePosition(d){return f.x(d)},getWordRangeAtPosition(d,s){return f.y(d,s)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,D.ok)(!this.b),this.m=f}_acceptIsDirty(f){(0,D.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(f){const d=this.w(f);if(d.isEmpty)return"";if(d.isSingleLine)return this.f[d.start.line].substring(d.start.character,d.end.character);const s=this.g,i=d.start.line,n=d.end.line,o=[];o.push(this.f[i].substring(d.start.character));for(let a=i+1;a<n;a++)o.push(this.f[a]);return o.push(this.f[n].substring(0,d.end.character)),o.join(s)}t(f){let d;if(f instanceof b.$HK?d=f.line:typeof f=="number"&&(d=f),typeof d!="number"||d<0||d>=this.f.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new v(d,this.f[d],d===this.f.length-1)}u(f){return f=this.x(f),this.l(),this.j.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.l();const d=this.j.getIndexOf(f),s=this.f[d.index].length;return new b.$HK(d.index,Math.min(d.remainder,s))}w(f){if(!(f instanceof b.$IK))throw new Error("Invalid argument");const d=this.x(f.start),s=this.x(f.end);return d===f.start&&s===f.end?f:new b.$IK(d.line,d.character,s.line,s.character)}x(f){if(!(f instanceof b.$HK))throw new Error("Invalid argument");if(this.f.length===0)return f.with(0,0);let{line:d,character:s}=f,i=!1;if(d<0)d=0,s=0,i=!0;else if(d>=this.f.length)d=this.f.length-1,s=this.f[d].length,i=!0;else{const n=this.f[d].length;s<0?(s=0,i=!0):s>n&&(s=n,i=!0)}return i?new b.$HK(d,s):f}y(f,d){const s=this.x(f);if(!d)d=C(this.m);else if((0,g.$Se)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const i=(0,L.$fs)(s.character+1,(0,L.$ds)(d),this.f[s.line],0);if(i)return new b.$IK(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$KM=m;class v{constructor(f,d,s){this.a=f,this.b=d,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new b.$IK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new b.$IK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$LM=v}),define(Ee[284],Se([1,0,7,20,4]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let I=class{constructor(b){this.a=new D.$4L(D.ColorThemeKind.Dark),this.b=new g.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(b){let $;switch(b){case"light":$=D.ColorThemeKind.Light;break;case"hcDark":$=D.ColorThemeKind.HighContrast;break;case"hcLight":$=D.ColorThemeKind.HighContrastLight;break;default:$=D.ColorThemeKind.Dark}this.a=new D.$4L($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$tgc=I,e.$tgc=I=Ke([We(0,N.$HM)],I)}),define(Ee[285],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.CellExecutionUpdateType=void 0;var N;(function(g){g[g.Output=1]="Output",g[g.OutputItems=2]="OutputItems",g[g.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$MI=(0,D.$Zh)("INotebookExecutionService")}),define(Ee[286],Se([1,0,3,29,192,99]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zPb=void 0;class L extends D.$Rc{constructor($,y,A){super(),this._source=$,this.b=y,this.c=A,this.a=void 0}f($){const y=$.getLineCount();return new N.$Ds(1,1,y,this.g($,y))}g($,y){if(y<1||y>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const $=new g.$SB;$.acceptChunk(this._source);const y=$.finish(!0),{textBuffer:A,disposable:C}=y.create(1);this.b=A,this.B(C)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const y=new g.$SB;y.acceptChunk($);const A=y.finish(!0),{textBuffer:C,disposable:m}=A.create(1);return this.B(m),C})),this.a}findInInputs($){const A=new I.$GB($,!1,!1,null).parseSearchRequest();if(!A)return[];const C=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(C,A,!0,5e3)}findInOutputs($){const A=new I.$GB($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(C=>{const m=C.findMatchesLineByLine(this.f(C),A,!0,5e3);if(m.length!==0)return{textBuffer:C,matches:m}}).filter(C=>!!C):[]}}e.$zPb=L}),define(Ee[67],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.TestPosition=e.TestIdPathParts=void 0;var D;(function(I){I.Delimiter="\0"})(D||(e.TestIdPathParts=D={}));var N;(function(I){I[I.IsSame=0]="IsSame",I[I.Disconnected=1]="Disconnected",I[I.IsChild=2]="IsChild",I[I.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class g{static fromExtHostTestItem(L,b,$=L.parent){if(L._isRoot)return new g([b]);const y=[L.id];for(let A=$;A&&A.id!==b;A=A.parent)y.push(A.id);return y.push(b),new g(y.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const b=L.indexOf("\0");return b===-1?L:L.slice(0,b)}static fromString(L){return new g(L.split("\0"))}static join(L,b){return new g([...L.path,b])}static joinToString(L,b){return L.toString()+"\0"+b}static parentId(L){const b=L.lastIndexOf("\0");return b===-1?void 0:L.slice(0,b)}static localId(L){const b=L.lastIndexOf("\0");return b===-1?L:L.slice(b+1)}static isChild(L,b){return b.startsWith(L)&&b[L.length]==="\0"}static compare(L,b){return L===b?0:g.isChild(L,b)?2:g.isChild(b,L)?3:1}constructor(L,b=L.length){if(this.path=L,this.d=b,L.length===0||b<1)throw new Error("cannot create test with empty path")}get rootId(){return new g(this.path,1)}get parentId(){return this.d>1?new g(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new g(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new g(this.path,L)}compare(L){if(typeof L=="string")return g.compare(this.toString(),L);for(let b=0;b<L.d&&b<this.d;b++)if(L.path[b]!==this.path[b])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$wJ=g}),define(Ee[89],Se([1,0,2,49,29,67]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$DJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$CJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$BJ=e.$AJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$zJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$yJ=e.$xJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(T){T[T.Unset=0]="Unset",T[T.Queued=1]="Queued",T[T.Running=2]="Running",T[T.Passed=3]="Passed",T[T.Failed=4]="Failed",T[T.Skipped=5]="Skipped",T[T.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var b;(function(T){T[T.Run=1]="Run",T[T.Debug=2]="Debug",T[T.Coverage=3]="Coverage"})(b||(e.ExtTestRunProfileKind=b={}));var $;(function(T){T[T.Run=2]="Run",T[T.Debug=4]="Debug",T[T.Coverage=8]="Coverage",T[T.HasNonDefaultProfile=16]="HasNonDefaultProfile",T[T.HasConfigurable=32]="HasConfigurable",T[T.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$xJ=[2,4,8,16,32,64];const y=T=>"runId"in T;e.$yJ=y;var A;(function(T){T.serialize=M=>({range:M.range.toJSON(),uri:M.uri.toJSON()}),T.deserialize=M=>({range:g.$Ds.lift(M.range),uri:D.URI.revive(M.uri)})})(A||(e.IRichLocation=A={}));var C;(function(T){T[T.Error=0]="Error",T[T.Output=1]="Output"})(C||(e.TestMessageType=C={}));var m;(function(T){T.serialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&A.serialize(M.location)}),T.deserialize=M=>({message:M.message,type:0,expected:M.expected,actual:M.actual,contextValue:M.contextValue,location:M.location&&A.deserialize(M.location)})})(m||(e.ITestErrorMessage=m={}));const v=(T,M)=>`${M?"s":"e"}${T}`;e.$zJ=v;var S;(function(T){T.serialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&A.serialize(M.location)}),T.deserialize=M=>({message:M.message,type:1,offset:M.offset,length:M.length,location:M.location&&A.deserialize(M.location)})})(S||(e.ITestOutputMessage=S={}));var f;(function(T){T.serialize=M=>M.type===0?m.serialize(M):S.serialize(M),T.deserialize=M=>M.type===0?m.deserialize(M):S.deserialize(M)})(f||(e.ITestMessage=f={}));var d;(function(T){T.serializeWithoutMessages=M=>({state:M.state,duration:M.duration,messages:[]}),T.serialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(f.serialize)}),T.deserialize=M=>({state:M.state,duration:M.duration,messages:M.messages.map(f.deserialize)})})(d||(e.ITestTaskState=d={}));const s="\0",i=(T,M)=>T+s+M;e.$AJ=i;const n=T=>{const M=T.indexOf(s);return{ctrlId:T.slice(0,M),tagId:T.slice(M+1)}};e.$BJ=n;var o;(function(T){T.serialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?.toJSON(),range:M.range?.toJSON()||null,description:M.description,error:M.error,sortText:M.sortText}),T.deserialize=M=>({extId:M.extId,label:M.label,tags:M.tags,busy:M.busy,children:void 0,uri:M.uri?D.URI.revive(M.uri):void 0,range:M.range?g.$Ds.lift(M.range):null,description:M.description,error:M.error,sortText:M.sortText})})(o||(e.ITestItem=o={}));var a;(function(T){T[T.NotExpandable=0]="NotExpandable",T[T.Expandable=1]="Expandable",T[T.BusyExpanding=2]="BusyExpanding",T[T.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(T){T.serialize=M=>({expand:M.expand,item:o.serialize(M.item)}),T.deserialize=M=>({controllerId:I.$wJ.root(M.item.extId),expand:M.expand,item:o.deserialize(M.item)})})(t||(e.InternalTestItem=t={}));var r;(function(T){T.serialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.uri!==void 0&&(W.uri=M.item.uri?.toJSON()),M.item.range!==void 0&&(W.range=M.item.range?.toJSON()),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}},T.deserialize=M=>{let W;return M.item&&(W={},M.item.label!==void 0&&(W.label=M.item.label),M.item.tags!==void 0&&(W.tags=M.item.tags),M.item.busy!==void 0&&(W.busy=M.item.busy),M.item.range!==void 0&&(W.range=M.item.range?g.$Ds.lift(M.item.range):null),M.item.description!==void 0&&(W.description=M.item.description),M.item.error!==void 0&&(W.error=M.item.error),M.item.sortText!==void 0&&(W.sortText=M.item.sortText)),{extId:M.extId,expand:M.expand,item:W}}})(r||(e.ITestItemUpdate=r={}));const h=(T,M)=>{M.expand!==void 0&&(T.expand=M.expand),M.item!==void 0&&(T.item=T.item?Object.assign(T.item,M.item):M.item)};e.$CJ=h;var u;(function(T){T.serializeWithoutMessages=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(d.serializeWithoutMessages)}),T.serialize=M=>({...t.serialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(d.serialize)}),T.deserialize=M=>({...t.deserialize(M),ownComputedState:M.ownComputedState,computedState:M.computedState,tasks:M.tasks.map(d.deserialize),retired:!0})})(u||(e.TestResultItem=u={}));var c;(function(T){T.empty=()=>({covered:0,total:0}),T.sum=(M,W)=>{M.covered+=W.covered,M.total+=W.total}})(c||(e.ICoveredCount=c={}));var l;(function(T){T.serialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(p.serialize),uri:M.uri.toJSON()}),T.deserialize=M=>({statement:M.statement,branch:M.branch,function:M.function,details:M.details?.map(p.deserialize),uri:D.URI.from(M.uri)})})(l||(e.IFileCoverage=l={}));function k(T){return{...T,location:T.location?.toJSON()}}function R(T){return T.location=T.location?N.$Cs.isIPosition(T.location)?N.$Cs.lift(T.location):g.$Ds.lift(T.location):void 0,T}e.$DJ=3;var w;(function(T){T[T.Function=0]="Function",T[T.Statement=1]="Statement"})(w||(e.DetailType=w={}));var p;(function(T){T.serialize=M=>M.type===0?P.serialize(M):z.serialize(M),T.deserialize=M=>M.type===0?P.deserialize(M):z.deserialize(M)})(p||(e.CoverageDetails=p={}));var E;(function(T){T.serialize=k,T.deserialize=R})(E||(e.IBranchCoverage=E={}));var P;(function(T){T.serialize=k,T.deserialize=R})(P||(e.IFunctionCoverage=P={}));var z;(function(T){T.serialize=M=>({...k(M),branches:M.branches?.map(E.serialize)}),T.deserialize=M=>({...R(M),branches:M.branches?.map(E.deserialize)})})(z||(e.IStatementCoverage=z={}));var j;(function(T){T[T.Add=0]="Add",T[T.Update=1]="Update",T[T.DocumentSynced=2]="DocumentSynced",T[T.Remove=3]="Remove",T[T.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",T[T.Retire=5]="Retire",T[T.AddTag=6]="AddTag",T[T.RemoveTag=7]="RemoveTag"})(j||(e.TestDiffOpType=j={}));var F;(function(T){T.deserialize=M=>M.op===0?{op:M.op,item:t.deserialize(M.item)}:M.op===1?{op:M.op,item:r.deserialize(M.item)}:M.op===2?{op:M.op,uri:D.URI.revive(M.uri),docv:M.docv}:M,T.serialize=M=>M.op===0?{op:M.op,item:t.serialize(M.item)}:M.op===1?{op:M.op,item:r.serialize(M.item)}:M})(F||(e.TestsDiffOp=F={}));class O{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(M){const W=this.o();for(const Y of M)switch(Y.op){case 0:this.j(t.deserialize(Y.item),W);break;case 1:this.k(r.deserialize(Y.item),W);break;case 3:this.l(Y.itemId,W);break;case 5:this.m(Y.itemId);break;case 4:this.updatePendingRoots(Y.amount);break;case 6:this.c.set(Y.tag.id,Y.tag);break;case 7:this.c.delete(Y.id);break}W.complete?.()}j(M,W){const Y=I.$wJ.parentId(M.item.extId)?.toString();let ue;if(!Y)ue=this.p(M),this.f.add(ue),this.d.set(M.item.extId,ue);else if(this.d.has(Y)){const Z=this.d.get(Y);Z.children.add(M.item.extId),ue=this.p(M,Z),this.d.set(M.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(M)}`);return}return W.add?.(ue),M.expand===2&&this.g++,ue}k(M,W){const Y=this.d.get(M.extId);if(Y)return M.expand!==void 0&&(Y.expand===2&&this.g--,M.expand===2&&this.g++),(0,e.$CJ)(Y,M),W.update?.(Y),Y}l(M,W){const Y=this.d.get(M);if(!Y)return;const ue=I.$wJ.parentId(Y.item.extId)?.toString();ue?this.d.get(ue).children.delete(Y.item.extId):this.f.delete(Y);const Z=[[M]];for(;Z.length;)for(const Q of Z.pop()){const x=this.d.get(Q);x&&(Z.push(x.children),this.d.delete(Q),W.remove?.(x,x!==Y),x.expand===2&&this.g--)}}m(M){}updatePendingRoots(M){this.h+=M}o(){return{}}}e.$EJ=O}),define(Ee[112],Se([1,0,12,4,3,60,89,67]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const y=(i,n)=>i===n,C=Object.entries({range:(i,n)=>i===n?!0:!i||!n?!1:i.equalsRange(n),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,n)=>!(i.length!==n.length||i.some(o=>!n.includes(o)))}),m=(i,n)=>{let o;for(const[a,t]of C)t(i[a],n[a])||(o?o[a]=n[a]:o={[a]:n[a]});return o};class v extends g.$Rc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new D.$_g(()=>this.flushDiff(),200)),this.g=this.B(new N.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(n){this.h=n;for(const o of this.tree.values())this.I(o)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const o of this.m)if(o.op===2&&o.uri===n.uri){o.docv=n.docv;return}break}case 1:{const o=this.m[this.m.length-1];if(o){if(o.op===1&&o.item.extId===n.item.extId){(0,L.$CJ)(o.item,n.item);return}if(o.op===0&&o.item.item.extId===n.item.extId){(0,L.$CJ)(o.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,o){const a=this.tree.get(n);if(a){if((a.expandLevels===void 0||o>a.expandLevels)&&(a.expandLevels=o),a.expand===1){const t=this.L(a);return t.isOpen()?this.J(a,o-1):t.wait().then(()=>this.J(a,o-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.J(a,o-1)):this.J(a,o-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(n,o){switch(o.op){case 3:this.N(b.$wJ.joinToString(n.fullId,o.id));break;case 0:this.y(o.item,n);break;case 5:for(const a of o.ops)this.u(n,a);break;case 1:this.z(o.new,o.old,n.fullId.toString());break;case 2:this.I(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:o.update}});break;case 6:this.w(n.actual.uri);break;default:(0,I.$4c)(o)}}w(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}y(n,o){const a=b.$wJ.fromExtHostTestItem(n,this.root.id,o?.actual),t=this.s.getApiFor(n);t.parent&&t.parent!==o?.actual&&this.s.getChildren(t.parent).delete(n.id);let r=this.tree.get(a.toString());if(!r){r={fullId:a,actual:n,expandLevels:o?.expandLevels?o.expandLevels-1:void 0,expand:0},n.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(n,o),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(n)}}),this.H(n,r,o);return}if(r.actual===n){this.G(n,r,o);return}if(r.actual.uri?.toString()!==n.uri?.toString())return this.N(a.toString()),this.y(n,o);const h=this.s.getChildren(r.actual),u=r.actual,c=m(this.s.toITestItem(u),this.s.toITestItem(n));this.s.getApiFor(u).listener=void 0,r.actual=n,r.expand=0,c&&(c.hasOwnProperty("tags")&&(this.z(n.tags,u.tags,a.toString()),delete c.tags),this.u(r,{op:4,update:c})),this.H(n,r,o);for(const[l,k]of h)this.s.getChildren(n).get(k.id)||this.N(b.$wJ.joinToString(a,k.id));this.w(r.actual.uri)}z(n,o,a){const t=new Set(o.map(r=>r.id));for(const r of n)t.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:a,item:{tags:n.map(r=>(0,L.$AJ)(this.s.controllerId,r.id))}}}),t.forEach(this.D,this)}C(n){const o=this.j.get(n.id);o?o.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$AJ)(this.s.controllerId,n.id)}}))}D(n){const o=this.j.get(n);o&&!--o.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,L.$AJ)(this.s.controllerId,n)}))}F(n,o){this.s.getApiFor(n).parent=o&&o.actual!==this.root?o.actual:void 0}G(n,o,a){this.F(n,a);const t=this.s.getApiFor(n);t.parent=a?.actual,t.listener=r=>this.u(o,r),this.I(o)}H(n,o,a){this.G(n,o,a);for(const[t,r]of this.s.getChildren(n))this.y(r,o)}I(n){let o;this.h?n.resolveBarrier?o=n.resolveBarrier.isOpen()?3:2:o=n.actual.canResolveChildren?1:0:o=0,o!==n.expand&&(n.expand=o,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:o}}),o===1&&n.expandLevels!==void 0&&this.L(n))}J(n,o){if(o<0)return;const a=[];for(const[t,r]of this.s.getChildren(n.actual)){const h=this.expand(b.$wJ.joinToString(n.fullId,r.id),o);(0,D.$Mg)(h)&&a.push(h)}if(a.length)return Promise.all(a).then(()=>{})}L(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const r=new D.$Yg;return r.open(),r}n.expand=2,this.M(n);const o=n.resolveBarrier=new D.$Yg,a=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let t;try{t=this.h(n.actual===this.root?void 0:n.actual)}catch(r){a(r)}return(0,D.$Mg)(t)?t.catch(a).then(()=>{o.open(),this.I(n)}):(o.open(),this.I(n)),n.resolveBarrier}M(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}N(n){const o=this.tree.get(n);if(!o)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const a=[o];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.D(r.id);this.tree.delete(t.fullId.toString());for(const[r,h]of this.s.getChildren(t.actual))a.push(this.tree.get(b.$wJ.joinToString(t.fullId,h.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$xM=v;class S extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$yM=S;class f extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$zM=f;class d extends Error{constructor(n,o,a){super(`TestItem with ID "${n}" is from controller "${o}" and cannot be added as a child of an item from controller "${a}".`)}}e.$AM=d;const s=(i,n,o)=>{let a=new Map;return{get size(){return a.size},forEach(t,r){for(const h of a.values())t.call(r,h,this)},[Symbol.iterator](){return a.entries()},replace(t){const r=new Map,h=new Set(a.keys()),u={op:5,ops:[]};for(const c of t){if(!(c instanceof o))throw new f(c.id);const l=n(c).controllerId;if(l!==i.controllerId)throw new d(c.id,l,i.controllerId);if(r.has(c.id))throw new S(c.id);r.set(c.id,c),h.delete(c.id),u.ops.push({op:0,item:c})}for(const c of h.keys())u.ops.push({op:3,id:c});i.listener?.(u),a=r},add(t){if(!(t instanceof o))throw new f(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$BM=s}),define(Ee[142],Se([1,0,112]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;const N=new WeakMap,g=(L,b)=>{const $={controllerId:b};return N.set(L,$),$};e.$CM=g;const I=L=>{const b=N.get(L);if(!b)throw new D.$zM(L?.id||"<unknown>");return b};e.$DM=I}),define(Ee[113],Se([1,0,17,2]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rub=e.$Qub=e.$Pub=e.$Oub=e.$Nub=void 0,e.$Nub="vscode-cdn.net",e.$Oub=`vscode-resource.${e.$Nub}`,e.$Pub=`'self' https://*.${e.$Nub}`;function g(b,$){return b.scheme===D.Schemas.http||b.scheme===D.Schemas.https?b:($&&$.authority&&$.isRemote&&b.scheme===D.Schemas.file&&(b=N.URI.from({scheme:D.Schemas.vscodeRemote,authority:$.authority,path:b.path})),N.URI.from({scheme:D.Schemas.https,authority:`${b.scheme}+${I(b.authority)}.${e.$Oub}`,path:b.path,fragment:b.fragment,query:b.query}))}e.$Qub=g;function I(b){return b.replace(/./g,$=>{const y=$.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?$:"-"+y.toString(16).padStart(4,"0")})}function L(b){return b.replace(/-([0-9a-f]{4})/g,($,y)=>String.fromCharCode(parseInt(y,16)))}e.$Rub=L}),define(Ee[287],Se([1,0,4,3,113]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class I{constructor(b,$,y){this.d=b,this.e=$,this.f=y,this.a=0,this.b=new N.$Qc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const C of this.c.values())A.indexOf(C.editor)<0&&C.inset.dispose()}))}dispose(){this.c.forEach(b=>b.inset.dispose()),this.b.dispose()}createWebviewEditorInset(b,$,y,A,C){let m;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===b){m=n;break}if(!m)throw new Error("not a visible editor");const v=this,S=this.a++,f=new D.$Rd,d=new D.$Rd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,g.$Qub)(n,v.f)}get cspSource(){return g.$Pub}set options(n){this.b=n,v.d.$setOptions(S,n)}get options(){return this.b}set html(n){this.a=n,v.d.$setHtml(S,n)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(n){return v.d.$postMessage(S,n)}},i=new class{constructor(){this.editor=b,this.line=$,this.height=y,this.webview=s,this.onDidDispose=d.event}dispose(){v.c.has(S)&&(v.c.delete(S),v.d.$disposeEditorInset(S),d.fire(),d.dispose(),f.dispose())}};return this.d.$createEditorInset(S,m.id,m.value.document.uri,$+1,y,A||{},C.identifier,C.extensionLocation),this.c.set(S,{editor:b,inset:i,onDidReceiveMessage:f}),i}$onDidDispose(b){const $=this.c.get(b);$&&$.inset.dispose()}$onDidReceiveMessage(b,$){this.c.get(b)?.onDidReceiveMessage.fire($)}}e.$Pec=I}),define(Ee[288],Se([1,0,5]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.VariableKind=e.$tN=void 0,e.$tN=(0,D.$Zh)("configurationResolverService");var N;(function(I){I.Unknown="unknown",I.Env="env",I.Config="config",I.Command="command",I.Input="input",I.ExtensionInstallFolder="extensionInstallFolder",I.WorkspaceFolder="workspaceFolder",I.Cwd="cwd",I.WorkspaceFolderBasename="workspaceFolderBasename",I.UserHome="userHome",I.LineNumber="lineNumber",I.SelectedText="selectedText",I.File="file",I.FileWorkspaceFolder="fileWorkspaceFolder",I.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",I.RelativeFile="relativeFile",I.RelativeFileDirname="relativeFileDirname",I.FileDirname="fileDirname",I.FileExtname="fileExtname",I.FileBasename="fileBasename",I.FileBasenameNoExtension="fileBasenameNoExtension",I.FileDirnameBasename="fileDirnameBasename",I.ExecPath="execPath",I.ExecInstallFolder="execInstallFolder",I.PathSeparator="pathSeparator"})(N||(e.VariableKind=N={}));class g extends Error{constructor(L,b){super(b),this.variable=L}}e.$uN=g}),define(Ee[289],Se([1,0,16,50,18,24,11,102,231,288,13]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;class C{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(v,S,f,d){this.h=new Map,this.a=v,this.b=S,this.g=f,d&&(this.c=d.then(s=>this.i(s)))}i(v){if(L.$i){const S=Object.create(null);return Object.keys(v).forEach(f=>{S[f.toLowerCase()]=v[f]}),S}return v}resolveWithEnvironment(v,S,f){return this.l({env:this.i(v),userHome:void 0},S?S.uri:void 0,f)}async resolveAsync(v,S){const f={env:await this.c,userHome:await this.g};return this.l(f,v?v.uri:void 0,S)}async j(v,S,f,d){const s=I.$en(S);L.$i&&s.windows?Object.keys(s.windows).forEach(n=>s[n]=s.windows[n]):L.$j&&s.osx?Object.keys(s.osx).forEach(n=>s[n]=s.osx[n]):L.$k&&s.linux&&Object.keys(s.linux).forEach(n=>s[n]=s.linux[n]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,v?v.uri:void 0,s,f,d)}async resolveAnyAsync(v,S,f){return this.j(v,S,f)}async resolveAnyMap(v,S,f){const d=new Map;return{newConfig:await this.j(v,S,f,d),resolvedVariables:d}}resolveWithInteractionReplace(v,S,f,d){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(v,S,f,d){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(v,S){if(this.h.has(v))throw new Error("Variable "+v+" is contributed twice.");this.h.set(v,S)}async l(v,S,f,d,s){if(g.$Cf(f))return this.m(v,S,f,d,s);if(Array.isArray(f))return Promise.all(f.map(i=>this.l(v,S,i,d,s)));if(g.$Ef(f)){const i=Object.create(null),n=await Promise.all(Object.keys(f).map(async o=>[await this.m(v,S,o,d,s),await this.l(v,S,f[o],d,s)]));for(const[o,a]of n)i[o]=a;return i}return f}m(v,S,f,d,s){return(0,A.$Xe)(f,C.VARIABLE_REGEXP,async(i,n)=>{if(n.includes(C.VARIABLE_LHS))return i;let o=await this.o(v,i,n,S,d);return s?.set(n,o),o!==i&&g.$Cf(o)&&o.match(C.VARIABLE_REGEXP)&&(o=await this.m(v,S,o,d,s)),o})}n(v){return this.b?this.b.getUriLabel(v,{noPrefix:!0}):v.fsPath}async o(v,S,f,d,s){let i;const n=f.split(":");n.length>1&&(f=n[0],i=n[1]);const o=r=>{const h=this.a.getFilePath();if(h)return(0,b.$Ev)(h);throw new y.$uN(r,(0,$.localize)(0,null,S))},a=r=>{const h=o(r);if(this.a.getWorkspaceFolderPathForFile){const u=this.a.getWorkspaceFolderPathForFile();if(u)return(0,b.$Ev)(u)}throw new y.$uN(r,(0,$.localize)(1,null,S,D.$mc(h)))},t=r=>{if(i){const h=this.a.getFolderUri(i);if(h)return h;throw new y.$uN(r,(0,$.localize)(2,null,S,i))}if(d)return d;throw this.a.getWorkspaceFolderCount()>1?new y.$uN(r,(0,$.localize)(3,null,S)):new y.$uN(r,(0,$.localize)(4,null,S))};switch(f){case"env":if(i){if(v.env){const r=v.env[L.$i?i.toLowerCase():i];if(g.$Cf(r))return r}return""}throw new y.$uN(y.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const r=this.a.getConfigurationValue(d,i);if(g.$Lf(r))throw new y.$uN(y.VariableKind.Config,(0,$.localize)(6,null,S,i));if(g.$Ef(r))throw new y.$uN(y.VariableKind.Config,(0,$.localize)(7,null,S,i));return r}throw new y.$uN(y.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(y.VariableKind.Command,S,i,s,"command");case"input":return this.p(y.VariableKind.Input,S,i,s,"input");case"extensionInstallFolder":if(i){const r=await this.a.getExtension(i);if(!r)throw new y.$uN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(r.extensionLocation)}throw new y.$uN(y.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,b.$Ev)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return d||i?(0,b.$Ev)(this.n(t(y.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,b.$Ev)(D.$mc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(v.userHome)return v.userHome;throw new y.$uN(y.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new y.$uN(y.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new y.$uN(y.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return o(y.VariableKind.File);case"fileWorkspaceFolder":return a(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return D.$mc(a(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return d||i?D.$kc(this.n(t(y.VariableKind.RelativeFile)),o(y.VariableKind.RelativeFile)):o(y.VariableKind.RelativeFile);case"relativeFileDirname":{const r=D.$lc(o(y.VariableKind.RelativeFileDirname));if(d||i){const h=D.$kc(this.n(t(y.VariableKind.RelativeFileDirname)),r);return h.length===0?".":h}return r}case"fileDirname":return D.$lc(o(y.VariableKind.FileDirname));case"fileExtname":return D.$nc(o(y.VariableKind.FileExtname));case"fileBasename":return D.$mc(o(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=D.$mc(o(y.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-D.$nc(r).length)}case"fileDirnameBasename":return D.$mc(D.$lc(o(y.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||S}case"execInstallFolder":{const r=this.a.getAppRoot();return r||S}case"pathSeparator":return D.sep;default:try{const r=i?`${f}:${i}`:f;return this.p(y.VariableKind.Unknown,S,r,s,void 0)}catch{return S}}}}p(v,S,f,d,s){if(f&&d){const i=s===void 0?d[f]:d[s+":"+f];if(typeof i=="string")return i;throw new y.$uN(v,(0,$.localize)(14,null,S))}return S}}e.$IN=C}),define(Ee[143],Se([1,0,5,139]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.OpenEditorContext=e.GroupsOrder=e.$NC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MC=void 0,e.$MC=(0,D.$Zh)("editorGroupsService");var g;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(g||(e.GroupDirection=g={}));var I;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(I||(e.GroupOrientation=I={}));var L;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var b;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(b||(e.GroupsArrangement=b={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function y(S){const f=S;return(0,N.$vE)(f?.editor)&&(0,N.$vE)(f?.replacement)}e.$NC=y;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var C;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(C||(e.OpenEditorContext=C={}));function m(S){const f=S;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.$OC=m;function v(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$PC=v}),define(Ee[290],Se([1,0,5,143]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=e.$QC=void 0,e.$QC=(0,D.$Zh)("editorService"),e.$RC=-1,e.$SC=-2;function g(I){const L=I;return typeof I=="number"||(0,N.$OC)(L)}e.$TC=g}),define(Ee[144],Se([1,0,5,133]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=void 0,e.$2J=(0,D.$1h)(N.$7h)}),define(Ee[145],Se([1,0,26,4,16,3]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=e.$J6b=e.$I6b=e.$H6b=void 0;class L{constructor(s,i){this.versionId=s,this.removedDueToLooping=i}}e.$H6b=L;class b{static isHostExtension(s,i,n){if(i.getExtensionDescription(s))return!1;const o=n.getExtensionDescription(s);return o?!!((o.main||o.browser)&&o.api==="none"):!1}constructor(s,i){this.j=s,this.c=new N.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new D.$fm,this.g=[],this.h=new Map;for(const s of this.e){if(this.f.has(s.identifier)){console.error("Extension `"+s.identifier.value+"` is already registered");continue}this.f.set(s.identifier,s),this.g.push(s);const i=this.j.readActivationEvents(s);for(const n of i)this.h.has(n)||this.h.set(n,[]),this.h.get(n).push(s)}}set(s){return this.e=s,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(s,i){this.e=f(this.e,i),this.e=this.e.concat(s);const n=b.l(this.e);return this.e=f(this.e,n.map(o=>o.identifier)),this.k(),this.d++,this.c.fire(void 0),new L(this.d,n)}static l(s){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,h){this.addNode(r),this.addNode(h),this.c.has(r)?this.c.get(r).push(h):this.c.set(r,[h])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,h){const u=i.getArcs(r);for(let c=0;c<u.length;c++)if(!h.has(u[c]))return!1;return!0}getNodes(){return this.e}},n=new D.$fm;for(const r of s)if(n.set(r.identifier,r),r.extensionDependencies)for(const h of r.extensionDependencies)i.addArc(D.$dm.toKey(r.identifier),D.$dm.toKey(h));const o=new Set;i.getNodes().filter(r=>i.getArcs(r).length===0).forEach(r=>o.add(r));const a=i.getNodes().filter(r=>!o.has(r));let t;do{t=!1;for(let r=0;r<a.length;r++){const h=a[r];i.hasOnlyGoodArcs(h,o)&&(a.splice(r,1),r--,o.add(h),t=!0)}}while(t);return a.map(r=>n.get(r))}containsActivationEvent(s){return this.h.has(s)}containsExtension(s){return this.f.has(s)}getExtensionDescriptionsForActivationEvent(s){const i=this.h.get(s);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(s){const i=this.f.get(s);return i||void 0}getExtensionDescriptionByUUID(s){for(const i of this.g)if(i.uuid===s)return i}getExtensionDescriptionByIdOrUUID(s,i){return this.getExtensionDescription(s)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$I6b=b;class ${constructor(s,i){this.versionId=s,this.extensions=i}}e.$J6b=$;class y{constructor(s){this.d=new m,this.c=new b(s,[])}async acquireLock(s){const i=await this.d.acquire(s);return new A(this,i)}deltaExtensions(s,i,n){if(!s.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,n)}containsActivationEvent(s){return this.c.containsActivationEvent(s)}containsExtension(s){return this.c.containsExtension(s)}getExtensionDescriptionsForActivationEvent(s){return this.c.getExtensionDescriptionsForActivationEvent(s)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(s){return this.c.getExtensionDescription(s)}getExtensionDescriptionByUUID(s){return this.c.getExtensionDescriptionByUUID(s)}getExtensionDescriptionByIdOrUUID(s,i){return this.c.getExtensionDescriptionByIdOrUUID(s,i)}}e.$K6b=y;class A extends I.$Rc{constructor(s,i){super(),this.f=s,this.c=!1,this.B(i)}isAcquiredFor(s){return!this.c&&this.f===s}}e.$L6b=A;class C{constructor(s){this.name=s,this.promise=new Promise((i,n)=>{this.c=i})}resolve(s){this.c(s)}}class m{constructor(){this.c=[],this.d=!1}async acquire(s){const i=new C(s);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const s=this.c.shift();this.d=!0;let i=!0;const n=setTimeout(()=>{i&&console.warn(`The customer named ${s.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),o=()=>{i&&(clearTimeout(n),i=!1,this.d=!1,this.e())};s.resolve((0,I.$Pc)(o))}}var v;(function(d){d[d.Builtin=0]="Builtin",d[d.User=1]="User",d[d.Dev=2]="Dev"})(v||(v={}));function S(d,s){const i=d.isBuiltin?0:d.isUnderDevelopment?2:1,n=s.isBuiltin?0:s.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=g.$fc.basename(d.extensionLocation.path),a=g.$fc.basename(s.extensionLocation.path);return o<a?-1:o>a?1:0}function f(d,s){const i=new D.$em(s);return d.filter(n=>!i.has(n.identifier))}}),define(Ee[291],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lm=e.$Km=e.$Jm=e.$Im=e.$Hm=e.ExtHostConnectionType=void 0;var D;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(D||(e.ExtHostConnectionType=D={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(C){this.pipeName=C,this.type=1}serialize(C){C[N.ENV_KEY]=this.pipeName}}e.$Hm=N;class g{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(C){C[g.ENV_KEY]="1"}}e.$Im=g;class I{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(C){C[I.ENV_KEY]="1"}}e.$Jm=I;function L(A){delete A[N.ENV_KEY],delete A[g.ENV_KEY],delete A[I.ENV_KEY]}function b(A,C){L(C),A.serialize(C)}e.$Km=b;function $(A){if(A[N.ENV_KEY])return y(A,new N(A[N.ENV_KEY]));if(A[g.ENV_KEY])return y(A,new g);if(A[I.ENV_KEY])return y(A,new I);throw new Error("No connection information defined in environment!")}e.$Lm=$;function y(A,C){return L(A),C}}),define(Ee[114],Se([1,0,22]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$mm=e.$lm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(N||(e.UIKind=N={}));var g;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(g||(e.ExtensionHostExitCode=g={}));var I;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(I||(e.MessageType=I={}));function L(y){const A=D.$fe.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$lm=L;function b(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$mm=b;var $;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(Ee[90],Se([1,0,5,4,14,27,114,65,87,24,2,3,217]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=void 0;let v=class extends C.$Rc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new N.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$yo,name:(0,m.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(i.onDidChangeLogLevel(n=>{(0,g.$jj)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===g.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,n){const o=this.getTelemetryDetails(),a=new S(i,n,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:o.isUsageEnabled,isErrorsEnabled:o.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(s,i,n){this.f=s,this.g=i,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=f(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,b.$6k)((0,$.$Fo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((n,o)=>{const a=n.filter(t=>!t.isDisposed);a.length===0?this.r.delete(o):this.r.set(o,a)}),this.r.forEach(n=>{for(const o of n)o.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const o=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!o)return this.r.delete(s.value),!1;let a=!1;for(const t of o)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$YM=v,e.$YM=v=Ke([We(0,I.$XM),We(1,g.$ij)],v);class S{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,n,o,a,t,r){this.g=n,this.h=o,this.i=a,this.j=t,this.a=new N.$Rd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,$.$Io)(i,[]),this.c&&(i=(0,y.$hn)(i,this.c)),this.b||(i=(0,y.$hn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const n={name:s.name,message:s.message,stack:s.stack,cause:s.cause},o=(0,$.$Io)(n,[]),a=new Error(o.message,{cause:o.cause});a.stack=o.stack,a.name=o.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$ZM=S;function f(d){const s=Date.now()-new Date(d).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$1M=f,e.$2M=(0,D.$Zh)("IExtHostTelemetry")}),define(Ee[25],Se([1,0,4,2,261,137,26,5]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.$UF=e.ActivationKind=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.ExtensionHostStartup=e.$OF=e.$NF=e.$MF=e.$LF=void 0,e.$LF=Object.freeze({identifier:new L.$dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$MF="extensions.webWorker",e.$NF=(0,b.$Zh)("extensionService");class ${constructor(a){this.dependency=a}}e.$OF=$;var y;(function(o){o[o.EagerAutoStart=1]="EagerAutoStart",o[o.EagerManualStart=2]="EagerManualStart",o[o.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,r){this.c=a,this.d=t.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:I.$CF.createActivationEventsMap(this.d)}}set(a,t,r){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const h=[],u=[],c=[],l=[],k=C(this.d),R=C(t),w=(j,F)=>j.extensionLocation.toString()===F.extensionLocation.toString()||j.isBuiltin===F.isBuiltin||j.isUserBuiltin===F.isUserBuiltin||j.isUnderDevelopment===F.isUnderDevelopment;for(const j of this.d){const F=R.get(j.identifier);if(!F){h.push(j.identifier),k.delete(j.identifier);continue}if(!w(j,F)){h.push(j.identifier),k.delete(j.identifier);continue}}for(const j of t){const F=k.get(j.identifier);if(!F){u.push(j);continue}if(!w(F,j)){h.push(F.identifier),k.delete(F.identifier);continue}}const p=new L.$em(this.e),E=new L.$em(r);for(const j of this.e)E.has(j)||c.push(j);for(const j of r)p.has(j)||l.push(j);const P=I.$CF.createActivationEventsMap(u),z={versionId:a,toRemove:h,toAdd:u,addActivationEvents:P,myToRemove:c,myToAdd:l};return this.delta(z),z}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:r,myToRemove:h,myToAdd:u}=a,c=new L.$em(t),l=new L.$em(h);for(let k=0;k<this.d.length;k++)c.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)l.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of u)this.e.push(k);return this.f=null,a}containsExtension(a){for(const t of this.e)if(L.$dm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const r=I.$CF.readActivationEvents(t);for(const h of r)a.add(h)}return a}}e.$PF=A;function C(o){const a=new L.$fm;for(const t of o)a.set(t.identifier,t);return a}function m(o,a){return o.enabledApiProposals?o.enabledApiProposals.includes(a):!1}e.$QF=m;function v(o,a){if(!m(o,a))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.$RF=v;class S{constructor(a,t,r,h){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=r,this.activationReason=h}}e.$SF=S;class f{constructor(a,t){this.description=a,this.value=t}}e.$TF=f;var d;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(d||(e.ActivationKind=d={}));function s(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,g.$Oo)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.$UF=s;function i(o,a){return{identifier:new L.$dm((0,g.$Mo)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!a,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform}}e.$VF=i;class n{constructor(){this.onDidRegisterExtensions=D.Event.None,this.onDidChangeExtensionsStatus=D.Event.None,this.onDidChangeExtensions=D.Event.None,this.onWillActivateByEvent=D.Event.None,this.onDidChangeResponsiveChange=D.Event.None,this.onWillStop=D.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$WF=n}),define(Ee[292],Se([1,0,8,145,26,25,14,12]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=e.$cfc=e.$bfc=e.$afc=e.$_ec=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(s,i,n,o){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=n,this.activateResolvedTime=o}}e.$_ec=$;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$afc=y;class A{constructor(s,i,n,o,a,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=n,this.module=o,this.exports=a,this.subscriptions=t}}e.$bfc=A;class C extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$cfc=C;class m extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$dfc=m;class v extends A{constructor(s){super(!0,s,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(s,i,n,o){this.g=o,this.a=s,this.b=i,this.c=n,this.d=new g.$fm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,n]of this.d)s.push(n.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const n=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(n.map(o=>({id:o.identifier,reason:{startup:i,extensionId:o.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const n=this.a.getExtensionDescription(s);if(!n)throw new Error(`Extension '${s}' is not known`);return this.h([{id:n.identifier,reason:i}])}async h(s){const i=s.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(i.map(n=>n.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const a=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new v(a));return this.c.onExtensionActivationError(s.id,a,new I.$OF(s.id.value)),t}const n=[],o=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of o){if(this.m(a))continue;const t=this.d.get(a);if(t){n.push(t);continue}if(this.l(a)){n.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:s.reason}));continue}const r=this.a.getExtensionDescription(a);if(r){if(!r.main&&!r.browser)continue;n.push(this.j({id:r.identifier,reason:s.reason}));continue}const h=i.displayName||i.identifier.value,u=new Error(`Cannot activate the '${h}' extension because it depends on unknown extension '${a}'`),c=this.k(s,i.displayName,[],new v(u));return this.c.onExtensionActivationError(i.identifier,u,new I.$OF(a)),c}return this.k(s,i.displayName,n,null)}k(s,i,n,o){const a=new f(s.id,i,s.reason,n,o,this.c,this.g);return this.d.set(s.id,a),a}l(s){return N.$I6b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$efc=S,e.$efc=S=Ke([We(3,L.$hj)],S);let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,n,o,a,t,r){this.c=s,this.d=i,this.f=n,this.g=o,this.h=a,this.j=t,this.k=r,this.a=new b.$Yg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);n.detail=i.value.activationFailedError,this.h=new v(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new v(i),this.b&&D.$3(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};f=Ke([We(6,L.$hj)],f)}),define(Ee[15],Se([1,0,19,22,164,74,80,28,160,54,100,24,18,2,29,83,135,142,139,111,67,89,290,7,25]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$GM=e.$FM=e.MarkdownString=e.$EM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var u;(function(Fe){function Ne(re){const{selectionStartLineNumber:Oe,selectionStartColumn:He,positionLineNumber:et,positionColumn:Je}=re,rt=new r.$HK(Oe-1,He-1),$t=new r.$HK(et-1,Je-1);return new r.$JK(rt,$t)}Fe.to=Ne;function De(re){const{anchor:Oe,active:He}=re;return{selectionStartLineNumber:Oe.line+1,selectionStartColumn:Oe.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Fe.from=De})(u||(e.Selection=u={}));var c;(function(Fe){function Ne(re){if(!re)return;const{start:Oe,end:He}=re;return{startLineNumber:Oe.line+1,startColumn:Oe.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Fe.from=Ne;function De(re){if(!re)return;const{startLineNumber:Oe,startColumn:He,endLineNumber:et,endColumn:Je}=re;return new r.$IK(Oe-1,He-1,et-1,Je-1)}Fe.to=De})(c||(e.Range=c={}));var l;(function(Fe){function Ne(De){switch(De){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Fe.to=Ne})(l||(e.TokenType=l={}));var k;(function(Fe){function Ne(re){return new r.$HK(re.lineNumber-1,re.column-1)}Fe.to=Ne;function De(re){return{lineNumber:re.line+1,column:re.character+1}}Fe.from=De})(k||(e.Position=k={}));var R;(function(Fe){function Ne(Oe,He,et){return(0,D.$Gb)((0,D.$2b)(Oe).map(Je=>De(Je,He,et)))}Fe.from=Ne;function De(Oe,He,et){if(typeof Oe=="string")return{$serialized:!0,language:Oe,isBuiltin:et?.isBuiltin};if(Oe)return{$serialized:!0,language:Oe.language,scheme:re(Oe.scheme,He),pattern:le.from(Oe.pattern)??void 0,exclusive:Oe.exclusive,notebookType:Oe.notebookType,isBuiltin:et?.isBuiltin}}function re(Oe,He){return He&&typeof Oe=="string"?He.transformOutgoingScheme(Oe):Oe}})(R||(e.DocumentSelector=R={}));var w;(function(Fe){function Ne(re){switch(re){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Fe.from=Ne;function De(re){switch(re){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Fe.to=De})(w||(e.DiagnosticTag=w={}));var p;(function(Fe){function Ne(re){let Oe;return re.code&&((0,m.$Cf)(re.code)||(0,m.$Gf)(re.code)?Oe=String(re.code):Oe={value:String(re.code.value),target:re.code.target}),{...c.from(re.range),message:re.message,source:re.source,code:Oe,severity:P.from(re.severity),relatedInformation:re.relatedInformation&&re.relatedInformation.map(E.from),tags:Array.isArray(re.tags)?(0,D.$Gb)(re.tags.map(w.from)):void 0}}Fe.from=Ne;function De(re){const Oe=new r.$UK(c.to(re),re.message,P.to(re.severity));return Oe.source=re.source,Oe.code=(0,m.$Cf)(re.code)?re.code:re.code?.value,Oe.relatedInformation=re.relatedInformation&&re.relatedInformation.map(E.to),Oe.tags=re.tags&&(0,D.$Gb)(re.tags.map(w.to)),Oe}Fe.to=De})(p||(e.Diagnostic=p={}));var E;(function(Fe){function Ne(re){return{...c.from(re.location.range),message:re.message,resource:re.location.uri}}Fe.from=Ne;function De(re){return new r.$TK(new r.$SK(re.resource,c.to(re)),re.message)}Fe.to=De})(E||(e.DiagnosticRelatedInformation=E={}));var P;(function(Fe){function Ne(re){switch(re){case r.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}Fe.from=Ne;function De(re){switch(re){case d.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Fe.to=De})(P||(e.DiagnosticSeverity=P={}));var z;(function(Fe){function Ne(re){return typeof re=="number"&&re>=r.ViewColumn.One?re-1:re===r.ViewColumn.Beside?t.$SC:t.$RC}Fe.from=Ne;function De(re){if(typeof re=="number"&&re>=0)return re+1;throw new Error("invalid 'EditorGroupColumn'")}Fe.to=De})(z||(e.ViewColumn=z={}));function j(Fe){return typeof Fe.range<"u"}function F(Fe){return Fe.length===0?!0:!!j(Fe[0])}e.$EM=F;var O;(function(Fe){function Ne(Je){return Je.map(Fe.from)}Fe.fromMany=Ne;function De(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function re(Je){let rt;if(De(Je)){const{language:wt,value:Nt}=Je;rt={value:"```"+wt+`
`+Nt+"\n```\n"}}else r.$8K.isMarkdownString(Je)?rt={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?rt={value:Je}:rt={value:""};const $t=Object.create(null);rt.uris=$t;const pt=wt=>{try{let Nt=v.URI.parse(wt,!0);Nt=Nt.with({query:Oe(Nt.query,$t)}),$t[wt]=Nt}catch{}return""},Mt=new $.marked.Renderer;return Mt.link=pt,Mt.image=wt=>typeof wt=="string"?pt(L.$hk(wt).href):"",(0,$.marked)(rt.value,{renderer:Mt}),rt}Fe.from=re;function Oe(Je,rt){if(!Je)return Je;let $t;try{$t=(0,y.$vh)(Je)}catch{}if(!$t)return Je;let pt=!1;return $t=(0,C.$gn)($t,Mt=>{if(v.URI.isUri(Mt)){const wt=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[wt]=Mt,pt=!0,wt}else return}),pt?JSON.stringify($t):Je}function He(Je){const rt=new r.$8K(Je.value,Je.supportThemeIcons);return rt.isTrusted=Je.isTrusted,rt.supportHtml=Je.supportHtml,rt.baseUri=Je.baseUri?v.URI.from(Je.baseUri):void 0,rt}Fe.to=He;function et(Je){if(Je)return typeof Je=="string"?Je:Fe.from(Je)}Fe.fromStrict=et})(O||(e.MarkdownString=O={}));function T(Fe){return F(Fe)?Fe.map(Ne=>({range:c.from(Ne.range),hoverMessage:Array.isArray(Ne.hoverMessage)?O.fromMany(Ne.hoverMessage):Ne.hoverMessage?O.from(Ne.hoverMessage):void 0,renderOptions:Ne.renderOptions})):Fe.map(Ne=>({range:c.from(Ne)}))}e.$FM=T;function M(Fe){return typeof Fe>"u"?Fe:typeof Fe=="string"?v.URI.file(Fe):Fe}e.$GM=M;var W;(function(Fe){function Ne(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?M(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Fe.from=Ne})(W||(e.ThemableDecorationAttachmentRenderOptions=W={}));var Y;(function(Fe){function Ne(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?M(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?W.from(De.before):void 0,after:De.after?W.from(De.after):void 0}}Fe.from=Ne})(Y||(e.ThemableDecorationRenderOptions=Y={}));var ue;(function(Fe){function Ne(De){if(typeof De>"u")return De;switch(De){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Fe.from=Ne})(ue||(e.DecorationRangeBehavior=ue={}));var Z;(function(Fe){function Ne(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?ue.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?Y.from(De.light):void 0,dark:De.dark?Y.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?M(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?W.from(De.before):void 0,after:De.after?W.from(De.after):void 0}}Fe.from=Ne})(Z||(e.DecorationRenderOptions=Z={}));var Q;(function(Fe){function Ne(re){return{text:re.newText,eol:re.newEol&&Te.from(re.newEol),range:c.from(re.range)}}Fe.from=Ne;function De(re){const Oe=new r.$NK(c.to(re.range),re.text);return Oe.newEol=typeof re.eol>"u"?void 0:Te.to(re.eol),Oe}Fe.to=De})(Q||(e.TextEdit=Q={}));var x;(function(Fe){function Ne(re,Oe){const He={edits:[]};if(re instanceof r.$QK){const et=new b.$Ac;for(const Je of re._allEntries())Je._type===1&&v.URI.isUri(Je.to)&&Je.from===void 0&&et.add(Je.to);for(const Je of re._allEntries())if(Je._type===1){let rt;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?rt={type:"base64",value:(0,N.$ze)(N.$fe.wrap(Je.options.contents))}:rt={type:"dataTransferItem",id:Je.options.contents._itemId}),He.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:rt},metadata:Je.metadata})}else Je._type===2?He.edits.push({resource:Je.uri,textEdit:Q.from(Je.edit),versionId:et.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?He.edits.push({resource:Je.uri,textEdit:{range:c.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:et.has(Je.uri)?void 0:Oe?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?He.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&He.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Oe?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(kt.from)}})}return He}Fe.from=Ne;function De(re){const Oe=new r.$QK,He=new b.$zc;for(const et of re.edits)if(et.textEdit){const Je=et,rt=v.URI.revive(Je.resource),$t=c.to(Je.textEdit.range),pt=Je.textEdit.text,Mt=Je.textEdit.insertAsSnippet;let wt;Mt?wt=r.$PK.replace($t,new r.$RK(pt)):wt=r.$NK.replace($t,pt);const Nt=He.get(rt);Nt?Nt.push(wt):He.set(rt,[wt])}else Oe.renameFile(v.URI.revive(et.oldResource),v.URI.revive(et.newResource),et.options);for(const[et,Je]of He)Oe.set(et,Je);return Oe}Fe.to=De})(x||(e.WorkspaceEdit=x={}));var oe;(function(Fe){const Ne=Object.create(null);Ne[r.SymbolKind.File]=0,Ne[r.SymbolKind.Module]=1,Ne[r.SymbolKind.Namespace]=2,Ne[r.SymbolKind.Package]=3,Ne[r.SymbolKind.Class]=4,Ne[r.SymbolKind.Method]=5,Ne[r.SymbolKind.Property]=6,Ne[r.SymbolKind.Field]=7,Ne[r.SymbolKind.Constructor]=8,Ne[r.SymbolKind.Enum]=9,Ne[r.SymbolKind.Interface]=10,Ne[r.SymbolKind.Function]=11,Ne[r.SymbolKind.Variable]=12,Ne[r.SymbolKind.Constant]=13,Ne[r.SymbolKind.String]=14,Ne[r.SymbolKind.Number]=15,Ne[r.SymbolKind.Boolean]=16,Ne[r.SymbolKind.Array]=17,Ne[r.SymbolKind.Object]=18,Ne[r.SymbolKind.Key]=19,Ne[r.SymbolKind.Null]=20,Ne[r.SymbolKind.EnumMember]=21,Ne[r.SymbolKind.Struct]=22,Ne[r.SymbolKind.Event]=23,Ne[r.SymbolKind.Operator]=24,Ne[r.SymbolKind.TypeParameter]=25;function De(Oe){return typeof Ne[Oe]=="number"?Ne[Oe]:6}Fe.from=De;function re(Oe){for(const He in Ne)if(Ne[He]===Oe)return Number(He);return r.SymbolKind.Property}Fe.to=re})(oe||(e.SymbolKind=oe={}));var X;(function(Fe){function Ne(re){switch(re){case r.SymbolTag.Deprecated:return 1}}Fe.from=Ne;function De(re){switch(re){case 1:return r.SymbolTag.Deprecated}}Fe.to=De})(X||(e.SymbolTag=X={}));var ve;(function(Fe){function Ne(re){return{name:re.name,kind:oe.from(re.kind),tags:re.tags&&re.tags.map(X.from),containerName:re.containerName,location:ye.from(re.location)}}Fe.from=Ne;function De(re){const Oe=new r.$YK(re.name,oe.to(re.kind),re.containerName,ye.to(re.location));return Oe.tags=re.tags&&re.tags.map(X.to),Oe}Fe.to=De})(ve||(e.WorkspaceSymbol=ve={}));var ge;(function(Fe){function Ne(re){const Oe={name:re.name||"!!MISSING: name!!",detail:re.detail,range:c.from(re.range),selectionRange:c.from(re.selectionRange),kind:oe.from(re.kind),tags:re.tags?.map(X.from)??[]};return re.children&&(Oe.children=re.children.map(Ne)),Oe}Fe.from=Ne;function De(re){const Oe=new r.$ZK(re.name,re.detail,oe.to(re.kind),c.to(re.range),c.to(re.selectionRange));return(0,D.$Kb)(re.tags)&&(Oe.tags=re.tags.map(X.to)),re.children&&(Oe.children=re.children.map(De)),Oe}Fe.to=De})(ge||(e.DocumentSymbol=ge={}));var V;(function(Fe){function Ne(re){const Oe=new r.$4K(oe.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Oe._sessionId=re._sessionId,Oe._itemId=re._itemId,Oe}Fe.to=Ne;function De(re,Oe,He){if(Oe=Oe??re._sessionId,He=He??re._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,name:re.name,detail:re.detail,kind:oe.from(re.kind),uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(X.from)}}Fe.from=De})(V||(e.CallHierarchyItem=V={}));var U;(function(Fe){function Ne(De){return new r.$5K(V.to(De.from),De.fromRanges.map(re=>c.to(re)))}Fe.to=Ne})(U||(e.CallHierarchyIncomingCall=U={}));var ne;(function(Fe){function Ne(De){return new r.$6K(V.to(De.to),De.fromRanges.map(re=>c.to(re)))}Fe.to=Ne})(ne||(e.CallHierarchyOutgoingCall=ne={}));var ye;(function(Fe){function Ne(re){return{range:re.range&&c.from(re.range),uri:re.uri}}Fe.from=Ne;function De(re){return new r.$SK(v.URI.revive(re.uri),c.to(re.range))}Fe.to=De})(ye||(e.location=ye={}));var fe;(function(Fe){function Ne(re){const Oe=re,He=re;return{originSelectionRange:Oe.originSelectionRange?c.from(Oe.originSelectionRange):void 0,uri:Oe.targetUri?Oe.targetUri:He.uri,range:c.from(Oe.targetRange?Oe.targetRange:He.range),targetSelectionRange:Oe.targetSelectionRange?c.from(Oe.targetSelectionRange):void 0}}Fe.from=Ne;function De(re){return{targetUri:v.URI.revive(re.uri),targetRange:c.to(re.range),targetSelectionRange:re.targetSelectionRange?c.to(re.targetSelectionRange):void 0,originSelectionRange:re.originSelectionRange?c.to(re.originSelectionRange):void 0}}Fe.to=De})(fe||(e.DefinitionLink=fe={}));var me;(function(Fe){function Ne(re){return{range:c.from(re.range),contents:O.fromMany(re.contents)}}Fe.from=Ne;function De(re){return new r.$VK(re.contents.map(O.to),c.to(re.range))}Fe.to=De})(me||(e.Hover=me={}));var ee;(function(Fe){function Ne(re){return{range:c.from(re.range),expression:re.expression}}Fe.from=Ne;function De(re){return new r.$PL(c.to(re.range),re.expression)}Fe.to=De})(ee||(e.EvaluatableExpression=ee={}));var ie;(function(Fe){function Ne(re){if(re instanceof r.$QL)return{type:"text",range:c.from(re.range),text:re.text};if(re instanceof r.$RL)return{type:"variable",range:c.from(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};if(re instanceof r.$SL)return{type:"expression",range:c.from(re.range),expression:re.expression};throw new Error("Unknown 'InlineValue' type")}Fe.from=Ne;function De(re){switch(re.type){case"text":return{range:c.to(re.range),text:re.text};case"variable":return{range:c.to(re.range),variableName:re.variableName,caseSensitiveLookup:re.caseSensitiveLookup};case"expression":return{range:c.to(re.range),expression:re.expression}}}Fe.to=De})(ie||(e.InlineValue=ie={}));var G;(function(Fe){function Ne(re){return{frameId:re.frameId,stoppedLocation:c.from(re.stoppedLocation)}}Fe.from=Ne;function De(re){return new r.$TL(re.frameId,c.to(re.stoppedLocation))}Fe.to=De})(G||(e.InlineValueContext=G={}));var te;(function(Fe){function Ne(re){return{range:c.from(re.range),kind:re.kind}}Fe.from=Ne;function De(re){return new r.$WK(c.to(re.range),re.kind)}Fe.to=De})(te||(e.DocumentHighlight=te={}));var J;(function(Fe){function Ne(re){return{uri:re.uri,highlights:re.highlights.map(te.from)}}Fe.from=Ne;function De(re){return new r.$XK(v.URI.revive(re.uri),re.highlights.map(te.to))}Fe.to=De})(J||(e.MultiDocumentHighlight=J={}));var ce;(function(Fe){function Ne(De){switch(De){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Fe.to=Ne})(ce||(e.CompletionTriggerKind=ce={}));var be;(function(Fe){function Ne(De){return{triggerKind:ce.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Fe.to=Ne})(be||(e.CompletionContext=be={}));var Ie;(function(Fe){function Ne(re){switch(re){case r.CompletionItemTag.Deprecated:return 1}}Fe.from=Ne;function De(re){switch(re){case 1:return r.CompletionItemTag.Deprecated}}Fe.to=De})(Ie||(e.CompletionItemTag=Ie={}));var Me;(function(Fe){const Ne=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function De(He){return Ne.get(He)??9}Fe.from=De;const re=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Oe(He){return re.get(He)??r.CompletionItemKind.Property}Fe.to=Oe})(Me||(e.CompletionItemKind=Me={}));var B;(function(Fe){function Ne(De,re){const Oe=new r.$bL(De.label);return Oe.insertText=De.insertText,Oe.kind=Me.to(De.kind),Oe.tags=De.tags?.map(Ie.to),Oe.detail=De.detail,Oe.documentation=L.$ck(De.documentation)?O.to(De.documentation):De.documentation,Oe.sortText=De.sortText,Oe.filterText=De.filterText,Oe.preselect=De.preselect,Oe.commitCharacters=De.commitCharacters,S.$Ds.isIRange(De.range)?Oe.range=c.to(De.range):typeof De.range=="object"&&(Oe.range={inserting:c.to(De.range.insert),replacing:c.to(De.range.replace)}),Oe.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Oe.insertText=new r.$RK(De.insertText):(Oe.insertText=De.insertText,Oe.textEdit=Oe.range instanceof r.$IK?new r.$NK(Oe.range,Oe.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Oe.additionalTextEdits=De.additionalTextEdits.map(He=>Q.to(He))),Oe.command=re&&De.command?re.fromInternal(De.command):void 0,Oe}Fe.to=Ne})(B||(e.CompletionItem=B={}));var _;(function(Fe){function Ne(re){if(typeof re.label!="string"&&!Array.isArray(re.label))throw new TypeError("Invalid label");return{label:re.label,documentation:O.fromStrict(re.documentation)}}Fe.from=Ne;function De(re){return{label:re.label,documentation:L.$ck(re.documentation)?O.to(re.documentation):re.documentation}}Fe.to=De})(_||(e.ParameterInformation=_={}));var se;(function(Fe){function Ne(re){return{label:re.label,documentation:O.fromStrict(re.documentation),parameters:Array.isArray(re.parameters)?re.parameters.map(_.from):[],activeParameter:re.activeParameter}}Fe.from=Ne;function De(re){return{label:re.label,documentation:L.$ck(re.documentation)?O.to(re.documentation):re.documentation,parameters:Array.isArray(re.parameters)?re.parameters.map(_.to):[],activeParameter:re.activeParameter}}Fe.to=De})(se||(e.SignatureInformation=se={}));var K;(function(Fe){function Ne(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.from):[]}}Fe.from=Ne;function De(re){return{activeSignature:re.activeSignature,activeParameter:re.activeParameter,signatures:Array.isArray(re.signatures)?re.signatures.map(se.to):[]}}Fe.to=De})(K||(e.SignatureHelp=K={}));var ae;(function(Fe){function Ne(De,re){const Oe=new r.$aL(k.to(re.position),typeof re.label=="string"?re.label:re.label.map(de.to.bind(void 0,De)),re.kind&&Re.to(re.kind));return Oe.textEdits=re.textEdits&&re.textEdits.map(Q.to),Oe.tooltip=L.$ck(re.tooltip)?O.to(re.tooltip):re.tooltip,Oe.paddingLeft=re.paddingLeft,Oe.paddingRight=re.paddingRight,Oe}Fe.to=Ne})(ae||(e.InlayHint=ae={}));var de;(function(Fe){function Ne(De,re){const Oe=new r.$_K(re.label);return Oe.tooltip=L.$ck(re.tooltip)?O.to(re.tooltip):re.tooltip,f.Command.is(re.command)&&(Oe.command=De.fromInternal(re.command)),re.location&&(Oe.location=ye.to(re.location)),Oe}Fe.to=Ne})(de||(e.InlayHintLabelPart=de={}));var Re;(function(Fe){function Ne(re){return re}Fe.from=Ne;function De(re){return re}Fe.to=De})(Re||(e.InlayHintKind=Re={}));var Be;(function(Fe){function Ne(re){return{range:c.from(re.range),url:re.target,tooltip:re.tooltip}}Fe.from=Ne;function De(re){let Oe;if(re.url)try{Oe=typeof re.url=="string"?v.URI.parse(re.url,!0):v.URI.revive(re.url)}catch{}return new r.$gL(c.to(re.range),Oe)}Fe.to=De})(Be||(e.DocumentLink=Be={}));var Xe;(function(Fe){function Ne(re){const Oe=new r.$jL(re.label);return re.textEdit&&(Oe.textEdit=Q.to(re.textEdit)),re.additionalTextEdits&&(Oe.additionalTextEdits=re.additionalTextEdits.map(He=>Q.to(He))),Oe}Fe.to=Ne;function De(re){return{label:re.label,textEdit:re.textEdit?Q.from(re.textEdit):void 0,additionalTextEdits:re.additionalTextEdits?re.additionalTextEdits.map(Oe=>Q.from(Oe)):void 0}}Fe.from=De})(Xe||(e.ColorPresentation=Xe={}));var Ye;(function(Fe){function Ne(re){return new r.$hL(re[0],re[1],re[2],re[3])}Fe.to=Ne;function De(re){return[re.red,re.green,re.blue,re.alpha]}Fe.from=De})(Ye||(e.Color=Ye={}));var it;(function(Fe){function Ne(re){return{range:c.from(re.range)}}Fe.from=Ne;function De(re){return new r.$3K(c.to(re.range))}Fe.to=De})(it||(e.SelectionRange=it={}));var st;(function(Fe){function Ne(De){switch(De){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Fe.to=Ne})(st||(e.TextDocumentSaveReason=st={}));var Pe;(function(Fe){function Ne(re){switch(re){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Fe.from=Ne;function De(re){switch(re){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Fe.to=De})(Pe||(e.TextEditorLineNumbersStyle=Pe={}));var Te;(function(Fe){function Ne(re){if(re===r.EndOfLine.CRLF)return 1;if(re===r.EndOfLine.LF)return 0}Fe.from=Ne;function De(re){if(re===1)return r.EndOfLine.CRLF;if(re===0)return r.EndOfLine.LF}Fe.to=De})(Te||(e.EndOfLine=Te={}));var qe;(function(Fe){function Ne(De){if(typeof De=="object")return De.viewId;switch(De){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Fe.from=Ne})(qe||(e.ProgressLocation=qe={}));var Le;(function(Fe){function Ne(re){const Oe={start:re.start+1,end:re.end+1};return re.kind&&(Oe.kind=xe.from(re.kind)),Oe}Fe.from=Ne;function De(re){const Oe={start:re.start-1,end:re.end-1};return re.kind&&(Oe.kind=xe.to(re.kind)),Oe}Fe.to=De})(Le||(e.FoldingRange=Le={}));var xe;(function(Fe){function Ne(re){if(re)switch(re){case r.FoldingRangeKind.Comment:return f.$tt.Comment;case r.FoldingRangeKind.Imports:return f.$tt.Imports;case r.FoldingRangeKind.Region:return f.$tt.Region}}Fe.from=Ne;function De(re){if(re)switch(re.value){case f.$tt.Comment.value:return r.FoldingRangeKind.Comment;case f.$tt.Imports.value:return r.FoldingRangeKind.Imports;case f.$tt.Region.value:return r.FoldingRangeKind.Region}}Fe.to=De})(xe||(e.FoldingRangeKind=xe={}));var he;(function(Fe){function Ne(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?c.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$hE.id:void 0}}Fe.from=Ne})(he||(e.TextEditorOpenOptions=he={}));var le;(function(Fe){function Ne(He){return He instanceof r.$DL?He.toJSON():typeof He=="string"?He:De(He)||re(He)?new r.$DL(He.baseUri??He.base,He.pattern).toJSON():He}Fe.from=Ne;function De(He){const et=He;return et?v.URI.isUri(et.baseUri)&&typeof et.pattern=="string":!1}function re(He){const et=He;return et?typeof et.base=="string"&&typeof et.pattern=="string":!1}function Oe(He){return typeof He=="string"?He:new r.$DL(v.URI.revive(He.baseUri),He.pattern)}Fe.to=Oe})(le||(e.GlobPattern=le={}));var Ce;(function(Fe){function Ne(De){if(De){if(Array.isArray(De))return De.map(Ne);if(typeof De=="string")return De;{const re=De;return{language:re.language,scheme:re.scheme,pattern:le.from(re.pattern),exclusive:re.exclusive,notebookType:re.notebookType}}}else return}Fe.from=Ne})(Ce||(e.LanguageSelector=Ce={}));var Ve;(function(Fe){function Ne(re){return!!re&&typeof re=="object"&&"documents"in re&&Array.isArray(re.documents)&&re.documents.every(Oe=>Array.isArray(Oe)&&Oe.every(He=>He&&typeof He=="object"&&"uri"in He&&v.URI.isUri(He.uri)&&"version"in He&&typeof He.version=="number"&&"ranges"in He&&Array.isArray(He.ranges)&&He.ranges.every(et=>et instanceof r.$IK)))}Fe.is=Ne;function De(re){return{documents:re.documents.map(Oe=>Oe.map(He=>({uri:v.URI.from(He.uri),version:He.version,ranges:He.ranges.map(et=>c.from(et))})))}}Fe.from=De})(Ve||(e.MappedEditsContext=Ve={}));var Ge;(function(Fe){function Ne(re){return{start:re.start,end:re.end}}Fe.from=Ne;function De(re){return new r.$5L(re.start,re.end)}Fe.to=De})(Ge||(e.NotebookRange=Ge={}));var _e;(function(Fe){function Ne(re){return{timing:typeof re.runStartTime=="number"&&typeof re.runEndTime=="number"?{startTime:re.runStartTime,endTime:re.runEndTime}:void 0,executionOrder:re.executionOrder,success:re.lastRunSuccess}}Fe.to=Ne;function De(re){return{lastRunSuccess:re.success,runStartTime:re.timing?.startTime,runEndTime:re.timing?.endTime,executionOrder:re.executionOrder}}Fe.from=De})(_e||(e.NotebookCellExecutionSummary=_e={}));var ot;(function(Fe){function Ne(De){if(De===n.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(De===n.NotebookCellExecutionState.Pending)return;if(De===n.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Fe.to=Ne})(ot||(e.NotebookCellExecutionState=ot={}));var ut;(function(Fe){function Ne(re){switch(re){case r.NotebookCellKind.Markup:return n.CellKind.Markup;case r.NotebookCellKind.Code:default:return n.CellKind.Code}}Fe.from=Ne;function De(re){switch(re){case n.CellKind.Markup:return r.NotebookCellKind.Markup;case n.CellKind.Code:default:return r.NotebookCellKind.Code}}Fe.to=De})(ut||(e.NotebookCellKind=ut={}));var je;(function(Fe){function Ne(re){const Oe={metadata:re.metadata??Object.create(null),cells:[]};for(const He of re.cells)r.$6L.validate(He),Oe.cells.push(kt.from(He));return Oe}Fe.from=Ne;function De(re){const Oe=new r.$7L(re.cells.map(kt.to));return(0,m.$Pf)(re.metadata)||(Oe.metadata=re.metadata),Oe}Fe.to=De})(je||(e.NotebookData=je={}));var kt;(function(Fe){function Ne(re){return{cellKind:ut.from(re.kind),language:re.languageId,mime:re.mime,source:re.value,metadata:re.metadata,internalMetadata:_e.from(re.executionSummary??{}),outputs:re.outputs?re.outputs.map(jt.from):[]}}Fe.from=Ne;function De(re){return new r.$6L(ut.to(re.cellKind),re.source,re.language,re.mime,re.outputs?re.outputs.map(jt.to):void 0,re.metadata,re.internalMetadata?_e.to(re.internalMetadata):void 0)}Fe.to=De})(kt||(e.NotebookCellData=kt={}));var Ht;(function(Fe){function Ne(re){return{mime:re.mime,valueBytes:N.$fe.wrap(re.data)}}Fe.from=Ne;function De(re){return new r.$8L(re.valueBytes.buffer,re.mime)}Fe.to=De})(Ht||(e.NotebookCellOutputItem=Ht={}));var jt;(function(Fe){function Ne(re){return{outputId:re.id,items:re.items.map(Ht.from),metadata:re.metadata}}Fe.from=Ne;function De(re){const Oe=re.items.map(Ht.to);return new r.$9L(Oe,re.outputId,re.metadata)}Fe.to=De})(jt||(e.NotebookCellOutput=jt={}));var yt;(function(Fe){function Ne(Oe){return re(Oe)?{include:le.from(Oe.include)??void 0,exclude:le.from(Oe.exclude)??void 0}:le.from(Oe)??void 0}Fe.from=Ne;function De(Oe){return re(Oe)?{include:le.to(Oe.include),exclude:le.to(Oe.exclude)}:le.to(Oe)}Fe.to=De;function re(Oe){const He=Oe;return He?!(0,m.$Lf)(He.include)&&!(0,m.$Lf)(He.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var Wt;(function(Fe){function Ne(De,re,Oe){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:re.toInternal(He,Oe),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Fe.from=Ne})(Wt||(e.NotebookStatusBarItem=Wt={}));var zt;(function(Fe){function Ne(De,re,Oe){const He=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:re.toInternal(He,Oe),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Fe.from=Ne})(zt||(e.NotebookKernelSourceAction=zt={}));var Kt;(function(Fe){function Ne(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Fe.from=Ne})(Kt||(e.NotebookDocumentContentOptions=Kt={}));var Gt;(function(Fe){function Ne(re){return{uri:re.uri,provides:re.provides}}Fe.from=Ne;function De(re){return new r.$$L(v.URI.revive(re.uri),re.provides)}Fe.to=De})(Gt||(e.NotebookRendererScript=Gt={}));var Rt;(function(Fe){function Ne(re){return{message:O.fromStrict(re.message)||"",type:0,expected:re.expectedOutput,actual:re.actualOutput,contextValue:re.contextValue,location:re.location&&{range:c.from(re.location.range),uri:re.location.uri}}}Fe.from=Ne;function De(re){const Oe=new r.$eM(typeof re.message=="string"?re.message:O.to(re.message));return Oe.actualOutput=re.actual,Oe.expectedOutput=re.expected,Oe.contextValue=re.contextValue,Oe.location=re.location?ye.to(re.location):void 0,Oe}Fe.to=De})(Rt||(e.TestMessage=Rt={}));var Ct;(function(Fe){Fe.namespace=a.$AJ,Fe.denamespace=a.$BJ})(Ct||(e.TestTag=Ct={}));var tt;(function(Fe){function Ne(re){const Oe=(0,s.$DM)(re).controllerId;return{extId:o.$wJ.fromExtHostTestItem(re,Oe).toString(),label:re.label,uri:v.URI.revive(re.uri),busy:re.busy,tags:re.tags.map(He=>Ct.namespace(Oe,He.id)),range:S.$Ds.lift(c.from(re.range)),description:re.description||null,sortText:re.sortText||null,error:re.error&&O.fromStrict(re.error)||null}}Fe.from=Ne;function De(re){return{parent:void 0,error:void 0,id:o.$wJ.fromString(re.extId).localId,label:re.label,uri:v.URI.revive(re.uri),tags:(re.tags||[]).map(Oe=>{const{tagId:He}=Ct.denamespace(Oe);return new r.$fM(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:c.to(re.range||void 0),canResolveChildren:!1,busy:re.busy,description:re.description||void 0,sortText:re.sortText||void 0}}Fe.toPlain=De})(tt||(e.TestItem=tt={})),function(Fe){function Ne(re){return{id:re.id}}Fe.from=Ne;function De(re){return new r.$fM(re.id)}Fe.to=De}(Ct||(e.TestTag=Ct={}));var Jt;(function(Fe){const Ne=(re,Oe)=>{const He=[];for(const[Je,rt]of Oe)o.$wJ.compare(rt.item.extId,Je)===2&&(Oe.delete(Je),He.push(rt));const et={...tt.toPlain(re.item),parent:void 0,taskStates:re.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(rt=>rt.type===0).map(Rt.to)})),children:He.map(Je=>Ne(Je,Oe))};for(const Je of et.children)Je.parent=et;return et};function De(re){const Oe=[],He=new Map;for(const et of re.items){He.set(et.item.extId,et);const Je=o.$wJ.root(et.item.extId);re.request.targets.some(rt=>rt.controllerId===Je&&rt.testIds.includes(et.item.extId))&&Oe.push(et)}return{completedAt:re.completedAt,results:Oe.map(et=>Ne(et,He))}}Fe.to=De})(Jt||(e.TestResults=Jt={}));var qt;(function(Fe){function Ne(He){return{covered:He.covered,total:He.total}}function De(He){return"line"in He?k.from(He):c.from(He)}function re(He){return"branches"in He?{count:He.executionCount,location:De(He.location),type:1,branches:He.branches.length?He.branches.map(et=>({count:et.executionCount,location:et.location&&De(et.location)})):void 0}:{type:0,name:He.name,count:He.executionCount,location:De(He.location)}}Fe.fromDetailed=re;function Oe(He){return{uri:He.uri,statement:Ne(He.statementCoverage),branch:He.branchCoverage&&Ne(He.branchCoverage),function:He.functionCoverage&&Ne(He.functionCoverage),details:He.detailedCoverage?.map(re)}}Fe.fromFile=Oe})(qt||(e.TestCoverage=qt={}));var lt;(function(Fe){function Ne(De){switch(De){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Fe.to=Ne})(lt||(e.CodeActionTriggerKind=lt={}));var mt;(function(Fe){function Ne(re){const Oe=new r.$lM(oe.to(re.kind),re.name,re.detail||"",v.URI.revive(re.uri),c.to(re.range),c.to(re.selectionRange));return Oe._sessionId=re._sessionId,Oe._itemId=re._itemId,Oe}Fe.to=Ne;function De(re,Oe,He){if(Oe=Oe??re._sessionId,He=He??re._itemId,Oe===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Oe,_itemId:He,kind:oe.from(re.kind),name:re.name,detail:re.detail??"",uri:re.uri,range:c.from(re.range),selectionRange:c.from(re.selectionRange),tags:re.tags?.map(X.from)}}Fe.from=De})(mt||(e.TypeHierarchyItem=mt={}));var Zt;(function(Fe){function Ne(De){if(De)return{value:De.value,tooltip:De.tooltip}}Fe.from=Ne})(Zt||(e.ViewBadge=Zt={}));var It;(function(Fe){function Ne(He,et,Je){const rt=et.fileData;return rt?new r.$wL(new r.$xL(rt.name,v.URI.revive(rt.uri),rt.id,(0,I.$cb)(()=>Je(rt.id)))):He===A.$Zr.uriList&&et.uriListData?new r.$vL(Oe(et.uriListData)):new r.$vL(et.asString)}Fe.to=Ne;async function De(He,et){const Je=await et.asString();if(He===A.$Zr.uriList)return{asString:Je,fileData:void 0,uriListData:re(Je)};const rt=et.asFile();return{asString:Je,fileData:rt?{name:rt.name,uri:rt.uri,id:rt._itemId??rt.id}:void 0}}Fe.from=De;function re(He){return g.$at.split(He).map(et=>{if(et.startsWith("#"))return et;try{return v.URI.parse(et)}catch{}return et})}function Oe(He){return g.$at.create(He.map(et=>typeof et=="string"?et:v.URI.revive(et)))}})(It||(e.DataTransferItem=It={}));var St;(function(Fe){function Ne(re,Oe){const He=re.items.map(([et,Je])=>[et,It.to(et,Je,Oe)]);return new r.$yL(He)}Fe.toDataTransfer=Ne;async function De(re){const Oe={items:[]},He=[];for(const[et,Je]of re)He.push((async()=>{Oe.items.push([et,await It.from(et,Je)])})());return await Promise.all(He),Oe}Fe.from=De})(St||(e.DataTransfer=St={}));var ft;(function(Fe){function Ne(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Fe.from=Ne})(ft||(e.ChatReplyFollowup=ft={}));var At;(function(Fe){function Ne(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:ft.from(De)}Fe.from=Ne})(At||(e.ChatFollowup=At={}));var Ot;(function(Fe){function Ne(re){const Oe=new r.$wM(Et.to(re.role),re.content);return Oe.name=re.name,Oe}Fe.to=Ne;function De(re){return{role:Et.from(re.role),content:re.content,name:re.name}}Fe.from=De})(Ot||(e.ChatMessage=Ot={}));var Et;(function(Fe){function Ne(re){switch(re){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}Fe.to=Ne;function De(re){switch(re){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}Fe.from=De})(Et||(e.ChatMessageRole=Et={}));var Qe;(function(Fe){function Ne(Oe){const He={};for(const et of Object.keys(Oe))He[et]=Oe[et].map(Fe.to);return He}Fe.objectTo=Ne;function De(Oe){return{level:Lt.to(Oe.level),value:Oe.value,description:Oe.description}}Fe.to=De;function re(Oe){return{level:Lt.from(Oe.level),value:Oe.value,description:Oe.description}}Fe.from=re})(Qe||(e.ChatVariable=Qe={}));var Lt;(function(Fe){function Ne(re){switch(re){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}Fe.to=Ne;function De(re){switch(re){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}Fe.from=De})(Lt||(e.ChatVariableLevel=Lt={}));var Ut;(function(Fe){function Ne(De){switch(De){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}Fe.to=Ne})(Ut||(e.InteractiveEditorResponseFeedbackKind=Ut={}));var Qt;(function(Fe){function Ne(De,re){return"placeholder"in re&&"resolvedContent"in re?{content:re.placeholder,kind:"asyncContent"}:"markdownContent"in re?((0,h.$RF)(De,"chatAgents2Additions"),{content:O.from(re.markdownContent),kind:"markdownContent"}):"content"in re?"vulnerabilities"in re&&re.vulnerabilities?((0,h.$RF)(De,"chatAgents2Additions"),{content:re.content,vulnerabilities:re.vulnerabilities,kind:"vulnerability"}):typeof re.content=="string"?{content:re.content,kind:"content"}:((0,h.$RF)(De,"chatAgents2Additions"),{content:O.from(re.content),kind:"markdownContent"}):"documents"in re?{documents:re.documents.map(Oe=>({uri:Oe.uri,version:Oe.version,ranges:Oe.ranges.map(He=>c.from(He))})),kind:"usedContext"}:"reference"in re?{reference:"uri"in re.reference?{uri:re.reference.uri,range:c.from(re.reference.range)}:re.reference,kind:"reference"}:"inlineReference"in re?{inlineReference:"uri"in re.inlineReference?{uri:re.inlineReference.uri,range:c.from(re.inlineReference.range)}:re.inlineReference,name:re.title,kind:"inlineReference"}:"agentName"in re?((0,h.$RF)(De,"chatAgents2Additions"),{agentName:re.agentName,command:re.command,kind:"agentDetection"}):"treeData"in re?{treeData:re.treeData,kind:"treeData"}:"message"in re?{content:re.message,kind:"progressMessage"}:void 0}Fe.from=Ne})(Qt||(e.ChatResponseProgress=Qt={}));var gt;(function(Fe){function Ne(De,re,Oe){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:re.toInternal(De,Oe)}Fe.from=Ne})(gt||(e.TerminalQuickFix=gt={}))}),define(Ee[293],Se([1,0,2,8,7,15,75]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class b{constructor(y,A,C,m={timeout:1500,errors:3}){this.c=y,this.d=A,this.f=C,this.g=m,this.a=new L.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(A,C,m)=>{const S={dispose:this.a.push([A,C,y])};return Array.isArray(m)&&m.push(S),S}}async $participateInSave(y,A){const C=D.URI.revive(y);let m=!1;const v=setTimeout(()=>m=!0,this.g.timeout),S=[];try{for(const f of[...this.a]){if(m)break;const d=this.d.getDocument(C),s=await this.h(f,{document:d,reason:I.TextDocumentSaveReason.to(A)});S.push(s)}}finally{clearTimeout(v)}return S}h([y,A,C],m){const v=this.b.get(y);return typeof v=="number"&&v>this.g.errors?Promise.resolve(!1):this.i(C,y,A,m).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const f=this.b.get(y);this.b.set(y,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,A,C,m){const v=[],S=Date.now(),{document:f,reason:d}=m,{version:s}=f,i=Object.freeze({document:f,reason:d,waitUntil(n){if(Object.isFrozen(v))throw(0,N.$7)("waitUntil can not be called async");v.push(Promise.resolve(n))}});try{A.apply(C,[i])}catch(n){return Promise.reject(n)}return Object.freeze(v),new Promise((n,o)=>{const a=setTimeout(()=>o(new Error("timeout")),this.g.timeout);return Promise.all(v).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),n(t)}).catch(t=>{clearTimeout(a),o(t)})}).then(n=>{const o={edits:[]};for(const a of n)if(Array.isArray(a)&&a.every(t=>t instanceof g.$NK))for(const{newText:t,newEol:r,range:h}of a)o.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:h&&I.Range.from(h),text:t,eol:r&&I.EndOfLine.from(r)}});if(o.edits.length!==0)return s===f.version?this.f.$tryApplyWorkspaceEdit(o):Promise.reject(new Error("concurrent_edits"))})}}e.$Kfc=b}),define(Ee[294],Se([1,0,17,2,15,7,111]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0;class b{constructor(C,m,v,S){this.start=C,this.deletedCount=m,this.deletedItems=v,this.items=S}asApiEvent(){return{range:new I.$5L(this.start,this.start+this.deletedCount),addedCells:this.items.map(C=>C.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(C,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:C}}constructor(C,m,v){this.notebook=C,this.h=m,this.j=v,this.handle=v.handle,this.uri=N.URI.revive(v.uri),this.cellKind=v.cellKind,this.a=v.outputs.map(g.NotebookCellOutput.to),this.e=v.internalMetadata??{},this.b=Object.freeze(v.metadata??{}),this.d=Object.freeze(g.NotebookCellExecutionSummary.to(v.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const C=this,m=this.h.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const v={get index(){return C.notebook.getCellIndex(C)},notebook:C.notebook.apiNotebook,kind:g.NotebookCellKind.to(this.j.cellKind),document:m.document,get mime(){return C.g},set mime(S){C.g=S},get outputs(){return C.a.slice(0)},get metadata(){return C.b},get executionSummary(){return C.d}};this.f=Object.freeze(v)}return this.f}setOutputs(C){this.a=C.map(g.NotebookCellOutput.to)}setOutputItems(C,m,v){const S=v.map(g.NotebookCellOutputItem.to),f=this.a.find(d=>d.id===C);if(f&&(m||(f.items.length=0),f.items.push(...S),f.items.length>1&&f.items.every(d=>L.$II(d.mime)))){const d=new Map,s=[];f.items.forEach(i=>{let n;d.has(i.mime)?n=d.get(i.mime):(n=[],d.set(i.mime,n),s.push(i.mime)),n.push(i.data)}),f.items.length=0,s.forEach(i=>{const n=L.$JI(d.get(i));f.items.push({mime:i,data:n.data.buffer})})}}setMetadata(C){this.b=Object.freeze(C)}setInternalMetadata(C){this.e=C,this.d=Object.freeze(g.NotebookCellExecutionSummary.to(C))}setMime(C){}}e.$Pfc=$;class y{static{this.a=0}constructor(C,m,v,S,f){this.k=C,this.l=m,this.m=v,this.uri=S,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const C=this,m={get uri(){return C.uri},get version(){return C.g},get notebookType(){return C.d},get isDirty(){return C.h},get isUntitled(){return C.uri.scheme===D.Schemas.untitled},get isClosed(){return C.j},get metadata(){return C.f},get cellCount(){return C.b.length},cellAt(v){return v=C.n(v),C.b[v].apiCell},getCells(v){return(v?C.p(v):C.b).map(f=>f.apiCell)},save(){return C.q()}};this.e=Object.freeze(m)}return this.e}acceptDocumentPropertiesChanged(C){C.metadata&&(this.f=Object.freeze({...this.f,...C.metadata}))}acceptDirty(C){this.h=C}acceptModelChanged(C,m,v){this.g=C.versionId,this.h=m,this.acceptDocumentPropertiesChanged({metadata:v});const S={notebook:this.apiNotebook,metadata:v,cellChanges:[],contentChanges:[]},f=[];for(const s of C.rawEvents)s.kind===L.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,S.contentChanges):s.kind===L.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,S.contentChanges):s.kind===L.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),f.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===L.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),f.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),f.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const d=new Map;for(let s=0;s<f.length;s++){const i=f[s],n=d.get(i.cell);if(n===void 0){const o=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});d.set(i.cell,o-1)}else S.cellChanges[n]={...S.cellChanges[n],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(C){return C=C|0,C<0?0:C>=this.b.length?this.b.length-1:C}o(C){let m=C.start|0,v=C.end|0;return m<0&&(m=0),v>this.b.length&&(v=this.b.length),C.with({start:m,end:v})}p(C){C=this.o(C);const m=[];for(let v=C.start;v<C.end;v++)m.push(this.b[v]);return m}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(C,m,v){if(this.j)return;const S=[],f=[],d=[];if(C.reverse().forEach(s=>{const n=s[2].map(t=>{const r=new $(this,this.l,t);return m||f.push($.asModelAddData(this.apiNotebook,t)),r}),o=new b(s[0],s[1],[],n),a=this.b.splice(s[0],s[1],...n);for(const t of a)d.push(t.uri),o.deletedItems.push(t.apiCell);S.push(o)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:d}),v)for(const s of S)v.push(s.asApiEvent())}s(C,m,v,S){const f=this.b.splice(C,m);this.b.splice(v,0,...f);const d=[new b(C,m,f.map(s=>s.apiCell),[]),new b(v,0,[],f)];for(const s of d)S.push(s.asApiEvent())}t(C,m){this.b[C].setOutputs(m)}u(C,m,v,S){this.b[C].setOutputItems(m,v,S)}v(C,m){const v=this.b[C];v.apiCell.document.languageId!==m&&this.m.$acceptModelLanguageChanged(v.uri,m)}w(C,m){const v=this.b[C];v.apiCell.mime=m}x(C,m){this.b[C].setMetadata(m)}y(C,m){this.b[C].setInternalMetadata(m)}getCellFromApiCell(C){return this.b.find(m=>m.apiCell===C)}getCellFromIndex(C){return this.b[C]}getCell(C){return this.b.find(m=>m.handle===C)}getCellIndex(C){return this.b.indexOf(C)}}e.$Qfc=y}),define(Ee[295],Se([1,0,4,2,15,7]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class L{constructor($,y,A,C={timeout:1500,errors:3}){this.b=$,this.c=y,this.d=A,this.f=C,this.a=new D.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(y,A,C)=>{const m=function(S){y.call(A,S)};return m.extension=$,this.a.event(m,void 0,C)}}async $participateInSave($,y,A){const C=N.URI.revive($),m=this.c.getNotebookDocument(C);if(!m)throw new Error("Unable to resolve notebook document");const v=[];if(await this.a.fireAsync({notebook:m.apiNotebook,reason:g.TextDocumentSaveReason.to(y)},A,async(f,d)=>{const s=Date.now(),i=await await Promise.resolve(f);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof I.$QK?v.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",d.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(v.length===0)return!0;const S={edits:[]};for(const f of v){const{edits:d}=g.WorkspaceEdit.from(f);S.edits=S.edits.concat(d)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$7fc=L}),define(Ee[146],Se([1,0,8,15,7]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class I{static{this.apiEditorsToExtHost=new WeakMap}constructor(b,$,y,A,C,m){this.id=b,this.f=$,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=C,this.b=A,this.c=m}get apiEditor(){if(!this.e){const b=this;this.e={get notebook(){return b.notebookData.apiNotebook},get selection(){return b.a[0]},set selection($){this.selections=[$]},get selections(){return b.a},set selections($){if(!Array.isArray($)||!$.every(g.$5L.isNotebookRange))throw(0,D.$6)("selections");b.a=$,b.g($)},get visibleRanges(){return b.b},revealRange($,y){b.f.$tryRevealRange(b.id,N.NotebookRange.from($),y??g.NotebookEditorRevealType.Default)},get viewColumn(){return b.c}},I.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(b){this.d=b}_acceptVisibleRanges(b){this.b=b}_acceptSelections(b){this.a=b}g(b){this.f.$trySetSelections(this.id,b.map(N.NotebookRange.from))}_acceptViewColumn(b){this.c=b}}e.$Rfc=I}),define(Ee[296],Se([1,0,8,4,14,15]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let L=class{constructor($,y){this.c=$,this.d=y,this.a=new N.$Rd({onListenerError:D.$1}),this.b=new N.$Rd({onListenerError:D.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged($,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",$,y);const A=this.d.getEditorById($);y.visibleRanges&&A._acceptVisibleRanges(y.visibleRanges.ranges.map(I.NotebookRange.to)),y.selections&&A._acceptSelections(y.selections.selections.map(I.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:A.apiEditor,visibleRanges:A.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:A.apiEditor,selections:A.apiEditor.selections}))}$acceptEditorViewColumns($){for(const y in $)this.d.getEditorById(y)._acceptViewColumn(I.ViewColumn.to($[y]))}};e.$9fc=L,e.$9fc=L=Ke([We(0,g.$hj)],L)}),define(Ee[297],Se([1,0,15,85,215,21,59,8]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class ${constructor(m){this.b=0,this.c=new Map,this.a=m}async withProgress(m,v,S){const f=this.b++,{title:d,location:s,cancellable:i}=v,n={label:(0,g.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this.a.$startProgress(f,{location:D.ProgressLocation.from(s),title:d,source:n,cancellable:i},m.isUnderDevelopment?void 0:m.identifier.value).catch(b.$1),this.d(f,S,!!i)}d(m,v,S){let f;S&&(f=new I.$2d,this.c.set(m,f));const d=i=>{this.a.$progressEnd(i),this.c.delete(i),f?.dispose()};let s;try{s=v(new A(this.a,m),S&&f?f.token:I.CancellationToken.None)}catch(i){throw d(m),i}return s.then(i=>d(m),i=>d(m)),s}$acceptProgressCanceled(m){const v=this.c.get(m);v&&(v.cancel(),this.c.delete(m))}}e.$dgc=$;function y(C,m){return C.message=m.message,typeof m.increment=="number"&&(typeof C.increment=="number"?C.increment+=m.increment:C.increment=m.increment),C}class A extends N.$dv{constructor(m,v){super(S=>this.throttledReport(S)),this.c=m,this.d=v}throttledReport(m){this.c.$progressReport(this.d,m)}}Ke([(0,L.$th)(100,(C,m)=>y(C,m),()=>Object.create(null))],A.prototype,"throttledReport",null)}),define(Ee[147],Se([1,0,29,142,67,112,89,15,2]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=e.$TM=void 0;const y=(n,o,a,t)=>{let r=o;return{enumerable:!0,configurable:!1,get(){return r},set(h){if(!a(r,h)){const u=r;r=h,n.listener?.(t(h,u))}}}},A=(n,o)=>n===o,C={range:(n,o)=>n===o?!0:!n||!o?!1:n.isEqual(o),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(n,o)=>!(n.length!==o.length||n.some(a=>!o.find(t=>a.id===t.id)))},m=n=>o=>({op:4,update:n(o)}),v=(n,o)=>({range:(()=>{let a;const t=m(r=>({range:D.$Ds.lift(b.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return a},set(r){n.listener?.({op:6}),C.range(a,r)||(a=r,n.listener?.(t(r)))}}})(),label:y(n,o,C.label,m(a=>({label:a}))),description:y(n,void 0,C.description,m(a=>({description:a}))),sortText:y(n,void 0,C.sortText,m(a=>({sortText:a}))),canResolveChildren:y(n,!1,C.canResolveChildren,a=>({op:2,state:a})),busy:y(n,!1,C.busy,m(a=>({busy:a}))),error:y(n,void 0,C.error,m(a=>({error:b.MarkdownString.fromStrict(a)||null}))),tags:y(n,[],C.tags,(a,t)=>({op:1,new:a.map(b.TestTag.from),old:t.map(b.TestTag.from)}))}),S=n=>{const o=g.$wJ.fromString(n.extId),a=new d(o.controllerId,o.localId,n.label,$.URI.revive(n.uri)||void 0);return a.range=b.Range.to(n.range||void 0),a.description=n.description||void 0,a.sortText=n.sortText||void 0,a.tags=n.tags.map(t=>b.TestTag.to({id:(0,L.$BJ)(t).tagId})),a},f=n=>{let o;for(const a of n.tests){const t=S(a.item);(0,N.$DM)(t).parent=o,o=t}return o};e.$TM=f;class d{constructor(o,a,t,r){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const h=(0,N.$CM)(this,o);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return h.parent instanceof s?void 0:h.parent}},children:{value:(0,I.$BM)(h,N.$DM,d),enumerable:!0,writable:!1},...v(h,t)})}}e.$UM=d;class s extends d{constructor(o,a){super(o,o,a,void 0),this._isRoot=!0}}e.$VM=s;class i extends I.$xM{constructor(o,a,t){super({controllerId:o,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:N.$DM,getChildren:r=>r.children,root:new s(o,a),toITestItem:b.TestItem.from})}}e.$WM=i}),define(Ee[148],Se([1,0,60,8,121,15,7]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=void 0;class b{static{this.c=new g.$MM("TextEditorDecorationType")}constructor(m,v,S){const f=b.c.nextId();m.$registerTextEditorDecorationType(v.identifier,f,I.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:f,dispose(){m.$removeTextEditorDecorationType(f)}})}}e.$OM=b;class ${constructor(m,v){this.g=[],this.h=void 0,this.j=!1,this.c=m,this.d=m.version,this.e=v.undoStopBefore,this.f=v.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(m,v){this.k();let S=null;if(m instanceof L.$HK)S=new L.$IK(m,m);else if(m instanceof L.$IK)S=m;else throw new Error("Unrecognized location");this.l(S,v,!1)}insert(m,v){this.k(),this.l(new L.$IK(m,m),v,!0)}delete(m){this.k();let v=null;if(m instanceof L.$IK)v=m;else throw new Error("Unrecognized location");this.l(v,null,!0)}l(m,v,S){const f=this.c.validateRange(m);this.g.push({range:f,text:v,forceMoveMarkers:S})}setEndOfLine(m){if(this.k(),m!==L.EndOfLine.LF&&m!==L.EndOfLine.CRLF)throw(0,N.$6)("endOfLine");this.h=m}}class y{constructor(m,v,S,f){this.c=m,this.d=v,this._accept(S),this.e=f;const d=this;this.value={get tabSize(){return d.f},set tabSize(s){d.m(s)},get indentSize(){return d.g},set indentSize(s){d.o(s)},get insertSpaces(){return d.h},set insertSpaces(s){d.q(s)},get cursorStyle(){return d.j},set cursorStyle(s){d.s(s)},get lineNumbers(){return d.k},set lineNumbers(s){d.t(s)}}}_accept(m){this.f=m.tabSize,this.g=m.indentSize,this.h=m.insertSpaces,this.j=m.cursorStyle,this.k=I.TextEditorLineNumbersStyle.to(m.lineNumbers)}l(m){if(m==="auto")return"auto";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}m(m){const v=this.l(m);if(v!==null){if(typeof v=="number"){if(this.f===v)return;this.f=v}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:v}))}}n(m){if(m==="tabSize")return"tabSize";if(typeof m=="number"){const v=Math.floor(m);return v>0?v:null}if(typeof m=="string"){const v=parseInt(m,10);return isNaN(v)?null:v>0?v:null}return null}o(m){const v=this.n(m);if(v!==null){if(typeof v=="number"){if(this.g===v)return;this.g=v}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:v}))}}p(m){return m==="auto"?"auto":m==="false"?!1:!!m}q(m){const v=this.p(m);if(typeof v=="boolean"){if(this.h===v)return;this.h=v}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:v}))}s(m){this.j!==m&&(this.j=m,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:m})))}t(m){this.k!==m&&(this.k=m,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:I.TextEditorLineNumbersStyle.from(m)})))}assign(m){const v={};let S=!1;if(typeof m.tabSize<"u"){const f=this.l(m.tabSize);f==="auto"?(S=!0,v.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,S=!0,v.tabSize=f)}if(typeof m.indentSize<"u"){const f=this.n(m.indentSize);f==="tabSize"?(S=!0,v.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,S=!0,v.indentSize=f)}if(typeof m.insertSpaces<"u"){const f=this.p(m.insertSpaces);f==="auto"?(S=!0,v.insertSpaces=f):this.h!==f&&(this.h=f,S=!0,v.insertSpaces=f)}typeof m.cursorStyle<"u"&&this.j!==m.cursorStyle&&(this.j=m.cursorStyle,S=!0,v.cursorStyle=m.cursorStyle),typeof m.lineNumbers<"u"&&this.k!==m.lineNumbers&&(this.k=m.lineNumbers,S=!0,v.lineNumbers=I.TextEditorLineNumbersStyle.from(m.lineNumbers)),S&&this.u("setOptions",this.c.$trySetOptions(this.d,v))}u(m,v){v.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this.e.warn(S)})}}e.$PM=y;class A{constructor(m,v,S,f,d,s,i,n){this.id=m,this.j=v,this.k=S,this.g=!1,this.h=new Set,this.c=d,this.d=new y(this.j,this.id,s,S),this.e=i,this.f=n;const o=this;this.value=Object.freeze({get document(){return f.value},set document(a){throw new N.$8("document")},get selection(){return o.c&&o.c[0]},set selection(a){if(!(a instanceof L.$JK))throw(0,N.$6)("selection");o.c=[a],o.l()},get selections(){return o.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof L.$JK)))throw(0,N.$6)("selections");o.c=a,o.l()},get visibleRanges(){return o.e},set visibleRanges(a){throw new N.$8("visibleRanges")},get options(){return o.d.value},set options(a){o.g||o.d.assign(a)},get viewColumn(){return o.f},set viewColumn(a){throw new N.$8("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new $(f.value,t);return a(r),o.m(r)},insertSnippet(a,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(o.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let h;if(!t||Array.isArray(t)&&t.length===0)h=o.c.map(u=>I.Range.from(u));else if(t instanceof L.$HK){const{lineNumber:u,column:c}=I.Position.from(t);h=[{startLineNumber:u,startColumn:c,endLineNumber:u,endColumn:c}]}else if(t instanceof L.$IK)h=[I.Range.from(t)];else{h=[];for(const u of t)if(u instanceof L.$IK)h.push(I.Range.from(u));else{const{lineNumber:c,column:l}=I.Position.from(u);h.push({startLineNumber:c,startColumn:l,endLineNumber:c,endColumn:l})}}return v.$tryInsertSnippet(m,f.value.version,a.value,h,r)},setDecorations(a,t){const r=t.length===0;r&&!o.h.has(a.key)||(r?o.h.delete(a.key):o.h.add(a.key),o.n(()=>{if(I.$EM(t))return v.$trySetDecorations(m,a.key,I.$FM(t));{const h=new Array(4*t.length);for(let u=0,c=t.length;u<c;u++){const l=t[u];h[4*u]=l.start.line+1,h[4*u+1]=l.start.character+1,h[4*u+2]=l.end.line+1,h[4*u+3]=l.end.character+1}return v.$trySetDecorationsFast(m,a.key,h)}}))},revealRange(a,t){o.n(()=>v.$tryRevealRange(m,I.Range.from(a),t||L.TextEditorRevealType.Default))},show(a){v.$tryShowEditor(m,I.ViewColumn.from(a))},hide(){v.$tryHideEditor(m)}})}dispose(){(0,D.ok)(!this.g),this.g=!0}_acceptOptions(m){(0,D.ok)(!this.g),this.d._accept(m)}_acceptVisibleRanges(m){(0,D.ok)(!this.g),this.e=m}_acceptViewColumn(m){(0,D.ok)(!this.g),this.f=m}_acceptSelections(m){(0,D.ok)(!this.g),this.c=m}async l(){const m=this.c.map(I.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,m)),this.value}m(m){const v=m.finalize();if(v.edits.length===0&&!v.setEndOfLine)return Promise.resolve(!0);const S=v.edits.map(d=>d.range);S.sort((d,s)=>d.end.line===s.end.line?d.end.character===s.end.character?d.start.line===s.start.line?d.start.character-s.start.character:d.start.line-s.start.line:d.end.character-s.end.character:d.end.line-s.end.line);for(let d=0,s=S.length-1;d<s;d++){const i=S[d].end;if(S[d+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=v.edits.map(d=>({range:I.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,v.documentVersionId,f,{setEndOfLine:typeof v.setEndOfLine=="number"?I.EndOfLine.from(v.setEndOfLine):void 0,undoStopBefore:v.undoStopBefore,undoStopAfter:v.undoStopAfter})}n(m){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,v=>(v instanceof Error&&v.name==="DISPOSED"||this.k.warn(v),null))}}e.$QM=A}),define(Ee[298],Se([1,0,219,23,2,4,3,278,12,7,18,19,15,80,21,176,25]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;function s(o,a){if((0,A.$Cf)(o))return{label:o};if(o&&typeof o=="object"&&typeof o.label=="string"){let t;return Array.isArray(o.highlights)&&(t=o.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),t=t.length?t:void 0),{label:o.label,highlights:t}}}class i extends L.$Rc{constructor(a,t,r){super(),this.f=a,this.g=t,this.h=r,this.a=new Map,this.b=new f.$27;function h(u){return u&&u.$treeViewId&&(u.$treeItemHandle||u.$selectedTreeItems||u.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:u=>h(u)?this.r(u):Array.isArray(u)&&u.length>0?u.map(c=>h(c)?this.r(c):c):u})}registerTreeDataProvider(a,t,r){const h=this.createTreeView(a,{treeDataProvider:t},r);return{dispose:()=>h.dispose()}}createTreeView(a,t,r){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const h=t.dragAndDropController?.dropMimeTypes??[],u=t.dragAndDropController?.dragMimeTypes??[],c=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,k=this.m(a,t,r),R={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:h,dragMimeTypes:u,hasHandleDrag:c,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},w=this.f.$registerTreeViewDataProvider(a,R),p={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,d.$RF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,d.$RF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(E){(0,v.$ck)(E)&&(0,d.$RF)(r,"treeViewMarkdownMessage"),k.message=E},get title(){return k.title},set title(E){k.title=E},get description(){return k.description},set description(E){k.description=E},get badge(){return k.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?k.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(k.badge=void 0)},reveal:(E,P)=>k.reveal(E,P),dispose:async()=>{await w,this.a.delete(a),k.dispose()}};return this.B(p),p}$getChildren(a,t){const r=this.a.get(a);return r?r.getChildren(t):Promise.reject(new b.$QE(a))}async $handleDrop(a,t,r,h,u,c,l,k){const R=this.a.get(a);if(!R)return Promise.reject(new b.$QE(a));const w=m.DataTransfer.toDataTransfer(r,async p=>(await this.f.$resolveDropFileData(a,t,p)).buffer);return l===a&&k&&await this.j(w,R,k,u,c),R.onDrop(w,h,u)}async j(a,t,r,h,u){const c=this.b.removeDragOperationTransfer(u);if(c)(await c)?.forEach((l,k)=>{l&&a.set(k,l)});else if(u&&t.handleDrag){const l=t.handleDrag(r,a,h);this.b.addDragOperationTransfer(u,l),await l}return a}async $handleDrag(a,t,r,h){const u=this.a.get(a);if(!u)return Promise.reject(new b.$QE(a));const c=await this.j(new y.$yL,u,t,h,r);if(!(!c||h.isCancellationRequested))return m.DataTransfer.from(c)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new b.$QE(a);return t.hasResolve}$resolve(a,t,r){const h=this.a.get(a);if(!h)throw new b.$QE(a);return h.resolveTreeItem(t,r)}$setExpanded(a,t,r){const h=this.a.get(a);if(!h)throw new b.$QE(a);h.setExpanded(t,r)}$setSelectionAndFocus(a,t,r){const h=this.a.get(a);if(!h)throw new b.$QE(a);h.setSelectionAndFocus(t,r)}$setVisible(a,t){const r=this.a.get(a);if(!r){if(!t)return;throw new b.$QE(a)}r.setVisible(t)}$changeCheckboxState(a,t){const r=this.a.get(a);if(!r)throw new b.$QE(a);r.setCheckboxState(t)}m(a,t,r){const h=this.B(new n(a,t,this.f,this.g.converter,this.h,r));return this.a.set(a,h),h}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$wgc=i;class n extends L.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Lf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,r,h,u,c){if(super(),this.I=a,this.J=r,this.L=h,this.M=u,this.N=c,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new I.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new I.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new I.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new I.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new I.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new I.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new I.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$2d,c.contributes&&c.contributes.views)for(const w in c.contributes.views)for(const p of c.contributes.views[w])p.id===a&&(this.P=p.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(w=>this.F.fire({message:!1,element:w})));let l,k;const R=I.Event.debounce(this.F.event,(w,p)=>(w||(w={message:!1,elements:[]}),p.element!==!1&&(l||(l=new Promise(E=>k=E),this.G=this.G.then(()=>l)),Array.isArray(p.element)?w.elements.push(...p.element):w.elements.push(p.element)),p.message&&(w.message=!0),w),200,!0);this.B(R(({message:w,elements:p})=>{p.length&&(this.H=this.H.then(()=>{const E=k;return l=null,this.$(p).then(()=>E())})),w&&this.J.$setMessage(this.I,m.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let r=this.X(a);return r||(r=await this.Y(t)),r?r.map(h=>h.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const r=(0,A.$Lf)(t.select)?!0:t.select,h=(0,A.$Lf)(t.focus)?!1:t.focus,u=(0,A.$Lf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(c=>this.W(a,c[c.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:c.map(k=>k.item)},{select:r,focus:h,expand:u})),c=>this.M.error(c)):this.J.$reveal(this.I,void 0,{select:r,focus:h,expand:u})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=m.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const r=this.getExtensionElement(a);r&&(t?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(a,t){const r=!(0,C.$tb)(this.s,a);this.s=a;const h=this.t!==t;this.t=t,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),h&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async r=>{const h=this.getExtensionElement(r.treeItemHandle);return h?{extensionItem:h,treeItem:await this.f.getTreeItem(h),newState:r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);t.forEach(r=>{r.treeItem.checkboxState=r.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(r=>[r.extensionItem,r.newState])})}async handleDrag(a,t,r){const h=[];for(const u of a){const c=this.getExtensionElement(u);c&&h.push(c)}if(!(!this.g?.handleDrag||h.length===0))return await this.g.handleDrag(h,t,r),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,r){const h=t?this.getExtensionElement(t):void 0;if(!(!h&&t||!this.g?.handleDrop))return(0,$.$Sg)(()=>this.g?.handleDrop?this.g.handleDrop(h,a,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const r=this.j.get(a);if(r){const h=this.m.get(r);if(h){const u=await this.f.resolveTreeItem(h.extensionItem,r,t)??h.extensionItem;return this.hb(u),h.item.tooltip=this.eb(u.tooltip),h.item.command=this.fb(h.disposableStore,u.command),h.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(r=>this.W(t,r[r.length-1]).then(h=>(r.push(h),r))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Sg)(()=>this.f.getParent(a))}W(a,t){const r=this.m.get(a);return r?Promise.resolve(r):(0,$.$Sg)(()=>this.f.getTreeItem(a)).then(h=>this.kb(a,h,t,!0)).then(h=>this.getChildren(t?t.item.handle:void 0).then(()=>{const u=this.getExtensionElement(h);if(u){const c=this.m.get(u);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${h} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const r=this.getExtensionElement(a);t=r?this.m.get(r):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$2d(this.Z.token);try{const r=a?this.m.get(a):void 0,h=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const u=await Promise.all((0,C.$Gb)(h||[]).map(async c=>{const l=await this.f.getTreeItem(c);return l&&!t.token.isCancellationRequested?this.db(c,l,r):null}));return t.token.isCancellationRequested?void 0:(0,C.$Gb)(u)}finally{t.dispose()}}$(a){if(a.some(r=>!r))return this.Z.dispose(!0),this.Z=new S.$2d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(a);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(a){const t=new Set,r=a.map(u=>this.m.get(u));for(const u of r)if(u&&!t.has(u.item.handle)){let c=u;for(;c&&c.parent&&r.findIndex(l=>c&&c.parent&&l&&l.item.handle===c.parent.item.handle)===-1;){const l=this.j.get(c.parent.item.handle);c=l?this.m.get(l):void 0}c&&!c.parent&&t.add(u.item.handle)}const h=[];return t.forEach(u=>{const c=this.j.get(u);if(c){const l=this.m.get(c);l&&(!l.parent||!t.has(l.parent.item.handle))&&h.push(u)}}),h}bb(a){const t={};return Promise.all(a.map(r=>this.cb(r).then(h=>{h&&(t[r]=h.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const r=this.m.get(t);if(r)return this.rb(t),(0,$.$Sg)(()=>this.f.getTreeItem(t)).then(h=>{if(h){const u=this.ib(t,h,r.parent);return this.pb(t,u,r,r.parent),r.dispose(),u}return null})}return Promise.resolve(null)}db(a,t,r){const h=this.ib(a,t,r);if(t.id&&this.j.has(h.item.handle))throw new Error((0,D.localize)(0,null,t.id));return this.ob(a,h),this.qb(h,r),h}eb(a){return y.$8K.isMarkdownString(a)?m.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,r,h;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,r=a.checkboxState.tooltip,h=a.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:h}}hb(a){if(!y.$tL.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,r){this.hb(t);const h=this.B(new L.$Qc),u=this.kb(a,t,r),c=this.lb(t);return{item:{handle:u,parentHandle:r?r.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(h,t.command),contextValue:t.contextValue,icon:c,iconDark:this.mb(t)||c,themeIcon:this.jb(t),collapsibleState:(0,A.$Lf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:r,children:void 0,disposableStore:h,dispose(){h.dispose()}}}jb(a){return a.iconPath instanceof y.$BL?a.iconPath:void 0}kb(a,{id:t,label:r,resourceUri:h},u,c){if(t)return`${n.b}/${t}`;const l=s(r,this.N),k=u?u.item.handle:n.a;let R=l?l.label:h?(0,N.$yg)(h):"";R=R.indexOf("/")!==-1?R.replace("/","//"):R;const w=this.m.has(a)?this.m.get(a).item.handle:void 0,p=this.X(u)||[];let E,P=0;do{if(E=`${k}/${P}:${R}`,c||!this.j.has(E)||w===E)break;P++}while(P<=p.length);return E}lb(a){if(a.iconPath&&!(a.iconPath instanceof y.$BL))return typeof a.iconPath=="string"||g.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof y.$BL)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return g.URI.isUri(a)?a:g.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,r,h){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(a,t);const u=this.X(h)||[],c=u.filter(l=>l.item.handle===r.item.handle)[0];c&&u.splice(u.indexOf(c),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const r of t.children){const h=this.j.get(r.item.handle);h&&this.sb(h)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ee[299],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ee[300],Se([1,0,233,8,39,134,108,37,26,299,136,137]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0;const m=b.$qn.as(L.$rn.JSONContribution);class v{constructor(a,t,r){this.a=a,this.b=t,this.c=r}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(g.default.Error,a)}warn(a){this.d(g.default.Warning,a)}info(a){this.d(g.default.Info,a)}}e.$XF=v;class S{static a(a){const t=new $.$em;for(let r=0,h=a.length;r<h;r++)t.add(a[r].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const r=this.a(a),h=this.a(t),u=t.filter(l=>!r.has(l.description.identifier)),c=a.filter(l=>!h.has(l.description.identifier));return new S(u,c)}constructor(a,t){this.added=a,this.removed=t}}e.$YF=S;class f{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,N.$Z)(a)}}}e.$ZF=f;const d={type:"string",enum:["ui","workspace"],enumDescriptions:[D.localize(0,null),D.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$1F={properties:{engines:{type:"object",description:D.localize(2,null),properties:{vscode:{type:"string",description:D.localize(3,null),default:"^1.22.0"}}},publisher:{description:D.localize(4,null),type:"string"},displayName:{description:D.localize(5,null),type:"string"},categories:{description:D.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$cm},{type:"string",const:"Languages",deprecationMessage:D.localize(7,null)}]}},galleryBanner:{type:"object",description:D.localize(8,null),properties:{color:{description:D.localize(9,null),type:"string"},theme:{description:D.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:D.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:D.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:D.localize(13,null)},enabledApiProposals:{markdownDescription:D.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:D.localize(15,null),type:"string",enum:["none"],enumDescriptions:[D.localize(16,null)]},activationEvents:{description:D.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:D.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:D.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:D.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:D.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:D.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:D.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:D.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:D.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:D.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:D.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:D.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:D.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:D.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:D.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:D.localize(32,null)},{label:"onUri",body:"onUri",description:D.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:D.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:D.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:D.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:D.localize(37,null)},{label:"onRenderer",description:D.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:D.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:D.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:D.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:D.localize(42,null)},{label:"*",description:D.localize(43,null),body:"*"}]}},badges:{type:"array",description:D.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:D.localize(45,null)},href:{type:"string",description:D.localize(46,null)},description:{type:"string",description:D.localize(47,null)}}}},markdown:{type:"string",description:D.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:D.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:D.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$8n}},extensionPack:{description:D.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:I.$8n}},extensionKind:{description:D.localize(52,null),type:"array",items:d,default:["workspace"],defaultSnippets:[{body:["ui"],description:D.localize(53,null)},{body:["workspace"],description:D.localize(54,null)},{body:["ui","workspace"],description:D.localize(55,null)},{body:["workspace","ui"],description:D.localize(56,null)},{body:[],description:D.localize(57,null)}]},capabilities:{description:D.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:D.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:D.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(61,null),D.localize(62,null),D.localize(63,null)]},description:{type:"string",markdownDescription:D.localize(64,null)}}},untrustedWorkspaces:{description:D.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:D.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[D.localize(67,null),D.localize(68,null),D.localize(69,null)]},restrictedConfigurations:{description:D.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:D.localize(71,null)}}}}},sponsor:{description:D.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:D.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:D.localize(74,null),type:"string"},"vscode:uninstall":{description:D.localize(75,null),type:"string"}}},icon:{type:"string",description:D.localize(76,null)},l10n:{type:"string",description:D.localize(77,null)},pricing:{type:"string",markdownDescription:D.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new f(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&C.$CF.register(a.extensionPoint,a.activationEventsGenerator),e.$1F.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,m.registerSchema(s,e.$1F),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$2F=i;const n={ExtensionsRegistry:"ExtensionsRegistry"};b.$qn.add(n.ExtensionsRegistry,new i),e.$3F=b.$qn.as(n.ExtensionsRegistry),m.registerSchema(s,e.$1F),m.registerSchema(A.$Aj,{properties:{extensionEnabledApiProposals:{description:D.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Ee[301],Se([1,0,229,18,24,300,46,4]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_F=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:D.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:D.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:D.localize(2,null),default:""}}};var y;(function(m){function v(S,f,d){if(!S)return;const s=N.$Cf(S.type)?S.type:void 0;if(!s||s.length===0){d.error(D.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const n of S.required)N.$Cf(n)&&i.push(n);return{extensionId:f.value,taskType:s,required:i,properties:S.properties?g.$en(S.properties):{},when:S.when?L.$Xi.deserialize(S.when):void 0}}m.from=v})(y||(y={}));const A=I.$3F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(m,v)=>{for(const S of m)S.type&&v.push(`onTaskType:${S.type}`)},jsonSchema:{description:D.localize(4,null),type:"array",items:$}});class C{constructor(){this.d=new b.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((v,S)=>{A.setHandler((f,d)=>{this.c=void 0;try{for(const s of d.removed){const i=s.value;for(const n of i)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const s of d.added){const i=s.value;for(const n of i){const o=y.from(n,s.description.identifier,s.collector);o&&(this.a[o.taskType]=o)}}(d.removed.length>0||d.added.length>0)&&this.d.fire()}catch{}v(void 0)})})}onReady(){return this.b}get(v){return this.a[v]}all(){return Object.keys(this.a).map(v=>this.a[v])}getJsonSchema(){if(this.c===void 0){const v=[];for(const S of this.all()){const f={type:"object",additionalProperties:!1};S.required.length>0&&(f.required=S.required.slice(0)),S.properties!==void 0?f.properties=g.$en(S.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[S.taskType]},v.push(f)}this.c={oneOf:v}}return this.c}}e.$_F=new C}),define(Ee[302],Se([1,0,230,18,23,24,46,301]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$jG=e.JsonSchemaVersion=e.ExecutionEngine=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$dG=e.ShellQuoting=e.$cG=e.$bG=e.$aG=void 0,e.$aG="settings",e.$bG=new L.$ej("taskRunning",!1,D.localize(0,null)),e.$cG={value:D.localize(1,null),original:"Tasks"};var $;(function(T){T[T.Escape=1]="Escape",T[T.Strong=2]="Strong",T[T.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$dG="$customized",function(T){function M(W){if(!W)return T.Strong;switch(W.toLowerCase()){case"escape":return T.Escape;case"strong":return T.Strong;case"weak":return T.Weak;default:return T.Strong}}T.from=M}($||(e.ShellQuoting=$={}));var y;(function(T){T.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var A;(function(T){T[T.Always=1]="Always",T[T.Silent=2]="Silent",T[T.Never=3]="Never"})(A||(e.RevealKind=A={})),function(T){function M(W){switch(W.toLowerCase()){case"always":return T.Always;case"silent":return T.Silent;case"never":return T.Never;default:return T.Always}}T.fromString=M}(A||(e.RevealKind=A={}));var C;(function(T){T[T.Never=1]="Never",T[T.OnProblem=2]="OnProblem",T[T.Always=3]="Always"})(C||(e.RevealProblemKind=C={})),function(T){function M(W){switch(W.toLowerCase()){case"always":return T.Always;case"never":return T.Never;case"onproblem":return T.OnProblem;default:return T.OnProblem}}T.fromString=M}(C||(e.RevealProblemKind=C={}));var m;(function(T){T[T.Shared=1]="Shared",T[T.Dedicated=2]="Dedicated",T[T.New=3]="New"})(m||(e.PanelKind=m={})),function(T){function M(W){switch(W.toLowerCase()){case"shared":return T.Shared;case"dedicated":return T.Dedicated;case"new":return T.New;default:return T.Shared}}T.fromString=M}(m||(e.PanelKind=m={}));var v;(function(T){T.defaults={echo:!0,reveal:A.Always,revealProblems:C.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(v||(e.PresentationOptions=v={}));var S;(function(T){T[T.Shell=1]="Shell",T[T.Process=2]="Process",T[T.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(T){function M(Y){switch(Y.toLowerCase()){case"shell":return T.Shell;case"process":return T.Process;case"customExecution":return T.CustomExecution;default:return T.Process}}T.fromString=M;function W(Y){switch(Y){case T.Shell:return"shell";case T.Process:return"process";case T.CustomExecution:return"customExecution";default:return"process"}}T.toString=W}(S||(e.RuntimeType=S={}));var f;(function(T){function M(W){return N.$Cf(W)?W:W.value}T.value=M})(f||(e.CommandString=f={}));var d;(function(T){T.Clean={_id:"clean",isDefault:!1},T.Build={_id:"build",isDefault:!1},T.Rebuild={_id:"rebuild",isDefault:!1},T.Test={_id:"test",isDefault:!1};function M(Y){return Y===T.Clean._id||Y===T.Build._id||Y===T.Rebuild._id||Y===T.Test._id}T.is=M;function W(Y){if(Y!==void 0)return N.$Cf(Y)?M(Y)?{_id:Y,isDefault:!1}:void 0:Y}T.from=W})(d||(e.TaskGroup=d={}));var s;(function(T){T[T.Global=1]="Global",T[T.Workspace=2]="Workspace",T[T.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(T){T.Workspace="workspace",T.Extension="extension",T.InMemory="inMemory",T.WorkspaceFile="workspaceFile",T.User="user";function M(W){switch(W){case T.User:return 2;case T.WorkspaceFile:return 5;default:return 6}}T.toConfigurationTarget=M})(i||(e.TaskSourceKind=i={}));var n;(function(T){T.parallel="parallel",T.sequence="sequence"})(n||(e.DependsOrder=n={}));var o;(function(T){T[T.default=1]="default",T[T.folderOpen=2]="folderOpen"})(o||(e.RunOnOptions=o={}));var a;(function(T){T.defaults={reevaluateOnRerun:!0,runOn:o.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(M,W,Y,ue,Z,Q){this._label="",this._id=M,W&&(this._label=W),Y&&(this.type=Y),this.runOptions=ue,this.configurationProperties=Z,this._source=Q}getDefinition(M){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const M={folder:this.d(),id:this._id};return JSON.stringify(M)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(M,W=!1){if(M===void 0)return!1;if(N.$Cf(M))return M===this._label||M===this.configurationProperties.identifier||W&&M===this._id;const Y=this.getDefinition(!0);return Y!==void 0&&Y._key===M._key}getQualifiedLabel(){const M=this.getWorkspaceFolder();return M?`${this._label} (${M.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(M){this.c===void 0&&(this.c=[]),M&&(this.c=this.c.concat(M))}get taskLoadMessages(){return this.c}}e.$eG=t;class r extends t{constructor(M,W,Y,ue,Z,Q,x,oe){super(M,Y,void 0,x,oe,W),this.command={},this._source=W,this.hasDefinedMatchers=Q,Z&&(this.command=Z)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(M=!1){if(M&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case S.Shell:W="shell";break;case S.Process:W="process";break;case S.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(M){return M instanceof r}getMapKey(){const M=this._source.config.workspaceFolder;return M?`${M.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$aG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const M=this.d();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$dG,folder:M,id:W};return JSON.stringify(Y)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$yg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(M){return new r(M._id,M._source,M._label,M.type,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$fG=r;class h extends t{constructor(M,W,Y,ue,Z,Q,x){super(M,Y,ue,Q,x,W),this._source=W,this.configures=Z}static is(M){return M instanceof h}f(M){return M}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?g.$yg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$aG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const M=this.d();if(!M)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const Y={type:e.$dG,folder:M,id:W};return JSON.stringify(Y)}}e.$gG=h;class u extends t{constructor(M,W,Y,ue,Z,Q,x,oe,X){super(M,Y,ue,oe,X,W),this.defines=Z,this.hasDefinedMatchers=x,this.command=Q,this.icon=X.icon,this.hide=X.hide}clone(){return new u(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(M){return M instanceof u}getMapKey(){const M=this._source.workspaceFolder;return M?`${this._source.scope.toString()}|${M.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const M={type:"contributed",scope:this._source.scope,id:this._id};return M.folder=this.d(),JSON.stringify(M)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(M){return new u(M._id,M._source,M._label,M.type,M.defines,M.command,M.hasDefinedMatchers,M.runOptions,M.configurationProperties)}}e.$hG=u;class c extends t{constructor(M,W,Y,ue,Z,Q){super(M,Y,ue,Z,Q,W),this._source=W}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(M){return M instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(M){return new c(M._id,M._source,M._label,M.type,M.runOptions,M.configurationProperties)}}e.$iG=c;var l;(function(T){T[T.Process=1]="Process",T[T.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(T){T._default=T.Terminal}(l||(e.ExecutionEngine=l={}));var k;(function(T){T[T.V0_1_0=1]="V0_1_0",T[T.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class R{constructor(M){this.c=new Map;for(let W=0;W<M.length;W++)this.c.set(M[W].uri.toString(),W)}compare(M,W){const Y=M.getWorkspaceFolder(),ue=W.getWorkspaceFolder();if(Y&&ue){let Z=this.c.get(Y.uri.toString());Z=Z===void 0?0:Z+1;let Q=this.c.get(ue.uri.toString());return Q=Q===void 0?0:Q+1,Z===Q?M._label.localeCompare(W._label):Z-Q}else return!Y&&ue?-1:Y&&!ue?1:0}}e.$jG=R;var w;(function(T){T.DependsOnStarted="dependsOnStarted",T.AcquiredInput="acquiredInput",T.Start="start",T.ProcessStarted="processStarted",T.Active="active",T.Inactive="inactive",T.Changed="changed",T.Terminated="terminated",T.ProcessEnded="processEnded",T.End="end"})(w||(e.TaskEventKind=w={}));var p;(function(T){T.SingleRun="singleRun",T.Background="background"})(p||(e.TaskRunType=p={}));var E;(function(T){T[T.System=0]="System",T[T.User=1]="User",T[T.FolderOpen=2]="FolderOpen",T[T.ConfigurationChange=3]="ConfigurationChange",T[T.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var P;(function(T){function M(oe){return{taskId:oe._id,taskName:oe.configurationProperties.name,runType:oe.configurationProperties.isBackground?"background":"singleRun",group:oe.configurationProperties.group,__task:oe}}function W(oe,X,ve){return{...M(oe),kind:"start",terminalId:X,resolvedVariables:ve}}T.start=W;function Y(oe,X,ve){return{...M(oe),kind:"processStarted",terminalId:X,processId:ve}}T.processStarted=Y;function ue(oe,X,ve){return{...M(oe),kind:"processEnded",terminalId:X,exitCode:ve}}T.processEnded=ue;function Z(oe,X,ve){return{...M(oe),kind:"terminated",exitReason:ve,terminalId:X}}T.terminated=Z;function Q(oe,X,ve){return{...M(X),kind:oe,terminalId:ve}}T.general=Q;function x(){return{kind:"changed"}}T.changed=x})(P||(e.TaskEvent=P={}));var z;(function(T){function M(Y){const ue=Object.keys(Y).sort();let Z="";for(const Q of ue){let x=Y[Q];x instanceof Object?x=M(x):typeof x=="string"&&(x=x.replace(/,/g,",,")),Z+=Q+","+x+","}return Z}function W(Y){const Z={_key:M(Y),type:Y.taskType};return Object.assign(Z,Y),Z}T.create=W})(z||(e.KeyedTaskIdentifier=z={}));var j;(function(T){T.AutoDetect="task.autoDetect",T.SaveBeforeRun="task.saveBeforeRun",T.ShowDecorations="task.showDecorations",T.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",T.SlowProviderWarning="task.slowProviderWarning",T.QuickOpenHistory="task.quickOpen.history",T.QuickOpenDetail="task.quickOpen.detail",T.QuickOpenSkip="task.quickOpen.skip",T.QuickOpenShowAll="task.quickOpen.showAll",T.AllowAutomaticTasks="task.allowAutomaticTasks",T.Reconnection="task.reconnection",T.VerboseLogging="task.verboseLogging"})(j||(e.TaskSettingId=j={}));var F;(function(T){T.Tasks="tasks",T.SuppressTaskName="tasks.suppressTaskName",T.Windows="tasks.windows",T.Osx="tasks.osx",T.Linux="tasks.linux",T.ShowOutput="tasks.showOutput",T.IsShellCommand="tasks.isShellCommand",T.ServiceTestSetting="tasks.service.testSetting"})(F||(e.TasksSchemaProperties=F={}));var O;(function(T){function M(W,Y){const ue=b.$_F.get(W.type);if(ue===void 0){const oe=I.$en(W);return delete oe._key,z.create(oe)}const Z=Object.create(null);Z.type=ue.taskType;const Q=new Set;ue.required.forEach(oe=>Q.add(oe));const x=ue.properties;for(const oe of Object.keys(x)){const X=W[oe];if(X!=null)Z[oe]=X;else if(Q.has(oe)){const ve=x[oe];if(ve.default!==void 0)Z[oe]=I.$en(ve.default);else switch(ve.type){case"boolean":Z[oe]=!1;break;case"number":case"integer":Z[oe]=0;break;case"string":Z[oe]="";break;default:Y.error(D.localize(2,null,JSON.stringify(W,void 0,0),oe));return}}}return z.create(Z)}T.createTaskIdentifier=M})(O||(e.TaskDefinition=O={}))}),define(Ee[303],Se([1,0,8]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,b)=>{this.b=L,this.d=b,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,D.$Z)(L))}then(L,b){return this.j().then(L,b)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$M6b=N;class g extends N{constructor(){super(),this.h=!0,this.i=new D.$4}}e.$N6b=g}),define(Ee[68],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=void 0;class D{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++D.count}}e.$yv=D;const N=[];function g(b){const $=new D(b);return N[$.nid]=$,$}e.$zv=g;function I(b){return N[b].sid}e.$Av=I;class L{constructor($){this.value=$}}e.$Bv=L}),define(Ee[6],Se([1,0,68]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$DK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var g;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput",f[f.ChatEditorInput=10]="ChatEditorInput"})(g||(e.TabInputKind=g={}));var I;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(I||(e.TabModelOperationKind=I={}));var L;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var b;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(b||(e.WebviewMessageArrayBufferViewType=b={}));var $;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var y;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var A;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class C{static{this.a=0}static mixin(d){return d._id=C.a++,d}}e.$DK=C;var m;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(m||(e.ISuggestDataDtoField=m={}));var v;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(v||(e.ISuggestResultDtoField=v={}));var S;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$EK={MainThreadAuthentication:(0,D.$zv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.$zv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,D.$zv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,D.$zv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,D.$zv)("MainThreadChatVariables"),MainThreadClipboard:(0,D.$zv)("MainThreadClipboard"),MainThreadCommands:(0,D.$zv)("MainThreadCommands"),MainThreadComments:(0,D.$zv)("MainThreadComments"),MainThreadConfiguration:(0,D.$zv)("MainThreadConfiguration"),MainThreadConsole:(0,D.$zv)("MainThreadConsole"),MainThreadDebugService:(0,D.$zv)("MainThreadDebugService"),MainThreadDecorations:(0,D.$zv)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.$zv)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.$zv)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.$zv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.$zv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.$zv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.$zv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.$zv)("MainThreadEditorTabs"),MainThreadErrors:(0,D.$zv)("MainThreadErrors"),MainThreadTreeViews:(0,D.$zv)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.$zv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,D.$zv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.$zv)("MainThreadLanguages"),MainThreadLogger:(0,D.$zv)("MainThreadLogger"),MainThreadMessageService:(0,D.$zv)("MainThreadMessageService"),MainThreadOutputService:(0,D.$zv)("MainThreadOutputService"),MainThreadProgress:(0,D.$zv)("MainThreadProgress"),MainThreadQuickDiff:(0,D.$zv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,D.$zv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.$zv)("MainThreadStatusBar"),MainThreadSecretState:(0,D.$zv)("MainThreadSecretState"),MainThreadStorage:(0,D.$zv)("MainThreadStorage"),MainThreadSpeech:(0,D.$zv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,D.$zv)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.$zv)("MainThreadTerminalService"),MainThreadWebviews:(0,D.$zv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.$zv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.$zv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.$zv)("MainThreadCustomEditors"),MainThreadUrls:(0,D.$zv)("MainThreadUrls"),MainThreadUriOpeners:(0,D.$zv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,D.$zv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,D.$zv)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.$zv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,D.$zv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,D.$zv)("MainThreadExtensionService"),MainThreadSCM:(0,D.$zv)("MainThreadSCM"),MainThreadSearch:(0,D.$zv)("MainThreadSearch"),MainThreadShare:(0,D.$zv)("MainThreadShare"),MainThreadTask:(0,D.$zv)("MainThreadTask"),MainThreadWindow:(0,D.$zv)("MainThreadWindow"),MainThreadLabelService:(0,D.$zv)("MainThreadLabelService"),MainThreadNotebook:(0,D.$zv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.$zv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.$zv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.$zv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.$zv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,D.$zv)("MainThreadInteractive"),MainThreadChat:(0,D.$zv)("MainThreadChat"),MainThreadInlineChat:(0,D.$zv)("MainThreadInlineChatShape"),MainThreadTheming:(0,D.$zv)("MainThreadTheming"),MainThreadTunnelService:(0,D.$zv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,D.$zv)("MainThreadManagedSockets"),MainThreadTimeline:(0,D.$zv)("MainThreadTimeline"),MainThreadTesting:(0,D.$zv)("MainThreadTesting"),MainThreadLocalization:(0,D.$zv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,D.$zv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,D.$zv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,D.$zv)("MainThreadIssueReporter")},e.$FK={ExtHostCommands:(0,D.$zv)("ExtHostCommands"),ExtHostConfiguration:(0,D.$zv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.$zv)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.$zv)("ExtHostDebugService"),ExtHostDecorations:(0,D.$zv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.$zv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.$zv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.$zv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.$zv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.$zv)("ExtHostEditors"),ExtHostTreeViews:(0,D.$zv)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.$zv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.$zv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.$zv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,D.$zv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,D.$zv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.$zv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,D.$zv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,D.$zv)("ExtHostStatusBar"),ExtHostShare:(0,D.$zv)("ExtHostShare"),ExtHostExtensionService:(0,D.$zv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,D.$zv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,D.$zv)("ExtHostTerminalService"),ExtHostSCM:(0,D.$zv)("ExtHostSCM"),ExtHostSearch:(0,D.$zv)("ExtHostSearch"),ExtHostTask:(0,D.$zv)("ExtHostTask"),ExtHostWorkspace:(0,D.$zv)("ExtHostWorkspace"),ExtHostWindow:(0,D.$zv)("ExtHostWindow"),ExtHostWebviews:(0,D.$zv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.$zv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.$zv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.$zv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.$zv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.$zv)("ExtHostEditorTabs"),ExtHostProgress:(0,D.$zv)("ExtHostProgress"),ExtHostComments:(0,D.$zv)("ExtHostComments"),ExtHostSecretState:(0,D.$zv)("ExtHostSecretState"),ExtHostStorage:(0,D.$zv)("ExtHostStorage"),ExtHostUrls:(0,D.$zv)("ExtHostUrls"),ExtHostUriOpeners:(0,D.$zv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,D.$zv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,D.$zv)("ExtHostOutputService"),ExtHosLabelService:(0,D.$zv)("ExtHostLabelService"),ExtHostNotebook:(0,D.$zv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,D.$zv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,D.$zv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,D.$zv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.$zv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,D.$zv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,D.$zv)("ExtHostInteractive"),ExtHostInlineChat:(0,D.$zv)("ExtHostInlineChatShape"),ExtHostChat:(0,D.$zv)("ExtHostChat"),ExtHostChatAgents2:(0,D.$zv)("ExtHostChatAgents"),ExtHostChatVariables:(0,D.$zv)("ExtHostChatVariables"),ExtHostChatProvider:(0,D.$zv)("ExtHostChatProvider"),ExtHostSpeech:(0,D.$zv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,D.$zv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,D.$zv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,D.$zv)("ExtHostTheming"),ExtHostTunnelService:(0,D.$zv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,D.$zv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,D.$zv)("ExtHostAuthentication"),ExtHostTimeline:(0,D.$zv)("ExtHostTimeline"),ExtHostTesting:(0,D.$zv)("ExtHostTesting"),ExtHostTelemetry:(0,D.$zv)("ExtHostTelemetry"),ExtHostLocalization:(0,D.$zv)("ExtHostLocalization"),ExtHostIssueReporter:(0,D.$zv)("ExtHostIssueReporter")}}),define(Ee[304],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$EK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,b,$){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(L);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(b,$)??[]}getRelatedInformation(L,b,$){return this.c.$getAiRelatedInformation(b,$)}registerRelatedInformationProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiRelatedInformationProvider(y,b),new N.$GK(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$wec=g}),define(Ee[91],Se([1,0,5,14,6,20]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=e.$Cec=void 0,e.$Cec=(0,D.$Zh)("IExtHostApiDeprecationService");let L=class{constructor($,y){this.c=y,this.a=new Set,this.b=$.getProxy(g.$EK.MainThreadTelemetry)}report($,y,A){const C=this.d($,y);this.a.has(C)||(this.a.add(C),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:$}))}d($,y){return`${$}-${y.identifier.value}`}};e.$Dec=L,e.$Dec=L=Ke([We(0,I.$HM),We(1,N.$hj)],L),e.$Eec=Object.freeze(new class{report(b,$,y){}})}),define(Ee[305],Se([1,0,4,6,7,26]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class L{constructor(y){this.b=new Map,this.c=[],this.d=new D.$Rd,this.onDidChangeSessions=this.d.event,this.f=new b,this.g=new b,this.a=y.getProxy(N.$EK.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,A,C,m={}){const v=I.$dm.toKey(y.identifier),S=[...C].sort().join(" ");return await this.f.getOrCreate(`${v} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const f=y.displayName||y.name;return this.a.$getSession(A,C,v,f,m)})}async getSessions(y,A,C){const m=I.$dm.toKey(y.identifier),v=[...C].sort().join(" ");return await this.g.getOrCreate(`${m} ${v}`,async()=>{await this.a.$ensureProvider(A);const S=y.displayName||y.name;return this.a.$getSessions(A,C,m,S)})}async removeSession(y,A){const C=this.b.get(y);return C?C.provider.removeSession(A):this.a.$removeSession(y,A)}registerAuthenticationProvider(y,A,C,m){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:A,provider:C,options:m??{supportsMultipleAccounts:!1}}),this.c.find(S=>S.id===y)||this.c.push({id:y,label:A});const v=C.onDidChangeSessions(S=>{this.a.$sendDidChangeSessions(y,{added:S.added??[],changed:S.changed??[],removed:S.removed??[]})});return this.a.$registerAuthenticationProvider(y,A,m?.supportsMultipleAccounts??!1),new g.$GK(()=>{v.dispose(),this.b.delete(y);const S=this.c.findIndex(f=>f.id===y);S>-1&&this.c.splice(S),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,A,C){const m=this.b.get(y);if(m)return Promise.resolve(m.provider.createSession(A,C));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const C=this.b.get(y);if(C)return Promise.resolve(C.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this.d.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.$Hec=L;class b{constructor(){this.a=new Map}getOrCreate(y,A){const C=this.a.get(y);if(C)return C;const m=A().finally(()=>this.a.delete(y));return this.a.set(y,m),m}}}),define(Ee[306],Se([1,0,6,20,15]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let I=class{constructor(b,$){this.a=b.getProxy(D.$EK.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>$.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(b,$,y){const A=g.WorkspaceEdit.from(b,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,y?.isRefactoring??!1)}};e.$Iec=I,e.$Iec=I=Ke([We(0,N.$HM)],I)}),define(Ee[307],Se([1,0,4,52,3,6,15]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class b{static{this.a=0}constructor(A,C){this.extension=A,this.provider=C,this.handle=b.a++}}class ${static{this.a=0}constructor(A){this.b=new Map,this.c=new Map,this.d=new D.$Rd,this.onDidPerformUserAction=this.d.event,this.e=A.getProxy(I.$EK.MainThreadChat)}registerChatProvider(A,C,m){const v=new b(A,m);return this.b.set(v.handle,v),this.e.$registerChatProvider(v.handle,C),(0,g.$Pc)(()=>{this.e.$unregisterChatProvider(v.handle),this.b.delete(v.handle)})}transferChatSession(A,C){const m=N.Iterable.find(this.c.keys(),v=>this.c.get(v)===A)??0;typeof m=="number"&&this.e.$transferChatSession(m,C)}sendInteractiveRequestToProvider(A,C){this.e.$sendRequestToProvider(A,C)}async $prepareChat(A,C){const m=this.b.get(A);if(!m)return;const v=await m.provider.prepareSession(C);if(!v)return;const S=$.a++;return this.c.set(S,v),{id:S,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $provideWelcomeMessage(A,C){const m=this.b.get(A);if(!m||!m.provider.provideWelcomeMessage)return;const v=await m.provider.provideWelcomeMessage(C);if(v)return v.map(S=>typeof S=="string"?S:Array.isArray(S)?S.map(f=>L.ChatReplyFollowup.from(f)):L.MarkdownString.from(S))}async $provideSampleQuestions(A,C){const m=this.b.get(A);if(!m||!m.provider.provideSampleQuestions)return;const v=await m.provider.provideSampleQuestions(C);if(v)return v?.map(S=>L.ChatReplyFollowup.from(S))}$releaseSession(A){this.c.delete(A)}async $onDidPerformUserAction(A){this.d.fire(A)}}e.$Jec=$}),define(Ee[308],Se([1,0,12,21,44,4,38,18,2,209,85,6,15,7,279,25]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class d{static{this.a=0}constructor(n,o,a){this.i=o,this.j=a,this.b=new Map,this.g=new Map,this.h=new Map,this.d=n.getProxy(C.$EK.MainThreadChatAgents2)}createChatAgent(n,o,a){const t=d.a++,r=new s(n,o,this.d,t,a);return this.b.set(t,r),this.d.$registerAgent(t,o,{}),r.apiAgent}async $invokeAgent(n,o,a,t,r,h){this.g.delete(o);const u=this.b.get(n);if(!u)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let c=!1;function l(){if(c)throw new Error("Only valid while executing the command")}const k=new D.$kh;h.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(u.extension.identifier,k.p);const R=t.command?await u.validateSlashCommand(t.command):void 0,w=L.$Nd.create(!1);let p;try{const E=u.invoke({prompt:t.message,variables:m.ChatVariable.objectTo(t.variables),slashCommand:R},{history:r.history.map(m.ChatMessage.to)},new A.$dv(P=>{l(),typeof p>"u"&&"content"in P&&(p=w.elapsed());const z=m.ChatResponseProgress.from(u.extension,P);if(!z){this.j.error("Unknown progress type: "+JSON.stringify(P));return}if("placeholder"in P&&"resolvedContent"in P){const j=Promise.all([this.d.$handleProgressChunk(a,z),P.resolvedContent]);(0,D.$Og)(j,h).then(F=>{if(!F)return;const[O,T]=F,M=m.ChatResponseProgress.from(u.extension,T);if(!M){this.j.error("Unknown progress type: "+JSON.stringify(T));return}this.d.$handleProgressChunk(a,M,O??void 0)})}else this.d.$handleProgressChunk(a,z)}),h);return await(0,D.$Og)(Promise.resolve(E).then(P=>{if(P){this.g.set(o,P);let z=this.h.get(o);z||(z=new Map,this.h.set(o,z)),z.set(a,P);const j={firstProgress:p,totalElapsed:w.elapsed()};return{errorDetails:P.errorDetails,timings:j}}else this.g.delete(o)}),h)}catch(E){return this.j.error(E,u.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,g.$Ki)(E)),responseIsIncomplete:!0}}}finally{c=!0,k.complete()}}$releaseSession(n){this.g.delete(n),this.h.delete(n)}async $provideSlashCommands(n,o){const a=this.b.get(n);return a?a.provideSlashCommand(o):[]}$provideFollowups(n,o,a){const t=this.b.get(n);if(!t)return Promise.resolve([]);const r=this.g.get(o);return r?t.provideFollowups(r,a):Promise.resolve([])}$acceptFeedback(n,o,a,t,r){const h=this.b.get(n);if(!h)return;const u=this.h.get(o)?.get(a);if(!u)return;let c;switch(t){case S.InteractiveSessionVoteDirection.Down:c=v.ChatAgentResultFeedbackKind.Unhelpful;break;case S.InteractiveSessionVoteDirection.Up:c=v.ChatAgentResultFeedbackKind.Helpful;break}h.acceptFeedback(Object.freeze(r?{result:u,kind:c,reportIssue:r}:{result:u,kind:c}))}$acceptAction(n,o,a,t){const r=this.b.get(n);if(!r)return;const h=this.h.get(o)?.get(a);h&&t.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:t.action,result:h}))}}e.$Lec=d;class s{constructor(n,o,a,t,r){this.extension=n,this.s=o,this.t=a,this.u=t,this.w=r,this.o=new I.$Rd,this.q=new I.$Rd}acceptFeedback(n){this.o.fire(n)}acceptAction(n){this.q.fire(n)}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(N.CancellationToken.None),(0,b.$Mf)(this.b));const o=this.b.find(a=>a.name===n);if(!o)throw new Error(`Unknown slashCommand: ${n}`);return o}async provideSlashCommand(n){if(!this.a)return[];const o=await this.a.provideSlashCommands(n);return o?(this.b=o,o.map(a=>({name:a.name,description:a.description,followupPlaceholder:a.followupPlaceholder,shouldRepopulate:a.shouldRepopulate,sampleRequest:a.sampleRequest}))):[]}async provideFollowups(n,o){if(!this.d)return[];const a=await this.d.provideFollowups(n,o);return a?a.map(t=>m.ChatFollowup.from(t)):[]}get apiAgent(){let n=!1,o=!1;const a=()=>{n||o||(o=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof $.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof v.$BL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:m.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:m.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),o=!1}))},t=this;return{get name(){return t.s},get description(){return t.g??""},set description(r){t.g=r,a()},get fullName(){return t.h??t.extension.displayName??t.extension.name},set fullName(r){t.h=r,a()},get iconPath(){return t.i},set iconPath(r){t.i=r,a()},get slashCommandProvider(){return t.a},set slashCommandProvider(r){t.a=r,a()},get followupProvider(){return t.d},set followupProvider(r){t.d=r,a()},get isDefault(){return(0,f.$RF)(t.extension,"defaultChatAgent"),t.j},set isDefault(r){(0,f.$RF)(t.extension,"defaultChatAgent"),t.j=r,a()},get helpTextPrefix(){return(0,f.$RF)(t.extension,"defaultChatAgent"),t.k},set helpTextPrefix(r){if((0,f.$RF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPrefix is only available on the default chat agent");t.k=r,a()},get helpTextPostfix(){return(0,f.$RF)(t.extension,"defaultChatAgent"),t.l},set helpTextPostfix(r){if((0,f.$RF)(t.extension,"defaultChatAgent"),!t.j)throw new Error("helpTextPostfix is only available on the default chat agent");t.l=r,a()},get isSecondary(){return(0,f.$RF)(t.extension,"defaultChatAgent"),t.n},set isSecondary(r){(0,f.$RF)(t.extension,"defaultChatAgent"),t.n=r,a()},get sampleRequest(){return t.m},set sampleRequest(r){t.m=r,a()},get supportIssueReporting(){return(0,f.$RF)(t.extension,"chatAgents2Additions"),t.r},set supportIssueReporting(r){(0,f.$RF)(t.extension,"chatAgents2Additions"),t.r=r,a()},get onDidReceiveFeedback(){return t.o.event},onDidPerformAction:(0,f.$QF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){n=!0,t.a=void 0,t.d=void 0,t.o.dispose(),t.t.$unregisterAgent(t.u)}}}invoke(n,o,a,t){return this.w(n,o,a,t)}}}),define(Ee[309],Se([1,0,21,3,6,15,85,26,12,4]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class A{constructor(S,f){this.stream=new $.$qh,this.stream=f??new $.$qh;const d=this;this.apiObj={option:S,response:d.stream.asyncIterable}}}class C{constructor(S,f){this.a=new y.$Rd,this.b=new Map,this.c=new $.$qh,this.d=!1;const d=this;this.apiObject={result:S,response:d.c.asyncIterable,onDidStartResponseStream:d.a.event,cancel(){f.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,s]of this.b)s.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let f=this.b.get(S.index);f||(this.b.size===0?f=new A(S.index,this.c):f=new A(S.index),this.b.set(S.index,f),this.a.fire(f.apiObj)),f.stream.emitOne(S.part)}}class m{static{this.a=1}constructor(S,f){this.d=f,this.c=new Map,this.e=new Map,this.f=new b.$fm,this.b=S.getProxy(g.$EK.MainThreadChatProvider)}registerProvider(S,f,d,s){const i=m.a++;return this.c.set(i,{extension:S,provider:d}),this.b.$registerProvider(i,f,{extension:S,displayName:s.name??S.value}),(0,N.$Pc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,f,d,s,i){const n=this.c.get(S);if(!n)return;const o=new L.$dv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${n.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(f,{index:a.index,part:a.part})});return n.provider.provideChatResponse(d.map(I.ChatMessage.to),s,o,i)}allowListExtensionWhile(S,f){this.f.set(S,f),f.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,f){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const d=this;return{get isRevoked(){return!d.f.has(S)},makeRequest(s,i,n){if(!d.f.has(S))throw new Error("Access to chat has been revoked");const o=new D.$2d(n),a=Math.random()*1e6|0,t=d.b.$fetchResponse(S,f,a,s.map(I.ChatMessage.from),i??{},o.token),r=new C(t,o);return d.e.set(a,{res:r}),t.finally(()=>{d.e.delete(a)}),r.apiObject}}}async $handleResponseFragment(S,f){const d=this.e.get(S);d&&d.res.handleFragment(f)}}e.$Kec=m}),define(Ee[310],Se([1,0,3,6,8,15]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class L{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(N.$EK.MainThreadChatVariables)}async $resolveVariable($,y,A){const C=this.b.get($);if(C)try{const m=await C.resolver.resolve(C.data.name,{message:y},A);if(m)return m.map(I.ChatVariable.from)}catch(m){(0,g.$1)(m)}}registerVariableResolver($,y,A,C){const m=L.a++;return this.b.set(m,{extension:$.identifier,data:{name:y,description:A},resolver:C}),this.c.$registerVariable(m,{name:y,description:A}),(0,D.$Pc)(()=>{this.b.delete(m),this.c.$unregisterVariable(m)})}}e.$Mec=L}),define(Ee[311],Se([1,0,6]),function($e,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class N{constructor(I){const L=I.getProxy(D.$EK.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(b){return L.$writeText(b)}})}}e.$Nec=N}),define(Ee[35],Se([1,0,18,7,15,24,6,19,14,54,29,49,2,3,5,20,147,22,68,44,38,87,90,30]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=void 0;let h=class{#e;#t;#i;constructor(w,p,E){this.b=new Map,this.c=new Map,this.#e=w.getProxy(L.$EK.MainThreadCommands),this.d=p,this.#i=E,this.#t=w.getProxy(L.$EK.MainThreadTelemetry),this.converter=new u(this,P=>{const z=this.c.get(P);return z?.result===l.Void?z:void 0},p),this.f=[{processArgument(P){return(0,y.$wh)(P)}},{processArgument(P){return(0,I.$gn)(P,function(z){if(A.$Ds.isIRange(z))return g.Range.to(z);if(C.$Cs.isIPosition(z))return g.Position.to(z);if(A.$Ds.isIRange(z.range)&&m.URI.isUri(z.uri))return g.location.to(z);if(z instanceof s.$fe)return z.buffer.buffer;if(!Array.isArray(z))return z})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const p=this.registerCommand(!1,w.id,async(...E)=>{const P=w.args.map((j,F)=>{if(!j.validate(E[F]))throw new Error(`Invalid argument '${j.name}' when running '${w.id}', received: ${typeof E[F]=="object"?JSON.stringify(E[F],null,"	"):E[F]} `);return j.convert(E[F])}),z=await this.executeCommand(w.internalId,...P);return w.result.convert(z,E,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new N.$GK(()=>{p.dispose(),this.c.delete(w.id)})}registerCommand(w,p,E,P,z,j){if(this.d.trace("ExtHostCommands#registerCommand",p),!p.trim().length)throw new Error("invalid id");if(this.b.has(p))throw new Error(`command '${p}' already exists`);return this.b.set(p,{callback:E,thisArg:P,metadata:z,extension:j}),w&&this.#e.$registerCommand(p),new N.$GK(()=>{this.b.delete(p)&&w&&this.#e.$unregisterCommand(p)})}executeCommand(w,...p){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,p,!0)}async g(w,p,E){if(this.b.has(w))return this.#e.$fireCommandActivationEvent(w),this.h(w,p,!1);{let P=!1;const z=(0,I.$gn)(p,function(j){if(j instanceof N.$HK)return g.Position.from(j);if(j instanceof N.$IK)return g.Range.from(j);if(j instanceof N.$SK)return g.location.from(j);if(N.$5L.isNotebookRange(j))return g.NotebookRange.from(j);if(j instanceof ArrayBuffer)return P=!0,s.$fe.wrap(new Uint8Array(j));if(j instanceof Uint8Array)return P=!0,s.$fe.wrap(j);if(j instanceof s.$fe)return P=!0,j;if(!Array.isArray(j))return j});try{const j=await this.#e.$executeCommand(w,P?new i.$Bv(z):z,E);return(0,y.$wh)(j)}catch(j){if(j instanceof Error&&j.message==="$executeCommand:retry")return this.g(w,p,!1);throw j}}}async h(w,p,E){const P=this.b.get(w);if(!P)throw new Error("Unknown command");const{callback:z,thisArg:j,metadata:F}=P;if(F?.args)for(let T=0;T<F.args.length;T++)try{(0,D.$Tf)(p[T],F.args[T].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${F.args[T].name}' - ${F.args[T].description}`)}const O=o.$Nd.create();try{return await z.apply(j,p)}catch(T){if(w===this.converter.delegatingCommandId){const M=this.converter.getActualCommand(...p);M&&(w=M.command)}if(this.d.error(T,w,P.extension?.identifier),!E)throw T;if(P.extension?.identifier){const M=this.#i.onExtensionError(P.extension.identifier,T);this.d.trace("forwarded error to extension?",M,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$Ki)(T)),this.id=w,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,w,O.elapsed())}}j(w,p,E){w.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new a.$to(p),duration:E})}$executeContributedCommand(w,...p){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const E=this.b.get(w);return E?(p=p.map(P=>this.f.reduce((z,j)=>j.processArgument(z,E.extension?.identifier),P)),this.h(w,p,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),this.#e.$getCommands().then(p=>(w&&(p=p.filter(E=>E[0]!=="_")),p))}$getContributedCommandMetadata(){const w=Object.create(null);for(const[p,E]of this.b){const{metadata:P}=E;P&&(w[p]=P)}return Promise.resolve(w)}};e.$3M=h,e.$3M=h=Ke([We(0,f.$HM),We(1,$.$hj),We(2,t.$2M)],h),e.$4M=(0,S.$Zh)("IExtHostCommands");class u{constructor(w,p,E){this.d=w,this.f=p,this.g=E,this.delegatingCommandId=`__vsc${(0,r.$kg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,p){if(!w)return;const E={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return E;const P=this.f(w.command);if(P)E.id=P.internalId,E.arguments=P.args.map((z,j)=>z.convert(w.arguments&&w.arguments[j]));else if((0,b.$Kb)(w.arguments)){const z=`${w.command} /${++this.c}`;this.b.set(z,w),p.add((0,v.$Pc)(()=>{this.b.delete(z),this.g.trace("CommandsConverter#DISPOSE",z)})),E.$ident=z,E.id=this.delegatingCommandId,E.arguments=[z],this.g.trace("CommandsConverter#CREATE",w.command,z)}return E}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const p=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],p?p.command:"MISSING"),p?this.d.executeCommand(p.command,...p.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.$5M=u;class c{static{this.Uri=new c("uri","Uri of a text document",w=>m.URI.isUri(w),w=>w)}static{this.Position=new c("position","A position in a text document",w=>N.$HK.isPosition(w),g.Position.from)}static{this.Range=new c("range","A range in a text document",w=>N.$IK.isRange(w),g.Range.from)}static{this.Selection=new c("selection","A selection in a text document",w=>N.$JK.isSelection(w),g.Selection.from)}static{this.Number=new c("number","",w=>typeof w=="number",w=>w)}static{this.String=new c("string","",w=>typeof w=="string",w=>w)}static{this.StringArray=c.Arr(c.String)}static Arr(w){return new c(`${w.name}_array`,`Array of ${w.name}, ${w.description}`,p=>Array.isArray(p)&&p.every(E=>w.validate(E)),p=>p.map(E=>w.convert(E)))}static{this.CallHierarchyItem=new c("item","A call hierarchy item",w=>w instanceof N.$4K,g.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new c("item","A type hierarchy item",w=>w instanceof N.$lM,g.TypeHierarchyItem.from)}static{this.TestItem=new c("testItem","A VS Code TestItem",w=>w instanceof d.$UM,g.TestItem.from)}constructor(w,p,E,P){this.name=w,this.description=p,this.validate=E,this.convert=P}optional(){return new c(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,p){return new c(w??this.name,p??this.description,this.validate,this.convert)}}e.$6M=c;class l{static{this.Void=new l("no result",w=>w)}constructor(w,p){this.description=w,this.convert=p}}e.$7M=l;class k{constructor(w,p,E,P,z){this.id=w,this.internalId=p,this.description=E,this.args=P,this.result=z}}e.$8M=k}),define(Ee[312],Se([1,0,19,17,2,83,131,46,35,15,7]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;const C=[new $.$8M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of DocumentHighlight-instances.",v(y.DocumentHighlight.to))),new $.$8M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$6M.Uri],new $.$7M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,d)=>{if((0,D.$Jb)(f))return;class s extends A.$YK{static to(n){const o=new s(n.name,y.SymbolKind.to(n.kind),n.containerName||"",new A.$SK(d[0],y.Range.to(n.range)));return o.detail=n.detail,o.range=o.location.range,o.selectionRange=y.Range.to(n.selectionRange),o.children=n.children?n.children.map(s.to):[],o}}return f.map(s.to)})),new $.$8M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$6M.Uri,new $.$6M("options","Formatting options",f=>!0,f=>f)],new $.$7M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$8M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$6M.Uri,$.$6M.Range,new $.$6M("options","Formatting options",f=>!0,f=>f)],new $.$7M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$8M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$6M.Uri,$.$6M.Position,new $.$6M("ch","Trigger character",f=>typeof f=="string",f=>f),new $.$6M("options","Formatting options",f=>!0,f=>f)],new $.$7M("A promise that resolves to an array of TextEdits.",v(y.TextEdit.to))),new $.$8M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$8M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$8M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$8M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$8M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Location-instances.",v(y.location.to))),new $.$8M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of Hover-instances.",v(y.Hover.to))),new $.$8M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$6M.Uri,new $.$6M("position","A position in a text document",f=>Array.isArray(f)&&f.every(d=>A.$HK.isPosition(d)),f=>f.map(y.Position.from))],new $.$7M("A promise that resolves to an array of ranges.",f=>f.map(d=>{let s;for(const i of d.reverse())s=new A.$3K(y.Range.to(i),s);return s}))),new $.$8M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$6M.String.with("query","Search string")],new $.$7M("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(y.WorkspaceSymbol.to))),new $.$8M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(y.CallHierarchyItem.to))),new $.$8M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$6M.CallHierarchyItem],new $.$7M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(y.CallHierarchyIncomingCall.to))),new $.$8M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$6M.CallHierarchyItem],new $.$7M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(y.CallHierarchyOutgoingCall.to))),new $.$8M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to a range and placeholder text.",f=>{if(f)return{range:y.Range.to(f.range),placeholder:f.text}})),new $.$8M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$6M.Uri,$.$6M.Position,$.$6M.String.with("newName","The new symbol name")],new $.$7M("A promise that resolves to a WorkspaceEdit.",f=>{if(f){if(f.rejectReason)throw new Error(f.rejectReason);return y.WorkspaceEdit.to(f)}})),new $.$8M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$6M.Uri,$.$6M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$7M("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(y.DocumentLink.to))),new $.$8M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$6M.Uri],new $.$7M("A promise that resolves to SemanticTokensLegend.",f=>{if(f)return new A.$WL(f.tokenTypes,f.tokenModifiers)})),new $.$8M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$6M.Uri],new $.$7M("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,L.$_0)(f);if(d.type==="full")return new A.$YL(d.data,void 0)})),new $.$8M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$6M.Uri,$.$6M.Range.optional()],new $.$7M("A promise that resolves to SemanticTokensLegend.",f=>{if(f)return new A.$WL(f.tokenTypes,f.tokenModifiers)})),new $.$8M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$6M.Uri,$.$6M.Range],new $.$7M("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const d=(0,L.$_0)(f);if(d.type==="full")return new A.$YL(d.data,void 0)})),new $.$8M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$6M.Uri,$.$6M.Position,$.$6M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$6M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$7M("A promise that resolves to a CompletionList-instance.",(f,d,s)=>{if(!f)return new A.$cL([]);const i=f.suggestions.map(n=>y.CompletionItem.to(n,s));return new A.$cL(i,f.incomplete)})),new $.$8M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$6M.Uri,$.$6M.Position,$.$6M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$7M("A promise that resolves to SignatureHelp.",f=>{if(f)return y.SignatureHelp.to(f)})),new $.$8M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$6M.Uri,$.$6M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$7M("A promise that resolves to an array of CodeLens-instances.",(f,d,s)=>v(i=>new A.$7K(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(f))),new $.$8M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$6M.Uri,new $.$6M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>A.$IK.isRange(f),f=>A.$JK.isSelection(f)?y.Selection.from(f):y.Range.from(f)),$.$6M.String.with("kind","Code action kind to return code actions for").optional(),$.$6M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$7M("A promise that resolves to an array of Command-instances.",(f,d,s)=>v(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const n=new A.$1K(i.title,i.kind?new A.$2K(i.kind):void 0);return i.edit&&(n.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(n.command=s.fromInternal(i.command)),n.isPreferred=i.isPreferred,n}})(f))),new $.$8M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$6M.Uri],new $.$7M("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(d=>new A.$iL(y.Range.to(d.range),y.Color.to(d.color))):[])),new $.$8M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$6M("color","The color to show and insert",f=>f instanceof A.$hL,y.Color.from),new $.$6M("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:y.Range.from(f.range)}))],new $.$7M("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(y.ColorPresentation.to):[])),new $.$8M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$6M.Uri,$.$6M.Range],new $.$7M("A promise that resolves to an array of Inlay objects",(f,d,s)=>f.map(y.InlayHint.to.bind(void 0,s)))),new $.$8M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$6M.Uri],new $.$7M("A promise that resolves to an array of FoldingRange objects",(f,d)=>{if(f)return f.map(y.FoldingRange.to)})),new $.$8M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$7M("A promise that resolves to an array of NotebookContentProvider static info objects.",v(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(d=>y.NotebookExclusiveDocumentPattern.to(d))})))),new $.$8M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$6M.Uri,$.$6M.Range,new $.$6M("context","An InlineValueContext",f=>f&&typeof f.frameId=="number"&&f.stoppedLocation instanceof A.$IK,f=>y.InlineValueContext.from(f))],new $.$7M("A promise that resolves to an array of InlineValue objects",f=>f.map(y.InlineValue.to))),new $.$8M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$6M("uriOrString","Uri-instance or string (only http/https)",f=>g.URI.isUri(f)||typeof f=="string"&&(0,N.$_f)(f,N.Schemas.http,N.Schemas.https),f=>f),new $.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[y.ViewColumn.from(f),void 0]:[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)])).optional(),$.$6M.String.with("label","").optional()],$.$7M.Void),new $.$8M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$6M.Uri.with("resource","Resource to open"),$.$6M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[y.ViewColumn.from(f),void 0]:[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)])).optional()],$.$7M.Void),new $.$8M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$6M.Uri.with("left","Left-hand side resource of the diff editor"),$.$6M.Uri.with("right","Right-hand side resource of the diff editor"),$.$6M.String.with("title","Human readable title for the diff editor").optional(),new $.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[y.ViewColumn.from(f.viewColumn),y.TextEditorOpenOptions.from(f)]).optional()],$.$7M.Void),new $.$8M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$6M.String.with("title","Human readable title for the changes editor"),new $.$6M("resourceList","List of resources to compare",f=>{for(const d of f){if(d.length!==3)return!1;const[s,i,n]=d;if(!g.URI.isUri(s)||!g.URI.isUri(i)&&i!==void 0&&i!==null||!g.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},f=>f)],$.$7M.Void),new $.$8M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$6M.Uri,$.$6M.Position],new $.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$8M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$6M.TypeHierarchyItem],new $.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$8M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$6M.TypeHierarchyItem],new $.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(y.TypeHierarchyItem.to))),new $.$8M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$6M.TestItem],$.$7M.Void),new $.$8M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$6M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$7M.Void),new $.$8M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$6M.String.with("name","The context key name"),new $.$6M("value","The context key value",()=>!0,f=>f)],$.$7M.Void),new $.$8M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$6M.Uri,$.$6M.StringArray,new $.$6M("MappedEditsContext","Mapped Edits Context",f=>y.MappedEditsContext.is(f),f=>y.MappedEditsContext.from(f))],new $.$7M("A promise that resolves to a workspace edit or null",f=>f?y.WorkspaceEdit.to(f):null))];class m{static register(d){C.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",b.$Yi)}}e.$Gec=m;function v(f){return d=>{if(Array.isArray(d))return d.map(f)}}function S(f){if(!Array.isArray(f))return;const d=[];for(const s of f)I.$pt(s)?d.push(y.DefinitionLink.to(s)):d.push(y.location.to(s));return d}}),define(Ee[313],Se([1,0,12,59,4,3,2,83,26,15,7,6,25]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;function v(S,f,d){const s=S.getProxy(C.$EK.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$fm,f.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const k=this.b.get(l.handle);return k?k.value:l}else if(l&&l.$mid===7){const k=this.b.get(l.commentControlHandle);if(!k)return l;const R=k.getCommentThread(l.commentThreadHandle);return R?R.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const R=k.getCommentThread(l.thread.commentThreadHandle);return R?l.$mid===8?R.value:{thread:R.value,text:l.text}:l}else if(l&&l.$mid===10){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const R=k.getCommentThread(l.thread.commentThreadHandle);if(!R)return l;const w=l.commentUniqueId,p=R.getCommentByUniqueId(w);return p||l}else if(l&&l.$mid===11){const k=this.b.get(l.thread.commentControlHandle);if(!k)return l;const R=k.getCommentThread(l.thread.commentThreadHandle);if(!R)return l;const w=l.text,p=l.commentUniqueId,E=R.getCommentByUniqueId(p);return E?(typeof E.body=="string"?E.body=w:E.body=new A.$8K(w),E):l}return l}})}createCommentController(l,k,R){const w=i.a++,p=new o(l,w,k,R);this.b.set(p.handle,p);const E=this.c.get(l.identifier)||[];return E.push(p),this.c.set(l.identifier,E),p.value}async $createCommentThreadTemplate(l,k,R){const w=this.b.get(l);w&&w.$createCommentThreadTemplate(k,R)}async $updateCommentThreadTemplate(l,k,R){const w=this.b.get(l);w&&w.$updateCommentThreadTemplate(k,R)}$deleteCommentThread(l,k){this.b.get(l)?.$deleteCommentThread(k)}$provideCommentingRanges(l,k,R){const w=this.b.get(l);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const p=d.getDocument(L.URI.revive(k));return(0,D.$Sg)(async()=>{const E=await w.commentingRangeProvider.provideCommentingRanges(p,R);let P;return Array.isArray(E)?P={ranges:E,fileComments:!1}:E?P={ranges:E.ranges||[],fileComments:E.fileComments||!1}:P=E??void 0,P}).then(E=>{let P;return E&&(P={ranges:E.ranges.map(z=>y.Range.from(z)),fileComments:E.fileComments}),P})}$toggleReaction(l,k,R,w,p){const E=this.b.get(l);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,D.$Sg)(()=>{const P=E.getCommentThread(k);if(P){const z=P.getCommentByUniqueId(w.uniqueIdInThread);if(E!==void 0&&z&&E.reactionHandler)return E.reactionHandler(z,r(p))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,k,R,w,p,E,P,z){this.m=k,this.n=R,this.o=w,this.p=p,this.q=E,this.extensionDescription=P,this.r=z,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new g.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new I.$Sc,this.l.value=new I.$Qc,this.n===void 0&&(this.n=`${l}.${this.handle}`),s.$createCommentThread(k,this.handle,this.n,this.o,y.Range.from(this.p),P.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(k,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(F){j.range=F},get comments(){return j.comments},set comments(F){j.comments=F},get collapsibleState(){return j.collapsibleState},set collapsibleState(F){j.collapsibleState=F},get canReply(){return j.canReply},set canReply(F){j.canReply=F},get contextValue(){return j.contextValue},set contextValue(F){j.contextValue=F},get label(){return j.label},set label(F){j.label=F},get state(){return j.state},set state(F){j.state=F},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new I.$Qc);const l=R=>Object.prototype.hasOwnProperty.call(this.b,R),k={};l("range")&&(k.range=y.Range.from(this.p)),l("label")&&(k.label=this.label),l("contextValue")&&(k.contextValue=this.contextValue??null),l("comments")&&(k.comments=this.q.map(R=>a(this,R,this.k,this.extensionDescription))),l("collapsibleState")&&(k.collapseState=h(this.g)),l("canReply")&&(k.canReply=this.canReply),l("state")&&(k.state=u(this.h)),l("isTemplate")&&(k.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(l){for(const k of this.k){const R=k[0],w=k[1];if(l===w)return R}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ke([(0,N.$sh)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class o{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,k,R,w){this.f=l,this.g=k,this.h=R,this.i=w,this.a=new Map,s.$registerCommentController(this.handle,R,w,this.f.identifier.value);const p=this;this.value=Object.freeze({id:p.id,label:p.label,get options(){return p.options},set options(E){p.options=E},get commentingRangeProvider(){return p.commentingRangeProvider},set commentingRangeProvider(E){p.commentingRangeProvider=E},get reactionHandler(){return p.reactionHandler},set reactionHandler(E){p.reactionHandler=E},createCommentThread(E,P,z){return p.createCommentThread(E,P,z).value},dispose:()=>{p.dispose()}}),this.e=[],this.e.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(l,k,R){k===void 0&&(0,m.$RF)(this.f,"fileComments");const w=new n(this.id,this.handle,void 0,l,k,R,this.f,!1);return this.a.set(w.handle,w),w}$createCommentThreadTemplate(l,k){const R=new n(this.id,this.handle,void 0,L.URI.revive(l),y.Range.to(k),[],this.f,!0);return R.collapsibleState=b.CommentThreadCollapsibleState.Expanded,this.a.set(R.handle,R),R}$updateCommentThreadTemplate(l,k){const R=this.a.get(l);R&&(R.range=y.Range.to(k))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function a(c,l,k,R){let w=k.get(l);return w||(w=++c.commentHandle,k.set(l,w)),l.state!==void 0&&(0,m.$RF)(R,"commentsDraftState"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:w,body:typeof l.body=="string"?l.body:y.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(p=>t(p)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(c){return{label:c.label,iconPath:c.iconPath?y.$GM(c.iconPath):void 0,count:c.count,hasReacted:c.authorHasReacted}}function r(c){return{label:c.label||"",count:c.count||0,iconPath:c.iconPath?L.URI.revive(c.iconPath):"",authorHasReacted:c.hasReacted||!1}}function h(c){if(c!==void 0)switch(c){case A.CommentThreadCollapsibleState.Expanded:return b.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return b.CommentThreadCollapsibleState.Collapsed}return b.CommentThreadCollapsibleState.Collapsed}function u(c){if(c!==void 0)switch(c){case A.CommentThreadState.Unresolved:return b.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return b.CommentThreadState.Resolved}return b.CommentThreadState.Unresolved}return new i}e.$Qec=v}),define(Ee[314],Se([1,0,24,6,27,20]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;let L=class{constructor(A,C){this.a=A.getProxy(N.$EK.MainThreadConsole),this.b=C.consoleForward.includeStack,this.c=C.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(A,C){const m=this,v=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){m.e(A,C,v,arguments)}})}e(A,C,m,v){this.a.$logExtensionHostMessage({type:"__$console",severity:C,arguments:$(v,this.b)}),this.c&&this.f(A,m,v)}};e.$Egc=L,e.$Egc=L=Ke([We(0,I.$HM),We(1,g.$XM)],L);const b=1e5;function $(y,A){const C=[];if(y.length)for(let m=0;m<y.length;m++){let v=y[m];if(typeof v>"u")v="undefined";else if(v instanceof Error){const S=v;S.stack?v=S.stack:v=S.toString()}C.push(v)}if(A){const m=new Error().stack;m&&C.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,D.$jn)(C);return m.length>b?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(Ee[149],Se([1,0,2,6,7,5,20,14,19,13,16,25]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;let v=class{static{m=this}static{this.c=0}static{this.d=250}constructor(f,d){this.h=d,this.f=new Map,this.g=f.getProxy(N.$EK.MainThreadDecorations)}registerFileDecorationProvider(f,d){const s=m.c++;this.f.set(s,{provider:f,extensionDescription:d}),this.g.$registerDecorationProvider(s,d.identifier.value);const i=f.onDidChangeFileDecorations&&f.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(s,null);return}const o=(0,$.$2b)(n);if(o.length<=m.d){this.g.$onDidChange(s,o);return}this.h.warn("[Decorations] CAPPING events from decorations provider",d.identifier.value,o.length);const a=o.map(h=>({uri:h,rank:(0,y.$Ke)(h.path,"/")})),t=(0,$.$yb)(a,(h,u)=>h.rank-u.rank||(0,y.$Ye)(h.uri.path,u.uri.path)),r=[];e:for(const h of t){let u;for(const c of h){const l=(0,A.$lc)(c.uri.path);if(u!==l&&(u=l,r.push(c.uri)>=m.d))break e}}this.g.$onDidChange(s,r)});return new g.$GK(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(f,d,s){if(!this.f.has(f))return Object.create(null);const i=Object.create(null),{provider:n,extensionDescription:o}=this.f.get(f);return await Promise.all(d.map(async a=>{try{const{uri:t,id:r}=a,h=await Promise.resolve(n.provideFileDecoration(D.URI.revive(t),s));if(!h)return;try{g.$3L.validate(h),h.badge&&typeof h.badge!="string"&&(0,C.$RF)(o,"codiconDecoration"),i[r]=[h.propagate,h.tooltip,h.badge,h.color]}catch(u){this.h.warn(`INVALID decoration from extension '${o.identifier.value}': ${u}`)}}catch(t){this.h.error(t)}})),i}};e.$Gfc=v,e.$Gfc=v=m=Ke([We(0,L.$HM),We(1,b.$hj)],v),e.$Hfc=(0,I.$Zh)("IExtHostDecorations")}),define(Ee[315],Se([1,0,210,135,2,6,7,15,4,14,28,57]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0;class v{#e;#t;#i;constructor(d,s,i,n,o,a,t,r){this.d=d,this.e=s,this.f=i,this.g=n,this.h=o,this.c=!1,this.f=Math.max(n,i),this.#i=new A.$zc(h=>a.getComparisonKey(h)),this.#e=t,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(d,s){if(!d){this.clear();return}this.j();let i=[];if(g.URI.isUri(d)){if(!s){this.delete(d);return}this.#i.set(d,s.slice()),i=[d]}else if(Array.isArray(d)){i=[];let a;d=[...d].sort(v.k);for(const t of d){const[r,h]=t;if((!a||r.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=r,i.push(r),this.#i.set(r,[])),h)this.#i.get(r)?.push(...h);else{const u=this.#i.get(r);u&&(u.length=0)}}}if(this.#t.fire(i),!this.#e)return;const n=[];let o=0;for(const a of i){let t=[];const r=this.#i.get(a);if(r)if(r.length>this.g){t=[];const h=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(const c of r)if(c.severity===h[u]&&t.push({...b.Diagnostic.from(c),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,D.localize)(0,null,r.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=r.map(h=>({...b.Diagnostic.from(h),modelVersionId:this.h(a)}));if(n.push([a,t]),o+=t.length,o>this.f)break}this.#e.$changeMany(this.e,n)}delete(d){this.j(),this.#t.fire([d]),this.#i.delete(d),this.#e?.$changeMany(this.e,[[d,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(d,s){this.j();for(const[i,n]of this)d.call(s,i,n,this)}*[Symbol.iterator](){this.j();for(const d of this.#i.keys())yield[d,this.get(d)]}get(d){this.j();const s=this.#i.get(d);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(d){return this.j(),Array.isArray(this.#i.get(d))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(d,s){return d[0].toString()<s[0].toString()?-1:d[0].toString()>s[0].toString()?1:0}}e.$Aec=v;let S=class{static{m=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*m.d}static _mapper(d){const s=new A.$zc;for(const i of d)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(d,s,i,n){this.j=s,this.k=i,this.l=n,this.g=new Map,this.h=new $.$Vd({merge:o=>o.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,m._mapper),this.f=d.getProxy(I.$EK.MainThreadDiagnostics)}createDiagnosticCollection(d,s){const{g:i,f:n,h:o,j:a,k:t,l:r}=this,h=new class{$changeMany(l,k){n.$changeMany(l,k),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,l,k.length===0?"CLEARING":k)}$clear(l){n.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,l)}dispose(){n.dispose()}};let u;if(!s)s="_generated_diagnostic_collection_name_#"+m.c++,u=s;else if(!i.has(s))u=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do u=s+m.c++;while(i.has(u))}return new class extends v{constructor(){super(s,u,m.e,m.d,l=>r.getDocument(l)?.version,t.extUri,h,o),i.set(u,this)}dispose(){super.dispose(),i.delete(u)}}}getDiagnostics(d){if(d)return this.m(d);{const s=new Map,i=[];for(const n of this.g.values())n.forEach((o,a)=>{let t=s.get(o.toString());typeof t>"u"&&(t=i.length,s.set(o.toString(),t),i.push([o,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(d){let s=[];for(const i of this.g.values())i.has(d)&&(s=s.concat(i.get(d)));return s}$acceptMarkersChange(d){if(!this.n){const s="_generated_mirror",i=new v(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of d)this.n.set(g.URI.revive(s),i.map(b.Diagnostic.to))}};e.$Bec=S,e.$Bec=S=m=Ke([We(1,y.$hj),We(2,C.$zec)],S)}),define(Ee[316],Se([1,0,2,6,25]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;class I{constructor(b){this.a=b.getProxy(N.$EK.MainThreadDialogs)}showOpenDialog(b,$){return $?.allowUIResources&&(0,g.$RF)(b,"showLocal"),this.a.$showOpenDialog($).then(y=>y?y.map(A=>D.URI.revive(A)):void 0)}showSaveDialog(b){return this.a.$showSaveDialog(b).then($=>$?D.URI.revive($):void 0)}}e.$Ifc=I}),define(Ee[317],Se([1,0,8,2,7,6,17,21,13]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class y{static{this.a=0}constructor(C,m,v){this.d=m,this.e=v,this.b=new Map,this.c=C.getProxy(I.$EK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(C,m){if(Object.keys(L.Schemas).indexOf(C)>=0)throw new Error(`scheme '${C}' already registered`);const v=y.a++;this.b.set(v,m),this.c.$registerTextContentProvider(v,C);let S;return typeof m.onDidChange=="function"&&(S=m.onDidChange(f=>{if(f.scheme!==C){this.e.warn(`Provider for scheme '${C}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(v,f).then(d=>{if(!d&&typeof d!="string")return;const s=this.d.getDocument(f);if(!s)return;const i=(0,$.$Te)(d);if(!s.equalLines(i))return this.c.$onVirtualDocumentChange(f,d)},D.$Z)})),new g.$GK(()=>{this.b.delete(v)&&this.c.$unregisterTextContentProvider(v),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(C,m){const v=this.b.get(C);return v?Promise.resolve(v.provideTextDocumentContent(N.URI.revive(m),b.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.$Jfc=y}),define(Ee[318],Se([1,0,4,3,2,6,141,15,18,24,7,8]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class m{constructor(S,f){this.a=new D.$Rd({onListenerError:C.$1}),this.b=new D.$Rd({onListenerError:C.$1}),this.c=new D.$Rd({onListenerError:C.$1}),this.d=new D.$Rd({onListenerError:C.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Qc,this.h=new Map,this.f=S.getProxy(I.$EK.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(d=>{for(const s of d)this.b.fire(s.document)},void 0,this.e),this.g.onDidAddDocuments(d=>{for(const s of d)this.a.fire(s.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const f=this.g.getDocument(S);if(f)return f}getDocument(S){const f=this.getDocumentData(S);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return f.document}ensureDocumentData(S){const f=this.g.getDocument(S);if(f)return Promise.resolve(f);let d=this.h.get(S.toString());return d||(d=this.f.$tryOpenDocument(S).then(s=>{this.h.delete(S.toString());const i=g.URI.revive(s);return(0,$.$Nf)(this.g.getDocument(i))},s=>(this.h.delete(S.toString()),Promise.reject(s))),this.h.set(S.toString(),d)),d}createDocumentData(S){return this.f.$tryCreateDocument(S).then(f=>g.URI.revive(f))}$acceptModelLanguageChanged(S,f){const d=g.URI.revive(S),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");this.b.fire(s.document),s._acceptLanguageId(f),this.a.fire(s.document)}$acceptModelSaved(S){const f=g.URI.revive(S),d=this.g.getDocument(f);if(!d)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(d.document)}$acceptDirtyStateChanged(S,f){const d=g.URI.revive(S),s=this.g.getDocument(d);if(!s)throw new Error("unknown document");s._acceptIsDirty(f),this.c.fire({document:s.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,f,d){const s=g.URI.revive(S),i=this.g.getDocument(s);if(!i)throw new Error("unknown document");i._acceptIsDirty(d),i.onEvents(f);let n;f.isUndoing?n=A.TextDocumentChangeReason.Undo:f.isRedoing&&(n=A.TextDocumentChangeReason.Redo),this.c.fire((0,y.$fn)({document:i.document,contentChanges:f.changes.map(o=>({range:b.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:n}))}setWordDefinitionFor(S,f){(0,L.$JM)(S,f)}}e.$xec=m}),define(Ee[69],Se([1,0,60,4,3,2,5,6,141,20,148,15,14,28,17,52,43]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0;class s{constructor(o){this.value=o,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(o,a){this.h=o,this.i=a,this.a=null,this.b=new Map,this.c=new v.$zc,this.d=new N.$Rd,this.e=new N.$Rd,this.f=new N.$Rd,this.g=new N.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(o){this.acceptDocumentsAndEditorsDelta(o)}acceptDocumentsAndEditorsDelta(o){const a=[],t=[],r=[];if(o.removedDocuments)for(const h of o.removedDocuments){const u=I.URI.revive(h),c=this.c.get(u);c?.unref()&&(this.c.delete(u),a.push(c.value))}if(o.addedDocuments)for(const h of o.addedDocuments){const u=I.URI.revive(h.uri);let c=this.c.get(u);if(c&&u.scheme!==S.Schemas.vscodeNotebookCell&&u.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${u} already exists!'`);c||(c=new s(new $.$KM(this.h.getProxy(b.$EK.MainThreadDocuments),u,h.lines,h.EOL,h.versionId,h.languageId,h.isDirty,h.notebook)),this.c.set(u,c),t.push(c.value)),c.ref()}if(o.removedEditors)for(const h of o.removedEditors){const u=this.b.get(h);this.b.delete(h),u&&r.push(u)}if(o.addedEditors)for(const h of o.addedEditors){const u=I.URI.revive(h.documentUri);D.ok(this.c.has(u),`document '${u}' does not exist`),D.ok(!this.b.has(h.id),`editor '${h.id}' already exists!`);const c=this.c.get(u).value,l=new A.$QM(h.id,this.h.getProxy(b.$EK.MainThreadTextEditors),this.i,new d.$U(()=>c.document),h.selections.map(C.Selection.to),h.options,h.visibleRanges.map(k=>C.Range.to(k)),typeof h.editorPosition=="number"?C.ViewColumn.to(h.editorPosition):void 0);this.b.set(h.id,l)}o.newActiveEditor!==void 0&&(D.ok(o.newActiveEditor===null||this.b.has(o.newActiveEditor),`active editor '${o.newActiveEditor}' does not exist`),this.a=o.newActiveEditor),(0,g.$Mc)(a),(0,g.$Mc)(r),o.removedDocuments&&this.e.fire(a),o.addedDocuments&&this.d.fire(t),(o.removedEditors||o.addedEditors)&&this.f.fire(this.allEditors().map(h=>h.value)),o.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(o){return this.c.get(o)?.value}allDocuments(){return f.Iterable.map(this.c.values(),o=>o.value)}getEditor(o){return this.b.get(o)}activeEditor(o){if(!this.a)return;const a=this.b.get(this.a);return o?a:a?.value}allEditors(){return[...this.b.values()]}};e.$RM=i,e.$RM=i=Ke([We(0,y.$HM),We(1,m.$hj)],i),e.$SM=(0,L.$Zh)("IExtHostDocumentsAndEditors")}),define(Ee[70],Se([1,0,73,4,18,2,5,6,20,15,7]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,e.$0ec=(0,L.$Zh)("IExtHostEditorTabs");class C{constructor(d,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(d)}get apiObject(){if(!this.a){const d=this,s={get isActive(){return d.b.id===d.e()},get label(){return d.b.label},get input(){return d.c},get isDirty(){return d.b.isDirty},get isPinned(){return d.b.isPinned},get isPreview(){return d.b.isPreview},get group(){return d.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(d){this.b=d,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$mM(I.URI.revive(this.b.input.uri));case 2:return new A.$nM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new A.$oM(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new A.$pM(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$qM(this.b.input.viewType);case 4:return new A.$rM(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$sM(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$tM;case 9:return new A.$uM(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$vM(this.b.input.providerId);default:return}}}class m{constructor(d,s){this.c=[],this.d="",this.b=d,this.e=s;for(const i of d.tabs)i.isActive&&(this.d=i.id),this.c.push(new C(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const d=this,s={get isActive(){return d.b.groupId===d.e()},get viewColumn(){return y.ViewColumn.to(d.b.viewColumn)},get activeTab(){return d.c.find(i=>i.tabId===d.d)?.apiObject},get tabs(){return Object.freeze(d.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(d){this.b=d}acceptTabOperation(d){if(d.kind===0){const i=new C(d.tabDto,this,()=>this.activeTabId());return this.c.splice(d.index,0,i),d.tabDto.isActive&&(this.d=i.tabId),i}else if(d.kind===1){const i=this.c.splice(d.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(d.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this.c.splice(d.index,0,i),i}const s=this.c.find(i=>i.tabId===d.tabDto.id);if(!s)throw new Error("INVALID tab");return d.tabDto.isActive?this.d=d.tabDto.id:this.d===d.tabDto.id&&!d.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(d.tabDto),s}activeTabId(){return this.d}}let v=class{constructor(d){this.b=new N.$Rd,this.c=new N.$Rd,this.e=[],this.a=d.getProxy(b.$EK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const d=this,s={onDidChangeTabGroups:d.c.event,onDidChangeTabs:d.b.event,get all(){return Object.freeze(d.e.map(i=>i.apiObject))},get activeTabGroup(){const i=d.d;return(0,g.$Nf)(d.e.find(o=>o.groupId===i)?.apiObject)},close:async(i,n)=>{const o=Array.isArray(i)?i:[i];return o.length?S(o[0])?this.j(o,n):this.i(o,n):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(d){const s=new Set(this.e.map(h=>h.groupId)),i=new Set(d.map(h=>h.groupId)),n=(0,D.$K)(s,i),o=this.e.filter(h=>n.removed.includes(h.groupId)).map(h=>h.apiObject),a=[],t=[];this.e=d.map(h=>{const u=new m(h,()=>this.d);return n.added.includes(u.groupId)?a.push(u.apiObject):t.push(u.apiObject),u});const r=(0,g.$Nf)(d.find(h=>h.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:a,closed:o,changed:t}))}$acceptTabGroupUpdate(d){const s=this.e.find(i=>i.groupId===d.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(d),d.isActive&&(this.d=d.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const s=this.e.find(n=>n.groupId===d.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(d);switch(d.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(d){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===d)return i}h(d){return this.e.find(s=>s.apiObject===d)}async i(d,s){const i=[];for(const n of d){const o=this.g(n);if(!o)throw new Error("Tab close: Invalid tab not found!");i.push(o.tabId)}return this.a.$closeTab(i,s)}async j(d,s){const i=[];for(const n of d){const o=this.h(n);if(!o)throw new Error("Group close: Invalid group not found!");i.push(o.groupId)}return this.a.$closeGroup(i,s)}};e.$$ec=v,e.$$ec=v=Ke([We(0,$.$HM)],v);function S(f){return f.tabs!==void 0}}),define(Ee[319],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class g{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(D.$EK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,b,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(L);if(!y)throw new Error("Embedding vector provider not found");const A=await y.provideEmbeddingVector(b,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,b,$){const y=this.b;return this.b++,this.a.set(y,$),this.c.$registerAiEmbeddingVectorProvider(b,y),new N.$GK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$Lfc=g}),define(Ee[320],Se([1,0,2,6,3,7,15,172,13,22,25,80]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class m{constructor(){this.a=[]}add(f){this.b=void 0,this.a.push(f)}delete(f){const d=this.a.indexOf(f);d>=0&&(this.a.splice(d,1),this.b=void 0)}c(){if(!this.b){const f=this.a.sort(),d=[];let s,i,n=14,o=14;for(const a of f){let t=s?(0,$.$8e)(s,a):0;for(t===0?i=1:i=o;t<a.length;t++)t+1===a.length?(n=o,o=9):o+=1,d.push([i,a.toUpperCase().charCodeAt(t),o]),d.push([i,a.toLowerCase().charCodeAt(t),o]),i=o;s=a,o=n}d.push([9,58,10]),d.push([10,47,12]),this.b=new b.$bZ(d)}}provideDocumentLinks(f){this.c();const d=[],s=b.$cZ.computeLinks({getLineContent(i){return f.lineAt(i-1).text},getLineCount(){return f.lineCount}},this.b);for(const i of s){const n=L.DocumentLink.to(i);n.target&&d.push(n)}return d}}class v{constructor(f,d){this.i=d,this.b=new m,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=f.getProxy(N.$EK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(f,d,s,i={}){if(v.j(s),this.d.has(d))throw new Error(`a provider for the scheme '${d}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(f,"*",this.b));const n=this.h++;this.b.add(d),this.d.add(d),this.c.set(n,s);let o=2;i.isCaseSensitive&&(o+=1024),i.isReadonly&&(o+=2048),typeof s.copy=="function"&&(o+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$RF)(f,"fsChunks"),o+=4);let a;i.isReadonly&&(0,C.$ck)(i.isReadonly)&&((0,A.$RF)(f,"readonlyMessage"),a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(n,d,o,a).catch(r=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${d}`),console.error(r)});const t=s.onDidChangeFile(r=>{const h=[];for(const u of r){const{uri:c,type:l}=u;if(c.scheme!==d)continue;let k;switch(l){case I.FileChangeType.Changed:k=0;break;case I.FileChangeType.Created:k=1;break;case I.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}h.push({resource:c,type:k})}this.a.$onFileSystemChange(n,h)});return(0,g.$Pc)(()=>{t.dispose(),this.b.delete(d),this.d.delete(d),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(f){if(!f)throw new Error("MISSING provider");if(typeof f.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof f.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof f.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof f.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof f.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof f.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof f.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof f.rename!="function")throw new Error("Provider does NOT implement rename")}static k(f){const{type:d,ctime:s,mtime:i,size:n,permissions:o}=f;return{type:d,ctime:s,mtime:i,size:n,permissions:o}}$stat(f,d){return Promise.resolve(this.l(f).stat(D.URI.revive(d))).then(s=>v.k(s))}$readdir(f,d){return Promise.resolve(this.l(f).readDirectory(D.URI.revive(d)))}$readFile(f,d){return Promise.resolve(this.l(f).readFile(D.URI.revive(d))).then(s=>y.$fe.wrap(s))}$writeFile(f,d,s,i){return Promise.resolve(this.l(f).writeFile(D.URI.revive(d),s.buffer,i))}$delete(f,d,s){return Promise.resolve(this.l(f).delete(D.URI.revive(d),s))}$rename(f,d,s,i){return Promise.resolve(this.l(f).rename(D.URI.revive(d),D.URI.revive(s),i))}$copy(f,d,s,i){const n=this.l(f);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(D.URI.revive(d),D.URI.revive(s),i))}$mkdir(f,d){return Promise.resolve(this.l(f).createDirectory(D.URI.revive(d)))}$watch(f,d,s,i){const n=this.l(f).watch(D.URI.revive(s),i);this.f.set(d,n)}$unwatch(f,d){const s=this.f.get(d);s&&(s.dispose(),this.f.delete(d))}$open(f,d,s){const i=this.l(f);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(D.URI.revive(d),s))}$close(f,d){const s=this.l(f);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(d))}$read(f,d,s,i){const n=this.l(f);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const o=y.$fe.alloc(i);return Promise.resolve(n.read(d,s,o.buffer,0,i)).then(a=>o.slice(0,a))}$write(f,d,s,i){const n=this.l(f);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(d,s,i.buffer,0,i.byteLength))}l(f){const d=this.c.get(f);if(!d){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return d}}e.$Mfc=v}),define(Ee[71],Se([1,0,6,32,7,22,5,20,57,3,12,23,17]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;let S=v=class{constructor(d,s){this.b=new Map,this.c=new A.$9g,this.a=d.getProxy(D.$EK.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(n){try{let o;const a=i.b.get(n.scheme);return a?(await i.a.$ensureActivation(n.scheme),o=await a.impl.stat(n)):o=await i.a.$stat(n),{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions===N.FilePermission.Readonly?1:void 0}}catch(o){v.e(o)}},async readDirectory(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readDirectory(n)).slice()):await i.a.$readdir(n)}catch(o){return v.e(o)}},async createDirectory(n){try{const o=i.b.get(n.scheme);return o&&!o.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(o.impl,o.extUri,n)):await i.a.$mkdir(n)}catch(o){return v.e(o)}},async readFile(n){try{const o=i.b.get(n.scheme);return o?(await i.a.$ensureActivation(n.scheme),(await o.impl.readFile(n)).slice()):(await i.a.$readFile(n)).buffer}catch(o){return v.e(o)}},async writeFile(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(n)),await i.c.queueFor(n).queue(()=>Promise.resolve(a.impl.writeFile(n,o,{create:!0,overwrite:!0})))):await i.a.$writeFile(n,I.$fe.wrap(o))}catch(a){return v.e(a)}},async delete(n,o){try{const a=i.b.get(n.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(n.scheme),await a.impl.delete(n,{recursive:!1,...o})):await i.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...o})}catch(a){return v.e(a)}},async rename(n,o,a){try{return await i.a.$rename(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},async copy(n,o,a){try{return await i.a.$copy(n,o,{overwrite:!1,...a})}catch(t){return v.e(t)}},isWritableFileSystem(n){const o=s.getCapabilities(n);if(typeof o=="number")return!(o&2048)}})}async d(d,s,i){const n=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await d.stat(i)).type&N.FileType.Directory))throw g.$UL.FileExists(`Unable to create folder '${i.scheme===m.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(o){if(N.$yk(o)!==N.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(i)),i=s.dirname(i)}for(let o=n.length-1;o>=0;o--){i=s.joinPath(i,n[o]);try{await d.createDirectory(i)}catch(a){if(N.$yk(a)!==N.FileSystemProviderErrorCode.FileExists)throw a}}}static e(d){if(d instanceof g.$UL)throw d;if(d instanceof N.$uk)switch(d.code){case N.FileSystemProviderErrorCode.FileExists:throw g.$UL.FileExists(d.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$UL.FileNotFound(d.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$UL.FileNotADirectory(d.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$UL.FileIsADirectory(d.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$UL.NoPermissions(d.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$UL.Unavailable(d.message);default:throw new g.$UL(d.message,d.name)}if(!(d instanceof Error))throw new g.$UL(String(d));if(d.name==="ENOPRO"||d.message.includes("ENOPRO"))throw g.$UL.Unavailable(d.message);switch(d.name){case N.FileSystemProviderErrorCode.FileExists:throw g.$UL.FileExists(d.message);case N.FileSystemProviderErrorCode.FileNotFound:throw g.$UL.FileNotFound(d.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw g.$UL.FileNotADirectory(d.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw g.$UL.FileIsADirectory(d.message);case N.FileSystemProviderErrorCode.NoPermissions:throw g.$UL.NoPermissions(d.message);case N.FileSystemProviderErrorCode.Unavailable:throw g.$UL.Unavailable(d.message);default:throw new g.$UL(d.message,d.name)}}addFileSystemProvider(d,s,i){return this.b.set(d,{impl:s,extUri:i?.isCaseSensitive?C.$rg:C.$tg,isReadonly:!!i?.isReadonly}),(0,y.$Pc)(()=>this.b.delete(d))}getFileSystemProviderExtUri(d){return this.b.get(d)?.extUri??C.$rg}};e.$Yec=S,e.$Yec=S=v=Ke([We(0,b.$HM),We(1,$.$zec)],S),e.$Zec=(0,L.$Zh)("IExtHostConsumerFileSystem")}),define(Ee[321],Se([1,0,4,34,2,6,15,7,43]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(v,S,f,d,s,i){this.a=Math.random(),this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$Gj)(s),o=typeof s=="string",a=i?.correlate,t=d(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(a&&typeof r.session>"u")){if(!i?.ignoreCreateEvents)for(const h of r.created){const u=g.URI.revive(h);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.b.fire(u)}if(!i?.ignoreChangeEvents)for(const h of r.changed){const u=g.URI.revive(h);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.c.fire(u)}if(!i?.ignoreDeleteEvents)for(const h of r.deleted){const u=g.URI.revive(h);n(u.fsPath)&&(!o||S.getWorkspaceFolder(u))&&this.d.fire(u)}}});this.g=b.$GK.from(this.i(v,f,s,i,i?.correlate),this.b,this.c,this.d,t)}i(v,S,f,d,s){const i=b.$GK.from();if(typeof f=="string")return i;const n=v.getProxy(I.$EK.MainThreadFileSystemEventService);let o=!1;return(f.pattern.includes(N.$Cj)||f.pattern.includes(N.$Dj))&&(o=!0),n.$watch(S.identifier.value,this.a,f.baseUri,{recursive:o,excludes:d?.excludes??[]},!!s),b.$GK.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(v){this.a=v,this.session=this.a.session,this.b=new $.$U(()=>this.a.created.map(g.URI.revive)),this.c=new $.$U(()=>this.a.changed.map(g.URI.revive)),this.d=new $.$U(()=>this.a.deleted.map(g.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class C{constructor(v,S,f){this.j=v,this.k=S,this.l=f,this.a=new D.$Rd,this.b=new D.$Rd,this.c=new D.$Rd,this.d=new D.$Rd,this.g=new D.$Td,this.h=new D.$Td,this.i=new D.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(v,S,f,d){return new y(this.j,v,S,this.a.event,L.GlobPattern.from(f),d)}$onFileEvent(v){this.a.fire(new A(v))}$onDidRunFileOperation(v,S){switch(v){case 2:this.b.fire(Object.freeze({files:S.map(f=>({oldUri:g.URI.revive(f.source),newUri:g.URI.revive(f.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(f=>g.URI.revive(f.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(f=>g.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(v){return this.m(v,this.g)}getOnWillCreateFileEvent(v){return this.m(v,this.h)}getOnWillDeleteFileEvent(v){return this.m(v,this.i)}m(v,S){return(f,d,s)=>{const i=function(o){f.call(d,o)};return i.extension=v,S.event(i,void 0,s)}}async $onWillRunFileOperation(v,S,f,d){switch(v){case 2:return await this.n(this.g,{files:S.map(s=>({oldUri:g.URI.revive(s.source),newUri:g.URI.revive(s.target)}))},f,d);case 1:return await this.n(this.i,{files:S.map(s=>g.URI.revive(s.target))},f,d);case 0:case 3:return await this.n(this.h,{files:S.map(s=>g.URI.revive(s.target))},f,d)}}async n(v,S,f,d){const s=new Set,i=[];if(await v.fireAsync(S,d,async(o,a)=>{const t=Date.now(),r=await Promise.resolve(o);r instanceof b.$QK&&(i.push([a.extension,r]),s.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>f&&this.k.warn("SLOW file-participant",a.extension.identifier)}),d.isCancellationRequested||i.length===0)return;const n={edits:[]};for(const[,o]of i){const{edits:a}=L.WorkspaceEdit.from(o,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(a)}return{edit:n,extensionNames:Array.from(s)}}}e.$Nfc=C}),define(Ee[322],Se([1,0,3,2,6,15,7,35,12]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;class y{static{this.a=0}constructor(v,S){this.extension=v,this.provider=S,this.handle=y.a++}}class A{constructor(v){this.session=v,this.responses=[]}}class C{static{this.a=0}constructor(v,S,f,d){this.f=f,this.g=d,this.b=new Map,this.d=new Map,this.e=v.getProxy(g.$EK.MainThreadInlineChat),S.registerApiCommand(new b.$8M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new b.$6M("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?I.Range.from(s.initialRange):void 0,initialSelection:s.initialSelection?I.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?I.Position.from(s.position):void 0}})],b.$7M.Void))}registerProvider(v,S,f){const d=new y(v,S);return this.b.set(d.handle,d),this.e.$registerInteractiveEditorProvider(d.handle,f?.label??v.displayName??v.name,v.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",f?.supportReportIssue??!1),(0,D.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(d.handle),this.b.delete(d.handle)})}async $prepareSession(v,S,f,d){const s=this.b.get(v);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(N.URI.revive(S)),n=I.Selection.to(f),o=await s.provider.prepareInteractiveEditorSession({document:i,selection:n},d);if(!o)return;if(o.wholeRange&&!o.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=C.a++;return this.d.set(a,new A(o)),{id:a,placeholder:o.placeholder,input:o.input,slashCommands:o.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:I.Range.from(o.wholeRange),message:o.message}}async $provideResponse(v,S,f,d){const s=this.b.get(v);if(!s)return;const i=this.d.get(S.id);if(!i)return;const n={prompt:f.prompt,selection:I.Selection.to(f.selection),wholeRange:I.Range.to(f.wholeRange),attempt:f.attempt,live:f.live};let o=!1;const a={report:async c=>{if(!f.live&&c.edits?.length)throw new Error("Progress reporting is only supported for live sessions");o||d.isCancellationRequested||await this.e.$handleProgressChunk(f.requestId,{message:c.message,edits:c.edits?.map(I.TextEdit.from),editsShouldBeInstant:c.editsShouldBeInstant,slashCommand:c.slashCommand?.command,markdownFragment:L.$8K.isMarkdownString(c.content)?c.content.value:c.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,n,a,d));let r;try{r=await(0,$.$Og)(t,d)}finally{o=!0}if(!r)return;const h=i.responses.push(r)-1,u={wholeRange:I.Range.from(r.wholeRange),placeholder:r.placeholder};if(C.h(r)){const{edits:c,contents:l}=r,k=l!==void 0?I.MarkdownString.from(l):void 0;return c instanceof L.$QK?{...u,id:h,type:"bulkEdit",edits:I.WorkspaceEdit.from(c),message:k}:{...u,id:h,type:"editorEdit",edits:c.map(I.TextEdit.from),message:k}}return{...u,id:h,type:"message",message:I.MarkdownString.from(r.contents)}}async $provideFollowups(v,S,f,d){const s=this.b.get(v),i=this.d.get(S),n=i?.responses[f];if(s&&n&&s.provider.provideFollowups){const o=Promise.resolve(s.provider.provideFollowups(i.session,n,d));return(await(0,$.$Og)(o,d))?.map(I.ChatReplyFollowup.from)}}$handleFeedback(v,S,f,d){const s=this.b.get(v),i=this.d.get(S),n=i?.responses[f];if(s&&n){const o=I.InteractiveEditorResponseFeedbackKind.to(d);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,n,o)}}$releaseSession(v,S){}static h(v){return typeof v=="object"&&typeof v.edits=="object"}}e.$Ofc=C}),define(Ee[323],Se([1,0,2,35]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class g{constructor(L,b,$,y,A){this.a=b,this.b=$,this.c=y;const C=new N.$8M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$6M("showOptions","Show Options",m=>!0,m=>m),new N.$6M("resource","Interactive resource Uri",m=>!0,m=>m),new N.$6M("controllerId","Notebook controller Id",m=>!0,m=>m),new N.$6M("title","Interactive editor title",m=>!0,m=>m)],new N.$7M("Notebook and input URI",m=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const v=this.a.getEditorById(m.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",v.id),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri),notebookEditor:v.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:D.URI.revive(m.notebookUri),inputUri:D.URI.revive(m.inputUri)}}));this.c.registerApiCommand(C)}$willAddInteractiveDocument(L,b,$,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:b,lines:[""],languageId:$,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(D.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,b){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$2fc=g}),define(Ee[324],Se([1,0,6,7]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class g{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(D.$EK.MainThreadIssueReporter)}async $getIssueReporterUri(L,b){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(L);if(!$)throw new Error("Issue request handler not found");const y=await $.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueData(b);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(L,b){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(L);if(!$)throw new Error("Issue data provider not found");const y=await $.provideIssueTemplate(b);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(L,b){const $=L.identifier.value;return this.a.set($,b),this.c.$registerIssueUriRequestHandler($),new N.$GK(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(L,b){const $=L.identifier.value;return this.b.set($,b),this.c.$registerIssueDataProvider($),new N.$GK(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$3fc=g}),define(Ee[325],Se([1,0,3,6]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class g{constructor(L){this.b=0,this.a=L.getProxy(N.$EK.MainThreadLabelService)}$registerResourceLabelFormatter(L){const b=this.b++;return this.a.$registerResourceLabelFormatter(b,L),(0,D.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(b)})}}e.$4fc=g}),define(Ee[326],Se([1,0,2,24,15,7,83,6,13,29,19,18,168,21,26,3,131,121,110,38,8,12,25,212]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class h{constructor(B,_){this.d=B,this.e=_}async provideDocumentSymbols(B,_){const se=this.d.getDocument(B),K=await this.e.provideDocumentSymbols(se,_);if(!(0,A.$Jb)(K))return K[0]instanceof I.$ZK?K.map(g.DocumentSymbol.from):h.f(K)}static f(B){B=B.slice(0).sort((K,ae)=>{let de=K.location.range.start.compareTo(ae.location.range.start);return de===0&&(de=ae.location.range.end.compareTo(K.location.range.end)),de});const _=[],se=[];for(const K of B){const ae={name:K.name||"!!MISSING: name!!",kind:g.SymbolKind.from(K.kind),tags:K.tags?.map(g.SymbolTag.from)||[],detail:"",containerName:K.containerName,range:g.Range.from(K.location.range),selectionRange:g.Range.from(K.location.range),children:[]};for(;;){if(se.length===0){se.push(ae),_.push(ae);break}const de=se[se.length-1];if(y.$Ds.containsRange(de.range,ae.range)&&!y.$Ds.equalsRange(de.range,ae.range)){de.children?.push(ae),se.push(ae);break}se.pop()}}return _}}class u{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(B,_,se){this.g=B,this.h=_,this.j=se,this.e=new i.$vec("CodeLens"),this.f=new Map}async provideCodeLenses(B,_){const se=this.g.getDocument(B),K=await this.j.provideCodeLenses(se,_);if(!K||_.isCancellationRequested)return;const ae=this.e.add(K),de=new f.$Qc;this.f.set(ae,de);const Re={cacheId:ae,lenses:[]};for(let Be=0;Be<K.length;Be++)Re.lenses.push({cacheId:[ae,Be],range:g.Range.from(K[Be].range),command:this.h.toInternal(K[Be].command,de)});return Re}async resolveCodeLens(B,_){const se=B.cacheId&&this.e.get(...B.cacheId);if(!se)return;let K;if(typeof this.j.resolveCodeLens!="function"||se.isResolved?K=se:K=await this.j.resolveCodeLens(se,_),K||(K=se),_.isCancellationRequested)return;const ae=B.cacheId&&this.f.get(B.cacheId[0]);if(ae)return B.command=this.h.toInternal(K.command??u.d,ae),B}releaseCodeLenses(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}}function c(Me){return Array.isArray(Me)?Me.map(g.DefinitionLink.from):Me?[g.DefinitionLink.from(Me)]:[]}class l{constructor(B,_){this.d=B,this.e=_}async provideDefinition(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDefinition(K,ae,se);return c(de)}}class k{constructor(B,_){this.d=B,this.e=_}async provideDeclaration(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDeclaration(K,ae,se);return c(de)}}class R{constructor(B,_){this.d=B,this.e=_}async provideImplementation(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideImplementation(K,ae,se);return c(de)}}class w{constructor(B,_){this.d=B,this.e=_}async provideTypeDefinition(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideTypeDefinition(K,ae,se);return c(de)}}class p{constructor(B,_){this.d=B,this.e=_}async provideHover(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideHover(K,ae,se);if(!(!de||(0,A.$Jb)(de.contents)))return de.range||(de.range=K.getWordRangeAtPosition(ae)),de.range||(de.range=new I.$IK(ae,ae)),g.Hover.from(de)}}class E{constructor(B,_){this.d=B,this.e=_}async provideEvaluatableExpression(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideEvaluatableExpression(K,ae,se);if(de)return g.EvaluatableExpression.from(de)}}class P{constructor(B,_){this.d=B,this.e=_}async provideInlineValues(B,_,se,K){const ae=this.d.getDocument(B),de=await this.e.provideInlineValues(ae,g.Range.to(_),g.InlineValueContext.to(se),K);if(Array.isArray(de))return de.map(Re=>g.InlineValue.from(Re))}}class z{constructor(B,_){this.d=B,this.e=_}async provideDocumentHighlights(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideDocumentHighlights(K,ae,se);if(Array.isArray(de))return de.map(g.DocumentHighlight.from)}}class j{constructor(B,_){this.d=B,this.e=_}async provideMultiDocumentHighlights(B,_,se,K){const ae=this.d.getDocument(B),de=se.map(Xe=>this.d.getDocument(Xe)),Re=g.Position.to(_),Be=await this.e.provideMultiDocumentHighlights(ae,Re,de,K);if(Array.isArray(Be))return Be.map(g.MultiDocumentHighlight.from)}}class F{constructor(B,_){this.d=B,this.e=_}async provideLinkedEditingRanges(B,_,se){const K=this.d.getDocument(B),ae=g.Position.to(_),de=await this.e.provideLinkedEditingRanges(K,ae,se);if(de&&Array.isArray(de.ranges))return{ranges:(0,A.$Gb)(de.ranges.map(g.Range.from)),wordPattern:de.wordPattern}}}class O{constructor(B,_){this.d=B,this.e=_}async provideReferences(B,_,se,K){const ae=this.d.getDocument(B),de=g.Position.to(_),Re=await this.e.provideReferences(ae,de,se,K);if(Array.isArray(Re))return Re.map(g.location.from)}}class T{static{this.d=1e3}constructor(B,_,se,K,ae,de,Re){this.g=B,this.h=_,this.j=se,this.k=K,this.l=ae,this.m=de,this.n=Re,this.e=new i.$vec("CodeAction"),this.f=new Map}async provideCodeActions(B,_,se,K){const ae=this.g.getDocument(B),de=m.$Fs.isISelection(_)?g.Selection.to(_):g.Range.to(_),Re=[];for(const Pe of this.j.getDiagnostics(B))if(de.intersection(Pe.range)&&Re.push(Pe)>T.d)break;const Be={diagnostics:Re,only:se.only?new I.$2K(se.only):void 0,triggerKind:g.CodeActionTriggerKind.to(se.trigger)},Xe=await this.k.provideCodeActions(ae,de,Be,K);if(!(0,A.$Kb)(Xe)||K.isCancellationRequested)return;const Ye=this.e.add(Xe),it=new f.$Qc;this.f.set(Ye,it);const st=[];for(let Pe=0;Pe<Xe.length;Pe++){const Te=Xe[Pe];Te&&(T.o(Te)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),st.push({_isSynthetic:!0,title:Te.title,command:this.h.toInternal(Te,it)})):(Be.only&&(Te.kind?Be.only.contains(Te.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${Te.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),st.push({cacheId:[Ye,Pe],title:Te.title,command:Te.command&&this.h.toInternal(Te.command,it),diagnostics:Te.diagnostics&&Te.diagnostics.map(g.Diagnostic.from),edit:Te.edit&&g.WorkspaceEdit.from(Te.edit,void 0),kind:Te.kind&&Te.kind.value,isPreferred:Te.isPreferred,isAI:(0,t.$QF)(this.m,"codeActionAI")?Te.isAI:!1,disabled:Te.disabled?.reason})))}return{cacheId:Ye,actions:st}}async resolveCodeAction(B,_){const[se,K]=B,ae=this.e.get(se,K);if(!ae||T.o(ae))return{};if(!this.k.resolveCodeAction)return{};const de=await this.k.resolveCodeAction(ae,_)??ae;let Re;de.edit&&(Re=g.WorkspaceEdit.from(de.edit,void 0));let Be;if(de.command){const Xe=this.f.get(se);Xe&&(Be=this.h.toInternal(de.command,Xe))}return{edit:Re,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class M{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,se,K,ae){this.d=B,this.e=_,this.f=se,this.g=K,this.h=ae}async prepareDocumentPaste(B,_,se,K){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(B),de=_.map(Xe=>g.Range.to(Xe)),Re=g.DataTransfer.toDataTransfer(se,()=>{throw new o.$0});if(await this.f.prepareDocumentPaste(ae,de,Re,K),K.isCancellationRequested)return;const Be=Array.from(Re).filter(([,Xe])=>!(Xe instanceof I.$vL));return g.DataTransfer.from(Be)}async providePasteEdits(B,_,se,K,ae){if(!this.f.provideDocumentPasteEdits)return;const de=this.e.getDocument(_),Re=se.map(Ye=>g.Range.to(Ye)),Be=g.DataTransfer.toDataTransfer(K,async Ye=>(await this.d.$resolvePasteFileData(this.g,B,Ye)).buffer),Xe=await this.f.provideDocumentPasteEdits(de,Re,Be,ae);if(Xe)return{label:Xe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Xe.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:M.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?g.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class W{constructor(B,_){this.d=B,this.e=_}async provideDocumentFormattingEdits(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideDocumentFormattingEdits(K,_,se);if(Array.isArray(ae))return ae.map(g.TextEdit.from)}}class Y{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeFormattingEdits(B,_,se,K){const ae=this.d.getDocument(B),de=g.Range.to(_),Re=await this.e.provideDocumentRangeFormattingEdits(ae,de,se,K);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,_,se,K){(0,C.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(B),de=_.map(g.Range.to),Re=await this.e.provideDocumentRangesFormattingEdits(ae,de,se,K);if(Array.isArray(Re))return Re.map(g.TextEdit.from)}}class ue{constructor(B,_){this.d=B,this.e=_,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,_,se,K,ae){const de=this.d.getDocument(B),Re=g.Position.to(_),Be=await this.e.provideOnTypeFormattingEdits(de,Re,se,K,ae);if(Array.isArray(Be))return Be.map(g.TextEdit.from)}}class Z{constructor(B,_){this.e=B,this.f=_,this.d=new i.$vec("WorkspaceSymbols")}async provideWorkspaceSymbols(B,_){const se=await this.e.provideWorkspaceSymbols(B,_);if(!(0,A.$Kb)(se))return{symbols:[]};const K=this.d.add(se),ae={cacheId:K,symbols:[]};for(let de=0;de<se.length;de++){const Re=se[de];if(!Re||!Re.name){this.f.warn("INVALID SymbolInformation",Re);continue}ae.symbols.push({...g.WorkspaceSymbol.from(Re),cacheId:[K,de]})}return ae}async resolveWorkspaceSymbol(B,_){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const se=this.d.get(...B.cacheId);if(se){const K=await this.e.resolveWorkspaceSymbol(se,_);return K&&(0,N.$hn)(B,g.WorkspaceSymbol.from(K),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Q{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,_,se){this.d=B,this.e=_,this.f=se}async provideRenameEdits(B,_,se,K){const ae=this.d.getDocument(B),de=g.Position.to(_);try{const Re=await this.e.provideRenameEdits(ae,de,se,K);return Re?g.WorkspaceEdit.from(Re):void 0}catch(Re){const Be=Q.g(Re);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Re)}}async resolveRenameLocation(B,_,se){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const K=this.d.getDocument(B),ae=g.Position.to(_);try{const de=await this.e.prepareRename(K,ae,se);let Re,Be;if(I.$IK.isRange(de)?(Re=de,Be=K.getText(de)):(0,C.$Ef)(de)&&(Re=de.range,Be=de.placeholder),!Re||!Be)return;if(Re.start.line>ae.line||Re.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:g.Range.from(Re),text:Be}}catch(de){const Re=Q.g(de);return Re?{rejectReason:Re,range:void 0,text:void 0}:Promise.reject(de)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class x{constructor(B,_){this.resultId=B,this.tokens=_}}class oe{constructor(B,_){this.f=B,this.g=_,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,_,se){const K=this.f.getDocument(B),ae=_!==0?this.d.get(_):null;let de=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(K,ae.resultId,se):await this.g.provideDocumentSemanticTokens(K,se);return ae&&this.d.delete(_),de?(de=oe.h(de),this.o(oe.n(ae,de),de)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return oe.j(B)?oe.k(B)?B:new I.$YL(new Uint32Array(B.data),B.resultId):oe.l(B)?oe.m(B)?B:new I.$1L(B.edits.map(_=>new I.$ZL(_.start,_.deleteCount,_.data?new Uint32Array(_.data):_.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const _ of B.edits)if(!(_.data instanceof Uint32Array))return!1;return!0}static n(B,_){if(!oe.j(_)||!B||!B.tokens)return _;const se=B.tokens,K=se.length,ae=_.data,de=ae.length;let Re=0;const Be=Math.min(K,de);for(;Re<Be&&se[Re]===ae[Re];)Re++;if(Re===K&&Re===de)return new I.$1L([],_.resultId);let Xe=0;const Ye=Be-Re;for(;Xe<Ye&&se[K-Xe-1]===ae[de-Xe-1];)Xe++;return new I.$1L([{start:Re,deleteCount:K-Re-Xe,data:ae.subarray(Re,de-Xe)}],_.resultId)}o(B,_){if(oe.j(B)){const se=this.e++;return this.d.set(se,new x(B.resultId,B.data)),(0,d.$$0)({id:se,type:"full",data:B.data})}if(oe.l(B)){const se=this.e++;return oe.j(_)?this.d.set(se,new x(_.resultId,_.data)):this.d.set(se,new x(B.resultId)),(0,d.$$0)({id:se,type:"delta",deltas:(B.edits||[]).map(K=>({start:K.start,deleteCount:K.deleteCount,data:K.data}))})}return null}}class X{constructor(B,_){this.d=B,this.e=_}async provideDocumentRangeSemanticTokens(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideDocumentRangeSemanticTokens(K,g.Range.to(_),se);return ae?this.f(ae):null}f(B){return(0,d.$$0)({id:0,type:"full",data:B.data})}}class ve{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,_,se,K,ae){this.f=B,this.g=_,this.h=se,this.j=K,this.k=ae,this.d=new i.$vec("CompletionItem"),this.e=new Map}async provideCompletionItems(B,_,se,K){const ae=this.f.getDocument(B),de=g.Position.to(_),Re=ae.getWordRangeAtPosition(de)||new I.$IK(de,de),Be=Re.with({end:de}),Xe=new n.$Nd,Ye=await this.h.provideCompletionItems(ae,de,K,g.CompletionContext.to(se));if(!Ye||K.isCancellationRequested)return;const it=Array.isArray(Ye)?new I.$cL(Ye):Ye,st=ve.supportsResolving(this.h)?this.d.add(it.items):this.d.add([]),Pe=new f.$Qc;this.e.set(st,Pe);const Te=[],qe={x:st,b:Te,a:{replace:g.Range.from(Re),insert:g.Range.from(Be)},c:it.isIncomplete||void 0,d:Xe.elapsed()};for(let Le=0;Le<it.items.length;Le++){const xe=it.items[Le],he=this.l(xe,[st,Le],Be,Re);Te.push(he)}return qe}async resolveCompletionItem(B,_){if(typeof this.h.resolveCompletionItem!="function")return;const se=this.d.get(...B);if(!se)return;const K=this.l(se,B),ae=await this.h.resolveCompletionItem(se,_);if(!ae)return;const de=this.l(ae,B);return(K.h!==de.h||K.i!==de.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(K.n!==de.n||K.o!==de.o||!(0,N.$in)(K.p,de.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...K,d:de.d,c:de.c,l:de.l,h:de.h,i:de.i,n:de.n,o:de.o,p:de.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_,se,K){const ae=this.e.get(_[0]);if(!ae)throw Error("DisposableStore is missing...");const de=this.g.toInternal(B.command,ae),Re={x:_,a:B.label,b:B.kind!==void 0?g.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(g.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:g.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(g.TextEdit.from),n:de?.$ident,o:de?.id,p:de?.$ident?void 0:de?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Re.h=B.textEdit.newText):typeof B.insertText=="string"?Re.h=B.insertText:B.insertText instanceof I.$RK&&(Re.h=B.insertText.value,Re.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),I.$IK.isRange(Be)?Re.j=g.Range.from(Be):Be&&(!se?.isEqual(Be.inserting)||!K?.isEqual(Be.replacing))&&(Re.j={insert:g.Range.from(Be.inserting),replace:g.Range.from(Be.replacing)}),Re}}class ge{async provideInlineCompletions(B,_,se,K){}disposeCompletions(B){}handleDidShowCompletionItem(B,_,se){}handlePartialAccept(B,_,se){}}class V extends ge{constructor(B,_,se,K){super(),this.f=B,this.g=_,this.h=se,this.j=K,this.d=new U,this.e=(0,t.$QF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:I.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:I.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$QF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,_,se,K){const ae=this.g.getDocument(B),de=g.Position.to(_),Re=await this.h.provideInlineCompletionItems(ae,de,{selectedCompletionInfo:se.selectedSuggestionInfo?{range:g.Range.to(se.selectedSuggestionInfo.range),text:se.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[se.triggerKind]},K);if(!Re||K.isCancellationRequested)return;const Be=Array.isArray(Re)?Re:Re.items,Xe=this.e?Array.isArray(Re)?[]:Re.commands||[]:[],Ye=this.e&&!Array.isArray(Re)?Re.enableForwardStability:void 0;let it;return{pid:this.d.createReferenceId({dispose(){it?.dispose()},items:Be}),items:Be.map((Pe,Te)=>{let qe;Pe.command&&(it||(it=new f.$Qc),qe=this.j.toInternal(Pe.command,it));const Le=Pe.insertText;return{insertText:typeof Le=="string"?Le:{snippet:Le.value},filterText:Pe.filterText,range:Pe.range?g.Range.from(Pe.range):void 0,command:qe,idx:Te,completeBracketPairs:this.e?Pe.completeBracketPairs:!1}}),commands:Xe.map(Pe=>(it||(it=new f.$Qc),this.j.toInternal(Pe,it))),suppressSuggestions:!1,enableForwardStability:Ye}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,_,se){const K=this.d.get(B)?.items[_];K&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(K,se)}handlePartialAccept(B,_,se){const K=this.d.get(B)?.items[_];K&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(K,se)}}class U{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const _=this.e++;return this.d.set(_,B),_}disposeReferenceId(B){const _=this.d.get(B);return this.d.delete(B),_}get(B){return this.d.get(B)}}class ne{constructor(B,_){this.e=B,this.f=_,this.d=new i.$vec("SignatureHelp")}async provideSignatureHelp(B,_,se,K){const ae=this.e.getDocument(B),de=g.Position.to(_),Re=this.g(se),Be=await this.f.provideSignatureHelp(ae,de,K,Re);if(Be){const Xe=this.d.add([Be]);return{...g.SignatureHelp.from(Be),id:Xe}}}g(B){let _;if(B.activeSignatureHelp){const se=g.SignatureHelp.to(B.activeSignatureHelp),K=this.d.get(B.activeSignatureHelp.id,0);K?(_=K,_.activeSignature=se.activeSignature,_.activeParameter=se.activeParameter):_=se}return{...B,activeSignatureHelp:_}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,_,se,K,ae){this.f=B,this.g=_,this.h=se,this.j=K,this.k=ae,this.d=new i.$vec("InlayHints"),this.e=new Map}async provideInlayHints(B,_,se){const K=this.f.getDocument(B),ae=g.Range.to(_),de=await this.h.provideInlayHints(K,ae,se);if(!Array.isArray(de)||de.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`);return}if(se.isCancellationRequested)return;const Re=this.d.add(de);this.e.set(Re,new f.$Qc);const Be={hints:[],cacheId:Re};for(let Xe=0;Xe<de.length;Xe++)this.l(de[Xe],ae)&&Be.hints.push(this.m(de[Xe],[Re,Xe]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(_)}`),Be}async resolveInlayHint(B,_){if(typeof this.h.resolveInlayHint!="function")return;const se=this.d.get(...B);if(!se)return;const K=await this.h.resolveInlayHint(se,_);if(K&&this.l(K))return this.m(K,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,_){return B.label.length===0||Array.isArray(B.label)&&B.label.every(se=>se.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(_&&!_.contains(B.position))}m(B,_){const se=this.e.get(_[0]);if(!se)throw Error("DisposableStore is missing...");const K={label:"",cacheId:_,tooltip:g.MarkdownString.fromStrict(B.tooltip),position:g.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(g.TextEdit.from),kind:B.kind&&g.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};return typeof B.label=="string"?K.label=B.label:K.label=B.label.map(ae=>{const de={label:ae.value};return de.tooltip=g.MarkdownString.fromStrict(ae.tooltip),I.$SK.isLocation(ae.location)&&(de.location=g.location.from(ae.location)),ae.command&&(de.command=this.g.toInternal(ae.command,se)),de}),K}}class fe{constructor(B,_){this.e=B,this.f=_,this.d=new i.$vec("DocumentLink")}async provideLinks(B,_){const se=this.e.getDocument(B),K=await this.f.provideDocumentLinks(se,_);if(!(!Array.isArray(K)||K.length===0)&&!_.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:K.filter(fe.g).map(g.DocumentLink.from)};{const ae=this.d.add(K),de={links:[],cacheId:ae};for(let Re=0;Re<K.length;Re++){if(!fe.g(K[Re]))continue;const Be=g.DocumentLink.from(K[Re]);Be.cacheId=[ae,Re],de.links.push(Be)}return de}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,_){if(typeof this.f.resolveDocumentLink!="function")return;const se=this.d.get(...B);if(!se)return;const K=await this.f.resolveDocumentLink(se,_);if(!(!K||!fe.g(K)))return g.DocumentLink.from(K)}releaseLinks(B){this.d.delete(B)}}class me{constructor(B,_){this.d=B,this.e=_}async provideColors(B,_){const se=this.d.getDocument(B),K=await this.e.provideDocumentColors(se,_);return Array.isArray(K)?K.map(de=>({color:g.Color.from(de.color),range:g.Range.from(de.range)})):[]}async provideColorPresentations(B,_,se){const K=this.d.getDocument(B),ae=g.Range.to(_.range),de=g.Color.to(_.color),Re=await this.e.provideColorPresentations(de,{document:K,range:ae},se);if(Array.isArray(Re))return Re.map(g.ColorPresentation.from)}}class ee{constructor(B,_){this.d=B,this.e=_}async provideFoldingRanges(B,_,se){const K=this.d.getDocument(B),ae=await this.e.provideFoldingRanges(K,_,se);if(Array.isArray(ae))return ae.map(g.FoldingRange.from)}}class ie{constructor(B,_,se){this.d=B,this.e=_,this.f=se}async provideSelectionRanges(B,_,se){const K=this.d.getDocument(B),ae=_.map(g.Position.to),de=await this.e.provideSelectionRanges(K,ae,se);if(!(0,A.$Kb)(de))return[];if(de.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Re=[];for(let Be=0;Be<ae.length;Be++){const Xe=[];Re.push(Xe);let Ye=ae[Be],it=de[Be];for(;;){if(!it.range.contains(Ye))throw new Error("INVALID selection range, must contain the previous range");if(Xe.push(g.SelectionRange.from(it)),!it.parent)break;Ye=it.range,it=it.parent}}return Re}}class G{constructor(B,_){this.f=B,this.g=_,this.d=new s.$MM(""),this.e=new Map}async prepareSession(B,_,se){const K=this.f.getDocument(B),ae=g.Position.to(_),de=await this.g.prepareCallHierarchy(K,ae,se);if(!de)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(de)?de.map(Be=>this.h(Re,Be)):[this.h(Re,de)]}async provideCallsTo(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(K,se);if(ae)return ae.map(de=>({from:this.h(B,de.from),fromRanges:de.fromRanges.map(Re=>g.Range.from(Re))}))}async provideCallsFrom(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(K,se);if(ae)return ae.map(de=>({to:this.h(B,de.to),fromRanges:de.fromRanges.map(Re=>g.Range.from(Re))}))}releaseSession(B){this.e.delete(B)}h(B,_){const se=this.e.get(B),K=g.CallHierarchyItem.from(_,B,se.size.toString(36));return se.set(K._itemId,_),K}j(B,_){return this.e.get(B)?.get(_)}}class te{constructor(B,_){this.f=B,this.g=_,this.d=new s.$MM(""),this.e=new Map}async prepareSession(B,_,se){const K=this.f.getDocument(B),ae=g.Position.to(_),de=await this.g.prepareTypeHierarchy(K,ae,se);if(!de)return;const Re=this.d.nextId();return this.e.set(Re,new Map),Array.isArray(de)?de.map(Be=>this.h(Re,Be)):[this.h(Re,de)]}async provideSupertypes(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(K,se);if(ae)return ae.map(de=>this.h(B,de))}async provideSubtypes(B,_,se){const K=this.j(B,_);if(!K)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(K,se);if(ae)return ae.map(de=>this.h(B,de))}releaseSession(B){this.e.delete(B)}h(B,_){const se=this.e.get(B),K=g.TypeHierarchyItem.from(_,B,se.size.toString(36));return se.set(K._itemId,_),K}j(B,_){return this.e.get(B)?.get(_)}}class J{static toInternalProviderId(B,_){return B+"."+_}constructor(B,_,se,K,ae){this.d=B,this.e=_,this.f=se,this.g=K,this.h=ae}async provideDocumentOnDropEdits(B,_,se,K,ae){const de=this.e.getDocument(_),Re=g.Position.to(se),Be=g.DataTransfer.toDataTransfer(K,async Ye=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Ye)).buffer),Xe=await this.f.provideDocumentDropEdits(de,Re,Be,ae);if(Xe)return{label:Xe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Xe.yieldTo?.map(Ye=>"mimeType"in Ye?Ye:{providerId:J.toInternalProviderId(Ye.extensionId,Ye.providerId)}),insertText:typeof Xe.insertText=="string"?Xe.insertText:{snippet:Xe.insertText.value},additionalEdit:Xe.additionalEdit?g.WorkspaceEdit.from(Xe.additionalEdit,void 0):void 0}}}class ce{constructor(B,_){this.d=B,this.e=_}async provideMappedEdits(B,_,se,K){const ae=D.URI.revive(B),de=this.d.getDocument(ae),Re=se.documents.map(Ye=>Ye.map(it=>({uri:D.URI.revive(it.uri),version:it.version,ranges:it.ranges.map(st=>g.Range.to(st))}))),Be={documents:Re,selections:Re[0]?.[0]?.ranges??[]},Xe=await this.e.provideMappedEdits(de,_,Be,K);return Xe?g.WorkspaceEdit.from(Xe):null}}class be{constructor(B,_){this.adapter=B,this.extension=_}}class Ie{static{this.d=0}constructor(B,_,se,K,ae,de,Re,Be){this.g=_,this.h=se,this.j=K,this.k=ae,this.l=de,this.m=Re,this.n=Be,this.f=new Map,this.e=B.getProxy(b.$EK.MainThreadLanguageFeatures)}o(B,_){return g.DocumentSelector.from(B,this.g,_)}p(B){return new I.$GK(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Ie.d++}async s(B,_,se,K,ae,de=!1){const Re=this.f.get(B);if(!Re||!(Re.adapter instanceof _))return K;const Be=Date.now();de||this.l.trace(`[${Re.extension.identifier.value}] INVOKE provider '${se.toString().replace(/[\r\n]/g,"")}'`);const Xe=se(Re.adapter,Re.extension);return Promise.resolve(Xe).catch(Ye=>{(0,o.$3)(Ye)||(this.l.error(`[${Re.extension.identifier.value}] provider FAILED`),this.l.error(Ye),this.n.onExtensionError(Re.extension.identifier,Ye))}).finally(()=>{de||this.l.trace(`[${Re.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),v.CancellationToken.isCancellationToken(ae)?(0,a.$Pg)(Xe,ae):Xe}t(B,_){const se=this.q();return this.f.set(se,new be(B,_)),se}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,_,se,K){const ae=this.t(new h(this.h,se),B),de=K&&K.label||Ie.u(B);return this.e.$registerDocumentSymbolProvider(ae,this.o(_,B),de),this.p(ae)}$provideDocumentSymbols(B,_,se){return this.s(B,h,K=>K.provideDocumentSymbols(D.URI.revive(_),se),void 0,se)}registerCodeLensProvider(B,_,se){const K=this.q(),ae=typeof se.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(K,new be(new u(this.h,this.j.converter,se),B)),this.e.$registerCodeLensSupport(K,this.o(_,B),ae);let de=this.p(K);if(ae!==void 0){const Re=se.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ae));de=I.$GK.from(de,Re)}return de}$provideCodeLenses(B,_,se){return this.s(B,u,K=>K.provideCodeLenses(D.URI.revive(_),se),void 0,se)}$resolveCodeLens(B,_,se){return this.s(B,u,K=>K.resolveCodeLens(_,se),void 0,void 0)}$releaseCodeLenses(B,_){this.s(B,u,se=>Promise.resolve(se.releaseCodeLenses(_)),void 0,void 0)}registerDefinitionProvider(B,_,se){const K=this.t(new l(this.h,se),B);return this.e.$registerDefinitionSupport(K,this.o(_,B)),this.p(K)}$provideDefinition(B,_,se,K){return this.s(B,l,ae=>ae.provideDefinition(D.URI.revive(_),se,K),[],K)}registerDeclarationProvider(B,_,se){const K=this.t(new k(this.h,se),B);return this.e.$registerDeclarationSupport(K,this.o(_,B)),this.p(K)}$provideDeclaration(B,_,se,K){return this.s(B,k,ae=>ae.provideDeclaration(D.URI.revive(_),se,K),[],K)}registerImplementationProvider(B,_,se){const K=this.t(new R(this.h,se),B);return this.e.$registerImplementationSupport(K,this.o(_,B)),this.p(K)}$provideImplementation(B,_,se,K){return this.s(B,R,ae=>ae.provideImplementation(D.URI.revive(_),se,K),[],K)}registerTypeDefinitionProvider(B,_,se){const K=this.t(new w(this.h,se),B);return this.e.$registerTypeDefinitionSupport(K,this.o(_,B)),this.p(K)}$provideTypeDefinition(B,_,se,K){return this.s(B,w,ae=>ae.provideTypeDefinition(D.URI.revive(_),se,K),[],K)}registerHoverProvider(B,_,se,K){const ae=this.t(new p(this.h,se),B);return this.e.$registerHoverProvider(ae,this.o(_,B)),this.p(ae)}$provideHover(B,_,se,K){return this.s(B,p,ae=>ae.provideHover(D.URI.revive(_),se,K),void 0,K)}registerEvaluatableExpressionProvider(B,_,se,K){const ae=this.t(new E(this.h,se),B);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(_,B)),this.p(ae)}$provideEvaluatableExpression(B,_,se,K){return this.s(B,E,ae=>ae.provideEvaluatableExpression(D.URI.revive(_),se,K),void 0,K)}registerInlineValuesProvider(B,_,se,K){const ae=typeof se.onDidChangeInlineValues=="function"?this.q():void 0,de=this.t(new P(this.h,se),B);this.e.$registerInlineValuesProvider(de,this.o(_,B),ae);let Re=this.p(de);if(ae!==void 0){const Be=se.onDidChangeInlineValues(Xe=>this.e.$emitInlineValuesEvent(ae));Re=I.$GK.from(Re,Be)}return Re}$provideInlineValues(B,_,se,K,ae){return this.s(B,P,de=>de.provideInlineValues(D.URI.revive(_),se,K,ae),void 0,ae)}registerDocumentHighlightProvider(B,_,se){const K=this.t(new z(this.h,se),B);return this.e.$registerDocumentHighlightProvider(K,this.o(_,B)),this.p(K)}registerMultiDocumentHighlightProvider(B,_,se){const K=this.t(new j(this.h,se),B);return this.e.$registerMultiDocumentHighlightProvider(K,this.o(_,B)),this.p(K)}$provideDocumentHighlights(B,_,se,K){return this.s(B,z,ae=>ae.provideDocumentHighlights(D.URI.revive(_),se,K),void 0,K)}$provideMultiDocumentHighlights(B,_,se,K,ae){return this.s(B,j,de=>de.provideMultiDocumentHighlights(D.URI.revive(_),se,K.map(Re=>D.URI.revive(Re)),ae),void 0,ae)}registerLinkedEditingRangeProvider(B,_,se){const K=this.t(new F(this.h,se),B);return this.e.$registerLinkedEditingRangeProvider(K,this.o(_,B)),this.p(K)}$provideLinkedEditingRanges(B,_,se,K){return this.s(B,F,async ae=>{const de=await ae.provideLinkedEditingRanges(D.URI.revive(_),se,K);if(de)return{ranges:de.ranges,wordPattern:de.wordPattern?Ie.w(de.wordPattern):void 0}},void 0,K)}registerReferenceProvider(B,_,se){const K=this.t(new O(this.h,se),B);return this.e.$registerReferenceSupport(K,this.o(_,B)),this.p(K)}$provideReferences(B,_,se,K,ae){return this.s(B,O,de=>de.provideReferences(D.URI.revive(_),se,K,ae),void 0,ae)}registerCodeActionProvider(B,_,se,K){const ae=new f.$Qc,de=this.t(new T(this.h,this.j.converter,this.k,se,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(de,this.o(_,B),{providedKinds:K?.providedCodeActionKinds?.map(Re=>Re.value),documentation:K?.documentation?.map(Re=>({kind:Re.kind.value,command:this.j.converter.toInternal(Re.command,ae)}))},Ie.u(B),!!se.resolveCodeAction),ae.add(this.p(de)),ae}$provideCodeActions(B,_,se,K,ae){return this.s(B,T,de=>de.provideCodeActions(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveCodeAction(B,_,se){return this.s(B,T,K=>K.resolveCodeAction(_,se),{},void 0)}$releaseCodeActions(B,_){this.s(B,T,se=>Promise.resolve(se.releaseCodeActions(_)),void 0,void 0)}registerDocumentFormattingEditProvider(B,_,se){const K=this.t(new W(this.h,se),B);return this.e.$registerDocumentFormattingSupport(K,this.o(_,B),B.identifier,B.displayName||B.name),this.p(K)}$provideDocumentFormattingEdits(B,_,se,K){return this.s(B,W,ae=>ae.provideDocumentFormattingEdits(D.URI.revive(_),se,K),void 0,K)}registerDocumentRangeFormattingEditProvider(B,_,se){const K=typeof se.provideDocumentRangesFormattingEdits=="function",ae=this.t(new Y(this.h,se),B);return this.e.$registerRangeFormattingSupport(ae,this.o(_,B),B.identifier,B.displayName||B.name,K),this.p(ae)}$provideDocumentRangeFormattingEdits(B,_,se,K,ae){return this.s(B,Y,de=>de.provideDocumentRangeFormattingEdits(D.URI.revive(_),se,K,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(B,_,se,K,ae){return this.s(B,Y,de=>de.provideDocumentRangesFormattingEdits(D.URI.revive(_),se,K,ae),void 0,ae)}registerOnTypeFormattingEditProvider(B,_,se,K){const ae=this.t(new ue(this.h,se),B);return this.e.$registerOnTypeFormattingSupport(ae,this.o(_,B),K,B.identifier),this.p(ae)}$provideOnTypeFormattingEdits(B,_,se,K,ae,de){return this.s(B,ue,Re=>Re.provideOnTypeFormattingEdits(D.URI.revive(_),se,K,ae,de),void 0,de)}registerWorkspaceSymbolProvider(B,_){const se=this.t(new Z(_,this.l),B);return this.e.$registerNavigateTypeSupport(se,typeof _.resolveWorkspaceSymbol=="function"),this.p(se)}$provideWorkspaceSymbols(B,_,se){return this.s(B,Z,K=>K.provideWorkspaceSymbols(_,se),{symbols:[]},se)}$resolveWorkspaceSymbol(B,_,se){return this.s(B,Z,K=>K.resolveWorkspaceSymbol(_,se),void 0,void 0)}$releaseWorkspaceSymbols(B,_){this.s(B,Z,se=>se.releaseWorkspaceSymbols(_),void 0,void 0)}registerRenameProvider(B,_,se){const K=this.t(new Q(this.h,se,this.l),B);return this.e.$registerRenameSupport(K,this.o(_,B),Q.supportsResolving(se)),this.p(K)}$provideRenameEdits(B,_,se,K,ae){return this.s(B,Q,de=>de.provideRenameEdits(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveRenameLocation(B,_,se,K){return this.s(B,Q,ae=>ae.resolveRenameLocation(D.URI.revive(_),se,K),void 0,K)}registerDocumentSemanticTokensProvider(B,_,se,K){const ae=this.t(new oe(this.h,se),B),de=typeof se.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(_,B),K,de);let Re=this.p(ae);if(de){const Be=se.onDidChangeSemanticTokens(Xe=>this.e.$emitDocumentSemanticTokensEvent(de));Re=I.$GK.from(Re,Be)}return Re}$provideDocumentSemanticTokens(B,_,se,K){return this.s(B,oe,ae=>ae.provideDocumentSemanticTokens(D.URI.revive(_),se,K),null,K)}$releaseDocumentSemanticTokens(B,_){this.s(B,oe,se=>se.releaseDocumentSemanticColoring(_),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,_,se,K){const ae=this.t(new X(this.h,se),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(_,B),K),this.p(ae)}$provideDocumentRangeSemanticTokens(B,_,se,K){return this.s(B,X,ae=>ae.provideDocumentRangeSemanticTokens(D.URI.revive(_),se,K),null,K)}registerCompletionItemProvider(B,_,se,K){const ae=this.t(new ve(this.h,this.j.converter,se,this.m,B),B);return this.e.$registerCompletionsProvider(ae,this.o(_,B),K,ve.supportsResolving(se),B.identifier),this.p(ae)}$provideCompletionItems(B,_,se,K,ae){return this.s(B,ve,de=>de.provideCompletionItems(D.URI.revive(_),se,K,ae),void 0,ae)}$resolveCompletionItem(B,_,se){return this.s(B,ve,K=>K.resolveCompletionItem(_,se),void 0,se)}$releaseCompletionItems(B,_){this.s(B,ve,se=>se.releaseCompletionItems(_),void 0,void 0)}registerInlineCompletionsProvider(B,_,se,K){const ae=new V(B,this.h,se,this.j.converter),de=this.t(ae,B);return this.e.$registerInlineCompletionsSupport(de,this.o(_,B),ae.supportsHandleEvents,S.$dm.toKey(B.identifier.value),K?.yieldTo?.map(Re=>S.$dm.toKey(Re))||[]),this.p(de)}$provideInlineCompletions(B,_,se,K,ae){return this.s(B,ge,de=>de.provideInlineCompletions(D.URI.revive(_),se,K,ae),void 0,ae)}$handleInlineCompletionDidShow(B,_,se,K){this.s(B,ge,async ae=>{ae.handleDidShowCompletionItem(_,se,K)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,_,se,K){this.s(B,ge,async ae=>{ae.handlePartialAccept(_,se,K)},void 0,void 0)}$freeInlineCompletionsList(B,_){this.s(B,ge,async se=>{se.disposeCompletions(_)},void 0,void 0)}registerSignatureHelpProvider(B,_,se,K){const ae=Array.isArray(K)?{triggerCharacters:K,retriggerCharacters:[]}:K,de=this.t(new ne(this.h,se),B);return this.e.$registerSignatureHelpProvider(de,this.o(_,B),ae),this.p(de)}$provideSignatureHelp(B,_,se,K,ae){return this.s(B,ne,de=>de.provideSignatureHelp(D.URI.revive(_),se,K,ae),void 0,ae)}$releaseSignatureHelp(B,_){this.s(B,ne,se=>se.releaseSignatureHelp(_),void 0,void 0)}registerInlayHintsProvider(B,_,se){const K=typeof se.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,se,this.l,B),B);this.e.$registerInlayHintsProvider(ae,this.o(_,B),typeof se.resolveInlayHint=="function",K,Ie.u(B));let de=this.p(ae);if(K!==void 0){const Re=se.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(K));de=I.$GK.from(de,Re)}return de}$provideInlayHints(B,_,se,K){return this.s(B,ye,ae=>ae.provideInlayHints(D.URI.revive(_),se,K),void 0,K)}$resolveInlayHint(B,_,se){return this.s(B,ye,K=>K.resolveInlayHint(_,se),void 0,se)}$releaseInlayHints(B,_){this.s(B,ye,se=>se.releaseHints(_),void 0,void 0)}registerDocumentLinkProvider(B,_,se){const K=this.t(new fe(this.h,se),B);return this.e.$registerDocumentLinkProvider(K,this.o(_,B),typeof se.resolveDocumentLink=="function"),this.p(K)}$provideDocumentLinks(B,_,se){return this.s(B,fe,K=>K.provideLinks(D.URI.revive(_),se),void 0,se,_.scheme==="output")}$resolveDocumentLink(B,_,se){return this.s(B,fe,K=>K.resolveLink(_,se),void 0,void 0,!0)}$releaseDocumentLinks(B,_){this.s(B,fe,se=>se.releaseLinks(_),void 0,void 0,!0)}registerColorProvider(B,_,se){const K=this.t(new me(this.h,se),B);return this.e.$registerDocumentColorProvider(K,this.o(_,B)),this.p(K)}$provideDocumentColors(B,_,se){return this.s(B,me,K=>K.provideColors(D.URI.revive(_),se),[],se)}$provideColorPresentations(B,_,se,K){return this.s(B,me,ae=>ae.provideColorPresentations(D.URI.revive(_),se,K),void 0,K)}registerFoldingRangeProvider(B,_,se){const K=this.q(),ae=typeof se.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(K,new be(new ee(this.h,se),B)),this.e.$registerFoldingRangeProvider(K,this.o(_,B),B.identifier,ae);let de=this.p(K);if(ae!==void 0){const Re=se.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));de=I.$GK.from(de,Re)}return de}$provideFoldingRanges(B,_,se,K){return this.s(B,ee,ae=>ae.provideFoldingRanges(D.URI.revive(_),se,K),void 0,K)}registerSelectionRangeProvider(B,_,se){const K=this.t(new ie(this.h,se,this.l),B);return this.e.$registerSelectionRangeProvider(K,this.o(_,B)),this.p(K)}$provideSelectionRanges(B,_,se,K){return this.s(B,ie,ae=>ae.provideSelectionRanges(D.URI.revive(_),se,K),[],K)}registerCallHierarchyProvider(B,_,se){const K=this.t(new G(this.h,se),B);return this.e.$registerCallHierarchyProvider(K,this.o(_,B)),this.p(K)}$prepareCallHierarchy(B,_,se,K){return this.s(B,G,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(_),se,K)),void 0,K)}$provideCallHierarchyIncomingCalls(B,_,se,K){return this.s(B,G,ae=>ae.provideCallsTo(_,se,K),void 0,K)}$provideCallHierarchyOutgoingCalls(B,_,se,K){return this.s(B,G,ae=>ae.provideCallsFrom(_,se,K),void 0,K)}$releaseCallHierarchy(B,_){this.s(B,G,se=>Promise.resolve(se.releaseSession(_)),void 0,void 0)}registerTypeHierarchyProvider(B,_,se){const K=this.t(new te(this.h,se),B);return this.e.$registerTypeHierarchyProvider(K,this.o(_,B)),this.p(K)}$prepareTypeHierarchy(B,_,se,K){return this.s(B,te,ae=>Promise.resolve(ae.prepareSession(D.URI.revive(_),se,K)),void 0,K)}$provideTypeHierarchySupertypes(B,_,se,K){return this.s(B,te,ae=>ae.provideSupertypes(_,se,K),void 0,K)}$provideTypeHierarchySubtypes(B,_,se,K){return this.s(B,te,ae=>ae.provideSubtypes(_,se,K),void 0,K)}$releaseTypeHierarchy(B,_){this.s(B,te,se=>Promise.resolve(se.releaseSession(_)),void 0,void 0)}registerDocumentOnDropEditProvider(B,_,se,K){const ae=this.q();this.f.set(ae,new be(new J(this.e,this.h,se,ae,B),B));const de=(0,t.$QF)(B,"dropMetadata")&&K?J.toInternalProviderId(B.identifier.value,K.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(_,B),de,(0,t.$QF)(B,"dropMetadata")?K:void 0),this.p(ae)}$provideDocumentOnDropEdits(B,_,se,K,ae,de){return this.s(B,J,Re=>Promise.resolve(Re.provideDocumentOnDropEdits(_,D.URI.revive(se),K,ae,de)),void 0,void 0)}registerMappedEditsProvider(B,_,se){const K=this.t(new ce(this.h,se),B);return this.e.$registerMappedEditsProvider(K,this.o(_,B)),this.p(K)}$provideMappedEdits(B,_,se,K,ae){return this.s(B,ce,de=>Promise.resolve(de.provideMappedEdits(_,se,K,ae)),null,ae)}registerDocumentPasteEditProvider(B,_,se,K){const ae=this.q();this.f.set(ae,new be(new M(this.e,this.h,se,ae,B),B));const de=M.toInternalProviderId(B.identifier.value,K.id);return this.e.$registerPasteEditProvider(ae,this.o(_,B),de,{supportsCopy:!!se.prepareDocumentPaste,supportsPaste:!!se.provideDocumentPasteEdits,copyMimeTypes:K.copyMimeTypes,pasteMimeTypes:K.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(B,_,se,K,ae){return this.s(B,M,de=>de.prepareDocumentPaste(D.URI.revive(_),se,K,ae),void 0,ae)}$providePasteEdits(B,_,se,K,ae,de){return this.s(B,M,Re=>Re.providePasteEdits(_,D.URI.revive(se),K,ae,de),void 0,de)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Ie.w(B.decreaseIndentPattern),increaseIndentPattern:Ie.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Ie.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Ie.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Ie.w(B.beforeText),afterText:B.afterText?Ie.w(B.afterText):void 0,previousLineText:B.previousLineText?Ie.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Ie.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(_=>I.SyntaxTokenType.toString(_)):void 0}}static D(B){return B.map(Ie.C)}setLanguageConfiguration(B,_,se){const{wordPattern:K}=se;if(K&&(0,$.$Se)(K))throw new Error(`Invalid language configuration: wordPattern '${K}' is not allowed to match the empty string.`);K?this.h.setWordDefinitionFor(_,K):this.h.setWordDefinitionFor(_,void 0),se.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),se.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ae=this.q(),de={comments:se.comments,brackets:se.brackets,wordPattern:se.wordPattern?Ie.w(se.wordPattern):void 0,indentationRules:se.indentationRules?Ie.y(se.indentationRules):void 0,onEnterRules:se.onEnterRules?Ie.B(se.onEnterRules):void 0,__electricCharacterSupport:se.__electricCharacterSupport,__characterPairSupport:se.__characterPairSupport,autoClosingPairs:se.autoClosingPairs?Ie.D(se.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,_,de),this.p(ae)}$setWordDefinitions(B){for(const _ of B)this.h.setWordDefinitionFor(_.languageId,new RegExp(_.regexSource,_.regexFlags))}}e.$Fec=Ie}),define(Ee[327],Se([1,0,6,15,7,39,12,3,25]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class y{constructor(C,m,v,S){this.c=m,this.d=v,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=C.getProxy(D.$EK.MainThreadLanguages)}$acceptLanguageIds(C){this.b=C}async getLanguages(){return this.b.slice(0)}async changeLanguage(C,m){await this.a.$changeLanguage(C,m);const v=this.c.getDocumentData(C);if(!v)throw new Error(`document '${C.toString()}' NOT found`);return v.document}async tokenAtPosition(C,m){const v=C.version,S=N.Position.from(m),f=await this.a.$tokensAtPosition(C.uri,S),d={type:g.StandardTokenType.Other,range:C.getWordRangeAtPosition(m)??new g.$IK(m.line,m.character,m.line,m.character)};if(!f)return d;const s={range:N.Range.to(f.range),type:N.TokenType.to(f.type)};return!s.range.contains(m)||v!==C.version?d:s}createLanguageStatusItem(C,m,v){const S=this.f++,f=this.a,d=this.g,s=`${C.identifier.value}/${m}`;if(d.has(s))throw new Error(`LanguageStatusItem with id '${m}' ALREADY exists`);d.add(s);const i={selector:v,id:m,name:C.displayName??C.name,severity:g.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const o=new b.$Qc,a=()=>{if(n?.dispose(),!d.has(s)){console.warn(`LanguageStatusItem (${m}) from ${C.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,L.$2g)(()=>{o.clear(),this.a.$setLanguageStatus(S,{id:s,name:i.name??C.displayName??C.name,source:C.displayName??C.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===g.LanguageStatusSeverity.Error?I.default.Error:i.severity===g.LanguageStatusSeverity.Warning?I.default.Warning:I.default.Info,command:i.command&&this.d.toInternal(i.command,o),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){o.dispose(),n?.dispose(),f.$removeLanguageStatus(S),d.delete(s)},get id(){return i.id},get name(){return i.name},set name(r){i.name=r,a()},get selector(){return i.selector},set selector(r){i.selector=r,a()},get text(){return i.text},set text(r){i.text=r,a()},set text2(r){(0,$.$RF)(C,"languageStatusText"),i.text=r,a()},get text2(){return(0,$.$RF)(C,"languageStatusText"),i.text},get detail(){return i.detail},set detail(r){i.detail=r,a()},get severity(){return i.severity},set severity(r){i.severity=r,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(r){i.accessibilityInformation=r,a()},get command(){return i.command},set command(r){i.command=r,a()},get busy(){return i.busy},set busy(r){i.busy=r,a()}};return a(),t}}e.$5fc=y}),define(Ee[115],Se([1,0,11,13,2,5,14,6,27,20]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0;let A=class{constructor(m,v,S){this.f=S,this.d=new Map,this.a=v.getProxy(b.$EK.MainThreadLocalization),this.b=m.environment.appLanguage,this.c=this.b===D.$g}getMessage(m,v){const{message:S,args:f,comment:d}=v;if(this.c)return(0,N.$He)(S,f??{});let s=S;d&&d.length>0&&(s+=`/${Array.isArray(d)?d.join(""):d}`);const i=this.d.get(m)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$He)(i??S,f??{})}getBundle(m){return this.d.get(m)?.contents}getBundleUri(m){return this.d.get(m)?.uri}async initializeLocalizedMessages(m){if(this.c||!m.l10n&&!m.isBuiltin||this.d.has(m.identifier.value))return;let v;const S=await this.g(m);if(!S){this.f.error(`No bundle location found for extension ${m.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(S),d=JSON.parse(f);v=m.isBuiltin?d.contents?.bundle:d}catch(f){this.f.error(`Failed to load translations for ${m.identifier.value} from ${S}: ${f.message}`);return}v&&this.d.set(m.identifier.value,{contents:v,uri:S})}async g(m){if(m.isBuiltin){const v=await this.a.$fetchBuiltInBundleUri(m.identifier.value,this.b);return g.URI.revive(v)}return m.l10n?g.URI.joinPath(m.extensionLocation,m.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$qfc=A,e.$qfc=A=Ke([We(0,$.$XM),We(1,y.$HM),We(2,L.$hj)],A),e.$rfc=(0,I.$Zh)("IExtHostLocalizationService")}),define(Ee[150],Se([1,0,14,6,27,20,2,54]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;let $=class extends D.$sj{constructor(C,m){super(m.logLevel,m.logsLocation,m.loggers.map(v=>(0,b.$wh)(v))),this.r=C.getProxy(N.$EK.MainThreadLogger)}$setLogLevel(C,m){m?this.setLogLevel(L.URI.revive(m),C):this.setLogLevel(C)}setVisibility(C,m){super.setVisibility(C,m),this.r.$setVisibility(C,m)}s(C,m,v){return new y(this.r,C,m,v)}};e.$Dgc=$,e.$Dgc=$=Ke([We(0,I.$HM),We(1,g.$XM)],$);class y extends D.$nj{constructor(C,m,v,S){super(S?.logLevel==="always"),this.r=C,this.s=m,this.m=!1,this.n=[],this.setLevel(v),this.r.$createLogger(m,S).then(()=>{this.u(this.n),this.m=!0})}g(C,m){const v=[[C,m]];this.m?this.u(v):this.n.push(...v)}u(C){this.r.$log(this.s,C)}flush(){this.r.$flush(this.s)}}}),define(Ee[116],Se([1,0,6,5,3,20,22]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0,e.$sfc=(0,N.$Zh)("IExtHostManagedSockets");let b=class{constructor(C){this.b=0,this.c=null,this.d=new Map,this.a=C.getProxy(D.$EK.MainThreadManagedSockets)}setFactory(C,m){for(const v of this.d.values())v.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(C,m),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(C){if(!this.c||this.c.socketFactoryId!==C)throw new Error(`No socket factory with id ${C}`);const m=++this.b,v=await this.c.makeConnection(),S=new g.$Qc;return this.d.set(m,new y(m,v,S)),S.add((0,g.$Pc)(()=>this.d.delete(m))),S.add(v.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(m),S.dispose()})),S.add(v.onDidClose(f=>{this.a.$onDidManagedSocketClose(m,f?.stack??f?.message),S.dispose()})),S.add(v.onDidReceiveMessage(f=>this.a.$onDidManagedSocketHaveData(m,L.$fe.wrap(f)))),m}$remoteSocketWrite(C,m){this.d.get(C)?.actual.send(m.buffer)}$remoteSocketEnd(C){const m=this.d.get(C);m&&(m.actual.end(),m.dispose())}async $remoteSocketDrain(C){await this.d.get(C)?.actual.drain?.()}};e.$tfc=b,e.$tfc=b=Ke([We(0,I.$HM)],b);class ${constructor(C,m){this.socketFactoryId=C,this.makeConnection=m}}class y extends g.$Rc{constructor(C,m,v){super(),this.socketId=C,this.actual=m,this.B(v)}}}),define(Ee[328],Se([1,0,6,14,25]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;function I(b){return b&&b.title}let L=class{constructor($,y){this.b=y,this.a=$.getProxy(D.$EK.MainThreadMessageService)}showMessage($,y,A,C,m){const v={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof C=="string"||I(C)?S=[C,...m]:(v.modal=C?.modal,v.useCustom=C?.useCustom,v.detail=C?.detail,S=m),v.useCustom&&(0,g.$RF)($,"resolvers");const f=[];for(let d=0;d<S.length;d++){const s=S[d];if(typeof s=="string")f.push({title:s,handle:d,isCloseAffordance:!1});else if(typeof s=="object"){const{title:i,isCloseAffordance:n}=s;f.push({title:i,isCloseAffordance:!!n,handle:d})}else this.b.warn("Invalid message item:",s)}return this.a.$showMessage(y,A,v,f).then(d=>{if(typeof d=="number")return S[d]})}};e.$6fc=L,e.$6fc=L=Ke([We(1,N.$hj)],L)}),define(Ee[329],Se([1,0,19,12,21,4,3,28,2,26,14,6,35,15,7,113,285,25,68]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;let n=class{constructor(l,k,R,w,p){this.m=k,this.n=R,this.o=w,this.q=p,this.b=new b.$zc,this.c=new b.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new I.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=l.getProxy(C.$EK.MainThreadNotebookKernels);const E=new m.$8M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.$6M("options","Select kernel options",P=>!0,P=>{if(P&&"notebookEditor"in P&&"id"in P){const z=this.n.getIdByEditor(P.notebookEditor);return{id:P.id,extension:P.extension,notebookEditorId:z}}else if(P&&"notebookEditor"in P){const z=this.n.getIdByEditor(P.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${P.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return P})],m.$7M.Void);this.o.registerApiCommand(E)}createNotebookController(l,k,R,w,p,E){for(const X of this.j.values())if(X.controller.id===k&&y.$dm.equals(l.identifier,X.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const P=this.k++,z=this;this.q.trace(`NotebookController[${P}], CREATED by ${l.identifier.value}, ${k}`);const j=()=>console.warn(`NO execute handler from notebook controller '${M.id}' of extension: '${l.identifier}'`);let F=!1;const O=new I.$Rd,T=new I.$Rd,M={id:u(l.identifier,k),notebookType:R,extensionId:l.identifier,extensionLocation:l.extensionLocation,label:w||l.identifier.value,preloads:E?E.map(v.NotebookRendererScript.from):[]};let W=p??j,Y,ue;this.a.$addKernel(P,M).catch(X=>{console.log(X),F=!0});let Z=0;const Q=()=>{if(F)return;const X=++Z;Promise.resolve().then(()=>{X===Z&&this.a.$updateKernel(P,M)})},x=new b.$zc,oe={get id(){return k},get notebookType(){return M.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return M.label},set label(X){M.label=X??l.displayName??l.name,Q()},get detail(){return M.detail??""},set detail(X){M.detail=X,Q()},get description(){return M.description??""},set description(X){M.description=X,Q()},get supportedLanguages(){return M.supportedLanguages},set supportedLanguages(X){M.supportedLanguages=X,Q()},get supportsExecutionOrder(){return M.supportsExecutionOrder??!1},set supportsExecutionOrder(X){M.supportsExecutionOrder=X,Q()},get rendererScripts(){return M.preloads?M.preloads.map(v.NotebookRendererScript.to):[]},get executeHandler(){return W},set executeHandler(X){W=X??j},get interruptHandler(){return Y},set interruptHandler(X){Y=X,M.supportsInterrupt=!!X,Q()},set variableProvider(X){(0,s.$RF)(l,"notebookVariableProvider"),ue=X,M.hasVariableProvider=!!X,X?.onDidChangeVariables(ve=>z.a.$variablesUpdated(ve.uri)),Q()},get variableProvider(){return ue},createNotebookCellExecution(X){if(F)throw new Error("notebook controller is DISPOSED");if(!x.has(X.notebook.uri))throw z.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.notebook.uri.toString()}`);return z._createNotebookCellExecution(X,u(l.identifier,this.id))},createNotebookExecution(X){if((0,s.$RF)(l,"notebookExecution"),F)throw new Error("notebook controller is DISPOSED");if(!x.has(X.uri))throw z.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(ve=>ve.toString())),new Error(`notebook controller is NOT associated to notebook: ${X.uri.toString()}`);return z._createNotebookExecution(X,u(l.identifier,this.id))},dispose:()=>{F||(this.q.trace(`NotebookController[${P}], DISPOSED`),F=!0,this.j.delete(P),O.dispose(),T.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(X,ve){ve===S.NotebookControllerAffinity2.Hidden&&(0,s.$RF)(l,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(P,X.uri,ve)},onDidReceiveMessage:T.event,postMessage(X,ve){return(0,s.$RF)(l,"notebookMessaging"),z.a.$postMessage(P,ve&&z.n.getIdByEditor(ve),X)},asWebviewUri(X){return(0,s.$RF)(l,"notebookMessaging"),(0,f.$Qub)(X,z.m.remote)}};return this.j.set(P,{extensionId:l.identifier,controller:oe,onDidReceiveMessage:T,onDidChangeSelection:O,associatedNotebooks:x}),oe}getIdByController(l){for(const[k,R]of this.j)if(R.controller===l)return u(R.extensionId,l.id);return null}createNotebookControllerDetectionTask(l,k){const R=this.g++,w=this;this.q.trace(`NotebookControllerDetectionTask[${R}], CREATED by ${l.identifier.value}`),this.a.$addKernelDetectionTask(R,k);const p={dispose:()=>{this.f.delete(R),w.a.$removeKernelDetectionTask(R)}};return this.f.set(R,p),p}registerKernelSourceActionProvider(l,k,R){const w=this.i++,p=typeof R.onDidChangeNotebookKernelSourceActions=="function"?w:void 0,E=this;this.h.set(w,R),this.q.trace(`NotebookKernelSourceActionProvider[${w}], CREATED by ${l.identifier.value}`),this.a.$addKernelSourceActionProvider(w,w,k);let P;return p!==void 0&&(P=R.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(p))),{dispose:()=>{this.h.delete(w),E.a.$removeKernelSourceActionProvider(w,w),P?.dispose()}}}async $provideKernelSourceActions(l,k){const R=this.h.get(l);if(R){const w=new L.$Qc;return(await R.provideNotebookKernelSourceActions(k)??[]).map(E=>v.NotebookKernelSourceAction.from(E,this.o.converter,w))}return[]}$acceptNotebookAssociation(l,k,R){const w=this.j.get(l);if(w){const p=this.n.getNotebookDocument($.URI.revive(k));R?w.associatedNotebooks.set(p.uri,!0):w.associatedNotebooks.delete(p.uri),this.q.trace(`NotebookController[${l}] ASSOCIATE notebook`,p.uri.toString(),R),w.onDidChangeSelection.fire({selected:R,notebook:p.apiNotebook})}}async $executeCells(l,k,R){const w=this.j.get(l);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(k)),E=[];for(const P of R){const z=p.getCell(P);z&&E.push(z.apiCell)}try{this.q.trace(`NotebookController[${l}] EXECUTE cells`,p.uri.toString(),E.length),await w.controller.executeHandler.call(w.controller,E,p.apiNotebook,w.controller)}catch(P){this.q.error(`NotebookController[${l}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(l,k,R){const w=this.j.get(l);if(!w)return;const p=this.n.getNotebookDocument($.URI.revive(k));if(w.controller.interruptHandler)await w.controller.interruptHandler.call(w.controller,p.apiNotebook);else for(const E of R){const P=p.getCell(E);P&&this.b.get(P.uri)?.cancel()}if(w.controller.interruptHandler){const E=this.c.get(p.uri);R.length&&Array.isArray(E)&&E.length&&E.forEach(P=>P.dispose())}}async $provideVariables(l,k,R,w,p,E,P){const z=this.j.get(l);if(!z)return;const j=this.n.getNotebookDocument($.URI.revive(R)),F=z.controller.variableProvider;if(!F)return;const O=w?{name:w,value:""}:void 0,T=p==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,M=F.provideVariables(j.apiNotebook,O,T,E,P);for await(const W of M){if(P.isCancellationRequested)return;this.a.$receiveVariable(k,W)}}$acceptKernelMessageFromRenderer(l,k,R){const w=this.j.get(l);if(!w)return;const p=this.n.getEditorById(k);w.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:R}))}$cellExecutionChanged(l,k,R){const p=this.n.getNotebookDocument($.URI.revive(l)).getCell(k);if(p){const E=R?v.NotebookCellExecutionState.to(R):S.NotebookCellExecutionState.Idle;E!==void 0&&this.l.fire({cell:p.apiCell,state:E})}}_createNotebookCellExecution(l,k){if(l.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const w=this.n.getNotebookDocument(l.notebook.uri).getCellFromApiCell(l);if(!w)throw new Error("invalid cell");if(this.b.has(w.uri))throw new Error(`duplicate execution for ${w.uri}`);const p=new a(k,w,this.a);this.b.set(w.uri,p);const E=p.onDidChangeState(()=>{p.state===o.Resolved&&(p.dispose(),E.dispose(),this.b.delete(w.uri))});return p.asApiObject()}_createNotebookExecution(l,k){const R=this.n.getNotebookDocument(l.uri),w=l.getCells().find(P=>{const z=R.getCellFromApiCell(P);return z&&this.b.has(z.uri)});if(w)throw new Error(`duplicate cell execution for ${w.document.uri}`);if(this.c.has(R.uri))throw new Error(`duplicate notebook execution for ${R.uri}`);const p=new r(k,R,this.a),E=p.onDidChangeState(()=>{p.state===t.Resolved&&(p.dispose(),E.dispose(),this.c.delete(R.uri))});return this.c.set(R.uri,[p,E]),p.asApiObject()}};e.$0fc=n,e.$0fc=n=Ke([We(4,A.$hj)],n);var o;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(o||(o={}));class a extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(l,k,R){super(),this.m=k,this.n=R,this.b=a.a++,this.c=new I.$Rd,this.onDidChangeState=this.c.event,this.f=o.Init,this.g=this.B(new g.$2d),this.h=new h(10,w=>this.s(w)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,l,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(l){await this.h.addItem(l)}async s(l){const k=Array.isArray(l)?l:[l];return this.n.$updateExecution(this.b,new i.$Bv(k))}t(){if(this.f===o.Init)throw new Error("Must call start before modifying cell output");if(this.f===o.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(l){let k=this.m;if(l&&(k=this.m.notebook.getCellFromApiCell(l)),!k)throw new Error("INVALID cell");return k.handle}y(l){return l.map(k=>{const R=S.$9L.ensureUniqueMimeTypes(k.items,!0);return R===k.items?v.NotebookCellOutput.from(k):v.NotebookCellOutput.from({items:R,id:k.id,metadata:k.metadata})})}async z(l,k,R){const w=this.w(k),p=this.y((0,D.$2b)(l));return this.r({editType:d.CellExecutionUpdateType.Output,cellHandle:w,append:R,outputs:p})}async C(l,k,R){return l=S.$9L.ensureUniqueMimeTypes((0,D.$2b)(l),!0),this.r({editType:d.CellExecutionUpdateType.OutputItems,items:l.map(v.NotebookCellOutputItem.from),outputId:k.id,append:R})}asApiObject(){const l=this;return Object.freeze({get token(){return l.g.token},get cell(){return l.m.apiCell},get executionOrder(){return l.j},set executionOrder(R){l.j=R,l.s([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:l.j}])},start(R){if(l.f===o.Resolved||l.f===o.Started)throw new Error("Cannot call start again");l.f=o.Started,l.c.fire(),l.s({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:R})},end(R,w){if(l.f===o.Resolved)throw new Error("Cannot call resolve twice");l.f=o.Resolved,l.c.fire(),l.h.flush(),l.n.$completeExecution(l.b,new i.$Bv({runEndTime:w,lastRunSuccess:R}))},clearOutput(R){return l.t(),l.z([],R,!1)},appendOutput(R,w){return l.t(),l.z(R,w,!0)},replaceOutput(R,w){return l.t(),l.z(R,w,!1)},appendOutputItems(R,w){return l.t(),l.C(R,w,!0)},replaceOutputItems(R,w){return l.t(),l.C(R,w,!1)}})}}var t;(function(c){c[c.Init=0]="Init",c[c.Started=1]="Started",c[c.Resolved=2]="Resolved"})(t||(t={}));class r extends L.$Rc{static{this.a=0}get state(){return this.f}constructor(l,k,R){super(),this.h=k,this.j=R,this.b=r.a++,this.c=new I.$Rd,this.onDidChangeState=this.c.event,this.f=t.Init,this.g=this.B(new g.$2d),this.j.$createNotebookExecution(this.b,l,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===t.Resolved||this.f===t.Started)throw new Error("Cannot call start again");this.f=t.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===t.Resolved)throw new Error("Cannot call resolve twice");this.f=t.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class h{constructor(l,k){this.f=l,this.g=k,this.a=[],this.b=Date.now()}addItem(l){return this.a.push(l),this.c||(this.c=new N.$kh,this.b=Date.now(),(0,N.$1g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const l=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>l.complete())}}function u(c,l){return`${c.value}/${l}`}e.$$fc=u}),define(Ee[330],Se([1,0,4,6,146]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class I{constructor(b,$){this.c=$,this.a=new Map,this.b=b.getProxy(N.$EK.MainThreadNotebookRenderers)}$postRendererMessage(b,$,y){const A=this.c.getEditorById(b);this.a.get($)?.fire({editor:A.apiEditor,message:y})}createRendererMessaging(b,$){if(!b.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,C,m)=>this.d($).event(A,C,m),postMessage:(A,C)=>{g.$Rfc.apiEditorsToExtHost.has(A)&&([A,C]=[C,A]);const m=C&&g.$Rfc.apiEditorsToExtHost.get(C);return this.b.$postMessage(m?.id,$,A)}}}d(b){let $=this.a.get(b);return $||($=new D.$Rd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(b)}}),this.a.set(b,$),$)}}e.$_fc=I}),define(Ee[331],Se([1,0,3,18,2,25,6]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class b{constructor(y){this.b=new Map,this.a=y.getProxy(L.$EK.MainThreadProfileContentHandlers)}registrProfileContentHandler(y,A,C){if((0,I.$RF)(y,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,C),this.a.$registerProfileContentHandler(A,C.name,C.description,y.identifier.value),(0,D.$Pc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(y,A,C,m){const v=this.b.get(y);if(!v)throw new Error(`Unknown handler with id: ${y}`);return v.saveProfile(A,C,m)}async $readProfile(y,A,C){const m=this.b.get(y);if(!m)throw new Error(`Unknown handler with id: ${y}`);return m.readProfile((0,N.$Cf)(A)?A:g.URI.revive(A),C)}}e.$cgc=b}),define(Ee[332],Se([1,0,2,6,12,15]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class L{static{this.a=0}constructor($,y){this.d=y,this.c=new Map,this.b=$.getProxy(N.$EK.MainThreadQuickDiff)}$provideOriginalResource($,y,A){const C=D.URI.revive(y),m=this.c.get($);return m?(0,g.$Sg)(()=>m.provideOriginalResource(C,A)).then(v=>v||null):Promise.resolve(null)}registerQuickDiffProvider($,y,A,C){const m=L.a++;return this.c.set(m,y),this.b.$registerQuickDiffProvider(m,I.DocumentSelector.from($,this.d),A,C),{dispose:()=>{this.b.$unregisterQuickDiffProvider(m),this.c.delete(m)}}}}e.$egc=L}),define(Ee[333],Se([1,0,21,4,3,6,2,7,8,19,39,61,25,15]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;function S(f,d,s){const i=f.getProxy(I.$EK.MainThreadQuickOpen);class n{constructor(k,R){this.e=new Map,this.f=0,this.a=k,this.b=R}showQuickPick(k,R,w,p=D.CancellationToken.None){this.c=void 0;const E=Promise.resolve(R),P=++this.f,z=i.$show(P,{title:w?.title,placeHolder:w?.placeHolder,matchOnDescription:w?.matchOnDescription,matchOnDetail:w?.matchOnDetail,ignoreFocusLost:w?.ignoreFocusOut,canPickMany:w?.canPickMany},p),j={},F=z.then(()=>j);return Promise.race([F,E]).then(O=>{if(O===j)return;const T=(0,m.$QF)(k,"quickPickItemTooltip");return E.then(M=>{const W=[];for(let Y=0;Y<M.length;Y++){const ue=M[Y];if(typeof ue=="string")W.push({label:ue,handle:Y});else if(ue.kind===b.QuickPickItemKind.Separator)W.push({type:"separator",label:ue.label});else{ue.tooltip&&!T&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const Z=ue.iconPath?h(ue.iconPath):void 0;W.push({label:ue.label,iconPath:Z?.iconPath,iconClass:Z?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:T?v.MarkdownString.fromStrict(ue.tooltip):void 0,handle:Y})}}return w&&typeof w.onDidSelectItem=="function"&&(this.c=Y=>{w.onDidSelectItem(M[Y])}),i.$setItems(P,W),z.then(Y=>{if(typeof Y=="number")return M[Y];if(Array.isArray(Y))return Y.map(ue=>M[ue])})})}).then(void 0,O=>{if(!(0,$.$3)(O))return i.$setError(P,O),Promise.reject(O)})}$onItemSelected(k){this.c?.(k)}showInput(k,R=D.CancellationToken.None){return this.d=k?.validateInput,i.$input(k,typeof this.d=="function",R).then(void 0,w=>{if(!(0,$.$3)(w))return Promise.reject(w)})}async $validateInput(k){if(!this.d)return;const R=await this.d(k);if(!R||typeof R=="string")return R;let w;switch(R.severity){case b.InputBoxValidationSeverity.Info:w=A.default.Info;break;case b.InputBoxValidationSeverity.Warning:w=A.default.Warning;break;case b.InputBoxValidationSeverity.Error:w=A.default.Error;break;default:w=R.message?A.default.Error:A.default.Ignore;break}return{content:R.message,severity:w}}async showWorkspaceFolderPick(k,R=D.CancellationToken.None){const w=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!w)return;const p=await this.a.getWorkspaceFolders2();if(p)return p.find(E=>E.uri.toString()===w.uri.toString())}createQuickPick(k){const R=new u(k,()=>this.e.delete(R._id));return this.e.set(R._id,R),R}createInputBox(k){const R=new c(k,()=>this.e.delete(R._id));return this.e.set(R._id,R),R}$onDidChangeValue(k,R){this.e.get(k)?._fireDidChangeValue(R)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,R){const w=this.e.get(k);w instanceof u&&w._fireDidChangeActive(R)}$onDidChangeSelection(k,R){const w=this.e.get(k);w instanceof u&&w._fireDidChangeSelection(R)}$onDidTriggerButton(k,R){this.e.get(k)?._fireDidTriggerButton(R)}$onDidTriggerItemButton(k,R,w){const p=this.e.get(k);p instanceof u&&p._fireDidTriggerItemButton(R,w)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class o{static{this.a=1}constructor(k,R){this.x=k,this.y=R,this._id=u.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Rd,this.q=new N.$Rd,this.r=new N.$Rd,this.s=new N.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((R,w)=>{const p=R===b.$2L.Back?-1:w;this.o.set(p,R)}),this.z({buttons:k.map((R,w)=>({...h(R.iconPath),tooltip:R.tooltip,handle:R===b.$2L.Back?-1:w}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const R=this.o.get(k);R&&this.r.fire(R)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,g.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(k){if(!this.v){for(const R of Object.keys(k)){const w=k[R];this.u[R]=w===void 0?null:w}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(l){if(l instanceof b.$BL)return{id:l.id};const k=r(l),R=t(l);return{dark:typeof k=="string"?L.URI.file(k):k,light:typeof R=="string"?L.URI.file(R):R}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function r(l){return typeof l=="object"&&"dark"in l?l.dark:l}function h(l){const k=a(l);let R,w;return"id"in k?w=C.ThemeIcon.asClassName(k):R=k,{iconPath:R,iconClass:w}}class u extends o{constructor(k,R){super(k.identifier,R),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Rd,this.L=[],this.M=new N.$Rd,this.N=new N.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((p,E)=>{this.C.set(E,p),this.D.set(p,E)});const R=(0,m.$QF)(this.O,"quickPickItemTooltip"),w=[];for(let p=0;p<k.length;p++){const E=k[p];if(E.kind===b.QuickPickItemKind.Separator)w.push({type:"separator",label:E.label});else{E.tooltip&&!R&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=E.iconPath?h(E.iconPath):void 0;w.push({handle:p,label:E.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:R?v.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((z,j)=>({...h(z.iconPath),tooltip:z.tooltip,handle:j}))})}}this.z({items:w})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(R=>this.D.has(R)),this.z({activeItems:this.J.map(R=>this.D.get(R))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(R=>this.D.has(R)),this.z({selectedItems:this.L.map(R=>this.D.get(R))})}_fireDidChangeActive(k){const R=(0,y.$Gb)(k.map(w=>this.C.get(w)));this.J=R,this.K.fire(R)}_fireDidChangeSelection(k){const R=(0,y.$Gb)(k.map(w=>this.C.get(w)));this.L=R,this.M.fire(R)}_fireDidTriggerItemButton(k,R){const w=this.C.get(k);if(!w||!w.buttons||!w.buttons.length)return;const p=w.buttons[R];p&&this.N.fire({button:p,item:w})}}class c extends o{constructor(k,R){super(k.identifier,R),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:A.default.Error}):this.z({validationMessage:k.message,severity:k.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new n(d,s)}e.$fgc=S}),define(Ee[334],Se([1,0,2,4,59,3,12,6,19,128,14,21,26,61,15,25,17,11]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=void 0;function n(F){return F instanceof D.URI}function o(F,O){return F.scheme===d.Schemas.file&&O.scheme===d.Schemas.file&&s.$k?F.toString()===O.toString():F.toString().toLowerCase()===O.toString().toLowerCase()}function a(F){if(F)return typeof F.iconPath=="string"?D.URI.file(F.iconPath):D.URI.isUri(F.iconPath)||v.ThemeIcon.isThemeIcon(F.iconPath)?F.iconPath:void 0}function t(F){if(F?.icon){if(D.URI.isUri(F.icon))return F.icon;if(v.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const O=F.icon;return{light:O.light,dark:O.dark}}}else return}function r(F){if(F.icon){if(D.URI.isUri(F.icon))return F.icon;if(v.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const O=F.icon;return{light:O.light,dark:O.dark}}}else return}function h(F){if(F.icon){if(D.URI.isUri(F.icon))return F.icon;if(v.ThemeIcon.isThemeIcon(F.icon))return F.icon;{const O=F.icon;return{light:O.light,dark:O.dark}}}else return}function u(F,O){if(!F.iconPath&&!O.iconPath)return 0;if(F.iconPath){if(!O.iconPath)return 1}else return-1;const T=typeof F.iconPath=="string"?F.iconPath:D.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id,M=typeof O.iconPath=="string"?O.iconPath:D.URI.isUri(O.iconPath)?O.iconPath.fsPath:O.iconPath.id;return(0,y.$Bq)(T,M)}function c(F,O){let T=0;if(F.strikeThrough!==O.strikeThrough)return F.strikeThrough?1:-1;if(F.faded!==O.faded)return F.faded?1:-1;if(F.tooltip!==O.tooltip)return(F.tooltip||"").localeCompare(O.tooltip||"");if(T=u(F,O),T!==0)return T;if(F.light&&O.light)T=u(F.light,O.light);else{if(F.light)return 1;if(O.light)return-1}if(T!==0)return T;if(F.dark&&O.dark)T=u(F.dark,O.dark);else{if(F.dark)return 1;if(O.dark)return-1}return T}function l(F,O){if(F.command!==O.command)return F.command<O.command?-1:1;if(F.title!==O.title)return F.title<O.title?-1:1;if(F.tooltip!==O.tooltip){if(F.tooltip!==void 0&&O.tooltip!==void 0)return F.tooltip<O.tooltip?-1:1;if(F.tooltip!==void 0)return 1;if(O.tooltip!==void 0)return-1}if(F.arguments===O.arguments)return 0;if(F.arguments)if(O.arguments){if(F.arguments.length!==O.arguments.length)return F.arguments.length-O.arguments.length}else return 1;else return-1;for(let T=0;T<F.arguments.length;T++){const M=F.arguments[T],W=O.arguments[T];if(M!==W&&!(n(M)&&n(W)&&o(M,W)))return M<W?-1:1}return 0}function k(F,O){let T=(0,y.$Bq)(F.resourceUri.fsPath,O.resourceUri.fsPath,!0);if(T!==0)return T;if(F.command&&O.command)T=l(F.command,O.command);else{if(F.command)return 1;if(O.command)return-1}if(T!==0)return T;if(F.decorations&&O.decorations)T=c(F.decorations,O.decorations);else{if(F.decorations)return 1;if(O.decorations)return-1}return T}function R(F,O){for(let T=0;T<F.length;T++)if(F[T]!==O[T])return!1;return!0}function w(F,O){return F.command===O.command&&F.title===O.title&&F.tooltip===O.tooltip&&(F.arguments&&O.arguments?R(F.arguments,O.arguments):F.arguments===O.arguments)}function p(F,O){return(0,$.$tb)(F,O,w)}class E{#e;#t;get value(){return this.d}set value(O){O=O??"",this.#e.$setInputBoxValue(this.o,O),this.q(O)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(O){this.#e.$setInputBoxPlaceholder(this.o,O),this.f=O}get validateInput(){return(0,f.$RF)(this.m,"scmValidation"),this.g}set validateInput(O){if((0,f.$RF)(this.m,"scmValidation"),O&&typeof O!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=O,this.#e.$setValidationProviderIsEnabled(this.o,!!O)}get enabled(){return this.h}set enabled(O){O=!!O,this.h!==O&&(this.h=O,this.#e.$setInputBoxEnablement(this.o,O))}get visible(){return this.j}set visible(O){O=!!O,this.j!==O&&(this.j=O,this.#e.$setInputBoxVisibility(this.o,O))}get actionButton(){return(0,f.$RF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(O){(0,f.$RF)(this.m,"scmInputBoxActionButton"),this.l.value=new I.$Qc,this.k=O;const T=O!==void 0?{command:this.n.converter.toInternal(O.command,this.l.value),icon:t(O),enabled:O.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,T??null)}get document(){return(0,f.$RF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(O,T,M,W,Y,ue){this.m=O,this.n=T,this.o=Y,this.p=ue,this.d="",this.e=new N.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new I.$Sc,this.#t=M,this.#e=W}showValidationMessage(O,T){(0,f.$RF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,O,T)}$onInputBoxValueChange(O){this.q(O)}q(O){this.d=O,this.e.fire(O)}}e.$ggc=E;class P{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(O){this.v=O,this.q.$updateGroupLabel(this.t,this.handle,O)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(O){this.p=O,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(O){this.f=[...O],this.k.fire()}constructor(O,T,M,W,Y){this.q=O,this.s=T,this.t=M,this.u=W,this.v=Y,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=P.d++}getResourceState(O){return this.g.get(O)}$executeResourceCommand(O,T){const M=this.h.get(O);return M?(0,L.$Sg)(()=>this.s.executeCommand(M.command,...M.arguments||[],T)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const O=[...this.f].sort(k),M=(0,$.$Cb)(this.o,O,k).map(ue=>{const Z=ue.toInsert.map(Q=>{const x=this.e++;this.g.set(x,Q);const oe=Q.resourceUri;let X;if(Q.command)if(Q.command.command==="vscode.open"||Q.command.command==="vscode.diff"||Q.command.command==="vscode.changes"){const ie=new I.$Qc;X=this.s.converter.toInternal(Q.command,ie),this.j.set(x,ie)}else this.h.set(x,Q.command);const ve=a(Q.decorations),ge=Q.decorations&&a(Q.decorations.light)||ve,V=Q.decorations&&a(Q.decorations.dark)||ve,U=[ge,V],ne=Q.decorations&&Q.decorations.tooltip||"",ye=Q.decorations&&!!Q.decorations.strikeThrough,fe=Q.decorations&&!!Q.decorations.faded,me=Q.contextValue||"";return{rawResource:[x,oe,U,ne,ye,fe,me,X],handle:x}});return{start:ue.start,deleteCount:ue.deleteCount,toInsert:Z}}),W=M.map(({start:ue,deleteCount:Z,toInsert:Q})=>[ue,Z,Q.map(x=>x.rawResource)]),Y=M.reverse();for(const{start:ue,deleteCount:Z,toInsert:Q}of Y){const x=Q.map(X=>X.handle),oe=this.n.splice(ue,Z,...x);for(const X of oe)this.g.delete(X),this.h.delete(X),this.j.get(X)?.dispose(),this.j.delete(X)}return this.o=O,W}dispose(){this.l=!0,this.m.fire()}}class z{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(O){this.g!==O&&(this.g=O,this.#e.$updateSourceControl(this.x,{count:O}))}get quickDiffProvider(){return this.h}set quickDiffProvider(O){this.h=O;let T;(0,f.$QF)(this.y,"quickDiffProvider")&&(T=O?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!O,quickDiffLabel:T})}get historyProvider(){return(0,f.$RF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(O){(0,f.$RF)(this.y,"scmHistoryProvider"),this.j=O,this.k.value=new I.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!O}),O&&(this.k.value.add(O.onDidChangeCurrentHistoryItemGroup(()=>{this.l=O?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(O.onDidChangeActionButton(()=>{(0,f.$RF)(this.y,"scmActionButton"),this.m.value=new I.$Qc;const T=O.actionButton!==void 0?{command:this.z.converter.toInternal(O.actionButton.command,this.m.value),description:O.actionButton.description,enabled:O.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,T??null)})))}get commitTemplate(){return this.n}set commitTemplate(O){O!==this.n&&(this.n=O,this.#e.$updateSourceControl(this.x,{commitTemplate:O}))}get acceptInputCommand(){return this.p}set acceptInputCommand(O){this.o.value=new I.$Qc,this.p=O;const T=this.z.converter.toInternal(O,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:T})}get actionButton(){return(0,f.$RF)(this.y,"scmActionButton"),this.s}set actionButton(O){(0,f.$RF)(this.y,"scmActionButton"),this.q.value=new I.$Qc,this.s=O;const T=O!==void 0?{command:this.z.converter.toInternal(O.command,this.q.value),secondaryCommands:O.secondaryCommands?.map(M=>M.map(W=>this.z.converter.toInternal(W,this.q.value))),description:O.description,enabled:O.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:T??null})}get statusBarCommands(){return this.u}set statusBarCommands(O){if(this.u&&O&&p(this.u,O))return;this.t.value=new I.$Qc,this.u=O;const T=(O||[]).map(M=>this.z.converter.toInternal(M,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:T})}get selected(){return this.v}constructor(O,T,M,W,Y,ue,Z){this.y=O,this.z=W,this.A=Y,this.B=ue,this.C=Z,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new I.$Sc,this.m=new I.$Sc,this.n=void 0,this.o=new I.$Sc,this.p=void 0,this.q=new I.$Sc,this.t=new I.$Sc,this.u=void 0,this.v=!1,this.w=new N.$Rd,this.onDidChangeSelection=this.w.event,this.x=z.d++,this.D=new Map,this.E=new Set,this.#e=M;const Q=D.URI.from({scheme:d.Schemas.vscodeSourceControl,path:`${Y}/scm${this.x}/input`,query:Z?`rootUri=${encodeURIComponent(Z.toString())}`:void 0});this.f=new E(O,W,T,this.#e,this.x,Q),this.#e.$registerSourceControl(this.x,Y,ue,Z,Q)}createResourceGroup(O,T){const M=new P(this.#e,this.z,this.x,O,T),W=N.Event.once(M.onDidDispose)(()=>this.D.delete(M));return this.D.set(M,W),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const O=[],T=[];for(const[M,W]of this.D){W.dispose();const Y=M.onDidUpdateResourceStates(()=>{this.E.add(M),this.eventuallyUpdateResourceStates()});N.Event.once(M.onDidDispose)(()=>{this.E.delete(M),Y.dispose(),this.e.delete(M.handle),this.#e.$unregisterGroup(this.x,M.handle)}),O.push([M.handle,M.id,M.label,M.features]);const ue=M._takeResourceStateSnapshot();ue.length>0&&T.push([M.handle,ue]),this.e.set(M.handle,M)}this.#e.$registerGroups(this.x,O,T),this.D.clear()}eventuallyUpdateResourceStates(){const O=[];this.E.forEach(T=>{const M=T._takeResourceStateSnapshot();M.length!==0&&O.push([T.handle,M])}),O.length>0&&this.#e.$spliceResourceStates(this.x,O),this.E.clear()}getResourceGroup(O){return this.e.get(O)}setSelectionState(O){this.v=O,this.w.fire(O)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(O=>O.dispose()),this.#e.$unregisterSourceControl(this.x)}}Ke([(0,g.$sh)(100)],z.prototype,"eventuallyAddResourceGroups",null),Ke([(0,g.$sh)(100)],z.prototype,"eventuallyUpdateResourceStates",null);let j=class{static{i=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(O,T,M,W){this.n=T,this.o=M,this.p=W,this.h=new Map,this.j=new m.$fm,this.k=new N.$Rd,this.l=new Map,this.f=O.getProxy(b.$EK.MainThreadSCM),this.g=O.getProxy(b.$EK.MainThreadTelemetry),T.registerArgumentProcessor({processArgument:Y=>{if(Y&&Y.$mid===3){const ue=this.h.get(Y.sourceControlHandle);if(!ue)return Y;const Z=ue.getResourceGroup(Y.groupHandle);return Z?Z.getResourceState(Y.handle):Y}else if(Y&&Y.$mid===4){const ue=this.h.get(Y.sourceControlHandle);return ue?ue.getResourceGroup(Y.groupHandle):Y}else if(Y&&Y.$mid===5){const ue=this.h.get(Y.handle);return ue||Y}return Y}})}createSourceControl(O,T,M,W){this.p.trace("ExtHostSCM#createSourceControl",O.identifier.value,T,M,W),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:O.identifier.value});const Y=i.d++,ue=new z(O,this.o,this.f,this.n,T,M,W);this.h.set(Y,ue);const Z=this.j.get(O.identifier)||[];return Z.push(ue),this.j.set(O.identifier,Z),ue}registerSourceControlInputBoxValueProvider(O,T){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",O.identifier.value,T.label);const M=i.e++;return this.l.set(M,T),this.f.$registerSourceControlInputBoxValueProvider(M,T.label,h(T)),(0,I.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(M),this.l.delete(M)})}async $provideInputBoxValue(O,T,M){const W=this.l.get(O);if(W)return await W.provideValue(T,M,C.CancellationToken.None)??void 0}getLastInputBox(O){this.p.trace("ExtHostSCM#getLastInputBox",O.identifier.value);const T=this.j.get(O.identifier),M=T&&T[T.length-1];return M&&M.inputBox}$provideOriginalResource(O,T,M){const W=D.URI.revive(T);this.p.trace("ExtHostSCM#$provideOriginalResource",O,W.toString());const Y=this.h.get(O);return!Y||!Y.quickDiffProvider||!Y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Sg)(()=>Y.quickDiffProvider.provideOriginalResource(W,M)).then(ue=>ue||null)}$onInputBoxValueChange(O,T){this.p.trace("ExtHostSCM#$onInputBoxValueChange",O);const M=this.h.get(O);return M&&M.inputBox.$onInputBoxValueChange(T),Promise.resolve(void 0)}$executeResourceCommand(O,T,M,W){this.p.trace("ExtHostSCM#$executeResourceCommand",O,T,M);const Y=this.h.get(O);if(!Y)return Promise.resolve(void 0);const ue=Y.getResourceGroup(T);return ue?ue.$executeResourceCommand(M,W):Promise.resolve(void 0)}$validateInput(O,T,M){this.p.trace("ExtHostSCM#$validateInput",O);const W=this.h.get(O);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Sg)(()=>W.inputBox.validateInput(T,M)).then(Y=>{if(!Y)return Promise.resolve(void 0);const ue=S.MarkdownString.fromStrict(Y.message);return ue?Promise.resolve([ue,Y.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(O){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",O),O!==void 0&&this.h.get(O)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=O,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(O,T,M){return await this.h.get(O)?.historyProvider?.resolveHistoryItemGroupBase(T,M)??void 0}async $resolveHistoryItemGroupCommonAncestor(O,T,M,W){return await this.h.get(O)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(T,M,W)??void 0}async $provideHistoryItems(O,T,M,W){return(await this.h.get(O)?.historyProvider?.provideHistoryItems(T,M,W))?.map(Z=>({...Z,icon:r(Z)}))??void 0}async $provideHistoryItemChanges(O,T,M){return await this.h.get(O)?.historyProvider?.provideHistoryItemChanges(T,M)??void 0}};e.$hgc=j,e.$hgc=j=i=Ke([We(3,A.$hj)],j)}),define(Ee[117],Se([1,0,6,4,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0;class I{constructor(b){this.b=new N.$Rd,this.onDidChangePassword=this.b.event,this.a=b.getProxy(D.$EK.MainThreadSecretState)}async $onDidChangePassword(b){this.b.fire(b)}get(b,$){return this.a.$getPassword(b,$)}store(b,$,y){return this.a.$setPassword(b,$,y)}delete(b,$){return this.a.$deletePassword(b,$)}}e.$nfc=I,e.$ofc=(0,g.$Zh)("IExtHostSecretState")}),define(Ee[335],Se([1,0,6,15,2]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class I{static{this.a=0}constructor(b,$){this.d=$,this.c=new Map,this.b=b.getProxy(D.$EK.MainThreadShare)}async $provideShare(b,$,y){return await this.c.get(b)?.provideShare({selection:N.Range.to($.selection),resourceUri:g.URI.revive($.resourceUri)},y)??void 0}registerShareProvider(b,$){const y=I.a++;return this.c.set(y,$),this.b.$registerShareProvider(y,N.DocumentSelector.from(b,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$igc=I}),define(Ee[336],Se([1,0,21,3,6]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class I{static{this.a=1}constructor(b){this.c=new Map,this.d=new Map,this.b=b.getProxy(g.$EK.MainThreadSpeech)}async $createSpeechToTextSession(b,$){const y=this.c.get(b);if(!y)return;const A=new N.$Qc,C=new D.$2d;this.d.set($,C);const m=A.add(y.provideSpeechToTextSession(C.token));A.add(m.onDidChange(v=>{C.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,v)})),A.add(C.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(b){this.d.get(b)?.dispose(!0),this.d.delete(b)}registerProvider(b,$,y){const A=I.a++;return this.c.set(A,y),this.b.$registerProvider(A,$,{extension:b,displayName:b.value}),(0,N.$Pc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$jgc=I}),define(Ee[337],Se([1,0,7,6,216,3,15,18]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new D.$CL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new D.$CL("statusBarItem.warningForeground")]])}#e;#t;constructor(m,v,S,f,d,s=D.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new I.$Qc,this.#e=m,this.#t=v,d&&f){this.c=(0,D.$fL)(f.identifier,d);const n=S.get(this.c);n&&(s=n.alignLeft?D.StatusBarAlignment.Left:D.StatusBarAlignment.Right,i=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String($.a++);this.e=f,this.f=d,this.g=s,this.h=this.u(i)}u(m){if((0,b.$Gf)(m))return m===Number.POSITIVE_INFINITY?Number.MAX_VALUE:m===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:m}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(m){this.k=m,this.v()}set name(m){this.m=m,this.v()}set tooltip(m){this.l=m,this.v()}set color(m){this.n=m,this.v()}set backgroundColor(m){m&&!$.b.has(m.id)&&(m=void 0),this.o=m,this.v()}set command(m){this.r?.fromApi!==m&&(this.p&&this.q.add(this.p),this.p=new I.$Qc,typeof m=="string"?this.r={fromApi:m,internal:this.#t.toInternal({title:"",command:m},this.p)}:m?this.r={fromApi:m,internal:this.#t.toInternal(m,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(m){this.t=m,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let m;this.e?this.f?m=`${this.e.identifier.value}.${this.f}`:m=this.e.identifier.value:m=this.f;let v;this.m?v=this.m:v=(0,g.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const f=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,m,this.e?.identifier.value,v,this.k,f,this.r?.internal,S,this.o,this.g===D.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$kgc=$;class y{constructor(m){this.b=[],this.a=m.createStatusBarEntry(void 0,"status.extensionMessage",D.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,g.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(m){const v={message:m};return this.b.unshift(v),this.c(),new D.$GK(()=>{const S=this.b.indexOf(v);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(m,v){this.e=new Map,this.a=m.getProxy(N.$EK.MainThreadStatusBar),this.b=v,this.c=new y(this)}$acceptStaticEntries(m){for(const v of m)this.e.set(v.entryId,v)}createStatusBarEntry(m,v,S,f){return new $(this.a,this.b,this.e,m,v,S,f)}setStatusBarMessage(m,v){const S=this.c.setMessage(m);let f;return typeof v=="number"?f=setTimeout(()=>S.dispose(),v):typeof v<"u"&&v.then(()=>S.dispose(),()=>S.dispose()),new D.$GK(()=>{S.dispose(),clearTimeout(f)})}}e.$lgc=A}),define(Ee[118],Se([1,0,6,4,5]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class I{constructor(b,$){this.c=$,this.b=new N.$Rd,this.onDidChangeStorage=this.b.event,this.a=b.getProxy(D.$EK.MainThreadStorage)}registerExtensionStorageKeysToSync(b,$){this.a.$registerExtensionStorageKeysToSync(b,$)}async initializeExtensionStorage(b,$,y){const A=await this.a.$initializeExtensionStorage(b,$);let C;return A&&(C=this.d(b,$,A)),C||y}setValue(b,$,y){return this.a.$setValue(b,$,y)}$acceptValue(b,$,y){const A=this.d(b,$,y);A&&this.b.fire({shared:b,key:$,value:A})}d(b,$,y){try{return JSON.parse(y)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${b}): ${A}`)}}}e.$ffc=I,e.$gfc=(0,g.$Zh)("IExtHostStorage")}),define(Ee[92],Se([1,0,5,27,14,71,2]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=void 0,e.$1ec=(0,D.$Zh)("IExtensionStoragePaths");let b=class{constructor(y,A,C){this.d=A,this.f=C,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(m=>this.c=m)}async g(y){return L.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,A=await this.g(y);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(C){this.d.error("[ExtHostStorage]",C);return}}workspaceValue(y){if(this.c)return L.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return L.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$2ec=b,e.$2ec=b=Ke([We(0,N.$XM),We(1,g.$hj),We(2,I.$Zec)],b)}),define(Ee[47],Se([1,0,4,6,5,2,20,3,7,218,8,262,21,30,263,61,12,15,35]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=void 0,e.$jfc=(0,g.$Zh)("IExtHostTerminalService");class n{constructor(w,p,E,P){this.l=w,this._id=p,this.m=E,this.n=P,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(j=>this.f=j);const z=this;this.value={get name(){return z.n||""},get processId(){return z.b},get creationOptions(){return z.m},get exitStatus(){return z.h},get state(){return z.j},get selection(){return z.k},sendText(j,F=!0){z.q(),z.l.$sendText(z._id,j,F)},show(j){z.q(),z.l.$show(z._id,j)},hide(){z.q(),z.l.$hide(z._id)},dispose(){z.a||(z.a=!0,z.l.$dispose(z._id))},get dimensions(){if(!(z.d===void 0||z.g===void 0))return{columns:z.d,rows:z.g}}}}async create(w,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:w.name,shellPath:w.shellPath??void 0,shellArgs:w.shellArgs??void 0,cwd:w.cwd??p?.cwd??void 0,env:w.env??void 0,icon:c(w.iconPath)??void 0,color:f.ThemeColor.isThemeColor(w.color)?w.color.id:void 0,initialText:w.message??void 0,strictEnv:w.strictEnv??void 0,hideFromUser:w.hideFromUser??void 0,isFeatureTerminal:p?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:p?.useShellEnvironment??void 0,location:p?.location||this.o(w.location,p?.resolvedExtHostIdentifier),isTransient:w.isTransient??void 0})}async createExtensionTerminal(w,p,E,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:E,color:f.ThemeColor.isThemeColor(P)?P.id:void 0,location:this.o(w,p),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(w,p){return typeof w=="object"?"parentTerminal"in w&&w.parentTerminal&&p?{parentTerminal:p}:"viewColumn"in w?{viewColumn:s.ViewColumn.from(w.viewColumn),preserveFocus:w.preserveFocus}:void 0:w}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(w){this.n=w}setExitStatus(w,p){this.h=Object.freeze({code:w,reason:p})}setDimensions(w,p){return w===this.d&&p===this.g||w===0||p===0?!1:(this.d=w,this.g=p,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(w){this.k=w}_setProcessId(w){this.f?(this.f(w),this.f=void 0):this.b.then(p=>{p!==w&&(this.b=Promise.resolve(w))})}}e.$kfc=n;class o{get onProcessReady(){return this.b.event}constructor(w){this.g=w,this.id=0,this.shouldPersist=!1,this.a=new D.$Rd,this.onProcessData=this.a.event,this.b=new D.$Rd,this.d=new D.$Rd,this.onDidChangeProperty=this.d.event,this.f=new D.$Rd,this.onProcessExit=this.f.event}refreshProperty(w){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${w}`)}updateProperty(w,p){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${w}, value: ${p}`)}async start(){}shutdown(){this.g.close()}input(w){this.g.handleInput?.(w)}resize(w,p){this.g.setDimensions?.({columns:w,rows:p})}clearBuffer(){}async processBinary(w){}acknowledgeDataEvent(w){}async setUnicodeVersion(w){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(w){this.g.onDidWrite(p=>this.a.fire(p)),this.g.onDidClose?.((p=void 0)=>{this.f.fire(p===void 0?void 0:p)}),this.g.onDidOverrideDimensions?.(p=>{p&&this.d.fire({type:"overrideDimensions",value:{cols:p.columns,rows:p.rows}})}),this.g.onDidChangeName?.(p=>{this.d.fire({type:"title",value:p})}),this.g.open(w||void 0),w&&this.g.setDimensions?.(w),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends b.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(w=>w.value)}constructor(w,p,E){super(),this.Q=p,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new b.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new D.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new D.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new D.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new D.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new D.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new D.$Rd,this.onDidChangeShell=this.N.event,this.O=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new D.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(N.$EK.MainThreadTerminalService),this.y=new S.$5qb(this.a.$sendProcessData),this.a.$registerProcessSupport(w),this.Q.registerArgumentProcessor({processArgument:P=>{const z=j=>{const F=j;return this.W(F.instanceId)?.value};switch(P?.$mid){case 15:return z(P);default:{if(Array.isArray(P))for(let j=0;j<P.length&&P[j].$mid===15;j++)P[j]=z(P[j]);return P}}}}),this.B({dispose:()=>{for(const[P,z]of this.g)z.shutdown(!0)}})}getDefaultShell(w){return(w?this.u:this.s)?.path||""}getDefaultShellArgs(w){return(w?this.u:this.s)?.args||[]}createExtensionTerminal(w,p){const E=new n(this.a,(0,v.$kg)(),w,w.name),P=new o(w.pty);return E.createExtensionTerminal(w.location,this.R(w,p).resolvedExtHostIdentifier,c(w.iconPath),l(w.color)).then(z=>{const j=this.S(z,P);this.h[z]=j}),this.f.push(E),E.value}R(w,p){if(p=p||{},w.location&&typeof w.location=="object"&&"parentTerminal"in w.location){const E=w.location.parentTerminal;if(E){const P=this.f.find(z=>z.value===E);P&&(p.resolvedExtHostIdentifier=P._id)}}else w.location&&typeof w.location!="object"?p.location=w.location:p.location&&typeof p.location=="object"&&"splitActiveTerminal"in p.location&&(p.location={splitActiveTerminal:!0});return p}attachPtyToTerminal(w,p){if(!this.W(w))throw new Error(`Cannot resolve terminal with id ${w} for virtual process`);const P=new o(p),z=this.S(w,P);this.h[w]=z}async $acceptActiveTerminalChanged(w){const p=this.b;if(w===null){this.b=void 0,p!==this.b&&this.J.fire(this.b);return}const E=this.W(w);E&&(this.b=E,p!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(w,p){const E=this.W(w);E&&this.O.fire({terminal:E.value,data:p})}async $acceptTerminalDimensions(w,p,E){const P=this.W(w);P&&P.setDimensions(p,E)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(w,p){const E=this.W(w);E&&this.P.fire({terminal:E.value,...p})}async $acceptTerminalMaximumDimensions(w,p,E){this.g.get(w)?.resize(p,E)}async $acceptTerminalTitleChange(w,p){const E=this.W(w);E&&(E.name=p)}async $acceptTerminalClosed(w,p,E){const P=this.Y(this.f,w);if(P!==null){const z=this.f.splice(P,1)[0];z.setExitStatus(p,E),this.H.fire(z.value)}}$acceptTerminalOpened(w,p,E,P){if(p){const F=this.Y(this.f,p);if(F!==null){this.f[F]._id=w,this.I.fire(this.terminals[F]),this.f[F].isOpen=!0;return}}const z={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:I.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},j=new n(this.a,w,z,E);this.f.push(j),this.I.fire(j.value),j.isOpen=!0}async $acceptTerminalProcessId(w,p){this.W(w)?._setProcessId(p)}async $startExtensionTerminal(w,p){const E=this.W(w);if(!E)return{message:(0,y.localize)(0,null,w)};E.isOpen||await new Promise(z=>{const j=this.onDidOpenTerminal(async F=>{F===E.value&&(j.dispose(),z())})});const P=this.g.get(w);P?P.startSendingEvents(p):this.j[w]={initialDimensions:p}}S(w,p){const E=new b.$Qc;E.add(p.onProcessReady(z=>this.a.$sendProcessReady(w,z.pid,z.cwd,z.windowsPty))),E.add(p.onDidChangeProperty(z=>this.a.$sendProcessProperty(w,z))),this.y.startBuffering(w,p.onProcessData),E.add(p.onProcessExit(z=>this.U(w,z))),this.g.set(w,p);const P=this.j[w];return P&&p instanceof o&&(p.startSendingEvents(P.initialDimensions),delete this.j[w]),E}$acceptProcessAckDataEvent(w,p){this.g.get(w)?.acknowledgeDataEvent(p)}$acceptProcessInput(w,p){this.g.get(w)?.input(p)}$acceptTerminalInteraction(w){const p=this.W(w);p?.setInteractedWith()&&this.M.fire(p.value)}$acceptTerminalSelection(w,p){this.W(w)?.setSelection(p)}$acceptProcessResize(w,p,E){try{this.g.get(w)?.resize(p,E)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(w,p){this.g.get(w)?.shutdown(p)}$acceptProcessRequestInitialCwd(w){this.g.get(w)?.getInitialCwd().then(p=>this.a.$sendProcessProperty(w,{type:"initialCwd",value:p}))}$acceptProcessRequestCwd(w){this.g.get(w)?.getCwd().then(p=>this.a.$sendProcessProperty(w,{type:"cwd",value:p}))}$acceptProcessRequestLatency(w){return Promise.resolve(w)}registerLinkProvider(w){return this.z.add(w),this.z.size===1&&this.a.$startLinkProvider(),new $.$GK(()=>{this.z.delete(w),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(w,p,E){if(this.C.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this.C.set(p,E),this.a.$registerProfileProvider(p,w.identifier.value),new $.$GK(()=>{this.C.delete(p),this.a.$unregisterProfileProvider(p)})}registerTerminalQuickFixProvider(w,p,E){if(this.D.has(w))throw new Error(`Terminal quick fix provider "${w}" is already registered`);return this.D.set(w,E),this.a.$registerQuickFixProvider(w,p),new $.$GK(()=>{this.D.delete(w),this.a.$unregisterQuickFixProvider(w)})}async $provideTerminalQuickFixes(w,p){const E=new m.$2d().token;if(E.isCancellationRequested)return;const P=this.D.get(w);if(!P)return;const z=await P.provideTerminalQuickFixes(p,E);if(z===null||Array.isArray(z)&&z.length===0)return;const j=new b.$Qc;if(this.w.value=j,!Array.isArray(z))return z?s.TerminalQuickFix.from(z,this.Q.converter,j):void 0;const F=[];for(const O of z){const T=s.TerminalQuickFix.from(O,this.Q.converter,j);T&&F.push(T)}return F}async $createContributedProfileTerminal(w,p){const E=new m.$2d().token;let P=await this.C.get(w)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${w}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,p);return}this.createTerminalFromOptions(P.options,p)}}async $provideLinks(w,p){const E=this.W(w);if(!E)return[];this.F.delete(w),this.G.get(w)?.dispose(!0);const z=new m.$2d;this.G.set(w,z);const j=[],F={terminal:E.value,line:p},O=[];for(const W of this.z)O.push(d.Promises.withAsyncBody(async Y=>{z.token.onCancellationRequested(()=>Y({provider:W,links:[]}));const ue=await W.provideTerminalLinks(F,z.token)||[];z.token.isCancellationRequested||Y({provider:W,links:ue})}));const T=await Promise.all(O);if(z.token.isCancellationRequested)return[];const M=new Map;for(const W of T)W&&W.links.length>0&&j.push(...W.links.map(Y=>{const ue={id:a++,startIndex:Y.startIndex,length:Y.length,label:Y.tooltip};return M.set(ue.id,{provider:W.provider,link:Y}),ue}));return this.F.set(w,M),j}$activateLink(w,p){const E=this.F.get(w)?.get(p);E&&E.provider.handleTerminalLink(E.link)}U(w,p){this.y.stopBuffering(w),this.g.delete(w),delete this.j[w];const E=this.h[w];E&&(E.dispose(),delete this.h[w]),this.a.$sendProcessExit(w,p)}W(w){return this.X(this.f,w)}X(w,p){const E=this.Y(w,p);return E!==null?w[E]:null}Y(w,p){const E=w.findIndex(P=>P._id===p);return E===-1?null:E}getEnvironmentVariableCollection(w){let p=this.n.get(w.identifier.value);return p||(p=new r,this.$(w.identifier.value,p)),p.getScopedEnvironmentVariableCollection(void 0)}Z(w,p){const E=(0,C.$ur)(p.map),P=(0,C.$vr)(p.descriptionMap);this.a.$setEnvironmentVariableCollection(w,p.persistent,E.length===0?void 0:E,P)}$initEnvironmentVariableCollections(w){w.forEach(p=>{const E=p[0],P=new r(p[1]);this.$(E,P)})}$acceptDefaultProfile(w,p){const E=this.s;this.s=w,this.u=p,E?.path!==w.path&&this.N.fire(w.path)}$(w,p){this.n.set(w,p),p.onDidChangeCollection(()=>{this.Z(w,p)})}};e.$lfc=t,e.$lfc=t=Ke([We(1,i.$4M),We(2,L.$HM)],t);class r{get persistent(){return this.b}set persistent(w){this.b=w,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(w){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new D.$Rd,this.map=new Map(w)}getScopedEnvironmentVariableCollection(w){const p=this.h(w);let E=this.a.get(p);return E||(E=new h(this,w),this.a.set(p,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(w,p,E,P){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:P})}append(w,p,E,P){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:P})}prepend(w,p,E,P){this.f(w,{value:p,type:$.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:P})}f(w,p){if(p.options&&p.options.applyAtProcessCreation===!1&&!p.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(w,p.scope),P=this.map.get(E),z=p.options?{applyAtProcessCreation:p.options.applyAtProcessCreation??!1,applyAtShellIntegration:p.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==p.value||P.type!==p.type||P.options?.applyAtProcessCreation!==z.applyAtProcessCreation||P.options?.applyAtShellIntegration!==z.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==p.scope?.workspaceFolder?.index){const j=this.g(w,p.scope),F={variable:w,...p,options:z};this.map.set(j,F),this.d.fire()}}get(w,p){const E=this.g(w,p),P=this.map.get(E);return P?k(P):void 0}g(w,p){const E=this.h(p);return E.length?`${w}:::${E}`:w}h(w){return this.j(w?.workspaceFolder)??""}j(w){return w?w.uri.toString():void 0}getVariableMap(w){const p=new Map;for(const[E,P]of this.map)this.h(P.scope)===this.h(w)&&p.set(P.variable,k(P));return p}delete(w,p){const E=this.g(w,p);this.map.delete(E),this.d.fire()}clear(w){if(w?.workspaceFolder){for(const[p,E]of this.map)E.scope?.workspaceFolder?.index===w.workspaceFolder.index&&this.map.delete(p);this.k(w)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(w,p){const E=this.h(p),P=this.descriptionMap.get(E);if(!P||P.description!==w){let z;typeof w=="string"?z=w:z=w?.value.split(`

`)[0];const j={description:z,scope:p};this.descriptionMap.set(E,j),this.d.fire()}}getDescription(w){const p=this.h(w);return this.descriptionMap.get(p)?.description}k(w){const p=this.h(w);this.descriptionMap.delete(p)}}class h{get persistent(){return this.b.persistent}set persistent(w){this.b.persistent=w}get onDidChangeCollection(){return this.a&&this.a.event}constructor(w,p){this.b=w,this.d=p,this.a=new D.$Rd}getScoped(w){return this.b.getScopedEnvironmentVariableCollection(w)}replace(w,p,E){this.b.replace(w,p,E,this.d)}append(w,p,E){this.b.append(w,p,E,this.d)}prepend(w,p,E){this.b.prepend(w,p,E,this.d)}get(w){return this.b.get(w,this.d)}forEach(w,p){this.b.getVariableMap(this.d).forEach((E,P)=>w.call(p,P,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(w){this.b.delete(w,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(w){this.b.setDescription(w,this.d)}get description(){return this.b.getDescription(this.d)}}let u=class extends t{constructor(w,p){super(!1,w,p)}createTerminal(w,p,E){throw new A.$$}createTerminalFromOptions(w,p){throw new A.$$}};e.$mfc=u,e.$mfc=u=Ke([We(0,i.$4M),We(1,L.$HM)],u);function c(R){if(!(!R||typeof R=="string"))return"id"in R?{id:R.id,color:R.color}:R}function l(R){return f.ThemeColor.isThemeColor(R)?R:void 0}function k(R){const w={...R};return delete w.scope,w.options=w.options??void 0,delete w.variable,w}}),define(Ee[338],Se([1,0,12,22,21,4,74,53,3,24,18,30,6,20,147,15,7,67,112,89,25]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=e.$qgc=e.$pgc=void 0;let a=class extends $.$Rc{constructor(j,F,O){super(),this.u=O,this.f=this.B(new I.$Rd),this.g=new Map,this.s=this.B(new I.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=j.getProxy(m.$EK.MainThreadTesting),this.m=new p(this.h),this.j=new u(this.h),F.registerArgumentProcessor({processArgument:T=>{switch(T?.$mid){case 16:{const M=T,W=M.tests[M.tests.length-1].item.extId;return this.g.get(s.$wJ.root(W))?.collection.tree.get(W)?.actual??(0,S.$TM)(T)}case 18:{const{extId:M,message:W}=T;return{test:this.g.get(s.$wJ.root(M))?.collection.tree.get(M)?.actual,message:f.TestMessage.to(W)}}default:return T}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const T=await F.executeCommand("_testing.getExplorerSelection"),M=W=>{const Y=this.g.get(s.$wJ.root(W));if(Y)return s.$wJ.isRoot(W)?Y.controller:Y.collection.tree.get(W)?.actual};return{include:T?.include.map(M).filter(A.$Kf)||[],exclude:T?.exclude.map(M).filter(A.$Kf)||[]}})}createTestController(j,F,O,T){if(this.g.has(F))throw new Error(`Attempt to insert a duplicate controller with ID "${F}"`);const M=new $.$Qc,W=M.add(new S.$WM(F,O,this.u));W.root.label=O;const Y=new Map,ue=new Set,Z=this.h,Q={items:W.root.children,get label(){return O},set label(oe){O=oe,W.root.label=oe,Z.$updateController(F,{label:O})},get refreshHandler(){return T},set refreshHandler(oe){T=oe,Z.$updateController(F,{canRefresh:!!oe})},get id(){return F},createRunProfile:(oe,X,ve,ge,V,U)=>{let ne=(0,b.$Ni)(oe);for(;Y.has(ne);)ne++;return new E(this.h,Y,j,ue,this.s.event,F,ne,oe,X,ve,ge,V,U)},createTestItem(oe,X,ve){return new S.$UM(F,oe,X,ve)},createTestRun:(oe,X,ve=!0)=>this.j.createTestRun(j,F,W,oe,X,ve),invalidateTestResults:oe=>{if(oe===void 0)this.h.$markTestRetired(void 0);else{const X=oe instanceof Array?oe:[oe];this.h.$markTestRetired(X.map(ve=>s.$wJ.fromExtHostTestItem(ve,F).toString()))}},set resolveHandler(oe){W.resolveHandler=oe},get resolveHandler(){return W.resolveHandler},dispose:()=>{M.dispose()}};Z.$registerTestController(F,O,!!T),M.add((0,$.$Pc)(()=>Z.$unregisterTestController(F)));const x={controller:Q,collection:W,profiles:Y,extension:j,activeProfiles:ue};return this.g.set(F,x),M.add((0,$.$Pc)(()=>this.g.delete(F))),M.add(W.onDidGenerateDiff(oe=>Z.$publishDiff(F,oe.map(n.TestsDiffOp.serialize)))),Q}createTestObserver(){return this.m.checkout()}async runTests(j,F=g.CancellationToken.None){const O=c(j);if(!O)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const T=this.g.get(O.controllerId);if(!T)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:j.include?.map(M=>s.$wJ.fromExtHostTestItem(M,T.collection.root.id).toString())??[T.collection.root.id],profileGroup:P[O.kind],profileId:O.profileId,controllerId:O.controllerId}],exclude:j.exclude?.map(M=>M.id)},F)}$syncTests(){for(const{collection:j}of this.g.values())j.flushDiff();return Promise.resolve()}async $provideFileCoverage(j,F,O){return await this.j.getCoverageReport(j,F)?.provideFileCoverage(O)??[]}async $resolveFileCoverage(j,F,O,T){return await this.j.getCoverageReport(j,F)?.resolveFileCoverage(O,T)??[]}$configureRunProfile(j,F){this.g.get(j)?.profiles.get(F)?.configureHandler?.()}$setActiveRunProfiles(j){const F=new Map;for(const[O,T]of Object.entries(j)){const M=this.g.get(O);if(!M)continue;const W=new Map,Y=T.filter(Z=>!M.activeProfiles.has(Z)),ue=[...M.activeProfiles].filter(Z=>!T.includes(Z));for(const Z of Y)W.set(Z,!0),M.activeProfiles.add(Z);for(const Z of ue)W.set(Z,!1),M.activeProfiles.delete(Z);W.size&&F.set(O,W)}this.s.fire(F)}async $refreshTests(j,F){await this.g.get(j)?.controller.refreshHandler?.(F)}$publishTestResults(j){this.results=Object.freeze(j.map(F=>(0,y.$fn)(f.TestResults.to(F))).concat(this.results).sort((F,O)=>O.completedAt-F.completedAt).slice(0,32)),this.f.fire()}async $expandTest(j,F){const O=this.g.get(s.$wJ.fromString(j).controllerId)?.collection;O&&(await O.expand(j,F<0?1/0:F),O.flushDiff())}$acceptDiff(j){this.m.applyDiff(j.map(n.TestsDiffOp.deserialize))}async $runControllerTests(j,F){return Promise.all(j.map(O=>this.w(O,!1,F)))}async $startContinuousRun(j,F){const O=new g.$2d(F),T=await Promise.all(j.map(M=>this.w(M,!0,O.token)));return!F.isCancellationRequested&&!T.some(M=>M.error)&&await new Promise(M=>F.onCancellationRequested(M)),O.dispose(!0),T}async w(j,F,O){const T=this.g.get(j.controllerId);if(!T)return{};const{collection:M,profiles:W,extension:Y}=T,ue=W.get(j.profileId);if(!ue)return{};const Z=j.testIds.map(X=>M.tree.get(X)).filter(A.$Kf),Q=j.excludeExtIds.map(X=>T.collection.tree.get(X)).filter(A.$Kf).filter(X=>Z.some(ve=>ve.fullId.compare(X.fullId)===2));if(!Z.length)return{};const x=new d.$dM(Z.some(X=>X.actual instanceof S.$VM)?void 0:Z.map(X=>X.actual),Q.map(X=>X.actual),ue,F),oe=(0,n.$yJ)(j)&&this.j.prepareForMainThreadTestRun(x,l.fromInternal(j,T.collection),Y,O);try{return await ue.runHandler(x,O),{}}catch(X){return{error:String(X)}}finally{oe&&(oe.hasRunningTasks&&!O.isCancellationRequested&&await I.Event.toPromise(oe.onEnd),oe.dispose())}}$cancelExtensionTestRun(j){j===void 0?this.j.cancelAllRuns():this.j.cancelRunById(j)}};e.$pgc=a,e.$pgc=a=Ke([We(0,v.$HM)],a);const t=1e4;var r;(function(z){z[z.Running=0]="Running",z[z.Cancelling=1]="Cancelling",z[z.Ended=2]="Ended"})(r||(r={}));class h extends $.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(j,F,O,T){super(),this.s=j,this.u=F,this.w=O,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new I.$Rd),this.m=this.B(new I.$Rd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new g.$2d(T));const M=this.B(new D.$_g(()=>this.y(),t));this.B(this.h.token.onCancellationRequested(()=>M.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(j){const F=this.s.id,O=this.s.controllerId,T=(0,C.$kg)(),M=this.w,W=this.m;let Y;const ue=oe=>(X,...ve)=>{if(Q){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}this.s.isIncluded(X)&&(this.C(X),oe(X,...ve))},Z=(oe,X)=>{const ve=X instanceof Array?X.map(f.TestMessage.from):[f.TestMessage.from(X)];if(oe.uri&&oe.range){const ge={range:f.Range.from(oe.range),uri:oe.uri};for(const V of ve)V.location=V.location||ge}this.u.$appendTestMessagesInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),ve)};let Q=!1;const x={isPersisted:this.s.isPersisted,token:this.h.token,name:j,get coverageProvider(){return Y?.provider},set coverageProvider(oe){(0,o.$RF)(M,"testCoverage"),Y=oe&&new k(oe),W.fire({taskId:T,runId:F,coverage:Y})},enqueued:ue(oe=>{this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),1)}),skipped:ue(oe=>{this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),5)}),started:ue(oe=>{this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),2)}),errored:ue((oe,X,ve)=>{Z(oe,X),this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),6,ve)}),failed:ue((oe,X,ve)=>{Z(oe,X),this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,O).toString(),4,ve)}),passed:ue((oe,X)=>{this.u.$updateTestStateInRun(F,T,s.$wJ.fromExtHostTestItem(oe,this.s.controllerId).toString(),3,X)}),appendOutput:(oe,X,ve)=>{Q||(ve&&(this.s.isIncluded(ve)?this.C(ve):ve=void 0),this.u.$appendOutputToRun(F,T,N.$fe.fromString(oe),X&&f.location.from(X),ve&&s.$wJ.fromExtHostTestItem(ve,O).toString()))},end:()=>{Q||(Q=!0,this.u.$finishedTestRunTask(F,T),this.f.delete(T),this.f.size||this.z())}};return this.f.set(T,{run:x}),this.u.$startedTestRunTask(F,{id:T,name:j,running:!0}),x}y(){for(const{run:j}of this.f.values())j.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(j){if(!(j instanceof S.$UM))throw new i.$zM(j.id);if(this.g.has(s.$wJ.fromExtHostTestItem(j,this.s.controllerId).toString()))return;const F=[],O=this.s.colllection.root;for(;;){const T=f.TestItem.from(j);if(F.unshift(T),this.g.has(T.extId)||(this.g.add(T.extId),j===O))break;j=j.parent||O}this.u.$addTestsToRun(this.s.controllerId,this.s.id,F)}dispose(){this.z(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(j){this.f=j,this.c=new Map,this.d=[]}getCoverageReport(j,F){return this.d.find(O=>O.runId===j)?.coverage.get(F)}prepareForMainThreadTestRun(j,F,O,T){return this.g(j,F,O,T)}cancelRunById(j){for(const F of this.c.values())if(F.id===j){F.cancel();return}}cancelAllRuns(){for(const j of this.c.values())j.cancel()}createTestRun(j,F,O,T,M,W){const Y=this.c.get(T);if(Y)return Y.createRun(M);const ue=l.fromPublic(F,O,T,W),Z=c(T);this.f.$startedExtensionTestRun({controllerId:F,continuous:!!T.continuous,profile:Z&&{group:P[Z.kind],id:Z.profileId},exclude:T.exclude?.map(x=>s.$wJ.fromExtHostTestItem(x,O.root.id).toString())??[],id:ue.id,include:T.include?.map(x=>s.$wJ.fromExtHostTestItem(x,O.root.id).toString())??[O.root.id],persist:W});const Q=this.g(T,ue,j);return I.Event.once(Q.onEnd)(()=>{this.f.$finishedExtensionTestRun(ue.id),Q.dispose()}),Q.createRun(M)}g(j,F,O,T){const M=new h(F,this.f,O,T);this.c.set(j,M);let W;const Y=M.onDidCoverage(({runId:ue,taskId:Z,coverage:Q})=>{W||(W={runId:ue,coverage:new Map},this.d.unshift(W),this.d.length>n.$DJ&&this.d.pop()),W.coverage.set(Z,Q),this.f.$signalCoverageAvailable(ue,Z,!!Q)});return I.Event.once(M.onEnd)(()=>{this.c.delete(j),Y.dispose()}),M}}e.$qgc=u;const c=z=>{if(z.profile){if(!(z.profile instanceof E))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return z.profile}};class l{static fromPublic(j,F,O,T){return new l(j,(0,C.$kg)(),O.include?.map(M=>s.$wJ.fromExtHostTestItem(M,j).toString())??[j],O.exclude?.map(M=>s.$wJ.fromExtHostTestItem(M,j).toString())??[],T,F)}static fromInternal(j,F){return new l(j.controllerId,j.runId,j.testIds,j.excludeExtIds,!0,F)}constructor(j,F,O,T,M,W){this.controllerId=j,this.id=F,this.isPersisted=M,this.colllection=W,this.c=O.map(Y=>Y+"\0"),this.d=T.map(Y=>Y+"\0")}isIncluded(j){const F=s.$wJ.fromExtHostTestItem(j,this.controllerId).toString()+"\0";for(const O of this.d)if(F===O||F.startsWith(O))return!1;for(const O of this.c)if(F===O||F.startsWith(O))return!0;return!1}}e.$rgc=l;class k{constructor(j){this.provider=j}async provideFileCoverage(j){this.c||(this.c=(async()=>this.provider.provideFileCoverage(j))());try{return(await this.c)?.map(f.TestCoverage.fromFile)??[]}catch(F){throw this.c=void 0,F}}async resolveFileCoverage(j,F){const O=await this.c;let T=O?.[j];return!this.provider||!O||!T?[]:(T.detailedCoverage||(T=O[j]=await this.provider.resolveFileCoverage?.(T,F)??T),T.detailedCoverage?.map(f.TestCoverage.fromDetailed)??[])}}class R{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(j){this.h=j,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(j){this.c.add(j)}update(j){Object.assign(j.revived,f.TestItem.toPlain(j.item)),this.c.has(j)||this.d.add(j)}remove(j){if(this.c.has(j)){this.c.delete(j);return}this.d.delete(j);const F=s.$wJ.parentId(j.item.extId);if(F&&this.g.has(F.toString())){this.g.add(j.item.extId);return}this.f.add(j)}getChangeEvent(){const{c:j,d:F,f:O}=this;return{get added(){return[...j].map(T=>T.revived)},get updated(){return[...F].map(T=>T.revived)},get removed(){return[...O].map(T=>T.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class w extends n.$EJ{constructor(){super(...arguments),this.q=new I.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(j){return this.d.get(j)}getMirroredTestDataByReference(j){return this.d.get(j.id)}p(j,F){return{...j,revived:f.TestItem.toPlain(j.item),depth:F?F.depth+1:0,children:new Set}}o(){return new R(this.q)}}class p{constructor(j){this.d=j}checkout(){this.c||(this.c=this.f());const j=this.c;return j.observers++,{onDidChangeTest:j.tests.onDidChangeTests,get tests(){return[...j.tests.rootTests].map(F=>F.revived)},dispose:(0,L.$cb)(()=>{--j.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(j){return this.c?.tests.getMirroredTestDataByReference(j)}applyDiff(j){this.c?.tests.apply(j)}f(){const j=new w;return this.d.$subscribeToDiffs(),{observers:0,tests:j}}}class E{#e;#t;#i;#o;#r;get label(){return this.d}set label(j){j!==this.d&&(this.d=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:j}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(j){j!==this.g&&(this.g=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:j}))}get isDefault(){return this.f}set isDefault(j){j!==this.f&&(this.f=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:j}))}get tag(){return this._tag}set tag(j){j?.id!==this._tag?.id&&(this._tag=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:j?f.TestTag.namespace(this.controllerId,j.id):null}))}get configureHandler(){return this.c}set configureHandler(j){j!==this.c&&(this.c=j,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!j}))}get isSelected(){return(0,o.$RF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,o.$RF)(this.#t,"testingActiveProfile"),I.Event.chain(this.#o,j=>j.map(F=>F.get(this.controllerId)?.get(this.profileId)).filter(A.$Kf))}constructor(j,F,O,T,M,W,Y,ue,Z,Q,x=!1,oe=void 0,X=!1){this.controllerId=W,this.profileId=Y,this.d=ue,this.kind=Z,this.runHandler=Q,this.f=x,this._tag=oe,this.g=X,this.#e=j,this.#r=F,this.#t=O,this.#i=T,this.#o=M,F.set(Y,this);const ve=P[Z];if(typeof ve!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);this.#e.$publishTestRunProfile({profileId:Y,controllerId:W,tag:oe?f.TestTag.namespace(this.controllerId,oe.id):null,label:ue,group:ve,isDefault:x,hasConfigurationHandler:!1,supportsContinuousRun:X})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$sgc=E;const P={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ee[339],Se([1,0,19,8,4,6,148,15,7]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class y{constructor(C,m){this.i=m,this.a=new g.$Rd({onListenerError:N.$1}),this.b=new g.$Rd({onListenerError:N.$1}),this.c=new g.$Rd({onListenerError:N.$1}),this.d=new g.$Rd({onListenerError:N.$1}),this.f=new g.$Rd({onListenerError:N.$1}),this.g=new g.$Rd({onListenerError:N.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=C.getProxy(I.$EK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(C){const m=this.i.allEditors();return C?m:m.map(v=>v.value)}async showTextDocument(C,m,v){let S;typeof m=="number"?S={position:b.ViewColumn.from(m),preserveFocus:v}:typeof m=="object"?S={position:b.ViewColumn.from(m.viewColumn),preserveFocus:m.preserveFocus,selection:typeof m.selection=="object"?b.Range.from(m.selection):void 0,pinned:typeof m.preview=="boolean"?!m.preview:void 0}:S={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(C.uri,S),d=f&&this.i.getEditor(f);if(d)return d.value;throw f?new Error(`Could NOT open editor for "${C.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${C.uri.toString()}".`)}createTextEditorDecorationType(C,m){return new L.$OM(this.h,C,m).value}$acceptEditorPropertiesChanged(C,m){const v=this.i.getEditor(C);if(!v)throw new Error("unknown text editor");if(m.options&&v._acceptOptions(m.options),m.selections){const S=m.selections.selections.map(b.Selection.to);v._acceptSelections(S)}if(m.visibleRanges){const S=D.$Gb(m.visibleRanges.map(b.Range.to));v._acceptVisibleRanges(S)}if(m.options&&this.b.fire({textEditor:v.value,options:{...m.options,lineNumbers:b.TextEditorLineNumbersStyle.to(m.options.lineNumbers)}}),m.selections){const S=$.TextEditorSelectionChangeKind.fromValue(m.selections.source),f=m.selections.selections.map(b.Selection.to);this.a.fire({textEditor:v.value,selections:f,kind:S})}if(m.visibleRanges){const S=D.$Gb(m.visibleRanges.map(b.Range.to));this.c.fire({textEditor:v.value,visibleRanges:S})}}$acceptEditorPositionData(C){for(const m in C){const v=this.i.getEditor(m);if(!v)throw new Error("Unknown text editor");const S=b.ViewColumn.to(C[m]);v.value.viewColumn!==S&&(v._acceptViewColumn(S),this.d.fire({textEditor:v.value,viewColumn:S}))}}getDiffInformation(C){return Promise.resolve(this.h.$getDiffInformation(C))}}e.$Oec=y}),define(Ee[340],Se([1,0,2,5,6,3,7,15,26,18]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,N.$Zh)("IExtHostTimeline");class A{constructor(v,S){this.b=new Map,this.c=new Map,this.a=v.getProxy(g.$EK.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(f,d)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&$.$dm.equals(d,this.b.get(f.source)?.extension)){const s=f.uri===void 0?void 0:D.URI.revive(f.uri);return this.c.get(f.source)?.get(C(s))?.get(f.handle)}else return;return f}})}async $getTimeline(v,S,f,d){return this.b.get(v)?.provider.provideTimeline(D.URI.revive(S),f,d)}registerTimelineProvider(v,S,f,d){const s=new I.$Qc,i=this.d(S.id,d,s).bind(this);let n;S.onDidChange&&(n=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const o=this.c;return this.f({...S,scheme:v,onDidChange:void 0,async provideTimeline(a,t,r){t?.resetCache&&(s.clear(),o.get(S.id)?.clear());const h=await S.provideTimeline(a,t,r);if(h==null)return;const u=i(a,t);return{...h,source:S.id,items:h.items.map(u)}},dispose(){for(const a of o.values())a.get(S.id)?.clear();n?.dispose(),s.dispose()}},f)}d(v,S,f){return(d,s)=>{let i;if(s?.cacheResults){let n=this.c.get(v);n===void 0&&(n=new Map,this.c.set(v,n));const o=C(d);i=n.get(o),i===void 0&&(i=new Map,n.set(o,i))}return n=>{const{iconPath:o,...a}=n,t=`${v}|${n.id??n.timestamp}`;i?.set(t,n);let r,h,u;n.iconPath&&(o instanceof L.$BL?u={id:o.id,color:o.color}:D.URI.isUri(o)?(r=o,h=o):{light:r,dark:h}=o);let c;return L.$8K.isMarkdownString(a.tooltip)?c=b.MarkdownString.from(a.tooltip):(0,y.$Cf)(a.tooltip)?c=a.tooltip:L.$8K.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=b.MarkdownString.from(a.detail)):(0,y.$Cf)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=a.detail),{...a,id:a.id??void 0,handle:t,source:v,command:n.command?S.toInternal(n.command,f):void 0,icon:r,iconDark:h,themeIcon:u,tooltip:c,accessibilityInformation:n.accessibilityInformation}}}}f(v,S){if(this.b.get(v.id))throw new Error(`Timeline Provider ${v.id} already exists.`);return this.a.$registerTimelineProvider({id:v.id,label:v.label,scheme:v.scheme}),this.b.set(v.id,{provider:v,extension:S}),(0,I.$Pc)(()=>{for(const d of this.c.values())d.get(v.id)?.clear();this.b.delete(v.id),this.a.$unregisterTimelineProvider(v.id),v.dispose()})}}e.$vgc=A;function C(m){return m?.toString()}}),define(Ee[72],Se([1,0,21,4,3,220,5,14,88,6,27,20,7]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ixb=e.$Hxb=e.TunnelDtoConverter=void 0;class v extends $.$rv{}var S;(function(d){function s(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:n.protocol}}d.fromApiTunnel=s;function i(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==$.TunnelPrivacyId.ConstantPrivate&&n.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}d.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$Hxb=(0,L.$Zh)("IExtHostTunnelService");let f=class extends g.$Rc{constructor(s,i,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$EK.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const n=await this.a.$openTunnel(i,s.displayName);if(n){const o=new v(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(o),o}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const n=this.u();return this.r.set(n,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,n),new m.$GK(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(s,i,n,o,a){const t=[];for(const h of s){const u=this.r.get(h);if(!u)return[];t.push(...await Promise.all(i.map(async c=>{let l;try{l=await u.provider.providePortAttributes({port:c,pid:n,commandLine:o},a)}catch{l=await u.provider.providePortAttributes(c,n,o,a)}return{providedAttributes:l,port:c}})))}const r=t.filter(h=>!!h.providedAttributes);return r.length>0?r.map(h=>({autoForwardAction:h.providedAttributes.autoForwardAction,port:h.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(o,a)=>await s.provideTunnel(o,a,new D.$2d().token)??void 0;const n=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,g.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const n=s.tunnelFactory??(i?this.w(i):void 0);if(n){this.b=n;let o=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&o.length===0&&(o=[{id:"private",label:I.localize(0,null),themeIcon:"lock"},{id:"public",label:I.localize(1,null),themeIcon:"eye"}]);const a=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:o}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,g.$Pc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const n=this.g.get(s.host);n.has(s.port)&&(i&&n.get(s.port).disposeListener.dispose(),await n.get(s.port).tunnel.dispose(),n.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const o=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),o===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const a=this.B(o.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(o.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:o,disposeListener:a}),S.fromApiTunnel(o)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(o=>this.f(o.host,o.port,o.detail??""))),n=s.filter((o,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(o=>o.port).join(", ")} to ${n.map(o=>o.port).join(", ")}`),n}};e.$Ixb=f,e.$Ixb=f=Ke([We(0,C.$HM),We(1,A.$XM),We(2,b.$hj)],f)}),define(Ee[341],Se([1,0,3,17,2,6]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class L{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(I.$EK.MainThreadUriOpeners)}registerExternalUriOpener($,y,A,C){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const m=C.schemes.find(v=>!L.a.has(v));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this.c.set(y,A),this.b.$registerUriOpener(y,C.schemes,$,C.label),(0,D.$Pc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri($,y,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener with id: ${$}`);const m=g.URI.revive(y);return C.canOpenExternalUri(m,A)}async $openUri($,y,A){const C=this.c.get($);if(!C)throw new Error(`Unknown opener id: '${$}'`);return C.openExternalUri(g.URI.revive(y.resolvedUri),{sourceUri:g.URI.revive(y.sourceUri)},A)}}e.$xgc=L}),define(Ee[342],Se([1,0,6,2,3,8,26]),function($e,e,D,N,g,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class b{static{this.a=0}constructor(y){this.c=new L.$em,this.d=new Map,this.b=y.getProxy(D.$EK.MainThreadUrls)}registerUriHandler(y,A){const C=y.identifier;if(this.c.has(C))throw new Error(`Protocol handler already registered for extension ${C}`);const m=b.a++;return this.c.add(C),this.d.set(m,A),this.b.$registerUriHandler(m,C,y.displayName||y.name),(0,g.$Pc)(()=>{this.c.delete(C),this.d.delete(m),this.b.$unregisterUriHandler(m)})}$handleExternalUri(y,A){const C=this.d.get(y);if(!C)return Promise.resolve(void 0);try{C.handleUri(N.URI.revive(A))}catch(m){(0,I.$Z)(m)}return Promise.resolve(void 0)}async createAppUri(y){return N.URI.revive(await this.b.$createAppUri(y))}}e.$ygc=b}),define(Ee[93],Se([1,0,4,3,17,24,2,237,274,113,6]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=e.$4ec=e.$3ec=void 0;class C{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(o,a,t,r,h,u,c){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new D.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new D.$Rd,this._onDidDispose=this.#h.event,this.#e=o,this.#t=a,this.#s=t,this.#o=r,this.#r=h,this.#n=u,this.#l=m(u),this.#d=v(u),this.#i=c}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(o){return this.#u=!0,(0,y.$Qub)(o,this.#o)}get cspSource(){const o=this.#n.extensionLocation;if(o.scheme===g.Schemas.https||o.scheme===g.Schemas.http){let a=o.toString();return a.endsWith("/")||(a+="/"),a+" "+y.$Pub}return y.$Pub}get html(){return this.a(),this.#a}set html(o){this.a(),this.#a!==o&&(this.#a=o,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(o)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(o)))}get options(){return this.a(),this.#s}set options(o){this.a(),I.$in(this.#s,o)||this.#t.$setOptions(this.#e,d(this.#n,this.#r,o)),this.#s=o}async postMessage(o){if(this.#c)return!1;const a=(0,$.$jfb)(o,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(o){if(!this.#d)return o;const a=this.#n.extensionLocation?.scheme===g.Schemas.vscodeRemote,t=this.#n.extensionLocation.scheme===g.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return o.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,k)=>{const R=L.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),w=(0,y.$Qub)(R,{isRemote:a,authority:t}).toString();return`${h}${w}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,h,u,c,l,k)=>{const R=L.URI.from({scheme:c||"file",path:decodeURIComponent(l)}),w=(0,y.$Qub)(R,{isRemote:a,authority:t}).toString();return`${h}${w}${k}`})}}e.$3ec=C;function m(n){try{const o=(0,b.$Xo)((0,b.$Wo)(n.engines.vscode));return!!o&&o.majorBase>=1&&o.minorBase>=57}catch{return!1}}e.$4ec=m;function v(n){try{const o=(0,b.$Xo)((0,b.$Wo)(n.engines.vscode));return o?o.majorBase<1||o.majorBase===1&&o.minorBase<60:!1}catch{return!1}}class S extends N.$Rc{constructor(o,a,t,r,h){super(),this.c=a,this.f=t,this.g=r,this.h=h,this.b=new Map,this.a=o.getProxy(A.$EK.MainThreadWebviews)}dispose(){super.dispose();for(const o of this.b.values())o.dispose();this.b.clear()}$onMessage(o,a,t){const r=this.j(o);if(r){const{message:h}=(0,$.$kfb)(a,t.value);r._onMessageEmitter.fire(h)}}$onMissingCsp(o,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(o,a,t){const r=new C(o,this.a,s(a),this.c,this.f,t,this.h);this.b.set(o,r);const h=r._onDidDispose(()=>{h.dispose(),this.deleteWebview(o)});return r}deleteWebview(o){this.b.delete(o)}j(o){return this.b.get(o)}}e.$5ec=S;function f(n){return{id:n.identifier,location:n.extensionLocation}}e.$6ec=f;function d(n,o,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(n,o)}}e.$7ec=d;function s(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(o=>L.URI.from(o))}}function i(n,o){return[...(o?.getWorkspaceFolders()||[]).map(a=>a.uri),n.extensionLocation]}}),define(Ee[343],Se([1,0,21,53,3,17,23,2,15,93,110,6,7]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class v{constructor(r,h){this.document=r,this.b=h,this.a=1,this.c=new A.$vec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,h){await this.f(r).undo(),h||this.disposeBackup()}async redo(r,h){await this.f(r).redo(),h||this.disposeBackup()}disposeEdits(r){for(const h of r)this.c.delete(h)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=a(this.document.uri)+this.a++;return(0,L.$Bg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const h=this.c.get(r,0);if(!h)throw new Error("No edit found");return h}}class S{constructor(){this.a=new Map}get(r,h){return this.a.get(this.b(r,h))}add(r,h,u){const c=this.b(r,h.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${r} resource:${h.uri}`);const l=new v(h,u);return this.a.set(c,l),l}delete(r,h){const u=this.b(r,h.uri);this.a.delete(u)}b(r,h){return`${r}@@@${h}`}}var f;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(f||(f={}));class d{constructor(){this.a=new Map}addTextProvider(r,h,u){return this.b(0,r,h,u)}addCustomProvider(r,h,u){return this.b(1,r,h,u)}get(r){return this.a.get(r)}b(r,h,u,c){if(this.a.has(h))throw new Error(`Provider for viewType:${h} already registered`);return this.a.set(h,{type:r,extension:u,provider:c}),new m.$GK(()=>this.a.delete(h))}}class s{constructor(r,h,u,c,l){this.d=h,this.f=u,this.g=c,this.h=l,this.b=new d,this.c=new S,this.a=r.getProxy(C.$EK.MainThreadCustomEditors)}registerCustomEditorProvider(r,h,u,c){const l=new g.$Qc;return n(u)?(l.add(this.b.addTextProvider(h,r,u)),this.a.$registerTextEditorProvider((0,y.$6ec)(r),h,c.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,y.$4ec)(r))):(l.add(this.b.addCustomProvider(h,r,u)),i(u)&&l.add(u.onDidChangeCustomDocument(k=>{const R=this.i(h,k.document.uri);if(o(k)){const w=R.addEdit(k);this.a.$onDidEdit(k.document.uri,h,w,k.label)}else this.a.$onContentChange(k.document.uri,h)})),this.a.$registerCustomEditorProvider((0,y.$6ec)(r),h,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,y.$4ec)(r))),m.$GK.from(l,new m.$GK(()=>{this.a.$unregisterEditorProvider(h)}))}async $createCustomDocument(r,h,u,c,l){const k=this.b.get(h);if(!k)throw new Error(`No provider found for '${h}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${h}'`);const R=b.URI.revive(r),w=await k.provider.openCustomDocument(R,{backupId:u,untitledDocumentData:c?.buffer},l);let p;return i(k.provider)&&this.f&&(p=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(h,w,p),{editable:i(k.provider)}}async $disposeCustomDocument(r,h){const u=this.b.get(h);if(!u)throw new Error(`No provider found for '${h}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${h}'`);const c=b.URI.revive(r),{document:l}=this.i(h,c);this.c.delete(h,l),l.dispose()}async $resolveCustomEditor(r,h,u,c,l,k){const R=this.b.get(u);if(!R)throw new Error(`No provider found for '${u}'`);const w=$.ViewColumn.to(l),p=this.g.createNewWebview(h,c.contentOptions,R.extension),E=this.h.createNewWebviewPanel(h,u,c.title,w,c.options,p,c.active),P=b.URI.revive(r);switch(R.type){case 1:{const{document:z}=this.i(u,P);return R.provider.resolveCustomEditor(z,E,k)}case 0:{const z=this.d.getDocument(P);return R.provider.resolveCustomTextEditor(z,E,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,h,u){this.i(h,r).disposeEdits(u)}async $onMoveCustomEditor(r,h,u){const c=this.b.get(u);if(!c)throw new Error(`No provider found for '${u}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const l=this.h.getWebviewPanel(r);if(!l)throw new Error("No webview found");const k=b.URI.revive(h),R=this.d.getDocument(k);await c.provider.moveCustomTextEditor(R,l,D.CancellationToken.None)}async $undo(r,h,u,c){return this.i(h,r).undo(u,c)}async $redo(r,h,u,c){return this.i(h,r).redo(u,c)}async $revert(r,h,u){const c=this.i(h,r);await this.j(h).revertCustomDocument(c.document,u),c.disposeBackup()}async $onSave(r,h,u){const c=this.i(h,r);await this.j(h).saveCustomDocument(c.document,u),c.disposeBackup()}async $onSaveAs(r,h,u,c){const l=this.i(h,r);return this.j(h).saveCustomDocumentAs(l.document,b.URI.revive(u),c)}async $backup(r,h,u){const c=this.i(h,r),k=await this.j(h).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},u);return c.updateBackup(k),k.id}i(r,h){const u=this.c.get(r,b.URI.revive(h));if(!u)throw new Error("No custom document found");return u}j(r){const u=this.b.get(r)?.provider;if(!u||!i(u))throw new Error("Custom document is not editable");return u}}e.$9ec=s;function i(t){return!!t.onDidChangeCustomDocument}function n(t){return typeof t.resolveCustomTextEditor=="function"}function o(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const r=t.scheme===I.Schemas.file||t.scheme===I.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Ni)(r)+""}}),define(Ee[344],Se([1,0,4,3,2,30,15,93,6,7]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class A extends N.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(S,f,d,s){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new D.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new D.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=f,this.#o=d,this.#i=s.viewType,this.#r=s.panelOptions,this.#s=s.viewColumn,this.#n=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(S){this.c(),this.#n!==S&&(this.#n=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,g.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,f){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:L.ViewColumn.from(S),preserveFocus:!!f})}c(){if(this.#l)throw new Error("Webview is disposed")}}class C extends N.$Rc{static c(){return(0,I.$kg)()}constructor(S,f,d){super(),this.j=f,this.m=d,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$EK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,f,d,s,i={}){const n=typeof s=="object"?s.viewColumn:s,o={viewColumn:L.ViewColumn.from(n),preserveFocus:typeof s=="object"&&!!s.preserveFocus},a=(0,b.$4ec)(S),t=C.c();this.f.$createWebviewPanel((0,b.$6ec)(S),t,f,{title:d,panelOptions:m(i),webviewOptions:(0,b.$7ec)(S,this.m,i),serializeBuffersForPostMessage:a},o);const r=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,f,d,n,i,r,!0)}$onDidChangeWebviewPanelViewStates(S){const f=Object.keys(S);f.sort((d,s)=>{const i=S[d],n=S[s];return i.active?1:n.active?-1:+i.visible-+n.visible});for(const d of f){const s=this.getWebviewPanel(d);if(!s)continue;const i=S[d];s._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,f,d){if(this.h.has(f))throw new Error(`Serializer for '${f}' already registered`);return this.h.set(f,{serializer:d,extension:S}),this.f.$registerSerializer(f,{serializeBuffersForPostMessage:(0,b.$4ec)(S)}),new y.$GK(()=>{this.h.delete(f),this.f.$unregisterSerializer(f)})}async $deserializeWebviewPanel(S,f,d,s){const i=this.h.get(f);if(!i)throw new Error(`No serializer found for '${f}'`);const{serializer:n,extension:o}=i,a=this.j.createNewWebview(S,d.webviewOptions,o),t=this.createNewWebviewPanel(S,f,d.title,s,d.panelOptions,a,d.active);await n.deserializeWebviewPanel(t,d.state)}createNewWebviewPanel(S,f,d,s,i,n,o){const a=new A(S,this.f,n,{viewType:f,title:d,viewColumn:s,panelOptions:i,active:o});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$8ec=C;function m(v){return{enableFindWidget:v.enableFindWidget,retainContextWhenHidden:v.retainContextWhenHidden}}}),define(Ee[345],Se([1,0,4,3,93,15,6,7]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class $ extends N.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(C,m,v,S,f,d){super(),this.#r=!1,this.#u=this.B(new D.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new D.$Rd),this.onDidDispose=this.#l.event,this.#i=v,this.#a=S,this.#e=C,this.#t=m,this.#o=f,this.#n=d}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(C){this.a(),this.#a!==C&&(this.#a=C,this.#t.$setWebviewViewTitle(this.#e,C))}get description(){return this.a(),this.#s}set description(C){this.a(),this.#s!==C&&(this.#s=C,this.#t.$setWebviewViewDescription(this.#e,C))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(C){C===this.#n||this.#r||(this.#n=C,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(C){this.a(),!(C?.value===this.#c?.value&&C?.tooltip===this.#c?.tooltip)&&(this.#c=I.ViewBadge.from(C),this.#t.$setWebviewViewBadge(this.#e,C))}show(C){this.a(),this.#t.$show(this.#e,!!C)}a(){if(this.#r)throw new Error("Webview is disposed")}}class y{constructor(C,m){this.d=m,this.b=new Map,this.c=new Map,this.a=C.getProxy(L.$EK.MainThreadWebviewViews)}registerWebviewViewProvider(C,m,v,S){if(this.b.has(m))throw new Error(`View provider for '${m}' already registered`);return this.b.set(m,{provider:v,extension:C}),this.a.$registerWebviewViewProvider((0,g.$6ec)(C),m,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,g.$4ec)(C)}),new b.$GK(()=>{this.b.delete(m),this.a.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(C,m,v,S,f){const d=this.b.get(m);if(!d)throw new Error(`No view provider found for '${m}'`);const{provider:s,extension:i}=d,n=this.d.createNewWebview(C,{},i),o=new $(C,this.a,m,v,n,!0);this.c.set(C,o),await s.resolveWebviewView(o,{state:S},f)}async $onDidChangeWebviewViewVisibility(C,m){this.e(C)._setVisible(m)}async $disposeWebviewView(C){const m=this.e(C);this.c.delete(C),m.dispose(),this.d.deleteWebview(C)}e(C){const m=this.c.get(C);if(!m)throw new Error("No webview found");return m}}e.$zgc=y}),define(Ee[151],Se([1,0,4,6,2,17,13,5,20,25]),function($e,e,D,N,g,I,L,b,$,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=void 0;let C=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(v){const S=this.d;return{get focused(){return S.focused},get active(){return(0,y.$RF)(v,"windowActivity"),S.active}}}constructor(v){this.c=new D.$Rd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=v.getProxy(N.$EK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:f})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(v){this.onDidChangeWindowProperty("focused",v)}$onDidChangeWindowActive(v){this.onDidChangeWindowProperty("active",v)}onDidChangeWindowProperty(v,S){S!==this.d[v]&&(this.d={...this.d,[v]:S},this.c.fire(this.d))}openUri(v,S){let f;if(typeof v=="string"){f=v;try{v=g.URI.parse(v)}catch{return Promise.reject(`Invalid uri - '${v}'`)}}return(0,L.$Fe)(v.scheme)?Promise.reject("Invalid scheme - cannot be empty"):v.scheme===I.Schemas.command?Promise.reject(`Invalid scheme '${v.scheme}'`):this.b.$openUri(v,f,S)}async asExternalUri(v,S){if((0,L.$Fe)(v.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(v,S);return g.URI.from(f)}};e.$Agc=C,e.$Agc=C=A=Ke([We(0,$.$HM)],C),e.$Bgc=(0,b.$Zh)("IExtHostWindow")}),define(Ee[346],Se([1,0,314,27,20]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=void 0;const I=1024*1024;let L=class extends D.$Egc{constructor($,y){super($,y),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,y,A){const C=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,C.write(`
START_NATIVE_LOG
`),y.apply(console,A),C.write(`
END_NATIVE_LOG
`),this.g=!1}j($,y){const A=process[$],C=A.write;let m="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(v,S,f)=>{if(!this.g){m+=v.toString(S);const d=m.length>I?m.length:m.lastIndexOf(`
`);d!==-1&&(console[y](m.slice(0,d)),m=m.slice(d+1))}C.call(A,v,S,f)}})}};e.$dhc=L,e.$dhc=L=Ke([We(0,g.$HM),We(1,N.$XM)],L)}),define(Ee[347],Se([1,0,71,17,14,249,32,11]),function($e,e,D,N,g,I,L,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;let $=class{constructor(C,m){C.addFileSystemProvider(N.Schemas.file,new y(m),{isCaseSensitive:b.$k})}};e.$ehc=$,e.$ehc=$=Ke([We(0,D.$Zec),We(1,g.$hj)],$);class y{constructor(C){this.b=C,this.a=new I.$kq(this.b)}async stat(C){const m=await this.a.stat(C);return{type:m.type,ctime:m.ctime,mtime:m.mtime,size:m.size,permissions:m.permissions===L.FilePermission.Readonly?1:void 0}}readDirectory(C){return this.a.readdir(C)}createDirectory(C){return this.a.mkdir(C)}readFile(C){return this.a.readFile(C)}writeFile(C,m,v){return this.a.writeFile(C,m,{...v,unlock:!1,atomic:!1})}delete(C,m){return this.a.delete(C,{...m,useTrash:!1,atomic:!1})}rename(C,m,v){return this.a.rename(C,m,v)}copy(C,m,v){return this.a.copy(C,m,v)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(C,m){throw new Error("Method not implemented.")}}}),define(Ee[348],Se([1,0,16,63,30,35,3,6,2,20]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$chc=void 0;let A=class extends L.$Rc{constructor(m,v){super();const S=m.getProxy(b.$EK.MainThreadDownloadService);v.registerCommand(!1,"_workbench.downloadResource",async f=>{const d=$.URI.file((0,D.$ic)((0,N.tmpdir)(),(0,g.$kg)()));return await S.$download(f,d),d})}};e.$chc=A,e.$chc=A=Ke([We(0,y.$HM),We(1,I.$4M)],A)}),define(Ee[349],Se([1,0,150,17,251,30]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=void 0;class L extends D.$Dgc{s($,y,A){return $.scheme===N.Schemas.file?new g.$TN(A?.name||(0,I.$kg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,y):super.s($,y,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$phc=L}),define(Ee[350],Se([1,0,55,16,2,92,3,17,12,31]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ohc=void 0;class A extends I.$2ec{constructor(){super(...arguments),this.i=null}async g(t){const r=await super.g(t);if(r.scheme!==b.Schemas.file)return r;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${r.fsPath}.`),r;const h=r.fsPath;let u=0;do{let c;u===0?c=h:c=/[/\\]$/.test(h)?`${h.substr(0,h.length-1)}-${u}`:`${h}-${u}`,await C(c);const l=N.$ic(c,"vscode.lock"),k=await f(this.d,l,!1);if(k)return this.i=k,process.on("exit",()=>{k.dispose()}),g.URI.file(c);u++}while(u<10);return r}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$ohc=A;async function C(a){try{await y.Promises.stat(a);return}catch{}try{await y.Promises.mkdir(a,{recursive:!0})}catch{}}const m=1e3,v=10*60*1e3;class S extends L.$Rc{constructor(t,r){super(),this.b=t,this.c=r,this.a=this.B(new $.$$g),this.a.cancelAndSet(async()=>{const h=await d(t,r);(!h||h.pid!==process.pid)&&(t.info(`Lock '${r}': The lock was lost unexpectedly.`),this.a.cancel());try{await y.Promises.utimes(r,new Date,new Date)}catch(u){t.error(u),t.info(`Lock '${r}': Could not update mtime.`)}},m)}dispose(){super.dispose();try{D.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const r={pid:process.pid,willReleaseAt:Date.now()+t};await y.Promises.writeFile(this.c,JSON.stringify(r),{flag:"w"})}catch(r){this.b.error(r)}}}async function f(a,t,r){try{const u={pid:process.pid,willReleaseAt:0};await y.Promises.writeFile(t,JSON.stringify(u),{flag:"wx"})}catch(u){a.error(u)}const h=await d(a,t);return!h||h.pid!==process.pid?r?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),n(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function d(a,t){let r;try{r=await y.Promises.readFile(t)}catch(h){return a.error(h),null}try{return JSON.parse(String(r))}catch(h){return a.error(h),null}}async function s(a,t){let r;try{r=await y.Promises.stat(t)}catch(h){return a.error(h),0}return r.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function n(a,t){const r=await d(a,t);if(!r)return a.info(`Lock '${t}': Could not read pid of lock holder.`),o(a,t);if(r.willReleaseAt){let k=r.willReleaseAt-Date.now();if(k<5e3){for(k>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${k} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);k>0;){if(await(0,$.$1g)(Math.min(100,k)),await s(a,t)===0)return o(a,t);k=r.willReleaseAt-Date.now()}return o(a,t)}}if(!i(r.pid))return a.info(`Lock '${t}': The pid ${r.pid} appears to be gone.`),o(a,t);const h=await s(a,t),u=Date.now()-h;if(u<=v)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${u} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$1g)(2e3);const c=await s(a,t),l=Date.now()-c;return l<=v?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),o(a,t))}async function o(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await y.Promises.unlink(t)}catch{}return f(a,t,!0)}}),define(Ee[351],Se([1,0,30,20,47,35]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=void 0;let L=class extends g.$lfc{constructor($,y){super(!0,$,y)}createTerminal($,y,A){return this.createTerminalFromOptions({name:$,shellPath:y,shellArgs:A})}createTerminalFromOptions($,y){const A=new g.$kfc(this.a,(0,D.$kg)(),$,$.name);return this.f.push(A),A.create($,this.R($,y)),A.value}};e.$Jgc=L,e.$Jgc=L=Ke([We(0,I.$4M),We(1,N.$HM)],L)}),define(Ee[352],Se([1,0,12,22,21,8,4,3,130,303,68]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.ResponsiveState=e.RequestInitiator=e.$P6b=e.$O6b=void 0;function m(E,P){try{return JSON.stringify(E,P)}catch{return"null"}}const v="$$ref$$",S={[v]:-1};class f{constructor(P,z){this.jsonString=P,this.referencedBuffers=z}}function d(E,P=null,z=!1){const j=[];return{jsonString:(z?m:JSON.stringify)(E,(O,T)=>{if(typeof T>"u")return S;if(typeof T=="object"){if(T instanceof N.$fe){const M=j.push(T)-1;return{[v]:M}}if(P)return P(O,T)}return T}),referencedBuffers:j}}e.$O6b=d;function s(E,P,z){return JSON.parse(E,(j,F)=>{if(F){const O=F[v];if(typeof O=="number")return P[O];if(z&&F.$mid===1)return z.transformIncoming(F)}return F})}e.$P6b=s;function i(E,P){return JSON.stringify(E,P)}function n(E){return E?(P,z)=>z&&z.$mid===1?E.transformOutgoing(z):z:null}var o;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(o||(e.RequestInitiator=o={}));var a;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},r=Symbol.for("rpcProtocol"),h=Symbol.for("rpcProxy");class u extends b.$Rc{static{C=r}static{this.a=3*1e3}constructor(P,z=null,j=null){super(),this[C]=!0,this.b=this.B(new L.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=z,this.g=j,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let F=0,O=A.$yv.count;F<O;F++)this.m[F]=null,this.s[F]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new D.$_g(()=>this.H(),1e3)),this.c.onMessage(F=>this.L(F))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const z=this.w[P];delete this.w[P],z.resolveErr(I.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+u.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+u.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,$.$Ym)(P,this.g):P}getProxy(P){const{nid:z,sid:j}=P;return this.s[z]||(this.s[z]=this.J(z,j)),this.s[z]}J(P,z){const j={get:(F,O)=>(typeof O=="string"&&!F[O]&&O.charCodeAt(0)===36&&(F[O]=(...T)=>this.U(P,O,T)),O===h?z:F[O])};return new Proxy(Object.create(null),j)}set(P,z){return this.m[P.nid]=z,z}assertRegistered(P){for(let z=0,j=P.length;z<j;z++){const F=P[z];if(!this.m[F.nid])throw new Error(`Missing proxy instance ${F.sid}`)}}L(P){if(this.j)return;const z=P.byteLength,j=l.read(P,0),F=j.readUInt8(),O=j.readUInt32();switch(F){case 1:case 2:{let{rpcId:T,method:M,args:W}=R.deserializeRequestJSONArgs(j);this.g&&(W=(0,$.$Ym)(W,this.g)),this.M(z,O,T,M,W,F===2);break}case 3:case 4:{let{rpcId:T,method:M,args:W}=R.deserializeRequestMixedArgs(j);this.g&&(W=(0,$.$Ym)(W,this.g)),this.M(z,O,T,M,W,F===4);break}case 5:{this.f?.logIncoming(z,O,0,"ack"),this.G(O);break}case 6:{this.N(z,O);break}case 7:{this.O(z,O,void 0);break}case 9:{let T=R.deserializeReplyOKJSON(j);this.g&&(T=(0,$.$Ym)(T,this.g)),this.O(z,O,T);break}case 10:{const T=R.deserializeReplyOKJSONWithBuffers(j,this.g);this.O(z,O,T);break}case 8:{const T=R.deserializeReplyOKVSBuffer(j);this.O(z,O,T);break}case 11:{let T=R.deserializeReplyErrError(j);this.g&&(T=(0,$.$Ym)(T,this.g)),this.P(z,O,T);break}case 12:{this.P(z,O,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,z,j,F,O,T){this.f?.logIncoming(P,z,1,`receiveRequest ${(0,A.$Av)(j)}.${F}(`,O);const M=String(z);let W,Y;if(T){const Z=new g.$2d;O.push(Z.token),W=this.Q(j,F,O),Y=()=>Z.cancel()}else W=this.Q(j,F,O),Y=t;this.u[M]=Y;const ue=R.serializeAcknowledged(z);this.f?.logOutgoing(ue.byteLength,z,1,"ack"),this.c.send(ue),W.then(Z=>{delete this.u[M];const Q=R.serializeReplyOK(z,Z,this.h);this.f?.logOutgoing(Q.byteLength,z,1,"reply:",Z),this.c.send(Q)},Z=>{delete this.u[M];const Q=R.serializeReplyErr(z,Z);this.f?.logOutgoing(Q.byteLength,z,1,"replyErr:",Z),this.c.send(Q)})}N(P,z){this.f?.logIncoming(P,z,1,"receiveCancel");const j=String(z);this.u[j]?.()}O(P,z,j){this.f?.logIncoming(P,z,0,"receiveReply:",j);const F=String(z);if(!this.w.hasOwnProperty(F))return;const O=this.w[F];delete this.w[F],O.resolveOk(j)}P(P,z,j){this.f?.logIncoming(P,z,0,"receiveReplyErr:",j);const F=String(z);if(!this.w.hasOwnProperty(F))return;const O=this.w[F];delete this.w[F];let T;j&&(j.$isError?(T=new Error,T.name=j.name,T.message=j.message,T.stack=j.stack):T=j),O.resolveErr(T)}Q(P,z,j){try{return Promise.resolve(this.S(P,z,j))}catch(F){return Promise.reject(F)}}S(P,z,j){const F=this.m[P];if(!F)throw new Error("Unknown actor "+(0,A.$Av)(P));const O=F[z];if(typeof O!="function")throw new Error("Unknown method "+z+" on actor "+(0,A.$Av)(P));return O.apply(F,j)}U(P,z,j){if(this.j)return new y.$N6b;let F=null;if(j.length>0&&g.CancellationToken.isCancellationToken(j[j.length-1])&&(F=j.pop()),F&&F.isCancellationRequested)return Promise.reject(I.$5());const O=R.serializeRequestArguments(j,this.h),T=++this.t,M=String(T),W=new y.$M6b,Y=new b.$Qc;F&&Y.add(F.onCancellationRequested(()=>{const Z=R.serializeCancel(T);this.f?.logOutgoing(Z.byteLength,T,0,"cancel"),this.c.send(R.serializeCancel(T))})),this.w[M]=new c(W,Y),this.F(T);const ue=R.serializeRequest(T,P,z,O,!!F);return this.f?.logOutgoing(ue.byteLength,T,0,`request: ${(0,A.$Av)(P)}.${z}(`,j),this.c.send(ue),W}}e.$Q6b=u;class c{constructor(P,z){this.a=P,this.b=z}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class l{static alloc(P,z,j){const F=new l(N.$fe.alloc(j+1+4),0);return F.writeUInt8(P),F.writeUInt32(z),F}static read(P,z){return new l(P,z)}get buffer(){return this.a}constructor(P,z){this.a=P,this.b=z}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+P).toString();return this.b+=P,j}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+P);return this.b+=P,z}static sizeMixedArray(P){let z=0;z+=1;for(let j=0,F=P.length;j<F;j++){const O=P[j];switch(z+=1,O.type){case 1:z+=this.sizeLongString(O.value);break;case 2:z+=this.sizeVSBuffer(O.value);break;case 3:z+=this.sizeUInt32,z+=this.sizeLongString(O.value);for(let T=0;T<O.buffers.length;++T)z+=this.sizeVSBuffer(O.buffers[T]);break;case 4:break}}return z}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let z=0,j=P.length;z<j;z++){const F=P[z];switch(F.type){case 1:this.writeUInt8(1),this.writeLongString(F.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(F.value);break;case 3:this.writeUInt8(3),this.writeUInt32(F.buffers.length),this.writeLongString(F.value);for(let O=0;O<F.buffers.length;++O)this.writeBuffer(F.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const z=new Array(P);for(let j=0;j<P;j++)switch(this.readUInt8()){case 1:z[j]=this.readLongString();break;case 2:z[j]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),T=this.readLongString(),M=[];for(let W=0;W<O;++W)M.push(this.readVSBuffer());z[j]=new A.$Bv(s(T,M,null));break}case 4:z[j]=void 0;break}return z}}var k;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(k||(k={}));class R{static a(P){for(let z=0,j=P.length;z<j;z++)if(P[z]instanceof N.$fe||P[z]instanceof A.$Bv||typeof P[z]>"u")return!0;return!1}static serializeRequestArguments(P,z){if(this.a(P)){const j=[];for(let F=0,O=P.length;F<O;F++){const T=P[F];if(T instanceof N.$fe)j[F]={type:2,value:T};else if(typeof T>"u")j[F]={type:4};else if(T instanceof A.$Bv){const{jsonString:M,referencedBuffers:W}=d(T.value,z);j[F]={type:3,value:N.$fe.fromString(M),buffers:W}}else j[F]={type:1,value:N.$fe.fromString(i(T,z))}}return{type:1,args:j}}return{type:0,args:i(P,z)}}static serializeRequest(P,z,j,F,O){switch(F.type){case 0:return this.b(P,z,j,F.args,O);case 1:return this.c(P,z,j,F.args,O)}}static b(P,z,j,F,O){const T=N.$fe.fromString(j),M=N.$fe.fromString(F);let W=0;W+=l.sizeUInt8(),W+=l.sizeShortString(T),W+=l.sizeLongString(M);const Y=l.alloc(O?2:1,P,W);return Y.writeUInt8(z),Y.writeShortString(T),Y.writeLongString(M),Y.buffer}static deserializeRequestJSONArgs(P){const z=P.readUInt8(),j=P.readShortString(),F=P.readLongString();return{rpcId:z,method:j,args:JSON.parse(F)}}static c(P,z,j,F,O){const T=N.$fe.fromString(j);let M=0;M+=l.sizeUInt8(),M+=l.sizeShortString(T),M+=l.sizeMixedArray(F);const W=l.alloc(O?4:3,P,M);return W.writeUInt8(z),W.writeShortString(T),W.writeMixedArray(F),W.buffer}static deserializeRequestMixedArgs(P){const z=P.readUInt8(),j=P.readShortString(),F=P.readMixedArray(),O=new Array(F.length);for(let T=0,M=F.length;T<M;T++){const W=F[T];typeof W=="string"?O[T]=JSON.parse(W):O[T]=W}return{rpcId:z,method:j,args:O}}static serializeAcknowledged(P){return l.alloc(5,P,0).buffer}static serializeCancel(P){return l.alloc(6,P,0).buffer}static serializeReplyOK(P,z,j){if(typeof z>"u")return this.d(P);if(z instanceof N.$fe)return this.e(P,z);if(z instanceof A.$Bv){const{jsonString:F,referencedBuffers:O}=d(z.value,j,!0);return this.g(P,F,O)}else return this.f(P,m(z,j))}static d(P){return l.alloc(7,P,0).buffer}static e(P,z){let j=0;j+=l.sizeVSBuffer(z);const F=l.alloc(8,P,j);return F.writeVSBuffer(z),F.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,z){const j=N.$fe.fromString(z);let F=0;F+=l.sizeLongString(j);const O=l.alloc(9,P,F);return O.writeLongString(j),O.buffer}static g(P,z,j){const F=N.$fe.fromString(z);let O=0;O+=l.sizeUInt32,O+=l.sizeLongString(F);for(const M of j)O+=l.sizeVSBuffer(M);const T=l.alloc(10,P,O);T.writeUInt32(j.length),T.writeLongString(F);for(const M of j)T.writeBuffer(M);return T.buffer}static deserializeReplyOKJSON(P){const z=P.readLongString();return JSON.parse(z)}static deserializeReplyOKJSONWithBuffers(P,z){const j=P.readUInt32(),F=P.readLongString(),O=[];for(let T=0;T<j;++T)O.push(P.readVSBuffer());return new A.$Bv(s(F,O,z))}static serializeReplyErr(P,z){const j=z?m(I.$2(z),null):void 0;if(typeof j!="string")return this.h(P);const F=N.$fe.fromString(j);let O=0;O+=l.sizeLongString(F);const T=l.alloc(11,P,O);return T.writeLongString(F),T.buffer}static deserializeReplyErrError(P){const z=P.readLongString();return JSON.parse(z)}static h(P){return l.alloc(12,P,0).buffer}}var w;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var p;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(p||(p={}))}),define(Ee[353],Se([1,0,4,37,46,5]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.OutputChannelUpdateMode=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0,e.$PJ="text/x-code-output",e.$QJ="output",e.$RJ="Log",e.$SJ="text/x-code-log-output",e.$TJ="log",e.$UJ="workbench.panel.output",e.$VJ=new g.$ej("inOutput",!1),e.$WJ=new g.$ej("activeLogOutput",!1),e.$XJ=new g.$ej("outputView.scrollLock",!1),e.$YJ=(0,I.$Zh)("outputService");var L;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$ZJ={OutputChannels:"workbench.contributions.outputChannels"};class b{constructor(){this.a=new Map,this.b=new D.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new D.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(A=>y.push(A)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}N.$qn.add(e.$ZJ.OutputChannels,new b),e.$1J=new g.$ej("activeOutputChannel","")}),define(Ee[152],Se([1,0,6,5,20,26,14,353,71,27,57,181,22,18,32,4,3]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=void 0;class s extends L.$nj{get disposed(){return this.n}constructor(a,t,r,h,u){super(),this.id=a,this.name=t,this.r=r,this.s=h,this.extension=u,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,b.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=m.$fe.fromString(t).byteLength,(0,L.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,b.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(a){this.append(a)}}let n=class{constructor(a,t,r,h,u,c){this.i=t,this.j=r,this.k=h,this.l=u,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(D.$EK.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,C.$om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,r]of this.g)r.visible=t===this.h}createOutputChannel(a,t,r){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const h=typeof t=="object"&&t.log,u=(0,v.$Cf)(t)?t:void 0;if((0,v.$Cf)(u)&&!u.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const l=this.i.environment.extensionLogLevel?.find(([R])=>I.$dm.equals(r.identifier,R))?.[1];l&&(c=(0,L.$xj)(l));const k=h?this.o(a,c,r):this.n(a,u,r);return k.then(R=>{this.g.set(R.id,R),R.visible=R.id===this.h}),h?this.r(a,c??this.m.getLevel(),k):this.q(a,k)}async n(a,t,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const h=await this.c,u=this.k.extUri.joinPath(h,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(u,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(a,u,t,r.identifier.value);return new s(l,a,c,this.a,r)}async o(a,t,r){const h=await this.p(r),u=a.replace(/[\\/:\*\?"<>\|]/g,""),c=this.k.extUri.joinPath(h,`${u}.log`),l=`${r.identifier.value}.${u}`,k=this.l.createLogger(c,{id:l,name:a,logLevel:t,extensionId:r.identifier.value});return new i(l,a,k,this.a,r)}p(a){let t=this.d.get(a.identifier.value);if(!t){const r=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(r)}catch(h){if((0,S.$yk)(h)!==S.FileSystemProviderErrorCode.FileExists)throw h}return r})())}return t}q(a,t){let r=!1;const h=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return a},append(u){h(),t.then(c=>c.append(u))},appendLine(u){h(),t.then(c=>c.appendLine(u))},clear(){h(),t.then(u=>u.clear())},replace(u){h(),t.then(c=>c.replace(u))},show(u,c){h(),t.then(l=>l.show(u,c))},hide(){h(),t.then(u=>u.hide())},dispose(){r=!0,t.then(u=>u.dispose())}}}r(a,t,r){const h=new d.$Qc,u=()=>{if(h.isDisposed)throw new Error("Channel has been closed")},c=h.add(new f.$Rd);function l(k){t=k,c.fire(k)}return r.then(k=>{h.add(k),k.logLevel!==t&&l(k.logLevel),h.add(k.onDidChangeLogLevel(R=>l(R)))}),{...this.q(a,r),get logLevel(){return t},onDidChangeLogLevel:c.event,trace(k,...R){u(),r.then(w=>w.trace(k,...R))},debug(k,...R){u(),r.then(w=>w.debug(k,...R))},info(k,...R){u(),r.then(w=>w.info(k,...R))},warn(k,...R){u(),r.then(w=>w.warn(k,...R))},error(k,...R){u(),r.then(w=>w.error(k,...R))},dispose(){h.dispose()}}}};e.$agc=n,e.$agc=n=Ke([We(0,g.$HM),We(1,y.$XM),We(2,$.$Zec),We(3,A.$zec),We(4,L.$ij),We(5,L.$hj)],n),e.$bgc=(0,N.$Zh)("IExtHostOutputService")}),define(Ee[153],Se([1,0,5,12]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=void 0,e.$Dm=(0,D.$Zh)("remoteAgentService"),e.$Em=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(g){let I=1/0;for(let b=0;b<this.maxSampleCount;b++){const $=await g.getRoundTripTime();if($===void 0)return;I=Math.min(I,$/2),await(0,N.$1g)(this.sampleDelay)}this.average.push(I),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(I):L=this.initial.reduce((b,$)=>b+$,0)/this.initial.length,this.lastMeasurement={initial:L,current:I,average:this.average.reduce((b,$)=>b+$,0)/this.average.length,high:(()=>typeof L>"u"?!1:I>this.highLatencyMaxThreshold||I>this.highLatencyMinThreshold&&I>L*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Ee[354],Se([1,0,223,86,37,40,45,3,4,153,11,24]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=void 0,e.$tH=Object.freeze({id:"application",order:100,title:(0,D.localize)(0,null),type:"object"}),e.$uH=Object.freeze({id:"workbench",order:7,title:(0,D.localize)(1,null),type:"object"}),e.$vH=Object.freeze({id:"security",scope:1,title:(0,D.localize)(2,null),type:"object",order:7}),e.$wH={ConfigurationMigration:"base.contributions.configuration.migration"};class m{constructor(){this.migrations=[],this.a=new $.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(s){this.migrations.push(...s)}}const v=new m;g.$qn.add(e.$wH.ConfigurationMigration,v);let S=class extends b.$Rc{constructor(s,i){super(),this.a=s,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async n=>{for(const o of n.added)await this.f(o,v.migrations)})),this.c(v.migrations),this.B(v.onDidRegisterConfigurationMigration(n=>this.c(n)))}async c(s){await this.f(void 0,s);for(const i of this.b.getWorkspace().folders)await this.f(i,s)}async f(s,i){await Promise.all([i.map(n=>this.g(n,s?.uri))])}async g(s,i){const n=this.a.inspect(s.key,{resource:i}),o=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[a,t]of o){const r=[];for(const u of n.overrideIdentifiers??[]){const c=await this.h(s,{resource:i,overrideIdentifier:u},a);for(const l of c??[]){let k=r.find(([[R,w]])=>R===l[0]&&(0,C.$in)(w.value,l[1].value));k||r.push(k=[l,[]]),k[1].push(u)}}const h=await this.h(s,{resource:i},a,n);for(const u of h??[])r.push([u,[]]);r.length&&await Promise.allSettled(r.map(async([[u,c],l])=>this.a.updateValue(u,c.value,{resource:i,overrideIdentifiers:l},t)))}}async h(s,i,n,o){const a=(o??this.a.inspect(s.key,i))[n];if(a===void 0)return;const t=h=>this.a.inspect(h,i)[n],r=await s.migrateFn(a,t);return Array.isArray(r)?r:[[s.key,r]]}};e.$xH=S,e.$xH=S=Ke([We(0,L.$ti),We(1,I.$9h)],S);let f=class extends b.$Rc{constructor(s){super(),(async()=>{if(!A.$i&&(await s.getEnvironment())?.os!==1)return;g.$qn.as(N.$vn.Configuration).registerConfiguration({...e.$vH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,D.localize)(3,null)},default:[],markdownDescription:(0,D.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,D.localize)(5,null),scope:2}}})})()}};e.$yH=f,e.$yH=f=Ke([We(0,y.$Dm)],f)}),define(Ee[355],Se([1,0,34,17,16,23,232,354,86,5,37]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcb=e.$Ucb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Tcb=e.$Scb=void 0,e.$Scb=(0,y.$Zh)("editorResolverService"),e.$Tcb="workbench.editorAssociations";const C=A.$qn.as($.$vn.Configuration),m={...b.$uH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};C.registerConfiguration(m);var v;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(v||(e.RegisteredEditorPriority=v={}));var S;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function f(s){switch(s){case v.exclusive:return 5;case v.default:return 4;case v.builtin:return 3;case v.option:default:return 1}}e.$Ucb=f;function d(s,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof s=="string"&&s.indexOf(g.$fc.sep)>=0?`${i.scheme}:${i.path}`:(0,I.$yg)(i);return D.$Fj(typeof s=="string"?s.toLowerCase():s,a.toLowerCase())}e.$Vcb=d}),define(Ee[356],Se([1,0,33,17,16,11,23,2,5,267,40,144,153]),function($e,e,D,N,g,I,L,b,$,y,A,C,m){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=void 0,e.$gK=(0,$.$Zh)("pathService");let S=v=class{constructor(d,s,i,n){this.d=d,this.e=s,this.f=i,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||I.OS)(),this.b=(async()=>{const o=await this.e.getEnvironment();return this.c=o?.userHome??d})()}hasValidBasename(d,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(n=>this.h(d,n,s)):this.h(d,s,i)}h(d,s,i){return d.scheme===N.Schemas.file||d.scheme===N.Schemas.vscodeRemote?(0,D.$Zf)(i??(0,L.$yg)(d),s===1):!0}get defaultUriScheme(){return v.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(d,s){if(d.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,y.$dK)(s.getWorkspace());if(i)return i;const n=s.getWorkspace().folders[0];if(n)return n.uri.scheme;const o=s.getWorkspace().configuration;return o?o.scheme:N.Schemas.file}userHome(d){return d?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(d=>d===1?g.$ec:g.$fc)}async fileURI(d){let s="";if(await this.a===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const n=d.indexOf("/",2);n===-1?(s=d.substring(2),d="/"):(s=d.substring(2,n),d=d.substring(n)||"/")}return b.URI.from({scheme:N.Schemas.file,authority:s,path:d,query:"",fragment:""})}};e.$hK=S,e.$hK=S=v=Ke([We(1,m.$Dm),We(2,C.$2J),We(3,A.$9h)],S)}),define(Ee[357],Se([1,0,234,19,59,4,53,3,2,45,239,14,64,269,88,40,144,25,21,18,24,46]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.$_J=e.$$J=e.OnPortForward=e.$0J=e.$9J=e.$8J=e.$7J=e.$6J=e.TunnelSource=e.TunnelCloseReason=e.$5J=e.$4J=e.$3J=void 0;const t=10*1e3,r="remote.tunnels.toRestore";e.$3J="onTunnel",e.$4J=new a.$ej("forwardedPortsViewEnabled",!1,D.localize(0,null));function h(z){const j=z.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(j)return{host:j[1]?.substring(0,j[1].length-1)||"localhost",port:Number(j[2])}}e.$5J=h;var u;(function(z){z.Other="Other",z.User="User",z.AutoForwardEnd="AutoForwardEnd"})(u||(e.TunnelCloseReason=u={}));var c;(function(z){z[z.User=0]="User",z[z.Auto=1]="Auto",z[z.Extension=2]="Extension"})(c||(e.TunnelSource=c={})),e.$6J={source:c.User,description:D.localize(1,null)},e.$7J={source:c.Auto,description:D.localize(2,null)};function l(z,j,F){const O=z.get(R(j,F));if(O)return O;if((0,S.$nv)(j))for(const T of S.$mv){const M=R(T,F);if(z.has(M))return z.get(M)}else if((0,S.$pv)(j))for(const T of S.$ov){const M=R(T,F);if(z.has(M))return z.get(M)}}e.$8J=l;function k(z,j,F){const O=l(z,j,F);if(O)return O;const T=(0,S.$pv)(j)?"localhost":(0,S.$nv)(j)?"0.0.0.0":void 0;if(T)return l(z,T,F)}e.$9J=k;function R(z,j){return z+":"+j}e.$0J=R;var w;(function(z){z.Notify="notify",z.OpenBrowser="openBrowser",z.OpenBrowserOnce="openBrowserOnce",z.OpenPreview="openPreview",z.Silent="silent",z.Ignore="ignore"})(w||(e.OnPortForward=w={}));function p(z){return z&&"host"in z&&typeof z.host=="string"&&"port"in z&&typeof z.port=="number"&&(!("detail"in z)||typeof z.detail=="string")&&(!("pid"in z)||typeof z.pid=="string")}e.$$J=p;class E extends b.$Rc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(j){super(),this.r=j,this.j=[],this.n=new I.$Rd,this.onDidChangeAttributes=this.n.event,this.B(j.onDidChangeConfiguration(F=>{(F.affectsConfiguration(E.c)||F.affectsConfiguration(E.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(j,F,O){let T=this.w(j,F,O,this.j,0);const M={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;T>=0;){const W=this.j[T];W.key===j?(M.onAutoForward=W.onAutoForward??M.onAutoForward,M.elevateIfNeeded=W.elevateIfNeeded!==void 0?W.elevateIfNeeded:M.elevateIfNeeded,M.label=W.label??M.label,M.requireLocalPort=W.requireLocalPort,M.protocol=W.protocol):(M.onAutoForward=M.onAutoForward??W.onAutoForward,M.elevateIfNeeded=M.elevateIfNeeded!==void 0?M.elevateIfNeeded:W.elevateIfNeeded,M.label=M.label??W.label,M.requireLocalPort=M.requireLocalPort!==void 0?M.requireLocalPort:void 0,M.protocol=M.protocol??W.protocol),T=this.w(j,F,O,this.j,T+1)}return M.onAutoForward!==void 0||M.elevateIfNeeded!==void 0||M.label!==void 0||M.requireLocalPort!==void 0||M.protocol!==void 0?M:this.C()}t(j){return j.start!==void 0&&j.end!==void 0}u(j){return j.host!==void 0&&j.port!==void 0&&(0,n.$Cf)(j.host)&&(0,n.$Gf)(j.port)}w(j,F,O,T,M){if(M>=T.length)return-1;const W=!(0,S.$nv)(F)&&!(0,S.$pv)(F),ue=T.slice(M).findIndex(Z=>(0,n.$Gf)(Z.key)?W?!1:Z.key===j:this.t(Z.key)?W?!1:j>=Z.key.start&&j<=Z.key.end:this.u(Z.key)?j===Z.key.port&&F===Z.key.host:O?Z.key.test(O):!1);return ue>=0?ue+M:-1}y(){const j=this.r.getValue(E.c);if(!j||!(0,n.$Ef)(j))return[];const F=[];for(const T in j){if(T===void 0)continue;const M=j[T];let W;if(Number(T))W=Number(T);else if((0,n.$Cf)(T))if(E.g.test(T)){const Y=T.match(E.g);W={start:Number(Y[1]),end:Number(Y[2])}}else if(E.h.test(T)){const Y=T.match(E.h);W={host:Y[1],port:Number(Y[2])}}else{let Y;try{Y=RegExp(T)}catch{}Y&&(W=Y)}W&&F.push({key:W,elevateIfNeeded:M.elevateIfNeeded,onAutoForward:M.onAutoForward,label:M.label,requireLocalPort:M.requireLocalPort,protocol:M.protocol})}const O=this.r.getValue(E.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(F)}z(j){function F(O,T){return(0,n.$Gf)(O.key)?O.key:T.t(O.key)?O.key.start:T.u(O.key)?O.key.port:Number.MAX_VALUE}return j.sort((O,T)=>F(O,this)-F(T,this))}C(){return this.m}static providedActionToAction(j){switch(j){case S.ProvidedOnAutoForward.Notify:return w.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return w.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return w.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return w.OpenPreview;case S.ProvidedOnAutoForward.Silent:return w.Silent;case S.ProvidedOnAutoForward.Ignore:return w.Ignore;default:return}}async addAttributes(j,F,O){const M=this.r.inspect(E.c).userRemoteValue;let W;!M||!(0,n.$Ef)(M)?W={}:W=(0,o.$en)(M),W[`${j}`]||(W[`${j}`]={});for(const Y in F)W[`${j}`][Y]=F[Y];return this.r.updateValue(E.c,W,O)}}e.$_J=E;let P=class extends b.$Rc{constructor(j,F,O,T,M,W,Y,ue,Z,Q){super(),this.H=j,this.I=F,this.J=O,this.L=T,this.M=M,this.N=W,this.O=Y,this.P=ue,this.Q=Z,this.R=Q,this.c=new Map,this.g=new I.$Rd,this.onForwardPort=this.g.event,this.h=new I.$Rd,this.onClosePort=this.h.event,this.j=new I.$Rd,this.onPortName=this.j.event,this.n=new I.$Rd,this.onCandidatesChanged=this.n.event,this.t=new I.$Rd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new I.$Rd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new E(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async x=>{const oe=await this.getAttributes(x.map(X=>({port:X.tunnelRemotePort,host:X.tunnelRemoteHost})));for(const X of x)if(X.localAddress){const ve=R(X.tunnelRemoteHost,X.tunnelRemotePort),ge=k(this.m??new Map,X.tunnelRemoteHost,X.tunnelRemotePort);this.forwarded.set(ve,{remotePort:X.tunnelRemotePort,remoteHost:X.tunnelRemoteHost,localAddress:X.localAddress,protocol:oe?.get(X.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(X.localAddress,oe?.get(X.tunnelRemotePort)),localPort:X.tunnelLocalPort,runningProcess:ge?.detail,hasRunningProcess:!!ge,pid:ge?.pid,privacy:X.privacy,source:e.$6J}),this.f.set(ve,X)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async x=>{const oe=R(x.tunnelRemoteHost,x.tunnelRemotePort);if(!k(this.forwarded,x.tunnelRemoteHost,x.tunnelRemotePort)&&!k(this.detected,x.tunnelRemoteHost,x.tunnelRemotePort)&&!k(this.c,x.tunnelRemoteHost,x.tunnelRemotePort)&&x.localAddress){const X=k(this.m??new Map,x.tunnelRemoteHost,x.tunnelRemotePort),ve=(await this.getAttributes([{port:x.tunnelRemotePort,host:x.tunnelRemoteHost}]))?.get(x.tunnelRemotePort);this.forwarded.set(oe,{remoteHost:x.tunnelRemoteHost,remotePort:x.tunnelRemotePort,localAddress:x.localAddress,protocol:ve?.protocol??S.TunnelProtocol.Http,localUri:await this.X(x.localAddress,ve),localPort:x.tunnelLocalPort,closeable:!0,runningProcess:X?.detail,hasRunningProcess:!!X,pid:X?.pid,privacy:x.privacy,source:e.$6J})}await this.$(),this.f.set(oe,x),this.g.fire(this.forwarded.get(oe))})),this.B(this.H.onTunnelClosed(x=>this.W(x,u.Other))),this.U()}S(){return this.Q.extensions.find(j=>j.activationEvents?.includes(e.$3J))?(this.R.createKey(e.$4J.key,!0),!0):!1}U(){if(this.S())return;const j=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&j.dispose()}))}async W(j,F){const O=R(j.host,j.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(j))}X(j,F){if(j.startsWith("http"))return $.URI.parse(j);const O=F?.protocol??"http";return $.URI.parse(`${O}://${j}`)}async Y(){const j=this.N.getWorkspace(),F=j.configuration?(0,L.$Ni)(j.configuration.path):j.folders.length>0?(0,L.$Ni)(j.folders[0].uri.path):void 0;if(F===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${r}.${this.L.remoteAuthority}.${F}`}async Z(){const j=this.I.get(r,1);if(j)return this.I.remove(r,1),await this.$(),j;const F=await this.Y();if(F)return this.I.get(F,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=await this.s;if(j&&j!==this.y){const F=JSON.parse(j)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${F.map(O=>O.remotePort).join(", ")}`);for(const O of F){const T=k(this.detected,O.remoteHost,O.remotePort);O.source.source!==c.Extension&&!T||O.source.source===c.Extension&&T?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===c.Extension&&!T&&this.D.set(R(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const j=await this.Y();this.w=this.B(new b.$Qc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async F=>{F.key===j&&(this.s=Promise.resolve(this.I.get(j,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const j=JSON.stringify(Array.from(this.forwarded.values()));if(j!==this.y){this.y=j;const F=await this.Y();F&&this.I.store(F,this.y,0,0)}}}async bb(j,F,O){if(!j.tunnelLocalPort||!O?.requireLocalPort||j.tunnelLocalPort===F)return;const T=new Date;if(this.ab.getTime()+t>T.getTime())return;this.ab=T;const M=D.localize(3,null,F,j.tunnelRemotePort,j.tunnelLocalPort);return this.P.info(M)}async forward(j,F){return!this.z&&this.L.remoteAuthority&&await I.Event.toPromise(this.C.event),this.cb(j,F)}async cb(j,F){await this.Q.activateByEvent(e.$3J);const O=k(this.forwarded,j.remote.host,j.remote.port);F=F??(F!==null?(await this.getAttributes([j.remote]))?.get(j.remote.port):void 0);const T=j.local!==void 0?j.local:j.remote.port;let M;if(O)return this.eb(O,j,F);{const W=this.L.remoteAuthority,Y=W?{getAddress:async()=>(await this.M.resolveAuthority(W)).authority}:void 0,ue=R(j.remote.host,j.remote.port);this.c.set(ue,!0),j=this.db(ue,j);const Z=await this.H.openTunnel(Y,j.remote.host,j.remote.port,void 0,T,j.elevateIfNeeded?j.elevateIfNeeded:F?.elevateIfNeeded,j.privacy,F?.protocol);if(typeof Z=="string")M=Z;else if(Z&&Z.localAddress){const Q=k(this.m??new Map,j.remote.host,j.remote.port),x=Z.protocol?Z.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:F?.protocol??S.TunnelProtocol.Http,oe={remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localPort:Z.tunnelLocalPort,name:F?.label??j.name,closeable:!0,localAddress:Z.localAddress,protocol:x,localUri:await this.X(Z.localAddress,F),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:j.source??e.$6J,privacy:Z.privacy};return this.forwarded.set(ue,oe),this.f.set(ue,Z),this.c.delete(ue),await this.$(),await this.bb(Z,T,F),this.g.fire(oe),Z}this.c.delete(ue)}return M}db(j,F){const O=this.D.has(j)?this.D:this.F.has(j)?this.F:void 0;if(O){const T=O.get(j);O.delete(j),T&&(F.name=T.name??F.name,F.local=("local"in T?T.local:"localPort"in T?T.localPort:void 0)??F.local,F.privacy=T.privacy??F.privacy)}return F}async eb(j,F,O){const T=O?.label??F.name;let M;(function(Y){Y[Y.None=0]="None",Y[Y.Fire=1]="Fire",Y[Y.Reopen=2]="Reopen"})(M||(M={}));let W=M.None;switch(T!==j.name&&(j.name=T,W=M.Fire),(O?.protocol||j.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==j.protocol&&(F.source=j.source,W=M.Reopen),F.privacy&&j.privacy!==F.privacy&&(W=M.Reopen),W){case M.Fire:{this.g.fire();break}case M.Reopen:await this.close(j.remoteHost,j.remotePort,u.User),await this.cb(F,O)}return k(this.f,F.remote.host,F.remote.port)}async name(j,F,O){const T=k(this.forwarded,j,F),M=R(j,F);if(T){T.name=O,await this.$(),this.j.fire({host:j,port:F});return}else this.detected.has(M)&&(this.detected.get(M).name=O,this.j.fire({host:j,port:F}))}async close(j,F,O){const T=R(j,F),M=this.forwarded.get(T);return O===u.AutoForwardEnd&&M&&M.source.source===c.Auto&&this.F.set(T,{local:M.localPort,name:M.name,privacy:M.privacy}),await this.H.closeTunnel(j,F),this.W({host:j,port:F},O)}address(j,F){const O=R(j,F);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(j){if(j)for(const F of j){const O=k(this.m??new Map,F.remoteAddress.host,F.remoteAddress.port),T=typeof F.localAddress=="string"?F.localAddress:R(F.localAddress.host,F.localAddress.port);this.detected.set(R(F.remoteAddress.host,F.remoteAddress.port),{remoteHost:F.remoteAddress.host,remotePort:F.remoteAddress.port,localAddress:T,protocol:S.TunnelProtocol.Http,localUri:this.X(T),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:c.Extension,description:D.localize(4,null)}}),this.H.setEnvironmentTunnel(F.remoteAddress.host,F.remoteAddress.port,T,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(j){this.r=j}async setCandidates(j){let F=j;this.r&&(F=await this.r(j));const O=this.fb(F);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(T=>T.port).join(", ")}`),this.n.fire(O)}fb(j){const F=this.m??new Map,O=new Map;return this.m=O,j.forEach(T=>{const M=R(T.host,T.port);O.set(M,{host:T.host,port:T.port,detail:T.detail,pid:T.pid}),F.has(M)&&F.delete(M);const W=k(this.forwarded,T.host,T.port);W&&(W.runningProcess=T.detail,W.hasRunningProcess=!0,W.pid=T.pid)}),F.forEach((T,M)=>{const W=h(M);if(!W)return;const Y=k(this.forwarded,W.host,W.port);Y&&(Y.runningProcess=void 0,Y.hasRunningProcess=!1,Y.pid=void 0);const ue=k(this.detected,W.host,W.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),F}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const j=Array.from(this.forwarded.values()),F=await this.getAttributes(j.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(F)for(const O of j){const T=F.get(O.remotePort);(T?.protocol||O.protocol!==S.TunnelProtocol.Http)&&T?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},T),T&&T.label&&T.label!==O.name&&await this.name(O.remoteHost,O.remotePort,T.label)}}async getAttributes(j,F=!0){const O=new Map,T=new Map;j.forEach(Z=>{const Q=k(this.m??new Map,S.$mv[0],Z.port)??Z;if(Q){O.set(Z.port,Q);const x=p(Q)?Q.pid:void 0;T.has(x)||T.set(x,[]),T.get(x)?.push(Z.port)}});const M=new Map;if(j.forEach(Z=>{const Q=this.configPortsAttributes.getAttributes(Z.port,Z.host,O.get(Z.port)?.detail);Q&&M.set(Z.port,Q)}),this.G.length===0||!F)return M.size>0?M:void 0;const W=await Promise.all((0,N.$Qb)(this.G.map(Z=>Array.from(T.entries()).map(Q=>{const x=Q[1],oe=O.get(x[0]);return Z.providePortAttributes(x,oe?.pid,oe?.detail,new i.$2d().token)})))),Y=new Map;if(W.forEach(Z=>Z.forEach(Q=>{Q&&Y.set(Q.port,Q)})),!M&&!Y)return;const ue=new Map;return j.forEach(Z=>{const Q=M.get(Z.port),x=Y.get(Z.port);ue.set(Z.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??E.providedActionToAction(x?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),ue}addAttributesProvider(j){this.G.push(j)}};e.$aK=P,Ke([(0,g.$sh)(1e3)],P.prototype,"$",null),e.$aK=P=Ke([We(0,S.$iv),We(1,v.$dp),We(2,y.$ti),We(3,d.$2J),We(4,m.$Zk),We(5,f.$9h),We(6,C.$hj),We(7,A.$Nv),We(8,s.$NF),We(9,a.$fj)],P)}),define(Ee[94],Se([1,0]),function($e,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$VI=e.$UI=void 0;class D{constructor(L,b){this.line=L,this.character=b}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,b){return new D(0,0)}with(L){return new D(0,0)}}e.$UI=D;class N{constructor(L,b,$,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new D(L,b),this.end=new D($,y)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new N(0,0,0,0)}with(L){return new N(0,0,0,0)}}e.$VI=N;var g;(function(I){I[I.Information=1]="Information",I[I.Warning=2]="Warning"})(g||(e.TextSearchCompleteMessageType=g={}))}),define(Ee[36],Se([1,0,19,34,24,33,13,5,16,8,94,12]),function($e,e,D,N,g,I,L,b,$,y,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.SearchErrorCode=e.$$I=e.$0I=e.SearchSortOrder=e.ViewMode=e.$9I=e.$8I=e.$7I=e.$6I=e.SearchCompletionExitCode=e.$5I=e.$4I=e.$3I=e.QueryType=e.SearchProviderType=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$WI="workbench.view.search",e.$XI="workbench.panel.search",e.$YI="workbench.view.search",e.$ZI="search-result",e.$1I="search.exclude";const m="\u27EA ",v=" characters skipped \u27EB",S=(m.length+v.length+5)*2;e.$2I=(0,b.$Zh)("searchService");var f;(function(x){x[x.file=0]="file",x[x.text=1]="text"})(f||(e.SearchProviderType=f={}));var d;(function(x){x[x.File=1]="File",x[x.Text=2]="Text"})(d||(e.QueryType=d={}));function s(x){return!!x.preview}e.$3I=s;function i(x){return!!x.resource}e.$4I=i;function n(x){return!!x.message}e.$5I=n;var o;(function(x){x[x.Normal=0]="Normal",x[x.NewSearchStarted=1]="NewSearchStarted"})(o||(e.SearchCompletionExitCode=o={}));class a{constructor(oe){this.resource=oe,this.results=[]}}e.$6I=a;class t{constructor(oe,X,ve,ge){this.ranges=X,this.webviewIndex=ge;const V=Array.isArray(X)?X:[X];if(ve&&ve.matchLines===1&&r(V)){oe=(0,L.$vf)(oe,ve.matchLines);let U="",ne=0,ye=0;const fe=Math.floor(ve.charsPerLine/5),me=[];for(const ee of V){const ie=Math.max(ee.startColumn-fe,0),G=ee.startColumn+ve.charsPerLine;if(ie>ye+fe+S){const te=m+(ie-ye)+v;U+=te+oe.slice(ie,G),ne+=ie-(ye+te.length)}else U+=oe.slice(ye,G);me.push(new u(0,ee.startColumn-ne,ee.endColumn-ne)),ye=G}this.preview={text:U,matches:Array.isArray(this.ranges)?me:me[0]}}else{const U=Array.isArray(X)?X[0].startLineNumber:X.startLineNumber;this.preview={text:oe,matches:(0,D.$1b)(X,ne=>new h(ne.startLineNumber-U,ne.startColumn,ne.endLineNumber-U,ne.endColumn))}}}}e.$7I=t;function r(x){const oe=x[0].startLineNumber;for(const X of x)if(X.startLineNumber!==oe||X.endLineNumber!==oe)return!1;return!0}class h{constructor(oe,X,ve,ge){this.startLineNumber=oe,this.startColumn=X,this.endLineNumber=ve,this.endColumn=ge}}e.$8I=h;class u extends h{constructor(oe,X,ve){super(oe,X,oe,ve)}}e.$9I=u;var c;(function(x){x.List="list",x.Tree="tree"})(c||(e.ViewMode=c={}));var l;(function(x){x.Default="default",x.FileNames="fileNames",x.Type="type",x.Modified="modified",x.CountDescending="countDescending",x.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function k(x,oe=!0){const X=x&&x.files&&x.files.exclude,ve=oe&&x&&x.search&&x.search.exclude;if(!X&&!ve)return;if(!X||!ve)return X||ve;let ge=Object.create(null);return ge=g.$hn(ge,g.$en(X)),ge=g.$hn(ge,g.$en(ve),!0),ge}e.$0I=k;function R(x,oe){return x.excludePattern&&N.$Fj(x.excludePattern,oe)?!1:x.includePattern||x.usingSearchPaths?x.includePattern&&N.$Fj(x.includePattern,oe)?!0:x.usingSearchPaths?!!x.folderQueries&&x.folderQueries.some(X=>{const ve=X.folder.fsPath;if(I.$2f(oe,ve)){const ge=$.$kc(ve,oe);return!X.includePattern||!!N.$Fj(X.includePattern,ge)}else return!1}):!1:!0}e.$$I=R;var w;(function(x){x[x.unknownEncoding=1]="unknownEncoding",x[x.regexParseError=2]="regexParseError",x[x.globParseError=3]="globParseError",x[x.invalidLiteral=4]="invalidLiteral",x[x.rgProcessError=5]="rgProcessError",x[x.other=6]="other",x[x.canceled=7]="canceled"})(w||(e.SearchErrorCode=w={}));class p extends Error{constructor(oe,X){super(oe),this.code=X}}e.$_I=p;function E(x){const oe=x.message;if((0,y.$3)(x))return new p(oe,w.canceled);try{const X=JSON.parse(oe);return new p(X.message,X.code)}catch{return new p(oe,w.other)}}e.$aJ=E;function P(x){const oe={message:x.message,code:x.code};return new Error(JSON.stringify(oe))}e.$bJ=P;function z(x){return x.type==="error"?!0:x.type==="success"}e.$cJ=z;function j(x){return x.type==="success"}e.$dJ=j;function F(x){return!!x.path}e.$eJ=F;function O(x,oe){const X=x.searchPath?x.searchPath:x.relativePath;return(0,L.$sf)(X,oe)}e.$fJ=O;class T{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$gJ=T;function M(x,oe){const X={...x||{},...oe||{}};return Object.keys(X).filter(ve=>{const ge=X[ve];return typeof ge=="boolean"&&ge})}e.$hJ=M;class W{constructor(oe,X){this.c=null,this.a={...oe.excludePattern||{},...X.excludePattern||{}},this.b=N.$Gj(this.a);let ve=oe.includePattern;X.includePattern&&(ve?ve={...ve,...X.includePattern}:ve=X.includePattern),ve&&(this.c=N.$Gj(ve))}matchesExcludesSync(oe,X,ve){return!!(this.b&&this.b(oe,X,ve))}includedInQuerySync(oe,X,ve){return!(this.b&&this.b(oe,X,ve)||this.c&&!this.c(oe,X,ve))}includedInQuery(oe,X,ve){const ge=this.b(oe,X,ve),V=()=>this.c?!!this.c(oe,X,ve):!0;return(0,C.$Mg)(ge)?ge.then(U=>U?!1:V()):V()}hasSiblingExcludeClauses(){return Y(this.a)}}e.$iJ=W;function Y(x){for(const oe in x)if(typeof x[oe]!="boolean")return!0;return!1}function ue(x){if(!x)return;let oe;return X=>(oe||(oe=(x()||Promise.resolve([])).then(ve=>ve?Q(ve):{})),oe.then(ve=>!!ve[X]))}e.$jJ=ue;function Z(x){if(!x)return;let oe;return X=>{if(!oe){const ve=x();oe=ve?Q(ve):{}}return!!oe[X]}}e.$kJ=Z;function Q(x){const oe={};for(const X of x)oe[X]=!0;return oe}}),define(Ee[41],Se([1,0,19,12,21,4,3,77,17,122,23,13,2,221,5,14,252,40,57,27,20,15,7,66,36,6,54]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0;function l(j,F,O){return new A.$qg(T=>p(T,O)).isEqual(j,F)}function k(j,F,O){return l(j.uri,F.uri,O)?0:(0,C.$Ye)(j.uri.toString(),F.uri.toString())}function R(j,F,O){return j.index!==F.index?j.index<F.index?-1:1:l(j.uri,F.uri,O)?(0,C.$Ye)(j.name,F.name):(0,C.$Ye)(j.uri.toString(),F.uri.toString())}function w(j,F,O,T){const M=j.slice(0).sort((Y,ue)=>O(Y,ue,T)),W=F.slice(0).sort((Y,ue)=>O(Y,ue,T));return(0,D.$Db)(M,W,(Y,ue)=>O(Y,ue,T))}function p(j,F){const O=F.getCapabilities(j.scheme);return!(O&&O&1024)}class E extends s.$gi{static toExtHostWorkspace(F,O,T,M){if(!F)return{workspace:null,added:[],removed:[]};const{id:W,name:Y,folders:ue,configuration:Z,transient:Q,isUntitled:x}=F,oe=[],X=O;O?ue.forEach((U,ne)=>{const ye=m.URI.revive(U.uri),fe=E.o(T||O,ye,M);fe?(fe.name=U.name,fe.index=U.index,oe.push(fe)):oe.push({uri:ye,name:U.name,index:ne})}):oe.push(...ue.map(({uri:U,name:ne,index:ye})=>({uri:m.URI.revive(U),name:ne,index:ye}))),oe.sort((U,ne)=>U.index<ne.index?-1:1);const ve=new E(W,Y,oe,!!Q,Z?m.URI.revive(Z):null,!!x,U=>p(U,M)),{added:ge,removed:V}=w(X?X.workspaceFolders:[],ve.workspaceFolders,k,M);return{workspace:ve,added:ge,removed:V}}static o(F,O,T){for(let M=0;M<F.folders.length;M++){const W=F.workspaceFolders[M];if(l(W.uri,O,T))return W}}constructor(F,O,T,M,W,Y,ue){super(F,T.map(Z=>new s.$hi(Z)),M,W,ue),this.t=O,this.u=Y,this.q=[],this.s=b.$6h.forUris(ue),T.forEach(Z=>{this.q.push(Z),this.s.set(Z.uri,Z)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(F,O){return O&&this.s.get(F)&&(F=(0,A.$Ag)(F)),this.s.findSubstr(F)}resolveWorkspaceFolder(F){return this.s.get(F)}}let P=class{constructor(F,O,T,M,W){this.c=new I.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new I.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new I.$Td,this.B=new Map,this.h=M,this.s=T,this.t=W,this.j=new y.$1l,this.k=new N.$Yg,this.o=F.getProxy(u.$EK.MainThreadWorkspace),this.q=F.getProxy(u.$EK.MainThreadMessageService);const Y=O.workspace;this.l=Y?new E(Y.id,Y.name,[],!!Y.transient,Y.configuration?m.URI.revive(Y.configuration):null,!!Y.isUntitled,ue=>p(ue,T)):void 0}$initializeWorkspace(F,O){this.v=O,this.$acceptWorkspaceData(F),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?m.URI.from({scheme:$.Schemas.untitled,path:(0,A.$yg)((0,A.$Ag)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(F,O,T,...M){const W=[];if(Array.isArray(M)&&M.forEach(x=>{m.URI.isUri(x.uri)&&!W.some(oe=>l(oe.uri,x.uri,this.s))&&W.push({uri:x.uri,name:x.name||(0,A.$xg)(x.uri)})}),this.n||[O,T].some(x=>typeof x!="number"||x<0)||T===0&&W.length===0)return!1;const Y=this.x?this.x.workspaceFolders:[];if(O+T>Y.length)return!1;const ue=Y.slice(0);ue.splice(O,T,...W.map(x=>({uri:x.uri,name:x.name||(0,A.$xg)(x.uri),index:void 0})));for(let x=0;x<ue.length;x++){const oe=ue[x];if(ue.some((X,ve)=>ve!==x&&l(oe.uri,X.uri,this.s)))return!1}ue.forEach((x,oe)=>x.index=oe);const{added:Z,removed:Q}=w(Y,ue,R,this.s);if(Z.length===0&&Q.length===0)return!1;if(this.o){const x=F.displayName||F.name;this.o.$updateWorkspaceFolders(x,O,T,W).then(void 0,oe=>{this.n=void 0;const X={source:{identifier:F.identifier,label:F.displayName||F.name}};this.q.$showMessage(d.Severity.Error,(0,v.localize)(0,null,x,oe.toString()),X,[])})}return this.y(ue),!0}getWorkspaceFolder(F,O){if(this.x)return this.x.getWorkspaceFolder(F,O)}async getWorkspaceFolder2(F,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(F,O)}async resolveWorkspaceFolder(F){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(F)}getPath(){if(!this.x)return;const{folders:F}=this.x;if(F.length!==0)return F[0].uri.fsPath}getRelativePath(F,O){let T,M="";if(typeof F=="string"?(T=m.URI.file(F),M=F):typeof F<"u"&&(T=F,M=F.fsPath),!T)return M;const W=this.getWorkspaceFolder(T,!0);if(!W)return M;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let Y=(0,A.$Dg)(W.uri,T);return O&&W.name&&(Y=`${W.name}/${Y}`),Y}y(F){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:F,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(F){const{workspace:O,added:T,removed:M}=E.toExtHostWorkspace(F,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:T,removed:M}))}findFiles(F,O,T,M,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${M.value}, entryPoint: findFiles`);let Y;if(O===null?Y=!1:O&&(typeof O=="string"?Y=O:Y=O.pattern),W&&W.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:Z}=z(a.GlobPattern.from(F));return this.o.$startFileSearch(ue??null,Z??null,Y??null,T??null,W).then(Q=>Array.isArray(Q)?Q.map(x=>m.URI.revive(x)):[])}async findTextInFiles(F,O,T,M,W=g.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${M.value}, entryPoint: findTextInFiles`);const Y=this.j.getNext(),ue=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:Z,folder:Q}=z(a.GlobPattern.from(O.include)),x=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,oe={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:ue,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:Z,excludePattern:x},X=!1;if(this.u[Y]=ve=>{if(X)return;const ge=m.URI.revive(ve.resource);ve.results.forEach(V=>{const U=(0,c.$wh)(V);(0,h.$3I)(U)?T({uri:ge,preview:{text:U.preview.text,matches:(0,D.$1b)(U.preview.matches,ne=>new t.$IK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))},ranges:(0,D.$1b)(U.ranges,ne=>new t.$IK(ne.startLineNumber,ne.startColumn,ne.endLineNumber,ne.endColumn))}):T({uri:ge,text:U.text,lineNumber:U.lineNumber})})},W.isCancellationRequested)return{};try{const ve=await this.o.$startTextSearch(F,Q??null,oe,Y,W);return delete this.u[Y],ve||{}}catch(ve){throw delete this.u[Y],ve}}$handleTextSearchResult(F,O){this.u[O]?.(F)}async save(F){const O=await this.o.$save(F,{saveAs:!1});return m.URI.revive(O)}async saveAs(F){const O=await this.o.$save(F,{saveAs:!0});return m.URI.revive(O)}saveAll(F){return this.o.$saveAll(F)}resolveProxy(F){return this.o.$resolveProxy(F)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(F){return this.o.$requestWorkspaceTrust(F)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(F,O){if(this.w.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.w.set(F,O);const T=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerEditSessionIdentityProvider(M,T),(0,L.$Pc)(()=>{this.w.delete(F),this.o.$unregisterEditSessionIdentityProvider(M)})}async $getEditSessionIdentifier(F,O){this.h.info("Getting edit session identifier for workspaceFolder",F);const T=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!T){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",T);const M=this.w.get(T.uri.scheme);if(this.h.info(`Provider for scheme ${T.uri.scheme} is defined: `,!!M),!M)return;const W=await M.provideEditSessionIdentity(T,O);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(F,O,T,M){this.h.info("Getting edit session identifier for workspaceFolder",F);const W=await this.resolveWorkspaceFolder(m.URI.revive(F));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const Y=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!Y),!Y)return;const ue=await Y.provideEditSessionIdentityMatch?.(O,T,M);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(F){return(O,T,M)=>{const W=function(ue){O.call(T,ue)};return W.extension=F,this.A.event(W,void 0,M)}}async $onWillCreateEditSessionIdentity(F,O,T){const M=await this.resolveWorkspaceFolder(m.URI.revive(F));if(M===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:M},O,async(W,Y)=>{const ue=Date.now();await Promise.resolve(W),Date.now()-ue>T&&this.h.warn("SLOW edit session create-participant",Y.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(F,O){if(this.B.has(F))throw new Error(`A provider has already been registered for scheme ${F}`);this.B.set(F,O);const T=this.t.transformOutgoingScheme(F),M=this.z++;return this.o.$registerCanonicalUriProvider(M,T),(0,L.$Pc)(()=>{this.B.delete(F),this.o.$unregisterCanonicalUriProvider(M)})}async provideCanonicalUri(F,O,T){const M=this.B.get(F.scheme);if(!M)return;const W=await M.provideCanonicalUri?.(m.URI.revive(F),O,T);if(W)return W}async $provideCanonicalUri(F,O,T){return this.provideCanonicalUri(m.URI.revive(F),{targetScheme:O},T)}};e.$Tec=P,e.$Tec=P=Ke([We(0,o.$HM),We(1,n.$XM),We(2,i.$zec),We(3,f.$hj),We(4,r.$Rec)],P),e.$Uec=(0,S.$Zh)("IExtHostWorkspace");function z(j){let F,O;return j&&(typeof j=="string"?F=j:(F=j.pattern,O=m.URI.revive(j.baseUri))),{includePattern:F,folder:O}}}),define(Ee[42],Se([1,0,24,4,41,6,7,254,86,18,12,5,20,14,2]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=e.$Vec=void 0;function f(r,h){if(h){const u=h.split(".");let c=r;for(let l=0;c&&l<u.length;l++)c=c[u[l]];return c}}function d(r){return r instanceof S.URI}function s(r){return r&&r.uri instanceof S.URI&&r.languageId&&typeof r.languageId=="string"}function i(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&r.uri instanceof S.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function o(r){if(d(r))return{resource:r};if(s(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(i(r))return{overrideIdentifier:r.languageId};if(n(r))return{resource:r.uri};if(r===null)return{resource:null}}let a=class{constructor(h,u,c){this.a=h.getProxy(I.$EK.MainThreadConfiguration),this.c=u,this.b=c,this.d=new A.$Yg,this.e=null}getConfigProvider(){return this.d.wait().then(h=>this.e)}$initializeConfiguration(h){this.e=new t(this.a,this.c,h,this.b),this.d.open()}$acceptConfigurationChanged(h,u){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(h,u))}};e.$Vec=a,e.$Vec=a=Ke([We(0,m.$HM),We(1,g.$Uec),We(2,v.$hj)],a);class t{constructor(h,u,c,l){this.a=new N.$Rd,this.b=h,this.f=l,this.c=u,this.e=b.$On.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(h,u){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=b.$On.parse(h),this.d=this.k(h.configurationScopes),this.a.fire(this.j(u,c))}getConfiguration(h,u,c){const l=o(u)||{},k=this.g(h?f(this.e.getValue(void 0,l,this.c.workspace),h):this.e.getValue(void 0,l,this.c.workspace));h&&this.h(h,l,c?.identifier);function R(p){if(p==null)return null;if(typeof p=="boolean")return p?2:5;switch(p){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const w={has(p){return typeof f(k,p)<"u"},get:(p,E)=>{this.h(h?`${h}.${p}`:p,l,c?.identifier);let P=f(k,p);if(typeof P>"u")P=E;else{let z;const j=(F,O)=>{if((0,y.$Ef)(F)){let T;const M=()=>{z=z||(0,D.$en)(k),T=T||f(z,O)};return new Proxy(F,{get:(W,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return M(),()=>T;if(z)return T=T||f(z,O),T[Y];const ue=W[Y];return typeof Y=="string"?j(ue,`${O}.${Y}`):ue},set:(W,Y,ue)=>(M(),T&&(T[Y]=ue),!0),deleteProperty:(W,Y)=>(M(),T&&delete T[Y],!0),defineProperty:(W,Y,ue)=>(M(),T&&Object.defineProperty(T,Y,ue),!0)})}return Array.isArray(F)?(0,D.$en)(F):F};P=j(P,p)}return P},update:(p,E,P,z)=>{p=h?`${h}.${p}`:p;const j=R(P);return E!==void 0?this.b.$updateConfigurationOption(j,p,E,l,z):this.b.$removeConfigurationOption(j,p,l,z)},inspect:p=>{p=h?`${h}.${p}`:p;const E=this.e.inspect(p,l,this.c.workspace);if(E)return{key:p,defaultValue:(0,D.$en)(E.policy?.value??E.default?.value),globalValue:(0,D.$en)(E.user?.value??E.application?.value),workspaceValue:(0,D.$en)(E.workspace?.value),workspaceFolderValue:(0,D.$en)(E.workspaceFolder?.value),defaultLanguageValue:(0,D.$en)(E.default?.override),globalLanguageValue:(0,D.$en)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,D.$en)(E.workspace?.override),workspaceFolderLanguageValue:(0,D.$en)(E.workspaceFolder?.override),languageIds:(0,D.$en)(E.overrideIdentifiers)}}};return typeof k=="object"&&(0,D.$hn)(w,k,!1),Object.freeze(w)}g(h){const u=c=>(0,y.$Ef)(c)?new Proxy(c,{get:(l,k)=>u(l[k]),set:(l,k,R)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(l,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(l,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return u(h)}h(h,u,c){const l=$.$Fn.test(h)?4:this.d.get(h),k=c?`[${c.value}] `:"";if(l===4){typeof u?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${h}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){u?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${h}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(h,u){const c=new b.$Qn(h,u,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,k)=>c.affectsConfiguration(l,o(k))})}k(h){return h.reduce((u,c)=>(u.set(c[0],c[1]),u),new Map)}}e.$Wec=t,e.$Xec=(0,C.$Zh)("IExtHostConfiguration")}),define(Ee[95],Se([1,0,2,12,4,6,7,41,69,42,21,47,20,27,5,17,11,14,91,302,8]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(j){function F(T){if(T!=null)return T}j.from=F;function O(T){if(T!=null)return T}j.to=O})(a||(a={}));var t;(function(j){function F(T){if(T!=null)return T}j.from=F;function O(T){if(T!=null)return T}j.to=O})(t||(t={}));var r;(function(j){function F(T){if(T!=null)return T}j.from=F;function O(T){if(T!=null)return T}j.to=O})(r||(r={}));var h;(function(j){function F(M){if(M){const W=M;return W&&!!W.process}else return!1}j.is=F;function O(M){if(M==null)return;const W={process:M.process,args:M.args};return M.options&&(W.options=r.from(M.options)),W}j.from=O;function T(M){if(M!=null)return new L.$pL(M.process,M.args,M.options)}j.to=T})(h||(h={}));var u;(function(j){function F(T){if(T!=null)return T}j.from=F;function O(T){if(T!=null)return T}j.to=O})(u||(u={}));var c;(function(j){function F(M){if(M){const W=M;return W&&(!!W.commandLine||!!W.command)}else return!1}j.is=F;function O(M){if(M==null)return;const W={};return M.commandLine!==void 0?W.commandLine=M.commandLine:(W.command=M.command,W.args=M.args),M.options&&(W.options=u.from(M.options)),W}j.from=O;function T(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new L.$qL(M.commandLine,M.options):new L.$qL(M.command,M.args?M.args:[],M.options)}j.to=T})(c||(c={}));var l;(function(j){function F(M){if(M){const W=M;return W&&W.customExecution==="customExecution"}else return!1}j.is=F;function O(M){return{customExecution:"customExecution"}}j.from=O;function T(M,W){return W.get(M)}j.to=T})(l||(e.CustomExecutionDTO=l={}));var k;(function(j){function F(O,T){let M;return O.scope!==void 0&&typeof O.scope!="number"?M=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===L.TaskScope.Workspace&&T&&T.workspaceFile?M=T.workspaceFile:M=n.$aG),{id:O._id,workspaceFolder:M}}j.from=F})(k||(e.TaskHandleDTO=k={}));var R;(function(j){function F(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}j.from=F})(R||(R={}));var w;(function(j){function F(M,W){if(M==null)return[];const Y=[];for(const ue of M){const Z=O(ue,W);Z&&Y.push(Z)}return Y}j.fromMany=F;function O(M,W){if(M==null)return;let Y;M.execution instanceof L.$pL?Y=h.from(M.execution):M.execution instanceof L.$qL?Y=c.from(M.execution):M.execution&&M.execution instanceof L.$rL&&(Y=l.from(M.execution));const ue=a.from(M.definition);let Z;return M.scope?typeof M.scope=="number"?Z=M.scope:Z=M.scope.uri:Z=L.TaskScope.Workspace,!ue||!Z?void 0:{_id:M._id,definition:ue,name:M.name,source:{extensionId:W.identifier.value,label:M.source,scope:Z},execution:Y,isBackground:M.isBackground,group:R.from(M.group),presentationOptions:t.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}j.from=O;async function T(M,W,Y){if(M==null)return;let ue;h.is(M.execution)?ue=h.to(M.execution):c.is(M.execution)?ue=c.to(M.execution):l.is(M.execution)&&(ue=l.to(M._id,Y));const Z=a.to(M.definition);let Q;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?Q=M.source.scope:Q=await W.resolveWorkspaceFolder(D.URI.revive(M.source.scope)):Q=L.TaskScope.Workspace),!Z||!Q)return;const x=new L.$sL(Z,Q,M.name,M.source.label,ue,M.problemMatchers);return M.isBackground!==void 0&&(x.isBackground=M.isBackground),M.group!==void 0&&(x.group=L.$oL.from(M.group._id),x.group&&M.group.isDefault&&(x.group=new L.$oL(x.group.id,x.group.label),M.group.isDefault===!0&&(x.group.isDefault=M.group.isDefault))),M.presentationOptions&&(x.presentationOptions=t.to(M.presentationOptions)),M._id&&(x._id=M._id),M.detail&&(x.detail=M.detail),x}j.to=T})(w||(e.TaskDTO=w={}));var p;(function(j){function F(T){return T}j.from=F;function O(T){if(T)return Object.assign(Object.create(null),T)}j.to=O})(p||(p={}));class E{#e;constructor(F,O,T){this._id=O,this.a=T,this.#e=F}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(F){}fireDidEndProcess(F){}}let P=class{constructor(F,O,T,M,W,Y,ue,Z){this.q=new g.$Rd,this.r=new g.$Rd,this.s=new g.$Rd,this.t=new g.$Rd,this.a=F.getProxy(I.$EK.MainThreadTask),this.b=T,this.c=M,this.d=W,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=Z,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(F,O,T){if(!T)return new L.$GK(()=>{});const M=this.w();return this.j.set(M,{type:O,provider:T,extension:F}),this.a.$registerTaskProvider(M,O),new L.$GK(()=>{this.j.delete(M),this.a.$unregisterTaskProvider(M)})}registerTaskSystem(F,O){this.a.$registerTaskSystem(F,O)}fetchTasks(F){return this.a.$fetchTasks(p.from(F)).then(async O=>{const T=[];for(const M of O){const W=await w.to(M,this.b,this.m);W&&T.push(W)}return T})}get taskExecutions(){const F=[];return this.k.forEach(O=>F.push(O)),F}terminateTask(F){if(!(F instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(F._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(F,O,T){const M=this.m.get(F.id);M&&(this.o.set(F.id,M),this.e.attachPtyToTerminal(O,await M.callback(T))),this.p=F.id,this.q.fire({execution:await this.y(F)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(F){const O=await this.y(F);this.l.delete(F.id),this.k.delete(F.id),this.A(F),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(F){const O=await this.y(F.id);this.s.fire({execution:O,processId:F.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(F){const O=await this.y(F.id);this.t.fire({execution:O,exitCode:F.exitCode})}$provideTasks(F,O){const T=this.j.get(F);if(!T)return Promise.reject(new Error("no handler found"));const M=[],W=(0,N.$Sg)(()=>T.provider.provideTasks(A.CancellationToken.None)).then(Y=>this.u(O,M,T,Y));return new Promise(Y=>{W.then(ue=>{Promise.all(M).then(()=>{Y(ue)})})})}async $resolveTask(F,O){const T=this.j.get(F);if(!T)return Promise.reject(new Error("no handler found"));if(O.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${T.type}].`);const M=await w.to(O,this.b,this.m);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const W=await T.provider.resolveTask(M,A.CancellationToken.None);if(!W)return;this.z(W,T);const Y=w.from(W,T.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(Y.execution)&&await this.x(Y,W,!0),await this.v(Y)}w(){return this.h++}async x(F,O,T){const M=await this.a.$createTaskId(F);!T&&!this.m.has(M)&&(this.n.add(M),this.o.set(M,O.execution)),this.m.set(M,O.execution)}async y(F,O){if(typeof F=="string"){const W=this.l.get(F);if(!W)throw new o.$ab("Unexpected: The specified task is missing an execution");return W}const T=this.l.get(F.id);if(T)return T;const M=new Promise((W,Y)=>{function ue(Z,Q,x){x?W(new E(Z,Q.id,x)):Y("Unexpected: Task does not exist.")}O?ue(this,F,O):w.to(F.task,this.b,this.m).then(Z=>ue(this,F,Z))});return this.l.set(F.id,M),M.then(W=>(this.k.set(F.id,W),W),W=>Promise.reject(W))}z(F,O){F._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}A(F){this.o.get(F.id)&&this.o.delete(F.id),this.n.has(F.id)&&this.p!==F.id&&(this.m.delete(F.id),this.n.delete(F.id));const T=this.n.values();let M=T.next();for(;!M.done;)!this.o.has(M.value)&&this.p!==M.value&&(this.m.delete(M.value),this.n.delete(M.value)),M=T.next()}};e.$mgc=P,e.$mgc=P=Ke([We(0,m.$HM),We(1,v.$XM),We(2,b.$Uec),We(3,$.$SM),We(4,y.$Xec),We(5,C.$jfc),We(6,s.$hj),We(7,i.$Cec)],P);let z=class extends P{constructor(F,O,T,M,W,Y,ue,Z){super(F,O,T,M,W,Y,ue,Z),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:d.$h(0)})}async executeTask(F,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const T=w.from(O,F);if(T===void 0)throw new Error("Task is not valid");if(l.is(T.execution))await this.x(T,O,!1);else throw new o.$$;const M=await this.y(await this.a.$getTaskExecution(T),O);return this.a.$executeTask(T).catch(W=>{throw new Error(W)}),M}u(F,O,T,M){const W=[];if(M)for(const Y of M){if(this.z(Y,T),!Y.definition||!F[Y.definition.type]){const Z=Y.source?Y.source:"No task source";this.f.warn(`The task [${Z}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=w.from(Y,T.extension);ue&&l.is(ue.execution)?(W.push(ue),O.push(this.x(ue,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:T.extension}}async v(F){if(l.is(F.execution))return F;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(F,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(F,O,T){}};e.$ngc=z,e.$ngc=z=Ke([We(0,m.$HM),We(1,v.$XM),We(2,b.$Uec),We(3,$.$SM),We(4,y.$Xec),We(5,C.$jfc),We(6,s.$hj),We(7,i.$Cec)],z),e.$ogc=(0,S.$Zh)("IExtHostTask")}),define(Ee[358],Se([1,0,36,29]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.$qJ=void 0;function g(L){return"cellResults"in L}e.$qJ=g,e.$rJ="rawCell#";function I(L,b){let $=-1;const y=[];let A=[];return L.forEach(m=>{m.range.startLineNumber!==$&&A.length>0&&(y.push([...A]),A=[]),A.push(m),$=m.range.endLineNumber}),A.length>0&&y.push([...A]),y.map(m=>{const v=[],S=m[0].range.startLineNumber,f=m[m.length-1].range.endLineNumber;for(let d=S;d<=f;d++)v.push(b.getLineContent(d));return new D.$7I(v.join(`
`)+`
`,m.map(d=>new N.$Ds(d.range.startLineNumber-1,d.range.startColumn-1,d.range.endLineNumber-1,d.range.endColumn-1)))})}e.$sJ=I}),define(Ee[359],Se([1,0,214,22,4,3,28,13,18,2,32,110,6,35,15,7,68,294,146,8,24,17,286,358,355]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class u{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(l=>l.apiEditor)}constructor(l,k,R,w,p,E){this.q=R,this.r=w,this.s=p,this.t=E,this.f=new Map,this.g=new L.$zc,this.h=new Map,this.j=new g.$Rd({onListenerError:n.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new g.$Rd({onListenerError:n.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new g.$Rd({onListenerError:n.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new g.$Rd({onListenerError:n.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new C.$vec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=l.getProxy(m.$EK.MainThreadNotebook),this.c=l.getProxy(m.$EK.MainThreadNotebookDocuments),this.d=l.getProxy(m.$EK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===13){const z=P.notebookEditor?.notebookUri,j=P.cell.handle,O=this.g.get(z)?.getCell(j);if(O)return O.apiCell}if(P&&P.$mid===14){const z=P.uri,j=this.g.get(z);if(j)return j.apiNotebook}return P}}),u.B(k)}getEditorById(l){const k=this.h.get(l);if(!k)throw new Error(`unknown text editor: ${l}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(l){for(const[k,R]of this.h)if(R.apiEditor===l)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(l,k){const R=this.g.get(l);if(!R&&!k)throw new Error(`NO notebook document for '${l}'`);return R}static u(l,k){if(!k)return;const R=k.filenamePattern.map(w=>S.NotebookExclusiveDocumentPattern.from(w)).filter(w=>w!==void 0);if(k.filenamePattern&&!R){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:k.displayName,filenamePattern:R,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,k,R){const w=u.a++,p=typeof R.onDidChangeCellStatusBarItems=="function"?u.a++:void 0;this.f.set(w,R),this.b.$registerNotebookCellStatusBarItemProvider(w,p,k);let E;return p!==void 0&&(E=R.onDidChangeCellStatusBarItems(P=>this.b.$emitCellStatusBarEvent(p))),new f.$GK(()=>{this.f.delete(w),this.b.$unregisterNotebookCellStatusBarItemProvider(w,p),E?.dispose()})}async createNotebookDocument(l){const k=await this.c.$tryCreateNotebook({viewType:l.viewType,content:l.content&&S.NotebookData.from(l.content)});return y.URI.revive(k)}async openNotebookDocument(l){const k=this.g.get(l);if(k)return k.apiNotebook;const R=await this.c.$tryOpenNotebook(l),w=this.g.get(y.URI.revive(R));return(0,$.$Nf)(w?.apiNotebook)}async showNotebookDocument(l,k){y.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let R;typeof k=="object"?R={position:S.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(S.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:R={preserveFocus:!1};const w=await this.d.$tryShowNotebookDocument(l.uri,l.notebookType,R),p=w&&this.h.get(w)?.apiEditor;if(p)return p;throw w?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,k,R,w){const p=this.f.get(l),E=y.URI.revive(k),P=this.g.get(E);if(!P||!p)return;const z=P.getCellFromIndex(R);if(!z)return;const j=await p.provideCellStatusBarItems(z.apiCell,w);if(!j)return;const F=new I.$Qc,O=this.p.add([F]),M=(Array.isArray(j)?j:[j]).map(W=>S.NotebookStatusBarItem.from(W,this.i,F));return{cacheId:O,items:M}}$releaseNotebookCellStatusBarItems(l){this.p.delete(l)}registerNotebookSerializer(l,k,R,w,p){if((0,b.$Fe)(k))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:k,serializer:R,options:w}),this.b.$registerNotebookSerializer(E,{id:l.identifier,location:l.extensionLocation},k,S.NotebookDocumentContentOptions.from(w),u.u(l,p)),(0,I.$Pc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(l,k,R){const w=this.x.get(l);if(!w)throw new Error("NO serializer found");const p=await w.serializer.deserializeNotebook(k.buffer,R);return new d.$Bv(S.NotebookData.from(p))}async $notebookToData(l,k,R){const w=this.x.get(l);if(!w)throw new Error("NO serializer found");const p=await w.serializer.serializeNotebook(S.NotebookData.to(k.value),R);return N.$fe.wrap(p)}async $saveNotebook(l,k,R,w,p){const E=y.URI.revive(k),P=this.x.get(l);if(!P)throw new Error("NO serializer found");const z=this.g.get(E);if(!z)throw new Error("Document NOT found");if(z.versionId!==R)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new A.$Dk((0,D.localize)(0,null,this.z(E)),6);await this.y(E,w);const j={metadata:(0,o.$mn)(z.apiNotebook.metadata,W=>!(P.options?.transientDocumentMetadata??{})[W]),cells:[]};for(const W of z.apiNotebook.getCells()){const Y=new f.$6L(W.kind,W.document.getText(),W.document.languageId,W.mime,P.options?.transientOutputs?[]:[...W.outputs],W.metadata,W.executionSummary);Y.metadata=(0,o.$mn)(W.metadata,ue=>!(P.options?.transientCellMetadata??{})[ue]),j.cells.push(Y)}const F=await P.serializer.serializeNotebook(j,p);await this.s.value.writeFile(E,F);const O=this.s.getFileSystemProviderExtUri(E.scheme),T=await this.s.value.stat(E);return{name:O.basename(E),isFile:(T.type&A.FileType.File)!==0,isDirectory:(T.type&A.FileType.Directory)!==0,isSymbolicLink:(T.type&A.FileType.SymbolicLink)!==0,mtime:T.mtime,ctime:T.ctime,size:T.size,readonly:!!((T.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((T.permissions??0)&A.FilePermission.Locked),etag:A.$Ok({mtime:T.mtime,size:T.size}),children:void 0}}async $searchInNotebooks(l,k,R,w,p){const E=this.x.get(l)?.serializer;if(!E)return{limitHit:!1,results:[]};const P=new L.$Ac;await(async(T,M,W)=>{await Promise.all(T.map(async Y=>await Promise.all(Y.filenamePatterns.map(ue=>{const Z={...W,type:1,filePattern:ue};return this.t.doInternalFileSearchWithCustomCallback(Z,M,Q=>{Q.forEach(x=>{P.has(x)||w.some(X=>Y.isFromSettings&&!X.isFromSettings?!1:X.filenamePatterns.some(ve=>(0,h.$Vcb)(ve,x)))||P.add(x)})})}))))})(R,p,k);const j=new L.$zc;let F=!1;const O=Array.from(P).map(async T=>{const M=[];try{if(p.isCancellationRequested)return;if(k.maxResults&&[...j.values()].reduce((Z,Q)=>Z+Q.cellResults.length,0)>k.maxResults){F=!0;return}const W=[],Y=this.g.get(T);if(Y)Y.apiNotebook.getCells().forEach(Q=>W.push({input:Q.document.getText(),outputs:Q.outputs.flatMap(x=>x.items.map(oe=>oe.data.toString()))}));else{const Z=await this.s.value.readFile(T),Q=N.$fe.fromString(Z.toString()),x=await E.deserializeNotebook(Q.buffer,p);if(p.isCancellationRequested)return;S.NotebookData.from(x).cells.forEach(X=>W.push({input:X.source,outputs:X.outputs.flatMap(ve=>ve.items.map(ge=>ge.valueBytes.toString()))}))}if(p.isCancellationRequested)return;W.forEach((Z,Q)=>{const x=k.contentPattern.pattern,oe=new t.$zPb(Z.input,void 0,Z.outputs),X=oe.findInInputs(x),ve=oe.findInOutputs(x),ge=ve.flatMap(V=>(0,r.$sJ)(V.matches,V.textBuffer)).map((V,U)=>(V.webviewIndex=U,V));if(X.length>0||ve.length>0){const V={index:Q,contentResults:(0,r.$sJ)(X,oe.inputTextBuffer),webviewResults:ge};M.push(V)}});const ue={resource:T,cellResults:M};j.set(T,ue);return}catch{return}});return await Promise.all(O),{limitHit:F,results:[...j.values()]}}async y(l,k){const R=await this.s.value.stat(l);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==A.$Nk&&typeof R.mtime=="number"&&typeof R.size=="number"&&k.mtime<R.mtime&&k.etag!==A.$Ok({mtime:k.mtime,size:R.size}))throw new A.$Dk((0,D.localize)(1,null),3,k)}z(l){return l.scheme===a.Schemas.file?l.fsPath:l.toString()}A(l,k,R){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const w=new i.$Rfc(k,this.d,l,R.visibleRanges.map(S.NotebookRange.to),R.selections.map(S.NotebookRange.to),typeof R.viewColumn=="number"?S.ViewColumn.to(R.viewColumn):void 0);this.h.set(k,w)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const R of l.value.removedDocuments){const w=y.URI.revive(R),p=this.g.get(w);p&&(p.dispose(),this.g.delete(w),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:p.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(p.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===w.toString()&&this.h.delete(E.id)}if(l.value.addedDocuments){const R=[];for(const w of l.value.addedDocuments){const p=y.URI.revive(w.uri);if(this.g.has(p))throw new Error(`adding EXISTING notebook ${p} `);const E=new s.$Qfc(this.c,this.q,this.r,p,w);R.push(...w.cells.map(P=>s.$Pfc.asModelAddData(E.apiNotebook,P))),this.g.get(p)?.dispose(),this.g.set(p,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:R}),this.m.fire(E.apiNotebook)}}if(l.value.addedEditors)for(const R of l.value.addedEditors){if(this.h.has(R.id))return;const w=y.URI.revive(R.documentUri),p=this.g.get(w);p&&this.A(p,R.id,R)}const k=[];if(l.value.removedEditors)for(const R of l.value.removedEditors){const w=this.h.get(R);w&&(this.h.delete(R),this.k?.id===w.id&&(this.k=void 0),k.push(w))}if(l.value.visibleEditors){this.l=l.value.visibleEditors.map(w=>this.h.get(w)).filter(w=>!!w);const R=new Set;this.l.forEach(w=>R.add(w.id));for(const w of this.h.values()){const p=R.has(w.id);w._acceptVisibility(p)}this.l=[...this.h.values()].map(w=>w).filter(w=>w.visible),this.o.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this.k=void 0:l.value.newActiveEditor&&(this.h.get(l.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${l.value.newActiveEditor}`),this.k=this.h.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(l){const k=v.$6M.String.with("notebookType","A notebook type"),R=new v.$8M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new v.$6M("data","Bytes to convert to data",p=>p instanceof Uint8Array,p=>N.$fe.wrap(p))],new v.$7M("Notebook Data",p=>S.NotebookData.to(p.value))),w=new v.$8M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new v.$6M("NotebookData","Notebook data to convert to bytes",p=>!0,p=>new d.$Bv(S.NotebookData.from(p)))],new v.$7M("Bytes",p=>p.buffer));l.registerApiCommand(R),l.registerApiCommand(w)}}e.$1fc=u}),define(Ee[360],Se([1,0,16,21,44,34,23,38,36]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class y{constructor(m,v,S){this.k=m,this.l=v,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=m.filePattern,this.b=m.includePattern&&I.$Gj(m.includePattern),this.c=m.maxResults||void 0,this.d=m.exists,this.h=new Set,this.j=m.excludePattern&&I.$Gj(m.excludePattern)}cancel(){this.g=!0,this.h.forEach(m=>m.cancel()),this.h=new Set}search(m){const v=this.k.folderQueries||[];return new Promise((S,f)=>{const d=s=>{this.f++,m(s)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),n=D.$mc(i);this.j&&this.j(i,n)||this.v(d,{base:s,basename:n})}),Promise.all(v.map(s=>this.p(s,d))).then(s=>{S({limitHit:this.e,stats:s[0]||void 0})},s=>{f(new Error((0,g.$Ki)(s)))})})}async p(m,v){const S=new N.$2d,f=this.q(m),d=this.r(),s=new $.$iJ(this.k,m),i=!s.hasSiblingExcludeClauses();let n;try{this.h.add(S),n=b.$Nd.create();const o=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,S.token),a=n.elapsed(),t=b.$Nd.create();return this.g&&!this.e||(o&&o.forEach(r=>{const h=D.$fc.relative(m.folder.path,r.path);if(i){const u=D.$mc(r.path);this.v(v,{base:m.folder,relativePath:h,basename:u});return}this.s(d,m.folder,h,v)}),this.g&&!this.e)?null:(this.u(d,s,v),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(m){const v=(0,$.$hJ)(this.k.includePattern,m.includePattern),S=(0,$.$hJ)(this.k.excludePattern,m.excludePattern);return{folder:m.folder,excludes:S,includes:v,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}s({pathToEntries:m},v,S,f){if(S===this.a){const s=D.$mc(this.a);this.v(f,{base:v,relativePath:this.a,basename:s})}function d(s){const i=D.$mc(s),n=D.$lc(s);let o=m[n];o||(o=m[n]=[],d(n)),o.push({base:v,relativePath:s,basename:i})}d(S)}u({rootEntries:m,pathToEntries:v},S,f){const d=this,s=this.a;function i(n){const o=(0,$.$kJ)(()=>n.map(a=>a.basename));for(let a=0,t=n.length;a<t;a++){const r=n[a],{relativePath:h,basename:u}=r;if(S.matchesExcludesSync(h,u,s!==u?o:void 0))continue;const c=v[h];if(c)i(c);else{if(h===s)continue;d.v(f,r)}if(d.e)break}}i(m)}v(m,v){(!this.b||v.relativePath&&this.b(v.relativePath,v.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||m(v))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(m,v,S,f){const d=this.c(m.cacheKey),s=new y(m,v,d&&d.token);let i=0;const n=o=>{i+=o.length,S(o.map(a=>this.d(a)))};return this.e(s,A.a,n,f).then(o=>({limitHit:o.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:o.stats}}))}clearCache(m){this.c(m)?.cancel()}c(m){if(m)return this.b.has(m)||this.b.set(m,new N.$2d),this.b.get(m)}d(m){return m.relativePath?{resource:L.$Bg(m.base,m.relativePath)}:{resource:m.base}}e(m,v,S,f){const d=f.onCancellationRequested(()=>{m.cancel()}),s=n=>{n&&(i.push(n),v>0&&i.length>=v&&(S(i),i=[]))};let i=[];return m.search(s).then(n=>(i.length&&S(i),d.dispose(),n),n=>(i.length&&S(i),d.dispose(),Promise.reject(n)))}}e.$Sfc=A}),define(Ee[361],Se([1,0,19,73,34,102,28,17,16,23,13,18,2,99,235,45,14,40,143,356,36]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.$iK=void 0;let a=class{constructor(p,E,P,z,j){this.a=p,this.b=E,this.c=P,this.d=z,this.e=j}text(p,E,P={}){p=this.f(p,P);const z=this.a.getValue(),j=E&&E.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(E?.map(s.$ii),P),type:2,contentPattern:p,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:z.search.usePCRE2||j||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(p,E){const P=this.a.getValue();p.isRegExp&&(p.pattern=p.pattern.replace(/\r?\n/g,"\\n"));const z={...p,wordSeparators:P.editor.wordSeparators};return this.j(p,E)&&(z.isCaseSensitive=!0),this.k(p)&&(z.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(z.notebookInfo||(z.notebookInfo={}),z.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),z}file(p,E={}){return{...this.h(p,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey}}g(p,E){return p?(p=Array.isArray(p)?p.map(c):c(p),E?this.parseSearchPaths(p):{pattern:r(...Array.isArray(p)?p:[p])}):{}}h(p=[],E={}){const P=this.g(E.includePattern,E.expandPatterns),z=this.g(E.excludePattern,E.expandPatterns),j=p.length>1,F=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(M=>this.q(M,E,z)):p.map(M=>this.r(M,E,z,j))).filter(M=>!!M),O={_reason:E._reason,folderQueries:F,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:z.pattern,includePattern:P.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const M=D.$Gb(D.$Qb(this.c.groups.map(ue=>ue.editors.map(Z=>Z.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(M));const W=M.filter(ue=>(0,o.$$I)(O,ue.fsPath)),Y=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(Y)),{...O,...Y}}const T=E.extraFileResources&&E.extraFileResources.filter(M=>(0,o.$$I)(O,M.fsPath));return O.extraFileResources=T&&T.length?T:void 0,O}i(p){const E=[],P=new L.$zc,z={};let j=!1;return p.forEach(F=>{if(F.scheme===b.Schemas.walkThrough)return;if((0,y.$Fg)(F)){const T=this.b.getWorkspaceFolder(F)?.uri??F.with({path:$.$lc(F.fsPath)});let M=P.get(T);M||(j=!0,M={folder:T,includePattern:{}},E.push(M),P.set(T,M));const W=$.$kc(T.fsPath,F.fsPath);(0,C.$Nf)(M.includePattern)[W.replace(/\\/g,"/")]=!0}else F.fsPath&&(j=!0,z[F.fsPath]=!0)}),{folderQueries:E,includePattern:z,usingSearchPaths:!0,excludePattern:j?void 0:{"**/*":!0}}}j(p,E){if(E.isSmartCase){if(p.isRegExp){if(A.$tf(p.pattern,!0))return!0}else if(A.$tf(p.pattern))return!0}return!!p.isCaseSensitive}k(p){return p.isMultiline||p.isRegExp&&(0,v.$HB)(p.pattern)||p.pattern.indexOf(`
`)>=0?!0:!!p.isMultiline}parseSearchPaths(p){const E=Y=>$.$hc(Y)||/^\.\.?([\/\\]|$)/.test(Y),z=(Array.isArray(p)?p:h(p)).map(Y=>{const ue=this.e.resolvedUserHome;return ue?(0,I.$Gv)(Y,ue.scheme===b.Schemas.file?ue.fsPath:ue.path):Y}),j=N.$J(z,Y=>E(Y)?"searchPaths":"exprSegments"),F=(j.exprSegments||[]).map(Y=>A.$Oe(Y,"/")).map(Y=>A.$Oe(Y,"\\")).map(Y=>(Y[0]==="."&&(Y="*"+Y),u(Y))),O={},T=this.m(j.searchPaths||[]);T&&T.length&&(O.searchPaths=T);const M=D.$Qb(F),W=r(...M);return W&&(O.pattern=W),O}l(p,E){return E.disregardExcludeSettings?void 0:(0,o.$0I)(p,!E.disregardSearchExcludeSettings)}m(p){if(!p||!p.length)return[];const E=p.flatMap(z=>{let{pathPortion:j,globPortion:F}=t(z);return F&&(F=l(F)),this.n(j).flatMap(T=>this.o(T,F))}),P=new Map;return E.forEach(z=>{const j=z.searchPath.toString(),F=P.get(j);F?z.pattern&&(F.pattern=F.pattern||{},F.pattern[z.pattern]=!0):P.set(j,{searchPath:z.searchPath,pattern:z.pattern?r(z.pattern):void 0})}),Array.from(P.values())}n(p){if($.$hc(p)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==b.Schemas.file?[{searchPath:E[0].uri.with({path:p})}]:[{searchPath:m.URI.file($.$gc(p))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(p=c(p),p.startsWith("../")||p===".."){const z=$.$fc.resolve(E.path,p);return[{searchPath:E.with({path:z})}]}const P=l(p);return[{searchPath:E,pattern:P}]}else{if(p==="./"||p===".\\")return[];{const E=p.replace(/^\.[\/\\]/,""),z=this.b.getWorkspace().folders.map(j=>{const F=E.match(new RegExp(`^${A.$Je(j.name)}(?:/(.*)|$)`));return F?{match:F,folder:j}:null}).filter(C.$Kf);if(z.length)return z.map(j=>{const F=j.match[1];return{searchPath:j.folder.uri,pattern:F&&l(F)}});{const j=p.match(/\.[\/\\](.+)[\/\\]?/),F=j?j[1]:p,O=S.localize(0,null,F);throw new Error(O)}}}}o(p,E){const P=p.pattern&&E?`${p.pattern}/${E}`:p.pattern||E,z=[{searchPath:p.searchPath,pattern:P}];return P&&!P.endsWith("**")&&z.push({searchPath:p.searchPath,pattern:P+"/**"}),z}q(p,E,P){const z=this.r((0,s.$ii)(p.searchPath),E,P,!1);return z?{...z,includePattern:p.pattern}:null}r(p,E,P,z){let j;const F=m.URI.isUri(p)?p:p.uri;if(P.searchPaths){const Y=P.searchPaths.filter(ue=>(0,y.$ug)(ue.searchPath,F))[0];if(Y&&!Y.pattern)return null;Y&&(j=Y.pattern)}const O=this.a.getValue({resource:F}),M={...this.l(O,E)||{},...j||{}},W=m.URI.isUri(p)?(0,y.$yg)(p):p.name;return{folder:F,folderName:z?W:void 0,excludePattern:Object.keys(M).length>0?M:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!O.search.followSymlinks}}};e.$iK=a,e.$iK=a=Ke([We(0,f.$ti),We(1,s.$9h),We(2,i.$MC),We(3,d.$hj),We(4,n.$gK)],a);function t(w){const p=w.match(/[\*\{\}\(\)\[\]\?]/);if(p){const E=p.index,P=w.substr(0,E).match(/[/|\\][^/\\]*$/);if(P){let z=w.substr(0,P.index);return z.match(/[/\\]/)||(z+="/"),{pathPortion:z,globPortion:w.substr((P.index||0)+1)}}}return{pathPortion:w}}function r(...w){return w.length?w.reduce((p,E)=>(p[E]=!0,p),Object.create(null)):void 0}function h(w){return g.$Ej(w,",").map(p=>p.trim()).filter(p=>!!p.length)}function u(w){return[`**/${w}/**`,`**/${w}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function c(w){return w.replace(/\\/g,"/")}function l(w){return c(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(w){return w.replace(/([?*[\]])/g,"[$1]")}function R(w,p){w=D.$Lb(w,z=>z.toString());const E=[],P=p.getWorkspace();return w&&w.forEach(z=>{let j;if(p.getWorkbenchState()===2)j=(0,y.$Dg)(P.folders[0].uri,z),j&&j!=="."&&(j="./"+j);else{const F=p.getWorkspaceFolder(z);if(F){const O=F.name;if(P.folders.filter(M=>M.name===O).length===1){const M=(0,y.$Dg)(F.uri,z);M===""?j=`./${F.name}`:j=`./${F.name}/${M}`}else j=z.fsPath}}j&&E.push(k(j))}),E}e.$jK=R}),define(Ee[362],Se([1,0,23,2,21,8,5,361,36,40]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrb=e.$Krb=void 0;const A=7e3;function C(f,d){const s=d.activationEvents;if(!s)return Promise.resolve(void 0);const i=[],n=[];for(const u of s)if(/^workspaceContains:/.test(u)){const c=u.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?n.push(c):i.push(c)}if(i.length===0&&n.length===0)return Promise.resolve(void 0);let o;const a=new Promise((u,c)=>{o=u}),t=u=>o({activationEvent:u}),r=Promise.all(i.map(u=>m(f,u,t))).then(()=>{}),h=v(f,d.identifier,n,t);return Promise.all([r,h]).then(()=>{o(void 0)}),a}e.$Krb=C;async function m(f,d,s){for(const i of f.folders)if(await f.exists(D.$Bg(N.URI.revive(i),d))){s(`workspaceContains:${d}`);return}}async function v(f,d,s,i){if(s.length===0)return Promise.resolve(void 0);const n=new g.$2d,o=f.checkExists(f.folders,s,n.token),a=setTimeout(async()=>{n.cancel(),f.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${s.join(",")}`)},A);let t=!1;try{t=await o}catch(r){I.$3(r)||I.$Z(r)}n.dispose(),clearTimeout(a),t&&i(`workspaceContains:${s.join(",")}`)}function S(f,d,s,i){const n=f.get(L.$Yh),o=f.get($.$2I),t=n.createInstance(b.$iK).file(d.map(r=>(0,y.$ii)(N.URI.revive(r))),{_reason:"checkExists",includePattern:s,exists:!0});return o.fileSearch(t,i).then(r=>!!r.limitHit,r=>I.$3(r)?!1:Promise.reject(r))}e.$Lrb=S}),define(Ee[48],Se([1,0,211,16,56,23,12,3,77,2,14,6,42,292,118,41,25,145,8,26,22,271,7,64,5,27,92,20,107,72,47,4,362,117,273,17,115,38,11,116]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h,u,c,l,k,R,w,p,E,P,z,j,F,O,T,M){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=e.$wfc=e.$vfc=e.$ufc=void 0,e.$ufc=(0,h.$Zh)("IHostUtils");let Y=W=class extends b.$Rc{constructor(V,U,ne,ye,fe,me,ee,ie,G,te,J,ce){super(),this.X=ce,this.a=this.B(new p.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=U,this.g=ne,this.f=ee,this.j=ye,this.m=fe,this.s=me,this.t=G,this.u=te,this.w=J,this.y=this.g.getProxy(C.$EK.MainThreadWorkspace),this.z=this.g.getProxy(C.$EK.MainThreadTelemetry),this.C=this.g.getProxy(C.$EK.MainThreadExtensionService),this.D=new L.$Yg,this.F=new L.$Yg,this.G=new L.$Yg,this.H=new L.$Yg,this.I=new ve(this.f.extensions.activationEvents),this.L=new s.$I6b(this.I,this.f.extensions.allExtensions);const be=new n.$em(this.f.extensions.myExtensions);this.J=new s.$I6b(this.I,oe(this.L,be)),T.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$ffc(this.g,this.s),this.N=new P.$nfc(this.g),this.O=ie,this.h=V.createChild(new k.$Xh([S.$gfc,this.M],[P.$ofc,this.N])),this.P=this.B(new v.$efc(this.J,this.L,{onExtensionActivationError:(Ie,Me,B)=>{this.C.$onExtensionActivationError(Ie,i.$2(Me),B)},actualActivateExtension:async(Ie,Me)=>{if(s.$I6b.isHostExtension(Ie,this.J,this.L))return await this.C.$activateExtension(Ie,Me),new v.$dfc;const B=this.J.getExtensionDescription(Ie);return this.db(B,Me)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),g.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(V){i.$Z(V)}}async Y(){this.O.onWillDeactivateAll();let V=[];try{V=this.J.getAllExtensionDescriptions().map(fe=>fe.identifier).filter(fe=>this.isActivated(fe)).map(fe=>this.cb(fe))}catch{}await Promise.all(V)}terminate(V,U=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${V}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ne=this.Y();Promise.race([(0,L.$1g)(5e3),ne]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${U}`):this.s.info(`Extension host exiting with code ${U}`),this.s.flush(),this.s.dispose(),this.c.exit(U)})}isActivated(V){return this.G.isOpen()?this.P.isActivated(V):!1}async getExtension(V){const U=await this.C.$getExtension(V);return U&&{...U,identifier:new n.$dm(U.identifier.value),extensionLocation:y.URI.revive(U.extensionLocation)}}Z(V,U){return this.P.activateByEvent(V,U)}$(V,U){return this.P.activateById(V,U)}activateByIdWithErrors(V,U){return this.$(V,U).then(()=>{const ne=this.P.getActivatedExtension(V);if(ne.activationFailed)return Promise.reject(ne.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(V=>this.J)}getExtensionExports(V){if(this.G.isOpen())return this.P.getActivatedExtension(V).exports;try{return this.P.getActivatedExtension(V).exports}catch{return null}}async ab(V){if(V.scheme===j.Schemas.file&&this.c.fsRealpath){const U=await this.c.fsRealpath(V.fsPath);return y.URI.file(U)}return V}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(V=>new X(V))),this.Q}async bb(V){const U=$.$6h.forUris(ne=>I.$sg.ignorePathCasing(ne));return await Promise.all(V.map(async ne=>{if(this.ub(ne)){const ye=await this.ab(ne.extensionLocation);U.set(ye,ne)}})),U}cb(V){let U=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(V))return U;const ne=this.P.getActivatedExtension(V);if(!ne)return U;try{typeof ne.module.deactivate=="function"&&(U=Promise.resolve(ne.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${V.value}':`),this.s.error(ye)}try{(0,b.$Mc)(ne.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${V.value}':`),this.s.error(ye)}return U}async db(V,U){return this.f.remote.isRemote?this.C.$onWillActivateExtension(V.identifier):await this.C.$onWillActivateExtension(V.identifier),this.fb(V,U).then(ne=>{const ye=ne.activationTimes;return this.C.$onDidActivateExtension(V.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,U),this.eb(V,U,"success",ye),ne},ne=>{throw this.eb(V,U,"failure"),ne})}eb(V,U,ne,ye){const fe=Z(V,U);this.z.$publicLog2("extensionActivationTimes",{...fe,...ye||{},outcome:ne})}fb(V,U){const ne=Z(V,U);this.z.$publicLog2("activatePlugin",ne);const ye=this.ub(V);if(!ye)return Promise.resolve(new v.$cfc(v.$_ec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${V.identifier.value}, startup: ${U.startup}, activationEvent: '${U.activationEvent}'${V.identifier.value!==U.extensionId.value?`, root cause: ${U.extensionId.value}`:""}`),this.s.flush();const fe=new v.$afc(U.startup);return Promise.all([this.vb(V,(0,I.$Bg)(V.extensionLocation,ye),fe),this.gb(V)]).then(me=>(g.mark(`code/extHost/willActivateExtension/${V.identifier.value}`),W.hb(this.s,V.identifier,me[0],me[1],fe))).then(me=>(g.mark(`code/extHost/didActivateExtension/${V.identifier.value}`),me))}gb(V){const U=new a.$ifc(V,this.M),ne=new a.$hfc(V.identifier.value,!1,this.M),ye=new z.$pfc(V,this.N),fe=V.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,me=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${V.identifier.value}`),Promise.all([U.whenReady,ne.whenReady,this.O.whenReady]).then(()=>{const ee=this;let ie,G;const te=(0,d.$QF)(V,"ipc")?this.f.messagePorts?.get(n.$dm.toKey(V.identifier)):void 0;return Object.freeze({globalState:U,workspaceState:ne,secrets:ye,subscriptions:[],get extensionUri(){return V.extensionLocation},get extensionPath(){return V.extensionLocation.fsPath},asAbsolutePath(J){return N.$ic(V.extensionLocation.fsPath,J)},get storagePath(){return ee.O.workspaceValue(V)?.fsPath},get globalStoragePath(){return ee.O.globalValue(V).fsPath},get logPath(){return N.$ic(ee.f.logsLocation.fsPath,V.identifier.value)},get logUri(){return y.URI.joinPath(ee.f.logsLocation,V.identifier.value)},get storageUri(){return ee.O.workspaceValue(V)},get globalStorageUri(){return ee.O.globalValue(V)},get extensionMode(){return fe},get extension(){return ie===void 0&&(ie=new x(ee,V.identifier,V,me,!1)),ie},get extensionRuntime(){return(0,d.$RF)(V,"extensionRuntime"),ee.extensionRuntime},get environmentVariableCollection(){return ee.u.getEnvironmentVariableCollection(V)},get messagePassingProtocol(){if(!G){if(!te)return;const J=p.Event.buffer(p.Event.fromDOMEventEmitter(te,"message",ce=>ce.data));te.start(),G={onDidReceiveMessage:J,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(V,U,ne,ye,fe){return ne=ne||{activate:void 0,deactivate:void 0},this.ib(V,U,ne,ye,fe).then(me=>new v.$bfc(!1,null,fe.build(),ne,me,ye.subscriptions))}static ib(V,U,ne,ye,fe){if(typeof ne.activate=="function")try{fe.activateCallStart(),V.trace(`ExtensionService#_callActivateOptional ${U.value}`);const me=typeof global=="object"?global:self,ee=ne.activate.apply(me,[ye]);return fe.activateCallStop(),fe.activateResolveStart(),Promise.resolve(ee).then(ie=>(fe.activateResolveStop(),ie))}catch(me){return Promise.reject(me)}else return Promise.resolve(ne)}jb(V,U){this.$(V.identifier,{startup:!1,extensionId:V.identifier,activationEvent:U}).then(void 0,ne=>{this.s.error(ne)})}kb(V,U=0){const ye=Date.now();(0,T.$B)(()=>{for(let fe=U;fe<V.length;fe+=1){const me=V[fe];for(const ee of me.activationEvents??[])if(ee==="onStartupFinished")if(Date.now()-ye>50){this.kb(V,fe);break}else this.jb(me,ee)}})}lb(){this.C.$setPerformanceMarks(g.getMarks()),this.m.getConfigProvider().then(V=>{const U=V.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ne=this.J.getAllExtensionDescriptions();if(U)this.kb(ne);else for(const ye of ne)if(ye.activationEvents)for(const fe of ye.activationEvents)fe==="onStartupFinished"&&this.jb(ye,fe)})}mb(){const V=this.Z("*",!0).then(void 0,me=>{this.s.error(me)});this.B(this.j.onDidChangeWorkspace(me=>this.nb(me.added)));const U=this.j.workspace?this.j.workspace.folders:[],ne=this.nb(U),ye=this.pb(),fe=Promise.all([ye,V,ne]).then(()=>{});return Promise.race([fe,(0,L.$1g)(1e4)]).then(()=>{this.lb()}),fe}nb(V){return V.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(U=>this.ob(V,U))).then(()=>{})}async ob(V,U){if(this.isActivated(U.identifier))return;const ne=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:V.map(me=>me.uri),forceUsingSearch:ne||!this.c.fsExists,exists:me=>this.c.fsExists(me.fsPath),checkExists:(me,ee,ie)=>this.y.$checkExists(me,ee,ie)},fe=await(0,E.$Krb)(ye,U);if(fe)return this.$(U.identifier,{startup:!0,extensionId:U.identifier,activationEvent:fe.activationEvent}).then(void 0,me=>this.s.error(me))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(V){throw console.error(V),V}}async qb(){const{extensionDevelopmentLocationURI:V,extensionTestsLocationURI:U}=this.f.environment;if(!V||!U)throw new Error(D.localize(0,null));const ne=await this.vb(null,U,new v.$afc(!1));if(!ne||typeof ne.run!="function")throw new Error(D.localize(1,null,U.toString()));return new Promise((ye,fe)=>{const me=(G,te)=>{G?(T.$t&&this.s.error("Test runner called back with error",G),fe(G)):(T.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof te=="number"&&te>0?1:0))},ee=(0,I.$pg)(U),ie=ne.run(ee,me);ie&&ie.then&&ie.then(()=>{T.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{T.$t&&this.s.error("Test runner finished with error",G),fe(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$1g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(V,U){return this.R[V]=U,(0,b.$Pc)(()=>{delete this.R[V]})}async getRemoteExecServer(V){const{resolver:U}=await this.sb(V);return U?.resolveExecServer?.(V,{resolveAttempt:0})}async sb(V){const U=V.indexOf("+");if(U===-1)throw new t.$MK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ne=V.substr(0,U);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ne}`,!1),{authorityPrefix:ne,resolver:this.R[ne]}}async $resolveAuthority(V,U){const ne=O.$Nd.create(!1),ye=()=>`[resolveAuthority(${(0,r.$4k)(V)},${U})][${ne.elapsed()}ms] `,fe=se=>this.s.info(`${ye()}${se}`),me=se=>this.s.warn(`${ye()}${se}`),ee=(se,K=void 0)=>this.s.error(`${ye()}${se}`,K),ie=se=>{if(se instanceof t.$MK)return{type:"error",error:{code:se._code,message:se._message,detail:se._detail}};throw se},G=async se=>{fe(`activating resolver for ${se}...`);const{resolver:K,authorityPrefix:ae}=await this.sb(se);if(!K)throw ee(`no resolver for ${ae}`),new t.$MK(`No remote extension installed to resolve ${ae}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:K,authorityPrefix:ae,remoteAuthority:se}},te=V.split(/@|%40/g).reverse();fe(`activating remote resolvers ${te.join(" -> ")}`);let J;try{J=await Promise.all(te.map(G)).catch(async se=>{if(!(se instanceof t.$MK)||se._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw se;return me(`resolving nested authorities failed: ${se.message}`),[await G(V)]})}catch(se){return ie(se)}const ce=new L.$$g;ce.cancelAndSet(()=>fe("waiting..."),1e3);let be,Ie;for(const[se,{authorityPrefix:K,resolver:ae,remoteAuthority:de}]of J.entries())try{if(se===J.length-1)fe("invoking final resolve()..."),g.mark(`code/extHost/willResolveAuthority/${K}`),be=await ae.resolve(de,{resolveAttempt:U,execServer:Ie}),g.mark(`code/extHost/didResolveAuthorityOK/${K}`),fe("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$LK.isManagedResolvedAuthority(be)?be:void 0));else{if(fe(`invoking resolveExecServer() for ${de}`),g.mark(`code/extHost/willResolveExecServer/${K}`),Ie=await ae.resolveExecServer?.(de,{resolveAttempt:U,execServer:Ie}),!Ie)throw new t.$MK(`Exec server was not available for ${de}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);g.mark(`code/extHost/didResolveExecServerOK/${K}`)}}catch(Re){return g.mark(`code/extHost/didResolveAuthorityError/${K}`),ee("returned an error",Re),ce.dispose(),ie(Re)}ce.dispose();const Me={environmentTunnels:be.environmentTunnels,features:be.tunnelFeatures},B={extensionHostEnv:be.extensionHostEnv,isTrusted:be.isTrusted,authenticationSession:be.authenticationSessionForInitializingExtensions?{id:be.authenticationSessionForInitializingExtensions.id,providerId:be.authenticationSessionForInitializingExtensions.providerId}:void 0};fe(`returned ${t.$LK.isManagedResolvedAuthority(be)?"managed authority":`${be.host}:${be.port}`}`);let _;if(t.$LK.isManagedResolvedAuthority(be)){const se=U;this.X.setFactory(se,be.makeConnection),_={authority:V,connectTo:new r.$1k(se),connectionToken:be.connectionToken}}else _={authority:V,connectTo:new r.$2k(be.host,be.port),connectionToken:be.connectionToken};return{type:"ok",value:{authority:_,options:B,tunnelInformation:Me}}}async $getCanonicalURI(V,U){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$4k)(V)})`);const{resolver:ne}=await this.sb(V);if(!ne)return null;const ye=y.URI.revive(U);if(typeof ne.getCanonicalURI>"u")return ye;const fe=await(0,L.$Sg)(()=>ne.getCanonicalURI(ye));return fe||ye}$startExtensionHost(V){V.toAdd.forEach(ye=>ye.extensionLocation=y.URI.revive(ye.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ue(this.I,this.L,this.J,V);return this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(V,U){return U===1?this.D.wait().then(ne=>this.Z(V,!1)):this.G.wait().then(ne=>this.Z(V,!1))}async $activate(V,U){return await this.G.wait(),this.J.getExtensionDescription(V)?(await this.$(V,U),!0):!1}async $deltaExtensions(V){V.toAdd.forEach(me=>me.extensionLocation=y.URI.revive(me.extensionLocation));const{globalRegistry:U,myExtensions:ne}=ue(this.I,this.L,this.J,V),ye=await this.bb(ne);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(U.getAllExtensionDescriptions()),this.J.set(ne),T.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(V){return V}async $test_up(V){return V.byteLength}async $test_down(V){const U=o.$fe.alloc(V),ne=Math.random()%256;for(let ye=0;ye<V;ye++)U.writeUInt8(ne,ye);return U}async $updateRemoteConnectionData(V){this.W=V,this.a.fire()}};e.$vfc=Y,e.$vfc=Y=W=Ke([We(0,h.$Yh),We(1,e.$ufc),We(2,l.$HM),We(3,f.$Uec),We(4,m.$Xec),We(5,A.$hj),We(6,u.$XM),We(7,c.$1ec),We(8,R.$Hxb),We(9,w.$jfc),We(10,F.$rfc),We(11,M.$sfc)],Y);function ue(ge,V,U,ne){ge.addActivationEvents(ne.addActivationEvents);const ye=new s.$I6b(ge,V.getAllExtensionDescriptions());ye.deltaExtensions(ne.toAdd,ne.toRemove);const fe=new n.$em(U.getAllExtensionDescriptions().map(ee=>ee.identifier));for(const ee of ne.myToRemove)fe.delete(ee);for(const ee of ne.myToAdd)fe.add(ee);const me=oe(ye,fe);return{globalRegistry:ye,myExtensions:me}}function Z(ge,V){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:V.activationEvent,reasonId:V.extensionId.value}}function Q(ge){return ge.getAllExtensionDescriptions().map(V=>V.identifier.value).join(",")}e.$wfc=(0,h.$Zh)("IExtHostExtensionService");class x{#e;#t;#i;constructor(V,U,ne,ye,fe){this.#e=V,this.#t=U,this.#i=ne.identifier,this.id=ne.identifier.value,this.extensionUri=ne.extensionLocation,this.extensionPath=N.$gc((0,I.$pg)(ne.extensionLocation)),this.packageJSON=ne,this.extensionKind=ye,this.isFromDifferentExtensionHost=fe}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$xfc=x;function oe(ge,V){return ge.getAllExtensionDescriptions().filter(U=>V.has(U.identifier))}class X{constructor(V){this.a=V}setSearchTree(V){this.a=V}findSubstr(V){return this.a.findSubstr(V)}forEach(V){return this.a.forEach(V)}}e.$yfc=X;class ve{constructor(V){this.a=new n.$fm,this.addActivationEvents(V)}readActivationEvents(V){return this.a.get(V.identifier)??[]}addActivationEvents(V){for(const U of Object.keys(V))this.a.set(U,V[U])}}}),define(Ee[363],Se([1,0,56,2,6,42,25,26,20,27,5,48,14,13]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;let f=class{constructor(o,a,t,r,h,u,c){this.c=o,this.d=a,this.e=t,this.f=r,this.g=h,this.h=u,this.i=c,this.a=new Map,this.b=[]}async install(){this.j(),D.mark("code/extHost/willWaitForConfig");const o=await this.f.getConfigProvider();D.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new s(this.c,a,this.d,o,this.i)),this.register(this.e.createInstance(d)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(o){if("nodeModuleName"in o)if(Array.isArray(o.nodeModuleName))for(const a of o.nodeModuleName)this.a.set(a,o);else this.a.set(o.nodeModuleName,o);typeof o.alternativeModuleName=="function"&&this.b.push(a=>o.alternativeModuleName(a))}};e.$Ggc=f,e.$Ggc=f=Ke([We(2,A.$Yh),We(3,I.$Xec),We(4,C.$wfc),We(5,y.$XM),We(6,m.$hj)],f);let d=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(o){if(o.environment.appRoot&&S.a.size){const a=(0,v.$Je)(this.c(o.environment.appRoot.fsPath)),t="[a-z0-9_.-]",r=`@${t}+\\/${t}+|${t}+`,h="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${h}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(o){if(!this.b)return;const a=this.b.exec(this.c(o));if(!a)return;const[,t,r,h]=a,u=S.a.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),t+u+h}c(o){return o.replace(/\\/g,"/")}};d=S=Ke([We(0,y.$XM)],d);class s{constructor(o,a,t,r,h){this.c=o,this.d=a,this.e=t,this.f=r,this.g=h,this.nodeModuleName="vscode",this.a=new b.$fm}load(o,a){const t=this.d.findSubstr(a);if(t){let r=this.a.get(t.identifier);return r||(r=this.c(t,this.e,this.f),this.a.set(t.identifier,r)),r}if(!this.b){let r="";this.d.forEach((h,u)=>r+=`	${u} -> ${h.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this.b=this.c(L.$LF,this.e,this.f)}return this.b}}let i=class{constructor(o,a,t){this.e=o,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(g.$EK.MainThreadTelemetry);const r=t.getProxy(g.$EK.MainThreadWindow);this.c=(h,u)=>{const c=N.URI.parse(h);return u?this.g(h,u):c.scheme==="http"||c.scheme==="https"?r.$openUri(c,h,{allowTunneling:!0}):c.scheme==="mailto"||c.scheme===this.f?r.$openUri(c,h,{}):this.g(h,u)}}load(o,a,t){const r=this.e.findSubstr(a);return r&&(this.a=r.identifier.value,this.h()),this.b=t(o),this.c}g(o,a){return this.i(),this.b(o,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ke([We(2,$.$HM)],i)}),define(Ee[58],Se([1,0,43,3,16,50,5,69,70,48,7,41,289,42]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,L.$Zh)("IExtHostVariableResolverProvider");class S extends m.$IN{constructor(s,i,n,o,a,t,r){function h(){if(n){const u=n.activeEditor();if(u)return u.document.uri;const c=o.tabGroups.all.find(l=>l.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof A.$nM||c.input instanceof A.$sM)return c.input.modified;if(c.input instanceof A.$mM||c.input instanceof A.$rM||c.input instanceof A.$pM)return c.input.uri}}}super({getFolderUri:u=>{const c=t.folders.filter(l=>l.name===u);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(u,c)=>a.getConfiguration(void 0,u).get(c),getAppRoot:()=>I.cwd(),getExecPath:()=>I.env.VSCODE_EXEC_PATH,getFilePath:()=>{const u=h();if(u)return g.$gc(u.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const u=h();if(u){const c=i.getWorkspaceFolder(u);if(c)return g.$gc(c.uri.fsPath)}}},getSelectedText:()=>{if(n){const u=n.activeEditor();if(u&&!u.selection.isEmpty)return u.document.getText(u.selection)}},getLineNumber:()=>{if(n){const u=n.activeEditor();if(u)return String(u.selection.end.line+1)}},getExtension:u=>s.getExtension(u)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(I.env))}}let f=class extends N.$Rc{constructor(s,i,n,o,a){super(),this.b=s,this.c=i,this.g=n,this.h=o,this.j=a,this.a=new D.$U(async()=>{const t=await this.h.getConfigProvider(),h={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async u=>{h.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,h,this.m())})}getResolver(){return this.a.value}m(){}};e.$Afc=f,e.$Afc=f=Ke([We(0,y.$wfc),We(1,C.$Uec),We(2,b.$SM),We(3,v.$Xec),We(4,$.$0ec)],f)}),define(Ee[96],Se([1,0,12,4,2,5,6,70,48,20,7,41,140,281,42,58]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,I.$Zh)("IExtHostDebugService");let d=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,h,u,c,l,k){this.E=h,this.F=u,this.G=c,this.H=l,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new N.$Rd,this.n=new N.$Rd,this.o=new N.$Rd,this.u=new N.$Rd,this.k=r.getProxy(L.$EK.MainThreadDebugService),this.y=new N.$Rd,this.A=new N.$Rd,this.v=new i(this.k),this.w=new Map,this.F.getExtensionRegistry().then(R=>{R.onDidChange(w=>{this.J(R)}),this.J(R)})}asDebugSourceUri(r,h){const u=r;if(typeof u.sourceReference=="number"&&u.sourceReference>0){let c=`debug:${encodeURIComponent(u.path||"")}`,l="?";return h&&(c+=`${l}session=${encodeURIComponent(h.id)}`,l="&"),c+=`${l}ref=${u.sourceReference}`,g.URI.parse(c)}else{if(u.path)return g.URI.file(u.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const h=[];for(const u of r.getAllExtensionDescriptions())if(u.contributes){const c=u.contributes.debuggers;if(c&&c.length>0)for(const l of c)(0,v.$nF)(l)&&h.push(l.type)}this.k.$registerDebugTypes(h)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(h=>r.push(h)),r}addBreakpoints(r){const h=r.filter(l=>{const k=l.id;return this.w.has(k)?!1:(this.w.set(k,l),!0)});this.U(h,[],[]);const u=[],c=new Map;for(const l of h)if(l instanceof A.$GL){let k=c.get(l.location.uri.toString());k||(k={type:"sourceMulti",uri:l.location.uri,lines:[]},c.set(l.location.uri.toString(),k),u.push(k)),k.lines.push({id:l.id,enabled:l.enabled,condition:l.condition,hitCondition:l.hitCondition,logMessage:l.logMessage,line:l.location.range.start.line,character:l.location.range.start.character})}else l instanceof A.$HL&&u.push({type:"function",id:l.id,enabled:l.enabled,hitCondition:l.hitCondition,logMessage:l.logMessage,condition:l.condition,functionName:l.functionName});return this.k.$registerBreakpoints(u)}removeBreakpoints(r){const h=r.filter(k=>this.w.delete(k.id));this.U([],h,[]);const u=h.filter(k=>k instanceof A.$GL).map(k=>k.id),c=h.filter(k=>k instanceof A.$HL).map(k=>k.id),l=h.filter(k=>k instanceof A.$IL).map(k=>k.id);return this.k.$unregisterBreakpoints(u,c,l)}startDebugging(r,h,u){return this.k.$startDebugging(r?r.uri:void 0,h,{parentSessionID:u.parentSession?u.parentSession.id:void 0,lifecycleManagedByParent:u.lifecycleManagedByParent,repl:u.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:u.noDebug,compact:u.compact,suppressSaveBeforeStart:u.suppressSaveBeforeStart,suppressDebugStatusbar:u.suppressDebugStatusbar??u.debugUI?.simple,suppressDebugToolbar:u.suppressDebugToolbar??u.debugUI?.simple,suppressDebugView:u.suppressDebugView??u.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,h,u){if(!h)return new A.$GK(()=>{});const c=this.d++;return this.f.push({type:r,handle:c,provider:h}),this.k.$registerDebugConfigurationProvider(r,u,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,c),new A.$GK(()=>{this.f=this.f.filter(l=>l.provider!==h),this.k.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(r,h,u){if(!u)return new A.$GK(()=>{});if(!this.Q(r,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.N(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this.g++;return this.h.push({type:h,handle:c,factory:u}),this.k.$registerDebugAdapterDescriptorFactory(h,c),new A.$GK(()=>{this.h=this.h.filter(l=>l.factory!==u),this.k.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(r,h){if(!h)return new A.$GK(()=>{});const u=this.i++;return this.j.push({type:r,handle:u,factory:h}),new A.$GK(()=>{this.j=this.j.filter(c=>c.factory!==h)})}async $runInTerminal(r,h){return Promise.resolve(void 0)}async $substituteVariables(r,h){let u;const c=await this.W(r);return c&&(u={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(u,h)}K(r,h){if(r.type==="implementation")return new o(r.implementation)}L(){}async $startDASession(r,h){const u=this,c=await this.V(h);return this.S(this.N(c.type),c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const k=this.M(l),R=this.K(k,c);if(!R)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const w=R;return this.B.set(r,w),this.R(c).then(p=>(p&&this.C.set(r,p),w.onMessage(async E=>{if(E.type==="request"&&E.command==="handshake"){const P=E,z={type:"response",seq:0,command:P.command,request_seq:P.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const j=await this.D.sign(P.arguments.value);z.body={signature:j},w.sendResponse(z)}else throw new Error("no signer")}catch(j){z.success=!1,z.message=j.message,w.sendResponse(z)}}else p&&p.onDidSendMessage&&p.onDidSendMessage(E),E=(0,v.$sF)(E,!0),u.k.$acceptDAMessage(r,E)}),w.onError(E=>{p&&p.onError&&p.onError(E),this.k.$acceptDAError(r,E.name,E.message,E.stack)}),w.onExit(E=>{p&&p.onExit&&p.onExit(E??void 0,void 0),this.k.$acceptDAExit(r,E??void 0,void 0)}),p&&p.onWillStartSession&&p.onWillStartSession(),w.startSession()))})}$sendDAMessage(r,h){h=(0,v.$rF)(h,!1);const u=this.C.get(r);u&&u.onWillReceiveMessage&&u.onWillReceiveMessage(h),this.B.get(r)?.sendMessage(h)}$stopDASession(r){const h=this.C.get(r);this.C.delete(r),h&&h.onWillStopSession&&h.onWillStopSession();const u=this.B.get(r);return this.B.delete(r),u?u.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const h=[],u=[],c=[];if(r.added)for(const l of r.added){const k=l.id;if(k&&!this.w.has(k)){let R;if(l.type==="function")R=new A.$HL(l.functionName,l.enabled,l.condition,l.hitCondition,l.logMessage);else if(l.type==="data")R=new A.$IL(l.label,l.dataId,l.canPersist,l.enabled,l.hitCondition,l.condition,l.logMessage);else{const w=g.URI.revive(l.uri);R=new A.$GL(new A.$SK(w,new A.$HK(l.line,l.character)),l.enabled,l.condition,l.hitCondition,l.logMessage)}(0,A.$EL)(R,k),this.w.set(k,R),h.push(R)}}if(r.removed)for(const l of r.removed){const k=this.w.get(l);k&&(this.w.delete(l),u.push(k))}if(r.changed){for(const l of r.changed)if(l.id){const k=this.w.get(l.id);if(k){if(k instanceof A.$HL&&l.type==="function"){const R=k;R.enabled=l.enabled,R.condition=l.condition,R.hitCondition=l.hitCondition,R.logMessage=l.logMessage,R.functionName=l.functionName}else if(k instanceof A.$GL&&l.type==="source"){const R=k;R.enabled=l.enabled,R.condition=l.condition,R.hitCondition=l.hitCondition,R.logMessage=l.logMessage,R.location=new A.$SK(g.URI.revive(l.uri),new A.$HK(l.line,l.character))}c.push(k)}}}this.U(h,u,c)}async $acceptStackFrameFocus(r){let h;const u=r.sessionId?await this.V(r.sessionId):void 0;if(!u)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?h=new A.$OL(u,r.threadId):h=new A.$NL(u,r.threadId,r.frameId),this.z=h,this.A.fire(this.z)}$provideDebugConfigurations(r,h,u){return(0,D.$Sg)(async()=>{const c=this.P(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const l=await this.W(h);return c.provideDebugConfigurations(l,u)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(r,h,u,c){return(0,D.$Sg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(h);return l.resolveDebugConfiguration(k,u,c)})}$resolveDebugConfigurationWithSubstitutedVariables(r,h,u,c){return(0,D.$Sg)(async()=>{const l=this.P(r);if(!l)throw new Error("no DebugConfigurationProvider found");if(!l.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(h);return l.resolveDebugConfigurationWithSubstitutedVariables(k,u,c)})}async $provideDebugAdapter(r,h){const u=this.O(r);if(!u)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.V(h);return this.S(u,c).then(l=>{if(!l)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.M(l)})}async $acceptDebugSessionStarted(r){const h=await this.V(r);this.m.fire(h)}async $acceptDebugSessionTerminated(r){const h=await this.V(r);h&&(this.n.fire(h),this.l.delete(h.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,h){(await this.V(r))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(r,h){const c={session:await this.V(r),event:h.event,body:h.body};this.u.fire(c)}M(r){if(r instanceof A.$JL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof A.$KL)return{type:"server",port:r.port,host:r.host};if(r instanceof A.$LL)return{type:"pipeServer",path:r.path};if(r instanceof A.$ML)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const h=this.h.filter(u=>u.type===r);if(h.length>0)return h[0].factory}O(r){const h=this.h.filter(u=>u.handle===r);if(h.length>0)return h[0].factory}P(r){const h=this.f.filter(u=>u.handle===r);if(h.length>0)return h[0].provider}Q(r,h){if(r.contributes){const u=r.contributes.debuggers;if(u&&u.length>0){for(const c of u)if(c.label&&c.type&&c.type===h)return!0}}return!1}R(r){const u=r.configuration.type,c=this.j.filter(l=>l.type===u||l.type==="*").map(l=>(0,D.$Sg)(()=>l.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(c).then(l=>{const k=l.filter(R=>!!R);if(k.length>0)return new n(k)}),new Promise(l=>setTimeout(()=>l(void 0),1e3))]).catch(l=>{})}async S(r,h){const u=h.configuration.debugServer;if(typeof u=="number")return Promise.resolve(new A.$KL(u));if(r){const l=await this.F.getExtensionRegistry();return(0,D.$Sg)(()=>r.createDebugAdapterDescriptor(h,this.T(h,l))).then(k=>{if(k)return k})}const c=await this.F.getExtensionRegistry();return Promise.resolve(this.T(h,c))}T(r,h){}U(r,h,u){(r.length>0||h.length>0||u.length>0)&&this.y.fire(Object.freeze({added:r,removed:h,changed:u}))}async V(r){if(r)if(typeof r=="string"){const h=this.l.get(r);if(h)return h}else{let h=this.l.get(r.id);if(!h){const u=await this.W(r.folderUri),c=r.parent?this.l.get(r.parent):void 0;h=new s(this.k,r.id,r.type,r.name,u,r.configuration,c),this.l.set(h.id,h),this.k.$sessionCached(h.id)}return h}throw new Error("cannot find session")}W(r){if(r){const h=g.URI.revive(r);return this.E.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}};e.$Cfc=d,e.$Cfc=d=Ke([We(0,y.$HM),We(1,C.$Uec),We(2,$.$wfc),We(3,S.$Xec),We(4,b.$0ec),We(5,f.$zfc)],d);class s{constructor(r,h,u,c,l,k,R){this.d=r,this.f=h,this.g=u,this.h=c,this.i=l,this.j=k,this.k=R}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,h){return this.d.$customDebugAdapterRequest(this.f,r,h)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Dfc=s;class i{constructor(r){this.value=Object.freeze({append(h){r.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$Efc=i;class n{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(h=>h.onError?h.onError(r):void 0)}onExit(r,h){this.d.forEach(u=>u.onExit?u.onExit(r,h):void 0)}}class o extends m.$Pfb{constructor(r){super(),this.h=r,r.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let a=class extends d{constructor(r,h,u,c,l,k){super(r,h,u,c,l,k)}};e.$Ffc=a,e.$Ffc=a=Ke([We(0,y.$HM),We(1,C.$Uec),We(2,$.$wfc),We(3,S.$Xec),We(4,b.$0ec),We(5,f.$zfc)],a)}),define(Ee[364],Se([1,0,8,56,2,6,352,14,106,107,27,247,20,66,48,90]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0;class d{static async installEarlyHandler(n){Error.stackTraceLimit=100;const o=n.get(b.$hj),t=n.get(m.$HM).getProxy(I.$EK.MainThreadErrors);D.setUnexpectedErrorHandler(r=>{o.error(r);const h=D.$2(r);t.$onUnexpectedError(h)})}static async installFullHandler(n){const o=n.get(b.$hj),a=n.get(m.$HM),t=n.get(S.$wfc),r=n.get(f.$2M),h=a.getProxy(I.$EK.MainThreadExtensionService),u=a.getProxy(I.$EK.MainThreadErrors),c=await t.getExtensionPathIndex(),l=new WeakMap;function k(p,E){if(l.has(p))return l.get(p).stack;let P="",z,j;for(const O of E)P+=`
	at ${O.toString()}`,j=O.getFileName(),!z&&j&&(z=c.findSubstr(g.URI.file(j)));const F=`${p.name||"Error"}: ${p.message||""}${P}`;return l.set(p,{extensionIdentifier:z?.identifier,stack:F}),F}const R=Symbol("prepareStackTrace wrapped");let w=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return w},set(p){if(p===k||!p||p[R]){w=p||k;return}w=function(E,P){return k(E,P),p.call(Error,E,P)},Object.assign(w,{[R]:!0})}}),D.setUnexpectedErrorHandler(p=>{o.error(p);const E=D.$2(p),P=l.get(p);if(!P?.extensionIdentifier){u.$onUnexpectedError(E);return}h.$onExtensionRuntimeError(P.extensionIdentifier,E);const z=r.onExtensionError(P.extensionIdentifier,p);o.trace("forwarded error to extension?",z,P)})}}e.$Hgc=d;class s{constructor(n,o,a,t,r){this.a=a,this.b=new L.$Q6b(n,null,t),o=s.e(o,this.b);const h=new y.$Xh(...(0,$.$Hr)());h.set(A.$XM,{_serviceBrand:void 0,...o,messagePorts:r}),h.set(m.$HM,new m.$IM(this.b)),h.set(v.$Rec,new v.$Sec(t)),h.set(S.$ufc,a);const u=new C.$nq(h,!0);u.invokeFunction(d.installEarlyHandler),this.d=u.invokeFunction(c=>c.get(b.$hj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",o),this.c=u.invokeFunction(c=>c.get(S.$wfc)),this.c.initialize(),u.invokeFunction(d.installFullHandler)}async asBrowserUri(n){const o=this.b.getProxy(I.$EK.MainThreadExtensionService);return g.URI.revive(await o.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,o){n.extensions.allExtensions.forEach(t=>{t.extensionLocation=g.URI.revive(o.transformIncomingURIs(t.extensionLocation))}),n.environment.appRoot=g.URI.revive(o.transformIncomingURIs(n.environment.appRoot));const a=n.environment.extensionDevelopmentLocationURI;return a&&(n.environment.extensionDevelopmentLocationURI=a.map(t=>g.URI.revive(o.transformIncomingURIs(t)))),n.environment.extensionTestsLocationURI=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=g.URI.revive(o.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=g.URI.revive(o.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=g.URI.revive(o.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=g.URI.revive(o.transformIncomingURIs(n.logsLocation)),n.workspace=o.transformIncomingURIs(n.workspace),n}}e.$Igc=s}),define(Ee[365],Se([1,0,12,11,222,241,138,96,70,48,20,47,7,58,41,282,283,42]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;let i=class extends b.$Cfc{constructor(r,h,u,c,l,k,R){super(r,h,u,c,k,R),this.Z=l,this.X=new a}K(r,h){switch(r.type){case"server":return new f.$Ngc(r);case"pipeServer":return new f.$Ogc(r);case"executable":return new f.$Pgc(r,h.type)}return super.K(r,h)}T(r,h){const u=f.$Pgc.platformAdapterExecutable(h.getAllExtensionDescriptions(),r.type);if(u)return new m.$JL(u.command,u.args,u.options)}L(){return new L.$F0b}async $runInTerminal(r,h){if(r.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(F=>{this.X.onTerminalClosed(F)}));const u=await this.G.getConfigProvider(),c=this.Z.getDefaultShell(!0),l=this.Z.getDefaultShellArgs(!0),k=r.title||g.localize(0,null),R=JSON.stringify({shell:c,shellArgs:l});let w=await this.X.checkout(R,k),p,E=!1;if(w)p=r.cwd;else{const F={shellPath:c,shellArgs:l,cwd:r.cwd,name:k,iconPath:new m.$BL("debug")};E=!0,w=this.Z.createTerminalFromOptions(F,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(w,R)}w.show(!0);const P=await w.processId;E?await new Promise(F=>setTimeout(F,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?w.sendText("cls"):c.indexOf("bash")>=0?w.sendText("clear"):N.$i?w.sendText("cls"):w.sendText("clear"));const z=(0,d.$Rgc)(c,r.args,!!r.argsCanBeInterpretedByShell,p,r.env);w.sendText(z);const j=this.onDidTerminateDebugSession(F=>{F.id===h&&(this.X.free(w),j.dispose())});return P}else if(r.kind==="external")return o(r,await this.G.getConfigProvider());return super.$runInTerminal(r,h)}};e.$Sgc=i,e.$Sgc=i=Ke([We(0,A.$HM),We(1,S.$Uec),We(2,y.$wfc),We(3,s.$Xec),We(4,C.$jfc),We(5,$.$0ec),We(6,v.$zfc)],i);let n;function o(t,r){if(!n)if(N.$i)n=new I.$r9b;else if(N.$j)n=new I.$s9b;else if(N.$k)n=new I.$t9b;else throw new Error("external terminals not supported on this platform");const h=r.getConfiguration("terminal");return n.runInTerminal(t.title,t.cwd,t.args,t.env||{},h.external||{})}class a{constructor(){this.b=new Map}static{this.a=1e3}async checkout(r,h){const c=[...this.b.entries()].map(([l,k])=>(0,D.$Ng)(async R=>{if(l.name!==h||k.lastUsedAt!==-1&&await(0,d.$Qgc)(await l.processId))return null;const w=Date.now();return k.lastUsedAt+a.a>w||R.isCancellationRequested||k.config!==r?null:(k.lastUsedAt=w,l)}));return await(0,D.$5g)(c,l=>!!l)}insert(r,h){this.b.set(r,{lastUsedAt:Date.now(),config:h})}free(r){const h=this.b.get(r);h&&(h.lastUsedAt=-1)}onTerminalClosed(r){this.b.delete(r)}}}),define(Ee[366],Se([1,0,16,2,104,41,69,42,40,47,20,27,95,17,14,91,23,63,58]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=void 0;let n=class extends m.$mgc{constructor(a,t,r,h,u,c,l,k,R){super(a,t,r,h,u,c,l,k),this.B=r,this.C=R,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(v.Schemas.file,{scheme:v.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const r=t;if(!t.execution&&r._id===void 0)throw new Error("Tasks to execute must include an execution");if(r._id!==void 0){const h=m.TaskHandleDTO.from(r,this.B),u=await this.a.$getTaskExecution(h);if(u.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(u,t);return this.a.$executeTask(h).catch(()=>{}),c}else{const h=m.TaskDTO.from(t,a);if(h===void 0)return Promise.reject(new Error("Task is not valid"));m.CustomExecutionDTO.is(h.execution)&&await this.x(h,t,!1);const u=await this.y(await this.a.$getTaskExecution(h),t);return this.a.$executeTask(h).catch(()=>{}),u}}u(a,t,r,h){const u=[];if(h)for(const c of h){this.z(c,r),(!c.definition||!a[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const l=m.TaskDTO.from(c,r.extension);l&&(u.push(l),m.CustomExecutionDTO.is(l.execution)&&t.push(this.x(l,c,!0)))}return{tasks:u,extension:r.extension}}async v(a){return a}async F(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const r=N.URI.file((0,s.homedir)());t=new $.$hi({uri:r,name:d.$yg(r),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const r=N.URI.revive(a),h={process:void 0,variables:Object.create(null)},u=await this.b.resolveWorkspaceFolder(r),c=await this.b.getWorkspaceFolders2()??[],l=await this.C.getResolver(),k=u?{uri:u.uri,name:u.name,index:u.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const R of t.variables)h.variables[R]=await l.resolveAsync(k,R);if(t.process!==void 0){let R;if(t.process.path!==void 0){R=t.process.path.split(D.$sc);for(let w=0;w<R.length;w++)R[w]=await l.resolveAsync(k,R[w])}h.process=await g.win32.findExecutable(await l.resolveAsync(k,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(k,t.process.cwd):void 0,R)}return h}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,r){return g.win32.findExecutable(a,t,r)}};e.$Kgc=n,e.$Kgc=n=Ke([We(0,A.$HM),We(1,C.$XM),We(2,I.$Uec),We(3,L.$SM),We(4,b.$Xec),We(5,y.$jfc),We(6,S.$hj),We(7,f.$Cec),We(8,i.$zfc)],n)}),define(Ee[367],Se([1,0,63,58]),function($e,e,D,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qhc=void 0;class g extends N.$Afc{m(){return(0,D.homedir)()}}e.$qhc=g}),define(Ee[154],Se([1,0,19,12,21,44,17,16,23,2,36]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0;class C{constructor(i,n,o,a){this.d=i,this.e=n,this.f=o,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,n){const o=this.d.folderQueries||[],a=new g.$2d(n);return new Promise((t,r)=>{this.a=new v(i);let h=!1;const u=(c,l)=>{if(!h&&!this.b){const k=this.h(c);f(c)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,h=!0,a.cancel(),c=this.j(c,this.d.maxResults-this.c));const R=this.h(c);this.c+=R,(R>0||!f(c))&&this.a.add(c,l)}};Promise.all(o.map((c,l)=>this.k(c,k=>u(k,l),a.token))).then(c=>{a.dispose(),this.a.flush();const l=c.some(k=>!!k&&!!k.limitHit);t({limitHit:this.b||l,messages:(0,D.$Qb)(c.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},c=>{a.dispose();const l=(0,I.$Ki)(c);r(new Error(l))})})}h(i){return f(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,n){const o=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:o.slice(0,n),preview:{matches:a.slice(0,n),text:i.preview.text},uri:i.uri}}async k(i,n,o){const a=new A.$iJ(this.d,i),t=[],r={report:c=>{if(!this.l(c))return;const l=i.folder.scheme===L.Schemas.file?(0,A.$jJ)(()=>this.f.readdir($.$Ag(c.uri))):void 0,k=$.$Dg(i.folder,c.uri);if(k){const R=a.includedInQuery(k,b.$mc(k),l);(0,N.$Mg)(R)?t.push(R.then(w=>{w&&n(c)})):R&&n(c)}}},h=this.n(i),u=await this.e.provideTextSearchResults(m(this.d.contentPattern),h,r,o);return t.length&&await Promise.all(t),u}l(i){if(f(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const n=(0,A.$hJ)(this.d.includePattern,i.includePattern),o=(0,A.$hJ)(this.d.excludePattern,i.excludePattern),a={folder:y.URI.from(i.folder),excludes:o,includes:n,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$Tfc=C;function m(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class v{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new d(512,n=>this.g(n))}add(i,n){this.d&&(this.b!==n||!$.$ug(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Ufc=v;function S(s){return f(s)?{preview:{matches:(0,D.$1b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,D.$1b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function f(s){return!!s.preview}e.$Vfc=f;class d{static{this.a=4e3}static{this.b=50}constructor(i,n){this.g=i,this.h=n,this.c=0,this.d=[],this.e=0}addItem(i,n){i&&this.j(i,n)}addItems(i,n){i&&this.k(i,n)}j(i,n){this.d.push(i),this.e+=n,this.l()}k(i,n){this.d=this.d.concat(i),this.e+=n,this.l()}l(){this.c<d.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},d.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Wfc=d}),define(Ee[97],Se([1,0,3,6,5,360,20,66,14,2,154]),function($e,e,D,N,g,I,L,b,$,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=e.$Xfc=void 0,e.$Xfc=(0,g.$Zh)("IExtHostSearch");let C=class{constructor(f,d,s){this.k=f,this.l=d,this.n=s,this.c=this.k.getProxy(N.$EK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new I.$Sfc}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,d){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const s=this.d++;return this.e.set(s,d),this.c.$registerTextSearchProvider(s,this.o(f)),(0,D.$Pc)(()=>{this.g.delete(f),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(f,d){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const s=this.d++;return this.h.set(s,d),this.c.$registerFileSearchProvider(s,this.o(f)),(0,D.$Pc)(()=>{this.i.delete(f),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(f,d,s,i){const n=m(s),o=this.h.get(f);if(o)return this.j.fileSearch(n,o,a=>{this.c.$handleFileMatch(f,d,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+f)}async doInternalFileSearchWithCustomCallback(f,d,s){return{messages:[]}}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,d,s,i){const n=this.e.get(f);if(!n||!n.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const o=m(s);return this.q(o,n).search(t=>this.c.$handleTextMatch(f,d,t),i)}$enableExtensionHostSearch(){}q(f,d){return new A.$Tfc(f,d,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Yfc=C,e.$Yfc=C=Ke([We(0,L.$HM),We(1,b.$Rec),We(2,$.$hj)],C);function m(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(v),extraFileResources:S.extraFileResources&&S.extraFileResources.map(f=>y.URI.revive(f))}}e.$Zfc=m;function v(S){return{...S,folder:y.URI.revive(S.folder)}}}),define(Ee[368],Se([1,0,21,8,4,3,17,39,2,132,190,171,79,26,32,14,65,87,266,6,304,312,91,305,306,307,308,309,310,311,287,35,313,42,343,96,149,315,316,317,293,318,69,70,319,48,320,71,321,57,27,322,323,324,325,326,327,115,116,328,359,295,272,296,329,330,152,331,297,332,333,20,334,97,117,335,336,337,118,92,95,90,47,338,339,284,340,298,72,15,7,341,66,342,93,344,345,151,41,280,114,25,94]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h,u,c,l,k,R,w,p,E,P,z,j,F,O,T,M,W,Y,ue,Z,Q,x,oe,X,ve,ge,V,U,ne,ye,fe,me,ee,ie,G,te,J,ce,be,Ie,Me,B,_,se,K,ae,de,Re,Be,Xe,Ye,it,st,Pe,Te,qe,Le,xe,he,le,Ce,Ve,Ge,_e,ot,ut,je,kt,Ht,jt,yt,Wt,zt,Kt,Gt,Rt,Ct,tt,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;function qt(lt){const mt=lt.get(V.$XM),Zt=lt.get(ge.$zec),It=lt.get(X.$Zec),St=lt.get(x.$wfc),ft=lt.get(Gt.$Uec),At=lt.get(xe.$2M),Ot=lt.get(P.$Xec),Et=lt.get(Ht.$Rec),Qe=lt.get(Re.$HM),Lt=lt.get(Te.$gfc),Ut=lt.get(qe.$1ec),Qt=lt.get(f.$ij),gt=lt.get(f.$hj),Fe=lt.get(ot.$Hxb),Ne=lt.get(t.$Cec),De=lt.get(Kt.$Bgc),re=lt.get(Ye.$ofc),Oe=lt.get(Z.$0ec),He=lt.get(G.$sfc);Qe.set(n.$FK.ExtHostFileSystemInfo,Zt),Qe.set(n.$FK.ExtHostLogLevelServiceShape,Qt),Qe.set(n.$FK.ExtHostWorkspace,ft),Qe.set(n.$FK.ExtHostConfiguration,Ot),Qe.set(n.$FK.ExtHostExtensionService,St),Qe.set(n.$FK.ExtHostStorage,Lt),Qe.set(n.$FK.ExtHostTunnelService,Fe),Qe.set(n.$FK.ExtHostWindow,De),Qe.set(n.$FK.ExtHostSecretState,re),Qe.set(n.$FK.ExtHostTelemetry,At),Qe.set(n.$FK.ExtHostEditorTabs,Oe),Qe.set(n.$FK.ExtHostManagedSockets,He);const et=Qe.set(n.$FK.ExtHostDecorations,lt.get(F.$Hfc)),Je=Qe.set(n.$FK.ExtHostDocumentsAndEditors,lt.get(ue.$SM)),rt=Qe.set(n.$FK.ExtHostCommands,lt.get(p.$4M)),$t=Qe.set(n.$FK.ExtHostTerminalService,lt.get(he.$jfc)),pt=Qe.set(n.$FK.ExtHostDebugService,lt.get(j.$Bfc)),Mt=Qe.set(n.$FK.ExtHostSearch,lt.get(Xe.$Xfc)),wt=Qe.set(n.$FK.ExtHostTask,lt.get(Le.$ogc)),Nt=Qe.set(n.$FK.ExtHostOutputService,lt.get(_.$bgc)),Vt=Qe.set(n.$FK.ExtHostLocalization,lt.get(ie.$rfc)),mi=Qe.set(n.$FK.ExtHostUrls,new jt.$ygc(Qe)),Pt=Qe.set(n.$FK.ExtHostDocuments,new Y.$xec(Qe,Je)),Si=Qe.set(n.$FK.ExtHostDocumentContentProviders,new M.$Jfc(Qe,Je,gt)),qi=Qe.set(n.$FK.ExtHostDocumentSaveParticipant,new W.$Kfc(gt,Pt,Qe.getProxy(n.$EK.MainThreadBulkEdits))),Dt=Qe.set(n.$FK.ExtHostNotebook,new J.$1fc(Qe,rt,Je,Pt,It,Mt)),ni=Qe.set(n.$FK.ExtHostNotebookDocuments,new be.$8fc(Dt)),$i=Qe.set(n.$FK.ExtHostNotebookEditors,new Ie.$9fc(gt,Dt)),ai=Qe.set(n.$FK.ExtHostNotebookKernels,new Me.$0fc(Qe,mt,Dt,rt,gt)),Di=Qe.set(n.$FK.ExtHostNotebookRenderers,new B.$_fc(Qe,Dt)),Ci=Qe.set(n.$FK.ExtHostNotebookDocumentSaveParticipant,new ce.$7fc(gt,Dt,Qe.getProxy(n.$EK.MainThreadBulkEdits))),Ft=Qe.set(n.$FK.ExtHostEditors,new Ce.$Oec(Qe,Je)),bi=Qe.set(n.$FK.ExtHostTreeViews,new _e.$wgc(Qe.getProxy(n.$EK.MainThreadTreeViews),rt,gt)),Ii=Qe.set(n.$FK.ExtHostEditorInsets,new w.$Pec(Qe.getProxy(n.$EK.MainThreadEditorInsets),Ft,mt.remote)),ci=Qe.set(n.$FK.ExtHostDiagnostics,new O.$Bec(Qe,gt,Zt,Je)),ui=Qe.set(n.$FK.ExtHostLanguages,new ee.$5fc(Qe,Pt,rt.converter,Et)),ht=Qe.set(n.$FK.ExtHostLanguageFeatures,new me.$Fec(Qe,Et,Pt,rt,ci,gt,Ne,At)),Vi=Qe.set(n.$FK.ExtHostFileSystem,new oe.$Mfc(Qe,ht)),xt=Qe.set(n.$FK.ExtHostFileSystemEventService,new ve.$Nfc(Qe,gt,Je)),ri=Qe.set(n.$FK.ExtHostQuickOpen,(0,de.$fgc)(Qe,ft,rt)),di=Qe.set(n.$FK.ExtHostSCM,new Be.$hgc(Qe,rt,Pt,gt)),Pi=Qe.set(n.$FK.ExtHostQuickDiff,new ae.$egc(Qe,Et)),Hi=Qe.set(n.$FK.ExtHostShare,new it.$igc(Qe,Et)),Ri=Qe.set(n.$FK.ExtHostComments,(0,E.$Qec)(Qe,rt,Pt)),pi=Qe.set(n.$FK.ExtHostProgress,new K.$dgc(Qe.getProxy(n.$EK.MainThreadProgress))),Ki=Qe.set(n.$FK.ExtHosLabelService,new fe.$4fc(Qe)),Ai=Qe.set(n.$FK.ExtHostTheming,new Ve.$tgc(Qe)),li=Qe.set(n.$FK.ExtHostAuthentication,new r.$Hec(Qe)),Gi=Qe.set(n.$FK.ExtHostTimeline,new Ge.$vgc(Qe,rt)),wi=Qe.set(n.$FK.ExtHostWebviews,new yt.$5ec(Qe,mt.remote,ft,gt,Ne)),Li=Qe.set(n.$FK.ExtHostWebviewPanels,new Wt.$8ec(Qe,wi,ft)),cn=Qe.set(n.$FK.ExtHostCustomEditors,new z.$9ec(Qe,Pt,Ut,wi,Li)),Mi=Qe.set(n.$FK.ExtHostWebviewViews,new zt.$zgc(Qe,wi)),si=Qe.set(n.$FK.ExtHostTesting,new le.$pgc(Qe,rt,Je)),un=Qe.set(n.$FK.ExtHostUriOpeners,new kt.$xgc(Qe)),ln=Qe.set(n.$FK.ExtHostProfileContentHandlers,new se.$cgc(Qe));Qe.set(n.$FK.ExtHostInteractive,new ne.$2fc(Qe,Dt,Je,rt,gt));const Ji=Qe.set(n.$FK.ExtHostInlineChat,new U.$Ofc(Qe,rt,Pt,gt)),fi=Qe.set(n.$FK.ExtHostChatProvider,new l.$Kec(Qe,gt)),Qi=Qe.set(n.$FK.ExtHostChatAgents2,new c.$Lec(Qe,fi,gt)),Zi=Qe.set(n.$FK.ExtHostChatVariables,new k.$Mec(Qe)),gi=Qe.set(n.$FK.ExtHostChat,new u.$Jec(Qe)),Yi=Qe.set(n.$FK.ExtHostAiRelatedInformation,new o.$wec(Qe)),Fi=Qe.set(n.$FK.ExtHostAiEmbeddingVector,new Q.$Lfc(Qe)),Ti=Qe.set(n.$FK.ExtHostIssueReporter,new ye.$3fc(Qe)),_t=Qe.set(n.$FK.ExtHostStatusBar,new Pe.$lgc(Qe,rt.converter)),vi=Qe.set(n.$FK.ExtHostSpeech,new st.$jgc(Qe)),hn=Object.values(n.$FK);Qe.assertRegistered(hn);const Yt=new h.$Iec(Qe,Je),yi=new R.$Nec(Qe),Ei=new te.$6fc(Qe,gt),Oi=new T.$Ifc(Qe);return a.$Gec.register(rt),function(Ue,ei,Xi){const bt=function(){let pe=!Ue.isUnderDevelopment;function ke(){pe||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function ze(at){if(Array.isArray(at))at.forEach(ze);else if(typeof at=="string")ke();else{const vt=at;typeof vt.scheme>"u"&&ke(),typeof vt.exclusive=="boolean"&&(0,tt.$RF)(Ue,"documentFiltersExclusive")}return at}}(),xi={getSession(pe,ke,ze){return li.getSession(Ue,pe,ke,ze)},getSessions(pe,ke){return(0,tt.$RF)(Ue,"authGetSessions"),li.getSessions(Ue,pe,ke)},async hasSession(pe,ke){return(0,tt.$RF)(Ue,"authSession"),!!await li.getSession(Ue,pe,ke,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(pe,ke,ze,at){return li.registerAuthenticationProvider(pe,ke,ze,at)}},dn={registerCommand(pe,ke,ze){return rt.registerCommand(!0,pe,ke,ze,void 0,Ue)},registerTextEditorCommand(pe,ke,ze){return rt.registerCommand(!0,pe,(...at)=>{const vt=Ft.getActiveTextEditor();if(!vt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return vt.edit(Tt=>{ke.apply(ze,[vt,Tt,...at])}).then(Tt=>{Tt||gt.warn("Edits from command "+pe+" were not applied.")},Tt=>{gt.warn("An error occurred while running command "+pe,Tt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(pe,ke,ze)=>((0,tt.$RF)(Ue,"diffCommand"),rt.registerCommand(!0,pe,async(...at)=>{const vt=Je.activeEditor(!0);if(!vt){gt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(vt.id);ke.apply(ze,[Tt,...at])},void 0,void 0,Ue)),executeCommand(pe,...ke){return rt.executeCommand(pe,...ke)},getCommands(pe=!1){return rt.getCommands(pe)}},_i={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return $t.getDefaultShell(!1)},get onDidChangeShell(){return $t.onDidChangeShell},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,tt.$RF)(Ue,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,tt.$RF)(Ue,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,xe.$1M)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe,ke){return xe.$ZM.validateSender(pe),At.instantiateLogger(Ue,pe,ke)},openExternal(pe,ke){return De.openUri(pe,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ke?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===mt.environment.appUriScheme)return mi.createAppUri(pe);try{return await De.asExternalUri(pe,{allowTunneling:!!mt.remote.authority})}catch(ke){if((0,L.$$f)(pe,L.Schemas.http)||(0,L.$$f)(pe,L.Schemas.https))return pe;throw ke}},get remoteName(){return(0,d.$6k)(mt.remote.authority)},get remoteAuthority(){return(0,tt.$RF)(Ue,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return gt.onDidChangeLogLevel},registerIssueUriRequestHandler(pe){return(0,tt.$RF)(Ue,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Ue,pe)},registerIssueDataProvider(pe){return(0,tt.$RF)(Ue,"handleIssueUri"),Ti.registerIssueDataProvider(Ue,pe)},get appQuality(){return(0,tt.$RF)(Ue,"resolvers"),mt.quality},get appCommit(){return(0,tt.$RF)(Ue,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(pe,ke,ze){return si.createTestController(Ue,pe,ke,ze)},createTestObserver(){return(0,tt.$RF)(Ue,"testObserver"),si.createTestObserver()},runTests(pe){return(0,tt.$RF)(Ue,"testObserver"),si.runTests(pe)},get onDidChangeTestResults(){return(0,tt.$RF)(Ue,"testObserver"),si.onResultsChanged},get testResults(){return(0,tt.$RF)(Ue,"testObserver"),si.results}},hi=mt.remote.isRemote?je.ExtensionKind.Workspace:je.ExtensionKind.UI,tn={getExtension(pe,ke){(0,tt.$QF)(Ue,"extensionsAny")||(ke=!1);const ze=ei.mine.getExtensionDescription(pe);if(ze)return new x.$xfc(St,Ue.identifier,ze,hi,!1);if(ke){const at=ei.all.getExtensionDescription(pe);if(at)return new x.$xfc(St,Ue.identifier,at,hi,!0)}},get all(){const pe=[];for(const ke of ei.mine.getAllExtensionDescriptions())pe.push(new x.$xfc(St,Ue.identifier,ke,hi,!1));return pe},get allAcrossExtensionHosts(){(0,tt.$RF)(Ue,"extensionsAny");const pe=new v.$em(ei.mine.getAllExtensionDescriptions().map(ze=>ze.identifier)),ke=[];for(const ze of ei.all.getAllExtensionDescriptions()){const at=!pe.has(ze.identifier);ke.push(new x.$xfc(St,Ue.identifier,ze,hi,at))}return ke},get onDidChange(){return(0,tt.$QF)(Ue,"extensionsAny")?g.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(pe){return ci.createDiagnosticCollection(Ue.identifier,pe)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:pe=>ci.getDiagnostics(pe),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(pe,ke){return ui.changeLanguage(pe.uri,ke)},match(pe,ke){const ze=Pt.getDocumentData(ke.uri)?.notebook;return(0,A.$kt)(ut.LanguageSelector.from(pe),ke.uri,ke.languageId,!0,ze?.uri,ze?.notebookType)},registerCodeActionsProvider(pe,ke,ze){return ht.registerCodeActionProvider(Ue,bt(pe),ke,ze)},registerDocumentPasteEditProvider(pe,ke,ze){return(0,tt.$RF)(Ue,"documentPaste"),ht.registerDocumentPasteEditProvider(Ue,bt(pe),ke,ze)},registerCodeLensProvider(pe,ke){return ht.registerCodeLensProvider(Ue,bt(pe),ke)},registerDefinitionProvider(pe,ke){return ht.registerDefinitionProvider(Ue,bt(pe),ke)},registerDeclarationProvider(pe,ke){return ht.registerDeclarationProvider(Ue,bt(pe),ke)},registerImplementationProvider(pe,ke){return ht.registerImplementationProvider(Ue,bt(pe),ke)},registerTypeDefinitionProvider(pe,ke){return ht.registerTypeDefinitionProvider(Ue,bt(pe),ke)},registerHoverProvider(pe,ke){return ht.registerHoverProvider(Ue,bt(pe),ke,Ue.identifier)},registerEvaluatableExpressionProvider(pe,ke){return ht.registerEvaluatableExpressionProvider(Ue,bt(pe),ke,Ue.identifier)},registerInlineValuesProvider(pe,ke){return ht.registerInlineValuesProvider(Ue,bt(pe),ke,Ue.identifier)},registerDocumentHighlightProvider(pe,ke){return ht.registerDocumentHighlightProvider(Ue,bt(pe),ke)},registerMultiDocumentHighlightProvider(pe,ke){return ht.registerMultiDocumentHighlightProvider(Ue,bt(pe),ke)},registerLinkedEditingRangeProvider(pe,ke){return ht.registerLinkedEditingRangeProvider(Ue,bt(pe),ke)},registerReferenceProvider(pe,ke){return ht.registerReferenceProvider(Ue,bt(pe),ke)},registerRenameProvider(pe,ke){return ht.registerRenameProvider(Ue,bt(pe),ke)},registerDocumentSymbolProvider(pe,ke,ze){return ht.registerDocumentSymbolProvider(Ue,bt(pe),ke,ze)},registerWorkspaceSymbolProvider(pe){return ht.registerWorkspaceSymbolProvider(Ue,pe)},registerDocumentFormattingEditProvider(pe,ke){return ht.registerDocumentFormattingEditProvider(Ue,bt(pe),ke)},registerDocumentRangeFormattingEditProvider(pe,ke){return ht.registerDocumentRangeFormattingEditProvider(Ue,bt(pe),ke)},registerOnTypeFormattingEditProvider(pe,ke,ze,...at){return ht.registerOnTypeFormattingEditProvider(Ue,bt(pe),ke,[ze].concat(at))},registerDocumentSemanticTokensProvider(pe,ke,ze){return ht.registerDocumentSemanticTokensProvider(Ue,bt(pe),ke,ze)},registerDocumentRangeSemanticTokensProvider(pe,ke,ze){return ht.registerDocumentRangeSemanticTokensProvider(Ue,bt(pe),ke,ze)},registerSignatureHelpProvider(pe,ke,ze,...at){return typeof ze=="object"?ht.registerSignatureHelpProvider(Ue,bt(pe),ke,ze):ht.registerSignatureHelpProvider(Ue,bt(pe),ke,typeof ze>"u"?[]:[ze,...at])},registerCompletionItemProvider(pe,ke,...ze){return ht.registerCompletionItemProvider(Ue,bt(pe),ke,ze)},registerInlineCompletionItemProvider(pe,ke,ze){return ke.handleDidShowCompletionItem&&(0,tt.$RF)(Ue,"inlineCompletionsAdditions"),ke.handleDidPartiallyAcceptCompletionItem&&(0,tt.$RF)(Ue,"inlineCompletionsAdditions"),ze&&(0,tt.$RF)(Ue,"inlineCompletionsAdditions"),ht.registerInlineCompletionsProvider(Ue,bt(pe),ke,ze)},registerDocumentLinkProvider(pe,ke){return ht.registerDocumentLinkProvider(Ue,bt(pe),ke)},registerColorProvider(pe,ke){return ht.registerColorProvider(Ue,bt(pe),ke)},registerFoldingRangeProvider(pe,ke){return ht.registerFoldingRangeProvider(Ue,bt(pe),ke)},registerSelectionRangeProvider(pe,ke){return ht.registerSelectionRangeProvider(Ue,pe,ke)},registerCallHierarchyProvider(pe,ke){return ht.registerCallHierarchyProvider(Ue,pe,ke)},registerTypeHierarchyProvider(pe,ke){return ht.registerTypeHierarchyProvider(Ue,pe,ke)},setLanguageConfiguration:(pe,ke)=>ht.setLanguageConfiguration(Ue,pe,ke),getTokenInformationAtPosition(pe,ke){return(0,tt.$RF)(Ue,"tokenInformation"),ui.tokenAtPosition(pe,ke)},registerInlayHintsProvider(pe,ke){return ht.registerInlayHintsProvider(Ue,pe,ke)},createLanguageStatusItem(pe,ke){return ui.createLanguageStatusItem(Ue,pe,ke)},registerDocumentDropEditProvider(pe,ke,ze){return ht.registerDocumentOnDropEditProvider(Ue,pe,ke,(0,tt.$QF)(Ue,"dropMetadata")?ze:void 0)}},rn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return $t.activeTerminal},get terminals(){return $t.terminals},async showTextDocument(pe,ke,ze){const at=await($.URI.isUri(pe)?Promise.resolve(sn.openTextDocument(pe)):Promise.resolve(pe));return Ft.showTextDocument(at,ke,ze)},createTextEditorDecorationType(pe){return Ft.createTextEditorDecorationType(Ue,pe)},onDidChangeActiveTextEditor(pe,ke,ze){return Ft.onDidChangeActiveTextEditor(pe,ke,ze)},onDidChangeVisibleTextEditors(pe,ke,ze){return Ft.onDidChangeVisibleTextEditors(pe,ke,ze)},onDidChangeTextEditorSelection(pe,ke,ze){return Ft.onDidChangeTextEditorSelection(pe,ke,ze)},onDidChangeTextEditorOptions(pe,ke,ze){return Ft.onDidChangeTextEditorOptions(pe,ke,ze)},onDidChangeTextEditorVisibleRanges(pe,ke,ze){return Ft.onDidChangeTextEditorVisibleRanges(pe,ke,ze)},onDidChangeTextEditorViewColumn(pe,ke,ze){return Ft.onDidChangeTextEditorViewColumn(pe,ke,ze)},onDidCloseTerminal(pe,ke,ze){return $t.onDidCloseTerminal(pe,ke,ze)},onDidOpenTerminal(pe,ke,ze){return $t.onDidOpenTerminal(pe,ke,ze)},onDidChangeActiveTerminal(pe,ke,ze){return $t.onDidChangeActiveTerminal(pe,ke,ze)},onDidChangeTerminalDimensions(pe,ke,ze){return(0,tt.$RF)(Ue,"terminalDimensions"),$t.onDidChangeTerminalDimensions(pe,ke,ze)},onDidChangeTerminalState(pe,ke,ze){return $t.onDidChangeTerminalState(pe,ke,ze)},onDidWriteTerminalData(pe,ke,ze){return(0,tt.$RF)(Ue,"terminalDataWriteEvent"),$t.onDidWriteTerminalData(pe,ke,ze)},onDidExecuteTerminalCommand(pe,ke,ze){return(0,tt.$RF)(Ue,"terminalExecuteCommandEvent"),$t.onDidExecuteTerminalCommand(pe,ke,ze)},get state(){return De.getState(Ue)},onDidChangeWindowState(pe,ke,ze){return De.onDidChangeWindowState(pe,ke,ze)},showInformationMessage(pe,...ke){return Ei.showMessage(Ue,b.default.Info,pe,ke[0],ke.slice(1))},showWarningMessage(pe,...ke){return Ei.showMessage(Ue,b.default.Warning,pe,ke[0],ke.slice(1))},showErrorMessage(pe,...ke){return Ei.showMessage(Ue,b.default.Error,pe,ke[0],ke.slice(1))},showQuickPick(pe,ke,ze){return ri.showQuickPick(Ue,pe,ke,ze)},showWorkspaceFolderPick(pe){return ri.showWorkspaceFolderPick(pe)},showInputBox(pe,ke){return ri.showInput(pe,ke)},showOpenDialog(pe){return Oi.showOpenDialog(Ue,pe)},showSaveDialog(pe){return Oi.showSaveDialog(pe)},createStatusBarItem(pe,ke,ze){let at,vt,Tt;return typeof pe=="string"?(at=pe,vt=ke,Tt=ze):(vt=pe,Tt=ke),_t.createStatusBarEntry(Ue,at,vt,Tt)},setStatusBarMessage(pe,ke){return _t.setStatusBarMessage(pe,ke)},withScmProgress(pe){return Ne.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),pi.withProgress(Ue,{location:je.ProgressLocation.SourceControl},(ke,ze)=>pe({report(at){}}))},withProgress(pe,ke){return pi.withProgress(Ue,pe,ke)},createOutputChannel(pe,ke){return Nt.createOutputChannel(pe,ke,Ue)},createWebviewPanel(pe,ke,ze,at){return Li.createWebviewPanel(Ue,pe,ke,ze,at)},createWebviewTextEditorInset(pe,ke,ze,at){return(0,tt.$RF)(Ue,"editorInsets"),Ii.createWebviewEditorInset(pe,ke,ze,at,Ue)},createTerminal(pe,ke,ze){return typeof pe=="object"?"pty"in pe?$t.createExtensionTerminal(pe):$t.createTerminalFromOptions(pe):$t.createTerminal(pe,ke,ze)},registerTerminalLinkProvider(pe){return $t.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,ke){return $t.registerProfileProvider(Ue,pe,ke)},registerTerminalQuickFixProvider(pe,ke){return(0,tt.$RF)(Ue,"terminalQuickFixProvider"),$t.registerTerminalQuickFixProvider(pe,Ue.identifier.value,ke)},registerTreeDataProvider(pe,ke){return bi.registerTreeDataProvider(pe,ke,Ue)},createTreeView(pe,ke){return bi.createTreeView(pe,ke,Ue)},registerWebviewPanelSerializer:(pe,ke)=>Li.registerWebviewPanelSerializer(Ue,pe,ke),registerCustomEditorProvider:(pe,ke,ze={})=>cn.registerCustomEditorProvider(Ue,pe,ke,ze),registerFileDecorationProvider(pe){return et.registerFileDecorationProvider(pe,Ue)},registerUriHandler(pe){return mi.registerUriHandler(Ue,pe)},createQuickPick(){return ri.createQuickPick(Ue)},createInputBox(){return ri.createInputBox(Ue)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(pe,ke,ze){return Ai.onDidChangeActiveColorTheme(pe,ke,ze)},registerWebviewViewProvider(pe,ke,ze){return Mi.registerWebviewViewProvider(Ue,pe,ke,ze?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,ke,ze){return Dt.onDidChangeActiveNotebookEditor(pe,ke,ze)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,ke,ze){return $i.onDidChangeNotebookEditorSelection(pe,ke,ze)},onDidChangeNotebookEditorVisibleRanges(pe,ke,ze){return $i.onDidChangeNotebookEditorVisibleRanges(pe,ke,ze)},showNotebookDocument(pe,ke){return Dt.showNotebookDocument(pe,ke)},registerExternalUriOpener(pe,ke,ze){return(0,tt.$RF)(Ue,"externalUriOpener"),un.registerExternalUriOpener(Ue.identifier,pe,ke,ze)},registerProfileContentHandler(pe,ke){return(0,tt.$RF)(Ue,"profileContentHandlers"),ln.registrProfileContentHandler(Ue,pe,ke)},registerQuickDiffProvider(pe,ke,ze,at){return(0,tt.$RF)(Ue,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(pe),ke,ze,at)},get tabGroups(){return Oe.tabGroups},registerShareProvider(pe,ke){return(0,tt.$RF)(Ue,"shareProvider"),Hi.registerShareProvider(bt(pe),ke)}},sn={get rootPath(){return Ne.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw new N.$8("rootPath")},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw new N.$8("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw new N.$8("workspaceFile")},updateWorkspaceFolders:(pe,ke,...ze)=>ft.updateWorkspaceFolders(Ue,pe,ke||0,...ze),onDidChangeWorkspaceFolders:function(pe,ke,ze){return ft.onDidChangeWorkspace(pe,ke,ze)},asRelativePath:(pe,ke)=>ft.getRelativePath(pe,ke),findFiles:(pe,ke,ze,at)=>ft.findFiles(pe,ke,ze,Ue.identifier,at),findTextInFiles:(pe,ke,ze,at)=>{(0,tt.$RF)(Ue,"findTextInFiles");let vt,Tt;return typeof ke=="object"?(vt=ke,Tt=ze):(vt={},Tt=ke,at=ze),ft.findTextInFiles(pe,vt||{},Tt,Ue.identifier,at)},save:pe=>((0,tt.$RF)(Ue,"saveEditor"),ft.save(pe)),saveAs:pe=>((0,tt.$RF)(Ue,"saveEditor"),ft.saveAs(pe)),saveAll:pe=>ft.saveAll(pe),applyEdit(pe,ke){return Yt.applyWorkspaceEdit(pe,Ue,ke)},createFileSystemWatcher:(pe,ke,ze,at)=>{let vt;return typeof ke=="boolean"?vt={ignoreCreateEvents:!!ke,ignoreChangeEvents:!!ze,ignoreDeleteEvents:!!at,correlate:!1}:ke&&((0,tt.$RF)(Ue,"createFileSystemWatcher"),vt={...ke,correlate:!0}),xt.createFileSystemWatcher(ft,Ue,pe,vt)},get textDocuments(){return Pt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw new N.$8("textDocuments")},openTextDocument(pe){let ke;const ze=pe;if(typeof pe=="string")ke=Promise.resolve($.URI.file(pe));else if($.URI.isUri(pe))ke=Promise.resolve(pe);else if(!ze||typeof ze=="object")ke=Pt.createDocumentData(ze);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ke.then(at=>Pt.ensureDocumentData(at).then(vt=>vt.document))},onDidOpenTextDocument:(pe,ke,ze)=>Pt.onDidAddDocument(pe,ke,ze),onDidCloseTextDocument:(pe,ke,ze)=>Pt.onDidRemoveDocument(pe,ke,ze),onDidChangeTextDocument:(pe,ke,ze)=>Pt.onDidChangeDocument(pe,ke,ze),onDidSaveTextDocument:(pe,ke,ze)=>Pt.onDidSaveDocument(pe,ke,ze),onWillSaveTextDocument:(pe,ke,ze)=>qi.getOnWillSaveTextDocumentEvent(Ue)(pe,ke,ze),get notebookDocuments(){return Dt.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,ke){let ze;if($.URI.isUri(pe))ze=pe,await Dt.openNotebookDocument(pe);else if(typeof pe=="string")ze=$.URI.revive(await Dt.createNotebookDocument({viewType:pe,content:ke}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(ze).apiNotebook},onDidSaveNotebookDocument(pe,ke,ze){return ni.onDidSaveNotebookDocument(pe,ke,ze)},onDidChangeNotebookDocument(pe,ke,ze){return ni.onDidChangeNotebookDocument(pe,ke,ze)},onWillSaveNotebookDocument(pe,ke,ze){return Ci.getOnWillSaveNotebookDocumentEvent(Ue)(pe,ke,ze)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(pe,ke,ze,at){return Dt.registerNotebookSerializer(Ue,pe,ke,ze,(0,tt.$QF)(Ue,"notebookLiveShare")?at:void 0)},onDidChangeConfiguration:(pe,ke,ze)=>Xi.onDidChangeConfiguration(pe,ke,ze),getConfiguration(pe,ke){return ke=arguments.length===1?void 0:ke,Xi.getConfiguration(pe,ke,Ue)},registerTextDocumentContentProvider(pe,ke){return Si.registerTextDocumentContentProvider(pe,ke)},registerTaskProvider:(pe,ke)=>(Ne.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),wt.registerTaskProvider(Ue,pe,ke)),registerFileSystemProvider(pe,ke,ze){return(0,I.$Oc)(Vi.registerFileSystemProvider(Ue,pe,ke,ze),It.addFileSystemProvider(pe,ke,ze))},get fs(){return It.value},registerFileSearchProvider:(pe,ke)=>((0,tt.$RF)(Ue,"fileSearchProvider"),Mt.registerFileSearchProvider(pe,ke)),registerTextSearchProvider:(pe,ke)=>((0,tt.$RF)(Ue,"textSearchProvider"),Mt.registerTextSearchProvider(pe,ke)),registerRemoteAuthorityResolver:(pe,ke)=>((0,tt.$RF)(Ue,"resolvers"),St.registerRemoteAuthorityResolver(pe,ke)),registerResourceLabelFormatter:pe=>((0,tt.$RF)(Ue,"resolvers"),Ki.$registerResourceLabelFormatter(pe)),getRemoteExecServer:pe=>((0,tt.$RF)(Ue,"resolvers"),St.getRemoteExecServer(pe)),onDidCreateFiles:(pe,ke,ze)=>xt.onDidCreateFile(pe,ke,ze),onDidDeleteFiles:(pe,ke,ze)=>xt.onDidDeleteFile(pe,ke,ze),onDidRenameFiles:(pe,ke,ze)=>xt.onDidRenameFile(pe,ke,ze),onWillCreateFiles:(pe,ke,ze)=>xt.getOnWillCreateFileEvent(Ue)(pe,ke,ze),onWillDeleteFiles:(pe,ke,ze)=>xt.getOnWillDeleteFileEvent(Ue)(pe,ke,ze),onWillRenameFiles:(pe,ke,ze)=>xt.getOnWillRenameFileEvent(Ue)(pe,ke,ze),openTunnel:pe=>((0,tt.$RF)(Ue,"tunnels"),Fe.openTunnel(Ue,pe).then(ke=>{if(!ke)throw new Error("cannot open tunnel");return ke})),get tunnels(){return(0,tt.$RF)(Ue,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(pe,ke,ze)=>((0,tt.$RF)(Ue,"tunnels"),Fe.onDidChangeTunnels(pe,ke,ze)),registerPortAttributesProvider:(pe,ke)=>((0,tt.$RF)(Ue,"portsAttributes"),Fe.registerPortsAttributesProvider(pe,ke)),registerTunnelProvider:(pe,ke)=>((0,tt.$RF)(Ue,"tunnelFactory"),Fe.registerTunnelProvider(pe,ke)),registerTimelineProvider:(pe,ke)=>((0,tt.$RF)(Ue,"timeline"),Gi.registerTimelineProvider(pe,ke,Ue.identifier,rt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,tt.$RF)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,ke,ze)=>ft.onDidGrantWorkspaceTrust(pe,ke,ze),registerEditSessionIdentityProvider:(pe,ke)=>((0,tt.$RF)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,ke)),onWillCreateEditSessionIdentity:(pe,ke,ze)=>((0,tt.$RF)(Ue,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(Ue)(pe,ke,ze)),registerCanonicalUriProvider:(pe,ke)=>((0,tt.$RF)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(pe,ke)),getCanonicalUri:(pe,ke,ze)=>((0,tt.$RF)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(pe,ke,ze))},fn={get inputBox(){return Ne.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Ue)},createSourceControl(pe,ke,ze){return di.createSourceControl(Ue,pe,ke,ze)},registerSourceControlInputBoxValueProvider(pe){return(0,tt.$RF)(Ue,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Ue,pe)}},on={createCommentController(pe,ke){return Ri.createCommentController(Ue,pe,ke)}},an={get activeDebugSession(){return pt.activeDebugSession},get activeDebugConsole(){return pt.activeDebugConsole},get breakpoints(){return pt.breakpoints},get stackFrameFocus(){return pt.stackFrameFocus},onDidStartDebugSession(pe,ke,ze){return pt.onDidStartDebugSession(pe,ke,ze)},onDidTerminateDebugSession(pe,ke,ze){return pt.onDidTerminateDebugSession(pe,ke,ze)},onDidChangeActiveDebugSession(pe,ke,ze){return pt.onDidChangeActiveDebugSession(pe,ke,ze)},onDidReceiveDebugSessionCustomEvent(pe,ke,ze){return pt.onDidReceiveDebugSessionCustomEvent(pe,ke,ze)},onDidChangeBreakpoints(pe,ke,ze){return pt.onDidChangeBreakpoints(pe,ke,ze)},onDidChangeStackFrameFocus(pe,ke,ze){return(0,tt.$RF)(Ue,"debugFocus"),pt.onDidChangeStackFrameFocus(pe,ke,ze)},registerDebugConfigurationProvider(pe,ke,ze){return pt.registerDebugConfigurationProvider(pe,ke,ze||Rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,ke){return pt.registerDebugAdapterDescriptorFactory(Ue,pe,ke)},registerDebugAdapterTrackerFactory(pe,ke){return pt.registerDebugAdapterTrackerFactory(pe,ke)},startDebugging(pe,ke,ze){return!ze||typeof ze=="object"&&"configuration"in ze?pt.startDebugging(pe,ke,{parentSession:ze}):pt.startDebugging(pe,ke,ze||{})},stopDebugging(pe){return pt.stopDebugging(pe)},addBreakpoints(pe){return pt.addBreakpoints(pe)},removeBreakpoints(pe){return pt.removeBreakpoints(pe)},asDebugSourceUri(pe,ke){return pt.asDebugSourceUri(pe,ke)}},Ni={registerTaskProvider:(pe,ke)=>wt.registerTaskProvider(Ue,pe,ke),fetchTasks:pe=>wt.fetchTasks(pe),executeTask:pe=>wt.executeTask(Ue,pe),get taskExecutions(){return wt.taskExecutions},onDidStartTask:(pe,ke,ze)=>wt.onDidStartTask(pe,ke,ze),onDidEndTask:(pe,ke,ze)=>wt.onDidEndTask(pe,ke,ze),onDidStartTaskProcess:(pe,ke,ze)=>wt.onDidStartTaskProcess(pe,ke,ze),onDidEndTaskProcess:(pe,ke,ze)=>wt.onDidEndTaskProcess(pe,ke,ze)},ji={createNotebookController(pe,ke,ze,at,vt){return ai.createNotebookController(Ue,pe,ke,ze,at,(0,tt.$QF)(Ue,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(pe,ke)=>Dt.registerNotebookCellStatusBarItemProvider(Ue,pe,ke),createRendererMessaging(pe){return Di.createRendererMessaging(Ue,pe)},createNotebookControllerDetectionTask(pe){return(0,tt.$RF)(Ue,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Ue,pe)},registerKernelSourceActionProvider(pe,ke){return(0,tt.$RF)(Ue,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Ue,pe,ke)},onDidChangeNotebookCellExecutionState(pe,ke,ze){return(0,tt.$RF)(Ue,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(pe,ke,ze)}},zi={t(...pe){if(typeof pe[0]=="string"){const ke=pe.shift(),ze=!pe||typeof pe[0]!="object"?pe:pe[0];return Vt.getMessage(Ue.identifier.value,{message:ke,args:ze})}return Vt.getMessage(Ue.identifier.value,pe[0])},get bundle(){return Vt.getBundle(Ue.identifier.value)},get uri(){return Vt.getBundleUri(Ue.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(pe,ke){return(0,tt.$RF)(Ue,"interactive"),Ji.registerProvider(Ue,pe,ke)},registerInteractiveSessionProvider(pe,ke){return(0,tt.$RF)(Ue,"interactive"),gi.registerChatProvider(Ue,pe,ke)},sendInteractiveRequestToProvider(pe,ke){return(0,tt.$RF)(Ue,"interactive"),gi.sendInteractiveRequestToProvider(pe,ke)},get onDidPerformUserAction(){return(0,tt.$RF)(Ue,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(pe,ke){return(0,tt.$RF)(Ue,"interactive"),gi.transferChatSession(pe,ke)}},Ui={getRelatedInformation(pe,ke){return(0,tt.$RF)(Ue,"aiRelatedInformation"),Yi.getRelatedInformation(Ue,pe,ke)},registerRelatedInformationProvider(pe,ke){return(0,tt.$RF)(Ue,"aiRelatedInformation"),Yi.registerRelatedInformationProvider(Ue,pe,ke)},registerEmbeddingVectorProvider(pe,ke){return(0,tt.$RF)(Ue,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Ue,pe,ke)}},gn={registerChatResponseProvider(pe,ke,ze){return(0,tt.$RF)(Ue,"chatProvider"),fi.registerProvider(Ue.identifier,pe,ke,ze)},requestChatAccess(pe){return(0,tt.$RF)(Ue,"chatRequestAccess"),fi.requestChatResponseProvider(Ue.identifier,pe)},registerVariable(pe,ke,ze){return(0,tt.$RF)(Ue,"chatVariables"),Zi.registerVariableResolver(Ue,pe,ke,ze)},registerMappedEditsProvider(pe,ke){return(0,tt.$RF)(Ue,"mappedEditsProvider"),ht.registerMappedEditsProvider(Ue,pe,ke)},createChatAgent(pe,ke){return(0,tt.$RF)(Ue,"chatAgents2"),Qi.createChatAgent(Ue,pe,ke)}},mn={registerSpeechProvider(pe,ke){return(0,tt.$RF)(Ue,"speech"),vi.registerProvider(Ue.identifier,pe,ke)}};return{version:mt.version,ai:Ui,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:ki,l10n:zi,languages:nn,notebooks:ji,scm:fn,speech:mn,tasks:Ni,tests:en,window:rn,workspace:sn,Breakpoint:je.$FL,TerminalOutputAnchor:je.TerminalOutputAnchor,ChatAgentResultFeedbackKind:je.ChatAgentResultFeedbackKind,ChatMessage:je.$wM,ChatMessageRole:je.ChatMessageRole,ChatVariableLevel:je.ChatVariableLevel,CallHierarchyIncomingCall:je.$5K,CallHierarchyItem:je.$4K,CallHierarchyOutgoingCall:je.$6K,CancellationError:N.$4,CancellationTokenSource:D.$2d,CandidatePortSource:n.CandidatePortSource,CodeAction:je.$1K,CodeActionKind:je.$2K,CodeActionTriggerKind:je.CodeActionTriggerKind,CodeLens:je.$7K,Color:je.$hL,ColorInformation:je.$iL,ColorPresentation:je.$jL,ColorThemeKind:je.ColorThemeKind,CommentMode:je.CommentMode,CommentState:je.CommentState,CommentThreadCollapsibleState:je.CommentThreadCollapsibleState,CommentThreadState:je.CommentThreadState,CompletionItem:je.$bL,CompletionItemKind:je.CompletionItemKind,CompletionItemTag:je.CompletionItemTag,CompletionList:je.$cL,CompletionTriggerKind:je.CompletionTriggerKind,ConfigurationTarget:je.ConfigurationTarget,CustomExecution:je.$rL,DebugAdapterExecutable:je.$JL,DebugAdapterInlineImplementation:je.$ML,DebugAdapterNamedPipeServer:je.$LL,DebugAdapterServer:je.$KL,DebugConfigurationProviderTriggerKind:Rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:je.DebugConsoleMode,DecorationRangeBehavior:je.DecorationRangeBehavior,Diagnostic:je.$UK,DiagnosticRelatedInformation:je.$TK,DiagnosticSeverity:je.DiagnosticSeverity,DiagnosticTag:je.DiagnosticTag,Disposable:je.$GK,DocumentHighlight:je.$WK,DocumentHighlightKind:je.DocumentHighlightKind,MultiDocumentHighlight:je.$XK,DocumentLink:je.$gL,DocumentSymbol:je.$ZK,EndOfLine:je.EndOfLine,EnvironmentVariableMutatorType:je.EnvironmentVariableMutatorType,EvaluatableExpression:je.$PL,InlineValueText:je.$QL,InlineValueVariableLookup:je.$RL,InlineValueEvaluatableExpression:je.$SL,InlineCompletionTriggerKind:je.InlineCompletionTriggerKind,EventEmitter:g.$Rd,ExtensionKind:je.ExtensionKind,ExtensionMode:je.ExtensionMode,ExternalUriOpenerPriority:je.ExternalUriOpenerPriority,FileChangeType:je.FileChangeType,FileDecoration:je.$3L,FileDecoration2:je.$3L,FileSystemError:je.$UL,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:je.$VL,FoldingRangeKind:je.FoldingRangeKind,FunctionBreakpoint:je.$HL,InlineCompletionItem:je.$dL,InlineCompletionList:je.$eL,Hover:je.$VK,IndentAction:C.IndentAction,Location:je.$SK,MarkdownString:je.$8K,OverviewRulerLane:m.OverviewRulerLane,ParameterInformation:je.$9K,PortAutoForwardAction:je.PortAutoForwardAction,Position:je.$HK,ProcessExecution:je.$pL,ProgressLocation:je.ProgressLocation,QuickInputButtons:je.$2L,Range:je.$IK,RelativePattern:je.$DL,Selection:je.$JK,SelectionRange:je.$3K,SemanticTokens:je.$YL,SemanticTokensBuilder:je.$XL,SemanticTokensEdit:je.$ZL,SemanticTokensEdits:je.$1L,SemanticTokensLegend:je.$WL,ShellExecution:je.$qL,ShellQuoting:je.ShellQuoting,SignatureHelp:je.$$K,SignatureHelpTriggerKind:je.SignatureHelpTriggerKind,SignatureInformation:je.$0K,SnippetString:je.$RK,SourceBreakpoint:je.$GL,StandardTokenType:je.StandardTokenType,StatusBarAlignment:je.StatusBarAlignment,SymbolInformation:je.$YK,SymbolKind:je.SymbolKind,SymbolTag:je.SymbolTag,Task:je.$sL,TaskGroup:je.$oL,TaskPanelKind:je.TaskPanelKind,TaskRevealKind:je.TaskRevealKind,TaskScope:je.TaskScope,TerminalLink:je.$kL,TerminalQuickFixTerminalCommand:je.$mL,TerminalQuickFixOpener:je.$lL,TerminalLocation:je.TerminalLocation,TerminalProfile:je.$nL,TerminalExitReason:je.TerminalExitReason,TextDocumentSaveReason:je.TextDocumentSaveReason,TextEdit:je.$NK,SnippetTextEdit:je.$PK,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:je.TextEditorLineNumbersStyle,TextEditorRevealType:je.TextEditorRevealType,TextEditorSelectionChangeKind:je.TextEditorSelectionChangeKind,SyntaxTokenType:je.SyntaxTokenType,TextDocumentChangeReason:je.TextDocumentChangeReason,ThemeColor:je.$CL,ThemeIcon:je.$BL,TreeItem:je.$tL,TreeItemCheckboxState:je.TreeItemCheckboxState,TreeItemCollapsibleState:je.TreeItemCollapsibleState,TypeHierarchyItem:je.$lM,UIKind:Ct.UIKind,Uri:$.URI,ViewColumn:je.ViewColumn,WorkspaceEdit:je.$QK,DocumentDropEdit:je.$zL,DocumentPasteEdit:je.$AL,InlayHint:je.$aL,InlayHintLabelPart:je.$_K,InlayHintKind:je.InlayHintKind,RemoteAuthorityResolverError:je.$MK,ResolvedAuthority:je.$KK,ManagedResolvedAuthority:je.$LK,SourceControlInputBoxValidationType:je.SourceControlInputBoxValidationType,ExtensionRuntime:je.ExtensionRuntime,TimelineItem:je.$aM,NotebookRange:je.$5L,NotebookCellKind:je.NotebookCellKind,NotebookCellExecutionState:je.NotebookCellExecutionState,NotebookCellData:je.$6L,NotebookData:je.$7L,NotebookRendererScript:je.$$L,NotebookCellStatusBarAlignment:je.NotebookCellStatusBarAlignment,NotebookEditorRevealType:je.NotebookEditorRevealType,NotebookCellOutput:je.$9L,NotebookCellOutputItem:je.$8L,NotebookCellStatusBarItem:je.$0L,NotebookControllerAffinity:je.NotebookControllerAffinity,NotebookControllerAffinity2:je.NotebookControllerAffinity2,NotebookEdit:je.$OK,NotebookKernelSourceAction:je.$_L,NotebookVariablesRequestKind:je.NotebookVariablesRequestKind,PortAttributes:je.$cM,LinkedEditingRanges:je.$bM,TestResultState:je.TestResultState,TestRunRequest:je.$dM,TestMessage:je.$eM,TestMessage2:je.$eM,TestTag:je.$fM,TestRunProfileKind:je.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:je.$yL,DataTransferItem:je.$uL,CoveredCount:je.$gM,FileCoverage:je.$hM,StatementCoverage:je.$iM,BranchCoverage:je.$jM,FunctionCoverage:je.$kM,WorkspaceTrustState:je.WorkspaceTrustState,LanguageStatusSeverity:je.LanguageStatusSeverity,QuickPickItemKind:je.QuickPickItemKind,InputBoxValidationSeverity:je.InputBoxValidationSeverity,TabInputText:je.$mM,TabInputTextDiff:je.$nM,TabInputTextMerge:je.$oM,TabInputCustom:je.$pM,TabInputNotebook:je.$rM,TabInputNotebookDiff:je.$sM,TabInputWebview:je.$qM,TabInputTerminal:je.$tM,TabInputInteractiveWindow:je.$uM,TabInputChat:je.$vM,TelemetryTrustedValue:s.$to,LogLevel:f.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:je.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:je.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:je.InteractiveEditorResponseFeedbackKind,StackFrameFocus:je.$NL,ThreadFocus:je.$OL,RelatedInformationType:je.RelatedInformationType,SpeechToTextStatus:je.SpeechToTextStatus}}}e.$Cgc=qt}),define(Ee[369],Se([1,0,106,152,41,149,42,35,69,47,95,96,97,118,72,91,151,71,57,117,90,70,150,14,58,115,116]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h,u,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Gr)(u.$rfc,u.$qfc,1),(0,D.$Gr)(r.$ij,t.$Dgc,1),(0,D.$Gr)(f.$Cec,f.$Dec,1),(0,D.$Gr)(b.$4M,b.$3M,0),(0,D.$Gr)(L.$Xec,L.$Vec,0),(0,D.$Gr)(s.$Zec,s.$Yec,0),(0,D.$Gr)(C.$Bfc,C.$Ffc,0),(0,D.$Gr)(I.$Hfc,I.$Gfc,0),(0,D.$Gr)($.$SM,$.$RM,0),(0,D.$Gr)(c.$sfc,c.$tfc,0),(0,D.$Gr)(i.$zec,i.$yec,0),(0,D.$Gr)(N.$bgc,N.$agc,1),(0,D.$Gr)(m.$Xfc,m.$Yfc,0),(0,D.$Gr)(v.$gfc,v.$ffc,0),(0,D.$Gr)(A.$ogc,A.$ngc,0),(0,D.$Gr)(y.$jfc,y.$mfc,0),(0,D.$Gr)(S.$Hxb,S.$Ixb,0),(0,D.$Gr)(d.$Bgc,d.$Agc,0),(0,D.$Gr)(g.$Uec,g.$Tec,0),(0,D.$Gr)(n.$ofc,n.$nfc,0),(0,D.$Gr)(o.$2M,o.$YM,0),(0,D.$Gr)(a.$0ec,a.$$ec,0),(0,D.$Gr)(h.$zfc,h.$Afc,0)}),define(Ee[119],Se([1,0,19,14,36,94]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=e.$Ugc=e.$Tgc=void 0;function L(C){return C.startsWith("**")||C.startsWith("/")?C:`/${C}`}e.$Tgc=L;function b(C,m,v,S){const f=(0,D.$1b)(v,$),d=new g.$7I(m,f,S),s=d.preview.matches;return{ranges:(0,D.$1b)(f,y),uri:C,preview:{text:d.preview.text,matches:(0,D.$1b)(s,y)}}}e.$Ugc=b;function $(C){return new g.$8I(C.start.line,C.start.character,C.end.line,C.end.character)}function y(C){return new I.$VI(C.startLineNumber,C.startColumn,C.endLineNumber,C.endColumn)}let A=class{constructor(m,v){this.a=m,this.b=v}appendLine(m){this.b.debug(`${this.a}#search`,m)}};e.$Vgc=A,e.$Vgc=A=Ke([We(1,N.$hj)],A)}),define(Ee[370],Se([1,0,51,16,76,33,11,13,119,371]),function($e,e,D,N,g,I,L,b,$,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=e.$Xgc=e.$Wgc=void 0;const A=y.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function C(n,o,a,t){const r=m(n,o,a,t),h=o.folder.fsPath;return{cmd:D.spawn(A,r.args,{cwd:h}),rgDiskPath:A,siblingClauses:r.siblingClauses,rgArgs:r,cwd:h}}e.$Wgc=C;function m(n,o,a,t){const r=["--files","--hidden","--case-sensitive","--no-require-git"];S([o],a,!1).forEach(u=>{const c=(0,$.$Tgc)(u);if(r.push("-g",c),L.$j){const l=(0,g.$zl)(c);l!==c&&r.push("-g",l)}});const h=v([o],t,void 0,!1);return h.globArgs.forEach(u=>{const c=`!${(0,$.$Tgc)(u)}`;if(r.push("-g",c),L.$j){const l=(0,g.$zl)(c);l!==c&&r.push("-g",l)}}),o.disregardIgnoreFiles!==!1?r.push("--no-ignore"):o.disregardParentIgnoreFiles!==!1&&r.push("--no-ignore-parent"),o.ignoreSymlinks||r.push("--follow"),n.exists&&r.push("--quiet"),r.push("--no-config"),o.disregardGlobalIgnoreFiles&&r.push("--no-ignore-global"),{args:r,siblingClauses:h.siblingClauses}}function v(n,o,a,t=!0){const r=[];let h={};return n.forEach(u=>{const c=Object.assign({},u.excludePattern||{},o||{}),l=f(c,t?u.folder.fsPath:void 0,a);r.push(...l.globArgs),l.siblingClauses&&(h=Object.assign(h,l.siblingClauses))}),{globArgs:r,siblingClauses:h}}function S(n,o,a=!0){const t=[];return n.forEach(r=>{const h=Object.assign({},o||{},r.includePattern||{}),u=f(h,a?r.folder.fsPath:void 0);t.push(...u.globArgs)}),t}function f(n,o,a){const t=[],r={};return Object.keys(n).forEach(h=>{if(a&&a.has(h)||!h)return;const u=n[h];h=s(o?d(o,h):h),h.startsWith("\\\\")?h="\\\\"+h.substr(2).replace(/\\/g,"/"):h=h.replace(/\\/g,"/"),typeof u=="boolean"&&u?(h.startsWith("\\\\")&&(h+="**"),t.push(i(h))):u&&u.when&&(r[h]=u)}),{globArgs:t,siblingClauses:r}}function d(n,o){return N.$hc(o)?o:N.$ic(n,o)}e.$Xgc=d;function s(n){return n=b.$Oe(n,"\\"),b.$Oe(n,"/")}function i(n){return I.$Xf(n).toLowerCase()==="c:/"?n.replace(/^c:[/\\]/i,"/"):n}e.$Ygc=i}),define(Ee[372],Se([1,0,51,55,16,373,19,44,34,76,33,11,38,13,18,31,36,370,129]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1gc=e.$Zgc=void 0;const n=new Set;process.on("exit",()=>{n.forEach(h=>h())});class o{constructor(u){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=u,this.b=u.filePattern||"",this.d=u.includePattern&&$.$Gj(u.includePattern),this.f=u.maxResults||null,this.g=!!u.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Iq)(this.b).normalizedLowercase),this.u=u.excludePattern&&$.$Gj(u.excludePattern),this.t=new Map,u.folderQueries.forEach(c=>{const l=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),k=c.folder.fsPath;u.folderQueries.map(R=>R.folder.fsPath).filter(R=>R!==k).forEach(R=>{(0,A.$2f)(R,k)&&(l[g.$kc(k,R)]=!0)}),this.t.set(k,new t(l,k))})}cancel(){this.l=!0,n.forEach(u=>u())}walk(u,c,l,k,R){if(this.m=m.$Nd.create(!1),this.l)return R(null,this.j);c.forEach(w=>{const p=g.$mc(w.fsPath);this.u&&this.u(w.fsPath,p)||this.J(l,{relativePath:w.fsPath,searchPath:void 0})}),this.r=m.$Nd.create(!1),this.w(u,(w,p)=>{this.x(this.y,this,w,l,k,E=>{if(E){const P=(0,b.$Ki)(E);console.error(P),this.q.push(P),p(E,void 0)}else p(null,void 0)})},(w,p)=>{this.m.stop();const E=w?L.$Gb(w)[0]:null;R(E,this.j)})}w(u,c,l){const k=new Array(u.length),R=new Array(u.length);let w=!1,p=0;if(u.length===0)return l(null,[]);u.forEach((E,P)=>{c(E,(z,j)=>{if(z?(w=!0,k[P]=null,R[P]=z):(k[P]=j,R[P]=null),++p===u.length)return l(w?R:null,k)})})}x(u,c,...l){try{u.apply(c,l)}catch(k){l[l.length-1](k)}}y(u,c,l,k){const R=u.folder.fsPath,w=C.$j,p=()=>F&&F.kill();n.add(p);let E=W=>{n.delete(p),E=()=>{},k(W)},P="";const z=this.D(),j=(0,s.$Wgc)(this.a,u,this.a.includePattern,this.t.get(u.folder.fsPath).expression),F=j.cmd,O=!Object.keys(j.siblingClauses).length,T=j.rgArgs.args.map(W=>W.match(/^-/)?W:`'${W}'`).join(" ");let M=`${j.rgDiskPath} ${T}
 - cwd: ${j.cwd}`;j.rgArgs.siblingClauses&&(M+=`
 - Sibling clauses: ${JSON.stringify(j.rgArgs.siblingClauses)}`),l({message:M}),this.s=0,this.z(F,"utf8",l,(W,Y,ue)=>{if(W){E(W);return}if(this.j){E();return}const Q=(P+(w?y.$yl(Y||""):Y)).split(`
`);if(ue){const x=Q.length;Q[x-1]=Q[x-1].trim(),Q[x-1]||Q.pop()}else P=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){E(new Error("Splitting up files failed"));return}if(this.s+=Q.length,O){for(const x of Q)if(this.J(c,{base:R,relativePath:x,searchPath:this.N(u,x)}),this.j){p();break}(ue||this.j)&&E();return}this.G(u,z,R,Q,c),ue&&(this.H(z,R,c),E())})}spawnFindCmd(u){const c=this.t.get(u.folder.fsPath),l=c.getBasenameTerms(),k=c.getPathTerms(),R=["-L","."];if(l.length||k.length){R.push("-not","(","(");for(const w of l)R.push("-name",w),R.push("-o");for(const w of k)R.push("-path",w),R.push("-o");R.pop(),R.push(")","-prune",")")}return R.push("-type","f"),D.spawn("find",R,{cwd:u.folder.fsPath})}readStdout(u,c,l){let k="";this.z(u,c,()=>{},(R,w,p)=>{if(R){l(R);return}k+=w,p&&l(null,k)})}z(u,c,l,k){let R=(E,P,z)=>{(E||z)&&(R=()=>{},this.r?.stop()),k(E,P,z)},w=!1;u.stdout?(this.A(u.stdout,c,R),u.stdout.once("data",()=>w=!0)):l({message:"stdout is null"});let p;u.stderr?p=this.B(u.stderr):l({message:"stderr is null"}),u.on("error",E=>{R(E)}),u.on("close",E=>{let P;!w&&(P=this.C(p,c))&&r(P)?R(new Error(`command failed with error code ${E}: ${this.C(p,c)}`)):(this.g&&E===0&&(this.j=!0),R(null,"",!0))})}A(u,c,l){const k=new I.StringDecoder(c);return u.on("data",R=>{l(null,k.write(R))}),k}B(u){const c=[];return u.on("data",l=>{c.push(l)}),c}C(u,c){const l=new I.StringDecoder(c);return u.map(k=>l.write(k)).join("")}D(){const u={rootEntries:[],pathToEntries:Object.create(null)};return u.pathToEntries["."]=u.rootEntries,u}G(u,{pathToEntries:c},l,k,R){k.indexOf(this.b)!==-1&&this.J(R,{base:l,relativePath:this.b,searchPath:this.N(u,this.b)});const w=p=>{const E=g.$mc(p),P=g.$lc(p);let z=c[P];z||(z=c[P]=[],w(P)),z.push({base:l,relativePath:p,basename:E,searchPath:this.N(u,p)})};k.forEach(w)}H({rootEntries:u,pathToEntries:c},l,k){const R=this,w=this.t.get(l),p=this.b;function E(P){R.o++;const z=(0,d.$kJ)(()=>P.map(j=>j.basename));for(let j=0,F=P.length;j<F;j++){const O=P[j],{relativePath:T,basename:M}=O;if(w.test(T,M,p!==M?z:void 0))continue;const W=c[T];if(W)E(W);else{if(R.p++,T===p)continue;R.J(k,O)}if(R.j)break}}E(u)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(u,c,l,k,R){const w=u.folder,p=(0,d.$kJ)(()=>l);this.w(l,(E,P)=>{if(this.l||this.j)return P(null);const z=c?[c,E].join(g.sep):E;if(this.t.get(u.folder.fsPath).test(z,E,this.a.filePattern!==E?p:void 0))return P(null);const j=[w.fsPath,z].join(g.sep);N.lstat(j,(F,O)=>{if(F||this.l||this.j)return P(null);this.L(j,O,(T,M)=>T||this.l||this.j?P(null):M.isDirectory()?(this.o++,this.M(j,O,(W,Y)=>W||this.l||this.j||(Y=Y||"",this.v[Y])?P(null):(this.v[Y]=!0,f.Promises.readdir(j).then(ue=>{if(this.l||this.j)return P(null);this.I(u,z,ue,k,Z=>P(Z||null))},ue=>{P(null)})))):(this.p++,z===this.b||this.h&&S.$Gf(M.size)&&M.size>this.h||this.J(k,{base:w.fsPath,relativePath:z,searchPath:this.N(u,z)}),P(null,void 0)))})},E=>{const P=E&&L.$Gb(E);return R(P&&P.length>0?P[0]:void 0)})}J(u,c){this.K(c)&&(!this.d||this.d(c.relativePath,g.$mc(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||u(c))}K(u){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,d.$fJ)(u,this.c)}return!0}L(u,c,l){return c.isSymbolicLink()?N.stat(u,l):l(null,c)}M(u,c,l){return c.isSymbolicLink()?N.realpath(u,(k,R)=>k?l(k):l(null,R)):l(null,u)}N(u,c){return u.folderName?g.$ic(u.folderName,c):c}}e.$Zgc=o;class a{constructor(u){this.a=u.folderQueries,this.b=u.extraFileResources||[],this.c=new o(u)}search(u,c,l){this.c.walk(this.a,this.b,u,c,(k,R)=>{l(k,{limitHit:R,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$1gc=a;class t{constructor(u,c){this.expression=u,this.c=c,this.d(u)}d(u){let c,l;Object.keys(u).filter(k=>u[k]).forEach(k=>{g.$hc(k)?(c=c||$.$Bj(),c[k]=u[k]):(l=l||$.$Bj(),l[k]=u[k])}),this.a=c&&$.$Gj(c,{trimForExclusions:!0}),this.b=l&&$.$Gj(l,{trimForExclusions:!0})}test(u,c,l){return this.b&&this.b(u,c,l)||this.a&&this.a(g.$ic(this.c,u),c,l)}getBasenameTerms(){const u=[];return this.a&&u.push(...$.$Ij(this.a)),this.b&&u.push(...$.$Ij(this.b)),u}getPathTerms(){const u=[];return this.a&&u.push(...$.$Jj(this.a)),this.b&&u.push(...$.$Jj(this.b)),u}}function r(h){const u=h.trim().split(`
`),c=u[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return v.$uf(u[u.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(Ee[374],Se([1,0,98,22,185,21]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.$0C=e.$9C=e.$8C=e.$7C=e.$6C=e.$5C=e.$4C=e.DecodeStreamErrorKind=e.$3C=e.$2C=e.$1C=e.$ZC=e.$YC=e.$XC=e.$WC=e.$VC=void 0,e.$VC="utf8",e.$WC="utf8bom",e.$XC="utf16be",e.$YC="utf16le";function L(c){return[e.$VC,e.$WC,e.$XC,e.$YC].some(l=>l===c)}e.$ZC=L,e.$1C=[254,255],e.$2C=[255,254],e.$3C=[239,187,191];const b=512,$=512,y=512*8,A=512*128;var C;(function(c){c[c.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(C||(e.DecodeStreamErrorKind=C={}));class m extends Error{constructor(l,k){super(l),this.decodeStreamErrorKind=k}}e.$4C=m;class v{static async create(l){let k;if(l!==e.$VC)k=(await(0,g.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(s(l));else{const R=new TextDecoder;k={write(w){return R.decode(w,{stream:!0})},end(){return R.decode()}}}return new v(k)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function S(c,l){const k=l.minBytesRequiredForDetection??l.guessEncoding?y:$;return new Promise((R,w)=>{const p=(0,D.$6d)(O=>O.join("")),E=[];let P=0,z;const j=new I.$2d,F=async()=>{try{const O=await u({buffer:N.$fe.concat(E),bytesRead:P},l.guessEncoding);if(O.seemsBinary&&l.acceptTextOnly)throw new m("Stream is binary but only text is accepted for decoding",1);O.encoding=await l.overwriteEncoding(O.encoding),z=await v.create(O.encoding);const T=z.write(N.$fe.concat(E).buffer);p.write(T),E.length=0,P=0,R({stream:p,detected:O})}catch(O){j.cancel(),p.destroy(),w(O)}};(0,D.$0d)(c,{onData:async O=>{z?p.write(z.write(O.buffer)):(E.push(O),P+=O.byteLength,P>=k&&(c.pause(),await F(),setTimeout(()=>c.resume())))},onError:O=>p.error(O),onEnd:async()=>{z||await F(),p.end(z?.end())}},j.token)})}e.$5C=S;async function f(c,l,k){const w=(await(0,g.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(s(l),k);let p=!1,E=!1;return{read(){if(E)return null;const P=c.read();if(typeof P!="string"){if(E=!0,!p&&k?.addBOM)switch(l){case e.$VC:case e.$WC:return N.$fe.wrap(Uint8Array.from(e.$3C));case e.$XC:return N.$fe.wrap(Uint8Array.from(e.$1C));case e.$YC:return N.$fe.wrap(Uint8Array.from(e.$2C))}const z=w.end();return z&&z.length>0?(p=!0,N.$fe.wrap(z)):null}return p=!0,N.$fe.wrap(w.write(P))}}}e.$6C=f;async function d(c){return(await(0,g.$UC)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(s(c))}e.$7C=d;function s(c){return c===e.$WC||c===null?e.$VC:c}e.$8C=s;function i(c,l){if(!c||l<e.$1C.length)return null;const k=c.readUInt8(0),R=c.readUInt8(1);if(k===e.$1C[0]&&R===e.$1C[1])return e.$XC;if(k===e.$2C[0]&&R===e.$2C[1])return e.$YC;if(l<e.$3C.length)return null;const w=c.readUInt8(2);return k===e.$3C[0]&&R===e.$3C[1]&&w===e.$3C[2]?e.$WC:null}e.$9C=i;const n=["ascii","utf-16","utf-32"];async function o(c){const l=await(0,g.$UC)("jschardet","dist/jschardet.min.js"),k=c.slice(0,A),R=r(k.buffer),w=l.detect(R);if(!w||!w.encoding)return null;const p=w.encoding.toLowerCase();return 0<=n.indexOf(p)?null:t(w.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(c){const l=c.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[l]||l}function r(c){let l="";for(let k=0;k<c.length;k++)l+=String.fromCharCode(c[k]);return l}function h(c){switch(c){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=c.match(/windows(\d+)/);return l?"windows-"+l[1]:c}}}e.$0C=h;function u({buffer:c,bytesRead:l},k){let R=i(c,l),w=!1;if(R!==e.$XC&&R!==e.$YC&&c){let p=!0,E=!0,P=!1;for(let z=0;z<l&&z<b;z++){const j=z%2===1,F=c.readUInt8(z)===0;if(F&&(P=!0),p&&(j&&!F||!j&&F)&&(p=!1),E&&(j&&F||!j&&!F)&&(E=!1),F&&!p&&!E)break}P&&(p?R=e.$YC:E?R=e.$XC:w=!0)}return k&&!w&&!R&&c?o(c.slice(0,l)).then(p=>({seemsBinary:!1,encoding:p})):{seemsBinary:w,encoding:R}}e.$$C=u,e.$_C={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ee[155],Se([1,0,374,31,154]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=void 0;class I extends g.$Tfc{constructor(b,$,y=N,A="searchProcess"){super(b,$,{readdir:C=>y.Promises.readdir(C.fsPath),toCanonicalName:C=>(0,D.$0C)(C)},A)}}e.$9gc=I}),define(Ee[156],Se([1,0,51,390,373,19,73,34,16,13,2,36,94,391,371,119]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=e.$5gc=e.$4gc=e.$3gc=e.$2gc=void 0;const d=S.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class s{constructor(E){this.a=E}provideTextSearchResults(E,P,z,j){return this.a.appendLine(`provideTextSearchResults ${E.pattern}, ${JSON.stringify({...P,folder:P.folder.toString()})}`),new Promise((F,O)=>{j.onCancellationRequested(()=>x());const T=r(E,P),M=P.folder.fsPath,W=T.map(V=>V.match(/^-/)?V:`'${V}'`).join(" ");this.a.appendLine(`${d} ${W}
 - cwd: ${M}`);let Y=D.spawn(d,T,{cwd:M});Y.on("error",V=>{console.error(V),this.a.appendLine("Error: "+(V&&V.message)),O((0,C.$bJ)(new C.$_I(V&&V.message,C.SearchErrorCode.rgProcessError)))});let ue=!1;const Z=new o(P.maxResults,M,P.previewOptions);Z.on("result",V=>{ue=!0,X="",z.report(V)});let Q=!1;const x=()=>{Q=!0,Y?.kill(),Z?.cancel()};let oe=!1;Z.on("hitLimit",()=>{oe=!0,x()});let X="";Y.stdout.on("data",V=>{Z.handleData(V),ue||(X+=V)});let ve=!1;Y.stdout.once("data",()=>ve=!0);let ge="";Y.stderr.on("data",V=>{const U=V.toString();this.a.appendLine(U),ge.length+U.length<1e6&&(ge+=U)}),Y.on("close",()=>{if(this.a.appendLine(ve?"Got data from stdout":"No data from stdout"),this.a.appendLine(ue?"Got result from parser":"No result from parser"),X&&this.a.appendLine(`Got data without result: ${X}`),this.a.appendLine(""),Q)F({limitHit:oe});else{Z.flush(),Y=null;let V;ge&&!ve&&(V=i(ge))?O((0,C.$bJ)(new C.$_I(V.message,V.code))):F({limitHit:oe})}})})}}e.$2gc=s;function i(p){const E=p.split(`
`),P=E[0].trim();if(E.some(j=>j.startsWith("regex parse error")))return new C.$_I(n(E),C.SearchErrorCode.regexParseError);const z=P.match(/grep config error: unknown encoding: (.*)/);if(z)return new C.$_I(`Unknown encoding: ${z[1]}`,C.SearchErrorCode.unknownEncoding);if(P.startsWith("error parsing glob"))return new C.$_I(P.charAt(0).toUpperCase()+P.substr(1),C.SearchErrorCode.globParseError);if(P.startsWith("the literal"))return new C.$_I(P.charAt(0).toUpperCase()+P.substr(1),C.SearchErrorCode.invalidLiteral);if(P.startsWith("PCRE2: error compiling pattern"))return new C.$_I(P,C.SearchErrorCode.regexParseError)}function n(p){const E=["Regex parse error"],P=p.filter(z=>z.startsWith("PCRE2:"));if(P.length>=1){const z=P[0].replace("PCRE2:","");if(z.indexOf(":")!==-1&&z.split(":").length>=2){const j=z.split(":")[1];E.push(":"+j)}}return E.join("")}class o extends N.EventEmitter{constructor(E,P,z){super(),this.g=E,this.h=P,this.j=z,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new g.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(E,P){return super.on(E,P),this}handleData(E){if(this.b)return;const P=typeof E=="string"?E:this.d.write(E);this.k(P)}k(E){let P=E.indexOf(`
`);const z=this.a+E;if(P>=0)P+=this.a.length;else{this.a=z;return}let j=0;for(;P>=0;)this.m(z.substring(j,P).trim()),j=P+1,P=z.indexOf(`
`,j);this.a=z.substring(j)}m(E){if(this.b||!E)return;let P;try{P=JSON.parse(E)}catch{throw new Error(`malformed line from rg: ${E}`)}if(P.type==="match"){const z=a(P.data.path),j=A.URI.file($.$ic(this.h,z)),F=this.n(P.data,j);this.p(F),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(P.type==="context"){const z=a(P.data.path),j=A.URI.file($.$ic(this.h,z));this.o(P.data,j).forEach(O=>this.p(O))}}n(E,P){const z=E.line_number-1,j=a(E.lines),F=Buffer.from(j);let O=0,T=0,M=z;E.submatches.length===0&&E.submatches.push(j.length?{start:0,end:1,match:{text:j[0]}}:{start:0,end:0,match:{text:""}});const W=(0,I.$Gb)(E.submatches.map((Y,ue)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const Z=a(Y.match),Q=F.slice(O,Y.start).toString(),x=t(Q),oe=x.numLines>0?x.lastLineLength:x.lastLineLength+T,X=t(Z),ve=x.numLines+M,ge=X.numLines+ve,V=X.numLines>0?X.lastLineLength:X.lastLineLength+oe;return O=Y.end,T=V,M=ge,new m.$VI(ve,oe,ge,V)}));return(0,f.$Ugc)(P,j,W,this.j)}o(E,P){const z=a(E.lines),j=E.line_number;return z.replace(/\r?\n$/,"").split(`
`).map((F,O)=>({text:F,uri:P,lineNumber:j+O}))}p(E){this.emit("result",E)}}e.$3gc=o;function a(p){return p.bytes?Buffer.from(p.bytes,"base64").toString():p.text}function t(p){const E=/\n/g;let P=0,z=-1,j;for(;j=E.exec(p);)P++,z=j.index;const F=z>=0?p.length-z-1:p.length;return{numLines:P,lastLineLength:F}}function r(p,E){const P=["--hidden","--no-require-git"];P.push(p.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:z,otherIncludes:j}=(0,L.$J)(E.includes,O=>O.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(j&&j.length){const O=new Set;j.forEach(T=>{O.add(T)}),P.push("-g","!*"),O.forEach(T=>{h(T).map(f.$Tgc).forEach(M=>{P.push("-g",M)})})}z&&z.length&&z.forEach(O=>{P.push("-g",O)}),E.excludes.map(f.$Tgc).forEach(O=>P.push("-g",`!${O}`)),E.maxFileSize&&P.push("--max-filesize",E.maxFileSize+""),E.useIgnoreFiles?E.useParentIgnoreFiles||P.push("--no-ignore-parent"):P.push("--no-ignore"),E.followSymlinks&&P.push("--follow"),E.encoding&&E.encoding!=="utf8"&&P.push("--encoding",E.encoding),p.pattern==="--"&&(p.isRegExp=!0,p.pattern="\\-\\-"),p.isMultiline&&!p.isRegExp&&(p.pattern=(0,y.$Je)(p.pattern),p.isRegExp=!0),E.usePCRE2&&P.push("--pcre2"),P.push("--crlf"),p.isRegExp&&(p.pattern=u(p.pattern),P.push("--engine","auto"));let F;if(p.isWordMatch){const T=(0,y.$Re)(p.pattern,!!p.isRegExp,{wholeWord:p.isWordMatch}).source.replace(/\\\//g,"/");P.push("--regexp",T)}else if(p.isRegExp){let O=l(p.pattern);O=k(O),P.push("--regexp",O)}else F=p.pattern,P.push("--fixed-strings");return P.push("--no-config"),E.useGlobalIgnoreFiles||P.push("--no-ignore-global"),P.push("--json"),p.isMultiline&&P.push("--multiline"),E.beforeContext&&P.push("--before-context",E.beforeContext+""),E.afterContext&&P.push("--after-context",E.afterContext+""),P.push("--"),F&&P.push(F),P.push("."),P}e.$4gc=r;function h(p){return w(p).flatMap(P=>{const z=(0,b.$Ej)(P,"/");return z.map((j,F)=>z.slice(0,F+1).join("/"))})}function u(p){const E=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;p.match(E);)p=p.replace(E,"$1\\x{$2}");const P=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;p.match(P);)p=p.replace(P,"$1\\x{$2}");return p}e.$5gc=u;const c=p=>p.type==="Assertion"&&p.kind==="lookbehind";function l(p){let E;try{E=new v.RegExpParser().parsePattern(p)}catch{return p}let P="",z=0;const j=(T,M,W)=>{P+=p.slice(z,T)+W,z=M},F=[];return new v.RegExpVisitor({onCharacterEnter(T){if(T.raw!=="\\n")return;const M=F[0];if(!M)j(T.start,T.end,"\\r?\\n");else if(!F.some(c))if(M.type==="CharacterClass")if(M.negate){const W=p.slice(M.start+2,T.start)+p.slice(T.end,M.end-1);M.parent?.type==="Quantifier"?j(M.start,M.end,W?`[^${W}]`:"."):j(M.start,M.end,"(?!\\r?\\n"+(W?`|[${W}]`:"")+")")}else{const W=p.slice(M.start+1,T.start)+p.slice(T.end,M.end-1);j(M.start,M.end,W===""?"\\r?\\n":`(?:[${W}]|\\r?\\n)`)}else M.type==="Quantifier"&&j(T.start,T.end,"(?:\\r?\\n)")},onQuantifierEnter(T){F.unshift(T)},onQuantifierLeave(){F.shift()},onCharacterClassRangeEnter(T){F.unshift(T)},onCharacterClassRangeLeave(){F.shift()},onCharacterClassEnter(T){F.unshift(T)},onCharacterClassLeave(){F.shift()},onAssertionEnter(T){c(T)&&F.push(T)},onAssertionLeave(T){F[0]===T&&F.shift()}}).visit(E),P+=p.slice(z),P}e.$6gc=l;function k(p){return p.replace(/\n/g,"\\r?\\n")}e.$7gc=k;function R(p){let E=!1,P=!1,z="",j="";for(let F=0;F<p.length;F++){const O=p[F];switch(O){case"\\":P?(E?j+="\\"+O:z+="\\"+O,P=!1):P=!0;break;case"{":if(P)E?j+=O:z+=O,P=!1;else{if(E)return{strInBraces:z+"{"+j+"{"+p.substring(F+1)};E=!0}break;case"}":if(P)E?j+=O:z+=O,P=!1;else{if(E)return{fixedStart:z,strInBraces:j,fixedEnd:p.substring(F+1)};z+=O}break;default:E?j+=(P?"\\":"")+O:z+=(P?"\\":"")+O,P=!1;break}}return{strInBraces:z+(E?"{"+j:"")}}function w(p){const{fixedStart:E,strInBraces:P,fixedEnd:z}=R(p);if(E===void 0||z===void 0)return[P];let j=(0,b.$Ej)(P,",");j.length||(j=[""]);const F=w(z);return j.flatMap(O=>{const T=E+O;return F.map(M=>T+M)})}e.$8gc=w}),define(Ee[375],Se([1,0,21,156,85,17]),function($e,e,D,N,g,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=void 0;class L{constructor(y){this.b=y,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(y,A,C,m){const v=new N.$2gc(this.b);if(A.folder.scheme===I.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:I.Schemas.file})},f=new g.$dv(d=>C.report({...d,uri:d.uri.with({scheme:A.folder.scheme})}));return this.c(m,d=>v.provideTextSearchResults(y,S,f,d))}else return this.c(m,S=>v.provideTextSearchResults(y,A,C,S))}async c(y,A){const C=b(y);this.a.add(C);const m=await A(C.token);return this.a.delete(C),m}d(){this.a.forEach(y=>y.cancel())}}e.$_gc=L;function b($){const y=new D.$2d;return $.onCancellationRequested(()=>y.cancel()),y}}),define(Ee[376],Se([1,0,31,156,155]),function($e,e,D,N,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=void 0;class I{constructor($){this.a=$}search($,y,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const C={appendLine(v){A({message:v})}},m=new g.$9gc(this.a,new N.$2gc(C),D);return new Promise((v,S)=>m.search(f=>{y(f.map(L))},$).then(f=>v({limitHit:f.limitHit,type:"success",stats:f.stats}),S))}}e.$0gc=I;function L(b){return{path:b.resource&&b.resource.fsPath,results:b.results,numMatches:(b.results||[]).reduce(($,y)=>{if(y.ranges){const A=y;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(Ee[377],Se([1,0,19,12,8,4,129,16,38,2,32,36,372,376]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=void 0;class S{static{this.a=512}constructor(o="searchProcess"){this.d=o,this.b=Object.create(null)}fileSearch(o){let a;const t=s(o),r=new I.$Rd({onDidAddFirstListener:()=>{a=(0,N.$Ng)(h=>this.doFileSearchWithEngine(m.$1gc,t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}textSearch(o){let a;const t=s(o),r=new I.$Rd({onDidAddFirstListener:()=>{a=(0,N.$Ng)(h=>this.f(t,u=>r.fire(u),h)),a.then(h=>r.fire(h),h=>r.fire({type:"error",error:{message:h.message,stack:h.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return r.event}f(o,a,t){return o.maxFileSize=this.g().maxFileSize,new v.$0gc(o).search(t,a,a)}g(){return{maxFileSize:16*A.$Qk.GB}}doFileSearch(o,a,t){return this.doFileSearchWithEngine(m.$1gc,o,a,t)}doFileSearchWithEngine(o,a,t,r,h=S.a){let u=0;const c=k=>{Array.isArray(k)?(u+=k.length,t(k.map(R=>this.h(R)))):k.relativePath?(u++,t(this.h(k))):t(k)};if(a.sortByScore){let k=this.l(a,c,r);if(!k){const R=a.maxResults?Object.assign({},a,{maxResults:null}):a,w=new o(R);k=this.j(w,a,t,c,r)}return new Promise((R,w)=>{k.then(([p,E])=>{const P=E.map(z=>this.h(z));this.o(P,t,h),R(p)},w)})}const l=new o(a);return this.r(l,c,h,r).then(k=>({limitHit:k.limitHit,type:"success",stats:{detailStats:k.stats,type:this.d,fromCache:!1,resultCount:u,sortingTime:void 0}}))}h(o){return{path:o.base?(0,b.$ic)(o.base,o.relativePath):o.relativePath}}j(o,a,t,r,h){const u=new I.$Rd;let c=(0,N.$Ng)(k=>{let R=[];const w=p=>{Array.isArray(p)?R=p:(r(p),u.fire(p))};return this.r(o,w,-1,k).then(p=>[p,R])}),l;if(a.cacheKey){l=this.k(a.cacheKey);const k={promise:c,event:u.event,resolved:!1};l.resultsToSearchCache[a.filePattern||""]=k,c.then(()=>{k.resolved=!0},R=>{delete l.resultsToSearchCache[a.filePattern||""]}),c=this.s(c)}return c.then(([k,R])=>{const w=l?l.scorerCache:Object.create(null),p=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Nd.create(!1);return this.n(a,R,w,h).then(E=>{const P=p?p.elapsed():-1;return[{type:"success",stats:{detailStats:k.stats,sortingTime:P,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:E.length},messages:k.messages,limitHit:k.limitHit||typeof a.maxResults=="number"&&R.length>a.maxResults},E]})})}k(o){const a=this.b[o];return a||(this.b[o]=new f)}l(o,a,t){const r=o.cacheKey&&this.b[o.cacheKey];if(!r)return;const h=this.q(r,o.filePattern||"",a,t);if(h)return h.then(([u,c,l])=>{const k=$.$Nd.create(!1);return this.n(o,c,r.scorerCache,t).then(R=>{const w=k.elapsed(),p={fromCache:!0,detailStats:l,type:this.d,resultCount:c.length,sortingTime:w};return[{type:"success",limitHit:u.limitHit||typeof o.maxResults=="number"&&c.length>o.maxResults,stats:p},R]})})}n(o,a,t,r){const h=(0,L.$Iq)(o.filePattern||""),u=(l,k)=>(0,L.$Hq)(l,k,h,!0,d,t),c=typeof o.maxResults=="number"?o.maxResults:Number.MAX_VALUE;return D.$Fb(a,u,c,1e4,r)}o(o,a,t){if(t&&t>0)for(let r=0;r<o.length;r+=t)a(o.slice(r,r+t));else a(o)}q(o,a,t,r){const h=$.$Nd.create(!1),u=a.indexOf(b.sep)>=0;let c;for(const w in o.resultsToSearchCache)if(a.startsWith(w)){if(u&&w.indexOf(b.sep)<0&&w!=="")continue;const p=o.resultsToSearchCache[w];c={promise:this.s(p.promise),event:p.event,resolved:p.resolved};break}if(!c)return null;const l=h.elapsed(),k=$.$Nd.create(!1),R=c.event(t);return r&&r.onCancellationRequested(()=>{R.dispose()}),c.promise.then(([w,p])=>{if(r&&r.isCancellationRequested)throw(0,g.$5)();const E=[],P=(0,L.$Iq)(a).normalizedLowercase;for(const z of p)(0,C.$fJ)(z,P)&&E.push(z);return[w,E,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:k.elapsed(),cacheEntryCount:p.length}]})}r(o,a,t,r){return new Promise((h,u)=>{let c=[];r?.onCancellationRequested(()=>o.cancel()),o.search(l=>{l&&(t?(c.push(l),t>0&&c.length>=t&&(a(c),c=[])):a(l))},l=>{a(l)},(l,k)=>{c.length&&a(c),l?u(l):h(k)})})}clearCache(o){return delete this.b[o],Promise.resolve(void 0)}s(o){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return o.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return o.finally(a)}}}}e.$$gc=S;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const d=new class{getItemLabel(n){return(0,b.$mc)(n.relativePath)}getItemDescription(n){return(0,b.$lc)(n.relativePath)}getItemPath(n){return n.relativePath}};function s(n){return{...n,folderQueries:n.folderQueries&&n.folderQueries.map(i),extraFileResources:n.extraFileResources&&n.extraFileResources.map(o=>y.URI.revive(o))}}function i(n){return{...n,folder:y.URI.revive(n.folder)}}}),define(Ee[378],Se([1,0,3,17,2,31,14,27,20,97,66,36,377,375,119,155]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ahc=void 0;let d=class extends y.$Yfc{constructor(i,n,o,a){super(i,o,a),this.s=I,this.t=-1,this.v=null,this.w=!1,this.x=new D.$Qc;const t=new S.$Vgc("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new v.$_gc(t))),n.remote.isRemote&&n.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$Vgc("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new v.$_gc(i))),this.x.add(this.z(N.Schemas.file,new m.$$gc("fileSearchProvider")))}z(i,n){const o=this.d++;return this.v=n,this.t=o,this.c.$registerFileSearchProvider(o,this.o(i)),(0,D.$Pc)(()=>{this.v=null,this.c.$unregisterProvider(o)})}$provideFileSearchResults(i,n,o,a){const t=(0,y.$Zfc)(o);return i===this.t?this.A(i,n,t,a):super.$provideFileSearchResults(i,n,o,a)}doInternalFileSearchWithCustomCallback(i,n,o){const a=t=>{if((0,C.$eJ)(t)&&(t=[t]),Array.isArray(t)){o(t.map(r=>g.URI.file(r.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,n)}async A(i,n,o,a){return this.doInternalFileSearchWithCustomCallback(o,a,t=>{this.c.$handleFileMatch(i,n,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,n){return new f.$9gc(i,n,void 0,"textSearchProvider")}};e.$ahc=d,e.$ahc=d=Ke([We(0,$.$HM),We(1,b.$XM),We(2,A.$Rec),We(3,L.$hj)],d)}),define(Ee[120],Se([1,0,392,62,63,393,22,8,4,3,16,11,30,81,82]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vh=e.$Uh=e.$Th=e.$Sh=e.$Rh=e.$Qh=e.$Ph=e.$Oh=void 0;class f{traceSocketEvent(p,E){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,p,E)}constructor(p,E=""){this.f=!0,this.debugLabel=E,this.socket=p,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=P=>{if(this.traceSocketEvent("error",{code:P?.code,message:P?.message}),P){if(P.code==="EPIPE")return;(0,b.$Z)(P)}},this.socket.on("error",this.a),this.b=P=>{this.traceSocketEvent("close",{hadError:P}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(p){const E=P=>{this.traceSocketEvent("read",P),p(L.$fe.wrap(P))};return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(p){const E=P=>{p({type:0,hadError:P,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(p){const E=()=>{p()};return this.socket.on("end",E),{dispose:()=>this.socket.off("end",E)}}write(p){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",p),this.socket.write(p.buffer,E=>{if(E){if(E.code==="EPIPE")return;(0,b.$Z)(E)}})}catch(E){if(E.code==="EPIPE")return;(0,b.$Z)(E)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((p,E)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),p();return}const P=()=>{this.socket.off("close",P),this.socket.off("end",P),this.socket.off("error",P),this.socket.off("timeout",P),this.socket.off("drain",P),this.traceSocketEvent("nodeDrainEnd"),p()};this.socket.on("close",P),this.socket.on("end",P),this.socket.on("error",P),this.socket.on("timeout",P),this.socket.on("drain",P)})}}e.$Oh=f;var d;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var s;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(s||(s={}));class i extends y.$Rc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(p,E){this.socket.traceSocketEvent(p,E)}constructor(p,E,P,z){super(),this.f=this.B(new $.$Rd),this.g=this.B(new $.$Rd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=p,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:E,inflateBytesLength:P?.byteLength||0,recordInflateBytes:z}),this.a=this.B(new n(this,E,P,z,this.f,(j,F)=>this.m(j,F))),this.B(this.a.onError(j=>{console.error(j),(0,b.$Z)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new S.$Jh,this.B(this.socket.onData(j=>this.n(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(p){return this.f.event(p)}onClose(p){return this.g.event(p)}onEnd(p){return this.socket.onEnd(p)}write(p){let E=0;for(;E<p.byteLength;)this.a.writeMessage(p.slice(E,Math.min(E+262144,p.byteLength)),{compressed:!0,opcode:2}),E+=262144}m(p,{compressed:E,opcode:P}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",p);let z=2;p.byteLength<126?z+=0:p.byteLength<2**16?z+=2:z+=8;const j=L.$fe.alloc(z),F=E?64:0,O=P&15;if(j.writeUInt8(128|F|O,0),p.byteLength<126)j.writeUInt8(p.byteLength,1);else if(p.byteLength<2**16){j.writeUInt8(126,1);let T=1;j.writeUInt8(p.byteLength>>>8&255,++T),j.writeUInt8(p.byteLength>>>0&255,++T)}else{j.writeUInt8(127,1);let T=1;j.writeUInt8(0,++T),j.writeUInt8(0,++T),j.writeUInt8(0,++T),j.writeUInt8(0,++T),j.writeUInt8(p.byteLength>>>24&255,++T),j.writeUInt8(p.byteLength>>>16&255,++T),j.writeUInt8(p.byteLength>>>8&255,++T),j.writeUInt8(p.byteLength>>>0&255,++T)}this.socket.write(L.$fe.concat([j,p]))}end(){this.h=!0,this.socket.end()}n(p){if(p.byteLength!==0){for(this.b.acceptChunk(p);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const E=this.b.peek(this.j.readLen),P=E.readUInt8(0),z=(P&128)>>>7,j=(P&64)>>>6,F=P&15,O=E.readUInt8(1),T=(O&128)>>>7,M=O&127;this.j.state=2,this.j.readLen=2+(T?4:0)+(M===126?2:0)+(M===127?8:0),this.j.fin=z,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!z,this.j.mask=0,this.j.opcode=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const E=this.b.read(this.j.readLen),P=E.readUInt8(1),z=(P&128)>>>7;let j=P&127,F=1;j===126?j=E.readUInt8(++F)*2**8+E.readUInt8(++F):j===127&&(j=E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*0+E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F));let O=0;z&&(O=E.readUInt8(++F)*2**24+E.readUInt8(++F)*2**16+E.readUInt8(++F)*2**8+E.readUInt8(++F)),this.j.state=3,this.j.readLen=j,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const E=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",E),t(E,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",E),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(E,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(E,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Ph=i;class n extends y.$Rc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:L.$fe.alloc(0)}constructor(p,E,P,z,j,F){super(),this.n=p,this.r=j,this.s=F,this.a=this.B(new $.$Rd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Rd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Rd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,E?(this.b=this.B(new o(this.n,z,P,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(p,E){this.g.push({data:p,options:E}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:p,options:E}=this.g.shift();if(this.f&&E.compressed){const P=await this.w(this.f,p);this.s(P,E)}else this.s(p,{...E,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(p,E){return new Promise((P,z)=>{p.write(E),p.flush(j=>P(j))})}acceptFrame(p,E,P){this.h.push({data:p,isCompressed:E,isLastFrameOfMessage:P}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const p=this.h.shift();if(this.b&&p.isCompressed){const E=await this.C(this.b,p.data,p.isLastFrameOfMessage);this.r.fire(E)}else this.r.fire(p.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(p,E,P){return new Promise((z,j)=>{p.write(E),P&&p.write(L.$fe.fromByteArray([0,0,255,255])),p.flush(F=>z(F))})}}class o extends y.$Rc{get recordedInflateBytes(){return this.j?L.$fe.concat(this.f):L.$fe.alloc(0)}constructor(p,E,P,z){super(),this.h=p,this.j=E,this.a=this.B(new $.$Rd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,I.createInflateRaw)(z),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(L.$fe.wrap(j))}),P&&(this.h.traceSocketEvent("zlibInflateInitialWrite",P.buffer),this.b.write(P.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(p){this.j&&this.f.push(p.clone()),this.h.traceSocketEvent("zlibInflateWrite",p),this.b.write(p.buffer)}flush(p){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const E=L.$fe.concat(this.g);this.g.length=0,p(E)})}}class a extends y.$Rc{constructor(p,E){super(),this.g=p,this.a=this.B(new $.$Rd),this.onError=this.a.event,this.f=[],this.b=(0,I.createDeflateRaw)({windowBits:15}),this.b.on("error",P=>{this.g.traceSocketEvent("zlibDeflateError",{message:P?.message,code:P?.code}),this.a.fire(P)}),this.b.on("data",P=>{this.g.traceSocketEvent("zlibDeflateData",P),this.f.push(L.$fe.wrap(P))})}write(p){this.g.traceSocketEvent("zlibDeflateWrite",p.buffer),this.b.write(p.buffer)}flush(p){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let E=L.$fe.concat(this.f);this.f.length=0,E=E.slice(0,E.byteLength-4),p(E)})}}function t(w,p){if(p===0)return;const E=w.byteLength>>>2;for(let T=0;T<E;T++){const M=w.readUInt32BE(T*4);w.writeUInt32BE(M^p,T*4)}const P=E*4,z=w.byteLength-P,j=p>>>24&255,F=p>>>16&255,O=p>>>8&255;z>=1&&w.writeUInt8(w.readUInt8(P)^j,P),z>=2&&w.writeUInt8(w.readUInt8(P+1)^F,P+1),z>=3&&w.writeUInt8(w.readUInt8(P+2)^O,P+2)}e.$Qh=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function h(){const w=(0,m.$kg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const p=process.platform!=="darwin"&&e.$Qh?e.$Qh:(0,g.tmpdir)(),E=(0,A.$ic)(p,`vscode-ipc-${w}.sock`);return c(E),E}e.$Rh=h;function u(w,p,E){const P=(0,D.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${P}-${E}-${p}-sock`;const z=E.substr(0,4),j=p.substr(0,6),F=P.substr(0,8);let O;return process.platform!=="darwin"&&e.$Qh&&!process.env.VSCODE_PORTABLE?O=(0,A.$ic)(e.$Qh,`vscode-${F}-${z}-${j}.sock`):O=(0,A.$ic)(w,`${z}-${j}.sock`),c(O),O}e.$Sh=u;function c(w){const p=r[C.$u];typeof p=="number"&&w.length>=p&&console.warn(`WARNING: IPC handle "${w}" is longer than ${p} chars, try a shorter --user-data-dir`)}class l extends v.$Dh{static b(p){const E=$.Event.fromNodeEventEmitter(p,"connection");return $.Event.map(E,P=>({protocol:new S.$Kh(new f(P,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(P,"close"))}))}constructor(p){super(l.b(p)),this.d=p}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Th=l;function k(w){return new Promise((p,E)=>{const P=(0,N.createServer)();P.on("error",E),P.listen(w,()=>{P.removeListener("error",E),p(new l(P))})})}e.$Uh=k;function R(w,p){return new Promise((E,P)=>{const z=(0,N.createConnection)(w,()=>{z.removeListener("error",P),E(S.$Lh.fromSocket(new f(z,`ipc-client${p}`),p))});z.once("error",P)})}e.$Vh=R}),define(Ee[379],Se([1,0,62,63,165,120,12,3,11,45,14,136,256,257,109,88,22]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D0b=e.$C0b=e.$B0b=e.$A0b=void 0;async function s(t,r,h,u,c){let l;for(let k=3;k&&(l?.dispose(),l=await new i(t,r,h,u,c).waitForReady(),!(c&&g.$ng[c]||!g.$ng[l.tunnelLocalPort]));k--);return l}class i extends b.$Rc{constructor(r,h,u,c,l){super(),this.m=h,this.n=l,this.privacy=f.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=D.createServer(),this.c=new L.$Yg,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=k=>this.r(k),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=c,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(h=>{h()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,h=(0,f.$pv)(this.m)?"0.0.0.0":"127.0.0.1";let u=await(0,g.$og)(r,2,1e3,h),c=null;return this.b.listen(u,this.m),await this.c.wait(),c=this.b.address(),c||(u=0,this.b.listen(u,this.m),await this.c.wait(),c=this.b.address()),this.tunnelLocalPort=c.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${c.port}`,this}async r(r){r.pause();const h=(0,f.$nv)(this.tunnelRemoteHost)||(0,f.$pv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,m.$dl)(this.a,h,this.tunnelRemotePort),c=u.getSocket(),l=u.readEntireBuffer();u.dispose(),l.byteLength>0&&r.write(l.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),c.end()}),r.on("close",()=>c.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),c instanceof I.$Oh?c.socket.destroy():c.end()}),c instanceof I.$Oh?this.t(r,c):this.s(r,c),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),c.end()})}s(r,h){h.onClose(()=>r.destroy()),h.onEnd(()=>r.end()),h.onData(u=>r.write(u.buffer)),r.on("data",u=>h.write(d.$fe.wrap(u))),r.resume()}t(r,h){const u=h.socket;u.on("end",()=>r.end()),u.on("close",()=>r.end()),u.on("error",()=>{r.destroy()}),u.pipe(r),r.pipe(u)}}e.$A0b=i;let n=class extends f.$sv{constructor(r,h,u,c,l){super(h,l),this.u=r,this.v=u,this.w=c}isPortPrivileged(r){return(0,f.$qv)(r,this.l,$.OS,N.release())}s(r,h,u,c,l,k,R,w){const p=this.r(h,u);if(p)return++p.refcount,p.value;if((0,f.$kv)(r))return this.t(r,h,u,l,k,R,w);{this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${u} on local port ${l}.`);const E={commit:this.w.commit,quality:this.w.quality,addressProvider:r,remoteSocketFactoryService:this.u,signService:this.v,logService:this.j,ipcLogger:null},P=s(E,c,h,u,l);return this.j.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.p(h,u,P),P}}};e.$B0b=n,e.$B0b=n=Ke([We(0,v.$0k),We(1,A.$hj),We(2,S.$al),We(3,C.$zj),We(4,y.$ti)],n);let o=class extends n{constructor(r,h,u,c,l){super(r,h,u,c,l)}};e.$C0b=o,e.$C0b=o=Ke([We(0,v.$0k),We(1,A.$hj),We(2,S.$al),We(3,C.$zj),We(4,y.$ti)],o);let a=class extends b.$Rc{constructor(r,h,u,c,l){super(),this.b=r,this.c=h,this.f=u,this.g=c,this.h=l,this.a=new Map}async openTunnel(r,h,u,c,l,k,R,w,p){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${c} on local port ${k}.`),!this.a.has(r)){const E=new o(this.b,this.c,this.g,this.f,this.h);this.B(E),this.a.set(r,E),E.onTunnelClosed(async()=>{(await E.tunnels).length===0&&(E.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(h,u,c,l,k,R,w,p)}};e.$D0b=a,e.$D0b=a=Ke([We(0,v.$0k),We(1,A.$hj),We(2,C.$zj),We(3,S.$al),We(4,y.$ti)],a)}),define(Ee[380],Se([1,0,120,276,55,35,2,14,40]),function($e,e,D,N,g,I,L,b,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0M=e.$9M=void 0;class y{constructor(m,v,S){this.b=m,this.c=v,this.f=S,this.a=N.createServer((f,d)=>this.h(f,d)),this.g().catch(f=>(v.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",m=>this.c.error(m))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(m,v){const S=(d,s)=>{v.writeHead(d,{"content-type":"application/json"}),v.end(JSON.stringify(s||null),i=>i&&this.c.error(i))},f=[];m.setEncoding("utf8"),m.on("data",d=>f.push(d)),m.on("end",async()=>{try{const d=JSON.parse(f.join(""));let s;switch(d.type){case"open":s=await this.i(d);break;case"openExternal":s=await this.j(d);break;case"status":s=await this.l(d);break;case"extensionManagement":s=await this.k(d);break;default:S(404,`Unknown message type: ${d.type}`);break}S(200,s)}catch(d){const s=d instanceof Error?d.message:JSON.stringify(d);S(500,s),this.c.error("Error while processing pipe request",d)}})}async i(m){const{fileURIs:v,folderURIs:S,forceNewWindow:f,diffMode:d,mergeMode:s,addMode:i,forceReuseWindow:n,gotoLineMode:o,waitMarkerFilePath:a,remoteAuthority:t}=m,r=[];if(Array.isArray(S))for(const l of S)try{r.push({folderUri:L.URI.parse(l)})}catch{}if(Array.isArray(v))for(const l of v)try{(0,$.$si)(l)?r.push({workspaceUri:L.URI.parse(l)}):r.push({fileUri:L.URI.parse(l)})}catch{}const h=a?L.URI.file(a):void 0,c={forceNewWindow:f,diffMode:d,mergeMode:s,addMode:i,gotoLineMode:o,forceReuseWindow:n,preferNewWindow:!n&&!h&&!i,waitMarkerFileURI:h,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",r,c)}async j(m){for(const v of m.uris){const S=L.URI.parse(v),f=S.scheme==="file"?S:v;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(m){const v=f=>f?.map(d=>/\.vsix$/i.test(d)?L.URI.parse(d):d),S={list:m.list,install:v(m.install),uninstall:v(m.uninstall),force:m.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(m){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&g.existsSync(this.f)&&g.unlinkSync(this.f)}}e.$9M=y;let A=class extends y{constructor(m,v){super(m,v,(0,D.$Rh)())}};e.$0M=A,e.$0M=A=Ke([We(0,I.$4M),We(1,b.$hj)],A)}),define(Ee[381],Se([1,0,56,368,363,275,48,348,2,17,7,380,103,346,347]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class f extends g.$Ggc{j(){const i=this,n=globalThis._VSCODE_NODE_MODULES.module,o=n._load;n._load=function(h,u,c){return h=t(h),i.a.has(h)?i.a.get(h).load(h,$.URI.file((0,m.$fq)(u.filename)),l=>o.apply(this,[l,u,c])):o.apply(this,arguments)};const a=n._resolveLookupPaths;n._resolveLookupPaths=(r,h)=>a.call(this,t(r),h);const t=r=>{for(const h of i.b){const u=h(r);if(u){r=u;break}}return r}}}class d extends L.$vfc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(v.$dhc);const i=this.h.invokeFunction(N.$Cgc);if(this.h.createInstance(b.$chc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(C.$0M);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$ehc),await this.h.createInstance(f,i,{mine:this.J,all:this.L}).install(),D.mark("code/extHost/didInitAPI");const o=await this.m.getConfigProvider();await(0,I.$bhc)(this.j,o,this,this.s,this.z,this.f),D.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,n,o){if(n.scheme!==y.Schemas.file)throw new Error(`Cannot load URI: '${n}', must be of file-scheme`);let a=null;o.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${n.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&D.mark(`code/extHost/willLoadExtensionCode/${t}`),a=$e.__$__nodeRequire(n.fsPath)}finally{t&&D.mark(`code/extHost/didLoadExtensionCode/${t}`),o.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const n in i){const o=i[n];o===null?delete process.env[n]:process.env[n]=o}}}e.$fhc=d}),define(Ee[382],Se([1,0,51,22,4,3,122,11,23,2,31,14,255,64,109,88,379,27,20,72,357]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=e.$khc=e.$jhc=e.$ihc=e.$hhc=e.$ghc=void 0;function a(p){const E=p.trim().split(`
`),P=[];return E.forEach(j=>{const F=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(j);F&&F.length>=3&&P.push({pid:parseInt(F[1],10),socket:parseInt(F[2],10)})}),P.reduce((j,F)=>(j[F.socket]=F,j),{})}e.$ghc=a;function t(...p){const E=[].concat(...p.map(h));return[...new Map(E.filter(P=>P.st==="0A").map(P=>{const z=P.local_address.split(":");return{socket:parseInt(P.inode,10),ip:r(z[0]),port:parseInt(z[1],16)}}).map(P=>[P.ip+":"+P.port,P])).values()]}e.$hhc=t;function r(p){let E="";if(p.length===8)for(let P=p.length-2;P>=0;P-=2)E+=parseInt(p.substr(P,2),16),P!==0&&(E+=".");else for(let P=0;P<p.length;P+=8){const z=p.substring(P,P+8);let j="";for(let F=8;F>=2;F-=2)j+=z.substring(F-2,F),(F===6||F===2)&&(j=parseInt(j,16).toString(16),E+=`${j}`,j="",P+F!==p.length-6&&(E+=":"))}return E}e.$ihc=r;function h(p){const E=p.trim().split(`
`),P=E.shift().trim().split(/\s+/).filter(j=>j!=="rx_queue"&&j!=="tm->when");return E.map(j=>j.trim().split(/\s+/).reduce((F,O,T)=>(F[P[T]||T]=O,F),{}))}e.$jhc=h;function u(p){return!!p.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||p.indexOf("out/server-main.js")!==-1||p.indexOf("_productName=VSCode")!==-1}function c(p){const E=p.trim().split(`
`),P=[];return E.forEach(z=>{const j=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(z);j&&j.length>=4&&P.push({pid:parseInt(j[1],10),ppid:parseInt(j[2]),cmd:j[3]})}),P}e.$khc=c;async function l(p,E,P){const z=P.reduce((F,O)=>(F[O.pid]=O,F),{}),j=[];return p.forEach(({socket:F,ip:O,port:T})=>{const M=E[F]?E[F].pid:void 0,W=M?z[M]?.cmd:void 0;M&&W&&!u(W)&&j.push({host:O,port:T,detail:W,pid:M})}),j}e.$lhc=l;function k(p,E,P){const z=new Map,j=c(E);for(const F of p){const O=P.get(F.port);if(O){z.set(F.port,O);continue}const T=j.find(M=>M.cmd.includes(`${F.port}`));if(T){let M=T,W;do W=j.find(Y=>Y.ppid===M.pid),W&&(M=W);while(W);z.set(F.port,{host:F.ip,port:F.port,pid:M.pid,detail:M.cmd,ppid:M.ppid})}else z.set(F.port,{host:F.ip,port:F.port,ppid:Number.MAX_VALUE})}return z}e.$mhc=k;let R=class extends n.$Ixb{constructor(E,P,z,j){super(E,P,z),this.D=P,this.F=j,this.y=void 0,this.z=new Map,this.C=!1,b.$k&&P.remote.isRemote&&P.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(E){if(E&&this.C)return;this.C=E;let P;this.y&&(P=this.y,await this.a.$onFoundNewCandidates(this.y));const z=new L.$2l;let j=0;for(;this.C;){const F=new Date().getTime(),O=(await this.I()).filter(W=>(0,f.$nv)(W.host)||(0,f.$pv)(W.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(W=>W.port).join(", ")}`);const T=new Date().getTime()-F;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${T} ms.`),j++>3&&z.update(T),(!P||JSON.stringify(P)!==JSON.stringify(O))&&(P=O,await this.a.$onFoundNewCandidates(P));const M=this.G(z.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${M} ms.`),await new Promise(W=>setTimeout(()=>W(),M))}}G(E){return Math.max(E*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(E=>E.port).join(", ")}`)}async I(){let E="",P="";try{E=await A.Promises.readFile("/proc/net/tcp","utf8"),P=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const z=t(E,P),j=await new Promise(Z=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,x,oe)=>{Z(x)})}),F=a(j),O=await A.Promises.readdir("/proc"),T=[];for(const Z of O)try{const Q=Number(Z),x=$.$Bg(y.URI.file("/proc"),Z);if((await A.Promises.stat(x.fsPath)).isDirectory()&&!isNaN(Q)){const X=await A.Promises.readlink($.$Bg(x,"cwd").fsPath),ve=await A.Promises.readFile($.$Bg(x,"cmdline").fsPath,"utf8");T.push({pid:Q,cwd:X,cmd:ve})}}catch{}const M=[],W=z.filter(Z=>{const Q=F[Z.socket];return Q||M.push(Z),Q}),Y=l(W,F,T);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${M.length}`),M.length>0){const Z=await new Promise(Q=>{(0,D.exec)("ps -F -A -l | grep root",(x,oe,X)=>{Q(oe)})});this.z=k(M,Z,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(Q=>Q.port).join(", ")}`)}return Y.then(Z=>ue?Z.concat(ue):Z)}w(E){return async P=>{const z=new d.$A0b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(F,O,T,M){const W=await E.makeConnection();return w.connect(W,O,T,M)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new v.$1k(0),connectionToken:E.connectionToken})}},signService:this.F},"localhost",P.remoteAddress.host||"localhost",P.remoteAddress.port,P.localAddressPort);await z.waitForReady();const j=new g.$Rd;return{localAddress:(0,o.$5J)(z.localAddress)??z.localAddress,remoteAddress:{port:z.tunnelRemotePort,host:z.tunnelRemoteHost},onDidDispose:j.event,dispose:()=>{z.dispose(),j.fire(),j.dispose()}}}}};e.$nhc=R,e.$nhc=R=Ke([We(0,i.$HM),We(1,s.$XM),We(2,C.$hj),We(3,S.$al)],R);class w extends m.$Nqb{static connect(E,P,z,j){const F=new I.$Qc,O={onClose:F.add(new g.$Rd),onData:F.add(new g.$Rd),onEnd:F.add(new g.$Rd)};F.add(E.onDidReceiveMessage(M=>O.onData.fire(N.$fe.wrap(M)))),F.add(E.onDidEnd(()=>O.onEnd.fire())),F.add(E.onDidClose(M=>O.onClose.fire({type:0,error:M,hadError:!!M})));const T=new w(E,j,O);return T.B(F),(0,m.$Mqb)(T,P,z,j,O)}constructor(E,P,z){super(P,z),this.n=E}write(E){this.n.send(E.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(Ee[383],Se([1,0,106,351,366,365,378,381,382,96,48,97,95,47,72,92,350,349,14,367,58,270,105,109,138]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s,i,n,o,a,t,r,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,D.$Gr)(A.$wfc,b.$fhc,0),(0,D.$Gr)(i.$ij,s.$phc,1),(0,D.$Gr)(i.$hj,new t.$Wh(a.$Fgc,[!1],!0)),(0,D.$Gr)(r.$al,h.$F0b,1),(0,D.$Gr)(f.$1ec,d.$ohc,0),(0,D.$Gr)(y.$Bfc,I.$Sgc,0),(0,D.$Gr)(C.$Xfc,L.$ahc,0),(0,D.$Gr)(m.$ogc,g.$Kgc,0),(0,D.$Gr)(v.$jfc,N.$Jgc,0),(0,D.$Gr)(S.$Hxb,$.$nhc,0),(0,D.$Gr)(o.$zfc,n.$qhc,0)}),define(Ee[394],Se([1,0,62,395,56,8,82,120,253,114,364,22,31,103,12,132,277,291,369,383]),function($e,e,D,N,g,I,L,b,$,y,A,C,m,v,S,f,d,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let l=0;l<process.execArgv.length;l++)process.execArgv[l]==="--inspect-port=0"&&(process.execArgv.splice(l,1),l--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,l=c._load;c._load=function(k){if(k==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return l.apply(this,arguments)}})();const n=process.exit.bind(process);function o(c){process.exit=function(l){if(c)n(l);else{const k=new Error("An extension called process.exit() and this was prevented.");console.warn(k.stack)}},process.crash=function(){const l=new Error("An extension called process.crash() and this was prevented.");console.warn(l.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let a=function(c){n()};function t(){const c=(0,s.$Lm)(process.env);if(c.type===3)return new Promise((l,k)=>{const R=w=>{const p=w[0],E=new L.$Mh;p.on("message",P=>E.fire(C.$fe.wrap(P.data))),p.on("close",()=>{a("renderer closed the MessagePort")}),p.start(),l({onMessage:E.event,send:P=>p.postMessage(P.buffer)})};process.parentPort.on("message",w=>R(w.ports))});if(c.type===2)return new Promise((l,k)=>{let R=null;const w=setTimeout(()=>{a("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),p=108e5,E=3e5,P=new S.$ah(()=>a("renderer disconnected for too long (1)"),p),z=new S.$ah(()=>a("renderer disconnected for too long (2)"),E);process.on("message",(F,O)=>{if(F&&F.type==="VSCODE_EXTHOST_IPC_SOCKET"){O.setNoDelay(!0);const T=C.$fe.wrap(Buffer.from(F.initialDataChunk,"base64"));let M;if(F.skipWebSocketFrames)M=new b.$Oh(O,"extHost-socket");else{const W=C.$fe.wrap(Buffer.from(F.inflateBytes,"base64"));M=new b.$Ph(new b.$Oh(O,"extHost-socket"),F.permessageDeflate,W,!1)}R?(P.cancel(),z.cancel(),R.beginAcceptReconnection(M,T),R.endAcceptReconnection(),R.sendResume()):(clearTimeout(w),R=new L.$Nh({socket:M,initialChunk:T}),R.sendResume(),R.onDidDispose(()=>a("renderer disconnected")),l(R),R.onSocketClose(()=>{P.schedule()}))}if(F&&F.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;P.isScheduled()&&z.schedule()}});const j={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(j)});{const l=c.pipeName;return new Promise((k,R)=>{const w=D.createConnection(l,()=>{w.removeListener("error",R);const p=new L.$Nh({socket:new b.$Oh(w,"extHost-renderer")});p.sendResume(),k(p)});w.once("error",R),w.on("close",()=>{a("renderer closed the socket")})})}}async function r(){const c=await t();return new class{constructor(){this.a=new L.$Mh,this.onMessage=this.a.event,this.b=!1,c.onMessage(l=>{(0,y.$mm)(l,2)?(this.b=!0,a("received terminate message from renderer")):this.a.fire(l)})}send(l){this.b||c.send(l)}async drain(){if(c.drain)return c.drain()}}}function h(c){return new Promise(l=>{const k=c.onMessage(R=>{k.dispose();const w=JSON.parse(R.toString()),p=w.commit,E=$.default.commit;if(p&&E&&p!==E&&n(55),w.parentPid){let P=0;setInterval(function(){try{process.kill(w.parentPid,0),P=0}catch(j){j&&j.code==="EPERM"?(P++,P>=3&&a(`parent process ${w.parentPid} does not exist anymore (3 x EPERM): ${j.message} (code: ${j.code}) (errno: ${j.errno})`)):a(`parent process ${w.parentPid} does not exist anymore: ${j.message} (code: ${j.code}) (errno: ${j.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(w.parentPid)}catch(j){(0,I.$Z)(j)}}c.send((0,y.$lm)(0)),l({protocol:c,initData:w})});c.send((0,y.$lm)(1))})}async function u(){const c=[];process.on("unhandledRejection",(P,z)=>{c.push(z),setTimeout(()=>{const j=c.indexOf(z);j>=0&&z.catch(F=>{c.splice(j,1),(0,I.$3)(F)||(console.warn(`rejected promise not handled within 1 second: ${F}`),F&&F.stack&&console.warn(`stack trace: ${F.stack}`),P&&(0,I.$Z)(P))})},1e3)}),process.on("rejectionHandled",P=>{const z=c.indexOf(P);z>=0&&c.splice(z,1)}),process.on("uncaughtException",function(P){(0,I.$Y)(P)||(0,I.$Z)(P)}),g.mark("code/extHost/willConnectToRenderer");const l=await r();g.mark("code/extHost/didConnectToRenderer");const k=await h(l);g.mark("code/extHost/didWaitForInitData");const{initData:R}=k;o(!!R.environment.extensionTestsLocationURI),R.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,R.environment.skipWorkspaceStorageLock=(0,f.boolean)(i.skipWorkspaceStorageLock,!1);const w=new class{constructor(){this.pid=process.pid}exit(z){n(z)}fsExists(z){return m.Promises.exists(z)}fsRealpath(z){return(0,v.$eq)(z)}};let p=null;R.remote.authority&&i.transformURIs&&(p=(0,d.$Kr)(R.remote.authority));const E=new A.$Igc(k.protocol,R,w,p);a=P=>E.terminate(P)}u().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef71b038ad2518e32514b6cc3a4df9f94c096e65/core/vs/workbench/api/node/extensionHostProcess.js.map
