/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/errors","vs/base/common/strings","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/path","vs/base/common/platform","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/base/common/severity","vs/workbench/api/common/extHostCommands","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/themables","vs/base/common/extpath","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/api/common/extHostTheming","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Re=function(pe){for(var e=[],E=0,T=pe.length;E<T;E++)e[E]=Pe[pe[E]];return e};define(Pe[66],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$th=e.$sh=e.$rh=void 0;function E(A){return(m,g,w)=>{let R=null,S=null;if(typeof w.value=="function"?(R="value",S=w.value):typeof w.get=="function"&&(R="get",S=w.get),!S)throw new Error("not supported");w[R]=A(S,g)}}function T(A,m,g){let w=null,R=null;if(typeof g.value=="function"?(w="value",R=g.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(w="get",R=g.get),!R)throw new Error("not supported");const S=`$memoize$${m}`;g[w]=function(...l){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,l)}),this[S]}}e.$rh=T;function P(A,m,g){return E((w,R)=>{const S=`$debounce$${R}`,l=`$debounce$result$${R}`;return function(...$){this[l]||(this[l]=g?g():void 0),clearTimeout(this[S]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[S]=setTimeout(()=>{w.apply(this,$),this[l]=g?g():void 0},A)}})}e.$sh=P;function M(A,m,g){return E((w,R)=>{const S=`$throttle$timer$${R}`,l=`$throttle$result$${R}`,$=`$throttle$lastRun$${R}`,b=`$throttle$pending$${R}`;return function(...a){if(this[l]||(this[l]=g?g():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...a)),this[b])return;const s=this[$]+A;s<=Date.now()?(this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0):(this[b]=!0,this[S]=setTimeout(()=>{this[b]=!1,this[$]=Date.now(),w.apply(this,[this[l]]),this[l]=g?g():void 0},s-Date.now()))}})}e.$th=M}),define(Pe[89],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NM=e.$MM=void 0;class E{constructor(P){this.a=P,this.b=0}nextId(){return this.a+ ++this.b}}e.$MM=E,e.$NM=new E("id#")}),define(Pe[119],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dn=e.$cn=e.$bn=e.$an=e.$_m=e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=e.$6m=e.$5m=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var T;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(T||(e.SyntaxKind=T={}));var P;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(P||(e.ParseErrorCode=P={}));var M;(function(i){i.DEFAULT={allowTrailingComma:!0}})(M||(e.ParseOptions=M={}));function A(i,r=!1){let u=0;const d=i.length;let v="",f=0,k=16,L=0;function p(F){let C=0,I=0;for(;C<F;){const X=i.charCodeAt(u);if(X>=48&&X<=57)I=I*16+X-48;else if(X>=65&&X<=70)I=I*16+X-65+10;else if(X>=97&&X<=102)I=I*16+X-97+10;else break;u++,C++}return C<F&&(I=-1),I}function y(F){u=F,v="",f=0,k=16,L=0}function D(){const F=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&w(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&w(i.charCodeAt(u)))for(u++;u<i.length&&w(i.charCodeAt(u));)u++;else return L=3,i.substring(F,u);let C=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&w(i.charCodeAt(u))){for(u++;u<i.length&&w(i.charCodeAt(u));)u++;C=u}else L=3;return i.substring(F,C)}function N(){let F="",C=u;for(;;){if(u>=d){F+=i.substring(C,u),L=2;break}const I=i.charCodeAt(u);if(I===34){F+=i.substring(C,u),u++;break}if(I===92){if(F+=i.substring(C,u),u++,u>=d){L=2;break}switch(i.charCodeAt(u++)){case 34:F+='"';break;case 92:F+="\\";break;case 47:F+="/";break;case 98:F+="\b";break;case 102:F+="\f";break;case 110:F+=`
`;break;case 114:F+="\r";break;case 116:F+="	";break;case 117:{const ue=p(4);ue>=0?F+=String.fromCharCode(ue):L=4;break}default:L=5}C=u;continue}if(I>=0&&I<=31)if(g(I)){F+=i.substring(C,u),L=2;break}else L=6;u++}return F}function q(){if(v="",L=0,f=u,u>=d)return f=d,k=17;let F=i.charCodeAt(u);if(m(F)){do u++,v+=String.fromCharCode(F),F=i.charCodeAt(u);while(m(F));return k=15}if(g(F))return u++,v+=String.fromCharCode(F),F===13&&i.charCodeAt(u)===10&&(u++,v+=`
`),k=14;switch(F){case 123:return u++,k=1;case 125:return u++,k=2;case 91:return u++,k=3;case 93:return u++,k=4;case 58:return u++,k=6;case 44:return u++,k=5;case 34:return u++,v=N(),k=10;case 47:{const C=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<d&&!g(i.charCodeAt(u));)u++;return v=i.substring(C,u),k=12}if(i.charCodeAt(u+1)===42){u+=2;const I=d-1;let X=!1;for(;u<I;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,X=!0;break}u++}return X||(u++,L=1),v=i.substring(C,u),k=13}return v+=String.fromCharCode(F),u++,k=16}case 45:if(v+=String.fromCharCode(F),u++,u===d||!w(i.charCodeAt(u)))return k=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return v+=D(),k=11;default:for(;u<d&&V(F);)u++,F=i.charCodeAt(u);if(f!==u){switch(v=i.substring(f,u),v){case"true":return k=8;case"false":return k=9;case"null":return k=7}return k=16}return v+=String.fromCharCode(F),u++,k=16}}function V(F){if(m(F)||g(F))return!1;switch(F){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function U(){let F;do F=q();while(F>=12&&F<=15);return F}return{setPosition:y,getPosition:()=>u,scan:r?U:q,getToken:()=>k,getTokenValue:()=>v,getTokenOffset:()=>f,getTokenLength:()=>u-f,getTokenError:()=>L}}e.$5m=A;function m(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function w(i){return i>=48&&i<=57}var R;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(R||(R={}));function S(i,r){const u=[],d=new Object;let v;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let k=!1;function L(p,y,D,N){f.value=p,f.offset=y,f.length=D,f.type=N,f.colonOffset=void 0,v=f}try{o(i,{onObjectBegin:(p,y)=>{if(r<=p)throw d;v=void 0,k=r>p,u.push("")},onObjectProperty:(p,y,D)=>{if(r<y||(L(p,y,D,"property"),u[u.length-1]=p,r<=y+D))throw d},onObjectEnd:(p,y)=>{if(r<=p)throw d;v=void 0,u.pop()},onArrayBegin:(p,y)=>{if(r<=p)throw d;v=void 0,u.push(0)},onArrayEnd:(p,y)=>{if(r<=p)throw d;v=void 0,u.pop()},onLiteralValue:(p,y,D)=>{if(r<y||(L(p,y,D,h(p)),r<=y+D))throw d},onSeparator:(p,y,D)=>{if(r<=y)throw d;if(p===":"&&v&&v.type==="property")v.colonOffset=y,k=!1,v=void 0;else if(p===","){const N=u[u.length-1];typeof N=="number"?u[u.length-1]=N+1:(k=!0,u[u.length-1]=""),v=void 0}}})}catch(p){if(p!==d)throw p}return{path:u,previousNode:v,isAtPropertyKey:k,matches:p=>{let y=0;for(let D=0;y<p.length&&D<u.length;D++)if(p[y]===u[D]||p[y]==="*")y++;else if(p[y]!=="**")return!1;return y===p.length}}}e.$6m=S;function l(i,r=[],u=M.DEFAULT){let d=null,v=[];const f=[];function k(p){Array.isArray(v)?v.push(p):d!==null&&(v[d]=p)}return o(i,{onObjectBegin:()=>{const p={};k(p),f.push(v),v=p,d=null},onObjectProperty:p=>{d=p},onObjectEnd:()=>{v=f.pop()},onArrayBegin:()=>{const p=[];k(p),f.push(v),v=p,d=null},onArrayEnd:()=>{v=f.pop()},onLiteralValue:k,onError:(p,y,D)=>{r.push({error:p,offset:y,length:D})}},u),v[0]}e.$7m=l;function $(i,r=[],u=M.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function v(p){d.type==="property"&&(d.length=p-d.offset,d=d.parent)}function f(p){return d.children.push(p),p}o(i,{onObjectBegin:p=>{d=f({type:"object",offset:p,length:-1,parent:d,children:[]})},onObjectProperty:(p,y,D)=>{d=f({type:"property",offset:y,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:p,offset:y,length:D,parent:d})},onObjectEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,v(p+y)},onArrayBegin:(p,y)=>{d=f({type:"array",offset:p,length:-1,parent:d,children:[]})},onArrayEnd:(p,y)=>{d.length=p+y-d.offset,d=d.parent,v(p+y)},onLiteralValue:(p,y,D)=>{f({type:h(p),offset:y,length:D,parent:d,value:p}),v(y+D)},onSeparator:(p,y,D)=>{d.type==="property"&&(p===":"?d.colonOffset=y:p===","&&v(y))},onError:(p,y,D)=>{r.push({error:p,offset:y,length:D})}},u);const L=d.children[0];return L&&delete L.parent,L}e.$8m=$;function b(i,r){if(!i)return;let u=i;for(const d of r)if(typeof d=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let v=!1;for(const f of u.children)if(Array.isArray(f.children)&&f.children[0].value===d){u=f.children[1],v=!0;break}if(!v)return}else{const v=d;if(u.type!=="array"||v<0||!Array.isArray(u.children)||v>=u.children.length)return;u=u.children[v]}return u}e.$9m=b;function a(i){if(!i.parent||!i.parent.children)return[];const r=a(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;r.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&r.push(u)}return r}e.$0m=a;function s(i){switch(i.type){case"array":return i.children.map(s);case"object":{const r=Object.create(null);for(const u of i.children){const d=u.children[1];d&&(r[u.children[0].value]=s(d))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$$m=s;function t(i,r,u=!1){return r>=i.offset&&r<i.offset+i.length||u&&r===i.offset+i.length}e.$_m=t;function n(i,r,u=!1){if(t(i,r,u)){const d=i.children;if(Array.isArray(d))for(let v=0;v<d.length&&d[v].offset<=r;v++){const f=n(d[v],r,u);if(f)return f}return i}}e.$an=n;function o(i,r,u=M.DEFAULT){const d=A(i,!1);function v(ne){return ne?()=>ne(d.getTokenOffset(),d.getTokenLength()):()=>!0}function f(ne){return ne?ke=>ne(ke,d.getTokenOffset(),d.getTokenLength()):()=>!0}const k=v(r.onObjectBegin),L=f(r.onObjectProperty),p=v(r.onObjectEnd),y=v(r.onArrayBegin),D=v(r.onArrayEnd),N=f(r.onLiteralValue),q=f(r.onSeparator),V=v(r.onComment),U=f(r.onError),F=u&&u.disallowComments,C=u&&u.allowTrailingComma;function I(){for(;;){const ne=d.scan();switch(d.getTokenError()){case 4:X(14);break;case 5:X(15);break;case 3:X(13);break;case 1:F||X(11);break;case 2:X(12);break;case 6:X(16);break}switch(ne){case 12:case 13:F?X(10):V();break;case 16:X(1);break;case 15:case 14:break;default:return ne}}}function X(ne,ke=[],ce=[]){if(U(ne),ke.length+ce.length>0){let Y=d.getToken();for(;Y!==17;){if(ke.indexOf(Y)!==-1){I();break}else if(ce.indexOf(Y)!==-1)break;Y=I()}}}function ue(ne){const ke=d.getTokenValue();return ne?N(ke):L(ke),I(),!0}function he(){switch(d.getToken()){case 11:{let ne=0;try{ne=JSON.parse(d.getTokenValue()),typeof ne!="number"&&(X(2),ne=0)}catch{X(2)}N(ne);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return I(),!0}function be(){return d.getToken()!==10?(X(3,[],[2,5]),!1):(ue(!1),d.getToken()===6?(q(":"),I(),me()||X(4,[],[2,5])):X(5,[],[2,5]),!0)}function we(){k(),I();let ne=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(ne||X(4,[],[]),q(","),I(),d.getToken()===2&&C)break}else ne&&X(6,[],[]);be()||X(4,[],[2,5]),ne=!0}return p(),d.getToken()!==2?X(7,[2],[]):I(),!0}function ge(){y(),I();let ne=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(ne||X(4,[],[]),q(","),I(),d.getToken()===4&&C)break}else ne&&X(6,[],[]);me()||X(4,[],[4,5]),ne=!0}return D(),d.getToken()!==4?X(8,[4],[]):I(),!0}function me(){switch(d.getToken()){case 3:return ge();case 1:return we();case 10:return ue(!0);default:return he()}}return I(),d.getToken()===17?u.allowEmptyContent?!0:(X(4,[],[]),!1):me()?(d.getToken()!==17&&X(9,[],[]),!0):(X(4,[],[]),!1)}e.$bn=o;function c(i,r){const u=A(i),d=[];let v,f=0,k;do switch(k=u.getPosition(),v=u.scan(),v){case 12:case 13:case 17:f!==k&&d.push(i.substring(f,k)),r!==void 0&&d.push(u.getTokenValue().replace(/[^\r\n]/g,r)),f=u.getPosition();break}while(v!==17);return d.join("")}e.$cn=c;function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$dn=h}),function(pe,e){typeof define=="function"&&define.amd?define(Pe[120],Re([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(pe=typeof globalThis<"u"?globalThis:pe||self,e(pe.marked={}))}(this,function(pe){"use strict";function e(Ce,le){for(var ie=0;ie<le.length;ie++){var G=le[ie];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(Ce,G.key,G)}}function E(Ce,le,ie){return le&&e(Ce.prototype,le),ie&&e(Ce,ie),Object.defineProperty(Ce,"prototype",{writable:!1}),Ce}function T(Ce,le){if(Ce){if(typeof Ce=="string")return P(Ce,le);var ie=Object.prototype.toString.call(Ce).slice(8,-1);if(ie==="Object"&&Ce.constructor&&(ie=Ce.constructor.name),ie==="Map"||ie==="Set")return Array.from(Ce);if(ie==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ie))return P(Ce,le)}}function P(Ce,le){(le==null||le>Ce.length)&&(le=Ce.length);for(var ie=0,G=new Array(le);ie<le;ie++)G[ie]=Ce[ie];return G}function M(Ce,le){var ie=typeof Symbol<"u"&&Ce[Symbol.iterator]||Ce["@@iterator"];if(ie)return(ie=ie.call(Ce)).next.bind(ie);if(Array.isArray(Ce)||(ie=T(Ce))||le&&Ce&&typeof Ce.length=="number"){ie&&(Ce=ie);var G=0;return function(){return G>=Ce.length?{done:!0}:{done:!1,value:Ce[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}pe.defaults=A();function m(Ce){pe.defaults=Ce}var g=/[&<>"']/,w=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(le){return l[le]};function b(Ce,le){if(le){if(g.test(Ce))return Ce.replace(w,$)}else if(R.test(Ce))return Ce.replace(S,$);return Ce}var a=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function s(Ce){return Ce.replace(a,function(le,ie){return ie=ie.toLowerCase(),ie==="colon"?":":ie.charAt(0)==="#"?ie.charAt(1)==="x"?String.fromCharCode(parseInt(ie.substring(2),16)):String.fromCharCode(+ie.substring(1)):""})}var t=/(^|[^\[])\^/g;function n(Ce,le){Ce=typeof Ce=="string"?Ce:Ce.source,le=le||"";var ie={replace:function(te,x){return x=x.source||x,x=x.replace(t,"$1"),Ce=Ce.replace(te,x),ie},getRegex:function(){return new RegExp(Ce,le)}};return ie}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ce,le,ie){if(Ce){var G;try{G=decodeURIComponent(s(ie)).replace(o,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}le&&!c.test(ie)&&(ie=v(le,ie));try{ie=encodeURI(ie).replace(/%25/g,"%")}catch{return null}return ie}var i={},r=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function v(Ce,le){i[" "+Ce]||(r.test(Ce)?i[" "+Ce]=Ce+"/":i[" "+Ce]=p(Ce,"/",!0)),Ce=i[" "+Ce];var ie=Ce.indexOf(":")===-1;return le.substring(0,2)==="//"?ie?le:Ce.replace(u,"$1")+le:le.charAt(0)==="/"?ie?le:Ce.replace(d,"$1")+le:Ce+le}var f={exec:function(){}};function k(Ce){for(var le=1,ie,G;le<arguments.length;le++){ie=arguments[le];for(G in ie)Object.prototype.hasOwnProperty.call(ie,G)&&(Ce[G]=ie[G])}return Ce}function L(Ce,le){var ie=Ce.replace(/\|/g,function(x,se,fe){for(var Se=!1,Fe=se;--Fe>=0&&fe[Fe]==="\\";)Se=!Se;return Se?"|":" |"}),G=ie.split(/ \|/),te=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>le)G.splice(le);else for(;G.length<le;)G.push("");for(;te<G.length;te++)G[te]=G[te].trim().replace(/\\\|/g,"|");return G}function p(Ce,le,ie){var G=Ce.length;if(G===0)return"";for(var te=0;te<G;){var x=Ce.charAt(G-te-1);if(x===le&&!ie)te++;else if(x!==le&&ie)te++;else break}return Ce.slice(0,G-te)}function y(Ce,le){if(Ce.indexOf(le[1])===-1)return-1;for(var ie=Ce.length,G=0,te=0;te<ie;te++)if(Ce[te]==="\\")te++;else if(Ce[te]===le[0])G++;else if(Ce[te]===le[1]&&(G--,G<0))return te;return-1}function D(Ce){Ce&&Ce.sanitize&&!Ce.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(Ce,le){if(le<1)return"";for(var ie="";le>1;)le&1&&(ie+=Ce),le>>=1,Ce+=Ce;return ie+Ce}function q(Ce,le,ie,G){var te=le.href,x=le.title?b(le.title):null,se=Ce[1].replace(/\\([\[\]])/g,"$1");if(Ce[0].charAt(0)!=="!"){G.state.inLink=!0;var fe={type:"link",raw:ie,href:te,title:x,text:se,tokens:G.inlineTokens(se)};return G.state.inLink=!1,fe}return{type:"image",raw:ie,href:te,title:x,text:b(se)}}function V(Ce,le){var ie=Ce.match(/^(\s+)(?:```)/);if(ie===null)return le;var G=ie[1];return le.split(`
`).map(function(te){var x=te.match(/^\s+/);if(x===null)return te;var se=x[0];return se.length>=G.length?te.slice(G.length):te}).join(`
`)}var U=function(){function Ce(ie){this.options=ie||pe.defaults}var le=Ce.prototype;return le.space=function(G){var te=this.rules.block.newline.exec(G);if(te&&te[0].length>0)return{type:"space",raw:te[0]}},le.code=function(G){var te=this.rules.block.code.exec(G);if(te){var x=te[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:te[0],codeBlockStyle:"indented",text:this.options.pedantic?x:p(x,`
`)}}},le.fences=function(G){var te=this.rules.block.fences.exec(G);if(te){var x=te[0],se=V(x,te[3]||"");return{type:"code",raw:x,lang:te[2]?te[2].trim():te[2],text:se}}},le.heading=function(G){var te=this.rules.block.heading.exec(G);if(te){var x=te[2].trim();if(/#$/.test(x)){var se=p(x,"#");(this.options.pedantic||!se||/ $/.test(se))&&(x=se.trim())}return{type:"heading",raw:te[0],depth:te[1].length,text:x,tokens:this.lexer.inline(x)}}},le.hr=function(G){var te=this.rules.block.hr.exec(G);if(te)return{type:"hr",raw:te[0]}},le.blockquote=function(G){var te=this.rules.block.blockquote.exec(G);if(te){var x=te[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:te[0],tokens:this.lexer.blockTokens(x,[]),text:x}}},le.list=function(G){var te=this.rules.block.list.exec(G);if(te){var x,se,fe,Se,Fe,O,K,J,B,Q,_,Ee,ze=te[1].trim(),Qe=ze.length>1,Je={type:"list",raw:"",ordered:Qe,start:Qe?+ze.slice(0,-1):"",loose:!1,items:[]};ze=Qe?"\\d{1,9}\\"+ze.slice(-1):"\\"+ze,this.options.pedantic&&(ze=Qe?ze:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+ze+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Ee=!1,!(!(te=Ye.exec(G))||this.rules.block.hr.test(G)));){if(x=te[0],G=G.substring(x.length),J=te[2].split(`
`,1)[0],B=G.split(`
`,1)[0],this.options.pedantic?(Se=2,_=J.trimLeft()):(Se=te[2].search(/[^ ]/),Se=Se>4?1:Se,_=J.slice(Se),Se+=te[1].length),O=!1,!J&&/^ *$/.test(B)&&(x+=B+`
`,G=G.substring(B.length+1),Ee=!0),!Ee)for(var it=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),nt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),_e=new RegExp("^ {0,"+Math.min(3,Se-1)+"}(?:```|~~~)"),rt=new RegExp("^ {0,"+Math.min(3,Se-1)+"}#");G&&(Q=G.split(`
`,1)[0],J=Q,this.options.pedantic&&(J=J.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(_e.test(J)||rt.test(J)||it.test(J)||nt.test(G)));){if(J.search(/[^ ]/)>=Se||!J.trim())_+=`
`+J.slice(Se);else if(!O)_+=`
`+J;else break;!O&&!J.trim()&&(O=!0),x+=Q+`
`,G=G.substring(Q.length+1)}Je.loose||(K?Je.loose=!0:/\n *\n *$/.test(x)&&(K=!0)),this.options.gfm&&(se=/^\[[ xX]\] /.exec(_),se&&(fe=se[0]!=="[ ] ",_=_.replace(/^\[[ xX]\] +/,""))),Je.items.push({type:"list_item",raw:x,task:!!se,checked:fe,loose:!1,text:_}),Je.raw+=x}Je.items[Je.items.length-1].raw=x.trimRight(),Je.items[Je.items.length-1].text=_.trimRight(),Je.raw=Je.raw.trimRight();var Ue=Je.items.length;for(Fe=0;Fe<Ue;Fe++){this.lexer.state.top=!1,Je.items[Fe].tokens=this.lexer.blockTokens(Je.items[Fe].text,[]);var ct=Je.items[Fe].tokens.filter(function(Z){return Z.type==="space"}),ee=ct.every(function(Z){for(var ve=Z.raw.split(""),Be=0,Ke=M(ve),xe;!(xe=Ke()).done;){var ot=xe.value;if(ot===`
`&&(Be+=1),Be>1)return!0}return!1});!Je.loose&&ct.length&&ee&&(Je.loose=!0,Je.items[Fe].loose=!0)}return Je}},le.html=function(G){var te=this.rules.block.html.exec(G);if(te){var x={type:"html",raw:te[0],pre:!this.options.sanitizer&&(te[1]==="pre"||te[1]==="script"||te[1]==="style"),text:te[0]};if(this.options.sanitize){var se=this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]);x.type="paragraph",x.text=se,x.tokens=this.lexer.inline(se)}return x}},le.def=function(G){var te=this.rules.block.def.exec(G);if(te){te[3]&&(te[3]=te[3].substring(1,te[3].length-1));var x=te[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:x,raw:te[0],href:te[2],title:te[3]}}},le.table=function(G){var te=this.rules.block.table.exec(G);if(te){var x={type:"table",header:L(te[1]).map(function(K){return{text:K}}),align:te[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:te[3]&&te[3].trim()?te[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(x.header.length===x.align.length){x.raw=te[0];var se=x.align.length,fe,Se,Fe,O;for(fe=0;fe<se;fe++)/^ *-+: *$/.test(x.align[fe])?x.align[fe]="right":/^ *:-+: *$/.test(x.align[fe])?x.align[fe]="center":/^ *:-+ *$/.test(x.align[fe])?x.align[fe]="left":x.align[fe]=null;for(se=x.rows.length,fe=0;fe<se;fe++)x.rows[fe]=L(x.rows[fe],x.header.length).map(function(K){return{text:K}});for(se=x.header.length,Se=0;Se<se;Se++)x.header[Se].tokens=this.lexer.inline(x.header[Se].text);for(se=x.rows.length,Se=0;Se<se;Se++)for(O=x.rows[Se],Fe=0;Fe<O.length;Fe++)O[Fe].tokens=this.lexer.inline(O[Fe].text);return x}}},le.lheading=function(G){var te=this.rules.block.lheading.exec(G);if(te)return{type:"heading",raw:te[0],depth:te[2].charAt(0)==="="?1:2,text:te[1],tokens:this.lexer.inline(te[1])}},le.paragraph=function(G){var te=this.rules.block.paragraph.exec(G);if(te){var x=te[1].charAt(te[1].length-1)===`
`?te[1].slice(0,-1):te[1];return{type:"paragraph",raw:te[0],text:x,tokens:this.lexer.inline(x)}}},le.text=function(G){var te=this.rules.block.text.exec(G);if(te)return{type:"text",raw:te[0],text:te[0],tokens:this.lexer.inline(te[0])}},le.escape=function(G){var te=this.rules.inline.escape.exec(G);if(te)return{type:"escape",raw:te[0],text:b(te[1])}},le.tag=function(G){var te=this.rules.inline.tag.exec(G);if(te)return!this.lexer.state.inLink&&/^<a /i.test(te[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(te[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(te[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(te[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:te[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(te[0]):b(te[0]):te[0]}},le.link=function(G){var te=this.rules.inline.link.exec(G);if(te){var x=te[2].trim();if(!this.options.pedantic&&/^</.test(x)){if(!/>$/.test(x))return;var se=p(x.slice(0,-1),"\\");if((x.length-se.length)%2===0)return}else{var fe=y(te[2],"()");if(fe>-1){var Se=te[0].indexOf("!")===0?5:4,Fe=Se+te[1].length+fe;te[2]=te[2].substring(0,fe),te[0]=te[0].substring(0,Fe).trim(),te[3]=""}}var O=te[2],K="";if(this.options.pedantic){var J=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(O);J&&(O=J[1],K=J[3])}else K=te[3]?te[3].slice(1,-1):"";return O=O.trim(),/^</.test(O)&&(this.options.pedantic&&!/>$/.test(x)?O=O.slice(1):O=O.slice(1,-1)),q(te,{href:O&&O.replace(this.rules.inline._escapes,"$1"),title:K&&K.replace(this.rules.inline._escapes,"$1")},te[0],this.lexer)}},le.reflink=function(G,te){var x;if((x=this.rules.inline.reflink.exec(G))||(x=this.rules.inline.nolink.exec(G))){var se=(x[2]||x[1]).replace(/\s+/g," ");if(se=te[se.toLowerCase()],!se||!se.href){var fe=x[0].charAt(0);return{type:"text",raw:fe,text:fe}}return q(x,se,x[0],this.lexer)}},le.emStrong=function(G,te,x){x===void 0&&(x="");var se=this.rules.inline.emStrong.lDelim.exec(G);if(se&&!(se[3]&&x.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var fe=se[1]||se[2]||"";if(!fe||fe&&(x===""||this.rules.inline.punctuation.exec(x))){var Se=se[0].length-1,Fe,O,K=Se,J=0,B=se[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(B.lastIndex=0,te=te.slice(-1*G.length+Se);(se=B.exec(te))!=null;)if(Fe=se[1]||se[2]||se[3]||se[4]||se[5]||se[6],!!Fe){if(O=Fe.length,se[3]||se[4]){K+=O;continue}else if((se[5]||se[6])&&Se%3&&!((Se+O)%3)){J+=O;continue}if(K-=O,!(K>0)){if(O=Math.min(O,O+K+J),Math.min(Se,O)%2){var Q=G.slice(1,Se+se.index+O);return{type:"em",raw:G.slice(0,Se+se.index+O+1),text:Q,tokens:this.lexer.inlineTokens(Q)}}var _=G.slice(2,Se+se.index+O-1);return{type:"strong",raw:G.slice(0,Se+se.index+O+1),text:_,tokens:this.lexer.inlineTokens(_)}}}}}},le.codespan=function(G){var te=this.rules.inline.code.exec(G);if(te){var x=te[2].replace(/\n/g," "),se=/[^ ]/.test(x),fe=/^ /.test(x)&&/ $/.test(x);return se&&fe&&(x=x.substring(1,x.length-1)),x=b(x,!0),{type:"codespan",raw:te[0],text:x}}},le.br=function(G){var te=this.rules.inline.br.exec(G);if(te)return{type:"br",raw:te[0]}},le.del=function(G){var te=this.rules.inline.del.exec(G);if(te)return{type:"del",raw:te[0],text:te[2],tokens:this.lexer.inlineTokens(te[2])}},le.autolink=function(G,te){var x=this.rules.inline.autolink.exec(G);if(x){var se,fe;return x[2]==="@"?(se=b(this.options.mangle?te(x[1]):x[1]),fe="mailto:"+se):(se=b(x[1]),fe=se),{type:"link",raw:x[0],text:se,href:fe,tokens:[{type:"text",raw:se,text:se}]}}},le.url=function(G,te){var x;if(x=this.rules.inline.url.exec(G)){var se,fe;if(x[2]==="@")se=b(this.options.mangle?te(x[0]):x[0]),fe="mailto:"+se;else{var Se;do Se=x[0],x[0]=this.rules.inline._backpedal.exec(x[0])[0];while(Se!==x[0]);se=b(x[0]),x[1]==="www."?fe="http://"+se:fe=se}return{type:"link",raw:x[0],text:se,href:fe,tokens:[{type:"text",raw:se,text:se}]}}},le.inlineText=function(G,te){var x=this.rules.inline.text.exec(G);if(x){var se;return this.lexer.state.inRawBlock?se=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):b(x[0]):x[0]:se=b(this.options.smartypants?te(x[0]):x[0]),{type:"text",raw:x[0],text:se}}},Ce}(),F={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:f,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};F._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,F._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,F.def=n(F.def).replace("label",F._label).replace("title",F._title).getRegex(),F.bullet=/(?:[*+-]|\d{1,9}[.)])/,F.listItemStart=n(/^( *)(bull) */).replace("bull",F.bullet).getRegex(),F.list=n(F.list).replace(/bull/g,F.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+F.def.source+")").getRegex(),F._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",F._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,F.html=n(F.html,"i").replace("comment",F._comment).replace("tag",F._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),F.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.blockquote=n(F.blockquote).replace("paragraph",F.paragraph).getRegex(),F.normal=k({},F),F.gfm=k({},F.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),F.gfm.table=n(F.gfm.table).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.gfm.paragraph=n(F._paragraph).replace("hr",F.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",F.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",F._tag).getRegex(),F.pedantic=k({},F.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",F._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:f,paragraph:n(F.normal._paragraph).replace("hr",F.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",F.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:f,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:f,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=n(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=n(F._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=n(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=n(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=n(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=n(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=n(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=n(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=n(C.reflink).replace("label",C._label).replace("ref",F._label).getRegex(),C.nolink=n(C.nolink).replace("ref",F._label).getRegex(),C.reflinkSearch=n(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=k({},C),C.pedantic=k({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=k({},C.normal,{escape:n(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=n(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=k({},C.gfm,{br:n(C.br).replace("{2,}","*").getRegex(),text:n(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function I(Ce){return Ce.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function X(Ce){var le="",ie,G,te=Ce.length;for(ie=0;ie<te;ie++)G=Ce.charCodeAt(ie),Math.random()>.5&&(G="x"+G.toString(16)),le+="&#"+G+";";return le}var ue=function(){function Ce(ie){this.tokens=[],this.tokens.links=Object.create(null),this.options=ie||pe.defaults,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:F.normal,inline:C.normal};this.options.pedantic?(G.block=F.pedantic,G.inline=C.pedantic):this.options.gfm&&(G.block=F.gfm,this.options.breaks?G.inline=C.breaks:G.inline=C.gfm),this.tokenizer.rules=G}Ce.lex=function(G,te){var x=new Ce(te);return x.lex(G)},Ce.lexInline=function(G,te){var x=new Ce(te);return x.inlineTokens(G)};var le=Ce.prototype;return le.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var te;te=this.inlineQueue.shift();)this.inlineTokens(te.src,te.tokens);return this.tokens},le.blockTokens=function(G,te){var x=this;te===void 0&&(te=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(K,J,B){return J+"    ".repeat(B.length)});for(var se,fe,Se,Fe;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(K){return(se=K.call({lexer:x},G,te))?(G=G.substring(se.raw.length),te.push(se),!0):!1}))){if(se=this.tokenizer.space(G)){G=G.substring(se.raw.length),se.raw.length===1&&te.length>0?te[te.length-1].raw+=`
`:te.push(se);continue}if(se=this.tokenizer.code(G)){G=G.substring(se.raw.length),fe=te[te.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+se.raw,fe.text+=`
`+se.text,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):te.push(se);continue}if(se=this.tokenizer.fences(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.heading(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.hr(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.blockquote(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.list(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.html(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.def(G)){G=G.substring(se.raw.length),fe=te[te.length-1],fe&&(fe.type==="paragraph"||fe.type==="text")?(fe.raw+=`
`+se.raw,fe.text+=`
`+se.raw,this.inlineQueue[this.inlineQueue.length-1].src=fe.text):this.tokens.links[se.tag]||(this.tokens.links[se.tag]={href:se.href,title:se.title});continue}if(se=this.tokenizer.table(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.lheading(G)){G=G.substring(se.raw.length),te.push(se);continue}if(Se=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var K=1/0,J=G.slice(1),B=void 0;x.options.extensions.startBlock.forEach(function(Q){B=Q.call({lexer:this},J),typeof B=="number"&&B>=0&&(K=Math.min(K,B))}),K<1/0&&K>=0&&(Se=G.substring(0,K+1))}(),this.state.top&&(se=this.tokenizer.paragraph(Se))){fe=te[te.length-1],Fe&&fe.type==="paragraph"?(fe.raw+=`
`+se.raw,fe.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):te.push(se),Fe=Se.length!==G.length,G=G.substring(se.raw.length);continue}if(se=this.tokenizer.text(G)){G=G.substring(se.raw.length),fe=te[te.length-1],fe&&fe.type==="text"?(fe.raw+=`
`+se.raw,fe.text+=`
`+se.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=fe.text):te.push(se);continue}if(G){var O="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(O);break}else throw new Error(O)}}return this.state.top=!0,te},le.inline=function(G,te){return te===void 0&&(te=[]),this.inlineQueue.push({src:G,tokens:te}),te},le.inlineTokens=function(G,te){var x=this;te===void 0&&(te=[]);var se,fe,Se,Fe=G,O,K,J;if(this.tokens.links){var B=Object.keys(this.tokens.links);if(B.length>0)for(;(O=this.tokenizer.rules.inline.reflinkSearch.exec(Fe))!=null;)B.includes(O[0].slice(O[0].lastIndexOf("[")+1,-1))&&(Fe=Fe.slice(0,O.index)+"["+N("a",O[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(O=this.tokenizer.rules.inline.blockSkip.exec(Fe))!=null;)Fe=Fe.slice(0,O.index)+"["+N("a",O[0].length-2)+"]"+Fe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(O=this.tokenizer.rules.inline.escapedEmSt.exec(Fe))!=null;)Fe=Fe.slice(0,O.index)+"++"+Fe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(K||(J=""),K=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(_){return(se=_.call({lexer:x},G,te))?(G=G.substring(se.raw.length),te.push(se),!0):!1}))){if(se=this.tokenizer.escape(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.tag(G)){G=G.substring(se.raw.length),fe=te[te.length-1],fe&&se.type==="text"&&fe.type==="text"?(fe.raw+=se.raw,fe.text+=se.text):te.push(se);continue}if(se=this.tokenizer.link(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(se.raw.length),fe=te[te.length-1],fe&&se.type==="text"&&fe.type==="text"?(fe.raw+=se.raw,fe.text+=se.text):te.push(se);continue}if(se=this.tokenizer.emStrong(G,Fe,J)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.codespan(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.br(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.del(G)){G=G.substring(se.raw.length),te.push(se);continue}if(se=this.tokenizer.autolink(G,X)){G=G.substring(se.raw.length),te.push(se);continue}if(!this.state.inLink&&(se=this.tokenizer.url(G,X))){G=G.substring(se.raw.length),te.push(se);continue}if(Se=G,this.options.extensions&&this.options.extensions.startInline&&function(){var _=1/0,Ee=G.slice(1),ze=void 0;x.options.extensions.startInline.forEach(function(Qe){ze=Qe.call({lexer:this},Ee),typeof ze=="number"&&ze>=0&&(_=Math.min(_,ze))}),_<1/0&&_>=0&&(Se=G.substring(0,_+1))}(),se=this.tokenizer.inlineText(Se,I)){G=G.substring(se.raw.length),se.raw.slice(-1)!=="_"&&(J=se.raw.slice(-1)),K=!0,fe=te[te.length-1],fe&&fe.type==="text"?(fe.raw+=se.raw,fe.text+=se.text):te.push(se);continue}if(G){var Q="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Q);break}else throw new Error(Q)}}return te},E(Ce,null,[{key:"rules",get:function(){return{block:F,inline:C}}}]),Ce}(),he=function(){function Ce(ie){this.options=ie||pe.defaults}var le=Ce.prototype;return le.code=function(G,te,x){var se=(te||"").match(/\S*/)[0];if(this.options.highlight){var fe=this.options.highlight(G,se);fe!=null&&fe!==G&&(x=!0,G=fe)}return G=G.replace(/\n$/,"")+`
`,se?'<pre><code class="'+this.options.langPrefix+b(se,!0)+'">'+(x?G:b(G,!0))+`</code></pre>
`:"<pre><code>"+(x?G:b(G,!0))+`</code></pre>
`},le.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},le.html=function(G){return G},le.heading=function(G,te,x,se){if(this.options.headerIds){var fe=this.options.headerPrefix+se.slug(x);return"<h"+te+' id="'+fe+'">'+G+"</h"+te+`>
`}return"<h"+te+">"+G+"</h"+te+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(G,te,x){var se=te?"ol":"ul",fe=te&&x!==1?' start="'+x+'"':"";return"<"+se+fe+`>
`+G+"</"+se+`>
`},le.listitem=function(G){return"<li>"+G+`</li>
`},le.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(G){return"<p>"+G+`</p>
`},le.table=function(G,te){return te&&(te="<tbody>"+te+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+te+`</table>
`},le.tablerow=function(G){return`<tr>
`+G+`</tr>
`},le.tablecell=function(G,te){var x=te.header?"th":"td",se=te.align?"<"+x+' align="'+te.align+'">':"<"+x+">";return se+G+("</"+x+`>
`)},le.strong=function(G){return"<strong>"+G+"</strong>"},le.em=function(G){return"<em>"+G+"</em>"},le.codespan=function(G){return"<code>"+G+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(G){return"<del>"+G+"</del>"},le.link=function(G,te,x){if(G=h(this.options.sanitize,this.options.baseUrl,G),G===null)return x;var se='<a href="'+b(G)+'"';return te&&(se+=' title="'+te+'"'),se+=">"+x+"</a>",se},le.image=function(G,te,x){if(G=h(this.options.sanitize,this.options.baseUrl,G),G===null)return x;var se='<img src="'+G+'" alt="'+x+'"';return te&&(se+=' title="'+te+'"'),se+=this.options.xhtml?"/>":">",se},le.text=function(G){return G},Ce}(),be=function(){function Ce(){}var le=Ce.prototype;return le.strong=function(G){return G},le.em=function(G){return G},le.codespan=function(G){return G},le.del=function(G){return G},le.html=function(G){return G},le.text=function(G){return G},le.link=function(G,te,x){return""+x},le.image=function(G,te,x){return""+x},le.br=function(){return""},Ce}(),we=function(){function Ce(){this.seen={}}var le=Ce.prototype;return le.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(G,te){var x=G,se=0;if(this.seen.hasOwnProperty(x)){se=this.seen[G];do se++,x=G+"-"+se;while(this.seen.hasOwnProperty(x))}return te||(this.seen[G]=se,this.seen[x]=0),x},le.slug=function(G,te){te===void 0&&(te={});var x=this.serialize(G);return this.getNextSafeSlug(x,te.dryrun)},Ce}(),ge=function(){function Ce(ie){this.options=ie||pe.defaults,this.options.renderer=this.options.renderer||new he,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new be,this.slugger=new we}Ce.parse=function(G,te){var x=new Ce(te);return x.parse(G)},Ce.parseInline=function(G,te){var x=new Ce(te);return x.parseInline(G)};var le=Ce.prototype;return le.parse=function(G,te){te===void 0&&(te=!0);var x="",se,fe,Se,Fe,O,K,J,B,Q,_,Ee,ze,Qe,Je,Ye,it,nt,_e,rt,Ue=G.length;for(se=0;se<Ue;se++){if(_=G[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[_.type]&&(rt=this.options.extensions.renderers[_.type].call({parser:this},_),rt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(_.type))){x+=rt||"";continue}switch(_.type){case"space":continue;case"hr":{x+=this.renderer.hr();continue}case"heading":{x+=this.renderer.heading(this.parseInline(_.tokens),_.depth,s(this.parseInline(_.tokens,this.textRenderer)),this.slugger);continue}case"code":{x+=this.renderer.code(_.text,_.lang,_.escaped);continue}case"table":{for(B="",J="",Fe=_.header.length,fe=0;fe<Fe;fe++)J+=this.renderer.tablecell(this.parseInline(_.header[fe].tokens),{header:!0,align:_.align[fe]});for(B+=this.renderer.tablerow(J),Q="",Fe=_.rows.length,fe=0;fe<Fe;fe++){for(K=_.rows[fe],J="",O=K.length,Se=0;Se<O;Se++)J+=this.renderer.tablecell(this.parseInline(K[Se].tokens),{header:!1,align:_.align[Se]});Q+=this.renderer.tablerow(J)}x+=this.renderer.table(B,Q);continue}case"blockquote":{Q=this.parse(_.tokens),x+=this.renderer.blockquote(Q);continue}case"list":{for(Ee=_.ordered,ze=_.start,Qe=_.loose,Fe=_.items.length,Q="",fe=0;fe<Fe;fe++)Ye=_.items[fe],it=Ye.checked,nt=Ye.task,Je="",Ye.task&&(_e=this.renderer.checkbox(it),Qe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=_e+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=_e+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:_e}):Je+=_e),Je+=this.parse(Ye.tokens,Qe),Q+=this.renderer.listitem(Je,nt,it);x+=this.renderer.list(Q,Ee,ze);continue}case"html":{x+=this.renderer.html(_.text);continue}case"paragraph":{x+=this.renderer.paragraph(this.parseInline(_.tokens));continue}case"text":{for(Q=_.tokens?this.parseInline(_.tokens):_.text;se+1<Ue&&G[se+1].type==="text";)_=G[++se],Q+=`
`+(_.tokens?this.parseInline(_.tokens):_.text);x+=te?this.renderer.paragraph(Q):Q;continue}default:{var ct='Token with "'+_.type+'" type was not found.';if(this.options.silent){console.error(ct);return}else throw new Error(ct)}}}return x},le.parseInline=function(G,te){te=te||this.renderer;var x="",se,fe,Se,Fe=G.length;for(se=0;se<Fe;se++){if(fe=G[se],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(Se=this.options.extensions.renderers[fe.type].call({parser:this},fe),Se!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(fe.type))){x+=Se||"";continue}switch(fe.type){case"escape":{x+=te.text(fe.text);break}case"html":{x+=te.html(fe.text);break}case"link":{x+=te.link(fe.href,fe.title,this.parseInline(fe.tokens,te));break}case"image":{x+=te.image(fe.href,fe.title,fe.text);break}case"strong":{x+=te.strong(this.parseInline(fe.tokens,te));break}case"em":{x+=te.em(this.parseInline(fe.tokens,te));break}case"codespan":{x+=te.codespan(fe.text);break}case"br":{x+=te.br();break}case"del":{x+=te.del(this.parseInline(fe.tokens,te));break}case"text":{x+=te.text(fe.text);break}default:{var O='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(O);return}else throw new Error(O)}}}return x},Ce}();function me(Ce,le,ie){if(typeof Ce>"u"||Ce===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");if(typeof le=="function"&&(ie=le,le=null),le=k({},me.defaults,le||{}),D(le),ie){var G=le.highlight,te;try{te=ue.lex(Ce,le)}catch(Fe){return ie(Fe)}var x=function(O){var K;if(!O)try{le.walkTokens&&me.walkTokens(te,le.walkTokens),K=ge.parse(te,le)}catch(J){O=J}return le.highlight=G,O?ie(O):ie(null,K)};if(!G||G.length<3||(delete le.highlight,!te.length))return x();var se=0;me.walkTokens(te,function(Fe){Fe.type==="code"&&(se++,setTimeout(function(){G(Fe.text,Fe.lang,function(O,K){if(O)return x(O);K!=null&&K!==Fe.text&&(Fe.text=K,Fe.escaped=!0),se--,se===0&&x()})},0))}),se===0&&x();return}function fe(Fe){if(Fe.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(Fe.message+"",!0)+"</pre>";throw Fe}try{var Se=ue.lex(Ce,le);if(le.walkTokens){if(le.async)return Promise.all(me.walkTokens(Se,le.walkTokens)).then(function(){return ge.parse(Se,le)}).catch(fe);me.walkTokens(Se,le.walkTokens)}return ge.parse(Se,le)}catch(Fe){fe(Fe)}}me.options=me.setOptions=function(Ce){return k(me.defaults,Ce),m(me.defaults),me},me.getDefaults=A,me.defaults=pe.defaults,me.use=function(){for(var Ce=arguments.length,le=new Array(Ce),ie=0;ie<Ce;ie++)le[ie]=arguments[ie];var G=k.apply(void 0,[{}].concat(le)),te=me.defaults.extensions||{renderers:{},childTokens:{}},x;le.forEach(function(se){if(se.extensions&&(x=!0,se.extensions.forEach(function(Se){if(!Se.name)throw new Error("extension name required");if(Se.renderer){var Fe=te.renderers?te.renderers[Se.name]:null;Fe?te.renderers[Se.name]=function(){for(var O=arguments.length,K=new Array(O),J=0;J<O;J++)K[J]=arguments[J];var B=Se.renderer.apply(this,K);return B===!1&&(B=Fe.apply(this,K)),B}:te.renderers[Se.name]=Se.renderer}if(Se.tokenizer){if(!Se.level||Se.level!=="block"&&Se.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");te[Se.level]?te[Se.level].unshift(Se.tokenizer):te[Se.level]=[Se.tokenizer],Se.start&&(Se.level==="block"?te.startBlock?te.startBlock.push(Se.start):te.startBlock=[Se.start]:Se.level==="inline"&&(te.startInline?te.startInline.push(Se.start):te.startInline=[Se.start]))}Se.childTokens&&(te.childTokens[Se.name]=Se.childTokens)})),se.renderer&&function(){var Se=me.defaults.renderer||new he,Fe=function(J){var B=Se[J];Se[J]=function(){for(var Q=arguments.length,_=new Array(Q),Ee=0;Ee<Q;Ee++)_[Ee]=arguments[Ee];var ze=se.renderer[J].apply(Se,_);return ze===!1&&(ze=B.apply(Se,_)),ze}};for(var O in se.renderer)Fe(O);G.renderer=Se}(),se.tokenizer&&function(){var Se=me.defaults.tokenizer||new U,Fe=function(J){var B=Se[J];Se[J]=function(){for(var Q=arguments.length,_=new Array(Q),Ee=0;Ee<Q;Ee++)_[Ee]=arguments[Ee];var ze=se.tokenizer[J].apply(Se,_);return ze===!1&&(ze=B.apply(Se,_)),ze}};for(var O in se.tokenizer)Fe(O);G.tokenizer=Se}(),se.walkTokens){var fe=me.defaults.walkTokens;G.walkTokens=function(Se){var Fe=[];return Fe.push(se.walkTokens.call(this,Se)),fe&&(Fe=Fe.concat(fe.call(this,Se))),Fe}}x&&(G.extensions=te),me.setOptions(G)})},me.walkTokens=function(Ce,le){for(var ie=[],G=function(){var fe=x.value;switch(ie=ie.concat(le.call(me,fe)),fe.type){case"table":{for(var Se=M(fe.header),Fe;!(Fe=Se()).done;){var O=Fe.value;ie=ie.concat(me.walkTokens(O.tokens,le))}for(var K=M(fe.rows),J;!(J=K()).done;)for(var B=J.value,Q=M(B),_;!(_=Q()).done;){var Ee=_.value;ie=ie.concat(me.walkTokens(Ee.tokens,le))}break}case"list":{ie=ie.concat(me.walkTokens(fe.items,le));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[fe.type]?me.defaults.extensions.childTokens[fe.type].forEach(function(ze){ie=ie.concat(me.walkTokens(fe[ze],le))}):fe.tokens&&(ie=ie.concat(me.walkTokens(fe.tokens,le)))}},te=M(Ce),x;!(x=te()).done;)G();return ie},me.parseInline=function(Ce,le){if(typeof Ce>"u"||Ce===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ce!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ce)+", string expected");le=k({},me.defaults,le||{}),D(le);try{var ie=ue.lexInline(Ce,le);return le.walkTokens&&me.walkTokens(ie,le.walkTokens),ge.parseInline(ie,le)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+b(G.message+"",!0)+"</pre>";throw G}},me.Parser=ge,me.parser=ge.parse,me.Renderer=he,me.TextRenderer=be,me.Lexer=ue,me.lexer=ue.lex,me.Tokenizer=U,me.Slugger=we,me.parse=me;var ne=me.options,ke=me.setOptions,ce=me.use,Y=me.walkTokens,W=me.parseInline,re=me,Ie=ge.parse,Ae=ue.lex;pe.Lexer=ue,pe.Parser=ge,pe.Renderer=he,pe.Slugger=we,pe.TextRenderer=be,pe.Tokenizer=U,pe.getDefaults=A,pe.lexer=Ae,pe.marked=me,pe.options=ne,pe.parse=re,pe.parseInline=W,pe.parser=Ie,pe.setOptions=ke,pe.use=ce,pe.walkTokens=Y,Object.defineProperty(pe,"__esModule",{value:!0})}),define(Pe[121],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3l=e.$2l=e.$1l=e.rot=e.$Yl=void 0;function E(m,g,w){return Math.min(Math.max(m,g),w)}e.$Yl=E;function T(m,g){return(g+m%g)%g}e.rot=T;class P{constructor(){this.a=0}getNext(){return this.a++}}e.$1l=P;class M{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$2l=M;class A{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const w=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=w,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$3l=A}),function(){function pe(P){const M=[];typeof P=="number"&&M.push("code/timeOrigin",P);function A(g){M.push(g,Date.now())}function m(){const g=[];for(let w=0;w<M.length;w+=2)g.push({name:M[w],startTime:M[w+1]});return g}return{mark:A,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?pe():{mark(P){performance.mark(P)},getMarks(){let P=performance.timeOrigin;typeof P!="number"&&(P=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(P)}];for(const A of performance.getEntriesByType("mark"))M.push({name:A.name,startTime:Math.round(P+A.startTime)});return M}};if(typeof process=="object"){const P=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return pe(P)}else return console.trace("perf-util loaded in UNKNOWN environment"),pe()}function E(P){return P.MonacoPerformanceMarks||(P.MonacoPerformanceMarks=e()),P.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=E(T))}(),function(pe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var T in E)(typeof exports=="object"?exports:pe)[T]=E[T]}}(typeof self<"u"?self:this,function(){return function(pe){var e={};function E(T){if(e[T])return e[T].exports;var P=e[T]={i:T,l:!1,exports:{}};return pe[T].call(P.exports,P,P.exports,E),P.l=!0,P.exports}return E.m=pe,E.c=e,E.d=function(T,P,M){E.o(T,P)||Object.defineProperty(T,P,{enumerable:!0,get:M})},E.r=function(T){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(T,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(T,"__esModule",{value:!0})},E.t=function(T,P){if(1&P&&(T=E(T)),8&P||4&P&&typeof T=="object"&&T&&T.__esModule)return T;var M=Object.create(null);if(E.r(M),Object.defineProperty(M,"default",{enumerable:!0,value:T}),2&P&&typeof T!="string")for(var A in T)E.d(M,A,function(m){return T[m]}.bind(null,A));return M},E.n=function(T){var P=T&&T.__esModule?function(){return T.default}:function(){return T};return E.d(P,"a",P),P},E.o=function(T,P){return Object.prototype.hasOwnProperty.call(T,P)},E.p="",E(E.s=0)}([function(pe,e,E){(function(T){var P;e=pe.exports=ce,P=typeof T=="object"&&T.env&&T.env.NODE_DEBUG&&/\bsemver\b/i.test(T.env.NODE_DEBUG)?function(){var B=Array.prototype.slice.call(arguments,0);B.unshift("SEMVER"),console.log.apply(console,B)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var M=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],g=e.src=[],w=0,R=w++;g[R]="0|[1-9]\\d*";var S=w++;g[S]="[0-9]+";var l=w++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=w++;g[$]="("+g[R]+")\\.("+g[R]+")\\.("+g[R]+")";var b=w++;g[b]="("+g[S]+")\\.("+g[S]+")\\.("+g[S]+")";var a=w++;g[a]="(?:"+g[R]+"|"+g[l]+")";var s=w++;g[s]="(?:"+g[S]+"|"+g[l]+")";var t=w++;g[t]="(?:-("+g[a]+"(?:\\."+g[a]+")*))";var n=w++;g[n]="(?:-?("+g[s]+"(?:\\."+g[s]+")*))";var o=w++;g[o]="[0-9A-Za-z-]+";var c=w++;g[c]="(?:\\+("+g[o]+"(?:\\."+g[o]+")*))";var h=w++,i="v?"+g[$]+g[t]+"?"+g[c]+"?";g[h]="^"+i+"$";var r="[v=\\s]*"+g[b]+g[n]+"?"+g[c]+"?",u=w++;g[u]="^"+r+"$";var d=w++;g[d]="((?:<|>)?=?)";var v=w++;g[v]=g[S]+"|x|X|\\*";var f=w++;g[f]=g[R]+"|x|X|\\*";var k=w++;g[k]="[v=\\s]*("+g[f]+")(?:\\.("+g[f]+")(?:\\.("+g[f]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var L=w++;g[L]="[v=\\s]*("+g[v]+")(?:\\.("+g[v]+")(?:\\.("+g[v]+")(?:"+g[n]+")?"+g[c]+"?)?)?";var p=w++;g[p]="^"+g[d]+"\\s*"+g[k]+"$";var y=w++;g[y]="^"+g[d]+"\\s*"+g[L]+"$";var D=w++;g[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=w++;g[N]="(?:~>?)";var q=w++;g[q]="(\\s*)"+g[N]+"\\s+",m[q]=new RegExp(g[q],"g");var V=w++;g[V]="^"+g[N]+g[k]+"$";var U=w++;g[U]="^"+g[N]+g[L]+"$";var F=w++;g[F]="(?:\\^)";var C=w++;g[C]="(\\s*)"+g[F]+"\\s+",m[C]=new RegExp(g[C],"g");var I=w++;g[I]="^"+g[F]+g[k]+"$";var X=w++;g[X]="^"+g[F]+g[L]+"$";var ue=w++;g[ue]="^"+g[d]+"\\s*("+r+")$|^$";var he=w++;g[he]="^"+g[d]+"\\s*("+i+")$|^$";var be=w++;g[be]="(\\s*)"+g[d]+"\\s*("+r+"|"+g[k]+")",m[be]=new RegExp(g[be],"g");var we=w++;g[we]="^\\s*("+g[k]+")\\s+-\\s+("+g[k]+")\\s*$";var ge=w++;g[ge]="^\\s*("+g[L]+")\\s+-\\s+("+g[L]+")\\s*$";var me=w++;g[me]="(<|>)?=?\\s*\\*";for(var ne=0;ne<35;ne++)P(ne,g[ne]),m[ne]||(m[ne]=new RegExp(g[ne]));function ke(B,Q){if(B instanceof ce)return B;if(typeof B!="string"||B.length>M||!(Q?m[u]:m[h]).test(B))return null;try{return new ce(B,Q)}catch{return null}}function ce(B,Q){if(B instanceof ce){if(B.loose===Q)return B;B=B.version}else if(typeof B!="string")throw new TypeError("Invalid Version: "+B);if(B.length>M)throw new TypeError("version is longer than "+M+" characters");if(!(this instanceof ce))return new ce(B,Q);P("SemVer",B,Q),this.loose=Q;var _=B.trim().match(Q?m[u]:m[h]);if(!_)throw new TypeError("Invalid Version: "+B);if(this.raw=B,this.major=+_[1],this.minor=+_[2],this.patch=+_[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");_[4]?this.prerelease=_[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var ze=+Ee;if(ze>=0&&ze<A)return ze}return Ee}):this.prerelease=[],this.build=_[5]?_[5].split("."):[],this.format()}e.parse=ke,e.valid=function(B,Q){var _=ke(B,Q);return _?_.version:null},e.clean=function(B,Q){var _=ke(B.trim().replace(/^[=v]+/,""),Q);return _?_.version:null},e.SemVer=ce,ce.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ce.prototype.toString=function(){return this.version},ce.prototype.compare=function(B){return P("SemVer.compare",this.version,this.loose,B),B instanceof ce||(B=new ce(B,this.loose)),this.compareMain(B)||this.comparePre(B)},ce.prototype.compareMain=function(B){return B instanceof ce||(B=new ce(B,this.loose)),W(this.major,B.major)||W(this.minor,B.minor)||W(this.patch,B.patch)},ce.prototype.comparePre=function(B){if(B instanceof ce||(B=new ce(B,this.loose)),this.prerelease.length&&!B.prerelease.length)return-1;if(!this.prerelease.length&&B.prerelease.length)return 1;if(!this.prerelease.length&&!B.prerelease.length)return 0;var Q=0;do{var _=this.prerelease[Q],Ee=B.prerelease[Q];if(P("prerelease compare",Q,_,Ee),_===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(_===void 0)return-1;if(_!==Ee)return W(_,Ee)}while(++Q)},ce.prototype.inc=function(B,Q){switch(B){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Q);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Q);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Q),this.inc("pre",Q);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Q),this.inc("pre",Q);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var _=this.prerelease.length;--_>=0;)typeof this.prerelease[_]=="number"&&(this.prerelease[_]++,_=-2);_===-1&&this.prerelease.push(0)}Q&&(this.prerelease[0]===Q?isNaN(this.prerelease[1])&&(this.prerelease=[Q,0]):this.prerelease=[Q,0]);break;default:throw new Error("invalid increment argument: "+B)}return this.format(),this.raw=this.version,this},e.inc=function(B,Q,_,Ee){typeof _=="string"&&(Ee=_,_=void 0);try{return new ce(B,_).inc(Q,Ee).version}catch{return null}},e.diff=function(B,Q){if(Ce(B,Q))return null;var _=ke(B),Ee=ke(Q);if(_.prerelease.length||Ee.prerelease.length){for(var ze in _)if((ze==="major"||ze==="minor"||ze==="patch")&&_[ze]!==Ee[ze])return"pre"+ze;return"prerelease"}for(var ze in _)if((ze==="major"||ze==="minor"||ze==="patch")&&_[ze]!==Ee[ze])return ze},e.compareIdentifiers=W;var Y=/^[0-9]+$/;function W(B,Q){var _=Y.test(B),Ee=Y.test(Q);return _&&Ee&&(B=+B,Q=+Q),_&&!Ee?-1:Ee&&!_?1:B<Q?-1:B>Q?1:0}function re(B,Q,_){return new ce(B,_).compare(new ce(Q,_))}function Ie(B,Q,_){return re(B,Q,_)>0}function Ae(B,Q,_){return re(B,Q,_)<0}function Ce(B,Q,_){return re(B,Q,_)===0}function le(B,Q,_){return re(B,Q,_)!==0}function ie(B,Q,_){return re(B,Q,_)>=0}function G(B,Q,_){return re(B,Q,_)<=0}function te(B,Q,_,Ee){var ze;switch(Q){case"===":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),ze=B===_;break;case"!==":typeof B=="object"&&(B=B.version),typeof _=="object"&&(_=_.version),ze=B!==_;break;case"":case"=":case"==":ze=Ce(B,_,Ee);break;case"!=":ze=le(B,_,Ee);break;case">":ze=Ie(B,_,Ee);break;case">=":ze=ie(B,_,Ee);break;case"<":ze=Ae(B,_,Ee);break;case"<=":ze=G(B,_,Ee);break;default:throw new TypeError("Invalid operator: "+Q)}return ze}function x(B,Q){if(B instanceof x){if(B.loose===Q)return B;B=B.value}if(!(this instanceof x))return new x(B,Q);P("comparator",B,Q),this.loose=Q,this.parse(B),this.semver===se?this.value="":this.value=this.operator+this.semver.version,P("comp",this)}e.rcompareIdentifiers=function(B,Q){return W(Q,B)},e.major=function(B,Q){return new ce(B,Q).major},e.minor=function(B,Q){return new ce(B,Q).minor},e.patch=function(B,Q){return new ce(B,Q).patch},e.compare=re,e.compareLoose=function(B,Q){return re(B,Q,!0)},e.rcompare=function(B,Q,_){return re(Q,B,_)},e.sort=function(B,Q){return B.sort(function(_,Ee){return e.compare(_,Ee,Q)})},e.rsort=function(B,Q){return B.sort(function(_,Ee){return e.rcompare(_,Ee,Q)})},e.gt=Ie,e.lt=Ae,e.eq=Ce,e.neq=le,e.gte=ie,e.lte=G,e.cmp=te,e.Comparator=x;var se={};function fe(B,Q){if(B instanceof fe)return B.loose===Q?B:new fe(B.raw,Q);if(B instanceof x)return new fe(B.value,Q);if(!(this instanceof fe))return new fe(B,Q);if(this.loose=Q,this.raw=B,this.set=B.split(/\s*\|\|\s*/).map(function(_){return this.parseRange(_.trim())},this).filter(function(_){return _.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+B);this.format()}function Se(B){return!B||B.toLowerCase()==="x"||B==="*"}function Fe(B,Q,_,Ee,ze,Qe,Je,Ye,it,nt,_e,rt,Ue){return((Q=Se(_)?"":Se(Ee)?">="+_+".0.0":Se(ze)?">="+_+"."+Ee+".0":">="+Q)+" "+(Ye=Se(it)?"":Se(nt)?"<"+(+it+1)+".0.0":Se(_e)?"<"+it+"."+(+nt+1)+".0":rt?"<="+it+"."+nt+"."+_e+"-"+rt:"<="+Ye)).trim()}function O(B,Q){for(var _=0;_<B.length;_++)if(!B[_].test(Q))return!1;if(Q.prerelease.length){for(_=0;_<B.length;_++)if(P(B[_].semver),B[_].semver!==se&&B[_].semver.prerelease.length>0){var Ee=B[_].semver;if(Ee.major===Q.major&&Ee.minor===Q.minor&&Ee.patch===Q.patch)return!0}return!1}return!0}function K(B,Q,_){try{Q=new fe(Q,_)}catch{return!1}return Q.test(B)}function J(B,Q,_,Ee){var ze,Qe,Je,Ye,it;switch(B=new ce(B,Ee),Q=new fe(Q,Ee),_){case">":ze=Ie,Qe=G,Je=Ae,Ye=">",it=">=";break;case"<":ze=Ae,Qe=ie,Je=Ie,Ye="<",it="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(K(B,Q,Ee))return!1;for(var nt=0;nt<Q.set.length;++nt){var _e=Q.set[nt],rt=null,Ue=null;if(_e.forEach(function(ct){ct.semver===se&&(ct=new x(">=0.0.0")),rt=rt||ct,Ue=Ue||ct,ze(ct.semver,rt.semver,Ee)?rt=ct:Je(ct.semver,Ue.semver,Ee)&&(Ue=ct)}),rt.operator===Ye||rt.operator===it||(!Ue.operator||Ue.operator===Ye)&&Qe(B,Ue.semver)||Ue.operator===it&&Je(B,Ue.semver))return!1}return!0}x.prototype.parse=function(B){var Q=this.loose?m[ue]:m[he],_=B.match(Q);if(!_)throw new TypeError("Invalid comparator: "+B);this.operator=_[1],this.operator==="="&&(this.operator=""),_[2]?this.semver=new ce(_[2],this.loose):this.semver=se},x.prototype.toString=function(){return this.value},x.prototype.test=function(B){return P("Comparator.test",B,this.loose),this.semver===se||(typeof B=="string"&&(B=new ce(B,this.loose)),te(B,this.operator,this.semver,this.loose))},x.prototype.intersects=function(B,Q){if(!(B instanceof x))throw new TypeError("a Comparator is required");var _;if(this.operator==="")return _=new fe(B.value,Q),K(this.value,_,Q);if(B.operator==="")return _=new fe(this.value,Q),K(B.semver,_,Q);var Ee=!(this.operator!==">="&&this.operator!==">"||B.operator!==">="&&B.operator!==">"),ze=!(this.operator!=="<="&&this.operator!=="<"||B.operator!=="<="&&B.operator!=="<"),Qe=this.semver.version===B.semver.version,Je=!(this.operator!==">="&&this.operator!=="<="||B.operator!==">="&&B.operator!=="<="),Ye=te(this.semver,"<",B.semver,Q)&&(this.operator===">="||this.operator===">")&&(B.operator==="<="||B.operator==="<"),it=te(this.semver,">",B.semver,Q)&&(this.operator==="<="||this.operator==="<")&&(B.operator===">="||B.operator===">");return Ee||ze||Qe&&Je||Ye||it},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(B){return B.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(B){var Q=this.loose;B=B.trim(),P("range",B,Q);var _=Q?m[ge]:m[we];B=B.replace(_,Fe),P("hyphen replace",B),B=B.replace(m[be],"$1$2$3"),P("comparator trim",B,m[be]),B=(B=(B=B.replace(m[q],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var Ee=Q?m[ue]:m[he],ze=B.split(" ").map(function(Qe){return function(Je,Ye){return P("comp",Je),Je=function(it,nt){return it.trim().split(/\s+/).map(function(_e){return function(rt,Ue){P("caret",rt,Ue);var ct=Ue?m[X]:m[I];return rt.replace(ct,function(ee,Z,ve,Be,Ke){var xe;return P("caret",rt,ee,Z,ve,Be,Ke),Se(Z)?xe="":Se(ve)?xe=">="+Z+".0.0 <"+(+Z+1)+".0.0":Se(Be)?xe=Z==="0"?">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+".0 <"+(+Z+1)+".0.0":Ke?(P("replaceCaret pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Be+Ke+" <"+Z+"."+ve+"."+(+Be+1):">="+Z+"."+ve+"."+Be+Ke+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Be+Ke+" <"+(+Z+1)+".0.0"):(P("no pr"),xe=Z==="0"?ve==="0"?">="+Z+"."+ve+"."+Be+" <"+Z+"."+ve+"."+(+Be+1):">="+Z+"."+ve+"."+Be+" <"+Z+"."+(+ve+1)+".0":">="+Z+"."+ve+"."+Be+" <"+(+Z+1)+".0.0"),P("caret return",xe),xe})}(_e,nt)}).join(" ")}(Je,Ye),P("caret",Je),Je=function(it,nt){return it.trim().split(/\s+/).map(function(_e){return function(rt,Ue){var ct=Ue?m[U]:m[V];return rt.replace(ct,function(ee,Z,ve,Be,Ke){var xe;return P("tilde",rt,ee,Z,ve,Be,Ke),Se(Z)?xe="":Se(ve)?xe=">="+Z+".0.0 <"+(+Z+1)+".0.0":Se(Be)?xe=">="+Z+"."+ve+".0 <"+Z+"."+(+ve+1)+".0":Ke?(P("replaceTilde pr",Ke),Ke.charAt(0)!=="-"&&(Ke="-"+Ke),xe=">="+Z+"."+ve+"."+Be+Ke+" <"+Z+"."+(+ve+1)+".0"):xe=">="+Z+"."+ve+"."+Be+" <"+Z+"."+(+ve+1)+".0",P("tilde return",xe),xe})}(_e,nt)}).join(" ")}(Je,Ye),P("tildes",Je),Je=function(it,nt){return P("replaceXRanges",it,nt),it.split(/\s+/).map(function(_e){return function(rt,Ue){rt=rt.trim();var ct=Ue?m[y]:m[p];return rt.replace(ct,function(ee,Z,ve,Be,Ke,xe){P("xRange",rt,ee,Z,ve,Be,Ke,xe);var ot=Se(ve),pt=ot||Se(Be),Ne=pt||Se(Ke);return Z==="="&&Ne&&(Z=""),ot?ee=Z===">"||Z==="<"?"<0.0.0":"*":Z&&Ne?(pt&&(Be=0),Ne&&(Ke=0),Z===">"?(Z=">=",pt?(ve=+ve+1,Be=0,Ke=0):Ne&&(Be=+Be+1,Ke=0)):Z==="<="&&(Z="<",pt?ve=+ve+1:Be=+Be+1),ee=Z+ve+"."+Be+"."+Ke):pt?ee=">="+ve+".0.0 <"+(+ve+1)+".0.0":Ne&&(ee=">="+ve+"."+Be+".0 <"+ve+"."+(+Be+1)+".0"),P("xRange return",ee),ee})}(_e,nt)}).join(" ")}(Je,Ye),P("xrange",Je),Je=function(it,nt){return P("replaceStars",it,nt),it.trim().replace(m[me],"")}(Je,Ye),P("stars",Je),Je}(Qe,Q)}).join(" ").split(/\s+/);return this.loose&&(ze=ze.filter(function(Qe){return!!Qe.match(Ee)})),ze=ze.map(function(Qe){return new x(Qe,Q)})},fe.prototype.intersects=function(B,Q){if(!(B instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(_){return _.every(function(Ee){return B.set.some(function(ze){return ze.every(function(Qe){return Ee.intersects(Qe,Q)})})})})},e.toComparators=function(B,Q){return new fe(B,Q).set.map(function(_){return _.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(B){if(!B)return!1;typeof B=="string"&&(B=new ce(B,this.loose));for(var Q=0;Q<this.set.length;Q++)if(O(this.set[Q],B))return!0;return!1},e.satisfies=K,e.maxSatisfying=function(B,Q,_){var Ee=null,ze=null;try{var Qe=new fe(Q,_)}catch{return null}return B.forEach(function(Je){Qe.test(Je)&&(Ee&&ze.compare(Je)!==-1||(ze=new ce(Ee=Je,_)))}),Ee},e.minSatisfying=function(B,Q,_){var Ee=null,ze=null;try{var Qe=new fe(Q,_)}catch{return null}return B.forEach(function(Je){Qe.test(Je)&&(Ee&&ze.compare(Je)!==1||(ze=new ce(Ee=Je,_)))}),Ee},e.validRange=function(B,Q){try{return new fe(B,Q).range||"*"}catch{return null}},e.ltr=function(B,Q,_){return J(B,Q,"<",_)},e.gtr=function(B,Q,_){return J(B,Q,">",_)},e.outside=J,e.prerelease=function(B,Q){var _=ke(B,Q);return _&&_.prerelease.length?_.prerelease:null},e.intersects=function(B,Q,_){return B=new fe(B,_),Q=new fe(Q,_),B.intersects(Q)},e.coerce=function(B){if(B instanceof ce)return B;if(typeof B!="string")return null;var Q=B.match(m[D]);return Q==null?null:ke((Q[1]||"0")+"."+(Q[2]||"0")+"."+(Q[3]||"0"))}}).call(this,E(1))},function(pe,e){var E,T,P=pe.exports={};function M(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function m(s){if(E===setTimeout)return setTimeout(s,0);if((E===M||!E)&&setTimeout)return E=setTimeout,setTimeout(s,0);try{return E(s,0)}catch{try{return E.call(null,s,0)}catch{return E.call(this,s,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:M}catch{E=M}try{T=typeof clearTimeout=="function"?clearTimeout:A}catch{T=A}})();var g,w=[],R=!1,S=-1;function l(){R&&g&&(R=!1,g.length?w=g.concat(w):S=-1,w.length&&$())}function $(){if(!R){var s=m(l);R=!0;for(var t=w.length;t;){for(g=w,w=[];++S<t;)g&&g[S].run();S=-1,t=w.length}g=null,R=!1,function(n){if(T===clearTimeout)return clearTimeout(n);if((T===A||!T)&&clearTimeout)return T=clearTimeout,clearTimeout(n);try{T(n)}catch{try{return T.call(null,n)}catch{return T.call(this,n)}}}(s)}}function b(s,t){this.fun=s,this.array=t}function a(){}P.nextTick=function(s){var t=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)t[n-1]=arguments[n];w.push(new b(s,t)),w.length!==1||R||m($)},b.prototype.run=function(){this.fun.apply(null,this.array)},P.title="browser",P.browser=!0,P.env={},P.argv=[],P.version="",P.versions={},P.on=a,P.addListener=a,P.once=a,P.off=a,P.removeListener=a,P.removeAllListeners=a,P.emit=a,P.prependListener=a,P.prependOnceListener=a,P.listeners=function(s){return[]},P.binding=function(s){throw new Error("process.binding is not supported")},P.cwd=function(){return"/"},P.chdir=function(s){throw new Error("process.chdir is not supported")},P.umask=function(){return 0}}])}),define(Pe[122],Re([1,0,11,6]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=e.$6d=e.$5d=e.$4d=e.$3d=void 0;function P(c){const h=c;return h?typeof h.read=="function":!1}e.$3d=P;function M(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}e.$4d=M;function A(c){const h=c;return h?M(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.$5d=A;function m(c,h){return new g(c,h)}e.$6d=m;class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,E.$Z)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let r;switch(h){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const u=r.indexOf(i);u>=0&&r.splice(u,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function w(c,h){const i=[];let r;for(;(r=c.read())!==null;)i.push(r);return h(i)}e.$7d=w;function R(c,h,i){const r=[];let u;for(;(u=c.read())!==null&&r.length<i;)r.push(u);return u===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof u<"u"){const d=u;return u=void 0,d}return c.read()}}}e.$8d=R;function S(c,h){return new Promise((i,r)=>{const u=[];l(c,{onData:d=>{h&&u.push(d)},onError:d=>{h?r(d):i(void 0)},onEnd:()=>{i(h?h(u):void 0)}})})}e.$9d=S;function l(c,h,i){c.on("error",r=>{i?.isCancellationRequested||h.onError(r)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",r=>{i?.isCancellationRequested||h.onData(r)})}e.$0d=l;function $(c,h){return new Promise((i,r)=>{const u=new T.$Qc,d=[],v=L=>{if(d.push(L),d.length>h)return u.dispose(),c.pause(),i({stream:c,buffer:d,ended:!1})},f=L=>(u.dispose(),r(L)),k=()=>(u.dispose(),i({stream:c,buffer:d,ended:!0}));u.add((0,T.$Pc)(()=>c.removeListener("error",f))),c.on("error",f),u.add((0,T.$Pc)(()=>c.removeListener("end",k))),c.on("end",k),u.add((0,T.$Pc)(()=>c.removeListener("data",v))),c.on("data",v)})}e.$$d=$;function b(c,h){const i=m(h);return i.end(c),i}e.$_d=b;function a(){const c=m(()=>{throw new Error("not supported")});return c.end(),c}e.$ae=a;function s(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}e.$be=s;function t(c,h,i){const r=m(i);return l(c,{onData:u=>r.write(h.data(u)),onError:u=>r.error(h.error?h.error(u):u),onEnd:()=>r.end()}),r}e.$ce=t;function n(c,h,i){let r=!1;return{read:()=>{const u=h.read();return r?u:(r=!0,u!==null?i([c,u]):c)}}}e.$de=n;function o(c,h,i){let r=!1;const u=m(i);return l(h,{onData:d=>r?u.write(d):(r=!0,u.write(i([c,d]))),onError:d=>u.error(d),onEnd:()=>{r||(r=!0,u.write(c)),u.end()}}),u}e.$ee=o}),define(Pe[24],Re([1,0,39,122]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=void 0;const P=typeof Buffer<"u",M=new E.$U(()=>new Uint8Array(256));let A,m;class g{static alloc(D){return P?new g(Buffer.allocUnsafe(D)):new g(new Uint8Array(D))}static wrap(D){return P&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new g(D)}static fromString(D,N){return!(N?.dontUseNodeBuffer||!1)&&P?new g(Buffer.from(D)):(A||(A=new TextEncoder),new g(A.encode(D)))}static fromByteArray(D){const N=g.alloc(D.length);for(let q=0,V=D.length;q<V;q++)N.buffer[q]=D[q];return N}static concat(D,N){if(typeof N>"u"){N=0;for(let U=0,F=D.length;U<F;U++)N+=D[U].byteLength}const q=g.alloc(N);let V=0;for(let U=0,F=D.length;U<F;U++){const C=D[U];q.set(C,V),V+=C.byteLength}return q}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=g.alloc(this.byteLength);return D.set(this),D}toString(){return P?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(D,N){return new g(this.buffer.subarray(D,N))}set(D,N){if(D instanceof g)this.buffer.set(D.buffer,N);else if(D instanceof Uint8Array)this.buffer.set(D,N);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),N);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return l(this.buffer,D)}writeUInt32BE(D,N){$(this.buffer,D,N)}readUInt32LE(D){return b(this.buffer,D)}writeUInt32LE(D,N){a(this.buffer,D,N)}readUInt8(D){return s(this.buffer,D)}writeUInt8(D,N){t(this.buffer,D,N)}indexOf(D,N=0){return w(this.buffer,D instanceof g?D.buffer:D,N)}}e.$fe=g;function w(y,D,N=0){const q=D.byteLength,V=y.byteLength;if(q===0)return 0;if(q===1)return y.indexOf(D[0]);if(q>V-N)return-1;const U=M.value;U.fill(D.length);for(let X=0;X<D.length;X++)U[D[X]]=D.length-X-1;let F=N+D.length-1,C=F,I=-1;for(;F<V;)if(y[F]===D[C]){if(C===0){I=F;break}F--,C--}else F+=Math.max(D.length-C,U[y[F]]),C=D.length-1;return I}e.$ge=w;function R(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0}e.$he=R;function S(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255}e.$ie=S;function l(y,D){return y[D]*2**24+y[D+1]*2**16+y[D+2]*2**8+y[D+3]}e.$je=l;function $(y,D,N){y[N+3]=D,D=D>>>8,y[N+2]=D,D=D>>>8,y[N+1]=D,D=D>>>8,y[N]=D}e.$ke=$;function b(y,D){return y[D+0]<<0>>>0|y[D+1]<<8>>>0|y[D+2]<<16>>>0|y[D+3]<<24>>>0}e.$le=b;function a(y,D,N){y[N+0]=D&255,D=D>>>8,y[N+1]=D&255,D=D>>>8,y[N+2]=D&255,D=D>>>8,y[N+3]=D&255}e.$me=a;function s(y,D){return y[D]}e.$ne=s;function t(y,D,N){y[N]=D}e.$oe=t;function n(y){return T.$7d(y,D=>g.concat(D))}e.$pe=n;function o(y){return T.$be(y)}e.$qe=o;function c(y){return T.$9d(y,D=>g.concat(D))}e.$re=c;async function h(y){return y.ended?g.concat(y.buffer):g.concat([...y.buffer,await c(y.stream)])}e.$se=h;function i(y){return T.$_d(y,D=>g.concat(D))}e.$te=i;function r(y){return T.$ce(y,{data:D=>typeof D=="string"?g.fromString(D):g.wrap(D)},D=>g.concat(D))}e.$ue=r;function u(y){return T.$6d(D=>g.concat(D),y)}e.$ve=u;function d(y,D){return T.$de(y,D,N=>g.concat(N))}e.$we=d;function v(y,D){return T.$ee(y,D,N=>g.concat(N))}e.$xe=v;function f(y){let D=0,N=0,q=0;const V=new Uint8Array(Math.floor(y.length/4*3)),U=C=>{switch(N){case 3:V[q++]=D|C,N=0;break;case 2:V[q++]=D|C>>>2,D=C<<6,N=3;break;case 1:V[q++]=D|C>>>4,D=C<<4,N=2;break;default:D=C<<2,N=1}};for(let C=0;C<y.length;C++){const I=y.charCodeAt(C);if(I>=65&&I<=90)U(I-65);else if(I>=97&&I<=122)U(I-97+26);else if(I>=48&&I<=57)U(I-48+52);else if(I===43||I===45)U(62);else if(I===47||I===95)U(63);else{if(I===61)break;throw new SyntaxError(`Unexpected base64 character ${y[C]}`)}}const F=q;for(;N>0;)U(0);return g.wrap(V).slice(0,F)}e.$ye=f;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function p({buffer:y},D=!0,N=!1){const q=N?L:k;let V="";const U=y.byteLength%3;let F=0;for(;F<y.byteLength-U;F+=3){const C=y[F+0],I=y[F+1],X=y[F+2];V+=q[C>>>2],V+=q[(C<<4|I>>>4)&63],V+=q[(I<<2|X>>>6)&63],V+=q[X&63]}if(U===1){const C=y[F+0];V+=q[C>>>2],V+=q[C<<4&63],D&&(V+="==")}else if(U===2){const C=y[F+0],I=y[F+1];V+=q[C>>>2],V+=q[(C<<4|I>>>4)&63],V+=q[I<<2&63],D&&(V+="=")}return V}e.$ze=p}),define(Pe[123],Re([1,0,28,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2j=e.$1j=e.$Zj=e.$Yj=e.FuzzyScore=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.or=void 0;function P(...x){return function(se,fe){for(let Se=0,Fe=x.length;Se<Fe;Se++){const O=x[Se](se,fe);if(O)return O}return null}}e.or=P,e.$Mj=M.bind(void 0,!1),e.$Nj=M.bind(void 0,!0);function M(x,se,fe){if(!fe||fe.length<se.length)return null;let Se;return x?Se=T.$7e(fe,se):Se=fe.indexOf(se)===0,Se?se.length>0?[{start:0,end:se.length}]:[]:null}function A(x,se){const fe=se.toLowerCase().indexOf(x.toLowerCase());return fe===-1?null:[{start:fe,end:fe+x.length}]}e.$Oj=A;function m(x,se){return g(x.toLowerCase(),se.toLowerCase(),0,0)}e.$Pj=m;function g(x,se,fe,Se){if(fe===x.length)return[];if(Se===se.length)return null;if(x[fe]===se[Se]){let Fe=null;return(Fe=g(x,se,fe+1,Se+1))?t({start:Se,end:Se+1},Fe):null}return g(x,se,fe,Se+1)}function w(x){return 97<=x&&x<=122}function R(x){return 65<=x&&x<=90}e.$Qj=R;function S(x){return 48<=x&&x<=57}function l(x){return x===32||x===9||x===10||x===13}const $=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(x=>$.add(x.charCodeAt(0)));function b(x){return l(x)||$.has(x)}function a(x,se){return x===se||b(x)&&b(se)}function s(x){return w(x)||R(x)||S(x)}function t(x,se){return se.length===0?se=[x]:x.end===se[0].start?se[0].start=x.start:se.unshift(x),se}function n(x,se){for(let fe=se;fe<x.length;fe++){const Se=x.charCodeAt(fe);if(R(Se)||S(Se)||fe>0&&!s(x.charCodeAt(fe-1)))return fe}return x.length}function o(x,se,fe,Se){if(fe===x.length)return[];if(Se===se.length)return null;if(x[fe]!==se[Se].toLowerCase())return null;{let Fe=null,O=Se+1;for(Fe=o(x,se,fe+1,Se+1);!Fe&&(O=n(se,O))<se.length;)Fe=o(x,se,fe+1,O),O++;return Fe===null?null:t({start:Se,end:Se+1},Fe)}}function c(x){let se=0,fe=0,Se=0,Fe=0,O=0;for(let _=0;_<x.length;_++)O=x.charCodeAt(_),R(O)&&se++,w(O)&&fe++,s(O)&&Se++,S(O)&&Fe++;const K=se/x.length,J=fe/x.length,B=Se/x.length,Q=Fe/x.length;return{upperPercent:K,lowerPercent:J,alphaPercent:B,numericPercent:Q}}function h(x){const{upperPercent:se,lowerPercent:fe}=x;return fe===0&&se>.6}function i(x){const{upperPercent:se,lowerPercent:fe,alphaPercent:Se,numericPercent:Fe}=x;return fe>.2&&se<.8&&Se>.6&&Fe<.2}function r(x){let se=0,fe=0,Se=0,Fe=0;for(let O=0;O<x.length;O++)Se=x.charCodeAt(O),R(Se)&&se++,w(Se)&&fe++,l(Se)&&Fe++;return(se===0||fe===0)&&Fe===0?x.length<=30:se<=5}function u(x,se){if(!se||(se=se.trim(),se.length===0)||!r(x)||se.length>60)return null;const fe=c(se);if(!i(fe)){if(!h(fe))return null;se=se.toLowerCase()}let Se=null,Fe=0;for(x=x.toLowerCase();Fe<se.length&&(Se=o(x,se,0,Fe))===null;)Fe=n(se,Fe+1);return Se}e.$Rj=u;function d(x,se,fe=!1){if(!se||se.length===0)return null;let Se=null,Fe=0;for(x=x.toLowerCase(),se=se.toLowerCase();Fe<se.length&&(Se=v(x,se,0,Fe,fe))===null;)Fe=f(se,Fe+1);return Se}e.$Sj=d;function v(x,se,fe,Se,Fe){if(fe===x.length)return[];if(Se===se.length)return null;if(a(x.charCodeAt(fe),se.charCodeAt(Se))){let O=null,K=Se+1;if(O=v(x,se,fe+1,Se+1,Fe),!Fe)for(;!O&&(K=f(se,K))<se.length;)O=v(x,se,fe+1,K,Fe),K++;return O?x.charCodeAt(fe)!==se.charCodeAt(Se)?O:t({start:Se,end:Se+1},O):null}else return null}function f(x,se){for(let fe=se;fe<x.length;fe++)if(b(x.charCodeAt(fe))||fe>0&&b(x.charCodeAt(fe-1)))return fe;return x.length}const k=P(e.$Nj,u,A),L=P(e.$Nj,u,m),p=new E.$Cc(1e4);function y(x,se,fe=!1){if(typeof x!="string"||typeof se!="string")return null;let Se=p.get(x);Se||(Se=new RegExp(T.$Pe(x),"i"),p.set(x,Se));const Fe=Se.exec(se);return Fe?[{start:Fe.index,end:Fe.index+Fe[0].length}]:fe?L(x,se):k(x,se)}e.$Tj=y;function D(x,se){const fe=Ie(x,x.toLowerCase(),0,se,se.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return fe?q(fe):null}e.$Uj=D;function N(x,se,fe,Se,Fe,O){const K=Math.min(13,x.length);for(;fe<K;fe++){const J=Ie(x,se,fe,Se,Fe,O,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(J)return J}return[0,O]}e.$Vj=N;function q(x){if(typeof x>"u")return[];const se=[],fe=x[1];for(let Se=x.length-1;Se>1;Se--){const Fe=x[Se]+fe,O=se[se.length-1];O&&O.end===Fe?O.end=Fe+1:se.push({start:Fe,end:Fe+1})}return se}e.$Wj=q;const V=128;function U(){const x=[],se=[];for(let fe=0;fe<=V;fe++)se[fe]=0;for(let fe=0;fe<=V;fe++)x.push(se.slice(0));return x}function F(x){const se=[];for(let fe=0;fe<=x;fe++)se[fe]=0;return se}const C=F(2*V),I=F(2*V),X=U(),ue=U(),he=U(),be=!1;function we(x,se,fe,Se,Fe){function O(J,B,Q=" "){for(;J.length<B;)J=Q+J;return J}let K=` |   |${Se.split("").map(J=>O(J,3)).join("|")}
`;for(let J=0;J<=fe;J++)J===0?K+=" |":K+=`${se[J-1]}|`,K+=x[J].slice(0,Fe+1).map(B=>O(B.toString(),3)).join("|")+`
`;return K}function ge(x,se,fe,Se){x=x.substr(se),fe=fe.substr(Se),console.log(we(ue,x,x.length,fe,fe.length)),console.log(we(he,x,x.length,fe,fe.length)),console.log(we(X,x,x.length,fe,fe.length))}function me(x,se){if(se<0||se>=x.length)return!1;const fe=x.codePointAt(se);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!T.$mf(fe)}}function ne(x,se){if(se<0||se>=x.length)return!1;switch(x.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function ke(x,se,fe){return se[x]!==fe[x]}function ce(x,se,fe,Se,Fe,O,K=!1){for(;se<fe&&Fe<O;)x[se]===Se[Fe]&&(K&&(C[se]=Fe),se+=1),Fe+=1;return se===fe}e.$Xj=ce;var Y;(function(x){x[x.Diag=1]="Diag",x[x.Left=2]="Left",x[x.LeftLeft=3]="LeftLeft"})(Y||(Y={}));var W;(function(x){x.Default=[-100,0];function se(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}x.isDefault=se})(W||(e.FuzzyScore=W={}));class re{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(se,fe){this.firstMatchCanBeWeak=se,this.boostFullMatch=fe}}e.$Yj=re;function Ie(x,se,fe,Se,Fe,O,K=re.default){const J=x.length>V?V:x.length,B=Se.length>V?V:Se.length;if(fe>=J||O>=B||J-fe>B-O||!ce(se,fe,J,Fe,O,B,!0))return;Ae(J,B,fe,O,se,Fe);let Q=1,_=1,Ee=fe,ze=O;const Qe=[!1];for(Q=1,Ee=fe;Ee<J;Q++,Ee++){const _e=C[Ee],rt=I[Ee],Ue=Ee+1<J?I[Ee+1]:B;for(_=_e-O+1,ze=_e;ze<Ue;_++,ze++){let ct=Number.MIN_SAFE_INTEGER,ee=!1;ze<=rt&&(ct=Ce(x,se,Ee,fe,Se,Fe,ze,B,O,X[Q-1][_-1]===0,Qe));let Z=0;ct!==Number.MAX_SAFE_INTEGER&&(ee=!0,Z=ct+ue[Q-1][_-1]);const ve=ze>_e,Be=ve?ue[Q][_-1]+(X[Q][_-1]>0?-5:0):0,Ke=ze>_e+1&&X[Q][_-1]>0,xe=Ke?ue[Q][_-2]+(X[Q][_-2]>0?-5:0):0;if(Ke&&(!ve||xe>=Be)&&(!ee||xe>=Z))ue[Q][_]=xe,he[Q][_]=3,X[Q][_]=0;else if(ve&&(!ee||Be>=Z))ue[Q][_]=Be,he[Q][_]=2,X[Q][_]=0;else if(ee)ue[Q][_]=Z,he[Q][_]=1,X[Q][_]=X[Q-1][_-1]+1;else throw new Error("not possible")}}if(be&&ge(x,fe,Se,O),!Qe[0]&&!K.firstMatchCanBeWeak)return;Q--,_--;const Je=[ue[Q][_],O];let Ye=0,it=0;for(;Q>=1;){let _e=_;do{const rt=he[Q][_e];if(rt===3)_e=_e-2;else if(rt===2)_e=_e-1;else break}while(_e>=1);Ye>1&&se[fe+Q-1]===Fe[O+_-1]&&!ke(_e+O-1,Se,Fe)&&Ye+1>X[Q][_e]&&(_e=_),_e===_?Ye++:Ye=1,it||(it=_e),Q--,_=_e-1,Je.push(_)}B===J&&K.boostFullMatch&&(Je[0]+=2);const nt=it-J;return Je[0]-=nt,Je}e.$Zj=Ie;function Ae(x,se,fe,Se,Fe,O){let K=x-1,J=se-1;for(;K>=fe&&J>=Se;)Fe[K]===O[J]&&(I[K]=J,K--),J--}function Ce(x,se,fe,Se,Fe,O,K,J,B,Q,_){if(se[fe]!==O[K])return Number.MIN_SAFE_INTEGER;let Ee=1,ze=!1;return K===fe-Se?Ee=x[fe]===Fe[K]?7:5:ke(K,Fe,O)&&(K===0||!ke(K-1,Fe,O))?(Ee=x[fe]===Fe[K]?7:5,ze=!0):me(O,K)&&(K===0||!me(O,K-1))?Ee=5:(me(O,K-1)||ne(O,K-1))&&(Ee=5,ze=!0),Ee>1&&fe===Se&&(_[0]=!0),ze||(ze=ke(K,Fe,O)||me(O,K-1)||ne(O,K-1)),fe===Se?K>B&&(Ee-=ze?3:5):Q?Ee+=ze?2:0:Ee+=ze?0:1,K+1===J&&(Ee-=ze?3:5),Ee}function le(x,se,fe,Se,Fe,O,K){return G(x,se,fe,Se,Fe,O,!0,K)}e.$1j=le;function ie(x,se,fe,Se,Fe,O,K){return G(x,se,fe,Se,Fe,O,!1,K)}e.$2j=ie;function G(x,se,fe,Se,Fe,O,K,J){let B=Ie(x,se,fe,Se,Fe,O,J);if(B&&!K)return B;if(x.length>=3){const Q=Math.min(7,x.length-1);for(let _=fe+1;_<Q;_++){const Ee=te(x,_);if(Ee){const ze=Ie(Ee,Ee.toLowerCase(),fe,Se,Fe,O,J);ze&&(ze[0]-=3,(!B||ze[0]>B[0])&&(B=ze))}}}return B}function te(x,se){if(se+1>=x.length)return;const fe=x[se],Se=x[se+1];if(fe!==Se)return x.slice(0,se)+Se+fe+x.slice(se+2)}}),define(Pe[31],Re([1,0,12]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(P){P[P.Ignore=0]="Ignore",P[P.Info=1]="Info",P[P.Warning=2]="Warning",P[P.Error=3]="Error"})(T||(T={})),function(P){const M="error",A="warning",m="warn",g="info",w="ignore";function R(l){return l?E.$6e(M,l)?P.Error:E.$6e(A,l)||E.$6e(m,l)?P.Warning:E.$6e(g,l)?P.Info:P.Ignore:P.Ignore}P.fromValue=R;function S(l){switch(l){case P.Error:return M;case P.Warning:return A;case P.Info:return g;default:return w}}P.toString=S}(T||(T={})),e.default=T}),define(Pe[124],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Od=void 0,e.$Od=Symbol("MicrotaskDelay")}),define(Pe[50],Re([1,0,18,12]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=e.$5h=e.$4h=e.$3h=e.$2h=void 0;class P{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const b=$.charCodeAt(0),a=this.b.charCodeAt(this.c);return b-a}value(){return this.b[this.c]}}e.$2h=P;class M{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,T.$Ze)($,this.b,0,$.length,this.c,this.d):(0,T.$2e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$3h=M;class A{constructor($=!0,b=!0){this.f=$,this.g=b}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let b=$.length-1;b>=0;b--,this.c--){const a=this.b.charCodeAt(b);if(!(a===47||this.f&&a===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const b=this.b.charCodeAt(this.e);if(b===47||this.f&&b===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,T.$Ze)($,this.b,0,$.length,this.d,this.e):(0,T.$2e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$4h=A;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class g{constructor($,b){this.f=$,this.g=b,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,T.$1e)($,this.c.scheme);if(this.d[this.e]===2)return(0,T.$1e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,T.$Ye)($,this.c.query);if(this.d[this.e]===5)return(0,T.$Ye)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$5h=g;class w{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(R||(R={}));class S{static forUris($=()=>!1,b=()=>!1){return new S(new g($,b))}static forPaths($=!1){return new S(new A(void 0,!$))}static forStrings(){return new S(new P)}static forConfigKeys(){return new S(new M)}constructor($){this.b=$}clear(){this.c=void 0}fill($,b){if(b){const a=b.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s,$)}else{const a=$.slice(0);(0,E.$Wb)(a);for(const s of a)this.set(s[0],s[1])}}set($,b){const a=this.b.reset($);let s;this.c||(this.c=new w,this.c.segment=a.value());const t=[];for(s=this.c;;){const o=a.cmp(s.segment);if(o>0)s.left||(s.left=new w,s.left.segment=a.value()),t.push([-1,s]),s=s.left;else if(o<0)s.right||(s.right=new w,s.right.segment=a.value()),t.push([1,s]),s=s.right;else if(a.hasNext())a.next(),s.mid||(s.mid=new w,s.mid.segment=a.value()),t.push([0,s]),s=s.mid;else break}const n=s.value;s.value=b,s.key=$;for(let o=t.length-1;o>=0;o--){const c=t[o][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=t[o][0],r=t[o+1][0];if(i===1&&r===1)t[o][1]=c.rotateLeft();else if(i===-1&&r===-1)t[o][1]=c.rotateRight();else if(i===1&&r===-1)c.right=t[o+1][1]=t[o+1][1].rotateRight(),t[o][1]=c.rotateLeft();else if(i===-1&&r===1)c.left=t[o+1][1]=t[o+1][1].rotateLeft(),t[o][1]=c.rotateRight();else throw new Error;if(o>0)switch(t[o-1][0]){case-1:t[o-1][1].left=t[o][1];break;case 1:t[o-1][1].right=t[o][1];break;case 0:t[o-1][1].mid=t[o][1];break}else this.c=t[0][1]}}return n}get($){return this.d($)?.value}d($){const b=this.b.reset($);let a=this.c;for(;a;){const s=b.cmp(a.segment);if(s>0)a=a.left;else if(s<0)a=a.right;else if(b.hasNext())b.next(),a=a.mid;else break}return a}has($){const b=this.d($);return!(b?.value===void 0&&b?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,b){const a=this.b.reset($),s=[];let t=this.c;for(;t;){const n=a.cmp(t.segment);if(n>0)s.push([-1,t]),t=t.left;else if(n<0)s.push([1,t]),t=t.right;else if(a.hasNext())a.next(),s.push([0,t]),t=t.mid;else break}if(t){if(b?(t.left=void 0,t.mid=void 0,t.right=void 0,t.height=1):(t.key=void 0,t.value=void 0),!t.mid&&!t.value)if(t.left&&t.right){const n=this.f(t.right);if(n.key){const{key:o,value:c,segment:h}=n;this.e(n.key,!1),t.key=o,t.value=c,t.segment=h}}else{const n=t.left??t.right;if(s.length>0){const[o,c]=s[s.length-1];switch(o){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=s.length-1;n>=0;n--){const o=s[n][1];o.updateHeight();const c=o.balanceFactor();if(c>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),s[n][1]=o.rotateLeft()):c<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),s[n][1]=o.rotateRight()),n>0)switch(s[n-1][0]){case-1:s[n-1][1].left=s[n][1];break;case 1:s[n-1][1].right=s[n][1];break;case 0:s[n-1][1].mid=s[n][1];break}else this.c=s[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const b=this.b.reset($);let a=this.c,s;for(;a;){const t=b.cmp(a.segment);if(t>0)a=a.left;else if(t<0)a=a.right;else if(b.hasNext())b.next(),s=a.value||s,a=a.mid;else break}return a&&a.value||s}findSuperstr($){return this.g($,!1)}g($,b){const a=this.b.reset($);let s=this.c;for(;s;){const t=a.cmp(s.segment);if(t>0)s=s.left;else if(t<0)s=s.right;else if(a.hasNext())a.next(),s=s.mid;else return s.mid?this.h(s.mid):b?s.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[b,a]of this)$(a,b)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const b=[];return this.j($,b),b[Symbol.iterator]()}j($,b){$&&($.left&&this.j($.left,b),$.value&&b.push([$.key,$.value]),$.mid&&this.j($.mid,b),$.right&&this.j($.right,b))}_isBalanced(){const $=b=>{if(!b)return!0;const a=b.balanceFactor();return a<-1||a>1?!1:$(b.left)&&$(b.right)};return $(this.c)}}e.$6h=S}),define(Pe[45],Re([1,0,90]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$6j=e.ThemeColor=void 0;var T;(function(A){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}A.isThemeColor=m})(T||(e.ThemeColor=T={}));function P(A){return{id:A}}e.$6j=P;var M;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function g(n){const o=m.exec(n.id);if(!o)return g(E.$5j.error);const[,c,h]=o,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}A.asClassNameArray=g;function w(n){return g(n).join(" ")}A.asClassName=w;function R(n){return"."+g(n).join(".")}A.asCSSSelector=R;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||T.isThemeColor(n.color))}A.isThemeIcon=S;const l=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function $(n){const o=l.exec(n);if(!o)return;const[,c]=o;return{id:c}}A.fromString=$;function b(n){return{id:n}}A.fromId=b;function a(n,o){let c=n.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),o&&(c=`${c}~${o}`),{id:c}}A.modify=a;function s(n){const o=n.id.lastIndexOf("~");if(o!==-1)return n.id.substring(o+1)}A.getModifier=s;function t(n,o){return n.id===o.id&&n.color?.id===o.color?.id}A.isEqual=t})(M||(e.ThemeIcon=M={}))}),define(Pe[125],Re([1,0,123,12,45]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=void 0;const M="$(",A=new RegExp(`\\$\\(${P.ThemeIcon.iconNameExpression}(?:${P.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${A.source}`,"g");function g(t){return t.replace(m,(n,o)=>o?n:`\\${n}`)}e.$7j=g;const w=new RegExp(`\\\\${A.source}`,"g");function R(t){return t.replace(w,n=>`\\${n}`)}e.$8j=R;const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function l(t){return t.indexOf(M)===-1?t:t.replace(S,(n,o,c,h)=>c?n:o||h||"")}e.$9j=l;function $(t){return t?t.replace(/\$\((.*?)\)/g,(n,o)=>` ${o} `).trim():""}e.$0j=$;const b=new RegExp(`\\$\\(${P.ThemeIcon.iconNameCharacter}+\\)`,"g");function a(t){b.lastIndex=0;let n="";const o=[];let c=0;for(;;){const h=b.lastIndex,i=b.exec(t),r=t.substring(h,i?.index);if(r.length>0){n+=r;for(let u=0;u<r.length;u++)o.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:o}}e.$$j=a;function s(t,n,o=!1){const{text:c,iconOffsets:h}=n;if(!h||h.length===0)return(0,E.$Tj)(t,c,o);const i=(0,T.$Ne)(c," "),r=c.length-i.length,u=(0,E.$Tj)(t,i,o);if(u)for(const d of u){const v=h[d.start+r]+r;d.start+=v,d.end+=v}return u}e.$_j=s}),define(Pe[33],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kg=e.$jg=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(P){return E.test(P)}e.$jg=T,e.$kg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(m){for(let g=0;g<m.length;g++)m[g]=Math.floor(Math.random()*256);return m};const M=new Uint8Array(16),A=[];for(let m=0;m<256;m++)A.push(m.toString(16).padStart(2,"0"));return function(){P(M),M[6]=M[6]&15|64,M[8]=M[8]&63|128;let g=0,w="";return w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+="-",w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w+=A[M[g++]],w}}()}),define(Pe[126],Re([1,0,18,67,33]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$at=e.$_s=e.$$s=e.$0s=e.$9s=void 0;function M(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}e.$9s=M;function A(S,l,$){const b={id:(0,P.$kg)(),name:S,uri:l,data:$};return{asString:async()=>"",asFile:()=>b,value:void 0}}e.$0s=A;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return T.Iterable.some(this,([b,a])=>a.asFile())&&$.push("files"),R(g(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const b=this.a.get(l);b?b.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const b of $)yield[l,b]}b(l){return g(l)}}e.$$s=m;function g(S){return S.toLowerCase()}function w(S,l){return R(g(S),l.map(g))}e.$_s=w;function R(S,l){if(S==="*/*")return l.length>0;if(l.includes(S))return!0;const $=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[b,a,s]=$;return s==="*"?l.some(t=>t.startsWith(a+"/")):!1}e.$at=Object.freeze({create:S=>(0,E.$Lb)(S.map(l=>l.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$at.split(S).filter(l=>!l.startsWith("#"))})}),define(Pe[127],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dt=e.StringEOL=void 0;var E;(function(P){P[P.Unknown=0]="Unknown",P[P.Invalid=3]="Invalid",P[P.LF=1]="LF",P[P.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function T(P){let M=0,A=0,m=0,g=0;for(let w=0,R=P.length;w<R;w++){const S=P.charCodeAt(w);S===13?(M===0&&(A=w),M++,w+1<R&&P.charCodeAt(w+1)===10?(g|=2,w++):g|=3,m=w+1):S===10&&(g|=1,M===0&&(A=w),M++,m=w+1)}return M===0&&(A=P.length),[M,A,P.length-m,g]}e.$dt=T}),define(Pe[128],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=void 0,e.$as={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[129],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=e.$At=e.IndentAction=void 0;var E;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(E||(e.IndentAction=E={}));class T{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let g=0,w=m.notIn.length;g<w;g++)switch(m.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,g){if(m.getTokenCount()===0)return!0;const w=m.findTokenIndexAtOffset(g-2),R=m.getStandardTokenType(w);return this.isOK(R)}g(m,g){for(let w=m;w<=g;w++){const R=String.fromCharCode(w);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$At=T;class P{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of m)M(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),M(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),M(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),M(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&M(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$Bt=P;function M(A,m,g){A.has(m)?A.get(m).push(g):A.set(m,[g])}}),define(Pe[130],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FB=e.$EB=e.$DB=e.$CB=e.$BB=e.$AB=e.$zB=e.$yB=e.$xB=e.NodeColor=e.$wB=void 0;class E{constructor(s,t){this.piece=s,this.color=t,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$xB)return P(this.right);let s=this;for(;s.parent!==e.$xB&&s.parent.left!==s;)s=s.parent;return s.parent===e.$xB?e.$xB:s.parent}prev(){if(this.left!==e.$xB)return M(this.left);let s=this;for(;s.parent!==e.$xB&&s.parent.right!==s;)s=s.parent;return s.parent===e.$xB?e.$xB:s.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$wB=E;var T;(function(a){a[a.Black=0]="Black",a[a.Red=1]="Red"})(T||(e.NodeColor=T={})),e.$xB=new E(null,0),e.$xB.parent=e.$xB,e.$xB.left=e.$xB,e.$xB.right=e.$xB,e.$xB.color=0;function P(a){for(;a.left!==e.$xB;)a=a.left;return a}e.$yB=P;function M(a){for(;a.right!==e.$xB;)a=a.right;return a}e.$zB=M;function A(a){return a===e.$xB?0:a.size_left+a.piece.length+A(a.right)}function m(a){return a===e.$xB?0:a.lf_left+a.piece.lineFeedCnt+m(a.right)}function g(){e.$xB.parent=e.$xB}function w(a,s){const t=s.right;t.size_left+=s.size_left+(s.piece?s.piece.length:0),t.lf_left+=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),s.right=t.left,t.left!==e.$xB&&(t.left.parent=s),t.parent=s.parent,s.parent===e.$xB?a.root=t:s.parent.left===s?s.parent.left=t:s.parent.right=t,t.left=s,s.parent=t}e.$AB=w;function R(a,s){const t=s.left;s.left=t.right,t.right!==e.$xB&&(t.right.parent=s),t.parent=s.parent,s.size_left-=t.size_left+(t.piece?t.piece.length:0),s.lf_left-=t.lf_left+(t.piece?t.piece.lineFeedCnt:0),s.parent===e.$xB?a.root=t:s===s.parent.right?s.parent.right=t:s.parent.left=t,t.right=s,s.parent=t}e.$BB=R;function S(a,s){let t,n;if(s.left===e.$xB?(n=s,t=n.right):s.right===e.$xB?(n=s,t=n.left):(n=P(s.right),t=n.right),n===a.root){a.root=t,t.color=0,s.detach(),g(),a.root.parent=e.$xB;return}const o=n.color===1;if(n===n.parent.left?n.parent.left=t:n.parent.right=t,n===s?(t.parent=n.parent,b(a,t)):(n.parent===s?t.parent=n:t.parent=n.parent,b(a,t),n.left=s.left,n.right=s.right,n.parent=s.parent,n.color=s.color,s===a.root?a.root=n:s===s.parent.left?s.parent.left=n:s.parent.right=n,n.left!==e.$xB&&(n.left.parent=n),n.right!==e.$xB&&(n.right.parent=n),n.size_left=s.size_left,n.lf_left=s.lf_left,b(a,n)),s.detach(),t.parent.left===t){const h=A(t),i=m(t);if(h!==t.parent.size_left||i!==t.parent.lf_left){const r=h-t.parent.size_left,u=i-t.parent.lf_left;t.parent.size_left=h,t.parent.lf_left=i,$(a,t.parent,r,u)}}if(b(a,t.parent),o){g();return}let c;for(;t!==a.root&&t.color===0;)t===t.parent.left?(c=t.parent.right,c.color===1&&(c.color=0,t.parent.color=1,w(a,t.parent),c=t.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.right.color===0&&(c.left.color=0,c.color=1,R(a,c),c=t.parent.right),c.color=t.parent.color,t.parent.color=0,c.right.color=0,w(a,t.parent),t=a.root)):(c=t.parent.left,c.color===1&&(c.color=0,t.parent.color=1,R(a,t.parent),c=t.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,t=t.parent):(c.left.color===0&&(c.right.color=0,c.color=1,w(a,c),c=t.parent.left),c.color=t.parent.color,t.parent.color=0,c.left.color=0,R(a,t.parent),t=a.root));t.color=0,g()}e.$CB=S;function l(a,s){for(b(a,s);s!==a.root&&s.parent.color===1;)if(s.parent===s.parent.parent.left){const t=s.parent.parent.right;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.right&&(s=s.parent,w(a,s)),s.parent.color=0,s.parent.parent.color=1,R(a,s.parent.parent))}else{const t=s.parent.parent.left;t.color===1?(s.parent.color=0,t.color=0,s.parent.parent.color=1,s=s.parent.parent):(s===s.parent.left&&(s=s.parent,R(a,s)),s.parent.color=0,s.parent.parent.color=1,w(a,s.parent.parent))}a.root.color=0}e.$DB=l;function $(a,s,t,n){for(;s!==a.root&&s!==e.$xB;)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}e.$EB=$;function b(a,s){let t=0,n=0;if(s!==a.root){for(;s!==a.root&&s===s.parent.right;)s=s.parent;if(s!==a.root)for(s=s.parent,t=A(s.left)-s.size_left,n=m(s.left)-s.lf_left,s.size_left+=t,s.lf_left+=n;s!==a.root&&(t!==0||n!==0);)s.parent.left===s&&(s.parent.size_left+=t,s.parent.lf_left+=n),s=s.parent}}e.$FB=b}),define(Pe[91],Re([1,0,92,29,93,130,94]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QB=e.$PB=e.$OB=e.$NB=e.$MB=void 0;const m=65535;function g(t){let n;return t[t.length-1]<65536?n=new Uint16Array(t.length):n=new Uint32Array(t.length),n.set(t,0),n}class w{constructor(n,o,c,h,i){this.lineStarts=n,this.cr=o,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function R(t,n=!0){const o=[0];let c=1;for(let h=0,i=t.length;h<i;h++){const r=t.charCodeAt(h);r===13?h+1<i&&t.charCodeAt(h+1)===10?(o[c++]=h+2,h++):o[c++]=h+1:r===10&&(o[c++]=h+1)}return n?g(o):o}e.$MB=R;function S(t,n){t.length=0,t[0]=0;let o=1,c=0,h=0,i=0,r=!0;for(let d=0,v=n.length;d<v;d++){const f=n.charCodeAt(d);f===13?d+1<v&&n.charCodeAt(d+1)===10?(i++,t[o++]=d+2,d++):(c++,t[o++]=d+1):f===10?(h++,t[o++]=d+1):r&&f!==9&&(f<32||f>126)&&(r=!1)}const u=new w(g(t),c,h,i,r);return t.length=0,u}e.$NB=S;class l{constructor(n,o,c,h,i){this.bufferIndex=n,this.start=o,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$OB=l;class ${constructor(n,o){this.buffer=n,this.lineStarts=o}}e.$PB=$;class b{constructor(n,o){this.a=[],this.c=n,this.d=o,this.b=0,n.root!==M.$xB&&n.iterate(n.root,c=>(c!==M.$xB&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class a{constructor(n){this.a=n,this.b=[]}get(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let o=this.b.length-1;o>=0;o--){const c=this.b[o];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let o=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=n){c[h]=null,o=!0;continue}}if(o){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class s{constructor(n,o,c){this.create(n,o,c)}create(n,o,c){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=M.$xB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=c;let h=null;for(let i=0,r=n.length;i<r;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=R(n[i].buffer));const u=new l(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),h=this.S(h,u)}this.h=new a(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const o=m,c=o-Math.floor(o/3),h=c*2;let i="",r=0;const u=[];if(this.iterate(this.root,d=>{const v=this.R(d),f=v.length;if(r<=c||r+f<h)return i+=v,r+=f,!0;const k=i.replace(/\r\n|\r|\n/g,n);return u.push(new $(k,R(k))),i=v,r=f,!0}),r>0){const d=i.replace(/\r\n|\r|\n/g,n);u.push(new $(d,R(d)))}this.create(u,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new b(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let o=0;return this.iterate(this.root,h=>{if(h===M.$xB)return!0;const i=this.R(h),r=i.length,u=n.G(o),d=n.G(o+r),v=n.getValueInRange2(u,d);return o+=r,i===v})}getOffsetAt(n,o){let c=0,h=this.root;for(;h!==M.$xB;)if(h.left!==M.$xB&&h.lf_left+1>=n)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=n){c+=h.size_left;const i=this.B(h,n-h.lf_left-2);return c+=i+o-1}else n-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let o=this.root,c=0;const h=n;for(;o!==M.$xB;)if(o.size_left!==0&&o.size_left>=n)o=o.left;else if(o.size_left+o.piece.length>=n){const i=this.A(o,n-o.size_left);if(c+=o.lf_left+i.index,i.index===0){const r=this.getOffsetAt(c+1,1),u=h-r;return new E.$Cs(c+1,u+1)}return new E.$Cs(c+1,i.remainder+1)}else if(n-=o.size_left+o.piece.length,c+=o.lf_left+o.piece.lineFeedCnt,o.right===M.$xB){const i=this.getOffsetAt(c+1,1),r=h-n-i;return new E.$Cs(c+1,r+1)}else o=o.right;return new E.$Cs(1,1)}getValueInRange(n,o){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),h=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,h);return o?o!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,o):i}getValueInRange2(n,o){if(n.node===o.node){const u=n.node,d=this.a[u.piece.bufferIndex].buffer,v=this.u(u.piece.bufferIndex,u.piece.start);return d.substring(v+n.remainder,v+o.remainder)}let c=n.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let r=h.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==M.$xB;){const u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(c===o.node){r+=u.substring(d,d+o.remainder);break}else r+=u.substr(d,c.piece.length);c=c.next()}return r}getLinesContent(){const n=[];let o=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===M.$xB)return!0;const r=i.piece;let u=r.length;if(u===0)return!0;const d=this.a[r.bufferIndex].buffer,v=this.a[r.bufferIndex].lineStarts,f=r.start.line,k=r.end.line;let L=v[f]+r.start.column;if(h&&(d.charCodeAt(L)===10&&(L++,u--),n[o++]=c,c="",h=!1,u===0))return!0;if(f===k)return!this.f&&d.charCodeAt(L+u-1)===13?(h=!0,c+=d.substr(L,u-1)):c+=d.substr(L,u),!0;c+=this.f?d.substring(L,Math.max(L,v[f+1]-this.e)):d.substring(L,v[f+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;for(let p=f+1;p<k;p++)c=this.f?d.substring(v[p],v[p+1]-this.e):d.substring(v[p],v[p+1]).replace(/(\r\n|\r|\n)$/,""),n[o++]=c;return!this.f&&d.charCodeAt(v[k]+r.end.column-1)===13?(h=!0,r.end.column===0?o--:c=d.substr(v[k],r.end.column-1)):c=d.substr(v[k],r.end.column),!0}),h&&(n[o++]=c,c=""),n[o++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const o=n.node.next();if(!o)return 0;const c=this.a[o.piece.bufferIndex],h=this.u(o.piece.bufferIndex,o.piece.start);return c.buffer.charCodeAt(h)}else{const o=this.a[n.node.piece.bufferIndex],h=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return o.buffer.charCodeAt(h)}}getLineCharCode(n,o){const c=this.H(n,o+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const o=this.getOffsetAt(n,1);return this.getLength()-o}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const o=this.G(n);return this.l(o)}findMatchesInNode(n,o,c,h,i,r,u,d,v,f,k){const L=this.a[n.piece.bufferIndex],p=this.u(n.piece.bufferIndex,n.piece.start),y=this.u(n.piece.bufferIndex,i),D=this.u(n.piece.bufferIndex,r);let N;const q={line:0,column:0};let V,U;o._wordSeparators?(V=L.buffer.substring(y,D),U=F=>F+y,o.reset(0)):(V=L.buffer,U=F=>F,o.reset(y));do if(N=o.next(V),N){if(U(N.index)>=D)return f;this.s(n,U(N.index)-p,q);const F=this.t(n.piece.bufferIndex,i,q),C=q.line===i.line?q.column-i.column+h:q.column+1,I=C+N[0].length;if(k[f++]=(0,A.$IB)(new T.$Ds(c+F,C,c+F,I),N,d),U(N.index)+N[0].length>=D||f>=v)return f}while(N);return f}findMatchesLineByLine(n,o,c,h){const i=[];let r=0;const u=new A.$LB(o.wordSeparators,o.regex);let d=this.H(n.startLineNumber,n.startColumn);if(d===null)return[];const v=this.H(n.endLineNumber,n.endColumn);if(v===null)return[];let f=this.s(d.node,d.remainder);const k=this.s(v.node,v.remainder);if(d.node===v.node)return this.findMatchesInNode(d.node,u,n.startLineNumber,n.startColumn,f,k,o,c,h,r,i),i;let L=n.startLineNumber,p=d.node;for(;p!==v.node;){const D=this.t(p.piece.bufferIndex,f,p.piece.end);if(D>=1){const q=this.a[p.piece.bufferIndex].lineStarts,V=this.u(p.piece.bufferIndex,p.piece.start),U=q[f.line+D],F=L===n.startLineNumber?n.startColumn:1;if(r=this.findMatchesInNode(p,u,L,F,f,this.s(p,U-V),o,c,h,r,i),r>=h)return i;L+=D}const N=L===n.startLineNumber?n.startColumn-1:0;if(L===n.endLineNumber){const q=this.getLineContent(L).substring(N,n.endColumn-1);return r=this.n(o,u,q,n.endLineNumber,N,r,i,c,h),i}if(r=this.n(o,u,this.getLineContent(L).substr(N),L,N,r,i,c,h),r>=h)return i;L++,d=this.H(L,1),p=d.node,f=this.s(d.node,d.remainder)}if(L===n.endLineNumber){const D=L===n.startLineNumber?n.startColumn-1:0,N=this.getLineContent(L).substring(D,n.endColumn-1);return r=this.n(o,u,N,n.endLineNumber,D,r,i,c,h),i}const y=L===n.startLineNumber?n.startColumn:1;return r=this.findMatchesInNode(v.node,u,L,y,f,k,o,c,h,r,i),i}n(n,o,c,h,i,r,u,d,v){const f=n.wordSeparators;if(!d&&n.simpleSearch){const L=n.simpleSearch,p=L.length,y=c.length;let D=-p;for(;(D=c.indexOf(L,D+p))!==-1;)if((!f||(0,A.$KB)(f,c,y,D,p))&&(u[r++]=new P.$Vu(new T.$Ds(h,D+1+i,h,D+1+p+i),null),r>=v))return r;return r}let k;o.reset(0);do if(k=o.next(c),k&&(u[r++]=(0,A.$IB)(new T.$Ds(h,k.index+1+i,h,k.index+1+k[0].length+i),k,d),r>=v))return r;while(k);return r}insert(n,o,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==M.$xB){const{node:h,remainder:i,nodeStartOffset:r}=this.G(n),u=h.piece,d=u.bufferIndex,v=this.s(h,i);if(h.piece.bufferIndex===0&&u.end.line===this.g.line&&u.end.column===this.g.column&&r+u.length===n&&o.length<m){this.F(h,o),this.y();return}if(r===n)this.o(o,h),this.h.validate(n);else if(r+h.piece.length>n){const f=[];let k=new l(u.bufferIndex,v,u.end,this.t(u.bufferIndex,v,u.end),this.u(d,u.end)-this.u(d,v));if(this.K()&&this.M(o)&&this.I(h,i)===10){const D={line:k.start.line+1,column:0};k=new l(k.bufferIndex,D,k.end,this.t(k.bufferIndex,D,k.end),k.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(h,i-1)===13){const D=this.s(h,i-1);this.C(h,D),o="\r"+o,h.piece.length===0&&f.push(h)}else this.C(h,v);else this.C(h,v);const L=this.w(o);k.length>0&&this.S(h,k);let p=h;for(let y=0;y<L.length;y++)p=this.S(p,L[y]);this.v(f)}else this.q(o,h)}else{const h=this.w(o);let i=this.T(null,h[0]);for(let r=1;r<h.length;r++)i=this.S(i,h[r])}this.y()}delete(n,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===M.$xB)return;const c=this.G(n),h=this.G(n+o),i=c.node,r=h.node;if(i===r){const L=this.s(i,c.remainder),p=this.s(i,h.remainder);if(c.nodeStartOffset===n){if(o===i.piece.length){const y=i.next();(0,M.$CB)(this,i),this.N(y),this.y();return}this.D(i,p),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+o){this.C(i,L),this.O(i),this.y();return}this.E(i,L,p),this.y();return}const u=[],d=this.s(i,c.remainder);this.C(i,d),this.h.validate(n),i.piece.length===0&&u.push(i);const v=this.s(r,h.remainder);this.D(r,v),r.piece.length===0&&u.push(r);const f=i.next();for(let L=f;L!==M.$xB&&L!==r;L=L.next())u.push(L);const k=i.piece.length===0?i.prev():i;this.v(u),this.O(k),this.y()}o(n,o){const c=[];if(this.K()&&this.M(n)&&this.L(o)){const r=o.piece,u={line:r.start.line+1,column:0},d=new l(r.bufferIndex,u,r.end,this.t(r.bufferIndex,u,r.end),r.length-1);o.piece=d,n+=`
`,(0,M.$EB)(this,o,-1,-1),o.piece.length===0&&c.push(o)}const h=this.w(n);let i=this.T(o,h[h.length-1]);for(let r=h.length-2;r>=0;r--)i=this.T(i,h[r]);this.N(i),this.v(c)}q(n,o){this.Q(n,o)&&(n+=`
`);const c=this.w(n),h=this.S(o,c[0]);let i=h;for(let r=1;r<c.length;r++)i=this.S(i,c[r]);this.N(h)}s(n,o,c){const h=n.piece,i=n.piece.bufferIndex,r=this.a[i].lineStarts,d=r[h.start.line]+h.start.column+o;let v=h.start.line,f=h.end.line,k=0,L=0,p=0;for(;v<=f&&(k=v+(f-v)/2|0,p=r[k],k!==f);)if(L=r[k+1],d<p)f=k-1;else if(d>=L)v=k+1;else break;return c?(c.line=k,c.column=d-p,null):{line:k,column:d-p}}t(n,o,c){if(c.column===0)return c.line-o.line;const h=this.a[n].lineStarts;if(c.line===h.length-1)return c.line-o.line;const i=h[c.line+1],r=h[c.line]+c.column;if(i>r+1)return c.line-o.line;const u=r-1;return this.a[n].buffer.charCodeAt(u)===13?c.line-o.line+1:c.line-o.line}u(n,o){return this.a[n].lineStarts[o.line]+o.column}v(n){for(let o=0;o<n.length;o++)(0,M.$CB)(this,n[o])}w(n){if(n.length>m){const f=[];for(;n.length>m;){const L=n.charCodeAt(m-1);let p;L===13||L>=55296&&L<=56319?(p=n.substring(0,m-1),n=n.substring(m-1)):(p=n.substring(0,m),n=n.substring(m));const y=R(p);f.push(new l(this.a.length,{line:0,column:0},{line:y.length-1,column:p.length-y[y.length-1]},y.length-1,p.length)),this.a.push(new $(p,y))}const k=R(n);return f.push(new l(this.a.length,{line:0,column:0},{line:k.length-1,column:n.length-k[k.length-1]},k.length-1,n.length)),this.a.push(new $(n,k)),f}let o=this.a[0].buffer.length;const c=R(n,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let f=0;f<c.length;f++)c[f]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,o+=1}else{if(o!==0)for(let f=0;f<c.length;f++)c[f]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,r=this.a[0].lineStarts.length-1,u=i-this.a[0].lineStarts[r],d={line:r,column:u},v=new l(0,h,d,this.t(0,h,d),i-o);return this.g=d,[v]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,o=0){let c=this.root,h="";const i=this.h.get2(n);if(i){c=i.node;const r=this.B(c,n-i.nodeStartLineNumber-1),u=this.a[c.piece.bufferIndex].buffer,d=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)h=u.substring(d+r,d+c.piece.length);else{const v=this.B(c,n-i.nodeStartLineNumber);return u.substring(d+r,d+v-o)}}else{let r=0;const u=n;for(;c!==M.$xB;)if(c.left!==M.$xB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const d=this.B(c,n-c.lf_left-2),v=this.B(c,n-c.lf_left-1),f=this.a[c.piece.bufferIndex].buffer,k=this.u(c.piece.bufferIndex,c.piece.start);return r+=c.size_left,this.h.set({node:c,nodeStartOffset:r,nodeStartLineNumber:u-(n-1-c.lf_left)}),f.substring(k+d,k+v-o)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const d=this.B(c,n-c.lf_left-2),v=this.a[c.piece.bufferIndex].buffer,f=this.u(c.piece.bufferIndex,c.piece.start);h=v.substring(f+d,f+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,r+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==M.$xB;){const r=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const u=this.B(c,0),d=this.u(c.piece.bufferIndex,c.piece.start);return h+=r.substring(d,d+u-o),h}else{const u=this.u(c.piece.bufferIndex,c.piece.start);h+=r.substr(u,c.piece.length)}c=c.next()}return h}y(){let n=this.root,o=1,c=0;for(;n!==M.$xB;)o+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=o,this.c=c,this.h.validate(this.c)}A(n,o){const c=n.piece,h=this.s(n,o),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===o){const r=this.t(n.piece.bufferIndex,c.start,h);if(r!==i)return{index:r,remainder:0}}return{index:i,remainder:h.column}}B(n,o){if(o<0)return 0;const c=n.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+o+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),r=o,u=this.u(c.bufferIndex,r),d=this.t(c.bufferIndex,c.start,r),v=d-h,f=u-i,k=c.length+f;n.piece=new l(c.bufferIndex,c.start,r,d,k),(0,M.$EB)(this,n,f,v)}D(n,o){const c=n.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),r=o,u=this.t(c.bufferIndex,r,c.end),d=this.u(c.bufferIndex,r),v=u-h,f=i-d,k=c.length+f;n.piece=new l(c.bufferIndex,r,c.end,u,k),(0,M.$EB)(this,n,f,v)}E(n,o,c){const h=n.piece,i=h.start,r=h.end,u=h.length,d=h.lineFeedCnt,v=o,f=this.t(h.bufferIndex,h.start,v),k=this.u(h.bufferIndex,o)-this.u(h.bufferIndex,i);n.piece=new l(h.bufferIndex,h.start,v,f,k),(0,M.$EB)(this,n,k-u,f-d);const L=new l(h.bufferIndex,c,r,this.t(h.bufferIndex,c,r),this.u(h.bufferIndex,r)-this.u(h.bufferIndex,c)),p=this.S(n,L);this.N(p)}F(n,o){this.Q(o,n)&&(o+=`
`);const c=this.K()&&this.L(o)&&this.M(n),h=this.a[0].buffer.length;this.a[0].buffer+=o;const i=R(o,!1);for(let p=0;p<i.length;p++)i[p]+=h;if(c){const p=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-p}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const r=this.a[0].lineStarts.length-1,u=this.a[0].buffer.length-this.a[0].lineStarts[r],d={line:r,column:u},v=n.piece.length+o.length,f=n.piece.lineFeedCnt,k=this.t(0,n.piece.start,d),L=k-f;n.piece=new l(n.piece.bufferIndex,n.piece.start,d,k,v),this.g=d,(0,M.$EB)(this,n,o.length,L)}G(n){let o=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let h=0;for(;o!==M.$xB;)if(o.size_left>n)o=o.left;else if(o.size_left+o.piece.length>=n){h+=o.size_left;const i={node:o,remainder:n-o.size_left,nodeStartOffset:h};return this.h.set(i),i}else n-=o.size_left+o.piece.length,h+=o.size_left+o.piece.length,o=o.right;return null}H(n,o){let c=this.root,h=0;for(;c!==M.$xB;)if(c.left!==M.$xB&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),r=this.B(c,n-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+o-1,r),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+o-1<=c.piece.length)return{node:c,remainder:i+o-1,nodeStartOffset:h};o-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==M.$xB;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),r=this.J(c);return{node:c,remainder:Math.min(o-1,i),nodeStartOffset:r}}else if(c.piece.length>=o-1){const i=this.J(c);return{node:c,remainder:o-1,nodeStartOffset:i}}else o-=c.piece.length;c=c.next()}return null}I(n,o){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start)+o;return c.buffer.charCodeAt(h)}J(n){if(!n)return 0;let o=n.size_left;for(;n!==this.root;)n.parent.right===n&&(o+=n.parent.size_left+n.parent.piece.length),n=n.parent;return o}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===M.$xB||n.piece.lineFeedCnt===0)return!1;const o=n.piece,c=this.a[o.bufferIndex].lineStarts,h=o.start.line,i=c[h]+o.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===M.$xB||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const o=n.prev();this.M(o)&&this.P(o,n)}}O(n){if(this.K()&&this.M(n)){const o=n.next();this.L(o)&&this.P(n,o)}}P(n,o){const c=[],h=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:h[n.piece.end.line]-h[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const r=n.piece.length-1,u=n.piece.lineFeedCnt-1;n.piece=new l(n.piece.bufferIndex,n.piece.start,i,u,r),(0,M.$EB)(this,n,-1,-1),n.piece.length===0&&c.push(n);const d={line:o.piece.start.line+1,column:0},v=o.piece.length-1,f=this.t(o.piece.bufferIndex,d,o.piece.end);o.piece=new l(o.piece.bufferIndex,d,o.piece.end,f,v),(0,M.$EB)(this,o,-1,-1),o.piece.length===0&&c.push(o);const k=this.w(`\r
`);this.S(n,k[0]);for(let L=0;L<c.length;L++)(0,M.$CB)(this,c[L])}Q(n,o){if(this.K()&&this.M(n)){const c=o.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,M.$CB)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},r=h.length-1,u=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,u,r),(0,M.$EB)(this,c,-1,-1)}return!0}}return!1}iterate(n,o){if(n===M.$xB)return o(M.$xB);const c=this.iterate(n.left,o);return c&&o(n)&&this.iterate(n.right,o)}R(n){if(n===M.$xB)return"";const o=this.a[n.piece.bufferIndex],c=n.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return o.buffer.substring(h,i)}getPieceContent(n){const o=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),h=this.u(n.bufferIndex,n.end);return o.buffer.substring(c,h)}S(n,o){const c=new M.$wB(o,1);if(c.left=M.$xB,c.right=M.$xB,c.parent=M.$xB,c.size_left=0,c.lf_left=0,this.root===M.$xB)this.root=c,c.color=0;else if(n.right===M.$xB)n.right=c,c.parent=n;else{const i=(0,M.$yB)(n.right);i.left=c,c.parent=i}return(0,M.$DB)(this,c),c}T(n,o){const c=new M.$wB(o,1);if(c.left=M.$xB,c.right=M.$xB,c.parent=M.$xB,c.size_left=0,c.lf_left=0,this.root===M.$xB)this.root=c,c.color=0;else if(n.left===M.$xB)n.left=c,c.parent=n;else{const h=(0,M.$zB)(n.left);h.right=c,c.parent=h}return(0,M.$DB)(this,c),c}U(n){let o="";return this.iterate(n,c=>(o+=this.R(c),!0)),o}}e.$QB=s}),define(Pe[131],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$37=e.$27=void 0;class E{constructor(){this.a=new Map}removeDragOperationTransfer(M){if(M&&this.a.has(M)){const A=this.a.get(M);return this.a.delete(M),A}}addDragOperationTransfer(M,A){this.a.set(M,A)}}e.$27=E;class T{constructor(M){this.identifier=M}}e.$37=T}),define(Pe[132],Re([9,10]),function(pe,e){return pe.create("vs/base/common/actions",e)}),define(Pe[133],Re([1,0,5,6,132]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=void 0;class M extends T.$Rc{constructor(l,$="",b="",a=!0,s){super(),this.h=this.B(new E.$Rd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=b,this.w=a,this.C=s}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Ei=M;class A extends T.$Rc{constructor(){super(...arguments),this.f=this.B(new E.$Rd),this.onWillRun=this.f.event,this.m=this.B(new E.$Rd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let b;try{await this.u(l,$)}catch(a){b=a}this.m.fire({action:l,error:b})}async u(l,$){await l.run($)}}e.$Fi=A;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const b of l)b.length&&($.length?$=[...$,new m,...b]:$=b);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Gi=m;class g{get actions(){return this.a}constructor(l,$,b,a){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=a,this.a=b}async run(){}}e.$Hi=g;class w extends M{static{this.ID="vs.actions.empty"}constructor(){super(w.ID,P.localize(0,null),void 0,!1)}}e.$Ii=w;function R(S){return{id:S.id,label:S.label,class:void 0,enabled:S.enabled??!0,checked:S.checked??!1,run:async(...l)=>S.run(...l),tooltip:S.label}}e.$Ji=R}),define(Pe[134],Re([9,10]),function(pe,e){return pe.create("vs/base/common/date",e)}),define(Pe[135],Re([1,0,134]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$om=e.$nm=void 0;const T=60,P=T*60,M=P*24,A=M*7,m=M*30,g=M*365;function w(S,l,$,b){typeof S!="number"&&(S=S.getTime());const a=Math.round((new Date().getTime()-S)/1e3);if(a<-30)return(0,E.localize)(0,null,w(new Date().getTime()+a*1e3,!1));if(!b&&a<30)return(0,E.localize)(1,null);let s;return a<T?(s=a,l?s===1?$?(0,E.localize)(2,null,s):(0,E.localize)(3,null,s):$?(0,E.localize)(4,null,s):(0,E.localize)(5,null,s):s===1?$?(0,E.localize)(6,null,s):(0,E.localize)(7,null,s):$?(0,E.localize)(8,null,s):(0,E.localize)(9,null,s)):a<P?(s=Math.floor(a/T),l?s===1?$?(0,E.localize)(10,null,s):(0,E.localize)(11,null,s):$?(0,E.localize)(12,null,s):(0,E.localize)(13,null,s):s===1?$?(0,E.localize)(14,null,s):(0,E.localize)(15,null,s):$?(0,E.localize)(16,null,s):(0,E.localize)(17,null,s)):a<M?(s=Math.floor(a/P),l?s===1?$?(0,E.localize)(18,null,s):(0,E.localize)(19,null,s):$?(0,E.localize)(20,null,s):(0,E.localize)(21,null,s):s===1?$?(0,E.localize)(22,null,s):(0,E.localize)(23,null,s):$?(0,E.localize)(24,null,s):(0,E.localize)(25,null,s)):a<A?(s=Math.floor(a/M),l?s===1?(0,E.localize)(26,null,s):(0,E.localize)(27,null,s):s===1?(0,E.localize)(28,null,s):(0,E.localize)(29,null,s)):a<m?(s=Math.floor(a/A),l?s===1?$?(0,E.localize)(30,null,s):(0,E.localize)(31,null,s):$?(0,E.localize)(32,null,s):(0,E.localize)(33,null,s):s===1?$?(0,E.localize)(34,null,s):(0,E.localize)(35,null,s):$?(0,E.localize)(36,null,s):(0,E.localize)(37,null,s)):a<g?(s=Math.floor(a/m),l?s===1?$?(0,E.localize)(38,null,s):(0,E.localize)(39,null,s):$?(0,E.localize)(40,null,s):(0,E.localize)(41,null,s):s===1?$?(0,E.localize)(42,null,s):(0,E.localize)(43,null,s):$?(0,E.localize)(44,null,s):(0,E.localize)(45,null,s)):(s=Math.floor(a/g),l?s===1?$?(0,E.localize)(46,null,s):(0,E.localize)(47,null,s):$?(0,E.localize)(48,null,s):(0,E.localize)(49,null,s):s===1?$?(0,E.localize)(50,null,s):(0,E.localize)(51,null,s):$?(0,E.localize)(52,null,s):(0,E.localize)(53,null,s))}e.$nm=w;function R(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$om=R}),define(Pe[136],Re([9,10]),function(pe,e){return pe.create("vs/base/common/errorMessage",e)}),define(Pe[40],Re([1,0,18,16,136]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mi=e.$Li=e.$Ki=void 0;function M(S,l){return l&&(S.stack||S.stacktrace)?P.localize(0,null,m(S),A(S.stack)||A(S.stacktrace)):m(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function m(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?P.localize(1,null,S.message):S.message||P.localize(2,null)}function g(S=null,l=!1){if(!S)return P.localize(3,null);if(Array.isArray(S)){const $=E.$Gb(S),b=g($[0],l);return $.length>1?P.localize(4,null,b,$.length):b}if(T.$Cf(S))return S;if(S.detail){const $=S.detail;if($.error)return M($.error,l);if($.exception)return M($.exception,l)}return S.stack?M(S,l):S.message?S.message:P.localize(5,null)}e.$Ki=g;function w(S){const l=S;return l instanceof Error&&Array.isArray(l.actions)}e.$Li=w;function R(S,l){let $;return typeof S=="string"?$=new Error(S):$=S,$.actions=l,$}e.$Mi=R}),define(Pe[137],Re([1,0,39,20]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=e.$Bq=e.$Aq=e.$zq=e.$yq=e.$xq=e.$wq=e.$vq=e.$uq=e.$tq=e.$sq=e.$rq=void 0;const P=new E.$U(()=>{const L=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:L,collatorIsNumeric:L.resolvedOptions().numeric}}),M=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new E.$U(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(L,p,y=!1){const D=L||"",N=p||"",q=P.value.collator.compare(D,N);return P.value.collatorIsNumeric&&q===0&&D!==N?D<N?-1:1:q}e.$rq=m;function g(L,p){const y=M.value.collator;return L=L||"",p=p||"",c(y,L,p)}e.$sq=g;function w(L,p){const y=M.value.collator;return L=L||"",p=p||"",u(L,p)||c(y,L,p)}e.$tq=w;function R(L,p){const y=M.value.collator;return L=L||"",p=p||"",r(L,p)||c(y,L,p)}e.$uq=R;function S(L,p){return L=L||"",p=p||"",L===p?0:L<p?-1:1}e.$vq=S;function l(L,p){const[y,D]=n(L),[N,q]=n(p);let V=P.value.collator.compare(D,q);if(V===0){if(P.value.collatorIsNumeric&&D!==q)return D<q?-1:1;if(V=P.value.collator.compare(y,N),P.value.collatorIsNumeric&&V===0&&y!==N)return y<N?-1:1}return V}e.$wq=l;function $(L,p){L=L||"",p=p||"";const y=o(L),D=o(p),N=M.value.collator,q=A.value.collator;return c(q,y,D)||c(N,L,p)}e.$xq=$;function b(L,p){L=L||"",p=p||"";const y=o(L),D=o(p),N=M.value.collator,q=A.value.collator;return c(q,y,D)||u(L,p)||c(N,L,p)}e.$yq=b;function a(L,p){L=L||"",p=p||"";const y=o(L),D=o(p),N=M.value.collator,q=A.value.collator;return c(q,y,D)||r(L,p)||c(N,L,p)}e.$zq=a;function s(L,p){L=L||"",p=p||"";const y=o(L).toLowerCase(),D=o(p).toLowerCase();return y!==D?y<D?-1:1:L!==p?L<p?-1:1:0}e.$Aq=s;const t=/^(.*?)(\.([^.]*))?$/;function n(L,p=!1){const y=L?t.exec(L):[];let D=[y&&y[1]||"",y&&y[3]||""];return p&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function o(L){const p=L?t.exec(L):[];return p&&p[1]&&p[1].charAt(0)!=="."&&p[3]||""}function c(L,p,y){const D=L.compare(p,y);return D!==0?D:p.length!==y.length?p.length<y.length?-1:1:0}function h(L){const p=L.charAt(0);return p.toLocaleUpperCase()!==p}function i(L){const p=L.charAt(0);return p.toLocaleLowerCase()!==p}function r(L,p){return h(L)&&i(p)?-1:i(L)&&h(p)?1:0}function u(L,p){return i(L)&&h(p)?-1:h(L)&&i(p)?1:0}function d(L,p,y=!1){return y||(L=L&&L.toLowerCase(),p=p&&p.toLowerCase()),L===p?0:L<p?-1:1}function v(L,p,y=!1){const D=L.split(T.sep),N=p.split(T.sep),q=D.length-1,V=N.length-1;let U,F;for(let C=0;;C++){if(U=q===C,F=V===C,U&&F)return m(D[C],N[C],y);if(U)return-1;if(F)return 1;const I=d(D[C],N[C],y);if(I!==0)return I}}e.$Bq=v;function f(L,p,y){const D=L.toLowerCase(),N=p.toLowerCase(),q=k(L,p,y);if(q)return q;const V=D.endsWith(y),U=N.endsWith(y);if(V!==U)return V?-1:1;const F=m(D,N);return F!==0?F:D.localeCompare(N)}e.$Cq=f;function k(L,p,y){const D=L.toLowerCase(),N=p.toLowerCase(),q=D.startsWith(y),V=N.startsWith(y);if(q!==V)return q?-1:1;if(q&&V){if(D.length<N.length)return-1;if(D.length>N.length)return 1}return 0}e.$Dq=k}),define(Pe[46],Re([1,0,20,21,12,16]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=void 0;function A(f){return f===47||f===92}e.$Uf=A;function m(f){return f.replace(/[\\/]/g,E.$fc.sep)}e.$Vf=m;function g(f){return f.indexOf("/")===-1&&(f=m(f)),/^[a-zA-Z]:(\/|$)/.test(f)&&(f="/"+f),f}e.$Wf=g;function w(f,k=E.$fc.sep){if(!f)return"";const L=f.length,p=f.charCodeAt(0);if(A(p)){if(A(f.charCodeAt(1))&&!A(f.charCodeAt(2))){let D=3;const N=D;for(;D<L&&!A(f.charCodeAt(D));D++);if(N!==D&&!A(f.charCodeAt(D+1))){for(D+=1;D<L;D++)if(A(f.charCodeAt(D)))return f.slice(0,D+1).replace(/[\\/]/g,k)}}return k}else if(t(p)&&f.charCodeAt(1)===58)return A(f.charCodeAt(2))?f.slice(0,2)+k:f.slice(0,2);let y=f.indexOf("://");if(y!==-1){for(y+=3;y<L;y++)if(A(f.charCodeAt(y)))return f.slice(0,y+1)}return""}e.$Xf=w;function R(f){if(!T.$i||!f||f.length<5)return!1;let k=f.charCodeAt(0);if(k!==92||(k=f.charCodeAt(1),k!==92))return!1;let L=2;const p=L;for(;L<f.length&&(k=f.charCodeAt(L),k!==92);L++);return!(p===L||(k=f.charCodeAt(L+1),isNaN(k)||k===92))}e.$Yf=R;const S=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function b(f,k=T.$i){const L=k?S:l;return!(!f||f.length===0||/^\s+$/.test(f)||(L.lastIndex=0,L.test(f))||k&&$.test(f)||f==="."||f===".."||k&&f[f.length-1]==="."||k&&f.length!==f.trim().length||f.length>255)}e.$Zf=b;function a(f,k,L){const p=f===k;return!L||p?p:!f||!k?!1:(0,P.$6e)(f,k)}e.$1f=a;function s(f,k,L,p=E.sep){if(f===k)return!0;if(!f||!k||k.length>f.length)return!1;if(L){if(!(0,P.$7e)(f,k))return!1;if(k.length===f.length)return!0;let D=k.length;return k.charAt(k.length-1)===p&&D--,f.charAt(D)===p}return k.charAt(k.length-1)!==p&&(k+=p),f.indexOf(k)===0}e.$2f=s;function t(f){return f>=65&&f<=90||f>=97&&f<=122}e.$3f=t;function n(f,k){return T.$i&&f.endsWith(":")&&(f+=E.sep),(0,E.$hc)(f)||(f=(0,E.$ic)(k,f)),f=(0,E.$gc)(f),T.$i?(f=(0,P.$Oe)(f,E.sep),f.endsWith(":")&&(f+=E.sep)):(f=(0,P.$Oe)(f,E.sep),f||(f=E.sep)),f}e.$4f=n;function o(f){const k=(0,E.$gc)(f);return T.$i?f.length>3?!1:c(k)&&(f.length===2||k.charCodeAt(2)===92):k===E.$fc.sep}e.$5f=o;function c(f,k=T.$i){return k?t(f.charCodeAt(0))&&f.charCodeAt(1)===58:!1}e.$6f=c;function h(f,k=T.$i){return c(f,k)?f[0]:void 0}e.$7f=h;function i(f,k,L){return k.length>f.length?-1:f===k?0:(L&&(f=f.toLowerCase(),k=k.toLowerCase()),f.indexOf(k))}e.$8f=i;function r(f){const k=f.split(":");let L,p,y;for(const D of k){const N=Number(D);(0,M.$Gf)(N)?p===void 0?p=N:y===void 0&&(y=N):L=L?[L,D].join(":"):D}if(!L)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:L,line:p!==void 0?p:void 0,column:y!==void 0?y:p!==void 0?1:void 0}}e.$9f=r;const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function v(f,k,L=8){let p="";for(let D=0;D<L;D++){let N;D===0&&T.$i&&!k&&(L===3||L===4)?N=d:N=u,p+=N.charAt(Math.floor(Math.random()*N.length))}let y;return k?y=`${k}-${p}`:y=p,f?(0,E.$ic)(f,y):y}e.$0f=v}),define(Pe[68],Re([1,0,20]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4r=e.$3r=e.$2r=e.$1r=e.$Zr=void 0,e.$Zr=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const T={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(R){const S=(0,E.$nc)(R),l=T[S.toLowerCase()];return l!==void 0?l:A(R)}e.$1r=M;function A(R){const S=(0,E.$nc)(R);return P[S.toLowerCase()]}e.$2r=A;function m(R){for(const S in P)if(P[S]===R)return S}e.$3r=m;const g=/^(.+)\/(.+?)(;.+)?$/;function w(R,S){const l=g.exec(R);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:S?void 0:R}e.$4r=w}),define(Pe[51],Re([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=void 0;function P(g){return JSON.stringify(g,A)}e.$uh=P;function M(g){let w=JSON.parse(g);return w=m(w),w}e.$vh=M;function A(g,w){return w instanceof RegExp?{$mid:2,source:w.source,flags:w.flags}:w}function m(g,w=0){if(!g||w>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return T.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof E.$fe||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let R=0;R<g.length;++R)g[R]=m(g[R],w+1);else for(const R in g)Object.hasOwnProperty.call(g,R)&&(g[R]=m(g[R],w+1))}return g}e.$wh=m}),define(Pe[13],Re([1,0,11,21,12,2]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.Schemas=void 0;var A;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(A||(e.Schemas=A={}));function m(l,$){return M.URI.isUri(l)?(0,P.$6e)(l.scheme,$):(0,P.$7e)(l,$+":")}e.$$f=m;function g(l,...$){return $.some(b=>m(l,b))}e.$_f=g,e.$ag="vscode-tkn",e.$bg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${A.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${A.vscodeRemoteResource}`}set($,b,a){this.a[$]=b,this.b[$]=a}setConnectionToken($,b){this.c[$]=b}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return E.$Z(o),$}const b=$.authority;let a=this.a[b];a&&a.indexOf(":")!==-1&&a.indexOf("[")===-1&&(a=`[${a}]`);const s=this.b[b],t=this.c[b];let n=`path=${encodeURIComponent($.path)}`;return typeof t=="string"&&(n+=`&${e.$bg}=${encodeURIComponent(t)}`),M.URI.from({scheme:T.$o?this.d:A.vscodeRemoteResource,authority:`${a}:${s}`,path:this.f,query:n})}}e.$cg=new w,e.$dg="vs/../../extensions",e.$eg="vs/../../node_modules",e.$fg="vs/../../node_modules.asar",e.$gg="vs/../../node_modules.asar.unpacked",e.$hg="vscode-app";class R{static{this.a=e.$hg}asBrowserUri($){const b=this.b($,pe);return this.uriToBrowserUri(b)}uriToBrowserUri($){return $.scheme===A.vscodeRemote?e.$cg.rewrite($):$.scheme===A.file&&(T.$m||T.$q===`${A.vscodeFileResource}://${R.a}`)?$.with({scheme:A.vscodeFileResource,authority:$.authority||R.a,query:null,fragment:null}):$}asFileUri($){const b=this.b($,pe);return this.uriToFileUri(b)}uriToFileUri($){return $.scheme===A.vscodeFileResource?$.with({scheme:A.file,authority:$.authority!==R.a?$.authority:null,query:null,fragment:null}):$}b($,b){return M.URI.isUri($)?$:M.URI.parse(b.toUrl($))}}e.$ig=new R;var S;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const b="vscode-coi";function a(t){let n;typeof t=="string"?n=new URL(t).searchParams:t instanceof URL?n=t.searchParams:M.URI.isUri(t)&&(n=new URL(t.toString(!0)).searchParams);const o=n?.get(b);if(o)return $.get(o)}l.getHeadersFromQuery=a;function s(t,n,o){if(!globalThis.crossOriginIsolated)return;const c=n&&o?"3":o?"2":"1";t instanceof URLSearchParams?t.set(b,c):t[b]=c}l.addSearchParam=s})(S||(e.COI=S={}))}),define(Pe[25],Re([1,0,46,13,20,21,12,2]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lg=e.DataUri=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=e.$ug=e.$tg=e.$sg=e.$rg=e.$qg=e.$pg=void 0;function g($){return(0,m.$vc)($,!0)}e.$pg=g;class w{constructor(b){this.a=b}compare(b,a,s=!1){return b===a?0:(0,A.$Ye)(this.getComparisonKey(b,s),this.getComparisonKey(a,s))}isEqual(b,a,s=!1){return b===a?!0:!b||!a?!1:this.getComparisonKey(b,s)===this.getComparisonKey(a,s)}getComparisonKey(b,a=!1){return b.with({path:this.a(b)?b.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(b){return this.a(b)}isEqualOrParent(b,a,s=!1){if(b.scheme===a.scheme){if(b.scheme===T.Schemas.file)return E.$2f(g(b),g(a),this.a(b))&&b.query===a.query&&(s||b.fragment===a.fragment);if((0,e.$Gg)(b.authority,a.authority))return E.$2f(b.path,a.path,this.a(b),"/")&&b.query===a.query&&(s||b.fragment===a.fragment)}return!1}joinPath(b,...a){return m.URI.joinPath(b,...a)}basenameOrAuthority(b){return(0,e.$yg)(b)||b.authority}basename(b){return P.$fc.basename(b.path)}extname(b){return P.$fc.extname(b.path)}dirname(b){if(b.path.length===0)return b;let a;return b.scheme===T.Schemas.file?a=m.URI.file(P.$lc(g(b))).path:(a=P.$fc.dirname(b.path),b.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${b.toString})) resulted in a relative path`),a="/")),b.with({path:a})}normalizePath(b){if(!b.path.length)return b;let a;return b.scheme===T.Schemas.file?a=m.URI.file(P.$gc(g(b))).path:a=P.$fc.normalize(b.path),b.with({path:a})}relativePath(b,a){if(b.scheme!==a.scheme||!(0,e.$Gg)(b.authority,a.authority))return;if(b.scheme===T.Schemas.file){const n=P.$kc(g(b),g(a));return M.$i?E.$Vf(n):n}let s=b.path||"/";const t=a.path||"/";if(this.a(b)){let n=0;for(const o=Math.min(s.length,t.length);n<o&&!(s.charCodeAt(n)!==t.charCodeAt(n)&&s.charAt(n).toLowerCase()!==t.charAt(n).toLowerCase());n++);s=t.substr(0,n)+s.substr(n)}return P.$fc.relative(s,t)}resolvePath(b,a){if(b.scheme===T.Schemas.file){const s=m.URI.file(P.$jc(g(b),a));return b.with({authority:s.authority,path:s.path})}return a=E.$Wf(a),b.with({path:P.$fc.resolve(b.path,a)})}isAbsolutePath(b){return!!b.path&&b.path[0]==="/"}isEqualAuthority(b,a){return b===a||b!==void 0&&a!==void 0&&(0,A.$6e)(b,a)}hasTrailingPathSeparator(b,a=P.sep){if(b.scheme===T.Schemas.file){const s=g(b);return s.length>E.$Xf(s).length&&s[s.length-1]===a}else{const s=b.path;return s.length>1&&s.charCodeAt(s.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(b.fsPath)}}removeTrailingPathSeparator(b,a=P.sep){return(0,e.$Hg)(b,a)?b.with({path:b.path.substr(0,b.path.length-1)}):b}addTrailingPathSeparator(b,a=P.sep){let s=!1;if(b.scheme===T.Schemas.file){const t=g(b);s=t!==void 0&&t.length===E.$Xf(t).length&&t[t.length-1]===a}else{a="/";const t=b.path;s=t.length===1&&t.charCodeAt(t.length-1)===47}return!s&&!(0,e.$Hg)(b,a)?b.with({path:b.path+"/"}):b}}e.$qg=w,e.$rg=new w(()=>!1),e.$sg=new w($=>$.scheme===T.Schemas.file?!M.$k:!0),e.$tg=new w($=>!0),e.$ug=e.$rg.isEqual.bind(e.$rg),e.$vg=e.$rg.isEqualOrParent.bind(e.$rg),e.$wg=e.$rg.getComparisonKey.bind(e.$rg),e.$xg=e.$rg.basenameOrAuthority.bind(e.$rg),e.$yg=e.$rg.basename.bind(e.$rg),e.$zg=e.$rg.extname.bind(e.$rg),e.$Ag=e.$rg.dirname.bind(e.$rg),e.$Bg=e.$rg.joinPath.bind(e.$rg),e.$Cg=e.$rg.normalizePath.bind(e.$rg),e.$Dg=e.$rg.relativePath.bind(e.$rg),e.$Eg=e.$rg.resolvePath.bind(e.$rg),e.$Fg=e.$rg.isAbsolutePath.bind(e.$rg),e.$Gg=e.$rg.isEqualAuthority.bind(e.$rg),e.$Hg=e.$rg.hasTrailingPathSeparator.bind(e.$rg),e.$Ig=e.$rg.removeTrailingPathSeparator.bind(e.$rg),e.$Jg=e.$rg.addTrailingPathSeparator.bind(e.$rg);function R($,b){const a=[];for(let s=0;s<$.length;s++){const t=b($[s]);$.some((n,o)=>o===s?!1:(0,e.$vg)(t,b(n)))||a.push($[s])}return a}e.$Kg=R;var S;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function b(a){const s=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,h]=o.split(":");c&&h&&s.set(c,h)});const n=a.path.substring(0,a.path.indexOf(";"));return n&&s.set($.META_DATA_MIME,n),s}$.parseMetaData=b})(S||(e.DataUri=S={}));function l($,b,a){if(b){let s=$.path;return s&&s[0]!==P.$fc.sep&&(s=P.$fc.sep+s),$.with({scheme:a,authority:b,path:s})}return $.with({scheme:a})}e.$Lg=l}),define(Pe[14],Re([1,0,19,11,5,6,25,21,124,39]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.Promises=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=void 0;function R(le){return!!le&&typeof le.then=="function"}e.$Mg=R;function S(le){const ie=new E.$2d,G=le(ie.token),te=new Promise((x,se)=>{const fe=ie.token.onCancellationRequested(()=>{fe.dispose(),ie.dispose(),se(new T.$4)});Promise.resolve(G).then(Se=>{fe.dispose(),ie.dispose(),x(Se)},Se=>{fe.dispose(),ie.dispose(),se(Se)})});return new class{cancel(){ie.cancel()}then(x,se){return te.then(x,se)}catch(x){return this.then(void 0,x)}finally(x){return te.finally(x)}}}e.$Ng=S;function l(le,ie,G){return new Promise((te,x)=>{const se=ie.onCancellationRequested(()=>{se.dispose(),te(G)});le.then(te,x).finally(()=>se.dispose())})}e.$Og=l;function $(le,ie){return new Promise((G,te)=>{const x=ie.onCancellationRequested(()=>{x.dispose(),te(new T.$4)});le.then(G,te).finally(()=>x.dispose())})}e.$Pg=$;async function b(le){let ie=-1;const G=le.map((te,x)=>te.then(se=>(ie=x,se)));try{return await Promise.race(G)}finally{le.forEach((te,x)=>{x!==ie&&te.cancel()})}}e.$Qg=b;function a(le,ie,G){let te;const x=setTimeout(()=>{te?.(void 0),G?.()},ie);return Promise.race([le.finally(()=>clearTimeout(x)),new Promise(se=>te=se)])}e.$Rg=a;function s(le){return new Promise((ie,G)=>{const te=le();R(te)?te.then(ie,G):ie(te)})}e.$Sg=s;class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ie){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ie,!this.b){const G=()=>{if(this.b=null,this.f)return;const te=this.queue(this.d);return this.d=null,te};this.b=new Promise(te=>{this.a.then(G,G).then(te)})}return new Promise((G,te)=>{this.b.then(G,te)})}return this.a=ie(),new Promise((G,te)=>{this.a.then(x=>{this.a=null,G(x)},x=>{this.a=null,te(x)})})}dispose(){this.f=!0}}e.$Tg=t;class n{constructor(){this.a=Promise.resolve(null)}queue(ie){return this.a=this.a.then(()=>ie(),()=>ie())}}e.$Ug=n;class o{constructor(){this.a=new Map}queue(ie,G){const x=(this.a.get(ie)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ie)===x&&this.a.delete(ie)});return this.a.set(ie,x),x}}e.$Vg=o;const c=(le,ie)=>{let G=!0;const te=setTimeout(()=>{G=!1,ie()},le);return{isTriggered:()=>G,dispose:()=>{clearTimeout(te),G=!1}}},h=le=>{let ie=!0;return queueMicrotask(()=>{ie&&(ie=!1,le())}),{isTriggered:()=>ie,dispose:()=>{ie=!1}}};class i{constructor(ie){this.defaultDelay=ie,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ie,G=this.defaultDelay){this.g=ie,this.h(),this.b||(this.b=new Promise((x,se)=>{this.d=x,this.f=se}).then(()=>{if(this.b=null,this.d=null,this.g){const x=this.g;return this.g=null,x()}}));const te=()=>{this.a=null,this.d?.(null)};return this.a=G===g.$Od?h(te):c(G,te),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new T.$4),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$Wg=i;class r{constructor(ie){this.a=new i(ie),this.b=new t}trigger(ie,G){return this.a.trigger(()=>this.b.queue(ie),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$Xg=r;class u{constructor(){this.a=!1,this.b=new Promise((ie,G)=>{this.d=ie})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$Yg=u;class d extends u{constructor(ie){super(),this.f=setTimeout(()=>this.open(),ie)}open(){clearTimeout(this.f),super.open()}}e.$Zg=d;function v(le,ie){return ie?new Promise((G,te)=>{const x=setTimeout(()=>{se.dispose(),G()},le),se=ie.onCancellationRequested(()=>{clearTimeout(x),se.dispose(),te(new T.$4)})}):S(G=>v(le,G))}e.$1g=v;function f(le,ie=0,G){const te=setTimeout(()=>{le(),G&&x.dispose()},ie),x=(0,M.$Pc)(()=>{clearTimeout(te),G?.deleteAndLeak(x)});return G?.add(x),x}e.$2g=f;function k(le){const ie=[];let G=0;const te=le.length;function x(){return G<te?le[G++]():null}function se(fe){fe!=null&&ie.push(fe);const Se=x();return Se?Se.then(se):Promise.resolve(ie)}return Promise.resolve(null).then(se)}e.$3g=k;function L(le,ie=te=>!!te,G=null){let te=0;const x=le.length,se=()=>{if(te>=x)return Promise.resolve(G);const fe=le[te++];return Promise.resolve(fe()).then(Fe=>ie(Fe)?Promise.resolve(Fe):se())};return se()}e.$4g=L;function p(le,ie=te=>!!te,G=null){if(le.length===0)return Promise.resolve(G);let te=le.length;const x=()=>{te=-1;for(const se of le)se.cancel?.()};return new Promise((se,fe)=>{for(const Se of le)Se.then(Fe=>{--te>=0&&ie(Fe)?(x(),se(Fe)):te===0&&se(G)}).catch(Fe=>{--te>=0&&(x(),fe(Fe))})})}e.$5g=p;class y{constructor(ie){this.a=0,this.d=ie,this.f=[],this.b=0,this.g=new P.$Rd}get onDrained(){return this.g.event}get size(){return this.a}queue(ie){return this.a++,new Promise((G,te)=>{this.f.push({factory:ie,c:G,e:te}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ie=this.f.shift();this.b++;const G=ie.factory();G.then(ie.c,ie.e),G.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.$6g=y;class D extends y{constructor(){super(1)}}e.$7g=D;class N{constructor(){this.a=new we,this.b=0}queue(ie){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ie())):this.a.run(this.b++,ie())}}e.$8g=N;class q{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ie=new ne;return this.b.add(ie),ie.p}g(){for(const[,ie]of this.a)if(ie.size>0)return!1;return!0}queueFor(ie,G=A.$rg){const te=G.getComparisonKey(ie);let x=this.a.get(te);if(!x){x=new D;const se=this.f++,fe=P.Event.once(x.onDrained)(()=>{x?.dispose(),this.a.delete(te),this.h(),this.d?.deleteAndDispose(se),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new M.$1c),this.d.set(se,fe),this.a.set(te,x)}return x}h(){this.g()&&this.j()}j(){for(const ie of this.b)ie.complete();this.b.clear()}dispose(){for(const[,ie]of this.a)ie.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$9g=q;class V{constructor(ie,G){this.a=-1,typeof ie=="function"&&typeof G=="number"&&this.setIfNotSet(ie,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ie,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ie()},G)}setIfNotSet(ie,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ie()},G))}}e.$0g=V;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ie,G,te=globalThis){this.cancel();const x=te.setInterval(()=>{ie()},G);this.d=(0,M.$Pc)(()=>{te.clearInterval(x),this.d=void 0})}dispose(){this.cancel()}}e.$$g=U;class F{constructor(ie,G){this.b=-1,this.a=ie,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ie=this.d){this.cancel(),this.b=setTimeout(this.f,ie)}get delay(){return this.d}set delay(ie){this.d=ie}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$_g=F;class C{constructor(ie,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ie,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ie=this.b){ie%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ie}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ie/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ah=C;class I extends F{constructor(ie,G){super(ie,G),this.j=[]}work(ie){this.j.push(ie),this.isScheduled()||this.schedule()}h(){const ie=this.j;this.j=[],this.a?.(ie)}dispose(){this.j=[],super.dispose()}}e.$bh=I;class X extends M.$Rc{constructor(ie,G){super(),this.g=ie,this.h=G,this.a=[],this.b=this.B(new M.$Sc),this.f=!1}get pending(){return this.a.length}work(ie){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ie.length>this.g.maxBufferedWork)return!1}else if(this.pending+ie.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ie)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new F(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ch=X,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$eh=(le,ie)=>{(0,m.$B)(()=>{if(G)return;const te=Date.now()+15;ie(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,te-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$eh=(le,ie,G)=>{const te=le.requestIdleCallback(ie,typeof G=="number"?{timeout:G}:void 0);let x=!1;return{dispose(){x||(x=!0,le.cancelIdleCallback(te))}}},e.$dh=le=>(0,e.$eh)(globalThis,le)}();class ue{constructor(ie,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(te){this.l=te}finally{this.g=!0}},this.f=(0,e.$eh)(ie,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$fh=ue;class he extends ue{constructor(ie){super(globalThis,ie)}}e.$gh=he;async function be(le,ie,G){let te;for(let x=0;x<G;x++)try{return await le()}catch(se){te=se,await v(ie)}throw te}e.$hh=be;class we{isRunning(ie){return typeof ie=="number"?this.a?.taskId===ie:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ie,G,te){return this.a={taskId:ie,cancel:()=>te?.(),promise:G},G.then(()=>this.d(ie),()=>this.d(ie)),G}d(ie){this.a&&ie===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ie=this.b;this.b=void 0,ie.run().then(ie.promiseResolve,ie.promiseReject)}}queue(ie){if(this.b)this.b.run=ie;else{let G,te;const x=new Promise((se,fe)=>{G=se,te=fe});this.b={run:ie,promise:x,promiseResolve:G,promiseReject:te}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$ih=we;class ge{constructor(ie,G=()=>Date.now()){this.d=ie,this.f=G,this.a=0,this.b=0}increment(){const ie=this.f();return ie-this.a>this.d&&(this.a=ie,this.b=0),this.b++,this.b}}e.$jh=ge;var me;(function(le){le[le.Resolved=0]="Resolved",le[le.Rejected=1]="Rejected"})(me||(me={}));class ne{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ie,G)=>{this.a=ie,this.b=G})}complete(ie){return new Promise(G=>{this.a(ie),this.d={outcome:0,value:ie},G()})}error(ie){return new Promise(G=>{this.b(ie),this.d={outcome:1,value:ie},G()})}cancel(){return this.error(new T.$4)}}e.$kh=ne;var ke;(function(le){async function ie(te){let x;const se=await Promise.all(te.map(fe=>fe.then(Se=>Se,Se=>{x||(x=Se)})));if(typeof x<"u")throw x;return se}le.settled=ie;function G(te){return new Promise(async(x,se)=>{try{await te(x,se)}catch(fe){se(fe)}})}le.withAsyncBody=G})(ke||(e.Promises=ke={}));class ce{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ie){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ie.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new T.$bb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$lh=ce;class Y{constructor(ie){this.b=ie,this.a=new w.$U(()=>new ce(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}}e.$mh=Y;var W;(function(le){le[le.Initial=0]="Initial",le[le.DoneOK=1]="DoneOK",le[le.DoneError=2]="DoneError"})(W||(W={}));class re{static fromArray(ie){return new re(G=>{G.emitMany(ie)})}static fromPromise(ie){return new re(async G=>{G.emitMany(await ie)})}static fromPromises(ie){return new re(async G=>{await Promise.all(ie.map(async te=>G.emitOne(await te)))})}static merge(ie){return new re(async G=>{await Promise.all(ie.map(async te=>{for await(const x of te)G.emitOne(x)}))})}static{this.EMPTY=re.fromArray([])}constructor(ie){this.a=0,this.b=[],this.d=null,this.f=new P.$Rd,queueMicrotask(async()=>{const G={emitOne:te=>this.g(te),emitMany:te=>this.h(te),reject:te=>this.k(te)};try{await Promise.resolve(ie(G)),this.j()}catch(te){this.k(te)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ie=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ie<this.b.length)return{done:!1,value:this.b[ie++]};if(this.a===1)return{done:!0,value:void 0};await P.Event.toPromise(this.f.event)}while(!0)}}}static map(ie,G){return new re(async te=>{for await(const x of ie)te.emitOne(G(x))})}map(ie){return re.map(this,ie)}static filter(ie,G){return new re(async te=>{for await(const x of ie)G(x)&&te.emitOne(x)})}filter(ie){return re.filter(this,ie)}static coalesce(ie){return re.filter(ie,G=>!!G)}coalesce(){return re.coalesce(this)}static async toPromise(ie){const G=[];for await(const te of ie)G.push(te);return G}toPromise(){return re.toPromise(this)}g(ie){this.a===0&&(this.b.push(ie),this.f.fire())}h(ie){this.a===0&&(this.b=this.b.concat(ie),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ie){this.a===0&&(this.a=2,this.d=ie,this.f.fire())}}e.$nh=re;class Ie extends re{constructor(ie,G){super(G),this.l=ie}cancel(){this.l.cancel()}}e.$oh=Ie;function Ae(le){const ie=new E.$2d,G=le(ie.token);return new Ie(ie,async te=>{const x=ie.token.onCancellationRequested(()=>{x.dispose(),ie.dispose(),te.reject(new T.$4)});try{for await(const se of G){if(ie.token.isCancellationRequested)return;te.emitOne(se)}x.dispose(),ie.dispose()}catch(se){x.dispose(),ie.dispose(),te.reject(se)}})}e.$ph=Ae;class Ce{constructor(){this.a=new ne,this.b=new re(te=>{if(ie){te.reject(ie);return}return G&&te.emitMany(G),this.d=x=>te.reject(x),this.f=x=>te.emitOne(x),this.a.p});let ie,G;this.f=te=>{G||(G=[]),G.push(te)},this.d=te=>{ie||(ie=te)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ie){this.d(ie),this.a.complete()}emitOne(ie){this.f(ie)}}e.$qh=Ce}),define(Pe[34],Re([1,0,18,14,46,28,20,21,12]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=void 0;function w(){return Object.create(null)}e.$Bj=w,e.$Cj="**",e.$Dj="/";const R="[/\\\\]",S="[^/\\\\]",l=/\//g;function $(he,be){switch(he){case 0:return"";case 1:return`${S}*?`;default:return`(?:${R}|${S}+${R}${be?`|${R}${S}+`:""})*?`}}function b(he,be){if(!he)return[];const we=[];let ge=!1,me=!1,ne="";for(const ke of he){switch(ke){case be:if(!ge&&!me){we.push(ne),ne="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":me=!0;break;case"]":me=!1;break}ne+=ke}return ne&&we.push(ne),we}e.$Ej=b;function a(he){if(!he)return"";let be="";const we=b(he,e.$Dj);if(we.every(ge=>ge===e.$Cj))be=".*";else{let ge=!1;we.forEach((me,ne)=>{if(me===e.$Cj){if(ge)return;be+=$(2,ne===we.length-1)}else{let ke=!1,ce="",Y=!1,W="";for(const re of me){if(re!=="}"&&ke){ce+=re;continue}if(Y&&(re!=="]"||!W)){let Ie;re==="-"?Ie=re:(re==="^"||re==="!")&&!W?Ie="^":re===e.$Dj?Ie="":Ie=(0,g.$Je)(re),W+=Ie;continue}switch(re){case"{":ke=!0;continue;case"[":Y=!0;continue;case"}":{const Ae=`(?:${b(ce,",").map(Ce=>a(Ce)).join("|")})`;be+=Ae,ke=!1,ce="";break}case"]":{be+="["+W+"]",Y=!1,W="";break}case"?":be+=S;continue;case"*":be+=$(1);continue;default:be+=(0,g.$Je)(re)}}ne<we.length-1&&(we[ne+1]!==e.$Cj||ne+2<we.length)&&(be+=R)}ge=me===e.$Cj})}return be}const s=/^\*\*\/\*\.[\w\.-]+$/,t=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new M.$Cc(1e4),r=function(){return!1},u=function(){return null};function d(he,be){if(!he)return u;let we;typeof he!="string"?we=he.pattern:we=he,we=we.trim();const ge=`${we}_${!!be.trimForExclusions}`;let me=i.get(ge);if(me)return v(me,he);let ne;return s.test(we)?me=k(we.substr(4),we):(ne=t.exec(f(we,be)))?me=L(ne[1],we):(be.trimForExclusions?o:n).test(we)?me=p(we,be):(ne=c.exec(f(we,be)))?me=y(ne[1].substr(1),we,!0):(ne=h.exec(f(we,be)))?me=y(ne[1],we,!1):me=D(we),i.set(ge,me),v(me,he)}function v(he,be){if(typeof be=="string")return he;const we=function(ge,me){return(0,P.$2f)(ge,be.base,!m.$k)?he((0,g.$Ne)(ge.substr(be.base.length),A.sep),me):null};return we.allBasenames=he.allBasenames,we.allPaths=he.allPaths,we.basenames=he.basenames,we.patterns=he.patterns,we}function f(he,be){return be.trimForExclusions&&he.endsWith("/**")?he.substr(0,he.length-2):he}function k(he,be){return function(we,ge){return typeof we=="string"&&we.endsWith(he)?be:null}}function L(he,be){const we=`/${he}`,ge=`\\${he}`,me=function(ke,ce){return typeof ke!="string"?null:ce?ce===he?be:null:ke===he||ke.endsWith(we)||ke.endsWith(ge)?be:null},ne=[he];return me.basenames=ne,me.patterns=[be],me.allBasenames=ne,me}function p(he,be){const we=X(he.slice(1,-1).split(",").map(ce=>d(ce,be)).filter(ce=>ce!==u),he),ge=we.length;if(!ge)return u;if(ge===1)return we[0];const me=function(ce,Y){for(let W=0,re=we.length;W<re;W++)if(we[W](ce,Y))return he;return null},ne=we.find(ce=>!!ce.allBasenames);ne&&(me.allBasenames=ne.allBasenames);const ke=we.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return ke.length&&(me.allPaths=ke),me}function y(he,be,we){const ge=A.sep===A.$fc.sep,me=ge?he:he.replace(l,A.sep),ne=A.sep+me,ke=A.$fc.sep+he;let ce;return we?ce=function(Y,W){return typeof Y=="string"&&(Y===me||Y.endsWith(ne)||!ge&&(Y===he||Y.endsWith(ke)))?be:null}:ce=function(Y,W){return typeof Y=="string"&&(Y===me||!ge&&Y===he)?be:null},ce.allPaths=[(we?"*/":"./")+he],ce}function D(he){try{const be=new RegExp(`^${a(he)}$`);return function(we){return be.lastIndex=0,typeof we=="string"&&be.test(we)?he:null}}catch{return u}}function N(he,be,we){return!he||typeof be!="string"?!1:q(he)(be,void 0,we)}e.$Fj=N;function q(he,be={}){if(!he)return r;if(typeof he=="string"||V(he)){const we=d(he,be);if(we===u)return r;const ge=function(me,ne){return!!we(me,ne)};return we.allBasenames&&(ge.allBasenames=we.allBasenames),we.allPaths&&(ge.allPaths=we.allPaths),ge}return C(he,be)}e.$Gj=q;function V(he){const be=he;return be?typeof be.base=="string"&&typeof be.pattern=="string":!1}e.$Hj=V;function U(he){return he.allBasenames||[]}e.$Ij=U;function F(he){return he.allPaths||[]}e.$Jj=F;function C(he,be){const we=X(Object.getOwnPropertyNames(he).map(ce=>I(ce,he[ce],be)).filter(ce=>ce!==u)),ge=we.length;if(!ge)return u;if(!we.some(ce=>!!ce.requiresSiblings)){if(ge===1)return we[0];const ce=function(re,Ie){let Ae;for(let Ce=0,le=we.length;Ce<le;Ce++){const ie=we[Ce](re,Ie);if(typeof ie=="string")return ie;(0,T.$Mg)(ie)&&(Ae||(Ae=[]),Ae.push(ie))}return Ae?(async()=>{for(const Ce of Ae){const le=await Ce;if(typeof le=="string")return le}return null})():null},Y=we.find(re=>!!re.allBasenames);Y&&(ce.allBasenames=Y.allBasenames);const W=we.reduce((re,Ie)=>Ie.allPaths?re.concat(Ie.allPaths):re,[]);return W.length&&(ce.allPaths=W),ce}const me=function(ce,Y,W){let re,Ie;for(let Ae=0,Ce=we.length;Ae<Ce;Ae++){const le=we[Ae];le.requiresSiblings&&W&&(Y||(Y=(0,A.$mc)(ce)),re||(re=Y.substr(0,Y.length-(0,A.$nc)(ce).length)));const ie=le(ce,Y,re,W);if(typeof ie=="string")return ie;(0,T.$Mg)(ie)&&(Ie||(Ie=[]),Ie.push(ie))}return Ie?(async()=>{for(const Ae of Ie){const Ce=await Ae;if(typeof Ce=="string")return Ce}return null})():null},ne=we.find(ce=>!!ce.allBasenames);ne&&(me.allBasenames=ne.allBasenames);const ke=we.reduce((ce,Y)=>Y.allPaths?ce.concat(Y.allPaths):ce,[]);return ke.length&&(me.allPaths=ke),me}function I(he,be,we){if(be===!1)return u;const ge=d(he,we);if(ge===u)return u;if(typeof be=="boolean")return ge;if(be){const me=be.when;if(typeof me=="string"){const ne=(ke,ce,Y,W)=>{if(!W||!ge(ke,ce))return null;const re=me.replace("$(basename)",()=>Y),Ie=W(re);return(0,T.$Mg)(Ie)?Ie.then(Ae=>Ae?he:null):Ie?he:null};return ne.requiresSiblings=!0,ne}}return ge}function X(he,be){const we=he.filter(ce=>!!ce.basenames);if(we.length<2)return he;const ge=we.reduce((ce,Y)=>{const W=Y.basenames;return W?ce.concat(W):ce},[]);let me;if(be){me=[];for(let ce=0,Y=ge.length;ce<Y;ce++)me.push(be)}else me=we.reduce((ce,Y)=>{const W=Y.patterns;return W?ce.concat(W):ce},[]);const ne=function(ce,Y){if(typeof ce!="string")return null;if(!Y){let re;for(re=ce.length;re>0;re--){const Ie=ce.charCodeAt(re-1);if(Ie===47||Ie===92)break}Y=ce.substr(re)}const W=ge.indexOf(Y);return W!==-1?me[W]:null};ne.basenames=ge,ne.patterns=me,ne.allBasenames=ge;const ke=he.filter(ce=>!ce.basenames);return ke.push(ne),ke}function ue(he,be){return(0,E.$tb)(he,be,(we,ge)=>typeof we=="string"&&typeof ge=="string"?we===ge:typeof we!="string"&&typeof ge!="string"?we.base===ge.base&&we.pattern===ge.pattern:!1)}e.$Kj=ue}),define(Pe[52],Re([1,0,11,125,25,12,2]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class g{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,E.$6)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,T.$7j)(t):t).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+="\n```",this.value+=t,this.value+=`
`,this.value+=n,this.value+="\n```\n",this}appendLink(t,n,o){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),o&&(this.value+=` "${this.c(this.c(o,'"'),")")}"`),this.value+=")",this}c(t,n){const o=new RegExp((0,M.$Je)(n),"g");return t.replace(o,(c,h)=>t.charAt(h-1)!=="\\"?`\\${c}`:c)}}e.$ak=g;function w(s){return R(s)?!s.value:Array.isArray(s)?s.every(w):!0}e.$bk=w;function R(s){return s instanceof g?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$ck=R;function S(s,t){return s===t?!0:!s||!t?!1:s.value===t.value&&s.isTrusted===t.isTrusted&&s.supportThemeIcons===t.supportThemeIcons&&s.supportHtml===t.supportHtml&&(s.baseUri===t.baseUri||!!s.baseUri&&!!t.baseUri&&(0,P.$ug)(A.URI.from(s.baseUri),A.URI.from(t.baseUri)))}e.$dk=S;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$ek=l;function $(s){return s.replace(/"/g,"&quot;")}e.$fk=$;function b(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$gk=b;function a(s){const t=[],n=s.split("|").map(c=>c.trim());s=n[0];const o=n[1];if(o){const c=/height=(\d+)/.exec(o),h=/width=(\d+)/.exec(o),i=c?c[1]:"",r=h?h[1]:"",u=isFinite(parseInt(r)),d=isFinite(parseInt(i));u&&t.push(`width="${r}"`),d&&t.push(`height="${i}"`)}return{href:s,dimensions:t}}e.$hk=a}),define(Pe[95],Re([1,0,18,46,20,21,25,12]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=void 0;function g(d,v){const{os:f,tildify:k,relative:L}=v;if(L){const D=w(d,L,f);if(typeof D=="string")return D}let p=d.fsPath;if(f===1&&!M.$i?p=p.replace(/\//g,"\\"):f!==1&&M.$i&&(p=p.replace(/\\/g,"/")),f!==1&&k?.userHome){const D=k.userHome.fsPath;let N;d.scheme!==k.userHome.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep?N=k.userHome.with({path:d.path}).fsPath:N=p,p=l(N,D,f)}return(f===1?P.$ec:P.$fc).normalize(R(p,f===1))}e.$Dv=g;function w(d,v,f){const k=f===1?P.$ec:P.$fc,L=f===3?A.$rg:A.$tg,p=v.getWorkspace(),y=(0,E.$Nb)(p.folders);if(!y)return;d.scheme!==y.uri.scheme&&d.path[0]===P.$fc.sep&&d.path[1]!==P.$fc.sep&&(d=y.uri.with({path:d.path}));const D=v.getWorkspaceFolder(d);if(!D)return;let N;if(L.isEqual(D.uri,d)?N="":N=L.relativePath(D.uri,d)??"",N&&(N=k.normalize(N)),p.folders.length>1&&!v.noPrefix){const q=D.name?D.name:L.basenameOrAuthority(D.uri);N=N?`${q} \u2022 ${N}`:q}return N}function R(d,v=M.$i){return(0,T.$6f)(d,v)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Ev=R;let S=Object.create(null);function l(d,v,f=M.OS){if(f===1||!d||!v)return d;let k=S.original===v?S.normalized:void 0;k||(k=v,M.$i&&(k=(0,T.$Vf)(k)),k=`${(0,m.$Oe)(k,P.$fc.sep)}${P.$fc.sep}`,S={original:v,normalized:k});let L=d;return M.$i&&(L=(0,T.$Vf)(L)),(f===3?L.startsWith(k):(0,m.$7e)(L,k))?`~/${L.substr(k.length)}`:d}e.$Fv=l;function $(d,v){return d.replace(/^~($|\/|\\)/,`${v}$1`)}e.$Gv=$;const b="\u2026",a="\\\\",s="~";function t(d,v=P.sep){const f=new Array(d.length);let k=!1;for(let L=0;L<d.length;L++){const p=d[L];if(p===""){f[L]=`.${v}`;continue}if(!p){f[L]=p;continue}k=!0;let y="",D=p;D.indexOf(a)===0?(y=D.substr(0,D.indexOf(a)+a.length),D=D.substr(D.indexOf(a)+a.length)):D.indexOf(v)===0?(y=D.substr(0,D.indexOf(v)+v.length),D=D.substr(D.indexOf(v)+v.length)):D.indexOf(s)===0&&(y=D.substr(0,D.indexOf(s)+s.length),D=D.substr(D.indexOf(s)+s.length));const N=D.split(v);for(let q=1;k&&q<=N.length;q++)for(let V=N.length-q;k&&V>=0;V--){k=!1;let U=N.slice(V,V+q).join(v);for(let F=0;!k&&F<d.length;F++)if(F!==L&&d[F]&&d[F].indexOf(U)>-1){const C=V+q===N.length,I=V>0&&d[F].indexOf(v)>-1?v+U:U,X=d[F].endsWith(I);k=!C||X}if(!k){let F="";(N[0].endsWith(":")||y!=="")&&(V===1&&(V=0,q++,U=N[0]+v+U),V>0&&(F=N[0]+v),F=y+F),V>0&&(F=F+b+v),F=F+U,V+q<N.length&&(F=F+v+b),f[L]=F}}k&&(f[L]=p)}return f}e.$Hv=t;var n;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function o(d,v=Object.create(null)){const f=[];let k=!1,L="";for(const p of d)if(p==="$"||k&&p==="{")L&&f.push({value:L,type:n.TEXT}),L="",k=!0;else if(p==="}"&&k){const y=v[L];if(typeof y=="string")y.length&&f.push({value:y,type:n.VARIABLE});else if(y){const D=f[f.length-1];(!D||D.type!==n.SEPARATOR)&&f.push({value:y.label,type:n.SEPARATOR})}L="",k=!1}else L+=p;return L&&!k&&f.push({value:L,type:n.TEXT}),f.filter((p,y)=>{if(p.type===n.SEPARATOR){const D=f[y-1],N=f[y+1];return[D,N].every(q=>q&&(q.type===n.VARIABLE||q.type===n.TEXT)&&q.value.length>0)}return!0}).map(p=>p.value).join("")}e.$Iv=o;function c(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.$j?"&":"&&"):d.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.$Jv=c;function h(d,v){return M.$j||v?d.replace(/\(&&\w\)|&&/g,""):M.$i?d.replace(/&&|&/g,f=>f==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$Kv=h;function i(d){return d.replace(/&/g,"&&")}e.$Lv=i;function r(d){if(d.endsWith("]")){const v=d.lastIndexOf(" [",d.length-2);if(v!==-1){const f=u(d.substring(0,v));return{name:f.name,parentPath:f.parentPath+d.substring(v)}}}return u(d)}e.$Mv=r;function u(d){const v=d.indexOf("/")!==-1?P.$fc:P.$ec,f=v.basename(d),k=v.dirname(d);return f.length?{name:f,parentPath:k}:{name:k,parentPath:""}}}),define(Pe[138],Re([1,0,24,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zm=e.$Ym=e.$Xm=e.$Wm=e.$Vm=void 0;function P(S){return S.toJSON()}class M{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:P(T.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:P(T.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:T.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$Vm=M,e.$Wm=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,l,$){if(!S||$>200)return null;if(typeof S=="object"){if(S instanceof T.URI)return l.transformOutgoing(S);for(const b in S)if(Object.hasOwnProperty.call(S,b)){const a=A(S[b],l,$+1);a!==null&&(S[b]=a)}}return null}function m(S,l){const $=A(S,l,0);return $===null?S:$}e.$Xm=m;function g(S,l,$,b){if(!S||b>200)return null;if(typeof S=="object"){if(S.$mid===1)return $?T.URI.revive(l.transformIncoming(S)):l.transformIncoming(S);if(S instanceof E.$fe)return null;for(const a in S)if(Object.hasOwnProperty.call(S,a)){const s=g(S[a],l,$,b+1);s!==null&&(S[a]=s)}}return null}function w(S,l){const $=g(S,l,!1,0);return $===null?S:$}e.$Ym=w;function R(S,l){const $=g(S,l,!0,0);return $===null?S:$}e.$Zm=R}),define(Pe[139],Re([1,0,12,21,24]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xs=e.$Ws=e.$Vs=void 0;let M;function A(){return M||(M=new TextDecoder("UTF-16LE")),M}let m;function g(){return m||(m=new TextDecoder("UTF-16BE")),m}let w;function R(){return w||(w=T.$D()?A():g()),w}e.$Vs=R;function S(b,a,s){const t=new Uint16Array(b.buffer,a,s);return s>0&&(t[0]===65279||t[0]===65534)?l(b,a,s):A().decode(t)}e.$Ws=S;function l(b,a,s){const t=[];let n=0;for(let o=0;o<s;o++){const c=P.$he(b,a);a+=2,t[n++]=String.fromCharCode(c)}return t.join("")}class ${constructor(a){this.a=a|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const a=new Uint16Array(this.b.buffer,0,this.d);return R().decode(a)}f(){const a=this.e();this.d=0,this.c===null?this.c=[a]:this.c[this.c.length]=a}appendCharCode(a){const s=this.a-this.d;s<=1&&(s===0||E.$0e(a))&&this.f(),this.b[this.d++]=a}appendASCIICharCode(a){this.d===this.a&&this.f(),this.b[this.d++]=a}appendString(a){const s=a.length;if(this.d+s>=this.a){this.f(),this.c[this.c.length]=a;return}for(let t=0;t<s;t++)this.b[this.d++]=a.charCodeAt(t)}}e.$Xs=$}),define(Pe[140],Re([1,0,24,139]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zs=e.$Ys=void 0;function P(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class M{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(w,R,S,l){this.oldPosition=w,this.oldText=R,this.newPosition=S,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${P(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${P(this.oldText)}")`:`(replace@${this.oldPosition} "${P(this.oldText)}" with "${P(this.newText)}")`}static a(w){return 4+2*w.length}static c(w,R,S){const l=R.length;E.$ke(w,l,S),S+=4;for(let $=0;$<l;$++)E.$ie(w,R.charCodeAt($),S),S+=2;return S}static d(w,R){const S=E.$je(w,R);return R+=4,(0,T.$Ws)(w,R,S)}writeSize(){return 4+4+M.a(this.oldText)+M.a(this.newText)}write(w,R){return E.$ke(w,this.oldPosition,R),R+=4,E.$ke(w,this.newPosition,R),R+=4,R=M.c(w,this.oldText,R),R=M.c(w,this.newText,R),R}static read(w,R,S){const l=E.$je(w,R);R+=4;const $=E.$je(w,R);R+=4;const b=M.d(w,R);R+=M.a(b);const a=M.d(w,R);return R+=M.a(a),S.push(new M(l,b,$,a)),R}}e.$Ys=M;function A(g,w){return g===null||g.length===0?w:new m(g,w).compress()}e.$Zs=A;class m{constructor(w,R){this.a=w,this.c=R,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let w=0,R=0,S=this.n(w),l=this.l(R);for(;w<this.f||R<this.h;){if(S===null){this.k(l),l=this.l(++R);continue}if(l===null){this.m(S),S=this.n(++w);continue}if(l.oldEnd<=S.newPosition){this.k(l),l=this.l(++R);continue}if(S.newEnd<=l.oldPosition){this.m(S),S=this.n(++w);continue}if(l.oldPosition<S.newPosition){const[t,n]=m.r(l,S.newPosition-l.oldPosition);this.k(t),l=n;continue}if(S.newPosition<l.oldPosition){const[t,n]=m.q(S,l.oldPosition-S.newPosition);this.m(t),S=n;continue}let a,s;if(l.oldEnd===S.newEnd)a=S,s=l,S=this.n(++w),l=this.l(++R);else if(l.oldEnd<S.newEnd){const[t,n]=m.q(S,l.oldLength);a=t,s=l,S=n,l=this.l(++R)}else{const[t,n]=m.r(l,S.newLength);a=S,s=t,S=this.n(++w),l=n}this.d[this.e++]=new M(a.oldPosition,a.oldText,s.newPosition,s.newText),this.g+=a.newLength-a.oldLength,this.j+=s.newLength-s.oldLength}const $=m.s(this.d);return m.t($)}k(w){this.d[this.e++]=m.o(this.g,w),this.j+=w.newLength-w.oldLength}l(w){return w<this.h?this.c[w]:null}m(w){this.d[this.e++]=m.p(this.j,w),this.g+=w.newLength-w.oldLength}n(w){return w<this.f?this.a[w]:null}static o(w,R){return new M(R.oldPosition-w,R.oldText,R.newPosition,R.newText)}static p(w,R){return new M(R.oldPosition,R.oldText,R.newPosition+w,R.newText)}static q(w,R){const S=w.newText.substr(0,R),l=w.newText.substr(R);return[new M(w.oldPosition,w.oldText,w.newPosition,S),new M(w.oldEnd,"",w.newPosition+R,l)]}static r(w,R){const S=w.oldText.substr(0,R),l=w.oldText.substr(R);return[new M(w.oldPosition,S,w.newPosition,w.newText),new M(w.oldPosition+R,l,w.newEnd,"")]}static s(w){if(w.length===0)return w;const R=[];let S=0,l=w[0];for(let $=1;$<w.length;$++){const b=w[$];l.oldEnd===b.oldPosition?l=new M(l.oldPosition,l.oldText+b.oldText,l.newPosition,l.newText+b.newText):(R[S++]=l,l=b)}return R[S++]=l,R}static t(w){if(w.length===0)return w;const R=[];let S=0;for(let l=0;l<w.length;l++){const $=w[l];$.oldText!==$.newText&&(R[S++]=$)}return R}}}),define(Pe[141],Re([1,0,34,20]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kt=void 0;function P(M,A,m,g,w,R){if(Array.isArray(M)){let S=0;for(const l of M){const $=P(l,A,m,g,w,R);if($===10)return $;$>S&&(S=$)}return S}else{if(typeof M=="string")return g?M==="*"?5:M===m?10:0:0;if(M){const{language:S,pattern:l,scheme:$,hasAccessToAllModels:b,notebookType:a}=M;if(!g&&!b)return 0;a&&w&&(A=w);let s=0;if($)if($===A.scheme)s=10;else if($==="*")s=5;else return 0;if(S)if(S===m)s=10;else if(S==="*")s=Math.max(s,5);else return 0;if(a)if(a===R)s=10;else if(a==="*"&&R!==void 0)s=Math.max(s,5);else return 0;if(l){let t;if(typeof l=="string"?t=l:t={...l,base:(0,T.$gc)(l.base)},t===A.fsPath||(0,E.$Fj)(t,A.fsPath))s=10;else return 0}return s}else return 0}}e.$kt=P}),define(Pe[142],Re([1,0,5,12,29,93,91,127,140,6]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RB=void 0;class R extends w.$Rc{constructor(l,$,b,a,s,t,n){super(),this.m=this.B(new E.$Rd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!t,this.g=a,this.h=s,this.c=new A.$QB(l,b,n)}equals(l){return!(l instanceof R)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const b=l+$,a=this.getPositionAt(l),s=this.getPositionAt(b);return new P.$Ds(a.lineNumber,a.column,s.lineNumber,s.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const b=this.n($);return this.c.getValueInRange(l,b)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const b=this.getOffsetAt(l.startLineNumber,l.startColumn),a=this.getOffsetAt(l.endLineNumber,l.endColumn);let s=0;const t=this.n($),n=this.getEOL();if(t.length!==n.length){const o=t.length-n.length,c=l.endLineNumber-l.startLineNumber;s=o*c}return a-b+s}getCharacterCountInRange(l,$=0){if(this.j){let b=0;const a=l.startLineNumber,s=l.endLineNumber;for(let t=a;t<=s;t++){const n=this.getLineContent(t),o=t===a?l.startColumn-1:0,c=t===s?l.endColumn-1:n.length;for(let h=o;h<c;h++)T.$0e(n.charCodeAt(h))?(b=b+1,h=h+1):b=b+1}return b+=this.n($).length*(s-a),b}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=T.$Ue(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=T.$We(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,b){let a=this.g,s=this.h,t=this.j,n=!0,o=[];for(let v=0;v<l.length;v++){const f=l[v];n&&f._isTracked&&(n=!1);const k=f.range;if(f.text){let N=!0;t||(N=!T.$if(f.text),t=N),!a&&N&&(a=T.$hf(f.text)),!s&&N&&(s=T.$kf(f.text))}let L="",p=0,y=0,D=0;if(f.text){let N;[p,y,D,N]=(0,m.$dt)(f.text);const q=this.getEOL();N===0||N===(q===`\r
`?2:1)?L=f.text:L=f.text.replace(/\r\n|\r|\n/g,q)}o[v]={sortIndex:v,identifier:f.identifier||null,range:k,rangeOffset:this.getOffsetAt(k.startLineNumber,k.startColumn),rangeLength:this.getValueLengthInRange(k),text:L,eolCount:p,firstLineLength:y,lastLineLength:D,forceMoveMarkers:!!f.forceMoveMarkers,isAutoWhitespaceEdit:f.isAutoWhitespaceEdit||!1}}o.sort(R.u);let c=!1;for(let v=0,f=o.length-1;v<f;v++){const k=o[v].range.getEndPosition(),L=o[v+1].range.getStartPosition();if(L.isBeforeOrEqual(k)){if(L.isBefore(k))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(o=this.s(o));const h=b||$?R._getInverseEditRanges(o):[],i=[];if($)for(let v=0;v<o.length;v++){const f=o[v],k=h[v];if(f.isAutoWhitespaceEdit&&f.range.isEmpty())for(let L=k.startLineNumber;L<=k.endLineNumber;L++){let p="";L===k.startLineNumber&&(p=this.getLineContent(f.range.startLineNumber),T.$Ue(p)!==-1)||i.push({lineNumber:L,oldContent:p})}}let r=null;if(b){let v=0;r=[];for(let f=0;f<o.length;f++){const k=o[f],L=h[f],p=this.getValueInRange(k.range),y=k.rangeOffset+v;v+=k.text.length-p.length,r[f]={sortIndex:k.sortIndex,identifier:k.identifier,range:L,text:p,textChange:new g.$Ys(k.rangeOffset,p,y,k.text)}}c||r.sort((f,k)=>f.sortIndex-k.sortIndex)}this.g=a,this.h=s,this.j=t;const u=this.t(o);let d=null;if($&&i.length>0){i.sort((v,f)=>f.lineNumber-v.lineNumber),d=[];for(let v=0,f=i.length;v<f;v++){const k=i[v].lineNumber;if(v>0&&i[v-1].lineNumber===k)continue;const L=i[v].oldContent,p=this.getLineContent(k);p.length===0||p===L||T.$Ue(p)!==-1||d.push(k)}}return this.m.fire(),new M.$Zu(r,u,d)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const b=l[0].range,a=l[l.length-1].range,s=new P.$Ds(b.startLineNumber,b.startColumn,a.endLineNumber,a.endColumn);let t=b.startLineNumber,n=b.startColumn;const o=[];for(let u=0,d=l.length;u<d;u++){const v=l[u],f=v.range;$=$||v.forceMoveMarkers,o.push(this.getValueInRange(new P.$Ds(t,n,f.startLineNumber,f.startColumn))),v.text.length>0&&o.push(v.text),t=f.endLineNumber,n=f.endColumn}const c=o.join(""),[h,i,r]=(0,m.$dt)(c);return{sortIndex:0,identifier:l[0].identifier,range:s,rangeOffset:this.getOffsetAt(s.startLineNumber,s.startColumn),rangeLength:this.getValueLengthInRange(s,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:r,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(R.w);const $=[];for(let b=0;b<l.length;b++){const a=l[b],s=a.range.startLineNumber,t=a.range.startColumn,n=a.range.endLineNumber,o=a.range.endColumn;if(s===n&&t===o&&a.text.length===0)continue;a.text?(this.c.delete(a.rangeOffset,a.rangeLength),this.c.insert(a.rangeOffset,a.text,!0)):this.c.delete(a.rangeOffset,a.rangeLength);const c=new P.$Ds(s,t,n,o);$.push({range:c,rangeLength:a.rangeLength,text:a.text,rangeOffset:a.rangeOffset,forceMoveMarkers:a.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,b,a){return this.c.findMatchesLineByLine(l,$,b,a)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const b=l.startLineNumber,a=l.startColumn,[s,t,n]=(0,m.$dt)($);let o;if($.length>0){const c=s+1;c===1?o=new P.$Ds(b,a,b,a+t):o=new P.$Ds(b,a,b+c-1,n+1)}else o=new P.$Ds(b,a,b,a);return o}static _getInverseEditRanges(l){const $=[];let b=0,a=0,s=null;for(let t=0,n=l.length;t<n;t++){const o=l[t];let c,h;s?s.range.endLineNumber===o.range.startLineNumber?(c=b,h=a+(o.range.startColumn-s.range.endColumn)):(c=b+(o.range.startLineNumber-s.range.endLineNumber),h=o.range.startColumn):(c=o.range.startLineNumber,h=o.range.startColumn);let i;if(o.text.length>0){const r=o.eolCount+1;r===1?i=new P.$Ds(c,h,c,h+o.firstLineLength):i=new P.$Ds(c,h,c+r-1,o.lastLineLength+1)}else i=new P.$Ds(c,h,c,h);b=i.endLineNumber,a=i.endColumn,$.push(i),s=o}return $}static u(l,$){const b=P.$Ds.compareRangesUsingEnds(l.range,$.range);return b===0?l.sortIndex-$.sortIndex:b}static w(l,$){const b=P.$Ds.compareRangesUsingEnds(l.range,$.range);return b===0?$.sortIndex-l.sortIndex:-b}}e.$RB=R}),define(Pe[143],Re([1,0,12,91,142]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SB=void 0;class M{constructor(g,w,R,S,l,$,b,a,s){this.a=g,this.b=w,this.c=R,this.d=S,this.e=l,this.f=$,this.g=b,this.h=a,this.j=s}k(g){const w=this.c+this.d+this.e,R=this.c+this.e;return w===0?g===1?`
`:`\r
`:R>w/2?`\r
`:`
`}create(g){const w=this.k(g),R=this.a;if(this.j&&(w===`\r
`&&(this.c>0||this.d>0)||w===`
`&&(this.c>0||this.e>0)))for(let l=0,$=R.length;l<$;l++){const b=R[l].buffer.replace(/\r\n|\r|\n/g,w),a=(0,T.$MB)(b);R[l]=new T.$PB(b,a)}const S=new P.$RB(R,this.b,w,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&E.$qf(g)&&(this.b=E.$pf,g=g.substr(1));const w=g.charCodeAt(g.length-1);w===13||w>=55296&&w<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=w):(this.m(g,!1),this.c=!1,this.d=w)}m(g,w){!w&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const w=(0,T.$NB)(this.e,g);this.a.push(new T.$PB(g,w.lineStarts)),this.f+=w.cr,this.g+=w.lf,this.h+=w.crlf,w.isBasicASCII||(this.l=!1,this.j||(this.j=E.$hf(g)),this.k||(this.k=E.$kf(g)))}finish(g=!0){return this.o(),new M(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const w=(0,T.$MB)(g.buffer);g.lineStarts=w,this.d===13&&this.f++}}}e.$SB=A}),define(Pe[96],Re([1,0,24,21]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_0=e.$$0=void 0;var P;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(P||(P={}));function M(S){for(let l=0,$=S.length;l<$;l+=4){const b=S[l+0],a=S[l+1],s=S[l+2],t=S[l+3];S[l+0]=t,S[l+1]=s,S[l+2]=a,S[l+3]=b}}function A(S){const l=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return T.$D()||M(l),E.$fe.wrap(l)}function m(S){const l=S.buffer;if(T.$D()||M(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function g(S){const l=new Uint32Array(w(S));let $=0;if(l[$++]=S.id,S.type==="full")l[$++]=1,l[$++]=S.data.length,l.set(S.data,$),$+=S.data.length;else{l[$++]=2,l[$++]=S.deltas.length;for(const b of S.deltas)l[$++]=b.start,l[$++]=b.deleteCount,b.data?(l[$++]=b.data.length,l.set(b.data,$),$+=b.data.length):l[$++]=0}return A(l)}e.$$0=g;function w(S){let l=0;if(l+=1+1,S.type==="full")l+=1+S.data.length;else{l+=1,l+=(1+1+1)*S.deltas.length;for(const $ of S.deltas)$.data&&(l+=$.data.length)}return l}function R(S){const l=m(S);let $=0;const b=l[$++];if(l[$++]===1){const n=l[$++],o=l.subarray($,$+n);return $+=n,{id:b,type:"full",data:o}}const s=l[$++],t=[];for(let n=0;n<s;n++){const o=l[$++],c=l[$++],h=l[$++];let i;h>0&&(i=l.subarray($,$+h),$+=h),t[n]={start:o,deleteCount:c,data:i}}return{id:b,type:"delta",deltas:t}}e.$_0=R}),define(Pe[144],Re([9,10]),function(pe,e){return pe.create("vs/editor/common/config/editorOptions",e)}),define(Pe[145],Re([1,0,18,26,21,128,146,144]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var g;(function(ee){ee[ee.None=0]="None",ee[ee.Keep=1]="Keep",ee[ee.Brackets=2]="Brackets",ee[ee.Advanced=3]="Advanced",ee[ee.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class w{constructor(Z){this.c=Z}hasChanged(Z){return this.c[Z]}}e.ConfigurationChangedEvent=w;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class S{constructor(Z,ve,Be,Ke){this.id=Z,this.name=ve,this.defaultValue=Be,this.schema=Ke}applyUpdate(Z,ve){return $(Z,ve)}compute(Z,ve,Be){return Be}}class l{constructor(Z,ve){this.newValue=Z,this.didChange=ve}}e.ApplyUpdateResult=l;function $(ee,Z){if(typeof ee!="object"||typeof Z!="object"||!ee||!Z)return new l(Z,ee!==Z);if(Array.isArray(ee)||Array.isArray(Z)){const Be=Array.isArray(ee)&&Array.isArray(Z)&&E.$tb(ee,Z);return new l(Z,!Be)}let ve=!1;for(const Be in Z)if(Z.hasOwnProperty(Be)){const Ke=$(ee[Be],Z[Be]);Ke.didChange&&(ee[Be]=Ke.newValue,ve=!0)}return new l(ee,ve)}class b{constructor(Z){this.schema=void 0,this.id=Z,this.name="_never_",this.defaultValue=void 0}applyUpdate(Z,ve){return $(Z,ve)}validate(Z){return this.defaultValue}}class a{constructor(Z,ve,Be,Ke){this.id=Z,this.name=ve,this.defaultValue=Be,this.schema=Ke}applyUpdate(Z,ve){return $(Z,ve)}validate(Z){return typeof Z>"u"?this.defaultValue:Z}compute(Z,ve,Be){return Be}}function s(ee,Z){return typeof ee>"u"?Z:ee==="false"?!1:!!ee}e.boolean=s;class t extends a{constructor(Z,ve,Be,Ke=void 0){typeof Ke<"u"&&(Ke.type="boolean",Ke.default=Be),super(Z,ve,Be,Ke)}validate(Z){return s(Z,this.defaultValue)}}function n(ee,Z,ve,Be){if(typeof ee>"u")return Z;let Ke=parseInt(ee,10);return isNaN(Ke)?Z:(Ke=Math.max(ve,Ke),Ke=Math.min(Be,Ke),Ke|0)}e.clampedInt=n;class o extends a{static clampedInt(Z,ve,Be,Ke){return n(Z,ve,Be,Ke)}constructor(Z,ve,Be,Ke,xe,ot=void 0){typeof ot<"u"&&(ot.type="integer",ot.default=Be,ot.minimum=Ke,ot.maximum=xe),super(Z,ve,Be,ot),this.minimum=Ke,this.maximum=xe}validate(Z){return o.clampedInt(Z,this.defaultValue,this.minimum,this.maximum)}}function c(ee,Z,ve,Be){if(typeof ee>"u")return Z;const Ke=h.float(ee,Z);return h.clamp(Ke,ve,Be)}e.clampedFloat=c;class h extends a{static clamp(Z,ve,Be){return Z<ve?ve:Z>Be?Be:Z}static float(Z,ve){if(typeof Z=="number")return Z;if(typeof Z>"u")return ve;const Be=parseFloat(Z);return isNaN(Be)?ve:Be}constructor(Z,ve,Be,Ke,xe){typeof xe<"u"&&(xe.type="number",xe.default=Be),super(Z,ve,Be,xe),this.validationFn=Ke}validate(Z){return this.validationFn(h.float(Z,this.defaultValue))}}class i extends a{static string(Z,ve){return typeof Z!="string"?ve:Z}constructor(Z,ve,Be,Ke=void 0){typeof Ke<"u"&&(Ke.type="string",Ke.default=Be),super(Z,ve,Be,Ke)}validate(Z){return i.string(Z,this.defaultValue)}}function r(ee,Z,ve,Be){return typeof ee!="string"?Z:Be&&ee in Be?Be[ee]:ve.indexOf(ee)===-1?Z:ee}e.stringSet=r;class u extends a{constructor(Z,ve,Be,Ke,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ke,xe.default=Be),super(Z,ve,Be,xe),this.c=Ke}validate(Z){return r(Z,this.defaultValue,this.c)}}class d extends S{constructor(Z,ve,Be,Ke,xe,ot,pt=void 0){typeof pt<"u"&&(pt.type="string",pt.enum=xe,pt.default=Ke),super(Z,ve,Be,pt),this.c=xe,this.d=ot}validate(Z){return typeof Z!="string"?this.defaultValue:this.c.indexOf(Z)===-1?this.defaultValue:this.d(Z)}}function v(ee){switch(ee){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class f extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(Z){switch(Z){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Z,ve,Be){return Be===0?Z.accessibilitySupport:Be}}class k extends S{constructor(){const Z={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Z,{"editor.comments.insertSpace":{type:"boolean",default:Z.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Z.ignoreEmptyLines,description:m.localize(5,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertSpace:s(ve.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:s(ve.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var L;(function(ee){ee[ee.Hidden=0]="Hidden",ee[ee.Blink=1]="Blink",ee[ee.Smooth=2]="Smooth",ee[ee.Phase=3]="Phase",ee[ee.Expand=4]="Expand",ee[ee.Solid=5]="Solid"})(L||(e.TextEditorCursorBlinkingStyle=L={}));function p(ee){switch(ee){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var y;(function(ee){ee[ee.Line=1]="Line",ee[ee.Block=2]="Block",ee[ee.Underline=3]="Underline",ee[ee.LineThin=4]="LineThin",ee[ee.BlockOutline=5]="BlockOutline",ee[ee.UnderlineThin=6]="UnderlineThin"})(y||(e.TextEditorCursorStyle=y={}));function D(ee){switch(ee){case y.Line:return"line";case y.Block:return"block";case y.Underline:return"underline";case y.LineThin:return"line-thin";case y.BlockOutline:return"block-outline";case y.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=D;function N(ee){switch(ee){case"line":return y.Line;case"block":return y.Block;case"underline":return y.Underline;case"line-thin":return y.LineThin;case"block-outline":return y.BlockOutline;case"underline-thin":return y.UnderlineThin}}class q extends b{constructor(){super(140)}compute(Z,ve,Be){const Ke=["monaco-editor"];return ve.get(39)&&Ke.push(ve.get(39)),Z.extraEditorClassName&&Ke.push(Z.extraEditorClassName),ve.get(73)==="default"?Ke.push("mouse-default"):ve.get(73)==="copy"&&Ke.push("mouse-copy"),ve.get(110)&&Ke.push("showUnused"),ve.get(138)&&Ke.push("showDeprecated"),Ke.join(" ")}}class V extends t{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(Z,ve,Be){return Be&&Z.emptySelectionClipboard}}class U extends S{constructor(){const Z={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Z,{"editor.find.cursorMoveOnType":{type:"boolean",default:Z.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Z.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Z.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Z.globalFindClipboard,description:m.localize(16,null),included:P.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Z.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:Z.loop,description:m.localize(18,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{cursorMoveOnType:s(ve.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Z.seedSearchStringFromSelection=="boolean"?Z.seedSearchStringFromSelection?"always":"never":r(ve.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Z.autoFindInSelection=="boolean"?Z.autoFindInSelection?"always":"never":r(ve.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:s(ve.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:s(ve.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:s(ve.loop,this.defaultValue.loop)}}}class F extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",F.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?F.OFF:Z==="true"?F.ON:Z:Z?F.ON:F.OFF}}e.EditorFontLigatures=F;class C extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(Z){return typeof Z>"u"?this.defaultValue:typeof Z=="string"?Z==="false"?C.OFF:Z==="true"?C.TRANSLATE:Z:Z?C.TRANSLATE:C.OFF}compute(Z,ve,Be){return Z.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class I extends b{constructor(){super(50)}compute(Z,ve,Be){return Z.fontInfo}}class X extends a{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(Z){const ve=h.float(Z,this.defaultValue);return ve===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(ve,6,100)}compute(Z,ve,Be){return Z.fontInfo.fontSize}}class ue extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ue.d,maximum:ue.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ue.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(Z){return Z==="normal"||Z==="bold"?Z:String(o.clampedInt(Z,e.EDITOR_FONT_DEFAULTS.fontWeight,ue.d,ue.e))}}class he extends S{constructor(){const Z={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ve={type:"string",enum:["peek","gotoAndPeek","goto"],default:Z.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Be=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Z,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...ve},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...ve},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...ve},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...ve},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...ve},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Z.alternativeDefinitionCommand,enum:Be,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Z.alternativeTypeDefinitionCommand,enum:Be,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Z.alternativeDeclarationCommand,enum:Be,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Z.alternativeImplementationCommand,enum:Be,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Z.alternativeReferenceCommand,enum:Be,description:m.localize(41,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{multiple:r(ve.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ve.multipleDefinitions??r(ve.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ve.multipleTypeDefinitions??r(ve.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ve.multipleDeclarations??r(ve.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ve.multipleImplementations??r(ve.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ve.multipleReferences??r(ve.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(ve.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(ve.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(ve.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(ve.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(ve.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class be extends S{constructor(){const Z={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Z,{"editor.hover.enabled":{type:"boolean",default:Z.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:Z.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Z.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Z.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:Z.above,description:m.localize(46,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),delay:o.clampedInt(ve.delay,this.defaultValue.delay,0,1e4),sticky:s(ve.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(ve.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:s(ve.above,this.defaultValue.above)}}}var we;(function(ee){ee[ee.None=0]="None",ee[ee.Text=1]="Text",ee[ee.Blocks=2]="Blocks"})(we||(e.RenderMinimap=we={}));class ge extends b{constructor(){super(143)}compute(Z,ve,Be){return ge.computeLayout(ve,{memory:Z.memory,outerWidth:Z.outerWidth,outerHeight:Z.outerHeight,isDominatedByLongLines:Z.isDominatedByLongLines,lineHeight:Z.fontInfo.lineHeight,viewLineCount:Z.viewLineCount,lineNumbersDigitCount:Z.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Z.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Z.fontInfo.maxDigitWidth,pixelRatio:Z.pixelRatio,glyphMarginDecorationLaneCount:Z.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Z){const ve=Z.height/Z.lineHeight,Be=Math.floor(Z.paddingTop/Z.lineHeight);let Ke=Math.floor(Z.paddingBottom/Z.lineHeight);Z.scrollBeyondLastLine&&(Ke=Math.max(Ke,ve-1));const xe=(Be+Z.viewLineCount+Ke)/(Z.pixelRatio*Z.height),ot=Math.floor(Z.viewLineCount/xe);return{typicalViewportLineCount:ve,extraLinesBeforeFirstLine:Be,extraLinesBeyondLastLine:Ke,desiredRatio:xe,minimapLineCount:ot}}static c(Z,ve){const Be=Z.outerWidth,Ke=Z.outerHeight,xe=Z.pixelRatio;if(!Z.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ke),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ke};const ot=ve.stableMinimapLayoutInput,pt=ot&&Z.outerHeight===ot.outerHeight&&Z.lineHeight===ot.lineHeight&&Z.typicalHalfwidthCharacterWidth===ot.typicalHalfwidthCharacterWidth&&Z.pixelRatio===ot.pixelRatio&&Z.scrollBeyondLastLine===ot.scrollBeyondLastLine&&Z.paddingTop===ot.paddingTop&&Z.paddingBottom===ot.paddingBottom&&Z.minimap.enabled===ot.minimap.enabled&&Z.minimap.side===ot.minimap.side&&Z.minimap.size===ot.minimap.size&&Z.minimap.showSlider===ot.minimap.showSlider&&Z.minimap.renderCharacters===ot.minimap.renderCharacters&&Z.minimap.maxColumn===ot.minimap.maxColumn&&Z.minimap.scale===ot.minimap.scale&&Z.verticalScrollbarWidth===ot.verticalScrollbarWidth&&Z.isViewportWrapping===ot.isViewportWrapping,Ne=Z.lineHeight,Pt=Z.typicalHalfwidthCharacterWidth,Kt=Z.scrollBeyondLastLine,zt=Z.minimap.renderCharacters;let yt=xe>=2?Math.round(Z.minimap.scale*2):Z.minimap.scale;const Wt=Z.minimap.maxColumn,Ut=Z.minimap.size,Ht=Z.minimap.side,Gt=Z.verticalScrollbarWidth,Rt=Z.viewLineCount,St=Z.remainingWidth,Xe=Z.isViewportWrapping,Jt=zt?2:3;let Vt=Math.floor(xe*Ke);const ut=Vt/xe;let gt=!1,Zt=!1,It=Jt*yt,Dt=yt/xe,dt=1;if(Ut==="fill"||Ut==="fit"){const{typicalViewportLineCount:Qt,extraLinesBeforeFirstLine:ft,extraLinesBeyondLastLine:De,desiredRatio:Le,minimapLineCount:$e}=ge.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:Kt,paddingTop:Z.paddingTop,paddingBottom:Z.paddingBottom,height:Ke,lineHeight:Ne,pixelRatio:xe});if(Rt/$e>1)gt=!0,Zt=!0,yt=1,It=1,Dt=yt/xe;else{let Me=!1,je=yt+1;if(Ut==="fit"){const Ze=Math.ceil((ft+Rt+De)*It);Xe&&pt&&St<=ve.stableFitRemainingWidth?(Me=!0,je=ve.stableFitMaxMinimapScale):Me=Ze>Vt}if(Ut==="fill"||Me){gt=!0;const Ze=yt;It=Math.min(Ne*xe,Math.max(1,Math.floor(1/Le))),Xe&&pt&&St<=ve.stableFitRemainingWidth&&(je=ve.stableFitMaxMinimapScale),yt=Math.min(je,Math.max(1,Math.floor(It/Jt))),yt>Ze&&(dt=Math.min(2,yt/Ze)),Dt=yt/xe/dt,Vt=Math.ceil(Math.max(Qt,ft+Rt+De)*It),Xe?(ve.stableMinimapLayoutInput=Z,ve.stableFitRemainingWidth=St,ve.stableFitMaxMinimapScale=yt):(ve.stableMinimapLayoutInput=null,ve.stableFitRemainingWidth=0)}}}const At=Math.floor(Wt*Dt),Ot=Math.min(At,Math.max(0,Math.floor((St-Gt-2)*Dt/(Pt+Dt)))+e.MINIMAP_GUTTER_WIDTH);let Et=Math.floor(xe*Ot);const qe=Et/xe;Et=Math.floor(Et*dt);const Mt=zt?1:2,jt=Ht==="left"?0:Be-Ot-Gt;return{renderMinimap:Mt,minimapLeft:jt,minimapWidth:Ot,minimapHeightIsEditorHeight:gt,minimapIsSampling:Zt,minimapScale:yt,minimapLineHeight:It,minimapCanvasInnerWidth:Et,minimapCanvasInnerHeight:Vt,minimapCanvasOuterWidth:qe,minimapCanvasOuterHeight:ut}}static computeLayout(Z,ve){const Be=ve.outerWidth|0,Ke=ve.outerHeight|0,xe=ve.lineHeight|0,ot=ve.lineNumbersDigitCount|0,pt=ve.typicalHalfwidthCharacterWidth,Ne=ve.maxDigitWidth,Pt=ve.pixelRatio,Kt=ve.viewLineCount,zt=Z.get(135),yt=zt==="inherit"?Z.get(134):zt,Wt=yt==="inherit"?Z.get(130):yt,Ut=Z.get(133),Ht=ve.isDominatedByLongLines,Gt=Z.get(57),Rt=Z.get(67).renderType!==0,St=Z.get(68),Xe=Z.get(104),Jt=Z.get(83),Vt=Z.get(72),ut=Z.get(102),gt=ut.verticalScrollbarSize,Zt=ut.verticalHasArrows,It=ut.arrowSize,Dt=ut.horizontalScrollbarSize,dt=Z.get(43),At=Z.get(109)!=="never";let Ot=Z.get(65);dt&&At&&(Ot+=16);let Et=0;if(Rt){const tt=Math.max(ot,St);Et=Math.round(tt*Ne)}let qe=0;Gt&&(qe=xe*ve.glyphMarginDecorationLaneCount);let Mt=0,jt=Mt+qe,Qt=jt+Et,ft=Qt+Ot;const De=Be-qe-Et-Ot;let Le=!1,$e=!1,H=-1;yt==="inherit"&&Ht?(Le=!0,$e=!0):Wt==="on"||Wt==="bounded"?$e=!0:Wt==="wordWrapColumn"&&(H=Ut);const Me=ge.c({outerWidth:Be,outerHeight:Ke,lineHeight:xe,typicalHalfwidthCharacterWidth:pt,pixelRatio:Pt,scrollBeyondLastLine:Xe,paddingTop:Jt.top,paddingBottom:Jt.bottom,minimap:Vt,verticalScrollbarWidth:gt,viewLineCount:Kt,remainingWidth:De,isViewportWrapping:$e},ve.memory||new R);Me.renderMinimap!==0&&Me.minimapLeft===0&&(Mt+=Me.minimapWidth,jt+=Me.minimapWidth,Qt+=Me.minimapWidth,ft+=Me.minimapWidth);const je=De-Me.minimapWidth,Ze=Math.max(1,Math.floor((je-gt-2)/pt)),Ve=Zt?It:0;return $e&&(H=Math.max(1,Ze),Wt==="bounded"&&(H=Math.min(H,Ut))),{width:Be,height:Ke,glyphMarginLeft:Mt,glyphMarginWidth:qe,glyphMarginDecorationLaneCount:ve.glyphMarginDecorationLaneCount,lineNumbersLeft:jt,lineNumbersWidth:Et,decorationsLeft:Qt,decorationsWidth:Ot,contentLeft:ft,contentWidth:je,minimap:Me,viewportColumn:Ze,isWordWrapMinified:Le,isViewportWrapping:$e,wrappingColumn:H,verticalScrollbarWidth:gt,horizontalScrollbarHeight:Dt,overviewRuler:{top:Ve,width:gt,height:Ke-2*Ve,right:0}}}}e.EditorLayoutInfoComputer=ge;class me extends S{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(Z){return r(Z,"simple",["simple","advanced"])}compute(Z,ve,Be){return ve.get(2)===2?"advanced":Be}}class ne extends S{constructor(){const Z={enabled:!0};super(64,"lightbulb",Z,{"editor.lightbulb.enabled":{type:"boolean",default:Z.enabled,description:m.localize(50,null)}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{enabled:s(Z.enabled,this.defaultValue.enabled)}}}class ke extends S{constructor(){const Z={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",Z,{"editor.stickyScroll.enabled":{type:"boolean",default:Z.enabled,description:m.localize(51,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:Z.maxLineCount,minimum:1,maximum:10,description:m.localize(52,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Z.defaultModel,description:m.localize(53,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Z.scrollWithEditor,description:m.localize(54,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(ve.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:r(ve.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:s(ve.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ce extends S{constructor(){const Z={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",Z,{"editor.inlayHints.enabled":{type:"string",default:Z.enabled,description:m.localize(55,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(56,null),m.localize(57,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(58,null,P.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(59,null)]},"editor.inlayHints.fontSize":{type:"number",default:Z.fontSize,markdownDescription:m.localize(60,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Z.fontFamily,markdownDescription:m.localize(61,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Z.padding,description:m.localize(62,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return typeof ve.enabled=="boolean"&&(ve.enabled=ve.enabled?"on":"off"),{enabled:r(ve.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(ve.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(ve.fontFamily,this.defaultValue.fontFamily),padding:s(ve.padding,this.defaultValue.padding)}}}class Y extends S{constructor(){super(65,"lineDecorationsWidth",10)}validate(Z){return typeof Z=="string"&&/^\d+(\.\d+)?ch$/.test(Z)?-parseFloat(Z.substring(0,Z.length-2)):o.clampedInt(Z,this.defaultValue,0,1e3)}compute(Z,ve,Be){return Be<0?o.clampedInt(-Be*Z.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Be}}class W extends h{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Z=>h.clamp(Z,0,150),{markdownDescription:m.localize(63,null)})}compute(Z,ve,Be){return Z.fontInfo.lineHeight}}class re extends S{constructor(){const Z={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",Z,{"editor.minimap.enabled":{type:"boolean",default:Z.enabled,description:m.localize(64,null)},"editor.minimap.autohide":{type:"boolean",default:Z.autohide,description:m.localize(65,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(66,null),m.localize(67,null),m.localize(68,null)],default:Z.size,description:m.localize(69,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Z.side,description:m.localize(70,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Z.showSlider,description:m.localize(71,null)},"editor.minimap.scale":{type:"number",default:Z.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(72,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Z.renderCharacters,description:m.localize(73,null)},"editor.minimap.maxColumn":{type:"number",default:Z.maxColumn,description:m.localize(74,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),autohide:s(ve.autohide,this.defaultValue.autohide),size:r(ve.size,this.defaultValue.size,["proportional","fill","fit"]),side:r(ve.side,this.defaultValue.side,["right","left"]),showSlider:r(ve.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:s(ve.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(ve.scale,1,1,3),maxColumn:o.clampedInt(ve.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Ie(ee){return ee==="ctrlCmd"?P.$j?"metaKey":"ctrlKey":"altKey"}class Ae extends S{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(75,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(76,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{top:o.clampedInt(ve.top,0,0,1e3),bottom:o.clampedInt(ve.bottom,0,0,1e3)}}}class Ce extends S{constructor(){const Z={enabled:!0,cycle:!0};super(85,"parameterHints",Z,{"editor.parameterHints.enabled":{type:"boolean",default:Z.enabled,description:m.localize(77,null)},"editor.parameterHints.cycle":{type:"boolean",default:Z.cycle,description:m.localize(78,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),cycle:s(ve.cycle,this.defaultValue.cycle)}}}class le extends b{constructor(){super(141)}compute(Z,ve,Be){return Z.pixelRatio}}class ie extends S{constructor(){const Z={other:"on",comments:"off",strings:"off"},ve=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(79,null),m.localize(80,null),m.localize(81,null)]}];super(88,"quickSuggestions",Z,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ve,default:Z.strings,description:m.localize(82,null)},comments:{anyOf:ve,default:Z.comments,description:m.localize(83,null)},other:{anyOf:ve,default:Z.other,description:m.localize(84,null)}},default:Z,markdownDescription:m.localize(85,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Z}validate(Z){if(typeof Z=="boolean"){const Pt=Z?"on":"off";return{comments:Pt,strings:Pt,other:Pt}}if(!Z||typeof Z!="object")return this.defaultValue;const{other:ve,comments:Be,strings:Ke}=Z,xe=["on","inline","off"];let ot,pt,Ne;return typeof ve=="boolean"?ot=ve?"on":"off":ot=r(ve,this.defaultValue.other,xe),typeof Be=="boolean"?pt=Be?"on":"off":pt=r(Be,this.defaultValue.comments,xe),typeof Ke=="boolean"?Ne=Ke?"on":"off":Ne=r(Ke,this.defaultValue.strings,xe),{other:ot,comments:pt,strings:Ne}}}var G;(function(ee){ee[ee.Off=0]="Off",ee[ee.On=1]="On",ee[ee.Relative=2]="Relative",ee[ee.Interval=3]="Interval",ee[ee.Custom=4]="Custom"})(G||(e.RenderLineNumbersType=G={}));class te extends S{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(86,null),m.localize(87,null),m.localize(88,null),m.localize(89,null)],default:"on",description:m.localize(90,null)})}validate(Z){let ve=this.defaultValue.renderType,Be=this.defaultValue.renderFn;return typeof Z<"u"&&(typeof Z=="function"?(ve=4,Be=Z):Z==="interval"?ve=3:Z==="relative"?ve=2:Z==="on"?ve=1:ve=0),{renderType:ve,renderFn:Be}}}function x(ee){const Z=ee.get(97);return Z==="editable"?ee.get(90):Z!=="on"}e.filterValidationDecorations=x;class se extends S{constructor(){const Z=[],ve={type:"number",description:m.localize(91,null)};super(101,"rulers",Z,{type:"array",items:{anyOf:[ve,{type:["object"],properties:{column:ve,color:{type:"string",description:m.localize(92,null),format:"color-hex"}}}]},default:Z,description:m.localize(93,null)})}validate(Z){if(Array.isArray(Z)){const ve=[];for(const Be of Z)if(typeof Be=="number")ve.push({column:o.clampedInt(Be,0,0,1e4),color:null});else if(Be&&typeof Be=="object"){const Ke=Be;ve.push({column:o.clampedInt(Ke.column,0,0,1e4),color:Ke.color})}return ve.sort((Be,Ke)=>Be.column-Ke.column),ve}return this.defaultValue}}class fe extends S{constructor(){super(91,"readOnlyMessage",void 0)}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:Z}}function Se(ee,Z){if(typeof ee!="string")return Z;switch(ee){case"hidden":return 2;case"visible":return 3;default:return 1}}class Fe extends S{constructor(){const Z={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",Z,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(94,null),m.localize(95,null),m.localize(96,null)],default:"auto",description:m.localize(97,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(98,null),m.localize(99,null),m.localize(100,null)],default:"auto",description:m.localize(101,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Z.verticalScrollbarSize,description:m.localize(102,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Z.horizontalScrollbarSize,description:m.localize(103,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Z.scrollByPage,description:m.localize(104,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Z.ignoreHorizontalScrollbarInContentHeight,description:m.localize(105,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z,Be=o.clampedInt(ve.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ke=o.clampedInt(ve.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(ve.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Se(ve.vertical,this.defaultValue.vertical),horizontal:Se(ve.horizontal,this.defaultValue.horizontal),useShadows:s(ve.useShadows,this.defaultValue.useShadows),verticalHasArrows:s(ve.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:s(ve.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:s(ve.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:s(ve.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Be,horizontalSliderSize:o.clampedInt(ve.horizontalSliderSize,Be,0,1e3),verticalScrollbarSize:Ke,verticalSliderSize:o.clampedInt(ve.verticalSliderSize,Ke,0,1e3),scrollByPage:s(ve.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:s(ve.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends S{constructor(){const Z={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",Z,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.nonBasicASCII,description:m.localize(106,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Z.invisibleCharacters,description:m.localize(107,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Z.ambiguousCharacters,description:m.localize(108,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeComments,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Z.includeStrings,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Z.allowedCharacters,description:m.localize(111,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Z.allowedLocales,description:m.localize(112,null)}})}applyUpdate(Z,ve){let Be=!1;ve.allowedCharacters&&Z&&(T.$in(Z.allowedCharacters,ve.allowedCharacters)||(Z={...Z,allowedCharacters:ve.allowedCharacters},Be=!0)),ve.allowedLocales&&Z&&(T.$in(Z.allowedLocales,ve.allowedLocales)||(Z={...Z,allowedLocales:ve.allowedLocales},Be=!0));const Ke=super.applyUpdate(Z,ve);return Be?new l(Ke.newValue,!0):Ke}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{nonBasicASCII:Q(ve.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:s(ve.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:s(ve.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Q(ve.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Q(ve.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Z.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Z.allowedLocales,this.defaultValue.allowedLocales)}}c(Z,ve){if(typeof Z!="object"||!Z)return ve;const Be={};for(const[Ke,xe]of Object.entries(Z))xe===!0&&(Be[Ke]=!0);return Be}}class K extends S{constructor(){const Z={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(62,"inlineSuggest",Z,{"editor.inlineSuggest.enabled":{type:"boolean",default:Z.enabled,description:m.localize(113,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Z.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(114,null),m.localize(115,null),m.localize(116,null)],description:m.localize(117,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Z.suppressSuggestions,description:m.localize(118,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),mode:r(ve.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:r(ve.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:s(ve.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:s(ve.keepOnBlur,this.defaultValue.keepOnBlur)}}}class J extends S{constructor(){const Z={enabled:M.$as.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:M.$as.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Z,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(119,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Z.independentColorPoolPerBracketType,description:m.localize(120,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:s(ve.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends S{constructor(){const Z={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Z,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(121,null),m.localize(122,null),m.localize(123,null)],default:Z.bracketPairs,description:m.localize(124,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:Z.bracketPairsHorizontal,description:m.localize(128,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Z.highlightActiveBracketPair,description:m.localize(129,null)},"editor.guides.indentation":{type:"boolean",default:Z.indentation,description:m.localize(130,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(131,null),m.localize(132,null),m.localize(133,null)],default:Z.highlightActiveIndentation,description:m.localize(134,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{bracketPairs:Q(ve.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Q(ve.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:s(ve.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:s(ve.indentation,this.defaultValue.indentation),highlightActiveIndentation:Q(ve.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Q(ee,Z,ve){const Be=ve.indexOf(ee);return Be===-1?Z:ve[Be]}class _ extends S{constructor(){const Z={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",Z,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(135,null),m.localize(136,null)],default:Z.insertMode,description:m.localize(137,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Z.filterGraceful,description:m.localize(138,null)},"editor.suggest.localityBonus":{type:"boolean",default:Z.localityBonus,description:m.localize(139,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Z.shareSuggestSelections,markdownDescription:m.localize(140,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(141,null),m.localize(142,null),m.localize(143,null),m.localize(144,null)],default:Z.selectionMode,markdownDescription:m.localize(145,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Z.snippetsPreventQuickSuggestions,description:m.localize(146,null)},"editor.suggest.showIcons":{type:"boolean",default:Z.showIcons,description:m.localize(147,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Z.showStatusBar,description:m.localize(148,null)},"editor.suggest.preview":{type:"boolean",default:Z.preview,description:m.localize(149,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Z.showInlineDetails,description:m.localize(150,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(151,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(152,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(153,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(154,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(155,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(156,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{insertMode:r(ve.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:s(ve.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:s(ve.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:s(ve.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:s(ve.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:r(ve.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:s(ve.showIcons,this.defaultValue.showIcons),showStatusBar:s(ve.showStatusBar,this.defaultValue.showStatusBar),preview:s(ve.preview,this.defaultValue.preview),previewMode:r(ve.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:s(ve.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:s(ve.showMethods,this.defaultValue.showMethods),showFunctions:s(ve.showFunctions,this.defaultValue.showFunctions),showConstructors:s(ve.showConstructors,this.defaultValue.showConstructors),showDeprecated:s(ve.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:s(ve.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:s(ve.showFields,this.defaultValue.showFields),showVariables:s(ve.showVariables,this.defaultValue.showVariables),showClasses:s(ve.showClasses,this.defaultValue.showClasses),showStructs:s(ve.showStructs,this.defaultValue.showStructs),showInterfaces:s(ve.showInterfaces,this.defaultValue.showInterfaces),showModules:s(ve.showModules,this.defaultValue.showModules),showProperties:s(ve.showProperties,this.defaultValue.showProperties),showEvents:s(ve.showEvents,this.defaultValue.showEvents),showOperators:s(ve.showOperators,this.defaultValue.showOperators),showUnits:s(ve.showUnits,this.defaultValue.showUnits),showValues:s(ve.showValues,this.defaultValue.showValues),showConstants:s(ve.showConstants,this.defaultValue.showConstants),showEnums:s(ve.showEnums,this.defaultValue.showEnums),showEnumMembers:s(ve.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:s(ve.showKeywords,this.defaultValue.showKeywords),showWords:s(ve.showWords,this.defaultValue.showWords),showColors:s(ve.showColors,this.defaultValue.showColors),showFiles:s(ve.showFiles,this.defaultValue.showFiles),showReferences:s(ve.showReferences,this.defaultValue.showReferences),showFolders:s(ve.showFolders,this.defaultValue.showFolders),showTypeParameters:s(ve.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:s(ve.showSnippets,this.defaultValue.showSnippets),showUsers:s(ve.showUsers,this.defaultValue.showUsers),showIssues:s(ve.showIssues,this.defaultValue.showIssues)}}}class Ee extends S{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(183,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(184,null),default:!0,type:"boolean"}})}validate(Z){return!Z||typeof Z!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:s(Z.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:s(Z.selectSubwords,this.defaultValue.selectSubwords)}}}var ze;(function(ee){ee[ee.None=0]="None",ee[ee.Same=1]="Same",ee[ee.Indent=2]="Indent",ee[ee.DeepIndent=3]="DeepIndent"})(ze||(e.WrappingIndent=ze={}));class Qe extends S{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(185,null),m.localize(186,null),m.localize(187,null),m.localize(188,null)],description:m.localize(189,null),default:"same"}})}validate(Z){switch(Z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Z,ve,Be){return ve.get(2)===2?0:Be}}class Je extends b{constructor(){super(144)}compute(Z,ve,Be){const Ke=ve.get(143);return{isDominatedByLongLines:Z.isDominatedByLongLines,isWordWrapMinified:Ke.isWordWrapMinified,isViewportWrapping:Ke.isViewportWrapping,wrappingColumn:Ke.wrappingColumn}}}class Ye extends S{constructor(){const Z={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Z,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(190,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(191,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(192,null),m.localize(193,null)],default:"afterDrop"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),showDropSelector:r(ve.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends S{constructor(){const Z={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",Z,{"editor.pasteAs.enabled":{type:"boolean",default:Z.enabled,markdownDescription:m.localize(194,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterPaste"}})}validate(Z){if(!Z||typeof Z!="object")return this.defaultValue;const ve=Z;return{enabled:s(ve.enabled,this.defaultValue.enabled),showPasteSelector:r(ve.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",_e="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.$j?_e:P.$k?rt:nt,fontWeight:"normal",fontSize:P.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(ee){return e.editorOptionsRegistry[ee.id]=ee,ee}var ct;(function(ee){ee[ee.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ee[ee.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ee[ee.accessibilitySupport=2]="accessibilitySupport",ee[ee.accessibilityPageSize=3]="accessibilityPageSize",ee[ee.ariaLabel=4]="ariaLabel",ee[ee.ariaRequired=5]="ariaRequired",ee[ee.autoClosingBrackets=6]="autoClosingBrackets",ee[ee.autoClosingComments=7]="autoClosingComments",ee[ee.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ee[ee.autoClosingDelete=9]="autoClosingDelete",ee[ee.autoClosingOvertype=10]="autoClosingOvertype",ee[ee.autoClosingQuotes=11]="autoClosingQuotes",ee[ee.autoIndent=12]="autoIndent",ee[ee.automaticLayout=13]="automaticLayout",ee[ee.autoSurround=14]="autoSurround",ee[ee.bracketPairColorization=15]="bracketPairColorization",ee[ee.guides=16]="guides",ee[ee.codeLens=17]="codeLens",ee[ee.codeLensFontFamily=18]="codeLensFontFamily",ee[ee.codeLensFontSize=19]="codeLensFontSize",ee[ee.colorDecorators=20]="colorDecorators",ee[ee.colorDecoratorsLimit=21]="colorDecoratorsLimit",ee[ee.columnSelection=22]="columnSelection",ee[ee.comments=23]="comments",ee[ee.contextmenu=24]="contextmenu",ee[ee.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ee[ee.cursorBlinking=26]="cursorBlinking",ee[ee.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ee[ee.cursorStyle=28]="cursorStyle",ee[ee.cursorSurroundingLines=29]="cursorSurroundingLines",ee[ee.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ee[ee.cursorWidth=31]="cursorWidth",ee[ee.disableLayerHinting=32]="disableLayerHinting",ee[ee.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ee[ee.domReadOnly=34]="domReadOnly",ee[ee.dragAndDrop=35]="dragAndDrop",ee[ee.dropIntoEditor=36]="dropIntoEditor",ee[ee.emptySelectionClipboard=37]="emptySelectionClipboard",ee[ee.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ee[ee.extraEditorClassName=39]="extraEditorClassName",ee[ee.fastScrollSensitivity=40]="fastScrollSensitivity",ee[ee.find=41]="find",ee[ee.fixedOverflowWidgets=42]="fixedOverflowWidgets",ee[ee.folding=43]="folding",ee[ee.foldingStrategy=44]="foldingStrategy",ee[ee.foldingHighlight=45]="foldingHighlight",ee[ee.foldingImportsByDefault=46]="foldingImportsByDefault",ee[ee.foldingMaximumRegions=47]="foldingMaximumRegions",ee[ee.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ee[ee.fontFamily=49]="fontFamily",ee[ee.fontInfo=50]="fontInfo",ee[ee.fontLigatures=51]="fontLigatures",ee[ee.fontSize=52]="fontSize",ee[ee.fontWeight=53]="fontWeight",ee[ee.fontVariations=54]="fontVariations",ee[ee.formatOnPaste=55]="formatOnPaste",ee[ee.formatOnType=56]="formatOnType",ee[ee.glyphMargin=57]="glyphMargin",ee[ee.gotoLocation=58]="gotoLocation",ee[ee.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ee[ee.hover=60]="hover",ee[ee.inDiffEditor=61]="inDiffEditor",ee[ee.inlineSuggest=62]="inlineSuggest",ee[ee.letterSpacing=63]="letterSpacing",ee[ee.lightbulb=64]="lightbulb",ee[ee.lineDecorationsWidth=65]="lineDecorationsWidth",ee[ee.lineHeight=66]="lineHeight",ee[ee.lineNumbers=67]="lineNumbers",ee[ee.lineNumbersMinChars=68]="lineNumbersMinChars",ee[ee.linkedEditing=69]="linkedEditing",ee[ee.links=70]="links",ee[ee.matchBrackets=71]="matchBrackets",ee[ee.minimap=72]="minimap",ee[ee.mouseStyle=73]="mouseStyle",ee[ee.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ee[ee.mouseWheelZoom=75]="mouseWheelZoom",ee[ee.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ee[ee.multiCursorModifier=77]="multiCursorModifier",ee[ee.multiCursorPaste=78]="multiCursorPaste",ee[ee.multiCursorLimit=79]="multiCursorLimit",ee[ee.occurrencesHighlight=80]="occurrencesHighlight",ee[ee.overviewRulerBorder=81]="overviewRulerBorder",ee[ee.overviewRulerLanes=82]="overviewRulerLanes",ee[ee.padding=83]="padding",ee[ee.pasteAs=84]="pasteAs",ee[ee.parameterHints=85]="parameterHints",ee[ee.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ee[ee.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ee[ee.quickSuggestions=88]="quickSuggestions",ee[ee.quickSuggestionsDelay=89]="quickSuggestionsDelay",ee[ee.readOnly=90]="readOnly",ee[ee.readOnlyMessage=91]="readOnlyMessage",ee[ee.renameOnType=92]="renameOnType",ee[ee.renderControlCharacters=93]="renderControlCharacters",ee[ee.renderFinalNewline=94]="renderFinalNewline",ee[ee.renderLineHighlight=95]="renderLineHighlight",ee[ee.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ee[ee.renderValidationDecorations=97]="renderValidationDecorations",ee[ee.renderWhitespace=98]="renderWhitespace",ee[ee.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ee[ee.roundedSelection=100]="roundedSelection",ee[ee.rulers=101]="rulers",ee[ee.scrollbar=102]="scrollbar",ee[ee.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ee[ee.scrollBeyondLastLine=104]="scrollBeyondLastLine",ee[ee.scrollPredominantAxis=105]="scrollPredominantAxis",ee[ee.selectionClipboard=106]="selectionClipboard",ee[ee.selectionHighlight=107]="selectionHighlight",ee[ee.selectOnLineNumbers=108]="selectOnLineNumbers",ee[ee.showFoldingControls=109]="showFoldingControls",ee[ee.showUnused=110]="showUnused",ee[ee.snippetSuggestions=111]="snippetSuggestions",ee[ee.smartSelect=112]="smartSelect",ee[ee.smoothScrolling=113]="smoothScrolling",ee[ee.stickyScroll=114]="stickyScroll",ee[ee.stickyTabStops=115]="stickyTabStops",ee[ee.stopRenderingLineAfter=116]="stopRenderingLineAfter",ee[ee.suggest=117]="suggest",ee[ee.suggestFontSize=118]="suggestFontSize",ee[ee.suggestLineHeight=119]="suggestLineHeight",ee[ee.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ee[ee.suggestSelection=121]="suggestSelection",ee[ee.tabCompletion=122]="tabCompletion",ee[ee.tabIndex=123]="tabIndex",ee[ee.unicodeHighlighting=124]="unicodeHighlighting",ee[ee.unusualLineTerminators=125]="unusualLineTerminators",ee[ee.useShadowDOM=126]="useShadowDOM",ee[ee.useTabStops=127]="useTabStops",ee[ee.wordBreak=128]="wordBreak",ee[ee.wordSeparators=129]="wordSeparators",ee[ee.wordWrap=130]="wordWrap",ee[ee.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ee[ee.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ee[ee.wordWrapColumn=133]="wordWrapColumn",ee[ee.wordWrapOverride1=134]="wordWrapOverride1",ee[ee.wordWrapOverride2=135]="wordWrapOverride2",ee[ee.wrappingIndent=136]="wrappingIndent",ee[ee.wrappingStrategy=137]="wrappingStrategy",ee[ee.showDeprecated=138]="showDeprecated",ee[ee.inlayHints=139]="inlayHints",ee[ee.editorClassName=140]="editorClassName",ee[ee.pixelRatio=141]="pixelRatio",ee[ee.tabFocusMode=142]="tabFocusMode",ee[ee.layoutInfo=143]="layoutInfo",ee[ee.wrappingInfo=144]="wrappingInfo",ee[ee.defaultColorDecorators=145]="defaultColorDecorators",ee[ee.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ee[ee.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(ct||(e.EditorOption=ct={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new t(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(198,null)})),acceptSuggestionOnEnter:Ue(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(199,null),""],markdownDescription:m.localize(200,null)})),accessibilitySupport:Ue(new f),accessibilityPageSize:Ue(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(201,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",m.localize(202,null))),ariaRequired:Ue(new t(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new t(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(203,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new u(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(204,null),m.localize(205,null),""],description:m.localize(206,null)})),autoClosingComments:Ue(new u(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(207,null),m.localize(208,null),""],description:m.localize(209,null)})),autoClosingDelete:Ue(new u(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(210,null),""],description:m.localize(211,null)})),autoClosingOvertype:Ue(new u(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(212,null),""],description:m.localize(213,null)})),autoClosingQuotes:Ue(new u(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(214,null),m.localize(215,null),""],description:m.localize(216,null)})),autoIndent:Ue(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],v,{enumDescriptions:[m.localize(217,null),m.localize(218,null),m.localize(219,null),m.localize(220,null),m.localize(221,null)],description:m.localize(222,null)})),automaticLayout:Ue(new t(13,"automaticLayout",!1)),autoSurround:Ue(new u(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(223,null),m.localize(224,null),m.localize(225,null),""],description:m.localize(226,null)})),bracketPairColorization:Ue(new J),bracketPairGuides:Ue(new B),stickyTabStops:Ue(new t(115,"stickyTabStops",!1,{description:m.localize(227,null)})),codeLens:Ue(new t(17,"codeLens",!0,{description:m.localize(228,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:m.localize(229,null)})),codeLensFontSize:Ue(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(230,null)})),colorDecorators:Ue(new t(20,"colorDecorators",!0,{description:m.localize(231,null)})),colorDecoratorActivatedOn:Ue(new u(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(232,null),m.localize(233,null),m.localize(234,null)],description:m.localize(235,null)})),colorDecoratorsLimit:Ue(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(236,null)})),columnSelection:Ue(new t(22,"columnSelection",!1,{description:m.localize(237,null)})),comments:Ue(new k),contextmenu:Ue(new t(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new t(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(238,null)})),cursorBlinking:Ue(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],p,{description:m.localize(239,null)})),cursorSmoothCaretAnimation:Ue(new u(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(240,null),m.localize(241,null),m.localize(242,null)],description:m.localize(243,null)})),cursorStyle:Ue(new d(28,"cursorStyle",y.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:m.localize(244,null)})),cursorSurroundingLines:Ue(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(245,null)})),cursorSurroundingLinesStyle:Ue(new u(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(246,null),m.localize(247,null)],markdownDescription:m.localize(248,null)})),cursorWidth:Ue(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(249,null)})),disableLayerHinting:Ue(new t(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new t(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new t(34,"domReadOnly",!1)),dragAndDrop:Ue(new t(35,"dragAndDrop",!0,{description:m.localize(250,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new Ye),stickyScroll:Ue(new ke),experimentalWhitespaceRendering:Ue(new u(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(251,null),m.localize(252,null),m.localize(253,null)],description:m.localize(254,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new h(40,"fastScrollSensitivity",5,ee=>ee<=0?5:ee,{markdownDescription:m.localize(255,null)})),find:Ue(new U),fixedOverflowWidgets:Ue(new t(42,"fixedOverflowWidgets",!1)),folding:Ue(new t(43,"folding",!0,{description:m.localize(256,null)})),foldingStrategy:Ue(new u(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(257,null),m.localize(258,null)],description:m.localize(259,null)})),foldingHighlight:Ue(new t(45,"foldingHighlight",!0,{description:m.localize(260,null)})),foldingImportsByDefault:Ue(new t(46,"foldingImportsByDefault",!1,{description:m.localize(261,null)})),foldingMaximumRegions:Ue(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(262,null)})),unfoldOnClickAfterEndOfLine:Ue(new t(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(263,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(264,null)})),fontInfo:Ue(new I),fontLigatures2:Ue(new F),fontSize:Ue(new X),fontWeight:Ue(new ue),fontVariations:Ue(new C),formatOnPaste:Ue(new t(55,"formatOnPaste",!1,{description:m.localize(265,null)})),formatOnType:Ue(new t(56,"formatOnType",!1,{description:m.localize(266,null)})),glyphMargin:Ue(new t(57,"glyphMargin",!0,{description:m.localize(267,null)})),gotoLocation:Ue(new he),hideCursorInOverviewRuler:Ue(new t(59,"hideCursorInOverviewRuler",!1,{description:m.localize(268,null)})),hover:Ue(new be),inDiffEditor:Ue(new t(61,"inDiffEditor",!1)),letterSpacing:Ue(new h(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ee=>h.clamp(ee,-5,20),{description:m.localize(269,null)})),lightbulb:Ue(new ne),lineDecorationsWidth:Ue(new Y),lineHeight:Ue(new W),lineNumbers:Ue(new te),lineNumbersMinChars:Ue(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new t(69,"linkedEditing",!1,{description:m.localize(270,null)})),links:Ue(new t(70,"links",!0,{description:m.localize(271,null)})),matchBrackets:Ue(new u(71,"matchBrackets","always",["always","near","never"],{description:m.localize(272,null)})),minimap:Ue(new re),mouseStyle:Ue(new u(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new h(74,"mouseWheelScrollSensitivity",1,ee=>ee===0?1:ee,{markdownDescription:m.localize(273,null)})),mouseWheelZoom:Ue(new t(75,"mouseWheelZoom",!1,{markdownDescription:m.localize(274,null)})),multiCursorMergeOverlapping:Ue(new t(76,"multiCursorMergeOverlapping",!0,{description:m.localize(275,null)})),multiCursorModifier:Ue(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Ie,{markdownEnumDescriptions:[m.localize(276,null),m.localize(277,null)],markdownDescription:m.localize(278,null)})),multiCursorPaste:Ue(new u(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(279,null),m.localize(280,null)],markdownDescription:m.localize(281,null)})),multiCursorLimit:Ue(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(282,null)})),occurrencesHighlight:Ue(new u(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(283,null),m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),overviewRulerBorder:Ue(new t(81,"overviewRulerBorder",!0,{description:m.localize(287,null)})),overviewRulerLanes:Ue(new o(82,"overviewRulerLanes",3,0,3)),padding:Ue(new Ae),pasteAs:Ue(new it),parameterHints:Ue(new Ce),peekWidgetDefaultFocus:Ue(new u(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(288,null),m.localize(289,null)],description:m.localize(290,null)})),definitionLinkOpensInPeek:Ue(new t(87,"definitionLinkOpensInPeek",!1,{description:m.localize(291,null)})),quickSuggestions:Ue(new ie),quickSuggestionsDelay:Ue(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(292,null)})),readOnly:Ue(new t(90,"readOnly",!1)),readOnlyMessage:Ue(new fe),renameOnType:Ue(new t(92,"renameOnType",!1,{description:m.localize(293,null),markdownDeprecationMessage:m.localize(294,null)})),renderControlCharacters:Ue(new t(93,"renderControlCharacters",!0,{description:m.localize(295,null),restricted:!0})),renderFinalNewline:Ue(new u(94,"renderFinalNewline",P.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(296,null)})),renderLineHighlight:Ue(new u(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(297,null)],description:m.localize(298,null)})),renderLineHighlightOnlyWhenFocus:Ue(new t(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(299,null)})),renderValidationDecorations:Ue(new u(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new u(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(300,null),m.localize(301,null),m.localize(302,null),""],description:m.localize(303,null)})),revealHorizontalRightPadding:Ue(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new t(100,"roundedSelection",!0,{description:m.localize(304,null)})),rulers:Ue(new se),scrollbar:Ue(new Fe),scrollBeyondLastColumn:Ue(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(305,null)})),scrollBeyondLastLine:Ue(new t(104,"scrollBeyondLastLine",!0,{description:m.localize(306,null)})),scrollPredominantAxis:Ue(new t(105,"scrollPredominantAxis",!0,{description:m.localize(307,null)})),selectionClipboard:Ue(new t(106,"selectionClipboard",!0,{description:m.localize(308,null),included:P.$k})),selectionHighlight:Ue(new t(107,"selectionHighlight",!0,{description:m.localize(309,null)})),selectOnLineNumbers:Ue(new t(108,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new u(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(310,null),m.localize(311,null),m.localize(312,null)],description:m.localize(313,null)})),showUnused:Ue(new t(110,"showUnused",!0,{description:m.localize(314,null)})),showDeprecated:Ue(new t(138,"showDeprecated",!0,{description:m.localize(315,null)})),inlayHints:Ue(new ce),snippetSuggestions:Ue(new u(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(316,null),m.localize(317,null),m.localize(318,null),m.localize(319,null)],description:m.localize(320,null)})),smartSelect:Ue(new Ee),smoothScrolling:Ue(new t(113,"smoothScrolling",!1,{description:m.localize(321,null)})),stopRenderingLineAfter:Ue(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new _),inlineSuggest:Ue(new K),inlineCompletionsAccessibilityVerbose:Ue(new t(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(322,null)})),suggestFontSize:Ue(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(323,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(324,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new t(120,"suggestOnTriggerCharacters",!0,{description:m.localize(325,null)})),suggestSelection:Ue(new u(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(326,null),m.localize(327,null),m.localize(328,null)],description:m.localize(329,null)})),tabCompletion:Ue(new u(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(330,null),m.localize(331,null),m.localize(332,null)],description:m.localize(333,null)})),tabIndex:Ue(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new O),unusualLineTerminators:Ue(new u(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(334,null),m.localize(335,null),m.localize(336,null)],description:m.localize(337,null)})),useShadowDOM:Ue(new t(126,"useShadowDOM",!0)),useTabStops:Ue(new t(127,"useTabStops",!0,{description:m.localize(338,null)})),wordBreak:Ue(new u(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(339,null),m.localize(340,null)],description:m.localize(341,null)})),wordSeparators:Ue(new i(129,"wordSeparators",A.$bs,{description:m.localize(342,null)})),wordWrap:Ue(new u(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(343,null),m.localize(344,null),m.localize(345,null),m.localize(346,null)],description:m.localize(347,null)})),wordWrapBreakAfterCharacters:Ue(new i(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(348,null)})),wordWrapOverride1:Ue(new u(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new u(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new q),defaultColorDecorators:Ue(new t(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(349,null)})),pixelRatio:Ue(new le),tabFocusMode:Ue(new t(142,"tabFocusMode",!1,{markdownDescription:m.localize(350,null)})),layoutInfo:Ue(new ge),wrappingInfo:Ue(new Je),wrappingIndent:Ue(new Qe),wrappingStrategy:Ue(new me)}}),define(Pe[147],Re([9,10]),function(pe,e){return pe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[148],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[149],Re([9,10]),function(pe,e){return pe.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[150],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[151],Re([9,10]),function(pe,e){return pe.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[152],Re([9,10]),function(pe,e){return pe.create("vs/platform/files/common/files",e)}),define(Pe[153],Re([9,10]),function(pe,e){return pe.create("vs/platform/markers/common/markers",e)}),define(Pe[154],Re([9,10]),function(pe,e){return pe.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[155],Re([9,10]),function(pe,e){return pe.create("vs/platform/workspace/common/workspace",e)}),define(Pe[156],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Pe[157],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[158],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[159],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[160],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[161],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostNotebook",e)}),define(Pe[162],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[163],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[164],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[165],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[166],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[167],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Pe[168],Re([9,10]),function(pe,e){return pe.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[169],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/configuration",e)}),define(Pe[170],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/editor",e)}),define(Pe[171],Re([9,10]),function(pe,e){return pe.create("vs/workbench/common/views",e)}),define(Pe[172],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[173],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[174],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[175],Re([9,10]),function(pe,e){return pe.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[176],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[177],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Pe[178],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[179],Re([9,10]),function(pe,e){return pe.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[180],Re([1,0,11,149]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.TokenType=void 0;var P;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(P||(e.TokenType=P={}));function M(...w){switch(w.length){case 1:return(0,T.localize)(0,null,w[0]);case 2:return(0,T.localize)(1,null,w[0],w[1]);case 3:return(0,T.localize)(2,null,w[0],w[1],w[2]);default:return}}const A=(0,T.localize)(3,null),m=(0,T.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,E.$7)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(M("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(M("&&"));break;case 124:this.h(124)?this.k(16):this.l(M("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const S=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:S,lexeme:l,additionalInfo:R}),this.f.push($)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const S=this.c.substring(this.d,this.e),l=g.b.get(S);l?this.k(l):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,S=!1,l=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(m);return}const b=this.c.charCodeAt(R);if(S)S=!1;else if(b===47&&!l){R++;break}else b===91?l=!0:b===92?S=!0:b===93&&(l=!1);R++}for(;R<this.c.length&&g.a.has(this.c.charCodeAt(R));)R++;this.e=R;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$Ui=g}),define(Pe[181],Re([1,0,25,31,151,293]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function g(t){return t=t.trim(),t==="*"||A.test(t)}e.$Vo=g;function w(t){if(!g(t))return null;if(t=t.trim(),t==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=t.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}e.$Wo=w;function R(t){if(!t)return null;const n=t.majorBase,o=t.majorMustEqual,c=t.minorBase;let h=t.minorMustEqual;const i=t.patchBase;let r=t.patchMustEqual;t.hasCaret&&(n===0||(h=!1),r=!1);let u=0;if(t.preRelease){const d=m.exec(t.preRelease);if(d){const[,v,f,k]=d;u=Date.UTC(Number(v),Number(f)-1,Number(k))}}return{majorBase:n,majorMustEqual:o,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:r,isMinimum:t.hasGreaterEquals,notBefore:u}}e.$Xo=R;function S(t,n,o){let c;typeof t=="string"?c=R(w(t)):c=t;let h;n instanceof Date?h=n.getTime():typeof n=="string"&&(h=new Date(n).getTime());let i;if(typeof o=="string"?i=R(w(o)):i=o,!c||!i)return!1;const r=c.majorBase,u=c.minorBase,d=c.patchBase;let v=i.majorBase,f=i.minorBase,k=i.patchBase;const L=i.notBefore;let p=i.majorMustEqual,y=i.minorMustEqual,D=i.patchMustEqual;return i.isMinimum?r>v?!0:r<v?!1:u>f?!0:u<f||h&&h<L?!1:d>=k:(r===1&&v===0&&(!p||!y||!D)&&(v=1,f=0,k=0,p=!0,y=!1,D=!1),r<v?!1:r>v?!p:u<f?!1:u>f?!y:d<k?!1:d>k?!D:!(h&&h<L))}e.$Yo=S;function l(t,n,o,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([T.default.Error,P.localize(0,null)]),i;if(typeof c.name!="string")return i.push([T.default.Error,P.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([T.default.Error,P.localize(2,null,"version")]),i;if(!c.engines)return i.push([T.default.Error,P.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([T.default.Error,P.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!s(c.extensionDependencies))return i.push([T.default.Error,P.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!s(c.activationEvents))return i.push([T.default.Error,P.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([T.default.Error,P.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([T.default.Warning,P.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([T.default.Error,P.localize(9,null,"main")]),i;{const d=(0,E.$Bg)(o,c.main);(0,E.$vg)(d,o)||i.push([T.default.Warning,P.localize(10,null,d.path,o.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([T.default.Error,P.localize(11,null,"browser")]),i;{const d=(0,E.$Bg)(o,c.browser);(0,E.$vg)(d,o)||i.push([T.default.Warning,P.localize(12,null,d.path,o.path)])}}if(!M.valid(c.version))return i.push([T.default.Error,P.localize(13,null)]),i;const r=[];if(!$(t,n,c,h,r))for(const d of r)i.push([T.default.Error,d]);return i}e.$Zo=l;function $(t,n,o,c,h){return c||typeof o.main>"u"&&typeof o.browser>"u"?!0:a(t,n,o.engines.vscode,h)}e.$1o=$;function b(t,n,o){return t==="*"||a(n,o,t)}e.$2o=b;function a(t,n,o,c=[]){const h=R(w(o));if(!h)return c.push(P.localize(14,null,o)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(P.localize(15,null,o)),!1}else if(!h.majorMustEqual)return c.push(P.localize(16,null,o)),!1;return S(t,n,h)?!0:(c.push(P.localize(17,null,t,o)),!1)}function s(t){if(!Array.isArray(t))return!1;for(let n=0,o=t.length;n<o;n++)if(typeof t[n]!="string")return!1;return!0}}),define(Pe[69],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wh=void 0;class E{constructor(P,M=[],A=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=A}}e.$Wh=E}),define(Pe[70],Re([1,0,69]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.InstantiationType=void 0;const T=[];var P;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(P||(e.InstantiationType=P={}));function M(m,g,w){g instanceof E.$Wh||(g=new E.$Wh(g,[],!!w)),T.push([m,g])}e.$Gr=M;function A(){return T}e.$Hr=A}),define(Pe[182],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mq=e.$lq=void 0;class E{constructor(M,A){this.key=M,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$lq=E;class T{constructor(M){this.b=M,this.a=new Map}roots(){const M=[];for(const A of this.a.values())A.outgoing.size===0&&M.push(A);return M}insertEdge(M,A){const m=this.lookupOrInsertNode(M),g=this.lookupOrInsertNode(A);m.outgoing.set(g.key,g),g.incoming.set(m.key,m)}removeNode(M){const A=this.b(M);this.a.delete(A);for(const m of this.a.values())m.outgoing.delete(A),m.incoming.delete(A)}lookupOrInsertNode(M){const A=this.b(M);let m=this.a.get(A);return m||(m=new E(A,M),this.a.set(A,m)),m}lookup(M){return this.a.get(this.b(M))}isEmpty(){return this.a.size===0}toString(){const M=[];for(const[A,m]of this.a)M.push(`${A}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return M.join(`
`)}findCycleSlow(){for(const[M,A]of this.a){const m=new Set([M]),g=this.c(A,m);if(g)return g}}c(M,A){for(const[m,g]of M.outgoing){if(A.has(m))return[...A,m].join(" -> ");A.add(m);const w=this.c(g,A);if(w)return w;A.delete(m)}}}e.$mq=T}),define(Pe[4],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1h=e.$Zh=e.$Yh=e._util=void 0;var E;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function m(g){return g[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=m})(E||(e._util=E={})),e.$Yh=P("instantiationService");function T(A,m,g){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:A,index:g}):(m[E.DI_DEPENDENCIES]=[{id:A,index:g}],m[E.DI_TARGET]=m)}function P(A){if(E.serviceIds.has(A))return E.serviceIds.get(A);const m=function(g,w,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(m,g,R)};return m.toString=()=>A,E.serviceIds.set(A,m),m}e.$Zh=P;function M(A){return A}e.$1h=M}),define(Pe[41],Re([1,0,16,2,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.ConfigurationTarget=e.$vi=e.$ui=e.$ti=void 0,e.$ti=(0,P.$Zh)("configurationService");function M(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof T.URI)}e.$ui=M;function A(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof T.URI)}e.$vi=A;var m;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function g(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$wi=g;function w(t){return t.applicationValue!==void 0||t.userValue!==void 0||t.userLocalValue!==void 0||t.userRemoteValue!==void 0||t.workspaceValue!==void 0||t.workspaceFolderValue!==void 0}e.$xi=w;function R(t,n){const o=Object.create(null);for(const c in t)S(o,c,t[c],n);return o}e.$yi=R;function S(t,n,o,c){const h=n.split("."),i=h.pop();let r=t;for(let u=0;u<h.length;u++){const d=h[u];let v=r[d];switch(typeof v){case"undefined":v=r[d]=Object.create(null);break;case"object":break;default:c(`Ignoring ${n} as ${h.slice(0,u+1).join(".")} is ${JSON.stringify(v)}`);return}r=v}if(typeof r=="object"&&r!==null)try{r[i]=o}catch{c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}else c(`Ignoring ${n} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.$zi=S;function l(t,n){const o=n.split(".");$(t,o)}e.$Ai=l;function $(t,n){const o=n.shift();if(n.length===0){delete t[o];return}if(Object.keys(t).indexOf(o)!==-1){const c=t[o];typeof c=="object"&&!Array.isArray(c)&&($(c,n),Object.keys(c).length===0&&delete t[o])}}function b(t,n,o){function c(r,u){let d=r;for(const v of u){if(typeof d!="object"||d===null)return;d=d[v]}return d}const h=n.split("."),i=c(t,h);return typeof i>"u"?o:i}e.$Bi=b;function a(t,n,o){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in t?E.$Ef(t[c])&&E.$Ef(n[c])?a(t[c],n[c],o):o&&(t[c]=n[c]):t[c]=n[c])})}e.$Ci=a;function s(t){return t.replace(/[\[\]]/g,"")}e.$Di=s}),define(Pe[35],Re([1,0,21,12,180,4,148,11]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.$2i=e.$1i=e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.ContextKeyExprType=e.$Vi=void 0;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",E.$j),g.set("isLinux",E.$k),g.set("isWindows",E.$i),g.set("isWeb",E.$o),g.set("isMacNative",E.$j&&!E.$o),g.set("isEdge",E.$H),g.set("isFirefox",E.$F),g.set("isChrome",E.$E),g.set("isSafari",E.$G);function w(Y,W){if(g.get(Y)!==void 0)throw(0,m.$6)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(Y,W)}e.$Vi=w;const R=Object.prototype.hasOwnProperty;var S;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const l={regexParsingWithErrorRecovery:!0},$=(0,A.localize)(0,null),b=(0,A.localize)(1,null),a=(0,A.localize)(2,null),s=(0,A.localize)(3,null),t=(0,A.localize)(4,null),n=(0,A.localize)(5,null),o=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(W=l){this.k=W,this.d=new P.$Ui,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(W){if(W===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(W).scan(),this.g=0,this.h=[];try{const re=this.l();if(!this.E()){const Ie=this.D(),Ae=Ie.type===17?n:void 0;throw this.h.push({message:t,offset:Ie.offset,lexeme:P.$Ui.getLexeme(Ie),additionalInfo:Ae}),h.c}return re}catch(re){if(re!==h.c)throw re;return}}l(){return this.m()}m(){const W=[this.o()];for(;this.y(16);){const re=this.o();W.push(re)}return W.length===1?W[0]:i.or(...W)}o(){const W=[this.s()];for(;this.y(15);){const re=this.s();W.push(re)}return W.length===1?W[0]:i.and(...W)}s(){if(this.y(2)){const W=this.D();switch(W.type){case 11:return this.z(),v.INSTANCE;case 12:return this.z(),f.INSTANCE;case 0:{this.z();const re=this.l();return this.A(1,s),re?.negate()}case 17:return this.z(),N.create(W.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",W)}}return this.t()}t(){const W=this.D();switch(W.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const re=this.l();return this.A(1,s),re}case 17:{const re=W.lexeme;if(this.z(),this.y(9)){const Ae=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ae.type!==10)throw this.B("REGEX",Ae);const Ce=Ae.lexeme,le=Ce.lastIndexOf("/"),ie=le===Ce.length-1?void 0:this.w(Ce.substring(le+1));let G;try{G=new RegExp(Ce.substring(1,le),ie)}catch{throw this.B("REGEX",Ae)}return I.create(re,G)}switch(Ae.type){case 10:case 19:{const Ce=[Ae.lexeme];this.z();let le=this.D(),ie=0;for(let fe=0;fe<Ae.lexeme.length;fe++)Ae.lexeme.charCodeAt(fe)===40?ie++:Ae.lexeme.charCodeAt(fe)===41&&ie--;for(;!this.E()&&le.type!==15&&le.type!==16;){switch(le.type){case 0:ie++;break;case 1:ie--;break;case 10:case 18:for(let fe=0;fe<le.lexeme.length;fe++)le.lexeme.charCodeAt(fe)===40?ie++:Ae.lexeme.charCodeAt(fe)===41&&ie--}if(ie<0)break;Ce.push(P.$Ui.getLexeme(le)),this.z(),le=this.D()}const G=Ce.join(""),te=G.lastIndexOf("/"),x=te===G.length-1?void 0:this.w(G.substring(te+1));let se;try{se=new RegExp(G.substring(1,te),x)}catch{throw this.B("REGEX",Ae)}return i.regex(re,se)}case 18:{const Ce=Ae.lexeme;this.z();let le=null;if(!(0,T.$Fe)(Ce)){const ie=Ce.indexOf("/"),G=Ce.lastIndexOf("/");if(ie!==G&&ie>=0){const te=Ce.slice(ie+1,G),x=Ce[G+1]==="i"?"i":"";try{le=new RegExp(te,x)}catch{throw this.B("REGEX",Ae)}}}if(le===null)throw this.B("REGEX",Ae);return I.create(re,le)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,a);const Ae=this.u();return i.notIn(re,Ae)}switch(this.D().type){case 3:{this.z();const Ae=this.u();if(this.x().type===18)return i.equals(re,Ae);switch(Ae){case"true":return i.has(re);case"false":return i.not(re);default:return i.equals(re,Ae)}}case 4:{this.z();const Ae=this.u();if(this.x().type===18)return i.notEquals(re,Ae);switch(Ae){case"true":return i.not(re);case"false":return i.has(re);default:return i.notEquals(re,Ae)}}case 5:return this.z(),F.create(re,this.u());case 6:return this.z(),C.create(re,this.u());case 7:return this.z(),V.create(re,this.u());case 8:return this.z(),U.create(re,this.u());case 13:return this.z(),i.in(re,this.u());default:return i.has(re)}}case 20:throw this.h.push({message:o,offset:W.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const W=this.D();switch(W.type){case 17:case 18:return this.z(),W.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(W){return W.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(W){return this.C(W)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(W,re){if(this.C(W))return this.z();throw this.B(re,this.D())}B(W,re,Ie){const Ae=(0,A.localize)(8,null,W,P.$Ui.getLexeme(re)),Ce=re.offset,le=P.$Ui.getLexeme(re);return this.h.push({message:Ae,offset:Ce,lexeme:le,additionalInfo:Ie}),h.c}C(W){return this.D().type===W}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$Wi=h;class i{static false(){return v.INSTANCE}static true(){return f.INSTANCE}static has(W){return k.create(W)}static equals(W,re){return L.create(W,re)}static notEquals(W,re){return D.create(W,re)}static regex(W,re){return I.create(W,re)}static in(W,re){return p.create(W,re)}static notIn(W,re){return y.create(W,re)}static not(W){return N.create(W)}static and(...W){return he.create(W,null,!0)}static or(...W){return be.create(W,null,!0)}static greater(W,re){return V.create(W,re)}static greaterEquals(W,re){return U.create(W,re)}static smaller(W,re){return F.create(W,re)}static smallerEquals(W,re){return C.create(W,re)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(W){return W==null?void 0:this.c.parse(W)}}e.$Xi=i;function r(Y){const W=new h({regexParsingWithErrorRecovery:!1});return Y.map(re=>(W.parse(re),W.lexingErrors.length>0?W.lexingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?(0,A.localize)(9,null,Ie.additionalInfo):(0,A.localize)(10,null),offset:Ie.offset,length:Ie.lexeme.length})):W.parsingErrors.length>0?W.parsingErrors.map(Ie=>({errorMessage:Ie.additionalInfo?`${Ie.message}. ${Ie.additionalInfo}`:Ie.message,offset:Ie.offset,length:Ie.lexeme.length})):[]))}e.$Yi=r;function u(Y,W){const re=Y?Y.substituteConstants():void 0,Ie=W?W.substituteConstants():void 0;return!re&&!Ie?!0:!re||!Ie?!1:re.equals(Ie)}e.$Zi=u;function d(Y,W){return Y.cmp(W)}class v{static{this.INSTANCE=new v}constructor(){this.type=0}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!1}serialize(){return"false"}keys(){return[]}map(W){return this}negate(){return f.INSTANCE}}e.$1i=v;class f{static{this.INSTANCE=new f}constructor(){this.type=1}cmp(W){return this.type-W.type}equals(W){return W.type===this.type}substituteConstants(){return this}evaluate(W){return!0}serialize(){return"true"}keys(){return[]}map(W){return this}negate(){return v.INSTANCE}}e.$2i=f;class k{static create(W,re=null){const Ie=g.get(W);return typeof Ie=="boolean"?Ie?f.INSTANCE:v.INSTANCE:new k(W,re)}constructor(W,re){this.key=W,this.c=re,this.type=2}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.key,W.key)}equals(W){return W.type===this.type?this.key===W.key:!1}substituteConstants(){const W=g.get(this.key);return typeof W=="boolean"?W?f.INSTANCE:v.INSTANCE:this}evaluate(W){return!!W.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(W){return W.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.$3i=k;class L{static create(W,re,Ie=null){if(typeof re=="boolean")return re?k.create(W,Ie):N.create(W,Ie);const Ae=g.get(W);return typeof Ae=="boolean"?re===(Ae?"true":"false")?f.INSTANCE:v.INSTANCE:new L(W,re,Ie)}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=4}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=g.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?f.INSTANCE:v.INSTANCE}return this}evaluate(W){return W.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(W){return W.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$4i=L;class p{static create(W,re){return new p(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=10,this.c=null}cmp(W){return W.type!==this.type?this.type-W.type:me(this.d,this.f,W.d,W.f)}equals(W){return W.type===this.type?this.d===W.d&&this.f===W.f:!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.f),Ie=W.getValue(this.d);return Array.isArray(re)?re.includes(Ie):typeof Ie=="string"&&typeof re=="object"&&re!==null?R.call(re,Ie):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(W){return W.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$5i=p;class y{static create(W,re){return new y(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=11,this.c=p.create(W,re)}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(W){return W.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$6i=y;class D{static create(W,re,Ie=null){if(typeof re=="boolean")return re?N.create(W,Ie):k.create(W,Ie);const Ae=g.get(W);return typeof Ae=="boolean"?re===(Ae?"true":"false")?v.INSTANCE:f.INSTANCE:new D(W,re,Ie)}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=5}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){const W=g.get(this.c);if(typeof W=="boolean"){const re=W?"true":"false";return this.d===re?v.INSTANCE:f.INSTANCE}return this}evaluate(W){return W.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(W){return W.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=L.create(this.c,this.d,this)),this.f}}e.$7i=D;class N{static create(W,re=null){const Ie=g.get(W);return typeof Ie=="boolean"?Ie?v.INSTANCE:f.INSTANCE:new N(W,re)}constructor(W,re){this.c=W,this.d=re,this.type=3}cmp(W){return W.type!==this.type?this.type-W.type:ge(this.c,W.c)}equals(W){return W.type===this.type?this.c===W.c:!1}substituteConstants(){const W=g.get(this.c);return typeof W=="boolean"?W?v.INSTANCE:f.INSTANCE:this}evaluate(W){return!W.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(W){return W.mapNot(this.c)}negate(){return this.d||(this.d=k.create(this.c,this)),this.d}}e.$8i=N;function q(Y,W){if(typeof Y=="string"){const re=parseFloat(Y);isNaN(re)||(Y=re)}return typeof Y=="string"||typeof Y=="number"?W(Y):v.INSTANCE}class V{static create(W,re,Ie=null){return q(re,Ae=>new V(W,Ae,Ie))}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=12}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$9i=V;class U{static create(W,re,Ie=null){return q(re,Ae=>new U(W,Ae,Ie))}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=13}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(W){return W.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$0i=U;class F{static create(W,re,Ie=null){return q(re,Ae=>new F(W,Ae,Ie))}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=14}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$$i=F;class C{static create(W,re,Ie=null){return q(re,Ae=>new C(W,Ae,Ie))}constructor(W,re,Ie){this.c=W,this.d=re,this.f=Ie,this.type=15}cmp(W){return W.type!==this.type?this.type-W.type:me(this.c,this.d,W.c,W.d)}equals(W){return W.type===this.type?this.c===W.c&&this.d===W.d:!1}substituteConstants(){return this}evaluate(W){return typeof this.d=="string"?!1:parseFloat(W.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(W){return W.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$_i=C;class I{static create(W,re){return new I(W,re)}constructor(W,re){this.d=W,this.f=re,this.type=7,this.c=null}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.d<W.d)return-1;if(this.d>W.d)return 1;const re=this.f?this.f.source:"",Ie=W.f?W.f.source:"";return re<Ie?-1:re>Ie?1:0}equals(W){if(W.type===this.type){const re=this.f?this.f.source:"",Ie=W.f?W.f.source:"";return this.d===W.d&&re===Ie}return!1}substituteConstants(){return this}evaluate(W){const re=W.getValue(this.d);return this.f?this.f.test(re):!1}serialize(){const W=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${W}`}keys(){return[this.d]}map(W){return W.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=X.create(this)),this.c}}e.$aj=I;class X{static create(W){return new X(W)}constructor(W){this.c=W,this.type=8}cmp(W){return W.type!==this.type?this.type-W.type:this.c.cmp(W.c)}equals(W){return W.type===this.type?this.c.equals(W.c):!1}substituteConstants(){return this}evaluate(W){return!this.c.evaluate(W)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(W){return new X(this.c.map(W))}negate(){return this.c}}e.$bj=X;function ue(Y){let W=null;for(let re=0,Ie=Y.length;re<Ie;re++){const Ae=Y[re].substituteConstants();if(Y[re]!==Ae&&W===null){W=[];for(let Ce=0;Ce<re;Ce++)W[Ce]=Y[Ce]}W!==null&&(W[re]=Ae)}return W===null?Y:W}class he{static create(W,re,Ie){return he.d(W,re,Ie)}constructor(W,re){this.expr=W,this.c=re,this.type=6}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,Ie=this.expr.length;re<Ie;re++){const Ae=d(this.expr[re],W.expr[re]);if(Ae!==0)return Ae}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=ue(this.expr);return W===this.expr?this:he.create(W,this.c,!1)}evaluate(W){for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].evaluate(W))return!1;return!0}static d(W,re,Ie){const Ae=[];let Ce=!1;for(const le of W)if(le){if(le.type===1){Ce=!0;continue}if(le.type===0)return v.INSTANCE;if(le.type===6){Ae.push(...le.expr);continue}Ae.push(le)}if(Ae.length===0&&Ce)return f.INSTANCE;if(Ae.length!==0){if(Ae.length===1)return Ae[0];Ae.sort(d);for(let le=1;le<Ae.length;le++)Ae[le-1].equals(Ae[le])&&(Ae.splice(le,1),le--);if(Ae.length===1)return Ae[0];for(;Ae.length>1;){const le=Ae[Ae.length-1];if(le.type!==9)break;Ae.pop();const ie=Ae.pop(),G=Ae.length===0,te=be.create(le.expr.map(x=>he.create([x,ie],null,Ie)),null,G);te&&(Ae.push(te),Ae.sort(d))}if(Ae.length===1)return Ae[0];if(Ie){for(let le=0;le<Ae.length;le++)for(let ie=le+1;ie<Ae.length;ie++)if(Ae[le].negate().equals(Ae[ie]))return v.INSTANCE;if(Ae.length===1)return Ae[0]}return new he(Ae,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" && ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new he(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());this.c=be.create(W,this,!0)}return this.c}}e.$cj=he;class be{static create(W,re,Ie){return be.d(W,re,Ie)}constructor(W,re){this.expr=W,this.c=re,this.type=9}cmp(W){if(W.type!==this.type)return this.type-W.type;if(this.expr.length<W.expr.length)return-1;if(this.expr.length>W.expr.length)return 1;for(let re=0,Ie=this.expr.length;re<Ie;re++){const Ae=d(this.expr[re],W.expr[re]);if(Ae!==0)return Ae}return 0}equals(W){if(W.type===this.type){if(this.expr.length!==W.expr.length)return!1;for(let re=0,Ie=this.expr.length;re<Ie;re++)if(!this.expr[re].equals(W.expr[re]))return!1;return!0}return!1}substituteConstants(){const W=ue(this.expr);return W===this.expr?this:be.create(W,this.c,!1)}evaluate(W){for(let re=0,Ie=this.expr.length;re<Ie;re++)if(this.expr[re].evaluate(W))return!0;return!1}static d(W,re,Ie){let Ae=[],Ce=!1;if(W){for(let le=0,ie=W.length;le<ie;le++){const G=W[le];if(G){if(G.type===0){Ce=!0;continue}if(G.type===1)return f.INSTANCE;if(G.type===9){Ae=Ae.concat(G.expr);continue}Ae.push(G)}}if(Ae.length===0&&Ce)return v.INSTANCE;Ae.sort(d)}if(Ae.length!==0){if(Ae.length===1)return Ae[0];for(let le=1;le<Ae.length;le++)Ae[le-1].equals(Ae[le])&&(Ae.splice(le,1),le--);if(Ae.length===1)return Ae[0];if(Ie){for(let le=0;le<Ae.length;le++)for(let ie=le+1;ie<Ae.length;ie++)if(Ae[le].negate().equals(Ae[ie]))return f.INSTANCE;if(Ae.length===1)return Ae[0]}return new be(Ae,re)}}serialize(){return this.expr.map(W=>W.serialize()).join(" || ")}keys(){const W=[];for(const re of this.expr)W.push(...re.keys());return W}map(W){return new be(this.expr.map(re=>re.map(W)),null)}negate(){if(!this.c){const W=[];for(const re of this.expr)W.push(re.negate());for(;W.length>1;){const re=W.shift(),Ie=W.shift(),Ae=[];for(const Ce of ce(re))for(const le of ce(Ie))Ae.push(he.create([Ce,le],null,!1));W.unshift(be.create(Ae,null,!1))}this.c=be.create(W,this,!0)}return this.c}}e.$dj=be;class we extends k{static{this.d=[]}static all(){return we.d.values()}constructor(W,re,Ie){super(W,null),this.f=re,typeof Ie=="object"?we.d.push({...Ie,key:W}):Ie!==!0&&we.d.push({key:W,description:Ie,type:re!=null?typeof re:void 0})}bindTo(W){return W.createKey(this.key,this.f)}getValue(W){return W.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(W){return L.create(this.key,W)}notEqualsTo(W){return D.create(this.key,W)}}e.$ej=we,e.$fj=(0,M.$Zh)("contextKeyService");function ge(Y,W){return Y<W?-1:Y>W?1:0}function me(Y,W,re,Ie){return Y<re?-1:Y>re?1:W<Ie?-1:W>Ie?1:0}function ne(Y,W){if(Y.type===0||W.type===1)return!0;if(Y.type===9)return W.type===9?ke(Y.expr,W.expr):!1;if(W.type===9){for(const re of W.expr)if(ne(Y,re))return!0;return!1}if(Y.type===6){if(W.type===6)return ke(W.expr,Y.expr);for(const re of Y.expr)if(ne(re,W))return!0;return!1}return Y.equals(W)}e.$gj=ne;function ke(Y,W){let re=0,Ie=0;for(;re<Y.length&&Ie<W.length;){const Ae=Y[re].cmp(W[Ie]);if(Ae<0)return!1;Ae===0&&re++,Ie++}return re===Y.length}function ce(Y){return Y.type===9?Y.expr:[Y]}}),define(Pe[183],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8h=e.$7h=void 0,e.$7h=(0,E.$Zh)("environmentService"),e.$8h=(0,E.$1h)(e.$7h)}),define(Pe[97],Re([1,0,150,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$ho=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$go=e.$fo=e.$eo=e.$do=e.$co=e.$bo=e.$ao=e.$_n=e.$$n=e.$0n=e.$9n=e.$8n=void 0,e.$8n="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$9n=new RegExp(e.$8n),e.$0n="__web_extension",e.$$n="skipWalkthrough",e.$_n="extensionsSync",e.$ao="dependecyOrPackExtensionInstall";function P(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$bo=P;function M(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$co=M;function A(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$do=A;function m(t,n){return n==="web"&&!t.includes("web")}e.$eo=m;function g(t,n,o){return m(n,o)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===o}e.$fo=g;function w(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.$go=w;var R;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(R||(e.SortBy=R={}));var S;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$ho=(0,T.$Zh)("extensionGalleryService");var b;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.Extract="Extract",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var a;(function(t){t.UnknownError="UnknownError",t.PackageIsInvalidZip="PackageIsInvalidZip",t.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class s extends Error{constructor(n,o){super(n),this.code=o,this.name=o}}e.$io=s,e.$jo=(0,T.$Zh)("extensionManagementService"),e.$ko="extensionsIdentifiers/disabled",e.$lo="extensionsIdentifiers/enabled",e.$mo=(0,T.$Zh)("IGlobalExtensionEnablementService"),e.$no=(0,T.$Zh)("IExtensionTipsService"),e.$oo=(0,E.localize)(0,null),e.$po={value:e.$oo,original:"Extensions"},e.$qo={value:(0,E.localize)(1,null),original:"Preferences"}}),define(Pe[42],Re([1,0,50,20,12,16,2,152,4,21,13,39]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.$Nk=e.FileKind=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.FileOperationResult=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.$Bk=e.FileChangeType=e.$Ak=e.FileOperation=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.FileSystemProviderErrorCode=e.$tk=e.$sk=e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.FileSystemProviderCapabilities=e.$kk=e.FilePermission=e.FileType=e.$jk=e.$ik=void 0,e.$ik=(0,g.$Zh)("fileService");function l(ne){return ne.create===!0}e.$jk=l;var $;(function(ne){ne[ne.Unknown=0]="Unknown",ne[ne.File=1]="File",ne[ne.Directory=2]="Directory",ne[ne.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var b;(function(ne){ne[ne.Readonly=1]="Readonly",ne[ne.Locked=2]="Locked"})(b||(e.FilePermission=b={}));function a(ne){const ke=ne;return!!ke&&typeof ke.onDidChange=="function"}e.$kk=a;var s;(function(ne){ne[ne.None=0]="None",ne[ne.FileReadWrite=2]="FileReadWrite",ne[ne.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ne[ne.FileReadStream=16]="FileReadStream",ne[ne.FileFolderCopy=8]="FileFolderCopy",ne[ne.PathCaseSensitive=1024]="PathCaseSensitive",ne[ne.Readonly=2048]="Readonly",ne[ne.Trash=4096]="Trash",ne[ne.FileWriteUnlock=8192]="FileWriteUnlock",ne[ne.FileAtomicRead=16384]="FileAtomicRead",ne[ne.FileAtomicWrite=32768]="FileAtomicWrite",ne[ne.FileAtomicDelete=65536]="FileAtomicDelete",ne[ne.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function t(ne){return!!(ne.capabilities&2)}e.$lk=t;function n(ne){return!!(ne.capabilities&8)}e.$mk=n;function o(ne){return!!(ne.capabilities&131072)}e.$nk=o;function c(ne){return!!(ne.capabilities&4)}e.$ok=c;function h(ne){return!!(ne.capabilities&16)}e.$pk=h;function i(ne){return t(ne)?!!(ne.capabilities&16384):!1}e.$qk=i;function r(ne){return t(ne)?!!(ne.capabilities&32768):!1}e.$rk=r;function u(ne){return!!(ne.capabilities&65536)}e.$sk=u;function d(ne){return!!(ne.capabilities&2048)}e.$tk=d;var v;(function(ne){ne.FileExists="EntryExists",ne.FileNotFound="EntryNotFound",ne.FileNotADirectory="EntryNotADirectory",ne.FileIsADirectory="EntryIsADirectory",ne.FileExceedsStorageQuota="EntryExceedsStorageQuota",ne.FileTooLarge="EntryTooLarge",ne.FileWriteLocked="EntryWriteLocked",ne.NoPermissions="NoPermissions",ne.Unavailable="Unavailable",ne.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class f extends Error{static create(ke,ce){const Y=new f(ke.toString(),ce);return p(Y,ce),Y}constructor(ke,ce){super(ke),this.code=ce}}e.$uk=f;function k(ne,ke){return f.create(ne,ke)}e.$vk=k;function L(ne){return ne||k((0,m.localize)(0,null),v.Unknown)}e.$wk=L;function p(ne,ke){return ne.name=ke?`${ke} (FileSystemError)`:"FileSystemError",ne}e.$xk=p;function y(ne){if(!ne)return v.Unknown;if(ne instanceof f)return ne.code;const ke=/^(.+) \(FileSystemError\)$/.exec(ne.name);if(!ke)return v.Unknown;switch(ke[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.$yk=y;function D(ne){if(ne instanceof C)return ne.fileOperationResult;switch(y(ne)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.$zk=D;var N;(function(ne){ne[ne.CREATE=0]="CREATE",ne[ne.DELETE=1]="DELETE",ne[ne.MOVE=2]="MOVE",ne[ne.COPY=3]="COPY",ne[ne.WRITE=4]="WRITE"})(N||(e.FileOperation=N={}));class q{constructor(ke,ce,Y){this.resource=ke,this.operation=ce,this.target=Y}isOperation(ke){return this.operation===ke}}e.$Ak=q;var V;(function(ne){ne[ne.UPDATED=0]="UPDATED",ne[ne.ADDED=1]="ADDED",ne[ne.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class U{static{this.a=null}constructor(ke,ce){this.c=ce,this.b=void 0,this.d=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawAdded.map(W=>[W,!0])),Y}),this.f=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawUpdated.map(W=>[W,!0])),Y}),this.g=new S.$U(()=>{const Y=E.$6h.forUris(()=>this.c);return Y.fill(this.rawDeleted.map(W=>[W,!0])),Y}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const Y of ke){switch(Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}this.b!==U.a&&(typeof Y.cId=="number"?this.b===void 0?this.b=Y.cId:this.b!==Y.cId&&(this.b=U.a):this.b!==void 0&&(this.b=U.a))}}contains(ke,...ce){return this.h(ke,{includeChildren:!1},...ce)}affects(ke,...ce){return this.h(ke,{includeChildren:!0},...ce)}h(ke,ce,...Y){if(!ke)return!1;const W=Y.length>0;return!!((!W||Y.includes(1))&&(this.d.value.get(ke)||ce.includeChildren&&this.d.value.findSuperstr(ke))||(!W||Y.includes(0))&&(this.f.value.get(ke)||ce.includeChildren&&this.f.value.findSuperstr(ke))||(!W||Y.includes(2))&&(this.g.value.findSubstr(ke)||ce.includeChildren&&this.g.value.findSuperstr(ke)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ke){return this.b===ke}hasCorrelation(){return typeof this.b=="number"}}e.$Bk=U;function F(ne,ke,ce){return!ne||!ke||ne===ke||ke.length>ne.length?!1:(ke.charAt(ke.length-1)!==T.sep&&(ke+=T.sep),ce?(0,P.$7e)(ne,ke):ne.indexOf(ke)===0)}e.$Ck=F;class C extends Error{constructor(ke,ce,Y){super(ke),this.fileOperationResult=ce,this.options=Y}}e.$Dk=C;class I extends C{constructor(ke,ce,Y,W){super(ke,ce,W),this.fileOperationResult=ce,this.size=Y}}e.$Ek=I;class X extends C{constructor(ke,ce,Y){super(ke,2,Y),this.stat=ce}}e.$Fk=X;var ue;(function(ne){ne[ne.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ne[ne.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ne[ne.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ne[ne.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ne[ne.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ne[ne.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ne[ne.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ne[ne.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ne[ne.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ne[ne.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ne[ne.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(e.FileOperationResult=ue={})),e.$Gk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Hk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Ik="files.associations",e.$Jk="files.exclude",e.$Kk="files.readonlyInclude",e.$Lk="files.readonlyExclude",e.$Mk="files.readonlyFromPermissions";var he;(function(ne){ne[ne.FILE=0]="FILE",ne[ne.FOLDER=1]="FOLDER",ne[ne.ROOT_FOLDER=2]="ROOT_FOLDER"})(he||(e.FileKind=he={})),e.$Nk="";function be(ne){if(!(typeof ne.size!="number"||typeof ne.mtime!="number"))return ne.mtime.toString(29)+ne.size.toString(31)}e.$Ok=be;async function we(ne,ke){if(!ke.hasProvider(A.URI.from({scheme:ne.scheme})))return new Promise(ce=>{const Y=ke.onDidChangeFileSystemProviderRegistrations(W=>{W.scheme===ne.scheme&&W.added&&(Y.dispose(),ce())})})}e.$Pk=we;class ge{static{this.KB=1024}static{this.MB=ge.KB*ge.KB}static{this.GB=ge.MB*ge.KB}static{this.TB=ge.GB*ge.KB}static formatSize(ke){return(0,M.$Gf)(ke)||(ke=0),ke<ge.KB?(0,m.localize)(1,null,ke.toFixed(0)):ke<ge.MB?(0,m.localize)(2,null,(ke/ge.KB).toFixed(2)):ke<ge.GB?(0,m.localize)(3,null,(ke/ge.MB).toFixed(2)):ke<ge.TB?(0,m.localize)(4,null,(ke/ge.GB).toFixed(2)):(0,m.localize)(5,null,(ke/ge.TB).toFixed(2))}}e.$Qk=ge;function me(ne){const ke=typeof ne=="string"||ne?.scheme===R.Schemas.vscodeRemote;return typeof ne!="string"&&ne?.scheme===R.Schemas.file?1024*ge.MB:ke?10*ge.MB:w.$o?50*ge.MB:1024*ge.MB}e.$Rk=me}),define(Pe[71],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xh=void 0;class E{constructor(...P){this.a=new Map;for(const[M,A]of P)this.set(M,A)}set(P,M){const A=this.a.get(P);return this.a.set(P,M),A}has(P){return this.a.has(P)}get(P){return this.a.get(P)}}e.$Xh=E}),define(Pe[184],Re([1,0,14,11,6,69,182,4,71,185]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oq=e.$nq=void 0;const R=!1;class S extends Error{constructor(s){super("cyclic dependency between services"),this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class l{constructor(s=new g.$Xh,t=!1,n,o=R){this.f=s,this.g=t,this.h=n,this.i=o,this.o=new Set,this.f.set(m.$Yh,this),this._globalGraph=o?n?._globalGraph??new A.$mq(c=>c):void 0}createChild(s){return new l(s,this.g,this,this.i)}invokeFunction(s,...t){const n=b.traceInvocation(this.i,s);let o=!1;try{return s({get:h=>{if(o)throw(0,T.$7)("service accessor is only valid during the invocation of its target method");const i=this.m(h,n);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...t)}finally{o=!0,n.stop()}}createInstance(s,...t){let n,o;return s instanceof M.$Wh?(n=b.traceCreation(this.i,s.ctor),o=this.j(s.ctor,s.staticArguments.concat(t),n)):(n=b.traceCreation(this.i,s),o=this.j(s,t,n)),n.stop(),o}j(s,t=[],n){const o=m._util.getServiceDependencies(s).sort((i,r)=>i.index-r.index),c=[];for(const i of o){const r=this.m(i.id,n);r||this.u(`[createInstance] ${s.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(r)}const h=o.length>0?o[0].index:t.length;if(t.length!==h){console.trace(`[createInstance] First service dependency of ${s.name} at position ${h+1} conflicts with ${t.length} static arguments`);const i=h-t.length;i>0?t=t.concat(new Array(i)):t=t.slice(0,h)}return Reflect.construct(s,t.concat(c))}k(s,t){if(this.f.get(s)instanceof M.$Wh)this.f.set(s,t);else if(this.h)this.h.k(s,t);else throw new Error("illegalState - setting UNKNOWN service instance")}l(s){const t=this.f.get(s);return!t&&this.h?this.h.l(s):t}m(s,t){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(s));const n=this.l(s);return n instanceof M.$Wh?this.q(s,n,t.branch(s,!0)):(t.branch(s,!1),n)}q(s,t,n){if(this.o.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this.o.add(s);try{return this.r(s,t,n)}finally{this.o.delete(s)}}r(s,t,n){const o=new A.$mq(i=>i.id.toString());let c=0;const h=[{id:s,desc:t,_trace:n}];for(;h.length;){const i=h.pop();if(o.lookupOrInsertNode(i),c++>1e3)throw new S(o);for(const r of m._util.getServiceDependencies(i.desc.ctor)){const u=this.l(r.id);if(u||this.u(`[createInstance] ${s} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),u instanceof M.$Wh){const d={id:r.id,desc:u,_trace:i._trace.branch(r.id,!0)};o.insertEdge(i,d),h.push(d)}}}for(;;){const i=o.roots();if(i.length===0){if(!o.isEmpty())throw new S(o);break}for(const{data:r}of i){if(this.l(r.id)instanceof M.$Wh){const d=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,d)}o.removeNode(r)}}return this.l(s)}s(s,t,n=[],o,c){if(this.f.get(s)instanceof M.$Wh)return this.t(s,t,n,o,c);if(this.h)return this.h.s(s,t,n,o,c);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}t(s,t,n=[],o,c){if(o){const h=new l(void 0,this.g,this,this.i);h.c=String(s);const i=new Map,r=new E.$gh(()=>{const u=h.j(t,n,c);for(const[d,v]of i){const f=u[d];if(typeof f=="function")for(const k of v)f.apply(u,k)}return i.clear(),u});return new Proxy(Object.create(null),{get(u,d){if(!r.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let k=i.get(d);return k||(k=new w.$2c,i.set(d,k)),(p,y,D)=>{const N=k.push([p,y,D]);return(0,P.$Pc)(N)}}if(d in u)return u[d];const v=r.value;let f=v[d];return typeof f!="function"||(f=f.bind(v),u[d]=f),f},set(u,d,v){return r.value[d]=v,!0},getPrototypeOf(u){return t.prototype}})}else return this.j(t,n,c)}u(s,t){if(t&&console.warn(s),this.g)throw new Error(s)}}e.$nq=l;var $;(function(a){a[a.None=0]="None",a[a.Creation=1]="Creation",a[a.Invocation=2]="Invocation",a[a.Branch=3]="Branch"})($||($={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(s,t){return s?new b(2,t.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation(s,t){return s?new b(1,t.name):b.c}static{this.f=0}constructor(s,t){this.type=s,this.name=t,this.g=Date.now(),this.h=[]}branch(s,t){const n=new b(3,s.toString());return this.h.push([s,t,n]),n}stop(){const s=Date.now()-this.g;b.f+=s;let t=!1;function n(c,h){const i=[],r=new Array(c+1).join("	");for(const[u,d,v]of h.h)if(d&&v){t=!0,i.push(`${r}CREATES -> ${u}`);const f=n(c+1,v);f&&i.push(f)}else i.push(`${r}uses -> ${u}`);return i.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];(s>2||t)&&b.all.add(o.join(`
`))}}e.$oq=b}),define(Pe[15],Re([1,0,40,5,98,6,28,21,25,16,2,35,4]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.$rj=e.$qj=e.$pj=e.$oj=e.$nj=e.$mj=e.log=e.$kj=e.LogLevel=e.$jj=e.$ij=e.$hj=void 0,e.$hj=(0,l.$Zh)("logService"),e.$ij=(0,l.$Zh)("loggerService");function $(){return new Date().toISOString()}function b(p){return(0,w.$Gf)(p)}e.$jj=b;var a;(function(p){p[p.Off=0]="Off",p[p.Trace=1]="Trace",p[p.Debug=2]="Debug",p[p.Info=3]="Info",p[p.Warning=4]="Warning",p[p.Error=5]="Error"})(a||(e.LogLevel=a={})),e.$kj=a.Info;function s(p,y,D){switch(y){case a.Trace:p.trace(D);break;case a.Debug:p.debug(D);break;case a.Info:p.info(D);break;case a.Warning:p.warn(D);break;case a.Error:p.error(D);break;case a.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=s;function t(p,y=!1){let D="";for(let N=0;N<p.length;N++){let q=p[N];if(q instanceof Error&&(q=(0,E.$Ki)(q,y)),typeof q=="object")try{q=JSON.stringify(q)}catch{}D+=(N>0?" ":"")+q}return D}class n extends M.$Rc{constructor(){super(...arguments),this.b=e.$kj,this.c=this.B(new T.$Rd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==a.Off&&this.b<=y}}e.$mj=n;class o extends n{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...D){this.f(a.Trace)&&this.g(a.Trace,t([y,...D],!0))}debug(y,...D){this.f(a.Debug)&&this.g(a.Debug,t([y,...D]))}info(y,...D){this.f(a.Info)&&this.g(a.Info,t([y,...D]))}warn(y,...D){this.f(a.Warning)&&this.g(a.Warning,t([y,...D]))}error(y,...D){if(this.f(a.Error))if(y instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=y.stack,this.g(a.Error,t(N))}else this.g(a.Error,t([y,...D]))}flush(){}}e.$nj=o;class c extends n{constructor(y=e.$kj){super(),this.setLevel(y),this.g=!m.$i}trace(y,...D){this.f(a.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}debug(y,...D){this.f(a.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}info(y,...D){this.f(a.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,y,...D):console.log(`[main ${$()}]`,y,...D))}warn(y,...D){this.f(a.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,y,...D):console.warn(`[main ${$()}]`,y,...D))}error(y,...D){this.f(a.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,y,...D):console.error(`[main ${$()}]`,y,...D))}dispose(){}flush(){}}e.$oj=c;class h extends n{constructor(y=e.$kj,D=!0){super(),this.g=D,this.setLevel(y)}trace(y,...D){this.f(a.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...D):console.log(y,...D))}debug(y,...D){this.f(a.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...D):console.log(y,...D))}info(y,...D){this.f(a.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...D):console.log(y,...D))}warn(y,...D){this.f(a.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...D):console.log(y,...D))}error(y,...D){this.f(a.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...D):console.error(y,...D))}dispose(){}flush(){}}e.$pj=h;class i extends n{constructor(y,D=e.$kj){super(),this.g=y,this.setLevel(D)}trace(y,...D){this.f(a.Trace)&&this.g.log(a.Trace,[this.h(y),...D])}debug(y,...D){this.f(a.Debug)&&this.g.log(a.Debug,[this.h(y),...D])}info(y,...D){this.f(a.Info)&&this.g.log(a.Info,[this.h(y),...D])}warn(y,...D){this.f(a.Warning)&&this.g.log(a.Warning,[this.h(y),...D])}error(y,...D){this.f(a.Error)&&this.g.log(a.Error,[this.h(y),...D])}h(y){return typeof y=="string"?y:(0,E.$Ki)(y,this.f(a.Trace))}dispose(){}flush(){}}e.$qj=i;class r extends n{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const D of this.g)D.setLevel(y);super.setLevel(y)}trace(y,...D){for(const N of this.g)N.trace(y,...D)}debug(y,...D){for(const N of this.g)N.debug(y,...D)}info(y,...D){for(const N of this.g)N.info(y,...D)}warn(y,...D){for(const N of this.g)N.warn(y,...D)}error(y,...D){for(const N of this.g)N.error(y,...D)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose()}}e.$rj=r;class u extends M.$Rc{constructor(y,D,N){if(super(),this.h=y,this.j=D,this.b=new A.$zc,this.c=this.B(new T.$Rd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new T.$Rd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new T.$Rd),this.onDidChangeVisibility=this.g.event,N)for(const q of N)this.b.set(q.resource,{logger:void 0,info:q})}m(y){return(0,w.$Cf)(y)?[...this.b.values()].find(D=>D.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,D){const N=this.n(y),q=(0,w.$Cf)(y)?y:D?.id??(0,P.$Ni)(N.toString()).toString(16);let V=this.b.get(N)?.logger;const U=D?.logLevel==="always"?a.Trace:D?.logLevel;V||(V=this.s(N,U??this.getLogLevel(N)??this.h,{...D,id:q}));const F={logger:V,info:{resource:N,id:q,logLevel:U,name:D?.name,hidden:D?.hidden,extensionId:D?.extensionId,when:D?.when}};return this.registerLogger(F.info),this.b.set(N,F),V}n(y){return(0,w.$Cf)(y)?(0,g.$Bg)(this.j,`${y}.log`):y}setLogLevel(y,D){if(R.URI.isUri(y)){const N=y,q=D,V=this.b.get(N);V&&q!==V.info.logLevel&&(V.info.logLevel=q===this.h?void 0:q,V.logger?.setLevel(q),this.b.set(V.info.resource,V),this.f.fire([N,q]))}else{this.h=y;for(const[N,q]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&q.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,D){const N=this.m(y);N&&D!==!N.info.hidden&&(N.info.hidden=!D,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,D]))}getLogLevel(y){let D;return y&&(D=this.b.get(y)?.info.logLevel),D??this.h}registerLogger(y){const D=this.b.get(y.resource);D?D.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const D=this.b.get(y);D&&(D.logger&&D.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[D.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$sj=u;class d{constructor(){this.onDidChangeLogLevel=new T.$Rd().event}setLevel(y){}getLevel(){return a.Info}trace(y,...D){}debug(y,...D){}info(y,...D){}warn(y,...D){}error(y,...D){}critical(y,...D){}dispose(){}flush(){}}e.$tj=d;class v extends d{}e.$uj=v;function f(p){if(p.verbose)return a.Trace;if(typeof p.logLevel=="string"){const y=L(p.logLevel.toLowerCase());if(y!==void 0)return y}return e.$kj}e.$vj=f;function k(p){switch(p){case a.Trace:return"trace";case a.Debug:return"debug";case a.Info:return"info";case a.Warning:return"warn";case a.Error:return"error";case a.Off:return"off"}}e.$wj=k;function L(p){switch(p){case"trace":return a.Trace;case"debug":return a.Debug;case"info":return a.Info;case"warn":return a.Warning;case"error":return a.Error;case"critical":return a.Error;case"off":return a.Off}}e.$xj=L,e.$yj=new S.$ej("logLevel",k(a.Info))}),define(Pe[186],Re([1,0,6,15]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=void 0;class P extends E.$Rc{constructor(A,m=[]){super(),this.a=new T.$rj([A,...m]),this.B(A.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...m){this.a.trace(A,...m)}debug(A,...m){this.a.debug(A,...m)}info(A,...m){this.a.info(A,...m)}warn(A,...m){this.a.warn(A,...m)}error(A,...m){this.a.error(A,...m)}flush(){this.a.flush()}}e.$5N=P}),define(Pe[99],Re([1,0,31,153,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jt=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var M;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(M||(e.MarkerTag=M={}));var A;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(g){function w(b,a){return a-b}g.compare=w;const R=Object.create(null);R[g.Error]=(0,T.localize)(0,null),R[g.Warning]=(0,T.localize)(1,null),R[g.Info]=(0,T.localize)(2,null);function S(b){return R[b]||""}g.toString=S;function l(b){switch(b){case E.default.Error:return g.Error;case E.default.Warning:return g.Warning;case E.default.Info:return g.Info;case E.default.Ignore:return g.Hint}}g.fromSeverity=l;function $(b){switch(b){case g.Error:return E.default.Error;case g.Warning:return E.default.Warning;case g.Info:return E.default.Info;case g.Hint:return E.default.Ignore}}g.toSeverity=$}(A||(e.MarkerSeverity=A={}));var m;(function(g){const w="";function R(l){return S(l,!0)}g.makeKey=R;function S(l,$){const b=[w];return l.source?b.push(l.source.replace("\xA6","\\\xA6")):b.push(w),l.code?typeof l.code=="string"?b.push(l.code.replace("\xA6","\\\xA6")):b.push(l.code.value.replace("\xA6","\\\xA6")):b.push(w),l.severity!==void 0&&l.severity!==null?b.push(A.toString(l.severity)):b.push(w),l.message&&$?b.push(l.message.replace("\xA6","\\\xA6")):b.push(w),l.startLineNumber!==void 0&&l.startLineNumber!==null?b.push(l.startLineNumber.toString()):b.push(w),l.startColumn!==void 0&&l.startColumn!==null?b.push(l.startColumn.toString()):b.push(w),l.endLineNumber!==void 0&&l.endLineNumber!==null?b.push(l.endLineNumber.toString()):b.push(w),l.endColumn!==void 0&&l.endColumn!==null?b.push(l.endColumn.toString()):b.push(w),b.push(w),b.join("\xA6")}g.makeKeyOptionalMessage=S})(m||(e.IMarkerData=m={})),e.$jt=(0,P.$Zh)("markerService")}),define(Pe[187],Re([1,0,5,31,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$av=e.$_u=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$$u=e.Severity=void 0,e.Severity=T.default,e.$$u=(0,P.$Zh)("notificationService");var M;(function(R){R[R.DEFAULT=0]="DEFAULT",R[R.SILENT=1]="SILENT",R[R.URGENT=2]="URGENT"})(M||(e.NotificationPriority=M={}));var A;(function(R){R[R.WORKSPACE=0]="WORKSPACE",R[R.PROFILE=1]="PROFILE",R[R.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var m;(function(R){R[R.OFF=0]="OFF",R[R.SILENT=1]="SILENT",R[R.ERROR=2]="ERROR"})(m||(e.NotificationsFilter=m={}));class g{constructor(){this.progress=new w,this.onDidClose=E.Event.None,this.onDidChangeVisibility=E.Event.None}updateSeverity(S){}updateMessage(S){}updateActions(S){}close(){}}e.$_u=g;class w{infinite(){}done(){}total(S){}worked(S){}}e.$av=w}),define(Pe[188],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aj=e.$zj=void 0,e.$zj=(0,E.$Zh)("productService"),e.$Aj="vscode://schemas/vscode-product"});var He=this&&this.__decorate||function(pe,e,E,T){var P=arguments.length,M=P<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,E):T,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(pe,e,E,T);else for(var m=pe.length-1;m>=0;m--)(A=pe[m])&&(M=(P<3?A(M):P>3?A(e,E,M):A(e,E))||M);return P>3&&M&&Object.defineProperty(e,E,M),M},We=this&&this.__param||function(pe,e){return function(E,T){e(E,T,pe)}};define(Pe[72],Re([1,0,14,19,6,4]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hv=e.$gv=e.$fv=e.$ev=e.$dv=e.$cv=e.ProgressLocation=e.$bv=void 0,e.$bv=(0,M.$Zh)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$cv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$dv=m;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$ev=g;let w=class extends P.$Rc{constructor(l,$){super(),this.a=new E.$kh,$.withProgress(l,b=>(this.b=b,this.c&&b.report(this.c),this.a.p)),this.B((0,P.$Pc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$fv=w,e.$fv=w=He([We(1,e.$bv)],w);class R extends P.$Rc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new P.$Qc)}start(l){this.stop();const $=++this.a,b=new T.$2d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,P.$Pc)(()=>clearTimeout(this.f))),this.b.add((0,P.$Pc)(()=>b.cancel())),this.b.add((0,P.$Pc)(()=>this.c?this.c.done():void 0)),{id:$,token:b.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$gv=R,e.$hv=(0,M.$Zh)("editorProgressService")}),define(Pe[30],Re([1,0,53,16]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qn=void 0;class P{constructor(){this.a=new Map}add(A,m){E.ok(T.$Cf(A)),E.ok(T.$Ef(m)),E.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,m)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$qn=new P}),define(Pe[73],Re([1,0,5,30]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rn=void 0,e.$rn={JSONContribution:"base.contributions.json"};function P(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class M{constructor(){this.b=new E.$Rd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,w){this.a[P(g)]=w,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const A=new M;T.$qn.add(e.$rn.JSONContribution,A)}),define(Pe[54],Re([1,0,18,5,16,147,41,73,30]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=e.$Jn=e.$In=e.$Hn=e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.ConfigurationScope=e.$vn=e.EditPresentationTypes=void 0;var w;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(w||(e.EditPresentationTypes=w={})),e.$vn={Configuration:"base.contributions.configuration"};var R;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.$wn={properties:{},patternProperties:{}},e.$xn={properties:{},patternProperties:{}},e.$yn={properties:{},patternProperties:{}},e.$zn={properties:{},patternProperties:{}},e.$An={properties:{},patternProperties:{}},e.$Bn={properties:{},patternProperties:{}},e.$Cn="vscode://schemas/settings/resourceLanguage",e.$Dn="vscode://schemas/settings/configurationDefaults";const S=g.$qn.as(m.$rn.JSONContribution);class l{constructor(){this.h=new Set,this.i=new T.$Rd,this.onDidSchemaChange=this.i.event,this.j=new T.$Rd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Cn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const u=new Set;this.n(i,r,u),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:u})}deregisterConfigurations(i){const r=new Set;this.o(i,r),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const u=new Set;this.o(r,u),this.n(i,!1,u),S.registerSchema(e.$Cn,this.g),this.i.fire(),this.j.fire({properties:u})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const u=[];for(const{overrides:d,source:v}of i)for(const f in d)if(r.add(f),e.$Fn.test(f)){const k=this.a.get(f),L=k?.valuesSources??new Map;if(v)for(const N of Object.keys(d[f]))L.set(N,v);const p={...k?.value||{},...d[f]};this.a.set(f,{source:v,value:p,valuesSources:L});const y=(0,A.$Di)(f),D={type:"object",default:p,description:M.localize(1,null,y),$ref:e.$Cn,defaultDefaultValue:p,source:P.$Cf(v)?void 0:v,defaultValueSource:v};u.push(...a(f)),this.d[f]=D,this.b.properties[f]=D}else{this.a.set(f,{value:d[f],source:v});const k=this.d[f];k&&(this.w(f,k),this.r(f,k))}this.m(u)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:u,source:d}of i)for(const v in u){const f=this.a.get(v),k=P.$Cf(d)?d:d?.id,L=P.$Cf(f?.source)?f?.source:f?.source?.id;if(k===L)if(r.add(v),this.a.delete(v),e.$Fn.test(v))delete this.d[v],delete this.b.properties[v];else{const p=this.d[v];p&&(this.w(v,p),this.r(v,p))}}this.u()}deltaConfiguration(i){let r=!1;const u=new Set;i.removedDefaults&&(this.l(i.removedDefaults,u),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,u),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,u),i.addedConfigurations&&this.n(i.addedConfigurations,!1,u),this.i.fire(),this.j.fire({properties:u,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,u){i.forEach(d=>{this.p(d,r,d.extensionInfo,d.restrictedProperties,void 0,u),this.c.push(d),this.q(d)})}o(i,r){const u=d=>{if(d.properties)for(const v in d.properties){r.add(v);const f=this.d[v];f?.policy?.name&&this.e.delete(f.policy.name),delete this.d[v],this.s(v,d.properties[v])}d.allOf?.forEach(v=>u(v))};for(const d of i){u(d);const v=this.c.indexOf(d);v!==-1&&this.c.splice(v,1)}}p(i,r=!0,u,d,v=3,f){v=P.$Lf(i.scope)?v:i.scope;const k=i.properties;if(k)for(const p in k){const y=k[p];if(r&&o(p,y)){delete k[p];continue}if(y.source=u,y.defaultDefaultValue=k[p].default,this.w(p,y),e.$Fn.test(p)?y.scope=void 0:(y.scope=P.$Lf(y.scope)?v:y.scope,y.restricted=P.$Lf(y.restricted)?!!d?.includes(p):y.restricted),k[p].hasOwnProperty("included")&&!k[p].included){this.f[p]=k[p],delete k[p];continue}else this.d[p]=k[p],k[p].policy?.name&&this.e.set(k[p].policy.name,p);!k[p].deprecationMessage&&k[p].markdownDeprecationMessage&&(k[p].deprecationMessage=k[p].markdownDeprecationMessage),f.add(p)}const L=i.allOf;if(L)for(const p of L)this.p(p,r,u,d,v,f)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=u=>{const d=u.properties;if(d)for(const f in d)this.r(f,d[f]);u.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$wn.properties[i]=r,r.scope){case 1:e.$xn.properties[i]=r;break;case 2:e.$yn.properties[i]=r;break;case 6:e.$zn.properties[i]=r;break;case 3:e.$An.properties[i]=r;break;case 4:e.$Bn.properties[i]=r;break;case 5:e.$Bn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$wn.properties[i],r.scope){case 1:delete e.$xn.properties[i];break;case 2:delete e.$yn.properties[i];break;case 6:delete e.$zn.properties[i];break;case 3:delete e.$An.properties[i];break;case 4:case 5:delete e.$Bn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,u={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.$Cn};this.w(r,u),e.$wn.properties[r]=u,e.$xn.properties[r]=u,e.$yn.properties[r]=u,e.$zn.properties[r]=u,e.$An.properties[r]=u,e.$Bn.properties[r]=u}}v(){const i={type:"object",description:M.localize(4,null),errorMessage:M.localize(5,null),$ref:e.$Cn};e.$wn.patternProperties[e.$En]=i,e.$xn.patternProperties[e.$En]=i,e.$yn.patternProperties[e.$En]=i,e.$zn.patternProperties[e.$En]=i,e.$An.patternProperties[e.$En]=i,e.$Bn.patternProperties[e.$En]=i,this.i.fire()}w(i,r){const u=this.a.get(i);let d=u?.value,v=u?.source;P.$Jf(d)&&(d=r.defaultDefaultValue,v=void 0),P.$Jf(d)&&(d=t(r.type)),r.default=d,r.defaultValueSource=v}}const $="\\[([^\\]]+)\\]",b=new RegExp($,"g");e.$En=`^(${$})+$`,e.$Fn=new RegExp(e.$En);function a(h){const i=[];if(e.$Fn.test(h)){let r=b.exec(h);for(;r?.length;){const u=r[1].trim();u&&i.push(u),r=b.exec(h)}}return(0,E.$Lb)(i)}e.$Gn=a;function s(h){return h.reduce((i,r)=>`${i}[${r}]`,"")}e.$Hn=s;function t(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$In=t;const n=new l;g.$qn.add(e.$vn.Configuration,n);function o(h,i){return h.trim()?e.$Fn.test(h)?M.localize(7,null,h):n.getConfigurationProperties()[h]!==void 0?M.localize(8,null,h):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?M.localize(9,null,h,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:M.localize(6,null)}e.$Jn=o;function c(){const h=[],i=n.getConfigurationProperties();for(const r of Object.keys(i))h.push([r,i[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.$Kn=c}),define(Pe[189],Re([1,0,18,5,119,6,28,26,16,2,41,54,30]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qn=e.$Pn=e.$On=e.$Nn=e.$Mn=e.$Ln=void 0;function $(r){return Object.isFrozen(r)?r:m.$fn(r)}class b{constructor(u={},d=[],v=[],f){this.b=u,this.c=d,this.d=v,this.raw=f,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const u=this.raw.map(d=>{if(d instanceof b)return d;const v=new a("");return v.parseRaw(d),v.configurationModel});this.f=u.reduce((d,v)=>v===d?v:d.merge(v),u[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(u){return u?(0,R.$Bi)(this.contents,u):this.contents}inspect(u,d){const v=this.rawConfiguration.getValue(u),f=d?this.rawConfiguration.getOverrideValue(u,d):void 0,k=d?this.rawConfiguration.override(d).getValue(u):v;return{value:v,override:f,merged:k}}getOverrideValue(u,d){const v=this.i(d);return v?u?(0,R.$Bi)(v,u):v:void 0}getKeysForOverrideIdentifier(u){const d=[];for(const v of this.overrides)v.identifiers.includes(u)&&d.push(...v.keys);return E.$Lb(d)}getAllOverrideIdentifiers(){const u=[];for(const d of this.overrides)u.push(...d.identifiers);return E.$Lb(u)}override(u){let d=this.a.get(u);return d||(d=this.g(u),this.a.set(u,d)),d}merge(...u){const d=m.$en(this.contents),v=m.$en(this.overrides),f=[...this.keys],k=this.raw?.length?[...this.raw]:[this];for(const L of u)if(k.push(...L.raw?.length?L.raw:[L]),!L.isEmpty()){this.h(d,L.contents);for(const p of L.overrides){const[y]=v.filter(D=>E.$tb(D.identifiers,p.identifiers));y?(this.h(y.contents,p.contents),y.keys.push(...p.keys),y.keys=E.$Lb(y.keys)):v.push(m.$en(p))}for(const p of L.keys)f.indexOf(p)===-1&&f.push(p)}return new b(d,f,v,k.every(L=>L instanceof b)?void 0:k)}g(u){const d=this.i(u);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const v={};for(const f of E.$Lb([...Object.keys(this.contents),...Object.keys(d)])){let k=this.contents[f];const L=d[f];L&&(typeof k=="object"&&typeof L=="object"?(k=m.$en(k),this.h(k,L)):k=L),v[f]=k}return new b(v,this.keys,this.overrides)}h(u,d){for(const v of Object.keys(d)){if(v in u&&g.$Ef(u[v])&&g.$Ef(d[v])){this.h(u[v],d[v]);continue}u[v]=m.$en(d[v])}}i(u){let d=null,v=null;const f=k=>{k&&(v?this.h(v,k):v=m.$en(k))};for(const k of this.overrides)k.identifiers.length===1&&k.identifiers[0]===u?d=k.contents:k.identifiers.includes(u)&&f(k.contents);return f(d),v}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(u,d){this.j(u,d,!0)}setValue(u,d){this.j(u,d,!1)}removeValue(u){const d=this.keys.indexOf(u);d!==-1&&(this.keys.splice(d,1),(0,R.$Ai)(this.contents,u),S.$Fn.test(u)&&this.overrides.splice(this.overrides.findIndex(v=>E.$tb(v.identifiers,(0,S.$Gn)(u))),1))}j(u,d,v){(0,R.$zi)(this.contents,u,d,f=>console.error(f)),v=v||this.keys.indexOf(u)===-1,v&&this.keys.push(u),S.$Fn.test(u)&&this.overrides.push({identifiers:(0,S.$Gn)(u),keys:Object.keys(this.contents[u]),contents:(0,R.$yi)(this.contents[u],f=>console.error(f))})}}e.$Ln=b;class a{constructor(u){this.f=u,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(u,d){if(!g.$Lf(u)){const v=this.g(u);this.parseRaw(v,d)}}reparse(u){this.a&&this.parseRaw(this.a,u)}parseRaw(u,d){this.a=u;const{contents:v,keys:f,overrides:k,restricted:L,hasExcludedProperties:p}=this.h(u,d);this.b=new b(v,f,k,p?[u]:void 0),this.c=L||[]}g(u){let d={},v=null,f=[];const k=[],L=[];function p(D){Array.isArray(f)?f.push(D):v!==null&&(f[v]=D)}const y={onObjectBegin:()=>{const D={};p(D),k.push(f),f=D,v=null},onObjectProperty:D=>{v=D},onObjectEnd:()=>{f=k.pop()},onArrayBegin:()=>{const D=[];p(D),k.push(f),f=D,v=null},onArrayEnd:()=>{f=k.pop()},onLiteralValue:p,onError:(D,N,q)=>{L.push({error:D,offset:N,length:q})}};if(u)try{P.$bn(u,y),d=f[0]||{}}catch(D){console.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return d}h(u,d){const v=l.$qn.as(S.$vn.Configuration).getConfigurationProperties(),f=this.i(u,v,!0,d);u=f.raw;const k=(0,R.$yi)(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),L=Object.keys(u),p=this.j(u,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:k,keys:L,overrides:p,restricted:f.restricted,hasExcludedProperties:f.hasExcludedProperties}}i(u,d,v,f){let k=!1;if(!f?.scopes&&!f?.skipRestricted&&!f?.exclude?.length)return{raw:u,restricted:[],hasExcludedProperties:k};const L={},p=[];for(const y in u)if(S.$Fn.test(y)&&v){const D=this.i(u[y],d,!1,f);L[y]=D.raw,k=k||D.hasExcludedProperties,p.push(...D.restricted)}else{const D=d[y],N=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&p.push(y),!f.exclude?.includes(y)&&(f.include?.includes(y)||(N===void 0||f.scopes===void 0||f.scopes.includes(N))&&!(f.skipRestricted&&D?.restricted))?L[y]=u[y]:k=!0}return{raw:L,restricted:p,hasExcludedProperties:k}}j(u,d){const v=[];for(const f of Object.keys(u))if(S.$Fn.test(f)){const k={};for(const L in u[f])k[L]=u[f][L];v.push({identifiers:(0,S.$Gn)(f),keys:Object.keys(k),contents:(0,R.$yi)(k,d)})}return v}}e.$Mn=a;class s extends M.$Rc{constructor(u,d,v,f){super(),this.c=u,this.f=d,this.g=f,this.b=this.B(new T.$Rd),this.onDidChange=this.b.event,this.a=new a(this.c.toString()),this.B(this.g.watch(v.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(T.Event.any(T.Event.filter(this.g.onDidFilesChange,k=>k.contains(this.c)),T.Event.filter(this.g.onDidRunOperation,k=>(k.isOperation(0)||k.isOperation(3)||k.isOperation(1)||k.isOperation(4))&&v.isEqual(k.resource,u)))(()=>this.b.fire()))}async loadConfiguration(){try{const u=await this.g.readFile(this.c);return this.a.parse(u.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(u){return u&&(this.f=u),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Nn=s;class t{constructor(u,d,v,f,k,L,p,y,D,N,q,V,U){this.a=u,this.b=d,this.c=v,this.overrideIdentifiers=f,this.d=k,this.f=L,this.g=p,this.h=y,this.i=D,this.j=N,this.k=q,this.l=V,this.m=U}get value(){return $(this.c)}n(u,d,v){const f=u.inspect(d,v);return{get value(){return $(f.value)},get override(){return $(f.override)},get merged(){return $(f.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class n{constructor(u,d,v,f,k=new b,L=new b,p=new A.$zc,y=new b,D=new A.$zc){this.c=u,this.d=d,this.f=v,this.g=f,this.h=k,this.i=L,this.j=p,this.l=y,this.m=D,this.a=null,this.b=new A.$zc,this.n=null}getValue(u,d,v){return this.p(u,d,v).getValue(u)}updateValue(u,d,v={}){let f;v.resource?(f=this.m.get(v.resource),f||(f=new b,this.m.set(v.resource,f))):f=this.l,d===void 0?f.removeValue(u):f.setValue(u,d),v.resource||(this.a=null)}inspect(u,d,v){const f=this.p(u,d,v),k=this.t(d.resource,v),L=d.resource?this.m.get(d.resource)||this.l:this.l,p=new Set;for(const y of f.overrides)for(const D of y.identifiers)f.getOverrideValue(u,D)!==void 0&&p.add(D);return new t(u,d,f.getValue(u),p.size?[...p]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,v?this.i:void 0,k||void 0,L)}keys(u){const d=this.t(void 0,u);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(u){this.c=u,this.a=null,this.b.clear()}updatePolicyConfiguration(u){this.d=u}updateApplicationConfiguration(u){this.f=u,this.a=null,this.b.clear()}updateLocalUserConfiguration(u){this.g=u,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(u){this.h=u,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(u){this.i=u,this.a=null,this.b.clear()}updateFolderConfiguration(u,d){this.j.set(u,d),this.b.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this.b.delete(u)}compareAndUpdateDefaultConfiguration(u,d){const v=[];if(!d){const{added:f,updated:k,removed:L}=h(this.c,u);d=[...f,...k,...L]}for(const f of d)for(const k of(0,S.$Gn)(f)){const L=this.c.getKeysForOverrideIdentifier(k),p=u.getKeysForOverrideIdentifier(k),y=[...p.filter(D=>L.indexOf(D)===-1),...L.filter(D=>p.indexOf(D)===-1),...L.filter(D=>!m.$in(this.c.override(k).getValue(D),u.override(k).getValue(D)))];v.push([k,y])}return this.updateDefaultConfiguration(u),{keys:d,overrides:v}}compareAndUpdatePolicyConfiguration(u){const{added:d,updated:v,removed:f}=h(this.d,u),k=[...d,...v,...f];return k.length&&this.updatePolicyConfiguration(u),{keys:k,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:d,updated:v,removed:f,overrides:k}=h(this.applicationConfiguration,u),L=[...d,...v,...f];return L.length&&this.updateApplicationConfiguration(u),{keys:L,overrides:k}}compareAndUpdateLocalUserConfiguration(u){const{added:d,updated:v,removed:f,overrides:k}=h(this.localUserConfiguration,u),L=[...d,...v,...f];return L.length&&this.updateLocalUserConfiguration(u),{keys:L,overrides:k}}compareAndUpdateRemoteUserConfiguration(u){const{added:d,updated:v,removed:f,overrides:k}=h(this.remoteUserConfiguration,u),L=[...d,...v,...f];return L.length&&this.updateRemoteUserConfiguration(u),{keys:L,overrides:k}}compareAndUpdateWorkspaceConfiguration(u){const{added:d,updated:v,removed:f,overrides:k}=h(this.workspaceConfiguration,u),L=[...d,...v,...f];return L.length&&this.updateWorkspaceConfiguration(u),{keys:L,overrides:k}}compareAndUpdateFolderConfiguration(u,d){const v=this.folderConfigurations.get(u),{added:f,updated:k,removed:L,overrides:p}=h(v,d),y=[...f,...k,...L];return(y.length||!v)&&this.updateFolderConfiguration(u,d),{keys:y,overrides:p}}compareAndDeleteFolderConfiguration(u){const d=this.folderConfigurations.get(u);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:v,updated:f,removed:k,overrides:L}=h(d,void 0);return{keys:[...v,...f,...k],overrides:L}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(u,d,v){let f=this.q(d,v);return d.overrideIdentifier&&(f=f.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(u)!==void 0&&(f=f.merge(this.d)),f}q({resource:u},d){let v=this.r();if(d&&u){const f=d.getFolder(u);f&&(v=this.s(f.uri)||v);const k=this.m.get(u);k&&(v=v.merge(k))}return v}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(u){let d=this.b.get(u);if(!d){const v=this.r(),f=this.j.get(u);f?(d=v.merge(f),this.b.set(u,d)):d=v}return d}t(u,d){if(d&&u){const v=d.getFolder(u);if(v)return this.j.get(v.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((u,d)=>{const{contents:v,overrides:f,keys:k}=this.j.get(d);return u.push([d,{contents:v,overrides:f,keys:k}]),u},[])}}allKeys(){const u=new Set;return this.c.keys.forEach(d=>u.add(d)),this.userConfiguration.keys.forEach(d=>u.add(d)),this.i.keys.forEach(d=>u.add(d)),this.j.forEach(d=>d.keys.forEach(v=>u.add(v))),[...u.values()]}u(){const u=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>u.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(v=>u.add(v))),[...u.values()]}v(u){const d=new Set;return this.c.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.i.getKeysForOverrideIdentifier(u).forEach(v=>d.add(v)),this.j.forEach(v=>v.getKeysForOverrideIdentifier(u).forEach(f=>d.add(f))),[...d.values()]}static parse(u){const d=this.w(u.defaults),v=this.w(u.policy),f=this.w(u.application),k=this.w(u.user),L=this.w(u.workspace),p=u.folders.reduce((y,D)=>(y.set(w.URI.revive(D[0]),this.w(D[1])),y),new A.$zc);return new n(d,v,f,k,new b,L,p,new b,new A.$zc)}static w(u){return new b(u.contents,u.keys,u.overrides)}}e.$On=n;function o(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const u=new Set,d=new Map;for(const f of r)f.keys.forEach(k=>u.add(k)),f.overrides.forEach(([k,L])=>{const p=(0,A.$wc)(d,k,new Set);L.forEach(y=>p.add(y))});const v=[];return d.forEach((f,k)=>v.push([k,[...f.values()]])),{keys:[...u.values()],overrides:v}}e.$Pn=o;class c{constructor(u,d,v,f){this.change=u,this.f=d,this.g=v,this.h=f,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const k of u.keys)this.affectedKeys.add(k);for(const[,k]of u.overrides)for(const L of k)this.affectedKeys.add(L);this.d=this.a;for(const k of this.affectedKeys)this.d+=k+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=n.parse(this.f.data)),this.i}affectsConfiguration(u,d){const v=this.a+u,f=this.d.indexOf(v);if(f<0)return!1;const k=f+v.length;if(k>=this.d.length)return!1;const L=this.d.charCodeAt(k);if(L!==this.b&&L!==this.c)return!1;if(d){const p=this.previousConfiguration?this.previousConfiguration.getValue(u,d,this.f?.workspace):void 0,y=this.g.getValue(u,d,this.h);return!m.$in(p,y)}return!0}}e.$Qn=c;function h(r,u){const{added:d,removed:v,updated:f}=i(u?.rawConfiguration,r?.rawConfiguration),k=[],L=r?.getAllOverrideIdentifiers()||[],p=u?.getAllOverrideIdentifiers()||[];if(u){const y=p.filter(D=>!L.includes(D));for(const D of y)k.push([D,u.getKeysForOverrideIdentifier(D)])}if(r){const y=L.filter(D=>!p.includes(D));for(const D of y)k.push([D,r.getKeysForOverrideIdentifier(D)])}if(u&&r){for(const y of L)if(p.includes(y)){const D=i({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:u.getOverrideValue(void 0,y)||{},keys:u.getKeysForOverrideIdentifier(y)});k.push([y,[...D.added,...D.removed,...D.updated]])}}return{added:d,removed:v,updated:f,overrides:k}}function i(r,u){const d=r?u?r.keys.filter(k=>u.keys.indexOf(k)===-1):[...r.keys]:[],v=u?r?u.keys.filter(k=>r.keys.indexOf(k)===-1):[...u.keys]:[],f=[];if(r&&u){for(const k of u.keys)if(r.keys.indexOf(k)!==-1){const L=(0,R.$Bi)(u.contents,k),p=(0,R.$Bi)(r.contents,k);m.$in(L,p)||f.push(k)}}return{added:d,removed:v,updated:f}}}),define(Pe[100],Re([1,0,11,4]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4k=e.$3k=e.RemoteAuthorityResolverErrorCode=e.$2k=e.$1k=e.RemoteConnectionType=e.$Zk=void 0,e.$Zk=(0,T.$Zh)("remoteAuthorityResolverService");var P;(function(R){R[R.WebSocket=0]="WebSocket",R[R.Managed=1]="Managed"})(P||(e.RemoteConnectionType=P={}));class M{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$1k=M;class A{constructor(S,l){this.host=S,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$2k=A;var m;(function(R){R.Unknown="Unknown",R.NotAvailable="NotAvailable",R.TemporarilyNotAvailable="TemporarilyNotAvailable",R.NoResolverFound="NoResolverFound",R.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class g extends E.$ab{static isNotAvailable(S){return S instanceof g&&S._code===m.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof g&&S._code===m.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof g&&S._code===m.NoResolverFound}static isInvalidAuthority(S){return S instanceof g&&S._code===m.InvalidAuthority}static isHandled(S){return S instanceof g&&S.isHandled}constructor(S,l=m.Unknown,$){super(S),this._message=S,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,g.prototype)}}e.$3k=g;function w(R){const S=R.indexOf("+");return S===-1?R:R.substring(0,S)}e.$4k=w}),define(Pe[55],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9k=e.$8k=e.$7k=e.$6k=e.$5k=void 0;function T(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.$5k=T;function P(w){if(!w)return;const R=w.indexOf("+");return R<0?w:w.substr(0,R)}e.$6k=P;function M(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.$7k=M;function A(w){const{host:R,port:S}=g(w);if(typeof S>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:S}}e.$8k=A;function m(w,R){let{host:S,port:l}=g(w);return typeof l>"u"&&(l=R),{host:S,port:l}}e.$9k=m;function g(w){const R=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const S=w.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const l=w.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:w,port:void 0}}}),define(Pe[22],Re([1,0,12,4,55]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=e.$em=e.$dm=e.TargetPlatform=e.ExtensionType=e.$cm=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=void 0,e.$0l="extensions.user.cache",e.$$l="extensions.builtin.cache",e.$_l="undefined_publisher",e.$am=["ui","workspace","web"];function M(a){if(typeof a=="object"&&a!==null&&a.supported!==!0)return a.description}e.$bm=M,e.$cm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(a){a[a.System=0]="System",a[a.User=1]="User"})(A||(e.ExtensionType=A={}));var m;(function(a){a.WIN32_X64="win32-x64",a.WIN32_ARM64="win32-arm64",a.LINUX_X64="linux-x64",a.LINUX_ARM64="linux-arm64",a.LINUX_ARMHF="linux-armhf",a.ALPINE_X64="alpine-x64",a.ALPINE_ARM64="alpine-arm64",a.DARWIN_X64="darwin-x64",a.DARWIN_ARM64="darwin-arm64",a.WEB="web",a.UNIVERSAL="universal",a.UNKNOWN="unknown",a.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class g{constructor(s){this.value=s,this._lower=s.toLowerCase()}static equals(s,t){if(typeof s>"u"||s===null)return typeof t>"u"||t===null;if(typeof t>"u"||t===null)return!1;if(typeof s=="string"||typeof t=="string"){const n=typeof s=="string"?s:s.value,o=typeof t=="string"?t:t.value;return E.$6e(n,o)}return s._lower===t._lower}static toKey(s){return typeof s=="string"?s.toLowerCase():s._lower}}e.$dm=g;class w{get size(){return this.c.size}constructor(s){if(this.c=new Set,s)for(const t of s)this.add(t)}add(s){this.c.add(g.toKey(s))}delete(s){return this.c.delete(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}}e.$em=w;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(s){this.c.delete(g.toKey(s))}get(s){return this.c.get(g.toKey(s))}has(s){return this.c.has(g.toKey(s))}set(s,t){this.c.set(g.toKey(s),t)}values(){return this.c.values()}forEach(s){this.c.forEach(s)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$fm=R;function S(a){return l(a)}e.$gm=S;function l(a){return a.contributes&&a.contributes.localizations?a.contributes.localizations.length>0:!1}e.$hm=l;function $(a){return a.contributes&&a.contributes.authentication?a.contributes.authentication.length>0:!1}e.$im=$;function b(a,s){if(s){const t=`onResolveRemoteAuthority:${(0,P.$6k)(s)}`;return!!a.activationEvents?.includes(t)}return!1}e.$jm=b,e.$km=(0,T.$Zh)("IBuiltinExtensionsScannerService")}),define(Pe[101],Re([1,0,11,22]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CF=e.$BF=void 0;class P{constructor(){this.a=new Map,this.b=new WeakMap}register(A,m){this.a.set(A,m)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const m=Object.create(null);for(const g of A){const w=this.readActivationEvents(g);w.length>0&&(m[T.$dm.toKey(g.identifier)]=w)}return m}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const m=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let g=0;g<m.length;g++)m[g]==="onUri"&&(m[g]=`onUri:${T.$dm.toKey(A.identifier)}`);if(!A.contributes)return m;for(const g in A.contributes){const w=this.a.get(g);if(!w)continue;const R=A.contributes[g],S=Array.isArray(R)?R:[R];try{w(S,m)}catch(l){(0,E.$Z)(l)}}return m}}e.$BF=P,e.$CF=new P}),define(Pe[190],Re([1,0,21,74,33]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$so=e.$ro=void 0;function M(g){if(E.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function A(g,w,R,S,l,$,b,a,s){const t=Object.create(null);t["common.machineId"]=$,t["common.sqmId"]=b,t.sessionID=(0,P.$kg)()+Date.now(),t.commitHash=S,t.version=l,t["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,E.$h)(E.$u),t["common.nodePlatform"]=T.$cc,t["common.nodeArch"]=R,t["common.product"]=s||"desktop",a&&(t["common.msftInternal"]=a);let n=0;const o=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),E.$l&&(t["common.snap"]="true");const c=M(w);return c&&(t["common.platformDetail"]=c),t}e.$ro=A;function m(g){const w=T.env.USERDNSDOMAIN;if(!w)return!1;const R=w.toLowerCase();return g.some(S=>R===S)}e.$so=m}),define(Pe[191],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=void 0,e.$ml=(0,E.$Zh)("telemetryService"),e.$nl=(0,E.$Zh)("customEndpointTelemetryService"),e.$ol="telemetry.currentSessionDate",e.$pl="telemetry.firstSessionDate",e.$ql="telemetry.lastSessionDate",e.$rl="telemetry.machineId",e.$sl="telemetry.sqmId",e.$tl="telemetry",e.$ul="telemetry.telemetryLevel",e.$vl="telemetry.enableCrashReporter",e.$wl="telemetry.enableTelemetry";var T;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(T||(e.TelemetryLevel=T={}));var P;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(P||(e.TelemetryConfiguration=P={}))}),define(Pe[56],Re([1,0,26,16,5,41,55,190,191]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=void 0;class w{constructor(v){this.value=v,this.isTrustedTelemetryValue=!0}}e.$to=w;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$uo=R,e.$vo=new R;class S{async publicLog(v,f,k){}async publicLogError(v,f,k){}}e.$wo=S,e.$xo="telemetry",e.$yo="extensionTelemetryLog",e.$zo={log:()=>null,flush:()=>Promise.resolve(null)};function l(d,v){return P.Event.debounce(v.onDidChangeConfiguration,(k,L)=>{const p=k?new Set([...k.affectedKeys,...L.affectedKeys]):L.affectedKeys;return{...L,affectedKeys:p}},1e3,!0)(k=>{k.source!==7&&d.publicLog2("updateConfiguration",{configurationSource:(0,M.$wi)(k.source),configurationKeys:Array.from(k.affectedKeys)})})}e.$Ao=l;function $(d,v){return!v.isBuilt&&!v.disableTelemetry?!0:!(v.disableTelemetry||!d.enableTelemetry)}e.$Bo=$;function b(d,v){return v.extensionTestsLocationURI?!0:!(v.isBuilt||v.disableTelemetry||d.enableTelemetry&&d.aiConfig?.ariaKey)}e.$Co=b;function a(d){const v=d.getValue(g.$ul),f=d.getValue(g.$vl);if(d.getValue(g.$wl)===!1||f===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Do=a;function s(d){const v={},f={},k={};o(d,k);for(let L in k){L=L.length>150?L.substr(L.length-149):L;const p=k[L];typeof p=="number"?f[L]=p:typeof p=="boolean"?f[L]=p?1:0:typeof p=="string"?(p.length>8192&&console.warn(`Telemetry property: ${L} has been trimmed to 8192, the original length is ${p.length}`),v[L]=p.substring(0,8191)):typeof p<"u"&&p!==null&&(v[L]=p)}return{properties:v,measurements:f}}e.$Eo=s;const t=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function n(d){if(!d)return"none";const v=(0,A.$6k)(d);return t.has(v)?v:"other"}e.$Fo=n;function o(d,v,f=0,k){if(d)for(const L of Object.getOwnPropertyNames(d)){const p=d[L],y=k?k+L:L;Array.isArray(p)?v[y]=(0,E.$jn)(p):p instanceof Date?v[y]=p.toISOString():(0,T.$Ef)(p)?f<2?o(p,v,f+1,y+"."):v[y]=(0,E.$jn)(p):v[y]=p}}function c(d,v){const f=d.msftInternalDomains||[],k=v.getValue("telemetry.internalTesting");return(0,m.$so)(f)||k}e.$Go=c;function h(d){return[d.appRoot,d.extensionsPath,d.userHome.fsPath,d.tmpDir.fsPath,d.userDataPath]}e.$Ho=h;function i(d,v){if(!d||!d.includes("/")&&!d.includes("\\"))return d;let f=d;const k=[];for(const D of v)for(;;){const N=D.exec(d);if(!N)break;k.push([N.index,D.lastIndex])}const L=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let y=0;for(f="";;){const D=p.exec(d);if(!D)break;const N=k.some(([q,V])=>D.index<V&&q<p.lastIndex);!L.test(D[0])&&!N&&(f+=d.substring(y,D.index)+"<REDACTED: user-file-path>",y=p.lastIndex)}return y<d.length&&(f+=d.substr(y)),f}function r(d){if(!d)return d;const v=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const f of v)if(f.regex.test(d))return`<REDACTED: ${f.label}>`;return d}function u(d,v){return(0,E.$gn)(d,f=>{if(f instanceof w||Object.hasOwnProperty.call(f,"isTrustedTelemetryValue"))return f.value;if(typeof f=="string"){let k=f.replaceAll("%20"," ");k=i(k,v);for(const L of v)k=k.replace(L,"");return k=r(k),k}})}e.$Io=u}),define(Pe[192],Re([1,0,12,97,22,21,2,11,74,56]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=e.$Ko=e.$Jo=void 0;function R(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,E.$1e)(u.id,d.id)===0}e.$Jo=R;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(d){const v=d.manifest?d.manifest.version:d.version,f=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new l(d.identifier,v,f)}static parse(d){const v=S.exec(d);return v&&v[1]&&v[2]?new l({id:v[1]},v[2],v[4]||void 0):null}constructor(d,v,f="undefined"){this.version=v,this.targetPlatform=f,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof l?R(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$Ko=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(u){const d=$.exec(u);return d&&d[1]?[s(d[1]),d[2]]:[s(u),void 0]}e.$Lo=b;function a(u,d){return`${u}.${d}`}e.$Mo=a;function s(u){return u.toLowerCase()}e.$No=s;function t(u,d){return s(a(u??P.$_l,d))}e.$Oo=t;function n(u,d){const v=[],f=k=>{for(const L of v)if(L.some(p=>R(d(p),d(k))))return L;return null};for(const k of u){const L=f(k);L?L.push(k):v.push([k])}return v}e.$Po=n;function o(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.$Qo=o;function c(u){return{id:new w.$to(u.identifier.id),name:new w.$to(u.name),galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),isSigned:u.isSigned,...u.telemetryData}}e.$Ro=c,e.$So=new P.$dm("pprice.better-merge");function h(u,d){const v=[],f=d.manifest.extensionDependencies?.slice(0)??[];for(;f.length;){const k=f.shift();if(k&&v.every(L=>!R(L.identifier,{id:k}))){const L=u.filter(p=>R(p.identifier,{id:k}));L.length===1&&(v.push(L[0]),f.push(...L[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.$To=h;async function i(u,d){if(!M.$k)return!1;let v;try{v=(await u.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{v=(await u.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(k){d.debug("Error while getting the os-release file.",(0,m.$9)(k))}}return!!v&&(v.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(u,d){const v=await i(u,d),f=(0,T.$do)(v?"alpine":M.$u,g.$dc);return d.debug("ComputeTargetPlatform:",f),f}e.$Uo=r}),define(Pe[193],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.$wr=e.$vr=e.$ur=void 0;function E(g){return[...g.entries()]}e.$ur=E;function T(g){return g?[...g.entries()]:[]}e.$vr=T;function P(g){return new Map(g)}e.$wr=P;function M(g){return new Map(g??[])}e.$xr=M;function A(g){return Array.from(g.entries()).map(w=>[w[0],E(w[1].map),T(w[1].descriptionMap)])}e.$yr=A;function m(g){return new Map(g.map(w=>[w[0],{map:P(w[1]),descriptionMap:M(w[2])}]))}e.$zr=m}),define(Pe[194],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5qb=void 0;class E{constructor(P){this.b=P,this.a=new Map}dispose(){for(const P of this.a.values())P.dispose()}startBuffering(P,M,A=5){const m=M(g=>{const w=typeof g=="string"?g:g.data;let R=this.a.get(P);if(R){R.data.push(w);return}const S=setTimeout(()=>this.flushBuffer(P),A);R={data:[w],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(P),m.dispose()}},this.a.set(P,R)});return m}stopBuffering(P){this.a.get(P)?.dispose()}flushBuffer(P){const M=this.a.get(P);M&&(this.a.delete(P),this.b(P,M.data.join("")))}}e.$5qb=E}),define(Pe[195],Re([1,0,14,90,45,5,16,2,154,73,30]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.$gw=e.$fw=e.IconFontDefinition=e.IconContribution=e.$ew=void 0,e.$ew={IconContribution:"base.contributions.icons"};var S;(function(c){function h(i,r){let u=i.defaults;for(;P.ThemeIcon.isThemeIcon(u);){const d=b.getIcon(u.id);if(!d)return;u=d.defaults}return u}c.getDefinition=h})(S||(e.IconContribution=S={}));var l;(function(c){function h(r){return{weight:r.weight,style:r.style,src:r.src.map(u=>({format:u.format,location:u.location.toString()}))}}c.toJSONObject=h;function i(r){const u=d=>(0,A.$Cf)(d)?d:void 0;if(r&&Array.isArray(r.src)&&r.src.every(d=>(0,A.$Cf)(d.format)&&(0,A.$Cf)(d.location)))return{weight:u(r.weight),style:u(r.style),src:r.src.map(d=>({format:d.format,location:m.URI.parse(d.location)}))}}c.fromJSONObject=i})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new M.$Rd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${P.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(h,i,r,u){const d=this.b[h];if(d){if(r&&!d.description){d.description=r,this.d.properties[h].markdownDescription=`${r} $(${h})`;const k=this.e.enum.indexOf(h);k!==-1&&(this.e.enumDescriptions[k]=r),this.a.fire()}return d}const v={id:h,description:r,defaults:i,deprecationMessage:u};this.b[h]=v;const f={$ref:"#/definitions/icons"};return u&&(f.deprecationMessage=u),r&&(f.markdownDescription=`${r}: $(${h})`),this.d.properties[h]=f,this.e.enum.push(h),this.e.enumDescriptions.push(r||""),this.a.fire(),{id:h}}deregisterIcon(h){delete this.b[h],delete this.d.properties[h];const i=this.e.enum.indexOf(h);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(h=>this.b[h])}getIcon(h){return this.b[h]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(h,i){const r=this.f[h];return r||(this.f[h]=i,this.a.fire(),i)}deregisterIconFont(h){delete this.f[h]}getIconFont(h){return this.f[h]}toString(){const h=(d,v)=>d.id.localeCompare(v.id),i=d=>{for(;P.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},r=[];r.push("| preview     | identifier                        | default codicon ID                | description"),r.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const u=Object.keys(this.b).map(d=>this.b[d]);for(const d of u.filter(v=>!!v.description).sort(h))r.push(`|<i class="${i(d)}"></i>|${d.id}|${P.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);r.push("| preview     | identifier                        "),r.push("| ----------- | --------------------------------- |");for(const d of u.filter(v=>!P.ThemeIcon.isThemeIcon(v.defaults)).sort(h))r.push(`|<i class="${i(d)}"></i>|${d.id}|`);return r.join(`
`)}}const b=new $;R.$qn.add(e.$ew.IconContribution,b);function a(c,h,i,r){return b.registerIcon(c,h,i,r)}e.$fw=a;function s(){return b}e.$gw=s;function t(){const c=(0,T.$3j)();for(const h in c){const i="\\"+c[h].toString(16);b.registerIcon(h,{fontCharacter:i})}}t(),e.$hw="vscode://schemas/icons";const n=R.$qn.as(w.$rn.JSONContribution);n.registerSchema(e.$hw,b.getIconSchema());const o=new E.$_g(()=>n.notifySchemaChanged(e.$hw),200);b.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$iw=a("widget-close",T.$5j.close,(0,g.localize)(2,null)),e.$jw=a("goto-previous-location",T.$5j.arrowUp,(0,g.localize)(3,null)),e.$kw=a("goto-next-location",T.$5j.arrowDown,(0,g.localize)(4,null)),e.$lw=P.ThemeIcon.modify(T.$5j.sync,"spin"),e.$mw=P.ThemeIcon.modify(T.$5j.loading,"spin")}),define(Pe[196],Re([1,0,5,41,4,15]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.$qv=e.$pv=e.$ov=e.$nv=e.$mv=e.$lv=e.ProvidedOnAutoForward=e.$kv=e.TunnelPrivacyId=e.TunnelProtocol=e.$jv=e.$iv=void 0,e.$iv=(0,P.$Zh)("tunnelService"),e.$jv=(0,P.$Zh)("sharedTunnelsService");var A;(function(s){s.Http="http",s.Https="https"})(A||(e.TunnelProtocol=A={}));var m;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(m||(e.TunnelPrivacyId=m={}));function g(s){return!!s.forwardPort}e.$kv=g;var w;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(w||(e.ProvidedOnAutoForward=w={}));function R(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(t)return{address:t[1],port:+t[2]}}e.$lv=R,e.$mv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(s){return e.$mv.indexOf(s)>=0}e.$nv=S,e.$ov=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function l(s){return e.$ov.indexOf(s)>=0}e.$pv=l;function $(s,t,n,o){if(n===1)return!1;if(n===2&&l(t)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(o);if(c?.length===4&&parseInt(c[1])>=18)return!1}return s<1024}e.$qv=$;class b{constructor(t,n,o){this.remoteAddress=t,this.localAddress=n,this.b=o,this.a=new E.$Rd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$rv=b;let a=class{constructor(t,n){this.j=t,this.k=n,this.a=new E.$Rd,this.onTunnelOpened=this.a.event,this.b=new E.$Rd,this.onTunnelClosed=this.b.event,this.c=new E.$Rd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=[],this.i=new Set}get hasTunnelProvider(){return!!this.f}get l(){const t=this.k.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.h=[]}}):(this.g=!1,this.h=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.h=t.privacyOptions}get canElevate(){return this.g}get canChangePrivacy(){return this.h.length>0}get privacyOptions(){return this.h}get tunnels(){return this.m()}async m(){const t=[],n=Array.from(this.e.values());for(const o of n){const c=Array.from(o.values());for(const h of c){const i=await h.value;i&&typeof i!="string"&&t.push(i)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:n}of t.values())await n.then(o=>typeof o!="string"?o?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,n,o,c,h){this.p(t,n,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:n,localAddress:o,privacy:c,protocol:h,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,n){(l(t)||S(t))&&(t=e.$mv[0]);const o=this.r(t,n);if(o)return++o.refcount,o.value}openTunnel(t,n,o,c,h,i=!1,r,u){this.j.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${n}:${o} on local port ${h}.`);const d=this.f??t;if(!d)return;if(n||(n="localhost"),c||(c=this.l),this.f&&this.i.has(o)){this.j.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.s(d,n,o,c,h,i,r,u);return v?v.then(f=>{if(f){if(typeof f=="string")return this.j.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.q(n,o),f}else{this.j.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.q(n,o);return}this.j.trace("ForwardedPorts: (TunnelService) New tunnel established.");const k=this.n(f);return(f.tunnelRemoteHost!==n||f.tunnelRemotePort!==o)&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),r&&f.privacy!==r&&this.j.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(k),k}):(this.j.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}n(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.j.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const n=this.e.get(t.tunnelRemoteHost);if(n){const o=n.get(t.tunnelRemotePort);o&&(o.refcount--,await this.o(t.tunnelRemoteHost,t.tunnelRemotePort,o))}}}}async o(t,n,o){if(o.refcount<=0){this.j.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${n}.`);const c=o.value.then(async h=>{h&&typeof h!="string"&&(await h.dispose(!0),this.b.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(n),c}}async closeTunnel(t,n){this.j.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${n} `);const o=this.e.get(t);if(o&&o.has(n)){const c=o.get(n);c.refcount=0,await this.o(t,n,c)}}p(t,n,o){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(n,{refcount:1,value:o})}async q(t,n){const o=this.e.get(t);if(o){const c=o.get(n),h=c?await c.value:void 0;(!h||typeof h=="string")&&o.delete(n),o.size===0&&this.e.delete(t)}}r(t,n){const o=[t];S(t)?(o.push(...e.$mv),o.push(...e.$ov)):l(t)&&o.push(...e.$ov);const c=o.map(h=>this.e.get(h));for(const h of c){const i=h?.get(n);if(i)return i}}canTunnel(t){return!!R(t)}t(t,n,o,c,h,i,r){this.j.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${n}:${o} on local port ${c}.`);const u=o;this.i.add(u);const d=c===void 0?o:c,v={elevationRequired:h?this.isPortPrivileged(d):!1},f={remoteAddress:{host:n,port:o},localAddressPort:c,privacy:i,public:i?i!==m.Private:void 0,protocol:r},k=t.forwardPort(f,v);return k?(this.p(n,o,k),k.finally(()=>{this.j.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.i.delete(u)})):this.i.delete(u),k}};e.$sv=a,e.$sv=a=He([We(0,M.$hj),We(1,T.$ti)],a)}),define(Pe[197],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$tv=void 0,e.$tv=(0,E.$Zh)("editSessionIdentityService");var T;(function(P){P[P.Complete=100]="Complete",P[P.Partial=50]="Partial",P[P.None=0]="None"})(T||(e.EditSessionIdentityMatch=T={}))}),define(Pe[198],Re([1,0,13]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fK=e.$eK=e.$dK=e.$cK=e.$bK=void 0;function T(g){return g.scheme!==E.Schemas.file&&g.scheme!==E.Schemas.vscodeRemote}e.$bK=T;function P(g){if(g.folders.length)return g.folders.every(w=>T(w.uri))?g.folders[0].uri:void 0;if(g.configuration&&T(g.configuration))return g.configuration}e.$cK=P;function M(g){return P(g)?.scheme}e.$dK=M;function A(g){return P(g)?.authority}e.$eK=A;function m(g){return P(g)!==void 0}e.$fK=m}),define(Pe[47],Re([1,0,155,20,50,25,2,4,13]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.WorkbenchState=e.$di=e.$ci=e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=e.$9h=void 0,e.$9h=(0,m.$Zh)("contextService");function w(d){const v=d;return typeof v?.id=="string"&&A.URI.isUri(v.uri)}e.$0h=w;function R(d){return typeof d?.id=="string"&&!w(d)&&!l(d)}e.$$h=R,e.$_h={id:"ext-dev"},e.$ai={id:"empty-window"};function S(d,v){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,T.$mc)(d)}:v?e.$_h:e.$ai;const f=d;return f.configuration?{id:f.id,configPath:f.configuration}:f.folders.length===1?{id:f.id,uri:f.folders[0].uri}:{id:f.id}}e.$bi=S;function l(d){const v=d;return typeof v?.id=="string"&&A.URI.isUri(v.configPath)}e.$ci=l;function $(d){const v=d;if(v?.uri)return{id:v.id,uri:A.URI.revive(v.uri)};const f=d;if(f?.configPath)return{id:f.id,configPath:A.URI.revive(f.configPath)};if(d?.id)return{id:d.id}}e.$di=$;var b;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function a(d){const v=d;return!!(v&&typeof v=="object"&&typeof v.id=="string"&&Array.isArray(v.folders))}e.$ei=a;function s(d){const v=d;return!!(v&&typeof v=="object"&&A.URI.isUri(v.uri)&&typeof v.name=="string"&&typeof v.toResource=="function")}e.$fi=s;class t{constructor(v,f,k,L,p){this.h=v,this.j=k,this.k=L,this.l=p,this.c=P.$6h.forUris(this.l,()=>!0),this.folders=f}update(v){this.h=v.id,this.k=v.configuration,this.j=v.transient,this.l=v.l,this.folders=v.folders}get folders(){return this.g}set folders(v){this.g=v,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(v){this.k=v}getFolder(v){return v&&this.c.findSubstr(v)||null}n(){this.c=P.$6h.forUris(this.l,()=>!0);for(const v of this.folders)this.c.set(v.uri,v)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$gi=t;class n{constructor(v,f){this.raw=f,this.uri=v.uri,this.index=v.index,this.name=v.name}toResource(v){return(0,M.$Bg)(this.uri,v)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$hi=n;function o(d){return new n({uri:d,index:0,name:(0,M.$xg)(d)},{uri:d.toString()})}e.$ii=o,e.$ji="code-workspace",e.$ki=`.${e.$ji}`,e.$li=[{name:(0,E.localize)(0,null),extensions:[e.$ji]}],e.$mi="workspace.json";function c(d,v){return M.$sg.isEqualOrParent(d,v.untitledWorkspacesHome)}e.$ni=c;function h(d){let v;return A.URI.isUri(d)?v=d:v=d.configuration,v?.scheme===g.Schemas.tmp}e.$oi=h,e.$pi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(d){return d.id===e.$pi}e.$qi=i;function r(d,v){return!c(d,v)&&!h(d)}e.$ri=r;function u(d){return(typeof d=="string"?(0,T.$nc)(d):(0,M.$zg)(d))===e.$ki}e.$si=u}),define(Pe[75],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vec=void 0;class E{static{this.a=!1}constructor(P){this.d=P,this.b=new Map,this.c=1}add(P){const M=this.c++;return this.b.set(M,P),this.e(),M}get(P,M){return this.b.has(P)?this.b.get(P)[M]:void 0}delete(P){this.b.delete(P),this.e()}e(){E.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$vec=E}),define(Pe[43],Re([1,0,13,25,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zec=e.$yec=void 0;class M{constructor(){this.a=new Set(Object.keys(E.Schemas)),this.b=new Map,this.extUri=new T.$qg(m=>{const g=this.b.get(m.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(m,g){g===null?this.b.delete(m.scheme):this.b.set(m.scheme,g)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$yec=M,e.$zec=(0,P.$Zh)("IExtHostFileSystemInfo")}),define(Pe[27],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XM=void 0,e.$XM=(0,E.$Zh)("IExtHostInitDataService")}),define(Pe[199],Re([1,0,160,15,186,27]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;let A=class extends P.$5N{constructor(g,w,R){const S=R.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=R.remote.isRemote?(0,E.localize)(0,null):g?(0,E.localize)(1,null):(0,E.localize)(2,null);super(w.createLogger(S,{name:l}))}};e.$Fgc=A,e.$Fgc=A=He([We(1,T.$ij),We(2,M.$XM)],A)}),define(Pe[200],Re([1,0,14]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ifc=e.$hfc=void 0;class T{constructor(A,m,g){this.h=new Map,this.a=A,this.b=m,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(w=>(this.f=w,this)),this.g=this.c.onDidChangeStorage(w=>{w.shared===this.b&&w.key===this.a&&(this.f=w.value)}),this.i=new E.$_g(()=>{const w=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const R of w.values())R.complete()}catch(R){for(const S of w.values())S.error(R)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,m){let g=this.f[A];return typeof g>"u"&&(g=m),g}update(A,m){this.f[A]=m;const g=this.h.get(A);if(g!==void 0)return g.p;const w=new E.$kh;return this.h.set(A,w),this.i.isScheduled()||this.i.schedule(),w.p}dispose(){this.g.dispose()}}e.$hfc=T;class P extends T{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,m){super(A.identifier.value,!0,m),this.j=A}}e.$ifc=P}),define(Pe[201],Re([1,0,5,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8fc=void 0;class P{constructor(A){this.c=A,this.a=new E.$Rd,this.onDidSaveNotebookDocument=this.a.event,this.b=new E.$Rd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,m,g,w){const S=this.c.getNotebookDocument(T.URI.revive(A)).acceptModelChanged(m.value,g,w);this.b.fire(S)}$acceptDirtyStateChanged(A,m){this.c.getNotebookDocument(T.URI.revive(A)).acceptDirty(m)}$acceptModelSaved(A){const m=this.c.getNotebookDocument(T.URI.revive(A));this.a.fire(m.apiNotebook)}}e.$8fc=P}),define(Pe[17],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IM=e.$HM=void 0,e.$HM=(0,E.$Zh)("IExtHostRpcService");class T{constructor(M){this.getProxy=M.getProxy.bind(M),this.set=M.set.bind(M),this.dispose=M.dispose.bind(M),this.assertRegistered=M.assertRegistered.bind(M),this.drain=M.drain.bind(M)}}e.$IM=T}),define(Pe[202],Re([1,0,22,5]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pfc=void 0;class P{#e;constructor(A,m){this.b=new T.$Rd,this.onDidChange=this.b.event,this.a=E.$dm.toKey(A.identifier),this.#e=m,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(A){return this.#e.get(this.a,A)}store(A,m){return this.#e.store(this.a,A,m)}delete(A){return this.#e.delete(this.a,A)}}e.$pfc=P}),define(Pe[57],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sec=e.$Rec=void 0,e.$Rec=(0,E.$Zh)("IURITransformerService");class T{constructor(M){M?(this.transformIncoming=M.transformIncoming.bind(M),this.transformOutgoing=M.transformOutgoing.bind(M),this.transformOutgoingURI=M.transformOutgoingURI.bind(M),this.transformOutgoingScheme=M.transformOutgoingScheme.bind(M)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$Sec=T}),define(Pe[203],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kfb=e.$jfb=void 0;class T{constructor(){this.buffers=[]}add(g){let w=this.buffers.indexOf(g);return w<0&&(w=this.buffers.length,this.buffers.push(g)),w}}function P(m,g){if(g.serializeBuffersForPostMessage){const w=new T,S=JSON.stringify(m,($,b)=>{if(b instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b)};if(ArrayBuffer.isView(b)){const a=M(b);if(a)return{$$vscode_array_buffer_reference$$:!0,index:w.add(b.buffer),view:{type:a,byteLength:b.byteLength,byteOffset:b.byteOffset}}}return b}),l=w.buffers.map($=>{const b=new Uint8Array($);return E.$fe.wrap(b)});return{message:S,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$jfb=P;function M(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(m,g){const w=g.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),R=g.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const b=$,{index:a}=b,s=w[a];if(b.view)switch(b.view.type){case 1:return new Int8Array(s,b.view.byteOffset,b.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(s,b.view.byteOffset,b.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(s,b.view.byteOffset,b.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(s,b.view.byteOffset,b.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(s,b.view.byteOffset,b.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(s,b.view.byteOffset,b.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(s,b.view.byteOffset,b.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(s,b.view.byteOffset,b.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(s,b.view.byteOffset,b.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(s,b.view.byteOffset,b.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(s,b.view.byteOffset,b.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return s}return $}:void 0;return{message:JSON.parse(m,R),arrayBuffers:w}}e.$kfb=A}),define(Pe[102],Re([1,0,170,16,2,6,4,30,42,13,40,133,31]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HE=e.$GE=e.$FE=e.EditorsOrder=e.$EE=e.CloseDirection=e.$DE=e.$CE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$BE=e.$AE=e.$zE=e.$yE=e.$xE=e.$wE=e.$vE=e.$uE=e.EditorInputCapabilities=e.$tE=e.SaveReason=e.Verbosity=e.$sE=e.$rE=e.$qE=e.$pE=e.$oE=e.$nE=e.$mE=e.$lE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$kE=e.$jE=e.$iE=e.$hE=e.$gE=void 0,e.$gE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$hE={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.$iE="workbench.editor.sidebysideEditor",e.$jE="workbench.editors.textDiffEditor",e.$kE="workbench.editors.binaryResourceDiffEditor";var $;(function(ce){ce[ce.PROGRAMMATIC=1]="PROGRAMMATIC",ce[ce.USER=2]="USER",ce[ce.EDIT=3]="EDIT",ce[ce.NAVIGATION=4]="NAVIGATION",ce[ce.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var b;(function(ce){ce[ce.IDENTICAL=1]="IDENTICAL",ce[ce.SIMILAR=2]="SIMILAR",ce[ce.DIFFERENT=3]="DIFFERENT"})(b||(e.EditorPaneSelectionCompareResult=b={}));function a(ce){const Y=ce;return!!Y&&typeof Y.getSelection=="function"&&!!Y.onDidChangeSelection}e.$lE=a;function s(ce,Y,W){for(const re of W.visibleEditorPanes)if(re.group.id===Y&&ce.matches(re.input))return re.getViewState()}e.$mE=s;function t(ce){if(k(ce))return!1;const Y=ce;return P.URI.isUri(Y?.resource)}e.$nE=t;function n(ce){if(k(ce))return!1;const Y=ce;return Y?.original!==void 0&&Y.modified!==void 0}e.$oE=n;function o(ce){if(k(ce))return!1;const Y=ce;return Array.isArray(Y?.resources)}e.$pE=o;function c(ce){if(k(ce)||n(ce))return!1;const Y=ce;return Y?.primary!==void 0&&Y.secondary!==void 0}e.$qE=c;function h(ce){if(k(ce))return!1;const Y=ce;return Y?Y.resource===void 0||Y.resource.scheme===w.Schemas.untitled||Y.forceUntitled===!0:!1}e.$rE=h;function i(ce){if(k(ce))return!1;const Y=ce;return P.URI.isUri(Y?.base?.resource)&&P.URI.isUri(Y?.input1?.resource)&&P.URI.isUri(Y?.input2?.resource)&&P.URI.isUri(Y?.result?.resource)}e.$sE=i;var r;(function(ce){ce[ce.SHORT=0]="SHORT",ce[ce.MEDIUM=1]="MEDIUM",ce[ce.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var u;(function(ce){ce[ce.EXPLICIT=1]="EXPLICIT",ce[ce.AUTO=2]="AUTO",ce[ce.FOCUS_CHANGE=3]="FOCUS_CHANGE",ce[ce.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(u||(e.SaveReason=u={}));class d{constructor(){this.a=new Map}registerSource(Y,W){let re=this.a.get(Y);return re||(re={source:Y,label:W},this.a.set(Y,re)),re.source}getSourceLabel(Y){return this.a.get(Y)?.label??Y}}e.$tE=new d;var v;(function(ce){ce[ce.None=0]="None",ce[ce.Readonly=2]="Readonly",ce[ce.Untitled=4]="Untitled",ce[ce.Singleton=8]="Singleton",ce[ce.RequiresTrust=16]="RequiresTrust",ce[ce.CanSplitInGroup=32]="CanSplitInGroup",ce[ce.ForceDescription=64]="ForceDescription",ce[ce.CanDropIntoEditor=128]="CanDropIntoEditor",ce[ce.MultipleEditors=256]="MultipleEditors",ce[ce.Scratchpad=512]="Scratchpad",ce[ce.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(v||(e.EditorInputCapabilities=v={}));class f extends M.$Rc{}e.$uE=f;function k(ce){return ce instanceof f}e.$vE=k;function L(ce){const Y=ce;return P.URI.isUri(Y?.preferredResource)}function p(ce){const Y=ce;return k(Y?.primary)&&k(Y?.secondary)}e.$wE=p;function y(ce){const Y=ce;return k(Y?.modified)&&k(Y?.original)}e.$xE=y;function D(ce,Y,W,re,Ie){return ke(re,[(0,S.$Ji)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const Ae={...W,limits:{size:Number.MAX_VALUE}};ce.openEditor(Y,Ae)}}),(0,S.$Ji)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>Ie.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$yE=D;function N(ce){return k(ce?.editor)}e.$zE=N;function q(ce){const Y=ce;return N(ce)&&Y?.group!==void 0}e.$AE=q;function V(ce){const Y=ce;return typeof Y?.groupId=="number"&&k(Y.editor)}e.$BE=V;var U;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.REPLACE=1]="REPLACE",ce[ce.MOVE=2]="MOVE",ce[ce.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var F;(function(ce){ce[ce.GROUP_ACTIVE=0]="GROUP_ACTIVE",ce[ce.GROUP_INDEX=1]="GROUP_INDEX",ce[ce.GROUP_LABEL=2]="GROUP_LABEL",ce[ce.GROUP_LOCKED=3]="GROUP_LOCKED",ce[ce.EDITOR_OPEN=4]="EDITOR_OPEN",ce[ce.EDITOR_CLOSE=5]="EDITOR_CLOSE",ce[ce.EDITOR_MOVE=6]="EDITOR_MOVE",ce[ce.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ce[ce.EDITOR_LABEL=8]="EDITOR_LABEL",ce[ce.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ce[ce.EDITOR_PIN=10]="EDITOR_PIN",ce[ce.EDITOR_STICKY=11]="EDITOR_STICKY",ce[ce.EDITOR_DIRTY=12]="EDITOR_DIRTY",ce[ce.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(F||(e.GroupModelChangeKind=F={}));var C;(function(ce){ce[ce.PRIMARY=1]="PRIMARY",ce[ce.SECONDARY=2]="SECONDARY",ce[ce.BOTH=3]="BOTH",ce[ce.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class I{getOriginalUri(Y,W){if(!Y)return;if(i(Y))return e.$DE.getOriginalUri(Y.result,W);if(W?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Y);if(Ie&&Ae){if(W?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ie,{filterByScheme:W.filterByScheme}),secondary:this.getOriginalUri(Ae,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===C.ANY)return this.getOriginalUri(Ie,{filterByScheme:W.filterByScheme})??this.getOriginalUri(Ae,{filterByScheme:W.filterByScheme});Y=W.supportSideBySide===C.PRIMARY?Ie:Ae}}if(n(Y)||o(Y)||c(Y)||i(Y))return;const re=L(Y)?Y.preferredResource:Y.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}a(Y){return p(Y)||c(Y)?{primary:Y.primary,secondary:Y.secondary}:y(Y)||n(Y)?{primary:Y.modified,secondary:Y.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(Y,W){if(!Y)return;if(i(Y))return e.$DE.getCanonicalUri(Y.result,W);if(W?.supportSideBySide){const{primary:Ie,secondary:Ae}=this.a(Y);if(Ie&&Ae){if(W?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ie,{filterByScheme:W.filterByScheme}),secondary:this.getCanonicalUri(Ae,{filterByScheme:W.filterByScheme})};if(W?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ie,{filterByScheme:W.filterByScheme})??this.getCanonicalUri(Ae,{filterByScheme:W.filterByScheme});Y=W.supportSideBySide===C.PRIMARY?Ie:Ae}}if(n(Y)||o(Y)||c(Y)||i(Y))return;const re=Y.resource;return!re||!W||!W.filterByScheme?re:this.b(re,W.filterByScheme)}b(Y,W){if(Array.isArray(W)){if(W.some(re=>Y.scheme===re))return Y}else if(W===Y.scheme)return Y}}var X;(function(ce){ce[ce.UNKNOWN=0]="UNKNOWN",ce[ce.KEYBOARD=1]="KEYBOARD",ce[ce.MOUSE=2]="MOUSE"})(X||(e.EditorCloseMethod=X={}));function ue(ce,Y,W,re){if(!ce.isSticky(Y))return!1;switch(re.preventPinnedEditorClose){case"keyboardAndMouse":return W===X.MOUSE||W===X.KEYBOARD;case"mouse":return W===X.MOUSE;case"keyboard":return W===X.KEYBOARD}return!1}e.$CE=ue,e.$DE=new I;var he;(function(ce){ce[ce.LEFT=0]="LEFT",ce[ce.RIGHT=1]="RIGHT"})(he||(e.CloseDirection=he={}));class be{constructor(){this.c=new Map,this.d=new Map}start(Y){const W=this.a=Y.get(A.$Yh);for(const[re,Ie]of this.c)this.e(re,Ie,W);this.c.clear()}e(Y,W,re){const Ie=re.createInstance(W);this.d.set(Y,Ie)}registerFileEditorFactory(Y){if(this.b)throw new Error("Can only register one file editor factory.");this.b=Y}getFileEditorFactory(){return(0,T.$Nf)(this.b)}registerEditorSerializer(Y,W){if(this.c.has(Y)||this.d.has(Y))throw new Error(`A editor serializer with type ID '${Y}' was already registered.`);return this.a?this.e(Y,W,this.a):this.c.set(Y,W),(0,M.$Pc)(()=>{this.c.delete(Y),this.d.delete(Y)})}getEditorSerializer(Y){return this.d.get(typeof Y=="string"?Y:Y.typeId)}}m.$qn.add(e.$gE.EditorFactory,new be);async function we(ce,Y,W){return!ce||!ce.length?[]:await Promise.all(ce.map(async re=>{const Ie=P.URI.revive(re.fileUri);if(!Ie){W.info("Cannot resolve the path because it is not valid.",re);return}if(!await Y.canHandleResource(Ie)){W.info("Cannot resolve the path because it cannot be handled",re);return}let Ce=re.exists,le=re.type;if(typeof Ce!="boolean"||typeof le!="number")try{le=(await Y.stat(Ie)).isDirectory?g.FileType.Directory:g.FileType.Unknown,Ce=!0}catch(G){W.error(G),Ce=!1}if(!Ce&&re.openOnlyIfExists){W.info("Cannot resolve the path because it does not exist",re);return}if(le===g.FileType.Directory){W.info("Cannot resolve the path because it is a directory",re);return}const ie={...re.options,pinned:!0};return Ce?{resource:Ie,options:ie}:{resource:Ie,options:ie,forceUntitled:!0}}))}e.$EE=we;var ge;(function(ce){ce[ce.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ce[ce.SEQUENTIAL=1]="SEQUENTIAL"})(ge||(e.EditorsOrder=ge={}));function me(ce){const Y=ce;if(!Y)return!1;const W=Y;if(W.modified)return me(W.modified);const re=Y;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.$FE=me;function ne(ce){return(0,R.$Li)(ce)}e.$GE=ne;function ke(ce,Y,W){const re=(0,R.$Mi)(ce,Y);return re.forceMessage=W?.forceMessage,re.forceSeverity=W?.forceSeverity,re.allowDialog=W?.allowDialog,re}e.$HE=ke}),define(Pe[204],Re([1,0,5,171,4,6,28,30,18,26,90,195]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QE=e.$PE=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$OE=e.$NE=e.ViewContentGroups=e.$ME=e.$LE=e.ViewContainerLocation=e.Extensions=e.$KE=e.$JE=e.$IE=void 0,e.$IE="views",e.$JE=(0,T.localize)(0,null),e.$KE=(0,S.$fw)("default-view-icon",R.$5j.window,(0,T.localize)(1,null));var l;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$LE=[0,1,2];function b(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$ME=b;class a extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onDidRegister=this.c.event,this.f=this.B(new E.$Rd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Qb)([...this.g.values()])}registerViewContainer(u,d,v){const f=this.get(u.id);if(f)return f;const k=u;return k.openCommandActionDescriptor=v?.doNotRegisterOpenCommand?void 0:k.openCommandActionDescriptor??{id:k.id},(0,A.$wc)(this.g,d,[]).push(k),v?.isDefault&&this.h.push(k),this.c.fire({viewContainer:k,viewContainerLocation:d}),k}deregisterViewContainer(u){for(const d of this.g.keys()){const v=this.g.get(d),f=v?.indexOf(u);if(f!==-1){v?.splice(f,1),v.length===0&&this.g.delete(d),this.f.fire({viewContainer:u,viewContainerLocation:d});return}}}get(u){return this.all.filter(d=>d.id===u)[0]}getViewContainers(u){return[...this.g.get(u)||[]]}getViewContainerLocation(u){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(v=>v?.id===u.id).length>0)[0]}getDefaultViewContainer(u){return this.h.find(d=>this.getViewContainerLocation(d)===u)}}m.$qn.add(l.ViewContainersRegistry,new a);var s;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(s||(e.ViewContentGroups=s={}));function t(r,u){const d=r.group??s.More,v=u.group??s.More;return d!==v?d.localeCompare(v):(r.order??5)-(u.order??5)}class n extends M.$Rc{constructor(){super(...arguments),this.c=this.B(new E.$Rd),this.onViewsRegistered=this.c.event,this.f=this.B(new E.$Rd),this.onViewsDeregistered=this.f.event,this.g=this.B(new E.$Rd),this.onDidChangeContainer=this.g.event,this.h=this.B(new E.$Rd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Fc}registerViews(u,d){this.registerViews2([{views:u,viewContainer:d}])}registerViews2(u){u.forEach(({views:d,viewContainer:v})=>this.r(d,v)),this.c.fire(u)}deregisterViews(u,d){const v=this.s(u,d);v.length&&this.f.fire({views:v,viewContainer:d})}moveViews(u,d){for(const v of this.m.keys())if(v!==d){const f=this.s(u,v);f.length&&(this.r(f,d),this.g.fire({views:f,from:v,to:d}))}}getViews(u){return this.m.get(u)||[]}getView(u){for(const d of this.j){const v=(this.m.get(d)||[]).filter(f=>f.id===u)[0];if(v)return v}return null}getViewContainer(u){for(const d of this.j)if((this.m.get(d)||[]).filter(f=>f.id===u)[0])return d;return null}registerViewWelcomeContent(u,d){return this.n.add(u,d),this.h.fire(u),(0,M.$Pc)(()=>{this.n.delete(u,d),this.h.fire(u)})}registerViewWelcomeContent2(u,d){const v=new Map;for(const[f,k]of d)this.n.add(u,k),v.set(f,(0,M.$Pc)(()=>{this.n.delete(u,k),this.h.fire(u)}));return this.h.fire(u),v}getViewWelcomeContent(u){const d=[];return this.n.forEach(u,v=>d.push(v)),d.sort(t)}r(u,d){let v=this.m.get(d);v||(v=[],this.m.set(d,v),this.j.push(d));for(const f of u){if(this.getView(f.id)!==null)throw new Error((0,T.localize)(2,null,f.id));v.push(f)}}s(u,d){const v=this.m.get(d);if(!v)return[];const f=[],k=[];for(const L of v)u.includes(L)?f.push(L):k.push(L);return f.length&&(k.length?this.m.set(d,k):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),f}}m.$qn.add(l.ViewsRegistry,new n),e.$NE=(0,P.$Zh)("viewsService"),e.$OE=(0,P.$Zh)("viewDescriptorService");var o;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var c;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(u,d){this.c=!1,this.d=!1,(0,w.$hn)(this,u),this.d=!!d,this.resolve=async v=>{if(d&&!this.c){const f=await d(v);f&&(this.tooltip=this.tooltip??f.tooltip,this.command=this.command??f.command)}v.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$PE=h;class i extends Error{constructor(u){super((0,T.localize)(3,null,u)),this.name="NoTreeViewError"}static is(u){return u.name==="NoTreeViewError"}}e.$QE=i}),define(Pe[205],Re([1,0,2,29,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$dF=e.$cF=void 0;function M(w){return!!w&&typeof w=="object"&&"uri"in w&&w.uri instanceof E.URI&&"version"in w&&typeof w.version=="number"&&"ranges"in w&&Array.isArray(w.ranges)&&w.ranges.every(T.$Ds.isIRange)}e.$cF=M;function A(w){return!!w&&typeof w=="object"&&"documents"in w&&Array.isArray(w.documents)&&w.documents.every(M)}e.$dF=A;var m;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var g;(function(w){w[w.Action=1]="Action",w[w.Toolbar=2]="Toolbar"})(g||(e.InteractiveSessionCopyKind=g={})),e.$eF=(0,P.$Zh)("IChatService")}),define(Pe[206],Re([1,0,5,14,172]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfb=void 0;class M{constructor(){this.f=new Map,this.k=[],this.m=new E.$Rd,this.n=new E.$Rd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,g,w,R){const S={command:m};if(g&&Object.keys(g).length>0&&(S.arguments=g),this.s("request",S),typeof R=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(S.seq);if($){this.f.delete(S.seq);const b={type:"response",seq:0,request_seq:S.seq,success:!1,command:m,message:(0,P.localize)(0,null,R,m)};$(b)}},R)}return w&&this.f.set(S.seq,w),S.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,g){return m.type!=="event"||g.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,T.$1g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const g=m,w=this.f.get(g.request_seq);w&&(this.f.delete(g.request_seq),w(g));break}}}}s(m,g){g.type=m,g.seq=this.d++,this.sendMessage(g)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((g,w)=>m.set(w,g)),await(0,T.$1g)(500),m.forEach((g,w)=>{g({type:"response",seq:0,request_seq:w,success:!1,command:"canceled",message:"canceled"}),this.f.delete(w)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Pfb=M}),define(Pe[207],Re([1,0,173,35,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.$pH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$oH=e.MemoryRangeType=e.$nH=e.State=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.$HG=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=e.$tG=e.$sG=e.$rG=e.$qG=e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=void 0,e.$kG="workbench.view.debug",e.$lG="workbench.debug.variablesView",e.$mG="workbench.debug.watchExpressionsView",e.$nG="workbench.debug.callStackView",e.$oG="workbench.debug.loadedScriptsView",e.$pG="workbench.debug.breakPointsView",e.$qG="workbench.debug.disassemblyView",e.$rG="workbench.panel.repl",e.$sG="workbench.panel.repl.view",e.$tG=new T.$ej("debugType",void 0,{type:"string",description:E.localize(0,null)}),e.$uG=new T.$ej("debugConfigurationType",void 0,{type:"string",description:E.localize(1,null)}),e.$vG=new T.$ej("debugState","inactive",{type:"string",description:E.localize(2,null)}),e.$wG="debugUx",e.$xG=new T.$ej(e.$wG,"default",{type:"string",description:E.localize(3,null)}),e.$yG=new T.$ej("hasDebugged",!1,{type:"boolean",description:E.localize(4,null)}),e.$zG=new T.$ej("inDebugMode",!1,{type:"boolean",description:E.localize(5,null)}),e.$AG=new T.$ej("inDebugRepl",!1,{type:"boolean",description:E.localize(6,null)}),e.$BG=new T.$ej("breakpointWidgetVisible",!1,{type:"boolean",description:E.localize(7,null)}),e.$CG=new T.$ej("inBreakpointWidget",!1,{type:"boolean",description:E.localize(8,null)}),e.$DG=new T.$ej("breakpointsFocused",!0,{type:"boolean",description:E.localize(9,null)}),e.$EG=new T.$ej("watchExpressionsFocused",!0,{type:"boolean",description:E.localize(10,null)}),e.$FG=new T.$ej("watchExpressionsExist",!1,{type:"boolean",description:E.localize(11,null)}),e.$GG=new T.$ej("variablesFocused",!0,{type:"boolean",description:E.localize(12,null)}),e.$HG=new T.$ej("expressionSelected",!1,{type:"boolean",description:E.localize(13,null)}),e.$IG=new T.$ej("breakpointInputFocused",!1,{type:"boolean",description:E.localize(14,null)}),e.$JG=new T.$ej("callStackItemType",void 0,{type:"string",description:E.localize(15,null)}),e.$KG=new T.$ej("callStackSessionIsAttach",!1,{type:"boolean",description:E.localize(16,null)}),e.$LG=new T.$ej("callStackItemStopped",!1,{type:"boolean",description:E.localize(17,null)}),e.$MG=new T.$ej("callStackSessionHasOneThread",!1,{type:"boolean",description:E.localize(18,null)}),e.$NG=new T.$ej("watchItemType",void 0,{type:"string",description:E.localize(19,null)}),e.$OG=new T.$ej("canViewMemory",void 0,{type:"boolean",description:E.localize(20,null)}),e.$PG=new T.$ej("breakpointItemType",void 0,{type:"string",description:E.localize(21,null)}),e.$QG=new T.$ej("breakpointSupportsCondition",!1,{type:"boolean",description:E.localize(22,null)}),e.$RG=new T.$ej("loadedScriptsSupported",!1,{type:"boolean",description:E.localize(23,null)}),e.$SG=new T.$ej("loadedScriptsItemType",void 0,{type:"string",description:E.localize(24,null)}),e.$TG=new T.$ej("focusedSessionIsAttach",!1,{type:"boolean",description:E.localize(25,null)}),e.$UG=new T.$ej("focusedSessionIsNoDebug",!1,{type:"boolean",description:E.localize(26,null)}),e.$VG=new T.$ej("stepBackSupported",!1,{type:"boolean",description:E.localize(27,null)}),e.$WG=new T.$ej("restartFrameSupported",!1,{type:"boolean",description:E.localize(28,null)}),e.$XG=new T.$ej("stackFrameSupportsRestart",!1,{type:"boolean",description:E.localize(29,null)}),e.$YG=new T.$ej("jumpToCursorSupported",!1,{type:"boolean",description:E.localize(30,null)}),e.$ZG=new T.$ej("stepIntoTargetsSupported",!1,{type:"boolean",description:E.localize(31,null)}),e.$1G=new T.$ej("breakpointsExist",!1,{type:"boolean",description:E.localize(32,null)}),e.$2G=new T.$ej("debuggersAvailable",!1,{type:"boolean",description:E.localize(33,null)}),e.$3G=new T.$ej("debugExtensionAvailable",!0,{type:"boolean",description:E.localize(34,null)}),e.$4G=new T.$ej("debugProtocolVariableMenuContext",void 0,{type:"string",description:E.localize(35,null)}),e.$5G=new T.$ej("debugSetVariableSupported",!1,{type:"boolean",description:E.localize(36,null)}),e.$6G=new T.$ej("debugSetExpressionSupported",!1,{type:"boolean",description:E.localize(37,null)}),e.$7G=new T.$ej("breakWhenValueChangesSupported",!1,{type:"boolean",description:E.localize(38,null)}),e.$8G=new T.$ej("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:E.localize(39,null)}),e.$9G=new T.$ej("breakWhenValueIsReadSupported",!1,{type:"boolean",description:E.localize(40,null)}),e.$0G=new T.$ej("terminateDebuggeeSupported",!1,{type:"boolean",description:E.localize(41,null)}),e.$$G=new T.$ej("suspendDebuggeeSupported",!1,{type:"boolean",description:E.localize(42,null)}),e.$_G=new T.$ej("variableEvaluateNamePresent",!1,{type:"boolean",description:E.localize(43,null)}),e.$aH=new T.$ej("variableIsReadonly",!1,{type:"boolean",description:E.localize(44,null)}),e.$bH=new T.$ej("exceptionWidgetVisible",!1,{type:"boolean",description:E.localize(45,null)}),e.$cH=new T.$ej("multiSessionRepl",!1,{type:"boolean",description:E.localize(46,null)}),e.$dH=new T.$ej("multiSessionDebug",!1,{type:"boolean",description:E.localize(47,null)}),e.$eH=new T.$ej("disassembleRequestSupported",!1,{type:"boolean",description:E.localize(48,null)}),e.$fH=new T.$ej("disassemblyViewFocus",!1,{type:"boolean",description:E.localize(49,null)}),e.$gH=new T.$ej("languageSupportsDisassembleRequest",!1,{type:"boolean",description:E.localize(50,null)}),e.$hH=new T.$ej("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:E.localize(51,null)});const M=l=>E.localize(52,null,l);e.$iH=M,e.$jH="editor.contrib.debug",e.$kH="editor.contrib.breakpoint",e.$lH="debug",e.$mH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:E.localize(53,null)};var A;(function(l){l[l.Inactive=0]="Inactive",l[l.Initializing=1]="Initializing",l[l.Stopped=2]="Stopped",l[l.Running=3]="Running"})(A||(e.State=A={}));function m(l){switch(l){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$nH=m;var g;(function(l){l[l.Valid=0]="Valid",l[l.Unreadable=1]="Unreadable",l[l.Error=2]="Error"})(g||(e.MemoryRangeType=g={})),e.$oH="vscode-debug-memory";var w;(function(l){l[l.Initial=1]="Initial",l[l.Dynamic=2]="Dynamic"})(w||(e.DebugConfigurationProviderTriggerKind=w={}));var R;(function(l){l.UnverifiedBreakpoints="unverifiedBreakpoints"})(R||(e.DebuggerString=R={})),e.$pH=(0,P.$Zh)("debugService");var S;(function(l){l[l.CONDITION=0]="CONDITION",l[l.HIT_COUNT=1]="HIT_COUNT",l[l.LOG_MESSAGE=2]="LOG_MESSAGE"})(S||(e.BreakpointWidgetContext=S={}))}),define(Pe[208],Re([1,0,12,2,20,26,13,29,19,18]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vF=e.$uF=e.$tF=e.$sF=e.$rF=e.$qF=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=e.$kF=e.$jF=void 0;const R=/{([^}]+)}/g;function S(L,p,y){return L.replace(R,function(D,N){return p&&N.length>0&&N[0]!=="_"?D:y&&y.hasOwnProperty(N)?y[N]:D})}e.$jF=S;function l(L){const p={};for(const y of Object.keys(L))y.startsWith("!")||(p[y]=L[y]);return p}e.$kF=l;function $(L){return L.configuration.request==="attach"&&!b(L)&&(!L.parentSession||$(L.parentSession))}e.$lF=$;function b(L){let p=L.configuration.type;if(p)return p==="vslsShare"&&(p=L.configuration.adapterProxy.configuration.type),(0,E.$6e)(p,"extensionhost")||(0,E.$6e)(p,"pwa-extensionhost")?L:L.parentSession?b(L.parentSession):void 0}e.$mF=b;function a(L){return L.type&&(L.label||L.program||L.runtime)}e.$nF=a;function s(L,p,y){let D,N=0;const q=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=q.exec(L);){const U=V.index+1,F=U+V[0].length;if(U<=p&&F>=y){D=V[0],N=U;break}}if(D){const U=/\w+/g;let F=null;for(;(F=U.exec(D))&&!(F.index+1+N+F[0].length>=y););F&&(D=D.substring(0,U.lastIndex))}return D?{start:N,end:N+D.length-1}:{start:0,end:0}}e.$oF=s;async function t(L,p,y,D){if(L.evaluatableExpressionProvider.has(p)){const N=L.evaluatableExpressionProvider.ordered(p),q=(0,w.$Gb)(await Promise.all(N.map(async V=>{try{return await V.provideEvaluatableExpression(p,y,D??g.CancellationToken.None)}catch{return}})));if(q.length>0){let V=q[0].expression;const U=q[0].range;return V||(V=p.getLineContent(y.lineNumber).substring(U.startColumn-1,U.endColumn-1)),{range:U,matchingExpression:V}}}else{const N=p.getLineContent(y.lineNumber),{start:q,end:V}=s(N,y.column,y.column),U=N.substring(q-1,V);return{matchingExpression:U,range:new m.$Ds(y.lineNumber,q,y.lineNumber,q+U.length)}}return null}e.$pF=t;const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(L){return!!(L&&L.match(n))}e.$qF=o;function c(L){if(typeof L.path=="string"&&!(typeof L.sourceReference=="number"&&L.sourceReference>0)){if(o(L.path))return T.URI.parse(L.path);if((0,P.$hc)(L.path))return T.URI.file(L.path)}return L.path}function h(L){if(typeof L.path=="object"){const p=T.URI.revive(L.path);if(p)return p.scheme===A.Schemas.file?p.fsPath:p.toString()}return L.path}function i(L,p){const y=p?c:h,D=(0,M.$en)(L);return u(D,(N,q)=>{N&&q&&(q.path=y(q))}),D}e.$rF=i;function r(L,p){const y=p?c:h,D=(0,M.$en)(L);return u(D,(N,q)=>{!N&&q&&(q.path=y(q))}),D}e.$sF=r;function u(L,p){switch(L.type){case"event":{const y=L;switch(y.event){case"output":p(!1,y.body.source);break;case"loadedSource":p(!1,y.body.source);break;case"breakpoint":p(!1,y.body.breakpoint.source);break;default:break}break}case"request":{const y=L;switch(y.command){case"setBreakpoints":p(!0,y.arguments.source);break;case"breakpointLocations":p(!0,y.arguments.source);break;case"source":p(!0,y.arguments.source);break;case"gotoTargets":p(!0,y.arguments.source);break;case"launchVSCode":y.arguments.args.forEach(D=>p(!1,D));break;default:break}break}case"response":{const y=L;if(y.success&&y.body)switch(y.command){case"stackTrace":y.body.stackFrames.forEach(D=>p(!1,D.source));break;case"loadedSources":y.body.sources.forEach(D=>p(!1,D));break;case"scopes":y.body.scopes.forEach(D=>p(!1,D.source));break;case"setFunctionBreakpoints":y.body.breakpoints.forEach(D=>p(!1,D.source));break;case"setBreakpoints":y.body.breakpoints.forEach(D=>p(!1,D.source));break;case"disassemble":y.body?.instructions.forEach(N=>p(!1,N.location));break;default:break}break}}}function d(L){return L.filter(p=>!p.presentation?.hidden).sort((p,y)=>p.presentation?y.presentation?p.presentation.group?y.presentation.group?p.presentation.group!==y.presentation.group?p.presentation.group.localeCompare(y.presentation.group):v(p.presentation.order,y.presentation.order):-1:y.presentation.group?1:v(p.presentation.order,y.presentation.order):-1:y.presentation?1:0)}e.$tF=d;function v(L,p){return typeof L!="number"?typeof p!="number"?0:1:typeof p!="number"?-1:L-p}async function f(L,p){const y=L.getValue("debug.saveBeforeStart",{overrideIdentifier:p.activeTextEditorLanguageId});if(y!=="none"&&(await p.saveAll(),y==="allEditorsInActiveGroup")){const D=p.activeEditorPane;D&&D.input.resource?.scheme===A.Schemas.untitled&&await p.save({editor:D.input,groupId:D.group.id})}await L.reloadConfiguration()}e.$uF=f;const k=(L,p)=>!L||!p?L===p:L.name===p.name&&L.path===p.path&&L.sourceReference===p.sourceReference;e.$vF=k}),define(Pe[76],Re([1,0,24,34,67,68,13,20,21,35]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KI=e.$JI=e.$II=e.$HI=e.CellStatusbarAlignment=e.$GI=e.$FI=e.$EI=e.NotebookEditorPriority=e.$DI=e.$CI=e.$BI=e.$AI=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$zI=e.$yI=e.$xI=e.$wI=e.CellKind=e.$vI=e.$uI=e.$tI=void 0,e.$tI="workbench.editor.notebook",e.$uI="workbench.editor.notebookTextDiffEditor",e.$vI="workbench.editor.interactive";var R;(function(I){I[I.Markup=1]="Markup",I[I.Code=2]="Code"})(R||(e.CellKind=R={})),e.$wI=["application/json","application/javascript","text/html","image/svg+xml",M.$Zr.latex,M.$Zr.markdown,"image/png","image/jpeg",M.$Zr.text],e.$xI=[M.$Zr.latex,M.$Zr.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",M.$Zr.text],e.$yI=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$zI="_notAvailable";var S;(function(I){I[I.Running=1]="Running",I[I.Idle=2]="Idle"})(S||(e.NotebookRunState=S={}));var l;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})(l||(e.NotebookCellExecutionState=l={}));var $;(function(I){I[I.Unconfirmed=1]="Unconfirmed",I[I.Pending=2]="Pending",I[I.Executing=3]="Executing"})($||(e.NotebookExecutionState=$={}));var b;(function(I){I[I.WithHardKernelDependency=0]="WithHardKernelDependency",I[I.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",I[I.Pure=2]="Pure",I[I.Never=3]="Never"})(b||(e.NotebookRendererMatch=b={}));var a;(function(I){I.Always="always",I.Never="never",I.Optional="optional"})(a||(e.RendererMessagingSpec=a={}));var s;(function(I){I[I.ModelChange=1]="ModelChange",I[I.Move=2]="Move",I[I.ChangeCellLanguage=5]="ChangeCellLanguage",I[I.Initialize=6]="Initialize",I[I.ChangeCellMetadata=7]="ChangeCellMetadata",I[I.Output=8]="Output",I[I.OutputItem=9]="OutputItem",I[I.ChangeCellContent=10]="ChangeCellContent",I[I.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",I[I.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",I[I.ChangeCellMime=13]="ChangeCellMime",I[I.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var t;(function(I){I[I.Handle=0]="Handle",I[I.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(I){I[I.Replace=1]="Replace",I[I.Output=2]="Output",I[I.Metadata=3]="Metadata",I[I.CellLanguage=4]="CellLanguage",I[I.DocumentMetadata=5]="DocumentMetadata",I[I.Move=6]="Move",I[I.OutputItems=7]="OutputItems",I[I.PartialMetadata=8]="PartialMetadata",I[I.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var o;(function(I){I.scheme=A.Schemas.vscodeNotebookCell;const X=["W","X","Y","Z","a","b","c","d","e","f"],ue=new RegExp(`^[${X.join("")}]+`),he=7;function be(ce,Y){const W=Y.toString(he),Ie=`${W.length<X.length?X[W.length-1]:"z"}${W}s${(0,E.$ze)(E.$fe.fromString(ce.scheme),!0,!0)}`;return ce.with({scheme:I.scheme,fragment:Ie})}I.generate=be;function we(ce){if(ce.scheme!==I.scheme)return;const Y=ce.fragment.indexOf("s");if(Y<0)return;const W=parseInt(ce.fragment.substring(0,Y).replace(ue,""),he),re=(0,E.$ye)(ce.fragment.substring(Y+1)).toString();if(!isNaN(W))return{handle:W,notebook:ce.with({scheme:re,fragment:null})}}I.parse=we;function ge(ce,Y){return ce.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${Y??""},${ce.scheme!==A.Schemas.file?ce.scheme:""}`})}I.generateCellOutputUri=ge;function me(ce){if(ce.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const Y=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(ce.fragment);if(!Y)return;const W=Y[1]&&Y[1]!==""?Y[1]:void 0,re=Y[2];return{outputId:W,notebook:ce.with({scheme:re||A.Schemas.file,fragment:null})}}I.parseCellOutputUri=me;function ne(ce,Y,W){return I.generate(ce,Y).with({scheme:W})}I.generateCellPropertyUri=ne;function ke(ce,Y){if(ce.scheme===Y)return I.parse(ce.with({scheme:I.scheme}))}I.parseCellPropertyUri=ke})(o||(e.CellUri=o={}));const c=I=>g.$i?I.replace(/\//g,"\\"):I;class h{constructor(X=[],ue=e.$wI){this.e=ue,this.d=[...new Set(X)].map(he=>({pattern:he,matches:T.$Gj(c(he))}))}sort(X){const ue=new Map(P.Iterable.map(X,be=>[be,c(be)]));let he=[];for(const{matches:be}of this.d)for(const[we,ge]of ue)if(be(ge)){he.push(we),ue.delete(we);break}return ue.size&&(he=he.concat([...ue.keys()].sort((be,we)=>this.e.indexOf(be)-this.e.indexOf(we)))),he}prioritize(X,ue){const he=this.f(X);if(he===-1){this.d.unshift({pattern:X,matches:T.$Gj(c(X))});return}const be=new Set(ue.map(ge=>this.f(ge,he)));be.delete(-1);const we=Array.from(be).sort();this.d.splice(he+1,0,...we.map(ge=>this.d[ge]));for(let ge=we.length-1;ge>=0;ge--)this.d.splice(we[ge],1)}toArray(){return this.d.map(X=>X.pattern)}f(X,ue=this.d.length){const he=c(X);for(let be=0;be<ue;be++)if(this.d[be].matches(he))return be;return-1}}e.$AI=h;function i(I,X,ue,he=(be,we)=>be===we){const be=[];function we(ne,ke,ce){if(ke===0&&ce.length===0)return;const Y=be[be.length-1];Y&&Y.start+Y.deleteCount===ne?(Y.deleteCount+=ke,Y.toInsert.push(...ce)):be.push({start:ne,deleteCount:ke,toInsert:ce})}let ge=0,me=0;for(;;){if(ge===I.length){we(ge,0,X.slice(me));break}if(me===X.length){we(ge,I.length-ge,[]);break}const ne=I[ge],ke=X[me];if(he(ne,ke)){ge+=1,me+=1;continue}ue(ke)?(we(ge,1,[]),ge+=1):(we(ge,0,[ke]),me+=1)}return be}e.$BI=i,e.$CI=new w.$ej("notebookEditorCursorAtBoundary","none"),e.$DI=new w.$ej("notebookEditorCursorAtLineBoundary","none");var r;(function(I){I.default="default",I.option="option"})(r||(e.NotebookEditorPriority=r={}));function u(I){const X=I;return!!((typeof X.include=="string"||T.$Hj(X.include))&&(typeof X.exclude=="string"||T.$Hj(X.exclude)))}e.$EI=u;function d(I,X,ue){if(Array.isArray(I.viewType)&&I.viewType.indexOf(X)>=0||I.viewType===X)return!0;if(I.filenamePattern){const he=u(I.filenamePattern)?I.filenamePattern.include:I.filenamePattern,be=u(I.filenamePattern)?I.filenamePattern.exclude:void 0;if(T.$Fj(he,(0,m.$mc)(ue.fsPath).toLowerCase()))return!(be&&T.$Fj(be,(0,m.$mc)(ue.fsPath).toLowerCase()))}return!1}e.$FI=d,e.$GI={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var v;(function(I){I[I.Left=1]="Left",I[I.Right=2]="Right"})(v||(e.CellStatusbarAlignment=v={}));class f{static{this.d="notebook/"}static create(X){return`${f.d}${X}`}static parse(X){if(X.startsWith(f.d))return X.substring(f.d.length)}}e.$HI=f;function k(I){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(I)}e.$II=k;const L=new TextDecoder;function p(I){const X=[];let ue=!1;for(const ge of I)(X.length===0||ue)&&(X.push(ge),ue=!0);let he=N(X);const be=E.$fe.concat(X.map(ge=>E.$fe.wrap(ge))),we=C(be);return he=he||we.byteLength!==be.byteLength,{data:we,didCompression:he}}e.$JI=p,e.$KI=`${String.fromCharCode(27)}[A`;const y=e.$KI.split("").map(I=>I.charCodeAt(0)),D=10;function N(I){let X=!1;return I.forEach((ue,he)=>{if(he===0||ue.length<e.$KI.length)return;const be=I[he-1],we=ue.subarray(0,e.$KI.length);if(we[0]===y[0]&&we[1]===y[1]&&we[2]===y[2]){const ge=be.lastIndexOf(D);if(ge===-1)return;X=!0,I[he-1]=be.subarray(0,ge),I[he]=ue.subarray(e.$KI.length)}}),X}function q(I){let X=I;do I=X,X=I.replace(/[^\n]\x08/gm,"");while(X.length<I.length);return I}function V(I){for(I=I.replace(/\r+\n/gm,`
`);I.search(/\r[^$]/g)>-1;){const X=I.match(/^(.*)\r+/m)[1];let ue=I.match(/\r+(.*)$/m)[1];ue=ue+X.slice(ue.length,X.length),I=I.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return I}const U="\b".charCodeAt(0),F="\r".charCodeAt(0);function C(I){return!I.buffer.includes(U)&&!I.buffer.includes(F)?I:E.$fe.fromString(V(q(L.decode(I.buffer))))}}),define(Pe[7],Re([1,0,18,11,52,28,68,12,16,2,33,22,42,100,76]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b){"use strict";var a,s,t,n,o,c,h,i,r,u,d,v,f,k,L,p,y;Object.defineProperty(e,"__esModule",{value:!0}),e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$wM=e.ChatVariableLevel=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.TestRunProfileKind=e.TestResultState=e.$cM=e.$bM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$aM=e.NotebookVariablesRequestKind=e.$_L=e.$$L=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$0L=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.ColorThemeKind=e.$4L=e.$3L=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$2L=e.DebugConsoleMode=e.$1L=e.$ZL=e.$YL=e.$XL=e.$WL=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$VL=e.$UL=e.FileChangeType=e.$TL=e.$SL=e.$RL=e.$QL=e.InlineCompletionTriggerKind=e.$PL=e.$OL=e.$NL=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.$GL=e.$FL=e.$EL=e.$DL=e.ConfigurationTarget=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$tL=e.ViewBadge=e.ProgressLocation=e.$sL=e.$rL=e.TaskScope=e.ShellQuoting=e.$qL=e.$pL=e.$oL=e.TaskPanelKind=e.TaskRevealKind=e.$nL=e.TerminalLocation=e.$mL=e.$lL=e.$kL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$jL=e.$iL=e.$hL=e.$gL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$fL=e.StatusBarAlignment=e.ViewColumn=e.$eL=e.$dL=e.$cL=e.$bL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$aL=e.$_K=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$$K=e.$0K=e.$9K=e.$8K=e.$7K=e.LanguageStatusSeverity=e.$6K=e.$5K=e.$4K=e.$3K=e.$2K=e.$1K=e.CodeActionTriggerKind=e.$ZK=e.$YK=e.SymbolTag=e.SymbolKind=e.$XK=e.$WK=e.DocumentHighlightKind=e.$VK=e.$UK=e.$TK=e.$SK=e.DiagnosticSeverity=e.DiagnosticTag=e.$RK=e.$QK=e.FileEditType=e.$PK=e.$OK=e.$NK=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$MK=e.$LK=e.$KK=e.$JK=e.$IK=e.$HK=e.$GK=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function D(j){return Object.assign(j,{apply:function(...ae){if(ae.length===0)return Reflect.construct(j,[]);{const ye=ae.length===1?[]:ae[1];return Reflect.construct(j,ye,ae[0].constructor)}},call:function(...ae){if(ae.length===0)return Reflect.construct(j,[]);{const[ye,...Ge]=ae;return Reflect.construct(j,Ge,ye.constructor)}}})}var N;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(N||(e.TerminalOutputAnchor=N={}));var q;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(q||(e.TerminalQuickFixType=q={}));let V=a=class{static from(...z){let ae=z;return new a(function(){if(ae){for(const ye of ae)ye&&typeof ye.dispose=="function"&&ye.dispose();ae=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$GK=V,e.$GK=V=a=He([D],V);let U=s=class{static Min(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let ye=1;ye<z.length;ye++){const Ge=z[ye];Ge.isBefore(ae)&&(ae=Ge)}return ae}static Max(...z){if(z.length===0)throw new TypeError;let ae=z[0];for(let ye=1;ye<z.length;ye++){const Ge=z[ye];Ge.isAfter(ae)&&(ae=Ge)}return ae}static isPosition(z){if(!z)return!1;if(z instanceof s)return!0;const{line:ae,character:ye}=z;return typeof ae=="number"&&typeof ye=="number"}static of(z){if(z instanceof s)return z;if(this.isPosition(z))return new s(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ae){if(z<0)throw(0,T.$6)("line must be non-negative");if(ae<0)throw(0,T.$6)("character must be non-negative");this.c=z,this.e=ae}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ae=0){if(z===null||ae===null)throw(0,T.$6)();let ye;return typeof z>"u"?ye=0:typeof z=="number"?ye=z:(ye=typeof z.lineDelta=="number"?z.lineDelta:0,ae=typeof z.characterDelta=="number"?z.characterDelta:0),ye===0&&ae===0?this:new s(this.line+ye,this.character+ae)}with(z,ae=this.character){if(z===null||ae===null)throw(0,T.$6)();let ye;return typeof z>"u"?ye=this.line:typeof z=="number"?ye=z:(ye=typeof z.line=="number"?z.line:this.line,ae=typeof z.character=="number"?z.character:this.character),ye===this.line&&ae===this.character?this:new s(ye,ae)}toJSON(){return{line:this.line,character:this.character}}};e.$HK=U,e.$HK=U=s=He([D],U);let F=t=class{static isRange(z){return z instanceof t?!0:z?U.isPosition(z.start)&&U.isPosition(z.end):!1}static of(z){if(z instanceof t)return z;if(this.isRange(z))return new t(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ae,ye,Ge){let et,at;if(typeof z=="number"&&typeof ae=="number"&&typeof ye=="number"&&typeof Ge=="number"?(et=new U(z,ae),at=new U(ye,Ge)):U.isPosition(z)&&U.isPosition(ae)&&(et=U.of(z),at=U.of(ae)),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this.c=et,this.e=at):(this.c=at,this.e=et)}contains(z){return t.isRange(z)?this.contains(z.start)&&this.contains(z.end):U.isPosition(z)?!(U.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ae=U.Max(z.start,this.c),ye=U.Min(z.end,this.e);if(!ae.isAfter(ye))return new t(ae,ye)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ae=U.Min(z.start,this.c),ye=U.Max(z.end,this.end);return new t(ae,ye)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ae=this.end){if(z===null||ae===null)throw(0,T.$6)();let ye;return z?U.isPosition(z)?ye=z:(ye=z.start||this.start,ae=z.end||this.end):ye=this.start,ye.isEqual(this.c)&&ae.isEqual(this.end)?this:new t(ye,ae)}toJSON(){return[this.start,this.end]}};e.$IK=F,e.$IK=F=t=He([D],F);let C=n=class extends F{static isSelection(z){return z instanceof n?!0:z?F.isRange(z)&&U.isPosition(z.anchor)&&U.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ae,ye,Ge){let et,at;if(typeof z=="number"&&typeof ae=="number"&&typeof ye=="number"&&typeof Ge=="number"?(et=new U(z,ae),at=new U(ye,Ge)):U.isPosition(z)&&U.isPosition(ae)&&(et=U.of(z),at=U.of(ae)),!et||!at)throw new Error("Invalid arguments");super(et,at),this.f=et,this.g=at}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$JK=C,e.$JK=C=n=He([D],C);const I=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,T.$6)("connectionToken")};class X{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae,ye){if(typeof z!="string"||z.length===0)throw(0,T.$6)("host");if(typeof ae!="number"||ae===0||Math.round(ae)!==ae)throw(0,T.$6)("port");typeof ye<"u"&&I(ye),this.host=z,this.port=Math.round(ae),this.connectionToken=ye}}e.$KK=X;class ue{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ae){this.makeConnection=z,this.connectionToken=ae,typeof ae<"u"&&I(ae)}}e.$LK=ue;class he extends Error{static NotAvailable(z,ae){return new he(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,ae)}static TemporarilyNotAvailable(z){return new he(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ae=$.RemoteAuthorityResolverErrorCode.Unknown,ye){super(z),this._message=z,this._code=ae,this._detail=ye,Object.setPrototypeOf(this,he.prototype)}}e.$MK=he;var be;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(be||(e.EndOfLine=be={}));var we;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(we||(e.EnvironmentVariableMutatorType=we={}));let ge=o=class{static isTextEdit(z){return z instanceof o?!0:z?F.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ae){return new o(z,ae)}static insert(z,ae){return o.replace(new F(z,z),ae)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const ae=new o(new F(new U(0,0),new U(0,0)),"");return ae.newEol=z,ae}get range(){return this.c}set range(z){if(z&&!F.isRange(z))throw(0,T.$6)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,T.$6)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,T.$6)("newEol");this.f=z}constructor(z,ae){this.c=z,this.e=ae}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$NK=ge,e.$NK=ge=o=He([D],ge);let me=c=class{static isNotebookCellEdit(z){return z instanceof c?!0:z?_t.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ae){return new c(z,ae)}static insertCells(z,ae){return new c(new _t(z,z),ae)}static deleteCells(z){return new c(z,[])}static updateCellMetadata(z,ae){const ye=new c(new _t(z,z),[]);return ye.newCellMetadata=ae,ye}static updateNotebookMetadata(z){const ae=new c(new _t(0,0),[]);return ae.newNotebookMetadata=z,ae}constructor(z,ae){this.range=z,this.newCells=ae}};e.$OK=me,e.$OK=me=c=He([D],me);class ne{static isSnippetTextEdit(z){return z instanceof ne?!0:z?F.isRange(z.range)&&Y.isSnippetString(z.snippet):!1}static replace(z,ae){return new ne(z,ae)}static insert(z,ae){return ne.replace(new F(z,z),ae)}constructor(z,ae){this.range=z,this.snippet=ae}}e.$PK=ne;var ke;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(ke||(e.FileEditType=ke={}));let ce=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ae,ye,Ge){this.c.push({_type:1,from:z,to:ae,options:ye,metadata:Ge})}createFile(z,ae,ye){this.c.push({_type:1,from:void 0,to:z,options:ae,metadata:ye})}deleteFile(z,ae,ye){this.c.push({_type:1,from:z,to:void 0,options:ae,metadata:ye})}e(z,ae,ye){this.c.push({_type:3,metadata:ye,uri:z,edit:{editType:5,metadata:ae},notebookMetadata:ae})}f(z,ae,ye,Ge){const et=ae.start,at=ae.end;(et!==at||ye.length>0)&&this.c.push({_type:5,uri:z,index:et,count:at-et,cells:ye,metadata:Ge})}g(z,ae,ye,Ge){this.c.push({_type:3,metadata:Ge,uri:z,edit:{editType:3,index:ae,metadata:ye}})}replace(z,ae,ye,Ge){this.c.push({_type:2,uri:z,edit:new ge(ae,ye),metadata:Ge})}insert(z,ae,ye,Ge){this.replace(z,new F(ae,ae),ye,Ge)}delete(z,ae,ye){this.replace(z,ae,"",ye)}has(z){return this.c.some(ae=>ae._type===2&&ae.uri.toString()===z.toString())}set(z,ae){if(ae)for(const ye of ae){if(!ye)continue;let Ge,et;Array.isArray(ye)?(Ge=ye[0],et=ye[1]):Ge=ye,me.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(z,Ge.range.start,Ge.newCellMetadata,et):Ge.newNotebookMetadata?this.e(z,Ge.newNotebookMetadata,et):this.f(z,Ge.range,Ge.newCells,et):ne.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:z,range:Ge.range,edit:Ge.snippet,metadata:et}):this.c.push({_type:2,uri:z,edit:Ge,metadata:et})}else{for(let ye=0;ye<this.c.length;ye++){const Ge=this.c[ye];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===z.toString()&&(this.c[ye]=void 0);break}}(0,E.$Hb)(this.c)}}get(z){const ae=[];for(const ye of this.c)ye._type===2&&ye.uri.toString()===z.toString()&&ae.push(ye.edit);return ae}entries(){const z=new M.$zc;for(const ae of this.c)if(ae._type===2){let ye=z.get(ae.uri);ye||(ye=[ae.uri,[]],z.set(ae.uri,ye)),ye[1].push(ae.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$QK=ce,e.$QK=ce=He([D],ce);let Y=h=class{static isSnippetString(z){return z instanceof h?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=h.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ae=this.e++){if(typeof z=="function"){const ye=new h;ye.e=this.e,z(ye),this.e=ye.e,z=ye.value}else z=h.c(z);return this.value+="${",this.value+=ae,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ae=this.e++){const ye=z.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ae,this.value+="|",this.value+=ye,this.value+="|}",this}appendVariable(z,ae){if(typeof ae=="function"){const ye=new h;ye.e=this.e,ae(ye),this.e=ye.e,ae=ye.value}else typeof ae=="string"&&(ae=ae.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ae&&(this.value+=":",this.value+=ae),this.value+="}",this}};e.$RK=Y,e.$RK=Y=h=He([D],Y);var W;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(W||(e.DiagnosticTag=W={}));var re;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(re||(e.DiagnosticSeverity=re={}));let Ie=i=class{static isLocation(z){return z instanceof i?!0:z?F.isRange(z.range)&&w.URI.isUri(z.uri):!1}constructor(z,ae){if(this.uri=z,ae)if(F.isRange(ae))this.range=F.of(ae);else if(U.isPosition(ae))this.range=new F(ae,ae);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$SK=Ie,e.$SK=Ie=i=He([D],Ie);let Ae=class{static is(z){return z?typeof z.message=="string"&&z.location&&F.isRange(z.location.range)&&w.URI.isUri(z.location.uri):!1}constructor(z,ae){this.location=z,this.message=ae}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.location.range.isEqual(ae.location.range)&&z.location.uri.toString()===ae.location.uri.toString()}};e.$TK=Ae,e.$TK=Ae=He([D],Ae);let Ce=class{constructor(z,ae,ye=re.Error){if(!F.isRange(z))throw new TypeError("range must be set");if(!ae)throw new TypeError("message must be set");this.range=z,this.message=ae,this.severity=ye}toJSON(){return{severity:re[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ae){return z===ae?!0:!z||!ae?!1:z.message===ae.message&&z.severity===ae.severity&&z.code===ae.code&&z.severity===ae.severity&&z.source===ae.source&&z.range.isEqual(ae.range)&&(0,E.$tb)(z.tags,ae.tags)&&(0,E.$tb)(z.relatedInformation,ae.relatedInformation,Ae.isEqual)}};e.$UK=Ce,e.$UK=Ce=He([D],Ce);let le=class{constructor(z,ae){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ae}};e.$VK=le,e.$VK=le=He([D],le);var ie;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(ie||(e.DocumentHighlightKind=ie={}));let G=class{constructor(z,ae=ie.Text){this.range=z,this.kind=ae}toJSON(){return{range:this.range,kind:ie[this.kind]}}};e.$WK=G,e.$WK=G=He([D],G);let te=class{constructor(z,ae){this.uri=z,this.highlights=ae}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$XK=te,e.$XK=te=He([D],te);var x;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var se;(function(j){j[j.Deprecated=1]="Deprecated"})(se||(e.SymbolTag=se={}));let fe=r=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ae,ye,Ge,et){this.name=z,this.kind=ae,this.containerName=et,typeof ye=="string"&&(this.containerName=ye),Ge instanceof Ie?this.location=Ge:ye instanceof F&&(this.location=new Ie(Ge,ye)),r.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.$YK=fe,e.$YK=fe=r=He([D],fe);let Se=u=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(u.validate)}constructor(z,ae,ye,Ge,et){this.name=z,this.detail=ae,this.kind=ye,this.range=Ge,this.selectionRange=et,this.children=[],u.validate(this)}};e.$ZK=Se,e.$ZK=Se=u=He([D],Se);var Fe;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Fe||(e.CodeActionTriggerKind=Fe={}));let O=class{constructor(z,ae){this.title=z,this.kind=ae}};e.$1K=O,e.$1K=O=He([D],O);let K=class{static{d=this}static{this.c="."}constructor(z){this.value=z}append(z){return new d(this.value?this.value+d.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+d.c)}};e.$2K=K,e.$2K=K=d=He([D],K),K.Empty=new K(""),K.QuickFix=K.Empty.append("quickfix"),K.Refactor=K.Empty.append("refactor"),K.RefactorExtract=K.Refactor.append("extract"),K.RefactorInline=K.Refactor.append("inline"),K.RefactorMove=K.Refactor.append("move"),K.RefactorRewrite=K.Refactor.append("rewrite"),K.Source=K.Empty.append("source"),K.SourceOrganizeImports=K.Source.append("organizeImports"),K.SourceFixAll=K.Source.append("fixAll"),K.Notebook=K.Empty.append("notebook");let J=class{constructor(z,ae){if(this.range=z,this.parent=ae,ae&&!ae.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$3K=J,e.$3K=J=He([D],J);class B{constructor(z,ae,ye,Ge,et,at){this.kind=z,this.name=ae,this.detail=ye,this.uri=Ge,this.range=et,this.selectionRange=at}}e.$4K=B;class Q{constructor(z,ae){this.fromRanges=ae,this.from=z}}e.$5K=Q;class _{constructor(z,ae){this.fromRanges=ae,this.to=z}}e.$6K=_;var Ee;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ee||(e.LanguageStatusSeverity=Ee={}));let ze=class{constructor(z,ae){this.range=z,this.command=ae}get isResolved(){return!!this.command}};e.$7K=ze,e.$7K=ze=He([D],ze);let Qe=v=class{#e;static isMarkdownString(z){return z instanceof v?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ae=!1){this.#e=new P.$ak(z,{supportThemeIcons:ae})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ae){return this.#e.appendCodeblock(ae??"",z),this}};e.$8K=Qe,e.$8K=Qe=v=He([D],Qe);let Je=class{constructor(z,ae){this.label=z,this.documentation=ae}};e.$9K=Je,e.$9K=Je=He([D],Je);let Ye=class{constructor(z,ae){this.label=z,this.documentation=ae,this.parameters=[]}};e.$0K=Ye,e.$0K=Ye=He([D],Ye);let it=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$$K=it,e.$$K=it=He([D],it);var nt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(nt||(e.SignatureHelpTriggerKind=nt={}));var _e;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(_e||(e.InlayHintKind=_e={}));let rt=class{constructor(z){this.value=z}};e.$_K=rt,e.$_K=rt=He([D],rt);let Ue=class{constructor(z,ae,ye){this.position=z,this.label=ae,this.kind=ye}};e.$aL=Ue,e.$aL=Ue=He([D],Ue);var ct;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ct||(e.CompletionTriggerKind=ct={}));var ee;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(ee||(e.CompletionItemKind=ee={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let ve=class{constructor(z,ae){this.label=z,this.kind=ae}toJSON(){return{label:this.label,kind:this.kind&&ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$bL=ve,e.$bL=ve=He([D],ve);let Be=class{constructor(z=[],ae=!1){this.items=z,this.isIncomplete=ae}};e.$cL=Be,e.$cL=Be=He([D],Be);let Ke=class{constructor(z,ae,ye){this.insertText=z,this.range=ae,this.command=ye}};e.$dL=Ke,e.$dL=Ke=He([D],Ke);let xe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$eL=xe,e.$eL=xe=He([D],xe);var ot;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ot||(e.ViewColumn=ot={}));var pt;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pt||(e.StatusBarAlignment=pt={}));function Ne(j,z){return`${S.$dm.toKey(j)}.${z}`}e.$fL=Ne;var Pt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(Pt||(e.TextEditorLineNumbersStyle=Pt={}));var Kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Kt||(e.TextDocumentSaveReason=Kt={}));var zt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(zt||(e.TextEditorRevealType=zt={}));var yt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(yt||(e.TextEditorSelectionChangeKind=yt={}));var Wt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Wt||(e.TextDocumentChangeReason=Wt={}));var Ut;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Ut||(e.DecorationRangeBehavior=Ut={})),function(j){function z(ae){switch(ae){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=z}(yt||(e.TextEditorSelectionChangeKind=yt={}));var Ht;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ht||(e.SyntaxTokenType=Ht={})),function(j){function z(ae){switch(ae){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=z}(Ht||(e.SyntaxTokenType=Ht={}));let Gt=class{constructor(z,ae){if(ae&&!w.URI.isUri(ae))throw(0,T.$6)("target");if(!F.isRange(z)||z.isEmpty)throw(0,T.$6)("range");this.range=z,this.target=ae}};e.$gL=Gt,e.$gL=Gt=He([D],Gt);let Rt=class{constructor(z,ae,ye,Ge){this.red=z,this.green=ae,this.blue=ye,this.alpha=Ge}};e.$hL=Rt,e.$hL=Rt=He([D],Rt);let St=class{constructor(z,ae){if(ae&&!(ae instanceof Rt))throw(0,T.$6)("color");if(!F.isRange(z)||z.isEmpty)throw(0,T.$6)("range");this.range=z,this.color=ae}};e.$iL=St,e.$iL=St=He([D],St);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,T.$6)("label");this.label=z}};e.$jL=Xe,e.$jL=Xe=He([D],Xe);var Jt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(Jt||(e.ColorFormat=Jt={}));var Vt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Vt||(e.SourceControlInputBoxValidationType=Vt={}));var ut;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(ut||(e.TerminalExitReason=ut={}));class gt{constructor(z,ae,ye){if(this.startIndex=z,this.length=ae,this.tooltip=ye,typeof z!="number"||z<0)throw(0,T.$6)("startIndex");if(typeof ae!="number"||ae<1)throw(0,T.$6)("length");if(ye!==void 0&&typeof ye!="string")throw(0,T.$6)("tooltip")}}e.$kL=gt;class Zt{constructor(z){this.uri=z}}e.$lL=Zt;class It{constructor(z){this.terminalCommand=z}}e.$mL=It;var Dt;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Dt||(e.TerminalLocation=Dt={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,T.$6)("options")}}e.$nL=dt;var At;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(At||(e.TaskRevealKind=At={}));var Ot;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ot||(e.TaskPanelKind=Ot={}));let Et=class{static{f=this}static{this.Clean=new f("clean","Clean")}static{this.Build=new f("build","Build")}static{this.Rebuild=new f("rebuild","Rebuild")}static{this.Test=new f("test","Test")}static from(z){switch(z){case"clean":return f.Clean;case"build":return f.Build;case"rebuild":return f.Rebuild;case"test":return f.Test;default:return}}constructor(z,ae){if(this.label=ae,typeof z!="string"||typeof ae!="string")throw(0,T.$6)("name");this.c=z}get id(){return this.c}};e.$oL=Et,e.$oL=Et=f=He([D],Et);function qe(j){let z="";for(let ae=0;ae<j.length;ae++)z+=j[ae].replace(/,/g,",,")+",";return z}let Mt=class{constructor(z,ae,ye){if(typeof z!="string")throw(0,T.$6)("process");this.e=[],this.c=z,ae!==void 0&&(Array.isArray(ae)?(this.e=ae,this.f=ye):this.f=ae)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,T.$6)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ae of this.e)z.push(ae);return qe(z)}};e.$pL=Mt,e.$pL=Mt=He([D],Mt);let jt=class{constructor(z,ae,ye){if(this.f=[],Array.isArray(ae)){if(!z)throw(0,T.$6)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$6)("command");this.e=z,this.f=ae,this.g=ye}else{if(typeof z!="string")throw(0,T.$6)("commandLine");this.c=z,this.g=ae}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,T.$6)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,T.$6)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ae of this.f)z.push(typeof ae=="string"?ae:ae.value);return qe(z)}};e.$qL=jt,e.$qL=jt=He([D],jt);var Qt;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(Qt||(e.ShellQuoting=Qt={}));var ft;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class De{constructor(z){this.c=z}computeId(){return"customExecution"+(0,R.$kg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$rL=De;let Le=class{static{k=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ae,ye,Ge,et,at){this.k=!1,this.l=this.definition=z;let ht;typeof ae=="string"?(this.n=this.name=ae,this.u=this.source=ye,this.execution=Ge,ht=et,this.k=!0):ae===ft.Global||ae===ft.Workspace?(this.target=ae,this.n=this.name=ye,this.u=this.source=Ge,this.execution=et,ht=at):(this.target=ae,this.n=this.name=ye,this.u=this.source=Ge,this.execution=et,ht=at),typeof ht=="string"?(this.q=[ht],this.r=!0):Array.isArray(ht)?(this.q=ht,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:k.e,id:this.o.computeId()}:this.o instanceof jt?this.l={type:k.f,id:this.o.computeId()}:this.o instanceof De?this.l={type:k.c,id:this.o.computeId()}:this.l={type:k.g,id:(0,R.$kg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,T.$6)("Kind can't be undefined or null");this.A(),this.l=z}get scope(){return this.m}set target(z){this.A(),this.m=z}get name(){return this.n}set name(z){if(typeof z!="string")throw(0,T.$6)("name");this.A(),this.n=z}get execution(){return this.o}set execution(z){z===null&&(z=void 0),this.A(),this.o=z;const ae=this.l.type;(k.g===ae||k.e===ae||k.f===ae||k.c===ae)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(z){if(Array.isArray(z))this.A(),this.q=z,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.A(),this.t=z}get source(){return this.u}set source(z){if(typeof z!="string"||z.length===0)throw(0,T.$6)("source must be a string of length > 0");this.A(),this.u=z}get group(){return this.w}set group(z){z===null&&(z=void 0),this.A(),this.w=z}get detail(){return this.z}set detail(z){z===null&&(z=void 0),this.z=z}get presentationOptions(){return this.x}set presentationOptions(z){z==null&&(z=Object.create(null)),this.A(),this.x=z}get runOptions(){return this.y}set runOptions(z){z==null&&(z=Object.create(null)),this.A(),this.y=z}};e.$sL=Le,e.$sL=Le=k=He([D],Le);var $e;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})($e||(e.ProgressLocation=$e={}));var H;(function(j){function z(ae){const ye=ae;return(0,g.$Gf)(ye.value)?ye.tooltip&&!(0,g.$Cf)(ye.tooltip)?(console.log("INVALID view badge, invalid tooltip",ye.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",ye.value),!1)}j.isViewBadge=z})(H||(e.ViewBadge=H={}));let Me=L=class{static isTreeItem(z,ae){const ye=z;if(ye.checkboxState!==void 0){const Ge=(0,g.$Gf)(ye.checkboxState)?ye.checkboxState:(0,g.$Ef)(ye.checkboxState)&&(0,g.$Gf)(ye.checkboxState.state)?ye.checkboxState.state:void 0,et=!(0,g.$Gf)(ye.checkboxState)&&(0,g.$Ef)(ye.checkboxState)?ye.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==Ze.Checked&&Ge!==Ze.Unchecked||et!==void 0&&!(0,g.$Cf)(et))return console.log("INVALID tree item, invalid checkboxState",ye.checkboxState),!1}if(z instanceof L)return!0;if(ye.label!==void 0&&!(0,g.$Cf)(ye.label)&&!ye.label?.label)return console.log("INVALID tree item, invalid label",ye.label),!1;if(ye.id!==void 0&&!(0,g.$Cf)(ye.id))return console.log("INVALID tree item, invalid id",ye.id),!1;if(ye.iconPath!==void 0&&!(0,g.$Cf)(ye.iconPath)&&!w.URI.isUri(ye.iconPath)&&(!ye.iconPath||!(0,g.$Cf)(ye.iconPath.id))){const Ge=ye.iconPath;if(!Ge||!(0,g.$Cf)(Ge.light)&&!w.URI.isUri(Ge.light)&&!(0,g.$Cf)(Ge.dark)&&!w.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",ye.iconPath),!1}return ye.description!==void 0&&!(0,g.$Cf)(ye.description)&&typeof ye.description!="boolean"?(console.log("INVALID tree item, invalid description",ye.description),!1):ye.resourceUri!==void 0&&!w.URI.isUri(ye.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",ye.resourceUri),!1):ye.tooltip!==void 0&&!(0,g.$Cf)(ye.tooltip)&&!(ye.tooltip instanceof Qe)?(console.log("INVALID tree item, invalid tooltip",ye.tooltip),!1):ye.command!==void 0&&!ye.command.command?(console.log("INVALID tree item, invalid command",ye.command),!1):ye.collapsibleState!==void 0&&ye.collapsibleState<je.None&&ye.collapsibleState>je.Expanded?(console.log("INVALID tree item, invalid collapsibleState",ye.collapsibleState),!1):ye.contextValue!==void 0&&!(0,g.$Cf)(ye.contextValue)?(console.log("INVALID tree item, invalid contextValue",ye.contextValue),!1):ye.accessibilityInformation!==void 0&&!ye.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",ye.accessibilityInformation),!1):!0}constructor(z,ae=je.None){this.collapsibleState=ae,w.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$tL=Me,e.$tL=Me=L=He([D],Me);var je;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(je||(e.TreeItemCollapsibleState=je={}));var Ze;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Ze||(e.TreeItemCheckboxState=Ze={}));let Ve=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$uL=Ve,e.$uL=Ve=He([D],Ve);class tt extends Ve{}e.$vL=tt;class mt extends tt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$wL=mt;class vt{constructor(z,ae,ye,Ge){this.name=z,this.uri=ae,this._itemId=ye,this.c=Ge}data(){return this.c()}}e.$xL=vt;let Lt=class{#e=new Map;constructor(z){for(const[ae,ye]of z??[]){const Ge=this.#e.get(this.#t(ae));Ge?Ge.push(ye):this.#e.set(this.#t(ae),[ye])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ae){this.#e.set(this.#t(z),[ae])}forEach(z,ae){for(const[ye,Ge]of this.#e)for(const et of Ge)z.call(ae,et,ye,this)}*[Symbol.iterator](){for(const[z,ae]of this.#e)for(const ye of ae)yield[z,ye]}#t(z){return z.toLowerCase()}};e.$yL=Lt,e.$yL=Lt=He([D],Lt);let bt=class{constructor(z){this.insertText=z}};e.$zL=bt,e.$zL=bt=He([D],bt);let Nt=class{constructor(z,ae){this.label=ae,this.insertText=z}};e.$AL=Nt,e.$AL=Nt=He([D],Nt);let qt=class{constructor(z,ae){this.id=z,this.color=ae}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$BL=qt,e.$BL=qt=He([D],qt),qt.File=new qt("file"),qt.Folder=new qt("folder");let mi=class{constructor(z){this.id=z}};e.$CL=mi,e.$CL=mi=He([D],mi);var Ct;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ct||(e.ConfigurationTarget=Ct={}));let ki=class{get base(){return this.c}set base(z){this.c=z,this.e=w.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ae){if(typeof z!="string"&&(!z||!w.URI.isUri(z)&&!w.URI.isUri(z.uri)))throw(0,T.$6)("base");if(typeof ae!="string")throw(0,T.$6)("pattern");typeof z=="string"?this.baseUri=w.URI.file(z):w.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ae}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$DL=ki,e.$DL=ki=He([D],ki);const Vi=new WeakMap;function kt(j,z){Vi.set(j,z)}e.$EL=kt;let ni=class{constructor(z,ae,ye,Ge){this.enabled=typeof z=="boolean"?z:!0,typeof ae=="string"&&(this.condition=ae),typeof ye=="string"&&(this.hitCondition=ye),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=Vi.get(this)??(0,R.$kg)()),this.c}};e.$FL=ni,e.$FL=ni=He([D],ni);let $i=class extends ni{constructor(z,ae,ye,Ge,et){if(super(ae,ye,Ge,et),z===null)throw(0,T.$6)("location");this.location=z}};e.$GL=$i,e.$GL=$i=He([D],$i);let ai=class extends ni{constructor(z,ae,ye,Ge,et){super(ae,ye,Ge,et),this.functionName=z}};e.$HL=ai,e.$HL=ai=He([D],ai);let Si=class extends ni{constructor(z,ae,ye,Ge,et,at,ht){if(super(Ge,et,at,ht),!ae)throw(0,T.$6)("dataId");this.label=z,this.dataId=ae,this.canPersist=ye}};e.$IL=Si,e.$IL=Si=He([D],Si);let Ii=class{constructor(z,ae,ye){this.command=z,this.args=ae||[],this.options=ye}};e.$JL=Ii,e.$JL=Ii=He([D],Ii);let Ft=class{constructor(z,ae){this.port=z,this.host=ae}};e.$KL=Ft,e.$KL=Ft=He([D],Ft);let pi=class{constructor(z){this.path=z}};e.$LL=pi,e.$LL=pi=He([D],pi);let Ci=class{constructor(z){this.implementation=z}};e.$ML=Ci,e.$ML=Ci=He([D],Ci);let ci=class{constructor(z,ae,ye){this.session=z,this.threadId=ae,this.frameId=ye}};e.$NL=ci,e.$NL=ci=He([D],ci);let ui=class{constructor(z,ae){this.session=z,this.threadId=ae}};e.$OL=ui,e.$OL=ui=He([D],ui);let lt=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$PL=lt,e.$PL=lt=He([D],lt);var qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(qi||(e.InlineCompletionTriggerKind=qi={}));let xt=class{constructor(z,ae){this.range=z,this.text=ae}};e.$QL=xt,e.$QL=xt=He([D],xt);let ri=class{constructor(z,ae,ye=!0){this.range=z,this.variableName=ae,this.caseSensitiveLookup=ye}};e.$RL=ri,e.$RL=ri=He([D],ri);let di=class{constructor(z,ae){this.range=z,this.expression=ae}};e.$SL=di,e.$SL=di=He([D],di);let Pi=class{constructor(z,ae){this.frameId=z,this.stoppedLocation=ae}};e.$TL=Pi,e.$TL=Pi=He([D],Pi);var Ki;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ki||(e.FileChangeType=Ki={}));let Ri=p=class extends Error{static FileExists(z){return new p(z,l.FileSystemProviderErrorCode.FileExists,p.FileExists)}static FileNotFound(z){return new p(z,l.FileSystemProviderErrorCode.FileNotFound,p.FileNotFound)}static FileNotADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileNotADirectory,p.FileNotADirectory)}static FileIsADirectory(z){return new p(z,l.FileSystemProviderErrorCode.FileIsADirectory,p.FileIsADirectory)}static NoPermissions(z){return new p(z,l.FileSystemProviderErrorCode.NoPermissions,p.NoPermissions)}static Unavailable(z){return new p(z,l.FileSystemProviderErrorCode.Unavailable,p.Unavailable)}constructor(z,ae=l.FileSystemProviderErrorCode.Unknown,ye){super(w.URI.isUri(z)?z.toString(!0):z),this.code=ye?.name??"Unknown",(0,l.$xk)(this,ae),Object.setPrototypeOf(this,p.prototype),typeof Error.captureStackTrace=="function"&&typeof ye=="function"&&Error.captureStackTrace(this,ye)}};e.$UL=Ri,e.$UL=Ri=p=He([D],Ri);let vi=class{constructor(z,ae,ye){this.start=z,this.end=ae,this.kind=ye}};e.$VL=vi,e.$VL=vi=He([D],vi);var Hi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(Hi||(e.FoldingRangeKind=Hi={}));var Ai;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Ai||(e.CommentThreadCollapsibleState=Ai={}));var li;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(li||(e.CommentMode=li={}));var Gi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Gi||(e.CommentState=Gi={}));var bi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(bi||(e.CommentThreadState=bi={}));class Mi{constructor(z,ae=[]){this.tokenTypes=z,this.tokenModifiers=ae}}e.$WL=Mi;function cn(j){return typeof j>"u"||(0,g.$Df)(j)}class Li{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ae=0,ye=z.tokenTypes.length;ae<ye;ae++)this.k.set(z.tokenTypes[ae],ae);for(let ae=0,ye=z.tokenModifiers.length;ae<ye;ae++)this.l.set(z.tokenModifiers[ae],ae)}}push(z,ae,ye,Ge,et){if(typeof z=="number"&&typeof ae=="number"&&typeof ye=="number"&&typeof Ge=="number"&&(typeof et=="number"||typeof et>"u"))return typeof et>"u"&&(et=0),this.o(z,ae,ye,Ge,et);if(F.isRange(z)&&typeof ae=="string"&&cn(ye))return this.n(z,ae,ye);throw(0,T.$6)()}n(z,ae,ye){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ae))throw new Error("`tokenType` is not in the provided legend");const Ge=z.start.line,et=z.start.character,at=z.end.character-z.start.character,ht=this.k.get(ae);let Bt=0;if(ye)for(const Yt of ye){if(!this.l.has(Yt))throw new Error("`tokenModifier` is not in the provided legend");const ti=this.l.get(Yt);Bt|=1<<ti>>>0}this.o(Ge,et,at,ht,Bt)}o(z,ae,ye,Ge,et){if(this.f&&(z<this.c||z===this.c&&ae<this.e)){this.f=!1;const Bt=this.g.length/5|0;let Yt=0,ti=0;for(let ii=0;ii<Bt;ii++){let oi=this.g[5*ii],Bi=this.g[5*ii+1];oi===0?(oi=Yt,Bi+=ti):oi+=Yt,this.g[5*ii]=oi,this.g[5*ii+1]=Bi,Yt=oi,ti=Bi}}let at=z,ht=ae;this.f&&this.j>0&&(at-=this.c,at===0&&(ht-=this.e)),this.g[this.j++]=at,this.g[this.j++]=ht,this.g[this.j++]=ye,this.g[this.j++]=Ge,this.g[this.j++]=et,this.c=z,this.e=ae}static q(z){const ae=[],ye=z.length/5|0;for(let ht=0;ht<ye;ht++)ae[ht]=ht;ae.sort((ht,Bt)=>{const Yt=z[5*ht],ti=z[5*Bt];if(Yt===ti){const ii=z[5*ht+1],oi=z[5*Bt+1];return ii-oi}return Yt-ti});const Ge=new Uint32Array(z.length);let et=0,at=0;for(let ht=0;ht<ye;ht++){const Bt=5*ae[ht],Yt=z[Bt+0],ti=z[Bt+1],ii=z[Bt+2],oi=z[Bt+3],Bi=z[Bt+4],kn=Yt-et,On=kn===0?ti-at:ti,Wi=5*ht;Ge[Wi+0]=kn,Ge[Wi+1]=On,Ge[Wi+2]=ii,Ge[Wi+3]=oi,Ge[Wi+4]=Bi,et=Yt,at=ti}return Ge}build(z){return this.f?new si(new Uint32Array(this.g),z):new si(Li.q(this.g),z)}}e.$XL=Li;class si{constructor(z,ae){this.resultId=ae,this.data=z}}e.$YL=si;class un{constructor(z,ae,ye){this.start=z,this.deleteCount=ae,this.data=ye}}e.$ZL=un;class ln{constructor(z,ae){this.resultId=ae,this.edits=z}}e.$1L=ln;var Ji;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Ji||(e.DebugConsoleMode=Ji={}));let fi=class{static{this.Back={iconPath:new qt("arrow-left")}}constructor(){}};e.$2L=fi,e.$2L=fi=He([D],fi);var Qi;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Qi||(e.QuickPickItemKind=Qi={}));var Zi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(Zi||(e.InputBoxValidationSeverity=Zi={}));var gi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(gi||(e.ExtensionKind=gi={}));class Xi{static validate(z){if(typeof z.badge=="string"){let ae=(0,m.$df)(z.badge,0);if(ae<z.badge.length&&(ae+=(0,m.$df)(z.badge,ae)),z.badge.length>ae)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!qt.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ae,ye){this.badge=z,this.tooltip=ae,this.color=ye}}e.$3L=Xi;let Fi=class{constructor(z){this.kind=z}};e.$4L=Fi,e.$4L=Fi=He([D],Fi);var Ti;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(Ti||(e.ColorThemeKind=Ti={}));class _t{static isNotebookRange(z){return z instanceof _t?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ae){if(z<0)throw(0,T.$6)("start must be positive");if(ae<0)throw(0,T.$6)("end must be positive");z<=ae?(this.c=z,this.e=ae):(this.c=ae,this.e=z)}with(z){let ae=this.c,ye=this.e;return z.start!==void 0&&(ae=z.start),z.end!==void 0&&(ye=z.end),ae===this.c&&ye===this.e?this:new _t(ae,ye)}}e.$5L=_t;class wi{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ae=>wi.isNotebookCellData(ae))}static isNotebookCellData(z){return!0}constructor(z,ae,ye,Ge,et,at,ht){this.kind=z,this.value=ae,this.languageId=ye,this.mime=Ge,this.outputs=et??[],this.metadata=at,this.executionSummary=ht,wi.validate(this)}}e.$6L=wi;class hn{constructor(z){this.cells=z}}e.$7L=hn;class Xt{static isNotebookCellOutputItem(z){return z instanceof Xt?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ae={name:z.name,message:z.message,stack:z.stack};return Xt.json(ae,"application/vnd.code.notebook.error")}static stdout(z){return Xt.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return Xt.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ae="application/octet-stream"){return new Xt(z,ae)}static#e=new TextEncoder;static text(z,ae=A.$Zr.text){const ye=Xt.#e.encode(String(z));return new Xt(ye,ae)}static json(z,ae="text/x-json"){const ye=JSON.stringify(z,void 0,"	");return Xt.text(ye,ae)}constructor(z,ae){this.data=z,this.mime=ae;const ye=(0,A.$4r)(ae,!0);if(!ye)throw new Error(`INVALID mime type: ${ae}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=ye}}e.$8L=Xt;class yi{static isNotebookCellOutput(z){return z instanceof yi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ae=!1){const ye=new Set,Ge=new Set;for(let et=0;et<z.length;et++){const at=z[et],ht=(0,A.$4r)(at.mime);if(!ye.has(ht)||(0,b.$II)(ht)){ye.add(ht);continue}Ge.add(et),ae&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ge.size===0?z:z.filter((et,at)=>!Ge.has(at))}constructor(z,ae,ye){this.items=yi.ensureUniqueMimeTypes(z,!0),typeof ae=="string"?(this.id=ae,this.metadata=ye):(this.id=(0,R.$kg)(),this.metadata=ae??ye)}}e.$9L=yi;var Ei;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Ei||(e.NotebookCellKind=Ei={}));var Oi;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Oi||(e.NotebookCellExecutionState=Oi={}));var Oe;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Oe||(e.NotebookCellStatusBarAlignment=Oe={}));var ei;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(ei||(e.NotebookEditorRevealType=ei={}));class Yi{constructor(z,ae){this.text=z,this.alignment=ae}}e.$0L=Yi;var $t;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var xi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(xi||(e.NotebookControllerAffinity2=xi={}));class dn{constructor(z,ae=[]){this.uri=z,this.provides=(0,E.$2b)(ae)}}e.$$L=dn;class _i{constructor(z){this.label=z}}e.$_L=_i;var en;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(en||(e.NotebookVariablesRequestKind=en={}));let hi=class{constructor(z,ae){this.label=z,this.timestamp=ae}};e.$aM=hi,e.$aM=hi=He([D],hi);var tn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(tn||(e.ExtensionMode=tn={}));var nn;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(nn||(e.ExtensionRuntime=nn={}));var rn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(rn||(e.StandardTokenType=rn={}));class sn{constructor(z,ae){this.ranges=z,this.wordPattern=ae}}e.$bM=sn;class fn{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$cM=fn;var on;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(on||(e.TestResultState=on={}));var an;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(an||(e.TestRunProfileKind=an={}));let Ni=class{constructor(z=void 0,ae=void 0,ye=void 0,Ge=!1){this.include=z,this.exclude=ae,this.profile=ye,this.continuous=Ge}};e.$dM=Ni,e.$dM=Ni=He([D],Ni);let zi=y=class{static diff(z,ae,ye){const Ge=new y(z);return Ge.expectedOutput=ae,Ge.actualOutput=ye,Ge}constructor(z){this.message=z}};e.$eM=zi,e.$eM=zi=y=He([D],zi);let Ui=class{constructor(z){this.id=z}};e.$fM=Ui,e.$fM=Ui=He([D],Ui);class Di{constructor(z,ae){this.covered=z,this.total=ae}}e.$gM=Di;class ji{static fromDetails(z,ae){const ye=new Di(0,0),Ge=new Di(0,0),et=new Di(0,0);for(const ht of ae)if("branches"in ht){ye.total+=1,ye.covered+=ht.executionCount>0?1:0;for(const Bt of ht.branches)Ge.total+=1,Ge.covered+=Bt.executionCount>0?1:0}else et.total+=1,et.covered+=ht.executionCount>0?1:0;const at=new ji(z,ye,Ge.total>0?Ge:void 0,et.total>0?et:void 0);return at.detailedCoverage=ae,at}constructor(z,ae,ye,Ge){this.uri=z,this.statementCoverage=ae,this.branchCoverage=ye,this.functionCoverage=Ge}}e.$hM=ji;class gn{constructor(z,ae,ye=[]){this.executionCount=z,this.location=ae,this.branches=ye}}e.$iM=gn;class mn{constructor(z,ae){this.executionCount=z,this.location=ae}}e.$jM=mn;class oe{constructor(z,ae,ye){this.name=z,this.executionCount=ae,this.location=ye}}e.$kM=oe;var de;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(de||(e.ExternalUriOpenerPriority=de={}));var Te;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Te||(e.WorkspaceTrustState=Te={}));var st;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(st||(e.PortAutoForwardAction=st={}));class wt{constructor(z,ae,ye,Ge,et,at){this.kind=z,this.name=ae,this.detail=ye,this.uri=Ge,this.range=et,this.selectionRange=at}}e.$lM=wt;class Tt{constructor(z){this.uri=z}}e.$mM=Tt;class Sn{constructor(z,ae){this.original=z,this.modified=ae}}e.$nM=Sn;class In{constructor(z,ae,ye,Ge){this.base=z,this.input1=ae,this.input2=ye,this.result=Ge}}e.$oM=In;class Cn{constructor(z,ae){this.uri=z,this.viewType=ae}}e.$pM=Cn;class Pn{constructor(z){this.viewType=z}}e.$qM=Pn;class Rn{constructor(z,ae){this.uri=z,this.notebookType=ae}}e.$rM=Rn;class An{constructor(z,ae,ye){this.original=z,this.modified=ae,this.notebookType=ye}}e.$sM=An;class Mn{constructor(){}}e.$tM=Mn;class Ln{constructor(z,ae){this.uri=z,this.inputBoxUri=ae}}e.$uM=Ln;class Fn{constructor(z){this.providerId=z}}e.$vM=Fn;var $n;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})($n||(e.InteractiveSessionVoteDirection=$n={}));var pn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(pn||(e.InteractiveSessionCopyKind=pn={}));var vn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(vn||(e.InteractiveEditorResponseFeedbackKind=vn={}));var bn;(function(j){j[j.System=0]="System",j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.Function=3]="Function"})(bn||(e.ChatMessageRole=bn={}));var wn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class Tn{constructor(z,ae){this.role=z,this.content=ae}}e.$wM=Tn;var yn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(yn||(e.ChatAgentResultFeedbackKind=yn={}));var En;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(En||(e.RelatedInformationType=En={}));var Dn;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}))}),define(Pe[103],Re([1,0,53,13,12,294,146,7,18]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LM=e.$KM=e.$JM=void 0;const w=new Map;function R(b,a){a?w.set(b,a):w.delete(b)}e.$JM=R;function S(b){return w.get(b)}class l extends M.$7u{constructor(a,s,t,n,o,c,h,i){super(s,t,n,o),this.c=a,this.m=c,this.q=h,this.notebook=i,this.b=!1}dispose(){(0,E.ok)(!this.b),this.b=!0,this.q=!1}equalLines(a){return(0,g.$tb)(this.f,a)}get document(){if(!this.a){const a=this;this.a={get uri(){return a.d},get fileName(){return a.d.fsPath},get isUntitled(){return a.d.scheme===T.Schemas.untitled},get languageId(){return a.m},get version(){return a.h},get isClosed(){return a.b},get isDirty(){return a.q},save(){return a.r()},getText(s){return s?a.s(s):a.getText()},get eol(){return a.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return a.f.length},lineAt(s){return a.t(s)},offsetAt(s){return a.u(s)},positionAt(s){return a.v(s)},validateRange(s){return a.w(s)},validatePosition(s){return a.x(s)},getWordRangeAtPosition(s,t){return a.y(s,t)}}}return Object.freeze(this.a)}_acceptLanguageId(a){(0,E.ok)(!this.b),this.m=a}_acceptIsDirty(a){(0,E.ok)(!this.b),this.q=a}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(a){const s=this.w(a);if(s.isEmpty)return"";if(s.isSingleLine)return this.f[s.start.line].substring(s.start.character,s.end.character);const t=this.g,n=s.start.line,o=s.end.line,c=[];c.push(this.f[n].substring(s.start.character));for(let h=n+1;h<o;h++)c.push(this.f[h]);return c.push(this.f[o].substring(0,s.end.character)),c.join(t)}t(a){let s;if(a instanceof m.$HK?s=a.line:typeof a=="number"&&(s=a),typeof s!="number"||s<0||s>=this.f.length||Math.floor(s)!==s)throw new Error("Illegal value for `line`");return new $(s,this.f[s],s===this.f.length-1)}u(a){return a=this.x(a),this.l(),this.j.getPrefixSum(a.line-1)+a.character}v(a){a=Math.floor(a),a=Math.max(0,a),this.l();const s=this.j.getIndexOf(a),t=this.f[s.index].length;return new m.$HK(s.index,Math.min(s.remainder,t))}w(a){if(!(a instanceof m.$IK))throw new Error("Invalid argument");const s=this.x(a.start),t=this.x(a.end);return s===a.start&&t===a.end?a:new m.$IK(s.line,s.character,t.line,t.character)}x(a){if(!(a instanceof m.$HK))throw new Error("Invalid argument");if(this.f.length===0)return a.with(0,0);let{line:s,character:t}=a,n=!1;if(s<0)s=0,t=0,n=!0;else if(s>=this.f.length)s=this.f.length-1,t=this.f[s].length,n=!0;else{const o=this.f[s].length;t<0?(t=0,n=!0):t>o&&(t=o,n=!0)}return n?new m.$HK(s,t):a}y(a,s){const t=this.x(a);if(!s)s=S(this.m);else if((0,P.$Se)(s))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${s.source}' because it matches the empty string.`);const n=(0,A.$fs)(t.character+1,(0,A.$ds)(s),this.f[t.line],0);if(n)return new m.$IK(t.line,n.startColumn-1,t.line,n.endColumn-1)}}e.$KM=l;class ${constructor(a,s,t){this.a=a,this.b=s,this.c=t}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$IK(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$IK(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$LM=$}),define(Pe[209],Re([1,0,7,17,5]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tgc=void 0;let M=class{constructor(m){this.a=new E.$4L(E.ColorThemeKind.Dark),this.b=new P.$Rd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let g;switch(m){case"light":g=E.ColorThemeKind.Light;break;case"hcDark":g=E.ColorThemeKind.HighContrast;break;case"hcLight":g=E.ColorThemeKind.HighContrastLight;break;default:g=E.ColorThemeKind.Dark}this.a=new E.$4L(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$tgc=M,e.$tgc=M=He([We(0,T.$HM)],M)}),define(Pe[210],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MI=e.CellExecutionUpdateType=void 0;var T;(function(P){P[P.Output=1]="Output",P[P.OutputItems=2]="OutputItems",P[P.ExecutionState=3]="ExecutionState"})(T||(e.CellExecutionUpdateType=T={})),e.$MI=(0,E.$Zh)("INotebookExecutionService")}),define(Pe[211],Re([1,0,6,29,143,94]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zPb=void 0;class A extends E.$Rc{constructor(g,w,R){super(),this._source=g,this.b=w,this.c=R,this.a=void 0}f(g){const w=g.getLineCount();return new T.$Ds(1,1,w,this.g(g,w))}g(g,w){if(w<1||w>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(w)+1}get inputTextBuffer(){if(!this.b){const g=new P.$SB;g.acceptChunk(this._source);const w=g.finish(!0),{textBuffer:R,disposable:S}=w.create(1);this.b=R,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const w=new P.$SB;w.acceptChunk(g);const R=w.finish(!0),{textBuffer:S,disposable:l}=R.create(1);return this.B(l),S})),this.a}findInInputs(g){const R=new M.$GB(g,!1,!1,null).parseSearchRequest();if(!R)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,R,!0,5e3)}findInOutputs(g){const R=new M.$GB(g,!1,!1,null).parseSearchRequest();return R?this.outputTextBuffers.map(S=>{const l=S.findMatchesLineByLine(this.f(S),R,!0,5e3);if(l.length!==0)return{textBuffer:S,matches:l}}).filter(S=>!!S):[]}}e.$zPb=A}),define(Pe[48],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wJ=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(M){M.Delimiter="\0"})(E||(e.TestIdPathParts=E={}));var T;(function(M){M[M.IsSame=0]="IsSame",M[M.Disconnected=1]="Disconnected",M[M.IsChild=2]="IsChild",M[M.IsParent=3]="IsParent"})(T||(e.TestPosition=T={}));class P{static fromExtHostTestItem(A,m,g=A.parent){if(A._isRoot)return new P([m]);const w=[A.id];for(let R=g;R&&R.id!==m;R=R.parent)w.push(R.id);return w.push(m),new P(w.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const m=A.indexOf("\0");return m===-1?A:A.slice(0,m)}static fromString(A){return new P(A.split("\0"))}static join(A,m){return new P([...A.path,m])}static joinToString(A,m){return A.toString()+"\0"+m}static parentId(A){const m=A.lastIndexOf("\0");return m===-1?void 0:A.slice(0,m)}static localId(A){const m=A.lastIndexOf("\0");return m===-1?A:A.slice(m+1)}static isChild(A,m){return m.startsWith(A)&&m[A.length]==="\0"}static compare(A,m){return A===m?0:P.isChild(A,m)?2:P.isChild(m,A)?3:1}constructor(A,m=A.length){if(this.path=A,this.d=m,A.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new P(this.path,1)}get parentId(){return this.d>1?new P(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new P(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new P(this.path,A)}compare(A){if(typeof A=="string")return P.compare(this.toString(),A);for(let m=0;m<A.d&&m<this.d;m++)if(A.path[m]!==this.path[m])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$wJ=P}),define(Pe[58],Re([1,0,2,92,29,48]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EJ=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$DJ=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$CJ=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$BJ=e.$AJ=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$zJ=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$yJ=e.$xJ=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var A;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(A||(e.TestResultState=A={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var g;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$xJ=[2,4,8,16,32,64];const w=C=>"runId"in C;e.$yJ=w;var R;(function(C){C.serialize=I=>({range:I.range.toJSON(),uri:I.uri.toJSON()}),C.deserialize=I=>({range:P.$Ds.lift(I.range),uri:E.URI.revive(I.uri)})})(R||(e.IRichLocation=R={}));var S;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(S||(e.TestMessageType=S={}));var l;(function(C){C.serialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&R.serialize(I.location)}),C.deserialize=I=>({message:I.message,type:0,expected:I.expected,actual:I.actual,contextValue:I.contextValue,location:I.location&&R.deserialize(I.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,I)=>`${I?"s":"e"}${C}`;e.$zJ=$;var b;(function(C){C.serialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&R.serialize(I.location)}),C.deserialize=I=>({message:I.message,type:1,offset:I.offset,length:I.length,location:I.location&&R.deserialize(I.location)})})(b||(e.ITestOutputMessage=b={}));var a;(function(C){C.serialize=I=>I.type===0?l.serialize(I):b.serialize(I),C.deserialize=I=>I.type===0?l.deserialize(I):b.deserialize(I)})(a||(e.ITestMessage=a={}));var s;(function(C){C.serializeWithoutMessages=I=>({state:I.state,duration:I.duration,messages:[]}),C.serialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(a.serialize)}),C.deserialize=I=>({state:I.state,duration:I.duration,messages:I.messages.map(a.deserialize)})})(s||(e.ITestTaskState=s={}));const t="\0",n=(C,I)=>C+t+I;e.$AJ=n;const o=C=>{const I=C.indexOf(t);return{ctrlId:C.slice(0,I),tagId:C.slice(I+1)}};e.$BJ=o;var c;(function(C){C.serialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?.toJSON(),range:I.range?.toJSON()||null,description:I.description,error:I.error,sortText:I.sortText}),C.deserialize=I=>({extId:I.extId,label:I.label,tags:I.tags,busy:I.busy,children:void 0,uri:I.uri?E.URI.revive(I.uri):void 0,range:I.range?P.$Ds.lift(I.range):null,description:I.description,error:I.error,sortText:I.sortText})})(c||(e.ITestItem=c={}));var h;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(C){C.serialize=I=>({expand:I.expand,item:c.serialize(I.item)}),C.deserialize=I=>({controllerId:M.$wJ.root(I.item.extId),expand:I.expand,item:c.deserialize(I.item)})})(i||(e.InternalTestItem=i={}));var r;(function(C){C.serialize=I=>{let X;return I.item&&(X={},I.item.label!==void 0&&(X.label=I.item.label),I.item.tags!==void 0&&(X.tags=I.item.tags),I.item.busy!==void 0&&(X.busy=I.item.busy),I.item.uri!==void 0&&(X.uri=I.item.uri?.toJSON()),I.item.range!==void 0&&(X.range=I.item.range?.toJSON()),I.item.description!==void 0&&(X.description=I.item.description),I.item.error!==void 0&&(X.error=I.item.error),I.item.sortText!==void 0&&(X.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:X}},C.deserialize=I=>{let X;return I.item&&(X={},I.item.label!==void 0&&(X.label=I.item.label),I.item.tags!==void 0&&(X.tags=I.item.tags),I.item.busy!==void 0&&(X.busy=I.item.busy),I.item.range!==void 0&&(X.range=I.item.range?P.$Ds.lift(I.item.range):null),I.item.description!==void 0&&(X.description=I.item.description),I.item.error!==void 0&&(X.error=I.item.error),I.item.sortText!==void 0&&(X.sortText=I.item.sortText)),{extId:I.extId,expand:I.expand,item:X}}})(r||(e.ITestItemUpdate=r={}));const u=(C,I)=>{I.expand!==void 0&&(C.expand=I.expand),I.item!==void 0&&(C.item=C.item?Object.assign(C.item,I.item):I.item)};e.$CJ=u;var d;(function(C){C.serializeWithoutMessages=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.serializeWithoutMessages)}),C.serialize=I=>({...i.serialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.serialize)}),C.deserialize=I=>({...i.deserialize(I),ownComputedState:I.ownComputedState,computedState:I.computedState,tasks:I.tasks.map(s.deserialize),retired:!0})})(d||(e.TestResultItem=d={}));var v;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(I,X)=>{I.covered+=X.covered,I.total+=X.total}})(v||(e.ICoveredCount=v={}));var f;(function(C){C.serialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.serialize),uri:I.uri.toJSON()}),C.deserialize=I=>({statement:I.statement,branch:I.branch,function:I.function,details:I.details?.map(y.deserialize),uri:E.URI.from(I.uri)})})(f||(e.IFileCoverage=f={}));function k(C){return{...C,location:C.location?.toJSON()}}function L(C){return C.location=C.location?T.$Cs.isIPosition(C.location)?T.$Cs.lift(C.location):P.$Ds.lift(C.location):void 0,C}e.$DJ=3;var p;(function(C){C[C.Function=0]="Function",C[C.Statement=1]="Statement"})(p||(e.DetailType=p={}));var y;(function(C){C.serialize=I=>I.type===0?N.serialize(I):q.serialize(I),C.deserialize=I=>I.type===0?N.deserialize(I):q.deserialize(I)})(y||(e.CoverageDetails=y={}));var D;(function(C){C.serialize=k,C.deserialize=L})(D||(e.IBranchCoverage=D={}));var N;(function(C){C.serialize=k,C.deserialize=L})(N||(e.IFunctionCoverage=N={}));var q;(function(C){C.serialize=I=>({...k(I),branches:I.branches?.map(D.serialize)}),C.deserialize=I=>({...L(I),branches:I.branches?.map(D.deserialize)})})(q||(e.IStatementCoverage=q={}));var V;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var U;(function(C){C.deserialize=I=>I.op===0?{op:I.op,item:i.deserialize(I.item)}:I.op===1?{op:I.op,item:r.deserialize(I.item)}:I.op===2?{op:I.op,uri:E.URI.revive(I.uri),docv:I.docv}:I,C.serialize=I=>I.op===0?{op:I.op,item:i.serialize(I.item)}:I.op===1?{op:I.op,item:r.serialize(I.item)}:I})(U||(e.TestsDiffOp=U={}));class F{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(I){const X=this.o();for(const ue of I)switch(ue.op){case 0:this.j(i.deserialize(ue.item),X);break;case 1:this.k(r.deserialize(ue.item),X);break;case 3:this.l(ue.itemId,X);break;case 5:this.m(ue.itemId);break;case 4:this.updatePendingRoots(ue.amount);break;case 6:this.c.set(ue.tag.id,ue.tag);break;case 7:this.c.delete(ue.id);break}X.complete?.()}j(I,X){const ue=M.$wJ.parentId(I.item.extId)?.toString();let he;if(!ue)he=this.p(I),this.f.add(he),this.d.set(I.item.extId,he);else if(this.d.has(ue)){const be=this.d.get(ue);be.children.add(I.item.extId),he=this.p(I,be),this.d.set(I.item.extId,he)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(I)}`);return}return X.add?.(he),I.expand===2&&this.g++,he}k(I,X){const ue=this.d.get(I.extId);if(ue)return I.expand!==void 0&&(ue.expand===2&&this.g--,I.expand===2&&this.g++),(0,e.$CJ)(ue,I),X.update?.(ue),ue}l(I,X){const ue=this.d.get(I);if(!ue)return;const he=M.$wJ.parentId(ue.item.extId)?.toString();he?this.d.get(he).children.delete(ue.item.extId):this.f.delete(ue);const be=[[I]];for(;be.length;)for(const we of be.pop()){const ge=this.d.get(we);ge&&(be.push(ge.children),this.d.delete(we),X.remove?.(ge,ge!==ue),ge.expand===2&&this.g--)}}m(I){}updatePendingRoots(I){this.h+=I}o(){return{}}}e.$EJ=F}),define(Pe[77],Re([1,0,14,5,6,53,58,48]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=e.$zM=e.$yM=e.$xM=e.TestItemEventOp=void 0;var g;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const w=(n,o)=>n===o,S=Object.entries({range:(n,o)=>n===o?!0:!n||!o?!1:n.equalsRange(o),busy:w,label:w,description:w,error:w,sortText:w,tags:(n,o)=>!(n.length!==o.length||n.some(c=>!o.includes(c)))}),l=(n,o)=>{let c;for(const[h,i]of S)i(n[h],o[h])||(c?c[h]=o[h]:c={[h]:o[h]});return c};class $ extends P.$Rc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new E.$_g(()=>this.flushDiff(),200)),this.g=this.B(new T.$Rd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.y(this.root,void 0)}set resolveHandler(o){this.h=o;for(const c of this.tree.values())this.I(c)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===o.uri){c.docv=o.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===o.item.extId){(0,A.$CJ)(c.item,o.item);return}if(c.op===0&&c.item.item.extId===o.item.extId){(0,A.$CJ)(c.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,c){const h=this.tree.get(o);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.L(h);return i.isOpen()?this.J(h,c-1):i.wait().then(()=>this.J(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.J(h,c-1)):this.J(h,c-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}u(o,c){switch(c.op){case 3:this.N(m.$wJ.joinToString(o.fullId,c.id));break;case 0:this.y(c.item,o);break;case 5:for(const h of c.ops)this.u(o,h);break;case 1:this.z(c.new,c.old,o.fullId.toString());break;case 2:this.I(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:c.update}});break;case 6:this.w(o.actual.uri);break;default:(0,M.$4c)(c)}}w(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}y(o,c){const h=m.$wJ.fromExtHostTestItem(o,this.root.id,c?.actual),i=this.s.getApiFor(o);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(o.id);let r=this.tree.get(h.toString());if(!r){r={fullId:h,actual:o,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},o.tags.forEach(this.C,this),this.tree.set(r.fullId.toString(),r),this.F(o,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:r.expand,item:this.s.toITestItem(o)}}),this.H(o,r,c);return}if(r.actual===o){this.G(o,r,c);return}if(r.actual.uri?.toString()!==o.uri?.toString())return this.N(h.toString()),this.y(o,c);const u=this.s.getChildren(r.actual),d=r.actual,v=l(this.s.toITestItem(d),this.s.toITestItem(o));this.s.getApiFor(d).listener=void 0,r.actual=o,r.expand=0,v&&(v.hasOwnProperty("tags")&&(this.z(o.tags,d.tags,h.toString()),delete v.tags),this.u(r,{op:4,update:v})),this.H(o,r,c);for(const[f,k]of u)this.s.getChildren(o).get(k.id)||this.N(m.$wJ.joinToString(h,k.id));this.w(r.actual.uri)}z(o,c,h){const i=new Set(c.map(r=>r.id));for(const r of o)i.delete(r.id)||this.C(r);this.pushDiff({op:1,item:{extId:h,item:{tags:o.map(r=>(0,A.$AJ)(this.s.controllerId,r.id))}}}),i.forEach(this.D,this)}C(o){const c=this.j.get(o.id);c?c.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$AJ)(this.s.controllerId,o.id)}}))}D(o){const c=this.j.get(o);c&&!--c.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,A.$AJ)(this.s.controllerId,o)}))}F(o,c){this.s.getApiFor(o).parent=c&&c.actual!==this.root?c.actual:void 0}G(o,c,h){this.F(o,h);const i=this.s.getApiFor(o);i.parent=h?.actual,i.listener=r=>this.u(c,r),this.I(c)}H(o,c,h){this.G(o,c,h);for(const[i,r]of this.s.getChildren(o))this.y(r,c)}I(o){let c;this.h?o.resolveBarrier?c=o.resolveBarrier.isOpen()?3:2:c=o.actual.canResolveChildren?1:0:c=0,c!==o.expand&&(o.expand=c,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:c}}),c===1&&o.expandLevels!==void 0&&this.L(o))}J(o,c){if(c<0)return;const h=[];for(const[i,r]of this.s.getChildren(o.actual)){const u=this.expand(m.$wJ.joinToString(o.fullId,r.id),c);(0,E.$Mg)(u)&&h.push(u)}if(h.length)return Promise.all(h).then(()=>{})}L(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const r=new E.$Yg;return r.open(),r}o.expand=2,this.M(o);const c=o.resolveBarrier=new E.$Yg,h=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,r)};let i;try{i=this.h(o.actual===this.root?void 0:o.actual)}catch(r){h(r)}return(0,E.$Mg)(i)?i.catch(h).then(()=>{c.open(),this.I(o)}):(c.open(),this.I(o)),o.resolveBarrier}M(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}N(o){const c=this.tree.get(o);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const r of i.actual.tags)this.D(r.id);this.tree.delete(i.fullId.toString());for(const[r,u]of this.s.getChildren(i.actual))h.push(this.tree.get(m.$wJ.joinToString(i.fullId,u.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$xM=$;class b extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$yM=b;class a extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$zM=a;class s extends Error{constructor(o,c,h){super(`TestItem with ID "${o}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$AM=s;const t=(n,o,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,r){for(const u of h.values())i.call(r,u,this)},[Symbol.iterator](){return h.entries()},replace(i){const r=new Map,u=new Set(h.keys()),d={op:5,ops:[]};for(const v of i){if(!(v instanceof c))throw new a(v.id);const f=o(v).controllerId;if(f!==n.controllerId)throw new s(v.id,f,n.controllerId);if(r.has(v.id))throw new b(v.id);r.set(v.id,v),u.delete(v.id),d.ops.push({op:0,item:v})}for(const v of u.keys())d.ops.push({op:3,id:v});n.listener?.(d),h=r},add(i){if(!(i instanceof c))throw new a(i.id);h.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){h.delete(i)&&n.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$BM=t}),define(Pe[104],Re([1,0,77]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DM=e.$CM=void 0;const T=new WeakMap,P=(A,m)=>{const g={controllerId:m};return T.set(A,g),g};e.$CM=P;const M=A=>{const m=T.get(A);if(!m)throw new E.$zM(A?.id||"<unknown>");return m};e.$DM=M}),define(Pe[78],Re([1,0,13,2]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rub=e.$Qub=e.$Pub=e.$Oub=e.$Nub=void 0,e.$Nub="vscode-cdn.net",e.$Oub=`vscode-resource.${e.$Nub}`,e.$Pub=`'self' https://*.${e.$Nub}`;function P(m,g){return m.scheme===E.Schemas.http||m.scheme===E.Schemas.https?m:(g&&g.authority&&g.isRemote&&m.scheme===E.Schemas.file&&(m=T.URI.from({scheme:E.Schemas.vscodeRemote,authority:g.authority,path:m.path})),T.URI.from({scheme:E.Schemas.https,authority:`${m.scheme}+${M(m.authority)}.${e.$Oub}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Qub=P;function M(m){return m.replace(/./g,g=>{const w=g.charCodeAt(0);return w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57?g:"-"+w.toString(16).padStart(4,"0")})}function A(m){return m.replace(/-([0-9a-f]{4})/g,(g,w)=>String.fromCharCode(parseInt(w,16)))}e.$Rub=A}),define(Pe[212],Re([1,0,5,6,78]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pec=void 0;class M{constructor(m,g,w){this.d=m,this.e=g,this.f=w,this.a=0,this.b=new T.$Qc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const R=g.getVisibleTextEditors();for(const S of this.c.values())R.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,g,w,R,S){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,b=this.a++,a=new E.$Rd,s=new E.$Rd,t=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,P.$Qub)(o,$.f)}get cspSource(){return P.$Pub}set options(o){this.b=o,$.d.$setOptions(b,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(b,o)}get html(){return this.a}get onDidReceiveMessage(){return a.event}postMessage(o){return $.d.$postMessage(b,o)}},n=new class{constructor(){this.editor=m,this.line=g,this.height=w,this.webview=t,this.onDidDispose=s.event}dispose(){$.c.has(b)&&($.c.delete(b),$.d.$disposeEditorInset(b),s.fire(),s.dispose(),a.dispose())}};return this.d.$createEditorInset(b,l.id,l.value.document.uri,g+1,w,R||{},S.identifier,S.extensionLocation),this.c.set(b,{editor:m,inset:n,onDidReceiveMessage:a}),n}$onDidDispose(m){const g=this.c.get(m);g&&g.inset.dispose()}$onDidReceiveMessage(m,g){this.c.get(m)?.onDidReceiveMessage.fire(g)}}e.$Pec=M}),define(Pe[213],Re([1,0,4]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.VariableKind=e.$tN=void 0,e.$tN=(0,E.$Zh)("configurationResolverService");var T;(function(M){M.Unknown="unknown",M.Env="env",M.Config="config",M.Command="command",M.Input="input",M.ExtensionInstallFolder="extensionInstallFolder",M.WorkspaceFolder="workspaceFolder",M.Cwd="cwd",M.WorkspaceFolderBasename="workspaceFolderBasename",M.UserHome="userHome",M.LineNumber="lineNumber",M.SelectedText="selectedText",M.File="file",M.FileWorkspaceFolder="fileWorkspaceFolder",M.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",M.RelativeFile="relativeFile",M.RelativeFileDirname="relativeFileDirname",M.FileDirname="fileDirname",M.FileExtname="fileExtname",M.FileBasename="fileBasename",M.FileBasenameNoExtension="fileBasenameNoExtension",M.FileDirnameBasename="fileDirnameBasename",M.ExecPath="execPath",M.ExecInstallFolder="execInstallFolder",M.PathSeparator="pathSeparator"})(T||(e.VariableKind=T={}));class P extends Error{constructor(A,m){super(m),this.variable=A}}e.$uN=P}),define(Pe[214],Re([1,0,20,74,16,26,21,95,176,213,12]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IN=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,b,a,s){this.h=new Map,this.a=$,this.b=b,this.g=a,s&&(this.c=s.then(t=>this.i(t)))}i($){if(A.$i){const b=Object.create(null);return Object.keys($).forEach(a=>{b[a.toLowerCase()]=$[a]}),b}return $}resolveWithEnvironment($,b,a){return this.l({env:this.i($),userHome:void 0},b?b.uri:void 0,a)}async resolveAsync($,b){const a={env:await this.c,userHome:await this.g};return this.l(a,$?$.uri:void 0,b)}async j($,b,a,s){const t=M.$en(b);A.$i&&t.windows?Object.keys(t.windows).forEach(o=>t[o]=t.windows[o]):A.$j&&t.osx?Object.keys(t.osx).forEach(o=>t[o]=t.osx[o]):A.$k&&t.linux&&Object.keys(t.linux).forEach(o=>t[o]=t.linux[o]),delete t.windows,delete t.osx,delete t.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,$?$.uri:void 0,t,a,s)}async resolveAnyAsync($,b,a){return this.j($,b,a)}async resolveAnyMap($,b,a){const s=new Map;return{newConfig:await this.j($,b,a,s),resolvedVariables:s}}resolveWithInteractionReplace($,b,a,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,b,a,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,b){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,b)}async l($,b,a,s,t){if(P.$Cf(a))return this.m($,b,a,s,t);if(Array.isArray(a))return Promise.all(a.map(n=>this.l($,b,n,s,t)));if(P.$Ef(a)){const n=Object.create(null),o=await Promise.all(Object.keys(a).map(async c=>[await this.m($,b,c,s,t),await this.l($,b,a[c],s,t)]));for(const[c,h]of o)n[c]=h;return n}return a}m($,b,a,s,t){return(0,R.$Xe)(a,S.VARIABLE_REGEXP,async(n,o)=>{if(o.includes(S.VARIABLE_LHS))return n;let c=await this.o($,n,o,b,s);return t?.set(o,c),c!==n&&P.$Cf(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m($,b,c,s,t)),c})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,b,a,s,t){let n;const o=a.split(":");o.length>1&&(a=o[0],n=o[1]);const c=r=>{const u=this.a.getFilePath();if(u)return(0,m.$Ev)(u);throw new w.$uN(r,(0,g.localize)(0,null,b))},h=r=>{const u=c(r);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,m.$Ev)(d)}throw new w.$uN(r,(0,g.localize)(1,null,b,E.$mc(u)))},i=r=>{if(n){const u=this.a.getFolderUri(n);if(u)return u;throw new w.$uN(r,(0,g.localize)(2,null,b,n))}if(s)return s;throw this.a.getWorkspaceFolderCount()>1?new w.$uN(r,(0,g.localize)(3,null,b)):new w.$uN(r,(0,g.localize)(4,null,b))};switch(a){case"env":if(n){if($.env){const r=$.env[A.$i?n.toLowerCase():n];if(P.$Cf(r))return r}return""}throw new w.$uN(w.VariableKind.Env,(0,g.localize)(5,null,b));case"config":if(n){const r=this.a.getConfigurationValue(s,n);if(P.$Lf(r))throw new w.$uN(w.VariableKind.Config,(0,g.localize)(6,null,b,n));if(P.$Ef(r))throw new w.$uN(w.VariableKind.Config,(0,g.localize)(7,null,b,n));return r}throw new w.$uN(w.VariableKind.Config,(0,g.localize)(8,null,b));case"command":return this.p(w.VariableKind.Command,b,n,t,"command");case"input":return this.p(w.VariableKind.Input,b,n,t,"input");case"extensionInstallFolder":if(n){const r=await this.a.getExtension(n);if(!r)throw new w.$uN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,b,n));return this.n(r.extensionLocation)}throw new w.$uN(w.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,b));default:switch(a){case"workspaceRoot":case"workspaceFolder":return(0,m.$Ev)(this.n(i(w.VariableKind.WorkspaceFolder)));case"cwd":return s||n?(0,m.$Ev)(this.n(i(w.VariableKind.Cwd))):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Ev)(E.$mc(this.n(i(w.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new w.$uN(w.VariableKind.UserHome,(0,g.localize)(11,null,b))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new w.$uN(w.VariableKind.LineNumber,(0,g.localize)(12,null,b))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new w.$uN(w.VariableKind.SelectedText,(0,g.localize)(13,null,b))}case"file":return c(w.VariableKind.File);case"fileWorkspaceFolder":return h(w.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return E.$mc(h(w.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return s||n?E.$kc(this.n(i(w.VariableKind.RelativeFile)),c(w.VariableKind.RelativeFile)):c(w.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.$lc(c(w.VariableKind.RelativeFileDirname));if(s||n){const u=E.$kc(this.n(i(w.VariableKind.RelativeFileDirname)),r);return u.length===0?".":u}return r}case"fileDirname":return E.$lc(c(w.VariableKind.FileDirname));case"fileExtname":return E.$nc(c(w.VariableKind.FileExtname));case"fileBasename":return E.$mc(c(w.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.$mc(c(w.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.$nc(r).length)}case"fileDirnameBasename":return E.$mc(E.$lc(c(w.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||b}case"execInstallFolder":{const r=this.a.getAppRoot();return r||b}case"pathSeparator":return E.sep;default:try{const r=n?`${a}:${n}`:a;return this.p(w.VariableKind.Unknown,b,r,t,void 0)}catch{return b}}}}p($,b,a,s,t){if(a&&s){const n=t===void 0?s[a]:s[t+":"+a];if(typeof n=="string")return n;throw new w.$uN($,(0,g.localize)(14,null,b))}return b}}e.$IN=S}),define(Pe[105],Re([1,0,4,102]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PC=e.$OC=e.OpenEditorContext=e.GroupsOrder=e.$NC=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$MC=void 0,e.$MC=(0,E.$Zh)("editorGroupsService");var P;(function(b){b[b.UP=0]="UP",b[b.DOWN=1]="DOWN",b[b.LEFT=2]="LEFT",b[b.RIGHT=3]="RIGHT"})(P||(e.GroupDirection=P={}));var M;(function(b){b[b.HORIZONTAL=0]="HORIZONTAL",b[b.VERTICAL=1]="VERTICAL"})(M||(e.GroupOrientation=M={}));var A;(function(b){b[b.FIRST=0]="FIRST",b[b.LAST=1]="LAST",b[b.NEXT=2]="NEXT",b[b.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var m;(function(b){b[b.MAXIMIZE=0]="MAXIMIZE",b[b.EXPAND=1]="EXPAND",b[b.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var g;(function(b){b[b.COPY_EDITORS=0]="COPY_EDITORS",b[b.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function w(b){const a=b;return(0,T.$vE)(a?.editor)&&(0,T.$vE)(a?.replacement)}e.$NC=w;var R;(function(b){b[b.CREATION_TIME=0]="CREATION_TIME",b[b.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",b[b.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R||(e.GroupsOrder=R={}));var S;(function(b){b[b.NEW_EDITOR=1]="NEW_EDITOR",b[b.MOVE_EDITOR=2]="MOVE_EDITOR",b[b.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function l(b){const a=b;return!!a&&typeof a.id=="number"&&Array.isArray(a.editors)}e.$OC=l;function $(b){return b.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$PC=$}),define(Pe[215],Re([1,0,4,105]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=e.$SC=e.$RC=e.$QC=void 0,e.$QC=(0,E.$Zh)("editorService"),e.$RC=-1,e.$SC=-2;function P(M){const A=M;return typeof M=="number"||(0,T.$OC)(A)}e.$TC=P}),define(Pe[216],Re([1,0,4,183]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=void 0,e.$2J=(0,E.$1h)(T.$7h)}),define(Pe[106],Re([1,0,22,5,20,6]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L6b=e.$K6b=e.$J6b=e.$I6b=e.$H6b=void 0;class A{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$H6b=A;class m{static isHostExtension(t,n,o){if(n.getExtensionDescription(t))return!1;const c=o.getExtensionDescription(t);return c?!!((c.main||c.browser)&&c.api==="none"):!1}constructor(t,n){this.j=t,this.c=new T.$Rd,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(b),this.f=new E.$fm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const o of n)this.h.has(o)||this.h.set(o,[]),this.h.get(o).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=a(this.e,n),this.e=this.e.concat(t);const o=m.l(this.e);return this.e=a(this.e,o.map(c=>c.identifier)),this.k(),this.d++,this.c.fire(void 0),new A(this.d,o)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(r){this.d.has(r)||(this.d.add(r),this.e.push(r))}addArc(r,u){this.addNode(r),this.addNode(u),this.c.has(r)?this.c.get(r).push(u):this.c.set(r,[u])}getArcs(r){return this.c.has(r)?this.c.get(r):[]}hasOnlyGoodArcs(r,u){const d=n.getArcs(r);for(let v=0;v<d.length;v++)if(!u.has(d[v]))return!1;return!0}getNodes(){return this.e}},o=new E.$fm;for(const r of t)if(o.set(r.identifier,r),r.extensionDependencies)for(const u of r.extensionDependencies)n.addArc(E.$dm.toKey(r.identifier),E.$dm.toKey(u));const c=new Set;n.getNodes().filter(r=>n.getArcs(r).length===0).forEach(r=>c.add(r));const h=n.getNodes().filter(r=>!c.has(r));let i;do{i=!1;for(let r=0;r<h.length;r++){const u=h[r];n.hasOnlyGoodArcs(u,c)&&(h.splice(r,1),r--,c.add(u),i=!0)}}while(i);return h.map(r=>o.get(r))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new g(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$I6b=m;class g{constructor(t,n){this.versionId=t,this.extensions=n}}e.$J6b=g;class w{constructor(t){this.d=new l,this.c=new m(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new R(this,n)}deltaExtensions(t,n,o){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,o)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$K6b=w;class R extends M.$Rc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$L6b=R;class S{constructor(t){this.name=t,this.promise=new Promise((n,o)=>{this.c=n})}resolve(t){this.c(t)}}class l{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new S(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const o=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),c=()=>{n&&(clearTimeout(o),n=!1,this.d=!1,this.e())};t.resolve((0,M.$Pc)(c))}}var $;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})($||($={}));function b(s,t){const n=s.isBuiltin?0:s.isUnderDevelopment?2:1,o=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==o)return n-o;const c=P.$fc.basename(s.extensionLocation.path),h=P.$fc.basename(t.extensionLocation.path);return c<h?-1:c>h?1:0}function a(s,t){const n=new E.$em(t);return s.filter(o=>!n.has(o.identifier))}}),define(Pe[79],Re([1,0,24]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$mm=e.$lm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var T;(function(w){w[w.Desktop=1]="Desktop",w[w.Web=2]="Web"})(T||(e.UIKind=T={}));var P;(function(w){w[w.VersionMismatch=55]="VersionMismatch",w[w.UnexpectedError=81]="UnexpectedError"})(P||(e.ExtensionHostExitCode=P={}));var M;(function(w){w[w.Initialized=0]="Initialized",w[w.Ready=1]="Ready",w[w.Terminate=2]="Terminate"})(M||(e.MessageType=M={}));function A(w){const R=E.$fe.alloc(1);switch(w){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.$lm=A;function m(w,R){if(w.byteLength!==1)return!1;switch(w.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.$mm=m;var g;(function(w){w.Start="START_NATIVE_LOG",w.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Pe[59],Re([1,0,4,5,15,27,79,55,56,26,2,6,164]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2M=e.$1M=e.$ZM=e.$YM=void 0;let $=class extends S.$Rc{constructor(t,n){super(),this.s=t,this.t=n,this.a=this.B(new T.$Rd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new T.$Rd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=R.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:g.$yo,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(n.onDidChangeLogLevel(o=>{(0,P.$jj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===P.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(t,n,o){const c=this.getTelemetryDetails(),h=new b(n,o,t,this.n,this.j,this.getBuiltInCommonProperties(t),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(t.identifier.value)??[];return this.r.set(t.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(t,n,o){this.f=t,this.g=n,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(t){const n=Object.create(null);switch(n["common.extname"]=`${t.publisher}.${t.name}`,n["common.extversion"]=t.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=a(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,m.$6k)((0,g.$Fo)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(t){this.h=this.getTelemetryConfiguration(),this.f=t;const n=this.getTelemetryDetails();this.r.forEach((o,c)=>{const h=o.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(o=>{for(const c of o)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(t,n){const c=this.r.get(t.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(t.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),h=!0);return h}};e.$YM=$,e.$YM=$=He([We(0,M.$XM),We(1,P.$ij)],$);class b{static validateSender(t){if(typeof t!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof t.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof t.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof t.flush<"u"&&typeof t.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(t,n,o,c,h,i,r){this.g=o,this.h=c,this.i=h,this.j=i,this.a=new T.$Rd,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=t,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(t,n){this.e&&(this.d={isUsageEnabled:t,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(t){let n="properties"in t?t.properties??{}:t;return n=(0,g.$Io)(n,[]),this.c&&(n=(0,w.$hn)(n,this.c)),this.b||(n=(0,w.$hn)(n,this.j)),"properties"in t?t.properties=n:t=n,t}k(t,n){this.f&&(this.g.publisher==="vscode"?t=this.g.name+"/"+t:t=this.g.identifier.value+"/"+t,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(t,n),this.h.trace(t,n))}logUsage(t,n){this.d.isUsageEnabled&&this.k(t,n)}logError(t,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof t=="string")this.k(t,n);else{const o={name:t.name,message:t.message,stack:t.stack,cause:t.cause},c=(0,g.$Io)(o,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(h,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const t=this,n={logUsage:t.logUsage.bind(t),get isUsageEnabled(){return t.d.isUsageEnabled},get isErrorsEnabled(){return t.d.isErrorsEnabled},logError:t.logError.bind(t),dispose:t.dispose.bind(t),onDidChangeEnableStates:t.a.event.bind(t)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let t=this.f;this.f=void 0,Promise.resolve(t.flush()).then(t=void 0),this.e=void 0}else this.f=void 0}}e.$ZM=b;function a(s){const t=Date.now()-new Date(s).getTime();return isNaN(t)?!1:t<1e3*60*60*24}e.$1M=a,e.$2M=(0,E.$Zh)("IExtHostTelemetry")}),define(Pe[23],Re([1,0,5,2,192,101,22,4]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WF=e.$VF=e.$UF=e.ActivationKind=e.$TF=e.$SF=e.$RF=e.$QF=e.$PF=e.ExtensionHostStartup=e.$OF=e.$NF=e.$MF=e.$LF=void 0,e.$LF=Object.freeze({identifier:new A.$dm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$MF="extensions.webWorker",e.$NF=(0,m.$Zh)("extensionService");class g{constructor(h){this.dependency=h}}e.$OF=g;var w;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(w||(e.ExtensionHostStartup=w={}));class R{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,r){this.c=h,this.d=i.slice(0),this.e=r.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:M.$CF.createActivationEventsMap(this.d)}}set(h,i,r){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const u=[],d=[],v=[],f=[],k=S(this.d),L=S(i),p=(V,U)=>V.extensionLocation.toString()===U.extensionLocation.toString()||V.isBuiltin===U.isBuiltin||V.isUserBuiltin===U.isUserBuiltin||V.isUnderDevelopment===U.isUnderDevelopment;for(const V of this.d){const U=L.get(V.identifier);if(!U){u.push(V.identifier),k.delete(V.identifier);continue}if(!p(V,U)){u.push(V.identifier),k.delete(V.identifier);continue}}for(const V of i){const U=k.get(V.identifier);if(!U){d.push(V);continue}if(!p(U,V)){u.push(U.identifier),k.delete(U.identifier);continue}}const y=new A.$em(this.e),D=new A.$em(r);for(const V of this.e)D.has(V)||v.push(V);for(const V of r)y.has(V)||f.push(V);const N=M.$CF.createActivationEventsMap(d),q={versionId:h,toRemove:u,toAdd:d,addActivationEvents:N,myToRemove:v,myToAdd:f};return this.delta(q),q}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:r,myToRemove:u,myToAdd:d}=h,v=new A.$em(i),f=new A.$em(u);for(let k=0;k<this.d.length;k++)v.has(this.d[k].identifier)&&(this.d.splice(k,1),k--);for(let k=0;k<this.e.length;k++)f.has(this.e[k])&&(this.e.splice(k,1),k--);for(const k of r)this.d.push(k);for(const k of d)this.e.push(k);return this.f=null,h}containsExtension(h){for(const i of this.e)if(A.$dm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const r=M.$CF.readActivationEvents(i);for(const u of r)h.add(u)}return h}}e.$PF=R;function S(c){const h=new A.$fm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}e.$QF=l;function $(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.$RF=$;class b{constructor(h,i,r,u){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=r,this.activationReason=u}}e.$SF=b;class a{constructor(h,i){this.description=h,this.value=i}}e.$TF=a;var s;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(s||(e.ActivationKind=s={}));function t(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,P.$Oo)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.$UF=t;function n(c,h){return{identifier:new A.$dm((0,P.$Mo)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform}}e.$VF=n;class o{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.onWillStop=E.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$WF=o}),define(Pe[217],Re([1,0,11,106,22,23,15,14]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$efc=e.$dfc=e.$cfc=e.$bfc=e.$afc=e.$_ec=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(t,n,o,c){this.startup=t,this.codeLoadingTime=n,this.activateCallTime=o,this.activateResolvedTime=c}}e.$_ec=g;class w{constructor(t){this.a=t,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(t,n){return t===-1||n===-1?-1:n-t}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$afc=w;class R{constructor(t,n,o,c,h,i){this.activationFailed=t,this.activationFailedError=n,this.activationTimes=o,this.module=c,this.exports=h,this.subscriptions=i}}e.$bfc=R;class S extends R{constructor(t){super(!1,null,t,{activate:void 0,deactivate:void 0},void 0,[])}}e.$cfc=S;class l extends R{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$dfc=l;class $ extends R{constructor(t){super(!0,t,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let b=class{constructor(t,n,o,c){this.g=c,this.a=t,this.b=n,this.c=o,this.d=new P.$fm,this.f=Object.create(null)}dispose(){for(const[t,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const t=[];for(const[n,o]of this.d)t.push(o.wait());await Promise.all(t)}isActivated(t){const n=this.d.get(t);return!!(n&&n.value)}getActivatedExtension(t){const n=this.d.get(t);if(!n||!n.value)throw new Error(`Extension '${t.value}' is not known or not activated`);return n.value}async activateByEvent(t,n){if(this.f[t])return;const o=this.a.getExtensionDescriptionsForActivationEvent(t);await this.h(o.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:t}}))),this.f[t]=!0}activateById(t,n){const o=this.a.getExtensionDescription(t);if(!o)throw new Error(`Extension '${t}' is not known`);return this.h([{id:o.identifier,reason:n}])}async h(t){const n=t.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(n.map(o=>o.wait()))}j(t){if(this.d.has(t.id))return this.d.get(t.id);if(this.l(t.id))return this.k(t,null,[],null);const n=this.a.getExtensionDescription(t.id);if(!n){const h=new Error(`Cannot activate unknown extension '${t.id.value}'`),i=this.k(t,null,[],new $(h));return this.c.onExtensionActivationError(t.id,h,new M.$OF(t.id.value)),i}const o=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){o.push(i);continue}if(this.l(h)){o.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:t.reason}));continue}const r=this.a.getExtensionDescription(h);if(r){if(!r.main&&!r.browser)continue;o.push(this.j({id:r.identifier,reason:t.reason}));continue}const u=n.displayName||n.identifier.value,d=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${h}'`),v=this.k(t,n.displayName,[],new $(d));return this.c.onExtensionActivationError(n.identifier,d,new M.$OF(h)),v}return this.k(t,n.displayName,o,null)}k(t,n,o,c){const h=new a(t.id,n,t.reason,o,c,this.c,this.g);return this.d.set(t.id,h),h}l(t){return T.$I6b.isHostExtension(t,this.a,this.b)}m(t){const n=this.b.getExtensionDescription(t);return n?!n.main&&!n.browser:!1}};e.$efc=b,e.$efc=b=He([We(3,A.$hj)],b);let a=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(t,n,o,c,h,i,r){this.c=t,this.d=n,this.f=o,this.g=c,this.h=h,this.j=i,this.k=r,this.a=new m.$Yg,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let t=0;t<this.g.length;t++){const n=this.g[t];if(n.value&&!n.value.activationFailed){this.g.splice(t,1),t--;continue}if(n.value&&n.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);o.detail=n.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(t=>t.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(t){const n=new Error;if(t&&t.name&&(n.name=t.name),t&&t.message?n.message=`Activating extension '${this.c.value}' failed: ${t.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${t}.`,t&&t.stack&&(n.stack=t.stack),this.h=new $(n),this.b&&E.$3(t))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(t)}}};a=He([We(6,A.$hj)],a)}),define(Pe[8],Re([1,0,18,24,126,218,52,28,120,51,68,26,16,2,29,80,99,104,102,76,48,58,215,7,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$GM=e.$FM=e.MarkdownString=e.$EM=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var d;(function(De){function Le(H){const{selectionStartLineNumber:Me,selectionStartColumn:je,positionLineNumber:Ze,positionColumn:Ve}=H,tt=new r.$HK(Me-1,je-1),mt=new r.$HK(Ze-1,Ve-1);return new r.$JK(tt,mt)}De.to=Le;function $e(H){const{anchor:Me,active:je}=H;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:je.line+1,positionColumn:je.character+1}}De.from=$e})(d||(e.Selection=d={}));var v;(function(De){function Le(H){if(!H)return;const{start:Me,end:je}=H;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:je.line+1,endColumn:je.character+1}}De.from=Le;function $e(H){if(!H)return;const{startLineNumber:Me,startColumn:je,endLineNumber:Ze,endColumn:Ve}=H;return new r.$IK(Me-1,je-1,Ze-1,Ve-1)}De.to=$e})(v||(e.Range=v={}));var f;(function(De){function Le($e){switch($e){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}De.to=Le})(f||(e.TokenType=f={}));var k;(function(De){function Le(H){return new r.$HK(H.lineNumber-1,H.column-1)}De.to=Le;function $e(H){return{lineNumber:H.line+1,column:H.character+1}}De.from=$e})(k||(e.Position=k={}));var L;(function(De){function Le(Me,je,Ze){return(0,E.$Gb)((0,E.$2b)(Me).map(Ve=>$e(Ve,je,Ze)))}De.from=Le;function $e(Me,je,Ze){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ze?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:H(Me.scheme,je),pattern:Z.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ze?.isBuiltin}}function H(Me,je){return je&&typeof Me=="string"?je.transformOutgoingScheme(Me):Me}})(L||(e.DocumentSelector=L={}));var p;(function(De){function Le(H){switch(H){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}De.from=Le;function $e(H){switch(H){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}De.to=$e})(p||(e.DiagnosticTag=p={}));var y;(function(De){function Le(H){let Me;return H.code&&((0,l.$Cf)(H.code)||(0,l.$Gf)(H.code)?Me=String(H.code):Me={value:String(H.code.value),target:H.code.target}),{...v.from(H.range),message:H.message,source:H.source,code:Me,severity:N.from(H.severity),relatedInformation:H.relatedInformation&&H.relatedInformation.map(D.from),tags:Array.isArray(H.tags)?(0,E.$Gb)(H.tags.map(p.from)):void 0}}De.from=Le;function $e(H){const Me=new r.$UK(v.to(H),H.message,N.to(H.severity));return Me.source=H.source,Me.code=(0,l.$Cf)(H.code)?H.code:H.code?.value,Me.relatedInformation=H.relatedInformation&&H.relatedInformation.map(D.to),Me.tags=H.tags&&(0,E.$Gb)(H.tags.map(p.to)),Me}De.to=$e})(y||(e.Diagnostic=y={}));var D;(function(De){function Le(H){return{...v.from(H.location.range),message:H.message,resource:H.location.uri}}De.from=Le;function $e(H){return new r.$TK(new r.$SK(H.resource,v.to(H)),H.message)}De.to=$e})(D||(e.DiagnosticRelatedInformation=D={}));var N;(function(De){function Le(H){switch(H){case r.DiagnosticSeverity.Error:return s.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return s.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return s.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return s.MarkerSeverity.Hint}return s.MarkerSeverity.Error}De.from=Le;function $e(H){switch(H){case s.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case s.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case s.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case s.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}De.to=$e})(N||(e.DiagnosticSeverity=N={}));var q;(function(De){function Le(H){return typeof H=="number"&&H>=r.ViewColumn.One?H-1:H===r.ViewColumn.Beside?i.$SC:i.$RC}De.from=Le;function $e(H){if(typeof H=="number"&&H>=0)return H+1;throw new Error("invalid 'EditorGroupColumn'")}De.to=$e})(q||(e.ViewColumn=q={}));function V(De){return typeof De.range<"u"}function U(De){return De.length===0?!0:!!V(De[0])}e.$EM=U;var F;(function(De){function Le(Ve){return Ve.map(De.from)}De.fromMany=Le;function $e(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function H(Ve){let tt;if($e(Ve)){const{language:bt,value:Nt}=Ve;tt={value:"```"+bt+`
`+Nt+"\n```\n"}}else r.$8K.isMarkdownString(Ve)?tt={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?tt={value:Ve}:tt={value:""};const mt=Object.create(null);tt.uris=mt;const vt=bt=>{try{let Nt=$.URI.parse(bt,!0);Nt=Nt.with({query:Me(Nt.query,mt)}),mt[bt]=Nt}catch{}return""},Lt=new g.marked.Renderer;return Lt.link=vt,Lt.image=bt=>typeof bt=="string"?vt(A.$hk(bt).href):"",(0,g.marked)(tt.value,{renderer:Lt}),tt}De.from=H;function Me(Ve,tt){if(!Ve)return Ve;let mt;try{mt=(0,w.$vh)(Ve)}catch{}if(!mt)return Ve;let vt=!1;return mt=(0,S.$gn)(mt,Lt=>{if($.URI.isUri(Lt)){const bt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[bt]=Lt,vt=!0,bt}else return}),vt?JSON.stringify(mt):Ve}function je(Ve){const tt=new r.$8K(Ve.value,Ve.supportThemeIcons);return tt.isTrusted=Ve.isTrusted,tt.supportHtml=Ve.supportHtml,tt.baseUri=Ve.baseUri?$.URI.from(Ve.baseUri):void 0,tt}De.to=je;function Ze(Ve){if(Ve)return typeof Ve=="string"?Ve:De.from(Ve)}De.fromStrict=Ze})(F||(e.MarkdownString=F={}));function C(De){return U(De)?De.map(Le=>({range:v.from(Le.range),hoverMessage:Array.isArray(Le.hoverMessage)?F.fromMany(Le.hoverMessage):Le.hoverMessage?F.from(Le.hoverMessage):void 0,renderOptions:Le.renderOptions})):De.map(Le=>({range:v.from(Le)}))}e.$FM=C;function I(De){return typeof De>"u"?De:typeof De=="string"?$.URI.file(De):De}e.$GM=I;var X;(function(De){function Le($e){return typeof $e>"u"?$e:{contentText:$e.contentText,contentIconPath:$e.contentIconPath?I($e.contentIconPath):void 0,border:$e.border,borderColor:$e.borderColor,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,color:$e.color,backgroundColor:$e.backgroundColor,margin:$e.margin,width:$e.width,height:$e.height}}De.from=Le})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var ue;(function(De){function Le($e){return typeof $e>"u"?$e:{backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?I($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?X.from($e.before):void 0,after:$e.after?X.from($e.after):void 0}}De.from=Le})(ue||(e.ThemableDecorationRenderOptions=ue={}));var he;(function(De){function Le($e){if(typeof $e>"u")return $e;switch($e){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}De.from=Le})(he||(e.DecorationRangeBehavior=he={}));var be;(function(De){function Le($e){return{isWholeLine:$e.isWholeLine,rangeBehavior:$e.rangeBehavior?he.from($e.rangeBehavior):void 0,overviewRulerLane:$e.overviewRulerLane,light:$e.light?ue.from($e.light):void 0,dark:$e.dark?ue.from($e.dark):void 0,backgroundColor:$e.backgroundColor,outline:$e.outline,outlineColor:$e.outlineColor,outlineStyle:$e.outlineStyle,outlineWidth:$e.outlineWidth,border:$e.border,borderColor:$e.borderColor,borderRadius:$e.borderRadius,borderSpacing:$e.borderSpacing,borderStyle:$e.borderStyle,borderWidth:$e.borderWidth,fontStyle:$e.fontStyle,fontWeight:$e.fontWeight,textDecoration:$e.textDecoration,cursor:$e.cursor,color:$e.color,opacity:$e.opacity,letterSpacing:$e.letterSpacing,gutterIconPath:$e.gutterIconPath?I($e.gutterIconPath):void 0,gutterIconSize:$e.gutterIconSize,overviewRulerColor:$e.overviewRulerColor,before:$e.before?X.from($e.before):void 0,after:$e.after?X.from($e.after):void 0}}De.from=Le})(be||(e.DecorationRenderOptions=be={}));var we;(function(De){function Le(H){return{text:H.newText,eol:H.newEol&&_e.from(H.newEol),range:v.from(H.range)}}De.from=Le;function $e(H){const Me=new r.$NK(v.to(H.range),H.text);return Me.newEol=typeof H.eol>"u"?void 0:_e.to(H.eol),Me}De.to=$e})(we||(e.TextEdit=we={}));var ge;(function(De){function Le(H,Me){const je={edits:[]};if(H instanceof r.$QK){const Ze=new m.$Ac;for(const Ve of H._allEntries())Ve._type===1&&$.URI.isUri(Ve.to)&&Ve.from===void 0&&Ze.add(Ve.to);for(const Ve of H._allEntries())if(Ve._type===1){let tt;Ve.options?.contents&&(ArrayBuffer.isView(Ve.options.contents)?tt={type:"base64",value:(0,T.$ze)(T.$fe.wrap(Ve.options.contents))}:tt={type:"dataTransferItem",id:Ve.options.contents._itemId}),je.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contents:tt},metadata:Ve.metadata})}else Ve._type===2?je.edits.push({resource:Ve.uri,textEdit:we.from(Ve.edit),versionId:Ze.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?je.edits.push({resource:Ve.uri,textEdit:{range:v.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ze.has(Ve.uri)?void 0:Me?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?je.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&je.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(Pt.from)}})}return je}De.from=Le;function $e(H){const Me=new r.$QK,je=new m.$zc;for(const Ze of H.edits)if(Ze.textEdit){const Ve=Ze,tt=$.URI.revive(Ve.resource),mt=v.to(Ve.textEdit.range),vt=Ve.textEdit.text,Lt=Ve.textEdit.insertAsSnippet;let bt;Lt?bt=r.$PK.replace(mt,new r.$RK(vt)):bt=r.$NK.replace(mt,vt);const Nt=je.get(tt);Nt?Nt.push(bt):je.set(tt,[bt])}else Me.renameFile($.URI.revive(Ze.oldResource),$.URI.revive(Ze.newResource),Ze.options);for(const[Ze,Ve]of je)Me.set(Ze,Ve);return Me}De.to=$e})(ge||(e.WorkspaceEdit=ge={}));var me;(function(De){const Le=Object.create(null);Le[r.SymbolKind.File]=0,Le[r.SymbolKind.Module]=1,Le[r.SymbolKind.Namespace]=2,Le[r.SymbolKind.Package]=3,Le[r.SymbolKind.Class]=4,Le[r.SymbolKind.Method]=5,Le[r.SymbolKind.Property]=6,Le[r.SymbolKind.Field]=7,Le[r.SymbolKind.Constructor]=8,Le[r.SymbolKind.Enum]=9,Le[r.SymbolKind.Interface]=10,Le[r.SymbolKind.Function]=11,Le[r.SymbolKind.Variable]=12,Le[r.SymbolKind.Constant]=13,Le[r.SymbolKind.String]=14,Le[r.SymbolKind.Number]=15,Le[r.SymbolKind.Boolean]=16,Le[r.SymbolKind.Array]=17,Le[r.SymbolKind.Object]=18,Le[r.SymbolKind.Key]=19,Le[r.SymbolKind.Null]=20,Le[r.SymbolKind.EnumMember]=21,Le[r.SymbolKind.Struct]=22,Le[r.SymbolKind.Event]=23,Le[r.SymbolKind.Operator]=24,Le[r.SymbolKind.TypeParameter]=25;function $e(Me){return typeof Le[Me]=="number"?Le[Me]:6}De.from=$e;function H(Me){for(const je in Le)if(Le[je]===Me)return Number(je);return r.SymbolKind.Property}De.to=H})(me||(e.SymbolKind=me={}));var ne;(function(De){function Le(H){switch(H){case r.SymbolTag.Deprecated:return 1}}De.from=Le;function $e(H){switch(H){case 1:return r.SymbolTag.Deprecated}}De.to=$e})(ne||(e.SymbolTag=ne={}));var ke;(function(De){function Le(H){return{name:H.name,kind:me.from(H.kind),tags:H.tags&&H.tags.map(ne.from),containerName:H.containerName,location:Ie.from(H.location)}}De.from=Le;function $e(H){const Me=new r.$YK(H.name,me.to(H.kind),H.containerName,Ie.to(H.location));return Me.tags=H.tags&&H.tags.map(ne.to),Me}De.to=$e})(ke||(e.WorkspaceSymbol=ke={}));var ce;(function(De){function Le(H){const Me={name:H.name||"!!MISSING: name!!",detail:H.detail,range:v.from(H.range),selectionRange:v.from(H.selectionRange),kind:me.from(H.kind),tags:H.tags?.map(ne.from)??[]};return H.children&&(Me.children=H.children.map(Le)),Me}De.from=Le;function $e(H){const Me=new r.$ZK(H.name,H.detail,me.to(H.kind),v.to(H.range),v.to(H.selectionRange));return(0,E.$Kb)(H.tags)&&(Me.tags=H.tags.map(ne.to)),H.children&&(Me.children=H.children.map($e)),Me}De.to=$e})(ce||(e.DocumentSymbol=ce={}));var Y;(function(De){function Le(H){const Me=new r.$4K(me.to(H.kind),H.name,H.detail||"",$.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}De.to=Le;function $e(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,name:H.name,detail:H.detail,kind:me.from(H.kind),uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(ne.from)}}De.from=$e})(Y||(e.CallHierarchyItem=Y={}));var W;(function(De){function Le($e){return new r.$5K(Y.to($e.from),$e.fromRanges.map(H=>v.to(H)))}De.to=Le})(W||(e.CallHierarchyIncomingCall=W={}));var re;(function(De){function Le($e){return new r.$6K(Y.to($e.to),$e.fromRanges.map(H=>v.to(H)))}De.to=Le})(re||(e.CallHierarchyOutgoingCall=re={}));var Ie;(function(De){function Le(H){return{range:H.range&&v.from(H.range),uri:H.uri}}De.from=Le;function $e(H){return new r.$SK($.URI.revive(H.uri),v.to(H.range))}De.to=$e})(Ie||(e.location=Ie={}));var Ae;(function(De){function Le(H){const Me=H,je=H;return{originSelectionRange:Me.originSelectionRange?v.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:je.uri,range:v.from(Me.targetRange?Me.targetRange:je.range),targetSelectionRange:Me.targetSelectionRange?v.from(Me.targetSelectionRange):void 0}}De.from=Le;function $e(H){return{targetUri:$.URI.revive(H.uri),targetRange:v.to(H.range),targetSelectionRange:H.targetSelectionRange?v.to(H.targetSelectionRange):void 0,originSelectionRange:H.originSelectionRange?v.to(H.originSelectionRange):void 0}}De.to=$e})(Ae||(e.DefinitionLink=Ae={}));var Ce;(function(De){function Le(H){return{range:v.from(H.range),contents:F.fromMany(H.contents)}}De.from=Le;function $e(H){return new r.$VK(H.contents.map(F.to),v.to(H.range))}De.to=$e})(Ce||(e.Hover=Ce={}));var le;(function(De){function Le(H){return{range:v.from(H.range),expression:H.expression}}De.from=Le;function $e(H){return new r.$PL(v.to(H.range),H.expression)}De.to=$e})(le||(e.EvaluatableExpression=le={}));var ie;(function(De){function Le(H){if(H instanceof r.$QL)return{type:"text",range:v.from(H.range),text:H.text};if(H instanceof r.$RL)return{type:"variable",range:v.from(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};if(H instanceof r.$SL)return{type:"expression",range:v.from(H.range),expression:H.expression};throw new Error("Unknown 'InlineValue' type")}De.from=Le;function $e(H){switch(H.type){case"text":return{range:v.to(H.range),text:H.text};case"variable":return{range:v.to(H.range),variableName:H.variableName,caseSensitiveLookup:H.caseSensitiveLookup};case"expression":return{range:v.to(H.range),expression:H.expression}}}De.to=$e})(ie||(e.InlineValue=ie={}));var G;(function(De){function Le(H){return{frameId:H.frameId,stoppedLocation:v.from(H.stoppedLocation)}}De.from=Le;function $e(H){return new r.$TL(H.frameId,v.to(H.stoppedLocation))}De.to=$e})(G||(e.InlineValueContext=G={}));var te;(function(De){function Le(H){return{range:v.from(H.range),kind:H.kind}}De.from=Le;function $e(H){return new r.$WK(v.to(H.range),H.kind)}De.to=$e})(te||(e.DocumentHighlight=te={}));var x;(function(De){function Le(H){return{uri:H.uri,highlights:H.highlights.map(te.from)}}De.from=Le;function $e(H){return new r.$XK($.URI.revive(H.uri),H.highlights.map(te.to))}De.to=$e})(x||(e.MultiDocumentHighlight=x={}));var se;(function(De){function Le($e){switch($e){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}De.to=Le})(se||(e.CompletionTriggerKind=se={}));var fe;(function(De){function Le($e){return{triggerKind:se.to($e.triggerKind),triggerCharacter:$e.triggerCharacter}}De.to=Le})(fe||(e.CompletionContext=fe={}));var Se;(function(De){function Le(H){switch(H){case r.CompletionItemTag.Deprecated:return 1}}De.from=Le;function $e(H){switch(H){case 1:return r.CompletionItemTag.Deprecated}}De.to=$e})(Se||(e.CompletionItemTag=Se={}));var Fe;(function(De){const Le=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function $e(je){return Le.get(je)??9}De.from=$e;const H=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Me(je){return H.get(je)??r.CompletionItemKind.Property}De.to=Me})(Fe||(e.CompletionItemKind=Fe={}));var O;(function(De){function Le($e,H){const Me=new r.$bL($e.label);return Me.insertText=$e.insertText,Me.kind=Fe.to($e.kind),Me.tags=$e.tags?.map(Se.to),Me.detail=$e.detail,Me.documentation=A.$ck($e.documentation)?F.to($e.documentation):$e.documentation,Me.sortText=$e.sortText,Me.filterText=$e.filterText,Me.preselect=$e.preselect,Me.commitCharacters=$e.commitCharacters,b.$Ds.isIRange($e.range)?Me.range=v.to($e.range):typeof $e.range=="object"&&(Me.range={inserting:v.to($e.range.insert),replacing:v.to($e.range.replace)}),Me.keepWhitespace=typeof $e.insertTextRules>"u"?!1:!!($e.insertTextRules&1),typeof $e.insertTextRules<"u"&&$e.insertTextRules&4?Me.insertText=new r.$RK($e.insertText):(Me.insertText=$e.insertText,Me.textEdit=Me.range instanceof r.$IK?new r.$NK(Me.range,Me.insertText):void 0),$e.additionalTextEdits&&$e.additionalTextEdits.length>0&&(Me.additionalTextEdits=$e.additionalTextEdits.map(je=>we.to(je))),Me.command=H&&$e.command?H.fromInternal($e.command):void 0,Me}De.to=Le})(O||(e.CompletionItem=O={}));var K;(function(De){function Le(H){if(typeof H.label!="string"&&!Array.isArray(H.label))throw new TypeError("Invalid label");return{label:H.label,documentation:F.fromStrict(H.documentation)}}De.from=Le;function $e(H){return{label:H.label,documentation:A.$ck(H.documentation)?F.to(H.documentation):H.documentation}}De.to=$e})(K||(e.ParameterInformation=K={}));var J;(function(De){function Le(H){return{label:H.label,documentation:F.fromStrict(H.documentation),parameters:Array.isArray(H.parameters)?H.parameters.map(K.from):[],activeParameter:H.activeParameter}}De.from=Le;function $e(H){return{label:H.label,documentation:A.$ck(H.documentation)?F.to(H.documentation):H.documentation,parameters:Array.isArray(H.parameters)?H.parameters.map(K.to):[],activeParameter:H.activeParameter}}De.to=$e})(J||(e.SignatureInformation=J={}));var B;(function(De){function Le(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(J.from):[]}}De.from=Le;function $e(H){return{activeSignature:H.activeSignature,activeParameter:H.activeParameter,signatures:Array.isArray(H.signatures)?H.signatures.map(J.to):[]}}De.to=$e})(B||(e.SignatureHelp=B={}));var Q;(function(De){function Le($e,H){const Me=new r.$aL(k.to(H.position),typeof H.label=="string"?H.label:H.label.map(_.to.bind(void 0,$e)),H.kind&&Ee.to(H.kind));return Me.textEdits=H.textEdits&&H.textEdits.map(we.to),Me.tooltip=A.$ck(H.tooltip)?F.to(H.tooltip):H.tooltip,Me.paddingLeft=H.paddingLeft,Me.paddingRight=H.paddingRight,Me}De.to=Le})(Q||(e.InlayHint=Q={}));var _;(function(De){function Le($e,H){const Me=new r.$_K(H.label);return Me.tooltip=A.$ck(H.tooltip)?F.to(H.tooltip):H.tooltip,a.Command.is(H.command)&&(Me.command=$e.fromInternal(H.command)),H.location&&(Me.location=Ie.to(H.location)),Me}De.to=Le})(_||(e.InlayHintLabelPart=_={}));var Ee;(function(De){function Le(H){return H}De.from=Le;function $e(H){return H}De.to=$e})(Ee||(e.InlayHintKind=Ee={}));var ze;(function(De){function Le(H){return{range:v.from(H.range),url:H.target,tooltip:H.tooltip}}De.from=Le;function $e(H){let Me;if(H.url)try{Me=typeof H.url=="string"?$.URI.parse(H.url,!0):$.URI.revive(H.url)}catch{}return new r.$gL(v.to(H.range),Me)}De.to=$e})(ze||(e.DocumentLink=ze={}));var Qe;(function(De){function Le(H){const Me=new r.$jL(H.label);return H.textEdit&&(Me.textEdit=we.to(H.textEdit)),H.additionalTextEdits&&(Me.additionalTextEdits=H.additionalTextEdits.map(je=>we.to(je))),Me}De.to=Le;function $e(H){return{label:H.label,textEdit:H.textEdit?we.from(H.textEdit):void 0,additionalTextEdits:H.additionalTextEdits?H.additionalTextEdits.map(Me=>we.from(Me)):void 0}}De.from=$e})(Qe||(e.ColorPresentation=Qe={}));var Je;(function(De){function Le(H){return new r.$hL(H[0],H[1],H[2],H[3])}De.to=Le;function $e(H){return[H.red,H.green,H.blue,H.alpha]}De.from=$e})(Je||(e.Color=Je={}));var Ye;(function(De){function Le(H){return{range:v.from(H.range)}}De.from=Le;function $e(H){return new r.$3K(v.to(H.range))}De.to=$e})(Ye||(e.SelectionRange=Ye={}));var it;(function(De){function Le($e){switch($e){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}De.to=Le})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(De){function Le(H){switch(H){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}De.from=Le;function $e(H){switch(H){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}De.to=$e})(nt||(e.TextEditorLineNumbersStyle=nt={}));var _e;(function(De){function Le(H){if(H===r.EndOfLine.CRLF)return 1;if(H===r.EndOfLine.LF)return 0}De.from=Le;function $e(H){if(H===1)return r.EndOfLine.CRLF;if(H===0)return r.EndOfLine.LF}De.to=$e})(_e||(e.EndOfLine=_e={}));var rt;(function(De){function Le($e){if(typeof $e=="object")return $e.viewId;switch($e){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}De.from=Le})(rt||(e.ProgressLocation=rt={}));var Ue;(function(De){function Le(H){const Me={start:H.start+1,end:H.end+1};return H.kind&&(Me.kind=ct.from(H.kind)),Me}De.from=Le;function $e(H){const Me={start:H.start-1,end:H.end-1};return H.kind&&(Me.kind=ct.to(H.kind)),Me}De.to=$e})(Ue||(e.FoldingRange=Ue={}));var ct;(function(De){function Le(H){if(H)switch(H){case r.FoldingRangeKind.Comment:return a.$tt.Comment;case r.FoldingRangeKind.Imports:return a.$tt.Imports;case r.FoldingRangeKind.Region:return a.$tt.Region}}De.from=Le;function $e(H){if(H)switch(H.value){case a.$tt.Comment.value:return r.FoldingRangeKind.Comment;case a.$tt.Imports.value:return r.FoldingRangeKind.Imports;case a.$tt.Region.value:return r.FoldingRangeKind.Region}}De.to=$e})(ct||(e.FoldingRangeKind=ct={}));var ee;(function(De){function Le($e){if($e)return{pinned:typeof $e.preview=="boolean"?!$e.preview:void 0,inactive:$e.background,preserveFocus:$e.preserveFocus,selection:typeof $e.selection=="object"?v.from($e.selection):void 0,override:typeof $e.override=="boolean"?n.$hE.id:void 0}}De.from=Le})(ee||(e.TextEditorOpenOptions=ee={}));var Z;(function(De){function Le(je){return je instanceof r.$DL?je.toJSON():typeof je=="string"?je:$e(je)||H(je)?new r.$DL(je.baseUri??je.base,je.pattern).toJSON():je}De.from=Le;function $e(je){const Ze=je;return Ze?$.URI.isUri(Ze.baseUri)&&typeof Ze.pattern=="string":!1}function H(je){const Ze=je;return Ze?typeof Ze.base=="string"&&typeof Ze.pattern=="string":!1}function Me(je){return typeof je=="string"?je:new r.$DL($.URI.revive(je.baseUri),je.pattern)}De.to=Me})(Z||(e.GlobPattern=Z={}));var ve;(function(De){function Le($e){if($e){if(Array.isArray($e))return $e.map(Le);if(typeof $e=="string")return $e;{const H=$e;return{language:H.language,scheme:H.scheme,pattern:Z.from(H.pattern),exclusive:H.exclusive,notebookType:H.notebookType}}}else return}De.from=Le})(ve||(e.LanguageSelector=ve={}));var Be;(function(De){function Le(H){return!!H&&typeof H=="object"&&"documents"in H&&Array.isArray(H.documents)&&H.documents.every(Me=>Array.isArray(Me)&&Me.every(je=>je&&typeof je=="object"&&"uri"in je&&$.URI.isUri(je.uri)&&"version"in je&&typeof je.version=="number"&&"ranges"in je&&Array.isArray(je.ranges)&&je.ranges.every(Ze=>Ze instanceof r.$IK)))}De.is=Le;function $e(H){return{documents:H.documents.map(Me=>Me.map(je=>({uri:$.URI.from(je.uri),version:je.version,ranges:je.ranges.map(Ze=>v.from(Ze))})))}}De.from=$e})(Be||(e.MappedEditsContext=Be={}));var Ke;(function(De){function Le(H){return{start:H.start,end:H.end}}De.from=Le;function $e(H){return new r.$5L(H.start,H.end)}De.to=$e})(Ke||(e.NotebookRange=Ke={}));var xe;(function(De){function Le(H){return{timing:typeof H.runStartTime=="number"&&typeof H.runEndTime=="number"?{startTime:H.runStartTime,endTime:H.runEndTime}:void 0,executionOrder:H.executionOrder,success:H.lastRunSuccess}}De.to=Le;function $e(H){return{lastRunSuccess:H.success,runStartTime:H.timing?.startTime,runEndTime:H.timing?.endTime,executionOrder:H.executionOrder}}De.from=$e})(xe||(e.NotebookCellExecutionSummary=xe={}));var ot;(function(De){function Le($e){if($e===o.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if($e===o.NotebookCellExecutionState.Pending)return;if($e===o.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${$e}`)}De.to=Le})(ot||(e.NotebookCellExecutionState=ot={}));var pt;(function(De){function Le(H){switch(H){case r.NotebookCellKind.Markup:return o.CellKind.Markup;case r.NotebookCellKind.Code:default:return o.CellKind.Code}}De.from=Le;function $e(H){switch(H){case o.CellKind.Markup:return r.NotebookCellKind.Markup;case o.CellKind.Code:default:return r.NotebookCellKind.Code}}De.to=$e})(pt||(e.NotebookCellKind=pt={}));var Ne;(function(De){function Le(H){const Me={metadata:H.metadata??Object.create(null),cells:[]};for(const je of H.cells)r.$6L.validate(je),Me.cells.push(Pt.from(je));return Me}De.from=Le;function $e(H){const Me=new r.$7L(H.cells.map(Pt.to));return(0,l.$Pf)(H.metadata)||(Me.metadata=H.metadata),Me}De.to=$e})(Ne||(e.NotebookData=Ne={}));var Pt;(function(De){function Le(H){return{cellKind:pt.from(H.kind),language:H.languageId,mime:H.mime,source:H.value,metadata:H.metadata,internalMetadata:xe.from(H.executionSummary??{}),outputs:H.outputs?H.outputs.map(zt.from):[]}}De.from=Le;function $e(H){return new r.$6L(pt.to(H.cellKind),H.source,H.language,H.mime,H.outputs?H.outputs.map(zt.to):void 0,H.metadata,H.internalMetadata?xe.to(H.internalMetadata):void 0)}De.to=$e})(Pt||(e.NotebookCellData=Pt={}));var Kt;(function(De){function Le(H){return{mime:H.mime,valueBytes:T.$fe.wrap(H.data)}}De.from=Le;function $e(H){return new r.$8L(H.valueBytes.buffer,H.mime)}De.to=$e})(Kt||(e.NotebookCellOutputItem=Kt={}));var zt;(function(De){function Le(H){return{outputId:H.id,items:H.items.map(Kt.from),metadata:H.metadata}}De.from=Le;function $e(H){const Me=H.items.map(Kt.to);return new r.$9L(Me,H.outputId,H.metadata)}De.to=$e})(zt||(e.NotebookCellOutput=zt={}));var yt;(function(De){function Le(Me){return H(Me)?{include:Z.from(Me.include)??void 0,exclude:Z.from(Me.exclude)??void 0}:Z.from(Me)??void 0}De.from=Le;function $e(Me){return H(Me)?{include:Z.to(Me.include),exclude:Z.to(Me.exclude)}:Z.to(Me)}De.to=$e;function H(Me){const je=Me;return je?!(0,l.$Lf)(je.include)&&!(0,l.$Lf)(je.exclude):!1}})(yt||(e.NotebookExclusiveDocumentPattern=yt={}));var Wt;(function(De){function Le($e,H,Me){const je=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{alignment:$e.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:H.toInternal(je,Me),text:$e.text,tooltip:$e.tooltip,accessibilityInformation:$e.accessibilityInformation,priority:$e.priority}}De.from=Le})(Wt||(e.NotebookStatusBarItem=Wt={}));var Ut;(function(De){function Le($e,H,Me){const je=typeof $e.command=="string"?{title:"",command:$e.command}:$e.command;return{command:H.toInternal(je,Me),label:$e.label,description:$e.description,detail:$e.detail,documentation:$e.documentation}}De.from=Le})(Ut||(e.NotebookKernelSourceAction=Ut={}));var Ht;(function(De){function Le($e){return{transientOutputs:$e?.transientOutputs??!1,transientCellMetadata:$e?.transientCellMetadata??{},transientDocumentMetadata:$e?.transientDocumentMetadata??{},cellContentMetadata:$e?.cellContentMetadata??{}}}De.from=Le})(Ht||(e.NotebookDocumentContentOptions=Ht={}));var Gt;(function(De){function Le(H){return{uri:H.uri,provides:H.provides}}De.from=Le;function $e(H){return new r.$$L($.URI.revive(H.uri),H.provides)}De.to=$e})(Gt||(e.NotebookRendererScript=Gt={}));var Rt;(function(De){function Le(H){return{message:F.fromStrict(H.message)||"",type:0,expected:H.expectedOutput,actual:H.actualOutput,contextValue:H.contextValue,location:H.location&&{range:v.from(H.location.range),uri:H.location.uri}}}De.from=Le;function $e(H){const Me=new r.$eM(typeof H.message=="string"?H.message:F.to(H.message));return Me.actualOutput=H.actual,Me.expectedOutput=H.expected,Me.contextValue=H.contextValue,Me.location=H.location?Ie.to(H.location):void 0,Me}De.to=$e})(Rt||(e.TestMessage=Rt={}));var St;(function(De){De.namespace=h.$AJ,De.denamespace=h.$BJ})(St||(e.TestTag=St={}));var Xe;(function(De){function Le(H){const Me=(0,t.$DM)(H).controllerId;return{extId:c.$wJ.fromExtHostTestItem(H,Me).toString(),label:H.label,uri:$.URI.revive(H.uri),busy:H.busy,tags:H.tags.map(je=>St.namespace(Me,je.id)),range:b.$Ds.lift(v.from(H.range)),description:H.description||null,sortText:H.sortText||null,error:H.error&&F.fromStrict(H.error)||null}}De.from=Le;function $e(H){return{parent:void 0,error:void 0,id:c.$wJ.fromString(H.extId).localId,label:H.label,uri:$.URI.revive(H.uri),tags:(H.tags||[]).map(Me=>{const{tagId:je}=St.denamespace(Me);return new r.$fM(je)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:v.to(H.range||void 0),canResolveChildren:!1,busy:H.busy,description:H.description||void 0,sortText:H.sortText||void 0}}De.toPlain=$e})(Xe||(e.TestItem=Xe={})),function(De){function Le(H){return{id:H.id}}De.from=Le;function $e(H){return new r.$fM(H.id)}De.to=$e}(St||(e.TestTag=St={}));var Jt;(function(De){const Le=(H,Me)=>{const je=[];for(const[Ve,tt]of Me)c.$wJ.compare(tt.item.extId,Ve)===2&&(Me.delete(Ve),je.push(tt));const Ze={...Xe.toPlain(H.item),parent:void 0,taskStates:H.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(tt=>tt.type===0).map(Rt.to)})),children:je.map(Ve=>Le(Ve,Me))};for(const Ve of Ze.children)Ve.parent=Ze;return Ze};function $e(H){const Me=[],je=new Map;for(const Ze of H.items){je.set(Ze.item.extId,Ze);const Ve=c.$wJ.root(Ze.item.extId);H.request.targets.some(tt=>tt.controllerId===Ve&&tt.testIds.includes(Ze.item.extId))&&Me.push(Ze)}return{completedAt:H.completedAt,results:Me.map(Ze=>Le(Ze,je))}}De.to=$e})(Jt||(e.TestResults=Jt={}));var Vt;(function(De){function Le(je){return{covered:je.covered,total:je.total}}function $e(je){return"line"in je?k.from(je):v.from(je)}function H(je){return"branches"in je?{count:je.executionCount,location:$e(je.location),type:1,branches:je.branches.length?je.branches.map(Ze=>({count:Ze.executionCount,location:Ze.location&&$e(Ze.location)})):void 0}:{type:0,name:je.name,count:je.executionCount,location:$e(je.location)}}De.fromDetailed=H;function Me(je){return{uri:je.uri,statement:Le(je.statementCoverage),branch:je.branchCoverage&&Le(je.branchCoverage),function:je.functionCoverage&&Le(je.functionCoverage),details:je.detailedCoverage?.map(H)}}De.fromFile=Me})(Vt||(e.TestCoverage=Vt={}));var ut;(function(De){function Le($e){switch($e){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}De.to=Le})(ut||(e.CodeActionTriggerKind=ut={}));var gt;(function(De){function Le(H){const Me=new r.$lM(me.to(H.kind),H.name,H.detail||"",$.URI.revive(H.uri),v.to(H.range),v.to(H.selectionRange));return Me._sessionId=H._sessionId,Me._itemId=H._itemId,Me}De.to=Le;function $e(H,Me,je){if(Me=Me??H._sessionId,je=je??H._itemId,Me===void 0||je===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:je,kind:me.from(H.kind),name:H.name,detail:H.detail??"",uri:H.uri,range:v.from(H.range),selectionRange:v.from(H.selectionRange),tags:H.tags?.map(ne.from)}}De.from=$e})(gt||(e.TypeHierarchyItem=gt={}));var Zt;(function(De){function Le($e){if($e)return{value:$e.value,tooltip:$e.tooltip}}De.from=Le})(Zt||(e.ViewBadge=Zt={}));var It;(function(De){function Le(je,Ze,Ve){const tt=Ze.fileData;return tt?new r.$wL(new r.$xL(tt.name,$.URI.revive(tt.uri),tt.id,(0,M.$cb)(()=>Ve(tt.id)))):je===R.$Zr.uriList&&Ze.uriListData?new r.$vL(Me(Ze.uriListData)):new r.$vL(Ze.asString)}De.to=Le;async function $e(je,Ze){const Ve=await Ze.asString();if(je===R.$Zr.uriList)return{asString:Ve,fileData:void 0,uriListData:H(Ve)};const tt=Ze.asFile();return{asString:Ve,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}De.from=$e;function H(je){return P.$at.split(je).map(Ze=>{if(Ze.startsWith("#"))return Ze;try{return $.URI.parse(Ze)}catch{}return Ze})}function Me(je){return P.$at.create(je.map(Ze=>typeof Ze=="string"?Ze:$.URI.revive(Ze)))}})(It||(e.DataTransferItem=It={}));var Dt;(function(De){function Le(H,Me){const je=H.items.map(([Ze,Ve])=>[Ze,It.to(Ze,Ve,Me)]);return new r.$yL(je)}De.toDataTransfer=Le;async function $e(H){const Me={items:[]},je=[];for(const[Ze,Ve]of H)je.push((async()=>{Me.items.push([Ze,await It.from(Ze,Ve)])})());return await Promise.all(je),Me}De.from=$e})(Dt||(e.DataTransfer=Dt={}));var dt;(function(De){function Le($e){return{kind:"reply",message:$e.message,title:$e.title,tooltip:$e.tooltip}}De.from=Le})(dt||(e.ChatReplyFollowup=dt={}));var At;(function(De){function Le($e){return typeof $e=="string"?{title:$e,message:$e,kind:"reply"}:"commandId"in $e?{kind:"command",title:$e.title??"",commandId:$e.commandId??"",when:$e.when??"",args:$e.args}:dt.from($e)}De.from=Le})(At||(e.ChatFollowup=At={}));var Ot;(function(De){function Le(H){const Me=new r.$wM(Et.to(H.role),H.content);return Me.name=H.name,Me}De.to=Le;function $e(H){return{role:Et.from(H.role),content:H.content,name:H.name}}De.from=$e})(Ot||(e.ChatMessage=Ot={}));var Et;(function(De){function Le(H){switch(H){case 0:return r.ChatMessageRole.System;case 1:return r.ChatMessageRole.User;case 2:return r.ChatMessageRole.Assistant;case 3:return r.ChatMessageRole.Function}}De.to=Le;function $e(H){switch(H){case r.ChatMessageRole.System:return 0;case r.ChatMessageRole.Assistant:return 2;case r.ChatMessageRole.Function:return 3;case r.ChatMessageRole.User:default:return 1}}De.from=$e})(Et||(e.ChatMessageRole=Et={}));var qe;(function(De){function Le(Me){const je={};for(const Ze of Object.keys(Me))je[Ze]=Me[Ze].map(De.to);return je}De.objectTo=Le;function $e(Me){return{level:Mt.to(Me.level),value:Me.value,description:Me.description}}De.to=$e;function H(Me){return{level:Mt.from(Me.level),value:Me.value,description:Me.description}}De.from=H})(qe||(e.ChatVariable=qe={}));var Mt;(function(De){function Le(H){switch(H){case"short":return r.ChatVariableLevel.Short;case"medium":return r.ChatVariableLevel.Medium;case"full":default:return r.ChatVariableLevel.Full}}De.to=Le;function $e(H){switch(H){case r.ChatVariableLevel.Short:return"short";case r.ChatVariableLevel.Medium:return"medium";case r.ChatVariableLevel.Full:default:return"full"}}De.from=$e})(Mt||(e.ChatVariableLevel=Mt={}));var jt;(function(De){function Le($e){switch($e){case 1:return r.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return r.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return r.InteractiveEditorResponseFeedbackKind.Undone;case 3:return r.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return r.InteractiveEditorResponseFeedbackKind.Bug}}De.to=Le})(jt||(e.InteractiveEditorResponseFeedbackKind=jt={}));var Qt;(function(De){function Le($e,H){return"placeholder"in H&&"resolvedContent"in H?{content:H.placeholder,kind:"asyncContent"}:"markdownContent"in H?((0,u.$RF)($e,"chatAgents2Additions"),{content:F.from(H.markdownContent),kind:"markdownContent"}):"content"in H?"vulnerabilities"in H&&H.vulnerabilities?((0,u.$RF)($e,"chatAgents2Additions"),{content:H.content,vulnerabilities:H.vulnerabilities,kind:"vulnerability"}):typeof H.content=="string"?{content:H.content,kind:"content"}:((0,u.$RF)($e,"chatAgents2Additions"),{content:F.from(H.content),kind:"markdownContent"}):"documents"in H?{documents:H.documents.map(Me=>({uri:Me.uri,version:Me.version,ranges:Me.ranges.map(je=>v.from(je))})),kind:"usedContext"}:"reference"in H?{reference:"uri"in H.reference?{uri:H.reference.uri,range:v.from(H.reference.range)}:H.reference,kind:"reference"}:"inlineReference"in H?{inlineReference:"uri"in H.inlineReference?{uri:H.inlineReference.uri,range:v.from(H.inlineReference.range)}:H.inlineReference,name:H.title,kind:"inlineReference"}:"agentName"in H?((0,u.$RF)($e,"chatAgents2Additions"),{agentName:H.agentName,command:H.command,kind:"agentDetection"}):"treeData"in H?{treeData:H.treeData,kind:"treeData"}:"message"in H?{content:H.message,kind:"progressMessage"}:void 0}De.from=Le})(Qt||(e.ChatResponseProgress=Qt={}));var ft;(function(De){function Le($e,H,Me){return"terminalCommand"in $e?{terminalCommand:$e.terminalCommand,shouldExecute:$e.shouldExecute}:"uri"in $e?{uri:$e.uri}:H.toInternal($e,Me)}De.from=Le})(ft||(e.TerminalQuickFix=ft={}))}),define(Pe[219],Re([1,0,2,11,7,8,185]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kfc=void 0;class m{constructor(w,R,S,l={timeout:1500,errors:3}){this.c=w,this.d=R,this.f=S,this.g=l,this.a=new A.$2c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(w){return(R,S,l)=>{const b={dispose:this.a.push([R,S,w])};return Array.isArray(l)&&l.push(b),b}}async $participateInSave(w,R){const S=E.URI.revive(w);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),b=[];try{for(const a of[...this.a]){if(l)break;const s=this.d.getDocument(S),t=await this.h(a,{document:s,reason:M.TextDocumentSaveReason.to(R)});b.push(t)}}finally{clearTimeout($)}return b}h([w,R,S],l){const $=this.b.get(w);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(S,w,R,l).then(()=>!0,b=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' threw ERROR`),this.c.error(b),!(b instanceof Error)||b.message!=="concurrent_edits"){const a=this.b.get(w);this.b.set(w,a?a+1:1),typeof a=="number"&&a>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${S.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(w,R,S,l){const $=[],b=Date.now(),{document:a,reason:s}=l,{version:t}=a,n=Object.freeze({document:a,reason:s,waitUntil(o){if(Object.isFrozen($))throw(0,T.$7)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{R.apply(S,[n])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,c)=>{const h=setTimeout(()=>c(new Error("timeout")),this.g.timeout);return Promise.all($).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' finished after ${Date.now()-b}ms`),clearTimeout(h),o(i)}).catch(i=>{clearTimeout(h),c(i)})}).then(o=>{const c={edits:[]};for(const h of o)if(Array.isArray(h)&&h.every(i=>i instanceof P.$NK))for(const{newText:i,newEol:r,range:u}of h)c.edits.push({resource:a.uri,versionId:void 0,textEdit:{range:u&&M.Range.from(u),text:i,eol:r&&M.EndOfLine.from(r)}});if(c.edits.length!==0)return t===a.version?this.f.$tryApplyWorkspaceEdit(c):Promise.reject(new Error("concurrent_edits"))})}}e.$Kfc=m}),define(Pe[220],Re([1,0,13,2,8,7,76]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qfc=e.$Pfc=void 0;class m{constructor(S,l,$,b){this.start=S,this.deletedCount=l,this.deletedItems=$,this.items=b}asApiEvent(){return{range:new M.$5L(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(S,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:S}}constructor(S,l,$){this.notebook=S,this.h=l,this.j=$,this.handle=$.handle,this.uri=T.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(P.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(P.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:P.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return S.g},set mime(b){S.g=b},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze($)}return this.f}setOutputs(S){this.a=S.map(P.NotebookCellOutput.to)}setOutputItems(S,l,$){const b=$.map(P.NotebookCellOutputItem.to),a=this.a.find(s=>s.id===S);if(a&&(l||(a.items.length=0),a.items.push(...b),a.items.length>1&&a.items.every(s=>A.$II(s.mime)))){const s=new Map,t=[];a.items.forEach(n=>{let o;s.has(n.mime)?o=s.get(n.mime):(o=[],s.set(n.mime,o),t.push(n.mime)),o.push(n.data)}),a.items.length=0,t.forEach(n=>{const o=A.$JI(s.get(n));a.items.push({mime:n,data:o.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(P.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$Pfc=g;class w{static{this.a=0}constructor(S,l,$,b,a){this.k=S,this.l=l,this.m=$,this.uri=b,this.handle=w.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=a.viewType,this.f=Object.freeze(a.metadata??Object.create(null)),this.r([[0,0,a.cells]],!0,void 0),this.g=a.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,l={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===E.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt($){return $=S.n($),S.b[$].apiCell},getCells($){return($?S.p($):S.b).map(a=>a.apiCell)},save(){return S.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,l,$){this.g=S.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const b={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},a=[];for(const t of S.rawEvents)t.kind===A.NotebookCellsChangeType.ModelChange?this.r(t.changes,!1,b.contentChanges):t.kind===A.NotebookCellsChangeType.Move?this.s(t.index,t.length,t.newIdx,b.contentChanges):t.kind===A.NotebookCellsChangeType.Output?(this.t(t.index,t.outputs),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.OutputItem?(this.u(t.index,t.outputId,t.append,t.outputItems),a.push({cell:this.b[t.index].apiCell,outputs:this.b[t.index].apiCell.outputs})):t.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(t.index,t.language),a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document})):t.kind===A.NotebookCellsChangeType.ChangeCellContent?a.push({cell:this.b[t.index].apiCell,document:this.b[t.index].apiCell.document}):t.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(t.index,t.mime):t.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(t.index,t.metadata),a.push({cell:this.b[t.index].apiCell,metadata:this.b[t.index].apiCell.metadata})):t.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(t.index,t.internalMetadata),a.push({cell:this.b[t.index].apiCell,executionSummary:this.b[t.index].apiCell.executionSummary}));const s=new Map;for(let t=0;t<a.length;t++){const n=a[t],o=s.get(n.cell);if(o===void 0){const c=b.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});s.set(n.cell,c-1)}else b.cellChanges[o]={...b.cellChanges[o],...n}}return Object.freeze(b),Object.freeze(b.cellChanges),Object.freeze(b.contentChanges),b}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let l=S.start|0,$=S.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),S.with({start:l,end:$})}p(S){S=this.o(S);const l=[];for(let $=S.start;$<S.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,l,$){if(this.j)return;const b=[],a=[],s=[];if(S.reverse().forEach(t=>{const o=t[2].map(i=>{const r=new g(this,this.l,i);return l||a.push(g.asModelAddData(this.apiNotebook,i)),r}),c=new m(t[0],t[1],[],o),h=this.b.splice(t[0],t[1],...o);for(const i of h)s.push(i.uri),c.deletedItems.push(i.apiCell);b.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:s}),$)for(const t of b)$.push(t.asApiEvent())}s(S,l,$,b){const a=this.b.splice(S,l);this.b.splice($,0,...a);const s=[new m(S,l,a.map(t=>t.apiCell),[]),new m($,0,[],a)];for(const t of s)b.push(t.asApiEvent())}t(S,l){this.b[S].setOutputs(l)}u(S,l,$,b){this.b[S].setOutputItems(l,$,b)}v(S,l){const $=this.b[S];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(S,l){const $=this.b[S];$.apiCell.mime=l}x(S,l){this.b[S].setMetadata(l)}y(S,l){this.b[S].setInternalMetadata(l)}getCellFromApiCell(S){return this.b.find(l=>l.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(l=>l.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$Qfc=w}),define(Pe[221],Re([1,0,5,2,8,7]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7fc=void 0;class A{constructor(g,w,R,S={timeout:1500,errors:3}){this.b=g,this.c=w,this.d=R,this.f=S,this.a=new E.$Td}dispose(){}getOnWillSaveNotebookDocumentEvent(g){return(w,R,S)=>{const l=function(b){w.call(R,b)};return l.extension=g,this.a.event(l,void 0,S)}}async $participateInSave(g,w,R){const S=T.URI.revive(g),l=this.c.getNotebookDocument(S);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:P.TextDocumentSaveReason.to(w)},R,async(a,s)=>{const t=Date.now(),n=await await Promise.resolve(a);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!R.isCancellationRequested&&n&&(n instanceof M.$QK?$.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),R.isCancellationRequested)return!1;if($.length===0)return!0;const b={edits:[]};for(const a of $){const{edits:s}=P.WorkspaceEdit.from(a);b.edits=b.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(b)}}e.$7fc=A}),define(Pe[107],Re([1,0,11,8,7]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rfc=void 0;class M{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,g,w,R,S,l){this.id=m,this.f=g,this.notebookData=w,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=R,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(g){this.selections=[g]},get selections(){return m.a},set selections(g){if(!Array.isArray(g)||!g.every(P.$5L.isNotebookRange))throw(0,E.$6)("selections");m.a=g,m.g(g)},get visibleRanges(){return m.b},revealRange(g,w){m.f.$tryRevealRange(m.id,T.NotebookRange.from(g),w??P.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},M.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(T.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Rfc=M}),define(Pe[222],Re([1,0,11,5,15,8]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9fc=void 0;let A=class{constructor(g,w){this.c=g,this.d=w,this.a=new T.$Rd({onListenerError:E.$1}),this.b=new T.$Rd({onListenerError:E.$1}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(g,w){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",g,w);const R=this.d.getEditorById(g);w.visibleRanges&&R._acceptVisibleRanges(w.visibleRanges.ranges.map(M.NotebookRange.to)),w.selections&&R._acceptSelections(w.selections.selections.map(M.NotebookRange.to)),w.visibleRanges&&this.b.fire({notebookEditor:R.apiEditor,visibleRanges:R.apiEditor.visibleRanges}),w.selections&&this.a.fire(Object.freeze({notebookEditor:R.apiEditor,selections:R.apiEditor.selections}))}$acceptEditorViewColumns(g){for(const w in g)this.d.getEditorById(w)._acceptViewColumn(M.ViewColumn.to(g[w]))}};e.$9fc=A,e.$9fc=A=He([We(0,P.$hj)],A)}),define(Pe[223],Re([1,0,8,72,162,19,66,11]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dgc=void 0;class g{constructor(l){this.b=0,this.c=new Map,this.a=l}async withProgress(l,$,b){const a=this.b++,{title:s,location:t,cancellable:n}=$,o={label:(0,P.localize)(0,null,l.displayName||l.name),id:l.identifier.value};return this.a.$startProgress(a,{location:E.ProgressLocation.from(t),title:s,source:o,cancellable:n},l.isUnderDevelopment?void 0:l.identifier.value).catch(m.$1),this.d(a,b,!!n)}d(l,$,b){let a;b&&(a=new M.$2d,this.c.set(l,a));const s=n=>{this.a.$progressEnd(n),this.c.delete(n),a?.dispose()};let t;try{t=$(new R(this.a,l),b&&a?a.token:M.CancellationToken.None)}catch(n){throw s(l),n}return t.then(n=>s(l),n=>s(l)),t}$acceptProgressCanceled(l){const $=this.c.get(l);$&&($.cancel(),this.c.delete(l))}}e.$dgc=g;function w(S,l){return S.message=l.message,typeof l.increment=="number"&&(typeof S.increment=="number"?S.increment+=l.increment:S.increment=l.increment),S}class R extends T.$dv{constructor(l,$){super(b=>this.throttledReport(b)),this.c=l,this.d=$}throttledReport(l){this.c.$progressReport(this.d,l)}}He([(0,A.$th)(100,(S,l)=>w(S,l),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(Pe[108],Re([1,0,29,104,48,77,58,8,2]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WM=e.$VM=e.$UM=e.$TM=void 0;const w=(o,c,h,i)=>{let r=c;return{enumerable:!0,configurable:!1,get(){return r},set(u){if(!h(r,u)){const d=r;r=u,o.listener?.(i(u,d))}}}},R=(o,c)=>o===c,S={range:(o,c)=>o===c?!0:!o||!c?!1:o.isEqual(c),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(o,c)=>!(o.length!==c.length||o.some(h=>!c.find(i=>h.id===i.id)))},l=o=>c=>({op:4,update:o(c)}),$=(o,c)=>({range:(()=>{let h;const i=l(r=>({range:E.$Ds.lift(m.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return h},set(r){o.listener?.({op:6}),S.range(h,r)||(h=r,o.listener?.(i(r)))}}})(),label:w(o,c,S.label,l(h=>({label:h}))),description:w(o,void 0,S.description,l(h=>({description:h}))),sortText:w(o,void 0,S.sortText,l(h=>({sortText:h}))),canResolveChildren:w(o,!1,S.canResolveChildren,h=>({op:2,state:h})),busy:w(o,!1,S.busy,l(h=>({busy:h}))),error:w(o,void 0,S.error,l(h=>({error:m.MarkdownString.fromStrict(h)||null}))),tags:w(o,[],S.tags,(h,i)=>({op:1,new:h.map(m.TestTag.from),old:i.map(m.TestTag.from)}))}),b=o=>{const c=P.$wJ.fromString(o.extId),h=new s(c.controllerId,c.localId,o.label,g.URI.revive(o.uri)||void 0);return h.range=m.Range.to(o.range||void 0),h.description=o.description||void 0,h.sortText=o.sortText||void 0,h.tags=o.tags.map(i=>m.TestTag.to({id:(0,A.$BJ)(i).tagId})),h},a=o=>{let c;for(const h of o.tests){const i=b(h.item);(0,T.$DM)(i).parent=c,c=i}return c};e.$TM=a;class s{constructor(c,h,i,r){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const u=(0,T.$CM)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return u.parent instanceof t?void 0:u.parent}},children:{value:(0,M.$BM)(u,T.$DM,s),enumerable:!0,writable:!1},...$(u,i)})}}e.$UM=s;class t extends s{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$VM=t;class n extends M.$xM{constructor(c,h,i){super({controllerId:c,getDocumentVersion:r=>r&&i.getDocument(r)?.version,getApiFor:T.$DM,getChildren:r=>r.children,root:new t(c,h),toITestItem:m.TestItem.from})}}e.$WM=n}),define(Pe[109],Re([1,0,53,11,89,8,7]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QM=e.$PM=e.$OM=void 0;class m{static{this.c=new P.$MM("TextEditorDecorationType")}constructor(l,$,b){const a=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,a,M.DecorationRenderOptions.from(b)),this.value=Object.freeze({key:a,dispose(){l.$removeTextEditorDecorationType(a)}})}}e.$OM=m;class g{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let b=null;if(l instanceof A.$HK)b=new A.$IK(l,l);else if(l instanceof A.$IK)b=l;else throw new Error("Unrecognized location");this.l(b,$,!1)}insert(l,$){this.k(),this.l(new A.$IK(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof A.$IK)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,b){const a=this.c.validateRange(l);this.g.push({range:a,text:$,forceMoveMarkers:b})}setEndOfLine(l){if(this.k(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw(0,T.$6)("endOfLine");this.h=l}}class w{constructor(l,$,b,a){this.c=l,this.d=$,this._accept(b),this.e=a;const s=this;this.value={get tabSize(){return s.f},set tabSize(t){s.m(t)},get indentSize(){return s.g},set indentSize(t){s.o(t)},get insertSpaces(){return s.h},set insertSpaces(t){s.q(t)},get cursorStyle(){return s.j},set cursorStyle(t){s.s(t)},get lineNumbers(){return s.k},set lineNumbers(t){s.t(t)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.insertSpaces,this.j=l.cursorStyle,this.k=M.TextEditorLineNumbersStyle.to(l.lineNumbers)}l(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}m(l){const $=this.l(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}n(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}o(l){const $=this.n(l);if($!==null){if(typeof $=="number"){if(this.g===$)return;this.g=$}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}p(l){return l==="auto"?"auto":l==="false"?!1:!!l}q(l){const $=this.p(l);if(typeof $=="boolean"){if(this.h===$)return;this.h=$}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}s(l){this.j!==l&&(this.j=l,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}t(l){this.k!==l&&(this.k=l,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:M.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let b=!1;if(typeof l.tabSize<"u"){const a=this.l(l.tabSize);a==="auto"?(b=!0,$.tabSize=a):typeof a=="number"&&this.f!==a&&(this.f=a,b=!0,$.tabSize=a)}if(typeof l.indentSize<"u"){const a=this.n(l.indentSize);a==="tabSize"?(b=!0,$.indentSize=a):typeof a=="number"&&this.g!==a&&(this.g=a,b=!0,$.indentSize=a)}if(typeof l.insertSpaces<"u"){const a=this.p(l.insertSpaces);a==="auto"?(b=!0,$.insertSpaces=a):this.h!==a&&(this.h=a,b=!0,$.insertSpaces=a)}typeof l.cursorStyle<"u"&&this.j!==l.cursorStyle&&(this.j=l.cursorStyle,b=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.k!==l.lineNumbers&&(this.k=l.lineNumbers,b=!0,$.lineNumbers=M.TextEditorLineNumbersStyle.from(l.lineNumbers)),b&&this.u("setOptions",this.c.$trySetOptions(this.d,$))}u(l,$){$.catch(b=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(b)})}}e.$PM=w;class R{constructor(l,$,b,a,s,t,n,o){this.id=l,this.j=$,this.k=b,this.g=!1,this.h=new Set,this.c=s,this.d=new w(this.j,this.id,t,b),this.e=n,this.f=o;const c=this;this.value=Object.freeze({get document(){return a.value},set document(h){throw new T.$8("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof A.$JK))throw(0,T.$6)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof A.$JK)))throw(0,T.$6)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new T.$8("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new T.$8("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new g(a.value,i);return h(r),c.m(r)},insertSnippet(h,i,r={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=c.c.map(d=>M.Range.from(d));else if(i instanceof A.$HK){const{lineNumber:d,column:v}=M.Position.from(i);u=[{startLineNumber:d,startColumn:v,endLineNumber:d,endColumn:v}]}else if(i instanceof A.$IK)u=[M.Range.from(i)];else{u=[];for(const d of i)if(d instanceof A.$IK)u.push(M.Range.from(d));else{const{lineNumber:v,column:f}=M.Position.from(d);u.push({startLineNumber:v,startColumn:f,endLineNumber:v,endColumn:f})}}return $.$tryInsertSnippet(l,a.value.version,h.value,u,r)},setDecorations(h,i){const r=i.length===0;r&&!c.h.has(h.key)||(r?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(M.$EM(i))return $.$trySetDecorations(l,h.key,M.$FM(i));{const u=new Array(4*i.length);for(let d=0,v=i.length;d<v;d++){const f=i[d];u[4*d]=f.start.line+1,u[4*d+1]=f.start.character+1,u[4*d+2]=f.end.line+1,u[4*d+3]=f.end.character+1}return $.$trySetDecorationsFast(l,h.key,u)}}))},revealRange(h,i){c.n(()=>$.$tryRevealRange(l,M.Range.from(h),i||A.TextEditorRevealType.Default))},show(h){$.$tryShowEditor(l,M.ViewColumn.from(h))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,E.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,E.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,E.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,E.ok)(!this.g),this.f=l}_acceptSelections(l){(0,E.ok)(!this.g),this.c=l}async l(){const l=this.c.map(M.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const b=$.edits.map(s=>s.range);b.sort((s,t)=>s.end.line===t.end.line?s.end.character===t.end.character?s.start.line===t.start.line?s.start.character-t.start.character:s.start.line-t.start.line:s.end.character-t.end.character:s.end.line-t.end.line);for(let s=0,t=b.length-1;s<t;s++){const n=b[s].end;if(b[s+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=$.edits.map(s=>({range:M.Range.from(s.range),text:s.text,forceMoveMarkers:s.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,a,{setEndOfLine:typeof $.setEndOfLine=="number"?M.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$QM=R}),define(Pe[224],Re([1,0,166,25,2,5,6,204,14,7,16,18,8,52,19,131,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;function t(c,h){if((0,R.$Cf)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(r=>r.length===2&&typeof r[0]=="number"&&typeof r[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends A.$Rc{constructor(h,i,r){super(),this.f=h,this.g=i,this.h=r,this.a=new Map,this.b=new a.$27;function u(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:d=>u(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(v=>u(v)?this.r(v):v):d})}registerTreeDataProvider(h,i,r){const u=this.createTreeView(h,{treeDataProvider:i},r);return{dispose:()=>u.dispose()}}createTreeView(h,i,r){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=i.dragAndDropController?.dropMimeTypes??[],d=i.dragAndDropController?.dragMimeTypes??[],v=!!i.dragAndDropController?.handleDrag,f=!!i.dragAndDropController?.handleDrop,k=this.m(h,i,r),L={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:u,dragMimeTypes:d,hasHandleDrag:v,hasHandleDrop:f,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},p=this.f.$registerTreeViewDataProvider(h,L),y={get onDidCollapseElement(){return k.onDidCollapseElement},get onDidExpandElement(){return k.onDidExpandElement},get selection(){return k.selectedElements},get onDidChangeSelection(){return k.onDidChangeSelection},get activeItem(){return(0,s.$RF)(r,"treeViewActiveItem"),k.focusedElement},get onDidChangeActiveItem(){return(0,s.$RF)(r,"treeViewActiveItem"),k.onDidChangeActiveItem},get visible(){return k.visible},get onDidChangeVisibility(){return k.onDidChangeVisibility},get onDidChangeCheckboxState(){return k.onDidChangeCheckboxState},get message(){return k.message},set message(D){(0,$.$ck)(D)&&(0,s.$RF)(r,"treeViewMarkdownMessage"),k.message=D},get title(){return k.title},set title(D){k.title=D},get description(){return k.description},set description(D){k.description=D},get badge(){return k.badge},set badge(D){D!==void 0&&w.ViewBadge.isViewBadge(D)?k.badge={value:Math.floor(Math.abs(D.value)),tooltip:D.tooltip}:D===void 0&&(k.badge=void 0)},reveal:(D,N)=>k.reveal(D,N),dispose:async()=>{await p,this.a.delete(h),k.dispose()}};return this.B(y),y}$getChildren(h,i){const r=this.a.get(h);return r?r.getChildren(i):Promise.reject(new m.$QE(h))}async $handleDrop(h,i,r,u,d,v,f,k){const L=this.a.get(h);if(!L)return Promise.reject(new m.$QE(h));const p=l.DataTransfer.toDataTransfer(r,async y=>(await this.f.$resolveDropFileData(h,i,y)).buffer);return f===h&&k&&await this.j(p,L,k,d,v),L.onDrop(p,u,d)}async j(h,i,r,u,d){const v=this.b.removeDragOperationTransfer(d);if(v)(await v)?.forEach((f,k)=>{f&&h.set(k,f)});else if(d&&i.handleDrag){const f=i.handleDrag(r,h,u);this.b.addDragOperationTransfer(d,f),await f}return h}async $handleDrag(h,i,r,u){const d=this.a.get(h);if(!d)return Promise.reject(new m.$QE(h));const v=await this.j(new w.$yL,d,i,u,r);if(!(!v||u.isCancellationRequested))return l.DataTransfer.from(v)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new m.$QE(h);return i.hasResolve}$resolve(h,i,r){const u=this.a.get(h);if(!u)throw new m.$QE(h);return u.resolveTreeItem(i,r)}$setExpanded(h,i,r){const u=this.a.get(h);if(!u)throw new m.$QE(h);u.setExpanded(i,r)}$setSelectionAndFocus(h,i,r){const u=this.a.get(h);if(!u)throw new m.$QE(h);u.setSelectionAndFocus(i,r)}$setVisible(h,i){const r=this.a.get(h);if(!r){if(!i)return;throw new m.$QE(h)}r.setVisible(i)}$changeCheckboxState(h,i){const r=this.a.get(h);if(!r)throw new m.$QE(h);r.setCheckboxState(i)}m(h,i,r){const u=this.B(new o(h,i,this.f,this.g.converter,this.h,r));return this.a.set(h,u),u}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$wgc=n;class o extends A.$Rc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,R.$Lf)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,r,u,d,v){if(super(),this.I=h,this.J=r,this.L=u,this.M=d,this.N=v,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new M.$Rd),this.onDidExpandElement=this.u.event,this.w=this.B(new M.$Rd),this.onDidCollapseElement=this.w.event,this.y=this.B(new M.$Rd),this.onDidChangeSelection=this.y.event,this.z=this.B(new M.$Rd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new M.$Rd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new M.$Rd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new M.$Rd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new b.$2d,v.contributes&&v.contributes.views)for(const p in v.contributes.views)for(const y of v.contributes.views[p])y.id===h&&(this.P=y.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(p=>this.F.fire({message:!1,element:p})));let f,k;const L=M.Event.debounce(this.F.event,(p,y)=>(p||(p={message:!1,elements:[]}),y.element!==!1&&(f||(f=new Promise(D=>k=D),this.G=this.G.then(()=>f)),Array.isArray(y.element)?p.elements.push(...y.element):p.elements.push(y.element)),y.message&&(p.message=!0),p),200,!0);this.B(L(({message:p,elements:y})=>{y.length&&(this.H=this.H.then(()=>{const D=k;return f=null,this.$(y).then(()=>D())})),p&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let r=this.X(h);return r||(r=await this.Y(i)),r?r.map(u=>u.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const r=(0,R.$Lf)(i.select)?!0:i.select,u=(0,R.$Lf)(i.focus)?!1:i.focus,d=(0,R.$Lf)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(v=>this.W(h,v[v.length-1]).then(f=>this.J.$reveal(this.I,{item:f.item,parentChain:v.map(k=>k.item)},{select:r,focus:u,expand:d})),v=>this.M.error(v)):this.J.$reveal(this.I,void 0,{select:r,focus:u,expand:d})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const r=this.getExtensionElement(h);r&&(i?this.u.fire(Object.freeze({element:r})):this.w.fire(Object.freeze({element:r})))}setSelectionAndFocus(h,i){const r=!(0,S.$tb)(this.s,h);this.s=h;const u=this.t!==i;this.t=i,r&&this.y.fire(Object.freeze({selection:this.selectedElements})),u&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async r=>{const u=this.getExtensionElement(r.treeItemHandle);return u?{extensionItem:u,treeItem:await this.f.getTreeItem(u),newState:r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(r=>r!==void 0);i.forEach(r=>{r.treeItem.checkboxState=r.newState?w.TreeItemCheckboxState.Checked:w.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(r=>[r.extensionItem,r.newState])})}async handleDrag(h,i,r){const u=[];for(const d of h){const v=this.getExtensionElement(d);v&&u.push(v)}if(!(!this.g?.handleDrag||u.length===0))return await this.g.handleDrag(u,i,r),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,r){const u=i?this.getExtensionElement(i):void 0;if(!(!u&&i||!this.g?.handleDrop))return(0,g.$Sg)(()=>this.g?.handleDrop?this.g.handleDrop(u,h,r):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const r=this.j.get(h);if(r){const u=this.m.get(r);if(u){const d=await this.f.resolveTreeItem(u.extensionItem,r,i)??u.extensionItem;return this.hb(d),u.item.tooltip=this.eb(d.tooltip),u.item.command=this.fb(u.disposableStore,d.command),u.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then(r=>this.W(i,r[r.length-1]).then(u=>(r.push(u),r))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$Sg)(()=>this.f.getParent(h))}W(h,i){const r=this.m.get(h);return r?Promise.resolve(r):(0,g.$Sg)(()=>this.f.getTreeItem(h)).then(u=>this.kb(h,u,i,!0)).then(u=>this.getChildren(i?i.item.handle:void 0).then(()=>{const d=this.getExtensionElement(u);if(d){const v=this.m.get(d);if(v)return Promise.resolve(v)}throw new Error(`Cannot resolve tree item for element ${u} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const r=this.getExtensionElement(h);i=r?this.m.get(r):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new b.$2d(this.Z.token);try{const r=h?this.m.get(h):void 0,u=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const d=await Promise.all((0,S.$Gb)(u||[]).map(async v=>{const f=await this.f.getTreeItem(v);return f&&!i.token.isCancellationRequested?this.db(v,f,r):null}));return i.token.isCancellationRequested?void 0:(0,S.$Gb)(d)}finally{i.dispose()}}$(h){if(h.some(r=>!r))return this.Z.dispose(!0),this.Z=new b.$2d,this.tb(),this.J.$refresh(this.I);{const r=this.ab(h);if(r.length)return this.bb(r)}return Promise.resolve(void 0)}ab(h){const i=new Set,r=h.map(d=>this.m.get(d));for(const d of r)if(d&&!i.has(d.item.handle)){let v=d;for(;v&&v.parent&&r.findIndex(f=>v&&v.parent&&f&&f.item.handle===v.parent.item.handle)===-1;){const f=this.j.get(v.parent.item.handle);v=f?this.m.get(f):void 0}v&&!v.parent&&i.add(d.item.handle)}const u=[];return i.forEach(d=>{const v=this.j.get(d);if(v){const f=this.m.get(v);f&&(!f.parent||!i.has(f.parent.item.handle))&&u.push(d)}}),u}bb(h){const i={};return Promise.all(h.map(r=>this.cb(r).then(u=>{u&&(i[r]=u.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const r=this.m.get(i);if(r)return this.rb(i),(0,g.$Sg)(()=>this.f.getTreeItem(i)).then(u=>{if(u){const d=this.ib(i,u,r.parent);return this.pb(i,d,r,r.parent),r.dispose(),d}return null})}return Promise.resolve(null)}db(h,i,r){const u=this.ib(h,i,r);if(i.id&&this.j.has(u.item.handle))throw new Error((0,E.localize)(0,null,i.id));return this.ob(h,u),this.qb(u,r),u}eb(h){return w.$8K.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,r,u;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,r=h.checkboxState.tooltip,u=h.checkboxState.accessibilityInformation),{isChecked:i===w.TreeItemCheckboxState.Checked,tooltip:r,accessibilityInformation:u}}hb(h){if(!w.$tL.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,r){this.hb(i);const u=this.B(new A.$Qc),d=this.kb(h,i,r),v=this.lb(i);return{item:{handle:d,parentHandle:r?r.item.handle:void 0,label:t(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(u,i.command),contextValue:i.contextValue,icon:v,iconDark:this.mb(i)||v,themeIcon:this.jb(i),collapsibleState:(0,R.$Lf)(i.collapsibleState)?w.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:r,children:void 0,disposableStore:u,dispose(){u.dispose()}}}jb(h){return h.iconPath instanceof w.$BL?h.iconPath:void 0}kb(h,{id:i,label:r,resourceUri:u},d,v){if(i)return`${o.b}/${i}`;const f=t(r,this.N),k=d?d.item.handle:o.a;let L=f?f.label:u?(0,T.$yg)(u):"";L=L.indexOf("/")!==-1?L.replace("/","//"):L;const p=this.m.has(h)?this.m.get(h).item.handle:void 0,y=this.X(d)||[];let D,N=0;do{if(D=`${k}/${N}:${L}`,v||!this.j.has(D)||p===D)break;N++}while(N<=y.length);return D}lb(h){if(h.iconPath&&!(h.iconPath instanceof w.$BL))return typeof h.iconPath=="string"||P.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof w.$BL)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return P.URI.isUri(h)?h:P.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,r,u){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==r.item.handle&&this.j.delete(r.item.handle),this.ob(h,i);const d=this.X(u)||[],v=d.filter(f=>f.item.handle===r.item.handle)[0];v&&d.splice(d.indexOf(v),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const r of i.children){const u=this.j.get(r.item.handle);u&&this.sb(u)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Pe[225],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariables:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariables.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveUserActions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveUserActions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",readonlyMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.readonlyMessage.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmInputBoxActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxActionButton.d.ts",scmInputBoxValueProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmInputBoxValueProvider.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[226],Re([1,0,178,11,31,97,73,30,22,225,188,101]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3F=e.$2F=e.$1F=e.$ZF=e.$YF=e.$XF=void 0;const l=m.$qn.as(A.$rn.JSONContribution);class ${constructor(h,i,r){this.a=h,this.b=i,this.c=r}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(P.default.Error,h)}warn(h){this.d(P.default.Warning,h)}info(h){this.d(P.default.Info,h)}}e.$XF=$;class b{static a(h){const i=new g.$em;for(let r=0,u=h.length;r<u;r++)i.add(h[r].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new b(i,[]);if(!i||!i.length)return new b([],h);const r=this.a(h),u=this.a(i),d=i.filter(f=>!r.has(f.description.identifier)),v=h.filter(f=>!u.has(f.description.identifier));return new b(d,v)}constructor(h,i){this.added=h,this.removed=i}}e.$YF=b;class a{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=b.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,T.$Z)(h)}}}e.$ZF=a;const s={type:"string",enum:["ui","workspace"],enumDescriptions:[E.localize(0,null),E.localize(1,null)]},t="vscode://schemas/vscode-extensions";e.$1F={properties:{engines:{type:"object",description:E.localize(2,null),properties:{vscode:{type:"string",description:E.localize(3,null),default:"^1.22.0"}}},publisher:{description:E.localize(4,null),type:"string"},displayName:{description:E.localize(5,null),type:"string"},categories:{description:E.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$cm},{type:"string",const:"Languages",deprecationMessage:E.localize(7,null)}]}},galleryBanner:{type:"object",description:E.localize(8,null),properties:{color:{description:E.localize(9,null),type:"string"},theme:{description:E.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:E.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:E.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:E.localize(13,null)},enabledApiProposals:{markdownDescription:E.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}},api:{markdownDescription:E.localize(15,null),type:"string",enum:["none"],enumDescriptions:[E.localize(16,null)]},activationEvents:{description:E.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:E.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:E.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:E.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:E.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:E.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:E.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:E.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:E.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:E.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:E.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:E.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:E.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:E.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:E.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:E.localize(32,null)},{label:"onUri",body:"onUri",description:E.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:E.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:E.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:E.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:E.localize(37,null)},{label:"onRenderer",description:E.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:E.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:E.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:E.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:E.localize(42,null)},{label:"*",description:E.localize(43,null),body:"*"}]}},badges:{type:"array",description:E.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:E.localize(45,null)},href:{type:"string",description:E.localize(46,null)},description:{type:"string",description:E.localize(47,null)}}}},markdown:{type:"string",description:E.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:E.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:E.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$8n}},extensionPack:{description:E.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:M.$8n}},extensionKind:{description:E.localize(52,null),type:"array",items:s,default:["workspace"],defaultSnippets:[{body:["ui"],description:E.localize(53,null)},{body:["workspace"],description:E.localize(54,null)},{body:["ui","workspace"],description:E.localize(55,null)},{body:["workspace","ui"],description:E.localize(56,null)},{body:[],description:E.localize(57,null)}]},capabilities:{description:E.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:E.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:E.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(61,null),E.localize(62,null),E.localize(63,null)]},description:{type:"string",markdownDescription:E.localize(64,null)}}},untrustedWorkspaces:{description:E.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:E.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[E.localize(67,null),E.localize(68,null),E.localize(69,null)]},restrictedConfigurations:{description:E.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:E.localize(71,null)}}}}},sponsor:{description:E.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:E.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:E.localize(74,null),type:"string"},"vscode:uninstall":{description:E.localize(75,null),type:"string"}}},icon:{type:"string",description:E.localize(76,null)},l10n:{type:"string",description:E.localize(77,null)},pricing:{type:"string",markdownDescription:E.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new a(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&S.$CF.register(h.extensionPoint,h.activationEventsGenerator),e.$1F.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(t,e.$1F),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$2F=n;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$qn.add(o.ExtensionsRegistry,new n),e.$3F=m.$qn.as(o.ExtensionsRegistry),l.registerSchema(t,e.$1F),l.registerSchema(R.$Aj,{properties:{extensionEnabledApiProposals:{description:E.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(w.allApiProposals),markdownEnumDescriptions:Object.values(w.allApiProposals)}}]}}}})}),define(Pe[227],Re([1,0,174,16,26,226,35,5]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_F=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:E.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:E.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:E.localize(2,null),default:""}}};var w;(function(l){function $(b,a,s){if(!b)return;const t=T.$Cf(b.type)?b.type:void 0;if(!t||t.length===0){s.error(E.localize(3,null));return}const n=[];if(Array.isArray(b.required))for(const o of b.required)T.$Cf(o)&&n.push(o);return{extensionId:a.value,taskType:t,required:n,properties:b.properties?P.$en(b.properties):{},when:b.when?A.$Xi.deserialize(b.when):void 0}}l.from=$})(w||(w={}));const R=M.$3F.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const b of l)b.type&&$.push(`onTaskType:${b.type}`)},jsonSchema:{description:E.localize(4,null),type:"array",items:g}});class S{constructor(){this.d=new m.$Rd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,b)=>{R.setHandler((a,s)=>{this.c=void 0;try{for(const t of s.removed){const n=t.value;for(const o of n)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const t of s.added){const n=t.value;for(const o of n){const c=w.from(o,t.description.identifier,t.collector);c&&(this.a[c.taskType]=c)}}(s.removed.length>0||s.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const b of this.all()){const a={type:"object",additionalProperties:!1};b.required.length>0&&(a.required=b.required.slice(0)),b.properties!==void 0?a.properties=P.$en(b.properties):a.properties=Object.create(null),a.properties.type={type:"string",enum:[b.taskType]},$.push(a)}this.c={oneOf:$}}return this.c}}e.$_F=new S}),define(Pe[228],Re([1,0,175,16,25,26,35,227]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$jG=e.JsonSchemaVersion=e.ExecutionEngine=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$dG=e.ShellQuoting=e.$cG=e.$bG=e.$aG=void 0,e.$aG="settings",e.$bG=new A.$ej("taskRunning",!1,E.localize(0,null)),e.$cG={value:E.localize(1,null),original:"Tasks"};var g;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$dG="$customized",function(C){function I(X){if(!X)return C.Strong;switch(X.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=I}(g||(e.ShellQuoting=g={}));var w;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(w||(e.CommandOptions=w={}));var R;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(R||(e.RevealKind=R={})),function(C){function I(X){switch(X.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=I}(R||(e.RevealKind=R={}));var S;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(C){function I(X){switch(X.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=I}(S||(e.RevealProblemKind=S={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function I(X){switch(X.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=I}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:R.Always,revealProblems:S.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var b;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(b||(e.RuntimeType=b={})),function(C){function I(ue){switch(ue.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=I;function X(ue){switch(ue){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=X}(b||(e.RuntimeType=b={}));var a;(function(C){function I(X){return T.$Cf(X)?X:X.value}C.value=I})(a||(e.CommandString=a={}));var s;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function I(ue){return ue===C.Clean._id||ue===C.Build._id||ue===C.Rebuild._id||ue===C.Test._id}C.is=I;function X(ue){if(ue!==void 0)return T.$Cf(ue)?I(ue)?{_id:ue,isDefault:!1}:void 0:ue}C.from=X})(s||(e.TaskGroup=s={}));var t;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(t||(e.TaskScope=t={}));var n;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function I(X){switch(X){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=I})(n||(e.TaskSourceKind=n={}));var o;(function(C){C.parallel="parallel",C.sequence="sequence"})(o||(e.DependsOrder=o={}));var c;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(I,X,ue,he,be,we){this._label="",this._id=I,X&&(this._label=X),ue&&(this.type=ue),this.runOptions=he,this.configurationProperties=be,this._source=we}getDefinition(I){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const I={folder:this.d(),id:this._id};return JSON.stringify(I)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(I,X=!1){if(I===void 0)return!1;if(T.$Cf(I))return I===this._label||I===this.configurationProperties.identifier||X&&I===this._id;const ue=this.getDefinition(!0);return ue!==void 0&&ue._key===I._key}getQualifiedLabel(){const I=this.getWorkspaceFolder();return I?`${this._label} (${I.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(I){this.c===void 0&&(this.c=[]),I&&(this.c=this.c.concat(I))}get taskLoadMessages(){return this.c}}e.$eG=i;class r extends i{constructor(I,X,ue,he,be,we,ge,me){super(I,ue,void 0,ge,me,X),this.command={},this._source=X,this.hasDefinedMatchers=we,be&&(this.command=be)}clone(){return new r(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(I=!1){if(I&&this._source.customizes!==void 0)return this._source.customizes;{let X;switch(this.command?this.command.runtime:void 0){case b.Shell:X="shell";break;case b.Process:X="process";break;case b.CustomExecution:X="customExecution";break;case void 0:X="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:X,_key:this._id,id:this._id}}}static is(I){return I instanceof r}getMapKey(){const I=this._source.config.workspaceFolder;return I?`${I.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$aG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const I=this.d();if(!I)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const ue={type:e.$dG,folder:I,id:X};return JSON.stringify(ue)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$yg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(I){return new r(I._id,I._source,I._label,I.type,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$fG=r;class u extends i{constructor(I,X,ue,he,be,we,ge){super(I,ue,he,we,ge,X),this._source=X,this.configures=be}static is(I){return I instanceof u}f(I){return I}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?P.$yg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$aG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const I=this.d();if(!I)return;let X=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(X+=this._source.kind);const ue={type:e.$dG,folder:I,id:X};return JSON.stringify(ue)}}e.$gG=u;class d extends i{constructor(I,X,ue,he,be,we,ge,me,ne){super(I,ue,he,me,ne,X),this.defines=be,this.hasDefinedMatchers=ge,this.command=we,this.icon=ne.icon,this.hide=ne.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(I){return I instanceof d}getMapKey(){const I=this._source.workspaceFolder;return I?`${this._source.scope.toString()}|${I.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const I={type:"contributed",scope:this._source.scope,id:this._id};return I.folder=this.d(),JSON.stringify(I)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(I){return new d(I._id,I._source,I._label,I.type,I.defines,I.command,I.hasDefinedMatchers,I.runOptions,I.configurationProperties)}}e.$hG=d;class v extends i{constructor(I,X,ue,he,be,we){super(I,ue,he,be,we,X),this._source=X}clone(){return new v(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(I){return I instanceof v}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(I){return new v(I._id,I._source,I._label,I.type,I.runOptions,I.configurationProperties)}}e.$iG=v;var f;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(f||(e.ExecutionEngine=f={})),function(C){C._default=C.Terminal}(f||(e.ExecutionEngine=f={}));var k;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(k||(e.JsonSchemaVersion=k={}));class L{constructor(I){this.c=new Map;for(let X=0;X<I.length;X++)this.c.set(I[X].uri.toString(),X)}compare(I,X){const ue=I.getWorkspaceFolder(),he=X.getWorkspaceFolder();if(ue&&he){let be=this.c.get(ue.uri.toString());be=be===void 0?0:be+1;let we=this.c.get(he.uri.toString());return we=we===void 0?0:we+1,be===we?I._label.localeCompare(X._label):be-we}else return!ue&&he?-1:ue&&!he?1:0}}e.$jG=L;var p;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(p||(e.TaskEventKind=p={}));var y;(function(C){C.SingleRun="singleRun",C.Background="background"})(y||(e.TaskRunType=y={}));var D;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(D||(e.TaskRunSource=D={}));var N;(function(C){function I(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function X(me,ne,ke){return{...I(me),kind:"start",terminalId:ne,resolvedVariables:ke}}C.start=X;function ue(me,ne,ke){return{...I(me),kind:"processStarted",terminalId:ne,processId:ke}}C.processStarted=ue;function he(me,ne,ke){return{...I(me),kind:"processEnded",terminalId:ne,exitCode:ke}}C.processEnded=he;function be(me,ne,ke){return{...I(me),kind:"terminated",exitReason:ke,terminalId:ne}}C.terminated=be;function we(me,ne,ke){return{...I(ne),kind:me,terminalId:ke}}C.general=we;function ge(){return{kind:"changed"}}C.changed=ge})(N||(e.TaskEvent=N={}));var q;(function(C){function I(ue){const he=Object.keys(ue).sort();let be="";for(const we of he){let ge=ue[we];ge instanceof Object?ge=I(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),be+=we+","+ge+","}return be}function X(ue){const be={_key:I(ue),type:ue.taskType};return Object.assign(be,ue),be}C.create=X})(q||(e.KeyedTaskIdentifier=q={}));var V;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var U;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(U||(e.TasksSchemaProperties=U={}));var F;(function(C){function I(X,ue){const he=m.$_F.get(X.type);if(he===void 0){const me=M.$en(X);return delete me._key,q.create(me)}const be=Object.create(null);be.type=he.taskType;const we=new Set;he.required.forEach(me=>we.add(me));const ge=he.properties;for(const me of Object.keys(ge)){const ne=X[me];if(ne!=null)be[me]=ne;else if(we.has(me)){const ke=ge[me];if(ke.default!==void 0)be[me]=M.$en(ke.default);else switch(ke.type){case"boolean":be[me]=!1;break;case"number":case"integer":be[me]=0;break;case"string":be[me]="";break;default:ue.error(E.localize(2,null,JSON.stringify(X,void 0,0),me));return}}}return q.create(be)}C.createTaskIdentifier=I})(F||(e.TaskDefinition=F={}))}),define(Pe[229],Re([1,0,11]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N6b=e.$M6b=void 0;class T{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,m)=>{this.b=A,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,E.$Z)(A))}then(A,m){return this.j().then(A,m)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$M6b=T;class P extends T{constructor(){super(),this.h=!0,this.i=new E.$4}}e.$N6b=P}),define(Pe[49],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=void 0;class E{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++E.count}}e.$yv=E;const T=[];function P(m){const g=new E(m);return T[g.nid]=g,g}e.$zv=P;function M(m){return T[m].sid}e.$Av=M;class A{constructor(g){this.value=g}}e.$Bv=A}),define(Pe[3],Re([1,0,49]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FK=e.$EK=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$DK=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var T;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(T||(e.TextEditorRevealType=T={}));var P;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput",a[a.ChatEditorInput=10]="ChatEditorInput"})(P||(e.TabInputKind=P={}));var M;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(M||(e.TabModelOperationKind=M={}));var A;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var m;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var g;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var w;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(w||(e.NotebookEditorRevealType=w={}));var R;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(R||(e.CandidatePortSource=R={}));class S{static{this.a=0}static mixin(s){return s._id=S.a++,s}}e.$DK=S;var l;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.kindModifier="m",a.commandIdent="n",a.commandId="o",a.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})($||(e.ISuggestResultDtoField=$={}));var b;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(b||(e.ExtHostTestingResource=b={})),e.$EK={MainThreadAuthentication:(0,E.$zv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.$zv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,E.$zv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,E.$zv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,E.$zv)("MainThreadChatVariables"),MainThreadClipboard:(0,E.$zv)("MainThreadClipboard"),MainThreadCommands:(0,E.$zv)("MainThreadCommands"),MainThreadComments:(0,E.$zv)("MainThreadComments"),MainThreadConfiguration:(0,E.$zv)("MainThreadConfiguration"),MainThreadConsole:(0,E.$zv)("MainThreadConsole"),MainThreadDebugService:(0,E.$zv)("MainThreadDebugService"),MainThreadDecorations:(0,E.$zv)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.$zv)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.$zv)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.$zv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.$zv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.$zv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.$zv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.$zv)("MainThreadEditorTabs"),MainThreadErrors:(0,E.$zv)("MainThreadErrors"),MainThreadTreeViews:(0,E.$zv)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.$zv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,E.$zv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.$zv)("MainThreadLanguages"),MainThreadLogger:(0,E.$zv)("MainThreadLogger"),MainThreadMessageService:(0,E.$zv)("MainThreadMessageService"),MainThreadOutputService:(0,E.$zv)("MainThreadOutputService"),MainThreadProgress:(0,E.$zv)("MainThreadProgress"),MainThreadQuickDiff:(0,E.$zv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.$zv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.$zv)("MainThreadStatusBar"),MainThreadSecretState:(0,E.$zv)("MainThreadSecretState"),MainThreadStorage:(0,E.$zv)("MainThreadStorage"),MainThreadSpeech:(0,E.$zv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,E.$zv)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.$zv)("MainThreadTerminalService"),MainThreadWebviews:(0,E.$zv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.$zv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.$zv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.$zv)("MainThreadCustomEditors"),MainThreadUrls:(0,E.$zv)("MainThreadUrls"),MainThreadUriOpeners:(0,E.$zv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.$zv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.$zv)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.$zv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,E.$zv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,E.$zv)("MainThreadExtensionService"),MainThreadSCM:(0,E.$zv)("MainThreadSCM"),MainThreadSearch:(0,E.$zv)("MainThreadSearch"),MainThreadShare:(0,E.$zv)("MainThreadShare"),MainThreadTask:(0,E.$zv)("MainThreadTask"),MainThreadWindow:(0,E.$zv)("MainThreadWindow"),MainThreadLabelService:(0,E.$zv)("MainThreadLabelService"),MainThreadNotebook:(0,E.$zv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.$zv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.$zv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.$zv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.$zv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.$zv)("MainThreadInteractive"),MainThreadChat:(0,E.$zv)("MainThreadChat"),MainThreadInlineChat:(0,E.$zv)("MainThreadInlineChatShape"),MainThreadTheming:(0,E.$zv)("MainThreadTheming"),MainThreadTunnelService:(0,E.$zv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,E.$zv)("MainThreadManagedSockets"),MainThreadTimeline:(0,E.$zv)("MainThreadTimeline"),MainThreadTesting:(0,E.$zv)("MainThreadTesting"),MainThreadLocalization:(0,E.$zv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,E.$zv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,E.$zv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,E.$zv)("MainThreadIssueReporter")},e.$FK={ExtHostCommands:(0,E.$zv)("ExtHostCommands"),ExtHostConfiguration:(0,E.$zv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.$zv)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.$zv)("ExtHostDebugService"),ExtHostDecorations:(0,E.$zv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.$zv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.$zv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.$zv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.$zv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.$zv)("ExtHostEditors"),ExtHostTreeViews:(0,E.$zv)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.$zv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.$zv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.$zv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.$zv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.$zv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.$zv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.$zv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,E.$zv)("ExtHostStatusBar"),ExtHostShare:(0,E.$zv)("ExtHostShare"),ExtHostExtensionService:(0,E.$zv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.$zv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.$zv)("ExtHostTerminalService"),ExtHostSCM:(0,E.$zv)("ExtHostSCM"),ExtHostSearch:(0,E.$zv)("ExtHostSearch"),ExtHostTask:(0,E.$zv)("ExtHostTask"),ExtHostWorkspace:(0,E.$zv)("ExtHostWorkspace"),ExtHostWindow:(0,E.$zv)("ExtHostWindow"),ExtHostWebviews:(0,E.$zv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.$zv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.$zv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.$zv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.$zv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.$zv)("ExtHostEditorTabs"),ExtHostProgress:(0,E.$zv)("ExtHostProgress"),ExtHostComments:(0,E.$zv)("ExtHostComments"),ExtHostSecretState:(0,E.$zv)("ExtHostSecretState"),ExtHostStorage:(0,E.$zv)("ExtHostStorage"),ExtHostUrls:(0,E.$zv)("ExtHostUrls"),ExtHostUriOpeners:(0,E.$zv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.$zv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.$zv)("ExtHostOutputService"),ExtHosLabelService:(0,E.$zv)("ExtHostLabelService"),ExtHostNotebook:(0,E.$zv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.$zv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.$zv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.$zv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.$zv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,E.$zv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,E.$zv)("ExtHostInteractive"),ExtHostInlineChat:(0,E.$zv)("ExtHostInlineChatShape"),ExtHostChat:(0,E.$zv)("ExtHostChat"),ExtHostChatAgents2:(0,E.$zv)("ExtHostChatAgents"),ExtHostChatVariables:(0,E.$zv)("ExtHostChatVariables"),ExtHostChatProvider:(0,E.$zv)("ExtHostChatProvider"),ExtHostSpeech:(0,E.$zv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,E.$zv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,E.$zv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,E.$zv)("ExtHostTheming"),ExtHostTunnelService:(0,E.$zv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,E.$zv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,E.$zv)("ExtHostAuthentication"),ExtHostTimeline:(0,E.$zv)("ExtHostTimeline"),ExtHostTesting:(0,E.$zv)("ExtHostTesting"),ExtHostTelemetry:(0,E.$zv)("ExtHostTelemetry"),ExtHostLocalization:(0,E.$zv)("ExtHostLocalization"),ExtHostIssueReporter:(0,E.$zv)("ExtHostIssueReporter")}}),define(Pe[230],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wec=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$EK.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,m,g){if(this.a.size===0)throw new Error("No related information providers registered");const w=this.a.get(A);if(!w)throw new Error("related information provider not found");return await w.provideRelatedInformation(m,g)??[]}getRelatedInformation(A,m,g){return this.c.$getAiRelatedInformation(m,g)}registerRelatedInformationProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiRelatedInformationProvider(w,m),new T.$GK(()=>{this.c.$unregisterAiRelatedInformationProvider(w),this.a.delete(w)})}}e.$wec=P}),define(Pe[81],Re([1,0,4,15,3,17]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=e.$Dec=e.$Cec=void 0,e.$Cec=(0,E.$Zh)("IExtHostApiDeprecationService");let A=class{constructor(g,w){this.c=w,this.a=new Set,this.b=g.getProxy(P.$EK.MainThreadTelemetry)}report(g,w,R){const S=this.d(g,w);this.a.has(S)||(this.a.add(S),w.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${R}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:w.identifier.value,apiId:g}))}d(g,w){return`${g}-${w.identifier.value}`}};e.$Dec=A,e.$Dec=A=He([We(0,M.$HM),We(1,T.$hj)],A),e.$Eec=Object.freeze(new class{report(m,g,w){}})}),define(Pe[231],Re([1,0,5,3,7,22]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hec=void 0;class A{constructor(w){this.b=new Map,this.c=[],this.d=new E.$Rd,this.onDidChangeSessions=this.d.event,this.f=new m,this.g=new m,this.a=w.getProxy(T.$EK.MainThreadAuthentication)}$setProviders(w){return this.c=w,Promise.resolve()}async getSession(w,R,S,l={}){const $=M.$dm.toKey(w.identifier),b=[...S].sort().join(" ");return await this.f.getOrCreate(`${$} ${R} ${b}`,async()=>{await this.a.$ensureProvider(R);const a=w.displayName||w.name;return this.a.$getSession(R,S,$,a,l)})}async getSessions(w,R,S){const l=M.$dm.toKey(w.identifier),$=[...S].sort().join(" ");return await this.g.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(R);const b=w.displayName||w.name;return this.a.$getSessions(R,S,l,b)})}async removeSession(w,R){const S=this.b.get(w);return S?S.provider.removeSession(R):this.a.$removeSession(w,R)}registerAuthenticationProvider(w,R,S,l){if(this.b.get(w))throw new Error(`An authentication provider with id '${w}' is already registered.`);this.b.set(w,{label:R,provider:S,options:l??{supportsMultipleAccounts:!1}}),this.c.find(b=>b.id===w)||this.c.push({id:w,label:R});const $=S.onDidChangeSessions(b=>{this.a.$sendDidChangeSessions(w,{added:b.added??[],changed:b.changed??[],removed:b.removed??[]})});return this.a.$registerAuthenticationProvider(w,R,l?.supportsMultipleAccounts??!1),new P.$GK(()=>{$.dispose(),this.b.delete(w);const b=this.c.findIndex(a=>a.id===w);b>-1&&this.c.splice(b),this.a.$unregisterAuthenticationProvider(w)})}$createSession(w,R,S){const l=this.b.get(w);if(l)return Promise.resolve(l.provider.createSession(R,S));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$removeSession(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.removeSession(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$getSessions(w,R){const S=this.b.get(w);if(S)return Promise.resolve(S.provider.getSessions(R));throw new Error(`Unable to find authentication provider with handle: ${w}`)}$onDidChangeAuthenticationSessions(w,R){return this.d.fire({provider:{id:w,label:R}}),Promise.resolve()}}e.$Hec=A;class m{constructor(){this.a=new Map}getOrCreate(w,R){const S=this.a.get(w);if(S)return S;const l=R().finally(()=>this.a.delete(w));return this.a.set(w,l),l}}}),define(Pe[232],Re([1,0,3,17,8]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iec=void 0;let M=class{constructor(m,g){this.a=m.getProxy(E.$EK.MainThreadBulkEdits),this.b={getTextDocumentVersion:w=>g.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,g,w){const R=P.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(R,void 0,w?.isRefactoring??!1)}};e.$Iec=M,e.$Iec=M=He([We(0,T.$HM)],M)}),define(Pe[233],Re([1,0,5,67,6,3,8]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jec=void 0;class m{static{this.a=0}constructor(R,S){this.extension=R,this.provider=S,this.handle=m.a++}}class g{static{this.a=0}constructor(R){this.b=new Map,this.c=new Map,this.d=new E.$Rd,this.onDidPerformUserAction=this.d.event,this.e=R.getProxy(M.$EK.MainThreadChat)}registerChatProvider(R,S,l){const $=new m(R,l);return this.b.set($.handle,$),this.e.$registerChatProvider($.handle,S),(0,P.$Pc)(()=>{this.e.$unregisterChatProvider($.handle),this.b.delete($.handle)})}transferChatSession(R,S){const l=T.Iterable.find(this.c.keys(),$=>this.c.get($)===R)??0;typeof l=="number"&&this.e.$transferChatSession(l,S)}sendInteractiveRequestToProvider(R,S){this.e.$sendRequestToProvider(R,S)}async $prepareChat(R,S){const l=this.b.get(R);if(!l)return;const $=await l.provider.prepareSession(S);if(!$)return;const b=g.a++;return this.c.set(b,$),{id:b,requesterUsername:$.requester?.name,requesterAvatarIconUri:$.requester?.icon,responderUsername:$.responder?.name,responderAvatarIconUri:$.responder?.icon,inputPlaceholder:$.inputPlaceholder}}async $provideWelcomeMessage(R,S){const l=this.b.get(R);if(!l||!l.provider.provideWelcomeMessage)return;const $=await l.provider.provideWelcomeMessage(S);if($)return $.map(b=>typeof b=="string"?b:Array.isArray(b)?b.map(a=>A.ChatReplyFollowup.from(a)):A.MarkdownString.from(b))}async $provideSampleQuestions(R,S){const l=this.b.get(R);if(!l||!l.provider.provideSampleQuestions)return;const $=await l.provider.provideSampleQuestions(S);if($)return $?.map(b=>A.ChatReplyFollowup.from(b))}$releaseSession(R){this.c.delete(R)}async $onDidPerformUserAction(R){this.d.fire(R)}}e.$Jec=g}),define(Pe[234],Re([1,0,14,19,40,5,60,16,2,156,72,3,8,7,205,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lec=void 0;class s{static{this.a=0}constructor(o,c,h){this.i=c,this.j=h,this.b=new Map,this.g=new Map,this.h=new Map,this.d=o.getProxy(S.$EK.MainThreadChatAgents2)}createChatAgent(o,c,h){const i=s.a++,r=new t(o,c,this.d,i,h);return this.b.set(i,r),this.d.$registerAgent(i,c,{}),r.apiAgent}async $invokeAgent(o,c,h,i,r,u){this.g.delete(c);const d=this.b.get(o);if(!d)throw new Error(`[CHAT](${o}) CANNOT invoke agent because the agent is not registered`);let v=!1;function f(){if(v)throw new Error("Only valid while executing the command")}const k=new E.$kh;u.onCancellationRequested(()=>k.complete()),setTimeout(()=>k.complete(),10*1e3),this.i.allowListExtensionWhile(d.extension.identifier,k.p);const L=i.command?await d.validateSlashCommand(i.command):void 0,p=A.$Nd.create(!1);let y;try{const D=d.invoke({prompt:i.message,variables:l.ChatVariable.objectTo(i.variables),slashCommand:L},{history:r.history.map(l.ChatMessage.to)},new R.$dv(N=>{f(),typeof y>"u"&&"content"in N&&(y=p.elapsed());const q=l.ChatResponseProgress.from(d.extension,N);if(!q){this.j.error("Unknown progress type: "+JSON.stringify(N));return}if("placeholder"in N&&"resolvedContent"in N){const V=Promise.all([this.d.$handleProgressChunk(h,q),N.resolvedContent]);(0,E.$Og)(V,u).then(U=>{if(!U)return;const[F,C]=U,I=l.ChatResponseProgress.from(d.extension,C);if(!I){this.j.error("Unknown progress type: "+JSON.stringify(C));return}this.d.$handleProgressChunk(h,I,F??void 0)})}else this.d.$handleProgressChunk(h,q)}),u);return await(0,E.$Og)(Promise.resolve(D).then(N=>{if(N){this.g.set(c,N);let q=this.h.get(c);q||(q=new Map,this.h.set(c,q)),q.set(h,N);const V={firstProgress:y,totalElapsed:p.elapsed()};return{errorDetails:N.errorDetails,timings:V}}else this.g.delete(c)}),u)}catch(D){return this.j.error(D,d.extension),{errorDetails:{message:(0,w.localize)(0,null,(0,P.$Ki)(D)),responseIsIncomplete:!0}}}finally{v=!0,k.complete()}}$releaseSession(o){this.g.delete(o),this.h.delete(o)}async $provideSlashCommands(o,c){const h=this.b.get(o);return h?h.provideSlashCommand(c):[]}$provideFollowups(o,c,h){const i=this.b.get(o);if(!i)return Promise.resolve([]);const r=this.g.get(c);return r?i.provideFollowups(r,h):Promise.resolve([])}$acceptFeedback(o,c,h,i,r){const u=this.b.get(o);if(!u)return;const d=this.h.get(c)?.get(h);if(!d)return;let v;switch(i){case b.InteractiveSessionVoteDirection.Down:v=$.ChatAgentResultFeedbackKind.Unhelpful;break;case b.InteractiveSessionVoteDirection.Up:v=$.ChatAgentResultFeedbackKind.Helpful;break}u.acceptFeedback(Object.freeze(r?{result:d,kind:v,reportIssue:r}:{result:d,kind:v}))}$acceptAction(o,c,h,i){const r=this.b.get(o);if(!r)return;const u=this.h.get(c)?.get(h);u&&i.action.kind!=="vote"&&r.acceptAction(Object.freeze({action:i.action,result:u}))}}e.$Lec=s;class t{constructor(o,c,h,i,r){this.extension=o,this.s=c,this.t=h,this.u=i,this.w=r,this.o=new M.$Rd,this.q=new M.$Rd}acceptFeedback(o){this.o.fire(o)}acceptAction(o){this.q.fire(o)}async validateSlashCommand(o){this.b||(await this.provideSlashCommand(T.CancellationToken.None),(0,m.$Mf)(this.b));const c=this.b.find(h=>h.name===o);if(!c)throw new Error(`Unknown slashCommand: ${o}`);return c}async provideSlashCommand(o){if(!this.a)return[];const c=await this.a.provideSlashCommands(o);return c?(this.b=c,c.map(h=>({name:h.name,description:h.description,followupPlaceholder:h.followupPlaceholder,shouldRepopulate:h.shouldRepopulate,sampleRequest:h.sampleRequest}))):[]}async provideFollowups(o,c){if(!this.d)return[];const h=await this.d.provideFollowups(o,c);return h?h.map(i=>l.ChatFollowup.from(i)):[]}get apiAgent(){let o=!1,c=!1;const h=()=>{o||c||(c=!0,queueMicrotask(()=>{this.t.$updateAgent(this.u,{description:this.g??"",fullName:this.h,icon:this.i?this.i instanceof g.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$BL?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.r}),c=!1}))},i=this;return{get name(){return i.s},get description(){return i.g??""},set description(r){i.g=r,h()},get fullName(){return i.h??i.extension.displayName??i.extension.name},set fullName(r){i.h=r,h()},get iconPath(){return i.i},set iconPath(r){i.i=r,h()},get slashCommandProvider(){return i.a},set slashCommandProvider(r){i.a=r,h()},get followupProvider(){return i.d},set followupProvider(r){i.d=r,h()},get isDefault(){return(0,a.$RF)(i.extension,"defaultChatAgent"),i.j},set isDefault(r){(0,a.$RF)(i.extension,"defaultChatAgent"),i.j=r,h()},get helpTextPrefix(){return(0,a.$RF)(i.extension,"defaultChatAgent"),i.k},set helpTextPrefix(r){if((0,a.$RF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPrefix is only available on the default chat agent");i.k=r,h()},get helpTextPostfix(){return(0,a.$RF)(i.extension,"defaultChatAgent"),i.l},set helpTextPostfix(r){if((0,a.$RF)(i.extension,"defaultChatAgent"),!i.j)throw new Error("helpTextPostfix is only available on the default chat agent");i.l=r,h()},get isSecondary(){return(0,a.$RF)(i.extension,"defaultChatAgent"),i.n},set isSecondary(r){(0,a.$RF)(i.extension,"defaultChatAgent"),i.n=r,h()},get sampleRequest(){return i.m},set sampleRequest(r){i.m=r,h()},get supportIssueReporting(){return(0,a.$RF)(i.extension,"chatAgents2Additions"),i.r},set supportIssueReporting(r){(0,a.$RF)(i.extension,"chatAgents2Additions"),i.r=r,h()},get onDidReceiveFeedback(){return i.o.event},onDidPerformAction:(0,a.$QF)(this.extension,"chatAgents2Additions")?this.q.event:void 0,dispose(){o=!0,i.a=void 0,i.d=void 0,i.o.dispose(),i.t.$unregisterAgent(i.u)}}}invoke(o,c,h,i){return this.w(o,c,h,i)}}}),define(Pe[235],Re([1,0,19,6,3,8,72,22,14,5]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kec=void 0;class R{constructor(b,a){this.stream=new g.$qh,this.stream=a??new g.$qh;const s=this;this.apiObj={option:b,response:s.stream.asyncIterable}}}class S{constructor(b,a){this.a=new w.$Rd,this.b=new Map,this.c=new g.$qh,this.d=!1;const s=this;this.apiObject={result:b,response:s.c.asyncIterable,onDidStartResponseStream:s.a.event,cancel(){a.cancel()}},b.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,t]of this.b)t.stream.resolve();else this.c.resolve()})}handleFragment(b){if(this.d)return;let a=this.b.get(b.index);a||(this.b.size===0?a=new R(b.index,this.c):a=new R(b.index),this.b.set(b.index,a),this.a.fire(a.apiObj)),a.stream.emitOne(b.part)}}class l{static{this.a=1}constructor(b,a){this.d=a,this.c=new Map,this.e=new Map,this.f=new m.$fm,this.b=b.getProxy(P.$EK.MainThreadChatProvider)}registerProvider(b,a,s,t){const n=l.a++;return this.c.set(n,{extension:b,provider:s}),this.b.$registerProvider(n,a,{extension:b,displayName:t.name??b.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(n),this.c.delete(n)})}async $provideChatResponse(b,a,s,t,n){const o=this.c.get(b);if(!o)return;const c=new A.$dv(async h=>{if(n.isCancellationRequested){this.d.warn(`[CHAT](${o.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:h.index,part:h.part})});return o.provider.provideChatResponse(s.map(M.ChatMessage.to),t,c,n)}allowListExtensionWhile(b,a){this.f.set(b,a),a.finally(()=>this.f.delete(b))}async requestChatResponseProvider(b,a){if(!this.f.has(b))throw new Error("Extension is NOT allowed to make chat requests");const s=this;return{get isRevoked(){return!s.f.has(b)},makeRequest(t,n,o){if(!s.f.has(b))throw new Error("Access to chat has been revoked");const c=new E.$2d(o),h=Math.random()*1e6|0,i=s.b.$fetchResponse(b,a,h,t.map(M.ChatMessage.from),n??{},c.token),r=new S(i,c);return s.e.set(h,{res:r}),i.finally(()=>{s.e.delete(h)}),r.apiObject}}}async $handleResponseFragment(b,a){const s=this.e.get(b);s&&s.res.handleFragment(a)}}e.$Kec=l}),define(Pe[236],Re([1,0,6,3,11,8]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mec=void 0;class A{static{this.a=0}constructor(g){this.b=new Map,this.c=g.getProxy(T.$EK.MainThreadChatVariables)}async $resolveVariable(g,w,R){const S=this.b.get(g);if(S)try{const l=await S.resolver.resolve(S.data.name,{message:w},R);if(l)return l.map(M.ChatVariable.from)}catch(l){(0,P.$1)(l)}}registerVariableResolver(g,w,R,S){const l=A.a++;return this.b.set(l,{extension:g.identifier,data:{name:w,description:R},resolver:S}),this.c.$registerVariable(l,{name:w,description:R}),(0,E.$Pc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Mec=A}),define(Pe[237],Re([1,0,3]),function(pe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nec=void 0;class T{constructor(M){const A=M.getProxy(E.$EK.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(m){return A.$writeText(m)}})}}e.$Nec=T}),define(Pe[32],Re([1,0,16,7,8,26,3,18,15,51,29,92,2,6,4,17,108,24,49,40,60,56,59,33]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8M=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=void 0;let u=class{#e;#t;#i;constructor(p,y,D){this.b=new Map,this.c=new Map,this.#e=p.getProxy(A.$EK.MainThreadCommands),this.d=y,this.#i=D,this.#t=p.getProxy(A.$EK.MainThreadTelemetry),this.converter=new d(this,N=>{const q=this.c.get(N);return q?.result===f.Void?q:void 0},y),this.f=[{processArgument(N){return(0,w.$wh)(N)}},{processArgument(N){return(0,M.$gn)(N,function(q){if(R.$Ds.isIRange(q))return P.Range.to(q);if(S.$Cs.isIPosition(q))return P.Position.to(q);if(R.$Ds.isIRange(q.range)&&l.URI.isUri(q.uri))return P.location.to(q);if(q instanceof t.$fe)return q.buffer.buffer;if(!Array.isArray(q))return q})}}]}registerArgumentProcessor(p){this.f.push(p)}registerApiCommand(p){const y=this.registerCommand(!1,p.id,async(...D)=>{const N=p.args.map((V,U)=>{if(!V.validate(D[U]))throw new Error(`Invalid argument '${V.name}' when running '${p.id}', received: ${typeof D[U]=="object"?JSON.stringify(D[U],null,"	"):D[U]} `);return V.convert(D[U])}),q=await this.executeCommand(p.internalId,...N);return p.result.convert(q,D,this.converter)},void 0,{description:p.description,args:p.args,returns:p.result.description});return this.c.set(p.id,p),new T.$GK(()=>{y.dispose(),this.c.delete(p.id)})}registerCommand(p,y,D,N,q,V){if(this.d.trace("ExtHostCommands#registerCommand",y),!y.trim().length)throw new Error("invalid id");if(this.b.has(y))throw new Error(`command '${y}' already exists`);return this.b.set(y,{callback:D,thisArg:N,metadata:q,extension:V}),p&&this.#e.$registerCommand(y),new T.$GK(()=>{this.b.delete(y)&&p&&this.#e.$unregisterCommand(y)})}executeCommand(p,...y){return this.d.trace("ExtHostCommands#executeCommand",p),this.g(p,y,!0)}async g(p,y,D){if(this.b.has(p))return this.#e.$fireCommandActivationEvent(p),this.h(p,y,!1);{let N=!1;const q=(0,M.$gn)(y,function(V){if(V instanceof T.$HK)return P.Position.from(V);if(V instanceof T.$IK)return P.Range.from(V);if(V instanceof T.$SK)return P.location.from(V);if(T.$5L.isNotebookRange(V))return P.NotebookRange.from(V);if(V instanceof ArrayBuffer)return N=!0,t.$fe.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return N=!0,t.$fe.wrap(V);if(V instanceof t.$fe)return N=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(p,N?new n.$Bv(q):q,D);return(0,w.$wh)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(p,y,!1);throw V}}}async h(p,y,D){const N=this.b.get(p);if(!N)throw new Error("Unknown command");const{callback:q,thisArg:V,metadata:U}=N;if(U?.args)for(let C=0;C<U.args.length;C++)try{(0,E.$Tf)(y[C],U.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${p}' failed. Illegal argument '${U.args[C].name}' - ${U.args[C].description}`)}const F=c.$Nd.create();try{return await q.apply(V,y)}catch(C){if(p===this.converter.delegatingCommandId){const I=this.converter.getActualCommand(...y);I&&(p=I.command)}if(this.d.error(C,p,N.extension?.identifier),!D)throw C;if(N.extension?.identifier){const I=this.#i.onExtensionError(N.extension.identifier,C);this.d.trace("forwarded error to extension?",I,N.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Ki)(C)),this.id=p,this.source=N.extension?.displayName??N.extension?.name}}}finally{this.j(N,p,F.elapsed())}}j(p,y,D){p.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:p.extension.identifier.value,id:new h.$to(y),duration:D})}$executeContributedCommand(p,...y){this.d.trace("ExtHostCommands#$executeContributedCommand",p);const D=this.b.get(p);return D?(y=y.map(N=>this.f.reduce((q,V)=>V.processArgument(q,D.extension?.identifier),N)),this.h(p,y,!0)):Promise.reject(new Error(`Contributed command '${p}' does not exist.`))}getCommands(p=!1){return this.d.trace("ExtHostCommands#getCommands",p),this.#e.$getCommands().then(y=>(p&&(y=y.filter(D=>D[0]!=="_")),y))}$getContributedCommandMetadata(){const p=Object.create(null);for(const[y,D]of this.b){const{metadata:N}=D;N&&(p[y]=N)}return Promise.resolve(p)}};e.$3M=u,e.$3M=u=He([We(0,a.$HM),We(1,g.$hj),We(2,i.$2M)],u),e.$4M=(0,b.$Zh)("IExtHostCommands");class d{constructor(p,y,D){this.d=p,this.f=y,this.g=D,this.delegatingCommandId=`__vsc${(0,r.$kg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(p,y){if(!p)return;const D={$ident:void 0,id:p.command,title:p.title,tooltip:p.tooltip};if(!p.command)return D;const N=this.f(p.command);if(N)D.id=N.internalId,D.arguments=N.args.map((q,V)=>q.convert(p.arguments&&p.arguments[V]));else if((0,m.$Kb)(p.arguments)){const q=`${p.command} /${++this.c}`;this.b.set(q,p),y.add((0,$.$Pc)(()=>{this.b.delete(q),this.g.trace("CommandsConverter#DISPOSE",q)})),D.$ident=q,D.id=this.delegatingCommandId,D.arguments=[q],this.g.trace("CommandsConverter#CREATE",p.command,q)}return D}fromInternal(p){return typeof p.$ident=="string"?this.b.get(p.$ident):{command:p.id,title:p.title,arguments:p.arguments}}getActualCommand(...p){return this.b.get(p[0])}h(...p){const y=this.getActualCommand(...p);return this.g.trace("CommandsConverter#EXECUTE",p[0],y?y.command:"MISSING"),y?this.d.executeCommand(y.command,...y.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${p[0]}`)}}e.$5M=d;class v{static{this.Uri=new v("uri","Uri of a text document",p=>l.URI.isUri(p),p=>p)}static{this.Position=new v("position","A position in a text document",p=>T.$HK.isPosition(p),P.Position.from)}static{this.Range=new v("range","A range in a text document",p=>T.$IK.isRange(p),P.Range.from)}static{this.Selection=new v("selection","A selection in a text document",p=>T.$JK.isSelection(p),P.Selection.from)}static{this.Number=new v("number","",p=>typeof p=="number",p=>p)}static{this.String=new v("string","",p=>typeof p=="string",p=>p)}static{this.StringArray=v.Arr(v.String)}static Arr(p){return new v(`${p.name}_array`,`Array of ${p.name}, ${p.description}`,y=>Array.isArray(y)&&y.every(D=>p.validate(D)),y=>y.map(D=>p.convert(D)))}static{this.CallHierarchyItem=new v("item","A call hierarchy item",p=>p instanceof T.$4K,P.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new v("item","A type hierarchy item",p=>p instanceof T.$lM,P.TypeHierarchyItem.from)}static{this.TestItem=new v("testItem","A VS Code TestItem",p=>p instanceof s.$UM,P.TestItem.from)}constructor(p,y,D,N){this.name=p,this.description=y,this.validate=D,this.convert=N}optional(){return new v(this.name,`(optional) ${this.description}`,p=>p==null||this.validate(p),p=>p===void 0?void 0:p===null?null:this.convert(p))}with(p,y){return new v(p??this.name,y??this.description,this.validate,this.convert)}}e.$6M=v;class f{static{this.Void=new f("no result",p=>p)}constructor(p,y){this.description=p,this.convert=y}}e.$7M=f;class k{constructor(p,y,D,N,q){this.id=p,this.internalId=y,this.description=D,this.args=N,this.result=q}}e.$8M=k}),define(Pe[238],Re([1,0,18,13,2,80,96,35,32,8,7]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gec=void 0;const S=[new g.$8M("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of DocumentHighlight-instances.",$(w.DocumentHighlight.to))),new g.$8M("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$6M.Uri],new g.$7M("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(a,s)=>{if((0,E.$Jb)(a))return;class t extends R.$YK{static to(o){const c=new t(o.name,w.SymbolKind.to(o.kind),o.containerName||"",new R.$SK(s[0],w.Range.to(o.range)));return c.detail=o.detail,c.range=c.location.range,c.selectionRange=w.Range.to(o.selectionRange),c.children=o.children?o.children.map(t.to):[],c}}return a.map(t.to)})),new g.$8M("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$6M.Uri,new g.$6M("options","Formatting options",a=>!0,a=>a)],new g.$7M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$8M("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$6M.Uri,g.$6M.Range,new g.$6M("options","Formatting options",a=>!0,a=>a)],new g.$7M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$8M("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$6M.Uri,g.$6M.Position,new g.$6M("ch","Trigger character",a=>typeof a=="string",a=>a),new g.$6M("options","Formatting options",a=>!0,a=>a)],new g.$7M("A promise that resolves to an array of TextEdits.",$(w.TextEdit.to))),new g.$8M("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$8M("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$8M("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$8M("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Location or LocationLink instances.",b)),new g.$8M("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Location-instances.",$(w.location.to))),new g.$8M("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of Hover-instances.",$(w.Hover.to))),new g.$8M("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$6M.Uri,new g.$6M("position","A position in a text document",a=>Array.isArray(a)&&a.every(s=>R.$HK.isPosition(s)),a=>a.map(w.Position.from))],new g.$7M("A promise that resolves to an array of ranges.",a=>a.map(s=>{let t;for(const n of s.reverse())t=new R.$3K(w.Range.to(n),t);return t}))),new g.$8M("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$6M.String.with("query","Search string")],new g.$7M("A promise that resolves to an array of SymbolInformation-instances.",a=>a.map(w.WorkspaceSymbol.to))),new g.$8M("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of CallHierarchyItem-instances",a=>a.map(w.CallHierarchyItem.to))),new g.$8M("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$6M.CallHierarchyItem],new g.$7M("A promise that resolves to an array of CallHierarchyIncomingCall-instances",a=>a.map(w.CallHierarchyIncomingCall.to))),new g.$8M("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$6M.CallHierarchyItem],new g.$7M("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",a=>a.map(w.CallHierarchyOutgoingCall.to))),new g.$8M("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to a range and placeholder text.",a=>{if(a)return{range:w.Range.to(a.range),placeholder:a.text}})),new g.$8M("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$6M.Uri,g.$6M.Position,g.$6M.String.with("newName","The new symbol name")],new g.$7M("A promise that resolves to a WorkspaceEdit.",a=>{if(a){if(a.rejectReason)throw new Error(a.rejectReason);return w.WorkspaceEdit.to(a)}})),new g.$8M("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$6M.Uri,g.$6M.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$7M("A promise that resolves to an array of DocumentLink-instances.",a=>a.map(w.DocumentLink.to))),new g.$8M("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$6M.Uri],new g.$7M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new R.$WL(a.tokenTypes,a.tokenModifiers)})),new g.$8M("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$6M.Uri],new g.$7M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,A.$_0)(a);if(s.type==="full")return new R.$YL(s.data,void 0)})),new g.$8M("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$6M.Uri,g.$6M.Range.optional()],new g.$7M("A promise that resolves to SemanticTokensLegend.",a=>{if(a)return new R.$WL(a.tokenTypes,a.tokenModifiers)})),new g.$8M("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$6M.Uri,g.$6M.Range],new g.$7M("A promise that resolves to SemanticTokens.",a=>{if(!a)return;const s=(0,A.$_0)(a);if(s.type==="full")return new R.$YL(s.data,void 0)})),new g.$8M("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$6M.Uri,g.$6M.Position,g.$6M.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$6M.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$7M("A promise that resolves to a CompletionList-instance.",(a,s,t)=>{if(!a)return new R.$cL([]);const n=a.suggestions.map(o=>w.CompletionItem.to(o,t));return new R.$cL(n,a.incomplete)})),new g.$8M("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$6M.Uri,g.$6M.Position,g.$6M.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$7M("A promise that resolves to SignatureHelp.",a=>{if(a)return w.SignatureHelp.to(a)})),new g.$8M("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$6M.Uri,g.$6M.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$7M("A promise that resolves to an array of CodeLens-instances.",(a,s,t)=>$(n=>new R.$7K(w.Range.to(n.range),n.command&&t.fromInternal(n.command)))(a))),new g.$8M("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$6M.Uri,new g.$6M("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",a=>R.$IK.isRange(a),a=>R.$JK.isSelection(a)?w.Selection.from(a):w.Range.from(a)),g.$6M.String.with("kind","Code action kind to return code actions for").optional(),g.$6M.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$7M("A promise that resolves to an array of Command-instances.",(a,s,t)=>$(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return t.fromInternal(n.command)}else{const o=new R.$1K(n.title,n.kind?new R.$2K(n.kind):void 0);return n.edit&&(o.edit=w.WorkspaceEdit.to(n.edit)),n.command&&(o.command=t.fromInternal(n.command)),o.isPreferred=n.isPreferred,o}})(a))),new g.$8M("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$6M.Uri],new g.$7M("A promise that resolves to an array of ColorInformation objects.",a=>a?a.map(s=>new R.$iL(w.Range.to(s.range),w.Color.to(s.color))):[])),new g.$8M("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$6M("color","The color to show and insert",a=>a instanceof R.$hL,w.Color.from),new g.$6M("context","Context object with uri and range",a=>!0,a=>({uri:a.uri,range:w.Range.from(a.range)}))],new g.$7M("A promise that resolves to an array of ColorPresentation objects.",a=>a?a.map(w.ColorPresentation.to):[])),new g.$8M("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$6M.Uri,g.$6M.Range],new g.$7M("A promise that resolves to an array of Inlay objects",(a,s,t)=>a.map(w.InlayHint.to.bind(void 0,t)))),new g.$8M("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$6M.Uri],new g.$7M("A promise that resolves to an array of FoldingRange objects",(a,s)=>{if(a)return a.map(w.FoldingRange.to)})),new g.$8M("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$7M("A promise that resolves to an array of NotebookContentProvider static info objects.",$(a=>({viewType:a.viewType,displayName:a.displayName,options:{transientOutputs:a.options.transientOutputs,transientCellMetadata:a.options.transientCellMetadata,transientDocumentMetadata:a.options.transientDocumentMetadata},filenamePattern:a.filenamePattern.map(s=>w.NotebookExclusiveDocumentPattern.to(s))})))),new g.$8M("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$6M.Uri,g.$6M.Range,new g.$6M("context","An InlineValueContext",a=>a&&typeof a.frameId=="number"&&a.stoppedLocation instanceof R.$IK,a=>w.InlineValueContext.from(a))],new g.$7M("A promise that resolves to an array of InlineValue objects",a=>a.map(w.InlineValue.to))),new g.$8M("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$6M("uriOrString","Uri-instance or string (only http/https)",a=>P.URI.isUri(a)||typeof a=="string"&&(0,T.$_f)(a,T.Schemas.http,T.Schemas.https),a=>a),new g.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional(),g.$6M.String.with("label","").optional()],g.$7M.Void),new g.$8M("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$6M.Uri.with("resource","Resource to open"),g.$6M.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="number"||typeof a=="object",a=>a&&(typeof a=="number"?[w.ViewColumn.from(a),void 0]:[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)])).optional()],g.$7M.Void),new g.$8M("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$6M.Uri.with("left","Left-hand side resource of the diff editor"),g.$6M.Uri.with("right","Right-hand side resource of the diff editor"),g.$6M.String.with("title","Human readable title for the diff editor").optional(),new g.$6M("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",a=>a===void 0||typeof a=="object",a=>a&&[w.ViewColumn.from(a.viewColumn),w.TextEditorOpenOptions.from(a)]).optional()],g.$7M.Void),new g.$8M("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$6M.String.with("title","Human readable title for the changes editor"),new g.$6M("resourceList","List of resources to compare",a=>{for(const s of a){if(s.length!==3)return!1;const[t,n,o]=s;if(!P.URI.isUri(t)||!P.URI.isUri(n)&&n!==void 0&&n!==null||!P.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},a=>a)],g.$7M.Void),new g.$8M("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$6M.Uri,g.$6M.Position],new g.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$8M("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$6M.TypeHierarchyItem],new g.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$8M("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$6M.TypeHierarchyItem],new g.$7M("A promise that resolves to an array of TypeHierarchyItem-instances",a=>a.map(w.TypeHierarchyItem.to))),new g.$8M("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$6M.TestItem],g.$7M.Void),new g.$8M("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$6M.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$7M.Void),new g.$8M("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$6M.String.with("name","The context key name"),new g.$6M("value","The context key value",()=>!0,a=>a)],g.$7M.Void),new g.$8M("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$6M.Uri,g.$6M.StringArray,new g.$6M("MappedEditsContext","Mapped Edits Context",a=>w.MappedEditsContext.is(a),a=>w.MappedEditsContext.from(a))],new g.$7M("A promise that resolves to a workspace edit or null",a=>a?w.WorkspaceEdit.to(a):null))];class l{static register(s){S.forEach(s.registerApiCommand,s),this.a(s)}static a(s){s.registerCommand(!1,"_validateWhenClauses",m.$Yi)}}e.$Gec=l;function $(a){return s=>{if(Array.isArray(s))return s.map(a)}}function b(a){if(!Array.isArray(a))return;const s=[];for(const t of a)M.$pt(t)?s.push(w.DefinitionLink.to(t)):s.push(w.location.to(t));return s}}),define(Pe[239],Re([1,0,14,66,5,6,2,80,22,8,7,3,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qec=void 0;function $(b,a,s){const t=b.getProxy(S.$EK.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$fm,a.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===6){const k=this.b.get(f.handle);return k?k.value:f}else if(f&&f.$mid===7){const k=this.b.get(f.commentControlHandle);if(!k)return f;const L=k.getCommentThread(f.commentThreadHandle);return L?L.value:f}else if(f&&(f.$mid===9||f.$mid===8)){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const L=k.getCommentThread(f.thread.commentThreadHandle);return L?f.$mid===8?L.value:{thread:L.value,text:f.text}:f}else if(f&&f.$mid===10){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const L=k.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const p=f.commentUniqueId,y=L.getCommentByUniqueId(p);return y||f}else if(f&&f.$mid===11){const k=this.b.get(f.thread.commentControlHandle);if(!k)return f;const L=k.getCommentThread(f.thread.commentThreadHandle);if(!L)return f;const p=f.text,y=f.commentUniqueId,D=L.getCommentByUniqueId(y);return D?(typeof D.body=="string"?D.body=p:D.body=new R.$8K(p),D):f}return f}})}createCommentController(f,k,L){const p=n.a++,y=new c(f,p,k,L);this.b.set(y.handle,y);const D=this.c.get(f.identifier)||[];return D.push(y),this.c.set(f.identifier,D),y.value}async $createCommentThreadTemplate(f,k,L){const p=this.b.get(f);p&&p.$createCommentThreadTemplate(k,L)}async $updateCommentThreadTemplate(f,k,L){const p=this.b.get(f);p&&p.$updateCommentThreadTemplate(k,L)}$deleteCommentThread(f,k){this.b.get(f)?.$deleteCommentThread(k)}$provideCommentingRanges(f,k,L){const p=this.b.get(f);if(!p||!p.commentingRangeProvider)return Promise.resolve(void 0);const y=s.getDocument(A.URI.revive(k));return(0,E.$Sg)(async()=>{const D=await p.commentingRangeProvider.provideCommentingRanges(y,L);let N;return Array.isArray(D)?N={ranges:D,fileComments:!1}:D?N={ranges:D.ranges||[],fileComments:D.fileComments||!1}:N=D??void 0,N}).then(D=>{let N;return D&&(N={ranges:D.ranges.map(q=>w.Range.from(q)),fileComments:D.fileComments}),N})}$toggleReaction(f,k,L,p,y){const D=this.b.get(f);return!D||!D.reactionHandler?Promise.resolve(void 0):(0,E.$Sg)(()=>{const N=D.getCommentThread(k);if(N){const q=N.getCommentByUniqueId(p.uniqueIdInThread);if(D!==void 0&&q&&D.reactionHandler)return D.reactionHandler(q,r(y))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(f){this.n=f}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(f){(f===void 0!=(this.p===void 0)||!f||!this.p||!f.isEqual(this.p))&&(this.p=f,this.b.range=f,this.c.fire())}get range(){return this.p}set canReply(f){this.d!==f&&(this.d=f,this.b.canReply=f,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(f){this.e=f,this.b.label=f,this.c.fire()}get contextValue(){return this.f}set contextValue(f){this.f=f,this.b.contextValue=f,this.c.fire()}get comments(){return this.q}set comments(f){this.q=f,this.b.comments=f,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(f){this.g=f,this.b.collapsibleState=f,this.c.fire()}get state(){return this.h}set state(f){this.h=f,this.b.state=f,this.c.fire()}get isDisposed(){return this.j}constructor(f,k,L,p,y,D,N,q){this.m=k,this.n=L,this.o=p,this.p=y,this.q=D,this.extensionDescription=N,this.r=q,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new P.$Rd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new M.$Sc,this.l.value=new M.$Qc,this.n===void 0&&(this.n=`${f}.${this.handle}`),t.$createCommentThread(k,this.handle,this.n,this.o,w.Range.from(this.p),N.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=D,this.i.push({dispose:()=>{t.$deleteCommentThread(k,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new M.$Qc);const f=L=>Object.prototype.hasOwnProperty.call(this.b,L),k={};f("range")&&(k.range=w.Range.from(this.p)),f("label")&&(k.label=this.label),f("contextValue")&&(k.contextValue=this.contextValue??null),f("comments")&&(k.comments=this.q.map(L=>h(this,L,this.k,this.extensionDescription))),f("collapsibleState")&&(k.collapseState=u(this.g)),f("canReply")&&(k.canReply=this.canReply),f("state")&&(k.state=d(this.h)),f("isTemplate")&&(k.isTemplate=this.r),this.b={},t.$updateCommentThread(this.m,this.handle,this.n,this.o,k)}getCommentByUniqueId(f){for(const k of this.k){const L=k[0],p=k[1];if(f===p)return L}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(f=>f.dispose())}}He([(0,T.$sh)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(f){this.b=f,t.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(f){this.c=f,t.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this.d}set options(f){this.d=f,t.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(f,k,L,p){this.f=f,this.g=k,this.h=L,this.i=p,this.a=new Map,t.$registerCommentController(this.handle,L,p,this.f.identifier.value);const y=this;this.value=Object.freeze({id:y.id,label:y.label,get options(){return y.options},set options(D){y.options=D},get commentingRangeProvider(){return y.commentingRangeProvider},set commentingRangeProvider(D){y.commentingRangeProvider=D},get reactionHandler(){return y.reactionHandler},set reactionHandler(D){y.reactionHandler=D},createCommentThread(D,N,q){return y.createCommentThread(D,N,q).value},dispose:()=>{y.dispose()}}),this.e=[],this.e.push({dispose:()=>{t.$unregisterCommentController(this.handle)}})}createCommentThread(f,k,L){k===void 0&&(0,l.$RF)(this.f,"fileComments");const p=new o(this.id,this.handle,void 0,f,k,L,this.f,!1);return this.a.set(p.handle,p),p}$createCommentThreadTemplate(f,k){const L=new o(this.id,this.handle,void 0,A.URI.revive(f),w.Range.to(k),[],this.f,!0);return L.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(L.handle,L),L}$updateCommentThreadTemplate(f,k){const L=this.a.get(f);L&&(L.range=w.Range.to(k))}$deleteCommentThread(f){this.a.get(f)?.dispose(),this.a.delete(f)}getCommentThread(f){return this.a.get(f)}dispose(){this.a.forEach(f=>{f.dispose()}),this.e.forEach(f=>f.dispose())}}function h(v,f,k,L){let p=k.get(f);return p||(p=++v.commentHandle,k.set(f,p)),f.state!==void 0&&(0,l.$RF)(L,"commentsDraftState"),{mode:f.mode,contextValue:f.contextValue,uniqueIdInThread:p,body:typeof f.body=="string"?f.body:w.MarkdownString.from(f.body),userName:f.author.name,userIconPath:f.author.iconPath,label:f.label,commentReactions:f.reactions?f.reactions.map(y=>i(y)):void 0,state:f.state,timestamp:f.timestamp?.toJSON()}}function i(v){return{label:v.label,iconPath:v.iconPath?w.$GM(v.iconPath):void 0,count:v.count,hasReacted:v.authorHasReacted}}function r(v){return{label:v.label||"",count:v.count||0,iconPath:v.iconPath?A.URI.revive(v.iconPath):"",authorHasReacted:v.hasReacted||!1}}function u(v){if(v!==void 0)switch(v){case R.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function d(v){if(v!==void 0)switch(v){case R.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new n}e.$Qec=$}),define(Pe[240],Re([1,0,26,3,27,17]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;let A=class{constructor(R,S){this.a=R.getProxy(T.$EK.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(R,S){const l=this,$=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){l.e(R,S,$,arguments)}})}e(R,S,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:g($,this.b)}),this.c&&this.f(R,l,$)}};e.$Egc=A,e.$Egc=A=He([We(0,M.$HM),We(1,P.$XM)],A);const m=1e5;function g(w,R){const S=[];if(w.length)for(let l=0;l<w.length;l++){let $=w[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const b=$;b.stack?$=b.stack:$=b.toString()}S.push($)}if(R){const l=new Error().stack;l&&S.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,E.$jn)(S);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Pe[110],Re([1,0,2,3,7,4,17,15,18,12,20,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hfc=e.$Gfc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(a,s){this.h=s,this.f=new Map,this.g=a.getProxy(T.$EK.MainThreadDecorations)}registerFileDecorationProvider(a,s){const t=l.c++;this.f.set(t,{provider:a,extensionDescription:s}),this.g.$registerDecorationProvider(t,s.identifier.value);const n=a.onDidChangeFileDecorations&&a.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(t,null);return}const c=(0,g.$2b)(o);if(c.length<=l.d){this.g.$onDidChange(t,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",s.identifier.value,c.length);const h=c.map(u=>({uri:u,rank:(0,w.$Ke)(u.path,"/")})),i=(0,g.$yb)(h,(u,d)=>u.rank-d.rank||(0,w.$Ye)(u.uri.path,d.uri.path)),r=[];e:for(const u of i){let d;for(const v of u){const f=(0,R.$lc)(v.uri.path);if(d!==f&&(d=f,r.push(v.uri)>=l.d))break e}}this.g.$onDidChange(t,r)});return new P.$GK(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(a,s,t){if(!this.f.has(a))return Object.create(null);const n=Object.create(null),{provider:o,extensionDescription:c}=this.f.get(a);return await Promise.all(s.map(async h=>{try{const{uri:i,id:r}=h,u=await Promise.resolve(o.provideFileDecoration(E.URI.revive(i),t));if(!u)return;try{P.$3L.validate(u),u.badge&&typeof u.badge!="string"&&(0,S.$RF)(c,"codiconDecoration"),n[r]=[u.propagate,u.tooltip,u.badge,u.color]}catch(d){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${d}`)}}catch(i){this.h.error(i)}})),n}};e.$Gfc=$,e.$Gfc=$=l=He([We(0,A.$HM),We(1,m.$hj)],$),e.$Hfc=(0,M.$Zh)("IExtHostDecorations")}),define(Pe[241],Re([1,0,157,99,2,3,7,8,5,15,28,43]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bec=e.$Aec=void 0;class ${#e;#t;#i;constructor(s,t,n,o,c,h,i,r){this.d=s,this.e=t,this.f=n,this.g=o,this.h=c,this.c=!1,this.f=Math.max(o,n),this.#i=new R.$zc(u=>h.getComparisonKey(u)),this.#e=i,this.#t=r}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(s,t){if(!s){this.clear();return}this.j();let n=[];if(P.URI.isUri(s)){if(!t){this.delete(s);return}this.#i.set(s,t.slice()),n=[s]}else if(Array.isArray(s)){n=[];let h;s=[...s].sort($.k);for(const i of s){const[r,u]=i;if((!h||r.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=r,n.push(r),this.#i.set(r,[])),u)this.#i.get(r)?.push(...u);else{const d=this.#i.get(r);d&&(d.length=0)}}}if(this.#t.fire(n),!this.#e)return;const o=[];let c=0;for(const h of n){let i=[];const r=this.#i.get(h);if(r)if(r.length>this.g){i=[];const u=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const v of r)if(v.severity===u[d]&&i.push({...m.Diagnostic.from(v),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:T.MarkerSeverity.Info,message:(0,E.localize)(0,null,r.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=r.map(u=>({...m.Diagnostic.from(u),modelVersionId:this.h(h)}));if(o.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,o)}delete(s){this.j(),this.#t.fire([s]),this.#i.delete(s),this.#e?.$changeMany(this.e,[[s,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(s,t){this.j();for(const[n,o]of this)s.call(t,n,o,this)}*[Symbol.iterator](){this.j();for(const s of this.#i.keys())yield[s,this.get(s)]}get(s){this.j();const t=this.#i.get(s);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(s){return this.j(),Array.isArray(this.#i.get(s))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(s,t){return s[0].toString()<t[0].toString()?-1:s[0].toString()>t[0].toString()?1:0}}e.$Aec=$;let b=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(s){const t=new R.$zc;for(const n of s)t.set(n,n);return{uris:Object.freeze(Array.from(t.values()))}}constructor(s,t,n,o){this.j=t,this.k=n,this.l=o,this.g=new Map,this.h=new g.$Vd({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=s.getProxy(M.$EK.MainThreadDiagnostics)}createDiagnosticCollection(s,t){const{g:n,f:o,h:c,j:h,k:i,l:r}=this,u=new class{$changeMany(f,k){o.$changeMany(f,k),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",s.value,f,k.length===0?"CLEARING":k)}$clear(f){o.$clear(f),h.trace("[DiagnosticCollection] remove all (extension, owner)",s.value,f)}dispose(){o.dispose()}};let d;if(!t)t="_generated_diagnostic_collection_name_#"+l.c++,d=t;else if(!n.has(t))d=t;else{this.j.warn(`DiagnosticCollection with name '${t}' does already exist.`);do d=t+l.c++;while(n.has(d))}return new class extends ${constructor(){super(t,d,l.e,l.d,f=>r.getDocument(f)?.version,i.extUri,u,c),n.set(d,this)}dispose(){super.dispose(),n.delete(d)}}}getDiagnostics(s){if(s)return this.m(s);{const t=new Map,n=[];for(const o of this.g.values())o.forEach((c,h)=>{let i=t.get(c.toString());typeof i>"u"&&(i=n.length,t.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...h)});return n}}m(s){let t=[];for(const n of this.g.values())n.has(s)&&(t=t.concat(n.get(s)));return t}$acceptMarkersChange(s){if(!this.n){const t="_generated_mirror",n=new $(t,t,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(t,n),this.n=n}for(const[t,n]of s)this.n.set(P.URI.revive(t),n.map(m.Diagnostic.to))}};e.$Bec=b,e.$Bec=b=l=He([We(1,w.$hj),We(2,S.$zec)],b)}),define(Pe[242],Re([1,0,2,3,23]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ifc=void 0;class M{constructor(m){this.a=m.getProxy(T.$EK.MainThreadDialogs)}showOpenDialog(m,g){return g?.allowUIResources&&(0,P.$RF)(m,"showLocal"),this.a.$showOpenDialog(g).then(w=>w?w.map(R=>E.URI.revive(R)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(g=>g?E.URI.revive(g):void 0)}}e.$Ifc=M}),define(Pe[243],Re([1,0,11,2,7,3,13,19,12]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jfc=void 0;class w{static{this.a=0}constructor(S,l,$){this.d=l,this.e=$,this.b=new Map,this.c=S.getProxy(M.$EK.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,l){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const $=w.a++;this.b.set($,l),this.c.$registerTextContentProvider($,S);let b;return typeof l.onDidChange=="function"&&(b=l.onDidChange(a=>{if(a.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this.d.getDocument(a)&&this.$provideTextDocumentContent($,a).then(s=>{if(!s&&typeof s!="string")return;const t=this.d.getDocument(a);if(!t)return;const n=(0,g.$Te)(s);if(!t.equalLines(n))return this.c.$onVirtualDocumentChange(a,s)},E.$Z)})),new P.$GK(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),b&&(b.dispose(),b=void 0)})}$provideTextDocumentContent(S,l){const $=this.b.get(S);return $?Promise.resolve($.provideTextDocumentContent(T.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Jfc=w}),define(Pe[244],Re([1,0,5,6,2,3,103,8,16,26,7,11]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xec=void 0;class l{constructor(b,a){this.a=new E.$Rd({onListenerError:S.$1}),this.b=new E.$Rd({onListenerError:S.$1}),this.c=new E.$Rd({onListenerError:S.$1}),this.d=new E.$Rd({onListenerError:S.$1}),this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new T.$Qc,this.h=new Map,this.f=b.getProxy(M.$EK.MainThreadDocuments),this.g=a,this.g.onDidRemoveDocuments(s=>{for(const t of s)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const t of s)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(b){if(!b)return;const a=this.g.getDocument(b);if(a)return a}getDocument(b){const a=this.getDocumentData(b);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${b}'`);return a.document}ensureDocumentData(b){const a=this.g.getDocument(b);if(a)return Promise.resolve(a);let s=this.h.get(b.toString());return s||(s=this.f.$tryOpenDocument(b).then(t=>{this.h.delete(b.toString());const n=P.URI.revive(t);return(0,g.$Nf)(this.g.getDocument(n))},t=>(this.h.delete(b.toString()),Promise.reject(t))),this.h.set(b.toString(),s)),s}createDocumentData(b){return this.f.$tryCreateDocument(b).then(a=>P.URI.revive(a))}$acceptModelLanguageChanged(b,a){const s=P.URI.revive(b),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(a),this.a.fire(t.document)}$acceptModelSaved(b){const a=P.URI.revive(b),s=this.g.getDocument(a);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(b,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(b,a){const s=P.URI.revive(b),t=this.g.getDocument(s);if(!t)throw new Error("unknown document");t._acceptIsDirty(a),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(b,a,s){const t=P.URI.revive(b),n=this.g.getDocument(t);if(!n)throw new Error("unknown document");n._acceptIsDirty(s),n.onEvents(a);let o;a.isUndoing?o=R.TextDocumentChangeReason.Undo:a.isRedoing&&(o=R.TextDocumentChangeReason.Redo),this.c.fire((0,w.$fn)({document:n.document,contentChanges:a.changes.map(c=>({range:m.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:o}))}setWordDefinitionFor(b,a){(0,A.$JM)(b,a)}}e.$xec=l}),define(Pe[61],Re([1,0,53,5,6,2,4,3,103,17,109,8,15,28,13,67,39]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SM=e.$RM=void 0;class t{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new $.$zc,this.d=new T.$Rd,this.e=new T.$Rd,this.f=new T.$Rd,this.g=new T.$Rd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],r=[];if(c.removedDocuments)for(const u of c.removedDocuments){const d=M.URI.revive(u),v=this.c.get(d);v?.unref()&&(this.c.delete(d),h.push(v.value))}if(c.addedDocuments)for(const u of c.addedDocuments){const d=M.URI.revive(u.uri);let v=this.c.get(d);if(v&&d.scheme!==b.Schemas.vscodeNotebookCell&&d.scheme!==b.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);v||(v=new t(new g.$KM(this.h.getProxy(m.$EK.MainThreadDocuments),d,u.lines,u.EOL,u.versionId,u.languageId,u.isDirty,u.notebook)),this.c.set(d,v),i.push(v.value)),v.ref()}if(c.removedEditors)for(const u of c.removedEditors){const d=this.b.get(u);this.b.delete(u),d&&r.push(d)}if(c.addedEditors)for(const u of c.addedEditors){const d=M.URI.revive(u.documentUri);E.ok(this.c.has(d),`document '${d}' does not exist`),E.ok(!this.b.has(u.id),`editor '${u.id}' already exists!`);const v=this.c.get(d).value,f=new R.$QM(u.id,this.h.getProxy(m.$EK.MainThreadTextEditors),this.i,new s.$U(()=>v.document),u.selections.map(S.Selection.to),u.options,u.visibleRanges.map(k=>S.Range.to(k)),typeof u.editorPosition=="number"?S.ViewColumn.to(u.editorPosition):void 0);this.b.set(u.id,f)}c.newActiveEditor!==void 0&&(E.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,P.$Mc)(h),(0,P.$Mc)(r),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(u=>u.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return a.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$RM=n,e.$RM=n=He([We(0,w.$HM),We(1,l.$hj)],n),e.$SM=(0,A.$Zh)("IExtHostDocumentsAndEditors")}),define(Pe[62],Re([1,0,245,5,16,2,4,3,17,8,7]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$ec=e.$0ec=void 0,e.$0ec=(0,A.$Zh)("IExtHostEditorTabs");class S{constructor(s,t,n){this.e=n,this.d=t,this.acceptDtoUpdate(s)}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.id===s.e()},get label(){return s.b.label},get input(){return s.c},get isDirty(){return s.b.isDirty},get isPinned(){return s.b.isPinned},get isPreview(){return s.b.isPreview},get group(){return s.d.apiObject}};this.a=Object.freeze(t)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(s){this.b=s,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new R.$mM(M.URI.revive(this.b.input.uri));case 2:return new R.$nM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified));case 3:return new R.$oM(M.URI.revive(this.b.input.base),M.URI.revive(this.b.input.input1),M.URI.revive(this.b.input.input2),M.URI.revive(this.b.input.result));case 6:return new R.$pM(M.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new R.$qM(this.b.input.viewType);case 4:return new R.$rM(M.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new R.$sM(M.URI.revive(this.b.input.original),M.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new R.$tM;case 9:return new R.$uM(M.URI.revive(this.b.input.uri),M.URI.revive(this.b.input.inputBoxUri));case 10:return new R.$vM(this.b.input.providerId);default:return}}}class l{constructor(s,t){this.c=[],this.d="",this.b=s,this.e=t;for(const n of s.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const s=this,t={get isActive(){return s.b.groupId===s.e()},get viewColumn(){return w.ViewColumn.to(s.b.viewColumn)},get activeTab(){return s.c.find(n=>n.tabId===s.d)?.apiObject},get tabs(){return Object.freeze(s.c.map(n=>n.apiObject))}};this.a=Object.freeze(t)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(s){this.b=s}acceptTabOperation(s){if(s.kind===0){const n=new S(s.tabDto,this,()=>this.activeTabId());return this.c.splice(s.index,0,n),s.tabDto.isActive&&(this.d=n.tabId),n}else if(s.kind===1){const n=this.c.splice(s.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${s.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(s.kind===3){if(s.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(s.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${s.oldIndex} which does not exist`);return this.c.splice(s.index,0,n),n}const t=this.c.find(n=>n.tabId===s.tabDto.id);if(!t)throw new Error("INVALID tab");return s.tabDto.isActive?this.d=s.tabDto.id:this.d===s.tabDto.id&&!s.tabDto.isActive&&(this.d=""),t.acceptDtoUpdate(s.tabDto),t}activeTabId(){return this.d}}let $=class{constructor(s){this.b=new T.$Rd,this.c=new T.$Rd,this.e=[],this.a=s.getProxy(m.$EK.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const s=this,t={onDidChangeTabGroups:s.c.event,onDidChangeTabs:s.b.event,get all(){return Object.freeze(s.e.map(n=>n.apiObject))},get activeTabGroup(){const n=s.d;return(0,P.$Nf)(s.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,o)=>{const c=Array.isArray(n)?n:[n];return c.length?b(c[0])?this.j(c,o):this.i(c,o):!0}};this.f=Object.freeze(t)}return this.f}$acceptEditorTabModel(s){const t=new Set(this.e.map(u=>u.groupId)),n=new Set(s.map(u=>u.groupId)),o=(0,E.$K)(t,n),c=this.e.filter(u=>o.removed.includes(u.groupId)).map(u=>u.apiObject),h=[],i=[];this.e=s.map(u=>{const d=new l(u,()=>this.d);return o.added.includes(d.groupId)?h.push(d.apiObject):i.push(d.apiObject),d});const r=(0,P.$Nf)(s.find(u=>u.isActive===!0)?.groupId);r!==void 0&&this.d!==r&&(this.d=r),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(s){const t=this.e.find(n=>n.groupId===s.groupId);if(!t)throw new Error("Update Group IPC call received before group creation.");t.acceptGroupDtoUpdate(s),s.isActive&&(this.d=s.groupId),this.c.fire(Object.freeze({changed:[t.apiObject],opened:[],closed:[]}))}$acceptTabOperation(s){const t=this.e.find(o=>o.groupId===s.groupId);if(!t)throw new Error("Update Tabs IPC call received before group creation.");const n=t.acceptTabOperation(s);switch(s.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(s){for(const t of this.e)for(const n of t.tabs)if(n.apiObject===s)return n}h(s){return this.e.find(t=>t.apiObject===s)}async i(s,t){const n=[];for(const o of s){const c=this.g(o);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,t)}async j(s,t){const n=[];for(const o of s){const c=this.h(o);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,t)}};e.$$ec=$,e.$$ec=$=He([We(0,g.$HM)],$);function b(a){return a.tabs!==void 0}}),define(Pe[246],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lfc=void 0;class P{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(E.$EK.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,m,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const w=this.a.get(A);if(!w)throw new Error("Embedding vector provider not found");const R=await w.provideEmbeddingVector(m,g);if(!R)throw new Error("Embedding vector provider returned undefined");return R}registerEmbeddingVectorProvider(A,m,g){const w=this.b;return this.b++,this.a.set(w,g),this.c.$registerAiEmbeddingVectorProvider(m,w),new T.$GK(()=>{this.c.$unregisterAiEmbeddingVectorProvider(w),this.a.delete(w)})}}e.$Lfc=P}),define(Pe[247],Re([1,0,2,3,6,7,8,295,12,24,23,52]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mfc=void 0;class l{constructor(){this.a=[]}add(a){this.b=void 0,this.a.push(a)}delete(a){const s=this.a.indexOf(a);s>=0&&(this.a.splice(s,1),this.b=void 0)}c(){if(!this.b){const a=this.a.sort(),s=[];let t,n,o=14,c=14;for(const h of a){let i=t?(0,g.$8e)(t,h):0;for(i===0?n=1:n=c;i<h.length;i++)i+1===h.length?(o=c,c=9):c+=1,s.push([n,h.toUpperCase().charCodeAt(i),c]),s.push([n,h.toLowerCase().charCodeAt(i),c]),n=c;t=h,c=o}s.push([9,58,10]),s.push([10,47,12]),this.b=new m.$bZ(s)}}provideDocumentLinks(a){this.c();const s=[],t=m.$cZ.computeLinks({getLineContent(n){return a.lineAt(n-1).text},getLineCount(){return a.lineCount}},this.b);for(const n of t){const o=A.DocumentLink.to(n);o.target&&s.push(o)}return s}}class ${constructor(a,s){this.i=s,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=a.getProxy(T.$EK.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(a,s,t,n={}){if($.j(t),this.d.has(s))throw new Error(`a provider for the scheme '${s}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(a,"*",this.b));const o=this.h++;this.b.add(s),this.d.add(s),this.c.set(o,t);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof t.copy=="function"&&(c+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,R.$RF)(a,"fsChunks"),c+=4);let h;n.isReadonly&&(0,S.$ck)(n.isReadonly)&&((0,R.$RF)(a,"readonlyMessage"),h={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(o,s,c,h).catch(r=>{console.error(`FAILED to register filesystem provider of ${a.identifier.value}-extension for the scheme ${s}`),console.error(r)});const i=t.onDidChangeFile(r=>{const u=[];for(const d of r){const{uri:v,type:f}=d;if(v.scheme!==s)continue;let k;switch(f){case M.FileChangeType.Changed:k=0;break;case M.FileChangeType.Created:k=1;break;case M.FileChangeType.Deleted:k=2;break;default:throw new Error("Unknown FileChangeType")}u.push({resource:v,type:k})}this.a.$onFileSystemChange(o,u)});return(0,P.$Pc)(()=>{i.dispose(),this.b.delete(s),this.d.delete(s),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(a){if(!a)throw new Error("MISSING provider");if(typeof a.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof a.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof a.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof a.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof a.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof a.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof a.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof a.rename!="function")throw new Error("Provider does NOT implement rename")}static k(a){const{type:s,ctime:t,mtime:n,size:o,permissions:c}=a;return{type:s,ctime:t,mtime:n,size:o,permissions:c}}$stat(a,s){return Promise.resolve(this.l(a).stat(E.URI.revive(s))).then(t=>$.k(t))}$readdir(a,s){return Promise.resolve(this.l(a).readDirectory(E.URI.revive(s)))}$readFile(a,s){return Promise.resolve(this.l(a).readFile(E.URI.revive(s))).then(t=>w.$fe.wrap(t))}$writeFile(a,s,t,n){return Promise.resolve(this.l(a).writeFile(E.URI.revive(s),t.buffer,n))}$delete(a,s,t){return Promise.resolve(this.l(a).delete(E.URI.revive(s),t))}$rename(a,s,t,n){return Promise.resolve(this.l(a).rename(E.URI.revive(s),E.URI.revive(t),n))}$copy(a,s,t,n){const o=this.l(a);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(E.URI.revive(s),E.URI.revive(t),n))}$mkdir(a,s){return Promise.resolve(this.l(a).createDirectory(E.URI.revive(s)))}$watch(a,s,t,n){const o=this.l(a).watch(E.URI.revive(t),n);this.f.set(s,o)}$unwatch(a,s){const t=this.f.get(s);t&&(t.dispose(),this.f.delete(s))}$open(a,s,t){const n=this.l(a);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(E.URI.revive(s),t))}$close(a,s){const t=this.l(a);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(s))}$read(a,s,t,n){const o=this.l(a);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const c=w.$fe.alloc(n);return Promise.resolve(o.read(s,t,c.buffer,0,n)).then(h=>c.slice(0,h))}$write(a,s,t,n){const o=this.l(a);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(s,t,n.buffer,0,n.byteLength))}l(a){const s=this.c.get(a);if(!s){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return s}}e.$Mfc=$}),define(Pe[63],Re([1,0,3,42,7,24,4,17,43,6,14,25,13]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zec=e.$Yec=void 0;let b=$=class{constructor(s,t){this.b=new Map,this.c=new R.$9g,this.a=s.getProxy(E.$EK.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(o){try{let c;const h=n.b.get(o.scheme);return h?(await n.a.$ensureActivation(o.scheme),c=await h.impl.stat(o)):c=await n.a.$stat(o),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===T.FilePermission.Readonly?1:void 0}}catch(c){$.e(c)}},async readDirectory(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readDirectory(o)).slice()):await n.a.$readdir(o)}catch(c){return $.e(c)}},async createDirectory(o){try{const c=n.b.get(o.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(c.impl,c.extUri,o)):await n.a.$mkdir(o)}catch(c){return $.e(c)}},async readFile(o){try{const c=n.b.get(o.scheme);return c?(await n.a.$ensureActivation(o.scheme),(await c.impl.readFile(o)).slice()):(await n.a.$readFile(o)).buffer}catch(c){return $.e(c)}},async writeFile(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await n.d(h.impl,h.extUri,h.extUri.dirname(o)),await n.c.queueFor(o).queue(()=>Promise.resolve(h.impl.writeFile(o,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(o,M.$fe.wrap(c))}catch(h){return $.e(h)}},async delete(o,c){try{const h=n.b.get(o.scheme);return h&&!h.isReadonly?(await n.a.$ensureActivation(o.scheme),await h.impl.delete(o,{recursive:!1,...c})):await n.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return $.e(h)}},async rename(o,c,h){try{return await n.a.$rename(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},async copy(o,c,h){try{return await n.a.$copy(o,c,{overwrite:!1,...h})}catch(i){return $.e(i)}},isWritableFileSystem(o){const c=t.getCapabilities(o);if(typeof c=="number")return!(c&2048)}})}async d(s,t,n){const o=[];for(;!t.isEqual(n,t.dirname(n));)try{if(!((await s.stat(n)).type&T.FileType.Directory))throw P.$UL.FileExists(`Unable to create folder '${n.scheme===l.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(T.$yk(c)!==T.FileSystemProviderErrorCode.FileNotFound)throw c;o.push(t.basename(n)),n=t.dirname(n)}for(let c=o.length-1;c>=0;c--){n=t.joinPath(n,o[c]);try{await s.createDirectory(n)}catch(h){if(T.$yk(h)!==T.FileSystemProviderErrorCode.FileExists)throw h}}}static e(s){if(s instanceof P.$UL)throw s;if(s instanceof T.$uk)switch(s.code){case T.FileSystemProviderErrorCode.FileExists:throw P.$UL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$UL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$UL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$UL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$UL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$UL.Unavailable(s.message);default:throw new P.$UL(s.message,s.name)}if(!(s instanceof Error))throw new P.$UL(String(s));if(s.name==="ENOPRO"||s.message.includes("ENOPRO"))throw P.$UL.Unavailable(s.message);switch(s.name){case T.FileSystemProviderErrorCode.FileExists:throw P.$UL.FileExists(s.message);case T.FileSystemProviderErrorCode.FileNotFound:throw P.$UL.FileNotFound(s.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw P.$UL.FileNotADirectory(s.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw P.$UL.FileIsADirectory(s.message);case T.FileSystemProviderErrorCode.NoPermissions:throw P.$UL.NoPermissions(s.message);case T.FileSystemProviderErrorCode.Unavailable:throw P.$UL.Unavailable(s.message);default:throw new P.$UL(s.message,s.name)}}addFileSystemProvider(s,t,n){return this.b.set(s,{impl:t,extUri:n?.isCaseSensitive?S.$rg:S.$tg,isReadonly:!!n?.isReadonly}),(0,w.$Pc)(()=>this.b.delete(s))}getFileSystemProviderExtUri(s){return this.b.get(s)?.extUri??S.$rg}};e.$Yec=b,e.$Yec=b=$=He([We(0,m.$HM),We(1,g.$zec)],b),e.$Zec=(0,A.$Zh)("IExtHostConsumerFileSystem")}),define(Pe[248],Re([1,0,5,34,2,3,8,7,39]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nfc=void 0;class w{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,b,a,s,t,n){this.a=Math.random(),this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const o=(0,T.$Gj)(t),c=typeof t=="string",h=n?.correlate,i=s(r=>{if(!(typeof r.session=="number"&&r.session!==this.a)&&!(h&&typeof r.session>"u")){if(!n?.ignoreCreateEvents)for(const u of r.created){const d=P.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.b.fire(d)}if(!n?.ignoreChangeEvents)for(const u of r.changed){const d=P.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.c.fire(d)}if(!n?.ignoreDeleteEvents)for(const u of r.deleted){const d=P.URI.revive(u);o(d.fsPath)&&(!c||b.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=m.$GK.from(this.i($,a,t,n,n?.correlate),this.b,this.c,this.d,i)}i($,b,a,s,t){const n=m.$GK.from();if(typeof a=="string")return n;const o=$.getProxy(M.$EK.MainThreadFileSystemEventService);let c=!1;return(a.pattern.includes(T.$Cj)||a.pattern.includes(T.$Dj))&&(c=!0),o.$watch(b.identifier.value,this.a,a.baseUri,{recursive:c,excludes:s?.excludes??[]},!!t),m.$GK.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class R{constructor($){this.a=$,this.session=this.a.session,this.b=new g.$U(()=>this.a.created.map(P.URI.revive)),this.c=new g.$U(()=>this.a.changed.map(P.URI.revive)),this.d=new g.$U(()=>this.a.deleted.map(P.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor($,b,a){this.j=$,this.k=b,this.l=a,this.a=new E.$Rd,this.b=new E.$Rd,this.c=new E.$Rd,this.d=new E.$Rd,this.g=new E.$Td,this.h=new E.$Td,this.i=new E.$Td,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,b,a,s){return new w(this.j,$,b,this.a.event,A.GlobPattern.from(a),s)}$onFileEvent($){this.a.fire(new R($))}$onDidRunFileOperation($,b){switch($){case 2:this.b.fire(Object.freeze({files:b.map(a=>({oldUri:P.URI.revive(a.source),newUri:P.URI.revive(a.target)}))}));break;case 1:this.d.fire(Object.freeze({files:b.map(a=>P.URI.revive(a.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:b.map(a=>P.URI.revive(a.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,b){return(a,s,t)=>{const n=function(c){a.call(s,c)};return n.extension=$,b.event(n,void 0,t)}}async $onWillRunFileOperation($,b,a,s){switch($){case 2:return await this.n(this.g,{files:b.map(t=>({oldUri:P.URI.revive(t.source),newUri:P.URI.revive(t.target)}))},a,s);case 1:return await this.n(this.i,{files:b.map(t=>P.URI.revive(t.target))},a,s);case 0:case 3:return await this.n(this.h,{files:b.map(t=>P.URI.revive(t.target))},a,s)}}async n($,b,a,s){const t=new Set,n=[];if(await $.fireAsync(b,s,async(c,h)=>{const i=Date.now(),r=await Promise.resolve(c);r instanceof m.$QK&&(n.push([h.extension,r]),t.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>a&&this.k.warn("SLOW file-participant",h.extension.identifier)}),s.isCancellationRequested||n.length===0)return;const o={edits:[]};for(const[,c]of n){const{edits:h}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(h)}return{edit:o,extensionNames:Array.from(t)}}}e.$Nfc=S}),define(Pe[249],Re([1,0,6,2,3,8,7,32,14]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ofc=void 0;class w{static{this.a=0}constructor($,b){this.extension=$,this.provider=b,this.handle=w.a++}}class R{constructor($){this.session=$,this.responses=[]}}class S{static{this.a=0}constructor($,b,a,s){this.f=a,this.g=s,this.b=new Map,this.d=new Map,this.e=$.getProxy(P.$EK.MainThreadInlineChat),b.registerApiCommand(new m.$8M("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$6M("Run arguments","",t=>!0,t=>{if(t)return{initialRange:t.initialRange?M.Range.from(t.initialRange):void 0,initialSelection:t.initialSelection?M.Selection.from(t.initialSelection):void 0,message:t.message,autoSend:t.autoSend,position:t.position?M.Position.from(t.position):void 0}})],m.$7M.Void))}registerProvider($,b,a){const s=new w($,b);return this.b.set(s.handle,s),this.e.$registerInteractiveEditorProvider(s.handle,a?.label??$.displayName??$.name,$.identifier.value,typeof b.handleInteractiveEditorResponseFeedback=="function",typeof b.provideFollowups=="function",a?.supportReportIssue??!1),(0,E.$Pc)(()=>{this.e.$unregisterInteractiveEditorProvider(s.handle),this.b.delete(s.handle)})}async $prepareSession($,b,a,s){const t=this.b.get($);if(!t){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const n=this.f.getDocument(T.URI.revive(b)),o=M.Selection.to(a),c=await t.provider.prepareInteractiveEditorSession({document:n,selection:o},s);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=S.a++;return this.d.set(h,new R(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:M.Range.from(c.wholeRange),message:c.message}}async $provideResponse($,b,a,s){const t=this.b.get($);if(!t)return;const n=this.d.get(b.id);if(!n)return;const o={prompt:a.prompt,selection:M.Selection.to(a.selection),wholeRange:M.Range.to(a.wholeRange),attempt:a.attempt,live:a.live};let c=!1;const h={report:async v=>{if(!a.live&&v.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||s.isCancellationRequested||await this.e.$handleProgressChunk(a.requestId,{message:v.message,edits:v.edits?.map(M.TextEdit.from),editsShouldBeInstant:v.editsShouldBeInstant,slashCommand:v.slashCommand?.command,markdownFragment:A.$8K.isMarkdownString(v.content)?v.content.value:v.content})}},i=Promise.resolve(t.provider.provideInteractiveEditorResponse(n.session,o,h,s));let r;try{r=await(0,g.$Og)(i,s)}finally{c=!0}if(!r)return;const u=n.responses.push(r)-1,d={wholeRange:M.Range.from(r.wholeRange),placeholder:r.placeholder};if(S.h(r)){const{edits:v,contents:f}=r,k=f!==void 0?M.MarkdownString.from(f):void 0;return v instanceof A.$QK?{...d,id:u,type:"bulkEdit",edits:M.WorkspaceEdit.from(v),message:k}:{...d,id:u,type:"editorEdit",edits:v.map(M.TextEdit.from),message:k}}return{...d,id:u,type:"message",message:M.MarkdownString.from(r.contents)}}async $provideFollowups($,b,a,s){const t=this.b.get($),n=this.d.get(b),o=n?.responses[a];if(t&&o&&t.provider.provideFollowups){const c=Promise.resolve(t.provider.provideFollowups(n.session,o,s));return(await(0,g.$Og)(c,s))?.map(M.ChatReplyFollowup.from)}}$handleFeedback($,b,a,s){const t=this.b.get($),n=this.d.get(b),o=n?.responses[a];if(t&&o){const c=M.InteractiveEditorResponseFeedbackKind.to(s);t.provider.handleInteractiveEditorResponseFeedback?.(n.session,o,c)}}$releaseSession($,b){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$Ofc=S}),define(Pe[250],Re([1,0,2,32]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2fc=void 0;class P{constructor(A,m,g,w,R){this.a=m,this.b=g,this.c=w;const S=new T.$8M("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new T.$6M("showOptions","Show Options",l=>!0,l=>l),new T.$6M("resource","Interactive resource Uri",l=>!0,l=>l),new T.$6M("controllerId","Notebook controller Id",l=>!0,l=>l),new T.$6M("title","Interactive editor title",l=>!0,l=>l)],new T.$7M("Notebook and input URI",l=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:E.URI.revive(l.notebookUri),inputUri:E.URI.revive(l.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,m,g,w){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:g,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(E.URI.revive(w))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$2fc=P}),define(Pe[251],Re([1,0,3,7]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3fc=void 0;class P{constructor(A){this.a=new Map,this.b=new Map,this.c=A.getProxy(E.$EK.MainThreadIssueReporter)}async $getIssueReporterUri(A,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const g=this.a.get(A);if(!g)throw new Error("Issue request handler not found");const w=await g.handleIssueUrlRequest();if(!w)throw new Error("Issue request handler returned no result");return w}async $getIssueReporterData(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueData(m);if(!w)throw new Error("Issue data provider returned no result");return w}async $getIssueReporterTemplate(A,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const g=this.b.get(A);if(!g)throw new Error("Issue data provider not found");const w=await g.provideIssueTemplate(m);if(!w)throw new Error("Issue template provider returned no result");return w}registerIssueUriRequestHandler(A,m){const g=A.identifier.value;return this.a.set(g,m),this.c.$registerIssueUriRequestHandler(g),new T.$GK(()=>{this.c.$unregisterIssueUriRequestHandler(g),this.a.delete(g)})}registerIssueDataProvider(A,m){const g=A.identifier.value;return this.b.set(g,m),this.c.$registerIssueDataProvider(g),new T.$GK(()=>{this.c.$unregisterIssueDataProvider(g),this.b.delete(g)})}}e.$3fc=P}),define(Pe[252],Re([1,0,6,3]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4fc=void 0;class P{constructor(A){this.b=0,this.a=A.getProxy(T.$EK.MainThreadLabelService)}$registerResourceLabelFormatter(A){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,A),(0,E.$Pc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$4fc=P}),define(Pe[253],Re([1,0,2,26,8,7,80,3,12,29,18,16,296,19,22,6,96,89,75,60,11,14,23,159]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class u{constructor(O,K){this.d=O,this.e=K}async provideDocumentSymbols(O,K){const J=this.d.getDocument(O),B=await this.e.provideDocumentSymbols(J,K);if(!(0,R.$Jb)(B))return B[0]instanceof M.$ZK?B.map(P.DocumentSymbol.from):u.f(B)}static f(O){O=O.slice(0).sort((B,Q)=>{let _=B.location.range.start.compareTo(Q.location.range.start);return _===0&&(_=Q.location.range.end.compareTo(B.location.range.end)),_});const K=[],J=[];for(const B of O){const Q={name:B.name||"!!MISSING: name!!",kind:P.SymbolKind.from(B.kind),tags:B.tags?.map(P.SymbolTag.from)||[],detail:"",containerName:B.containerName,range:P.Range.from(B.location.range),selectionRange:P.Range.from(B.location.range),children:[]};for(;;){if(J.length===0){J.push(Q),K.push(Q);break}const _=J[J.length-1];if(w.$Ds.containsRange(_.range,Q.range)&&!w.$Ds.equalsRange(_.range,Q.range)){_.children?.push(Q),J.push(Q);break}J.pop()}}return K}}class d{static{this.d={command:"missing",title:"!!MISSING: command!!"}}constructor(O,K,J){this.g=O,this.h=K,this.j=J,this.e=new n.$vec("CodeLens"),this.f=new Map}async provideCodeLenses(O,K){const J=this.g.getDocument(O),B=await this.j.provideCodeLenses(J,K);if(!B||K.isCancellationRequested)return;const Q=this.e.add(B),_=new a.$Qc;this.f.set(Q,_);const Ee={cacheId:Q,lenses:[]};for(let ze=0;ze<B.length;ze++)Ee.lenses.push({cacheId:[Q,ze],range:P.Range.from(B[ze].range),command:this.h.toInternal(B[ze].command,_)});return Ee}async resolveCodeLens(O,K){const J=O.cacheId&&this.e.get(...O.cacheId);if(!J)return;let B;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?B=J:B=await this.j.resolveCodeLens(J,K),B||(B=J),K.isCancellationRequested)return;const Q=O.cacheId&&this.f.get(O.cacheId[0]);if(Q)return O.command=this.h.toInternal(B.command??d.d,Q),O}releaseCodeLenses(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}}function v(Fe){return Array.isArray(Fe)?Fe.map(P.DefinitionLink.from):Fe?[P.DefinitionLink.from(Fe)]:[]}class f{constructor(O,K){this.d=O,this.e=K}async provideDefinition(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideDefinition(B,Q,J);return v(_)}}class k{constructor(O,K){this.d=O,this.e=K}async provideDeclaration(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideDeclaration(B,Q,J);return v(_)}}class L{constructor(O,K){this.d=O,this.e=K}async provideImplementation(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideImplementation(B,Q,J);return v(_)}}class p{constructor(O,K){this.d=O,this.e=K}async provideTypeDefinition(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideTypeDefinition(B,Q,J);return v(_)}}class y{constructor(O,K){this.d=O,this.e=K}async provideHover(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideHover(B,Q,J);if(!(!_||(0,R.$Jb)(_.contents)))return _.range||(_.range=B.getWordRangeAtPosition(Q)),_.range||(_.range=new M.$IK(Q,Q)),P.Hover.from(_)}}class D{constructor(O,K){this.d=O,this.e=K}async provideEvaluatableExpression(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideEvaluatableExpression(B,Q,J);if(_)return P.EvaluatableExpression.from(_)}}class N{constructor(O,K){this.d=O,this.e=K}async provideInlineValues(O,K,J,B){const Q=this.d.getDocument(O),_=await this.e.provideInlineValues(Q,P.Range.to(K),P.InlineValueContext.to(J),B);if(Array.isArray(_))return _.map(Ee=>P.InlineValue.from(Ee))}}class q{constructor(O,K){this.d=O,this.e=K}async provideDocumentHighlights(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideDocumentHighlights(B,Q,J);if(Array.isArray(_))return _.map(P.DocumentHighlight.from)}}class V{constructor(O,K){this.d=O,this.e=K}async provideMultiDocumentHighlights(O,K,J,B){const Q=this.d.getDocument(O),_=J.map(Qe=>this.d.getDocument(Qe)),Ee=P.Position.to(K),ze=await this.e.provideMultiDocumentHighlights(Q,Ee,_,B);if(Array.isArray(ze))return ze.map(P.MultiDocumentHighlight.from)}}class U{constructor(O,K){this.d=O,this.e=K}async provideLinkedEditingRanges(O,K,J){const B=this.d.getDocument(O),Q=P.Position.to(K),_=await this.e.provideLinkedEditingRanges(B,Q,J);if(_&&Array.isArray(_.ranges))return{ranges:(0,R.$Gb)(_.ranges.map(P.Range.from)),wordPattern:_.wordPattern}}}class F{constructor(O,K){this.d=O,this.e=K}async provideReferences(O,K,J,B){const Q=this.d.getDocument(O),_=P.Position.to(K),Ee=await this.e.provideReferences(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(P.location.from)}}class C{static{this.d=1e3}constructor(O,K,J,B,Q,_,Ee){this.g=O,this.h=K,this.j=J,this.k=B,this.l=Q,this.m=_,this.n=Ee,this.e=new n.$vec("CodeAction"),this.f=new Map}async provideCodeActions(O,K,J,B){const Q=this.g.getDocument(O),_=l.$Fs.isISelection(K)?P.Selection.to(K):P.Range.to(K),Ee=[];for(const nt of this.j.getDiagnostics(O))if(_.intersection(nt.range)&&Ee.push(nt)>C.d)break;const ze={diagnostics:Ee,only:J.only?new M.$2K(J.only):void 0,triggerKind:P.CodeActionTriggerKind.to(J.trigger)},Qe=await this.k.provideCodeActions(Q,_,ze,B);if(!(0,R.$Kb)(Qe)||B.isCancellationRequested)return;const Je=this.e.add(Qe),Ye=new a.$Qc;this.f.set(Je,Ye);const it=[];for(let nt=0;nt<Qe.length;nt++){const _e=Qe[nt];_e&&(C.o(_e)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),it.push({_isSynthetic:!0,title:_e.title,command:this.h.toInternal(_e,Ye)})):(ze.only&&(_e.kind?ze.only.contains(_e.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action is of kind '${_e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${ze.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),it.push({cacheId:[Je,nt],title:_e.title,command:_e.command&&this.h.toInternal(_e.command,Ye),diagnostics:_e.diagnostics&&_e.diagnostics.map(P.Diagnostic.from),edit:_e.edit&&P.WorkspaceEdit.from(_e.edit,void 0),kind:_e.kind&&_e.kind.value,isPreferred:_e.isPreferred,isAI:(0,i.$QF)(this.m,"codeActionAI")?_e.isAI:!1,disabled:_e.disabled?.reason})))}return{cacheId:Je,actions:it}}async resolveCodeAction(O,K){const[J,B]=O,Q=this.e.get(J,B);if(!Q||C.o(Q))return{};if(!this.k.resolveCodeAction)return{};const _=await this.k.resolveCodeAction(Q,K)??Q;let Ee;_.edit&&(Ee=P.WorkspaceEdit.from(_.edit,void 0));let ze;if(_.command){const Qe=this.f.get(J);Qe&&(ze=this.h.toInternal(_.command,Qe))}return{edit:Ee,command:ze}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class I{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,J,B,Q){this.d=O,this.e=K,this.f=J,this.g=B,this.h=Q}async prepareDocumentPaste(O,K,J,B){if(!this.f.prepareDocumentPaste)return;const Q=this.e.getDocument(O),_=K.map(Qe=>P.Range.to(Qe)),Ee=P.DataTransfer.toDataTransfer(J,()=>{throw new c.$0});if(await this.f.prepareDocumentPaste(Q,_,Ee,B),B.isCancellationRequested)return;const ze=Array.from(Ee).filter(([,Qe])=>!(Qe instanceof M.$vL));return P.DataTransfer.from(ze)}async providePasteEdits(O,K,J,B,Q){if(!this.f.provideDocumentPasteEdits)return;const _=this.e.getDocument(K),Ee=J.map(Je=>P.Range.to(Je)),ze=P.DataTransfer.toDataTransfer(B,async Je=>(await this.d.$resolvePasteFileData(this.g,O,Je)).buffer),Qe=await this.f.provideDocumentPasteEdits(_,Ee,ze,Q);if(Qe)return{label:Qe.label??(0,r.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:Qe.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:I.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?P.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class X{constructor(O,K){this.d=O,this.e=K}async provideDocumentFormattingEdits(O,K,J){const B=this.d.getDocument(O),Q=await this.e.provideDocumentFormattingEdits(B,K,J);if(Array.isArray(Q))return Q.map(P.TextEdit.from)}}class ue{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeFormattingEdits(O,K,J,B){const Q=this.d.getDocument(O),_=P.Range.to(K),Ee=await this.e.provideDocumentRangeFormattingEdits(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(P.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,K,J,B){(0,S.$Mf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Q=this.d.getDocument(O),_=K.map(P.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Q,_,J,B);if(Array.isArray(Ee))return Ee.map(P.TextEdit.from)}}class he{constructor(O,K){this.d=O,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,J,B,Q){const _=this.d.getDocument(O),Ee=P.Position.to(K),ze=await this.e.provideOnTypeFormattingEdits(_,Ee,J,B,Q);if(Array.isArray(ze))return ze.map(P.TextEdit.from)}}class be{constructor(O,K){this.e=O,this.f=K,this.d=new n.$vec("WorkspaceSymbols")}async provideWorkspaceSymbols(O,K){const J=await this.e.provideWorkspaceSymbols(O,K);if(!(0,R.$Kb)(J))return{symbols:[]};const B=this.d.add(J),Q={cacheId:B,symbols:[]};for(let _=0;_<J.length;_++){const Ee=J[_];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Q.symbols.push({...P.WorkspaceSymbol.from(Ee),cacheId:[B,_]})}return Q}async resolveWorkspaceSymbol(O,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const J=this.d.get(...O.cacheId);if(J){const B=await this.e.resolveWorkspaceSymbol(J,K);return B&&(0,T.$hn)(O,P.WorkspaceSymbol.from(B),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class we{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,K,J){this.d=O,this.e=K,this.f=J}async provideRenameEdits(O,K,J,B){const Q=this.d.getDocument(O),_=P.Position.to(K);try{const Ee=await this.e.provideRenameEdits(Q,_,J,B);return Ee?P.WorkspaceEdit.from(Ee):void 0}catch(Ee){const ze=we.g(Ee);return ze?{rejectReason:ze,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(O,K,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const B=this.d.getDocument(O),Q=P.Position.to(K);try{const _=await this.e.prepareRename(B,Q,J);let Ee,ze;if(M.$IK.isRange(_)?(Ee=_,ze=B.getText(_)):(0,S.$Ef)(_)&&(Ee=_.range,ze=_.placeholder),!Ee||!ze)return;if(Ee.start.line>Q.line||Ee.end.line<Q.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:P.Range.from(Ee),text:ze}}catch(_){const Ee=we.g(_);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(_)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ge{constructor(O,K){this.resultId=O,this.tokens=K}}class me{constructor(O,K){this.f=O,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,K,J){const B=this.f.getDocument(O),Q=K!==0?this.d.get(K):null;let _=typeof Q?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(B,Q.resultId,J):await this.g.provideDocumentSemanticTokens(B,J);return Q&&this.d.delete(K),_?(_=me.h(_),this.o(me.n(Q,_),_)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return me.j(O)?me.k(O)?O:new M.$YL(new Uint32Array(O.data),O.resultId):me.l(O)?me.m(O)?O:new M.$1L(O.edits.map(K=>new M.$ZL(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(O,K){if(!me.j(K)||!O||!O.tokens)return K;const J=O.tokens,B=J.length,Q=K.data,_=Q.length;let Ee=0;const ze=Math.min(B,_);for(;Ee<ze&&J[Ee]===Q[Ee];)Ee++;if(Ee===B&&Ee===_)return new M.$1L([],K.resultId);let Qe=0;const Je=ze-Ee;for(;Qe<Je&&J[B-Qe-1]===Q[_-Qe-1];)Qe++;return new M.$1L([{start:Ee,deleteCount:B-Ee-Qe,data:Q.subarray(Ee,_-Qe)}],K.resultId)}o(O,K){if(me.j(O)){const J=this.e++;return this.d.set(J,new ge(O.resultId,O.data)),(0,s.$$0)({id:J,type:"full",data:O.data})}if(me.l(O)){const J=this.e++;return me.j(K)?this.d.set(J,new ge(K.resultId,K.data)):this.d.set(J,new ge(O.resultId)),(0,s.$$0)({id:J,type:"delta",deltas:(O.edits||[]).map(B=>({start:B.start,deleteCount:B.deleteCount,data:B.data}))})}return null}}class ne{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeSemanticTokens(O,K,J){const B=this.d.getDocument(O),Q=await this.e.provideDocumentRangeSemanticTokens(B,P.Range.to(K),J);return Q?this.f(Q):null}f(O){return(0,s.$$0)({id:0,type:"full",data:O.data})}}class ke{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,K,J,B,Q){this.f=O,this.g=K,this.h=J,this.j=B,this.k=Q,this.d=new n.$vec("CompletionItem"),this.e=new Map}async provideCompletionItems(O,K,J,B){const Q=this.f.getDocument(O),_=P.Position.to(K),Ee=Q.getWordRangeAtPosition(_)||new M.$IK(_,_),ze=Ee.with({end:_}),Qe=new o.$Nd,Je=await this.h.provideCompletionItems(Q,_,B,P.CompletionContext.to(J));if(!Je||B.isCancellationRequested)return;const Ye=Array.isArray(Je)?new M.$cL(Je):Je,it=ke.supportsResolving(this.h)?this.d.add(Ye.items):this.d.add([]),nt=new a.$Qc;this.e.set(it,nt);const _e=[],rt={x:it,b:_e,a:{replace:P.Range.from(Ee),insert:P.Range.from(ze)},c:Ye.isIncomplete||void 0,d:Qe.elapsed()};for(let Ue=0;Ue<Ye.items.length;Ue++){const ct=Ye.items[Ue],ee=this.l(ct,[it,Ue],ze,Ee);_e.push(ee)}return rt}async resolveCompletionItem(O,K){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...O);if(!J)return;const B=this.l(J,O),Q=await this.h.resolveCompletionItem(J,K);if(!Q)return;const _=this.l(Q,O);return(B.h!==_.h||B.i!==_.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(B.n!==_.n||B.o!==_.o||!(0,T.$in)(B.p,_.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...B,d:_.d,c:_.c,l:_.l,h:_.h,i:_.i,n:_.n,o:_.o,p:_.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K,J,B){const Q=this.e.get(K[0]);if(!Q)throw Error("DisposableStore is missing...");const _=this.g.toInternal(O.command,Q),Ee={x:K,a:O.label,b:O.kind!==void 0?P.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(P.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:P.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(P.TextEdit.from),n:_?.$ident,o:_?.id,p:_?.$ident?void 0:_?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=O.textEdit.newText):typeof O.insertText=="string"?Ee.h=O.insertText:O.insertText instanceof M.$RK&&(Ee.h=O.insertText.value,Ee.i|=4);let ze;return O.textEdit?ze=O.textEdit.range:O.range&&(ze=O.range),M.$IK.isRange(ze)?Ee.j=P.Range.from(ze):ze&&(!J?.isEqual(ze.inserting)||!B?.isEqual(ze.replacing))&&(Ee.j={insert:P.Range.from(ze.inserting),replace:P.Range.from(ze.replacing)}),Ee}}class ce{async provideInlineCompletions(O,K,J,B){}disposeCompletions(O){}handleDidShowCompletionItem(O,K,J){}handlePartialAccept(O,K,J){}}class Y extends ce{constructor(O,K,J,B){super(),this.f=O,this.g=K,this.h=J,this.j=B,this.d=new W,this.e=(0,i.$QF)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:M.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:M.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,i.$QF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,K,J,B){const Q=this.g.getDocument(O),_=P.Position.to(K),Ee=await this.h.provideInlineCompletionItems(Q,_,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:P.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},B);if(!Ee||B.isCancellationRequested)return;const ze=Array.isArray(Ee)?Ee:Ee.items,Qe=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Je=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let Ye;return{pid:this.d.createReferenceId({dispose(){Ye?.dispose()},items:ze}),items:ze.map((nt,_e)=>{let rt;nt.command&&(Ye||(Ye=new a.$Qc),rt=this.j.toInternal(nt.command,Ye));const Ue=nt.insertText;return{insertText:typeof Ue=="string"?Ue:{snippet:Ue.value},filterText:nt.filterText,range:nt.range?P.Range.from(nt.range):void 0,command:rt,idx:_e,completeBracketPairs:this.e?nt.completeBracketPairs:!1}}),commands:Qe.map(nt=>(Ye||(Ye=new a.$Qc),this.j.toInternal(nt,Ye))),suppressSuggestions:!1,enableForwardStability:Je}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,K,J){const B=this.d.get(O)?.items[K];B&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(B,J)}handlePartialAccept(O,K,J){const B=this.d.get(O)?.items[K];B&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(B,J)}}class W{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const K=this.e++;return this.d.set(K,O),K}disposeReferenceId(O){const K=this.d.get(O);return this.d.delete(O),K}get(O){return this.d.get(O)}}class re{constructor(O,K){this.e=O,this.f=K,this.d=new n.$vec("SignatureHelp")}async provideSignatureHelp(O,K,J,B){const Q=this.e.getDocument(O),_=P.Position.to(K),Ee=this.g(J),ze=await this.f.provideSignatureHelp(Q,_,B,Ee);if(ze){const Qe=this.d.add([ze]);return{...P.SignatureHelp.from(ze),id:Qe}}}g(O){let K;if(O.activeSignatureHelp){const J=P.SignatureHelp.to(O.activeSignatureHelp),B=this.d.get(O.activeSignatureHelp.id,0);B?(K=B,K.activeSignature=J.activeSignature,K.activeParameter=J.activeParameter):K=J}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this.d.delete(O)}}class Ie{constructor(O,K,J,B,Q){this.f=O,this.g=K,this.h=J,this.j=B,this.k=Q,this.d=new n.$vec("InlayHints"),this.e=new Map}async provideInlayHints(O,K,J){const B=this.f.getDocument(O),Q=P.Range.to(K),_=await this.h.provideInlayHints(B,Q,J);if(!Array.isArray(_)||_.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(J.isCancellationRequested)return;const Ee=this.d.add(_);this.e.set(Ee,new a.$Qc);const ze={hints:[],cacheId:Ee};for(let Qe=0;Qe<_.length;Qe++)this.l(_[Qe],Q)&&ze.hints.push(this.m(_[Qe],[Ee,Qe]));return this.j.trace(`[InlayHints] ${ze.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),ze}async resolveInlayHint(O,K){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...O);if(!J)return;const B=await this.h.resolveInlayHint(J,K);if(B&&this.l(B))return this.m(B,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K){return O.label.length===0||Array.isArray(O.label)&&O.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(K&&!K.contains(O.position))}m(O,K){const J=this.e.get(K[0]);if(!J)throw Error("DisposableStore is missing...");const B={label:"",cacheId:K,tooltip:P.MarkdownString.fromStrict(O.tooltip),position:P.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(P.TextEdit.from),kind:O.kind&&P.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};return typeof O.label=="string"?B.label=O.label:B.label=O.label.map(Q=>{const _={label:Q.value};return _.tooltip=P.MarkdownString.fromStrict(Q.tooltip),M.$SK.isLocation(Q.location)&&(_.location=P.location.from(Q.location)),Q.command&&(_.command=this.g.toInternal(Q.command,J)),_}),B}}class Ae{constructor(O,K){this.e=O,this.f=K,this.d=new n.$vec("DocumentLink")}async provideLinks(O,K){const J=this.e.getDocument(O),B=await this.f.provideDocumentLinks(J,K);if(!(!Array.isArray(B)||B.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:B.filter(Ae.g).map(P.DocumentLink.from)};{const Q=this.d.add(B),_={links:[],cacheId:Q};for(let Ee=0;Ee<B.length;Ee++){if(!Ae.g(B[Ee]))continue;const ze=P.DocumentLink.from(B[Ee]);ze.cacheId=[Q,Ee],_.links.push(ze)}return _}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...O);if(!J)return;const B=await this.f.resolveDocumentLink(J,K);if(!(!B||!Ae.g(B)))return P.DocumentLink.from(B)}releaseLinks(O){this.d.delete(O)}}class Ce{constructor(O,K){this.d=O,this.e=K}async provideColors(O,K){const J=this.d.getDocument(O),B=await this.e.provideDocumentColors(J,K);return Array.isArray(B)?B.map(_=>({color:P.Color.from(_.color),range:P.Range.from(_.range)})):[]}async provideColorPresentations(O,K,J){const B=this.d.getDocument(O),Q=P.Range.to(K.range),_=P.Color.to(K.color),Ee=await this.e.provideColorPresentations(_,{document:B,range:Q},J);if(Array.isArray(Ee))return Ee.map(P.ColorPresentation.from)}}class le{constructor(O,K){this.d=O,this.e=K}async provideFoldingRanges(O,K,J){const B=this.d.getDocument(O),Q=await this.e.provideFoldingRanges(B,K,J);if(Array.isArray(Q))return Q.map(P.FoldingRange.from)}}class ie{constructor(O,K,J){this.d=O,this.e=K,this.f=J}async provideSelectionRanges(O,K,J){const B=this.d.getDocument(O),Q=K.map(P.Position.to),_=await this.e.provideSelectionRanges(B,Q,J);if(!(0,R.$Kb)(_))return[];if(_.length!==Q.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let ze=0;ze<Q.length;ze++){const Qe=[];Ee.push(Qe);let Je=Q[ze],Ye=_[ze];for(;;){if(!Ye.range.contains(Je))throw new Error("INVALID selection range, must contain the previous range");if(Qe.push(P.SelectionRange.from(Ye)),!Ye.parent)break;Je=Ye.range,Ye=Ye.parent}}return Ee}}class G{constructor(O,K){this.f=O,this.g=K,this.d=new t.$MM(""),this.e=new Map}async prepareSession(O,K,J){const B=this.f.getDocument(O),Q=P.Position.to(K),_=await this.g.prepareCallHierarchy(B,Q,J);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(ze=>this.h(Ee,ze)):[this.h(Ee,_)]}async provideCallsTo(O,K,J){const B=this.j(O,K);if(!B)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyIncomingCalls(B,J);if(Q)return Q.map(_=>({from:this.h(O,_.from),fromRanges:_.fromRanges.map(Ee=>P.Range.from(Ee))}))}async provideCallsFrom(O,K,J){const B=this.j(O,K);if(!B)throw new Error("missing call hierarchy item");const Q=await this.g.provideCallHierarchyOutgoingCalls(B,J);if(Q)return Q.map(_=>({to:this.h(O,_.to),fromRanges:_.fromRanges.map(Ee=>P.Range.from(Ee))}))}releaseSession(O){this.e.delete(O)}h(O,K){const J=this.e.get(O),B=P.CallHierarchyItem.from(K,O,J.size.toString(36));return J.set(B._itemId,K),B}j(O,K){return this.e.get(O)?.get(K)}}class te{constructor(O,K){this.f=O,this.g=K,this.d=new t.$MM(""),this.e=new Map}async prepareSession(O,K,J){const B=this.f.getDocument(O),Q=P.Position.to(K),_=await this.g.prepareTypeHierarchy(B,Q,J);if(!_)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(_)?_.map(ze=>this.h(Ee,ze)):[this.h(Ee,_)]}async provideSupertypes(O,K,J){const B=this.j(O,K);if(!B)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySupertypes(B,J);if(Q)return Q.map(_=>this.h(O,_))}async provideSubtypes(O,K,J){const B=this.j(O,K);if(!B)throw new Error("missing type hierarchy item");const Q=await this.g.provideTypeHierarchySubtypes(B,J);if(Q)return Q.map(_=>this.h(O,_))}releaseSession(O){this.e.delete(O)}h(O,K){const J=this.e.get(O),B=P.TypeHierarchyItem.from(K,O,J.size.toString(36));return J.set(B._itemId,K),B}j(O,K){return this.e.get(O)?.get(K)}}class x{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,J,B,Q){this.d=O,this.e=K,this.f=J,this.g=B,this.h=Q}async provideDocumentOnDropEdits(O,K,J,B,Q){const _=this.e.getDocument(K),Ee=P.Position.to(J),ze=P.DataTransfer.toDataTransfer(B,async Je=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Je)).buffer),Qe=await this.f.provideDocumentDropEdits(_,Ee,ze,Q);if(Qe)return{label:Qe.label??(0,r.localize)(1,null,this.h.displayName||this.h.name),yieldTo:Qe.yieldTo?.map(Je=>"mimeType"in Je?Je:{providerId:x.toInternalProviderId(Je.extensionId,Je.providerId)}),insertText:typeof Qe.insertText=="string"?Qe.insertText:{snippet:Qe.insertText.value},additionalEdit:Qe.additionalEdit?P.WorkspaceEdit.from(Qe.additionalEdit,void 0):void 0}}}class se{constructor(O,K){this.d=O,this.e=K}async provideMappedEdits(O,K,J,B){const Q=E.URI.revive(O),_=this.d.getDocument(Q),Ee=J.documents.map(Je=>Je.map(Ye=>({uri:E.URI.revive(Ye.uri),version:Ye.version,ranges:Ye.ranges.map(it=>P.Range.to(it))}))),ze={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},Qe=await this.e.provideMappedEdits(_,K,ze,B);return Qe?P.WorkspaceEdit.from(Qe):null}}class fe{constructor(O,K){this.adapter=O,this.extension=K}}class Se{static{this.d=0}constructor(O,K,J,B,Q,_,Ee,ze){this.g=K,this.h=J,this.j=B,this.k=Q,this.l=_,this.m=Ee,this.n=ze,this.f=new Map,this.e=O.getProxy(m.$EK.MainThreadLanguageFeatures)}o(O,K){return P.DocumentSelector.from(O,this.g,K)}p(O){return new M.$GK(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return Se.d++}async s(O,K,J,B,Q,_=!1){const Ee=this.f.get(O);if(!Ee||!(Ee.adapter instanceof K))return B;const ze=Date.now();_||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Qe=J(Ee.adapter,Ee.extension);return Promise.resolve(Qe).catch(Je=>{(0,c.$3)(Je)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Je),this.n.onExtensionError(Ee.extension.identifier,Je))}).finally(()=>{_||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-ze}ms`)}),$.CancellationToken.isCancellationToken(Q)?(0,h.$Pg)(Qe,Q):Qe}t(O,K){const J=this.q();return this.f.set(J,new fe(O,K)),J}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,J,B){const Q=this.t(new u(this.h,J),O),_=B&&B.label||Se.u(O);return this.e.$registerDocumentSymbolProvider(Q,this.o(K,O),_),this.p(Q)}$provideDocumentSymbols(O,K,J){return this.s(O,u,B=>B.provideDocumentSymbols(E.URI.revive(K),J),void 0,J)}registerCodeLensProvider(O,K,J){const B=this.q(),Q=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(B,new fe(new d(this.h,this.j.converter,J),O)),this.e.$registerCodeLensSupport(B,this.o(K,O),Q);let _=this.p(B);if(Q!==void 0){const Ee=J.onDidChangeCodeLenses(ze=>this.e.$emitCodeLensEvent(Q));_=M.$GK.from(_,Ee)}return _}$provideCodeLenses(O,K,J){return this.s(O,d,B=>B.provideCodeLenses(E.URI.revive(K),J),void 0,J)}$resolveCodeLens(O,K,J){return this.s(O,d,B=>B.resolveCodeLens(K,J),void 0,void 0)}$releaseCodeLenses(O,K){this.s(O,d,J=>Promise.resolve(J.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(O,K,J){const B=this.t(new f(this.h,J),O);return this.e.$registerDefinitionSupport(B,this.o(K,O)),this.p(B)}$provideDefinition(O,K,J,B){return this.s(O,f,Q=>Q.provideDefinition(E.URI.revive(K),J,B),[],B)}registerDeclarationProvider(O,K,J){const B=this.t(new k(this.h,J),O);return this.e.$registerDeclarationSupport(B,this.o(K,O)),this.p(B)}$provideDeclaration(O,K,J,B){return this.s(O,k,Q=>Q.provideDeclaration(E.URI.revive(K),J,B),[],B)}registerImplementationProvider(O,K,J){const B=this.t(new L(this.h,J),O);return this.e.$registerImplementationSupport(B,this.o(K,O)),this.p(B)}$provideImplementation(O,K,J,B){return this.s(O,L,Q=>Q.provideImplementation(E.URI.revive(K),J,B),[],B)}registerTypeDefinitionProvider(O,K,J){const B=this.t(new p(this.h,J),O);return this.e.$registerTypeDefinitionSupport(B,this.o(K,O)),this.p(B)}$provideTypeDefinition(O,K,J,B){return this.s(O,p,Q=>Q.provideTypeDefinition(E.URI.revive(K),J,B),[],B)}registerHoverProvider(O,K,J,B){const Q=this.t(new y(this.h,J),O);return this.e.$registerHoverProvider(Q,this.o(K,O)),this.p(Q)}$provideHover(O,K,J,B){return this.s(O,y,Q=>Q.provideHover(E.URI.revive(K),J,B),void 0,B)}registerEvaluatableExpressionProvider(O,K,J,B){const Q=this.t(new D(this.h,J),O);return this.e.$registerEvaluatableExpressionProvider(Q,this.o(K,O)),this.p(Q)}$provideEvaluatableExpression(O,K,J,B){return this.s(O,D,Q=>Q.provideEvaluatableExpression(E.URI.revive(K),J,B),void 0,B)}registerInlineValuesProvider(O,K,J,B){const Q=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,_=this.t(new N(this.h,J),O);this.e.$registerInlineValuesProvider(_,this.o(K,O),Q);let Ee=this.p(_);if(Q!==void 0){const ze=J.onDidChangeInlineValues(Qe=>this.e.$emitInlineValuesEvent(Q));Ee=M.$GK.from(Ee,ze)}return Ee}$provideInlineValues(O,K,J,B,Q){return this.s(O,N,_=>_.provideInlineValues(E.URI.revive(K),J,B,Q),void 0,Q)}registerDocumentHighlightProvider(O,K,J){const B=this.t(new q(this.h,J),O);return this.e.$registerDocumentHighlightProvider(B,this.o(K,O)),this.p(B)}registerMultiDocumentHighlightProvider(O,K,J){const B=this.t(new V(this.h,J),O);return this.e.$registerMultiDocumentHighlightProvider(B,this.o(K,O)),this.p(B)}$provideDocumentHighlights(O,K,J,B){return this.s(O,q,Q=>Q.provideDocumentHighlights(E.URI.revive(K),J,B),void 0,B)}$provideMultiDocumentHighlights(O,K,J,B,Q){return this.s(O,V,_=>_.provideMultiDocumentHighlights(E.URI.revive(K),J,B.map(Ee=>E.URI.revive(Ee)),Q),void 0,Q)}registerLinkedEditingRangeProvider(O,K,J){const B=this.t(new U(this.h,J),O);return this.e.$registerLinkedEditingRangeProvider(B,this.o(K,O)),this.p(B)}$provideLinkedEditingRanges(O,K,J,B){return this.s(O,U,async Q=>{const _=await Q.provideLinkedEditingRanges(E.URI.revive(K),J,B);if(_)return{ranges:_.ranges,wordPattern:_.wordPattern?Se.w(_.wordPattern):void 0}},void 0,B)}registerReferenceProvider(O,K,J){const B=this.t(new F(this.h,J),O);return this.e.$registerReferenceSupport(B,this.o(K,O)),this.p(B)}$provideReferences(O,K,J,B,Q){return this.s(O,F,_=>_.provideReferences(E.URI.revive(K),J,B,Q),void 0,Q)}registerCodeActionProvider(O,K,J,B){const Q=new a.$Qc,_=this.t(new C(this.h,this.j.converter,this.k,J,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(_,this.o(K,O),{providedKinds:B?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:B?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Q)}))},Se.u(O),!!J.resolveCodeAction),Q.add(this.p(_)),Q}$provideCodeActions(O,K,J,B,Q){return this.s(O,C,_=>_.provideCodeActions(E.URI.revive(K),J,B,Q),void 0,Q)}$resolveCodeAction(O,K,J){return this.s(O,C,B=>B.resolveCodeAction(K,J),{},void 0)}$releaseCodeActions(O,K){this.s(O,C,J=>Promise.resolve(J.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(O,K,J){const B=this.t(new X(this.h,J),O);return this.e.$registerDocumentFormattingSupport(B,this.o(K,O),O.identifier,O.displayName||O.name),this.p(B)}$provideDocumentFormattingEdits(O,K,J,B){return this.s(O,X,Q=>Q.provideDocumentFormattingEdits(E.URI.revive(K),J,B),void 0,B)}registerDocumentRangeFormattingEditProvider(O,K,J){const B=typeof J.provideDocumentRangesFormattingEdits=="function",Q=this.t(new ue(this.h,J),O);return this.e.$registerRangeFormattingSupport(Q,this.o(K,O),O.identifier,O.displayName||O.name,B),this.p(Q)}$provideDocumentRangeFormattingEdits(O,K,J,B,Q){return this.s(O,ue,_=>_.provideDocumentRangeFormattingEdits(E.URI.revive(K),J,B,Q),void 0,Q)}$provideDocumentRangesFormattingEdits(O,K,J,B,Q){return this.s(O,ue,_=>_.provideDocumentRangesFormattingEdits(E.URI.revive(K),J,B,Q),void 0,Q)}registerOnTypeFormattingEditProvider(O,K,J,B){const Q=this.t(new he(this.h,J),O);return this.e.$registerOnTypeFormattingSupport(Q,this.o(K,O),B,O.identifier),this.p(Q)}$provideOnTypeFormattingEdits(O,K,J,B,Q,_){return this.s(O,he,Ee=>Ee.provideOnTypeFormattingEdits(E.URI.revive(K),J,B,Q,_),void 0,_)}registerWorkspaceSymbolProvider(O,K){const J=this.t(new be(K,this.l),O);return this.e.$registerNavigateTypeSupport(J,typeof K.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(O,K,J){return this.s(O,be,B=>B.provideWorkspaceSymbols(K,J),{symbols:[]},J)}$resolveWorkspaceSymbol(O,K,J){return this.s(O,be,B=>B.resolveWorkspaceSymbol(K,J),void 0,void 0)}$releaseWorkspaceSymbols(O,K){this.s(O,be,J=>J.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(O,K,J){const B=this.t(new we(this.h,J,this.l),O);return this.e.$registerRenameSupport(B,this.o(K,O),we.supportsResolving(J)),this.p(B)}$provideRenameEdits(O,K,J,B,Q){return this.s(O,we,_=>_.provideRenameEdits(E.URI.revive(K),J,B,Q),void 0,Q)}$resolveRenameLocation(O,K,J,B){return this.s(O,we,Q=>Q.resolveRenameLocation(E.URI.revive(K),J,B),void 0,B)}registerDocumentSemanticTokensProvider(O,K,J,B){const Q=this.t(new me(this.h,J),O),_=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Q,this.o(K,O),B,_);let Ee=this.p(Q);if(_){const ze=J.onDidChangeSemanticTokens(Qe=>this.e.$emitDocumentSemanticTokensEvent(_));Ee=M.$GK.from(Ee,ze)}return Ee}$provideDocumentSemanticTokens(O,K,J,B){return this.s(O,me,Q=>Q.provideDocumentSemanticTokens(E.URI.revive(K),J,B),null,B)}$releaseDocumentSemanticTokens(O,K){this.s(O,me,J=>J.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,K,J,B){const Q=this.t(new ne(this.h,J),O);return this.e.$registerDocumentRangeSemanticTokensProvider(Q,this.o(K,O),B),this.p(Q)}$provideDocumentRangeSemanticTokens(O,K,J,B){return this.s(O,ne,Q=>Q.provideDocumentRangeSemanticTokens(E.URI.revive(K),J,B),null,B)}registerCompletionItemProvider(O,K,J,B){const Q=this.t(new ke(this.h,this.j.converter,J,this.m,O),O);return this.e.$registerCompletionsProvider(Q,this.o(K,O),B,ke.supportsResolving(J),O.identifier),this.p(Q)}$provideCompletionItems(O,K,J,B,Q){return this.s(O,ke,_=>_.provideCompletionItems(E.URI.revive(K),J,B,Q),void 0,Q)}$resolveCompletionItem(O,K,J){return this.s(O,ke,B=>B.resolveCompletionItem(K,J),void 0,J)}$releaseCompletionItems(O,K){this.s(O,ke,J=>J.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(O,K,J,B){const Q=new Y(O,this.h,J,this.j.converter),_=this.t(Q,O);return this.e.$registerInlineCompletionsSupport(_,this.o(K,O),Q.supportsHandleEvents,b.$dm.toKey(O.identifier.value),B?.yieldTo?.map(Ee=>b.$dm.toKey(Ee))||[]),this.p(_)}$provideInlineCompletions(O,K,J,B,Q){return this.s(O,ce,_=>_.provideInlineCompletions(E.URI.revive(K),J,B,Q),void 0,Q)}$handleInlineCompletionDidShow(O,K,J,B){this.s(O,ce,async Q=>{Q.handleDidShowCompletionItem(K,J,B)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,K,J,B){this.s(O,ce,async Q=>{Q.handlePartialAccept(K,J,B)},void 0,void 0)}$freeInlineCompletionsList(O,K){this.s(O,ce,async J=>{J.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(O,K,J,B){const Q=Array.isArray(B)?{triggerCharacters:B,retriggerCharacters:[]}:B,_=this.t(new re(this.h,J),O);return this.e.$registerSignatureHelpProvider(_,this.o(K,O),Q),this.p(_)}$provideSignatureHelp(O,K,J,B,Q){return this.s(O,re,_=>_.provideSignatureHelp(E.URI.revive(K),J,B,Q),void 0,Q)}$releaseSignatureHelp(O,K){this.s(O,re,J=>J.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(O,K,J){const B=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,Q=this.t(new Ie(this.h,this.j.converter,J,this.l,O),O);this.e.$registerInlayHintsProvider(Q,this.o(K,O),typeof J.resolveInlayHint=="function",B,Se.u(O));let _=this.p(Q);if(B!==void 0){const Ee=J.onDidChangeInlayHints(ze=>this.e.$emitInlayHintsEvent(B));_=M.$GK.from(_,Ee)}return _}$provideInlayHints(O,K,J,B){return this.s(O,Ie,Q=>Q.provideInlayHints(E.URI.revive(K),J,B),void 0,B)}$resolveInlayHint(O,K,J){return this.s(O,Ie,B=>B.resolveInlayHint(K,J),void 0,J)}$releaseInlayHints(O,K){this.s(O,Ie,J=>J.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(O,K,J){const B=this.t(new Ae(this.h,J),O);return this.e.$registerDocumentLinkProvider(B,this.o(K,O),typeof J.resolveDocumentLink=="function"),this.p(B)}$provideDocumentLinks(O,K,J){return this.s(O,Ae,B=>B.provideLinks(E.URI.revive(K),J),void 0,J,K.scheme==="output")}$resolveDocumentLink(O,K,J){return this.s(O,Ae,B=>B.resolveLink(K,J),void 0,void 0,!0)}$releaseDocumentLinks(O,K){this.s(O,Ae,J=>J.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(O,K,J){const B=this.t(new Ce(this.h,J),O);return this.e.$registerDocumentColorProvider(B,this.o(K,O)),this.p(B)}$provideDocumentColors(O,K,J){return this.s(O,Ce,B=>B.provideColors(E.URI.revive(K),J),[],J)}$provideColorPresentations(O,K,J,B){return this.s(O,Ce,Q=>Q.provideColorPresentations(E.URI.revive(K),J,B),void 0,B)}registerFoldingRangeProvider(O,K,J){const B=this.q(),Q=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(B,new fe(new le(this.h,J),O)),this.e.$registerFoldingRangeProvider(B,this.o(K,O),O.identifier,Q);let _=this.p(B);if(Q!==void 0){const Ee=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Q));_=M.$GK.from(_,Ee)}return _}$provideFoldingRanges(O,K,J,B){return this.s(O,le,Q=>Q.provideFoldingRanges(E.URI.revive(K),J,B),void 0,B)}registerSelectionRangeProvider(O,K,J){const B=this.t(new ie(this.h,J,this.l),O);return this.e.$registerSelectionRangeProvider(B,this.o(K,O)),this.p(B)}$provideSelectionRanges(O,K,J,B){return this.s(O,ie,Q=>Q.provideSelectionRanges(E.URI.revive(K),J,B),[],B)}registerCallHierarchyProvider(O,K,J){const B=this.t(new G(this.h,J),O);return this.e.$registerCallHierarchyProvider(B,this.o(K,O)),this.p(B)}$prepareCallHierarchy(O,K,J,B){return this.s(O,G,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),J,B)),void 0,B)}$provideCallHierarchyIncomingCalls(O,K,J,B){return this.s(O,G,Q=>Q.provideCallsTo(K,J,B),void 0,B)}$provideCallHierarchyOutgoingCalls(O,K,J,B){return this.s(O,G,Q=>Q.provideCallsFrom(K,J,B),void 0,B)}$releaseCallHierarchy(O,K){this.s(O,G,J=>Promise.resolve(J.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(O,K,J){const B=this.t(new te(this.h,J),O);return this.e.$registerTypeHierarchyProvider(B,this.o(K,O)),this.p(B)}$prepareTypeHierarchy(O,K,J,B){return this.s(O,te,Q=>Promise.resolve(Q.prepareSession(E.URI.revive(K),J,B)),void 0,B)}$provideTypeHierarchySupertypes(O,K,J,B){return this.s(O,te,Q=>Q.provideSupertypes(K,J,B),void 0,B)}$provideTypeHierarchySubtypes(O,K,J,B){return this.s(O,te,Q=>Q.provideSubtypes(K,J,B),void 0,B)}$releaseTypeHierarchy(O,K){this.s(O,te,J=>Promise.resolve(J.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(O,K,J,B){const Q=this.q();this.f.set(Q,new fe(new x(this.e,this.h,J,Q,O),O));const _=(0,i.$QF)(O,"dropMetadata")&&B?x.toInternalProviderId(O.identifier.value,B.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Q,this.o(K,O),_,(0,i.$QF)(O,"dropMetadata")?B:void 0),this.p(Q)}$provideDocumentOnDropEdits(O,K,J,B,Q,_){return this.s(O,x,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(K,E.URI.revive(J),B,Q,_)),void 0,void 0)}registerMappedEditsProvider(O,K,J){const B=this.t(new se(this.h,J),O);return this.e.$registerMappedEditsProvider(B,this.o(K,O)),this.p(B)}$provideMappedEdits(O,K,J,B,Q){return this.s(O,se,_=>Promise.resolve(_.provideMappedEdits(K,J,B,Q)),null,Q)}registerDocumentPasteEditProvider(O,K,J,B){const Q=this.q();this.f.set(Q,new fe(new I(this.e,this.h,J,Q,O),O));const _=I.toInternalProviderId(O.identifier.value,B.id);return this.e.$registerPasteEditProvider(Q,this.o(K,O),_,{supportsCopy:!!J.prepareDocumentPaste,supportsPaste:!!J.provideDocumentPasteEdits,copyMimeTypes:B.copyMimeTypes,pasteMimeTypes:B.pasteMimeTypes}),this.p(Q)}$prepareDocumentPaste(O,K,J,B,Q){return this.s(O,I,_=>_.prepareDocumentPaste(E.URI.revive(K),J,B,Q),void 0,Q)}$providePasteEdits(O,K,J,B,Q,_){return this.s(O,I,Ee=>Ee.providePasteEdits(K,E.URI.revive(J),B,Q,_),void 0,_)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:Se.w(O.decreaseIndentPattern),increaseIndentPattern:Se.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?Se.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?Se.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:Se.w(O.beforeText),afterText:O.afterText?Se.w(O.afterText):void 0,previousLineText:O.previousLineText?Se.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(Se.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(K=>M.SyntaxTokenType.toString(K)):void 0}}static D(O){return O.map(Se.C)}setLanguageConfiguration(O,K,J){const{wordPattern:B}=J;if(B&&(0,g.$Se)(B))throw new Error(`Invalid language configuration: wordPattern '${B}' is not allowed to match the empty string.`);B?this.h.setWordDefinitionFor(K,B):this.h.setWordDefinitionFor(K,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const Q=this.q(),_={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?Se.w(J.wordPattern):void 0,indentationRules:J.indentationRules?Se.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?Se.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport,autoClosingPairs:J.autoClosingPairs?Se.D(J.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Q,K,_),this.p(Q)}$setWordDefinitions(O){for(const K of O)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$Fec=Se}),define(Pe[254],Re([1,0,3,8,7,31,14,6,23]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5fc=void 0;class w{constructor(S,l,$,b){this.c=l,this.d=$,this.e=b,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(E.$EK.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,l){await this.a.$changeLanguage(S,l);const $=this.c.getDocumentData(S);if(!$)throw new Error(`document '${S.toString()}' NOT found`);return $.document}async tokenAtPosition(S,l){const $=S.version,b=T.Position.from(l),a=await this.a.$tokensAtPosition(S.uri,b),s={type:P.StandardTokenType.Other,range:S.getWordRangeAtPosition(l)??new P.$IK(l.line,l.character,l.line,l.character)};if(!a)return s;const t={range:T.Range.to(a.range),type:T.TokenType.to(a.type)};return!t.range.contains(l)||$!==S.version?s:t}createLanguageStatusItem(S,l,$){const b=this.f++,a=this.a,s=this.g,t=`${S.identifier.value}/${l}`;if(s.has(t))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);s.add(t);const n={selector:$,id:l,name:S.displayName??S.name,severity:P.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const c=new m.$Qc,h=()=>{if(o?.dispose(),!s.has(t)){console.warn(`LanguageStatusItem (${l}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,A.$2g)(()=>{c.clear(),this.a.$setLanguageStatus(b,{id:t,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:T.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===P.LanguageStatusSeverity.Error?M.default.Error:n.severity===P.LanguageStatusSeverity.Warning?M.default.Warning:M.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),o?.dispose(),a.$removeLanguageStatus(b),s.delete(t)},get id(){return n.id},get name(){return n.name},set name(r){n.name=r,h()},get selector(){return n.selector},set selector(r){n.selector=r,h()},get text(){return n.text},set text(r){n.text=r,h()},set text2(r){(0,g.$RF)(S,"languageStatusText"),n.text=r,h()},get text2(){return(0,g.$RF)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(r){n.detail=r,h()},get severity(){return n.severity},set severity(r){n.severity=r,h()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(r){n.accessibilityInformation=r,h()},get command(){return n.command},set command(r){n.command=r,h()},get busy(){return n.busy},set busy(r){n.busy=r,h()}};return h(),i}}e.$5fc=w}),define(Pe[82],Re([1,0,21,12,2,4,15,3,27,17]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rfc=e.$qfc=void 0;let R=class{constructor(l,$,b){this.f=b,this.d=new Map,this.a=$.getProxy(m.$EK.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===E.$g}getMessage(l,$){const{message:b,args:a,comment:s}=$;if(this.c)return(0,T.$He)(b,a??{});let t=b;s&&s.length>0&&(t+=`/${Array.isArray(s)?s.join(""):s}`);const n=this.d.get(l)?.contents[t];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${t}`),(0,T.$He)(n??b,a??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const b=await this.g(l);if(!b){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const a=await this.a.$fetchBundleContents(b),s=JSON.parse(a);$=l.isBuiltin?s.contents?.bundle:s}catch(a){this.f.error(`Failed to load translations for ${l.identifier.value} from ${b}: ${a.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:b})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return P.URI.revive($)}return l.l10n?P.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$qfc=R,e.$qfc=R=He([We(0,g.$XM),We(1,w.$HM),We(2,A.$hj)],R),e.$rfc=(0,M.$Zh)("IExtHostLocalizationService")}),define(Pe[255],Re([1,0,15,3,27,17,2,51]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;let g=class extends E.$sj{constructor(S,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$wh)($))),this.r=S.getProxy(T.$EK.MainThreadLogger)}$setLogLevel(S,l){l?this.setLogLevel(A.URI.revive(l),S):this.setLogLevel(S)}setVisibility(S,l){super.setVisibility(S,l),this.r.$setVisibility(S,l)}s(S,l,$){return new w(this.r,S,l,$)}};e.$Dgc=g,e.$Dgc=g=He([We(0,M.$HM),We(1,P.$XM)],g);class w extends E.$nj{constructor(S,l,$,b){super(b?.logLevel==="always"),this.r=S,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,b).then(()=>{this.u(this.n),this.m=!0})}g(S,l){const $=[[S,l]];this.m?this.u($):this.n.push(...$)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Pe[83],Re([1,0,3,4,6,17,24]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tfc=e.$sfc=void 0,e.$sfc=(0,T.$Zh)("IExtHostManagedSockets");let m=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(E.$EK.MainThreadManagedSockets)}setFactory(S,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(S,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const l=++this.b,$=await this.c.makeConnection(),b=new P.$Qc;return this.d.set(l,new w(l,$,b)),b.add((0,P.$Pc)(()=>this.d.delete(l))),b.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),b.dispose()})),b.add($.onDidClose(a=>{this.a.$onDidManagedSocketClose(l,a?.stack??a?.message),b.dispose()})),b.add($.onDidReceiveMessage(a=>this.a.$onDidManagedSocketHaveData(l,A.$fe.wrap(a)))),l}$remoteSocketWrite(S,l){this.d.get(S)?.actual.send(l.buffer)}$remoteSocketEnd(S){const l=this.d.get(S);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$tfc=m,e.$tfc=m=He([We(0,M.$HM)],m);class g{constructor(S,l){this.socketFactoryId=S,this.makeConnection=l}}class w extends P.$Rc{constructor(S,l,$){super(),this.socketId=S,this.actual=l,this.B($)}}}),define(Pe[256],Re([1,0,3,15,23]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6fc=void 0;function M(m){return m&&m.title}let A=class{constructor(g,w){this.b=w,this.a=g.getProxy(E.$EK.MainThreadMessageService)}showMessage(g,w,R,S,l){const $={source:{identifier:g.identifier,label:g.displayName||g.name}};let b;typeof S=="string"||M(S)?b=[S,...l]:($.modal=S?.modal,$.useCustom=S?.useCustom,$.detail=S?.detail,b=l),$.useCustom&&(0,P.$RF)(g,"resolvers");const a=[];for(let s=0;s<b.length;s++){const t=b[s];if(typeof t=="string")a.push({title:t,handle:s,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:o}=t;a.push({title:n,isCloseAffordance:!!o,handle:s})}else this.b.warn("Invalid message item:",t)}return this.a.$showMessage(w,R,$,a).then(s=>{if(typeof s=="number")return b[s]})}};e.$6fc=A,e.$6fc=A=He([We(1,T.$hj)],A)}),define(Pe[257],Re([1,0,18,14,19,5,6,28,2,22,15,3,32,8,7,78,210,23,49]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fc=e.$0fc=void 0;let o=class{constructor(f,k,L,p,y){this.m=k,this.n=L,this.o=p,this.q=y,this.b=new m.$zc,this.c=new m.$zc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new M.$Rd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=f.getProxy(S.$EK.MainThreadNotebookKernels);const D=new l.$8M("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$6M("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const q=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:q}}else if(N&&"notebookEditor"in N){const q=this.n.getIdByEditor(N.notebookEditor);if(q===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:q}}return N})],l.$7M.Void);this.o.registerApiCommand(D)}createNotebookController(f,k,L,p,y,D){for(const ne of this.j.values())if(ne.controller.id===k&&w.$dm.equals(f.identifier,ne.extensionId))throw new Error(`notebook controller with id '${k}' ALREADY exist`);const N=this.k++,q=this;this.q.trace(`NotebookController[${N}], CREATED by ${f.identifier.value}, ${k}`);const V=()=>console.warn(`NO execute handler from notebook controller '${I.id}' of extension: '${f.identifier}'`);let U=!1;const F=new M.$Rd,C=new M.$Rd,I={id:d(f.identifier,k),notebookType:L,extensionId:f.identifier,extensionLocation:f.extensionLocation,label:p||f.identifier.value,preloads:D?D.map($.NotebookRendererScript.from):[]};let X=y??V,ue,he;this.a.$addKernel(N,I).catch(ne=>{console.log(ne),U=!0});let be=0;const we=()=>{if(U)return;const ne=++be;Promise.resolve().then(()=>{ne===be&&this.a.$updateKernel(N,I)})},ge=new m.$zc,me={get id(){return k},get notebookType(){return I.notebookType},onDidChangeSelectedNotebooks:F.event,get label(){return I.label},set label(ne){I.label=ne??f.displayName??f.name,we()},get detail(){return I.detail??""},set detail(ne){I.detail=ne,we()},get description(){return I.description??""},set description(ne){I.description=ne,we()},get supportedLanguages(){return I.supportedLanguages},set supportedLanguages(ne){I.supportedLanguages=ne,we()},get supportsExecutionOrder(){return I.supportsExecutionOrder??!1},set supportsExecutionOrder(ne){I.supportsExecutionOrder=ne,we()},get rendererScripts(){return I.preloads?I.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return X},set executeHandler(ne){X=ne??V},get interruptHandler(){return ue},set interruptHandler(ne){ue=ne,I.supportsInterrupt=!!ne,we()},set variableProvider(ne){(0,t.$RF)(f,"notebookVariableProvider"),he=ne,I.hasVariableProvider=!!ne,ne?.onDidChangeVariables(ke=>q.a.$variablesUpdated(ke.uri)),we()},get variableProvider(){return he},createNotebookCellExecution(ne){if(U)throw new Error("notebook controller is DISPOSED");if(!ge.has(ne.notebook.uri))throw q.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.notebook.uri.toString()}`);return q._createNotebookCellExecution(ne,d(f.identifier,this.id))},createNotebookExecution(ne){if((0,t.$RF)(f,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ge.has(ne.uri))throw q.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ge.keys()).map(ke=>ke.toString())),new Error(`notebook controller is NOT associated to notebook: ${ne.uri.toString()}`);return q._createNotebookExecution(ne,d(f.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${N}], DISPOSED`),U=!0,this.j.delete(N),F.dispose(),C.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity(ne,ke){ke===b.NotebookControllerAffinity2.Hidden&&(0,t.$RF)(f,"notebookControllerAffinityHidden"),q.a.$updateNotebookPriority(N,ne.uri,ke)},onDidReceiveMessage:C.event,postMessage(ne,ke){return(0,t.$RF)(f,"notebookMessaging"),q.a.$postMessage(N,ke&&q.n.getIdByEditor(ke),ne)},asWebviewUri(ne){return(0,t.$RF)(f,"notebookMessaging"),(0,a.$Qub)(ne,q.m.remote)}};return this.j.set(N,{extensionId:f.identifier,controller:me,onDidReceiveMessage:C,onDidChangeSelection:F,associatedNotebooks:ge}),me}getIdByController(f){for(const[k,L]of this.j)if(L.controller===f)return d(L.extensionId,f.id);return null}createNotebookControllerDetectionTask(f,k){const L=this.g++,p=this;this.q.trace(`NotebookControllerDetectionTask[${L}], CREATED by ${f.identifier.value}`),this.a.$addKernelDetectionTask(L,k);const y={dispose:()=>{this.f.delete(L),p.a.$removeKernelDetectionTask(L)}};return this.f.set(L,y),y}registerKernelSourceActionProvider(f,k,L){const p=this.i++,y=typeof L.onDidChangeNotebookKernelSourceActions=="function"?p:void 0,D=this;this.h.set(p,L),this.q.trace(`NotebookKernelSourceActionProvider[${p}], CREATED by ${f.identifier.value}`),this.a.$addKernelSourceActionProvider(p,p,k);let N;return y!==void 0&&(N=L.onDidChangeNotebookKernelSourceActions(q=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(p),D.a.$removeKernelSourceActionProvider(p,p),N?.dispose()}}}async $provideKernelSourceActions(f,k){const L=this.h.get(f);if(L){const p=new A.$Qc;return(await L.provideNotebookKernelSourceActions(k)??[]).map(D=>$.NotebookKernelSourceAction.from(D,this.o.converter,p))}return[]}$acceptNotebookAssociation(f,k,L){const p=this.j.get(f);if(p){const y=this.n.getNotebookDocument(g.URI.revive(k));L?p.associatedNotebooks.set(y.uri,!0):p.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${f}] ASSOCIATE notebook`,y.uri.toString(),L),p.onDidChangeSelection.fire({selected:L,notebook:y.apiNotebook})}}async $executeCells(f,k,L){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(k)),D=[];for(const N of L){const q=y.getCell(N);q&&D.push(q.apiCell)}try{this.q.trace(`NotebookController[${f}] EXECUTE cells`,y.uri.toString(),D.length),await p.controller.executeHandler.call(p.controller,D,y.apiNotebook,p.controller)}catch(N){this.q.error(`NotebookController[${f}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(f,k,L){const p=this.j.get(f);if(!p)return;const y=this.n.getNotebookDocument(g.URI.revive(k));if(p.controller.interruptHandler)await p.controller.interruptHandler.call(p.controller,y.apiNotebook);else for(const D of L){const N=y.getCell(D);N&&this.b.get(N.uri)?.cancel()}if(p.controller.interruptHandler){const D=this.c.get(y.uri);L.length&&Array.isArray(D)&&D.length&&D.forEach(N=>N.dispose())}}async $provideVariables(f,k,L,p,y,D,N){const q=this.j.get(f);if(!q)return;const V=this.n.getNotebookDocument(g.URI.revive(L)),U=q.controller.variableProvider;if(!U)return;const F=p?{name:p,value:""}:void 0,C=y==="named"?b.NotebookVariablesRequestKind.Named:b.NotebookVariablesRequestKind.Indexed,I=U.provideVariables(V.apiNotebook,F,C,D,N);for await(const X of I){if(N.isCancellationRequested)return;this.a.$receiveVariable(k,X)}}$acceptKernelMessageFromRenderer(f,k,L){const p=this.j.get(f);if(!p)return;const y=this.n.getEditorById(k);p.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:L}))}$cellExecutionChanged(f,k,L){const y=this.n.getNotebookDocument(g.URI.revive(f)).getCell(k);if(y){const D=L?$.NotebookCellExecutionState.to(L):b.NotebookCellExecutionState.Idle;D!==void 0&&this.l.fire({cell:y.apiCell,state:D})}}_createNotebookCellExecution(f,k){if(f.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const p=this.n.getNotebookDocument(f.notebook.uri).getCellFromApiCell(f);if(!p)throw new Error("invalid cell");if(this.b.has(p.uri))throw new Error(`duplicate execution for ${p.uri}`);const y=new h(k,p,this.a);this.b.set(p.uri,y);const D=y.onDidChangeState(()=>{y.state===c.Resolved&&(y.dispose(),D.dispose(),this.b.delete(p.uri))});return y.asApiObject()}_createNotebookExecution(f,k){const L=this.n.getNotebookDocument(f.uri),p=f.getCells().find(N=>{const q=L.getCellFromApiCell(N);return q&&this.b.has(q.uri)});if(p)throw new Error(`duplicate cell execution for ${p.document.uri}`);if(this.c.has(L.uri))throw new Error(`duplicate notebook execution for ${L.uri}`);const y=new r(k,L,this.a),D=y.onDidChangeState(()=>{y.state===i.Resolved&&(y.dispose(),D.dispose(),this.c.delete(L.uri))});return this.c.set(L.uri,[y,D]),y.asApiObject()}};e.$0fc=o,e.$0fc=o=He([We(4,R.$hj)],o);var c;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(c||(c={}));class h extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(f,k,L){super(),this.m=k,this.n=L,this.b=h.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=c.Init,this.g=this.B(new P.$2d),this.h=new u(10,p=>this.s(p)),this.j=k.internalMetadata.executionOrder,this.n.$createExecution(this.b,f,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(f){await this.h.addItem(f)}async s(f){const k=Array.isArray(f)?f:[f];return this.n.$updateExecution(this.b,new n.$Bv(k))}t(){if(this.f===c.Init)throw new Error("Must call start before modifying cell output");if(this.f===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(f){let k=this.m;if(f&&(k=this.m.notebook.getCellFromApiCell(f)),!k)throw new Error("INVALID cell");return k.handle}y(f){return f.map(k=>{const L=b.$9L.ensureUniqueMimeTypes(k.items,!0);return L===k.items?$.NotebookCellOutput.from(k):$.NotebookCellOutput.from({items:L,id:k.id,metadata:k.metadata})})}async z(f,k,L){const p=this.w(k),y=this.y((0,E.$2b)(f));return this.r({editType:s.CellExecutionUpdateType.Output,cellHandle:p,append:L,outputs:y})}async C(f,k,L){return f=b.$9L.ensureUniqueMimeTypes((0,E.$2b)(f),!0),this.r({editType:s.CellExecutionUpdateType.OutputItems,items:f.map($.NotebookCellOutputItem.from),outputId:k.id,append:L})}asApiObject(){const f=this;return Object.freeze({get token(){return f.g.token},get cell(){return f.m.apiCell},get executionOrder(){return f.j},set executionOrder(L){f.j=L,f.s([{editType:s.CellExecutionUpdateType.ExecutionState,executionOrder:f.j}])},start(L){if(f.f===c.Resolved||f.f===c.Started)throw new Error("Cannot call start again");f.f=c.Started,f.c.fire(),f.s({editType:s.CellExecutionUpdateType.ExecutionState,runStartTime:L})},end(L,p){if(f.f===c.Resolved)throw new Error("Cannot call resolve twice");f.f=c.Resolved,f.c.fire(),f.h.flush(),f.n.$completeExecution(f.b,new n.$Bv({runEndTime:p,lastRunSuccess:L}))},clearOutput(L){return f.t(),f.z([],L,!1)},appendOutput(L,p){return f.t(),f.z(L,p,!0)},replaceOutput(L,p){return f.t(),f.z(L,p,!1)},appendOutputItems(L,p){return f.t(),f.C(L,p,!0)},replaceOutputItems(L,p){return f.t(),f.C(L,p,!1)}})}}var i;(function(v){v[v.Init=0]="Init",v[v.Started=1]="Started",v[v.Resolved=2]="Resolved"})(i||(i={}));class r extends A.$Rc{static{this.a=0}get state(){return this.f}constructor(f,k,L){super(),this.h=k,this.j=L,this.b=r.a++,this.c=new M.$Rd,this.onDidChangeState=this.c.event,this.f=i.Init,this.g=this.B(new P.$2d),this.j.$createNotebookExecution(this.b,f,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===i.Resolved||this.f===i.Started)throw new Error("Cannot call start again");this.f=i.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===i.Resolved)throw new Error("Cannot call resolve twice");this.f=i.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class u{constructor(f,k){this.f=f,this.g=k,this.a=[],this.b=Date.now()}addItem(f){return this.a.push(f),this.c||(this.c=new T.$kh,this.b=Date.now(),(0,T.$1g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const f=this.c;this.c=void 0;const k=this.a;return this.a=[],this.g(k).finally(()=>f.complete())}}function d(v,f){return`${v.value}/${f}`}e.$$fc=d}),define(Pe[258],Re([1,0,5,3,107]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_fc=void 0;class M{constructor(m,g){this.c=g,this.a=new Map,this.b=m.getProxy(T.$EK.MainThreadNotebookRenderers)}$postRendererMessage(m,g,w){const R=this.c.getEditorById(m);this.a.get(g)?.fire({editor:R.apiEditor,message:w})}createRendererMessaging(m,g){if(!m.contributes?.notebookRenderer?.some(R=>R.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(R,S,l)=>this.d(g).event(R,S,l),postMessage:(R,S)=>{P.$Rfc.apiEditorsToExtHost.has(R)&&([R,S]=[S,R]);const l=S&&P.$Rfc.apiEditorsToExtHost.get(S);return this.b.$postMessage(l?.id,g,R)}}}d(m){let g=this.a.get(m);return g||(g=new E.$Rd({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(m)}}),this.a.set(m,g),g)}}e.$_fc=M}),define(Pe[259],Re([1,0,6,16,2,23,3]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cgc=void 0;class m{constructor(w){this.b=new Map,this.a=w.getProxy(A.$EK.MainThreadProfileContentHandlers)}registrProfileContentHandler(w,R,S){if((0,M.$RF)(w,"profileContentHandlers"),this.b.has(R))throw new Error(`Handler with id '${R}' already registered`);return this.b.set(R,S),this.a.$registerProfileContentHandler(R,S.name,S.description,w.identifier.value),(0,E.$Pc)(()=>{this.b.delete(R),this.a.$unregisterProfileContentHandler(R)})}async $saveProfile(w,R,S,l){const $=this.b.get(w);if(!$)throw new Error(`Unknown handler with id: ${w}`);return $.saveProfile(R,S,l)}async $readProfile(w,R,S){const l=this.b.get(w);if(!l)throw new Error(`Unknown handler with id: ${w}`);return l.readProfile((0,T.$Cf)(R)?R:P.URI.revive(R),S)}}e.$cgc=m}),define(Pe[260],Re([1,0,2,3,14,8]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$egc=void 0;class A{static{this.a=0}constructor(g,w){this.d=w,this.c=new Map,this.b=g.getProxy(T.$EK.MainThreadQuickDiff)}$provideOriginalResource(g,w,R){const S=E.URI.revive(w),l=this.c.get(g);return l?(0,P.$Sg)(()=>l.provideOriginalResource(S,R)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(g,w,R,S){const l=A.a++;return this.c.set(l,w),this.b.$registerQuickDiffProvider(l,M.DocumentSelector.from(g,this.d),R,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$egc=A}),define(Pe[261],Re([1,0,19,5,6,3,2,7,11,18,31,45,23,8]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fgc=void 0;function b(a,s,t){const n=a.getProxy(M.$EK.MainThreadQuickOpen);class o{constructor(k,L){this.e=new Map,this.f=0,this.a=k,this.b=L}showQuickPick(k,L,p,y=E.CancellationToken.None){this.c=void 0;const D=Promise.resolve(L),N=++this.f,q=n.$show(N,{title:p?.title,placeHolder:p?.placeHolder,matchOnDescription:p?.matchOnDescription,matchOnDetail:p?.matchOnDetail,ignoreFocusLost:p?.ignoreFocusOut,canPickMany:p?.canPickMany},y),V={},U=q.then(()=>V);return Promise.race([U,D]).then(F=>{if(F===V)return;const C=(0,l.$QF)(k,"quickPickItemTooltip");return D.then(I=>{const X=[];for(let ue=0;ue<I.length;ue++){const he=I[ue];if(typeof he=="string")X.push({label:he,handle:ue});else if(he.kind===m.QuickPickItemKind.Separator)X.push({type:"separator",label:he.label});else{he.tooltip&&!C&&console.warn(`Extension '${k.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${k.identifier.value}`);const be=he.iconPath?u(he.iconPath):void 0;X.push({label:he.label,iconPath:be?.iconPath,iconClass:be?.iconClass,description:he.description,detail:he.detail,picked:he.picked,alwaysShow:he.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(he.tooltip):void 0,handle:ue})}}return p&&typeof p.onDidSelectItem=="function"&&(this.c=ue=>{p.onDidSelectItem(I[ue])}),n.$setItems(N,X),q.then(ue=>{if(typeof ue=="number")return I[ue];if(Array.isArray(ue))return ue.map(he=>I[he])})})}).then(void 0,F=>{if(!(0,g.$3)(F))return n.$setError(N,F),Promise.reject(F)})}$onItemSelected(k){this.c?.(k)}showInput(k,L=E.CancellationToken.None){return this.d=k?.validateInput,n.$input(k,typeof this.d=="function",L).then(void 0,p=>{if(!(0,g.$3)(p))return Promise.reject(p)})}async $validateInput(k){if(!this.d)return;const L=await this.d(k);if(!L||typeof L=="string")return L;let p;switch(L.severity){case m.InputBoxValidationSeverity.Info:p=R.default.Info;break;case m.InputBoxValidationSeverity.Warning:p=R.default.Warning;break;case m.InputBoxValidationSeverity.Error:p=R.default.Error;break;default:p=L.message?R.default.Error:R.default.Ignore;break}return{content:L.message,severity:p}}async showWorkspaceFolderPick(k,L=E.CancellationToken.None){const p=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[k]);if(!p)return;const y=await this.a.getWorkspaceFolders2();if(y)return y.find(D=>D.uri.toString()===p.uri.toString())}createQuickPick(k){const L=new d(k,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}createInputBox(k){const L=new v(k,()=>this.e.delete(L._id));return this.e.set(L._id,L),L}$onDidChangeValue(k,L){this.e.get(k)?._fireDidChangeValue(L)}$onDidAccept(k){this.e.get(k)?._fireDidAccept()}$onDidChangeActive(k,L){const p=this.e.get(k);p instanceof d&&p._fireDidChangeActive(L)}$onDidChangeSelection(k,L){const p=this.e.get(k);p instanceof d&&p._fireDidChangeSelection(L)}$onDidTriggerButton(k,L){this.e.get(k)?._fireDidTriggerButton(L)}$onDidTriggerItemButton(k,L,p){const y=this.e.get(k);y instanceof d&&y._fireDidTriggerItemButton(L,p)}$onDidHide(k){this.e.get(k)?._fireDidHide()}}class c{static{this.a=1}constructor(k,L){this.x=k,this.y=L,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new T.$Rd,this.q=new T.$Rd,this.r=new T.$Rd,this.s=new T.$Rd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(k){this.b=k,this.z({title:k})}get step(){return this.c}set step(k){this.c=k,this.z({step:k})}get totalSteps(){return this.d}set totalSteps(k){this.d=k,this.z({totalSteps:k})}get enabled(){return this.g}set enabled(k){this.g=k,this.z({enabled:k})}get busy(){return this.j}set busy(k){this.j=k,this.z({busy:k})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(k){this.k=k,this.z({ignoreFocusOut:k})}get value(){return this.l}set value(k){this.l=k,this.z({value:k})}get placeholder(){return this.m}set placeholder(k){this.m=k,this.z({placeholder:k})}get buttons(){return this.n}set buttons(k){this.n=k.slice(),this.o.clear(),k.forEach((L,p)=>{const y=L===m.$2L.Back?-1:p;this.o.set(y,L)}),this.z({buttons:k.map((L,p)=>({...u(L.iconPath),tooltip:L.tooltip,handle:L===m.$2L.Back?-1:p}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(k){this.l=k,this.q.fire(k)}_fireDidTriggerButton(k){const L=this.o.get(k);L&&this.r.fire(L)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,P.$Mc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(k){if(!this.v){for(const L of Object.keys(k)){const p=k[L];this.u[L]=p===void 0?null:p}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function h(f){if(f instanceof m.$BL)return{id:f.id};const k=r(f),L=i(f);return{dark:typeof k=="string"?A.URI.file(k):k,light:typeof L=="string"?A.URI.file(L):L}}function i(f){return typeof f=="object"&&"light"in f?f.light:f}function r(f){return typeof f=="object"&&"dark"in f?f.dark:f}function u(f){const k=h(f);let L,p;return"id"in k?p=S.ThemeIcon.asClassName(k):L=k,{iconPath:L,iconClass:p}}class d extends c{constructor(k,L){super(k.identifier,L),this.O=k,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new T.$Rd,this.L=[],this.M=new T.$Rd,this.N=new T.$Rd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(k){this.B=k.slice(),this.C.clear(),this.D.clear(),k.forEach((y,D)=>{this.C.set(D,y),this.D.set(y,D)});const L=(0,l.$QF)(this.O,"quickPickItemTooltip"),p=[];for(let y=0;y<k.length;y++){const D=k[y];if(D.kind===m.QuickPickItemKind.Separator)p.push({type:"separator",label:D.label});else{D.tooltip&&!L&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const N=D.iconPath?u(D.iconPath):void 0;p.push({handle:y,label:D.label,iconPath:N?.iconPath,iconClass:N?.iconClass,description:D.description,detail:D.detail,picked:D.picked,alwaysShow:D.alwaysShow,tooltip:L?$.MarkdownString.fromStrict(D.tooltip):void 0,buttons:D.buttons?.map((q,V)=>({...u(q.iconPath),tooltip:q.tooltip,handle:V}))})}}this.z({items:p})}get canSelectMany(){return this.E}set canSelectMany(k){this.E=k,this.z({canSelectMany:k})}get matchOnDescription(){return this.F}set matchOnDescription(k){this.F=k,this.z({matchOnDescription:k})}get matchOnDetail(){return this.G}set matchOnDetail(k){this.G=k,this.z({matchOnDetail:k})}get sortByLabel(){return this.H}set sortByLabel(k){this.H=k,this.z({sortByLabel:k})}get keepScrollPosition(){return this.I}set keepScrollPosition(k){this.I=k,this.z({keepScrollPosition:k})}get activeItems(){return this.J}set activeItems(k){this.J=k.filter(L=>this.D.has(L)),this.z({activeItems:this.J.map(L=>this.D.get(L))})}get selectedItems(){return this.L}set selectedItems(k){this.L=k.filter(L=>this.D.has(L)),this.z({selectedItems:this.L.map(L=>this.D.get(L))})}_fireDidChangeActive(k){const L=(0,w.$Gb)(k.map(p=>this.C.get(p)));this.J=L,this.K.fire(L)}_fireDidChangeSelection(k){const L=(0,w.$Gb)(k.map(p=>this.C.get(p)));this.L=L,this.M.fire(L)}_fireDidTriggerItemButton(k,L){const p=this.C.get(k);if(!p||!p.buttons||!p.buttons.length)return;const y=p.buttons[L];y&&this.N.fire({button:y,item:p})}}class v extends c{constructor(k,L){super(k.identifier,L),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(k){this.B=k,this.z({password:k})}get prompt(){return this.C}set prompt(k){this.C=k,this.z({prompt:k})}get valueSelection(){return this.D}set valueSelection(k){this.D=k,this.z({valueSelection:k})}get validationMessage(){return this.E}set validationMessage(k){this.E=k,k?typeof k=="string"?this.z({validationMessage:k,severity:R.default.Error}):this.z({validationMessage:k.message,severity:k.severity??R.default.Error}):this.z({validationMessage:void 0,severity:R.default.Ignore})}}return new o(s,t)}e.$fgc=b}),define(Pe[262],Re([1,0,2,5,66,6,14,3,18,137,15,19,22,45,8,23,13,21]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$hgc=e.$ggc=void 0;function o(U){return U instanceof E.URI}function c(U,F){return U.scheme===s.Schemas.file&&F.scheme===s.Schemas.file&&t.$k?U.toString()===F.toString():U.toString().toLowerCase()===F.toString().toLowerCase()}function h(U){if(U)return typeof U.iconPath=="string"?E.URI.file(U.iconPath):E.URI.isUri(U.iconPath)||$.ThemeIcon.isThemeIcon(U.iconPath)?U.iconPath:void 0}function i(U){if(U?.icon){if(E.URI.isUri(U.icon))return U.icon;if($.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const F=U.icon;return{light:F.light,dark:F.dark}}}else return}function r(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if($.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const F=U.icon;return{light:F.light,dark:F.dark}}}else return}function u(U){if(U.icon){if(E.URI.isUri(U.icon))return U.icon;if($.ThemeIcon.isThemeIcon(U.icon))return U.icon;{const F=U.icon;return{light:F.light,dark:F.dark}}}else return}function d(U,F){if(!U.iconPath&&!F.iconPath)return 0;if(U.iconPath){if(!F.iconPath)return 1}else return-1;const C=typeof U.iconPath=="string"?U.iconPath:E.URI.isUri(U.iconPath)?U.iconPath.fsPath:U.iconPath.id,I=typeof F.iconPath=="string"?F.iconPath:E.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,w.$Bq)(C,I)}function v(U,F){let C=0;if(U.strikeThrough!==F.strikeThrough)return U.strikeThrough?1:-1;if(U.faded!==F.faded)return U.faded?1:-1;if(U.tooltip!==F.tooltip)return(U.tooltip||"").localeCompare(F.tooltip||"");if(C=d(U,F),C!==0)return C;if(U.light&&F.light)C=d(U.light,F.light);else{if(U.light)return 1;if(F.light)return-1}if(C!==0)return C;if(U.dark&&F.dark)C=d(U.dark,F.dark);else{if(U.dark)return 1;if(F.dark)return-1}return C}function f(U,F){if(U.command!==F.command)return U.command<F.command?-1:1;if(U.title!==F.title)return U.title<F.title?-1:1;if(U.tooltip!==F.tooltip){if(U.tooltip!==void 0&&F.tooltip!==void 0)return U.tooltip<F.tooltip?-1:1;if(U.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(U.arguments===F.arguments)return 0;if(U.arguments)if(F.arguments){if(U.arguments.length!==F.arguments.length)return U.arguments.length-F.arguments.length}else return 1;else return-1;for(let C=0;C<U.arguments.length;C++){const I=U.arguments[C],X=F.arguments[C];if(I!==X&&!(o(I)&&o(X)&&c(I,X)))return I<X?-1:1}return 0}function k(U,F){let C=(0,w.$Bq)(U.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(C!==0)return C;if(U.command&&F.command)C=f(U.command,F.command);else{if(U.command)return 1;if(F.command)return-1}if(C!==0)return C;if(U.decorations&&F.decorations)C=v(U.decorations,F.decorations);else{if(U.decorations)return 1;if(F.decorations)return-1}return C}function L(U,F){for(let C=0;C<U.length;C++)if(U[C]!==F[C])return!1;return!0}function p(U,F){return U.command===F.command&&U.title===F.title&&U.tooltip===F.tooltip&&(U.arguments&&F.arguments?L(U.arguments,F.arguments):U.arguments===F.arguments)}function y(U,F){return(0,g.$tb)(U,F,p)}class D{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.o,F),this.q(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.o,F),this.f=F}get validateInput(){return(0,a.$RF)(this.m,"scmValidation"),this.g}set validateInput(F){if((0,a.$RF)(this.m,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.m.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.o,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.o,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.o,F))}get actionButton(){return(0,a.$RF)(this.m,"scmInputBoxActionButton"),this.k}set actionButton(F){(0,a.$RF)(this.m,"scmInputBoxActionButton"),this.l.value=new M.$Qc,this.k=F;const C=F!==void 0?{command:this.n.converter.toInternal(F.command,this.l.value),icon:i(F),enabled:F.enabled}:void 0;this.#e.$setInputBoxActionButton(this.o,C??null)}get document(){return(0,a.$RF)(this.m,"scmTextDocument"),this.#t.getDocument(this.p)}constructor(F,C,I,X,ue,he){this.m=F,this.n=C,this.o=ue,this.p=he,this.d="",this.e=new T.$Rd,this.f="",this.h=!0,this.j=!0,this.l=new M.$Sc,this.#t=I,this.#e=X}showValidationMessage(F,C){(0,a.$RF)(this.m,"scmValidation"),this.#e.$showValidationMessage(this.o,F,C)}$onInputBoxValueChange(F){this.q(F)}q(F){this.d=F,this.e.fire(F)}}e.$ggc=D;class N{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,C,I,X,ue){this.q=F,this.s=C,this.t=I,this.u=X,this.v=ue,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new T.$Rd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new T.$Rd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=N.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,C){const I=this.h.get(F);return I?(0,A.$Sg)(()=>this.s.executeCommand(I.command,...I.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(k),I=(0,g.$Cb)(this.o,F,k).map(he=>{const be=he.toInsert.map(we=>{const ge=this.e++;this.g.set(ge,we);const me=we.resourceUri;let ne;if(we.command)if(we.command.command==="vscode.open"||we.command.command==="vscode.diff"||we.command.command==="vscode.changes"){const ie=new M.$Qc;ne=this.s.converter.toInternal(we.command,ie),this.j.set(ge,ie)}else this.h.set(ge,we.command);const ke=h(we.decorations),ce=we.decorations&&h(we.decorations.light)||ke,Y=we.decorations&&h(we.decorations.dark)||ke,W=[ce,Y],re=we.decorations&&we.decorations.tooltip||"",Ie=we.decorations&&!!we.decorations.strikeThrough,Ae=we.decorations&&!!we.decorations.faded,Ce=we.contextValue||"";return{rawResource:[ge,me,W,re,Ie,Ae,Ce,ne],handle:ge}});return{start:he.start,deleteCount:he.deleteCount,toInsert:be}}),X=I.map(({start:he,deleteCount:be,toInsert:we})=>[he,be,we.map(ge=>ge.rawResource)]),ue=I.reverse();for(const{start:he,deleteCount:be,toInsert:we}of ue){const ge=we.map(ne=>ne.handle),me=this.n.splice(he,be,...ge);for(const ne of me)this.g.delete(ne),this.h.delete(ne),this.j.get(ne)?.dispose(),this.j.delete(ne)}return this.o=F,X}dispose(){this.l=!0,this.m.fire()}}class q{static{this.d=0}#e;get id(){return this.A}get label(){return this.B}get rootUri(){return this.C}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.x,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let C;(0,a.$QF)(this.y,"quickDiffProvider")&&(C=F?.label),this.#e.$updateSourceControl(this.x,{hasQuickDiffProvider:!!F,quickDiffLabel:C})}get historyProvider(){return(0,a.$RF)(this.y,"scmHistoryProvider"),this.j}set historyProvider(F){(0,a.$RF)(this.y,"scmHistoryProvider"),this.j=F,this.k.value=new M.$Qc,this.#e.$updateSourceControl(this.x,{hasHistoryProvider:!!F}),F&&(this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.x,this.l)})),this.k.value.add(F.onDidChangeActionButton(()=>{(0,a.$RF)(this.y,"scmActionButton"),this.m.value=new M.$Qc;const C=F.actionButton!==void 0?{command:this.z.converter.toInternal(F.actionButton.command,this.m.value),description:F.actionButton.description,enabled:F.actionButton.enabled}:void 0;this.#e.$onDidChangeHistoryProviderActionButton(this.x,C??null)})))}get commitTemplate(){return this.n}set commitTemplate(F){F!==this.n&&(this.n=F,this.#e.$updateSourceControl(this.x,{commitTemplate:F}))}get acceptInputCommand(){return this.p}set acceptInputCommand(F){this.o.value=new M.$Qc,this.p=F;const C=this.z.converter.toInternal(F,this.o.value);this.#e.$updateSourceControl(this.x,{acceptInputCommand:C})}get actionButton(){return(0,a.$RF)(this.y,"scmActionButton"),this.s}set actionButton(F){(0,a.$RF)(this.y,"scmActionButton"),this.q.value=new M.$Qc,this.s=F;const C=F!==void 0?{command:this.z.converter.toInternal(F.command,this.q.value),secondaryCommands:F.secondaryCommands?.map(I=>I.map(X=>this.z.converter.toInternal(X,this.q.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.x,{actionButton:C??null})}get statusBarCommands(){return this.u}set statusBarCommands(F){if(this.u&&F&&y(this.u,F))return;this.t.value=new M.$Qc,this.u=F;const C=(F||[]).map(I=>this.z.converter.toInternal(I,this.t.value));this.#e.$updateSourceControl(this.x,{statusBarCommands:C})}get selected(){return this.v}constructor(F,C,I,X,ue,he,be){this.y=F,this.z=X,this.A=ue,this.B=he,this.C=be,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new M.$Sc,this.m=new M.$Sc,this.n=void 0,this.o=new M.$Sc,this.p=void 0,this.q=new M.$Sc,this.t=new M.$Sc,this.u=void 0,this.v=!1,this.w=new T.$Rd,this.onDidChangeSelection=this.w.event,this.x=q.d++,this.D=new Map,this.E=new Set,this.#e=I;const we=E.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${ue}/scm${this.x}/input`,query:be?`rootUri=${encodeURIComponent(be.toString())}`:void 0});this.f=new D(F,X,C,this.#e,this.x,we),this.#e.$registerSourceControl(this.x,ue,he,be,we)}createResourceGroup(F,C){const I=new N(this.#e,this.z,this.x,F,C),X=T.Event.once(I.onDidDispose)(()=>this.D.delete(I));return this.D.set(I,X),this.eventuallyAddResourceGroups(),I}eventuallyAddResourceGroups(){const F=[],C=[];for(const[I,X]of this.D){X.dispose();const ue=I.onDidUpdateResourceStates(()=>{this.E.add(I),this.eventuallyUpdateResourceStates()});T.Event.once(I.onDidDispose)(()=>{this.E.delete(I),ue.dispose(),this.e.delete(I.handle),this.#e.$unregisterGroup(this.x,I.handle)}),F.push([I.handle,I.id,I.label,I.features]);const he=I._takeResourceStateSnapshot();he.length>0&&C.push([I.handle,he]),this.e.set(I.handle,I)}this.#e.$registerGroups(this.x,F,C),this.D.clear()}eventuallyUpdateResourceStates(){const F=[];this.E.forEach(C=>{const I=C._takeResourceStateSnapshot();I.length!==0&&F.push([C.handle,I])}),F.length>0&&this.#e.$spliceResourceStates(this.x,F),this.E.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.v=F,this.w.fire(F)}dispose(){this.o.dispose(),this.q.dispose(),this.t.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.x)}}He([(0,P.$sh)(100)],q.prototype,"eventuallyAddResourceGroups",null),He([(0,P.$sh)(100)],q.prototype,"eventuallyUpdateResourceStates",null);let V=class{static{n=this}static{this.d=0}static{this.e=0}get onDidChangeActiveProvider(){return this.k.event}constructor(F,C,I,X){this.n=C,this.o=I,this.p=X,this.h=new Map,this.j=new l.$fm,this.k=new T.$Rd,this.l=new Map,this.f=F.getProxy(m.$EK.MainThreadSCM),this.g=F.getProxy(m.$EK.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:ue=>{if(ue&&ue.$mid===3){const he=this.h.get(ue.sourceControlHandle);if(!he)return ue;const be=he.getResourceGroup(ue.groupHandle);return be?be.getResourceState(ue.handle):ue}else if(ue&&ue.$mid===4){const he=this.h.get(ue.sourceControlHandle);return he?he.getResourceGroup(ue.groupHandle):ue}else if(ue&&ue.$mid===5){const he=this.h.get(ue.handle);return he||ue}return ue}})}createSourceControl(F,C,I,X){this.p.trace("ExtHostSCM#createSourceControl",F.identifier.value,C,I,X),this.g.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const ue=n.d++,he=new q(F,this.o,this.f,this.n,C,I,X);this.h.set(ue,he);const be=this.j.get(F.identifier)||[];return be.push(he),this.j.set(F.identifier,be),he}registerSourceControlInputBoxValueProvider(F,C){this.p.trace("ExtHostSCM#registerSourceControlInputBoxValueProvider",F.identifier.value,C.label);const I=n.e++;return this.l.set(I,C),this.f.$registerSourceControlInputBoxValueProvider(I,C.label,u(C)),(0,M.$Pc)(()=>{this.f.$unregisterSourceControlInputBoxValueProvider(I),this.l.delete(I)})}async $provideInputBoxValue(F,C,I){const X=this.l.get(F);if(X)return await X.provideValue(C,I,S.CancellationToken.None)??void 0}getLastInputBox(F){this.p.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const C=this.j.get(F.identifier),I=C&&C[C.length-1];return I&&I.inputBox}$provideOriginalResource(F,C,I){const X=E.URI.revive(C);this.p.trace("ExtHostSCM#$provideOriginalResource",F,X.toString());const ue=this.h.get(F);return!ue||!ue.quickDiffProvider||!ue.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$Sg)(()=>ue.quickDiffProvider.provideOriginalResource(X,I)).then(he=>he||null)}$onInputBoxValueChange(F,C){this.p.trace("ExtHostSCM#$onInputBoxValueChange",F);const I=this.h.get(F);return I&&I.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(F,C,I,X){this.p.trace("ExtHostSCM#$executeResourceCommand",F,C,I);const ue=this.h.get(F);if(!ue)return Promise.resolve(void 0);const he=ue.getResourceGroup(C);return he?he.$executeResourceCommand(I,X):Promise.resolve(void 0)}$validateInput(F,C,I){this.p.trace("ExtHostSCM#$validateInput",F);const X=this.h.get(F);return!X||!X.inputBox.validateInput?Promise.resolve(void 0):(0,A.$Sg)(()=>X.inputBox.validateInput(C,I)).then(ue=>{if(!ue)return Promise.resolve(void 0);const he=b.MarkdownString.fromStrict(ue.message);return he?Promise.resolve([he,ue.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.p.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.h.get(F)?.setSelectionState(!0),this.m!==void 0&&this.h.get(this.m)?.setSelectionState(!1),this.m=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupBase(F,C,I){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupBase(C,I)??void 0}async $resolveHistoryItemGroupCommonAncestor(F,C,I,X){return await this.h.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(C,I,X)??void 0}async $provideHistoryItems(F,C,I,X){return(await this.h.get(F)?.historyProvider?.provideHistoryItems(C,I,X))?.map(be=>({...be,icon:r(be)}))??void 0}async $provideHistoryItemChanges(F,C,I){return await this.h.get(F)?.historyProvider?.provideHistoryItemChanges(C,I)??void 0}};e.$hgc=V,e.$hgc=V=n=He([We(3,R.$hj)],V)}),define(Pe[84],Re([1,0,3,5,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ofc=e.$nfc=void 0;class M{constructor(m){this.b=new T.$Rd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(E.$EK.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,g){return this.a.$getPassword(m,g)}store(m,g,w){return this.a.$setPassword(m,g,w)}delete(m,g){return this.a.$deletePassword(m,g)}}e.$nfc=M,e.$ofc=(0,P.$Zh)("IExtHostSecretState")}),define(Pe[263],Re([1,0,3,8,2]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$igc=void 0;class M{static{this.a=0}constructor(m,g){this.d=g,this.c=new Map,this.b=m.getProxy(E.$EK.MainThreadShare)}async $provideShare(m,g,w){return await this.c.get(m)?.provideShare({selection:T.Range.to(g.selection),resourceUri:P.URI.revive(g.resourceUri)},w)??void 0}registerShareProvider(m,g){const w=M.a++;return this.c.set(w,g),this.b.$registerShareProvider(w,T.DocumentSelector.from(m,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(w),this.c.delete(w)}}}}e.$igc=M}),define(Pe[264],Re([1,0,19,6,3]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jgc=void 0;class M{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(P.$EK.MainThreadSpeech)}async $createSpeechToTextSession(m,g){const w=this.c.get(m);if(!w)return;const R=new T.$Qc,S=new E.$2d;this.d.set(g,S);const l=R.add(w.provideSpeechToTextSession(S.token));R.add(l.onDidChange($=>{S.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,$)})),R.add(S.token.onCancellationRequested(()=>R.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,g,w){const R=M.a++;return this.c.set(R,w),this.b.$registerProvider(R,g,{extension:m,displayName:m.value}),(0,T.$Pc)(()=>{this.b.$unregisterProvider(R),this.c.delete(R)})}}e.$jgc=M}),define(Pe[265],Re([1,0,7,3,163,6,8,16]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lgc=e.$kgc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new E.$CL("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new E.$CL("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,b,a,s,t=E.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new M.$Qc,this.#e=l,this.#t=$,s&&a){this.c=(0,E.$fL)(a.identifier,s);const o=b.get(this.c);o&&(t=o.alignLeft?E.StatusBarAlignment.Left:E.StatusBarAlignment.Right,n=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(g.a++);this.e=a,this.f=s,this.g=t,this.h=this.u(n)}u(l){if((0,m.$Gf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new M.$Qc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,P.localize)(0,null,this.e.displayName||this.e.name);let b=this.n;this.o&&(b=g.b.get(this.o.id));const a=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,a,this.r?.internal,b,this.o,this.g===E.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$kgc=g;class w{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",E.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,P.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new E.$GK(()=>{const b=this.b.indexOf($);b>=0&&(this.b.splice(b,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class R{constructor(l,$){this.e=new Map,this.a=l.getProxy(T.$EK.MainThreadStatusBar),this.b=$,this.c=new w(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,b,a){return new g(this.a,this.b,this.e,l,$,b,a)}setStatusBarMessage(l,$){const b=this.c.setMessage(l);let a;return typeof $=="number"?a=setTimeout(()=>b.dispose(),$):typeof $<"u"&&$.then(()=>b.dispose(),()=>b.dispose()),new E.$GK(()=>{b.dispose(),clearTimeout(a)})}}e.$lgc=R}),define(Pe[85],Re([1,0,3,5,4]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gfc=e.$ffc=void 0;class M{constructor(m,g){this.c=g,this.b=new T.$Rd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(E.$EK.MainThreadStorage)}registerExtensionStorageKeysToSync(m,g){this.a.$registerExtensionStorageKeysToSync(m,g)}async initializeExtensionStorage(m,g,w){const R=await this.a.$initializeExtensionStorage(m,g);let S;return R&&(S=this.d(m,g,R)),S||w}setValue(m,g,w){return this.a.$setValue(m,g,w)}$acceptValue(m,g,w){const R=this.d(m,g,w);R&&this.b.fire({shared:m,key:g,value:R})}d(m,g,w){try{return JSON.parse(w)}catch(R){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${m}): ${R}`)}}}e.$ffc=M,e.$gfc=(0,P.$Zh)("IExtHostStorage")}),define(Pe[86],Re([1,0,4,27,15,63,2]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ec=e.$1ec=void 0,e.$1ec=(0,E.$Zh)("IExtensionStoragePaths");let m=class{constructor(w,R,S){this.d=R,this.f=S,this.a=w.workspace??void 0,this.b=w.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(w){return A.URI.joinPath(this.b.workspaceStorageHome,w)}async h(){if(!this.a)return Promise.resolve(void 0);const w=this.a.id,R=await this.g(w);try{return await this.f.value.stat(R),this.d.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",R),await this.f.value.createDirectory(R),await this.f.value.writeFile(A.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),R}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(w){if(this.c)return A.URI.joinPath(this.c,w.identifier.value)}globalValue(w){return A.URI.joinPath(this.b.globalStorageHome,w.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$2ec=m,e.$2ec=m=He([We(0,T.$XM),We(1,P.$hj),We(2,M.$Zec)],m)}),define(Pe[64],Re([1,0,5,3,4,2,17,6,7,165,11,193,19,33,194,45,14,8,32]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mfc=e.$lfc=e.$kfc=e.$jfc=void 0,e.$jfc=(0,P.$Zh)("IExtHostTerminalService");class o{constructor(p,y,D,N){this.l=p,this._id=y,this.m=D,this.n=N,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(V=>this.f=V);const q=this;this.value={get name(){return q.n||""},get processId(){return q.b},get creationOptions(){return q.m},get exitStatus(){return q.h},get state(){return q.j},get selection(){return q.k},sendText(V,U=!0){q.q(),q.l.$sendText(q._id,V,U)},show(V){q.q(),q.l.$show(q._id,V)},hide(){q.q(),q.l.$hide(q._id)},dispose(){q.a||(q.a=!0,q.l.$dispose(q._id))},get dimensions(){if(!(q.d===void 0||q.g===void 0))return{columns:q.d,rows:q.g}}}}async create(p,y){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:p.name,shellPath:p.shellPath??void 0,shellArgs:p.shellArgs??void 0,cwd:p.cwd??y?.cwd??void 0,env:p.env??void 0,icon:v(p.iconPath)??void 0,color:a.ThemeColor.isThemeColor(p.color)?p.color.id:void 0,initialText:p.message??void 0,strictEnv:p.strictEnv??void 0,hideFromUser:p.hideFromUser??void 0,isFeatureTerminal:y?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:y?.useShellEnvironment??void 0,location:y?.location||this.o(p.location,y?.resolvedExtHostIdentifier),isTransient:p.isTransient??void 0})}async createExtensionTerminal(p,y,D,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:D,color:a.ThemeColor.isThemeColor(N)?N.id:void 0,location:this.o(p,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(p,y){return typeof p=="object"?"parentTerminal"in p&&p.parentTerminal&&y?{parentTerminal:y}:"viewColumn"in p?{viewColumn:t.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus}:void 0:p}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(p){this.n=p}setExitStatus(p,y){this.h=Object.freeze({code:p,reason:y})}setDimensions(p,y){return p===this.d&&y===this.g||p===0||y===0?!1:(this.d=p,this.g=y,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(p){this.k=p}_setProcessId(p){this.f?(this.f(p),this.f=void 0):this.b.then(y=>{y!==p&&(this.b=Promise.resolve(p))})}}e.$kfc=o;class c{get onProcessReady(){return this.b.event}constructor(p){this.g=p,this.id=0,this.shouldPersist=!1,this.a=new E.$Rd,this.onProcessData=this.a.event,this.b=new E.$Rd,this.d=new E.$Rd,this.onDidChangeProperty=this.d.event,this.f=new E.$Rd,this.onProcessExit=this.f.event}refreshProperty(p){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${p}`)}updateProperty(p,y){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${p}, value: ${y}`)}async start(){}shutdown(){this.g.close()}input(p){this.g.handleInput?.(p)}resize(p,y){this.g.setDimensions?.({columns:p,rows:y})}clearBuffer(){}async processBinary(p){}acknowledgeDataEvent(p){}async setUnicodeVersion(p){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(p){this.g.onDidWrite(y=>this.a.fire(y)),this.g.onDidClose?.((y=void 0)=>{this.f.fire(y===void 0?void 0:y)}),this.g.onDidOverrideDimensions?.(y=>{y&&this.d.fire({type:"overrideDimensions",value:{cols:y.columns,rows:y.rows}})}),this.g.onDidChangeName?.(y=>{this.d.fire({type:"title",value:y})}),this.g.open(p||void 0),p&&this.g.setDimensions?.(p),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends m.$Rc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(p=>p.value)}constructor(p,y,D){super(),this.Q=y,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Sc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new E.$Rd,this.onDidCloseTerminal=this.H.event,this.I=new E.$Rd,this.onDidOpenTerminal=this.I.event,this.J=new E.$Rd,this.onDidChangeActiveTerminal=this.J.event,this.L=new E.$Rd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new E.$Rd,this.onDidChangeTerminalState=this.M.event,this.N=new E.$Rd,this.onDidChangeShell=this.N.event,this.O=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new E.$Rd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=D.getProxy(T.$EK.MainThreadTerminalService),this.y=new b.$5qb(this.a.$sendProcessData),this.a.$registerProcessSupport(p),this.Q.registerArgumentProcessor({processArgument:N=>{const q=V=>{const U=V;return this.W(U.instanceId)?.value};switch(N?.$mid){case 15:return q(N);default:{if(Array.isArray(N))for(let V=0;V<N.length&&N[V].$mid===15;V++)N[V]=q(N[V]);return N}}}}),this.B({dispose:()=>{for(const[N,q]of this.g)q.shutdown(!0)}})}getDefaultShell(p){return(p?this.u:this.s)?.path||""}getDefaultShellArgs(p){return(p?this.u:this.s)?.args||[]}createExtensionTerminal(p,y){const D=new o(this.a,(0,$.$kg)(),p,p.name),N=new c(p.pty);return D.createExtensionTerminal(p.location,this.R(p,y).resolvedExtHostIdentifier,v(p.iconPath),f(p.color)).then(q=>{const V=this.S(q,N);this.h[q]=V}),this.f.push(D),D.value}R(p,y){if(y=y||{},p.location&&typeof p.location=="object"&&"parentTerminal"in p.location){const D=p.location.parentTerminal;if(D){const N=this.f.find(q=>q.value===D);N&&(y.resolvedExtHostIdentifier=N._id)}}else p.location&&typeof p.location!="object"?y.location=p.location:y.location&&typeof y.location=="object"&&"splitActiveTerminal"in y.location&&(y.location={splitActiveTerminal:!0});return y}attachPtyToTerminal(p,y){if(!this.W(p))throw new Error(`Cannot resolve terminal with id ${p} for virtual process`);const N=new c(y),q=this.S(p,N);this.h[p]=q}async $acceptActiveTerminalChanged(p){const y=this.b;if(p===null){this.b=void 0,y!==this.b&&this.J.fire(this.b);return}const D=this.W(p);D&&(this.b=D,y!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(p,y){const D=this.W(p);D&&this.O.fire({terminal:D.value,data:y})}async $acceptTerminalDimensions(p,y,D){const N=this.W(p);N&&N.setDimensions(y,D)&&this.L.fire({terminal:N.value,dimensions:N.value.dimensions})}async $acceptDidExecuteCommand(p,y){const D=this.W(p);D&&this.P.fire({terminal:D.value,...y})}async $acceptTerminalMaximumDimensions(p,y,D){this.g.get(p)?.resize(y,D)}async $acceptTerminalTitleChange(p,y){const D=this.W(p);D&&(D.name=y)}async $acceptTerminalClosed(p,y,D){const N=this.Y(this.f,p);if(N!==null){const q=this.f.splice(N,1)[0];q.setExitStatus(y,D),this.H.fire(q.value)}}$acceptTerminalOpened(p,y,D,N){if(y){const U=this.Y(this.f,y);if(U!==null){this.f[U]._id=p,this.I.fire(this.terminals[U]),this.f[U].isOpen=!0;return}}const q={name:N.name,shellPath:N.executable,shellArgs:N.args,cwd:typeof N.cwd=="string"?N.cwd:M.URI.revive(N.cwd),env:N.env,hideFromUser:N.hideFromUser},V=new o(this.a,p,q,D);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(p,y){this.W(p)?._setProcessId(y)}async $startExtensionTerminal(p,y){const D=this.W(p);if(!D)return{message:(0,w.localize)(0,null,p)};D.isOpen||await new Promise(q=>{const V=this.onDidOpenTerminal(async U=>{U===D.value&&(V.dispose(),q())})});const N=this.g.get(p);N?N.startSendingEvents(y):this.j[p]={initialDimensions:y}}S(p,y){const D=new m.$Qc;D.add(y.onProcessReady(q=>this.a.$sendProcessReady(p,q.pid,q.cwd,q.windowsPty))),D.add(y.onDidChangeProperty(q=>this.a.$sendProcessProperty(p,q))),this.y.startBuffering(p,y.onProcessData),D.add(y.onProcessExit(q=>this.U(p,q))),this.g.set(p,y);const N=this.j[p];return N&&y instanceof c&&(y.startSendingEvents(N.initialDimensions),delete this.j[p]),D}$acceptProcessAckDataEvent(p,y){this.g.get(p)?.acknowledgeDataEvent(y)}$acceptProcessInput(p,y){this.g.get(p)?.input(y)}$acceptTerminalInteraction(p){const y=this.W(p);y?.setInteractedWith()&&this.M.fire(y.value)}$acceptTerminalSelection(p,y){this.W(p)?.setSelection(y)}$acceptProcessResize(p,y,D){try{this.g.get(p)?.resize(y,D)}catch(N){if(N.code!=="EPIPE"&&N.code!=="ERR_IPC_CHANNEL_CLOSED")throw N}}$acceptProcessShutdown(p,y){this.g.get(p)?.shutdown(y)}$acceptProcessRequestInitialCwd(p){this.g.get(p)?.getInitialCwd().then(y=>this.a.$sendProcessProperty(p,{type:"initialCwd",value:y}))}$acceptProcessRequestCwd(p){this.g.get(p)?.getCwd().then(y=>this.a.$sendProcessProperty(p,{type:"cwd",value:y}))}$acceptProcessRequestLatency(p){return Promise.resolve(p)}registerLinkProvider(p){return this.z.add(p),this.z.size===1&&this.a.$startLinkProvider(),new g.$GK(()=>{this.z.delete(p),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(p,y,D){if(this.C.has(y))throw new Error(`Terminal profile provider "${y}" already registered`);return this.C.set(y,D),this.a.$registerProfileProvider(y,p.identifier.value),new g.$GK(()=>{this.C.delete(y),this.a.$unregisterProfileProvider(y)})}registerTerminalQuickFixProvider(p,y,D){if(this.D.has(p))throw new Error(`Terminal quick fix provider "${p}" is already registered`);return this.D.set(p,D),this.a.$registerQuickFixProvider(p,y),new g.$GK(()=>{this.D.delete(p),this.a.$unregisterQuickFixProvider(p)})}async $provideTerminalQuickFixes(p,y){const D=new l.$2d().token;if(D.isCancellationRequested)return;const N=this.D.get(p);if(!N)return;const q=await N.provideTerminalQuickFixes(y,D);if(q===null||Array.isArray(q)&&q.length===0)return;const V=new m.$Qc;if(this.w.value=V,!Array.isArray(q))return q?t.TerminalQuickFix.from(q,this.Q.converter,V):void 0;const U=[];for(const F of q){const C=t.TerminalQuickFix.from(F,this.Q.converter,V);C&&U.push(C)}return U}async $createContributedProfileTerminal(p,y){const D=new l.$2d().token;let N=await this.C.get(p)?.provideTerminalProfile(D);if(!D.isCancellationRequested){if(N&&!("options"in N)&&(N={options:N}),!N||!("options"in N))throw new Error(`No terminal profile options provided for id "${p}"`);if("pty"in N.options){this.createExtensionTerminal(N.options,y);return}this.createTerminalFromOptions(N.options,y)}}async $provideLinks(p,y){const D=this.W(p);if(!D)return[];this.F.delete(p),this.G.get(p)?.dispose(!0);const q=new l.$2d;this.G.set(p,q);const V=[],U={terminal:D.value,line:y},F=[];for(const X of this.z)F.push(s.Promises.withAsyncBody(async ue=>{q.token.onCancellationRequested(()=>ue({provider:X,links:[]}));const he=await X.provideTerminalLinks(U,q.token)||[];q.token.isCancellationRequested||ue({provider:X,links:he})}));const C=await Promise.all(F);if(q.token.isCancellationRequested)return[];const I=new Map;for(const X of C)X&&X.links.length>0&&V.push(...X.links.map(ue=>{const he={id:h++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return I.set(he.id,{provider:X.provider,link:ue}),he}));return this.F.set(p,I),V}$activateLink(p,y){const D=this.F.get(p)?.get(y);D&&D.provider.handleTerminalLink(D.link)}U(p,y){this.y.stopBuffering(p),this.g.delete(p),delete this.j[p];const D=this.h[p];D&&(D.dispose(),delete this.h[p]),this.a.$sendProcessExit(p,y)}W(p){return this.X(this.f,p)}X(p,y){const D=this.Y(p,y);return D!==null?p[D]:null}Y(p,y){const D=p.findIndex(N=>N._id===y);return D===-1?null:D}getEnvironmentVariableCollection(p){let y=this.n.get(p.identifier.value);return y||(y=new r,this.$(p.identifier.value,y)),y.getScopedEnvironmentVariableCollection(void 0)}Z(p,y){const D=(0,S.$ur)(y.map),N=(0,S.$vr)(y.descriptionMap);this.a.$setEnvironmentVariableCollection(p,y.persistent,D.length===0?void 0:D,N)}$initEnvironmentVariableCollections(p){p.forEach(y=>{const D=y[0],N=new r(y[1]);this.$(D,N)})}$acceptDefaultProfile(p,y){const D=this.s;this.s=p,this.u=y,D?.path!==p.path&&this.N.fire(p.path)}$(p,y){this.n.set(p,y),y.onDidChangeCollection(()=>{this.Z(p,y)})}};e.$lfc=i,e.$lfc=i=He([We(1,n.$4M),We(2,A.$HM)],i);class r{get persistent(){return this.b}set persistent(p){this.b=p,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(p){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new E.$Rd,this.map=new Map(p)}getScopedEnvironmentVariableCollection(p){const y=this.h(p);let D=this.a.get(y);return D||(D=new u(this,p),this.a.set(y,D),D.onDidChangeCollection(()=>this.d.fire())),D}replace(p,y,D,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Replace,options:D??{applyAtProcessCreation:!0},scope:N})}append(p,y,D,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Append,options:D??{applyAtProcessCreation:!0},scope:N})}prepend(p,y,D,N){this.f(p,{value:y,type:g.EnvironmentVariableMutatorType.Prepend,options:D??{applyAtProcessCreation:!0},scope:N})}f(p,y){if(y.options&&y.options.applyAtProcessCreation===!1&&!y.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const D=this.g(p,y.scope),N=this.map.get(D),q=y.options?{applyAtProcessCreation:y.options.applyAtProcessCreation??!1,applyAtShellIntegration:y.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!N||N.value!==y.value||N.type!==y.type||N.options?.applyAtProcessCreation!==q.applyAtProcessCreation||N.options?.applyAtShellIntegration!==q.applyAtShellIntegration||N.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index){const V=this.g(p,y.scope),U={variable:p,...y,options:q};this.map.set(V,U),this.d.fire()}}get(p,y){const D=this.g(p,y),N=this.map.get(D);return N?k(N):void 0}g(p,y){const D=this.h(y);return D.length?`${p}:::${D}`:p}h(p){return this.j(p?.workspaceFolder)??""}j(p){return p?p.uri.toString():void 0}getVariableMap(p){const y=new Map;for(const[D,N]of this.map)this.h(N.scope)===this.h(p)&&y.set(N.variable,k(N));return y}delete(p,y){const D=this.g(p,y);this.map.delete(D),this.d.fire()}clear(p){if(p?.workspaceFolder){for(const[y,D]of this.map)D.scope?.workspaceFolder?.index===p.workspaceFolder.index&&this.map.delete(y);this.k(p)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(p,y){const D=this.h(y),N=this.descriptionMap.get(D);if(!N||N.description!==p){let q;typeof p=="string"?q=p:q=p?.value.split(`

`)[0];const V={description:q,scope:y};this.descriptionMap.set(D,V),this.d.fire()}}getDescription(p){const y=this.h(p);return this.descriptionMap.get(y)?.description}k(p){const y=this.h(p);this.descriptionMap.delete(y)}}class u{get persistent(){return this.b.persistent}set persistent(p){this.b.persistent=p}get onDidChangeCollection(){return this.a&&this.a.event}constructor(p,y){this.b=p,this.d=y,this.a=new E.$Rd}getScoped(p){return this.b.getScopedEnvironmentVariableCollection(p)}replace(p,y,D){this.b.replace(p,y,D,this.d)}append(p,y,D){this.b.append(p,y,D,this.d)}prepend(p,y,D){this.b.prepend(p,y,D,this.d)}get(p){return this.b.get(p,this.d)}forEach(p,y){this.b.getVariableMap(this.d).forEach((D,N)=>p.call(y,N,D,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(p){this.b.delete(p,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(p){this.b.setDescription(p,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends i{constructor(p,y){super(!1,p,y)}createTerminal(p,y,D){throw new R.$$}createTerminalFromOptions(p,y){throw new R.$$}};e.$mfc=d,e.$mfc=d=He([We(0,n.$4M),We(1,A.$HM)],d);function v(L){if(!(!L||typeof L=="string"))return"id"in L?{id:L.id,color:L.color}:L}function f(L){return a.ThemeColor.isThemeColor(L)?L:void 0}function k(L){const p={...L};return delete p.scope,p.options=p.options??void 0,delete p.variable,p}}),define(Pe[266],Re([1,0,14,24,19,5,218,98,6,26,16,33,3,17,108,8,7,48,77,58,23]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=e.$qgc=e.$pgc=void 0;let h=class extends g.$Rc{constructor(V,U,F){super(),this.u=F,this.f=this.B(new M.$Rd),this.g=new Map,this.s=this.B(new M.$Rd),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(l.$EK.MainThreadTesting),this.m=new y(this.h),this.j=new d(this.h),U.registerArgumentProcessor({processArgument:C=>{switch(C?.$mid){case 16:{const I=C,X=I.tests[I.tests.length-1].item.extId;return this.g.get(t.$wJ.root(X))?.collection.tree.get(X)?.actual??(0,b.$TM)(C)}case 18:{const{extId:I,message:X}=C;return{test:this.g.get(t.$wJ.root(I))?.collection.tree.get(I)?.actual,message:a.TestMessage.to(X)}}default:return C}}}),U.registerCommand(!1,"testing.getExplorerSelection",async()=>{const C=await U.executeCommand("_testing.getExplorerSelection"),I=X=>{const ue=this.g.get(t.$wJ.root(X));if(ue)return t.$wJ.isRoot(X)?ue.controller:ue.collection.tree.get(X)?.actual};return{include:C?.include.map(I).filter(R.$Kf)||[],exclude:C?.exclude.map(I).filter(R.$Kf)||[]}})}createTestController(V,U,F,C){if(this.g.has(U))throw new Error(`Attempt to insert a duplicate controller with ID "${U}"`);const I=new g.$Qc,X=I.add(new b.$WM(U,F,this.u));X.root.label=F;const ue=new Map,he=new Set,be=this.h,we={items:X.root.children,get label(){return F},set label(me){F=me,X.root.label=me,be.$updateController(U,{label:F})},get refreshHandler(){return C},set refreshHandler(me){C=me,be.$updateController(U,{canRefresh:!!me})},get id(){return U},createRunProfile:(me,ne,ke,ce,Y,W)=>{let re=(0,m.$Ni)(me);for(;ue.has(re);)re++;return new D(this.h,ue,V,he,this.s.event,U,re,me,ne,ke,ce,Y,W)},createTestItem(me,ne,ke){return new b.$UM(U,me,ne,ke)},createTestRun:(me,ne,ke=!0)=>this.j.createTestRun(V,U,X,me,ne,ke),invalidateTestResults:me=>{if(me===void 0)this.h.$markTestRetired(void 0);else{const ne=me instanceof Array?me:[me];this.h.$markTestRetired(ne.map(ke=>t.$wJ.fromExtHostTestItem(ke,U).toString()))}},set resolveHandler(me){X.resolveHandler=me},get resolveHandler(){return X.resolveHandler},dispose:()=>{I.dispose()}};be.$registerTestController(U,F,!!C),I.add((0,g.$Pc)(()=>be.$unregisterTestController(U)));const ge={controller:we,collection:X,profiles:ue,extension:V,activeProfiles:he};return this.g.set(U,ge),I.add((0,g.$Pc)(()=>this.g.delete(U))),I.add(X.onDidGenerateDiff(me=>be.$publishDiff(U,me.map(o.TestsDiffOp.serialize)))),we}createTestObserver(){return this.m.checkout()}async runTests(V,U=P.CancellationToken.None){const F=v(V);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const C=this.g.get(F.controllerId);if(!C)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:V.include?.map(I=>t.$wJ.fromExtHostTestItem(I,C.collection.root.id).toString())??[C.collection.root.id],profileGroup:N[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:V.exclude?.map(I=>I.id)},U)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $provideFileCoverage(V,U,F){return await this.j.getCoverageReport(V,U)?.provideFileCoverage(F)??[]}async $resolveFileCoverage(V,U,F,C){return await this.j.getCoverageReport(V,U)?.resolveFileCoverage(F,C)??[]}$configureRunProfile(V,U){this.g.get(V)?.profiles.get(U)?.configureHandler?.()}$setActiveRunProfiles(V){const U=new Map;for(const[F,C]of Object.entries(V)){const I=this.g.get(F);if(!I)continue;const X=new Map,ue=C.filter(be=>!I.activeProfiles.has(be)),he=[...I.activeProfiles].filter(be=>!C.includes(be));for(const be of ue)X.set(be,!0),I.activeProfiles.add(be);for(const be of he)X.set(be,!1),I.activeProfiles.delete(be);X.size&&U.set(F,X)}this.s.fire(U)}async $refreshTests(V,U){await this.g.get(V)?.controller.refreshHandler?.(U)}$publishTestResults(V){this.results=Object.freeze(V.map(U=>(0,w.$fn)(a.TestResults.to(U))).concat(this.results).sort((U,F)=>F.completedAt-U.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,U){const F=this.g.get(t.$wJ.fromString(V).controllerId)?.collection;F&&(await F.expand(V,U<0?1/0:U),F.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(o.TestsDiffOp.deserialize))}async $runControllerTests(V,U){return Promise.all(V.map(F=>this.w(F,!1,U)))}async $startContinuousRun(V,U){const F=new P.$2d(U),C=await Promise.all(V.map(I=>this.w(I,!0,F.token)));return!U.isCancellationRequested&&!C.some(I=>I.error)&&await new Promise(I=>U.onCancellationRequested(I)),F.dispose(!0),C}async w(V,U,F){const C=this.g.get(V.controllerId);if(!C)return{};const{collection:I,profiles:X,extension:ue}=C,he=X.get(V.profileId);if(!he)return{};const be=V.testIds.map(ne=>I.tree.get(ne)).filter(R.$Kf),we=V.excludeExtIds.map(ne=>C.collection.tree.get(ne)).filter(R.$Kf).filter(ne=>be.some(ke=>ke.fullId.compare(ne.fullId)===2));if(!be.length)return{};const ge=new s.$dM(be.some(ne=>ne.actual instanceof b.$VM)?void 0:be.map(ne=>ne.actual),we.map(ne=>ne.actual),he,U),me=(0,o.$yJ)(V)&&this.j.prepareForMainThreadTestRun(ge,f.fromInternal(V,C.collection),ue,F);try{return await he.runHandler(ge,F),{}}catch(ne){return{error:String(ne)}}finally{me&&(me.hasRunningTasks&&!F.isCancellationRequested&&await M.Event.toPromise(me.onEnd),me.dispose())}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$pgc=h,e.$pgc=h=He([We(0,$.$HM)],h);const i=1e4;var r;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(r||(r={}));class u extends g.$Rc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(V,U,F,C){super(),this.s=V,this.u=U,this.w=F,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new M.$Rd),this.m=this.B(new M.$Rd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new P.$2d(C));const I=this.B(new E.$_g(()=>this.y(),i));this.B(this.h.token.onCancellationRequested(()=>I.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.y()}createRun(V){const U=this.s.id,F=this.s.controllerId,C=(0,S.$kg)(),I=this.w,X=this.m;let ue;const he=me=>(ne,...ke)=>{if(we){console.warn(`Setting the state of test "${ne.id}" is a no-op after the run ends.`);return}this.s.isIncluded(ne)&&(this.C(ne),me(ne,...ke))},be=(me,ne)=>{const ke=ne instanceof Array?ne.map(a.TestMessage.from):[a.TestMessage.from(ne)];if(me.uri&&me.range){const ce={range:a.Range.from(me.range),uri:me.uri};for(const Y of ke)Y.location=Y.location||ce}this.u.$appendTestMessagesInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),ke)};let we=!1;const ge={isPersisted:this.s.isPersisted,token:this.h.token,name:V,get coverageProvider(){return ue?.provider},set coverageProvider(me){(0,c.$RF)(I,"testCoverage"),ue=me&&new k(me),X.fire({taskId:C,runId:U,coverage:ue})},enqueued:he(me=>{this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),1)}),skipped:he(me=>{this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),5)}),started:he(me=>{this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),2)}),errored:he((me,ne,ke)=>{be(me,ne),this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),6,ke)}),failed:he((me,ne,ke)=>{be(me,ne),this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,F).toString(),4,ke)}),passed:he((me,ne)=>{this.u.$updateTestStateInRun(U,C,t.$wJ.fromExtHostTestItem(me,this.s.controllerId).toString(),3,ne)}),appendOutput:(me,ne,ke)=>{we||(ke&&(this.s.isIncluded(ke)?this.C(ke):ke=void 0),this.u.$appendOutputToRun(U,C,T.$fe.fromString(me),ne&&a.location.from(ne),ke&&t.$wJ.fromExtHostTestItem(ke,F).toString()))},end:()=>{we||(we=!0,this.u.$finishedTestRunTask(U,C),this.f.delete(C),this.f.size||this.z())}};return this.f.set(C,{run:ge}),this.u.$startedTestRunTask(U,{id:C,name:V,running:!0}),ge}y(){for(const{run:V}of this.f.values())V.end()}z(){this.c!==2&&(this.c=2,this.j.fire())}C(V){if(!(V instanceof b.$UM))throw new n.$zM(V.id);if(this.g.has(t.$wJ.fromExtHostTestItem(V,this.s.controllerId).toString()))return;const U=[],F=this.s.colllection.root;for(;;){const C=a.TestItem.from(V);if(U.unshift(C),this.g.has(C.extId)||(this.g.add(C.extId),V===F))break;V=V.parent||F}this.u.$addTestsToRun(this.s.controllerId,this.s.id,U)}dispose(){this.z(),super.dispose()}}class d{get trackers(){return this.c.values()}constructor(V){this.f=V,this.c=new Map,this.d=[]}getCoverageReport(V,U){return this.d.find(F=>F.runId===V)?.coverage.get(U)}prepareForMainThreadTestRun(V,U,F,C){return this.g(V,U,F,C)}cancelRunById(V){for(const U of this.c.values())if(U.id===V){U.cancel();return}}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,U,F,C,I,X){const ue=this.c.get(C);if(ue)return ue.createRun(I);const he=f.fromPublic(U,F,C,X),be=v(C);this.f.$startedExtensionTestRun({controllerId:U,continuous:!!C.continuous,profile:be&&{group:N[be.kind],id:be.profileId},exclude:C.exclude?.map(ge=>t.$wJ.fromExtHostTestItem(ge,F.root.id).toString())??[],id:he.id,include:C.include?.map(ge=>t.$wJ.fromExtHostTestItem(ge,F.root.id).toString())??[F.root.id],persist:X});const we=this.g(C,he,V);return M.Event.once(we.onEnd)(()=>{this.f.$finishedExtensionTestRun(he.id),we.dispose()}),we.createRun(I)}g(V,U,F,C){const I=new u(U,this.f,F,C);this.c.set(V,I);let X;const ue=I.onDidCoverage(({runId:he,taskId:be,coverage:we})=>{X||(X={runId:he,coverage:new Map},this.d.unshift(X),this.d.length>o.$DJ&&this.d.pop()),X.coverage.set(be,we),this.f.$signalCoverageAvailable(he,be,!!we)});return M.Event.once(I.onEnd)(()=>{this.c.delete(V),ue.dispose()}),I}}e.$qgc=d;const v=q=>{if(q.profile){if(!(q.profile instanceof D))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class f{static fromPublic(V,U,F,C){return new f(V,(0,S.$kg)(),F.include?.map(I=>t.$wJ.fromExtHostTestItem(I,V).toString())??[V],F.exclude?.map(I=>t.$wJ.fromExtHostTestItem(I,V).toString())??[],C,U)}static fromInternal(V,U){return new f(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,U)}constructor(V,U,F,C,I,X){this.controllerId=V,this.id=U,this.isPersisted=I,this.colllection=X,this.c=F.map(ue=>ue+"\0"),this.d=C.map(ue=>ue+"\0")}isIncluded(V){const U=t.$wJ.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const F of this.d)if(U===F||U.startsWith(F))return!1;for(const F of this.c)if(U===F||U.startsWith(F))return!0;return!1}}e.$rgc=f;class k{constructor(V){this.provider=V}async provideFileCoverage(V){this.c||(this.c=(async()=>this.provider.provideFileCoverage(V))());try{return(await this.c)?.map(a.TestCoverage.fromFile)??[]}catch(U){throw this.c=void 0,U}}async resolveFileCoverage(V,U){const F=await this.c;let C=F?.[V];return!this.provider||!F||!C?[]:(C.detailedCoverage||(C=F[V]=await this.provider.resolveFileCoverage?.(C,U)??C),C.detailedCoverage?.map(a.TestCoverage.fromDetailed)??[])}}class L{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(V){this.h=V,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,a.TestItem.toPlain(V.item)),this.c.has(V)||this.d.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.d.delete(V);const U=t.$wJ.parentId(V.item.extId);if(U&&this.g.has(U.toString())){this.g.add(V.item.extId);return}this.f.add(V)}getChangeEvent(){const{c:V,d:U,f:F}=this;return{get added(){return[...V].map(C=>C.revived)},get updated(){return[...U].map(C=>C.revived)},get removed(){return[...F].map(C=>C.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class p extends o.$EJ{constructor(){super(...arguments),this.q=new M.$Rd,this.onDidChangeTests=this.q.event}get rootTests(){return this.f}getMirroredTestDataById(V){return this.d.get(V)}getMirroredTestDataByReference(V){return this.d.get(V.id)}p(V,U){return{...V,revived:a.TestItem.toPlain(V.item),depth:U?U.depth+1:0,children:new Set}}o(){return new L(this.q)}}class y{constructor(V){this.d=V}checkout(){this.c||(this.c=this.f());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(U=>U.revived)},dispose:(0,A.$cb)(()=>{--V.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}f(){const V=new p;return this.d.$subscribeToDiffs(),{observers:0,tests:V}}}class D{#e;#t;#i;#o;#r;get label(){return this.d}set label(V){V!==this.d&&(this.d=V,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:V}))}get isDefault(){return this.f}set isDefault(V){V!==this.f&&(this.f=V,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{tag:V?a.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,this.#e.$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!V}))}get isSelected(){return(0,c.$RF)(this.#t,"testingActiveProfile"),this.#i.has(this.profileId)}get onDidChangeSelected(){return(0,c.$RF)(this.#t,"testingActiveProfile"),M.Event.chain(this.#o,V=>V.map(U=>U.get(this.controllerId)?.get(this.profileId)).filter(R.$Kf))}constructor(V,U,F,C,I,X,ue,he,be,we,ge=!1,me=void 0,ne=!1){this.controllerId=X,this.profileId=ue,this.d=he,this.kind=be,this.runHandler=we,this.f=ge,this._tag=me,this.g=ne,this.#e=V,this.#r=U,this.#t=F,this.#i=C,this.#o=I,U.set(ue,this);const ke=N[be];if(typeof ke!="number")throw new Error(`Unknown TestRunProfile.group ${be}`);this.#e.$publishTestRunProfile({profileId:ue,controllerId:X,tag:me?a.TestTag.namespace(this.controllerId,me.id):null,label:he,group:ke,isDefault:ge,hasConfigurationHandler:!1,supportsContinuousRun:ne})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId))}}e.$sgc=D;const N={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Pe[267],Re([1,0,18,11,5,3,109,8,7]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oec=void 0;class w{constructor(S,l){this.i=l,this.a=new P.$Rd({onListenerError:T.$1}),this.b=new P.$Rd({onListenerError:T.$1}),this.c=new P.$Rd({onListenerError:T.$1}),this.d=new P.$Rd({onListenerError:T.$1}),this.f=new P.$Rd({onListenerError:T.$1}),this.g=new P.$Rd({onListenerError:T.$1}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=S.getProxy(M.$EK.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors($=>this.g.fire($)),this.i.onDidChangeActiveTextEditor($=>this.f.fire($))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(S){const l=this.i.allEditors();return S?l:l.map($=>$.value)}async showTextDocument(S,l,$){let b;typeof l=="number"?b={position:m.ViewColumn.from(l),preserveFocus:$}:typeof l=="object"?b={position:m.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selection:typeof l.selection=="object"?m.Range.from(l.selection):void 0,pinned:typeof l.preview=="boolean"?!l.preview:void 0}:b={preserveFocus:!1};const a=await this.h.$tryShowTextDocument(S.uri,b),s=a&&this.i.getEditor(a);if(s)return s.value;throw a?new Error(`Could NOT open editor for "${S.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${S.uri.toString()}".`)}createTextEditorDecorationType(S,l){return new A.$OM(this.h,S,l).value}$acceptEditorPropertiesChanged(S,l){const $=this.i.getEditor(S);if(!$)throw new Error("unknown text editor");if(l.options&&$._acceptOptions(l.options),l.selections){const b=l.selections.selections.map(m.Selection.to);$._acceptSelections(b)}if(l.visibleRanges){const b=E.$Gb(l.visibleRanges.map(m.Range.to));$._acceptVisibleRanges(b)}if(l.options&&this.b.fire({textEditor:$.value,options:{...l.options,lineNumbers:m.TextEditorLineNumbersStyle.to(l.options.lineNumbers)}}),l.selections){const b=g.TextEditorSelectionChangeKind.fromValue(l.selections.source),a=l.selections.selections.map(m.Selection.to);this.a.fire({textEditor:$.value,selections:a,kind:b})}if(l.visibleRanges){const b=E.$Gb(l.visibleRanges.map(m.Range.to));this.c.fire({textEditor:$.value,visibleRanges:b})}}$acceptEditorPositionData(S){for(const l in S){const $=this.i.getEditor(l);if(!$)throw new Error("Unknown text editor");const b=m.ViewColumn.to(S[l]);$.value.viewColumn!==b&&($._acceptViewColumn(b),this.d.fire({textEditor:$.value,viewColumn:b}))}}getDiffInformation(S){return Promise.resolve(this.h.$getDiffInformation(S))}}e.$Oec=w}),define(Pe[268],Re([1,0,2,4,3,6,7,8,22,16]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=void 0,e.$ugc=(0,T.$Zh)("IExtHostTimeline");class R{constructor($,b){this.b=new Map,this.c=new Map,this.a=$.getProxy(P.$EK.MainThreadTimeline),b.registerArgumentProcessor({processArgument:(a,s)=>{if(a&&a.$mid===12)if(this.b.get(a.source)&&g.$dm.equals(s,this.b.get(a.source)?.extension)){const t=a.uri===void 0?void 0:E.URI.revive(a.uri);return this.c.get(a.source)?.get(S(t))?.get(a.handle)}else return;return a}})}async $getTimeline($,b,a,s){return this.b.get($)?.provider.provideTimeline(E.URI.revive(b),a,s)}registerTimelineProvider($,b,a,s){const t=new M.$Qc,n=this.d(b.id,s,t).bind(this);let o;b.onDidChange&&(o=b.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:b.id}),this));const c=this.c;return this.f({...b,scheme:$,onDidChange:void 0,async provideTimeline(h,i,r){i?.resetCache&&(t.clear(),c.get(b.id)?.clear());const u=await b.provideTimeline(h,i,r);if(u==null)return;const d=n(h,i);return{...u,source:b.id,items:u.items.map(d)}},dispose(){for(const h of c.values())h.get(b.id)?.clear();o?.dispose(),t.dispose()}},a)}d($,b,a){return(s,t)=>{let n;if(t?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const c=S(s);n=o.get(c),n===void 0&&(n=new Map,o.set(c,n))}return o=>{const{iconPath:c,...h}=o,i=`${$}|${o.id??o.timestamp}`;n?.set(i,o);let r,u,d;o.iconPath&&(c instanceof A.$BL?d={id:c.id,color:c.color}:E.URI.isUri(c)?(r=c,u=c):{light:r,dark:u}=c);let v;return A.$8K.isMarkdownString(h.tooltip)?v=m.MarkdownString.from(h.tooltip):(0,w.$Cf)(h.tooltip)?v=h.tooltip:A.$8K.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=m.MarkdownString.from(h.detail)):(0,w.$Cf)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),v=h.detail),{...h,id:h.id??void 0,handle:i,source:$,command:o.command?b.toInternal(o.command,a):void 0,icon:r,iconDark:u,themeIcon:d,tooltip:v,accessibilityInformation:o.accessibilityInformation}}}}f($,b){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:b}),(0,M.$Pc)(()=>{for(const s of this.c.values())s.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$vgc=R;function S(l){return l?.toString()}}),define(Pe[87],Re([1,0,19,5,6,167,4,15,196,3,27,17,7]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ixb=e.$Hxb=e.TunnelDtoConverter=void 0;class $ extends g.$rv{}var b;(function(s){function t(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:o.protocol}}s.fromApiTunnel=t;function n(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==g.TunnelPrivacyId.ConstantPrivate&&o.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}s.fromServiceTunnel=n})(b||(e.TunnelDtoConverter=b={})),e.$Hxb=(0,A.$Zh)("IExtHostTunnelService");let a=class extends P.$Rc{constructor(t,n,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new T.$Rd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=t.getProxy(w.$EK.MainThreadTunnelService)}async openTunnel(t,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const o=await this.a.$openTunnel(n,t.displayName);if(o){const c=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(t,n){const o=this.u();return this.r.set(o,{selector:t,provider:n}),this.a.$registerPortsAttributesProvider(t,o),new l.$GK(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(t,n,o,c,h){const i=[];for(const u of t){const d=this.r.get(u);if(!d)return[];i.push(...await Promise.all(n.map(async v=>{let f;try{f=await d.provider.providePortAttributes({port:v,pid:o,commandLine:c},h)}catch{f=await d.provider.providePortAttributes(v,o,c,h)}return{providedAttributes:f,port:v}})))}const r=i.filter(u=>!!u.providedAttributes);return r.length>0?r.map(u=>({autoForwardAction:u.providedAttributes.autoForwardAction,port:u.port})):[]}async $registerCandidateFinder(t){}registerTunnelProvider(t,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await t.provideTunnel(c,h,new E.$2d().token)??void 0;const o=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,P.$Pc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(t,n){if(t){t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.f=t.showCandidatePort,this.a.$setCandidateFilter());const o=t.tunnelFactory??(n?this.w(n):void 0);if(o){this.b=o;let c=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:M.localize(0,null),themeIcon:"lock"},{id:"public",label:M.localize(1,null),themeIcon:"eye"}]);const h=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:c}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,P.$Pc)(()=>{this.b=void 0})}w(t){}async $closeTunnel(t,n){if(this.g.has(t.host)){const o=this.g.get(t.host);o.has(t.port)&&(n&&o.get(t.port).disposeListener.dispose(),await o.get(t.port).tunnel.dispose(),o.delete(t.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(t,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(t,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const c=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(t.remoteAddress.host)||this.g.set(t.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:c,disposeListener:h}),b.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(t){const n=await Promise.all(t.map(c=>this.f(c.host,c.port,c.detail??""))),o=t.filter((c,h)=>n[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(c=>c.port).join(", ")} to ${o.map(c=>c.port).join(", ")}`),o}};e.$Ixb=a,e.$Ixb=a=He([We(0,S.$HM),We(1,R.$XM),We(2,m.$hj)],a)}),define(Pe[269],Re([1,0,6,13,2,3]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;class A{static{this.a=new Set([T.Schemas.http,T.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(M.$EK.MainThreadUriOpeners)}registerExternalUriOpener(g,w,R,S){if(this.c.has(w))throw new Error(`Opener with id '${w}' already registered`);const l=S.schemes.find($=>!A.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(w,R),this.b.$registerUriOpener(w,S.schemes,g,S.label),(0,E.$Pc)(()=>{this.c.delete(w),this.b.$unregisterUriOpener(w)})}async $canOpenUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener with id: ${g}`);const l=P.URI.revive(w);return S.canOpenExternalUri(l,R)}async $openUri(g,w,R){const S=this.c.get(g);if(!S)throw new Error(`Unknown opener id: '${g}'`);return S.openExternalUri(P.URI.revive(w.resolvedUri),{sourceUri:P.URI.revive(w.sourceUri)},R)}}e.$xgc=A}),define(Pe[270],Re([1,0,3,2,6,11,22]),function(pe,e,E,T,P,M,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class m{static{this.a=0}constructor(w){this.c=new A.$em,this.d=new Map,this.b=w.getProxy(E.$EK.MainThreadUrls)}registerUriHandler(w,R){const S=w.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const l=m.a++;return this.c.add(S),this.d.set(l,R),this.b.$registerUriHandler(l,S,w.displayName||w.name),(0,P.$Pc)(()=>{this.c.delete(S),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(w,R){const S=this.d.get(w);if(!S)return Promise.resolve(void 0);try{S.handleUri(T.URI.revive(R))}catch(l){(0,M.$Z)(l)}return Promise.resolve(void 0)}async createAppUri(w){return T.URI.revive(await this.b.$createAppUri(w))}}e.$ygc=m}),define(Pe[65],Re([1,0,5,6,13,26,2,181,203,78,3]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7ec=e.$6ec=e.$5ec=e.$4ec=e.$3ec=void 0;class S{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;constructor(c,h,i,r,u,d,v){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new E.$Rd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new E.$Rd,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#s=i,this.#o=r,this.#r=u,this.#n=d,this.#l=l(d),this.#d=$(d),this.#i=v}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,w.$Qub)(c,this.#o)}get cspSource(){const c=this.#n.extensionLocation;if(c.scheme===P.Schemas.https||c.scheme===P.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+w.$Pub}return w.$Pub}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#n,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#s}set options(c){this.a(),M.$in(this.#s,c)||this.#t.$setOptions(this.#e,s(this.#n,this.#r,c)),this.#s=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$jfb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#n.extensionLocation?.scheme===P.Schemas.vscodeRemote,i=this.#n.extensionLocation.scheme===P.Schemas.vscodeRemote?this.#n.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,d,v,f,k)=>{const L=A.URI.from({scheme:v||"file",path:decodeURIComponent(f)}),p=(0,w.$Qub)(L,{isRemote:h,authority:i}).toString();return`${u}${p}${k}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(r,u,d,v,f,k)=>{const L=A.URI.from({scheme:v||"file",path:decodeURIComponent(f)}),p=(0,w.$Qub)(L,{isRemote:h,authority:i}).toString();return`${u}${p}${k}`})}}e.$3ec=S;function l(o){try{const c=(0,m.$Xo)((0,m.$Wo)(o.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}e.$4ec=l;function $(o){try{const c=(0,m.$Xo)((0,m.$Wo)(o.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class b extends T.$Rc{constructor(c,h,i,r,u){super(),this.c=h,this.f=i,this.g=r,this.h=u,this.b=new Map,this.a=c.getProxy(R.$EK.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const r=this.j(c);if(r){const{message:u}=(0,g.$kfb)(h,i.value);r._onMessageEmitter.fire(u)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const r=new S(c,this.a,t(h),this.c,this.f,i,this.h);this.b.set(c,r);const u=r._onDidDispose(()=>{u.dispose(),this.deleteWebview(c)});return r}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$5ec=b;function a(o){return{id:o.identifier,location:o.extensionLocation}}e.$6ec=a;function s(o,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||n(o,c)}}e.$7ec=s;function t(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(c=>A.URI.from(c))}}function n(o,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),o.extensionLocation]}}),define(Pe[271],Re([1,0,19,98,6,13,25,2,8,65,75,3,7]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9ec=void 0;class ${constructor(r,u){this.document=r,this.b=u,this.a=1,this.c=new R.$vec("custom documents")}addEdit(r){return this.c.add([r])}async undo(r,u){await this.f(r).undo(),u||this.disposeBackup()}async redo(r,u){await this.f(r).redo(),u||this.disposeBackup()}disposeEdits(r){for(const u of r)this.c.delete(u)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const r=h(this.document.uri)+this.a++;return(0,A.$Bg)(this.b,r)}updateBackup(r){this.d?.delete(),this.d=r}disposeBackup(){this.d?.delete(),this.d=void 0}f(r){const u=this.c.get(r,0);if(!u)throw new Error("No edit found");return u}}class b{constructor(){this.a=new Map}get(r,u){return this.a.get(this.b(r,u))}add(r,u,d){const v=this.b(r,u.uri);if(this.a.has(v))throw new Error(`Document already exists for viewType:${r} resource:${u.uri}`);const f=new $(u,d);return this.a.set(v,f),f}delete(r,u){const d=this.b(r,u.uri);this.a.delete(d)}b(r,u){return`${r}@@@${u}`}}var a;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(a||(a={}));class s{constructor(){this.a=new Map}addTextProvider(r,u,d){return this.b(0,r,u,d)}addCustomProvider(r,u,d){return this.b(1,r,u,d)}get(r){return this.a.get(r)}b(r,u,d,v){if(this.a.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this.a.set(u,{type:r,extension:d,provider:v}),new l.$GK(()=>this.a.delete(u))}}class t{constructor(r,u,d,v,f){this.d=u,this.f=d,this.g=v,this.h=f,this.b=new s,this.c=new b,this.a=r.getProxy(S.$EK.MainThreadCustomEditors)}registerCustomEditorProvider(r,u,d,v){const f=new P.$Qc;return o(d)?(f.add(this.b.addTextProvider(u,r,d)),this.a.$registerTextEditorProvider((0,w.$6ec)(r),u,v.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,w.$4ec)(r))):(f.add(this.b.addCustomProvider(u,r,d)),n(d)&&f.add(d.onDidChangeCustomDocument(k=>{const L=this.i(u,k.document.uri);if(c(k)){const p=L.addEdit(k);this.a.$onDidEdit(k.document.uri,u,p,k.label)}else this.a.$onContentChange(k.document.uri,u)})),this.a.$registerCustomEditorProvider((0,w.$6ec)(r),u,v.webviewOptions||{},!!v.supportsMultipleEditorsPerDocument,(0,w.$4ec)(r))),l.$GK.from(f,new l.$GK(()=>{this.a.$unregisterEditorProvider(u)}))}async $createCustomDocument(r,u,d,v,f){const k=this.b.get(u);if(!k)throw new Error(`No provider found for '${u}'`);if(k.type!==1)throw new Error(`Invalid provide type for '${u}'`);const L=m.URI.revive(r),p=await k.provider.openCustomDocument(L,{backupId:d,untitledDocumentData:v?.buffer},f);let y;return n(k.provider)&&this.f&&(y=this.f.workspaceValue(k.extension)??this.f.globalValue(k.extension)),this.c.add(u,p,y),{editable:n(k.provider)}}async $disposeCustomDocument(r,u){const d=this.b.get(u);if(!d)throw new Error(`No provider found for '${u}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${u}'`);const v=m.URI.revive(r),{document:f}=this.i(u,v);this.c.delete(u,f),f.dispose()}async $resolveCustomEditor(r,u,d,v,f,k){const L=this.b.get(d);if(!L)throw new Error(`No provider found for '${d}'`);const p=g.ViewColumn.to(f),y=this.g.createNewWebview(u,v.contentOptions,L.extension),D=this.h.createNewWebviewPanel(u,d,v.title,p,v.options,y,v.active),N=m.URI.revive(r);switch(L.type){case 1:{const{document:q}=this.i(d,N);return L.provider.resolveCustomEditor(q,D,k)}case 0:{const q=this.d.getDocument(N);return L.provider.resolveCustomTextEditor(q,D,k)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(r,u,d){this.i(u,r).disposeEdits(d)}async $onMoveCustomEditor(r,u,d){const v=this.b.get(d);if(!v)throw new Error(`No provider found for '${d}'`);if(!v.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const f=this.h.getWebviewPanel(r);if(!f)throw new Error("No webview found");const k=m.URI.revive(u),L=this.d.getDocument(k);await v.provider.moveCustomTextEditor(L,f,E.CancellationToken.None)}async $undo(r,u,d,v){return this.i(u,r).undo(d,v)}async $redo(r,u,d,v){return this.i(u,r).redo(d,v)}async $revert(r,u,d){const v=this.i(u,r);await this.j(u).revertCustomDocument(v.document,d),v.disposeBackup()}async $onSave(r,u,d){const v=this.i(u,r);await this.j(u).saveCustomDocument(v.document,d),v.disposeBackup()}async $onSaveAs(r,u,d,v){const f=this.i(u,r);return this.j(u).saveCustomDocumentAs(f.document,m.URI.revive(d),v)}async $backup(r,u,d){const v=this.i(u,r),k=await this.j(u).backupCustomDocument(v.document,{destination:v.getNewBackupUri()},d);return v.updateBackup(k),k.id}i(r,u){const d=this.c.get(r,m.URI.revive(u));if(!d)throw new Error("No custom document found");return d}j(r){const d=this.b.get(r)?.provider;if(!d||!n(d))throw new Error("Custom document is not editable");return d}}e.$9ec=t;function n(i){return!!i.onDidChangeCustomDocument}function o(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const r=i.scheme===M.Schemas.file||i.scheme===M.Schemas.untitled?i.fsPath:i.toString();return(0,T.$Ni)(r)+""}}),define(Pe[272],Re([1,0,5,6,2,33,8,65,3,7]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ec=void 0;class R extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;#u;#l;#d;#h;constructor(b,a,s,t){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new E.$Rd),this.onDidDispose=this.#d.event,this.#h=this.B(new E.$Rd),this.onDidChangeViewState=this.#h.event,this.#e=b,this.#t=a,this.#o=s,this.#i=t.viewType,this.#r=t.panelOptions,this.#s=t.viewColumn,this.#n=t.title,this.#u=t.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#n}set title(b){this.c(),this.#n!==b&&(this.#n=b,this.#t.$setTitle(this.#e,b))}get iconPath(){return this.c(),this.#a}set iconPath(b){this.c(),this.#a!==b&&(this.#a=b,this.#t.$setIconPath(this.#e,P.URI.isUri(b)?{light:b,dark:b}:b))}get options(){return this.#r}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(b){this.#l||(this.active!==b.active||this.visible!==b.visible||this.viewColumn!==b.viewColumn)&&(this.#u=b.active,this.#c=b.visible,this.#s=b.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(b,a){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof b>"u"?void 0:A.ViewColumn.from(b),preserveFocus:!!a})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends T.$Rc{static c(){return(0,M.$kg)()}constructor(b,a,s){super(),this.j=a,this.m=s,this.g=new Map,this.h=new Map,this.f=b.getProxy(g.$EK.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(b=>b.dispose()),this.g.clear()}createWebviewPanel(b,a,s,t,n={}){const o=typeof t=="object"?t.viewColumn:t,c={viewColumn:A.ViewColumn.from(o),preserveFocus:typeof t=="object"&&!!t.preserveFocus},h=(0,m.$4ec)(b),i=S.c();this.f.$createWebviewPanel((0,m.$6ec)(b),i,a,{title:s,panelOptions:l(n),webviewOptions:(0,m.$7ec)(b,this.m,n),serializeBuffersForPostMessage:h},c);const r=this.j.createNewWebview(i,n,b);return this.createNewWebviewPanel(i,a,s,o,n,r,!0)}$onDidChangeWebviewPanelViewStates(b){const a=Object.keys(b);a.sort((s,t)=>{const n=b[s],o=b[t];return n.active?1:o.active?-1:+n.visible-+o.visible});for(const s of a){const t=this.getWebviewPanel(s);if(!t)continue;const n=b[s];t._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(b){this.getWebviewPanel(b)?.dispose(),this.g.delete(b),this.j.deleteWebview(b)}registerWebviewPanelSerializer(b,a,s){if(this.h.has(a))throw new Error(`Serializer for '${a}' already registered`);return this.h.set(a,{serializer:s,extension:b}),this.f.$registerSerializer(a,{serializeBuffersForPostMessage:(0,m.$4ec)(b)}),new w.$GK(()=>{this.h.delete(a),this.f.$unregisterSerializer(a)})}async $deserializeWebviewPanel(b,a,s,t){const n=this.h.get(a);if(!n)throw new Error(`No serializer found for '${a}'`);const{serializer:o,extension:c}=n,h=this.j.createNewWebview(b,s.webviewOptions,c),i=this.createNewWebviewPanel(b,a,s.title,t,s.panelOptions,h,s.active);await o.deserializeWebviewPanel(i,s.state)}createNewWebviewPanel(b,a,s,t,n,o,c){const h=new R(b,this.f,o,{viewType:a,title:s,viewColumn:t,panelOptions:n,active:c});return this.g.set(b,h),h}getWebviewPanel(b){return this.g.get(b)}}e.$8ec=S;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Pe[273],Re([1,0,5,6,65,8,3,7]),function(pe,e,E,T,P,M,A,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;class g extends T.$Rc{#e;#t;#i;#o;#r;#n;#a;#s;#c;constructor(S,l,$,b,a,s){super(),this.#r=!1,this.#u=this.B(new E.$Rd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new E.$Rd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=b,this.#e=S,this.#t=l,this.#o=a,this.#n=s}dispose(){this.#r||(this.#r=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#s}set description(S){this.a(),this.#s!==S&&(this.#s=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#n}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(S){S===this.#n||this.#r||(this.#n=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=M.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#r)throw new Error("Webview is disposed")}}class w{constructor(S,l){this.d=l,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$EK.MainThreadWebviewViews)}registerWebviewViewProvider(S,l,$,b){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:S}),this.a.$registerWebviewViewProvider((0,P.$6ec)(S),l,{retainContextWhenHidden:b?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,P.$4ec)(S)}),new m.$GK(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(S,l,$,b,a){const s=this.b.get(l);if(!s)throw new Error(`No view provider found for '${l}'`);const{provider:t,extension:n}=s,o=this.d.createNewWebview(S,{},n),c=new g(S,this.a,l,$,o,!0);this.c.set(S,c),await t.resolveWebviewView(c,{state:b},a)}async $onDidChangeWebviewViewVisibility(S,l){this.e(S)._setVisible(l)}async $disposeWebviewView(S){const l=this.e(S);this.c.delete(S),l.dispose(),this.d.deleteWebview(S)}e(S){const l=this.c.get(S);if(!l)throw new Error("No webview found");return l}}e.$zgc=w}),define(Pe[111],Re([1,0,5,3,2,13,12,4,17,23]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=e.$Agc=void 0;let S=class{static{R=this}static{this.a={focused:!0,active:!0}}getState($){const b=this.d;return{get focused(){return b.focused},get active(){return(0,w.$RF)($,"windowActivity"),b.active}}}constructor($){this.c=new E.$Rd,this.onDidChangeWindowState=this.c.event,this.d=R.a,this.b=$.getProxy(T.$EK.MainThreadWindow),this.b.$getInitialState().then(({isFocused:b,isActive:a})=>{this.onDidChangeWindowProperty("focused",b),this.onDidChangeWindowProperty("active",a)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,b){b!==this.d[$]&&(this.d={...this.d,[$]:b},this.c.fire(this.d))}openUri($,b){let a;if(typeof $=="string"){a=$;try{$=P.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,A.$Fe)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===M.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,a,b)}async asExternalUri($,b){if((0,A.$Fe)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const a=await this.b.$asExternalUri($,b);return P.URI.from(a)}};e.$Agc=S,e.$Agc=S=R=He([We(0,g.$HM)],S),e.$Bgc=(0,m.$Zh)("IExtHostWindow")}),define(Pe[274],Re([1,0,240,27,17]),function(pe,e,E,T,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;let M=class extends E.$Egc{constructor(m,g){super(m,g)}f(m,g,w){g.apply(console,w)}};e.$Mic=M,e.$Mic=M=He([We(0,P.$HM),We(1,T.$XM)],M)}),define(Pe[275],Re([1,0,14,24,19,11,5,6,138,229,49]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Q6b=e.ResponsiveState=e.RequestInitiator=e.$P6b=e.$O6b=void 0;function l(D,N){try{return JSON.stringify(D,N)}catch{return"null"}}const $="$$ref$$",b={[$]:-1};class a{constructor(N,q){this.jsonString=N,this.referencedBuffers=q}}function s(D,N=null,q=!1){const V=[];return{jsonString:(q?l:JSON.stringify)(D,(F,C)=>{if(typeof C>"u")return b;if(typeof C=="object"){if(C instanceof T.$fe){const I=V.push(C)-1;return{[$]:I}}if(N)return N(F,C)}return C}),referencedBuffers:V}}e.$O6b=s;function t(D,N,q){return JSON.parse(D,(V,U)=>{if(U){const F=U[$];if(typeof F=="number")return N[F];if(q&&U.$mid===1)return q.transformIncoming(U)}return U})}e.$P6b=t;function n(D,N){return JSON.stringify(D,N)}function o(D){return D?(N,q)=>q&&q.$mid===1?D.transformOutgoing(q):q:null}var c;(function(D){D[D.LocalSide=0]="LocalSide",D[D.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(D){D[D.Responsive=0]="Responsive",D[D.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},r=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends m.$Rc{static{S=r}static{this.a=3*1e3}constructor(N,q=null,V=null){super(),this[S]=!0,this.b=this.B(new A.$Rd),this.onDidChangeResponsiveState=this.b.event,this.c=N,this.f=q,this.g=V,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let U=0,F=R.$yv.count;U<F;U++)this.m[U]=null,this.s[U]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new E.$_g(()=>this.H(),1e3)),this.c.onMessage(U=>this.L(U))}dispose(){this.j=!0,Object.keys(this.w).forEach(N=>{const q=this.w[N];delete this.w[N],q.resolveErr(M.$5())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(N){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(N){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(N){this.y!==N&&(this.y=N,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(N){return this.g?(0,g.$Ym)(N,this.g):N}getProxy(N){const{nid:q,sid:V}=N;return this.s[q]||(this.s[q]=this.J(q,V)),this.s[q]}J(N,q){const V={get:(U,F)=>(typeof F=="string"&&!U[F]&&F.charCodeAt(0)===36&&(U[F]=(...C)=>this.U(N,F,C)),F===u?q:U[F])};return new Proxy(Object.create(null),V)}set(N,q){return this.m[N.nid]=q,q}assertRegistered(N){for(let q=0,V=N.length;q<V;q++){const U=N[q];if(!this.m[U.nid])throw new Error(`Missing proxy instance ${U.sid}`)}}L(N){if(this.j)return;const q=N.byteLength,V=f.read(N,0),U=V.readUInt8(),F=V.readUInt32();switch(U){case 1:case 2:{let{rpcId:C,method:I,args:X}=L.deserializeRequestJSONArgs(V);this.g&&(X=(0,g.$Ym)(X,this.g)),this.M(q,F,C,I,X,U===2);break}case 3:case 4:{let{rpcId:C,method:I,args:X}=L.deserializeRequestMixedArgs(V);this.g&&(X=(0,g.$Ym)(X,this.g)),this.M(q,F,C,I,X,U===4);break}case 5:{this.f?.logIncoming(q,F,0,"ack"),this.G(F);break}case 6:{this.N(q,F);break}case 7:{this.O(q,F,void 0);break}case 9:{let C=L.deserializeReplyOKJSON(V);this.g&&(C=(0,g.$Ym)(C,this.g)),this.O(q,F,C);break}case 10:{const C=L.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(q,F,C);break}case 8:{const C=L.deserializeReplyOKVSBuffer(V);this.O(q,F,C);break}case 11:{let C=L.deserializeReplyErrError(V);this.g&&(C=(0,g.$Ym)(C,this.g)),this.P(q,F,C);break}case 12:{this.P(q,F,void 0);break}default:console.error("received unexpected message"),console.error(N)}}M(N,q,V,U,F,C){this.f?.logIncoming(N,q,1,`receiveRequest ${(0,R.$Av)(V)}.${U}(`,F);const I=String(q);let X,ue;if(C){const be=new P.$2d;F.push(be.token),X=this.Q(V,U,F),ue=()=>be.cancel()}else X=this.Q(V,U,F),ue=i;this.u[I]=ue;const he=L.serializeAcknowledged(q);this.f?.logOutgoing(he.byteLength,q,1,"ack"),this.c.send(he),X.then(be=>{delete this.u[I];const we=L.serializeReplyOK(q,be,this.h);this.f?.logOutgoing(we.byteLength,q,1,"reply:",be),this.c.send(we)},be=>{delete this.u[I];const we=L.serializeReplyErr(q,be);this.f?.logOutgoing(we.byteLength,q,1,"replyErr:",be),this.c.send(we)})}N(N,q){this.f?.logIncoming(N,q,1,"receiveCancel");const V=String(q);this.u[V]?.()}O(N,q,V){this.f?.logIncoming(N,q,0,"receiveReply:",V);const U=String(q);if(!this.w.hasOwnProperty(U))return;const F=this.w[U];delete this.w[U],F.resolveOk(V)}P(N,q,V){this.f?.logIncoming(N,q,0,"receiveReplyErr:",V);const U=String(q);if(!this.w.hasOwnProperty(U))return;const F=this.w[U];delete this.w[U];let C;V&&(V.$isError?(C=new Error,C.name=V.name,C.message=V.message,C.stack=V.stack):C=V),F.resolveErr(C)}Q(N,q,V){try{return Promise.resolve(this.S(N,q,V))}catch(U){return Promise.reject(U)}}S(N,q,V){const U=this.m[N];if(!U)throw new Error("Unknown actor "+(0,R.$Av)(N));const F=U[q];if(typeof F!="function")throw new Error("Unknown method "+q+" on actor "+(0,R.$Av)(N));return F.apply(U,V)}U(N,q,V){if(this.j)return new w.$N6b;let U=null;if(V.length>0&&P.CancellationToken.isCancellationToken(V[V.length-1])&&(U=V.pop()),U&&U.isCancellationRequested)return Promise.reject(M.$5());const F=L.serializeRequestArguments(V,this.h),C=++this.t,I=String(C),X=new w.$M6b,ue=new m.$Qc;U&&ue.add(U.onCancellationRequested(()=>{const be=L.serializeCancel(C);this.f?.logOutgoing(be.byteLength,C,0,"cancel"),this.c.send(L.serializeCancel(C))})),this.w[I]=new v(X,ue),this.F(C);const he=L.serializeRequest(C,N,q,F,!!U);return this.f?.logOutgoing(he.byteLength,C,0,`request: ${(0,R.$Av)(N)}.${q}(`,V),this.c.send(he),X}}e.$Q6b=d;class v{constructor(N,q){this.a=N,this.b=q}resolveOk(N){this.a.resolveOk(N),this.b.dispose()}resolveErr(N){this.a.resolveErr(N),this.b.dispose()}}class f{static alloc(N,q,V){const U=new f(T.$fe.alloc(V+1+4),0);return U.writeUInt8(N),U.writeUInt32(q),U}static read(N,q){return new f(N,q)}get buffer(){return this.a}constructor(N,q){this.a=N,this.b=q}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(N){this.a.writeUInt8(N,this.b),this.b+=1}readUInt8(){const N=this.a.readUInt8(this.b);return this.b+=1,N}writeUInt32(N){this.a.writeUInt32BE(N,this.b),this.b+=4}readUInt32(){const N=this.a.readUInt32BE(this.b);return this.b+=4,N}static sizeShortString(N){return 1+N.byteLength}writeShortString(N){this.a.writeUInt8(N.byteLength,this.b),this.b+=1,this.a.set(N,this.b),this.b+=N.byteLength}readShortString(){const N=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+N).toString();return this.b+=N,V}static sizeLongString(N){return 4+N.byteLength}writeLongString(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readLongString(){const N=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+N).toString();return this.b+=N,V}writeBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}static sizeVSBuffer(N){return 4+N.byteLength}writeVSBuffer(N){this.a.writeUInt32BE(N.byteLength,this.b),this.b+=4,this.a.set(N,this.b),this.b+=N.byteLength}readVSBuffer(){const N=this.a.readUInt32BE(this.b);this.b+=4;const q=this.a.slice(this.b,this.b+N);return this.b+=N,q}static sizeMixedArray(N){let q=0;q+=1;for(let V=0,U=N.length;V<U;V++){const F=N[V];switch(q+=1,F.type){case 1:q+=this.sizeLongString(F.value);break;case 2:q+=this.sizeVSBuffer(F.value);break;case 3:q+=this.sizeUInt32,q+=this.sizeLongString(F.value);for(let C=0;C<F.buffers.length;++C)q+=this.sizeVSBuffer(F.buffers[C]);break;case 4:break}}return q}writeMixedArray(N){this.a.writeUInt8(N.length,this.b),this.b+=1;for(let q=0,V=N.length;q<V;q++){const U=N[q];switch(U.type){case 1:this.writeUInt8(1),this.writeLongString(U.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(U.value);break;case 3:this.writeUInt8(3),this.writeUInt32(U.buffers.length),this.writeLongString(U.value);for(let F=0;F<U.buffers.length;++F)this.writeBuffer(U.buffers[F]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const N=this.a.readUInt8(this.b);this.b+=1;const q=new Array(N);for(let V=0;V<N;V++)switch(this.readUInt8()){case 1:q[V]=this.readLongString();break;case 2:q[V]=this.readVSBuffer();break;case 3:{const F=this.readUInt32(),C=this.readLongString(),I=[];for(let X=0;X<F;++X)I.push(this.readVSBuffer());q[V]=new R.$Bv(t(C,I,null));break}case 4:q[V]=void 0;break}return q}}var k;(function(D){D[D.Simple=0]="Simple",D[D.Mixed=1]="Mixed"})(k||(k={}));class L{static a(N){for(let q=0,V=N.length;q<V;q++)if(N[q]instanceof T.$fe||N[q]instanceof R.$Bv||typeof N[q]>"u")return!0;return!1}static serializeRequestArguments(N,q){if(this.a(N)){const V=[];for(let U=0,F=N.length;U<F;U++){const C=N[U];if(C instanceof T.$fe)V[U]={type:2,value:C};else if(typeof C>"u")V[U]={type:4};else if(C instanceof R.$Bv){const{jsonString:I,referencedBuffers:X}=s(C.value,q);V[U]={type:3,value:T.$fe.fromString(I),buffers:X}}else V[U]={type:1,value:T.$fe.fromString(n(C,q))}}return{type:1,args:V}}return{type:0,args:n(N,q)}}static serializeRequest(N,q,V,U,F){switch(U.type){case 0:return this.b(N,q,V,U.args,F);case 1:return this.c(N,q,V,U.args,F)}}static b(N,q,V,U,F){const C=T.$fe.fromString(V),I=T.$fe.fromString(U);let X=0;X+=f.sizeUInt8(),X+=f.sizeShortString(C),X+=f.sizeLongString(I);const ue=f.alloc(F?2:1,N,X);return ue.writeUInt8(q),ue.writeShortString(C),ue.writeLongString(I),ue.buffer}static deserializeRequestJSONArgs(N){const q=N.readUInt8(),V=N.readShortString(),U=N.readLongString();return{rpcId:q,method:V,args:JSON.parse(U)}}static c(N,q,V,U,F){const C=T.$fe.fromString(V);let I=0;I+=f.sizeUInt8(),I+=f.sizeShortString(C),I+=f.sizeMixedArray(U);const X=f.alloc(F?4:3,N,I);return X.writeUInt8(q),X.writeShortString(C),X.writeMixedArray(U),X.buffer}static deserializeRequestMixedArgs(N){const q=N.readUInt8(),V=N.readShortString(),U=N.readMixedArray(),F=new Array(U.length);for(let C=0,I=U.length;C<I;C++){const X=U[C];typeof X=="string"?F[C]=JSON.parse(X):F[C]=X}return{rpcId:q,method:V,args:F}}static serializeAcknowledged(N){return f.alloc(5,N,0).buffer}static serializeCancel(N){return f.alloc(6,N,0).buffer}static serializeReplyOK(N,q,V){if(typeof q>"u")return this.d(N);if(q instanceof T.$fe)return this.e(N,q);if(q instanceof R.$Bv){const{jsonString:U,referencedBuffers:F}=s(q.value,V,!0);return this.g(N,U,F)}else return this.f(N,l(q,V))}static d(N){return f.alloc(7,N,0).buffer}static e(N,q){let V=0;V+=f.sizeVSBuffer(q);const U=f.alloc(8,N,V);return U.writeVSBuffer(q),U.buffer}static deserializeReplyOKVSBuffer(N){return N.readVSBuffer()}static f(N,q){const V=T.$fe.fromString(q);let U=0;U+=f.sizeLongString(V);const F=f.alloc(9,N,U);return F.writeLongString(V),F.buffer}static g(N,q,V){const U=T.$fe.fromString(q);let F=0;F+=f.sizeUInt32,F+=f.sizeLongString(U);for(const I of V)F+=f.sizeVSBuffer(I);const C=f.alloc(10,N,F);C.writeUInt32(V.length),C.writeLongString(U);for(const I of V)C.writeBuffer(I);return C.buffer}static deserializeReplyOKJSON(N){const q=N.readLongString();return JSON.parse(q)}static deserializeReplyOKJSONWithBuffers(N,q){const V=N.readUInt32(),U=N.readLongString(),F=[];for(let C=0;C<V;++C)F.push(N.readVSBuffer());return new R.$Bv(t(U,F,q))}static serializeReplyErr(N,q){const V=q?l(M.$2(q),null):void 0;if(typeof V!="string")return this.h(N);const U=T.$fe.fromString(V);let F=0;F+=f.sizeLongString(U);const C=f.alloc(11,N,F);return C.writeLongString(U),C.buffer}static deserializeReplyErrError(N){const q=N.readLongString();return JSON.parse(q)}static h(N){return f.alloc(12,N,0).buffer}}var p;(function(D){D[D.RequestJSONArgs=1]="RequestJSONArgs",D[D.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",D[D.RequestMixedArgs=3]="RequestMixedArgs",D[D.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",D[D.Acknowledged=5]="Acknowledged",D[D.Cancel=6]="Cancel",D[D.ReplyOKEmpty=7]="ReplyOKEmpty",D[D.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",D[D.ReplyOKJSON=9]="ReplyOKJSON",D[D.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",D[D.ReplyErrError=11]="ReplyErrError",D[D.ReplyErrEmpty=12]="ReplyErrEmpty"})(p||(p={}));var y;(function(D){D[D.String=1]="String",D[D.VSBuffer=2]="VSBuffer",D[D.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",D[D.Undefined=4]="Undefined"})(y||(y={}))}),define(Pe[276],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;const E=function(M){const A=m=>{globalThis.removeEventListener("message",A);const g=m.data;Object.defineProperties(globalThis,{postMessage:{value(w,R){g.postMessage(w,R)}},onmessage:{get(){return g.onmessage},set(w){g.onmessage=w}}}),g.addEventListener("message",w=>{globalThis.dispatchEvent(new MessageEvent("message",{data:w.data,ports:w.ports?[...w.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(M)};globalThis.addEventListener("message",A)}.toString();class T extends EventTarget{constructor(M,A,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${E})('${A}'))`,w=new Blob([g],{type:"application/javascript"}),R=URL.createObjectURL(w),S=new MessageChannel,l=R,$={type:"_newWorker",id:l,port:S.port2,url:R,options:m};M($,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{M({type:"_terminateWorker",id:l}),URL.revokeObjectURL(R),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(b){S.port1.onmessage=b}},onmessageerror:{get(){return S.port1.onmessageerror},set(b){S.port1.onmessageerror=b}}}),S.port1.addEventListener("messageerror",b=>{const a=new MessageEvent("messageerror",{data:b.data});this.dispatchEvent(a)}),S.port1.addEventListener("message",b=>{const a=new MessageEvent("message",{data:b.data});this.dispatchEvent(a)}),S.port1.start()}}e.$Oic=T}),define(Pe[277],Re([1,0,5,30,35,4]),function(pe,e,E,T,P,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.OutputChannelUpdateMode=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.$QJ=e.$PJ=void 0,e.$PJ="text/x-code-output",e.$QJ="output",e.$RJ="Log",e.$SJ="text/x-code-log-output",e.$TJ="log",e.$UJ="workbench.panel.output",e.$VJ=new P.$ej("inOutput",!1),e.$WJ=new P.$ej("activeLogOutput",!1),e.$XJ=new P.$ej("outputView.scrollLock",!1),e.$YJ=(0,M.$Zh)("outputService");var A;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$ZJ={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new E.$Rd,this.onDidRegisterChannel=this.b.event,this.c=new E.$Rd,this.onDidRemoveChannel=this.c.event}registerChannel(w){this.a.has(w.id)||(this.a.set(w.id,w),this.b.fire(w.id))}getChannels(){const w=[];return this.a.forEach(R=>w.push(R)),w}getChannel(w){return this.a.get(w)}removeChannel(w){this.a.delete(w),this.c.fire(w)}}T.$qn.add(e.$ZJ.OutputChannels,new m),e.$1J=new P.$ej("activeOutputChannel","")}),define(Pe[112],Re([1,0,3,4,17,22,15,277,63,27,43,135,24,16,42,5,6]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bgc=e.$agc=void 0;class t extends A.$nj{get disposed(){return this.n}constructor(h,i,r,u,d){super(),this.id=h,this.name=i,this.r=r,this.s=u,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(r.getLevel()),this.B(r.onDidChangeLogLevel(v=>this.setLevel(v)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$fe.fromString(i).byteLength,(0,A.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends t{appendLine(h){this.append(h)}}let o=class{constructor(h,i,r,u,d,v){this.i=i,this.j=r,this.k=u,this.l=d,this.m=v,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(E.$EK.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$om)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,r]of this.g)r.visible=i===this.h}createOutputChannel(h,i,r){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const u=typeof i=="object"&&i.log,d=(0,$.$Cf)(i)?i:void 0;if((0,$.$Cf)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let v;const f=this.i.environment.extensionLogLevel?.find(([L])=>M.$dm.equals(r.identifier,L))?.[1];f&&(v=(0,A.$xj)(f));const k=u?this.o(h,v,r):this.n(h,d,r);return k.then(L=>{this.g.set(L.id,L),L.visible=L.id===this.h}),u?this.r(h,v??this.m.getLevel(),k):this.q(h,k)}async n(h,i,r){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const u=await this.c,d=this.k.extUri.joinPath(u,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),v=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),f=await this.a.$register(h,d,i,r.identifier.value);return new t(f,h,v,this.a,r)}async o(h,i,r){const u=await this.p(r),d=h.replace(/[\\/:\*\?"<>\|]/g,""),v=this.k.extUri.joinPath(u,`${d}.log`),f=`${r.identifier.value}.${d}`,k=this.l.createLogger(v,{id:f,name:h,logLevel:i,extensionId:r.identifier.value});return new n(f,h,k,this.a,r)}p(h){let i=this.d.get(h.identifier.value);if(!i){const r=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(r)}catch(u){if((0,b.$yk)(u)!==b.FileSystemProviderErrorCode.FileExists)throw u}return r})())}return i}q(h,i){let r=!1;const u=()=>{if(r)throw new Error("Channel has been closed")};return{get name(){return h},append(d){u(),i.then(v=>v.append(d))},appendLine(d){u(),i.then(v=>v.appendLine(d))},clear(){u(),i.then(d=>d.clear())},replace(d){u(),i.then(v=>v.replace(d))},show(d,v){u(),i.then(f=>f.show(d,v))},hide(){u(),i.then(d=>d.hide())},dispose(){r=!0,i.then(d=>d.dispose())}}}r(h,i,r){const u=new s.$Qc,d=()=>{if(u.isDisposed)throw new Error("Channel has been closed")},v=u.add(new a.$Rd);function f(k){i=k,v.fire(k)}return r.then(k=>{u.add(k),k.logLevel!==i&&f(k.logLevel),u.add(k.onDidChangeLogLevel(L=>f(L)))}),{...this.q(h,r),get logLevel(){return i},onDidChangeLogLevel:v.event,trace(k,...L){d(),r.then(p=>p.trace(k,...L))},debug(k,...L){d(),r.then(p=>p.debug(k,...L))},info(k,...L){d(),r.then(p=>p.info(k,...L))},warn(k,...L){d(),r.then(p=>p.warn(k,...L))},error(k,...L){d(),r.then(p=>p.error(k,...L))},dispose(){u.dispose()}}}};e.$agc=o,e.$agc=o=He([We(0,P.$HM),We(1,w.$XM),We(2,g.$Zec),We(3,R.$zec),We(4,A.$ij),We(5,A.$hj)],o),e.$bgc=(0,T.$Zh)("IExtHostOutputService")}),define(Pe[113],Re([1,0,4,14]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=void 0,e.$Dm=(0,E.$Zh)("remoteAgentService"),e.$Em=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(P){let M=1/0;for(let m=0;m<this.maxSampleCount;m++){const g=await P.getRoundTripTime();if(g===void 0)return;M=Math.min(M,g/2),await(0,T.$1g)(this.sampleDelay)}this.average.push(M),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(M):A=this.initial.reduce((m,g)=>m+g,0)/this.initial.length,this.lastMeasurement={initial:A,current:M,average:this.average.reduce((m,g)=>m+g,0)/this.average.length,high:(()=>typeof A>"u"?!1:M>this.highLatencyMaxThreshold||M>this.highLatencyMinThreshold&&M>A*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(Pe[278],Re([1,0,169,54,30,47,41,6,5,113,21,26]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=void 0,e.$tH=Object.freeze({id:"application",order:100,title:(0,E.localize)(0,null),type:"object"}),e.$uH=Object.freeze({id:"workbench",order:7,title:(0,E.localize)(1,null),type:"object"}),e.$vH=Object.freeze({id:"security",scope:1,title:(0,E.localize)(2,null),type:"object",order:7}),e.$wH={ConfigurationMigration:"base.contributions.configuration.migration"};class l{constructor(){this.migrations=[],this.a=new g.$Rd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const $=new l;P.$qn.add(e.$wH.ConfigurationMigration,$);let b=class extends m.$Rc{constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async o=>{for(const c of o.added)await this.f(c,$.migrations)})),this.c($.migrations),this.B($.onDidRegisterConfigurationMigration(o=>this.c(o)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(o=>this.g(o,t?.uri))])}async g(t,n){const o=this.a.inspect(t.key,{resource:n}),c=[["userValue",2],["userLocalValue",3],["userRemoteValue",4],["workspaceValue",5],["workspaceFolderValue",6]];for(const[h,i]of c){const r=[];for(const d of o.overrideIdentifiers??[]){const v=await this.h(t,{resource:n,overrideIdentifier:d},h);for(const f of v??[]){let k=r.find(([[L,p]])=>L===f[0]&&(0,S.$in)(p.value,f[1].value));k||r.push(k=[f,[]]),k[1].push(d)}}const u=await this.h(t,{resource:n},h,o);for(const d of u??[])r.push([d,[]]);r.length&&await Promise.allSettled(r.map(async([[d,v],f])=>this.a.updateValue(d,v.value,{resource:n,overrideIdentifiers:f},i)))}}async h(t,n,o,c){const h=(c??this.a.inspect(t.key,n))[o];if(h===void 0)return;const i=u=>this.a.inspect(u,n)[o],r=await t.migrateFn(h,i);return Array.isArray(r)?r:[[t.key,r]]}};e.$xH=b,e.$xH=b=He([We(0,A.$ti),We(1,M.$9h)],b);let a=class extends m.$Rc{constructor(t){super(),(async()=>{if(!R.$i&&(await t.getEnvironment())?.os!==1)return;P.$qn.as(T.$vn.Configuration).registerConfiguration({...e.$vH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,E.localize)(3,null)},default:[],markdownDescription:(0,E.localize)(4,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,E.localize)(5,null),scope:2}}})})()}};e.$yH=a,e.$yH=a=He([We(0,w.$Dm)],a)}),define(Pe[279],Re([1,0,34,13,20,25,177,278,54,4,30]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcb=e.$Ucb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Tcb=e.$Scb=void 0,e.$Scb=(0,w.$Zh)("editorResolverService"),e.$Tcb="workbench.editorAssociations";const S=R.$qn.as(g.$vn.Configuration),l={...m.$uH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(l);var $;(function(t){t.builtin="builtin",t.option="option",t.exclusive="exclusive",t.default="default"})($||(e.RegisteredEditorPriority=$={}));var b;(function(t){t[t.ABORT=1]="ABORT",t[t.NONE=2]="NONE"})(b||(e.ResolvedStatus=b={}));function a(t){switch(t){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$Ucb=a;function s(t,n){if(new Set([T.Schemas.extension,T.Schemas.webviewPanel,T.Schemas.vscodeWorkspaceTrust,T.Schemas.vscodeSettings]).has(n.scheme))return!1;const h=typeof t=="string"&&t.indexOf(P.$fc.sep)>=0?`${n.scheme}:${n.path}`:(0,M.$yg)(n);return E.$Fj(typeof t=="string"?t.toLowerCase():t,h.toLowerCase())}e.$Vcb=s}),define(Pe[280],Re([1,0,46,13,20,21,25,2,4,198,47,216,113]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$hK=e.$gK=void 0,e.$gK=(0,g.$Zh)("pathService");let b=$=class{constructor(s,t,n,o){this.d=s,this.e=t,this.f=n,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||M.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??s})()}hasValidBasename(s,t,n){return typeof t=="string"||typeof t>"u"?this.a.then(o=>this.h(s,o,t)):this.h(s,t,n)}h(s,t,n){return s.scheme===T.Schemas.file||s.scheme===T.Schemas.vscodeRemote?(0,E.$Zf)(n??(0,A.$yg)(s),t===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(s,t){if(s.remoteAuthority)return T.Schemas.vscodeRemote;const n=(0,w.$dK)(t.getWorkspace());if(n)return n;const o=t.getWorkspace().folders[0];if(o)return o.uri.scheme;const c=t.getWorkspace().configuration;return c?c.scheme:T.Schemas.file}userHome(s){return s?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(s=>s===1?P.$ec:P.$fc)}async fileURI(s){let t="";if(await this.a===1&&(s=s.replace(/\\/g,"/")),s[0]==="/"&&s[1]==="/"){const o=s.indexOf("/",2);o===-1?(t=s.substring(2),s="/"):(t=s.substring(2,o),s=s.substring(o)||"/")}return m.URI.from({scheme:T.Schemas.file,authority:t,path:s,query:"",fragment:""})}};e.$hK=b,e.$hK=b=$=He([We(1,l.$Dm),We(2,S.$2J),We(3,R.$9h)],b)}),define(Pe[114],Re([1,0]),function(pe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$VI=e.$UI=void 0;class E{constructor(A,m){this.line=A,this.character=m}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,m){return new E(0,0)}with(A){return new E(0,0)}}e.$UI=E;class T{constructor(A,m,g,w){this.isEmpty=!1,this.isSingleLine=!1,this.start=new E(A,m),this.end=new E(g,w)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new T(0,0,0,0)}with(A){return new T(0,0,0,0)}}e.$VI=T;var P;(function(M){M[M.Information=1]="Information",M[M.Warning=2]="Warning"})(P||(e.TextSearchCompleteMessageType=P={}))}),define(Pe[44],Re([1,0,18,34,26,46,12,4,20,11,114,14]),function(pe,e,E,T,P,M,A,m,g,w,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.SearchErrorCode=e.$$I=e.$0I=e.SearchSortOrder=e.ViewMode=e.$9I=e.$8I=e.$7I=e.$6I=e.SearchCompletionExitCode=e.$5I=e.$4I=e.$3I=e.QueryType=e.SearchProviderType=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.$WI="workbench.view.search",e.$XI="workbench.panel.search",e.$YI="workbench.view.search",e.$ZI="search-result",e.$1I="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",b=(l.length+$.length+5)*2;e.$2I=(0,m.$Zh)("searchService");var a;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text"})(a||(e.SearchProviderType=a={}));var s;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text"})(s||(e.QueryType=s={}));function t(ge){return!!ge.preview}e.$3I=t;function n(ge){return!!ge.resource}e.$4I=n;function o(ge){return!!ge.message}e.$5I=o;var c;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(me){this.resource=me,this.results=[]}}e.$6I=h;class i{constructor(me,ne,ke,ce){this.ranges=ne,this.webviewIndex=ce;const Y=Array.isArray(ne)?ne:[ne];if(ke&&ke.matchLines===1&&r(Y)){me=(0,A.$vf)(me,ke.matchLines);let W="",re=0,Ie=0;const Ae=Math.floor(ke.charsPerLine/5),Ce=[];for(const le of Y){const ie=Math.max(le.startColumn-Ae,0),G=le.startColumn+ke.charsPerLine;if(ie>Ie+Ae+b){const te=l+(ie-Ie)+$;W+=te+me.slice(ie,G),re+=ie-(Ie+te.length)}else W+=me.slice(Ie,G);Ce.push(new d(0,le.startColumn-re,le.endColumn-re)),Ie=G}this.preview={text:W,matches:Array.isArray(this.ranges)?Ce:Ce[0]}}else{const W=Array.isArray(ne)?ne[0].startLineNumber:ne.startLineNumber;this.preview={text:me,matches:(0,E.$1b)(ne,re=>new u(re.startLineNumber-W,re.startColumn,re.endLineNumber-W,re.endColumn))}}}}e.$7I=i;function r(ge){const me=ge[0].startLineNumber;for(const ne of ge)if(ne.startLineNumber!==me||ne.endLineNumber!==me)return!1;return!0}class u{constructor(me,ne,ke,ce){this.startLineNumber=me,this.startColumn=ne,this.endLineNumber=ke,this.endColumn=ce}}e.$8I=u;class d extends u{constructor(me,ne,ke){super(me,ne,me,ke)}}e.$9I=d;var v;(function(ge){ge.List="list",ge.Tree="tree"})(v||(e.ViewMode=v={}));var f;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})(f||(e.SearchSortOrder=f={}));function k(ge,me=!0){const ne=ge&&ge.files&&ge.files.exclude,ke=me&&ge&&ge.search&&ge.search.exclude;if(!ne&&!ke)return;if(!ne||!ke)return ne||ke;let ce=Object.create(null);return ce=P.$hn(ce,P.$en(ne)),ce=P.$hn(ce,P.$en(ke),!0),ce}e.$0I=k;function L(ge,me){return ge.excludePattern&&T.$Fj(ge.excludePattern,me)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&T.$Fj(ge.includePattern,me)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(ne=>{const ke=ne.folder.fsPath;if(M.$2f(me,ke)){const ce=g.$kc(ke,me);return!ne.includePattern||!!T.$Fj(ne.includePattern,ce)}else return!1}):!1:!0}e.$$I=L;var p;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(p||(e.SearchErrorCode=p={}));class y extends Error{constructor(me,ne){super(me),this.code=ne}}e.$_I=y;function D(ge){const me=ge.message;if((0,w.$3)(ge))return new y(me,p.canceled);try{const ne=JSON.parse(me);return new y(ne.message,ne.code)}catch{return new y(me,p.other)}}e.$aJ=D;function N(ge){const me={message:ge.message,code:ge.code};return new Error(JSON.stringify(me))}e.$bJ=N;function q(ge){return ge.type==="error"?!0:ge.type==="success"}e.$cJ=q;function V(ge){return ge.type==="success"}e.$dJ=V;function U(ge){return!!ge.path}e.$eJ=U;function F(ge,me){const ne=ge.searchPath?ge.searchPath:ge.relativePath;return(0,A.$sf)(ne,me)}e.$fJ=F;class C{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$gJ=C;function I(ge,me){const ne={...ge||{},...me||{}};return Object.keys(ne).filter(ke=>{const ce=ne[ke];return typeof ce=="boolean"&&ce})}e.$hJ=I;class X{constructor(me,ne){this.c=null,this.a={...me.excludePattern||{},...ne.excludePattern||{}},this.b=T.$Gj(this.a);let ke=me.includePattern;ne.includePattern&&(ke?ke={...ke,...ne.includePattern}:ke=ne.includePattern),ke&&(this.c=T.$Gj(ke))}matchesExcludesSync(me,ne,ke){return!!(this.b&&this.b(me,ne,ke))}includedInQuerySync(me,ne,ke){return!(this.b&&this.b(me,ne,ke)||this.c&&!this.c(me,ne,ke))}includedInQuery(me,ne,ke){const ce=this.b(me,ne,ke),Y=()=>this.c?!!this.c(me,ne,ke):!0;return(0,S.$Mg)(ce)?ce.then(W=>W?!1:Y()):Y()}hasSiblingExcludeClauses(){return ue(this.a)}}e.$iJ=X;function ue(ge){for(const me in ge)if(typeof ge[me]!="boolean")return!0;return!1}function he(ge){if(!ge)return;let me;return ne=>(me||(me=(ge()||Promise.resolve([])).then(ke=>ke?we(ke):{})),me.then(ke=>!!ke[ne]))}e.$jJ=he;function be(ge){if(!ge)return;let me;return ne=>{if(!me){const ke=ge();me=ke?we(ke):{}}return!!me[ne]}}e.$kJ=be;function we(ge){const me={};for(const ne of ge)me[ne]=!0;return me}}),define(Pe[36],Re([1,0,18,14,19,5,6,50,13,121,25,12,2,168,4,15,187,47,43,27,17,8,7,57,44,3,51]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uec=e.$Tec=void 0;function f(V,U,F){return new R.$qg(C=>y(C,F)).isEqual(V,U)}function k(V,U,F){return f(V.uri,U.uri,F)?0:(0,S.$Ye)(V.uri.toString(),U.uri.toString())}function L(V,U,F){return V.index!==U.index?V.index<U.index?-1:1:f(V.uri,U.uri,F)?(0,S.$Ye)(V.name,U.name):(0,S.$Ye)(V.uri.toString(),U.uri.toString())}function p(V,U,F,C){const I=V.slice(0).sort((ue,he)=>F(ue,he,C)),X=U.slice(0).sort((ue,he)=>F(ue,he,C));return(0,E.$Db)(I,X,(ue,he)=>F(ue,he,C))}function y(V,U){const F=U.getCapabilities(V.scheme);return!(F&&F&1024)}class D extends t.$gi{static toExtHostWorkspace(U,F,C,I){if(!U)return{workspace:null,added:[],removed:[]};const{id:X,name:ue,folders:he,configuration:be,transient:we,isUntitled:ge}=U,me=[],ne=F;F?he.forEach((W,re)=>{const Ie=l.URI.revive(W.uri),Ae=D.o(C||F,Ie,I);Ae?(Ae.name=W.name,Ae.index=W.index,me.push(Ae)):me.push({uri:Ie,name:W.name,index:re})}):me.push(...he.map(({uri:W,name:re,index:Ie})=>({uri:l.URI.revive(W),name:re,index:Ie}))),me.sort((W,re)=>W.index<re.index?-1:1);const ke=new D(X,ue,me,!!we,be?l.URI.revive(be):null,!!ge,W=>y(W,I)),{added:ce,removed:Y}=p(ne?ne.workspaceFolders:[],ke.workspaceFolders,k,I);return{workspace:ke,added:ce,removed:Y}}static o(U,F,C){for(let I=0;I<U.folders.length;I++){const X=U.workspaceFolders[I];if(f(X.uri,F,C))return X}}constructor(U,F,C,I,X,ue,he){super(U,C.map(be=>new t.$hi(be)),I,X,he),this.t=F,this.u=ue,this.q=[],this.s=m.$6h.forUris(he),C.forEach(be=>{this.q.push(be),this.s.set(be.uri,be)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(U,F){return F&&this.s.get(U)&&(U=(0,R.$Ag)(U)),this.s.findSubstr(U)}resolveWorkspaceFolder(U){return this.s.get(U)}}let N=class{constructor(U,F,C,I,X){this.c=new M.$Rd,this.onDidChangeWorkspace=this.c.event,this.g=new M.$Rd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new M.$Td,this.B=new Map,this.h=I,this.s=C,this.t=X,this.j=new w.$1l,this.k=new T.$Yg,this.o=U.getProxy(d.$EK.MainThreadWorkspace),this.q=U.getProxy(d.$EK.MainThreadMessageService);const ue=F.workspace;this.l=ue?new D(ue.id,ue.name,[],!!ue.transient,ue.configuration?l.URI.revive(ue.configuration):null,!!ue.isUntitled,he=>y(he,C)):void 0}$initializeWorkspace(U,F){this.v=F,this.$acceptWorkspaceData(U),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,R.$yg)((0,R.$Ag)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(U,F,C,...I){const X=[];if(Array.isArray(I)&&I.forEach(ge=>{l.URI.isUri(ge.uri)&&!X.some(me=>f(me.uri,ge.uri,this.s))&&X.push({uri:ge.uri,name:ge.name||(0,R.$xg)(ge.uri)})}),this.n||[F,C].some(ge=>typeof ge!="number"||ge<0)||C===0&&X.length===0)return!1;const ue=this.x?this.x.workspaceFolders:[];if(F+C>ue.length)return!1;const he=ue.slice(0);he.splice(F,C,...X.map(ge=>({uri:ge.uri,name:ge.name||(0,R.$xg)(ge.uri),index:void 0})));for(let ge=0;ge<he.length;ge++){const me=he[ge];if(he.some((ne,ke)=>ke!==ge&&f(me.uri,ne.uri,this.s)))return!1}he.forEach((ge,me)=>ge.index=me);const{added:be,removed:we}=p(ue,he,L,this.s);if(be.length===0&&we.length===0)return!1;if(this.o){const ge=U.displayName||U.name;this.o.$updateWorkspaceFolders(ge,F,C,X).then(void 0,me=>{this.n=void 0;const ne={source:{identifier:U.identifier,label:U.displayName||U.name}};this.q.$showMessage(s.Severity.Error,(0,$.localize)(0,null,ge,me.toString()),ne,[])})}return this.y(he),!0}getWorkspaceFolder(U,F){if(this.x)return this.x.getWorkspaceFolder(U,F)}async getWorkspaceFolder2(U,F){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(U,F)}async resolveWorkspaceFolder(U){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(U)}getPath(){if(!this.x)return;const{folders:U}=this.x;if(U.length!==0)return U[0].uri.fsPath}getRelativePath(U,F){let C,I="";if(typeof U=="string"?(C=l.URI.file(U),I=U):typeof U<"u"&&(C=U,I=U.fsPath),!C)return I;const X=this.getWorkspaceFolder(C,!0);if(!X)return I;typeof F>"u"&&this.x&&(F=this.x.folders.length>1);let ue=(0,R.$Dg)(X.uri,C);return F&&X.name&&(ue=`${X.name}/${ue}`),ue}y(U){this.x&&(this.n=D.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:U,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(U){const{workspace:F,added:C,removed:I}=D.toExtHostWorkspace(U,this.l,this.n,this.s);this.l=F||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:I}))}findFiles(U,F,C,I,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${I.value}, entryPoint: findFiles`);let ue;if(F===null?ue=!1:F&&(typeof F=="string"?ue=F:ue=F.pattern),X&&X.isCancellationRequested)return Promise.resolve([]);const{includePattern:he,folder:be}=q(h.GlobPattern.from(U));return this.o.$startFileSearch(he??null,be??null,ue??null,C??null,X).then(we=>Array.isArray(we)?we.map(ge=>l.URI.revive(ge)):[])}async findTextInFiles(U,F,C,I,X=P.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${I.value}, entryPoint: findTextInFiles`);const ue=this.j.getNext(),he=typeof F.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:F.previewOptions,{includePattern:be,folder:we}=q(h.GlobPattern.from(F.include)),ge=typeof F.exclude=="string"?F.exclude:F.exclude?F.exclude.pattern:void 0,me={ignoreSymlinks:typeof F.followSymlinks=="boolean"?!F.followSymlinks:void 0,disregardIgnoreFiles:typeof F.useIgnoreFiles=="boolean"?!F.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof F.useGlobalIgnoreFiles=="boolean"?!F.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof F.useParentIgnoreFiles=="boolean"?!F.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof F.useDefaultExcludes=="boolean"?!F.useDefaultExcludes:!0,fileEncoding:F.encoding,maxResults:F.maxResults,previewOptions:he,afterContext:F.afterContext,beforeContext:F.beforeContext,includePattern:be,excludePattern:ge},ne=!1;if(this.u[ue]=ke=>{if(ne)return;const ce=l.URI.revive(ke.resource);ke.results.forEach(Y=>{const W=(0,v.$wh)(Y);(0,u.$3I)(W)?C({uri:ce,preview:{text:W.preview.text,matches:(0,E.$1b)(W.preview.matches,re=>new i.$IK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))},ranges:(0,E.$1b)(W.ranges,re=>new i.$IK(re.startLineNumber,re.startColumn,re.endLineNumber,re.endColumn))}):C({uri:ce,text:W.text,lineNumber:W.lineNumber})})},X.isCancellationRequested)return{};try{const ke=await this.o.$startTextSearch(U,we??null,me,ue,X);return delete this.u[ue],ke||{}}catch(ke){throw delete this.u[ue],ke}}$handleTextSearchResult(U,F){this.u[F]?.(U)}async save(U){const F=await this.o.$save(U,{saveAs:!1});return l.URI.revive(F)}async saveAs(U){const F=await this.o.$save(U,{saveAs:!0});return l.URI.revive(F)}saveAll(U){return this.o.$saveAll(U)}resolveProxy(U){return this.o.$resolveProxy(U)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(U){return this.o.$requestWorkspaceTrust(U)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(U,F){if(this.w.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.w.set(U,F);const C=this.t.transformOutgoingScheme(U),I=this.z++;return this.o.$registerEditSessionIdentityProvider(I,C),(0,A.$Pc)(()=>{this.w.delete(U),this.o.$unregisterEditSessionIdentityProvider(I)})}async $getEditSessionIdentifier(U,F){this.h.info("Getting edit session identifier for workspaceFolder",U);const C=await this.resolveWorkspaceFolder(l.URI.revive(U));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const I=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!I),!I)return;const X=await I.provideEditSessionIdentity(C,F);if(this.h.info("Provider returned edit session identifier: ",X),!!X)return X}async $provideEditSessionIdentityMatch(U,F,C,I){this.h.info("Getting edit session identifier for workspaceFolder",U);const X=await this.resolveWorkspaceFolder(l.URI.revive(U));if(!X){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",X);const ue=this.w.get(X.uri.scheme);if(this.h.info(`Provider for scheme ${X.uri.scheme} is defined: `,!!ue),!ue)return;const he=await ue.provideEditSessionIdentityMatch?.(F,C,I);if(this.h.info("Provider returned edit session identifier match result: ",he),!!he)return he}getOnWillCreateEditSessionIdentityEvent(U){return(F,C,I)=>{const X=function(he){F.call(C,he)};return X.extension=U,this.A.event(X,void 0,I)}}async $onWillCreateEditSessionIdentity(U,F,C){const I=await this.resolveWorkspaceFolder(l.URI.revive(U));if(I===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:I},F,async(X,ue)=>{const he=Date.now();await Promise.resolve(X),Date.now()-he>C&&this.h.warn("SLOW edit session create-participant",ue.extension.identifier)}),F.isCancellationRequested}registerCanonicalUriProvider(U,F){if(this.B.has(U))throw new Error(`A provider has already been registered for scheme ${U}`);this.B.set(U,F);const C=this.t.transformOutgoingScheme(U),I=this.z++;return this.o.$registerCanonicalUriProvider(I,C),(0,A.$Pc)(()=>{this.B.delete(U),this.o.$unregisterCanonicalUriProvider(I)})}async provideCanonicalUri(U,F,C){const I=this.B.get(U.scheme);if(!I)return;const X=await I.provideCanonicalUri?.(l.URI.revive(U),F,C);if(X)return X}async $provideCanonicalUri(U,F,C){return this.provideCanonicalUri(l.URI.revive(U),{targetScheme:F},C)}};e.$Tec=N,e.$Tec=N=He([We(0,c.$HM),We(1,o.$XM),We(2,n.$zec),We(3,a.$hj),We(4,r.$Rec)],N),e.$Uec=(0,b.$Zh)("IExtHostWorkspace");function q(V){let U,F;return V&&(typeof V=="string"?U=V:(U=V.pattern,F=l.URI.revive(V.baseUri))),{includePattern:U,folder:F}}}),define(Pe[37],Re([1,0,26,5,36,3,7,189,54,16,14,4,17,15,2]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xec=e.$Wec=e.$Vec=void 0;function a(r,u){if(u){const d=u.split(".");let v=r;for(let f=0;v&&f<d.length;f++)v=v[d[f]];return v}}function s(r){return r instanceof b.URI}function t(r){return r&&r.uri instanceof b.URI&&r.languageId&&typeof r.languageId=="string"}function n(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function o(r){return r&&r.uri instanceof b.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function c(r){if(s(r))return{resource:r};if(t(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(n(r))return{overrideIdentifier:r.languageId};if(o(r))return{resource:r.uri};if(r===null)return{resource:null}}let h=class{constructor(u,d,v){this.a=u.getProxy(M.$EK.MainThreadConfiguration),this.c=d,this.b=v,this.d=new R.$Yg,this.e=null}getConfigProvider(){return this.d.wait().then(u=>this.e)}$initializeConfiguration(u){this.e=new i(this.a,this.c,u,this.b),this.d.open()}$acceptConfigurationChanged(u,d){this.getConfigProvider().then(v=>v.$acceptConfigurationChanged(u,d))}};e.$Vec=h,e.$Vec=h=He([We(0,l.$HM),We(1,P.$Uec),We(2,$.$hj)],h);class i{constructor(u,d,v,f){this.a=new T.$Rd,this.b=u,this.f=f,this.c=d,this.e=m.$On.parse(v),this.d=this.k(v.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(u,d){const v={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$On.parse(u),this.d=this.k(u.configurationScopes),this.a.fire(this.j(d,v))}getConfiguration(u,d,v){const f=c(d)||{},k=this.g(u?a(this.e.getValue(void 0,f,this.c.workspace),u):this.e.getValue(void 0,f,this.c.workspace));u&&this.h(u,f,v?.identifier);function L(y){if(y==null)return null;if(typeof y=="boolean")return y?2:5;switch(y){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const p={has(y){return typeof a(k,y)<"u"},get:(y,D)=>{this.h(u?`${u}.${y}`:y,f,v?.identifier);let N=a(k,y);if(typeof N>"u")N=D;else{let q;const V=(U,F)=>{if((0,w.$Ef)(U)){let C;const I=()=>{q=q||(0,E.$en)(k),C=C||a(q,F)};return new Proxy(U,{get:(X,ue)=>{if(typeof ue=="string"&&ue.toLowerCase()==="tojson")return I(),()=>C;if(q)return C=C||a(q,F),C[ue];const he=X[ue];return typeof ue=="string"?V(he,`${F}.${ue}`):he},set:(X,ue,he)=>(I(),C&&(C[ue]=he),!0),deleteProperty:(X,ue)=>(I(),C&&delete C[ue],!0),defineProperty:(X,ue,he)=>(I(),C&&Object.defineProperty(C,ue,he),!0)})}return Array.isArray(U)?(0,E.$en)(U):U};N=V(N,y)}return N},update:(y,D,N,q)=>{y=u?`${u}.${y}`:y;const V=L(N);return D!==void 0?this.b.$updateConfigurationOption(V,y,D,f,q):this.b.$removeConfigurationOption(V,y,f,q)},inspect:y=>{y=u?`${u}.${y}`:y;const D=this.e.inspect(y,f,this.c.workspace);if(D)return{key:y,defaultValue:(0,E.$en)(D.policy?.value??D.default?.value),globalValue:(0,E.$en)(D.user?.value??D.application?.value),workspaceValue:(0,E.$en)(D.workspace?.value),workspaceFolderValue:(0,E.$en)(D.workspaceFolder?.value),defaultLanguageValue:(0,E.$en)(D.default?.override),globalLanguageValue:(0,E.$en)(D.user?.override??D.application?.override),workspaceLanguageValue:(0,E.$en)(D.workspace?.override),workspaceFolderLanguageValue:(0,E.$en)(D.workspaceFolder?.override),languageIds:(0,E.$en)(D.overrideIdentifiers)}}};return typeof k=="object"&&(0,E.$hn)(p,k,!1),Object.freeze(p)}g(u){const d=v=>(0,w.$Ef)(v)?new Proxy(v,{get:(f,k)=>d(f[k]),set:(f,k,L)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(k)}' of object`)},deleteProperty:(f,k)=>{throw new Error(`TypeError: Cannot delete read only property '${String(k)}' of object`)},defineProperty:(f,k)=>{throw new Error(`TypeError: Cannot define property '${String(k)}' for a readonly object`)},setPrototypeOf:f=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):v;return d(u)}h(u,d,v){const f=g.$Fn.test(u)?4:this.d.get(u),k=v?`[${v.value}] `:"";if(f===4){typeof d?.resource>"u"&&this.f.warn(`${k}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(f===3){d?.resource&&this.f.warn(`${k}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(u,d){const v=new m.$Qn(u,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(f,k)=>v.affectsConfiguration(f,c(k))})}k(u){return u.reduce((d,v)=>(d.set(v[0],v[1]),d),new Map)}}e.$Wec=i,e.$Xec=(0,S.$Zh)("IExtHostConfiguration")}),define(Pe[115],Re([1,0,2,14,5,3,7,36,61,37,19,64,17,27,4,13,21,15,81,228,11]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=e.$ngc=e.$mgc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(V){function U(C){if(C!=null)return C}V.from=U;function F(C){if(C!=null)return C}V.to=F})(h||(h={}));var i;(function(V){function U(C){if(C!=null)return C}V.from=U;function F(C){if(C!=null)return C}V.to=F})(i||(i={}));var r;(function(V){function U(C){if(C!=null)return C}V.from=U;function F(C){if(C!=null)return C}V.to=F})(r||(r={}));var u;(function(V){function U(I){if(I){const X=I;return X&&!!X.process}else return!1}V.is=U;function F(I){if(I==null)return;const X={process:I.process,args:I.args};return I.options&&(X.options=r.from(I.options)),X}V.from=F;function C(I){if(I!=null)return new A.$pL(I.process,I.args,I.options)}V.to=C})(u||(u={}));var d;(function(V){function U(C){if(C!=null)return C}V.from=U;function F(C){if(C!=null)return C}V.to=F})(d||(d={}));var v;(function(V){function U(I){if(I){const X=I;return X&&(!!X.commandLine||!!X.command)}else return!1}V.is=U;function F(I){if(I==null)return;const X={};return I.commandLine!==void 0?X.commandLine=I.commandLine:(X.command=I.command,X.args=I.args),I.options&&(X.options=d.from(I.options)),X}V.from=F;function C(I){if(!(I==null||I.command===void 0&&I.commandLine===void 0))return I.commandLine?new A.$qL(I.commandLine,I.options):new A.$qL(I.command,I.args?I.args:[],I.options)}V.to=C})(v||(v={}));var f;(function(V){function U(I){if(I){const X=I;return X&&X.customExecution==="customExecution"}else return!1}V.is=U;function F(I){return{customExecution:"customExecution"}}V.from=F;function C(I,X){return X.get(I)}V.to=C})(f||(e.CustomExecutionDTO=f={}));var k;(function(V){function U(F,C){let I;return F.scope!==void 0&&typeof F.scope!="number"?I=F.scope.uri:F.scope!==void 0&&typeof F.scope=="number"&&(F.scope===A.TaskScope.Workspace&&C&&C.workspaceFile?I=C.workspaceFile:I=o.$aG),{id:F._id,workspaceFolder:I}}V.from=U})(k||(e.TaskHandleDTO=k={}));var L;(function(V){function U(F){if(F!=null)return{_id:F.id,isDefault:F.isDefault}}V.from=U})(L||(L={}));var p;(function(V){function U(I,X){if(I==null)return[];const ue=[];for(const he of I){const be=F(he,X);be&&ue.push(be)}return ue}V.fromMany=U;function F(I,X){if(I==null)return;let ue;I.execution instanceof A.$pL?ue=u.from(I.execution):I.execution instanceof A.$qL?ue=v.from(I.execution):I.execution&&I.execution instanceof A.$rL&&(ue=f.from(I.execution));const he=h.from(I.definition);let be;return I.scope?typeof I.scope=="number"?be=I.scope:be=I.scope.uri:be=A.TaskScope.Workspace,!he||!be?void 0:{_id:I._id,definition:he,name:I.name,source:{extensionId:X.identifier.value,label:I.source,scope:be},execution:ue,isBackground:I.isBackground,group:L.from(I.group),presentationOptions:i.from(I.presentationOptions),problemMatchers:I.problemMatchers,hasDefinedMatchers:I.hasDefinedMatchers,runOptions:I.runOptions?I.runOptions:{reevaluateOnRerun:!0},detail:I.detail}}V.from=F;async function C(I,X,ue){if(I==null)return;let he;u.is(I.execution)?he=u.to(I.execution):v.is(I.execution)?he=v.to(I.execution):f.is(I.execution)&&(he=f.to(I._id,ue));const be=h.to(I.definition);let we;if(I.source&&(I.source.scope!==void 0?typeof I.source.scope=="number"?we=I.source.scope:we=await X.resolveWorkspaceFolder(E.URI.revive(I.source.scope)):we=A.TaskScope.Workspace),!be||!we)return;const ge=new A.$sL(be,we,I.name,I.source.label,he,I.problemMatchers);return I.isBackground!==void 0&&(ge.isBackground=I.isBackground),I.group!==void 0&&(ge.group=A.$oL.from(I.group._id),ge.group&&I.group.isDefault&&(ge.group=new A.$oL(ge.group.id,ge.group.label),I.group.isDefault===!0&&(ge.group.isDefault=I.group.isDefault))),I.presentationOptions&&(ge.presentationOptions=i.to(I.presentationOptions)),I._id&&(ge._id=I._id),I.detail&&(ge.detail=I.detail),ge}V.to=C})(p||(e.TaskDTO=p={}));var y;(function(V){function U(C){return C}V.from=U;function F(C){if(C)return Object.assign(Object.create(null),C)}V.to=F})(y||(y={}));class D{#e;constructor(U,F,C){this._id=F,this.a=C,this.#e=U}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}let N=class{constructor(U,F,C,I,X,ue,he,be){this.q=new P.$Rd,this.r=new P.$Rd,this.s=new P.$Rd,this.t=new P.$Rd,this.a=U.getProxy(M.$EK.MainThreadTask),this.b=C,this.c=I,this.d=X,this.e=ue,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=he,this.g=be,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,F,C){if(!C)return new A.$GK(()=>{});const I=this.w();return this.j.set(I,{type:F,provider:C,extension:U}),this.a.$registerTaskProvider(I,F),new A.$GK(()=>{this.j.delete(I),this.a.$unregisterTaskProvider(I)})}registerTaskSystem(U,F){this.a.$registerTaskSystem(U,F)}fetchTasks(U){return this.a.$fetchTasks(y.from(U)).then(async F=>{const C=[];for(const I of F){const X=await p.to(I,this.b,this.m);X&&C.push(X)}return C})}get taskExecutions(){const U=[];return this.k.forEach(F=>U.push(F)),U}terminateTask(U){if(!(U instanceof D))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,F,C){const I=this.m.get(U.id);I&&(this.o.set(U.id,I),this.e.attachPtyToTerminal(F,await I.callback(C))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const F=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:F})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const F=await this.y(U.id);this.s.fire({execution:F,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const F=await this.y(U.id);this.t.fire({execution:F,exitCode:U.exitCode})}$provideTasks(U,F){const C=this.j.get(U);if(!C)return Promise.reject(new Error("no handler found"));const I=[],X=(0,T.$Sg)(()=>C.provider.provideTasks(R.CancellationToken.None)).then(ue=>this.u(F,I,C,ue));return new Promise(ue=>{X.then(he=>{Promise.all(I).then(()=>{ue(he)})})})}async $resolveTask(U,F){const C=this.j.get(U);if(!C)return Promise.reject(new Error("no handler found"));if(F.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${F.definition.type}] cannot be resolved by provider of type [${C.type}].`);const I=await p.to(F,this.b,this.m);if(!I)throw new Error("Unexpected: Task cannot be resolved.");const X=await C.provider.resolveTask(I,R.CancellationToken.None);if(!X)return;this.z(X,C);const ue=p.from(X,C.extension);if(!ue)throw new Error("Unexpected: Task cannot be resolved.");if(X.definition!==I.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return f.is(ue.execution)&&await this.x(ue,X,!0),await this.v(ue)}w(){return this.h++}async x(U,F,C){const I=await this.a.$createTaskId(U);!C&&!this.m.has(I)&&(this.n.add(I),this.o.set(I,F.execution)),this.m.set(I,F.execution)}async y(U,F){if(typeof U=="string"){const X=this.l.get(U);if(!X)throw new c.$ab("Unexpected: The specified task is missing an execution");return X}const C=this.l.get(U.id);if(C)return C;const I=new Promise((X,ue)=>{function he(be,we,ge){ge?X(new D(be,we.id,ge)):ue("Unexpected: Task does not exist.")}F?he(this,U,F):p.to(U.task,this.b,this.m).then(be=>he(this,U,be))});return this.l.set(U.id,I),I.then(X=>(this.k.set(U.id,X),X),X=>Promise.reject(X))}z(U,F){U._deprecated&&this.g.report("Task.constructor",F.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const C=this.n.values();let I=C.next();for(;!I.done;)!this.o.has(I.value)&&this.p!==I.value&&(this.m.delete(I.value),this.n.delete(I.value)),I=C.next()}};e.$mgc=N,e.$mgc=N=He([We(0,l.$HM),We(1,$.$XM),We(2,m.$Uec),We(3,g.$SM),We(4,w.$Xec),We(5,S.$jfc),We(6,t.$hj),We(7,n.$Cec)],N);let q=class extends N{constructor(U,F,C,I,X,ue,he,be){super(U,F,C,I,X,ue,he,be),this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:s.$h(0)})}async executeTask(U,F){if(!F.execution)throw new Error("Tasks to execute must include an execution");const C=p.from(F,U);if(C===void 0)throw new Error("Task is not valid");if(f.is(C.execution))await this.x(C,F,!1);else throw new c.$$;const I=await this.y(await this.a.$getTaskExecution(C),F);return this.a.$executeTask(C).catch(X=>{throw new Error(X)}),I}u(U,F,C,I){const X=[];if(I)for(const ue of I){if(this.z(ue,C),!ue.definition||!U[ue.definition.type]){const be=ue.source?ue.source:"No task source";this.f.warn(`The task [${be}, ${ue.name}] uses an undefined task type. The task will be ignored in the future.`)}const he=p.from(ue,C.extension);he&&f.is(he.execution)?(X.push(he),F.push(this.x(he,ue,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:X,extension:C.extension}}async v(U){if(f.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,F){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,F,C){}};e.$ngc=q,e.$ngc=q=He([We(0,l.$HM),We(1,$.$XM),We(2,m.$Uec),We(3,g.$SM),We(4,w.$Xec),We(5,S.$jfc),We(6,t.$hj),We(7,n.$Cec)],q),e.$ogc=(0,b.$Zh)("IExtHostTask")}),define(Pe[281],Re([1,0,44,29]),function(pe,e,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.$rJ=e.$qJ=void 0;function P(A){return"cellResults"in A}e.$qJ=P,e.$rJ="rawCell#";function M(A,m){let g=-1;const w=[];let R=[];return A.forEach(l=>{l.range.startLineNumber!==g&&R.length>0&&(w.push([...R]),R=[]),R.push(l),g=l.range.endLineNumber}),R.length>0&&w.push([...R]),w.map(l=>{const $=[],b=l[0].range.startLineNumber,a=l[l.length-1].range.endLineNumber;for(let s=b;s<=a;s++)$.push(m.getLineContent(s));return new E.$7I($.join(`
`)+`
`,l.map(s=>new T.$Ds(s.range.startLineNumber-1,s.range.startColumn-1,s.range.endLineNumber-1,s.range.endColumn-1)))})}e.$sJ=M}),define(Pe[282],Re([1,0,161,24,5,6,28,12,16,2,42,75,3,32,8,7,49,220,107,11,26,13,211,281,279]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1fc=void 0;class d{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(f=>f.apiEditor)}constructor(f,k,L,p,y,D){this.q=L,this.r=p,this.s=y,this.t=D,this.f=new Map,this.g=new A.$zc,this.h=new Map,this.j=new P.$Rd({onListenerError:o.$1}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.$Rd({onListenerError:o.$1}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.$Rd({onListenerError:o.$1}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.$Rd({onListenerError:o.$1}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$vec("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=f.getProxy(l.$EK.MainThreadNotebook),this.c=f.getProxy(l.$EK.MainThreadNotebookDocuments),this.d=f.getProxy(l.$EK.MainThreadNotebookEditors),this.i=k.converter,k.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===13){const q=N.notebookEditor?.notebookUri,V=N.cell.handle,F=this.g.get(q)?.getCell(V);if(F)return F.apiCell}if(N&&N.$mid===14){const q=N.uri,V=this.g.get(q);if(V)return V.apiNotebook}return N}}),d.B(k)}getEditorById(f){const k=this.h.get(f);if(!k)throw new Error(`unknown text editor: ${f}. known editors: ${[...this.h.keys()]} `);return k}getIdByEditor(f){for(const[k,L]of this.h)if(L.apiEditor===f)return k}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(f,k){const L=this.g.get(f);if(!L&&!k)throw new Error(`NO notebook document for '${f}'`);return L}static u(f,k){if(!k)return;const L=k.filenamePattern.map(p=>b.NotebookExclusiveDocumentPattern.from(p)).filter(p=>p!==void 0);if(k.filenamePattern&&!L){console.warn(`Notebook content provider view options file name pattern is invalid ${k.filenamePattern}`);return}return{extension:f.identifier,providerDisplayName:f.displayName||f.name,displayName:k.displayName,filenamePattern:L,exclusive:k.exclusive||!1}}registerNotebookCellStatusBarItemProvider(f,k,L){const p=d.a++,y=typeof L.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(p,L),this.b.$registerNotebookCellStatusBarItemProvider(p,y,k);let D;return y!==void 0&&(D=L.onDidChangeCellStatusBarItems(N=>this.b.$emitCellStatusBarEvent(y))),new a.$GK(()=>{this.f.delete(p),this.b.$unregisterNotebookCellStatusBarItemProvider(p,y),D?.dispose()})}async createNotebookDocument(f){const k=await this.c.$tryCreateNotebook({viewType:f.viewType,content:f.content&&b.NotebookData.from(f.content)});return w.URI.revive(k)}async openNotebookDocument(f){const k=this.g.get(f);if(k)return k.apiNotebook;const L=await this.c.$tryOpenNotebook(f),p=this.g.get(w.URI.revive(L));return(0,g.$Nf)(p?.apiNotebook)}async showNotebookDocument(f,k){w.URI.isUri(f)&&(f=await this.openNotebookDocument(f));let L;typeof k=="object"?L={position:b.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selections:k.selections&&k.selections.map(b.NotebookRange.from),pinned:typeof k.preview=="boolean"?!k.preview:void 0}:L={preserveFocus:!1};const p=await this.d.$tryShowNotebookDocument(f.uri,f.notebookType,L),y=p&&this.h.get(p)?.apiEditor;if(y)return y;throw p?new Error(`Could NOT open editor for "${f.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${f.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(f,k,L,p){const y=this.f.get(f),D=w.URI.revive(k),N=this.g.get(D);if(!N||!y)return;const q=N.getCellFromIndex(L);if(!q)return;const V=await y.provideCellStatusBarItems(q.apiCell,p);if(!V)return;const U=new M.$Qc,F=this.p.add([U]),I=(Array.isArray(V)?V:[V]).map(X=>b.NotebookStatusBarItem.from(X,this.i,U));return{cacheId:F,items:I}}$releaseNotebookCellStatusBarItems(f){this.p.delete(f)}registerNotebookSerializer(f,k,L,p,y){if((0,m.$Fe)(k))throw new Error("viewType cannot be empty or just whitespace");const D=this.w++;return this.x.set(D,{viewType:k,serializer:L,options:p}),this.b.$registerNotebookSerializer(D,{id:f.identifier,location:f.extensionLocation},k,b.NotebookDocumentContentOptions.from(p),d.u(f,y)),(0,M.$Pc)(()=>{this.b.$unregisterNotebookSerializer(D)})}async $dataToNotebook(f,k,L){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.deserializeNotebook(k.buffer,L);return new s.$Bv(b.NotebookData.from(y))}async $notebookToData(f,k,L){const p=this.x.get(f);if(!p)throw new Error("NO serializer found");const y=await p.serializer.serializeNotebook(b.NotebookData.to(k.value),L);return T.$fe.wrap(y)}async $saveNotebook(f,k,L,p,y){const D=w.URI.revive(k),N=this.x.get(f);if(!N)throw new Error("NO serializer found");const q=this.g.get(D);if(!q)throw new Error("Document NOT found");if(q.versionId!==L)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(D.scheme))throw new R.$Dk((0,E.localize)(0,null,this.z(D)),6);await this.y(D,p);const V={metadata:(0,c.$mn)(q.apiNotebook.metadata,X=>!(N.options?.transientDocumentMetadata??{})[X]),cells:[]};for(const X of q.apiNotebook.getCells()){const ue=new a.$6L(X.kind,X.document.getText(),X.document.languageId,X.mime,N.options?.transientOutputs?[]:[...X.outputs],X.metadata,X.executionSummary);ue.metadata=(0,c.$mn)(X.metadata,he=>!(N.options?.transientCellMetadata??{})[he]),V.cells.push(ue)}const U=await N.serializer.serializeNotebook(V,y);await this.s.value.writeFile(D,U);const F=this.s.getFileSystemProviderExtUri(D.scheme),C=await this.s.value.stat(D);return{name:F.basename(D),isFile:(C.type&R.FileType.File)!==0,isDirectory:(C.type&R.FileType.Directory)!==0,isSymbolicLink:(C.type&R.FileType.SymbolicLink)!==0,mtime:C.mtime,ctime:C.ctime,size:C.size,readonly:!!((C.permissions??0)&R.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(D.scheme),locked:!!((C.permissions??0)&R.FilePermission.Locked),etag:R.$Ok({mtime:C.mtime,size:C.size}),children:void 0}}async $searchInNotebooks(f,k,L,p,y){const D=this.x.get(f)?.serializer;if(!D)return{limitHit:!1,results:[]};const N=new A.$Ac;await(async(C,I,X)=>{await Promise.all(C.map(async ue=>await Promise.all(ue.filenamePatterns.map(he=>{const be={...X,type:1,filePattern:he};return this.t.doInternalFileSearchWithCustomCallback(be,I,we=>{we.forEach(ge=>{N.has(ge)||p.some(ne=>ue.isFromSettings&&!ne.isFromSettings?!1:ne.filenamePatterns.some(ke=>(0,u.$Vcb)(ke,ge)))||N.add(ge)})})}))))})(L,y,k);const V=new A.$zc;let U=!1;const F=Array.from(N).map(async C=>{const I=[];try{if(y.isCancellationRequested)return;if(k.maxResults&&[...V.values()].reduce((be,we)=>be+we.cellResults.length,0)>k.maxResults){U=!0;return}const X=[],ue=this.g.get(C);if(ue)ue.apiNotebook.getCells().forEach(we=>X.push({input:we.document.getText(),outputs:we.outputs.flatMap(ge=>ge.items.map(me=>me.data.toString()))}));else{const be=await this.s.value.readFile(C),we=T.$fe.fromString(be.toString()),ge=await D.deserializeNotebook(we.buffer,y);if(y.isCancellationRequested)return;b.NotebookData.from(ge).cells.forEach(ne=>X.push({input:ne.source,outputs:ne.outputs.flatMap(ke=>ke.items.map(ce=>ce.valueBytes.toString()))}))}if(y.isCancellationRequested)return;X.forEach((be,we)=>{const ge=k.contentPattern.pattern,me=new i.$zPb(be.input,void 0,be.outputs),ne=me.findInInputs(ge),ke=me.findInOutputs(ge),ce=ke.flatMap(Y=>(0,r.$sJ)(Y.matches,Y.textBuffer)).map((Y,W)=>(Y.webviewIndex=W,Y));if(ne.length>0||ke.length>0){const Y={index:we,contentResults:(0,r.$sJ)(ne,me.inputTextBuffer),webviewResults:ce};I.push(Y)}});const he={resource:C,cellResults:I};V.set(C,he);return}catch{return}});return await Promise.all(F),{limitHit:U,results:[...V.values()]}}async y(f,k){const L=await this.s.value.stat(f);if(typeof k?.mtime=="number"&&typeof k.etag=="string"&&k.etag!==R.$Nk&&typeof L.mtime=="number"&&typeof L.size=="number"&&k.mtime<L.mtime&&k.etag!==R.$Ok({mtime:k.mtime,size:L.size}))throw new R.$Dk((0,E.localize)(1,null),3,k)}z(f){return f.scheme===h.Schemas.file?f.fsPath:f.toString()}A(f,k,L){if(this.h.has(k))throw new Error(`editor with id ALREADY EXSIST: ${k}`);const p=new n.$Rfc(k,this.d,f,L.visibleRanges.map(b.NotebookRange.to),L.selections.map(b.NotebookRange.to),typeof L.viewColumn=="number"?b.ViewColumn.to(L.viewColumn):void 0);this.h.set(k,p)}$acceptDocumentAndEditorsDelta(f){if(f.value.removedDocuments)for(const L of f.value.removedDocuments){const p=w.URI.revive(L),y=this.g.get(p);y&&(y.dispose(),this.g.delete(p),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:y.apiNotebook.getCells().map(D=>D.document.uri)}),this.n.fire(y.apiNotebook));for(const D of this.h.values())D.notebookData.uri.toString()===p.toString()&&this.h.delete(D.id)}if(f.value.addedDocuments){const L=[];for(const p of f.value.addedDocuments){const y=w.URI.revive(p.uri);if(this.g.has(y))throw new Error(`adding EXISTING notebook ${y} `);const D=new t.$Qfc(this.c,this.q,this.r,y,p);L.push(...p.cells.map(N=>t.$Pfc.asModelAddData(D.apiNotebook,N))),this.g.get(y)?.dispose(),this.g.set(y,D),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:L}),this.m.fire(D.apiNotebook)}}if(f.value.addedEditors)for(const L of f.value.addedEditors){if(this.h.has(L.id))return;const p=w.URI.revive(L.documentUri),y=this.g.get(p);y&&this.A(y,L.id,L)}const k=[];if(f.value.removedEditors)for(const L of f.value.removedEditors){const p=this.h.get(L);p&&(this.h.delete(L),this.k?.id===p.id&&(this.k=void 0),k.push(p))}if(f.value.visibleEditors){this.l=f.value.visibleEditors.map(p=>this.h.get(p)).filter(p=>!!p);const L=new Set;this.l.forEach(p=>L.add(p.id));for(const p of this.h.values()){const y=L.has(p.id);p._acceptVisibility(y)}this.l=[...this.h.values()].map(p=>p).filter(p=>p.visible),this.o.fire(this.visibleNotebookEditors)}f.value.newActiveEditor===null?this.k=void 0:f.value.newActiveEditor&&(this.h.get(f.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${f.value.newActiveEditor}`),this.k=this.h.get(f.value.newActiveEditor)),f.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(f){const k=$.$6M.String.with("notebookType","A notebook type"),L=new $.$8M("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[k,new $.$6M("data","Bytes to convert to data",y=>y instanceof Uint8Array,y=>T.$fe.wrap(y))],new $.$7M("Notebook Data",y=>b.NotebookData.to(y.value))),p=new $.$8M("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[k,new $.$6M("NotebookData","Notebook data to convert to bytes",y=>!0,y=>new s.$Bv(b.NotebookData.from(y)))],new $.$7M("Bytes",y=>y.buffer));f.registerApiCommand(L),f.registerApiCommand(p)}}e.$1fc=d}),define(Pe[283],Re([1,0,20,19,40,34,25,60,44]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sfc=void 0;class w{constructor(l,$,b){this.k=l,this.l=$,this.o=b,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&M.$Gj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&M.$Gj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((b,a)=>{const s=t=>{this.f++,l(t)};if(this.g)return b({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(t=>{const n=t.toString(),o=E.$mc(n);this.j&&this.j(n,o)||this.v(s,{base:t,basename:o})}),Promise.all($.map(t=>this.p(t,s))).then(t=>{b({limitHit:this.e,stats:t[0]||void 0})},t=>{a(new Error((0,P.$Ki)(t)))})})}async p(l,$){const b=new T.$2d,a=this.q(l),s=this.r(),t=new g.$iJ(this.k,l),n=!t.hasSiblingExcludeClauses();let o;try{this.h.add(b),o=m.$Nd.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},a,b.token),h=o.elapsed(),i=m.$Nd.create();return this.g&&!this.e||(c&&c.forEach(r=>{const u=E.$fc.relative(l.folder.path,r.path);if(n){const d=E.$mc(r.path);this.v($,{base:l.folder,relativePath:u,basename:d});return}this.s(s,l.folder,u,$)}),this.g&&!this.e)?null:(this.u(s,t,$),{providerTime:h,postProcessTime:i.elapsed()})}finally{b.dispose(),this.h.delete(b)}}q(l){const $=(0,g.$hJ)(this.k.includePattern,l.includePattern),b=(0,g.$hJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:b,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,b,a){if(b===this.a){const t=E.$mc(this.a);this.v(a,{base:$,relativePath:this.a,basename:t})}function s(t){const n=E.$mc(t),o=E.$lc(t);let c=l[o];c||(c=l[o]=[],s(o)),c.push({base:$,relativePath:t,basename:n})}s(b)}u({rootEntries:l,pathToEntries:$},b,a){const s=this,t=this.a;function n(o){const c=(0,g.$kJ)(()=>o.map(h=>h.basename));for(let h=0,i=o.length;h<i;h++){const r=o[h],{relativePath:u,basename:d}=r;if(b.matchesExcludesSync(u,d,t!==d?c:void 0))continue;const v=$[u];if(v)n(v);else{if(u===t)continue;s.v(a,r)}if(s.e)break}}n(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class R{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,b,a){const s=this.c(l.cacheKey),t=new w(l,$,s&&s.token);let n=0;const o=c=>{n+=c.length,b(c.map(h=>this.d(h)))};return this.e(t,R.a,o,a).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new T.$2d),this.b.get(l)}d(l){return l.relativePath?{resource:A.$Bg(l.base,l.relativePath)}:{resource:l.base}}e(l,$,b,a){const s=a.onCancellationRequested(()=>{l.cancel()}),t=o=>{o&&(n.push(o),$>0&&n.length>=$&&(b(n),n=[]))};let n=[];return l.search(t).then(o=>(n.length&&b(n),s.dispose(),o),o=>(n.length&&b(n),s.dispose(),Promise.reject(o)))}}e.$Sfc=R}),define(Pe[284],Re([1,0,18,245,34,95,28,13,20,25,12,16,2,94,179,41,15,47,105,280,44]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.$iK=void 0;let h=class{constructor(y,D,N,q,V){this.a=y,this.b=D,this.c=N,this.d=q,this.e=V}text(y,D,N={}){y=this.f(y,N);const q=this.a.getValue(),V=D&&D.some(F=>!this.a.getValue({resource:F}).search.useRipgrep);return{...this.h(D?.map(t.$ii),N),type:2,contentPattern:y,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:q.search.usePCRE2||V||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(y,D){const N=this.a.getValue();y.isRegExp&&(y.pattern=y.pattern.replace(/\r?\n/g,"\\n"));const q={...y,wordSeparators:N.editor.wordSeparators};return this.j(y,D)&&(q.isCaseSensitive=!0),this.k(y)&&(q.isMultiline=!0),D.notebookSearchConfig?.includeMarkupInput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookMarkdownInput=D.notebookSearchConfig.includeMarkupInput),D.notebookSearchConfig?.includeMarkupPreview&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookMarkdownPreview=D.notebookSearchConfig.includeMarkupPreview),D.notebookSearchConfig?.includeCodeInput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookCellInput=D.notebookSearchConfig.includeCodeInput),D.notebookSearchConfig?.includeOutput&&(q.notebookInfo||(q.notebookInfo={}),q.notebookInfo.isInNotebookCellOutput=D.notebookSearchConfig.includeOutput),q}file(y,D={}){return{...this.h(y,D),type:1,filePattern:D.filePattern?D.filePattern.trim():D.filePattern,exists:D.exists,sortByScore:D.sortByScore,cacheKey:D.cacheKey}}g(y,D){return y?(y=Array.isArray(y)?y.map(v):v(y),D?this.parseSearchPaths(y):{pattern:r(...Array.isArray(y)?y:[y])}):{}}h(y=[],D={}){const N=this.g(D.includePattern,D.expandPatterns),q=this.g(D.excludePattern,D.expandPatterns),V=y.length>1,U=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(I=>this.q(I,D,q)):y.map(I=>this.r(I,D,q,V))).filter(I=>!!I),F={_reason:D._reason,folderQueries:U,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:D.extraFileResources,excludePattern:q.pattern,includePattern:N.pattern,onlyOpenEditors:D.onlyOpenEditors,maxResults:D.maxResults};if(D.onlyOpenEditors){const I=E.$Gb(E.$Qb(this.c.groups.map(he=>he.editors.map(be=>be.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(I));const X=I.filter(he=>(0,c.$$I)(F,he.fsPath)),ue=this.i(X);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ue)),{...F,...ue}}const C=D.extraFileResources&&D.extraFileResources.filter(I=>(0,c.$$I)(F,I.fsPath));return F.extraFileResources=C&&C.length?C:void 0,F}i(y){const D=[],N=new A.$zc,q={};let V=!1;return y.forEach(U=>{if(U.scheme===m.Schemas.walkThrough)return;if((0,w.$Fg)(U)){const C=this.b.getWorkspaceFolder(U)?.uri??U.with({path:g.$lc(U.fsPath)});let I=N.get(C);I||(V=!0,I={folder:C,includePattern:{}},D.push(I),N.set(C,I));const X=g.$kc(C.fsPath,U.fsPath);(0,S.$Nf)(I.includePattern)[X.replace(/\\/g,"/")]=!0}else U.fsPath&&(V=!0,q[U.fsPath]=!0)}),{folderQueries:D,includePattern:q,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(y,D){if(D.isSmartCase){if(y.isRegExp){if(R.$tf(y.pattern,!0))return!0}else if(R.$tf(y.pattern))return!0}return!!y.isCaseSensitive}k(y){return y.isMultiline||y.isRegExp&&(0,$.$HB)(y.pattern)||y.pattern.indexOf(`
`)>=0?!0:!!y.isMultiline}parseSearchPaths(y){const D=ue=>g.$hc(ue)||/^\.\.?([\/\\]|$)/.test(ue),q=(Array.isArray(y)?y:u(y)).map(ue=>{const he=this.e.resolvedUserHome;return he?(0,M.$Gv)(ue,he.scheme===m.Schemas.file?he.fsPath:he.path):ue}),V=T.$J(q,ue=>D(ue)?"searchPaths":"exprSegments"),U=(V.exprSegments||[]).map(ue=>R.$Oe(ue,"/")).map(ue=>R.$Oe(ue,"\\")).map(ue=>(ue[0]==="."&&(ue="*"+ue),d(ue))),F={},C=this.m(V.searchPaths||[]);C&&C.length&&(F.searchPaths=C);const I=E.$Qb(U),X=r(...I);return X&&(F.pattern=X),F}l(y,D){return D.disregardExcludeSettings?void 0:(0,c.$0I)(y,!D.disregardSearchExcludeSettings)}m(y){if(!y||!y.length)return[];const D=y.flatMap(q=>{let{pathPortion:V,globPortion:U}=i(q);return U&&(U=f(U)),this.n(V).flatMap(C=>this.o(C,U))}),N=new Map;return D.forEach(q=>{const V=q.searchPath.toString(),U=N.get(V);U?q.pattern&&(U.pattern=U.pattern||{},U.pattern[q.pattern]=!0):N.set(V,{searchPath:q.searchPath,pattern:q.pattern?r(q.pattern):void 0})}),Array.from(N.values())}n(y){if(g.$hc(y)){const D=this.b.getWorkspace().folders;return D[0]&&D[0].uri.scheme!==m.Schemas.file?[{searchPath:D[0].uri.with({path:y})}]:[{searchPath:l.URI.file(g.$gc(y))}]}if(this.b.getWorkbenchState()===2){const D=this.b.getWorkspace().folders[0].uri;if(y=v(y),y.startsWith("../")||y===".."){const q=g.$fc.resolve(D.path,y);return[{searchPath:D.with({path:q})}]}const N=f(y);return[{searchPath:D,pattern:N}]}else{if(y==="./"||y===".\\")return[];{const D=y.replace(/^\.[\/\\]/,""),q=this.b.getWorkspace().folders.map(V=>{const U=D.match(new RegExp(`^${R.$Je(V.name)}(?:/(.*)|$)`));return U?{match:U,folder:V}:null}).filter(S.$Kf);if(q.length)return q.map(V=>{const U=V.match[1];return{searchPath:V.folder.uri,pattern:U&&f(U)}});{const V=y.match(/\.[\/\\](.+)[\/\\]?/),U=V?V[1]:y,F=b.localize(0,null,U);throw new Error(F)}}}}o(y,D){const N=y.pattern&&D?`${y.pattern}/${D}`:y.pattern||D,q=[{searchPath:y.searchPath,pattern:N}];return N&&!N.endsWith("**")&&q.push({searchPath:y.searchPath,pattern:N+"/**"}),q}q(y,D,N){const q=this.r((0,t.$ii)(y.searchPath),D,N,!1);return q?{...q,includePattern:y.pattern}:null}r(y,D,N,q){let V;const U=l.URI.isUri(y)?y:y.uri;if(N.searchPaths){const ue=N.searchPaths.filter(he=>(0,w.$ug)(he.searchPath,U))[0];if(ue&&!ue.pattern)return null;ue&&(V=ue.pattern)}const F=this.a.getValue({resource:U}),I={...this.l(F,D)||{},...V||{}},X=l.URI.isUri(y)?(0,w.$yg)(y):y.name;return{folder:U,folderName:q?X:void 0,excludePattern:Object.keys(I).length>0?I:void 0,fileEncoding:F.files&&F.files.encoding,disregardIgnoreFiles:typeof D.disregardIgnoreFiles=="boolean"?D.disregardIgnoreFiles:!F.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof D.disregardGlobalIgnoreFiles=="boolean"?D.disregardGlobalIgnoreFiles:!F.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof D.disregardParentIgnoreFiles=="boolean"?D.disregardParentIgnoreFiles:!F.search.useParentIgnoreFiles,ignoreSymlinks:typeof D.ignoreSymlinks=="boolean"?D.ignoreSymlinks:!F.search.followSymlinks}}};e.$iK=h,e.$iK=h=He([We(0,a.$ti),We(1,t.$9h),We(2,n.$MC),We(3,s.$hj),We(4,o.$gK)],h);function i(p){const y=p.match(/[\*\{\}\(\)\[\]\?]/);if(y){const D=y.index,N=p.substr(0,D).match(/[/|\\][^/\\]*$/);if(N){let q=p.substr(0,N.index);return q.match(/[/\\]/)||(q+="/"),{pathPortion:q,globPortion:p.substr((N.index||0)+1)}}}return{pathPortion:p}}function r(...p){return p.length?p.reduce((y,D)=>(y[D]=!0,y),Object.create(null)):void 0}function u(p){return P.$Ej(p,",").map(y=>y.trim()).filter(y=>!!y.length)}function d(p){return[`**/${p}/**`,`**/${p}`].map(D=>D.replace(/\*\*\/\*\*/g,"**"))}function v(p){return p.replace(/\\/g,"/")}function f(p){return v(p).replace(/^\.\//,"").replace(/\/+$/g,"")}function k(p){return p.replace(/([?*[\]])/g,"[$1]")}function L(p,y){p=E.$Lb(p,q=>q.toString());const D=[],N=y.getWorkspace();return p&&p.forEach(q=>{let V;if(y.getWorkbenchState()===2)V=(0,w.$Dg)(N.folders[0].uri,q),V&&V!=="."&&(V="./"+V);else{const U=y.getWorkspaceFolder(q);if(U){const F=U.name;if(N.folders.filter(I=>I.name===F).length===1){const I=(0,w.$Dg)(U.uri,q);I===""?V=`./${U.name}`:V=`./${U.name}/${I}`}else V=q.fsPath}}V&&D.push(k(V))}),D}e.$jK=L}),define(Pe[285],Re([1,0,25,2,19,11,4,284,44,47]),function(pe,e,E,T,P,M,A,m,g,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lrb=e.$Krb=void 0;const R=7e3;function S(a,s){const t=s.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],o=[];for(const d of t)if(/^workspaceContains:/.test(d)){const v=d.substr(18);v.indexOf("*")>=0||v.indexOf("?")>=0||a.forceUsingSearch?o.push(v):n.push(v)}if(n.length===0&&o.length===0)return Promise.resolve(void 0);let c;const h=new Promise((d,v)=>{c=d}),i=d=>c({activationEvent:d}),r=Promise.all(n.map(d=>l(a,d,i))).then(()=>{}),u=$(a,s.identifier,o,i);return Promise.all([r,u]).then(()=>{c(void 0)}),h}e.$Krb=S;async function l(a,s,t){for(const n of a.folders)if(await a.exists(E.$Bg(T.URI.revive(n),s))){t(`workspaceContains:${s}`);return}}async function $(a,s,t,n){if(t.length===0)return Promise.resolve(void 0);const o=new P.$2d,c=a.checkExists(a.folders,t,o.token),h=setTimeout(async()=>{o.cancel(),a.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},R);let i=!1;try{i=await c}catch(r){M.$3(r)||M.$Z(r)}o.dispose(),clearTimeout(h),i&&n(`workspaceContains:${t.join(",")}`)}function b(a,s,t,n){const o=a.get(A.$Yh),c=a.get(g.$2I),i=o.createInstance(m.$iK).file(s.map(r=>(0,w.$ii)(T.URI.revive(r))),{_reason:"checkExists",includePattern:t,exists:!0});return c.fileSearch(i,n).then(r=>!!r.limitHit,r=>M.$3(r)?!1:Promise.reject(r))}e.$Lrb=b}),define(Pe[38],Re([1,0,158,20,88,25,14,6,50,2,15,3,37,217,85,36,23,106,11,22,24,200,7,100,4,27,86,17,71,87,64,5,285,84,202,13,82,60,21,83]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u,d,v,f,k,L,p,y,D,N,q,V,U,F,C,I){"use strict";var X;Object.defineProperty(e,"__esModule",{value:!0}),e.$yfc=e.$xfc=e.$wfc=e.$vfc=e.$ufc=void 0,e.$ufc=(0,u.$Zh)("IHostUtils");let ue=X=class extends m.$Rc{constructor(Y,W,re,Ie,Ae,Ce,le,ie,G,te,x,se){super(),this.X=se,this.a=this.B(new y.$Rd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=W,this.g=re,this.f=le,this.j=Ie,this.m=Ae,this.s=Ce,this.t=G,this.u=te,this.w=x,this.y=this.g.getProxy(S.$EK.MainThreadWorkspace),this.z=this.g.getProxy(S.$EK.MainThreadTelemetry),this.C=this.g.getProxy(S.$EK.MainThreadExtensionService),this.D=new A.$Yg,this.F=new A.$Yg,this.G=new A.$Yg,this.H=new A.$Yg,this.I=new ke(this.f.extensions.activationEvents),this.L=new t.$I6b(this.I,this.f.extensions.allExtensions);const fe=new o.$em(this.f.extensions.myExtensions);this.J=new t.$I6b(this.I,me(this.L,fe)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${we(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${we(this.J)}`)),this.M=new b.$ffc(this.g,this.s),this.N=new N.$nfc(this.g),this.O=ie,this.h=Y.createChild(new k.$Xh([b.$gfc,this.M],[N.$ofc,this.N])),this.P=this.B(new $.$efc(this.J,this.L,{onExtensionActivationError:(Se,Fe,O)=>{this.C.$onExtensionActivationError(Se,n.$2(Fe),O)},actualActivateExtension:async(Se,Fe)=>{if(t.$I6b.isHostExtension(Se,this.J,this.L))return await this.C.$activateExtension(Se,Fe),new $.$dfc;const O=this.J.getExtensionDescription(Se);return this.db(O,Fe)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),P.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(Y){n.$Z(Y)}}async Y(){this.O.onWillDeactivateAll();let Y=[];try{Y=this.J.getAllExtensionDescriptions().map(Ae=>Ae.identifier).filter(Ae=>this.isActivated(Ae)).map(Ae=>this.cb(Ae))}catch{}await Promise.all(Y)}terminate(Y,W=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${Y}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Ie=>{this.s.error(Ie)}),this.g.dispose();const re=this.Y();Promise.race([(0,A.$1g)(5e3),re]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${W}`):this.s.info(`Extension host exiting with code ${W}`),this.s.flush(),this.s.dispose(),this.c.exit(W)})}isActivated(Y){return this.G.isOpen()?this.P.isActivated(Y):!1}async getExtension(Y){const W=await this.C.$getExtension(Y);return W&&{...W,identifier:new o.$dm(W.identifier.value),extensionLocation:w.URI.revive(W.extensionLocation)}}Z(Y,W){return this.P.activateByEvent(Y,W)}$(Y,W){return this.P.activateById(Y,W)}activateByIdWithErrors(Y,W){return this.$(Y,W).then(()=>{const re=this.P.getActivatedExtension(Y);if(re.activationFailed)return Promise.reject(re.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(Y=>this.J)}getExtensionExports(Y){if(this.G.isOpen())return this.P.getActivatedExtension(Y).exports;try{return this.P.getActivatedExtension(Y).exports}catch{return null}}async ab(Y){if(Y.scheme===V.Schemas.file&&this.c.fsRealpath){const W=await this.c.fsRealpath(Y.fsPath);return w.URI.file(W)}return Y}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(Y=>new ne(Y))),this.Q}async bb(Y){const W=g.$6h.forUris(re=>M.$sg.ignorePathCasing(re));return await Promise.all(Y.map(async re=>{if(this.ub(re)){const Ie=await this.ab(re.extensionLocation);W.set(Ie,re)}})),W}cb(Y){let W=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(Y))return W;const re=this.P.getActivatedExtension(Y);if(!re)return W;try{typeof re.module.deactivate=="function"&&(W=Promise.resolve(re.module.deactivate()).then(void 0,Ie=>(this.s.error(Ie),Promise.resolve(void 0))))}catch(Ie){this.s.error(`An error occurred when deactivating the extension '${Y.value}':`),this.s.error(Ie)}try{(0,m.$Mc)(re.subscriptions)}catch(Ie){this.s.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this.s.error(Ie)}return W}async db(Y,W){return this.f.remote.isRemote?this.C.$onWillActivateExtension(Y.identifier):await this.C.$onWillActivateExtension(Y.identifier),this.fb(Y,W).then(re=>{const Ie=re.activationTimes;return this.C.$onDidActivateExtension(Y.identifier,Ie.codeLoadingTime,Ie.activateCallTime,Ie.activateResolvedTime,W),this.eb(Y,W,"success",Ie),re},re=>{throw this.eb(Y,W,"failure"),re})}eb(Y,W,re,Ie){const Ae=be(Y,W);this.z.$publicLog2("extensionActivationTimes",{...Ae,...Ie||{},outcome:re})}fb(Y,W){const re=be(Y,W);this.z.$publicLog2("activatePlugin",re);const Ie=this.ub(Y);if(!Ie)return Promise.resolve(new $.$cfc($.$_ec.NONE));this.s.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${W.startup}, activationEvent: '${W.activationEvent}'${Y.identifier.value!==W.extensionId.value?`, root cause: ${W.extensionId.value}`:""}`),this.s.flush();const Ae=new $.$afc(W.startup);return Promise.all([this.vb(Y,(0,M.$Bg)(Y.extensionLocation,Ie),Ae),this.gb(Y)]).then(Ce=>(P.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),X.hb(this.s,Y.identifier,Ce[0],Ce[1],Ae))).then(Ce=>(P.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),Ce))}gb(Y){const W=new h.$ifc(Y,this.M),re=new h.$hfc(Y.identifier.value,!1,this.M),Ie=new q.$pfc(Y,this.N),Ae=Y.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ce=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([W.whenReady,re.whenReady,this.O.whenReady]).then(()=>{const le=this;let ie,G;const te=(0,s.$QF)(Y,"ipc")?this.f.messagePorts?.get(o.$dm.toKey(Y.identifier)):void 0;return Object.freeze({globalState:W,workspaceState:re,secrets:Ie,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(x){return T.$ic(Y.extensionLocation.fsPath,x)},get storagePath(){return le.O.workspaceValue(Y)?.fsPath},get globalStoragePath(){return le.O.globalValue(Y).fsPath},get logPath(){return T.$ic(le.f.logsLocation.fsPath,Y.identifier.value)},get logUri(){return w.URI.joinPath(le.f.logsLocation,Y.identifier.value)},get storageUri(){return le.O.workspaceValue(Y)},get globalStorageUri(){return le.O.globalValue(Y)},get extensionMode(){return Ae},get extension(){return ie===void 0&&(ie=new ge(le,Y.identifier,Y,Ce,!1)),ie},get extensionRuntime(){return(0,s.$RF)(Y,"extensionRuntime"),le.extensionRuntime},get environmentVariableCollection(){return le.u.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!G){if(!te)return;const x=y.Event.buffer(y.Event.fromDOMEventEmitter(te,"message",se=>se.data));te.start(),G={onDidReceiveMessage:x,postMessage:te.postMessage.bind(te)}}return G}})})}static hb(Y,W,re,Ie,Ae){return re=re||{activate:void 0,deactivate:void 0},this.ib(Y,W,re,Ie,Ae).then(Ce=>new $.$bfc(!1,null,Ae.build(),re,Ce,Ie.subscriptions))}static ib(Y,W,re,Ie,Ae){if(typeof re.activate=="function")try{Ae.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${W.value}`);const Ce=typeof global=="object"?global:self,le=re.activate.apply(Ce,[Ie]);return Ae.activateCallStop(),Ae.activateResolveStart(),Promise.resolve(le).then(ie=>(Ae.activateResolveStop(),ie))}catch(Ce){return Promise.reject(Ce)}else return Promise.resolve(re)}jb(Y,W){this.$(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:W}).then(void 0,re=>{this.s.error(re)})}kb(Y,W=0){const Ie=Date.now();(0,C.$B)(()=>{for(let Ae=W;Ae<Y.length;Ae+=1){const Ce=Y[Ae];for(const le of Ce.activationEvents??[])if(le==="onStartupFinished")if(Date.now()-Ie>50){this.kb(Y,Ae);break}else this.jb(Ce,le)}})}lb(){this.C.$setPerformanceMarks(P.getMarks()),this.m.getConfigProvider().then(Y=>{const W=Y.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),re=this.J.getAllExtensionDescriptions();if(W)this.kb(re);else for(const Ie of re)if(Ie.activationEvents)for(const Ae of Ie.activationEvents)Ae==="onStartupFinished"&&this.jb(Ie,Ae)})}mb(){const Y=this.Z("*",!0).then(void 0,Ce=>{this.s.error(Ce)});this.B(this.j.onDidChangeWorkspace(Ce=>this.nb(Ce.added)));const W=this.j.workspace?this.j.workspace.folders:[],re=this.nb(W),Ie=this.pb(),Ae=Promise.all([Ie,Y,re]).then(()=>{});return Promise.race([Ae,(0,A.$1g)(1e4)]).then(()=>{this.lb()}),Ae}nb(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(W=>this.ob(Y,W))).then(()=>{})}async ob(Y,W){if(this.isActivated(W.identifier))return;const re=!this.f.remote.isRemote&&!!this.f.remote.authority,Ie={logService:this.s,folders:Y.map(Ce=>Ce.uri),forceUsingSearch:re||!this.c.fsExists,exists:Ce=>this.c.fsExists(Ce.fsPath),checkExists:(Ce,le,ie)=>this.y.$checkExists(Ce,le,ie)},Ae=await(0,D.$Krb)(Ie,W);if(Ae)return this.$(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Ae.activationEvent}).then(void 0,Ce=>this.s.error(Ce))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(Y){throw console.error(Y),Y}}async qb(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:W}=this.f.environment;if(!Y||!W)throw new Error(E.localize(0,null));const re=await this.vb(null,W,new $.$afc(!1));if(!re||typeof re.run!="function")throw new Error(E.localize(1,null,W.toString()));return new Promise((Ie,Ae)=>{const Ce=(G,te)=>{G?(C.$t&&this.s.error("Test runner called back with error",G),Ae(G)):(C.$t&&(te?this.s.info(`Test runner called back with ${te} failures.`):this.s.info("Test runner called back with successful outcome.")),Ie(typeof te=="number"&&te>0?1:0))},le=(0,M.$pg)(W),ie=re.run(le,Ce);ie&&ie.then&&ie.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ie(0)}).catch(G=>{C.$t&&this.s.error("Test runner finished with error",G),Ae(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$1g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,W){return this.R[Y]=W,(0,m.$Pc)(()=>{delete this.R[Y]})}async getRemoteExecServer(Y){const{resolver:W}=await this.sb(Y);return W?.resolveExecServer?.(Y,{resolveAttempt:0})}async sb(Y){const W=Y.indexOf("+");if(W===-1)throw new i.$MK("Not an authority that can be resolved!",r.RemoteAuthorityResolverErrorCode.InvalidAuthority);const re=Y.substr(0,W);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${re}`,!1),{authorityPrefix:re,resolver:this.R[re]}}async $resolveAuthority(Y,W){const re=F.$Nd.create(!1),Ie=()=>`[resolveAuthority(${(0,r.$4k)(Y)},${W})][${re.elapsed()}ms] `,Ae=J=>this.s.info(`${Ie()}${J}`),Ce=J=>this.s.warn(`${Ie()}${J}`),le=(J,B=void 0)=>this.s.error(`${Ie()}${J}`,B),ie=J=>{if(J instanceof i.$MK)return{type:"error",error:{code:J._code,message:J._message,detail:J._detail}};throw J},G=async J=>{Ae(`activating resolver for ${J}...`);const{resolver:B,authorityPrefix:Q}=await this.sb(J);if(!B)throw le(`no resolver for ${Q}`),new i.$MK(`No remote extension installed to resolve ${Q}.`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:B,authorityPrefix:Q,remoteAuthority:J}},te=Y.split(/@|%40/g).reverse();Ae(`activating remote resolvers ${te.join(" -> ")}`);let x;try{x=await Promise.all(te.map(G)).catch(async J=>{if(!(J instanceof i.$MK)||J._code!==r.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw J;return Ce(`resolving nested authorities failed: ${J.message}`),[await G(Y)]})}catch(J){return ie(J)}const se=new A.$$g;se.cancelAndSet(()=>Ae("waiting..."),1e3);let fe,Se;for(const[J,{authorityPrefix:B,resolver:Q,remoteAuthority:_}]of x.entries())try{if(J===x.length-1)Ae("invoking final resolve()..."),P.mark(`code/extHost/willResolveAuthority/${B}`),fe=await Q.resolve(_,{resolveAttempt:W,execServer:Se}),P.mark(`code/extHost/didResolveAuthorityOK/${B}`),Ae("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(Q,i.$LK.isManagedResolvedAuthority(fe)?fe:void 0));else{if(Ae(`invoking resolveExecServer() for ${_}`),P.mark(`code/extHost/willResolveExecServer/${B}`),Se=await Q.resolveExecServer?.(_,{resolveAttempt:W,execServer:Se}),!Se)throw new i.$MK(`Exec server was not available for ${_}`,r.RemoteAuthorityResolverErrorCode.NoResolverFound);P.mark(`code/extHost/didResolveExecServerOK/${B}`)}}catch(Ee){return P.mark(`code/extHost/didResolveAuthorityError/${B}`),le("returned an error",Ee),se.dispose(),ie(Ee)}se.dispose();const Fe={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures},O={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};Ae(`returned ${i.$LK.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let K;if(i.$LK.isManagedResolvedAuthority(fe)){const J=W;this.X.setFactory(J,fe.makeConnection),K={authority:Y,connectTo:new r.$1k(J),connectionToken:fe.connectionToken}}else K={authority:Y,connectTo:new r.$2k(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:K,options:O,tunnelInformation:Fe}}}async $getCanonicalURI(Y,W){this.s.info(`$getCanonicalURI invoked for authority (${(0,r.$4k)(Y)})`);const{resolver:re}=await this.sb(Y);if(!re)return null;const Ie=w.URI.revive(W);if(typeof re.getCanonicalURI>"u")return Ie;const Ae=await(0,A.$Sg)(()=>re.getCanonicalURI(Ie));return Ae||Ie}$startExtensionHost(Y){Y.toAdd.forEach(Ie=>Ie.extensionLocation=w.URI.revive(Ie.extensionLocation));const{globalRegistry:W,myExtensions:re}=he(this.I,this.L,this.J,Y);return this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${we(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${we(this.J)}`)),this.rb()}$activateByEvent(Y,W){return W===1?this.D.wait().then(re=>this.Z(Y,!1)):this.G.wait().then(re=>this.Z(Y,!1))}async $activate(Y,W){return await this.G.wait(),this.J.getExtensionDescription(Y)?(await this.$(Y,W),!0):!1}async $deltaExtensions(Y){Y.toAdd.forEach(Ce=>Ce.extensionLocation=w.URI.revive(Ce.extensionLocation));const{globalRegistry:W,myExtensions:re}=he(this.I,this.L,this.J,Y),Ie=await this.bb(re);return(await this.getExtensionPathIndex()).setSearchTree(Ie),this.L.set(W.getAllExtensionDescriptions()),this.J.set(re),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${we(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${we(this.J)}`)),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){const W=c.$fe.alloc(Y),re=Math.random()%256;for(let Ie=0;Ie<Y;Ie++)W.writeUInt8(re,Ie);return W}async $updateRemoteConnectionData(Y){this.W=Y,this.a.fire()}};e.$vfc=ue,e.$vfc=ue=X=He([We(0,u.$Yh),We(1,e.$ufc),We(2,f.$HM),We(3,a.$Uec),We(4,l.$Xec),We(5,R.$hj),We(6,d.$XM),We(7,v.$1ec),We(8,L.$Hxb),We(9,p.$jfc),We(10,U.$rfc),We(11,I.$sfc)],ue);function he(ce,Y,W,re){ce.addActivationEvents(re.addActivationEvents);const Ie=new t.$I6b(ce,Y.getAllExtensionDescriptions());Ie.deltaExtensions(re.toAdd,re.toRemove);const Ae=new o.$em(W.getAllExtensionDescriptions().map(le=>le.identifier));for(const le of re.myToRemove)Ae.delete(le);for(const le of re.myToAdd)Ae.add(le);const Ce=me(Ie,Ae);return{globalRegistry:Ie,myExtensions:Ce}}function be(ce,Y){return{id:ce.identifier.value,name:ce.name,extensionVersion:ce.version,publisherDisplayName:ce.publisher,activationEvents:ce.activationEvents?ce.activationEvents.join(","):null,isBuiltin:ce.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}function we(ce){return ce.getAllExtensionDescriptions().map(Y=>Y.identifier.value).join(",")}e.$wfc=(0,u.$Zh)("IExtHostExtensionService");class ge{#e;#t;#i;constructor(Y,W,re,Ie,Ae){this.#e=Y,this.#t=W,this.#i=re.identifier,this.id=re.identifier.value,this.extensionUri=re.extensionLocation,this.extensionPath=T.$gc((0,M.$pg)(re.extensionLocation)),this.packageJSON=re,this.extensionKind=Ie,this.isFromDifferentExtensionHost=Ae}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$xfc=ge;function me(ce,Y){return ce.getAllExtensionDescriptions().filter(W=>Y.has(W.identifier))}class ne{constructor(Y){this.a=Y}setSearchTree(Y){this.a=Y}findSubstr(Y){return this.a.findSubstr(Y)}forEach(Y){return this.a.forEach(Y)}}e.$yfc=ne;class ke{constructor(Y){this.a=new o.$fm,this.addActivationEvents(Y)}readActivationEvents(Y){return this.a.get(Y.identifier)??[]}addActivationEvents(Y){for(const W of Object.keys(Y))this.a.set(W,Y[W])}}}),define(Pe[286],Re([1,0,88,2,3,37,23,22,17,27,4,38,15,12]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;let a=class{constructor(c,h,i,r,u,d,v){this.c=c,this.d=h,this.e=i,this.f=r,this.g=u,this.h=d,this.i=v,this.a=new Map,this.b=[]}async install(){this.j(),E.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();E.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new t(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(s)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$Ggc=a,e.$Ggc=a=He([We(2,R.$Yh),We(3,M.$Xec),We(4,S.$wfc),We(5,w.$XM),We(6,l.$hj)],a);let s=class{static{b=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&b.a.size){const h=(0,$.$Je)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",r=`@${i}+\\/${i}+|${i}+`,u="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${u}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,r,u]=h,d=b.a.get(r);if(d!==void 0)return console.warn(`${r} as been renamed to ${d}, please update your imports`),i+d+u}c(c){return c.replace(/\\/g,"/")}};s=b=He([We(0,w.$XM)],s);class t{constructor(c,h,i,r,u){this.c=c,this.d=h,this.e=i,this.f=r,this.g=u,this.nodeModuleName="vscode",this.a=new m.$fm}load(c,h){const i=this.d.findSubstr(h);if(i){let r=this.a.get(i.identifier);return r||(r=this.c(i,this.e,this.f),this.a.set(i.identifier,r)),r}if(!this.b){let r="";this.d.forEach((u,d)=>r+=`	${d} -> ${u.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${r}`),this.b=this.c(A.$LF,this.e,this.f)}return this.b}}let n=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(P.$EK.MainThreadTelemetry);const r=i.getProxy(P.$EK.MainThreadWindow);this.c=(u,d)=>{const v=T.URI.parse(u);return d?this.g(u,d):v.scheme==="http"||v.scheme==="https"?r.$openUri(v,u,{allowTunneling:!0}):v.scheme==="mailto"||v.scheme===this.f?r.$openUri(v,u,{}):this.g(u,d)}}load(c,h,i){const r=this.e.findSubstr(h);return r&&(this.a=r.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=He([We(2,g.$HM)],n)}),define(Pe[116],Re([1,0,39,6,20,74,4,61,62,38,7,36,214,37]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Afc=e.$zfc=void 0,e.$zfc=(0,A.$Zh)("IExtHostVariableResolverProvider");class b extends l.$IN{constructor(t,n,o,c,h,i,r){function u(){if(o){const d=o.activeEditor();if(d)return d.document.uri;const v=c.tabGroups.all.find(f=>f.isActive)?.activeTab;if(v!==void 0){if(v.input instanceof R.$nM||v.input instanceof R.$sM)return v.input.modified;if(v.input instanceof R.$mM||v.input instanceof R.$rM||v.input instanceof R.$pM)return v.input.uri}}}super({getFolderUri:d=>{const v=i.folders.filter(f=>f.name===d);if(v&&v.length>0)return v[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(d,v)=>h.getConfiguration(void 0,d).get(v),getAppRoot:()=>M.cwd(),getExecPath:()=>M.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=u();if(d)return P.$gc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const d=u();if(d){const v=n.getWorkspaceFolder(d);if(v)return P.$gc(v.uri.fsPath)}}},getSelectedText:()=>{if(o){const d=o.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(o){const d=o.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>t.getExtension(d)},void 0,r?Promise.resolve(r):void 0,Promise.resolve(M.env))}}let a=class extends T.$Rc{constructor(t,n,o,c,h){super(),this.b=t,this.c=n,this.g=o,this.h=c,this.j=h,this.a=new E.$U(async()=>{const i=await this.h.getConfigProvider(),u={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{u.folders=await this.c.getWorkspaceFolders2()||[]})),new b(this.b,this.c,this.g,this.j,i,u,this.m())})}getResolver(){return this.a.value}m(){}};e.$Afc=a,e.$Afc=a=He([We(0,w.$wfc),We(1,S.$Uec),We(2,m.$SM),We(3,$.$Xec),We(4,g.$0ec)],a)}),define(Pe[117],Re([1,0,14,5,2,4,3,62,38,17,7,36,206,208,37,116]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ffc=e.$Efc=e.$Dfc=e.$Cfc=e.$Bfc=void 0,e.$Bfc=(0,M.$Zh)("IExtHostDebugService");let s=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,u,d,v,f,k){this.E=u,this.F=d,this.G=v,this.H=f,this.I=k,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.B=new Map,this.C=new Map,this.m=new T.$Rd,this.n=new T.$Rd,this.o=new T.$Rd,this.u=new T.$Rd,this.k=r.getProxy(A.$EK.MainThreadDebugService),this.y=new T.$Rd,this.A=new T.$Rd,this.v=new n(this.k),this.w=new Map,this.F.getExtensionRegistry().then(L=>{L.onDidChange(p=>{this.J(L)}),this.J(L)})}asDebugSourceUri(r,u){const d=r;if(typeof d.sourceReference=="number"&&d.sourceReference>0){let v=`debug:${encodeURIComponent(d.path||"")}`,f="?";return u&&(v+=`${f}session=${encodeURIComponent(u.id)}`,f="&"),v+=`${f}ref=${d.sourceReference}`,P.URI.parse(v)}else{if(d.path)return P.URI.file(d.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}J(r){const u=[];for(const d of r.getAllExtensionDescriptions())if(d.contributes){const v=d.contributes.debuggers;if(v&&v.length>0)for(const f of v)(0,$.$nF)(f)&&u.push(f.type)}this.k.$registerDebugTypes(u)}get stackFrameFocus(){return this.z}get onDidChangeStackFrameFocus(){return this.A.event}get onDidChangeBreakpoints(){return this.y.event}get breakpoints(){const r=[];return this.w.forEach(u=>r.push(u)),r}addBreakpoints(r){const u=r.filter(f=>{const k=f.id;return this.w.has(k)?!1:(this.w.set(k,f),!0)});this.U(u,[],[]);const d=[],v=new Map;for(const f of u)if(f instanceof R.$GL){let k=v.get(f.location.uri.toString());k||(k={type:"sourceMulti",uri:f.location.uri,lines:[]},v.set(f.location.uri.toString(),k),d.push(k)),k.lines.push({id:f.id,enabled:f.enabled,condition:f.condition,hitCondition:f.hitCondition,logMessage:f.logMessage,line:f.location.range.start.line,character:f.location.range.start.character})}else f instanceof R.$HL&&d.push({type:"function",id:f.id,enabled:f.enabled,hitCondition:f.hitCondition,logMessage:f.logMessage,condition:f.condition,functionName:f.functionName});return this.k.$registerBreakpoints(d)}removeBreakpoints(r){const u=r.filter(k=>this.w.delete(k.id));this.U([],u,[]);const d=u.filter(k=>k instanceof R.$GL).map(k=>k.id),v=u.filter(k=>k instanceof R.$HL).map(k=>k.id),f=u.filter(k=>k instanceof R.$IL).map(k=>k.id);return this.k.$unregisterBreakpoints(d,v,f)}startDebugging(r,u,d){return this.k.$startDebugging(r?r.uri:void 0,u,{parentSessionID:d.parentSession?d.parentSession.id:void 0,lifecycleManagedByParent:d.lifecycleManagedByParent,repl:d.consoleMode===R.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:d.noDebug,compact:d.compact,suppressSaveBeforeStart:d.suppressSaveBeforeStart,suppressDebugStatusbar:d.suppressDebugStatusbar??d.debugUI?.simple,suppressDebugToolbar:d.suppressDebugToolbar??d.debugUI?.simple,suppressDebugView:d.suppressDebugView??d.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,u,d){if(!u)return new R.$GK(()=>{});const v=this.d++;return this.f.push({type:r,handle:v,provider:u}),this.k.$registerDebugConfigurationProvider(r,d,!!u.provideDebugConfigurations,!!u.resolveDebugConfiguration,!!u.resolveDebugConfigurationWithSubstitutedVariables,v),new R.$GK(()=>{this.f=this.f.filter(f=>f.provider!==u),this.k.$unregisterDebugConfigurationProvider(v)})}registerDebugAdapterDescriptorFactory(r,u,d){if(!d)return new R.$GK(()=>{});if(!this.Q(r,u))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${u}' debugger.`);if(this.N(u))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const v=this.g++;return this.h.push({type:u,handle:v,factory:d}),this.k.$registerDebugAdapterDescriptorFactory(u,v),new R.$GK(()=>{this.h=this.h.filter(f=>f.factory!==d),this.k.$unregisterDebugAdapterDescriptorFactory(v)})}registerDebugAdapterTrackerFactory(r,u){if(!u)return new R.$GK(()=>{});const d=this.i++;return this.j.push({type:r,handle:d,factory:u}),new R.$GK(()=>{this.j=this.j.filter(v=>v.factory!==u)})}async $runInTerminal(r,u){return Promise.resolve(void 0)}async $substituteVariables(r,u){let d;const v=await this.W(r);return v&&(d={uri:v.uri,name:v.name,index:v.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.I.getResolver()).resolveAnyAsync(d,u)}K(r,u){if(r.type==="implementation")return new c(r.implementation)}L(){}async $startDASession(r,u){const d=this,v=await this.V(u);return this.S(this.N(v.type),v).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}' (extension might have failed to activate)`);const k=this.M(f),L=this.K(k,v);if(!L)throw new Error(`Couldn't create a debug adapter for type '${v.type}'.`);const p=L;return this.B.set(r,p),this.R(v).then(y=>(y&&this.C.set(r,y),p.onMessage(async D=>{if(D.type==="request"&&D.command==="handshake"){const N=D,q={type:"response",seq:0,command:N.command,request_seq:N.seq,success:!0};this.D||(this.D=this.L());try{if(this.D){const V=await this.D.sign(N.arguments.value);q.body={signature:V},p.sendResponse(q)}else throw new Error("no signer")}catch(V){q.success=!1,q.message=V.message,p.sendResponse(q)}}else y&&y.onDidSendMessage&&y.onDidSendMessage(D),D=(0,$.$sF)(D,!0),d.k.$acceptDAMessage(r,D)}),p.onError(D=>{y&&y.onError&&y.onError(D),this.k.$acceptDAError(r,D.name,D.message,D.stack)}),p.onExit(D=>{y&&y.onExit&&y.onExit(D??void 0,void 0),this.k.$acceptDAExit(r,D??void 0,void 0)}),y&&y.onWillStartSession&&y.onWillStartSession(),p.startSession()))})}$sendDAMessage(r,u){u=(0,$.$rF)(u,!1);const d=this.C.get(r);d&&d.onWillReceiveMessage&&d.onWillReceiveMessage(u),this.B.get(r)?.sendMessage(u)}$stopDASession(r){const u=this.C.get(r);this.C.delete(r),u&&u.onWillStopSession&&u.onWillStopSession();const d=this.B.get(r);return this.B.delete(r),d?d.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const u=[],d=[],v=[];if(r.added)for(const f of r.added){const k=f.id;if(k&&!this.w.has(k)){let L;if(f.type==="function")L=new R.$HL(f.functionName,f.enabled,f.condition,f.hitCondition,f.logMessage);else if(f.type==="data")L=new R.$IL(f.label,f.dataId,f.canPersist,f.enabled,f.hitCondition,f.condition,f.logMessage);else{const p=P.URI.revive(f.uri);L=new R.$GL(new R.$SK(p,new R.$HK(f.line,f.character)),f.enabled,f.condition,f.hitCondition,f.logMessage)}(0,R.$EL)(L,k),this.w.set(k,L),u.push(L)}}if(r.removed)for(const f of r.removed){const k=this.w.get(f);k&&(this.w.delete(f),d.push(k))}if(r.changed){for(const f of r.changed)if(f.id){const k=this.w.get(f.id);if(k){if(k instanceof R.$HL&&f.type==="function"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.functionName=f.functionName}else if(k instanceof R.$GL&&f.type==="source"){const L=k;L.enabled=f.enabled,L.condition=f.condition,L.hitCondition=f.hitCondition,L.logMessage=f.logMessage,L.location=new R.$SK(P.URI.revive(f.uri),new R.$HK(f.line,f.character))}v.push(k)}}}this.U(u,d,v)}async $acceptStackFrameFocus(r){let u;const d=r.sessionId?await this.V(r.sessionId):void 0;if(!d)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?u=new R.$OL(d,r.threadId):u=new R.$NL(d,r.threadId,r.frameId),this.z=u,this.A.fire(this.z)}$provideDebugConfigurations(r,u,d){return(0,E.$Sg)(async()=>{const v=this.P(r);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const f=await this.W(u);return v.provideDebugConfigurations(f,d)}).then(v=>{if(!v)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return v})}$resolveDebugConfiguration(r,u,d,v){return(0,E.$Sg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const k=await this.W(u);return f.resolveDebugConfiguration(k,d,v)})}$resolveDebugConfigurationWithSubstitutedVariables(r,u,d,v){return(0,E.$Sg)(async()=>{const f=this.P(r);if(!f)throw new Error("no DebugConfigurationProvider found");if(!f.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const k=await this.W(u);return f.resolveDebugConfigurationWithSubstitutedVariables(k,d,v)})}async $provideDebugAdapter(r,u){const d=this.O(r);if(!d)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const v=await this.V(u);return this.S(d,v).then(f=>{if(!f)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${v.type}'`);return this.M(f)})}async $acceptDebugSessionStarted(r){const u=await this.V(r);this.m.fire(u)}async $acceptDebugSessionTerminated(r){const u=await this.V(r);u&&(this.n.fire(u),this.l.delete(u.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,u){(await this.V(r))?._acceptNameChanged(u)}async $acceptDebugSessionCustomEvent(r,u){const v={session:await this.V(r),event:u.event,body:u.body};this.u.fire(v)}M(r){if(r instanceof R.$JL)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof R.$KL)return{type:"server",port:r.port,host:r.host};if(r instanceof R.$LL)return{type:"pipeServer",path:r.path};if(r instanceof R.$ML)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}N(r){const u=this.h.filter(d=>d.type===r);if(u.length>0)return u[0].factory}O(r){const u=this.h.filter(d=>d.handle===r);if(u.length>0)return u[0].factory}P(r){const u=this.f.filter(d=>d.handle===r);if(u.length>0)return u[0].provider}Q(r,u){if(r.contributes){const d=r.contributes.debuggers;if(d&&d.length>0){for(const v of d)if(v.label&&v.type&&v.type===u)return!0}}return!1}R(r){const d=r.configuration.type,v=this.j.filter(f=>f.type===d||f.type==="*").map(f=>(0,E.$Sg)(()=>f.factory.createDebugAdapterTracker(r)).then(k=>k,k=>null));return Promise.race([Promise.all(v).then(f=>{const k=f.filter(L=>!!L);if(k.length>0)return new o(k)}),new Promise(f=>setTimeout(()=>f(void 0),1e3))]).catch(f=>{})}async S(r,u){const d=u.configuration.debugServer;if(typeof d=="number")return Promise.resolve(new R.$KL(d));if(r){const f=await this.F.getExtensionRegistry();return(0,E.$Sg)(()=>r.createDebugAdapterDescriptor(u,this.T(u,f))).then(k=>{if(k)return k})}const v=await this.F.getExtensionRegistry();return Promise.resolve(this.T(u,v))}T(r,u){}U(r,u,d){(r.length>0||u.length>0||d.length>0)&&this.y.fire(Object.freeze({added:r,removed:u,changed:d}))}async V(r){if(r)if(typeof r=="string"){const u=this.l.get(r);if(u)return u}else{let u=this.l.get(r.id);if(!u){const d=await this.W(r.folderUri),v=r.parent?this.l.get(r.parent):void 0;u=new t(this.k,r.id,r.type,r.name,d,r.configuration,v),this.l.set(u.id,u),this.k.$sessionCached(u.id)}return u}throw new Error("cannot find session")}W(r){if(r){const u=P.URI.revive(r);return this.E.resolveWorkspaceFolder(u)}return Promise.resolve(void 0)}};e.$Cfc=s,e.$Cfc=s=He([We(0,w.$HM),We(1,S.$Uec),We(2,g.$wfc),We(3,b.$Xec),We(4,m.$0ec),We(5,a.$zfc)],s);class t{constructor(r,u,d,v,f,k,L){this.d=r,this.f=u,this.g=d,this.h=v,this.i=f,this.j=k,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,u){return this.d.$customDebugAdapterRequest(this.f,r,u)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.$Dfc=t;class n{constructor(r){this.value=Object.freeze({append(u){r.$appendDebugConsole(u)},appendLine(u){this.append(u+`
`)}})}}e.$Efc=n;class o{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(u=>u.onWillReceiveMessage?u.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(u=>u.onDidSendMessage?u.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(u=>u.onError?u.onError(r):void 0)}onExit(r,u){this.d.forEach(d=>d.onExit?d.onExit(r,u):void 0)}}class c extends l.$Pfb{constructor(r){super(),this.h=r,r.onDidSendMessage(u=>{this.acceptMessage(u)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let h=class extends s{constructor(r,u,d,v,f,k){super(r,u,d,v,f,k)}};e.$Ffc=h,e.$Ffc=h=He([We(0,w.$HM),We(1,S.$Uec),We(2,g.$wfc),We(3,b.$Xec),We(4,m.$0ec),We(5,a.$zfc)],h)}),define(Pe[287],Re([1,0,11,88,2,3,275,15,70,71,27,184,17,57,38,59]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0;class s{static async installEarlyHandler(o){Error.stackTraceLimit=100;const c=o.get(m.$hj),i=o.get(l.$HM).getProxy(M.$EK.MainThreadErrors);E.setUnexpectedErrorHandler(r=>{c.error(r);const u=E.$2(r);i.$onUnexpectedError(u)})}static async installFullHandler(o){const c=o.get(m.$hj),h=o.get(l.$HM),i=o.get(b.$wfc),r=o.get(a.$2M),u=h.getProxy(M.$EK.MainThreadExtensionService),d=h.getProxy(M.$EK.MainThreadErrors),v=await i.getExtensionPathIndex(),f=new WeakMap;function k(y,D){if(f.has(y))return f.get(y).stack;let N="",q,V;for(const F of D)N+=`
	at ${F.toString()}`,V=F.getFileName(),!q&&V&&(q=v.findSubstr(P.URI.file(V)));const U=`${y.name||"Error"}: ${y.message||""}${N}`;return f.set(y,{extensionIdentifier:q?.identifier,stack:U}),U}const L=Symbol("prepareStackTrace wrapped");let p=k;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return p},set(y){if(y===k||!y||y[L]){p=y||k;return}p=function(D,N){return k(D,N),y.call(Error,D,N)},Object.assign(p,{[L]:!0})}}),E.setUnexpectedErrorHandler(y=>{c.error(y);const D=E.$2(y),N=f.get(y);if(!N?.extensionIdentifier){d.$onUnexpectedError(D);return}u.$onExtensionRuntimeError(N.extensionIdentifier,D);const q=r.onExtensionError(N.extensionIdentifier,y);c.trace("forwarded error to extension?",q,N)})}}e.$Hgc=s;class t{constructor(o,c,h,i,r){this.a=h,this.b=new A.$Q6b(o,null,i),c=t.e(c,this.b);const u=new w.$Xh(...(0,g.$Hr)());u.set(R.$XM,{_serviceBrand:void 0,...c,messagePorts:r}),u.set(l.$HM,new l.$IM(this.b)),u.set($.$Rec,new $.$Sec(i)),u.set(b.$ufc,h);const d=new S.$nq(u,!0);d.invokeFunction(s.installEarlyHandler),this.d=d.invokeFunction(v=>v.get(m.$hj)),T.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=d.invokeFunction(v=>v.get(b.$wfc)),this.c.initialize(),d.invokeFunction(s.installFullHandler)}async asBrowserUri(o){const c=this.b.getProxy(M.$EK.MainThreadExtensionService);return P.URI.revive(await c.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,c){o.extensions.allExtensions.forEach(i=>{i.extensionLocation=P.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),o.environment.appRoot=P.URI.revive(c.transformIncomingURIs(o.environment.appRoot));const h=o.environment.extensionDevelopmentLocationURI;return h&&(o.environment.extensionDevelopmentLocationURI=h.map(i=>P.URI.revive(c.transformIncomingURIs(i)))),o.environment.extensionTestsLocationURI=P.URI.revive(c.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=P.URI.revive(c.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=P.URI.revive(c.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=P.URI.revive(c.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=P.URI.revive(c.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=P.URI.revive(c.transformIncomingURIs(o.logsLocation)),o.workspace=c.transformIncomingURIs(o.workspace),o}}e.$Igc=t}),define(Pe[288],Re([1,0,18,14,19,40,13,20,25,2,44]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wfc=e.$Vfc=e.$Ufc=e.$Tfc=void 0;class S{constructor(n,o,c,h){this.d=n,this.e=o,this.f=c,this.g=h,this.a=null,this.b=!1,this.c=0}search(n,o){const c=this.d.folderQueries||[],h=new P.$2d(o);return new Promise((i,r)=>{this.a=new $(n);let u=!1;const d=(v,f)=>{if(!u&&!this.b){const k=this.h(v);a(v)&&typeof this.d.maxResults=="number"&&this.c+k>this.d.maxResults&&(this.b=!0,u=!0,h.cancel(),v=this.j(v,this.d.maxResults-this.c));const L=this.h(v);this.c+=L,(L>0||!a(v))&&this.a.add(v,f)}};Promise.all(c.map((v,f)=>this.k(v,k=>d(k,f),h.token))).then(v=>{h.dispose(),this.a.flush();const f=v.some(k=>!!k&&!!k.limitHit);i({limitHit:this.b||f,messages:(0,E.$Qb)(v.map(k=>k?.message?Array.isArray(k.message)?k.message:[k.message]:[])),stats:{type:this.g}})},v=>{h.dispose();const f=(0,M.$Ki)(v);r(new Error(f))})})}h(n){return a(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,o){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],h=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,o),preview:{matches:h.slice(0,o),text:n.preview.text},uri:n.uri}}async k(n,o,c){const h=new R.$iJ(this.d,n),i=[],r={report:v=>{if(!this.l(v))return;const f=n.folder.scheme===A.Schemas.file?(0,R.$jJ)(()=>this.f.readdir(g.$Ag(v.uri))):void 0,k=g.$Dg(n.folder,v.uri);if(k){const L=h.includedInQuery(k,m.$mc(k),f);(0,T.$Mg)(L)?i.push(L.then(p=>{p&&o(v)})):L&&o(v)}}},u=this.n(n),d=await this.e.provideTextSearchResults(l(this.d.contentPattern),u,r,c);return i.length&&await Promise.all(i),d}l(n){if(a(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const o=(0,R.$hJ)(this.d.includePattern,n.includePattern),c=(0,R.$hJ)(this.d.excludePattern,n.excludePattern),h={folder:w.URI.from(n.folder),excludes:c,includes:o,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.f.toCanonicalName(n.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return h.usePCRE2=this.d.usePCRE2,h}}e.$Tfc=S;function l(t){return{isCaseSensitive:t.isCaseSensitive||!1,isRegExp:t.isRegExp||!1,isWordMatch:t.isWordMatch||!1,isMultiline:t.isMultiline||!1,pattern:t.pattern}}class ${constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new s(512,o=>this.g(o))}add(n,o){this.d&&(this.b!==o||!g.$ug(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:n.uri,results:[]}),this.d.results.push(b(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$Ufc=$;function b(t){return a(t)?{preview:{matches:(0,E.$1b)(t.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:t.preview.text},ranges:(0,E.$1b)(t.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:t.text,lineNumber:t.lineNumber}}function a(t){return!!t.preview}e.$Vfc=a;class s{static{this.a=4e3}static{this.b=50}constructor(n,o){this.g=n,this.h=o,this.c=0,this.d=[],this.e=0}addItem(n,o){n&&this.j(n,o)}addItems(n,o){n&&this.k(n,o)}j(n,o){this.d.push(n),this.e+=o,this.l()}k(n,o){this.d=this.d.concat(n),this.e+=o,this.l()}l(){this.c<s.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},s.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Wfc=s}),define(Pe[118],Re([1,0,6,3,4,283,17,57,15,2,288]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zfc=e.$Yfc=e.$Xfc=void 0,e.$Xfc=(0,P.$Zh)("IExtHostSearch");let S=class{constructor(a,s,t){this.k=a,this.l=s,this.n=t,this.c=this.k.getProxy(T.$EK.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new M.$Sfc}o(a){return this.l.transformOutgoingScheme(a)}registerTextSearchProvider(a,s){if(this.g.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this.g.add(a);const t=this.d++;return this.e.set(t,s),this.c.$registerTextSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.g.delete(a),this.e.delete(t),this.c.$unregisterProvider(t)})}registerFileSearchProvider(a,s){if(this.i.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this.i.add(a);const t=this.d++;return this.h.set(t,s),this.c.$registerFileSearchProvider(t,this.o(a)),(0,E.$Pc)(()=>{this.i.delete(a),this.h.delete(t),this.c.$unregisterProvider(t)})}$provideFileSearchResults(a,s,t,n){const o=l(t),c=this.h.get(a);if(c)return this.j.fileSearch(o,c,h=>{this.c.$handleFileMatch(a,s,h.map(i=>i.resource))},n);throw new Error("unknown provider: "+a)}async doInternalFileSearchWithCustomCallback(a,s,t){return{messages:[]}}$clearCache(a){return this.j.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,s,t,n){const o=this.e.get(a);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const c=l(t);return this.q(c,o).search(i=>this.c.$handleTextMatch(a,s,i),n)}$enableExtensionHostSearch(){}q(a,s){return new R.$Tfc(a,s,{readdir:t=>Promise.resolve([]),toCanonicalName:t=>t},"textSearchProvider")}};e.$Yfc=S,e.$Yfc=S=He([We(0,A.$HM),We(1,m.$Rec),We(2,g.$hj)],S);function l(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map($),extraFileResources:b.extraFileResources&&b.extraFileResources.map(a=>w.URI.revive(a))}}e.$Zfc=l;function $(b){return{...b,folder:w.URI.revive(b.folder)}}}),define(Pe[289],Re([1,0,19,11,5,6,13,31,2,145,141,129,93,22,42,15,55,56,197,3,230,238,81,231,232,233,234,235,236,237,212,32,239,37,271,117,110,241,242,243,219,244,61,62,246,38,247,63,248,43,27,249,250,251,252,253,254,82,83,256,282,221,201,222,257,258,112,259,223,260,261,17,262,118,84,263,264,265,85,86,115,59,64,266,267,209,268,224,87,8,7,269,57,270,65,272,273,111,36,207,79,23,114]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u,d,v,f,k,L,p,y,D,N,q,V,U,F,C,I,X,ue,he,be,we,ge,me,ne,ke,ce,Y,W,re,Ie,Ae,Ce,le,ie,G,te,x,se,fe,Se,Fe,O,K,J,B,Q,_,Ee,ze,Qe,Je,Ye,it,nt,_e,rt,Ue,ct,ee,Z,ve,Be,Ke,xe,ot,pt,Ne,Pt,Kt,zt,yt,Wt,Ut,Ht,Gt,Rt,St,Xe,Jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;function Vt(ut){const gt=ut.get(Y.$XM),Zt=ut.get(ce.$zec),It=ut.get(ne.$Zec),Dt=ut.get(ge.$wfc),dt=ut.get(Gt.$Uec),At=ut.get(ct.$2M),Ot=ut.get(N.$Xec),Et=ut.get(Kt.$Rec),qe=ut.get(Ee.$HM),Mt=ut.get(_e.$gfc),jt=ut.get(rt.$1ec),Qt=ut.get(a.$ij),ft=ut.get(a.$hj),De=ut.get(ot.$Hxb),Le=ut.get(i.$Cec),$e=ut.get(Ht.$Bgc),H=ut.get(Je.$ofc),Me=ut.get(be.$0ec),je=ut.get(G.$sfc);qe.set(o.$FK.ExtHostFileSystemInfo,Zt),qe.set(o.$FK.ExtHostLogLevelServiceShape,Qt),qe.set(o.$FK.ExtHostWorkspace,dt),qe.set(o.$FK.ExtHostConfiguration,Ot),qe.set(o.$FK.ExtHostExtensionService,Dt),qe.set(o.$FK.ExtHostStorage,Mt),qe.set(o.$FK.ExtHostTunnelService,De),qe.set(o.$FK.ExtHostWindow,$e),qe.set(o.$FK.ExtHostSecretState,H),qe.set(o.$FK.ExtHostTelemetry,At),qe.set(o.$FK.ExtHostEditorTabs,Me),qe.set(o.$FK.ExtHostManagedSockets,je);const Ze=qe.set(o.$FK.ExtHostDecorations,ut.get(U.$Hfc)),Ve=qe.set(o.$FK.ExtHostDocumentsAndEditors,ut.get(he.$SM)),tt=qe.set(o.$FK.ExtHostCommands,ut.get(y.$4M)),mt=qe.set(o.$FK.ExtHostTerminalService,ut.get(ee.$jfc)),vt=qe.set(o.$FK.ExtHostDebugService,ut.get(V.$Bfc)),Lt=qe.set(o.$FK.ExtHostSearch,ut.get(Qe.$Xfc)),bt=qe.set(o.$FK.ExtHostTask,ut.get(Ue.$ogc)),Nt=qe.set(o.$FK.ExtHostOutputService,ut.get(K.$bgc)),qt=qe.set(o.$FK.ExtHostLocalization,ut.get(ie.$rfc)),mi=qe.set(o.$FK.ExtHostUrls,new zt.$ygc(qe)),Ct=qe.set(o.$FK.ExtHostDocuments,new ue.$xec(qe,Ve)),ki=qe.set(o.$FK.ExtHostDocumentContentProviders,new I.$Jfc(qe,Ve,ft)),Vi=qe.set(o.$FK.ExtHostDocumentSaveParticipant,new X.$Kfc(ft,Ct,qe.getProxy(o.$EK.MainThreadBulkEdits))),kt=qe.set(o.$FK.ExtHostNotebook,new x.$1fc(qe,tt,Ve,Ct,It,Lt)),ni=qe.set(o.$FK.ExtHostNotebookDocuments,new fe.$8fc(kt)),$i=qe.set(o.$FK.ExtHostNotebookEditors,new Se.$9fc(ft,kt)),ai=qe.set(o.$FK.ExtHostNotebookKernels,new Fe.$0fc(qe,gt,kt,tt,ft)),Si=qe.set(o.$FK.ExtHostNotebookRenderers,new O.$_fc(qe,kt)),Ii=qe.set(o.$FK.ExtHostNotebookDocumentSaveParticipant,new se.$7fc(ft,kt,qe.getProxy(o.$EK.MainThreadBulkEdits))),Ft=qe.set(o.$FK.ExtHostEditors,new ve.$Oec(qe,Ve)),pi=qe.set(o.$FK.ExtHostTreeViews,new xe.$wgc(qe.getProxy(o.$EK.MainThreadTreeViews),tt,ft)),Ci=qe.set(o.$FK.ExtHostEditorInsets,new p.$Pec(qe.getProxy(o.$EK.MainThreadEditorInsets),Ft,gt.remote)),ci=qe.set(o.$FK.ExtHostDiagnostics,new F.$Bec(qe,ft,Zt,Ve)),ui=qe.set(o.$FK.ExtHostLanguages,new le.$5fc(qe,Ct,tt.converter,Et)),lt=qe.set(o.$FK.ExtHostLanguageFeatures,new Ce.$Fec(qe,Et,Ct,tt,ci,ft,Le,At)),qi=qe.set(o.$FK.ExtHostFileSystem,new me.$Mfc(qe,lt)),xt=qe.set(o.$FK.ExtHostFileSystemEventService,new ke.$Nfc(qe,ft,Ve)),ri=qe.set(o.$FK.ExtHostQuickOpen,(0,_.$fgc)(qe,dt,tt)),di=qe.set(o.$FK.ExtHostSCM,new ze.$hgc(qe,tt,Ct,ft)),Pi=qe.set(o.$FK.ExtHostQuickDiff,new Q.$egc(qe,Et)),Ki=qe.set(o.$FK.ExtHostShare,new Ye.$igc(qe,Et)),Ri=qe.set(o.$FK.ExtHostComments,(0,D.$Qec)(qe,tt,Ct)),vi=qe.set(o.$FK.ExtHostProgress,new B.$dgc(qe.getProxy(o.$EK.MainThreadProgress))),Hi=qe.set(o.$FK.ExtHosLabelService,new Ae.$4fc(qe)),Ai=qe.set(o.$FK.ExtHostTheming,new Be.$tgc(qe)),li=qe.set(o.$FK.ExtHostAuthentication,new r.$Hec(qe)),Gi=qe.set(o.$FK.ExtHostTimeline,new Ke.$vgc(qe,tt)),bi=qe.set(o.$FK.ExtHostWebviews,new yt.$5ec(qe,gt.remote,dt,ft,Le)),Mi=qe.set(o.$FK.ExtHostWebviewPanels,new Wt.$8ec(qe,bi,dt)),cn=qe.set(o.$FK.ExtHostCustomEditors,new q.$9ec(qe,Ct,jt,bi,Mi)),Li=qe.set(o.$FK.ExtHostWebviewViews,new Ut.$zgc(qe,bi)),si=qe.set(o.$FK.ExtHostTesting,new Z.$pgc(qe,tt,Ve)),un=qe.set(o.$FK.ExtHostUriOpeners,new Pt.$xgc(qe)),ln=qe.set(o.$FK.ExtHostProfileContentHandlers,new J.$cgc(qe));qe.set(o.$FK.ExtHostInteractive,new re.$2fc(qe,kt,Ve,tt,ft));const Ji=qe.set(o.$FK.ExtHostInlineChat,new W.$Ofc(qe,tt,Ct,ft)),fi=qe.set(o.$FK.ExtHostChatProvider,new f.$Kec(qe,ft)),Qi=qe.set(o.$FK.ExtHostChatAgents2,new v.$Lec(qe,fi,ft)),Zi=qe.set(o.$FK.ExtHostChatVariables,new k.$Mec(qe)),gi=qe.set(o.$FK.ExtHostChat,new d.$Jec(qe)),Xi=qe.set(o.$FK.ExtHostAiRelatedInformation,new c.$wec(qe)),Fi=qe.set(o.$FK.ExtHostAiEmbeddingVector,new we.$Lfc(qe)),Ti=qe.set(o.$FK.ExtHostIssueReporter,new Ie.$3fc(qe)),_t=qe.set(o.$FK.ExtHostStatusBar,new nt.$lgc(qe,tt.converter)),wi=qe.set(o.$FK.ExtHostSpeech,new it.$jgc(qe)),hn=Object.values(o.$FK);qe.assertRegistered(hn);const Xt=new u.$Iec(qe,Ve),yi=new L.$Nec(qe),Ei=new te.$6fc(qe,ft),Oi=new C.$Ifc(qe);return h.$Gec.register(tt),function(Oe,ei,Yi){const $t=function(){let oe=!Oe.isUnderDevelopment;function de(){oe||(ft.info(`Extension '${Oe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),oe=!0)}return function Te(st){if(Array.isArray(st))st.forEach(Te);else if(typeof st=="string")de();else{const wt=st;typeof wt.scheme>"u"&&de(),typeof wt.exclusive=="boolean"&&(0,Xe.$RF)(Oe,"documentFiltersExclusive")}return st}}(),xi={getSession(oe,de,Te){return li.getSession(Oe,oe,de,Te)},getSessions(oe,de){return(0,Xe.$RF)(Oe,"authGetSessions"),li.getSessions(Oe,oe,de)},async hasSession(oe,de){return(0,Xe.$RF)(Oe,"authSession"),!!await li.getSession(Oe,oe,de,{silent:!0})},get onDidChangeSessions(){return li.onDidChangeSessions},registerAuthenticationProvider(oe,de,Te,st){return li.registerAuthenticationProvider(oe,de,Te,st)}},dn={registerCommand(oe,de,Te){return tt.registerCommand(!0,oe,de,Te,void 0,Oe)},registerTextEditorCommand(oe,de,Te){return tt.registerCommand(!0,oe,(...st)=>{const wt=Ft.getActiveTextEditor();if(!wt){ft.warn("Cannot execute "+oe+" because there is no active text editor.");return}return wt.edit(Tt=>{de.apply(Te,[wt,Tt,...st])}).then(Tt=>{Tt||ft.warn("Edits from command "+oe+" were not applied.")},Tt=>{ft.warn("An error occurred while running command "+oe,Tt)})},void 0,void 0,Oe)},registerDiffInformationCommand:(oe,de,Te)=>((0,Xe.$RF)(Oe,"diffCommand"),tt.registerCommand(!0,oe,async(...st)=>{const wt=Ve.activeEditor(!0);if(!wt){ft.warn("Cannot execute "+oe+" because there is no active text editor.");return}const Tt=await Ft.getDiffInformation(wt.id);de.apply(Te,[Tt,...st])},void 0,void 0,Oe)),executeCommand(oe,...de){return tt.executeCommand(oe,...de)},getCommands(oe=!1){return tt.getCommands(oe)}},_i={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return yi.value},get shell(){return mt.getDefaultShell(!1)},get onDidChangeShell(){return mt.onDidChangeShell},get isTelemetryEnabled(){return At.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return At.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Xe.$RF)(Oe,"telemetry"),At.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$RF)(Oe,"telemetry"),At.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,ct.$1M)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(oe,de){return ct.$ZM.validateSender(oe),At.instantiateLogger(Oe,oe,de)},openExternal(oe,de){return $e.openUri(oe,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(oe){if(oe.scheme===gt.environment.appUriScheme)return mi.createAppUri(oe);try{return await $e.asExternalUri(oe,{allowTunneling:!!gt.remote.authority})}catch(de){if((0,A.$$f)(oe,A.Schemas.http)||(0,A.$$f)(oe,A.Schemas.https))return oe;throw de}},get remoteName(){return(0,s.$6k)(gt.remote.authority)},get remoteAuthority(){return(0,Xe.$RF)(Oe,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return ft.onDidChangeLogLevel},registerIssueUriRequestHandler(oe){return(0,Xe.$RF)(Oe,"handleIssueUri"),Ti.registerIssueUriRequestHandler(Oe,oe)},registerIssueDataProvider(oe){return(0,Xe.$RF)(Oe,"handleIssueUri"),Ti.registerIssueDataProvider(Oe,oe)},get appQuality(){return(0,Xe.$RF)(Oe,"resolvers"),gt.quality},get appCommit(){return(0,Xe.$RF)(Oe,"resolvers"),gt.commit}};gt.environment.extensionTestsLocationURI||Object.freeze(_i);const en={createTestController(oe,de,Te){return si.createTestController(Oe,oe,de,Te)},createTestObserver(){return(0,Xe.$RF)(Oe,"testObserver"),si.createTestObserver()},runTests(oe){return(0,Xe.$RF)(Oe,"testObserver"),si.runTests(oe)},get onDidChangeTestResults(){return(0,Xe.$RF)(Oe,"testObserver"),si.onResultsChanged},get testResults(){return(0,Xe.$RF)(Oe,"testObserver"),si.results}},hi=gt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,tn={getExtension(oe,de){(0,Xe.$QF)(Oe,"extensionsAny")||(de=!1);const Te=ei.mine.getExtensionDescription(oe);if(Te)return new ge.$xfc(Dt,Oe.identifier,Te,hi,!1);if(de){const st=ei.all.getExtensionDescription(oe);if(st)return new ge.$xfc(Dt,Oe.identifier,st,hi,!0)}},get all(){const oe=[];for(const de of ei.mine.getAllExtensionDescriptions())oe.push(new ge.$xfc(Dt,Oe.identifier,de,hi,!1));return oe},get allAcrossExtensionHosts(){(0,Xe.$RF)(Oe,"extensionsAny");const oe=new $.$em(ei.mine.getAllExtensionDescriptions().map(Te=>Te.identifier)),de=[];for(const Te of ei.all.getAllExtensionDescriptions()){const st=!oe.has(Te.identifier);de.push(new ge.$xfc(Dt,Oe.identifier,Te,hi,st))}return de},get onDidChange(){return(0,Xe.$QF)(Oe,"extensionsAny")?P.Event.any(ei.mine.onDidChange,ei.all.onDidChange):ei.mine.onDidChange}},nn={createDiagnosticCollection(oe){return ci.createDiagnosticCollection(Oe.identifier,oe)},get onDidChangeDiagnostics(){return ci.onDidChangeDiagnostics},getDiagnostics:oe=>ci.getDiagnostics(oe),getLanguages(){return ui.getLanguages()},setTextDocumentLanguage(oe,de){return ui.changeLanguage(oe.uri,de)},match(oe,de){const Te=Ct.getDocumentData(de.uri)?.notebook;return(0,R.$kt)(pt.LanguageSelector.from(oe),de.uri,de.languageId,!0,Te?.uri,Te?.notebookType)},registerCodeActionsProvider(oe,de,Te){return lt.registerCodeActionProvider(Oe,$t(oe),de,Te)},registerDocumentPasteEditProvider(oe,de,Te){return(0,Xe.$RF)(Oe,"documentPaste"),lt.registerDocumentPasteEditProvider(Oe,$t(oe),de,Te)},registerCodeLensProvider(oe,de){return lt.registerCodeLensProvider(Oe,$t(oe),de)},registerDefinitionProvider(oe,de){return lt.registerDefinitionProvider(Oe,$t(oe),de)},registerDeclarationProvider(oe,de){return lt.registerDeclarationProvider(Oe,$t(oe),de)},registerImplementationProvider(oe,de){return lt.registerImplementationProvider(Oe,$t(oe),de)},registerTypeDefinitionProvider(oe,de){return lt.registerTypeDefinitionProvider(Oe,$t(oe),de)},registerHoverProvider(oe,de){return lt.registerHoverProvider(Oe,$t(oe),de,Oe.identifier)},registerEvaluatableExpressionProvider(oe,de){return lt.registerEvaluatableExpressionProvider(Oe,$t(oe),de,Oe.identifier)},registerInlineValuesProvider(oe,de){return lt.registerInlineValuesProvider(Oe,$t(oe),de,Oe.identifier)},registerDocumentHighlightProvider(oe,de){return lt.registerDocumentHighlightProvider(Oe,$t(oe),de)},registerMultiDocumentHighlightProvider(oe,de){return lt.registerMultiDocumentHighlightProvider(Oe,$t(oe),de)},registerLinkedEditingRangeProvider(oe,de){return lt.registerLinkedEditingRangeProvider(Oe,$t(oe),de)},registerReferenceProvider(oe,de){return lt.registerReferenceProvider(Oe,$t(oe),de)},registerRenameProvider(oe,de){return lt.registerRenameProvider(Oe,$t(oe),de)},registerDocumentSymbolProvider(oe,de,Te){return lt.registerDocumentSymbolProvider(Oe,$t(oe),de,Te)},registerWorkspaceSymbolProvider(oe){return lt.registerWorkspaceSymbolProvider(Oe,oe)},registerDocumentFormattingEditProvider(oe,de){return lt.registerDocumentFormattingEditProvider(Oe,$t(oe),de)},registerDocumentRangeFormattingEditProvider(oe,de){return lt.registerDocumentRangeFormattingEditProvider(Oe,$t(oe),de)},registerOnTypeFormattingEditProvider(oe,de,Te,...st){return lt.registerOnTypeFormattingEditProvider(Oe,$t(oe),de,[Te].concat(st))},registerDocumentSemanticTokensProvider(oe,de,Te){return lt.registerDocumentSemanticTokensProvider(Oe,$t(oe),de,Te)},registerDocumentRangeSemanticTokensProvider(oe,de,Te){return lt.registerDocumentRangeSemanticTokensProvider(Oe,$t(oe),de,Te)},registerSignatureHelpProvider(oe,de,Te,...st){return typeof Te=="object"?lt.registerSignatureHelpProvider(Oe,$t(oe),de,Te):lt.registerSignatureHelpProvider(Oe,$t(oe),de,typeof Te>"u"?[]:[Te,...st])},registerCompletionItemProvider(oe,de,...Te){return lt.registerCompletionItemProvider(Oe,$t(oe),de,Te)},registerInlineCompletionItemProvider(oe,de,Te){return de.handleDidShowCompletionItem&&(0,Xe.$RF)(Oe,"inlineCompletionsAdditions"),de.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$RF)(Oe,"inlineCompletionsAdditions"),Te&&(0,Xe.$RF)(Oe,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(Oe,$t(oe),de,Te)},registerDocumentLinkProvider(oe,de){return lt.registerDocumentLinkProvider(Oe,$t(oe),de)},registerColorProvider(oe,de){return lt.registerColorProvider(Oe,$t(oe),de)},registerFoldingRangeProvider(oe,de){return lt.registerFoldingRangeProvider(Oe,$t(oe),de)},registerSelectionRangeProvider(oe,de){return lt.registerSelectionRangeProvider(Oe,oe,de)},registerCallHierarchyProvider(oe,de){return lt.registerCallHierarchyProvider(Oe,oe,de)},registerTypeHierarchyProvider(oe,de){return lt.registerTypeHierarchyProvider(Oe,oe,de)},setLanguageConfiguration:(oe,de)=>lt.setLanguageConfiguration(Oe,oe,de),getTokenInformationAtPosition(oe,de){return(0,Xe.$RF)(Oe,"tokenInformation"),ui.tokenAtPosition(oe,de)},registerInlayHintsProvider(oe,de){return lt.registerInlayHintsProvider(Oe,oe,de)},createLanguageStatusItem(oe,de){return ui.createLanguageStatusItem(Oe,oe,de)},registerDocumentDropEditProvider(oe,de,Te){return lt.registerDocumentOnDropEditProvider(Oe,oe,de,(0,Xe.$QF)(Oe,"dropMetadata")?Te:void 0)}},rn={get activeTextEditor(){return Ft.getActiveTextEditor()},get visibleTextEditors(){return Ft.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(oe,de,Te){const st=await(g.URI.isUri(oe)?Promise.resolve(sn.openTextDocument(oe)):Promise.resolve(oe));return Ft.showTextDocument(st,de,Te)},createTextEditorDecorationType(oe){return Ft.createTextEditorDecorationType(Oe,oe)},onDidChangeActiveTextEditor(oe,de,Te){return Ft.onDidChangeActiveTextEditor(oe,de,Te)},onDidChangeVisibleTextEditors(oe,de,Te){return Ft.onDidChangeVisibleTextEditors(oe,de,Te)},onDidChangeTextEditorSelection(oe,de,Te){return Ft.onDidChangeTextEditorSelection(oe,de,Te)},onDidChangeTextEditorOptions(oe,de,Te){return Ft.onDidChangeTextEditorOptions(oe,de,Te)},onDidChangeTextEditorVisibleRanges(oe,de,Te){return Ft.onDidChangeTextEditorVisibleRanges(oe,de,Te)},onDidChangeTextEditorViewColumn(oe,de,Te){return Ft.onDidChangeTextEditorViewColumn(oe,de,Te)},onDidCloseTerminal(oe,de,Te){return mt.onDidCloseTerminal(oe,de,Te)},onDidOpenTerminal(oe,de,Te){return mt.onDidOpenTerminal(oe,de,Te)},onDidChangeActiveTerminal(oe,de,Te){return mt.onDidChangeActiveTerminal(oe,de,Te)},onDidChangeTerminalDimensions(oe,de,Te){return(0,Xe.$RF)(Oe,"terminalDimensions"),mt.onDidChangeTerminalDimensions(oe,de,Te)},onDidChangeTerminalState(oe,de,Te){return mt.onDidChangeTerminalState(oe,de,Te)},onDidWriteTerminalData(oe,de,Te){return(0,Xe.$RF)(Oe,"terminalDataWriteEvent"),mt.onDidWriteTerminalData(oe,de,Te)},onDidExecuteTerminalCommand(oe,de,Te){return(0,Xe.$RF)(Oe,"terminalExecuteCommandEvent"),mt.onDidExecuteTerminalCommand(oe,de,Te)},get state(){return $e.getState(Oe)},onDidChangeWindowState(oe,de,Te){return $e.onDidChangeWindowState(oe,de,Te)},showInformationMessage(oe,...de){return Ei.showMessage(Oe,m.default.Info,oe,de[0],de.slice(1))},showWarningMessage(oe,...de){return Ei.showMessage(Oe,m.default.Warning,oe,de[0],de.slice(1))},showErrorMessage(oe,...de){return Ei.showMessage(Oe,m.default.Error,oe,de[0],de.slice(1))},showQuickPick(oe,de,Te){return ri.showQuickPick(Oe,oe,de,Te)},showWorkspaceFolderPick(oe){return ri.showWorkspaceFolderPick(oe)},showInputBox(oe,de){return ri.showInput(oe,de)},showOpenDialog(oe){return Oi.showOpenDialog(Oe,oe)},showSaveDialog(oe){return Oi.showSaveDialog(oe)},createStatusBarItem(oe,de,Te){let st,wt,Tt;return typeof oe=="string"?(st=oe,wt=de,Tt=Te):(wt=oe,Tt=de),_t.createStatusBarEntry(Oe,st,wt,Tt)},setStatusBarMessage(oe,de){return _t.setStatusBarMessage(oe,de)},withScmProgress(oe){return Le.report("window.withScmProgress",Oe,"Use 'withProgress' instead."),vi.withProgress(Oe,{location:Ne.ProgressLocation.SourceControl},(de,Te)=>oe({report(st){}}))},withProgress(oe,de){return vi.withProgress(Oe,oe,de)},createOutputChannel(oe,de){return Nt.createOutputChannel(oe,de,Oe)},createWebviewPanel(oe,de,Te,st){return Mi.createWebviewPanel(Oe,oe,de,Te,st)},createWebviewTextEditorInset(oe,de,Te,st){return(0,Xe.$RF)(Oe,"editorInsets"),Ci.createWebviewEditorInset(oe,de,Te,st,Oe)},createTerminal(oe,de,Te){return typeof oe=="object"?"pty"in oe?mt.createExtensionTerminal(oe):mt.createTerminalFromOptions(oe):mt.createTerminal(oe,de,Te)},registerTerminalLinkProvider(oe){return mt.registerLinkProvider(oe)},registerTerminalProfileProvider(oe,de){return mt.registerProfileProvider(Oe,oe,de)},registerTerminalQuickFixProvider(oe,de){return(0,Xe.$RF)(Oe,"terminalQuickFixProvider"),mt.registerTerminalQuickFixProvider(oe,Oe.identifier.value,de)},registerTreeDataProvider(oe,de){return pi.registerTreeDataProvider(oe,de,Oe)},createTreeView(oe,de){return pi.createTreeView(oe,de,Oe)},registerWebviewPanelSerializer:(oe,de)=>Mi.registerWebviewPanelSerializer(Oe,oe,de),registerCustomEditorProvider:(oe,de,Te={})=>cn.registerCustomEditorProvider(Oe,oe,de,Te),registerFileDecorationProvider(oe){return Ze.registerFileDecorationProvider(oe,Oe)},registerUriHandler(oe){return mi.registerUriHandler(Oe,oe)},createQuickPick(){return ri.createQuickPick(Oe)},createInputBox(){return ri.createInputBox(Oe)},get activeColorTheme(){return Ai.activeColorTheme},onDidChangeActiveColorTheme(oe,de,Te){return Ai.onDidChangeActiveColorTheme(oe,de,Te)},registerWebviewViewProvider(oe,de,Te){return Li.registerWebviewViewProvider(Oe,oe,de,Te?.webviewOptions)},get activeNotebookEditor(){return kt.activeNotebookEditor},onDidChangeActiveNotebookEditor(oe,de,Te){return kt.onDidChangeActiveNotebookEditor(oe,de,Te)},get visibleNotebookEditors(){return kt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return kt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(oe,de,Te){return $i.onDidChangeNotebookEditorSelection(oe,de,Te)},onDidChangeNotebookEditorVisibleRanges(oe,de,Te){return $i.onDidChangeNotebookEditorVisibleRanges(oe,de,Te)},showNotebookDocument(oe,de){return kt.showNotebookDocument(oe,de)},registerExternalUriOpener(oe,de,Te){return(0,Xe.$RF)(Oe,"externalUriOpener"),un.registerExternalUriOpener(Oe.identifier,oe,de,Te)},registerProfileContentHandler(oe,de){return(0,Xe.$RF)(Oe,"profileContentHandlers"),ln.registrProfileContentHandler(Oe,oe,de)},registerQuickDiffProvider(oe,de,Te,st){return(0,Xe.$RF)(Oe,"quickDiffProvider"),Pi.registerQuickDiffProvider($t(oe),de,Te,st)},get tabGroups(){return Me.tabGroups},registerShareProvider(oe,de){return(0,Xe.$RF)(Oe,"shareProvider"),Ki.registerShareProvider($t(oe),de)}},sn={get rootPath(){return Le.report("workspace.rootPath",Oe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(oe){throw new T.$8("rootPath")},getWorkspaceFolder(oe){return dt.getWorkspaceFolder(oe)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(oe){throw new T.$8("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(oe){throw new T.$8("workspaceFile")},updateWorkspaceFolders:(oe,de,...Te)=>dt.updateWorkspaceFolders(Oe,oe,de||0,...Te),onDidChangeWorkspaceFolders:function(oe,de,Te){return dt.onDidChangeWorkspace(oe,de,Te)},asRelativePath:(oe,de)=>dt.getRelativePath(oe,de),findFiles:(oe,de,Te,st)=>dt.findFiles(oe,de,Te,Oe.identifier,st),findTextInFiles:(oe,de,Te,st)=>{(0,Xe.$RF)(Oe,"findTextInFiles");let wt,Tt;return typeof de=="object"?(wt=de,Tt=Te):(wt={},Tt=de,st=Te),dt.findTextInFiles(oe,wt||{},Tt,Oe.identifier,st)},save:oe=>((0,Xe.$RF)(Oe,"saveEditor"),dt.save(oe)),saveAs:oe=>((0,Xe.$RF)(Oe,"saveEditor"),dt.saveAs(oe)),saveAll:oe=>dt.saveAll(oe),applyEdit(oe,de){return Xt.applyWorkspaceEdit(oe,Oe,de)},createFileSystemWatcher:(oe,de,Te,st)=>{let wt;return typeof de=="boolean"?wt={ignoreCreateEvents:!!de,ignoreChangeEvents:!!Te,ignoreDeleteEvents:!!st,correlate:!1}:de&&((0,Xe.$RF)(Oe,"createFileSystemWatcher"),wt={...de,correlate:!0}),xt.createFileSystemWatcher(dt,Oe,oe,wt)},get textDocuments(){return Ct.getAllDocumentData().map(oe=>oe.document)},set textDocuments(oe){throw new T.$8("textDocuments")},openTextDocument(oe){let de;const Te=oe;if(typeof oe=="string")de=Promise.resolve(g.URI.file(oe));else if(g.URI.isUri(oe))de=Promise.resolve(oe);else if(!Te||typeof Te=="object")de=Ct.createDocumentData(Te);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>Ct.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(oe,de,Te)=>Ct.onDidAddDocument(oe,de,Te),onDidCloseTextDocument:(oe,de,Te)=>Ct.onDidRemoveDocument(oe,de,Te),onDidChangeTextDocument:(oe,de,Te)=>Ct.onDidChangeDocument(oe,de,Te),onDidSaveTextDocument:(oe,de,Te)=>Ct.onDidSaveDocument(oe,de,Te),onWillSaveTextDocument:(oe,de,Te)=>Vi.getOnWillSaveTextDocumentEvent(Oe)(oe,de,Te),get notebookDocuments(){return kt.notebookDocuments.map(oe=>oe.apiNotebook)},async openNotebookDocument(oe,de){let Te;if(g.URI.isUri(oe))Te=oe,await kt.openNotebookDocument(oe);else if(typeof oe=="string")Te=g.URI.revive(await kt.createNotebookDocument({viewType:oe,content:de}));else throw new Error("Invalid arguments");return kt.getNotebookDocument(Te).apiNotebook},onDidSaveNotebookDocument(oe,de,Te){return ni.onDidSaveNotebookDocument(oe,de,Te)},onDidChangeNotebookDocument(oe,de,Te){return ni.onDidChangeNotebookDocument(oe,de,Te)},onWillSaveNotebookDocument(oe,de,Te){return Ii.getOnWillSaveNotebookDocumentEvent(Oe)(oe,de,Te)},get onDidOpenNotebookDocument(){return kt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return kt.onDidCloseNotebookDocument},registerNotebookSerializer(oe,de,Te,st){return kt.registerNotebookSerializer(Oe,oe,de,Te,(0,Xe.$QF)(Oe,"notebookLiveShare")?st:void 0)},onDidChangeConfiguration:(oe,de,Te)=>Yi.onDidChangeConfiguration(oe,de,Te),getConfiguration(oe,de){return de=arguments.length===1?void 0:de,Yi.getConfiguration(oe,de,Oe)},registerTextDocumentContentProvider(oe,de){return ki.registerTextDocumentContentProvider(oe,de)},registerTaskProvider:(oe,de)=>(Le.report("window.registerTaskProvider",Oe,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Oe,oe,de)),registerFileSystemProvider(oe,de,Te){return(0,M.$Oc)(qi.registerFileSystemProvider(Oe,oe,de,Te),It.addFileSystemProvider(oe,de,Te))},get fs(){return It.value},registerFileSearchProvider:(oe,de)=>((0,Xe.$RF)(Oe,"fileSearchProvider"),Lt.registerFileSearchProvider(oe,de)),registerTextSearchProvider:(oe,de)=>((0,Xe.$RF)(Oe,"textSearchProvider"),Lt.registerTextSearchProvider(oe,de)),registerRemoteAuthorityResolver:(oe,de)=>((0,Xe.$RF)(Oe,"resolvers"),Dt.registerRemoteAuthorityResolver(oe,de)),registerResourceLabelFormatter:oe=>((0,Xe.$RF)(Oe,"resolvers"),Hi.$registerResourceLabelFormatter(oe)),getRemoteExecServer:oe=>((0,Xe.$RF)(Oe,"resolvers"),Dt.getRemoteExecServer(oe)),onDidCreateFiles:(oe,de,Te)=>xt.onDidCreateFile(oe,de,Te),onDidDeleteFiles:(oe,de,Te)=>xt.onDidDeleteFile(oe,de,Te),onDidRenameFiles:(oe,de,Te)=>xt.onDidRenameFile(oe,de,Te),onWillCreateFiles:(oe,de,Te)=>xt.getOnWillCreateFileEvent(Oe)(oe,de,Te),onWillDeleteFiles:(oe,de,Te)=>xt.getOnWillDeleteFileEvent(Oe)(oe,de,Te),onWillRenameFiles:(oe,de,Te)=>xt.getOnWillRenameFileEvent(Oe)(oe,de,Te),openTunnel:oe=>((0,Xe.$RF)(Oe,"tunnels"),De.openTunnel(Oe,oe).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,Xe.$RF)(Oe,"tunnels"),De.getTunnels()},onDidChangeTunnels:(oe,de,Te)=>((0,Xe.$RF)(Oe,"tunnels"),De.onDidChangeTunnels(oe,de,Te)),registerPortAttributesProvider:(oe,de)=>((0,Xe.$RF)(Oe,"portsAttributes"),De.registerPortsAttributesProvider(oe,de)),registerTunnelProvider:(oe,de)=>((0,Xe.$RF)(Oe,"tunnelFactory"),De.registerTunnelProvider(oe,de)),registerTimelineProvider:(oe,de)=>((0,Xe.$RF)(Oe,"timeline"),Gi.registerTimelineProvider(oe,de,Oe.identifier,tt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:oe=>((0,Xe.$RF)(Oe,"workspaceTrust"),dt.requestWorkspaceTrust(oe)),onDidGrantWorkspaceTrust:(oe,de,Te)=>dt.onDidGrantWorkspaceTrust(oe,de,Te),registerEditSessionIdentityProvider:(oe,de)=>((0,Xe.$RF)(Oe,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(oe,de)),onWillCreateEditSessionIdentity:(oe,de,Te)=>((0,Xe.$RF)(Oe,"editSessionIdentityProvider"),dt.getOnWillCreateEditSessionIdentityEvent(Oe)(oe,de,Te)),registerCanonicalUriProvider:(oe,de)=>((0,Xe.$RF)(Oe,"canonicalUriProvider"),dt.registerCanonicalUriProvider(oe,de)),getCanonicalUri:(oe,de,Te)=>((0,Xe.$RF)(Oe,"canonicalUriProvider"),dt.provideCanonicalUri(oe,de,Te))},fn={get inputBox(){return Le.report("scm.inputBox",Oe,"Use 'SourceControl.inputBox' instead"),di.getLastInputBox(Oe)},createSourceControl(oe,de,Te){return di.createSourceControl(Oe,oe,de,Te)},registerSourceControlInputBoxValueProvider(oe){return(0,Xe.$RF)(Oe,"scmInputBoxValueProvider"),di.registerSourceControlInputBoxValueProvider(Oe,oe)}},on={createCommentController(oe,de){return Ri.createCommentController(Oe,oe,de)}},an={get activeDebugSession(){return vt.activeDebugSession},get activeDebugConsole(){return vt.activeDebugConsole},get breakpoints(){return vt.breakpoints},get stackFrameFocus(){return vt.stackFrameFocus},onDidStartDebugSession(oe,de,Te){return vt.onDidStartDebugSession(oe,de,Te)},onDidTerminateDebugSession(oe,de,Te){return vt.onDidTerminateDebugSession(oe,de,Te)},onDidChangeActiveDebugSession(oe,de,Te){return vt.onDidChangeActiveDebugSession(oe,de,Te)},onDidReceiveDebugSessionCustomEvent(oe,de,Te){return vt.onDidReceiveDebugSessionCustomEvent(oe,de,Te)},onDidChangeBreakpoints(oe,de,Te){return vt.onDidChangeBreakpoints(oe,de,Te)},onDidChangeStackFrameFocus(oe,de,Te){return(0,Xe.$RF)(Oe,"debugFocus"),vt.onDidChangeStackFrameFocus(oe,de,Te)},registerDebugConfigurationProvider(oe,de,Te){return vt.registerDebugConfigurationProvider(oe,de,Te||Rt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(oe,de){return vt.registerDebugAdapterDescriptorFactory(Oe,oe,de)},registerDebugAdapterTrackerFactory(oe,de){return vt.registerDebugAdapterTrackerFactory(oe,de)},startDebugging(oe,de,Te){return!Te||typeof Te=="object"&&"configuration"in Te?vt.startDebugging(oe,de,{parentSession:Te}):vt.startDebugging(oe,de,Te||{})},stopDebugging(oe){return vt.stopDebugging(oe)},addBreakpoints(oe){return vt.addBreakpoints(oe)},removeBreakpoints(oe){return vt.removeBreakpoints(oe)},asDebugSourceUri(oe,de){return vt.asDebugSourceUri(oe,de)}},Ni={registerTaskProvider:(oe,de)=>bt.registerTaskProvider(Oe,oe,de),fetchTasks:oe=>bt.fetchTasks(oe),executeTask:oe=>bt.executeTask(Oe,oe),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(oe,de,Te)=>bt.onDidStartTask(oe,de,Te),onDidEndTask:(oe,de,Te)=>bt.onDidEndTask(oe,de,Te),onDidStartTaskProcess:(oe,de,Te)=>bt.onDidStartTaskProcess(oe,de,Te),onDidEndTaskProcess:(oe,de,Te)=>bt.onDidEndTaskProcess(oe,de,Te)},zi={createNotebookController(oe,de,Te,st,wt){return ai.createNotebookController(Oe,oe,de,Te,st,(0,Xe.$QF)(Oe,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(oe,de)=>kt.registerNotebookCellStatusBarItemProvider(Oe,oe,de),createRendererMessaging(oe){return Si.createRendererMessaging(Oe,oe)},createNotebookControllerDetectionTask(oe){return(0,Xe.$RF)(Oe,"notebookKernelSource"),ai.createNotebookControllerDetectionTask(Oe,oe)},registerKernelSourceActionProvider(oe,de){return(0,Xe.$RF)(Oe,"notebookKernelSource"),ai.registerKernelSourceActionProvider(Oe,oe,de)},onDidChangeNotebookCellExecutionState(oe,de,Te){return(0,Xe.$RF)(Oe,"notebookCellExecutionState"),ai.onDidChangeNotebookCellExecutionState(oe,de,Te)}},Ui={t(...oe){if(typeof oe[0]=="string"){const de=oe.shift(),Te=!oe||typeof oe[0]!="object"?oe:oe[0];return qt.getMessage(Oe.identifier.value,{message:de,args:Te})}return qt.getMessage(Oe.identifier.value,oe[0])},get bundle(){return qt.getBundle(Oe.identifier.value)},get uri(){return qt.getBundleUri(Oe.identifier.value)}},Di={_version:1,registerInteractiveEditorSessionProvider(oe,de){return(0,Xe.$RF)(Oe,"interactive"),Ji.registerProvider(Oe,oe,de)},registerInteractiveSessionProvider(oe,de){return(0,Xe.$RF)(Oe,"interactive"),gi.registerChatProvider(Oe,oe,de)},sendInteractiveRequestToProvider(oe,de){return(0,Xe.$RF)(Oe,"interactive"),gi.sendInteractiveRequestToProvider(oe,de)},get onDidPerformUserAction(){return(0,Xe.$RF)(Oe,"interactiveUserActions"),gi.onDidPerformUserAction},transferChatSession(oe,de){return(0,Xe.$RF)(Oe,"interactive"),gi.transferChatSession(oe,de)}},ji={getRelatedInformation(oe,de){return(0,Xe.$RF)(Oe,"aiRelatedInformation"),Xi.getRelatedInformation(Oe,oe,de)},registerRelatedInformationProvider(oe,de){return(0,Xe.$RF)(Oe,"aiRelatedInformation"),Xi.registerRelatedInformationProvider(Oe,oe,de)},registerEmbeddingVectorProvider(oe,de){return(0,Xe.$RF)(Oe,"aiRelatedInformation"),Fi.registerEmbeddingVectorProvider(Oe,oe,de)}},gn={registerChatResponseProvider(oe,de,Te){return(0,Xe.$RF)(Oe,"chatProvider"),fi.registerProvider(Oe.identifier,oe,de,Te)},requestChatAccess(oe){return(0,Xe.$RF)(Oe,"chatRequestAccess"),fi.requestChatResponseProvider(Oe.identifier,oe)},registerVariable(oe,de,Te){return(0,Xe.$RF)(Oe,"chatVariables"),Zi.registerVariableResolver(Oe,oe,de,Te)},registerMappedEditsProvider(oe,de){return(0,Xe.$RF)(Oe,"mappedEditsProvider"),lt.registerMappedEditsProvider(Oe,oe,de)},createChatAgent(oe,de){return(0,Xe.$RF)(Oe,"chatAgents2"),Qi.createChatAgent(Oe,oe,de)}},mn={registerSpeechProvider(oe,de){return(0,Xe.$RF)(Oe,"speech"),wi.registerProvider(Oe.identifier,oe,de)}};return{version:gt.version,ai:ji,authentication:xi,commands:dn,comments:on,chat:gn,debug:an,env:_i,extensions:tn,interactive:Di,l10n:Ui,languages:nn,notebooks:zi,scm:fn,speech:mn,tasks:Ni,tests:en,window:rn,workspace:sn,Breakpoint:Ne.$FL,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$wM,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,CallHierarchyIncomingCall:Ne.$5K,CallHierarchyItem:Ne.$4K,CallHierarchyOutgoingCall:Ne.$6K,CancellationError:T.$4,CancellationTokenSource:E.$2d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$1K,CodeActionKind:Ne.$2K,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$7K,Color:Ne.$hL,ColorInformation:Ne.$iL,ColorPresentation:Ne.$jL,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$bL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$cL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$rL,DebugAdapterExecutable:Ne.$JL,DebugAdapterInlineImplementation:Ne.$ML,DebugAdapterNamedPipeServer:Ne.$LL,DebugAdapterServer:Ne.$KL,DebugConfigurationProviderTriggerKind:Rt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$UK,DiagnosticRelatedInformation:Ne.$TK,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$GK,DocumentHighlight:Ne.$WK,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$XK,DocumentLink:Ne.$gL,DocumentSymbol:Ne.$ZK,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$PL,InlineValueText:Ne.$QL,InlineValueVariableLookup:Ne.$RL,InlineValueEvaluatableExpression:Ne.$SL,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:P.$Rd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$3L,FileDecoration2:Ne.$3L,FileSystemError:Ne.$UL,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:Ne.$VL,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$HL,InlineCompletionItem:Ne.$dL,InlineCompletionList:Ne.$eL,Hover:Ne.$VK,IndentAction:S.IndentAction,Location:Ne.$SK,MarkdownString:Ne.$8K,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$9K,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$HK,ProcessExecution:Ne.$pL,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$2L,Range:Ne.$IK,RelativePattern:Ne.$DL,Selection:Ne.$JK,SelectionRange:Ne.$3K,SemanticTokens:Ne.$YL,SemanticTokensBuilder:Ne.$XL,SemanticTokensEdit:Ne.$ZL,SemanticTokensEdits:Ne.$1L,SemanticTokensLegend:Ne.$WL,ShellExecution:Ne.$qL,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$$K,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$0K,SnippetString:Ne.$RK,SourceBreakpoint:Ne.$GL,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$YK,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$sL,TaskGroup:Ne.$oL,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$kL,TerminalQuickFixTerminalCommand:Ne.$mL,TerminalQuickFixOpener:Ne.$lL,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$nL,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$NK,SnippetTextEdit:Ne.$PK,TextEditorCursorStyle:w.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$CL,ThemeIcon:Ne.$BL,TreeItem:Ne.$tL,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$lM,UIKind:St.UIKind,Uri:g.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$QK,DocumentDropEdit:Ne.$zL,DocumentPasteEdit:Ne.$AL,InlayHint:Ne.$aL,InlayHintLabelPart:Ne.$_K,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$MK,ResolvedAuthority:Ne.$KK,ManagedResolvedAuthority:Ne.$LK,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$aM,NotebookRange:Ne.$5L,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$6L,NotebookData:Ne.$7L,NotebookRendererScript:Ne.$$L,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$9L,NotebookCellOutputItem:Ne.$8L,NotebookCellStatusBarItem:Ne.$0L,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$OK,NotebookKernelSourceAction:Ne.$_L,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$cM,LinkedEditingRanges:Ne.$bM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$dM,TestMessage:Ne.$eM,TestMessage2:Ne.$eM,TestTag:Ne.$fM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Jt.TextSearchCompleteMessageType,DataTransfer:Ne.$yL,DataTransferItem:Ne.$uL,CoveredCount:Ne.$gM,FileCoverage:Ne.$hM,StatementCoverage:Ne.$iM,BranchCoverage:Ne.$jM,FunctionCoverage:Ne.$kM,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$mM,TabInputTextDiff:Ne.$nM,TabInputTextMerge:Ne.$oM,TabInputCustom:Ne.$pM,TabInputNotebook:Ne.$rM,TabInputNotebookDiff:Ne.$sM,TabInputWebview:Ne.$qM,TabInputTerminal:Ne.$tM,TabInputInteractiveWindow:Ne.$uM,TabInputChat:Ne.$vM,TelemetryTrustedValue:t.$to,LogLevel:a.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:Ne.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$NL,ThreadFocus:Ne.$OL,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus}}}e.$Cgc=Vt}),define(Pe[290],Re([1,0,70,112,36,110,37,32,61,64,115,117,118,85,87,81,111,63,43,84,59,62,255,15,116,82,83]),function(pe,e,E,T,P,M,A,m,g,w,R,S,l,$,b,a,s,t,n,o,c,h,i,r,u,d,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,E.$Gr)(d.$rfc,d.$qfc,1),(0,E.$Gr)(r.$ij,i.$Dgc,1),(0,E.$Gr)(a.$Cec,a.$Dec,1),(0,E.$Gr)(m.$4M,m.$3M,0),(0,E.$Gr)(A.$Xec,A.$Vec,0),(0,E.$Gr)(t.$Zec,t.$Yec,0),(0,E.$Gr)(S.$Bfc,S.$Ffc,0),(0,E.$Gr)(M.$Hfc,M.$Gfc,0),(0,E.$Gr)(g.$SM,g.$RM,0),(0,E.$Gr)(v.$sfc,v.$tfc,0),(0,E.$Gr)(n.$zec,n.$yec,0),(0,E.$Gr)(T.$bgc,T.$agc,1),(0,E.$Gr)(l.$Xfc,l.$Yfc,0),(0,E.$Gr)($.$gfc,$.$ffc,0),(0,E.$Gr)(R.$ogc,R.$ngc,0),(0,E.$Gr)(w.$jfc,w.$mfc,0),(0,E.$Gr)(b.$Hxb,b.$Ixb,0),(0,E.$Gr)(s.$Bgc,s.$Agc,0),(0,E.$Gr)(P.$Uec,P.$Tec,0),(0,E.$Gr)(o.$ofc,o.$nfc,0),(0,E.$Gr)(c.$2M,c.$YM,0),(0,E.$Gr)(h.$0ec,h.$$ec,0),(0,E.$Gr)(u.$zfc,u.$Afc,0)}),define(Pe[291],Re([1,0,289,38,2,286,7,14,274]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;class w extends M.$Ggc{j(){}getModule($,b){for(const a of this.b){const s=a($);if(s){$=s;break}}if(this.a.has($))return this.a.get($).load($,b,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends T.$vfc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(g.$Mic);const $=this.h.invokeFunction(E.$Cgc);this.r=this.h.createInstance(w,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,b,a){b=b.with({path:S(b.path,".js")});const s=$?.identifier.value;s&&performance.mark(`code/extHost/willFetchExtensionCode/${s}`);const t=P.URI.revive(await this.C.$asBrowserUri(b)),n=await fetch(t.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s}`),n.status!==200)throw new Error(n.statusText);const o=await n.text(),c=`${b.toString(!0)}#vscode-extension`,h=`${o}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(v){throw console.error(s?`Loading code for extension ${s} failed: ${v.message}`:`Loading code failed: ${v.message}`),console.error(`${b.toString(!0)}${typeof v.line=="number"?` line ${v.line}`:""}${typeof v.column=="number"?` column ${v.column}`:""}`),console.error(v),v}$&&await this.w.initializeLocalizedMessages($);const r={},u={exports:r},d=v=>{const f=this.r.getModule(v,b);if(f===void 0)throw new Error(`Cannot load module '${v}'`);return f};try{return a.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s}`),i(u,r,d),u.exports!==r?u.exports:r}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s}`),a.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const b=Date.now()+$;for(;Date.now()<b&&!("__jsDebugIsReady"in globalThis);)await(0,m.$1g)(10)}}e.$Nic=R;function S(l,$){return l.endsWith($)?l:l+$}}),define(Pe[292],Re([1,0,69,70,15,38,199,86,291]),function(pe,e,E,T,P,M,A,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,T.$Gr)(P.$hj,new E.$Wh(A.$Fgc,[!0],!0)),(0,T.$Gr)(M.$wfc,g.$Nic,0),(0,T.$Gr)(m.$1ec,m.$2ec,0)}),define(Pe[297],Re([1,0,24,5,79,287,276,20,88,13,2,290,292]),function(pe,e,E,T,P,M,A,m,g,w,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(i){return/^(file|vscode-remote):/i.test(i)}const b=fetch.bind(self);function a(i){self.fetch=async function(r,u){return r instanceof Request||$(String(r))&&(r=(await i(R.URI.parse(String(r)))).toString(!0)),b(r,u)},self.XMLHttpRequest=class extends XMLHttpRequest{open(r,u,d,v,f){(async()=>($(u.toString())&&(u=(await i(R.URI.parse(u.toString()))).toString(!0)),super.open(r,u,d??!0,v,f)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(r,u){if(/^file:/i.test(r.toString()))r=w.$ig.uriToBrowserUri(R.URI.parse(r.toString())).toString(!0);else if(/^vscode-remote:/i.test(r.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const v=`(${function(p){function y(q){return typeof q=="string"||q instanceof URL?String(q).replace(/^file:\/\//i,"vscode-file://vscode-app"):q}const D=fetch.bind(self);self.fetch=function(q,V){return q instanceof Request?D(q,V):D(y(q),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(q,V,U,F,C){return super.open(q,y(V),U??!0,F,C)}};const N=importScripts.bind(self);self.importScripts=(...q)=>{N(...q.map(y))},N(p)}.toString()}('${r}'))`;u=u||{},u.name=u.name||m.$mc(r.toString());const f=new Blob([v],{type:"application/javascript"}),k=URL.createObjectURL(f);return new i(k,u)}}else self.Worker=class extends A.$Oic{constructor(i,r){super(l,i,{name:m.$mc(i.toString()),...r})}};const s=new class{constructor(){this.pid=void 0}exit(i){S()}};class t{constructor(){const r=new MessageChannel,u=new T.$Rd;let d=!1;l(r.port2,[r.port2]),r.port1.onmessage=v=>{const{data:f}=v;if(!(f instanceof ArrayBuffer)){console.warn("UNKNOWN data received",f);return}const k=E.$fe.wrap(new Uint8Array(f,0,f.byteLength));if((0,P.$mm)(k,2)){d=!0,o("received terminate message from renderer");return}u.fire(k)},this.protocol={onMessage:u.event,send:v=>{if(!d){const f=v.buffer.buffer.slice(v.buffer.byteOffset,v.buffer.byteOffset+v.buffer.byteLength);r.port1.postMessage(f,[f])}}}}}function n(i){return new Promise(r=>{const u=i.onMessage(d=>{u.dispose();const v=JSON.parse(d.toString());i.send((0,P.$lm)(0)),r({protocol:i,initData:v})});i.send((0,P.$lm)(1))})}let o=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new t;return{onmessage(r){c(r)&&n(i.protocol).then(u=>{g.mark("code/extHost/didWaitForInitData");const d=new M.$Igc(u.protocol,u.initData,s,null,r.data);a(v=>d.asBrowserUri(v)),o=v=>d.terminate(v)})}}}e.create=h})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/ef71b038ad2518e32514b6cc3a4df9f94c096e65/core/vs/workbench/api/worker/extensionHostWorker.js.map
